import numpy as np


#1st order terms
class RR1:
    def l1(cosmo_functions,k1,k2,k3=None,theta=None,zz=0,r=0,s=0,nonlin=False,growth2=False):
        
        #get generic cosmology parameters
        k1,k2,k3,theta,Pk1,Pk2,Pk3,Pkd1,Pkd2,Pkd3,Pkdd1,Pkdd2,Pkdd3,d,K,C,f,D1,b1,b2,g2 = cosmo_functions.get_params(k1,k2,k3,theta,zz,nonlin=nonlin,growth2=growth2)
        
        fd,Dd,gd2,bd2,bd1,fdd,Ddd,gdd2,bdd2,bdd1 = cosmo_functions.get_derivs(zz)
        
        st = np.sin(theta)
        ct= np.cos(theta)

        perm12 = 12*1j*C*D1**3*Pk1*Pk2*f*k1*k2**2*st**4*(3*D1*bd1*f*(r + s - 1) + 3*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(35*d*k3**4) + 12*1j*C*D1**3*Pk1*Pk2*k1**3*(5*D1*bd1*f**2*(r + s - 1) + 7*b1**2*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + b1*f*(14*D1*bd1*(r + s - 1) + (5*D1*fd + 10*Dd*f)*(2*r + 2*s - 1)))/(35*d*k3**4) + 4*1j*C*D1**3*Pk1*Pk2*k1*st**2*(9*D1*bd1*f*(14*b1*k2**2 + f*(k1**2 + 3*k2**2))*(r + s - 1) + 63*b1**2*k2**2*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + 9*b1*f*(k1**2 + 3*k2**2)*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + 5*f**2*k1**2*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(105*d*k3**4) - 2*1j*C*D1**3*Pk2*Pkd1*f*k2**2*st**4*(6*D1*b1*fd*r + 3*D1*bd1*f*(r - 1) + D1*f*fd*(3*r - 1) + 3*Dd*b1*f*(4*r - 1) + Dd*f**2*(4*r - 1))/(35*d*k3**2) - 6*1j*C*D1**3*Pk2*Pkd1*k1**2*(5*D1*bd1*f**2*r + 7*b1**2*(D1*fd*r + Dd*f*(4*r - 1)) + b1*f*(7*D1*bd1*(2*r - 1) + 5*D1*fd*(2*r - 1) + 5*Dd*f*(4*r - 1)))/(35*d*k3**2) - 2*1j*C*D1**3*Pk2*Pkd1*st**2*(3*D1*bd1*f*(7*b1*k2**2*(2*r - 1) + 3*f*(k1**2*(r - 1) + k2**2*r)) + 21*b1**2*k2**2*(D1*fd*r + Dd*f*(4*r - 1)) + 9*b1*f*(D1*fd*(2*k1**2*r + k2**2*(2*r - 1)) + Dd*f*(k1**2 + k2**2)*(4*r - 1)) + 5*f**2*k1**2*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(105*d*k3**2) - 4*1j*D1**3*Pk1*Pk2*ct**7*f*k2**3*(C - 1)*(9*D1*bd1*f*(r + s - 1) + 9*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + 7*f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(21*d*k3**4) + 2*1j*D1**3*Pk1*Pk2*ct**6*f*k2**2*(k1**2*(7 - 6*C) + k2**2)*(9*D1*bd1*f*(r + s - 1) + 9*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + 7*f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(21*d*k1*k3**4) - 8*1j*D1**3*Pk1*Pk2*ct**5*f*k2**3*st**2*(C - 1)*(9*D1*bd1*f*(r + s - 1) + 9*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + 5*f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(21*d*k3**4) + 2*1j*D1**3*Pk1*Pk2*ct**5*k2*(-9*D1*bd1*f*(28*b1*k2**2*(C - 1) + 5*f*(k1**2*(6*C - 9) - 5*k2**2))*(r + s - 1) - 126*b1**2*k2**2*(C - 1)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) - 45*b1*f*(D1*fd + 2*Dd*f)*(k1**2*(6*C - 9) - 5*k2**2)*(2*r + 2*s - 1) - 35*f**2*(k1**2*(6*C - 9) - k2**2*(2*C + 3))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(105*d*k3**4) + 4*1j*D1**3*Pk1*Pk2*ct**4*f*k2**2*st**2*(k1**2*(23 - 18*C) + 5*k2**2)*(9*D1*bd1*f*(r + s - 1) + 9*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + 5*f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(105*d*k1*k3**4) - 2*1j*D1**3*Pk1*Pk2*ct**4*(9*D1*bd1*f*(-14*b1*k2**2*(k1**2*(7 - 6*C) + k2**2) + 5*f*(k1**4*(2*C - 5) - 10*k1**2*k2**2 - k2**4))*(r + s - 1) - 63*b1**2*k2**2*(k1**2*(7 - 6*C) + k2**2)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + 45*b1*f*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1)*(k1**4*(2*C - 5) - 10*k1**2*k2**2 - k2**4) + 35*f**2*k1**2*(k1**2*(2*C - 5) - k2**2*(6*C + 3))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(105*d*k1*k3**4) - 4*1j*D1**3*Pk1*Pk2*ct**3*f*k2**3*st**4*(C - 1)*(3*D1*bd1*f*(r + s - 1) + 3*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(7*d*k3**4) + 4*1j*D1**3*Pk1*Pk2*ct**3*k2*st**2*(-9*D1*bd1*f*(r + s - 1)*(14*b1*k2**2*(C - 1) + f*k1**2*(9*C - 18) - f*k2**2*(7*C + 12)) - 63*b1**2*k2**2*(C - 1)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) - 9*b1*f*(D1*fd + 2*Dd*f)*(k1**2*(9*C - 18) - k2**2*(7*C + 12))*(2*r + 2*s - 1) - 5*f**2*(k1**2*(9*C - 18) - k2**2*(10*C + 9))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(105*d*k3**4) + 2*1j*D1**3*Pk1*Pk2*ct**3*(9*D1*bd1*f*(14*b1*k2**2*(k1**2*(9 - 6*C) + k2**2*(2*C + 3)) + 5*f*(k1**4 + 10*k1**2*k2**2 + k2**4*(2*C + 3)))*(r + s - 1) + 63*b1**2*k2**2*(k1**2*(9 - 6*C) + k2**2*(2*C + 3))*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + 45*b1*f*(D1*fd + 2*Dd*f)*(k1**4 + 10*k1**2*k2**2 + k2**4*(2*C + 3))*(2*r + 2*s - 1) + 35*f**2*k1**2*(k1**2 + k2**2*(6*C + 1))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(105*d*k2*k3**4) + 2*1j*D1**3*Pk1*Pk2*ct**2*f*k2**2*st**4*(k1**2*(11 - 6*C) + 5*k2**2)*(3*D1*bd1*f*(r + s - 1) + 3*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(35*d*k1*k3**4) - 2*1j*D1**3*Pk1*Pk2*ct**2*k1*(63*b1**2*(k1**2*(2*C - 5) - k2**2*(6*C + 3))*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + 9*b1*(14*D1*bd1*f*(k1**2*(2*C - 5) - k2**2*(6*C + 3))*(r + s - 1) - 5*f*(5*k1**2 + k2**2*(6*C + 3))*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1)) - 5*f**2*(14*C*k1**2*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)) + 9*D1*bd1*(5*k1**2 + k2**2*(6*C + 3))*(r + s - 1)))/(105*d*k3**4) - 2*1j*D1**3*Pk1*Pk2*ct**2*st**2*(9*D1*bd1*f*(-14*b1*k2**2*(k1**2*(3 - 2*C) + k2**2) + f*(k1**4*(2*C - 11) - k1**2*k2**2*(30*C + 18) - 3*k2**4))*(r + s - 1) - 63*b1**2*k2**2*(k1**2*(3 - 2*C) + k2**2)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + 9*b1*f*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1)*(k1**4*(2*C - 11) - k1**2*k2**2*(30*C + 18) - 3*k2**4) + 5*f**2*k1**2*(k1**2*(2*C - 11) - k2**2*(36*C + 9))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(105*d*k1*k3**4) + 2*1j*D1**3*Pk1*Pk2*ct*f*k2*st**4*(3*k1**2 + k2**2*(10*C + 3))*(3*D1*bd1*f*(r + s - 1) + 3*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(35*d*k3**4) + 6*1j*D1**3*Pk1*Pk2*ct*k1**2*(k1**2 + k2**2*(6*C + 1))*(5*D1*bd1*f**2*(r + s - 1) + 7*b1**2*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + b1*f*(14*D1*bd1*(r + s - 1) + (5*D1*fd + 10*Dd*f)*(2*r + 2*s - 1)))/(35*d*k2*k3**4) + 2*1j*D1**3*Pk1*Pk2*ct*st**2*(9*D1*bd1*f*(14*b1*k2**2*(k1**2 + k2**2*(2*C + 1)) + f*(k1**4 + k1**2*k2**2*(18*C + 4) + k2**4*(6*C + 3)))*(r + s - 1) + 63*b1**2*k2**2*(k1**2 + k2**2*(2*C + 1))*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + 9*b1*f*(D1*fd + 2*Dd*f)*(k1**4 + k1**2*k2**2*(18*C + 4) + k2**4*(6*C + 3))*(2*r + 2*s - 1) + 5*f**2*k1**2*(k1**2 + k2**2*(18*C + 1))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(105*d*k2*k3**4) - 1j*D1**3*Pk1*Pk2*k1*(3*D1*bd1*f**2*(5*k1**2*(s - 1) + k2**2*(4*C*(9*r + 7*s - 7) + 5*s - 5)) + 7*b1**2*(D1*fd*(20*C*k2**2*(r + s) + s*(3*k1**2 + 3*k2**2)) + Dd*f*(3*k1**2*(4*s - 1) + k2**2*(40*C*(2*r + 2*s - 1) + 12*s - 3))) + b1*f*(7*D1*bd1*(k1**2*(6*s - 3) + k2**2*(40*C*(r + s - 1) + 6*s - 3)) + 6*D1*fd*(2*C*k2**2*(18*r + 14*s - 9) + s*(5*k1**2 + 5*k2**2)) + 3*Dd*f*(5*k1**2*(4*s - 1) + k2**2*(16*C*(9*r + 7*s - 4) + 20*s - 5))))/(35*d*k2**2*k3**2) - 1j*D1**3*Pk1*Pk2*(D1*bd1*f*(15*f**2*k1**2*(s - 1) + k2**2*r*(28*b2 - 56*g2)) + 7*b1**3*(5*D1*fd*k1**2*s + D1*fd*k2**2*(4*r + 5*s) + 5*Dd*k1**2*(f + 1)*(4*s - 1) + Dd*k2**2*(f*(16*r + 20*s - 9) + 20*s - 5)) + b1**2*(7*D1*bd1*(k1**2*(5*f + 5)*(3*s - 1) + k2**2*(3*f*(4*r + 5*s - 3) + 15*s - 5)) + D1*fd*(k1**2*s*(84*f + 21) + k2**2*(28*K*(r - 1) + 6*f*(8*r + 7*s - 4) + 28*r + 21*s - 28)) + Dd*f*(k1**2*(42*f + 21)*(4*s - 1) + k2**2*(112*K*r - 28*K + f*(96*r + 84*s - 45) + 112*r + 84*s - 49))) + b1*(D1*bd1*f*(k1**2*(42*f + 21)*(2*s - 1) + k2**2*(3*f*(16*r + 14*s - 7) + 7*r*(8*K + 8) + 42*s - 21)) + D1*(28*b2*fd*k2**2*(r - 1) + 45*f**2*fd*k1**2*s + 28*f*k2**2*r*(bd2 - 2*gd2) - 56*fd*g2*k2**2*(r - 1)) + Dd*f*(15*f**2*k1**2*(4*s - 1) + k2**2*(28*b2 - 56*g2)*(4*r - 1))))/(35*d*k1*k2**2) + 2*1j*D1**3*Pk1*ct**7*f*k2*(C - 1)*(-4*Pk2 + Pkd2*k2)*(9*b1*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) + f*(9*D1*bd1*s + 7*D1*fd*(3*s - 1) + 7*Dd*f*(4*s - 1)))/(21*d*k3**2) + 1j*D1**3*Pk1*ct**6*f**2*(4*Pk2 - Pkd2*k2)*(11*b1*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1)) + f*(11*D1*bd1*s + 9*D1*fd*(4*s - 1) + 9*Dd*f*(4*s - 1)))/(33*d*k1) - 1j*D1**3*Pk1*ct**6*f*(9*b1*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1))*(k1**2*(4*C - 5)*(4*Pk2 - Pkd2*k2) + k2**2*(-2*Pk2 + Pkd2*k2)) + f*(9*D1*bd1*s*(k1**2*(4*C - 5)*(4*Pk2 - Pkd2*k2) + k2**2*(-2*Pk2 + Pkd2*k2)) + D1*fd*(k1**2*(28*C - 35)*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(Pk2*(-24*C*r + 8*C + 24*r - 42*s + 6) + 7*Pkd2*k2*(3*s - 1))) + Dd*f*k1**2*(28*C - 35)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + Dd*f*k2**2*(Pk2*(C*(8 - 32*r) + 32*r - 56*s + 6) + 7*Pkd2*k2*(4*s - 1))))/(21*d*k1*k3**2) + 4*1j*D1**3*Pk1*ct**5*f*k2*st**2*(C - 1)*(-4*Pk2 + Pkd2*k2)*(9*b1*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) + f*(9*D1*bd1*s + 5*D1*fd*(3*s - 1) + 5*Dd*f*(4*s - 1)))/(21*d*k3**2) - 1j*D1**3*Pk1*ct**5*(-99*b1**2*k1**2*(4*Pk2 - Pkd2*k2)*(D1*fd*(-7*K*s + 7*K + 5*f*(2*s - 1) + 7*s - 7) + Dd*f*(4*s - 1)*(-7*K + 5*f + 7)) - 11*b1*(3*D1*(5*f**2*(5*Pk2*fd*k2**2*r + 6*bd1*k1**2*s*(4*Pk2 - Pkd2*k2) + 7*fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) - 3*f*k1**2*(4*Pk2 - Pkd2*k2)*(5*fd*(K - 1)*(2*s - 1) + s*(14*K*bd1 - 14*bd1 - 14*gd2)) + 42*fd*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) + Dd*f*(5*f**2*(5*Pk2*k2**2*(4*r - 1) + 21*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 45*f*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 126*g2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + f*(D1*(-5*f**2*(11*bd1*(84*Pk2*k1**2*s + 5*Pk2*k2**2*(r - 1) - 21*Pkd2*k1**2*k2*s) + 21*fd*(Pk2*k2**2*(4*r - 1) + 6*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) - 495*f*k1**2*s*(4*Pk2 - Pkd2*k2)*(-K*bd1 + bd1 + 2*gd2) - 198*g2*k1**2*(4*Pk2 - Pkd2*k2)*(7*bd1*s + 5*fd*(2*s - 1))) - 15*Dd*f*(7*f**2*(Pk2*k2**2*(4*r - 1) + 6*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 66*g2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))))/(1155*d*k1**2*k2) + 1j*D1**3*Pk1*ct**5*(126*b1**2*k1**2*k2**2*(C - 1)*(-2*Pk2 + Pkd2*k2)*(D1*fd*s + Dd*f*(4*s - 1)) - 9*b1*f*(-2*D1*(7*bd1*k1**2*k2**2*(C - 1)*(-2*Pk2 + Pkd2*k2)*(2*s - 1) + fd*(5*Pk2*k2**4*r - k1**4*(5*C - 10)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(Pk2*(4*C*(7*r + 19*s - 12) - 33*r - 36*s + 28) + 5*Pkd2*k2*(C - 4*s + 1)))) + Dd*f*(5*Pk2*k2**4*(1 - 4*r) + k1**4*(10*C - 20)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(-8*C*Pk2*(14*r + 38*s - 13) + 3*Pk2*(44*r + 48*s - 23) + 20*Pkd2*k2*(4*s - 1)))) + f**2*(D1*(9*bd1*(5*Pk2*k2**4*(r - 1) - k1**4*s*(10*C - 20)*(4*Pk2 - Pkd2*k2) + k1**2*k2**2*(Pk2*(4*C*(7*r + 19*s - 2) - 33*r - 36*s + 13) - 10*Pkd2*k2*(C + 2*s - 1))) - 5*fd*(3*Pk2*k2**4*(1 - 3*r) + k1**4*(14*C - 28)*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k1**2*k2**2*(-12*C*Pk2*(13*r + 32*s - 15) + 27*Pk2*(7*r + 8*s - 5) + Pkd2*k2*(14*C + 14)*(3*s - 1)))) - 5*Dd*f*(3*Pk2*k2**4*(1 - 4*r) + k1**4*(14*C - 28)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(-4*C*Pk2*(52*r + 128*s - 45) + 9*Pk2*(28*r + 32*s - 15) + Pkd2*k2*(14*C + 14)*(4*s - 1)))))/(105*d*k1**2*k2*k3**2) + 5*1j*D1**3*Pk1*ct**4*f**2*st**2*(4*Pk2 - Pkd2*k2)*(11*b1*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1)) + f*(11*D1*bd1*s + 7*D1*fd*(4*s - 1) + 7*Dd*f*(4*s - 1)))/(77*d*k1) + 2*1j*D1**3*Pk1*ct**4*f*st**2*(-9*b1*(D1*fd*(k1**2*(12*C - 17)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(-2*Pk2*(r*(8*C - 8) + 10*s - 5) + 5*Pkd2*k2*(2*s - 1))) + Dd*f*(k1**2*(12*C - 17)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(Pk2*(-32*C*r + 8*C + 32*r - 40*s + 2) + 5*Pkd2*k2*(4*s - 1)))) + f*(9*D1*bd1*(Pk2*k1**2*s*(68 - 48*C) + 2*Pk2*k2**2*(4*C*(r - 1) - 4*r + 5*s + 4) + Pkd2*k1**2*k2*s*(12*C - 17) - 5*Pkd2*k2**3*s) + D1*fd*(k1**2*(85 - 60*C)*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(2*Pk2*(44*C*(3*r - 1) - 132*r + 75*s + 19) + 25*Pkd2*k2*(1 - 3*s))) + Dd*f*k1**2*(85 - 60*C)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + Dd*f*k2**2*(Pk2*(88*C*(4*r - 1) - 352*r + 200*s + 38) + 25*Pkd2*k2*(1 - 4*s))))/(105*d*k1*k3**2) - 1j*D1**3*Pk1*ct**4*(-99*b1**2*(D1*fd*(k1**2*(4*Pk2 - Pkd2*k2)*(10*f*s - 5*f + 7*s - 7) + k2**2*(2*Pk2 - Pkd2*k2)*(20*f*s - 5*f + 7*s - 7)) + Dd*f*(4*s - 1)*(k1**2*(4*Pk2 - Pkd2*k2)*(5*f + 7) + k2**2*(2*Pk2 - Pkd2*k2)*(10*f + 7))) - 11*b1*f*(-9*D1*bd1*(5*f*(-8*Pk2*k1**2*s + Pk2*k2**2*(2 - 8*s) + 2*Pkd2*k1**2*k2*s + Pkd2*k2**3*(4*s - 1)) + s*(14*k1**2*(-4*Pk2 + Pkd2*k2) + 14*k2**2*(-2*Pk2 + Pkd2*k2))) + D1*fd*(5*k1**2*(4*Pk2 - Pkd2*k2)*(14*f*(3*s - 1) + 18*s - 9) - k2**2*(Pk2*(-72*K*r + 36*K + 5*f*(36*r + 51*s - 35) + 72*r - 180*s + 54) + 5*Pkd2*k2*(7*f*(6*s - 1) + 18*s - 9))) + 5*Dd*f*k1**2*(4*Pk2 - Pkd2*k2)*(14*f + 9)*(4*s - 1) - Dd*f*k2**2*(5*Pk2*f*(48*r + 68*s - 29) - 18*Pk2*(K*(8*r - 2) - 8*r + 20*s - 3) + Pkd2*k2*(70*f + 45)*(4*s - 1))) + f*(792*D1*Pk2*fd*g2*k2**2*(2*r - 1) - 5*D1*f**2*(-11*bd1*(-56*Pk2*k1**2*s + Pk2*k2**2*(12*r + 17*s + 6) + 14*Pkd2*k1**2*k2*s + 7*Pkd2*k2**3*(2*s - 1)) + 7*fd*(Pk2*k2**2*(-64*r - 220*s + 71) + 9*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 99*D1*f*(8*Pk2*gd2*k2**2*r + bd1*(-20*Pk2*k1**2*s - 2*Pk2*k2**2*(r*(2*K - 2) + 5*s) + 5*Pkd2*k1**2*k2*s + 5*Pkd2*k2**3*s)) + 792*Dd*Pk2*f*g2*k2**2*(4*r - 1) - 35*Dd*f**3*(Pk2*k2**2*(-64*r - 220*s + 71) + 9*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))))/(1155*d*k1*k2**2) - 1j*D1**3*Pk1*ct**4*(63*b1**2*k2**2*(Pkd2*k2**3 + k1**2*(4*C - 5)*(2*Pk2 - Pkd2*k2))*(D1*fd*s + Dd*f*(4*s - 1)) - 9*b1*f*(D1*(-7*bd1*k2**2*(2*s - 1)*(Pkd2*k2**3 + k1**2*(4*C - 5)*(2*Pk2 - Pkd2*k2)) + fd*(5*k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(Pk2*(4*C*(14*r + 62*s - 41) - 104*r - 194*s + 147) + 5*Pkd2*k2*(4*C - 12*s + 1)) - k2**4*(Pk2*(-16*C*r + 8*C + 24*r + 66*s - 41) + 10*Pkd2*k2*s))) + Dd*f*(5*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(8*C*(14*r + 62*s - 19) - 208*r - 388*s + 149) + 30*Pkd2*k2*(1 - 4*s)) + k2**4*(Pk2*(32*C*r - 8*C - 48*r - 132*s + 45) + 5*Pkd2*k2*(1 - 4*s)))) + f**2*(D1*(9*bd1*(5*k1**4*s*(-4*Pk2 + Pkd2*k2) + k1**2*k2**2*(-Pk2*(4*C*(7*r + 31*s + 3) - 52*r - 97*s + 2) + 5*Pkd2*k2*(4*C + 6*s - 5)) + k2**4*(Pk2*(-8*C*r + 12*r + 33*s - 4) + 5*Pkd2*k2*(s - 1))) - 5*fd*(Pk2*k2**4*(C*(8 - 24*r) - 36*r - 129*s + 55) + 7*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k1**2*k2**2*(Pk2*(132*C*(r + 5*s - 2) - 252*r - 579*s + 277) + Pkd2*k2*(-28*C - 7)*(3*s - 1)))) - 5*Dd*f*(Pk2*k2**4*(C*(8 - 32*r) - 48*r - 172*s + 55) + 7*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(88*C*(2*r + 10*s - 3) - 336*r - 772*s + 277) + Pkd2*k2*(-28*C - 7)*(4*s - 1)))))/(105*d*k1*k2**2*k3**2) + 2*1j*D1**3*Pk1*ct**3*f*k2*st**4*(C - 1)*(-4*Pk2 + Pkd2*k2)*(3*b1*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) + f*(3*D1*bd1*s + D1*fd*(3*s - 1) + Dd*f*(4*s - 1)))/(7*d*k3**2) - 1j*D1**3*Pk1*ct**3*st**2*(-99*b1**2*k1**2*(4*Pk2 - Pkd2*k2)*(D1*fd*(-7*K*s + 7*K + 10*f*(2*s - 1) + 7*s - 7) + Dd*f*(4*s - 1)*(-7*K + 10*f + 7)) - 11*b1*(3*D1*(10*f**2*(Pk2*fd*k2**2*r + 6*bd1*k1**2*s*(4*Pk2 - Pkd2*k2) + 5*fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) - 3*f*k1**2*(4*Pk2 - Pkd2*k2)*(3*fd*(K - 1)*(2*s - 1) + s*(14*K*bd1 - 14*bd1 - 14*gd2)) + 42*fd*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) + Dd*f*(10*f**2*(Pk2*k2**2*(4*r - 1) + 15*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 27*f*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 126*g2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + f*(-10*D1*f**2*(11*bd1*(60*Pk2*k1**2*s + Pk2*k2**2*(r - 1) - 15*Pkd2*k1**2*k2*s) + 5*fd*(5*Pk2*k2**2*(1 - 4*r) + 14*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) - 297*D1*f*k1**2*s*(4*Pk2 - Pkd2*k2)*(-K*bd1 + bd1 + 2*gd2) - 198*D1*g2*k1**2*(4*Pk2 - Pkd2*k2)*(7*bd1*s + fd*(6*s - 3)) - 50*Dd*f**3*(5*Pk2*k2**2*(1 - 4*r) + 14*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 594*Dd*f*g2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)))/(1155*d*k1**2*k2) - 1j*D1**3*Pk1*ct**3*(-231*b1**3*k1**2*(2*Pk2 - Pkd2*k2)*(3*D1*fd*s + Dd*(4*s - 1)*(-5*K + 3*f + 5)) - 33*b1**2*(7*D1*bd1*k1**2*(2*Pk2 - Pkd2*k2)*(3*s - 1)*(-5*K + 3*f + 5) + D1*(Pk2*fd*k2**2*r*(36*f + 21) + fd*k1**2*(Pk2*(112*K*s - 154*K + f*(-42*r + 72*s + 54) - 21*r - 28*s + 70) + 3*Pkd2*k2*(7*K + f*(5 - 40*s) - 14*s + 7)) + 70*gd2*k1**2*s*(2*Pk2 - Pkd2*k2)) + Dd*(-3*f**2*(6*Pk2*k2**2*(1 - 4*r) + k1**2*(Pk2*(28*r - 48*s + 5) + 20*Pkd2*k2*(4*s - 1))) + 7*f*(3*Pk2*k2**2*(4*r - 1) + k1**2*(Pk2*(64*K*s - 16*K - 12*r - 16*s + 7) + 6*Pkd2*k2*(1 - 4*s))) + 70*g2*k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1))) + 11*b1*(-612*D1*K*Pk2*f*fd*k1**2*s + 306*D1*K*Pk2*f*fd*k1**2 + 90*D1*K*Pkd2*f*fd*k1**2*k2*s - 45*D1*K*Pkd2*f*fd*k1**2*k2 - 126*D1*Pk2*bd2*f*k1**2*s + 390*D1*Pk2*f**2*fd*k1**2*r + 990*D1*Pk2*f**2*fd*k1**2*s - 535*D1*Pk2*f**2*fd*k1**2 - 30*D1*Pk2*f**2*fd*k2**2*r + 10*D1*Pk2*f**2*fd*k2**2 + 162*D1*Pk2*f*fd*k1**2*r + 252*D1*Pk2*f*fd*k1**2*s - 207*D1*Pk2*f*fd*k1**2 - 18*D1*Pk2*f*fd*k2**2*r + 9*D1*Pk2*f*fd*k2**2 + 672*D1*Pk2*f*gd2*k1**2*s + 672*D1*Pk2*fd*g2*k1**2*s - 924*D1*Pk2*fd*g2*k1**2 + 63*D1*Pkd2*bd2*f*k1**2*k2*s + 315*D1*Pkd2*f**2*fd*k1**2*k2*s - 35*D1*Pkd2*f**2*fd*k1**2*k2 + 90*D1*Pkd2*f*fd*k1**2*k2*s - 45*D1*Pkd2*f*fd*k1**2*k2 + 126*D1*Pkd2*fd*g2*k1**2*k2 + 3*D1*bd1*(3*f**2*(6*Pk2*k2**2*(1 - 2*r) + k1**2*(Pk2*(14*r - 24*s + 23) + 5*Pkd2*k2*(8*s - 3))) - 7*f*(3*Pk2*k2**2*(2*r - 1) + k1**2*(Pk2*(32*K*s + 6*K - 6*r - 8*s - 3) - 3*Pkd2*k2*(K + 4*s - 1))) - 70*g2*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1)) - 1224*Dd*K*Pk2*f**2*k1**2*s + 306*Dd*K*Pk2*f**2*k1**2 + 180*Dd*K*Pkd2*f**2*k1**2*k2*s - 45*Dd*K*Pkd2*f**2*k1**2*k2 + 520*Dd*Pk2*f**3*k1**2*r + 1320*Dd*Pk2*f**3*k1**2*s - 460*Dd*Pk2*f**3*k1**2 - 40*Dd*Pk2*f**3*k2**2*r + 10*Dd*Pk2*f**3*k2**2 + 324*Dd*Pk2*f**2*k1**2*r + 504*Dd*Pk2*f**2*k1**2*s - 207*Dd*Pk2*f**2*k1**2 - 36*Dd*Pk2*f**2*k2**2*r + 9*Dd*Pk2*f**2*k2**2 + 2688*Dd*Pk2*f*g2*k1**2*s - 672*Dd*Pk2*f*g2*k1**2 + 420*Dd*Pkd2*f**3*k1**2*k2*s - 105*Dd*Pkd2*f**3*k1**2*k2 + 180*Dd*Pkd2*f**2*k1**2*k2*s - 45*Dd*Pkd2*f**2*k1**2*k2 - 63*b2*k1**2*(2*Pk2 - Pkd2*k2)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))) + f*(11*D1*bd1*(5*f**2*(-2*Pk2*k2**2*r + k1**2*(Pk2*(26*r + 66*s + 15) + 7*Pkd2*k2*(3*s - 2))) + 9*f*(-Pk2*k2**2*r + k1**2*(9*Pk2*r + Pk2*s*(14 - 34*K) + Pkd2*k2*s*(5*K + 5))) + 42*g2*k1**2*(2*Pk2*(8*s + 3) - 3*Pkd2*k2)) - 99*b2*k1**2*(2*Pk2 - Pkd2*k2)*(7*D1*bd1*s + 5*D1*fd*(2*s - 1) + 5*Dd*f*(4*s - 1)) + k1**2*(35*D1*Pk2*f**2*fd*(76*r + 352*s - 107) - 99*D1*f*s*(10*Pk2*bd2 - 68*Pk2*gd2 - 5*Pkd2*bd2*k2 + 10*Pkd2*gd2*k2) + 198*D1*fd*g2*(34*Pk2 - 5*Pkd2*k2)*(2*s - 1) + 35*Dd*Pk2*f**3*(76*r + 352*s - 107) + 198*Dd*f*g2*(34*Pk2 - 5*Pkd2*k2)*(4*s - 1))))/(1155*d*k1**2*k2) + 2*1j*D1**3*Pk1*ct**3*st**2*(63*b1**2*k1**2*k2**2*(C - 1)*(-2*Pk2 + Pkd2*k2)*(D1*fd*s + Dd*f*(4*s - 1)) - 9*b1*f*(D1*(-7*bd1*k1**2*k2**2*(C - 1)*(-2*Pk2 + Pkd2*k2)*(2*s - 1) + fd*(-2*Pk2*k2**4*r + k1**4*(3*C - 9)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 2*k1**2*k2**2*(Pk2*(C*(-26*r - 54*s + 30) + 31*r + 22*s - 14) + Pkd2*k2*(C*(7*s - 5) + 9*s - 3)))) + Dd*f*(Pk2*k2**4*(1 - 4*r) + k1**4*(3*C - 9)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(-8*C*(13*r + 27*s - 10) + 124*r + 88*s - 53) + Pkd2*k2*(7*C + 9)*(4*s - 1)))) - f**2*(D1*(-9*Pk2*bd1*k2**4*(r - 1) + 19*Pk2*fd*k2**4*(3*r - 1) + 27*bd1*k1**4*s*(C - 3)*(4*Pk2 - Pkd2*k2) + 9*bd1*k1**2*k2**2*(Pk2*(C*(-26*r - 54*s + 20) + 31*r + 22*s - 25) + Pkd2*k2*(C*(7*s + 3) + 9*s - 3)) + fd*k1**4*(15*C - 45)*(4*Pk2 - Pkd2*k2)*(3*s - 1) + fd*k1**2*k2**2*(Pk2*(C*(-486*r - 804*s + 430) + 633*r + 324*s - 319) + Pkd2*k2*(50*C + 30)*(3*s - 1))) + Dd*f*(19*Pk2*k2**4*(4*r - 1) + k1**4*(15*C - 45)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(-2*C*(324*r + 536*s - 215) + 844*r + 432*s - 319) + Pkd2*k2*(50*C + 30)*(4*s - 1)))))/(105*d*k1**2*k2*k3**2) - 1j*D1**3*Pk1*ct**3*(21*b1**2*(D1*fd*(-3*Pk2*k2**4*r + k1**4*s*(6*C - 12)*(2*Pk2 - Pkd2*k2) + k1**2*k2**2*(Pk2*r*(23 - 20*C) - Pk2*s*(32*C - 32) + Pkd2*k2*s*(6*C + 6))) + Dd*f*(3*Pk2*k2**4*(1 - 4*r) + k1**4*(6*C - 12)*(2*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(-4*C*(20*r + 32*s - 13) + 92*r + 128*s - 55) + Pkd2*k2*(6*C + 6)*(4*s - 1)))) + 3*b1*f*(7*D1*bd1*(3*Pk2*k2**4*(1 - 2*r) + k1**4*(6*C - 12)*(2*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(Pk2*(C*(-40*r - 64*s + 52) + 46*r + 64*s - 55) + Pkd2*k2*(6*C + 6)*(2*s - 1))) - 3*D1*fd*(Pk2*k2**4*(2*r - 1) + 2*k1**4*(Pk2*(48*C*s - 34*C - 19*r - 60*s + 50) + 5*Pkd2*k2*(C - 4*s)) - k1**2*k2**2*(Pk2*(-4*C*(8*r - 4*s + 3) + 124*r + 200*s - 105) + Pkd2*k2*s*(20*C + 20))) - 3*Dd*f*(Pk2*k2**4*(4*r - 1) + k1**4*(Pk2*(48*C*(4*s - 1) - 76*r - 240*s + 79) + 20*Pkd2*k2*(1 - 4*s)) - 2*k1**2*k2**2*(Pk2*(C*(-32*r + 16*s + 4) + 124*r + 200*s - 81) + Pkd2*k2*(5*C + 5)*(4*s - 1)))) + f**2*(-9*D1*bd1*(Pk2*k2**4*r + k1**4*(Pk2*(48*C*s + 20*C - 19*r - 60*s - 21) - 10*Pkd2*k2*(C + 2*s - 2)) - k1**2*k2**2*(Pk2*(C*(-16*r + 8*s + 20) + 62*r + 100*s - 57) + Pkd2*k2*(10*C + 10)*(s - 1))) + 5*k1**2*(D1*fd*(Pk2*k2**2*(4*C*(39*r + 54*s - 31) + 45*r + 204*s - 83) + k1**2*(14*C*Pkd2*k2*(3*s - 1) + Pk2*(-276*C*s + 92*C + 87*r + 396*s - 161))) + Dd*f*(Pk2*k2**2*(4*C*(52*r + 72*s - 31) + 60*r + 272*s - 83) + k1**2*(14*C*Pkd2*k2*(4*s - 1) + Pk2*(-368*C*s + 92*C + 116*r + 528*s - 161))))))/(105*d*k1**2*k2*k3**2) + 3*1j*D1**3*Pk1*ct**2*f**2*st**4*(4*Pk2 - Pkd2*k2)*(11*b1*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1)) + f*(11*D1*bd1*s + 5*D1*fd*(4*s - 1) + 5*Dd*f*(4*s - 1)))/(77*d*k1) + 1j*D1**3*Pk1*ct**2*f*st**4*(-3*b1*(D1*fd*(k1**2*(4*C - 9)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(Pk2*(-r*(32*C - 32) - 20*s + 10) + 5*Pkd2*k2*(2*s - 1))) + Dd*f*(k1**2*(4*C - 9)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(-2*Pk2*(32*C*r - 8*C - 32*r + 20*s + 3) + 5*Pkd2*k2*(4*s - 1)))) + f*(3*D1*bd1*(Pk2*k1**2*s*(36 - 16*C) + 2*Pk2*k2**2*(8*C*(r - 1) - 8*r + 5*s + 8) + Pkd2*k1**2*k2*s*(4*C - 9) - 5*Pkd2*k2**3*s) + D1*fd*(-k1**2*(4*C - 9)*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(2*Pk2*(36*C*r - 12*C - 36*r + 15*s + 7) + 5*Pkd2*k2*(1 - 3*s))) - Dd*f*k1**2*(4*C - 9)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + Dd*f*k2**2*(2*Pk2*(12*C*(4*r - 1) - 48*r + 20*s + 7) + 5*Pkd2*k2*(1 - 4*s))))/(35*d*k1*k3**2) - 1j*D1**3*Pk1*ct**2*st**2*(-11*b1**2*(D1*fd*(3*k1**2*(4*Pk2 - Pkd2*k2)*(12*f*s - 6*f + 7*s - 7) + k2**2*(2*Pk2*(18*f*(4*s - 1) + r*(14*K - 14) + 21*s - 21) + 3*Pkd2*k2*(f*(6 - 24*s) - 7*s + 7))) + Dd*f*(k1**2*(4*Pk2 - Pkd2*k2)*(18*f + 21)*(4*s - 1) + k2**2*(72*Pk2*f*(4*s - 1) + 14*Pk2*(K*(8*r - 2) - 8*r + 12*s - 1) - Pkd2*k2*(36*f + 21)*(4*s - 1)))) - 11*b1*(D1*(-56*Pk2*fd*g2*k2**2*r + 2*f**2*(-9*bd1*(-8*Pk2*k1**2*s + Pk2*k2**2*(2 - 8*s) + 2*Pkd2*k1**2*k2*s + Pkd2*k2**3*(4*s - 1)) + fd*(10*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(Pk2*(-72*r - 75*s + 43) + 5*Pkd2*k2*(1 - 6*s)))) + f*(-56*Pk2*gd2*k2**2*r + 14*bd1*(12*Pk2*k1**2*s + 2*Pk2*k2**2*(2*K*r - K - 2*r + 3*s + 1) - 3*Pkd2*k1**2*k2*s - 3*Pkd2*k2**3*s) + 9*fd*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + fd*k2**2*(Pk2*(40*K*r - 20*K - 40*r + 36*s + 2) + 9*Pkd2*k2*(1 - 2*s)))) + Dd*f*(56*Pk2*g2*k2**2*(1 - 4*r) + 2*f**2*(10*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(Pk2*(-96*r - 100*s + 49) + 10*Pkd2*k2*(1 - 4*s))) + f*(9*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(Pk2*(80*K*r - 20*K - 80*r + 72*s + 2) + 9*Pkd2*k2*(1 - 4*s))))) + f*(D1*(88*Pk2*g2*k2**2*(7*bd1*(r - 1) + 5*fd*(2*r - 1)) - 2*f**2*(-11*bd1*(-40*Pk2*k1**2*s + Pk2*k2**2*(24*r + 25*s - 6) + 10*Pkd2*k1**2*k2*s + 5*Pkd2*k2**3*(2*s - 1)) + 5*fd*(Pk2*k2**2*(-128*r - 220*s + 87) + 7*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 11*f*(40*Pk2*gd2*k2**2*r + bd1*(-36*Pk2*k1**2*s - 2*Pk2*k2**2*(r*(10*K - 10) + 9*s) + 9*Pkd2*k1**2*k2*s + 9*Pkd2*k2**3*s))) - 10*Dd*(44*Pk2*f*g2*k2**2*(1 - 4*r) + f**3*(Pk2*k2**2*(-128*r - 220*s + 87) + 7*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)))))/(385*d*k1*k2**2) - 1j*D1**3*Pk1*ct**2*(-21*b1**3*(-Pkd2*k2**3 + k1**2*(2*Pk2 - Pkd2*k2))*(3*D1*fd*s + Dd*(3*f + 5)*(4*s - 1)) - 3*b1**2*(-7*D1*bd1*(3*f + 5)*(3*s - 1)*(Pkd2*k2**3 + k1**2*(-2*Pk2 + Pkd2*k2)) - D1*fd*(k1**2*(Pk2*(6*f*s - 63*f + 49*s - 91) + Pkd2*k2*s*(60*f + 21)) + k2**2*(3*Pk2*f*(32*r + 84*s - 25) + 7*Pk2*(-4*K*(r - 1) + 4*r + 13*s - 17) + Pkd2*k2*s*(30*f + 21))) - Dd*f*(k1**2*(4*s - 1)*(Pk2*(3*f + 49) + Pkd2*k2*(30*f + 21)) + k2**2*(6*Pk2*f*(32*r + 84*s - 29) - 7*Pk2*(4*K*(4*r - 1) - 16*r - 52*s + 17) + Pkd2*k2*(15*f + 21)*(4*s - 1)))) + b1*(3*D1*bd1*f*(k1**2*(Pk2*(6*f*(s + 10) + 98*s + 42) + Pkd2*k2*(30*f + 21)*(2*s - 1)) + k2**2*(7*Pk2*r*(8 - 8*K) + 182*Pk2*s + 21*Pkd2*k2*(2*s - 1) + 3*f*(Pk2*(32*r + 84*s - 33) + 5*Pkd2*k2*(2*s - 1)))) + 3*D1*(Pk2*f*(57*fd*k1**2*(2*s - 1) + 3*fd*k2**2*(K*(8*r - 4) + 8*r + 38*s - 23) + 56*gd2*k2**2*r) + 56*Pk2*fd*g2*k2**2*(r - 1) + 5*f**2*fd*(Pk2*k2**2*(24*r + 54*s - 17) + k1**2*(40*Pk2*s - 18*Pk2 + 7*Pkd2*k2*s))) + Dd*f*(9*Pk2*f*(19*k1**2*(4*s - 1) + k2**2*(16*K*r - 4*K + 16*r + 76*s - 23)) + 168*Pk2*g2*k2**2*(4*r - 1) + 5*f**2*(6*Pk2*k2**2*(16*r + 36*s - 13) + k1**2*(40*Pk2 + 7*Pkd2*k2)*(4*s - 1)))) + f*(D1*bd1*(9*Pk2*f*(19*k1**2*s + k2**2*(r*(4*K + 4) + 19*s)) + 168*Pk2*g2*k2**2*r + 5*f**2*(3*Pk2*k2**2*(8*r + 18*s - 9) + k1**2*(2*Pk2*(20*s + 7) + 7*Pkd2*k2*(s - 1)))) + 3*Pk2*(35*D1*f**2*fd*k1**2*(4*s - 1) + 12*D1*f*k2**2*r*(bd2 - 2*gd2) + 12*D1*fd*k2**2*(b2 - 2*g2)*(2*r - 1) + 35*Dd*f**3*k1**2*(4*s - 1) + 12*Dd*f*k2**2*(b2 - 2*g2)*(4*r - 1))))/(105*d*k1*k2**2) - 1j*D1**3*Pk1*ct**2*st**2*(-21*b1**2*k2**2*(D1*fd*(Pk2*k1**2*s*(14 - 8*C) + Pk2*k2**2*r*(8*C - 8) + Pkd2*k1**2*k2*s*(4*C - 7) - 3*Pkd2*k2**3*s) + Dd*f*(-k1**2*(4*C - 7)*(2*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(Pk2*(8*C - 8)*(4*r - 1) + 3*Pkd2*k2*(1 - 4*s)))) - 3*b1*f*(D1*(7*bd1*k1**2*k2**2*(4*C - 7)*(-2*Pk2 + Pkd2*k2)*(2*s - 1) + 7*bd1*k2**4*(Pk2*(8*C - 8)*(2*r - 1) + 3*Pkd2*k2*(1 - 2*s)) + 9*fd*k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1) + fd*k1**2*k2**2*(4*Pk2*(C*(26*r + 138*s - 75) - 65*r - 99*s + 60) + 3*Pkd2*k2*(-8*C*(5*s - 3) - 20*s + 3)) - 2*fd*k2**4*(Pk2*(C*(20 - 40*r) + 82*r + 102*s - 71) + 9*Pkd2*k2*s)) + Dd*f*(9*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 2*k1**2*k2**2*(-4*Pk2*(C*(26*r + 138*s - 41) - 65*r - 99*s + 41) + Pkd2*k2*(30*C + 15)*(4*s - 1)) + k2**4*(8*Pk2*(20*C*r - 5*C - 41*r - 51*s + 23) + 9*Pkd2*k2*(1 - 4*s)))) + f**2*(D1*(3*bd1*(9*k1**4*s*(-4*Pk2 + Pkd2*k2) + k1**2*k2**2*(-2*Pk2*(2*C*(13*r + 69*s - 7) - 65*r - 99*s + 44) + 3*Pkd2*k2*(4*C*(5*s + 1) + 10*s - 7)) + k2**4*(Pk2*(-40*C*r + 82*r + 102*s - 42) + 9*Pkd2*k2*(s - 1))) + fd*(6*Pk2*k2**4*(16*C*(3*r - 1) + 51*r + 69*s - 40) - 15*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k1**2*k2**2*(-2*Pk2*(2*C*(69*r + 351*s - 140) - 381*r - 504*s + 295) + Pkd2*k2*(120*C + 15)*(3*s - 1)))) + Dd*f*(24*Pk2*k2**4*(4*C*(4*r - 1) + 17*r + 23*s - 10) - 15*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(-2*Pk2*(8*C*(23*r + 117*s - 35) - 508*r - 672*s + 295) + Pkd2*k2*(120*C + 15)*(4*s - 1)))))/(105*d*k1*k2**2*k3**2) - 1j*D1**3*Pk1*ct**2*(-21*b1**2*(-D1*fd*(Pk2*k2**4*(4*r + 13*s) + k1**4*(-6*Pk2*s + 3*Pkd2*k2*s) + k1**2*k2**2*(Pk2*r*(36 - 20*C) + Pk2*s*(57 - 44*C) + Pkd2*k2*s*(12*C + 3))) + Dd*f*(Pk2*k2**4*(-16*r - 52*s + 17) + 3*k1**4*(2*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(16*C*Pk2*(5*r + 11*s - 4) - 3*Pk2*(48*r + 76*s - 31) + Pkd2*k2*(-12*C - 3)*(4*s - 1)))) + 3*b1*f*(-7*D1*bd1*(Pk2*k2**4*(-8*r - 26*s + 17) + 3*k1**4*(2*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(Pk2*(8*C*(5*r + 11*s - 8) - 72*r - 114*s + 93) + Pkd2*k2*(-12*C - 3)*(2*s - 1))) + 3*D1*fd*(2*Pk2*k2**4*(C*(8*r - 4) + 12*r + 19*s - 6) + k1**4*(Pk2*(18*s - 19) + 10*Pkd2*k2*s) + k1**2*k2**2*(Pk2*(-16*C*(r - 2*s + 3) + 136*r + 212*s - 87) + Pkd2*k2*s*(40*C + 10))) + 3*Dd*f*(Pk2*k2**4*(8*C*(4*r - 1) + 48*r + 76*s - 31) + k1**4*(9*Pk2 + 5*Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(-8*C*(4*r - 8*s + 1) + 272*r + 424*s - 174) + Pkd2*k2*(20*C + 5)*(4*s - 1)))) + f**2*(9*D1*bd1*(Pk2*k2**4*(r*(8*C + 12) + 19*s - 19) + k1**4*(Pk2*(9*s + 10) + 5*Pkd2*k2*(s - 1)) + k1**2*k2**2*(Pk2*(-8*C*(r - 2*s - 5) + 68*r + 106*s - 87) + Pkd2*k2*(20*C + 5)*(s - 1))) + 5*Pk2*k1**2*(D1*fd*(25*k1**2*(3*s - 1) + k2**2*(4*C*(33*r + 81*s - 38) + 75*s - 25)) + Dd*f*(25*k1**2*(4*s - 1) + k2**2*(8*C*(22*r + 54*s - 19) + 100*s - 25)))))/(105*d*k1*k2**2*k3**2) + 1j*D1**3*Pk1*ct*f*st**4*(33*b1**2*k1**2*(4*Pk2 - Pkd2*k2)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) + 11*b1*f*(-3*D1*(Pk2*fd*k2**2*r + 2*bd1*k1**2*s*(-4*Pk2 + Pkd2*k2) - fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) + Dd*f*(Pk2*k2**2*(1 - 4*r) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + f**2*(-11*D1*bd1*(-12*Pk2*k1**2*s + Pk2*k2**2*(r - 1) + 3*Pkd2*k1**2*k2*s) + D1*fd*(13*Pk2*k2**2*(1 - 4*r) + 10*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 13*Dd*Pk2*f*k2**2*(1 - 4*r) + 10*Dd*f*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)))/(77*d*k1**2*k2) - 1j*D1**3*Pk1*ct*f*st**4*(-3*b1*(2*D1*fd*(-3*Pk2*k2**4*r + k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(4*C*Pk2*(2*r + 6*s - 3) + 5*C*Pkd2*k2*(1 - 2*s) - 13*Pk2*r - 2*Pkd2*k2*s + Pkd2*k2)) + Dd*f*(3*Pk2*k2**4*(1 - 4*r) + 2*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(32*C*(r + 3*s - 1) - 52*r + 13) + Pkd2*k2*(-10*C - 2)*(4*s - 1)))) + f*(D1*(3*bd1*(3*Pk2*k2**4*(r - 1) + k1**4*(-8*Pk2*s + 2*Pkd2*k2*s) + k1**2*k2**2*(-8*C*Pk2*(r + 3*s - 1) + 13*Pk2*(r - 1) + Pkd2*k2*s*(10*C + 2))) + fd*(7*Pk2*k2**4*(3*r - 1) - 2*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k1**2*k2**2*(Pk2*(-8*C*(3*r + 9*s - 4) + 51*r - 17) + Pkd2*k2*(10*C + 2)*(3*s - 1)))) + Dd*f*(7*Pk2*k2**4*(4*r - 1) - 2*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(-32*C*(r + 3*s - 1) + 68*r - 17) + Pkd2*k2*(10*C + 2)*(4*s - 1)))))/(35*d*k1**2*k2*k3**2) - 1j*D1**3*Pk1*ct*(-7*b1**2*(-D1*fd*(Pk2*k2**2*(r*(20*C + 7) + s*(20*C + 16)) + k1**2*(6*C*Pkd2*k2*s + 13*Pk2*r + Pk2*s*(28 - 12*C))) + Dd*f*(-Pk2*k2**2*(40*C*(2*r + 2*s - 1) + 28*r + 64*s - 23) + k1**2*(6*C*Pkd2*k2*(1 - 4*s) + Pk2*(48*C*s - 12*C - 52*r - 112*s + 41)))) + b1*f*(7*D1*Pk2*bd1*k2**2*(40*C*(r + s - 1) + 14*r + 32*s - 23) - 7*D1*bd1*k1**2*(6*C*Pkd2*k2*(1 - 2*s) + Pk2*(12*C*(2*s - 1) - 26*r - 56*s + 41)) + 3*D1*fd*(Pk2*k2**2*(C*(88*r + 56*s - 44) + 26*r + 48*s - 13) + k1**2*(20*C*Pkd2*k2*s + Pk2*(4*C*(4*s - 7) + 46*r + 88*s - 23))) + 3*Dd*f*(Pk2*k2**2*(8*C*(22*r + 14*s - 9) + 52*r + 96*s - 37) + k1**2*(10*C*Pkd2*k2*(4*s - 1) + Pk2*(32*C*s - 8*C + 92*r + 176*s - 67)))) + 3*f**2*(20*C*Pk2*k1**2*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1)) + D1*bd1*(Pk2*k2**2*(4*C*(11*r + 7*s - 7) + 13*r + 24*s - 24) + k1**2*(10*C*Pkd2*k2*(s - 1) + Pk2*(8*C*s + 20*C + 23*r + 44*s - 44)))))/(35*d*k2*k3**2) - 1j*D1**3*Pk1*ct*st**2*(-231*b1**3*k1**2*(2*Pk2 - Pkd2*k2)*(D1*fd*s + Dd*f*(4*s - 1)) - 11*b1**2*(21*D1*bd1*f*k1**2*(2*Pk2 - Pkd2*k2)*(3*s - 1) - D1*fd*(Pk2*k2**2*r*(12*f + 7) + k1**2*(6*Pk2*f*(7*r + 4*s - 11) + 7*Pk2*(-8*K*(s - 1) + 3*r - 4*s + 4) + 9*Pkd2*f*k2*(8*s - 1) + Pkd2*k2*(21*K + 21)*(s - 1))) - Dd*f*(Pk2*k2**2*(6*f + 7)*(4*r - 1) + k1**2*(Pk2*f*(84*r + 48*s - 33) + 7*Pk2*(K*(8 - 32*s) + 12*r - 16*s + 1) + Pkd2*k2*(4*s - 1)*(21*K + 36*f + 21)))) + 11*b1*(-48*D1*K*Pk2*f*fd*k1**2*s + 24*D1*K*Pk2*f*fd*k1**2 + 18*D1*K*Pkd2*f*fd*k1**2*k2*s - 9*D1*K*Pkd2*f*fd*k1**2*k2 - 42*D1*Pk2*bd2*f*k1**2*s + 102*D1*Pk2*f**2*fd*k1**2*r + 234*D1*Pk2*f**2*fd*k1**2*s - 115*D1*Pk2*f**2*fd*k1**2 + 42*D1*Pk2*f**2*fd*k2**2*r - 14*D1*Pk2*f**2*fd*k2**2 + 34*D1*Pk2*f*fd*k1**2*r - 24*D1*Pk2*f*fd*k1**2*s - 5*D1*Pk2*f*fd*k1**2 + 22*D1*Pk2*f*fd*k2**2*r - 11*D1*Pk2*f*fd*k2**2 + 112*D1*Pk2*f*gd2*k1**2*s + 112*D1*Pk2*fd*g2*k1**2*s - 112*D1*Pk2*fd*g2*k1**2 + 21*D1*Pkd2*bd2*f*k1**2*k2*s + 45*D1*Pkd2*f**2*fd*k1**2*k2*s - 5*D1*Pkd2*f**2*fd*k1**2*k2 + 18*D1*Pkd2*f*fd*k1**2*k2*s - 9*D1*Pkd2*f*fd*k1**2*k2 - 42*D1*Pkd2*f*gd2*k1**2*k2*s - 42*D1*Pkd2*fd*g2*k1**2*k2*s + 42*D1*Pkd2*fd*g2*k1**2*k2 + D1*bd1*f*(Pk2*k2**2*(6*f + 7)*(2*r - 1) + k1**2*(3*Pk2*f*(14*r + 8*s + 11) - 7*Pk2*(16*K*s - 6*r + 8*s + 3) + 9*Pkd2*f*k2*(8*s - 3) + Pkd2*k2*s*(42*K + 42))) - 96*Dd*K*Pk2*f**2*k1**2*s + 24*Dd*K*Pk2*f**2*k1**2 + 36*Dd*K*Pkd2*f**2*k1**2*k2*s - 9*Dd*K*Pkd2*f**2*k1**2*k2 + 136*Dd*Pk2*f**3*k1**2*r + 312*Dd*Pk2*f**3*k1**2*s - 112*Dd*Pk2*f**3*k1**2 + 56*Dd*Pk2*f**3*k2**2*r - 14*Dd*Pk2*f**3*k2**2 + 68*Dd*Pk2*f**2*k1**2*r - 48*Dd*Pk2*f**2*k1**2*s - 5*Dd*Pk2*f**2*k1**2 + 44*Dd*Pk2*f**2*k2**2*r - 11*Dd*Pk2*f**2*k2**2 + 448*Dd*Pk2*f*g2*k1**2*s - 112*Dd*Pk2*f*g2*k1**2 + 60*Dd*Pkd2*f**3*k1**2*k2*s - 15*Dd*Pkd2*f**3*k1**2*k2 + 36*Dd*Pkd2*f**2*k1**2*k2*s - 9*Dd*Pkd2*f**2*k1**2*k2 - 168*Dd*Pkd2*f*g2*k1**2*k2*s + 42*Dd*Pkd2*f*g2*k1**2*k2 - 21*b2*k1**2*(2*Pk2 - Pkd2*k2)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))) + f*(11*D1*bd1*(f**2*(14*Pk2*k2**2*r + k1**2*(Pk2*(34*r + 78*s + 3) + 5*Pkd2*k2*(3*s - 2))) + f*(11*Pk2*k2**2*r + k1**2*(17*Pk2*r - 12*Pk2*(2*K*s + s) + Pkd2*k2*s*(9*K + 9))) + 14*g2*k1**2*s*(8*Pk2 - 3*Pkd2*k2)) - 33*b2*k1**2*(2*Pk2 - Pkd2*k2)*(7*D1*bd1*s + D1*fd*(6*s - 3) + 3*Dd*f*(4*s - 1)) + k1**2*(5*D1*Pk2*f**2*fd*(108*r + 352*s - 115) - 33*D1*f*s*(6*Pk2*bd2 - 16*Pk2*gd2 - 3*Pkd2*bd2*k2 + 6*Pkd2*gd2*k2) + 66*D1*fd*g2*(8*Pk2 - 3*Pkd2*k2)*(2*s - 1) + 5*Dd*Pk2*f**3*(108*r + 352*s - 115) + 66*Dd*f*g2*(8*Pk2 - 3*Pkd2*k2)*(4*s - 1))))/(385*d*k1**2*k2) - 1j*D1**3*Pk1*ct*(21*b1**3*(-D1*Pk2*fd*k2**2*r + D1*fd*k1**2*(5*Pk2*(r + 2*s) + 3*Pkd2*k2*s) - Dd*Pk2*k2**2*(f + 5)*(4*r - 1) + Dd*k1**2*(5*Pk2*(-8*K*s + 2*K + f*(4*r + 8*s - 3) + 4*r + 8*s - 3) + Pkd2*k2*(4*s - 1)*(5*K + 3*f + 5))) + 3*b1**2*(7*D1*bd1*(-Pk2*k2**2*(f + 5)*(3*r - 1) + k1**2*(5*Pk2*(-6*K*s + 2*K + 3*f*(r + 2*s - 1) + 3*r + 6*s - 3) + Pkd2*k2*(3*s - 1)*(5*K + 3*f + 5))) + D1*(Pk2*fd*k2**2*(6*f*r - 3*f + 7*r - 7) + fd*k1**2*(3*Pk2*f*(44*r + 112*s - 25) + 7*Pk2*(2*K*(2*s - 5) + 7*r + 16*s - 17) + Pkd2*k2*s*(21*K + 30*f + 21)) + 35*k1**2*s*(4*Pk2*gd2 + Pkd2*bd2*k2 - 2*Pkd2*gd2*k2)) + Dd*(3*f**2*(Pk2*k2**2*(4*r - 1) + k1**2*(Pk2*(88*r + 224*s - 78) + 5*Pkd2*k2*(4*s - 1))) + 7*f*(Pk2*k2**2*(4*r - 1) + k1**2*(Pk2*(16*K*s - 4*K + 28*r + 64*s - 23) + Pkd2*k2*(3*K + 3)*(4*s - 1))) + 35*k1**2*(4*s - 1)*(4*Pk2*g2 + Pkd2*b2*k2 - 2*Pkd2*g2*k2))) + b1*(3*D1*bd1*(3*f**2*(2*Pk2*k2**2*r + k1**2*(Pk2*(44*r + 112*s - 53) + 5*Pkd2*k2*(2*s - 1))) + 7*f*(2*Pk2*k2**2*r + k1**2*(2*Pk2*(4*K*s + 3*K + 7*r + 16*s - 3) + Pkd2*k2*(3*K + 3)*(2*s - 1))) + 35*k1**2*(2*s - 1)*(4*Pk2*g2 + Pkd2*b2*k2 - 2*Pkd2*g2*k2)) + k1**2*(D1*(5*Pk2*f**2*fd*(51*r + 162*s - 35) + 21*f*(6*Pk2*fd*(K + 1)*(2*s - 1) + s*(10*Pk2*bd2 - 8*Pk2*gd2 + 3*Pkd2*bd2*k2 - 6*Pkd2*gd2*k2)) - 42*fd*g2*(2*Pk2*(2*s - 5) + 3*Pkd2*k2*s)) + Dd*f*(5*Pk2*f**2*(68*r + 216*s - 71) + 126*Pk2*f*(K + 1)*(4*s - 1) - 42*g2*(4*Pk2 + 3*Pkd2*k2)*(4*s - 1)) + 21*b2*(D1*fd*(10*Pk2*(s - 1) + 3*Pkd2*k2*s) + Dd*f*(10*Pk2 + 3*Pkd2*k2)*(4*s - 1)))) + f*k1**2*(D1*bd1*(5*Pk2*f**2*(17*r + 54*s - 36) + 126*Pk2*f*s*(K + 1) - 42*g2*(Pk2*(4*s + 6) + 3*Pkd2*k2*(s - 1))) + 126*Pk2*(D1*f*s*(bd2 - 2*gd2) + D1*fd*g2*(2 - 4*s) + 2*Dd*f*g2*(1 - 4*s)) + 21*b2*(D1*(10*Pk2*bd1*s + 6*Pk2*fd*(2*s - 1) + 3*Pkd2*bd1*k2*(s - 1)) + 6*Dd*Pk2*f*(4*s - 1))))/(105*d*k1**2*k2) - 1j*D1**3*Pk1*ct*st**2*(-21*b1**2*(-D1*fd*(Pk2*k2**4*r + k1**4*(-4*Pk2*s + 2*Pkd2*k2*s) + k1**2*k2**2*(Pk2*r*(11 - 8*C) - Pk2*s*(4*C - 4) + Pkd2*k2*s*(6*C + 2))) + Dd*f*(Pk2*k2**4*(1 - 4*r) + 2*k1**4*(2*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(4*C*(8*r + 4*s - 3) - 44*r - 16*s + 15) + Pkd2*k2*(-6*C - 2)*(4*s - 1)))) - 3*b1*f*(7*D1*bd1*(Pk2*k2**4*(1 - 2*r) + 2*k1**4*(2*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(Pk2*(4*C*(4*r + 2*s - 3) - 22*r - 8*s + 15) + Pkd2*k2*(-6*C - 2)*(2*s - 1))) + D1*fd*(11*Pk2*k2**4*(1 - 2*r) + 2*k1**4*(Pk2*(48*C*s - 24*C - 23*r - 60*s + 36) - 3*Pkd2*k2*(6*C*s - 3*C + 2*s)) - k1**2*k2**2*(Pk2*(24*C*(5*r + 13*s - 6) + 116*r + 144*s - 101) + Pkd2*k2*s*(36*C + 12))) + Dd*f*(11*Pk2*k2**4*(1 - 4*r) + k1**4*(Pk2*(48*C*(4*s - 1) - 92*r - 240*s + 83) + Pkd2*k2*(-18*C - 6)*(4*s - 1)) - 2*k1**2*k2**2*(Pk2*(12*C*(10*r + 26*s - 9) + 116*r + 144*s - 65) + Pkd2*k2*(9*C + 3)*(4*s - 1)))) + f**2*(-3*D1*bd1*(-11*Pk2*k2**4*r + k1**4*(Pk2*(48*C*s - 23*r - 60*s + 11) - 6*Pkd2*k2*(3*C*s + s - 1)) - k1**2*k2**2*(Pk2*(12*C*(5*r + 13*s - 6) + 58*r + 72*s - 29) + Pkd2*k2*(18*C + 6)*(s - 1))) + k1**2*(D1*fd*(Pk2*k2**2*(12*C*(51*r + 54*s - 35) + 93*r + 252*s - 115) + k1**2*(30*C*Pkd2*k2*(3*s - 1) + Pk2*(-240*C*s + 80*C + 123*r + 312*s - 145))) + Dd*f*(Pk2*k2**2*(12*C*(68*r + 72*s - 35) + 124*r + 336*s - 115) + k1**2*(30*C*Pkd2*k2*(4*s - 1) + Pk2*(-320*C*s + 80*C + 164*r + 416*s - 145))))))/(105*d*k1**2*k2*k3**2) + 1j*D1**3*Pk1*f**2*st**6*(4*Pk2 - Pkd2*k2)*(11*b1*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1)) + f*(11*D1*bd1*s + 3*D1*fd*(4*s - 1) + 3*Dd*f*(4*s - 1)))/(231*d*k1) - 1j*D1**3*Pk1*f*st**4*(3*D1*bd1*f*(Pk2*k2**2*(2*r + s - 2) + k1**2*(4*C*Pkd2*k2*s + Pk2*(-8*C*s + 2*r + s - 2))) - 3*b1*(D1*fd*(Pk2*k2**2*(-4*r - 2*s + 1) + k1**2*(4*C*Pkd2*k2*(1 - 2*s) + Pk2*(16*C*s - 8*C - 4*r - 2*s + 1))) + Dd*f*(Pk2*k2**2*(-8*r - 4*s + 3) + k1**2*(4*C*Pkd2*k2*(1 - 4*s) + Pk2*(32*C*s - 8*C - 8*r - 4*s + 3)))) + f*(D1*fd*(Pk2*k2**2*(24*C*r - 8*C + 6*r + 3*s - 3) + k1**2*(4*C*Pkd2*k2*(3*s - 1) + Pk2*(-24*C*s + 8*C + 6*r + 3*s - 3))) + Dd*f*(Pk2*k2**2*(8*C*(4*r - 1) + 8*r + 4*s - 3) + k1**2*(4*C*Pkd2*k2*(4*s - 1) + Pk2*(-32*C*s + 8*C + 8*r + 4*s - 3)))))/(35*d*k1*k3**2) - 1j*D1**3*Pk1*f*st**4*(-33*b1**2*(D1*fd*(k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(2*Pk2 - Pkd2*k2)*(4*s - 1)) + Dd*f*(4*s - 1)*(k1**2*(4*Pk2 - Pkd2*k2) - 2*k2**2*(-2*Pk2 + Pkd2*k2))) - 11*b1*f*(3*D1*bd1*(8*Pk2*k1**2*s + 2*Pk2*k2**2*(4*s - 1) - 2*Pkd2*k1**2*k2*s + k2**3*(-4*Pkd2*s + Pkd2)) + D1*fd*(2*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(Pk2*(-36*r - 33*s + 17) + Pkd2*k2*(1 - 6*s))) + 2*Dd*f*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + Dd*f*k2**2*(Pk2*(-48*r - 44*s + 23) + 2*Pkd2*k2*(1 - 4*s))) + f**2*(11*D1*bd1*(-8*Pk2*k1**2*s + Pk2*k2**2*(12*r + 11*s - 6) + 2*Pkd2*k1**2*k2*s + Pkd2*k2**3*(2*s - 1)) + D1*fd*(Pk2*k2**2*(192*r + 220*s - 103) - 5*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + Dd*Pk2*f*k2**2*(192*r + 220*s - 103) - 5*Dd*f*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)))/(385*d*k1*k2**2) - 1j*D1**3*Pk1*st**2*(21*b1**3*(Pkd2*k2**3 + k1**2*(-2*Pk2 + Pkd2*k2))*(D1*fd*s + Dd*f*(4*s - 1)) - 3*b1**2*(-7*D1*bd1*f*(3*s - 1)*(Pkd2*k2**3 + k1**2*(-2*Pk2 + Pkd2*k2)) - D1*fd*(k1**2*(3*Pk2*f*(6*s - 7) + 7*Pk2*(s - 1) + 12*Pkd2*f*k2*s) + k2**2*(Pk2*f*(64*r + 84*s - 29) + 7*Pk2*(s - 1) + 6*Pkd2*f*k2*s)) + Dd*f*(-k1**2*(4*s - 1)*(Pk2*(9*f + 7) + 6*Pkd2*f*k2) + k2**2*(Pk2*(-2*f*(64*r + 84*s - 37) - 28*s + 7) + 3*Pkd2*f*k2*(1 - 4*s)))) + b1*f*(3*D1*bd1*(Pk2*s*(14*k1**2 + 14*k2**2) + 6*f*k1**2*(Pk2*(3*s + 2) + Pkd2*k2*(2*s - 1)) + f*k2**2*(Pk2*(64*r + 84*s - 45) + 3*Pkd2*k2*(2*s - 1))) + 3*D1*fd*(Pk2*k2**2*(16*K*r - 8*K + f*(48*r + 54*s - 25) + 16*r + 6*s - 11) + k1**2*(Pk2*(44*f*s - 18*f + 6*s - 3) + 5*Pkd2*f*k2*s)) + Dd*f*(3*Pk2*k2**2*(32*K*r - 8*K + f*(64*r + 72*s - 34) + 32*r + 12*s - 11) + k1**2*(4*s - 1)*(Pk2*(44*f + 9) + 5*Pkd2*f*k2))) + f*(D1*bd1*f*(3*Pk2*f*k2**2*(16*r + 18*s - 9) + 9*Pk2*k1**2*s + 3*Pk2*k2**2*(r*(8*K + 8) + 3*s) + f*k1**2*(2*Pk2*(22*s + 5) + 5*Pkd2*k2*(s - 1))) + 3*Pk2*(5*D1*f**2*fd*k1**2*(4*s - 1) + 8*D1*f*k2**2*r*(bd2 - 2*gd2) + 8*D1*fd*k2**2*(b2 - 2*g2)*(2*r - 1) + 5*Dd*f**3*k1**2*(4*s - 1) + 8*Dd*f*k2**2*(b2 - 2*g2)*(4*r - 1))))/(105*d*k1*k2**2) - 1j*D1**3*Pk1*st**2*(21*b1**2*k2**2*(D1*fd*(Pk2*k2**2*(2*r + s) + k1**2*(4*C*Pkd2*k2*s + 2*Pk2*r + Pk2*s)) + Dd*f*(Pk2*k2**2*(8*r + 4*s - 3) + k1**2*(4*C*Pkd2*k2*(4*s - 1) + Pk2*(8*r + 4*s - 3)))) + 3*b1*f*(D1*(7*bd1*k2**2*(Pk2*k2**2*(4*r + 2*s - 3) + k1**2*(4*C*Pkd2*k2*(2*s - 1) + Pk2*(4*r + 2*s - 3))) + fd*(3*Pk2*k1**4*(2*s - 1) + 2*Pk2*k2**4*(16*C*r - 8*C + 6*r + 3*s - 3) + k1**2*k2**2*(28*C*Pk2*(2*r + 6*s - 3) + 24*C*Pkd2*k2*s + 3*Pk2*(4*r + 4*s - 3)))) + Dd*f*(3*Pk2*k1**4*(4*s - 1) + Pk2*k2**4*(64*C*r - 16*C + 24*r + 12*s - 9) + 4*k1**2*k2**2*(3*C*Pkd2*k2*(4*s - 1) + Pk2*(28*C*(r + 3*s - 1) + 6*r + 6*s - 3)))) + f**2*(D1*(Pk2*fd*k1**2*(5*k1**2*(3*s - 1) + k2**2*(4*C*(39*r + 81*s - 40) + 15*s - 5)) + 3*bd1*(3*Pk2*k1**4*s + Pk2*k2**4*(16*C*r + 6*r + 3*s - 3) + k1**2*k2**2*(12*C*Pkd2*k2*(s - 1) + Pk2*(28*C*(r + 3*s - 1) + 6*r + 6*s - 3)))) + Dd*Pk2*f*k1**2*(5*k1**2*(4*s - 1) + k2**2*(16*C*(13*r + 27*s - 10) + 20*s - 5))))/(105*d*k1*k2**2*k3**2) + 2*1j*D1**3*Pk2*Pkd1*ct**6*f*k2**2*(C - 1)*(9*D1*bd1*f*(r - 1) + 9*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 7*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(21*d*k3**2) - 1j*D1**3*Pk2*Pkd1*ct**5*f**2*k2*(11*D1*bd1*f*(r - 1) + 11*b1*(3*D1*fd*r + Dd*f*(4*r - 1)) + 9*f*(4*r - 1)*(D1*fd + Dd*f))/(33*d*k1) - 1j*D1**3*Pk2*Pkd1*ct**5*f*k2*(k1**2*(5 - 4*C) + k2**2)*(9*D1*bd1*f*(r - 1) + 9*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 7*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(21*d*k1*k3**2) + 4*1j*D1**3*Pk2*Pkd1*ct**4*f*k2**2*st**2*(C - 1)*(9*D1*bd1*f*(r - 1) + 9*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 5*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(35*d*k3**2) - 1j*D1**3*Pk2*Pkd1*ct**4*(99*b1**2*(D1*fd*r*(-7*K + 10*f + 7) + Dd*f*(4*r - 1)*(-7*K + 5*f + 7)) + 11*b1*(9*D1*bd1*f*(2*r - 1)*(-7*K + 5*f + 7) + D1*(35*f**2*fd*(9*r - 1) - 45*f*fd*(K - 1)*(2*r - 1) + 126*f*gd2*r + 126*fd*g2*r) + 3*Dd*f*(4*r - 1)*(35*f**2 - 15*f*(K - 1) + 42*g2)) + f*(11*D1*bd1*(35*f**2*(3*r - 2) - 45*f*r*(K - 1) + 126*g2*(r - 1)) + 90*D1*(7*f**2*fd*(4*r - 1) + 11*f*gd2*r + 11*fd*g2*(2*r - 1)) + 90*Dd*f*(7*f**2 + 11*g2)*(4*r - 1)))/(1155*d) + 2*1j*D1**3*Pk2*Pkd1*ct**4*(9*D1*bd1*f*(7*b1*k2**2*(C - 1)*(2*r - 1) + 5*f*(k1**2*(C - 2)*(r - 1) + k2**2*(C - 2*r + 1))) + 63*b1**2*k2**2*(C - 1)*(D1*fd*r + Dd*f*(4*r - 1)) + 45*b1*f*(D1*fd*(k1**2*r*(2*C - 4) - k2**2*(C + 4*r - 1)) + Dd*f*(4*r - 1)*(k1**2*(C - 2) - 2*k2**2)) + 35*f**2*(k1**2*(C - 2) - k2**2*(C + 1))*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(105*d*k3**2) - 10*1j*D1**3*Pk2*Pkd1*ct**3*f**2*k2*st**2*(11*D1*bd1*f*(r - 1) + 11*b1*(3*D1*fd*r + Dd*f*(4*r - 1)) + 7*f*(4*r - 1)*(D1*fd + Dd*f))/(231*d*k1) - 2*1j*D1**3*Pk2*Pkd1*ct**3*f*k2*st**2*(k1**2*(3 - 2*C) + k2**2)*(9*D1*bd1*f*(r - 1) + 9*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 5*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(35*d*k1*k3**2) - 1j*D1**3*Pk2*Pkd1*ct**3*(99*b1**2*(D1*fd*r*(k1**2*(10*f + 7) + k2**2*(20*f + 7)) + Dd*f*(4*r - 1)*(k1**2*(5*f + 7) + k2**2*(10*f + 7))) + 11*b1*f*(9*D1*bd1*(2*r - 1)*(k1**2*(5*f + 7) + k2**2*(10*f + 7)) + 5*D1*fd*(k1**2*(7*f*(6*r - 1) + 18*r - 9) + k2**2*(14*f*(3*r - 1) + 18*r - 9)) + 5*Dd*f*(14*f + 9)*(k1**2 + k2**2)*(4*r - 1)) + 5*f**2*(11*D1*bd1*(7*f*(k1**2*(2*r - 1) + 2*k2**2*r) + r*(9*k1**2 + 9*k2**2)) + 63*f*k1**2*(4*r - 1)*(D1*fd + Dd*f)))/(1155*d*k1*k2) - 1j*D1**3*Pk2*Pkd1*ct**3*(9*D1*bd1*f*(7*b1*k2**2*(2*r - 1)*(k1**2*(5 - 4*C) + k2**2) + 5*f*(k1**4*(r - 1) - k1**2*k2**2*(4*C - 6*r + 1) + k2**4*r)) + 63*b1**2*k2**2*(k1**2*(5 - 4*C) + k2**2)*(D1*fd*r + Dd*f*(4*r - 1)) + 45*b1*f*(D1*fd*(2*k1**4*r + k1**2*k2**2*(4*C + 12*r - 5) + k2**4*(2*r - 1)) + Dd*f*(4*r - 1)*(k1**4 + 6*k1**2*k2**2 + k2**4)) + 35*f**2*k1**2*(k1**2 + k2**2*(4*C + 1))*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(105*d*k1*k2*k3**2) + 2*1j*D1**3*Pk2*Pkd1*ct**2*f*k2**2*st**4*(C - 1)*(6*D1*b1*fd*r + 3*D1*bd1*f*(r - 1) + D1*f*fd*(3*r - 1) + 3*Dd*b1*f*(4*r - 1) + Dd*f**2*(4*r - 1))/(35*d*k3**2) - 1j*D1**3*Pk2*Pkd1*ct**2*st**2*(11*b1**2*(D1*fd*r*(-7*K + 36*f + 7) + Dd*f*(4*r - 1)*(-7*K + 18*f + 7)) + 11*b1*(D1*bd1*f*(2*r - 1)*(-7*K + 18*f + 7) + D1*(10*f**2*fd*(9*r - 1) - 3*f*fd*(K - 1)*(2*r - 1) + 14*f*gd2*r + 14*fd*g2*r) + Dd*f*(4*r - 1)*(30*f**2 - 3*f*(K - 1) + 14*g2)) + f*(11*D1*bd1*(10*f**2*(3*r - 2) - 3*f*r*(K - 1) + 14*g2*(r - 1)) + 2*D1*(70*f**2*fd*(4*r - 1) + 33*f*gd2*r + 33*fd*g2*(2*r - 1)) + 2*Dd*f*(70*f**2 + 33*g2)*(4*r - 1)))/(385*d) - 1j*D1**3*Pk2*Pkd1*ct**2*(7*b1**3*(3*D1*fd*r + Dd*(4*r - 1)*(-5*K + 3*f + 5)) + b1**2*(7*D1*bd1*(3*r - 1)*(-5*K + 3*f + 5) + 3*D1*fd*(7*K + 5*f*(8*r - 1) + 14*r - 7) + 70*D1*gd2*r + 2*Dd*(4*r - 1)*(30*f**2 + 21*f + 35*g2)) + b1*(30*D1*K*f*fd*r - 15*D1*K*f*fd + D1*bd1*(15*f**2*(8*r - 3) - 21*f*(K - 4*r + 1) + 70*g2*(2*r - 1)) + 21*D1*bd2*f*r + 105*D1*f**2*fd*r - 35*D1*f**2*fd + 30*D1*f*fd*r - 15*D1*f*fd - 42*D1*fd*g2 + 60*Dd*K*f**2*r - 15*Dd*K*f**2 + 140*Dd*f**3*r - 35*Dd*f**3 + 60*Dd*f**2*r - 15*Dd*f**2 + 21*b2*(D1*fd*r + Dd*f*(4*r - 1))) + f*(5*D1*bd1*f*r*(3*K + 7*f + 3) + 42*D1*bd1*g2 + 15*D1*(f*r*(bd2 - 2*gd2) + fd*g2*(2 - 4*r)) + 30*Dd*f*g2*(1 - 4*r) + 3*b2*(7*D1*bd1*(r - 1) + 5*D1*fd*(2*r - 1) + 5*Dd*f*(4*r - 1))))/(35*d) + 2*1j*D1**3*Pk2*Pkd1*ct**2*st**2*(3*D1*bd1*f*(7*b1*k2**2*(C - 1)*(2*r - 1) + 3*f*(k1**2*(C - 4)*(r - 1) + k2**2*(-5*C*r + 6*C - 4*r + 3))) + 21*b1**2*k2**2*(C - 1)*(D1*fd*r + Dd*f*(4*r - 1)) + 9*b1*f*(D1*fd*(k1**2*r*(2*C - 8) - k2**2*(10*C*r + C + 8*r - 1)) + Dd*f*(4*r - 1)*(k1**2*(C - 4) - k2**2*(5*C + 4))) + 5*f**2*(k1**2*(C - 4) - k2**2*(6*C + 3))*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(105*d*k3**2) + 2*1j*D1**3*Pk2*Pkd1*ct**2*(63*b1**2*(k1**2*(C - 2) - k2**2*(C + 1))*(D1*fd*r + Dd*f*(4*r - 1)) + 9*b1*f*(7*D1*bd1*(2*r - 1)*(k1**2*(C - 2) - k2**2*(C + 1)) - 5*D1*fd*(k1**2*(C + 4*r - 2) + k2**2*(C + 1)*(2*r - 1)) - 5*Dd*f*(2*k1**2 + k2**2*(C + 1))*(4*r - 1)) - 5*f**2*(7*C*k1**2*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)) + 9*D1*bd1*(-C*k1**2 + C*k2**2*r + 2*k1**2*r + k2**2*r)))/(105*d*k3**2) - 1j*D1**3*Pk2*Pkd1*ct*f**2*k2*st**4*(11*D1*bd1*f*(r - 1) + 11*b1*(3*D1*fd*r + Dd*f*(4*r - 1)) + 5*f*(4*r - 1)*(D1*fd + Dd*f))/(77*d*k1) - 1j*D1**3*Pk2*Pkd1*ct*f*k2*st**4*(k1**2 + k2**2)*(6*D1*b1*fd*r + 3*D1*bd1*f*(r - 1) + D1*f*fd*(3*r - 1) + 3*Dd*b1*f*(4*r - 1) + Dd*f**2*(4*r - 1))/(35*d*k1*k3**2) - 3*1j*D1**3*Pk2*Pkd1*ct*k1*(k1**2 + k2**2*(4*C + 1))*(5*D1*bd1*f**2*r + 7*b1**2*(D1*fd*r + Dd*f*(4*r - 1)) + b1*f*(7*D1*bd1*(2*r - 1) + 5*D1*fd*(2*r - 1) + 5*Dd*f*(4*r - 1)))/(35*d*k2*k3**2) - 1j*D1**3*Pk2*Pkd1*ct*st**2*(11*b1**2*(D1*fd*r*(k1**2*(18*f + 7) + k2**2*(36*f + 7)) + Dd*f*(4*r - 1)*(k1**2*(9*f + 7) + k2**2*(18*f + 7))) + 11*b1*f*(D1*bd1*(2*r - 1)*(k1**2*(9*f + 7) + k2**2*(18*f + 7)) + D1*fd*(k1**2*(5*f*(6*r - 1) + 6*r - 3) + k2**2*(10*f*(3*r - 1) + 6*r - 3)) + Dd*f*(10*f + 3)*(k1**2 + k2**2)*(4*r - 1)) + f**2*(11*D1*bd1*(5*f*(k1**2*(2*r - 1) + 2*k2**2*r) + r*(3*k1**2 + 3*k2**2)) + 35*f*k1**2*(4*r - 1)*(D1*fd + Dd*f)))/(385*d*k1*k2) - 1j*D1**3*Pk2*Pkd1*ct*(35*D1*bd1*f**3*k1**2*r + 21*b1**3*(k1**2 + k2**2)*(3*D1*fd*r + Dd*(3*f + 5)*(4*r - 1)) + 3*b1**2*(7*D1*bd1*(3*f + 5)*(k1**2 + k2**2)*(3*r - 1) + 3*D1*fd*(k1**2*(20*f*r - 5*f + 7*r - 7) + k2**2*(10*f*r - 5*f + 7*r - 7)) + 3*Dd*f*(4*r - 1)*(k1**2*(10*f + 7) + k2**2*(5*f + 7))) + b1*f*(9*D1*bd1*(5*f*(k1**2*(4*r - 1) + 2*k2**2*r) + r*(14*k1**2 + 14*k2**2)) + 35*f*k1**2*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1))))/(105*d*k1*k2) - 1j*D1**3*Pk2*Pkd1*ct*st**2*(3*D1*bd1*f*(7*b1*k2**2*(k1**2 + k2**2)*(2*r - 1) + 3*f*(k1**4*(r - 1) + k1**2*k2**2*(12*C*(r - 1) + 2*r - 1) + k2**4*r)) + 21*b1**2*k2**2*(k1**2 + k2**2)*(D1*fd*r + Dd*f*(4*r - 1)) + 9*b1*f*(D1*fd*(2*k1**4*r + k1**2*k2**2*(r*(24*C + 4) - 1) + k2**4*(2*r - 1)) + Dd*f*(4*r - 1)*(k1**4 + k1**2*k2**2*(12*C + 2) + k2**4)) + 5*f**2*k1**2*(k1**2 + k2**2*(12*C + 1))*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(105*d*k1*k2*k3**2) - 1j*D1**3*Pk2*Pkd1*f*st**4*(33*b1**2*(2*D1*fd*r + Dd*f*(4*r - 1)) + 11*b1*f*(3*D1*bd1*(2*r - 1) + D1*fd*(9*r - 1) + 3*Dd*f*(4*r - 1)) + f**2*(11*D1*bd1*(3*r - 2) + (4*r - 1)*(10*D1*fd + 10*Dd*f)))/(385*d) - 1j*D1**3*Pk2*Pkd1*st**2*(7*b1**3*(D1*fd*r + Dd*f*(4*r - 1)) + b1**2*(7*D1*bd1*f*(3*r - 1) + D1*fd*(3*f*(8*r - 1) + r*(7*K + 7)) + Dd*f*(4*r - 1)*(7*K + 12*f + 7)) + b1*(6*D1*K*f*fd*r - 3*D1*K*f*fd + D1*bd1*f*(3*f*(8*r - 3) + (7*K + 7)*(2*r - 1)) + 7*D1*bd2*f*r + 15*D1*f**2*fd*r - 5*D1*f**2*fd + 6*D1*f*fd*r - 3*D1*f*fd - 14*D1*f*gd2*r - 14*D1*fd*g2*r + 12*Dd*K*f**2*r - 3*Dd*K*f**2 + 20*Dd*f**3*r - 5*Dd*f**3 + 12*Dd*f**2*r - 3*Dd*f**2 - 56*Dd*f*g2*r + 14*Dd*f*g2 + 7*b2*(D1*fd*r + Dd*f*(4*r - 1))) + f*(D1*bd1*(f*r*(3*K + 5*f + 3) - 14*g2*(r - 1)) + 3*D1*(f*r*(bd2 - 2*gd2) + fd*g2*(2 - 4*r)) + 6*Dd*f*g2*(1 - 4*r) + b2*(7*D1*bd1*(r - 1) + 3*D1*fd*(2*r - 1) + 3*Dd*f*(4*r - 1))))/(35*d) - 1j*D1**3*Pk2*Pkd1*(21*D1*bd1*f*r*(b2 - 2*g2) + 7*b1**3*(3*D1*fd*r + Dd*(4*r - 1)*(5*K + 3*f + 5)) + b1**2*(21*D1*K*fd*r - 21*D1*K*fd + 7*D1*bd1*(3*r - 1)*(5*K + 3*f + 5) + 35*D1*bd2*r + 30*D1*f*fd*r - 15*D1*f*fd + 21*D1*fd*r - 21*D1*fd - 70*D1*gd2*r + 84*Dd*K*f*r - 21*Dd*K*f + 35*Dd*b2*(4*r - 1) + 60*Dd*f**2*r - 15*Dd*f**2 + 84*Dd*f*r - 21*Dd*f - 280*Dd*g2*r + 70*Dd*g2) + b1*(2*D1*bd1*(3*f*r*(7*K + 5*f + 7) + g2*(35 - 70*r)) + 21*D1*f*r*(bd2 - 2*gd2) - 42*D1*fd*g2*(r - 1) + 42*Dd*f*g2*(1 - 4*r) + 7*b2*(5*D1*bd1*(2*r - 1) + 3*D1*fd*(r - 1) + 3*Dd*f*(4*r - 1))))/(35*d)
        perm13 = -8*1j*D1**3*Pk1*Pk3*ct**7*f*k2**5*(C - 1)*(9*D1*bd1*f*(r + s - 1) + 9*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 7*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(21*d*k3**6) - 4*1j*D1**3*Pk1*Pk3*ct**7*f*k2**3*(C - 1)*(9*b1*(2*s - 1)*(D1*fd + 2*Dd*f) + f*(9*D1*bd1*s + 7*D1*fd*(3*s - 1) + 14*Dd*f*(2*s - 1)))/(21*d*k3**4) - 4*1j*D1**3*Pk1*Pk3*ct**6*f*k2**4*(11*D1*bd1*f*(7*f*k2**2 + k1**2*(90*C - 81))*(r + s - 1) + 11*b1*(D1*fd*(7*f*k2**2*(3*r + 3*s - 2) + k1**2*(90*C - 81)*(2*r + 2*s - 1)) + Dd*f*(7*f*k2**2 + k1**2*(90*C - 81))*(4*r + 4*s - 3)) + 7*f*(D1*fd*(9*f*k2**2*(4*r + 4*s - 3) + k1**2*(110*C - 99)*(3*r + 3*s - 2)) + Dd*f*(9*f*k2**2 + k1**2*(110*C - 99))*(4*r + 4*s - 3)))/(231*d*k1*k3**6) - 2*1j*D1**3*Pk1*Pk3*ct**6*f*k2**2*(9*b1*(2*s - 1)*(D1*fd + 2*Dd*f) + f*(9*D1*bd1*s + 7*D1*fd*(3*s - 1) + 14*Dd*f*(2*s - 1)))/(21*d*k1*k3**2) - 2*1j*D1**3*Pk1*Pk3*ct**6*f*k2**2*(9*b1*(D1*fd*(k1**2*(8*C - 7)*(2*s - 1) + k2**2*(2*r + 2*s - 1)) + Dd*f*(k1**2*(16*C - 14)*(2*s - 1) + k2**2*(4*r + 4*s - 3))) + f*(D1*(9*bd1*k1**2*s*(8*C - 7) + 9*bd1*k2**2*(r + s - 1) + fd*k1**2*(56*C - 49)*(3*s - 1) + fd*k2**2*(-12*C*r + 4*C + 33*r + 21*s - 18)) + Dd*f*(k1**2*(112*C - 98)*(2*s - 1) + k2**2*(-16*C*r + 4*C + 44*r + 28*s - 25))))/(21*d*k1*k3**4) - 16*1j*D1**3*Pk1*Pk3*ct**5*f*k2**5*st**2*(C - 1)*(9*D1*bd1*f*(r + s - 1) + 9*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 5*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(21*d*k3**6) - 8*1j*D1**3*Pk1*Pk3*ct**5*f*k2**3*st**2*(C - 1)*(9*b1*(2*s - 1)*(D1*fd + 2*Dd*f) + f*(9*D1*bd1*s + 5*D1*fd*(3*s - 1) + 10*Dd*f*(2*s - 1)))/(21*d*k3**4) + 4*1j*D1**3*Pk1*Pk3*ct**5*k2**3*(-33*D1*bd1*f*(r + s - 1)*(35*f**2*k2**2 + 15*f*(k1**2*(20*C - 16) + k2**2*(K - 2*b1 - 1)) - k2**2*(-42*K*b1 + 42*b1 + 42*g2)) + 99*b1**2*k2**2*(D1*fd*(5*f*(2*r + 2*s - 1) + (7 - 7*K)*(r + s)) + Dd*f*(-7*K + 5*f + 7)*(4*r + 4*s - 3)) - 33*b1*(D1*(35*f**2*fd*k2**2*(3*r + 3*s - 2) + 15*f*fd*(k1**2*(20*C - 16) + k2**2*(K - 1))*(2*r + 2*s - 1) - 42*f*gd2*k2**2*(r + s - 1) - 42*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2 + 15*f*(k1**2*(20*C - 16) + k2**2*(K - 1)) - 42*g2*k2**2)) - 10*f*(D1*(126*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(770*C - 616)*(3*r + 3*s - 2) - 99*f*gd2*k2**2*(r + s - 1) - 99*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(126*f**2*k2**2 + f*k1**2*(770*C - 616) - 99*g2*k2**2)))/(1155*d*k3**6) - 1j*D1**3*Pk1*Pk3*ct**5*k2*(252*b1**2*k1**2*(C - 1)*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) + 9*b1*f*(2*D1*(28*bd1*k1**2*s*(C - 1) + 5*fd*(k1**2*(2*s - 1) + k2**2*r)) + 5*Dd*f*(k1**2*(8*s - 4) + k2**2*(4*r - 1))) + 5*f**2*(D1*(18*bd1*k1**2*s + 9*bd1*k2**2*(r - 1) - fd*k1**2*(28*C - 42)*(3*s - 1) + 3*fd*k2**2*(3*r - 1)) + Dd*f*(-k1**2*(56*C - 84)*(2*s - 1) + 3*k2**2*(4*r - 1))))/(105*d*k1**2*k3**2) - 1j*D1**3*Pk1*Pk3*ct**5*k2*(2772*b1**2*k1**2*k2**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + 11*b1*f*(3*D1*(84*bd1*k1**2*k2**2*(C - 1)*(2*r + 2*s - 1) + fd*(25*f*k2**4*r + k1**4*(360*C - 270)*(2*s - 1) - 6*k1**2*k2**2*(4*C*(12*r + 19*s - 7) - 63*r - 96*s + 38))) + Dd*f*(25*f*k2**4*(4*r - 1) + k1**4*(2160*C - 1620)*(2*s - 1) - 9*k1**2*k2**2*(8*C*(24*r + 38*s - 25) - 252*r - 384*s + 255))) + f**2*(D1*(11*bd1*(25*f*k2**4*(r - 1) + k1**4*s*(1080*C - 810) - 9*k1**2*k2**2*(C*(48*r + 76*s - 68) - 63*r - 96*s + 83)) + 15*fd*(7*f*k2**4*(4*r - 1) + k1**4*(616*C - 462)*(3*s - 1) - 11*k1**2*k2**2*(4*C*(31*r + 32*s - 21) - 141*r - 156*s + 99))) + 5*Dd*f*(21*f*k2**4*(4*r - 1) + k1**4*(3696*C - 2772)*(2*s - 1) - 11*k1**2*k2**2*(4*C*(124*r + 128*s - 95) - 564*r - 624*s + 453))))/(1155*d*k1**2*k3**4) - 4*1j*D1**3*Pk1*Pk3*ct**4*f*k2**4*st**2*(33*D1*bd1*f*(25*f*k2**2 + k1**2*(228*C - 198))*(r + s - 1) + 33*b1*(D1*fd*(25*f*k2**2*(3*r + 3*s - 2) + k1**2*(228*C - 198)*(2*r + 2*s - 1)) + Dd*f*(25*f*k2**2 + k1**2*(228*C - 198))*(4*r + 4*s - 3)) + 5*f*(D1*fd*(105*f*k2**2*(4*r + 4*s - 3) + k1**2*(836*C - 726)*(3*r + 3*s - 2)) + Dd*f*(105*f*k2**2 + k1**2*(836*C - 726))*(4*r + 4*s - 3)))/(1155*d*k1*k3**6) - 4*1j*D1**3*Pk1*Pk3*ct**4*f*k2**2*st**2*(9*b1*(2*s - 1)*(D1*fd + 2*Dd*f) + f*(9*D1*bd1*s + 5*D1*fd*(3*s - 1) + 10*Dd*f*(2*s - 1)))/(21*d*k1*k3**2) - 4*1j*D1**3*Pk1*Pk3*ct**4*f*k2**2*st**2*(9*b1*(D1*fd*(k1**2*(32*C - 27)*(2*s - 1) + k2**2*(-8*C*r + 18*r + 10*s - 5)) + Dd*f*(k1**2*(64*C - 54)*(2*s - 1) + k2**2*(-16*C*r + 4*C + 36*r + 20*s - 19))) + f*(D1*(9*bd1*k1**2*s*(32*C - 27) + 9*bd1*k2**2*(-4*C*(r - 1) + 9*r + 5*s - 9) + fd*k1**2*(160*C - 135)*(3*s - 1) + fd*k2**2*(-44*C*(3*r - 1) + 207*r + 75*s - 94)) + Dd*f*(k1**2*(320*C - 270)*(2*s - 1) + k2**2*(-176*C*r + 44*C + 276*r + 100*s - 119))))/(105*d*k1*k3**4) + 4*1j*D1**3*Pk1*Pk3*ct**4*k1*k2**2*(-11*D1*bd1*f*(r + s - 1)*(70*f**2*k2**2 + 45*f*(k1**2*(20*C - 14) + k2**2*(5*K - 8*b1 - 4)) - k2**2*(126*b1*(4 - 5*K) + 630*g2)) + 99*b1**2*k2**2*(D1*fd*(20*f*(2*r + 2*s - 1) + (28 - 35*K)*(r + s)) + Dd*f*(-35*K + 20*f + 28)*(4*r + 4*s - 3)) - 55*b1*(D1*(14*f**2*fd*k2**2*(3*r + 3*s - 2) + 9*f*(fd*(k1**2*(20*C - 14) + k2**2*(5*K - 4))*(2*r + 2*s - 1) - 14*gd2*k2**2*(r + s - 1)) - 126*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(14*f**2*k2**2 + 9*f*(k1**2*(20*C - 14) + k2**2*(5*K - 4)) - 126*g2*k2**2)) - 10*f*(D1*(189*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(770*C - 539)*(3*r + 3*s - 2) - 495*f*gd2*k2**2*(r + s - 1) - 495*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(189*f**2*k2**2 + f*k1**2*(770*C - 539) - 495*g2*k2**2)))/(1155*d*k3**6) - 6*1j*D1**3*Pk1*Pk3*ct**4*(5*D1*bd1*f**2*s + 7*b1**2*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) + b1*f*(14*D1*bd1*s + 5*D1*fd*(2*s - 1) + 10*Dd*f*(2*s - 1)))/(35*d*k1) - 1j*D1**3*Pk1*Pk3*ct**4*(126*b1**2*k1**2*(4*C - 3)*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) - 9*b1*f*(D1*(28*bd1*k1**2*s*(3 - 4*C) + fd*k2**2*(16*C*r - 8*C - 8*r + 66*s - 25)) + 2*Dd*f*k2**2*(4*C*(4*r - 1) - 8*r + 66*s - 31)) - f**2*(D1*(9*bd1*k2**2*(r*(8*C - 4) + 33*s - 4) + 5*fd*(k1**2*(56*C - 42)*(3*s - 1) + k2**2*(-24*C*r + 8*C + 48*r + 129*s - 59))) + 10*Dd*f*(k1**2*(56*C - 42)*(2*s - 1) + k2**2*(-16*C*r + 4*C + 32*r + 86*s - 51))))/(105*d*k1*k3**2) - 1j*D1**3*Pk1*Pk3*ct**4*(198*b1**2*k2**2*(D1*fd*(k1**2*(42*C - 35)*(r + s - 1) + k2**2*(5*f*(4*r + 4*s - 3) + 7*r + 7*s)) + Dd*f*(k1**2*(42*C - 35) + k2**2*(10*f + 7))*(4*r + 4*s - 3)) + 11*b1*f*(D1*(18*bd1*k2**2*(k1**2*(42*C - 35)*(2*r + 2*s - 1) + k2**2*(5*f*(4*r + 4*s - 3) + 14*r + 14*s - 14)) + fd*(k1**4*(720*C - 450)*(2*s - 1) - 9*k1**2*k2**2*(4*C*(72*r + 128*s - 49) - 240*r - 466*s + 183) + k2**4*(-72*K*r + 36*K + 5*f*(60*r - 51*s + 16) + 252*r + 180*s - 126))) + 2*Dd*f*(k1**4*(720*C - 450)*(2*s - 1) - 9*k1**2*k2**2*(8*C*(36*r + 64*s - 41) - 240*r - 466*s + 293) + k2**4*(-72*K*r + 18*K + 5*f*(40*r - 34*s + 7) + 252*r + 180*s - 153))) - f*(D1*(-5*f**2*k2**4*(11*bd1*(20*r - 17*s - 2) - 14*fd*(48*r + 110*s - 67)) - 11*f*(9*bd1*(k1**4*s*(80*C - 50) + k1**2*k2**2*(-4*C*(36*r + 64*s - 51) + 120*r + 233*s - 170) + 2*k2**4*(-2*K*r + 7*r + 5*s - 5)) + fd*k1**4*(560*C - 350)*(3*s - 1) + 5*fd*k1**2*k2**2*(-12*C*(81*r + 105*s - 62) + 798*r + 1131*s - 643) + 72*gd2*k2**4*r) + 792*fd*g2*k2**4*(1 - 2*r)) + 2*Dd*f*(35*f**2*k2**4*(48*r + 110*s - 67) - 110*f*(k1**4*(56*C - 35)*(2*s - 1) + k1**2*k2**2*(-3*C*(108*r + 140*s - 97) + 266*r + 377*s - 255)) + 396*g2*k2**4*(1 - 4*r))))/(1155*d*k1*k3**4) - 8*1j*D1**3*Pk1*Pk3*ct**3*f*k2**5*st**4*(C - 1)*(3*D1*bd1*f*(r + s - 1) + 3*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(7*d*k3**6) - 4*1j*D1**3*Pk1*Pk3*ct**3*f*k2**3*st**4*(C - 1)*(3*b1*(2*s - 1)*(D1*fd + 2*Dd*f) + f*(3*D1*bd1*s + D1*fd*(3*s - 1) + 2*Dd*f*(2*s - 1)))/(7*d*k3**4) + 8*1j*D1**3*Pk1*Pk3*ct**3*k1**2*k2*(11*D1*bd1*f*(r + s - 1)*(35*f**2*k2**2 - 45*f*(k1**2*(5*C - 3) + k2**2*(5*K - 6*b1 - 3)) + k2**2*(126*b1*(3 - 5*K) + 630*g2)) + 99*b1**2*k2**2*(D1*fd*(15*f*(2*r + 2*s - 1) + (21 - 35*K)*(r + s)) + Dd*f*(-35*K + 15*f + 21)*(4*r + 4*s - 3)) + 55*b1*(D1*(7*f**2*fd*k2**2*(3*r + 3*s - 2) - 9*f*fd*(k1**2*(5*C - 3) + k2**2*(5*K - 3))*(2*r + 2*s - 1) + 126*f*gd2*k2**2*(r + s - 1) + 126*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(7*f**2*k2**2 - 9*f*(k1**2*(5*C - 3) + k2**2*(5*K - 3)) + 126*g2*k2**2)) - 5*f*(D1*(126*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(385*C - 231)*(3*r + 3*s - 2) - 990*f*gd2*k2**2*(r + s - 1) - 990*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(126*f**2*k2**2 + f*k1**2*(385*C - 231) - 990*g2*k2**2)))/(1155*d*k3**6) + 4*1j*D1**3*Pk1*Pk3*ct**3*k2**3*st**2*(-33*D1*bd1*f*(r + s - 1)*(50*f**2*k2**2 + f*k1**2*(330*C - 246) - 3*f*k2**2*(-3*K + 20*b1 + 3) - k2**2*(-42*K*b1 + 42*b1 + 42*g2)) + 99*b1**2*k2**2*(D1*fd*(10*f*(2*r + 2*s - 1) + (7 - 7*K)*(r + s)) + Dd*f*(-7*K + 10*f + 7)*(4*r + 4*s - 3)) - 33*b1*(D1*(50*f**2*fd*k2**2*(3*r + 3*s - 2) + 3*f*fd*(k1**2*(110*C - 82) + k2**2*(3*K - 3))*(2*r + 2*s - 1) - 42*f*gd2*k2**2*(r + s - 1) - 42*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(50*f**2*k2**2 + f*k1**2*(330*C - 246) + 9*f*k2**2*(K - 1) - 42*g2*k2**2)) - 2*f*(D1*(700*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(3025*C - 2255)*(3*r + 3*s - 2) - 297*f*gd2*k2**2*(r + s - 1) - 297*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(700*f**2*k2**2 + f*k1**2*(3025*C - 2255) - 297*g2*k2**2)))/(1155*d*k3**6) + 1j*D1**3*Pk1*Pk3*ct**3*(462*b1**3*k2**4*(3*D1*fd*(r + s - 1) + Dd*(-5*K + 3*f + 5)*(4*r + 4*s - 3)) - 33*b1**2*k2**2*(D1*(fd*(k1**2*(252*C - 168)*(r + s - 1) + k2**2*(-14*K*(8*r + 8*s + 3) + 6*f*(61*r + 68*s - 39) + 175*r + 196*s + 42)) - 14*k2**2*(bd1*(-5*K + 3*f + 5)*(3*r + 3*s - 2) + 10*gd2*(r + s - 1))) + Dd*(3*f**2*k2**2*(244*r + 272*s - 197) + f*k1**2*(252*C - 168)*(4*r + 4*s - 3) + 7*f*k2**2*(-16*K*(4*r + 4*s - 3) + 100*r + 112*s - 81) - 140*g2*k2**2*(4*r + 4*s - 3))) - 11*b1*(3*D1*(f**2*k2**4*(366*bd1*r + 51*bd1*(8*s - 7) + 5*fd*(70*r - 2*s - 9)) + f*(84*bd1*k1**2*k2**2*(3*C - 2)*(2*r + 2*s - 1) + 7*bd1*k2**4*(K*(-32*r - 32*s + 38) + 50*r + 56*s - 59) + fd*k1**4*(60*C - 30)*(2*s - 1) - 6*fd*k1**2*k2**2*(6*C*(24*r + 52*s - 21) - 91*r - 232*s + 96) + 3*fd*k2**4*(-2*K*(50*r + 34*s - 25) + 122*r + 108*s - 61) + k2**4*(-42*bd2 + 224*gd2)*(r + s - 1)) - 14*k2**4*(3*b2*fd*(r + s) + 10*bd1*g2*(2*r + 2*s - 1) - 2*fd*g2*(8*r + 8*s + 3))) + Dd*f*(10*f**2*k2**4*(140*r - 4*s - 33) + 9*f*(k1**4*(40*C - 20)*(2*s - 1) + k1**2*k2**2*(-96*C*(6*r + 13*s - 8) + 364*r + 928*s - 555) + k2**4*(-2*K*(100*r + 68*s - 59) + 244*r + 216*s - 169)) - k2**4*(126*b2 - 672*g2)*(4*r + 4*s - 3))) + f*(D1*(-5*f**2*k2**4*(11*bd1*(70*r - 2*s - 39) - 21*fd*(76*r + 176*s - 107)) - 11*f*(9*bd1*(k1**4*s*(20*C - 10) + k1**2*k2**2*(-12*C*(12*r + 26*s - 17) + 91*r + 232*s - 131) + k2**4*(K*(-50*r - 34*s + 34) + 61*r + 54*s - 54)) + fd*k1**4*(140*C - 70)*(3*s - 1) + 5*fd*k1**2*k2**2*(-4*C*(231*r + 369*s - 200) + 591*r + 1080*s - 557) - 18*k2**4*(5*bd2*(r + s - 1) - 50*gd2*r - 34*gd2*(s - 1))) + 66*k2**4*(3*b2*(7*bd1*(r + s - 1) + 5*fd*(2*r + 2*s - 1)) - 2*g2*(7*bd1*(8*r + 8*s - 11) + 3*fd*(50*r + 34*s - 25)))) + Dd*f*(105*f**2*k2**4*(76*r + 176*s - 107) - 55*f*(k1**4*(56*C - 28)*(2*s - 1) + k1**2*k2**2*(-4*C*(308*r + 492*s - 323) + 788*r + 1440*s - 917)) + 198*k2**4*(5*b2*(4*r + 4*s - 3) - 2*g2*(100*r + 68*s - 59)))))/(1155*d*k2*k3**4) - 2*1j*D1**3*Pk1*Pk3*ct**3*k2*st**2*(126*b1**2*k1**2*(C - 1)*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) - 9*b1*f*(-2*D1*(14*bd1*k1**2*s*(C - 1) - fd*k1**2*(7*C - 8)*(2*s - 1) + fd*k2**2*r) + Dd*f*(k1**2*(28*C - 32)*(2*s - 1) + k2**2*(1 - 4*r))) + f**2*(D1*(18*bd1*k1**2*s*(8 - 7*C) + 9*bd1*k2**2*(r - 1) - fd*k1**2*(100*C - 110)*(3*s - 1) + 19*fd*k2**2*(1 - 3*r)) + Dd*f*(-k1**2*(200*C - 220)*(2*s - 1) + 19*k2**2*(1 - 4*r))))/(105*d*k1**2*k3**2) - 2*1j*D1**3*Pk1*Pk3*ct**3*k2*st**2*(1386*b1**2*k1**2*k2**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + 11*b1*f*(3*D1*(42*bd1*k1**2*k2**2*(C - 1)*(2*r + 2*s - 1) + fd*(5*f*k2**4*r + k1**4*(222*C - 156)*(2*s - 1) - 6*k1**2*k2**2*(6*C*(10*r + 9*s - 4) - 63*r - 62*s + 28))) + Dd*f*(5*f*k2**4*(4*r - 1) + k1**4*(1332*C - 936)*(2*s - 1) - 9*k1**2*k2**2*(24*C*(10*r + 9*s - 7) - 252*r - 248*s + 187))) + f**2*(D1*(11*bd1*(5*f*k2**4*(r - 1) + k1**4*s*(666*C - 468) - 9*k1**2*k2**2*(6*C*(10*r + 9*s - 11) - 63*r - 62*s + 69)) + fd*(125*f*k2**4*(1 - 4*r) + k1**4*(4070*C - 2860)*(3*s - 1) - 11*k1**2*k2**2*(6*C*(229*r + 134*s - 121) - 1347*r - 924*s + 757))) + Dd*f*(125*f*k2**4*(1 - 4*r) + k1**4*(8140*C - 5720)*(2*s - 1) - 11*k1**2*k2**2*(2*C*(916*r + 536*s - 497) - 1796*r - 1232*s + 1065))))/(1155*d*k1**2*k3**4) + 3*1j*D1**3*Pk1*Pk3*ct**3*(-D1*bd1*f**2*(k1**2*s*(10 - 20*C) + k2**2*r) + 7*b1**2*(D1*fd*(k1**2*(4*C - 2)*(s - 1) - k2**2*r) + Dd*f*(k1**2*(8*C - 4)*(2*s - 1) + k2**2*(1 - 4*r))) + b1*f*(D1*(28*bd1*k1**2*s*(2*C - 1) + 7*bd1*k2**2*(1 - 2*r) + fd*k1**2*(20*C - 10)*(2*s - 1) + fd*k2**2*(1 - 2*r)) + Dd*f*(k1**2*(40*C - 20)*(2*s - 1) + k2**2*(1 - 4*r))))/(35*d*k1**2*k2) - 1j*D1**3*Pk1*Pk3*ct**3*(3*b1**2*(D1*fd*(k1**4*(84*C - 42)*(s - 1) - 7*k1**2*k2**2*(4*C*(3*r + 8*s - 8) - 9*r - 32*s + 32) + k2**4*r*(36*f + 21)) + Dd*f*(k1**4*(168*C - 84)*(2*s - 1) - 7*k1**2*k2**2*(4*C*(12*r + 32*s - 19) - 36*r - 128*s + 73) + k2**4*(18*f + 21)*(4*r - 1))) + b1*f*(3*D1*bd1*(k1**4*s*(168*C - 84) - 7*k1**2*k2**2*(4*C*(6*r + 16*s - 3) - 18*r - 64*s + 9) + k2**4*(18*f + 21)*(2*r - 1)) + k2**2*(D1*fd*(-9*k1**2*(4*C*(4*r - 4*s - 7) - 8*r + 64*s - 5) + k2**2*(10*f*(3*r - 1) + 18*r - 9)) + Dd*f*(-36*k1**2*(C*(8*r - 8*s + 2) - 4*r + 32*s - 15) + k2**2*(10*f + 9)*(4*r - 1)))) + f**2*(D1*(-9*bd1*k1**2*k2**2*(4*C*(2*r - 2*s + 7) - 4*r + 32*s - 23) + bd1*k2**4*r*(10*f + 9) - fd*k1**4*(140*C - 70)*(3*s - 1) - 5*fd*k1**2*k2**2*(-4*C*(39*r + 54*s - 31) + 123*r + 312*s - 145)) - 5*Dd*f*k1**2*(k1**2*(56*C - 28)*(2*s - 1) + k2**2*(-4*C*(52*r + 72*s - 49) + 164*r + 416*s - 249))))/(105*d*k1**2*k2*k3**2) - 4*1j*D1**3*Pk1*Pk3*ct**2*f*k2**4*st**4*(33*D1*bd1*f*(5*f*k2**2 + k1**2*(26*C - 21))*(r + s - 1) + 33*b1*(D1*fd*(5*f*k2**2*(3*r + 3*s - 2) + k1**2*(26*C - 21)*(2*r + 2*s - 1)) + Dd*f*(5*f*k2**2 + k1**2*(26*C - 21))*(4*r + 4*s - 3)) + f*(D1*fd*(75*f*k2**2*(4*r + 4*s - 3) + k1**2*(286*C - 231)*(3*r + 3*s - 2)) + Dd*f*(75*f*k2**2 + k1**2*(286*C - 231))*(4*r + 4*s - 3)))/(385*d*k1*k3**6) - 2*1j*D1**3*Pk1*Pk3*ct**2*f*k2**2*st**4*(3*b1*(2*s - 1)*(D1*fd + 2*Dd*f) + f*(3*D1*bd1*s + D1*fd*(3*s - 1) + 2*Dd*f*(2*s - 1)))/(7*d*k1*k3**2) - 2*1j*D1**3*Pk1*Pk3*ct**2*f*k2**2*st**4*(3*b1*(D1*fd*(k1**2*(24*C - 19)*(2*s - 1) + k2**2*(-16*C*r + 26*r + 10*s - 5)) + Dd*f*(k1**2*(48*C - 38)*(2*s - 1) + k2**2*(-32*C*r + 8*C + 52*r + 20*s - 23))) + f*(D1*(3*bd1*k1**2*s*(24*C - 19) + 3*bd1*k2**2*(-8*C*(r - 1) + 13*r + 5*s - 13) + fd*k1**2*(24*C - 19)*(3*s - 1) + fd*k2**2*(C*(12 - 36*r) + 51*r + 15*s - 22)) + Dd*f*(k1**2*(48*C - 38)*(2*s - 1) + k2**2*(-48*C*r + 12*C + 68*r + 20*s - 27))))/(35*d*k1*k3**4) + 4*1j*D1**3*Pk1*Pk3*ct**2*k1**3*(33*D1*bd1*f*(r + s - 1)*(35*f**2*k2**2 - 15*f*(k1**2*(2*C - 1) - k2**2*(-10*K + 8*b1 + 4)) + k2**2*(84*b1*(2 - 5*K) + 420*g2)) + 198*b1**2*k2**2*(D1*fd*(10*f*(2*r + 2*s - 1) + (14 - 35*K)*(r + s)) + Dd*f*(-35*K + 10*f + 14)*(4*r + 4*s - 3)) + 165*b1*(D1*(7*f**2*fd*k2**2*(3*r + 3*s - 2) - 3*f*fd*(k1**2*(2*C - 1) + k2**2*(10*K - 4))*(2*r + 2*s - 1) + 84*f*gd2*k2**2*(r + s - 1) + 84*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(7*f**2*k2**2 + f*k1**2*(3 - 6*C) + 6*f*k2**2*(2 - 5*K) + 84*g2*k2**2)) - 5*f*(D1*(63*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(154*C - 77)*(3*r + 3*s - 2) - 1980*f*gd2*k2**2*(r + s - 1) - 1980*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(63*f**2*k2**2 + f*k1**2*(154*C - 77) - 1980*g2*k2**2)))/(1155*d*k3**6) + 4*1j*D1**3*Pk1*Pk3*ct**2*k1*k2**2*st**2*(-33*D1*bd1*f*(r + s - 1)*(20*f**2*k2**2 + 3*f*(k1**2*(74*C - 47) - k2**2*(-9*K + 48*b1 + 6)) - k2**2*(42*b1*(2 - 3*K) + 126*g2)) + 99*b1**2*k2**2*(D1*fd*(24*f*(2*r + 2*s - 1) + (14 - 21*K)*(r + s)) + Dd*f*(-21*K + 24*f + 14)*(4*r + 4*s - 3)) - 33*b1*(D1*(20*f**2*fd*k2**2*(3*r + 3*s - 2) + 3*f*(fd*(k1**2*(74*C - 47) + k2**2*(9*K - 6))*(2*r + 2*s - 1) - 42*gd2*k2**2*(r + s - 1)) - 126*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(20*f**2*k2**2 + f*k1**2*(222*C - 141) + 9*f*k2**2*(3*K - 2) - 126*g2*k2**2)) + f*(D1*(-1260*f**2*fd*k2**2*(4*r + 4*s - 3) - f*fd*k1**2*(4070*C - 2585)*(3*r + 3*s - 2) + 1782*f*gd2*k2**2*(r + s - 1) + 1782*fd*g2*k2**2*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(1260*f**2*k2**2 + f*k1**2*(4070*C - 2585) - 1782*g2*k2**2)))/(1155*d*k3**6) + 1j*D1**3*Pk1*Pk3*ct**2*k1*(462*b1**3*k2**2*(6*D1*fd*(r + s - 1) + Dd*(-15*K + 6*f + 10)*(4*r + 4*s - 3)) - 33*b1**2*(D1*(fd*(k1**2*(84*C - 42)*(r + s - 1) + k2**2*(-42*K*(8*r + 8*s + 3) + 3*f*(124*r + 166*s - 73) + 224*r + 287*s + 84)) - 14*k2**2*(bd1*(-15*K + 6*f + 10)*(3*r + 3*s - 2) + 30*gd2*(r + s - 1))) + 2*Dd*(6*f**2*k2**2*(62*r + 83*s - 57) + 7*f*(k1**2*(6*C - 3)*(4*r + 4*s - 3) + k2**2*(-24*K*(4*r + 4*s - 3) + 64*r + 82*s - 57)) - 210*g2*k2**2*(4*r + 4*s - 3))) - 11*b1*(3*D1*bd1*(3*f**2*k2**2*(124*r + 166*s - 155) + 7*f*(k1**2*(12*C - 6)*(2*r + 2*s - 1) + k2**2*(-6*K*(16*r + 16*s - 19) + 64*r + 82*s - 85)) - 420*g2*k2**2*(2*r + 2*s - 1)) + 3*D1*(5*f**2*fd*k2**2*(100*r + 56*s - 37) - 3*f*(fd*k1**2*(4*C*(24*r + 80*s - 35) - 48*r - 198*s + 89) + 2*fd*k2**2*(3*K*(42*r + 34*s - 21) - 80*r - 83*s + 40) + k2**2*(42*bd2 - 224*gd2)*(r + s - 1)) + 42*fd*k2**2*(-3*b2*(r + s) + 2*g2*(8*r + 8*s + 3))) + 2*Dd*f*(10*f**2*k2**2*(100*r + 56*s - 53) - 9*f*(k1**2*(8*C*(12*r + 40*s - 23) - 48*r - 198*s + 111) + k2**2*(3*K*(84*r + 68*s - 55) - 160*r - 166*s + 123)) + k2**2*(-189*b2 + 1008*g2)*(4*r + 4*s - 3))) + f*(-11*D1*bd1*(5*f**2*k2**2*(100*r + 56*s - 101) - 9*f*(k1**2*(4*C*(12*r + 40*s - 17) - 24*r - 99*s + 34) + k2**2*(6*K*(21*r + 17*s - 17) - 80*r - 83*s + 83)) - 126*k2**2*(3*b2*(r + s - 1) - 2*g2*(8*r + 8*s - 11))) + D1*(420*f**2*fd*k2**2*(10*r + 33*s - 19) + 11*f*(5*fd*k1**2*(12*C*(25*r + 59*s - 28) - 150*r - 429*s + 193) + 54*k2**2*(5*bd2*(r + s - 1) - 42*gd2*r - 34*gd2*(s - 1))) + 594*fd*k2**2*(5*b2*(2*r + 2*s - 1) - 2*g2*(42*r + 34*s - 21))) + 2*Dd*f*(210*f**2*k2**2*(10*r + 33*s - 19) + 110*f*k1**2*(C*(100*r + 236*s - 143) - 50*r - 143*s + 84) + 297*k2**2*(5*b2*(4*r + 4*s - 3) - 2*g2*(84*r + 68*s - 55)))))/(1155*d*k3**4) - 6*1j*D1**3*Pk1*Pk3*ct**2*st**2*(3*D1*bd1*f**2*s + 7*b1**2*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) + b1*f*(14*D1*bd1*s + D1*fd*(6*s - 3) + 6*Dd*f*(2*s - 1)))/(35*d*k1) + 1j*D1**3*Pk1*Pk3*ct**2*(3*D1*bd1*f**2*(r*(4 - 8*C) + 19*s) + 91*b1**2*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) + b1*f*(D1*(182*bd1*s - 3*fd*(16*C*r - 8*C - 8*r - 38*s + 23)) - 6*Dd*f*(4*C*(4*r - 1) - 8*r - 38*s + 21)))/(35*d*k1) - 2*1j*D1**3*Pk1*Pk3*ct**2*st**2*(7*b1**2*(D1*fd*k1**2*(12*C - 9)*(s - 1) + D1*fd*k2**2*r*(4 - 4*C) + Dd*f*k1**2*(24*C - 18)*(2*s - 1) + 4*Dd*f*k2**2*(-4*C*r + C + 4*r - 1)) - b1*f*(D1*(42*bd1*k1**2*s*(3 - 4*C) + 28*bd1*k2**2*(C - 1)*(2*r - 1) + fd*k1**2*(36*C - 18)*(2*s - 1) + fd*k2**2*(20*C*(2*r - 1) + 2*r + 102*s - 31)) + Dd*f*(k1**2*(72*C - 36)*(2*s - 1) + k2**2*(80*C*r - 20*C + 4*r + 204*s - 103))) - f**2*(D1*(18*bd1*k1**2*s*(2*C - 1) + bd1*k2**2*(20*C*r + r + 51*s - 21) + fd*k1**2*(40*C - 25)*(3*s - 1) + fd*k2**2*(C*(16 - 48*r) + 75*r + 69*s - 48)) + Dd*f*(k1**2*(80*C - 50)*(2*s - 1) + k2**2*(-64*C*r + 16*C + 100*r + 92*s - 71))))/(35*d*k1*k3**2) + 1j*D1**3*Pk1*Pk3*ct**2*(3*b1**2*(D1*fd*(7*k1**2*(12*C*r + 52*C*(s - 1) - 6*r - 39*s + 39) + k2**2*(28*K*(r - 1) + 3*f*(16*r + 84*s - 59) + 91*s + 28)) + 2*Dd*f*(14*k1**2*(C*(12*r + 52*s - 29) - 6*r - 39*s + 21) + k2**2*(7*K*(8*r - 2) + 6*f*(8*r + 42*s - 23) + 182*s - 91))) + 3*b1*(D1*bd1*f*(14*k1**2*(2*C*(6*r + 26*s - 3) - 6*r - 39*s + 3) + k2**2*(56*K*r + 3*f*(16*r + 84*s - 33) + 182*s - 119)) + D1*(5*f**2*fd*k2**2*(24*r + 54*s - 35) - 6*f*fd*(k1**2*(2*C - 1)*(4*s + 5) + k2**2*(4*K*r - 2*K - 12*r - 19*s + 6)) - 56*f*gd2*k2**2*r - 56*fd*g2*k2**2*(r - 1)) + 2*Dd*f*(10*f**2*k2**2*(8*r + 18*s - 11) - 3*f*(k1**2*(8*C - 4)*(2*s - 1) + k2**2*(8*K*r - 2*K - 24*r - 38*s + 25)) + 28*g2*k2**2*(1 - 4*r))) + f*(3*D1*bd1*(5*f**2*k2**2*(8*r + 18*s - 9) - 3*f*(k1**2*(4*C - 2)*(2*s - 7) + k2**2*(r*(4*K - 12) - 19*s + 19)) - 56*g2*k2**2*r) + D1*(-5*f*fd*k1**2*(4*C*(33*r + 81*s - 38) - 66*r - 237*s + 101) - 36*f*k2**2*r*(bd2 - 2*gd2) - 36*fd*k2**2*(b2 - 2*g2)*(2*r - 1)) - 4*Dd*f*(5*f*k1**2*(C*(44*r + 108*s - 65) - 22*r - 79*s + 45) + k2**2*(9*b2 - 18*g2)*(4*r - 1))))/(105*d*k1*k3**2) - 2*1j*D1**3*Pk1*Pk3*ct**2*st**2*(33*b1**2*k2**2*(D1*fd*(k1**2*(98*C - 77)*(r + s - 1) + k2**2*(18*f*(4*r + 4*s - 3) + r*(35 - 14*K) + 21*s)) + Dd*f*(k1**2*(98*C - 77)*(4*r + 4*s - 3) + k2**2*(7*K*(2 - 8*r) + 36*f*(4*r + 4*s - 3) + 140*r + 84*s - 77))) + 33*b1*(D1*(f**2*k2**4*(18*bd1*(4*r + 4*s - 3) + fd*(12*r - 75*s + 32)) + f*(fd*(k1**4*(108*C - 63)*(2*s - 1) + 2*k1**2*k2**2*(C*(-284*r - 348*s + 153) + 209*r + 279*s - 123) + k2**4*(K*(10 - 20*r) + 38*r + 18*s - 19)) + 7*k2**2*(bd1*k1**2*(14*C - 11)*(2*r + 2*s - 1) + 2*bd1*k2**2*(-2*K*r + K + 5*r + 3*s - 4) + 4*gd2*k2**2*r)) + 28*fd*g2*k2**4*r) + Dd*f*(2*f**2*k2**4*(8*r - 50*s + 23) + f*(k1**4*(216*C - 126)*(2*s - 1) + k1**2*k2**2*(-4*C*(284*r + 348*s - 245) + 836*r + 1116*s - 767) + k2**4*(K*(10 - 40*r) + 76*r + 36*s - 37)) + 28*g2*k2**4*(4*r - 1))) + f*(D1*(3*f**2*k2**4*(11*bd1*(4*r - 25*s + 14) - 10*fd*(96*r + 110*s - 79)) + 11*f*(3*bd1*(k1**4*s*(108*C - 63) + k1**2*k2**2*(C*(-284*r - 348*s + 326) + 209*r + 279*s - 242) + k2**4*(-10*K*r + 19*r + 9*s - 9)) + fd*k1**2*(k1**2*(180*C - 105)*(3*s - 1) - 2*k2**2*(C*(987*r + 855*s - 614) - 717*r - 684*s + 467)) + 60*gd2*k2**4*r) + 132*g2*k2**4*(7*bd1*(r - 1) + 5*fd*(2*r - 1))) - 2*Dd*f*(15*f**2*k2**4*(96*r + 110*s - 79) - 11*f*(k1**4*(180*C - 105)*(2*s - 1) + k1**2*k2**2*(C*(-1316*r - 1140*s + 899) + 956*r + 912*s - 695)) + 330*g2*k2**4*(1 - 4*r))))/(1155*d*k1*k3**4) - 4*1j*D1**3*Pk1*Pk3*ct*f*k2**3*st**4*(33*D1*bd1*f*(k1**2*(22*C - 14) + k2**2*(-10*b1 + 5*f))*(r + s - 1) - 165*b1**2*k2**2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 33*b1*(D1*fd*(5*f*k2**2*(3*r + 3*s - 2) + k1**2*(22*C - 14)*(2*r + 2*s - 1)) + Dd*f*(5*f*k2**2 + k1**2*(22*C - 14))*(4*r + 4*s - 3)) + 2*f*(D1*fd*(50*f*k2**2*(4*r + 4*s - 3) + k1**2*(121*C - 77)*(3*r + 3*s - 2)) + Dd*f*(50*f*k2**2 + k1**2*(121*C - 77))*(4*r + 4*s - 3)))/(385*d*k3**6) + 1j*D1**3*Pk1*Pk3*ct*f*k2*st**4*(6*D1*b1*fd*(k1**2*(10*C - 7)*(2*s - 1) + 3*k2**2*r) + D1*f*(6*bd1*k1**2*s*(10*C - 7) + 9*bd1*k2**2*(r - 1) + fd*k1**2*(20*C - 14)*(3*s - 1) + 7*fd*k2**2*(3*r - 1)) + 3*Dd*b1*f*(k1**2*(40*C - 28)*(2*s - 1) + 3*k2**2*(4*r - 1)) + Dd*f**2*(k1**2*(40*C - 28)*(2*s - 1) + 7*k2**2*(4*r - 1)))/(35*d*k1**2*k3**2) - 1j*D1**3*Pk1*Pk3*ct*f*k2*st**4*(33*D1*b1*fd*(-5*f*k2**4*r + k1**4*(36*C - 22)*(2*s - 1) + 2*k1**2*k2**2*(-12*C*(4*r + 2*s - 1) + 39*r + 20*s - 10)) + D1*f*(11*bd1*(-5*f*k2**4*(r - 1) + k1**4*s*(108*C - 66) - 3*k1**2*k2**2*(24*C*(2*r + s - 2) - 39*r - 20*s + 39)) + fd*(65*f*k2**4*(1 - 4*r) + k1**4*(396*C - 242)*(3*s - 1) - 11*k1**2*k2**2*(8*C*(24*r + 9*s - 11) - 153*r - 60*s + 71))) - 11*Dd*b1*f*(5*f*k2**4*(4*r - 1) - k1**4*(216*C - 132)*(2*s - 1) + 3*k1**2*k2**2*(96*C*(2*r + s - 1) - 156*r - 80*s + 79)) + Dd*f**2*(65*f*k2**4*(1 - 4*r) + k1**4*(792*C - 484)*(2*s - 1) - 11*k1**2*k2**2*(16*C*(16*r + 6*s - 7) - 204*r - 80*s + 91)))/(385*d*k1**2*k3**4) + 4*1j*D1**3*Pk1*Pk3*ct*k1**4*k2*(9*b1**2*(D1*fd*(5*f*(2*r + 2*s - 1) + (7 - 35*K)*(r + s)) + Dd*f*(-35*K + 5*f + 7)*(4*r + 4*s - 3)) + b1*(18*D1*bd1*f*(-35*K + 5*f + 7)*(r + s - 1) + 5*D1*(7*f**2*fd*(3*r + 3*s - 2) - 9*f*fd*(5*K - 1)*(2*r + 2*s - 1) + 126*f*gd2*(r + s - 1) + 126*fd*g2*(r + s)) + 5*Dd*f*(7*f**2 + f*(9 - 45*K) + 126*g2)*(4*r + 4*s - 3)) + 5*f*(D1*bd1*(7*f**2 + f*(9 - 45*K) + 126*g2)*(r + s - 1) + 90*D1*f*gd2*(r + s - 1) + 90*D1*fd*g2*(2*r + 2*s - 1) + 90*Dd*f*g2*(4*r + 4*s - 3)))/(105*d*k3**6) + 4*1j*D1**3*Pk1*Pk3*ct*k1**2*k2*st**2*(33*D1*bd1*f*(r + s - 1)*(10*f**2*k2**2 + f*k1**2*(36 - 66*C) + 9*f*k2**2*(-3*K + 12*b1 + 1) + k2**2*(-126*K*b1 + 42*b1 + 126*g2)) + 99*b1**2*k2**2*(D1*fd*(18*f*(2*r + 2*s - 1) + (7 - 21*K)*(r + s)) + Dd*f*(-21*K + 18*f + 7)*(4*r + 4*s - 3)) + 33*b1*(D1*(10*f**2*fd*k2**2*(3*r + 3*s - 2) - 3*f*fd*(k1**2*(22*C - 12) + k2**2*(9*K - 3))*(2*r + 2*s - 1) + 126*f*gd2*k2**2*(r + s - 1) + 126*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(10*f**2*k2**2 + f*k1**2*(36 - 66*C) + 9*f*k2**2*(1 - 3*K) + 126*g2*k2**2)) - 2*f*(D1*(210*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(605*C - 330)*(3*r + 3*s - 2) - 891*f*gd2*k2**2*(r + s - 1) - 891*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(210*f**2*k2**2 + f*k1**2*(605*C - 330) - 891*g2*k2**2)))/(1155*d*k3**6) + 1j*D1**3*Pk1*Pk3*ct*k1**2*(42*b1**3*k2**2*(3*D1*fd*(r + s - 1) + Dd*(-15*K + 3*f + 5)*(4*r + 4*s - 3)) + 3*b1**2*k2**2*(14*D1*bd1*(-15*K + 3*f + 5)*(3*r + 3*s - 2) + D1*(-6*f*fd*(21*r + 42*s - 16) + 7*fd*(6*K*(8*r + 8*s + 3) - 13*r - 22*s - 6) + 420*gd2*(r + s - 1)) - 7*Dd*(9*f**2*(4*r + 8*s - 5) + f*(-48*K*(4*r + 4*s - 3) + 52*r + 88*s - 57) - 60*g2*(4*r + 4*s - 3))) - b1*(D1*(f**2*k2**2*(9*bd1*(42*r + 84*s - 73) + 5*fd*(135*r + 150*s - 77)) - 3*f*(3*fd*(k1**2*(28*C - 14)*(2*s - 1) + k2**2*(236*K*r + 204*K*s - 118*K - 66*r - 88*s + 33)) + 7*k2**2*(bd1*(6*K*(16*r + 16*s - 19) - 26*r - 44*s + 41) + (18*bd2 - 96*gd2)*(r + s - 1))) - 126*k2**2*(3*b2*fd*(r + s) + 10*bd1*g2*(2*r + 2*s - 1) - 2*fd*g2*(8*r + 8*s + 3))) + Dd*f*(25*f**2*k2**2*(36*r + 40*s - 29) - 9*f*(k1**2*(56*C - 28)*(2*s - 1) + k2**2*(472*K*r + 408*K*s - 322*K - 132*r - 176*s + 121)) + k2**2*(-378*b2 + 2016*g2)*(4*r + 4*s - 3))) + f*(D1*(-5*f**2*k2**2*(bd1*(45*r + 50*s - 68) + 28*fd*(1 - 2*s)) + 9*f*(14*bd1*k1**2*s*(2*C - 1) + bd1*k2**2*(2*K*(59*r + 51*s - 51) - 33*r - 44*s + 44) + 30*bd2*k2**2*(r + s - 1) + fd*k1**2*(20*C - 10)*(3*s - 1) - 4*gd2*k2**2*(59*r + 51*s - 51)) + 18*k2**2*(3*b2*(7*bd1*(r + s - 1) + 5*fd*(2*r + 2*s - 1)) - 2*g2*(7*bd1*(8*r + 8*s - 11) + fd*(118*r + 102*s - 59)))) + 2*Dd*f*(70*f**2*k2**2*(2*s - 1) + f*k1**2*(180*C - 90)*(2*s - 1) + 9*k2**2*(15*b2*(4*r + 4*s - 3) - 2*g2*(236*r + 204*s - 161)))))/(105*d*k2*k3**4) - 1j*D1**3*Pk1*Pk3*ct*(105*b1**3*k2**2*(D1*fd*(r + 2*s - 2) + Dd*(K*(-8*r - 8*s + 6) + f*(4*r + 8*s - 5) + 4*r + 8*s - 5)) - 3*b1**2*(D1*(fd*(k1**2*(140*C - 70)*(s - 1) + k2**2*(14*K*(2*r - 2*s - 7) + 3*f*(56*s - 31) + 70*s + 49)) - 35*k2**2*(bd1*(-6*K*r - 6*K*s + 4*K + 3*f*(r + 2*s - 1) + 3*r + 6*s - 3) + 4*gd2*(r + s - 1))) + 28*Dd*(6*f**2*k2**2*(2*s - 1) + f*k1**2*(10*C - 5)*(2*s - 1) + f*k2**2*(4*K*r - 4*K*s + K + 10*s - 5) - 5*g2*k2**2*(4*r + 4*s - 3))) + b1*(-3*D1*bd1*(3*f**2*k2**2*(56*s - 25) + 7*f*(k1**2*s*(40*C - 20) + k2**2*(2*K*(4*r - 4*s + 7) + 20*s - 17)) - 140*g2*k2**2*(2*r + 2*s - 1)) + k2**2*(396*D1*K*f*fd*r + 252*D1*K*f*fd*s - 198*D1*K*f*fd + 210*D1*bd2*f*(r + s - 1) - 255*D1*f**2*fd*r - 810*D1*f**2*fd*s + 445*D1*f**2*fd - 234*D1*f*fd*r - 432*D1*f*fd*s + 117*D1*f*fd + 168*D1*f*gd2*r - 168*D1*f*gd2*s + 168*D1*f*gd2 + 168*D1*fd*g2*r - 168*D1*fd*g2*s - 588*D1*fd*g2 + 792*Dd*K*f**2*r + 504*Dd*K*f**2*s - 450*Dd*K*f**2 - 340*Dd*f**3*r - 1080*Dd*f**3*s + 625*Dd*f**3 - 468*Dd*f**2*r - 864*Dd*f**2*s + 549*Dd*f**2 + 672*Dd*f*g2*r - 672*Dd*f*g2*s + 168*Dd*f*g2 + 210*b2*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)))) + f*(D1*(-5*bd1*f**2*k2**2*(17*r + 54*s - 36) + 9*f*(fd*k1**2*(20*C - 10)*(3*s - 1) + k2**2*(bd1*(2*K*(11*r + 7*s - 7) - 13*r - 24*s + 24) + (2*bd2 - 4*gd2)*(11*r + 7*s - 7))) + 6*k2**2*(35*b2*bd1*(r + s - 1) + 3*b2*fd*(22*r + 14*s - 11) + 14*bd1*g2*(2*r - 2*s + 5) - 6*fd*g2*(22*r + 14*s - 11))) + 18*Dd*f*(f*k1**2*(20*C - 10)*(2*s - 1) + k2**2*(b2 - 2*g2)*(44*r + 28*s - 25))))/(105*d*k2*k3**2) + 1j*D1**3*Pk1*Pk3*ct*st**2*(1386*b1**3*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) - 33*b1**2*k2**2*(D1*(-42*bd1*f*k2**2*(3*r + 3*s - 2) + fd*k1**2*(140*C - 84)*(r + s - 1) + fd*k2**2*(6*f*(45*r + 52*s - 29) + r*(91 - 112*K) - s*(56*K - 56))) + Dd*f*(k1**2*(140*C - 84)*(4*r + 4*s - 3) + k2**2*(-224*K*(2*r + s - 1) + f*(540*r + 624*s - 447) + 364*r + 224*s - 203))) - 33*b1*(D1*(3*f**2*k2**4*(bd1*(90*r + 104*s - 91) + fd*(50*r - 22*s + 3)) + f*(7*bd1*k2**2*(k1**2*(20*C - 12)*(2*r + 2*s - 1) + k2**2*(-8*K*(4*r + 2*s - 3) + 26*r + 16*s - 21)) + fd*k1**4*(36*C - 18)*(2*s - 1) + 2*fd*k1**2*k2**2*(-4*C*(74*r + 117*s - 51) + 171*r + 300*s - 132) + fd*k2**4*(-16*K*(8*r + 3*s - 4) + 94*r + 48*s - 47) + 14*k2**4*(-3*bd2*(r + s - 1) + 8*gd2*(2*r + s - 1))) - 14*fd*k2**4*(3*b2*(r + s) - 8*g2*(2*r + s))) + Dd*f*(2*f**2*k2**4*(100*r - 44*s - 3) + f*(k1**4*(72*C - 36)*(2*s - 1) + k1**2*k2**2*(-16*C*(74*r + 117*s - 77) + 684*r + 1200*s - 771) + k2**4*(-16*K*(16*r + 6*s - 7) + 188*r + 96*s - 95)) - 14*k2**4*(3*b2*(4*r + 4*s - 3) - 32*g2*(2*r + s - 1)))) + f*(D1*(3*f**2*k2**4*(bd1*(-550*r + 242*s + 165) + 15*fd*(108*r + 176*s - 115)) - 11*f*(3*bd1*(k1**4*s*(36*C - 18) + k1**2*k2**2*(-4*C*(74*r + 117*s - 89) + 171*r + 300*s - 207) + k2**4*(-8*K*(8*r + 3*s - 3) + 47*r + 24*s - 24)) + fd*(k1**4*(60*C - 30)*(3*s - 1) + k1**2*k2**2*(-4*C*(501*r + 564*s - 355) + 1155*r + 1440*s - 865)) - 6*k2**4*(9*bd2*(r + s - 1) - 8*gd2*(8*r + 3*s - 3))) + 66*k2**4*(3*b2*(7*bd1*(r + s - 1) + 3*fd*(2*r + 2*s - 1)) - 8*g2*(7*bd1*(2*r + s - 2) + 2*fd*(8*r + 3*s - 4)))) + Dd*f*(45*f**2*k2**4*(108*r + 176*s - 115) - 11*f*(k1**4*(120*C - 60)*(2*s - 1) + k1**2*k2**2*(-4*C*(668*r + 752*s - 543) + 1540*r + 1920*s - 1345)) + 66*k2**4*(9*b2*(4*r + 4*s - 3) - 16*g2*(16*r + 6*s - 7)))))/(1155*d*k2*k3**4) + 1j*D1**3*Pk1*Pk3*ct*st**2*(D1*bd1*f**2*(k1**2*s*(36*C - 18) + 11*k2**2*r) + 7*b1**2*(D1*fd*(k1**2*(12*C - 6)*(s - 1) + k2**2*r) + Dd*f*(k1**2*(24*C - 12)*(2*s - 1) + k2**2*(4*r - 1))) + b1*f*(D1*(84*bd1*k1**2*s*(2*C - 1) + 7*bd1*k2**2*(2*r - 1) + fd*k1**2*(36*C - 18)*(2*s - 1) + 11*fd*k2**2*(2*r - 1)) + Dd*f*(k1**2*(72*C - 36)*(2*s - 1) + 11*k2**2*(4*r - 1))))/(35*d*k1**2*k2) - 1j*D1**3*Pk1*Pk3*ct*(42*D1*bd1*f**2*k1**2*s*(2*C - 1) + 7*b1**3*k2**2*(D1*fd*r + Dd*(f + 5)*(4*r - 1)) + b1**2*(D1*(7*bd1*k2**2*(f + 5)*(3*r - 1) + fd*k1**2*(140*C - 70)*(s - 1) + fd*k2**2*(f*(3 - 6*r) - 7*r + 7)) + Dd*f*(k1**2*(280*C - 140)*(2*s - 1) - k2**2*(3*f + 7)*(4*r - 1))) + 2*b1*f*(-D1*bd1*(k1**2*s*(70 - 140*C) + k2**2*r*(3*f + 7)) + D1*fd*k1**2*(42*C - 21)*(2*s - 1) + Dd*f*k1**2*(84*C - 42)*(2*s - 1)))/(35*d*k1**2*k2) + 1j*D1**3*Pk1*Pk3*ct*st**2*(3*b1**2*(D1*fd*(-k1**4*(84*C - 42)*(s - 1) + 7*k1**2*k2**2*(4*C*(3*r + s - 1) - 9*r - 4*s + 4) + k2**4*r*(12*f + 7)) + Dd*f*(-k1**4*(168*C - 84)*(2*s - 1) + 7*k1**2*k2**2*(4*C*(12*r + 4*s - 5) - 36*r - 16*s + 17) + k2**4*(6*f + 7)*(4*r - 1))) + 3*b1*f*(D1*bd1*(-k1**4*s*(168*C - 84) + 7*k1**2*k2**2*(4*C*(6*r + 2*s - 3) - 18*r - 8*s + 9) + k2**4*(6*f + 7)*(2*r - 1)) + k2**2*(D1*fd*(k1**2*(-8*C*(4*r + 39*s - 11) + 16*r + 264*s - 81) + k2**2*(14*f*(3*r - 1) + 22*r - 11)) + Dd*f*(-8*k1**2*(C*(8*r + 78*s - 41) - 4*r - 66*s + 34) + k2**2*(14*f + 11)*(4*r - 1)))) + f**2*(D1*(3*bd1*k1**2*k2**2*(-4*C*(4*r + 39*s - 21) + 8*r + 132*s - 59) + 3*bd1*k2**4*r*(14*f + 11) + fd*k1**4*(60*C - 30)*(3*s - 1) + fd*k1**2*k2**2*(-12*C*(51*r + 54*s - 35) + 399*r + 576*s - 325)) + Dd*f*k1**2*(k1**2*(120*C - 60)*(2*s - 1) + k2**2*(-12*C*(68*r + 72*s - 53) + 532*r + 768*s - 517))))/(105*d*k1**2*k2*k3**2) - 4*1j*D1**3*Pk1*Pk3*f**2*k2**6*st**6*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)) + 3*f*(D1*fd + Dd*f)*(4*r + 4*s - 3))/(231*d*k1*k3**6) - 4*1j*D1**3*Pk1*Pk3*f*k1*k2**2*st**4*(11*D1*bd1*f*(k1**2*(18*C - 9) + k2**2*(-24*b1 + 2*f))*(r + s - 1) - 132*b1**2*k2**2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 11*b1*(D1*fd*(2*f*k2**2*(3*r + 3*s - 2) + k1**2*(18*C - 9)*(2*r + 2*s - 1)) + Dd*f*(2*f*k2**2 + k1**2*(18*C - 9))*(4*r + 4*s - 3)) + 3*f*(D1*fd*(10*f*k2**2*(4*r + 4*s - 3) + k1**2*(22*C - 11)*(3*r + 3*s - 2)) + Dd*f*(10*f*k2**2 + k1**2*(22*C - 11))*(4*r + 4*s - 3)))/(385*d*k3**6) + 1j*D1**3*Pk1*Pk3*f*st**4*(3*b1*(D1*fd*(k1**2*(8*C - 4)*(2*s - 1) + k2**2*(4*r + 2*s - 1)) + 4*Dd*f*(k1**2*(4*C - 2)*(2*s - 1) + k2**2*(2*r + s - 1))) + f*(D1*(12*bd1*k1**2*s*(2*C - 1) + 3*bd1*k2**2*(2*r + s - 2) + fd*k1**2*(8*C - 4)*(3*s - 1) + fd*k2**2*(C*(8 - 24*r) + 18*r + 3*s - 7)) + 4*Dd*f*(k1**2*(4*C - 2)*(2*s - 1) + k2**2*(-8*C*r + 2*C + 6*r + s - 2))))/(35*d*k1*k3**2) + 1j*D1**3*Pk1*Pk3*f*st**4*(-66*b1**2*k2**4*(D1*fd + 2*Dd*f)*(4*r + 4*s - 3) + 11*b1*(D1*(-6*bd1*f*k2**4*(4*r + 4*s - 3) + fd*(f*k2**4*(12*r + 33*s - 16) + k1**4*(12 - 24*C)*(2*s - 1) + 3*k1**2*k2**2*(16*C*(3*r + 2*s - 1) - 28*r - 18*s + 9))) + 2*Dd*f*(f*k2**4*(8*r + 22*s - 13) + k1**4*(12 - 24*C)*(2*s - 1) + 6*k1**2*k2**2*(2*C*(12*r + 8*s - 7) - 14*r - 9*s + 8))) + f*(D1*(-11*bd1*(f*k2**4*(-4*r - 11*s + 10) + k1**4*s*(24*C - 12) + 3*k1**2*k2**2*(-8*C*(3*r + 2*s - 3) + 14*r + 9*s - 14)) + fd*(2*f*k2**4*(144*r + 110*s - 91) - k1**4*(88*C - 44)*(3*s - 1) + k1**2*k2**2*(528*C - 297)*(2*r + s - 1))) + 2*Dd*f*(f*k2**4*(144*r + 110*s - 91) - k1**4*(88*C - 44)*(2*s - 1) + k1**2*k2**2*(352*C - 198)*(2*r + s - 1))))/(385*d*k1*k3**4) - 12*1j*D1**3*Pk1*Pk3*k1**5*(D1*bd1*f*(r + s - 1)*(14*K*b1 + 5*K*f - 14*g2) + 7*K*b1**2*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) + b1*(5*D1*K*f*fd*(2*r + 2*s - 1) - 14*D1*f*gd2*(r + s - 1) - 14*D1*fd*g2*(r + s) + Dd*f*(5*K*f - 14*g2)*(4*r + 4*s - 3)) - 10*f*(D1*f*gd2*(r + s - 1) + D1*fd*g2*(2*r + 2*s - 1) + Dd*f*g2*(4*r + 4*s - 3)))/(35*d*k3**6) - 1j*D1**3*Pk1*Pk3*k1**3*(70*Dd*K*b1**3*(4*r + 4*s - 3) + 7*b1**2*(-D1*(-30*K*bd1*r - 30*K*bd1*s + 20*K*bd1 + 16*K*fd*r + 16*K*fd*s + 6*K*fd + f*fd*(3 - 6*s) - 3*fd*s + 20*gd2*(r + s - 1)) + 2*Dd*(f**2*(6*s - 3) + f*(-8*K*(4*r + 4*s - 3) + 6*s - 3) - 10*g2*(4*r + 4*s - 3))) + b1*(-228*D1*K*f*fd*r - 204*D1*K*f*fd*s + 114*D1*K*f*fd - 42*D1*b2*fd*r - 42*D1*b2*fd*s + 7*D1*bd1*(f**2*(6*s - 3) + f*(K*(-32*r - 32*s + 38) + 6*s - 3) - 20*g2*(2*r + 2*s - 1)) - 42*D1*bd2*f*(r + s - 1) + 45*D1*f**2*fd*s - 15*D1*f**2*fd + 30*D1*f*fd*s + 224*D1*f*gd2*r + 224*D1*f*gd2*s - 224*D1*f*gd2 + 224*D1*fd*g2*r + 224*D1*fd*g2*s + 84*D1*fd*g2 - 456*Dd*K*f**2*r - 408*Dd*K*f**2*s + 318*Dd*K*f**2 - 168*Dd*b2*f*r - 168*Dd*b2*f*s + 126*Dd*b2*f + 60*Dd*f**3*s - 30*Dd*f**3 + 60*Dd*f**2*s - 30*Dd*f**2 + 896*Dd*f*g2*r + 896*Dd*f*g2*s - 672*Dd*f*g2) + f*(D1*bd1*(15*f**2*(s - 1) - 3*f*(38*K*r + 34*K*(s - 1) - 5*s + 5) + 28*g2*(8*r + 8*s - 11)) - 30*D1*bd2*f*(r + s - 1) + 12*D1*f*gd2*(19*r + 17*s - 17) + 12*D1*fd*g2*(38*r + 34*s - 19) + 12*Dd*f*g2*(76*r + 68*s - 53) - 6*b2*(7*D1*bd1*(r + s - 1) + 5*D1*fd*(2*r + 2*s - 1) + 5*Dd*f*(4*r + 4*s - 3))))/(35*d*k3**4) + 4*1j*D1**3*Pk1*Pk3*k1**3*st**2*(33*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2 + 3*f*(k1**2*(1 - 2*C) + k2**2*(-3*K + 8*b1)) + k2**2*(-42*K*b1 + 42*g2)) + 99*b1**2*k2**2*(D1*fd*(-7*K*(r + s) + f*(8*r + 8*s - 4)) + Dd*f*(-7*K + 4*f)*(4*r + 4*s - 3)) + 33*b1*(D1*(5*f**2*fd*k2**2*(3*r + 3*s - 2) - 3*f*fd*(3*K*k2**2 + k1**2*(2*C - 1))*(2*r + 2*s - 1) + 42*f*gd2*k2**2*(r + s - 1) + 42*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(-9*K*f*k2**2 + 5*f**2*k2**2 + f*k1**2*(3 - 6*C) + 42*g2*k2**2)) + f*(D1*(-35*f**2*fd*k2**2*(4*r + 4*s - 3) - f*fd*k1**2*(110*C - 55)*(3*r + 3*s - 2) + 594*f*gd2*k2**2*(r + s - 1) + 594*fd*g2*k2**2*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2 + f*k1**2*(110*C - 55) - 594*g2*k2**2)))/(1155*d*k3**6) - 1j*D1**3*Pk1*Pk3*k1*(35*b1**3*(D1*fd*(s - 1) - 2*Dd*(K*(4*r + 4*s - 3) - 2*f*s + f - 2*s + 1)) + 7*b1**2*(2*D1*K*fd*(2*s + 5) - 5*D1*bd1*(K*(6*r + 6*s - 4) - 3*f*s + f - 3*s + 1) + 20*D1*gd2*(r + s - 1) + 8*Dd*K*f*(2*s - 1) + 20*Dd*g2*(4*r + 4*s - 3)) + b1*(56*D1*K*bd1*f*s - 98*D1*K*bd1*f + 108*D1*K*f*fd*r + 84*D1*K*f*fd*s - 54*D1*K*f*fd + 280*D1*bd1*g2*r + 280*D1*bd1*g2*s - 140*D1*bd1*g2 + 70*D1*bd2*f*(r + s - 1) - 45*D1*f**2*fd*s + 15*D1*f**2*fd - 30*D1*f*fd*s - 56*D1*f*gd2*s + 56*D1*f*gd2 - 56*D1*fd*g2*s - 140*D1*fd*g2 + 216*Dd*K*f**2*r + 168*Dd*K*f**2*s - 138*Dd*K*f**2 - 60*Dd*f**3*s + 30*Dd*f**3 - 60*Dd*f**2*s + 30*Dd*f**2 - 224*Dd*f*g2*s + 112*Dd*f*g2 + 70*b2*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3))) + f*(D1*bd1*(-15*f**2*(s - 1) + 3*f*(2*K*(9*r + 7*s - 7) - 5*s + 5) + 28*g2*(5 - 2*s)) + 6*D1*bd2*f*(9*r + 7*s - 7) - 12*D1*f*gd2*(9*r + 7*s - 7) - 12*D1*fd*g2*(18*r + 14*s - 9) - 12*Dd*f*g2*(36*r + 28*s - 23) + 2*b2*(35*D1*bd1*(r + s - 1) + 3*D1*fd*(18*r + 14*s - 9) + 3*Dd*f*(36*r + 28*s - 23))))/(35*d*k3**2) + 1j*D1**3*Pk1*Pk3*k1*st**2*(924*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) - 33*b1**2*(D1*(-28*bd1*f*k2**2*(3*r + 3*s - 2) + fd*k1**2*(28*C - 14)*(r + s - 1) + fd*k2**2*(-56*K*s + 3*f*(36*r + 50*s - 23) + 7*r*(2 - 12*K) + 7*s)) + 2*Dd*f*(k1**2*(14*C - 7)*(4*r + 4*s - 3) + 2*k2**2*(7*K*(-12*r - 8*s + 7) + f*(54*r + 75*s - 51) + 14*r + 7*s - 7))) - 11*b1*(3*D1*bd1*f*(k1**2*(28*C - 14)*(2*r + 2*s - 1) + k2**2*(-28*K*(6*r + 4*s - 5) + 3*f*(36*r + 50*s - 45) + 28*r + 14*s - 21)) + 3*D1*(f**2*fd*k2**2*(92*r + 40*s - 29) + f*(-42*bd2*k2**2*(r + s - 1) + fd*k1**2*(-4*C*(20*r + 48*s - 21) + 40*r + 102*s - 45) + 2*fd*k2**2*(K*(-44*r - 24*s + 22) + 6*r + 3*s - 3) + 56*gd2*k2**2*(3*r + 2*s - 2)) - 14*fd*k2**2*(3*b2*(r + s) - 4*g2*(3*r + 2*s))) + 2*Dd*f*(2*f**2*k2**2*(92*r + 40*s - 43) - 3*f*(k1**2*(4*C*(20*r + 48*s - 29) - 40*r - 102*s + 61) + 2*k2**2*(K*(44*r + 24*s - 23) - 6*r - 3*s + 3)) - 21*k2**2*(3*b2*(4*r + 4*s - 3) - 4*g2*(12*r + 8*s - 7)))) + f*(-11*D1*bd1*(f**2*k2**2*(92*r + 40*s - 85) - 3*f*(k1**2*(C*(40*r + 96*s - 52) - 20*r - 51*s + 26) + k2**2*(4*K*(11*r + 6*s - 6) - 6*r - 3*s + 3)) - 42*k2**2*(3*b2*(r + s - 1) - 4*g2*(3*r + 2*s - 3))) + D1*(20*f**2*fd*k2**2*(38*r + 99*s - 59) + 11*f*(fd*k1**2*(12*C*(23*r + 37*s - 20) - 138*r - 237*s + 125) + 6*k2**2*(9*bd2*(r + s - 1) - 4*gd2*(11*r + 6*s - 6))) + 66*fd*k2**2*(9*b2*(2*r + 2*s - 1) - 4*g2*(22*r + 12*s - 11))) + 2*Dd*f*(10*f**2*k2**2*(38*r + 99*s - 59) + 22*f*k1**2*(C*(92*r + 148*s - 97) - 46*r - 79*s + 51) + 33*k2**2*(9*b2*(4*r + 4*s - 3) - 4*g2*(44*r + 24*s - 23)))))/(1155*d*k3**4) + 1j*D1**3*Pk1*Pk3*st**2*(D1*bd1*f**2*(r*(8 - 16*C) + 3*s) + 7*b1**2*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) + b1*f*(D1*(14*bd1*s + fd*(-32*C*r + 16*C + 16*r + 6*s - 11)) - 2*Dd*f*(8*C*(4*r - 1) - 16*r - 6*s + 7)))/(35*d*k1) + 1j*D1**3*Pk1*Pk3*(-4*D1*bd1*f*r*(b2 - 2*g2) + 5*b1**3*(D1*fd*(s - 1) + 2*Dd*(f + 1)*(2*s - 1)) + b1**2*(5*D1*bd1*(f + 1)*(3*s - 1) + D1*fd*(-4*K*r + 4*K + 6*f*s - 3*f + 3*s) + 2*Dd*f*(-8*K*r + 2*K + 6*f*s - 3*f + 6*s - 3)) + b1*(-4*D1*b2*fd*(r - 1) + D1*bd1*f*(-8*K*r + f*(6*s - 3) + 6*s - 3) - 4*D1*f*r*(bd2 - 2*gd2) + 8*D1*fd*g2*(r - 1) - 4*Dd*b2*f*(4*r - 1) - 8*Dd*f*g2*(1 - 4*r)))/(5*d*k1) + 1j*D1**3*Pk1*Pk3*st**2*(3*b1**2*(D1*fd*(7*k1**2*(4*C*(r + s - 1) - 2*r - 3*s + 3) + k2**2*(f*(32*r + 84*s - 55) + 14*r + 7*s)) + 4*Dd*f*(7*k1**2*(C*(4*r + 4*s - 3) - 2*r - 3*s + 2) + k2**2*(f*(16*r + 42*s - 25) + 14*r + 7*s - 7))) + 3*b1*f*(D1*bd1*(14*k1**2*(C*(4*r + 4*s - 2) - 2*r - 3*s + 1) + k2**2*(f*(32*r + 84*s - 45) + 28*r + 14*s - 21)) + D1*fd*(k1**2*(2 - 4*C)*(36*s - 11) + k2**2*(-16*K*r + 8*K + f*(48*r + 54*s - 43) + 12*r + 6*s - 6)) + 4*Dd*f*(k1**2*(18 - 36*C)*(2*s - 1) + k2**2*(-8*K*r + 2*K + f*(16*r + 18*s - 13) + 6*r + 3*s - 3))) + f*(3*D1*bd1*f*(k1**2*(2 - 4*C)*(18*s - 7) + k2**2*(-8*K*r + f*(16*r + 18*s - 9) + 6*r + 3*s - 3)) + D1*(f*fd*k1**2*(-4*C*(39*r + 81*s - 40) + 78*r + 177*s - 85) - 24*f*k2**2*r*(bd2 - 2*gd2) - 24*fd*k2**2*(b2 - 2*g2)*(2*r - 1)) - 4*Dd*f*(f*k1**2*(C*(52*r + 108*s - 67) - 26*r - 59*s + 36) + k2**2*(6*b2 - 12*g2)*(4*r - 1))))/(105*d*k1*k3**2) + 2*1j*D1**3*Pk1*Pkd3*ct**7*f*k2**5*(C - 1)*(9*D1*bd1*f*(r + s - 1) + 9*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 7*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(21*d*k3**5) + 1j*D1**3*Pk1*Pkd3*ct**6*f*k2**4*(9*D1*bd1*f*(r + s - 1) + 9*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 7*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(21*d*k1*k3**3) + 1j*D1**3*Pk1*Pkd3*ct**6*f*k2**4*(11*D1*bd1*f*(7*f*k2**2 + k1**2*(90*C - 81))*(r + s - 1) + 11*b1*(D1*fd*(7*f*k2**2*(3*r + 3*s - 2) + k1**2*(90*C - 81)*(2*r + 2*s - 1)) + Dd*f*(7*f*k2**2 + k1**2*(90*C - 81))*(4*r + 4*s - 3)) + 7*f*(D1*fd*(9*f*k2**2*(4*r + 4*s - 3) + k1**2*(110*C - 99)*(3*r + 3*s - 2)) + Dd*f*(9*f*k2**2 + k1**2*(110*C - 99))*(4*r + 4*s - 3)))/(231*d*k1*k3**5) + 4*1j*D1**3*Pk1*Pkd3*ct**5*f*k2**5*st**2*(C - 1)*(9*D1*bd1*f*(r + s - 1) + 9*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 5*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(21*d*k3**5) + 2*1j*D1**3*Pk1*Pkd3*ct**5*k2**3*(63*b1**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + 9*b1*f*(7*D1*bd1*(C - 1)*(2*r + 2*s - 1) + 5*D1*fd*(-C + 2*r + 2*s) + 5*Dd*f*(4*r + 4*s - 3)) + 5*f**2*(9*D1*bd1*(C + r + s - 2) - (7*C - 14)*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))))/(105*d*k3**3) - 1j*D1**3*Pk1*Pkd3*ct**5*k2**3*(-33*D1*bd1*f*(r + s - 1)*(35*f**2*k2**2 + 15*f*(k1**2*(20*C - 16) + k2**2*(K - 2*b1 - 1)) - k2**2*(-42*K*b1 + 42*b1 + 42*g2)) + 99*b1**2*k2**2*(D1*fd*(5*f*(2*r + 2*s - 1) + (7 - 7*K)*(r + s)) + Dd*f*(-7*K + 5*f + 7)*(4*r + 4*s - 3)) - 33*b1*(D1*(35*f**2*fd*k2**2*(3*r + 3*s - 2) + 15*f*fd*(k1**2*(20*C - 16) + k2**2*(K - 1))*(2*r + 2*s - 1) - 42*f*gd2*k2**2*(r + s - 1) - 42*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2 + 15*f*(k1**2*(20*C - 16) + k2**2*(K - 1)) - 42*g2*k2**2)) - 10*f*(D1*(126*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(770*C - 616)*(3*r + 3*s - 2) - 99*f*gd2*k2**2*(r + s - 1) - 99*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(126*f**2*k2**2 + f*k1**2*(770*C - 616) - 99*g2*k2**2)))/(1155*d*k3**5) + 2*1j*D1**3*Pk1*Pkd3*ct**4*f*k2**4*st**2*(9*D1*bd1*f*(r + s - 1) + 9*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 5*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(21*d*k1*k3**3) + 1j*D1**3*Pk1*Pkd3*ct**4*f*k2**4*st**2*(33*D1*bd1*f*(25*f*k2**2 + k1**2*(228*C - 198))*(r + s - 1) + 33*b1*(D1*fd*(25*f*k2**2*(3*r + 3*s - 2) + k1**2*(228*C - 198)*(2*r + 2*s - 1)) + Dd*f*(25*f*k2**2 + k1**2*(228*C - 198))*(4*r + 4*s - 3)) + 5*f*(D1*fd*(105*f*k2**2*(4*r + 4*s - 3) + k1**2*(836*C - 726)*(3*r + 3*s - 2)) + Dd*f*(105*f*k2**2 + k1**2*(836*C - 726))*(4*r + 4*s - 3)))/(1155*d*k1*k3**5) - 1j*D1**3*Pk1*Pkd3*ct**4*k1*k2**2*(-11*D1*bd1*f*(r + s - 1)*(70*f**2*k2**2 + 45*f*(k1**2*(20*C - 14) + k2**2*(5*K - 8*b1 - 4)) - k2**2*(126*b1*(4 - 5*K) + 630*g2)) + 99*b1**2*k2**2*(D1*fd*(20*f*(2*r + 2*s - 1) + (28 - 35*K)*(r + s)) + Dd*f*(-35*K + 20*f + 28)*(4*r + 4*s - 3)) - 55*b1*(D1*(14*f**2*fd*k2**2*(3*r + 3*s - 2) + 9*f*(fd*(k1**2*(20*C - 14) + k2**2*(5*K - 4))*(2*r + 2*s - 1) - 14*gd2*k2**2*(r + s - 1)) - 126*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(14*f**2*k2**2 + 9*f*(k1**2*(20*C - 14) + k2**2*(5*K - 4)) - 126*g2*k2**2)) - 10*f*(D1*(189*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(770*C - 539)*(3*r + 3*s - 2) - 495*f*gd2*k2**2*(r + s - 1) - 495*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(189*f**2*k2**2 + f*k1**2*(770*C - 539) - 495*g2*k2**2)))/(1155*d*k3**5) + 3*1j*D1**3*Pk1*Pkd3*ct**4*k2**2*(5*D1*bd1*f**2*(r + s) + 7*b1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*f*(7*D1*bd1*(2*r + 2*s - 1) + 10*D1*fd*(r + s - 1) + 5*Dd*f*(4*r + 4*s - 3)))/(35*d*k1*k3) + 1j*D1**3*Pk1*Pkd3*ct**4*k2**2*(9*b1**2*(D1*fd*(k1**2*(42*C - 35)*(r + s - 1) + k2**2*(5*f*(4*r + 4*s - 3) + 7*r + 7*s)) + Dd*f*(k1**2*(42*C - 35) + k2**2*(10*f + 7))*(4*r + 4*s - 3)) + b1*f*(9*D1*bd1*(k1**2*(42*C - 35)*(2*r + 2*s - 1) + k2**2*(5*f*(4*r + 4*s - 3) + 14*r + 14*s - 14)) + 5*D1*fd*(18*k1**2*(-3*C + r + s + 2) + k2**2*(7*f*(6*r + 6*s - 5) + 18*r + 18*s - 9)) + 5*Dd*f*(9*k1**2 + k2**2*(14*f + 9))*(4*r + 4*s - 3)) + 5*f**2*(D1*bd1*(9*k1**2*(6*C + r + s - 6) + k2**2*(7*f*(2*r + 2*s - 1) + 9*r + 9*s - 9)) + k1**2*(42 - 42*C)*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))))/(105*d*k1*k3**3) + 2*1j*D1**3*Pk1*Pkd3*ct**3*f*k2**5*st**4*(C - 1)*(3*D1*bd1*f*(r + s - 1) + 3*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(7*d*k3**5) - 2*1j*D1**3*Pk1*Pkd3*ct**3*k1**2*k2*(11*D1*bd1*f*(r + s - 1)*(35*f**2*k2**2 - 45*f*(k1**2*(5*C - 3) + k2**2*(5*K - 6*b1 - 3)) + k2**2*(126*b1*(3 - 5*K) + 630*g2)) + 99*b1**2*k2**2*(D1*fd*(15*f*(2*r + 2*s - 1) + (21 - 35*K)*(r + s)) + Dd*f*(-35*K + 15*f + 21)*(4*r + 4*s - 3)) + 55*b1*(D1*(7*f**2*fd*k2**2*(3*r + 3*s - 2) - 9*f*fd*(k1**2*(5*C - 3) + k2**2*(5*K - 3))*(2*r + 2*s - 1) + 126*f*gd2*k2**2*(r + s - 1) + 126*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(7*f**2*k2**2 - 9*f*(k1**2*(5*C - 3) + k2**2*(5*K - 3)) + 126*g2*k2**2)) - 5*f*(D1*(126*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(385*C - 231)*(3*r + 3*s - 2) - 990*f*gd2*k2**2*(r + s - 1) - 990*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(126*f**2*k2**2 + f*k1**2*(385*C - 231) - 990*g2*k2**2)))/(1155*d*k3**5) + 2*1j*D1**3*Pk1*Pkd3*ct**3*k2**3*st**2*(63*b1**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + 9*b1*f*(7*D1*bd1*(C - 1)*(2*r + 2*s - 1) + 2*D1*fd*(C*(-7*r - 7*s + 2) + 11*r + 11*s - 4) - Dd*f*(7*C - 11)*(4*r + 4*s - 3)) + f**2*(-9*D1*bd1*(C*(7*r + 7*s - 10) - 11*r - 11*s + 14) + (70 - 50*C)*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))))/(105*d*k3**3) - 1j*D1**3*Pk1*Pkd3*ct**3*k2**3*st**2*(-33*D1*bd1*f*(r + s - 1)*(50*f**2*k2**2 + f*k1**2*(330*C - 246) - 3*f*k2**2*(-3*K + 20*b1 + 3) - k2**2*(-42*K*b1 + 42*b1 + 42*g2)) + 99*b1**2*k2**2*(D1*fd*(10*f*(2*r + 2*s - 1) + (7 - 7*K)*(r + s)) + Dd*f*(-7*K + 10*f + 7)*(4*r + 4*s - 3)) - 33*b1*(D1*(50*f**2*fd*k2**2*(3*r + 3*s - 2) + 3*f*fd*(k1**2*(110*C - 82) + k2**2*(3*K - 3))*(2*r + 2*s - 1) - 42*f*gd2*k2**2*(r + s - 1) - 42*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(50*f**2*k2**2 + f*k1**2*(330*C - 246) + 9*f*k2**2*(K - 1) - 42*g2*k2**2)) - 2*f*(D1*(700*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(3025*C - 2255)*(3*r + 3*s - 2) - 297*f*gd2*k2**2*(r + s - 1) - 297*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(700*f**2*k2**2 + f*k1**2*(3025*C - 2255) - 297*g2*k2**2)))/(1155*d*k3**5) - 6*1j*D1**3*Pk1*Pkd3*ct**3*k2*(C - 1)*(5*D1*bd1*f**2*(r + s) + 7*b1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*f*(7*D1*bd1*(2*r + 2*s - 1) + 10*D1*fd*(r + s - 1) + 5*Dd*f*(4*r + 4*s - 3)))/(35*d*k3) - 1j*D1**3*Pk1*Pkd3*ct**3*k2*(21*b1**3*k2**2*(3*D1*fd*(r + s - 1) + Dd*(-5*K + 3*f + 5)*(4*r + 4*s - 3)) - 3*b1**2*(D1*(3*fd*(k1**2*(42*C - 28)*(r + s - 1) + k2**2*(-7*K + 5*f*(8*r + 8*s - 5) + 14*r + 14*s + 7)) - 7*k2**2*(bd1*(-5*K + 3*f + 5)*(3*r + 3*s - 2) + 10*gd2*(r + s - 1))) + 2*Dd*(4*r + 4*s - 3)*(30*f**2*k2**2 + 21*f*(k1**2*(3*C - 2) + k2**2) - 35*g2*k2**2)) + b1*(-3*D1*bd1*(15*f**2*k2**2*(8*r + 8*s - 7) + 21*f*(k1**2*(6*C - 4)*(2*r + 2*s - 1) + k2**2*(K + 4*r + 4*s - 5)) - 70*g2*k2**2*(2*r + 2*s - 1)) + 3*D1*(-35*f**2*fd*k2**2*(5*r + 5*s - 4) + 3*f*(7*bd2*k2**2*(r + s - 1) + 5*fd*(k1**2*(6*C - 4) + k2**2*(K - 3)*(2*r + 2*s - 1))) + 21*fd*k2**2*(b2*(r + s) - 2*g2)) + Dd*f*k2**2*(63*b2 - 5*f*(-9*K + 35*f + 27))*(4*r + 4*s - 3)) + f*(D1*bd1*(-35*f**2*k2**2*(5*r + 5*s - 3) - 45*f*(k1**2*(6*C - 4) - k2**2*(K - 3)*(r + s - 1)) + 63*k2**2*(b2*(r + s - 1) + 2*g2)) + 5*D1*(f*fd*k1**2*(42*C - 28)*(3*r + 3*s - 2) + 9*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) + 9*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + 5*Dd*f*(f*k1**2*(42*C - 28) + k2**2*(9*b2 - 18*g2))*(4*r + 4*s - 3)))/(105*d*k3**3) + 1j*D1**3*Pk1*Pkd3*ct**2*f*k2**4*st**4*(3*D1*bd1*f*(r + s - 1) + 3*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(7*d*k1*k3**3) + 1j*D1**3*Pk1*Pkd3*ct**2*f*k2**4*st**4*(33*D1*bd1*f*(5*f*k2**2 + k1**2*(26*C - 21))*(r + s - 1) + 33*b1*(D1*fd*(5*f*k2**2*(3*r + 3*s - 2) + k1**2*(26*C - 21)*(2*r + 2*s - 1)) + Dd*f*(5*f*k2**2 + k1**2*(26*C - 21))*(4*r + 4*s - 3)) + f*(D1*fd*(75*f*k2**2*(4*r + 4*s - 3) + k1**2*(286*C - 231)*(3*r + 3*s - 2)) + Dd*f*(75*f*k2**2 + k1**2*(286*C - 231))*(4*r + 4*s - 3)))/(385*d*k1*k3**5) - 1j*D1**3*Pk1*Pkd3*ct**2*k1**3*(33*D1*bd1*f*(r + s - 1)*(35*f**2*k2**2 - 15*f*(k1**2*(2*C - 1) - k2**2*(-10*K + 8*b1 + 4)) + k2**2*(84*b1*(2 - 5*K) + 420*g2)) + 198*b1**2*k2**2*(D1*fd*(10*f*(2*r + 2*s - 1) + (14 - 35*K)*(r + s)) + Dd*f*(-35*K + 10*f + 14)*(4*r + 4*s - 3)) + 165*b1*(D1*(7*f**2*fd*k2**2*(3*r + 3*s - 2) - 3*f*fd*(k1**2*(2*C - 1) + k2**2*(10*K - 4))*(2*r + 2*s - 1) + 84*f*gd2*k2**2*(r + s - 1) + 84*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(7*f**2*k2**2 + f*k1**2*(3 - 6*C) + 6*f*k2**2*(2 - 5*K) + 84*g2*k2**2)) - 5*f*(D1*(63*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(154*C - 77)*(3*r + 3*s - 2) - 1980*f*gd2*k2**2*(r + s - 1) - 1980*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(63*f**2*k2**2 + f*k1**2*(154*C - 77) - 1980*g2*k2**2)))/(1155*d*k3**5) - 1j*D1**3*Pk1*Pkd3*ct**2*k1*k2**2*st**2*(-33*D1*bd1*f*(r + s - 1)*(20*f**2*k2**2 + 3*f*(k1**2*(74*C - 47) - k2**2*(-9*K + 48*b1 + 6)) - k2**2*(42*b1*(2 - 3*K) + 126*g2)) + 99*b1**2*k2**2*(D1*fd*(24*f*(2*r + 2*s - 1) + (14 - 21*K)*(r + s)) + Dd*f*(-21*K + 24*f + 14)*(4*r + 4*s - 3)) - 33*b1*(D1*(20*f**2*fd*k2**2*(3*r + 3*s - 2) + 3*f*(fd*(k1**2*(74*C - 47) + k2**2*(9*K - 6))*(2*r + 2*s - 1) - 42*gd2*k2**2*(r + s - 1)) - 126*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(20*f**2*k2**2 + f*k1**2*(222*C - 141) + 9*f*k2**2*(3*K - 2) - 126*g2*k2**2)) + f*(D1*(-1260*f**2*fd*k2**2*(4*r + 4*s - 3) - f*fd*k1**2*(4070*C - 2585)*(3*r + 3*s - 2) + 1782*f*gd2*k2**2*(r + s - 1) + 1782*fd*g2*k2**2*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(1260*f**2*k2**2 + f*k1**2*(4070*C - 2585) - 1782*g2*k2**2)))/(1155*d*k3**5) - 1j*D1**3*Pk1*Pkd3*ct**2*k1*(21*b1**3*k2**2*(6*D1*fd*(r + s - 1) + Dd*(-15*K + 6*f + 10)*(4*r + 4*s - 3)) - 3*b1**2*(D1*(3*fd*(k1**2*(14*C - 7)*(r + s - 1) + k2**2*(-21*K + 5*f*(4*r + 4*s - 1) + 7*r + 7*s + 14)) - 7*k2**2*(bd1*(-15*K + 6*f + 10)*(3*r + 3*s - 2) + 30*gd2*(r + s - 1))) + 3*Dd*(4*r + 4*s - 3)*(10*f**2*k2**2 + 7*f*(k1**2*(2*C - 1) + k2**2) - 70*g2*k2**2)) + b1*(-9*D1*bd1*(5*f**2*k2**2*(4*r + 4*s - 5) + 7*f*(k1**2*(2*C - 1)*(2*r + 2*s - 1) + k2**2*(3*K + 2*r + 2*s - 4)) - 70*g2*k2**2*(2*r + 2*s - 1)) - 3*D1*(35*f**2*fd*k2**2*(4*r + 4*s - 3) - 3*f*(21*bd2*k2**2*(r + s - 1) + 5*fd*(k1**2*(2*C - 1) + k2**2*(3*K - 3)*(2*r + 2*s - 1))) - 63*fd*k2**2*(b2*(r + s) - 2*g2)) + Dd*f*k2**2*(189*b2 - 5*f*(-27*K + 28*f + 27))*(4*r + 4*s - 3)) + f*(D1*bd1*(-35*f**2*k2**2*(4*r + 4*s - 3) - 45*f*(k1**2*(2*C - 1) - k2**2*(3*K - 3)*(r + s - 1)) + 189*k2**2*(b2*(r + s - 1) + 2*g2)) + 5*D1*(f*fd*k1**2*(14*C - 7)*(3*r + 3*s - 2) + 27*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) + 27*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + 5*Dd*f*(f*k1**2*(14*C - 7) + k2**2*(27*b2 - 54*g2))*(4*r + 4*s - 3)))/(105*d*k3**3) + 3*1j*D1**3*Pk1*Pkd3*ct**2*k2**2*st**2*(3*D1*bd1*f**2*(r + s) + 7*b1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*f*(7*D1*bd1*(2*r + 2*s - 1) + 6*D1*fd*(r + s - 1) + 3*Dd*f*(4*r + 4*s - 3)))/(35*d*k1*k3) + 1j*D1**3*Pk1*Pkd3*ct**2*k2**2*st**2*(b1**2*(D1*fd*(k1**2*(98*C - 77)*(r + s - 1) + 3*k2**2*(6*f*(4*r + 4*s - 3) + 7*r + 7*s)) + Dd*f*(k1**2*(98*C - 77) + k2**2*(36*f + 21))*(4*r + 4*s - 3)) + b1*f*(D1*bd1*(k1**2*(98*C - 77)*(2*r + 2*s - 1) + 6*k2**2*(3*f*(4*r + 4*s - 3) + 7*r + 7*s - 7)) + D1*fd*(-3*k1**2*(C*(44*r + 44*s - 8) - 32*r - 32*s + 5) + k2**2*(10*f*(6*r + 6*s - 5) + 18*r + 18*s - 9)) + Dd*f*(k1**2*(48 - 66*C) + k2**2*(20*f + 9))*(4*r + 4*s - 3)) + f**2*(D1*bd1*(k1**2*(-6*C*(11*r + 11*s - 18) + 48*r + 48*s - 81) + k2**2*(10*f*(2*r + 2*s - 1) + 9*r + 9*s - 9)) + k1**2*(45 - 60*C)*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))))/(35*d*k1*k3**3) + 1j*D1**3*Pk1*Pkd3*ct**2*(-15*D1*bd1*f**2*k1**2*(2*C - 1)*(r + s) + 7*b1**3*k2**2*(3*D1*fd*(r + s - 1) + Dd*(3*f + 5)*(4*r + 4*s - 3)) + b1**2*(D1*(7*bd1*k2**2*(3*f + 5)*(3*r + 3*s - 2) - 3*fd*(k1**2*(14*C - 7) - k2**2*(10*f + 7))*(r + s - 1)) + 3*Dd*f*(k1**2*(7 - 14*C) + k2**2*(5*f + 7))*(4*r + 4*s - 3)) + 3*b1*f*(-D1*bd1*(k1**2*(14*C - 7) - k2**2*(5*f + 7))*(2*r + 2*s - 1) - k1**2*(10*C - 5)*(2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))))/(35*d*k1*k3) - 2*1j*D1**3*Pk1*Pkd3*ct*f*k2**3*st**4*(5*C - 4)*(3*D1*bd1*f*(r + s - 1) + 3*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(35*d*k3**3) + 1j*D1**3*Pk1*Pkd3*ct*f*k2**3*st**4*(33*D1*bd1*f*(k1**2*(22*C - 14) + k2**2*(-10*b1 + 5*f))*(r + s - 1) - 165*b1**2*k2**2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 33*b1*(D1*fd*(5*f*k2**2*(3*r + 3*s - 2) + k1**2*(22*C - 14)*(2*r + 2*s - 1)) + Dd*f*(5*f*k2**2 + k1**2*(22*C - 14))*(4*r + 4*s - 3)) + 2*f*(D1*fd*(50*f*k2**2*(4*r + 4*s - 3) + k1**2*(121*C - 77)*(3*r + 3*s - 2)) + Dd*f*(50*f*k2**2 + k1**2*(121*C - 77))*(4*r + 4*s - 3)))/(385*d*k3**5) - 1j*D1**3*Pk1*Pkd3*ct*k1**4*k2*(9*b1**2*(D1*fd*(5*f*(2*r + 2*s - 1) + (7 - 35*K)*(r + s)) + Dd*f*(-35*K + 5*f + 7)*(4*r + 4*s - 3)) + b1*(18*D1*bd1*f*(-35*K + 5*f + 7)*(r + s - 1) + 5*D1*(7*f**2*fd*(3*r + 3*s - 2) - 9*f*fd*(5*K - 1)*(2*r + 2*s - 1) + 126*f*gd2*(r + s - 1) + 126*fd*g2*(r + s)) + 5*Dd*f*(7*f**2 + f*(9 - 45*K) + 126*g2)*(4*r + 4*s - 3)) + 5*f*(D1*bd1*(7*f**2 + f*(9 - 45*K) + 126*g2)*(r + s - 1) + 90*D1*f*gd2*(r + s - 1) + 90*D1*fd*g2*(2*r + 2*s - 1) + 90*Dd*f*g2*(4*r + 4*s - 3)))/(105*d*k3**5) - 1j*D1**3*Pk1*Pkd3*ct*k1**2*k2*(21*b1**3*(3*D1*fd*(r + s - 1) + Dd*(-15*K + 3*f + 5)*(4*r + 4*s - 3)) + 3*b1**2*(7*D1*bd1*(-15*K + 3*f + 5)*(3*r + 3*s - 2) - 3*D1*fd*(-21*K + 5*f + 7) + 210*D1*gd2*(r + s - 1) + 210*Dd*g2*(4*r + 4*s - 3)) + b1*(270*D1*K*f*fd*r + 270*D1*K*f*fd*s - 135*D1*K*f*fd + 189*D1*b2*fd*r + 189*D1*b2*fd*s + 9*D1*bd1*(5*f**2 + f*(7 - 21*K) + 70*g2*(2*r + 2*s - 1)) + 189*D1*bd2*f*(r + s - 1) - 105*D1*f**2*fd*r - 105*D1*f**2*fd*s + 70*D1*f**2*fd - 90*D1*f*fd*r - 90*D1*f*fd*s + 45*D1*f*fd - 378*D1*fd*g2 + 540*Dd*K*f**2*r + 540*Dd*K*f**2*s - 405*Dd*K*f**2 + 756*Dd*b2*f*r + 756*Dd*b2*f*s - 567*Dd*b2*f - 140*Dd*f**3*r - 140*Dd*f**3*s + 105*Dd*f**3 - 180*Dd*f**2*r - 180*Dd*f**2*s + 135*Dd*f**2) + f*(D1*bd1*(-35*f**2*(r + s - 1) + 45*f*(3*K - 1)*(r + s - 1) + 378*g2) + 135*D1*bd2*f*(r + s - 1) - 270*D1*f*gd2*(r + s - 1) - 270*D1*fd*g2*(2*r + 2*s - 1) - 270*Dd*f*g2*(4*r + 4*s - 3) + 27*b2*(7*D1*bd1*(r + s - 1) + 5*D1*fd*(2*r + 2*s - 1) + 5*Dd*f*(4*r + 4*s - 3))))/(105*d*k3**3) - 1j*D1**3*Pk1*Pkd3*ct*k1**2*k2*st**2*(33*D1*bd1*f*(r + s - 1)*(10*f**2*k2**2 + f*k1**2*(36 - 66*C) + 9*f*k2**2*(-3*K + 12*b1 + 1) + k2**2*(-126*K*b1 + 42*b1 + 126*g2)) + 99*b1**2*k2**2*(D1*fd*(18*f*(2*r + 2*s - 1) + (7 - 21*K)*(r + s)) + Dd*f*(-21*K + 18*f + 7)*(4*r + 4*s - 3)) + 33*b1*(D1*(10*f**2*fd*k2**2*(3*r + 3*s - 2) - 3*f*fd*(k1**2*(22*C - 12) + k2**2*(9*K - 3))*(2*r + 2*s - 1) + 126*f*gd2*k2**2*(r + s - 1) + 126*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(10*f**2*k2**2 + f*k1**2*(36 - 66*C) + 9*f*k2**2*(1 - 3*K) + 126*g2*k2**2)) - 2*f*(D1*(210*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(605*C - 330)*(3*r + 3*s - 2) - 891*f*gd2*k2**2*(r + s - 1) - 891*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(210*f**2*k2**2 + f*k1**2*(605*C - 330) - 891*g2*k2**2)))/(1155*d*k3**5) - 2*1j*D1**3*Pk1*Pkd3*ct*k2*st**2*(3*C - 2)*(3*D1*bd1*f**2*(r + s) + 7*b1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*f*(7*D1*bd1*(2*r + 2*s - 1) + 6*D1*fd*(r + s - 1) + 3*Dd*f*(4*r + 4*s - 3)))/(35*d*k3) + 1j*D1**3*Pk1*Pkd3*ct*k2*(-21*D1*bd1*f*(b2 - 2*g2)*(r + s) + 7*b1**3*(3*D1*fd*(r + s - 1) + Dd*(-5*K + 3*f + 5)*(4*r + 4*s - 3)) + b1**2*(-21*D1*K*fd*r - 21*D1*K*fd*s + 21*D1*K*fd + 7*D1*bd1*(-5*K + 3*f + 5)*(3*r + 3*s - 2) - 35*D1*bd2*(r + s - 1) + 30*D1*f*fd*r + 30*D1*f*fd*s - 30*D1*f*fd + 21*D1*fd*r + 21*D1*fd*s - 21*D1*fd + 70*D1*gd2*r + 70*D1*gd2*s - 70*D1*gd2 - 84*Dd*K*f*r - 84*Dd*K*f*s + 63*Dd*K*f - 140*Dd*b2*r - 140*Dd*b2*s + 105*Dd*b2 + 60*Dd*f**2*r + 60*Dd*f**2*s - 45*Dd*f**2 + 84*Dd*f*r + 84*Dd*f*s - 63*Dd*f + 280*Dd*g2*r + 280*Dd*g2*s - 210*Dd*g2) + b1*(D1*bd1*(15*f**2 - 21*f*(K - 1) + 70*g2)*(2*r + 2*s - 1) - 21*D1*bd2*f*(r + s - 1) + 42*D1*(f*gd2 + fd*g2)*(r + s - 1) + 42*Dd*f*g2*(4*r + 4*s - 3) - 7*b2*(5*D1*bd1*(2*r + 2*s - 1) + 3*D1*fd*(r + s - 1) + 3*Dd*f*(4*r + 4*s - 3))))/(35*d*k3) - 1j*D1**3*Pk1*Pkd3*ct*k2*st**2*(63*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) - 3*b1**2*(D1*(-21*bd1*f*k2**2*(3*r + 3*s - 2) + fd*k1**2*(70*C - 42)*(r + s - 1) + 3*fd*k2**2*(3*f*(8*r + 8*s - 5) + (7 - 7*K)*(r + s))) + Dd*f*(k1**2*(70*C - 42) + k2**2*(-21*K + 36*f + 21))*(4*r + 4*s - 3)) - 3*b1*(D1*bd1*f*(k1**2*(70*C - 42)*(2*r + 2*s - 1) + 3*k2**2*(3*f*(8*r + 8*s - 7) + (14 - 14*K)*(r + s - 1))) + 3*D1*(5*f**2*fd*k2**2*(5*r + 5*s - 4) + f*(-2*fd*k1**2*(8*C*r + 8*C*s + C - 4*r - 4*s - 1) - 3*fd*k2**2*(K - 1)*(2*r + 2*s - 1) + k2**2*(-7*bd2 + 14*gd2)*(r + s - 1)) - 7*fd*k2**2*(b2 - 2*g2)*(r + s)) + Dd*f*(4*r + 4*s - 3)*(25*f**2*k2**2 - 3*f*(k1**2*(8*C - 4) + k2**2*(3*K - 3)) - k2**2*(21*b2 - 42*g2))) + f*(-3*D1*bd1*(5*f**2*k2**2*(5*r + 5*s - 3) - 6*f*k1**2*(C*(4*r + 4*s - 9) - 2*r - 2*s + 5) - 9*f*k2**2*(K - 1)*(r + s - 1) + k2**2*(-21*b2 + 42*g2)*(r + s - 1)) + D1*(f*fd*k1**2*(90*C - 50)*(3*r + 3*s - 2) + 27*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) + 27*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + Dd*f*(f*k1**2*(90*C - 50) + k2**2*(27*b2 - 54*g2))*(4*r + 4*s - 3)))/(105*d*k3**3) + 1j*D1**3*Pk1*Pkd3*f**2*k2**6*st**6*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)) + 3*f*(D1*fd + Dd*f)*(4*r + 4*s - 3))/(231*d*k1*k3**5) + 1j*D1**3*Pk1*Pkd3*f*k1*k2**2*st**4*(11*D1*bd1*f*(k1**2*(18*C - 9) + k2**2*(-24*b1 + 2*f))*(r + s - 1) - 132*b1**2*k2**2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 11*b1*(D1*fd*(2*f*k2**2*(3*r + 3*s - 2) + k1**2*(18*C - 9)*(2*r + 2*s - 1)) + Dd*f*(2*f*k2**2 + k1**2*(18*C - 9))*(4*r + 4*s - 3)) + 3*f*(D1*fd*(10*f*k2**2*(4*r + 4*s - 3) + k1**2*(22*C - 11)*(3*r + 3*s - 2)) + Dd*f*(10*f*k2**2 + k1**2*(22*C - 11))*(4*r + 4*s - 3)))/(385*d*k3**5) + 1j*D1**3*Pk1*Pkd3*f*k2**2*st**4*(D1*bd1*f*(k1**2*(9 - 18*C)*(r + s - 1) + k2**2*(3*b1*(4*r + 4*s - 3) + f*(2*r + 2*s - 1))) + 3*b1**2*k2**2*(D1*fd + 2*Dd*f)*(4*r + 4*s - 3) + b1*(D1*fd*(f*k2**2*(6*r + 6*s - 5) + k1**2*(9 - 18*C)*(2*r + 2*s - 1)) + Dd*f*(2*f*k2**2 + k1**2*(9 - 18*C))*(4*r + 4*s - 3)) - f*k1**2*(6*C - 3)*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(35*d*k1*k3**3) + 3*1j*D1**3*Pk1*Pkd3*k1**5*(D1*bd1*f*(r + s - 1)*(14*K*b1 + 5*K*f - 14*g2) + 7*K*b1**2*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) + b1*(5*D1*K*f*fd*(2*r + 2*s - 1) - 14*D1*f*gd2*(r + s - 1) - 14*D1*fd*g2*(r + s) + Dd*f*(5*K*f - 14*g2)*(4*r + 4*s - 3)) - 10*f*(D1*f*gd2*(r + s - 1) + D1*fd*g2*(2*r + 2*s - 1) + Dd*f*g2*(4*r + 4*s - 3)))/(35*d*k3**5) - 1j*D1**3*Pk1*Pkd3*k1**3*(-35*Dd*K*b1**3*(4*r + 4*s - 3) + 7*b1**2*(D1*(-5*K*bd1*(3*r + 3*s - 2) + 3*K*fd + 10*gd2*(r + s - 1)) + 10*Dd*g2*(4*r + 4*s - 3)) + b1*(30*D1*K*f*fd*r + 30*D1*K*f*fd*s - 15*D1*K*f*fd + 7*D1*bd1*(-3*K*f + 10*g2*(2*r + 2*s - 1)) + 21*D1*bd2*f*(r + s - 1) - 42*D1*fd*g2 + 60*Dd*K*f**2*r + 60*Dd*K*f**2*s - 45*Dd*K*f**2) + 3*b2*(7*D1*bd1*f*(r + s - 1) + 7*b1*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) + 5*f*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))) + 3*f*(D1*bd1*(5*K*f*(r + s - 1) + 14*g2) + 5*D1*bd2*f*(r + s - 1) - 10*D1*f*gd2*(r + s - 1) - 10*D1*fd*g2*(2*r + 2*s - 1) - 10*Dd*f*g2*(4*r + 4*s - 3)))/(35*d*k3**3) - 1j*D1**3*Pk1*Pkd3*k1**3*st**2*(33*D1*bd1*f*(r + s - 1)*(5*f**2*k2**2 + 3*f*(k1**2*(1 - 2*C) + k2**2*(-3*K + 8*b1)) + k2**2*(-42*K*b1 + 42*g2)) + 99*b1**2*k2**2*(D1*fd*(-7*K*(r + s) + f*(8*r + 8*s - 4)) + Dd*f*(-7*K + 4*f)*(4*r + 4*s - 3)) + 33*b1*(D1*(5*f**2*fd*k2**2*(3*r + 3*s - 2) - 3*f*fd*(3*K*k2**2 + k1**2*(2*C - 1))*(2*r + 2*s - 1) + 42*f*gd2*k2**2*(r + s - 1) + 42*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(-9*K*f*k2**2 + 5*f**2*k2**2 + f*k1**2*(3 - 6*C) + 42*g2*k2**2)) + f*(D1*(-35*f**2*fd*k2**2*(4*r + 4*s - 3) - f*fd*k1**2*(110*C - 55)*(3*r + 3*s - 2) + 594*f*gd2*k2**2*(r + s - 1) + 594*fd*g2*k2**2*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2 + f*k1**2*(110*C - 55) - 594*g2*k2**2)))/(1155*d*k3**5) - 1j*D1**3*Pk1*Pkd3*k1*(3*D1*bd1*f*(b2 - 2*g2)*(r + s) + 5*Dd*K*b1**3*(4*r + 4*s - 3) + b1**2*(15*D1*K*bd1*r + 15*D1*K*bd1*s - 10*D1*K*bd1 + 3*D1*K*fd*r + 3*D1*K*fd*s - 3*D1*K*fd + 5*D1*bd2*(r + s - 1) - 10*D1*gd2*r - 10*D1*gd2*s + 10*D1*gd2 + 12*Dd*K*f*r + 12*Dd*K*f*s - 9*Dd*K*f + 5*Dd*b2*(4*r + 4*s - 3) - 40*Dd*g2*r - 40*Dd*g2*s + 30*Dd*g2) + b1*(6*D1*K*bd1*f*r + 6*D1*K*bd1*f*s - 3*D1*K*bd1*f - 20*D1*bd1*g2*r - 20*D1*bd1*g2*s + 10*D1*bd1*g2 + 3*D1*bd2*f*(r + s - 1) - 6*D1*f*gd2*r - 6*D1*f*gd2*s + 6*D1*f*gd2 - 6*D1*fd*g2*r - 6*D1*fd*g2*s + 6*D1*fd*g2 - 24*Dd*f*g2*r - 24*Dd*f*g2*s + 18*Dd*f*g2 + b2*(5*D1*bd1*(2*r + 2*s - 1) + 3*D1*fd*(r + s - 1) + 3*Dd*f*(4*r + 4*s - 3))))/(5*d*k3) - 1j*D1**3*Pk1*Pkd3*k1*st**2*(42*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) - 3*b1**2*(D1*(-14*bd1*f*k2**2*(3*r + 3*s - 2) + fd*k1**2*(14*C - 7)*(r + s - 1) + 3*fd*k2**2*(-7*K*(r + s) + f*(4*r + 4*s - 1))) + Dd*f*(k1**2*(14*C - 7) + k2**2*(-21*K + 6*f))*(4*r + 4*s - 3)) + b1*(-3*D1*bd1*f*(k1**2*(14*C - 7)*(2*r + 2*s - 1) + 3*k2**2*(-14*K*(r + s - 1) + f*(4*r + 4*s - 5))) + 3*D1*(-5*f**2*fd*k2**2*(4*r + 4*s - 3) + 3*f*(3*K*fd*k2**2*(2*r + 2*s - 1) + fd*k1**2*(2*C - 1) + k2**2*(7*bd2 - 14*gd2)*(r + s - 1)) + 21*fd*k2**2*(b2 - 2*g2)*(r + s)) + Dd*f*k2**2*(4*r + 4*s - 3)*(27*K*f + 63*b2 - 20*f**2 - 126*g2)) + f*(D1*bd1*(27*K*f*k2**2*(r + s - 1) - 5*f**2*k2**2*(4*r + 4*s - 3) + f*k1**2*(9 - 18*C) + k2**2*(63*b2 - 126*g2)*(r + s - 1)) + D1*(f*fd*k1**2*(10*C - 5)*(3*r + 3*s - 2) + 27*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) + 27*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + Dd*f*(f*k1**2*(10*C - 5) + k2**2*(27*b2 - 54*g2))*(4*r + 4*s - 3)))/(105*d*k3**3) + 1j*D1**3*Pk1*Pkd3*st**2*(-3*D1*bd1*f**2*k1**2*(2*C - 1)*(r + s) + 7*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1**2*(D1*(7*bd1*f*k2**2*(3*r + 3*s - 2) - fd*(-6*f*k2**2 + k1**2*(14*C - 7))*(r + s - 1)) + Dd*f*(3*f*k2**2 + k1**2*(7 - 14*C))*(4*r + 4*s - 3)) + b1*f*(-D1*bd1*(-3*f*k2**2 + k1**2*(14*C - 7))*(2*r + 2*s - 1) - k1**2*(6*C - 3)*(2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))))/(35*d*k1*k3) + 1j*D1**3*Pk3*Pkd1*b1*ct*k2*(6*D1*bd1*f*r*(5*f + 7) + 7*b1**2*(3*D1*fd*r + Dd*(3*f + 5)*(4*r - 1)) + b1*(7*D1*bd1*(3*f + 5)*(3*r - 1) + 3*D1*fd*(10*f*r - 5*f + 7*r - 7) + 3*Dd*f*(5*f + 7)*(4*r - 1)))/(35*d*k1) + 2*1j*D1**3*Pk3*Pkd1*ct**6*f*k2**4*(C - 1)*(9*D1*bd1*f*(r - 1) + 9*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 7*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(21*d*k3**4) + 1j*D1**3*Pk3*Pkd1*ct**5*f*k2**3*(9*D1*bd1*f*(r - 1) + 9*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 7*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(21*d*k1*k3**2) + 1j*D1**3*Pk3*Pkd1*ct**5*f*k2**3*(11*D1*bd1*f*(r - 1)*(7*f*k2**2 + k1**2*(72*C - 63)) + 11*b1*(3*D1*fd*r*(7*f*k2**2 + k1**2*(48*C - 42)) + Dd*f*(4*r - 1)*(7*f*k2**2 + k1**2*(72*C - 63))) + 7*f*(D1*fd*(9*f*k2**2*(4*r - 1) + k1**2*(88*C - 77)*(3*r - 1)) + Dd*f*(4*r - 1)*(9*f*k2**2 + k1**2*(88*C - 77))))/(231*d*k1*k3**4) + 4*1j*D1**3*Pk3*Pkd1*ct**4*f*k2**4*st**2*(C - 1)*(9*D1*bd1*f*(r - 1) + 9*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 5*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(35*d*k3**4) + 1j*D1**3*Pk3*Pkd1*ct**4*k2**2*(126*b1**2*(C - 1)*(D1*fd*r + Dd*f*(4*r - 1)) + 9*b1*f*(14*D1*bd1*(C - 1)*(2*r - 1) + 10*D1*fd*(-C + r + 1) + 5*Dd*f*(4*r - 1)) + 5*f**2*(9*D1*bd1*(2*C + r - 3) - (14*C - 21)*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1))))/(105*d*k3**2) - 1j*D1**3*Pk3*Pkd1*ct**4*k2**2*(-11*D1*bd1*f*(35*f**2*k2**2*(2*r - 3) + 45*f*(k1**2*(12*C - 9)*(r - 1) + k2**2*(-2*b1*r + b1 + r*(K - 1))) + 63*k2**2*(b1*(K - 1)*(2*r - 1) - 2*g2*(r - 1))) + 99*b1**2*k2**2*(D1*fd*r*(-7*K + 10*f + 7) + Dd*f*(4*r - 1)*(-7*K + 5*f + 7)) - 11*b1*(D1*(35*f**2*fd*k2**2*(6*r + 1) + 9*f*(5*fd*(k1**2*r*(24*C - 18) + k2**2*(K - 1)*(2*r - 1)) - 14*gd2*k2**2*r) - 126*fd*g2*k2**2*r) + Dd*f*(4*r - 1)*(70*f**2*k2**2 + 45*f*(k1**2*(12*C - 9) + k2**2*(K - 1)) - 126*g2*k2**2)) - 15*f*(D1*(63*f**2*fd*k2**2*(4*r - 1) + f*fd*k1**2*(308*C - 231)*(3*r - 1) - 66*f*gd2*k2**2*r + 66*fd*g2*k2**2*(1 - 2*r)) + Dd*f*(4*r - 1)*(63*f**2*k2**2 + f*k1**2*(308*C - 231) - 66*g2*k2**2)))/(1155*d*k3**4) + 2*1j*D1**3*Pk3*Pkd1*ct**3*f*k2**3*st**2*(9*D1*bd1*f*(r - 1) + 9*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 5*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(35*d*k1*k3**2) + 2*1j*D1**3*Pk3*Pkd1*ct**3*f*k2**3*st**2*(11*D1*bd1*f*(r - 1)*(25*f*k2**2 + k1**2*(162*C - 135)) + 11*b1*(3*D1*fd*r*(25*f*k2**2 + k1**2*(108*C - 90)) + Dd*f*(4*r - 1)*(25*f*k2**2 + k1**2*(162*C - 135))) + 5*f*(D1*fd*(35*f*k2**2*(4*r - 1) + k1**2*(198*C - 165)*(3*r - 1)) + Dd*f*(4*r - 1)*(35*f*k2**2 + k1**2*(198*C - 165))))/(1155*d*k1*k3**4) - 1j*D1**3*Pk3*Pkd1*ct**3*k1*k2*(33*D1*bd1*f*(35*f**2*k2**2 - 15*f*(k1**2*(8*C - 5)*(r - 1) + k2**2*(4*K*r - 6*b1*r + 3*b1 - 3*r)) - 21*k2**2*(b1*(4*K - 3)*(2*r - 1) - 8*g2*(r - 1))) + 99*b1**2*k2**2*(D1*fd*r*(-28*K + 30*f + 21) + Dd*f*(4*r - 1)*(-28*K + 15*f + 21)) - 33*b1*(D1*(35*f**2*fd*k2**2 + 3*f*(5*fd*(k1**2*r*(16*C - 10) + k2**2*(4*K - 3)*(2*r - 1)) - 56*gd2*k2**2*r) - 168*fd*g2*k2**2*r) + 3*Dd*f*(4*r - 1)*(5*f*(k1**2*(8*C - 5) + k2**2*(4*K - 3)) - 56*g2*k2**2)) - 5*f*(D1*(189*f**2*fd*k2**2*(4*r - 1) + f*fd*k1**2*(616*C - 385)*(3*r - 1) - 792*f*gd2*k2**2*r + 792*fd*g2*k2**2*(1 - 2*r)) + Dd*f*(4*r - 1)*(189*f**2*k2**2 + f*k1**2*(616*C - 385) - 792*g2*k2**2)))/(1155*d*k3**4) + 3*1j*D1**3*Pk3*Pkd1*ct**3*k2*(5*D1*bd1*f**2*r + 7*b1**2*(D1*fd*r + Dd*f*(4*r - 1)) + b1*f*(7*D1*bd1*(2*r - 1) + 5*D1*fd*(2*r - 1) + 5*Dd*f*(4*r - 1)))/(35*d*k1) + 1j*D1**3*Pk3*Pkd1*ct**3*k2*(9*b1**2*(D1*fd*r*(k1**2*(28*C - 21) + k2**2*(20*f + 7)) + Dd*f*(4*r - 1)*(k1**2*(28*C - 21) + k2**2*(10*f + 7))) + b1*f*(9*D1*bd1*(2*r - 1)*(k1**2*(28*C - 21) + k2**2*(10*f + 7)) - 5*D1*fd*(k1**2*(36*C - 27) + k2**2*(f*(14 - 42*r) - 18*r + 9)) + 5*Dd*f*k2**2*(14*f + 9)*(4*r - 1)) + 5*f**2*(D1*bd1*(k1**2*(36*C - 27) + k2**2*r*(14*f + 9)) - k1**2*(28*C - 21)*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1))))/(105*d*k1*k3**2) + 2*1j*D1**3*Pk3*Pkd1*ct**2*f*k2**4*st**4*(C - 1)*(6*D1*b1*fd*r + 3*D1*bd1*f*(r - 1) + D1*f*fd*(3*r - 1) + 3*Dd*b1*f*(4*r - 1) + Dd*f**2*(4*r - 1))/(35*d*k3**4) - 1j*D1**3*Pk3*Pkd1*ct**2*k1**2*(11*D1*bd1*f*(35*f**2*k2**2*(2*r + 1) - 45*f*(k1**2*(2*C - 1)*(r - 1) + 3*k2**2*(2*K*r - 2*b1*r + b1 - r)) - 189*k2**2*(b1*(2*K - 1)*(2*r - 1) - 4*g2*(r - 1))) + 297*b1**2*k2**2*(D1*fd*r*(-14*K + 10*f + 7) + Dd*f*(4*r - 1)*(-14*K + 5*f + 7)) + 11*b1*(3*D1*(35*f**2*fd*k2**2*(2*r - 1) - 15*f*fd*(k1**2*r*(4*C - 2) + k2**2*(6*K - 3)*(2*r - 1)) + 252*f*gd2*k2**2*r + 252*fd*g2*k2**2*r) + Dd*f*(4*r - 1)*(70*f**2*k2**2 - 45*f*(k1**2*(2*C - 1) + k2**2*(6*K - 3)) + 756*g2*k2**2)) - 5*f*(D1*(63*f**2*fd*k2**2*(4*r - 1) + f*fd*k1**2*(154*C - 77)*(3*r - 1) - 1188*f*gd2*k2**2*r + 1188*fd*g2*k2**2*(1 - 2*r)) + Dd*f*(4*r - 1)*(63*f**2*k2**2 + f*k1**2*(154*C - 77) - 1188*g2*k2**2)))/(1155*d*k3**4) + 2*1j*D1**3*Pk3*Pkd1*ct**2*k2**2*st**2*(C - 1)*(7*b1**2*(D1*fd*r + Dd*f*(4*r - 1)) - b1*f*(7*D1*bd1*(1 - 2*r) + 3*D1*fd*(10*r + 1) + 15*Dd*f*(4*r - 1)) + f**2*(-3*D1*bd1*(5*r - 6) + 10*D1*fd*(1 - 3*r) + 10*Dd*(-4*f*r + f)))/(35*d*k3**2) - 1j*D1**3*Pk3*Pkd1*ct**2*k2**2*st**2*(-33*D1*bd1*f*(10*f**2*k2**2*(2*r - 3) + 3*f*(k1**2*(38*C - 26)*(r - 1) + k2**2*(b1*(6 - 12*r) + r*(K - 1))) + 7*k2**2*(b1*(K - 1)*(2*r - 1) - 2*g2*(r - 1))) + 33*b1**2*k2**2*(D1*fd*r*(-7*K + 36*f + 7) + Dd*f*(4*r - 1)*(-7*K + 18*f + 7)) - 33*b1*(D1*(10*f**2*fd*k2**2*(6*r + 1) + 3*f*fd*(k1**2*r*(76*C - 52) + k2**2*(K - 1)*(2*r - 1)) - 14*f*gd2*k2**2*r - 14*fd*g2*k2**2*r) + Dd*f*(4*r - 1)*(20*f**2*k2**2 + 3*f*(k1**2*(38*C - 26) + k2**2*(K - 1)) - 14*g2*k2**2)) - 2*f*(D1*(315*f**2*fd*k2**2*(4*r - 1) + f*fd*k1**2*(1045*C - 715)*(3*r - 1) - 99*f*gd2*k2**2*r + 99*fd*g2*k2**2*(1 - 2*r)) + Dd*f*(4*r - 1)*(315*f**2*k2**2 + f*k1**2*(1045*C - 715) - 99*g2*k2**2)))/(1155*d*k3**4) - 3*1j*D1**3*Pk3*Pkd1*ct**2*(2*C - 1)*(5*D1*bd1*f**2*r + 7*b1**2*(D1*fd*r + Dd*f*(4*r - 1)) + b1*f*(7*D1*bd1*(2*r - 1) + 5*D1*fd*(2*r - 1) + 5*Dd*f*(4*r - 1)))/(35*d) - 1j*D1**3*Pk3*Pkd1*ct**2*(21*b1**3*k2**2*(3*D1*fd*r + Dd*(4*r - 1)*(-5*K + 3*f + 5)) - 3*b1**2*(D1*(-7*bd1*k2**2*(3*r - 1)*(-5*K + 3*f + 5) + 3*fd*(k1**2*r*(14*C - 7) + k2**2*(-7*K + 20*f*r + 5*f + 7*r + 7)) - 70*gd2*k2**2*r) + Dd*(4*r - 1)*(30*f**2*k2**2 + 21*f*(k1**2*(2*C - 1) + k2**2) - 70*g2*k2**2)) - 3*b1*(D1*bd1*(15*f**2*k2**2*(4*r - 3) + 21*f*(k1**2*(2*C - 1)*(2*r - 1) + k2**2*(K + 2*r - 2)) + 70*g2*k2**2*(1 - 2*r)) + D1*(35*f**2*fd*k2**2*(3*r - 1) - 3*f*(7*bd2*k2**2*r + 5*fd*(k1**2*(2*C - 1) + k2**2*(K - 2)*(2*r - 1))) + 21*fd*k2**2*(-b2*r + 2*g2)) + Dd*f*k2**2*(-21*b2 + 5*f*(-3*K + 7*f + 6))*(4*r - 1)) + f*(-3*D1*bd1*(35*f**2*k2**2*r + 15*f*(k1**2*(2*C - 1) - k2**2*r*(K - 2)) - 21*k2**2*(b2*(r - 1) + 2*g2)) + 5*D1*(f*fd*k1**2*(14*C - 7)*(3*r - 1) + 9*f*k2**2*r*(bd2 - 2*gd2) + 9*fd*k2**2*(b2 - 2*g2)*(2*r - 1)) + 5*Dd*f*(4*r - 1)*(f*k1**2*(14*C - 7) + k2**2*(9*b2 - 18*g2))))/(105*d*k3**2) + 1j*D1**3*Pk3*Pkd1*ct*f*k2**3*st**4*(6*D1*b1*fd*r + 3*D1*bd1*f*(r - 1) + D1*f*fd*(3*r - 1) + 3*Dd*b1*f*(4*r - 1) + Dd*f**2*(4*r - 1))/(35*d*k1*k3**2) + 1j*D1**3*Pk3*Pkd1*ct*f*k2**3*st**4*(11*D1*bd1*f*(r - 1)*(5*f*k2**2 + k1**2*(12*C - 9)) + 11*b1*(3*D1*fd*r*(5*f*k2**2 + k1**2*(8*C - 6)) + Dd*f*(4*r - 1)*(5*f*k2**2 + k1**2*(12*C - 9))) + f*(D1*fd*(25*f*k2**2*(4*r - 1) + k1**2*(44*C - 33)*(3*r - 1)) + Dd*f*(4*r - 1)*(25*f*k2**2 + k1**2*(44*C - 33))))/(385*d*k1*k3**4) - 1j*D1**3*Pk3*Pkd1*ct*k1**3*k2*(9*b1**2*(D1*fd*r*(-28*K + 10*f + 7) + Dd*f*(4*r - 1)*(-28*K + 5*f + 7)) + b1*(9*D1*bd1*f*(2*r - 1)*(-28*K + 5*f + 7) + D1*(35*f**2*fd*(3*r - 1) - 45*f*fd*(4*K - 1)*(2*r - 1) + 504*f*gd2*r + 504*fd*g2*r) + Dd*f*(4*r - 1)*(35*f**2 - 45*f*(4*K - 1) + 504*g2)) + f*(D1*bd1*(5*f*r*(-36*K + 7*f + 9) + 504*g2*(r - 1)) + 360*D1*f*gd2*r + 360*D1*fd*g2*(2*r - 1) + 360*Dd*f*g2*(4*r - 1)))/(105*d*k3**4) - 1j*D1**3*Pk3*Pkd1*ct*k1*k2*(21*b1**3*(3*D1*fd*r + Dd*(4*r - 1)*(-10*K + 3*f + 5)) + 3*b1**2*(7*D1*bd1*(3*r - 1)*(-10*K + 3*f + 5) - 3*D1*fd*(-14*K + 5*f + 7) + 140*D1*gd2*r + 140*Dd*g2*(4*r - 1)) + b1*(180*D1*K*f*fd*r - 90*D1*K*f*fd + 3*D1*bd1*(15*f**2 + f*(21 - 42*K) + 140*g2*(2*r - 1)) + 126*D1*bd2*f*r - 105*D1*f**2*fd*r + 35*D1*f**2*fd - 90*D1*f*fd*r + 45*D1*f*fd - 252*D1*fd*g2 + 360*Dd*K*f**2*r - 90*Dd*K*f**2 - 140*Dd*f**3*r + 35*Dd*f**3 - 180*Dd*f**2*r + 45*Dd*f**2 + 126*b2*(D1*fd*r + Dd*f*(4*r - 1))) + f*(D1*bd1*(-5*f*r*(-18*K + 7*f + 9) + 252*g2) + 90*D1*f*r*(bd2 - 2*gd2) + 90*D1*fd*g2*(2 - 4*r) + 180*Dd*f*g2*(1 - 4*r) + 18*b2*(7*D1*bd1*(r - 1) + 5*D1*fd*(2*r - 1) + 5*Dd*f*(4*r - 1))))/(105*d*k3**2) - 1j*D1**3*Pk3*Pkd1*ct*k1*k2*st**2*(33*D1*bd1*f*(15*f**2*k2**2 - f*k1**2*(48*C - 27)*(r - 1) + 3*f*k2**2*(-2*K*r + 9*b1*(2*r - 1) + r) - 7*k2**2*(b1*(2*K - 1)*(2*r - 1) - 4*g2*(r - 1))) + 33*b1**2*k2**2*(D1*fd*r*(-14*K + 54*f + 7) + Dd*f*(4*r - 1)*(-14*K + 27*f + 7)) - 33*b1*(D1*(15*f**2*fd*k2**2 + f*(fd*k1**2*r*(96*C - 54) + 3*fd*k2**2*(2*K - 1)*(2*r - 1) - 28*gd2*k2**2*r) - 28*fd*g2*k2**2*r) + Dd*f*(4*r - 1)*(3*f*(k1**2*(16*C - 9) + k2**2*(2*K - 1)) - 28*g2*k2**2)) + f*(D1*(-315*f**2*fd*k2**2*(4*r - 1) - f*fd*k1**2*(880*C - 495)*(3*r - 1) + 396*f*gd2*k2**2*r + 396*fd*g2*k2**2*(2*r - 1)) - Dd*f*(4*r - 1)*(315*f**2*k2**2 + f*k1**2*(880*C - 495) - 396*g2*k2**2)))/(1155*d*k3**4) + 1j*D1**3*Pk3*Pkd1*ct*k2*st**2*(3*D1*bd1*f**2*r + 7*b1**2*(D1*fd*r + Dd*f*(4*r - 1)) + b1*f*(7*D1*bd1*(2*r - 1) + 3*D1*fd*(2*r - 1) + 3*Dd*f*(4*r - 1)))/(35*d*k1) + 1j*D1**3*Pk3*Pkd1*ct*k2*st**2*(3*b1**2*(D1*fd*r*(k1**2*(28*C - 21) + k2**2*(36*f + 7)) + Dd*f*(4*r - 1)*(k1**2*(28*C - 21) + k2**2*(18*f + 7))) + 3*b1*f*(D1*bd1*(2*r - 1)*(k1**2*(28*C - 21) + k2**2*(18*f + 7)) + D1*fd*(-3*k1**2*(4*C*(4*r + 1) - 8*r - 3) + k2**2*(10*f*(3*r - 1) + 6*r - 3)) + Dd*f*(4*r - 1)*(k1**2*(12 - 24*C) + k2**2*(10*f + 3))) + f**2*(3*D1*bd1*(-3*k1**2*(8*C*r - 12*C - 4*r + 7) + k2**2*r*(10*f + 3)) + k1**2*(35 - 60*C)*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1))))/(105*d*k1*k3**2) - 1j*D1**3*Pk3*Pkd1*f*k2**2*st**4*(2*C - 1)*(6*D1*b1*fd*r + 3*D1*bd1*f*(r - 1) + D1*f*fd*(3*r - 1) + 3*Dd*b1*f*(4*r - 1) + Dd*f**2*(4*r - 1))/(35*d*k3**2) + 1j*D1**3*Pk3*Pkd1*f*k2**2*st**4*(11*D1*bd1*f*(k1**2*(6*C - 3)*(r - 1) + k2**2*(-6*b1*r + 3*b1 + 2*f*r - 3*f)) - 33*b1**2*k2**2*(2*D1*fd*r + Dd*f*(4*r - 1)) + 11*b1*(D1*fd*(f*k2**2*(6*r + 1) + k1**2*r*(12*C - 6)) + Dd*f*(4*r - 1)*(2*f*k2**2 + k1**2*(6*C - 3))) + f*(D1*fd*(15*f*k2**2*(4*r - 1) + k1**2*(22*C - 11)*(3*r - 1)) + Dd*f*(4*r - 1)*(15*f*k2**2 + k1**2*(22*C - 11))))/(385*d*k3**4) + 3*1j*D1**3*Pk3*Pkd1*k1**4*(D1*bd1*f*(7*K*b1*(2*r - 1) + 5*K*f*r - 14*g2*(r - 1)) + 7*K*b1**2*(D1*fd*r + Dd*f*(4*r - 1)) + b1*(D1*(5*K*f*fd*(2*r - 1) - 14*f*gd2*r - 14*fd*g2*r) + Dd*f*(4*r - 1)*(5*K*f - 14*g2)) - 10*f*(D1*f*gd2*r + D1*fd*g2*(2*r - 1) + Dd*f*g2*(4*r - 1)))/(35*d*k3**4) - 1j*D1**3*Pk3*Pkd1*k1**2*(-35*Dd*K*b1**3*(4*r - 1) + 7*b1**2*(D1*(5*K*bd1*(1 - 3*r) + 3*K*fd + 10*gd2*r) + 10*Dd*g2*(4*r - 1)) + b1*(-7*D1*bd1*(3*K*f + g2*(10 - 20*r)) + 3*D1*(5*K*f*fd*(2*r - 1) + 7*bd2*f*r - 14*fd*g2) + 15*Dd*K*f**2*(4*r - 1)) + 3*b2*(7*D1*bd1*f*(r - 1) + 7*b1*(D1*fd*r + Dd*f*(4*r - 1)) + 5*f*(D1*fd*(2*r - 1) + Dd*f*(4*r - 1))) + 3*f*(D1*bd1*(5*K*f*r + 14*g2) + 5*D1*(f*r*(bd2 - 2*gd2) + fd*g2*(2 - 4*r)) + 10*Dd*f*g2*(1 - 4*r)))/(35*d*k3**2) + 1j*D1**3*Pk3*Pkd1*k1**2*st**2*(-11*D1*bd1*f*(5*f**2*k2**2*(2*r + 1) - 9*f*(k1**2*(2*C - 1)*(r - 1) + k2**2*(K*r - 6*b1*r + 3*b1)) + 21*k2**2*(K*b1*(1 - 2*r) + 2*g2*(r - 1))) - 33*b1**2*k2**2*(D1*fd*r*(-7*K + 18*f) + Dd*f*(-7*K + 9*f)*(4*r - 1)) - 11*b1*(3*D1*(5*f**2*fd*k2**2*(2*r - 1) + f*(3*K*fd*k2**2*(1 - 2*r) + fd*k1**2*r*(6 - 12*C) + 14*gd2*k2**2*r) + 14*fd*g2*k2**2*r) + Dd*f*(4*r - 1)*(10*f**2*k2**2 - 9*f*(K*k2**2 + k1**2*(2*C - 1)) + 42*g2*k2**2)) + f*(D1*(35*f**2*fd*k2**2*(4*r - 1) + f*fd*k1**2*(110*C - 55)*(3*r - 1) - 198*f*gd2*k2**2*r + 198*fd*g2*k2**2*(1 - 2*r)) + Dd*f*(4*r - 1)*(35*f**2*k2**2 + f*k1**2*(110*C - 55) - 198*g2*k2**2)))/(1155*d*k3**4) - 1j*D1**3*Pk3*Pkd1*st**2*(2*C - 1)*(3*D1*bd1*f**2*r + 7*b1**2*(D1*fd*r + Dd*f*(4*r - 1)) + b1*f*(7*D1*bd1*(2*r - 1) + 3*D1*fd*(2*r - 1) + 3*Dd*f*(4*r - 1)))/(35*d) - 1j*D1**3*Pk3*Pkd1*(3*D1*bd1*f*r*(b2 - 2*g2) + 5*Dd*K*b1**3*(4*r - 1) + b1**2*(D1*(5*K*bd1*(3*r - 1) + 3*K*fd*(r - 1) + r*(5*bd2 - 10*gd2)) + 5*Dd*b2*(4*r - 1) - Dd*(4*r - 1)*(-3*K*f + 10*g2)) + b1*(6*D1*K*bd1*f*r + 5*D1*b2*bd1*(2*r - 1) + 2*D1*bd1*g2*(5 - 10*r) + 3*D1*f*r*(bd2 - 2*gd2) - 6*D1*fd*g2*(r - 1) + 6*Dd*f*g2*(1 - 4*r) + 3*b2*(D1*fd*(r - 1) + Dd*f*(4*r - 1))))/(5*d) - 1j*D1**3*Pk3*Pkd1*st**2*(21*b1**3*k2**2*(D1*fd*r + Dd*f*(4*r - 1)) - 3*b1**2*(D1*(7*bd1*f*k2**2*(1 - 3*r) + fd*(-7*K*k2**2*r + 3*f*k2**2*(4*r + 1) + k1**2*r*(14*C - 7))) + Dd*f*(4*r - 1)*(k1**2*(14*C - 7) + k2**2*(-7*K + 6*f))) - 3*b1*(D1*bd1*f*(k1**2*(14*C - 7)*(2*r - 1) + k2**2*(-14*K*r + 7*K + 12*f*r - 9*f)) + D1*(5*f**2*fd*k2**2*(3*r - 1) + 3*f*fd*(K*k2**2*(1 - 2*r) + k1**2*(1 - 2*C)) - 7*f*k2**2*r*(bd2 - 2*gd2) - 7*fd*k2**2*r*(b2 - 2*g2)) + Dd*f*k2**2*(4*r - 1)*(-3*K*f - 7*b2 + 5*f**2 + 14*g2)) + f*(-3*D1*bd1*(-3*K*f*k2**2*r + 5*f**2*k2**2*r + f*k1**2*(6*C - 3) - k2**2*(7*b2 - 14*g2)*(r - 1)) + D1*(f*fd*k1**2*(10*C - 5)*(3*r - 1) + 9*f*k2**2*r*(bd2 - 2*gd2) + 9*fd*k2**2*(b2 - 2*g2)*(2*r - 1)) + Dd*f*(4*r - 1)*(f*k1**2*(10*C - 5) + k2**2*(9*b2 - 18*g2))))/(105*d*k3**2)
        perm23 = 1j*D1**3*Pk2*Pk3*b1*(D1*bd1*f*(k1**2*(6*s - 3) + k2**2*r*(8 - 16*C)) + 5*b1**2*k1**2*(D1*fd*s + Dd*(f + 1)*(4*s - 1)) + b1*(5*D1*bd1*k1**2*(f + 1)*(3*s - 1) + D1*fd*(3*k1**2*s + k2**2*(4 - 8*C)*(r - 1)) + Dd*f*(3*k1**2*(4*s - 1) + k2**2*(8 - 16*C)*(2*r - 1))))/(5*d*k1*k2**2) - 4*1j*D1**3*Pk2*Pk3*ct**7*f*k1**2*k2**3*(462*C*D1*f*fd*r + 462*C*D1*f*fd*s - 308*C*D1*f*fd + 616*C*Dd*f**2*r + 616*C*Dd*f**2*s - 462*C*Dd*f**2 + 99*D1*bd1*f*(K - 1)*(r + s - 1) + 252*D1*f**2*fd*r + 252*D1*f**2*fd*s - 189*D1*f**2*fd - 462*D1*f*fd*r - 462*D1*f*fd*s + 308*D1*f*fd - 198*D1*f*gd2*r - 198*D1*f*gd2*s + 198*D1*f*gd2 - 396*D1*fd*g2*r - 396*D1*fd*g2*s + 198*D1*fd*g2 + 252*Dd*f**3*r + 252*Dd*f**3*s - 189*Dd*f**3 - 616*Dd*f**2*r - 616*Dd*f**2*s + 462*Dd*f**2 - 792*Dd*f*g2*r - 792*Dd*f*g2*s + 594*Dd*f*g2 + 99*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))/(231*d*k3**6) + 4*1j*D1**3*Pk2*Pk3*ct**6*f*k1*k2**2*(-1386*C*D1*f*fd*k1**2*r - 1386*C*D1*f*fd*k1**2*s + 924*C*D1*f*fd*k1**2 - 924*C*D1*f*fd*k2**2*r - 924*C*D1*f*fd*k2**2*s + 616*C*D1*f*fd*k2**2 - 1848*C*Dd*f**2*k1**2*r - 1848*C*Dd*f**2*k1**2*s + 1386*C*Dd*f**2*k1**2 - 1232*C*Dd*f**2*k2**2*r - 1232*C*Dd*f**2*k2**2*s + 924*C*Dd*f**2*k2**2 - 11*D1*bd1*f*(k1**2*(27*K - 27) + k2**2*(18*K - 7*f - 9))*(r + s - 1) - 1008*D1*f**2*fd*k1**2*r - 1008*D1*f**2*fd*k1**2*s + 756*D1*f**2*fd*k1**2 + 1386*D1*f*fd*k1**2*r + 1386*D1*f*fd*k1**2*s - 924*D1*f*fd*k1**2 + 693*D1*f*fd*k2**2*r + 693*D1*f*fd*k2**2*s - 462*D1*f*fd*k2**2 + 594*D1*f*gd2*k1**2*r + 594*D1*f*gd2*k1**2*s - 594*D1*f*gd2*k1**2 + 396*D1*f*gd2*k2**2*r + 396*D1*f*gd2*k2**2*s - 396*D1*f*gd2*k2**2 + 1188*D1*fd*g2*k1**2*r + 1188*D1*fd*g2*k1**2*s - 594*D1*fd*g2*k1**2 + 792*D1*fd*g2*k2**2*r + 792*D1*fd*g2*k2**2*s - 396*D1*fd*g2*k2**2 - 1008*Dd*f**3*k1**2*r - 1008*Dd*f**3*k1**2*s + 756*Dd*f**3*k1**2 + 1848*Dd*f**2*k1**2*r + 1848*Dd*f**2*k1**2*s - 1386*Dd*f**2*k1**2 + 924*Dd*f**2*k2**2*r + 924*Dd*f**2*k2**2*s - 693*Dd*f**2*k2**2 + 2376*Dd*f*g2*k1**2*r + 2376*Dd*f*g2*k1**2*s - 1782*Dd*f*g2*k1**2 + 1584*Dd*f*g2*k2**2*r + 1584*Dd*f*g2*k2**2*s - 1188*Dd*f*g2*k2**2 + 11*b1*(D1*fd*(k1**2*(27 - 27*K)*(2*r + 2*s - 1) + k2**2*(7*f*(3*r + 3*s - 2) + (9 - 18*K)*(2*r + 2*s - 1))) + Dd*f*(k1**2*(27 - 27*K) + k2**2*(-18*K + 7*f + 9))*(4*r + 4*s - 3)))/(231*d*k3**6) - 4*1j*D1**3*Pk2*Pk3*ct**5*f*k1**2*k2**3*st**2*(660*C*D1*f*fd*r + 660*C*D1*f*fd*s - 440*C*D1*f*fd + 880*C*Dd*f**2*r + 880*C*Dd*f**2*s - 660*C*Dd*f**2 + 198*D1*bd1*f*(K - 1)*(r + s - 1) + 588*D1*f**2*fd*r + 588*D1*f**2*fd*s - 441*D1*f**2*fd - 660*D1*f*fd*r - 660*D1*f*fd*s + 440*D1*f*fd - 396*D1*f*gd2*r - 396*D1*f*gd2*s + 396*D1*f*gd2 - 792*D1*fd*g2*r - 792*D1*fd*g2*s + 396*D1*fd*g2 + 588*Dd*f**3*r + 588*Dd*f**3*s - 441*Dd*f**3 - 880*Dd*f**2*r - 880*Dd*f**2*s + 660*Dd*f**2 - 1584*Dd*f*g2*r - 1584*Dd*f*g2*s + 1188*Dd*f*g2 + 198*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))/(231*d*k3**6) - 4*1j*D1**3*Pk2*Pk3*ct**5*k2*(-33*D1*bd1*f*(r + s - 1)*(35*f**2*k1**2*k2**2 - 15*f*(K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(2*C + 6*K - 5)) + k1**2*k2**2*(-42*K*b1 + 42*b1 + 42*g2)) + 693*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) - 33*b1*(D1*(35*f**2*fd*k1**2*k2**2*(3*r + 3*s - 2) - 15*f*fd*(2*r + 2*s - 1)*(K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(2*C + 6*K - 5)) + 42*f*gd2*k1**2*k2**2*(r + s - 1) + 42*fd*g2*k1**2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(35*f**2*k1**2*k2**2 - 15*f*(K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(2*C + 6*K - 5)) + 42*g2*k1**2*k2**2)) + 5*f*(D1*(378*f**2*fd*k1**4*(4*r + 4*s - 3) + 77*f*fd*(3*r + 3*s - 2)*(k1**4*(6*C - 6) + k1**2*k2**2*(12*C - 9) + k2**4*(2*C - 1)) - 198*f*gd2*(3*k1**4 + 6*k1**2*k2**2 + k2**4)*(r + s - 1) - 198*fd*g2*(3*k1**4 + 6*k1**2*k2**2 + k2**4)*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(378*f**2*k1**4 + 77*f*(k1**4*(6*C - 6) + k1**2*k2**2*(12*C - 9) + k2**4*(2*C - 1)) - 198*g2*(3*k1**4 + 6*k1**2*k2**2 + k2**4))))/(1155*d*k3**6) + 4*1j*D1**3*Pk2*Pk3*ct**4*f*k1*k2**2*st**2*(-33*D1*bd1*f*(k1**2*(54*K - 54) - k2**2*(-60*K + 25*f + 30))*(r + s - 1) + 2*D1*(-1050*f**2*fd*k1**2*(4*r + 4*s - 3) - 55*f*fd*(k1**2*(18*C - 18) + k2**2*(20*C - 15))*(3*r + 3*s - 2) + 198*f*gd2*(9*k1**2 + 10*k2**2)*(r + s - 1) + 198*fd*g2*(9*k1**2 + 10*k2**2)*(2*r + 2*s - 1)) - 2*Dd*f*(4*r + 4*s - 3)*(1050*f**2*k1**2 + 55*f*(k1**2*(18*C - 18) + k2**2*(20*C - 15)) - 198*g2*(9*k1**2 + 10*k2**2)) + 33*b1*(D1*fd*(k1**2*(54 - 54*K)*(2*r + 2*s - 1) + 5*k2**2*(5*f*(3*r + 3*s - 2) + (6 - 12*K)*(2*r + 2*s - 1))) + Dd*f*(k1**2*(54 - 54*K) + k2**2*(-60*K + 25*f + 30))*(4*r + 4*s - 3)))/(1155*d*k3**6) + 4*1j*D1**3*Pk2*Pk3*ct**4*k1*(11*D1*bd1*f*(r + s - 1)*(70*f**2*k1**2*k2**2 - 45*f*(k1**4*(K - 1) + k1**2*k2**2*(6*C + 6*K - 9) + k2**4*(4*C + 3*K - 2*b1 - 3)) + 126*k2**2*(-3*b1*k1**2*(K - 1) + b1*k2**2*(1 - 2*K) + g2*(3*k1**2 + 2*k2**2))) + 99*b1**2*k2**2*(D1*fd*(5*f*k2**2*(2*r + 2*s - 1) + (r + s)*(-7*k1**2*(3*K - 3) - 7*k2**2*(2*K - 1))) + Dd*f*(k1**2*(21 - 21*K) + k2**2*(-14*K + 5*f + 7))*(4*r + 4*s - 3)) + 11*b1*(D1*(70*f**2*fd*k1**2*k2**2*(3*r + 3*s - 2) - 45*f*fd*(2*r + 2*s - 1)*(k1**4*(K - 1) + k1**2*k2**2*(6*C + 6*K - 9) + k2**4*(4*C + 3*K - 3)) + 126*f*gd2*k2**2*(3*k1**2 + 2*k2**2)*(r + s - 1) + 126*fd*g2*k2**2*(3*k1**2 + 2*k2**2)*(r + s)) + Dd*f*(4*r + 4*s - 3)*(70*f**2*k1**2*k2**2 - 45*f*(k1**4*(K - 1) + k1**2*k2**2*(6*C + 6*K - 9) + k2**4*(4*C + 3*K - 3)) + 126*g2*k2**2*(3*k1**2 + 2*k2**2))) - 5*f*(D1*(252*f**2*fd*k1**4*(4*r + 4*s - 3) + 77*f*fd*(3*r + 3*s - 2)*(k1**4*(2*C - 2) + k1**2*k2**2*(12*C - 9) + k2**4*(6*C - 3)) - 198*f*gd2*(k1**4 + 6*k1**2*k2**2 + 3*k2**4)*(r + s - 1) - 198*fd*g2*(k1**4 + 6*k1**2*k2**2 + 3*k2**4)*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(252*f**2*k1**4 + 77*f*(k1**4*(2*C - 2) + k1**2*k2**2*(12*C - 9) + k2**4*(6*C - 3)) - 198*g2*(k1**4 + 6*k1**2*k2**2 + 3*k2**4))))/(1155*d*k3**6) - 4*1j*D1**3*Pk2*Pk3*ct**3*f*k1**2*k2**3*st**4*(66*C*D1*f*fd*r + 66*C*D1*f*fd*s - 44*C*D1*f*fd + 88*C*Dd*f**2*r + 88*C*Dd*f**2*s - 66*C*Dd*f**2 + 33*D1*bd1*f*(K - 1)*(r + s - 1) + 140*D1*f**2*fd*r + 140*D1*f**2*fd*s - 105*D1*f**2*fd - 66*D1*f*fd*r - 66*D1*f*fd*s + 44*D1*f*fd - 66*D1*f*gd2*r - 66*D1*f*gd2*s + 66*D1*f*gd2 - 132*D1*fd*g2*r - 132*D1*fd*g2*s + 66*D1*fd*g2 + 140*Dd*f**3*r + 140*Dd*f**3*s - 105*Dd*f**3 - 88*Dd*f**2*r - 88*Dd*f**2*s + 66*Dd*f**2 - 264*Dd*f*g2*r - 264*Dd*f*g2*s + 198*Dd*f*g2 + 33*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))/(77*d*k3**6) - 4*1j*D1**3*Pk2*Pk3*ct**3*k2*st**2*(-33*D1*bd1*f*(r + s - 1)*(50*f**2*k1**2*k2**2 - 3*f*(10*K*k2**4 + k1**4*(9*K - 9) + k1**2*k2**2*(6*C + 36*K - 24)) + k1**2*k2**2*(-42*K*b1 + 42*b1 + 42*g2)) + 693*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) - 33*b1*(D1*(50*f**2*fd*k1**2*k2**2*(3*r + 3*s - 2) - 3*f*fd*(2*r + 2*s - 1)*(10*K*k2**4 + k1**4*(9*K - 9) + k1**2*k2**2*(6*C + 36*K - 24)) + 42*f*gd2*k1**2*k2**2*(r + s - 1) + 42*fd*g2*k1**2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(50*f**2*k1**2*k2**2 - 3*f*(10*K*k2**4 + k1**4*(9*K - 9) + k1**2*k2**2*(6*C + 36*K - 24)) + 42*g2*k1**2*k2**2)) + 2*f*(D1*(1050*f**2*fd*k1**4*(4*r + 4*s - 3) + 55*f*fd*(3*r + 3*s - 2)*(k1**4*(9*C - 9) + k1**2*k2**2*(36*C - 27) + k2**4*(10*C - 5)) - 99*f*gd2*(9*k1**4 + 36*k1**2*k2**2 + 10*k2**4)*(r + s - 1) - 99*fd*g2*(9*k1**4 + 36*k1**2*k2**2 + 10*k2**4)*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(1050*f**2*k1**4 + 55*f*(k1**4*(9*C - 9) + k1**2*k2**2*(36*C - 27) + k2**4*(10*C - 5)) - 99*g2*(9*k1**4 + 36*k1**2*k2**2 + 10*k2**4))))/(1155*d*k3**6) + 4*1j*D1**3*Pk2*Pk3*ct**3*(D1*(-693*b1*fd*k2**2*(r + s)*(b1*(K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(6*K - 3)) - 2*g2*(3*k1**4 + 6*k1**2*k2**2 + k2**4)) - 35*f**3*k1**4*(22*bd1*k2**2*(r + s - 1) + 9*fd*k1**2*(4*r + 4*s - 3)) - 55*f**2*k2**2*(9*bd1*(r + s - 1)*(k1**4*(6*C + 2*K - 7) + k1**2*k2**2*(12*C + 3*K - 8*b1 - 9) + k2**4*(2*C - 1)) + k1**2*(7*fd*(k1**2*(4*C + 2*b1 - 3) + k2**2*(6*C - 3))*(3*r + 3*s - 2) - 18*gd2*(2*k1**2 + 3*k2**2)*(r + s - 1))) + 99*f*k2**2*(20*b1**2*fd*k1**2*k2**2*(2*r + 2*s - 1) + b1*(-14*bd1*(r + s - 1)*(K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(6*K - 3)) - 5*fd*(2*r + 2*s - 1)*(k1**4*(6*C + 2*K - 7) + k1**2*k2**2*(12*C + 3*K - 9) + k2**4*(2*C - 1)) + 14*gd2*(3*k1**4 + 6*k1**2*k2**2 + k2**4)*(r + s - 1)) + 2*g2*(7*bd1*(3*k1**4 + 6*k1**2*k2**2 + k2**4)*(r + s - 1) + 5*fd*k1**2*(2*k1**2 + 3*k2**2)*(2*r + 2*s - 1)))) - Dd*f*(4*r + 4*s - 3)*(693*b1*k2**2*(b1*(K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(6*K - 3)) - 2*g2*(3*k1**4 + 6*k1**2*k2**2 + k2**4)) + 315*f**3*k1**6 + 385*f**2*(k1**4*k2**2*(4*C + 2*b1 - 3) + k1**2*k2**4*(6*C - 3)) - 495*f*k2**2*(4*b1**2*k1**2*k2**2 + b1*(k1**4*(-6*C - 2*K + 7) - k1**2*k2**2*(12*C + 3*K - 9) + k2**4*(1 - 2*C)) + 4*g2*k1**4 + 6*g2*k1**2*k2**2)))/(1155*d*k2*k3**6) + 4*1j*D1**3*Pk2*Pk3*ct**2*f*k1*k2**2*st**4*(-198*C*D1*f*fd*k1**2*r - 198*C*D1*f*fd*k1**2*s + 132*C*D1*f*fd*k1**2 - 660*C*D1*f*fd*k2**2*r - 660*C*D1*f*fd*k2**2*s + 440*C*D1*f*fd*k2**2 - 264*C*Dd*f**2*k1**2*r - 264*C*Dd*f**2*k1**2*s + 198*C*Dd*f**2*k1**2 - 880*C*Dd*f**2*k2**2*r - 880*C*Dd*f**2*k2**2*s + 660*C*Dd*f**2*k2**2 - 33*D1*bd1*f*(k1**2*(3*K - 3) - k2**2*(-10*K + 5*f + 5))*(r + s - 1) - 1200*D1*f**2*fd*k1**2*r - 1200*D1*f**2*fd*k1**2*s + 900*D1*f**2*fd*k1**2 + 198*D1*f*fd*k1**2*r + 198*D1*f*fd*k1**2*s - 132*D1*f*fd*k1**2 + 495*D1*f*fd*k2**2*r + 495*D1*f*fd*k2**2*s - 330*D1*f*fd*k2**2 + 198*D1*f*gd2*k1**2*r + 198*D1*f*gd2*k1**2*s - 198*D1*f*gd2*k1**2 + 660*D1*f*gd2*k2**2*r + 660*D1*f*gd2*k2**2*s - 660*D1*f*gd2*k2**2 + 396*D1*fd*g2*k1**2*r + 396*D1*fd*g2*k1**2*s - 198*D1*fd*g2*k1**2 + 1320*D1*fd*g2*k2**2*r + 1320*D1*fd*g2*k2**2*s - 660*D1*fd*g2*k2**2 - 1200*Dd*f**3*k1**2*r - 1200*Dd*f**3*k1**2*s + 900*Dd*f**3*k1**2 + 264*Dd*f**2*k1**2*r + 264*Dd*f**2*k1**2*s - 198*Dd*f**2*k1**2 + 660*Dd*f**2*k2**2*r + 660*Dd*f**2*k2**2*s - 495*Dd*f**2*k2**2 + 792*Dd*f*g2*k1**2*r + 792*Dd*f*g2*k1**2*s - 594*Dd*f*g2*k1**2 + 2640*Dd*f*g2*k2**2*r + 2640*Dd*f*g2*k2**2*s - 1980*Dd*f*g2*k2**2 + 33*b1*(D1*fd*(k1**2*(3 - 3*K)*(2*r + 2*s - 1) + 5*k2**2*(f*(3*r + 3*s - 2) - (2*K - 1)*(2*r + 2*s - 1))) + Dd*f*(k1**2*(3 - 3*K) + k2**2*(-10*K + 5*f + 5))*(4*r + 4*s - 3)))/(385*d*k3**6) + 4*1j*D1**3*Pk2*Pk3*ct**2*k1*st**2*(33*D1*bd1*f*(r + s - 1)*(20*f**2*k1**2*k2**2 - 3*f*(k1**4*(K - 1) + k1**2*k2**2*(6*C + 18*K - 15) + k2**4*(12*C + 18*K - 12*b1 - 9)) - 42*k2**2*(b1*k1**2*(K - 1) + b1*k2**2*(2*K - 1) - g2*(k1**2 + 2*k2**2))) + 99*b1**2*k2**2*(D1*fd*(6*f*k2**2*(2*r + 2*s - 1) + (r + s)*(-7*k1**2*(K - 1) - 7*k2**2*(2*K - 1))) + Dd*f*(k1**2*(7 - 7*K) + k2**2*(-14*K + 6*f + 7))*(4*r + 4*s - 3)) + 33*b1*(D1*(20*f**2*fd*k1**2*k2**2*(3*r + 3*s - 2) - 3*f*fd*(2*r + 2*s - 1)*(k1**4*(K - 1) + k1**2*k2**2*(6*C + 18*K - 15) + k2**4*(12*C + 18*K - 9)) + 42*f*gd2*k2**2*(k1**2 + 2*k2**2)*(r + s - 1) + 42*fd*g2*k2**2*(k1**2 + 2*k2**2)*(r + s)) + Dd*f*(4*r + 4*s - 3)*(20*f**2*k1**2*k2**2 - 3*f*(k1**4*(K - 1) + k1**2*k2**2*(6*C + 18*K - 15) + k2**4*(12*C + 18*K - 9)) + 42*g2*k2**2*(k1**2 + 2*k2**2))) + f*(D1*(-840*f**2*fd*k1**4*(4*r + 4*s - 3) - 55*f*fd*(3*r + 3*s - 2)*(k1**4*(2*C - 2) + k1**2*k2**2*(36*C - 27) + k2**4*(36*C - 18)) + 198*f*gd2*(k1**4 + 18*k1**2*k2**2 + 18*k2**4)*(r + s - 1) + 198*fd*g2*(k1**4 + 18*k1**2*k2**2 + 18*k2**4)*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(840*f**2*k1**4 + 55*f*(k1**4*(2*C - 2) + k1**2*k2**2*(36*C - 27) + k2**4*(36*C - 18)) - 198*g2*(k1**4 + 18*k1**2*k2**2 + 18*k2**4))))/(1155*d*k3**6) + 4*1j*D1**3*Pk2*Pk3*ct**2*k1*(9*b1**2*(D1*fd*(30*f*k1**2*k2**2*(2*r + 2*s - 1) + (r + s)*(-21*K*k2**4 - 7*k1**4*(K - 1) - 7*k1**2*k2**2*(6*K - 3))) + Dd*f*(4*r + 4*s - 3)*(-21*K*k2**4 + k1**4*(7 - 7*K) + k1**2*k2**2*(-42*K + 30*f + 21))) + 3*b1*(-6*D1*bd1*f*(r + s - 1)*(21*K*k2**4 + k1**4*(7*K - 7) - k1**2*k2**2*(-42*K + 30*f + 21)) + D1*(-35*f**2*fd*k1**4*(3*r + 3*s - 2) - 15*f*fd*(2*r + 2*s - 1)*(k1**4*(2*C - 2) + k1**2*k2**2*(12*C + K - 9) + k2**4*(6*C - 3)) + 42*f*gd2*(k1**4 + 6*k1**2*k2**2 + 3*k2**4)*(r + s - 1) + 42*fd*g2*(r + s)*(k1**4 + 6*k1**2*k2**2 + 3*k2**4)) - Dd*f*(4*r + 4*s - 3)*(35*f**2*k1**4 + 15*f*(k1**4*(2*C - 2) + k1**2*k2**2*(12*C + K - 9) + k2**4*(6*C - 3)) - 42*g2*(k1**4 + 6*k1**2*k2**2 + 3*k2**4))) + f*(-3*D1*bd1*(r + s - 1)*(35*f**2*k1**4 + 15*f*(k1**4*(2*C - 2) + k1**2*k2**2*(12*C + K - 9) + k2**4*(6*C - 3)) - 42*g2*(k1**4 + 6*k1**2*k2**2 + 3*k2**4)) - 5*k1**2*k2**2*(D1*(f*fd*(14*C - 7)*(3*r + 3*s - 2) - 18*f*gd2*(r + s - 1) - 18*fd*g2*(2*r + 2*s - 1)) + Dd*f*(f*(14*C - 7) - 18*g2)*(4*r + 4*s - 3))))/(105*d*k3**6) - 4*1j*D1**3*Pk2*Pk3*ct*f**3*k1**2*k2**3*st**6*(D1*fd + Dd*f)*(4*r + 4*s - 3)/(11*d*k3**6) + 4*1j*D1**3*Pk2*Pk3*ct*f*k2*st**4*(D1*(-15*f**2*k1**2*(-11*bd1*k2**2*(r + s - 1) + 10*fd*k1**2*(4*r + 4*s - 3)) - 11*f*k2**2*(3*bd1*(5*K*k2**2 + k1**2*(6*K - 3))*(r + s - 1) - fd*(k1**2*(-12*C + 15*b1 + 9) + k2**2*(5 - 10*C))*(3*r + 3*s - 2) - 6*gd2*(6*k1**2 + 5*k2**2)*(r + s - 1)) - 33*fd*k2**2*(2*r + 2*s - 1)*(5*K*b1*k2**2 + b1*k1**2*(6*K - 3) - 2*g2*(6*k1**2 + 5*k2**2))) - Dd*f*(4*r + 4*s - 3)*(150*f**2*k1**4 - 11*f*(k1**2*k2**2*(-12*C + 15*b1 + 9) + k2**4*(5 - 10*C)) + 33*k2**2*(5*K*b1*k2**2 + b1*k1**2*(6*K - 3) - 2*g2*(6*k1**2 + 5*k2**2))))/(385*d*k3**6) + 4*1j*D1**3*Pk2*Pk3*ct*k1**2*(-D1*bd1*f*(r + s - 1)*(35*f**2*k1**4 + 45*f*k2**2*(k1**2*(4*C - 8*b1 - 3) + k2**2*(6*C - 3)) + 126*k2**2*(3*K*b1*k2**2 + b1*k1**2*(2*K - 1) - g2*(2*k1**2 + 3*k2**2))) + b1*(D1*(-35*f**2*fd*k1**4*(3*r + 3*s - 2) + 9*f*k2**2*(5*fd*(k1**2*(-4*C + 4*b1 + 3) + k2**2*(3 - 6*C))*(2*r + 2*s - 1) + 14*gd2*(2*k1**2 + 3*k2**2)*(r + s - 1)) - 63*fd*k2**2*(r + s)*(3*K*b1*k2**2 + b1*k1**2*(2*K - 1) - 2*g2*(2*k1**2 + 3*k2**2))) - Dd*f*(4*r + 4*s - 3)*(35*f**2*k1**4 + 45*f*k2**2*(k1**2*(4*C - 4*b1 - 3) + k2**2*(6*C - 3)) + 63*k2**2*(3*K*b1*k2**2 + b1*k1**2*(2*K - 1) - 2*g2*(2*k1**2 + 3*k2**2)))))/(105*d*k2*k3**6) + 4*1j*D1**3*Pk2*Pk3*ct*st**2*(D1*(-693*b1*fd*k2**4*(r + s)*(K*b1*k2**2 + b1*k1**2*(2*K - 1) - 2*g2*(2*k1**2 + k2**2)) - 15*f**3*k1**4*(22*bd1*k2**2*(r + s - 1) + 7*fd*k1**2*(4*r + 4*s - 3)) - 11*f**2*k2**2*(9*bd1*(r + s - 1)*(k1**4*(2*K - 1) - k1**2*k2**2*(-12*C - 9*K + 24*b1 + 9) + k2**4*(6*C - 3)) + k1**2*(5*fd*(k1**2*(4*C + 6*b1 - 3) + k2**2*(18*C - 9))*(3*r + 3*s - 2) - 18*gd2*(2*k1**2 + 9*k2**2)*(r + s - 1))) + 99*f*k2**2*(12*b1**2*fd*k1**2*k2**2*(2*r + 2*s - 1) - b1*fd*(2*r + 2*s - 1)*(k1**4*(2*K - 1) + k1**2*k2**2*(12*C + 9*K - 9) + k2**4*(6*C - 3)) - 14*b1*k2**2*(r + s - 1)*(K*bd1*k2**2 + bd1*k1**2*(2*K - 1) - gd2*(2*k1**2 + k2**2)) + 14*bd1*g2*k2**2*(2*k1**2 + k2**2)*(r + s - 1) + 2*fd*g2*k1**2*(2*k1**2 + 9*k2**2)*(2*r + 2*s - 1))) - Dd*f*(4*r + 4*s - 3)*(693*b1*k2**4*(K*b1*k2**2 + b1*k1**2*(2*K - 1) - 2*g2*(2*k1**2 + k2**2)) + 105*f**3*k1**6 + 55*f**2*(k1**4*k2**2*(4*C + 6*b1 - 3) + k1**2*k2**4*(18*C - 9)) - 99*f*k2**2*(12*b1**2*k1**2*k2**2 + b1*(k1**4*(1 - 2*K) - k1**2*k2**2*(12*C + 9*K - 9) + k2**4*(3 - 6*C)) + 2*g2*k1**2*(2*k1**2 + 9*k2**2))))/(1155*d*k2*k3**6) + 4*1j*D1**3*Pk2*Pk3*f**2*k1*k2**2*st**6*(D1*(11*b1*fd*k2**2*(3*r + 3*s - 2) + 11*bd1*f*k2**2*(r + s - 1) - 12*f*fd*k1**2*(4*r + 4*s - 3)) - Dd*f*(-11*b1*k2**2 + 12*f*k1**2)*(4*r + 4*s - 3))/(231*d*k3**6) + 4*1j*D1**3*Pk2*Pk3*f*k1*st**4*(D1*(2*f**2*k1**2*(11*bd1*k2**2*(r + s - 1) - 10*fd*k1**2*(4*r + 4*s - 3)) + 11*f*k2**2*(6*b1*bd1*k2**2*(r + s - 1) + 2*b1*fd*k1**2*(3*r + 3*s - 2) - fd*k2**2*(6*C - 3)*(3*r + 3*s - 2) + k2**2*(-9*K*bd1 + 18*gd2)*(r + s - 1)) + 33*fd*k2**4*(2*r + 2*s - 1)*(-3*K*b1 + b1**2 + 6*g2)) - Dd*f*(4*r + 4*s - 3)*(20*f**2*k1**4 - 11*f*(2*b1*k1**2*k2**2 + k2**4*(3 - 6*C)) - k2**4*(-99*K*b1 + 33*b1**2 + 198*g2)))/(385*d*k3**6) + 12*1j*D1**3*Pk2*Pk3*k1**3*(-D1*bd1*f*k2**2*(f*(10*C - 5) - 14*g2)*(r + s - 1) + b1**2*(D1*fd*(-7*K*k2**2*(r + s) + 5*f*k1**2*(2*r + 2*s - 1)) + Dd*f*(-7*K*k2**2 + 5*f*k1**2)*(4*r + 4*s - 3)) + b1*(2*D1*bd1*f*(-7*K*k2**2 + 5*f*k1**2)*(r + s - 1) + k2**2*(D1*(-f*fd*(10*C - 5)*(2*r + 2*s - 1) + 14*f*gd2*(r + s - 1) + 14*fd*g2*(r + s)) - Dd*f*(f*(10*C - 5) - 14*g2)*(4*r + 4*s - 3))))/(35*d*k3**6) + 4*1j*D1**3*Pk2*Pk3*k1*st**2*(-3*D1*bd1*f*(r + s - 1)*(5*f**2*k1**4 + 3*f*k2**2*(K*k1**2 - 12*b1*k1**2 + k2**2*(6*C - 3)) - k2**4*(-42*K*b1 + 42*g2)) - 9*b1**2*k2**2*(D1*fd*(7*K*k2**2*(r + s) - 6*f*k1**2*(2*r + 2*s - 1)) - Dd*f*(-7*K*k2**2 + 6*f*k1**2)*(4*r + 4*s - 3)) - 3*b1*(D1*(5*f**2*fd*k1**4*(3*r + 3*s - 2) + 3*f*fd*k2**2*(K*k1**2 + k2**2*(6*C - 3))*(2*r + 2*s - 1) - 42*f*gd2*k2**4*(r + s - 1) - 42*fd*g2*k2**4*(r + s)) + Dd*f*(4*r + 4*s - 3)*(3*K*f*k1**2*k2**2 + 5*f**2*k1**4 + f*k2**4*(18*C - 9) - 42*g2*k2**4)) + f*k1**2*k2**2*(D1*(-f*fd*(10*C - 5)*(3*r + 3*s - 2) + 18*f*gd2*(r + s - 1) + 18*fd*g2*(2*r + 2*s - 1)) - Dd*f*(f*(10*C - 5) - 18*g2)*(4*r + 4*s - 3)))/(105*d*k3**6) + 1j*D1**3*Pk2*Pk3*k1*(D1*bd1*(-70*b1*k2**4*(K*b1*(3*r + 3*s - 2) + g2*(-4*r - 4*s + 2)) + 15*f**3*k1**4*(s - 1) + 3*f**2*k2**2*(k1**2*(20*C*(r + 2*s - 2) - 7*b1*(8*r + 6*s - 7) - 10*r - 25*s + 25) + k2**2*(4*C - 2)*(9*r + 7*s - 7)) + 7*f*k2**2*(6*b1**2*k1**2*(3*r + 3*s - 2) + b1*(3*k1**2*(K*(4*r + 8*s - 6) - 2*s + 1) + 2*k2**2*(-6*C*(2*r + 2*s - 1) + 10*K*(r + s - 1) + 6*r + 6*s - 3)) + 6*b2*k1**2*(r + s - 1) - 4*g2*(3*k1**2*(r + 2*s - 2) + 5*k2**2*(r + s - 1)))) + b1*(D1*(120*C*f*fd*k1**2*k2**2*r + 240*C*f*fd*k1**2*k2**2*s - 60*C*f*fd*k1**2*k2**2 + 216*C*f*fd*k2**4*r + 168*C*f*fd*k2**4*s - 108*C*f*fd*k2**4 + 42*b1**2*fd*k1**2*k2**2*(r + s - 1) - 7*b1*k2**2*(6*f*fd*k1**2*(4*r + 3*s - 2) + 3*fd*k1**2*(-2*K*(r + 2*s) + s) + 2*fd*k2**2*(6*C*(r + s - 1) - 5*K*r - 5*K*s - 3*r - 3*s + 3) - 20*gd2*k2**2*(r + s - 1)) + 42*b2*fd*k1**2*k2**2*r + 42*b2*fd*k1**2*k2**2*s + 42*bd2*f*k1**2*k2**2*(r + s - 1) + 45*f**2*fd*k1**4*s - 60*f*fd*k1**2*k2**2*r - 150*f*fd*k1**2*k2**2*s + 30*f*fd*k1**2*k2**2 - 108*f*fd*k2**4*r - 84*f*fd*k2**4*s + 54*f*fd*k2**4 - 84*f*gd2*k1**2*k2**2*r - 168*f*gd2*k1**2*k2**2*s + 84*f*gd2*k1**2*k2**2 - 140*f*gd2*k2**4*r - 140*f*gd2*k2**4*s + 140*f*gd2*k2**4 - 84*fd*g2*k1**2*k2**2*r - 168*fd*g2*k1**2*k2**2*s - 140*fd*g2*k2**4*r - 140*fd*g2*k2**4*s) + Dd*(-70*b1*k2**4*(K*b1 - 2*g2)*(4*r + 4*s - 3) + 15*f**3*k1**4*(4*s - 1) + 3*f**2*k2**2*(k1**2*(80*C*(r + 2*s - 1) - 7*b1*(16*r + 12*s - 11) - 40*r - 100*s + 45) + k2**2*(4*C - 2)*(36*r + 28*s - 25)) + 7*f*k2**2*(6*b1**2*k1**2*(4*r + 4*s - 3) + 3*b1*k1**2*(8*K*(r + 2*s - 1) - 4*s + 1) - 2*b1*k2**2*(6*C - 5*K - 3)*(4*r + 4*s - 3) + 6*b2*k1**2*(4*r + 4*s - 3) - 48*g2*k1**2*(r + 2*s - 1) - 20*g2*k2**2*(4*r + 4*s - 3)))))/(35*d*k2**2*k3**4) - 1j*D1**3*Pk2*Pk3*(D1*bd1*f*k1**2*(-15*f*k1**2*(s - 1) + f*k2**2*(12*C - 6)*(9*r + 7*s - 7) + k2**2*(70*b2 - 140*g2)*(r + s - 1)) + 35*b1**3*k1**2*k2**2*(D1*fd*(2*r + s - 2) + Dd*(-8*K*s + 2*K + f*(8*r + 4*s - 5) + 4*s - 1)) - 7*b1**2*(-D1*(5*bd1*k1**2*k2**2*(-6*K*s + 2*K + 3*f*(2*r + s - 1) + 3*s - 1) + fd*(-k1**4*s*(12*f + 3) + k1**2*k2**2*(10*K*(r + s) + s*(9 - 12*C)) + k2**4*(4 - 8*C)*(r - 1)) + 20*gd2*k1**2*k2**2*s) + Dd*(6*f**2*k1**4*(4*s - 1) + f*(3*k1**4*(4*s - 1) + k1**2*k2**2*(12*C*(4*s - 1) - 10*K*(4*r + 4*s - 3) - 36*s + 9) + k2**4*(16*C - 8)*(2*r - 1)) + 20*g2*k1**2*k2**2*(1 - 4*s))) + b1*(-7*D1*bd1*(6*f**2*k1**4*(2*s - 1) + f*(k1**4*(6*s - 3) + k1**2*k2**2*(12*C*(2*s - 1) - 20*K*(r + s - 1) - 18*s + 9) + k2**4*r*(16*C - 8)) + 20*g2*k1**2*k2**2*(1 - 2*s)) + k1**2*(2*D1*(35*bd2*f*k2**2*(r + s - 1) + 3*f*fd*(-5*k1**2*s + k2**2*(2*C - 1)*(18*r + 14*s - 9)) - 70*f*gd2*k2**2*(r + s - 1) + 35*fd*k2**2*(b2 - 2*g2)*(r + s)) + Dd*f*(-15*f*k1**2*(4*s - 1) + f*k2**2*(12*C - 6)*(36*r + 28*s - 25) + k2**2*(70*b2 - 140*g2)*(4*r + 4*s - 3)))))/(35*d*k1*k2**2*k3**2) + 1j*D1**3*Pk2*Pkd3*b1*ct*(D1*bd1*(3*f*(k1**2 + k2**2*(1 - 2*C)) + k2**2*(-5*b2 + 10*g2))*(2*r + 2*s - 1) + b1**2*(3*D1*fd*k1**2*(r + s - 1) + Dd*(-5*K*k2**2 + k1**2*(3*f + 5))*(4*r + 4*s - 3)) + b1*(D1*bd1*(-5*K*k2**2 + k1**2*(3*f + 5))*(3*r + 3*s - 2) + D1*(3*fd*(k1**2 + k2**2*(1 - 2*C)) + k2**2*(-5*bd2 + 10*gd2))*(r + s - 1) + Dd*(3*f*(k1**2 + k2**2*(1 - 2*C)) + k2**2*(-5*b2 + 10*g2))*(4*r + 4*s - 3)))/(5*d*k2*k3) + 3*1j*D1**3*Pk2*Pkd3*b1*f*k1*st**4*(2*D1*b1*fd*(r + s - 1) + D1*bd1*f*(2*r + 2*s - 1) + Dd*b1*f*(4*r + 4*s - 3))/(35*d*k3) - 1j*D1**3*Pk2*Pkd3*b1*k1*(D1*bd1*(f*(6*C - 3) - 10*g2)*(2*r + 2*s - 1) + 5*Dd*K*b1**2*(4*r + 4*s - 3) + b1*(5*D1*bd2*(r + s - 1) + D1*(5*K*bd1*(3*r + 3*s - 2) + fd*(6*C - 3)*(r + s - 1) - 10*gd2*(r + s - 1)) + Dd*(f*(6*C - 3) - 10*g2)*(4*r + 4*s - 3)) + 5*b2*(D1*bd1*(2*r + 2*s - 1) + Dd*b1*(4*r + 4*s - 3)))/(5*d*k3) + 1j*D1**3*Pk2*Pkd3*ct**7*f*k1**2*k2**3*(462*C*D1*f*fd*r + 462*C*D1*f*fd*s - 308*C*D1*f*fd + 616*C*Dd*f**2*r + 616*C*Dd*f**2*s - 462*C*Dd*f**2 + 99*D1*bd1*f*(K - 1)*(r + s - 1) + 252*D1*f**2*fd*r + 252*D1*f**2*fd*s - 189*D1*f**2*fd - 462*D1*f*fd*r - 462*D1*f*fd*s + 308*D1*f*fd - 198*D1*f*gd2*r - 198*D1*f*gd2*s + 198*D1*f*gd2 - 396*D1*fd*g2*r - 396*D1*fd*g2*s + 198*D1*fd*g2 + 252*Dd*f**3*r + 252*Dd*f**3*s - 189*Dd*f**3 - 616*Dd*f**2*r - 616*Dd*f**2*s + 462*Dd*f**2 - 792*Dd*f*g2*r - 792*Dd*f*g2*s + 594*Dd*f*g2 + 99*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))/(231*d*k3**5) + 1j*D1**3*Pk2*Pkd3*ct**6*f*k1*k2**2*(D1*bd1*f*(7*f + 9)*(r + s - 1) + b1*(D1*fd*(7*f*(3*r + 3*s - 2) + 18*r + 18*s - 9) + Dd*f*(7*f + 9)*(4*r + 4*s - 3)) + 7*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(21*d*k3**3) - 1j*D1**3*Pk2*Pkd3*ct**6*f*k1*k2**2*(-1386*C*D1*f*fd*k1**2*r - 1386*C*D1*f*fd*k1**2*s + 924*C*D1*f*fd*k1**2 - 924*C*D1*f*fd*k2**2*r - 924*C*D1*f*fd*k2**2*s + 616*C*D1*f*fd*k2**2 - 1848*C*Dd*f**2*k1**2*r - 1848*C*Dd*f**2*k1**2*s + 1386*C*Dd*f**2*k1**2 - 1232*C*Dd*f**2*k2**2*r - 1232*C*Dd*f**2*k2**2*s + 924*C*Dd*f**2*k2**2 - 11*D1*bd1*f*(k1**2*(27*K - 27) + k2**2*(18*K - 7*f - 9))*(r + s - 1) - 1008*D1*f**2*fd*k1**2*r - 1008*D1*f**2*fd*k1**2*s + 756*D1*f**2*fd*k1**2 + 1386*D1*f*fd*k1**2*r + 1386*D1*f*fd*k1**2*s - 924*D1*f*fd*k1**2 + 693*D1*f*fd*k2**2*r + 693*D1*f*fd*k2**2*s - 462*D1*f*fd*k2**2 + 594*D1*f*gd2*k1**2*r + 594*D1*f*gd2*k1**2*s - 594*D1*f*gd2*k1**2 + 396*D1*f*gd2*k2**2*r + 396*D1*f*gd2*k2**2*s - 396*D1*f*gd2*k2**2 + 1188*D1*fd*g2*k1**2*r + 1188*D1*fd*g2*k1**2*s - 594*D1*fd*g2*k1**2 + 792*D1*fd*g2*k2**2*r + 792*D1*fd*g2*k2**2*s - 396*D1*fd*g2*k2**2 - 1008*Dd*f**3*k1**2*r - 1008*Dd*f**3*k1**2*s + 756*Dd*f**3*k1**2 + 1848*Dd*f**2*k1**2*r + 1848*Dd*f**2*k1**2*s - 1386*Dd*f**2*k1**2 + 924*Dd*f**2*k2**2*r + 924*Dd*f**2*k2**2*s - 693*Dd*f**2*k2**2 + 2376*Dd*f*g2*k1**2*r + 2376*Dd*f*g2*k1**2*s - 1782*Dd*f*g2*k1**2 + 1584*Dd*f*g2*k2**2*r + 1584*Dd*f*g2*k2**2*s - 1188*Dd*f*g2*k2**2 + 11*b1*(D1*fd*(k1**2*(27 - 27*K)*(2*r + 2*s - 1) + k2**2*(7*f*(3*r + 3*s - 2) + (9 - 18*K)*(2*r + 2*s - 1))) + Dd*f*(k1**2*(27 - 27*K) + k2**2*(-18*K + 7*f + 9))*(4*r + 4*s - 3)))/(231*d*k3**5) + 1j*D1**3*Pk2*Pkd3*ct**5*f*k1**2*k2**3*st**2*(660*C*D1*f*fd*r + 660*C*D1*f*fd*s - 440*C*D1*f*fd + 880*C*Dd*f**2*r + 880*C*Dd*f**2*s - 660*C*Dd*f**2 + 198*D1*bd1*f*(K - 1)*(r + s - 1) + 588*D1*f**2*fd*r + 588*D1*f**2*fd*s - 441*D1*f**2*fd - 660*D1*f*fd*r - 660*D1*f*fd*s + 440*D1*f*fd - 396*D1*f*gd2*r - 396*D1*f*gd2*s + 396*D1*f*gd2 - 792*D1*fd*g2*r - 792*D1*fd*g2*s + 396*D1*fd*g2 + 588*Dd*f**3*r + 588*Dd*f**3*s - 441*Dd*f**3 - 880*Dd*f**2*r - 880*Dd*f**2*s + 660*Dd*f**2 - 1584*Dd*f*g2*r - 1584*Dd*f*g2*s + 1188*Dd*f*g2 + 198*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))/(231*d*k3**5) + 1j*D1**3*Pk2*Pkd3*ct**5*k2*(63*b1**2*k1**2*(K - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*(63*D1*bd1*f*k1**2*(K - 1)*(2*r + 2*s - 1) + 3*D1*(35*f**2*fd*k1**2*(4*r + 4*s - 3) + 15*f*fd*(K*k2**2*(-2*r - 2*s + 1) + k1**2*(4*C*(r + s - 1) + 2*r + 2*s + 1)) - 42*f*gd2*k1**2*(r + s - 1) - 42*fd*g2*k1**2*(r + s - 1)) + Dd*f*(4*r + 4*s - 3)*(140*f**2*k1**2 + 45*f*(-K*k2**2 + k1**2*(2*C + 1)) - 126*g2*k1**2)) + f*(D1*bd1*(35*f**2*k1**2*(4*r + 4*s - 3) + 45*f*(-K*k2**2*(r + s - 1) + k1**2*(2*C*r + 2*C*s + r + s - 3)) - 126*g2*k1**2*(r + s)) + 5*D1*(7*f*fd*(3*k1**2 + k2**2*(1 - 2*C))*(3*r + 3*s - 2) - 9*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) - 9*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + 5*Dd*f*(7*f*(3*k1**2 + k2**2*(1 - 2*C)) + k2**2*(-9*b2 + 18*g2))*(4*r + 4*s - 3)))/(105*d*k3**3) + 1j*D1**3*Pk2*Pkd3*ct**5*k2*(-33*D1*bd1*f*(r + s - 1)*(35*f**2*k1**2*k2**2 - 15*f*(K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(2*C + 6*K - 5)) + k1**2*k2**2*(-42*K*b1 + 42*b1 + 42*g2)) + 693*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) - 33*b1*(D1*(35*f**2*fd*k1**2*k2**2*(3*r + 3*s - 2) - 15*f*fd*(2*r + 2*s - 1)*(K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(2*C + 6*K - 5)) + 42*f*gd2*k1**2*k2**2*(r + s - 1) + 42*fd*g2*k1**2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(35*f**2*k1**2*k2**2 - 15*f*(K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(2*C + 6*K - 5)) + 42*g2*k1**2*k2**2)) + 5*f*(D1*(378*f**2*fd*k1**4*(4*r + 4*s - 3) + 77*f*fd*(3*r + 3*s - 2)*(k1**4*(6*C - 6) + k1**2*k2**2*(12*C - 9) + k2**4*(2*C - 1)) - 198*f*gd2*(3*k1**4 + 6*k1**2*k2**2 + k2**4)*(r + s - 1) - 198*fd*g2*(3*k1**4 + 6*k1**2*k2**2 + k2**4)*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(378*f**2*k1**4 + 77*f*(k1**4*(6*C - 6) + k1**2*k2**2*(12*C - 9) + k2**4*(2*C - 1)) - 198*g2*(3*k1**4 + 6*k1**2*k2**2 + k2**4))))/(1155*d*k3**5) + 1j*D1**3*Pk2*Pkd3*ct**4*f*k1*k2**2*st**2*(3*D1*bd1*f*(5*f + 6)*(r + s - 1) + 3*b1*(D1*fd*(5*f*(3*r + 3*s - 2) + 12*r + 12*s - 6) + Dd*f*(5*f + 6)*(4*r + 4*s - 3)) + 10*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(21*d*k3**3) - 1j*D1**3*Pk2*Pkd3*ct**4*f*k1*k2**2*st**2*(-33*D1*bd1*f*(k1**2*(54*K - 54) - k2**2*(-60*K + 25*f + 30))*(r + s - 1) + 2*D1*(-1050*f**2*fd*k1**2*(4*r + 4*s - 3) - 55*f*fd*(k1**2*(18*C - 18) + k2**2*(20*C - 15))*(3*r + 3*s - 2) + 198*f*gd2*(9*k1**2 + 10*k2**2)*(r + s - 1) + 198*fd*g2*(9*k1**2 + 10*k2**2)*(2*r + 2*s - 1)) - 2*Dd*f*(4*r + 4*s - 3)*(1050*f**2*k1**2 + 55*f*(k1**2*(18*C - 18) + k2**2*(20*C - 15)) - 198*g2*(9*k1**2 + 10*k2**2)) + 33*b1*(D1*fd*(k1**2*(54 - 54*K)*(2*r + 2*s - 1) + 5*k2**2*(5*f*(3*r + 3*s - 2) + (6 - 12*K)*(2*r + 2*s - 1))) + Dd*f*(k1**2*(54 - 54*K) + k2**2*(-60*K + 25*f + 30))*(4*r + 4*s - 3)))/(1155*d*k3**5) + 3*1j*D1**3*Pk2*Pkd3*ct**4*k1*(5*D1*bd1*f**2*(r + s) + b1**2*(D1*fd*(10*f + 7)*(r + s - 1) + Dd*f*(5*f + 7)*(4*r + 4*s - 3)) + b1*f*(D1*bd1*(5*f + 7)*(2*r + 2*s - 1) + 10*D1*fd*(r + s - 1) + 5*Dd*f*(4*r + 4*s - 3)))/(35*d*k3) + 1j*D1**3*Pk2*Pkd3*ct**4*k1*(9*b1**2*(D1*fd*(k1**2*(7*K - 7)*(r + s - 1) + k2**2*(14*K*(r + s - 1) + 5*f + 7)) + 7*Dd*f*(2*K*k2**2 + k1**2*(K - 1))*(4*r + 4*s - 3)) + b1*(-9*D1*bd1*f*(-k1**2*(7*K - 7)*(2*r + 2*s - 1) + k2**2*(7*K*(-4*r - 4*s + 2) + 5*f + 7)) + 3*D1*(35*f**2*fd*k1**2*(5*r + 5*s - 4) + 15*f*fd*(k1**2*(4*C*(r + s - 1) + 2*r + 2*s + 1) + k2**2*(8*C*(r + s - 1) + K*(-6*r - 6*s + 3) - 4*r - 4*s + 5)) - 42*f*gd2*(k1**2 + 2*k2**2)*(r + s - 1) - 42*fd*g2*(k1**2 + 2*k2**2)*(r + s - 1)) + Dd*f*(4*r + 4*s - 3)*(175*f**2*k1**2 + 45*f*(k1**2*(2*C + 1) + k2**2*(4*C - 3*K - 2)) - 126*g2*(k1**2 + 2*k2**2))) + f*(D1*bd1*(35*f**2*k1**2*(5*r + 5*s - 3) + 45*f*(k1**2*(2*C*r + 2*C*s + r + s - 3) - k2**2*(-4*C*r - 4*C*s + 3*K*(r + s - 1) + 2*r + 2*s + 1)) - 126*g2*(k1**2 + 2*k2**2)*(r + s)) + 15*D1*(7*f*fd*(k1**2 + k2**2*(1 - 2*C))*(3*r + 3*s - 2) - 9*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) - 9*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + 15*Dd*f*(7*f*(k1**2 + k2**2*(1 - 2*C)) + k2**2*(-9*b2 + 18*g2))*(4*r + 4*s - 3)))/(105*d*k3**3) - 1j*D1**3*Pk2*Pkd3*ct**4*k1*(11*D1*bd1*f*(r + s - 1)*(70*f**2*k1**2*k2**2 - 45*f*(k1**4*(K - 1) + k1**2*k2**2*(6*C + 6*K - 9) + k2**4*(4*C + 3*K - 2*b1 - 3)) + 126*k2**2*(-3*b1*k1**2*(K - 1) + b1*k2**2*(1 - 2*K) + g2*(3*k1**2 + 2*k2**2))) + 99*b1**2*k2**2*(D1*fd*(5*f*k2**2*(2*r + 2*s - 1) + (r + s)*(-7*k1**2*(3*K - 3) - 7*k2**2*(2*K - 1))) + Dd*f*(k1**2*(21 - 21*K) + k2**2*(-14*K + 5*f + 7))*(4*r + 4*s - 3)) + 11*b1*(D1*(70*f**2*fd*k1**2*k2**2*(3*r + 3*s - 2) - 45*f*fd*(2*r + 2*s - 1)*(k1**4*(K - 1) + k1**2*k2**2*(6*C + 6*K - 9) + k2**4*(4*C + 3*K - 3)) + 126*f*gd2*k2**2*(3*k1**2 + 2*k2**2)*(r + s - 1) + 126*fd*g2*k2**2*(3*k1**2 + 2*k2**2)*(r + s)) + Dd*f*(4*r + 4*s - 3)*(70*f**2*k1**2*k2**2 - 45*f*(k1**4*(K - 1) + k1**2*k2**2*(6*C + 6*K - 9) + k2**4*(4*C + 3*K - 3)) + 126*g2*k2**2*(3*k1**2 + 2*k2**2))) - 5*f*(D1*(252*f**2*fd*k1**4*(4*r + 4*s - 3) + 77*f*fd*(3*r + 3*s - 2)*(k1**4*(2*C - 2) + k1**2*k2**2*(12*C - 9) + k2**4*(6*C - 3)) - 198*f*gd2*(k1**4 + 6*k1**2*k2**2 + 3*k2**4)*(r + s - 1) - 198*fd*g2*(k1**4 + 6*k1**2*k2**2 + 3*k2**4)*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(252*f**2*k1**4 + 77*f*(k1**4*(2*C - 2) + k1**2*k2**2*(12*C - 9) + k2**4*(6*C - 3)) - 198*g2*(k1**4 + 6*k1**2*k2**2 + 3*k2**4))))/(1155*d*k3**5) + 1j*D1**3*Pk2*Pkd3*ct**3*f*k1**2*k2**3*st**4*(66*C*D1*f*fd*r + 66*C*D1*f*fd*s - 44*C*D1*f*fd + 88*C*Dd*f**2*r + 88*C*Dd*f**2*s - 66*C*Dd*f**2 + 33*D1*bd1*f*(K - 1)*(r + s - 1) + 140*D1*f**2*fd*r + 140*D1*f**2*fd*s - 105*D1*f**2*fd - 66*D1*f*fd*r - 66*D1*f*fd*s + 44*D1*f*fd - 66*D1*f*gd2*r - 66*D1*f*gd2*s + 66*D1*f*gd2 - 132*D1*fd*g2*r - 132*D1*fd*g2*s + 66*D1*fd*g2 + 140*Dd*f**3*r + 140*Dd*f**3*s - 105*Dd*f**3 - 88*Dd*f**2*r - 88*Dd*f**2*s + 66*Dd*f**2 - 264*Dd*f*g2*r - 264*Dd*f*g2*s + 198*Dd*f*g2 + 33*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))/(77*d*k3**5) + 1j*D1**3*Pk2*Pkd3*ct**3*k2*st**2*(63*b1**2*k1**2*(K - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*(63*D1*bd1*f*k1**2*(K - 1)*(2*r + 2*s - 1) + 6*D1*(25*f**2*fd*k1**2*(4*r + 4*s - 3) + 3*f*(-5*K*fd*k2**2*(2*r + 2*s - 1) + 3*fd*k1**2*(2*C*(r + s - 1) + 4*r + 4*s - 1) - 7*gd2*k1**2*(r + s - 1)) - 21*fd*g2*k1**2*(r + s - 1)) + 2*Dd*f*(4*r + 4*s - 3)*(100*f**2*k1**2 + 9*f*(-5*K*k2**2 + k1**2*(3*C + 6)) - 63*g2*k1**2)) + 2*f*(D1*bd1*(25*f**2*k1**2*(4*r + 4*s - 3) + 9*f*(-5*K*k2**2*(r + s - 1) + 3*k1**2*(r*(C + 2) + s*(C + 2) - 3)) - 63*g2*k1**2*(r + s)) + 5*D1*(f*fd*(9*k1**2 + k2**2*(5 - 10*C))*(3*r + 3*s - 2) - 9*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) - 9*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + 5*Dd*f*(4*r + 4*s - 3)*(9*f*k1**2 + f*k2**2*(5 - 10*C) - k2**2*(9*b2 - 18*g2))))/(105*d*k3**3) + 1j*D1**3*Pk2*Pkd3*ct**3*k2*st**2*(-33*D1*bd1*f*(r + s - 1)*(50*f**2*k1**2*k2**2 - 3*f*(10*K*k2**4 + k1**4*(9*K - 9) + k1**2*k2**2*(6*C + 36*K - 24)) + k1**2*k2**2*(-42*K*b1 + 42*b1 + 42*g2)) + 693*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) - 33*b1*(D1*(50*f**2*fd*k1**2*k2**2*(3*r + 3*s - 2) - 3*f*fd*(2*r + 2*s - 1)*(10*K*k2**4 + k1**4*(9*K - 9) + k1**2*k2**2*(6*C + 36*K - 24)) + 42*f*gd2*k1**2*k2**2*(r + s - 1) + 42*fd*g2*k1**2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(50*f**2*k1**2*k2**2 - 3*f*(10*K*k2**4 + k1**4*(9*K - 9) + k1**2*k2**2*(6*C + 36*K - 24)) + 42*g2*k1**2*k2**2)) + 2*f*(D1*(1050*f**2*fd*k1**4*(4*r + 4*s - 3) + 55*f*fd*(3*r + 3*s - 2)*(k1**4*(9*C - 9) + k1**2*k2**2*(36*C - 27) + k2**4*(10*C - 5)) - 99*f*gd2*(9*k1**4 + 36*k1**2*k2**2 + 10*k2**4)*(r + s - 1) - 99*fd*g2*(9*k1**4 + 36*k1**2*k2**2 + 10*k2**4)*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(1050*f**2*k1**4 + 55*f*(k1**4*(9*C - 9) + k1**2*k2**2*(36*C - 27) + k2**4*(10*C - 5)) - 99*g2*(9*k1**4 + 36*k1**2*k2**2 + 10*k2**4))))/(1155*d*k3**5) + 3*1j*D1**3*Pk2*Pkd3*ct**3*(D1*bd1*f*(r + s)*(5*f*(k1**2 + k2**2*(1 - 2*C)) + k2**2*(-7*b2 + 14*g2)) + b1**2*(D1*fd*(-7*K*k2**2 + k1**2*(10*f + 7))*(r + s - 1) + Dd*f*(-7*K*k2**2 + k1**2*(5*f + 7))*(4*r + 4*s - 3)) + b1*(D1*bd1*f*(-7*K*k2**2 + k1**2*(5*f + 7))*(2*r + 2*s - 1) + D1*(r + s - 1)*(10*f*fd*(k1**2 + k2**2*(1 - 2*C)) - 7*f*k2**2*(bd2 - 2*gd2) - 7*fd*k2**2*(b2 - 2*g2)) + Dd*f*(5*f*(k1**2 + k2**2*(1 - 2*C)) + k2**2*(-7*b2 + 14*g2))*(4*r + 4*s - 3)))/(35*d*k2*k3) + 1j*D1**3*Pk2*Pkd3*ct**3*(D1*bd1*(105*b1*k1**2*k2**2*(b1*(K - 1)*(3*r + 3*s - 2) - 2*g2*(2*r + 2*s - 1)) + 35*f**3*k1**4*(2*r + 2*s - 1) + 45*f**2*(k1**4*(r + s - 1) + k1**2*k2**2*(4*C*r + 4*C*s - 3*K*(r + s - 1) + b1*(4*r + 4*s - 5) - 3) + k2**4*(2*C - 1)) + 63*f*k2**2*(b1*(K*k2**2 + k1**2*(C*(4*r + 4*s - 2) + K*(4*r + 4*s - 2) - 3)) - b2*k2**2*(r + s - 1) - 2*g2*(2*k1**2*(r + s) + k2**2))) + 105*Dd*b1**3*k1**2*k2**2*(K - 1)*(4*r + 4*s - 3) + 3*b1**2*k2**2*(42*C*k1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + 3*D1*fd*(-7*K*k2**2 + k1**2*(14*K*(r + s - 1) + 5*f*(4*r + 4*s - 1) + 21)) - 70*D1*gd2*k1**2*(r + s - 1) + 2*Dd*k1**2*(4*r + 4*s - 3)*(21*K*f + 15*f**2 - 35*g2)) + b1*(D1*(35*f**2*fd*k1**4*(6*r + 6*s - 5) + 9*f*(5*fd*(k1**4*(2*r + 2*s - 1) + k1**2*k2**2*(8*C*(r + s - 1) + K*(-6*r - 6*s + 3) + 3) + k2**4*(1 - 2*C)) - 7*k2**2*(bd2*k2**2 + 4*gd2*k1**2)*(r + s - 1)) - 63*fd*k2**2*(b2*k2**2*(r + s) + 4*g2*k1**2*(r + s - 1) - 2*g2*k2**2)) + Dd*f*(4*r + 4*s - 3)*(-63*b2*k2**4 + 70*f**2*k1**4 + 45*f*(k1**4 + k1**2*k2**2*(4*C - 3*K)) - 252*g2*k1**2*k2**2)) + 5*f*k1**2*(D1*(7*f*fd*(k1**2 + k2**2*(3 - 6*C))*(3*r + 3*s - 2) - 27*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) - 27*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + Dd*f*(7*f*(k1**2 + k2**2*(3 - 6*C)) + k2**2*(-27*b2 + 54*g2))*(4*r + 4*s - 3)))/(105*d*k2*k3**3) - 1j*D1**3*Pk2*Pkd3*ct**3*(D1*(-693*b1*fd*k2**2*(r + s)*(b1*(K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(6*K - 3)) - 2*g2*(3*k1**4 + 6*k1**2*k2**2 + k2**4)) - 35*f**3*k1**4*(22*bd1*k2**2*(r + s - 1) + 9*fd*k1**2*(4*r + 4*s - 3)) - 55*f**2*k2**2*(9*bd1*(r + s - 1)*(k1**4*(6*C + 2*K - 7) + k1**2*k2**2*(12*C + 3*K - 8*b1 - 9) + k2**4*(2*C - 1)) + k1**2*(7*fd*(k1**2*(4*C + 2*b1 - 3) + k2**2*(6*C - 3))*(3*r + 3*s - 2) - 18*gd2*(2*k1**2 + 3*k2**2)*(r + s - 1))) + 99*f*k2**2*(20*b1**2*fd*k1**2*k2**2*(2*r + 2*s - 1) + b1*(-14*bd1*(r + s - 1)*(K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(6*K - 3)) - 5*fd*(2*r + 2*s - 1)*(k1**4*(6*C + 2*K - 7) + k1**2*k2**2*(12*C + 3*K - 9) + k2**4*(2*C - 1)) + 14*gd2*(3*k1**4 + 6*k1**2*k2**2 + k2**4)*(r + s - 1)) + 2*g2*(7*bd1*(3*k1**4 + 6*k1**2*k2**2 + k2**4)*(r + s - 1) + 5*fd*k1**2*(2*k1**2 + 3*k2**2)*(2*r + 2*s - 1)))) - Dd*f*(4*r + 4*s - 3)*(693*b1*k2**2*(b1*(K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(6*K - 3)) - 2*g2*(3*k1**4 + 6*k1**2*k2**2 + k2**4)) + 315*f**3*k1**6 + 385*f**2*(k1**4*k2**2*(4*C + 2*b1 - 3) + k1**2*k2**4*(6*C - 3)) - 495*f*k2**2*(4*b1**2*k1**2*k2**2 + b1*(k1**4*(-6*C - 2*K + 7) - k1**2*k2**2*(12*C + 3*K - 9) + k2**4*(1 - 2*C)) + 4*g2*k1**4 + 6*g2*k1**2*k2**2)))/(1155*d*k2*k3**5) + 1j*D1**3*Pk2*Pkd3*ct**2*f*k1*k2**2*st**4*(3*D1*bd1*f*(f + 1)*(r + s - 1) + 3*b1*(D1*fd*(f*(3*r + 3*s - 2) + 2*r + 2*s - 1) + Dd*f*(f + 1)*(4*r + 4*s - 3)) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(7*d*k3**3) - 1j*D1**3*Pk2*Pkd3*ct**2*f*k1*k2**2*st**4*(-198*C*D1*f*fd*k1**2*r - 198*C*D1*f*fd*k1**2*s + 132*C*D1*f*fd*k1**2 - 660*C*D1*f*fd*k2**2*r - 660*C*D1*f*fd*k2**2*s + 440*C*D1*f*fd*k2**2 - 264*C*Dd*f**2*k1**2*r - 264*C*Dd*f**2*k1**2*s + 198*C*Dd*f**2*k1**2 - 880*C*Dd*f**2*k2**2*r - 880*C*Dd*f**2*k2**2*s + 660*C*Dd*f**2*k2**2 - 33*D1*bd1*f*(k1**2*(3*K - 3) - k2**2*(-10*K + 5*f + 5))*(r + s - 1) - 1200*D1*f**2*fd*k1**2*r - 1200*D1*f**2*fd*k1**2*s + 900*D1*f**2*fd*k1**2 + 198*D1*f*fd*k1**2*r + 198*D1*f*fd*k1**2*s - 132*D1*f*fd*k1**2 + 495*D1*f*fd*k2**2*r + 495*D1*f*fd*k2**2*s - 330*D1*f*fd*k2**2 + 198*D1*f*gd2*k1**2*r + 198*D1*f*gd2*k1**2*s - 198*D1*f*gd2*k1**2 + 660*D1*f*gd2*k2**2*r + 660*D1*f*gd2*k2**2*s - 660*D1*f*gd2*k2**2 + 396*D1*fd*g2*k1**2*r + 396*D1*fd*g2*k1**2*s - 198*D1*fd*g2*k1**2 + 1320*D1*fd*g2*k2**2*r + 1320*D1*fd*g2*k2**2*s - 660*D1*fd*g2*k2**2 - 1200*Dd*f**3*k1**2*r - 1200*Dd*f**3*k1**2*s + 900*Dd*f**3*k1**2 + 264*Dd*f**2*k1**2*r + 264*Dd*f**2*k1**2*s - 198*Dd*f**2*k1**2 + 660*Dd*f**2*k2**2*r + 660*Dd*f**2*k2**2*s - 495*Dd*f**2*k2**2 + 792*Dd*f*g2*k1**2*r + 792*Dd*f*g2*k1**2*s - 594*Dd*f*g2*k1**2 + 2640*Dd*f*g2*k2**2*r + 2640*Dd*f*g2*k2**2*s - 1980*Dd*f*g2*k2**2 + 33*b1*(D1*fd*(k1**2*(3 - 3*K)*(2*r + 2*s - 1) + 5*k2**2*(f*(3*r + 3*s - 2) - (2*K - 1)*(2*r + 2*s - 1))) + Dd*f*(k1**2*(3 - 3*K) + k2**2*(-10*K + 5*f + 5))*(4*r + 4*s - 3)))/(385*d*k3**5) + 3*1j*D1**3*Pk2*Pkd3*ct**2*k1*st**2*(3*D1*bd1*f**2*(r + s) + b1**2*(D1*fd*(12*f + 7)*(r + s - 1) + Dd*f*(6*f + 7)*(4*r + 4*s - 3)) + b1*f*(D1*bd1*(6*f + 7)*(2*r + 2*s - 1) + 6*D1*fd*(r + s - 1) + 3*Dd*f*(4*r + 4*s - 3)))/(35*d*k3) + 1j*D1**3*Pk2*Pkd3*ct**2*k1*(-3*D1*bd1*f*(r + s)*(7*b2 + f*(10*C - 5) - 14*g2) + 7*b1**3*(3*D1*fd*(r + s - 1) + Dd*(3*f + 5)*(4*r + 4*s - 3)) + 7*b1**2*(D1*bd1*(3*f + 5)*(3*r + 3*s - 2) - (3*K - 3)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))) - 3*b1*(20*C*D1*f*fd*r + 20*C*D1*f*fd*s - 20*C*D1*f*fd + 40*C*Dd*f**2*r + 40*C*Dd*f**2*s - 30*C*Dd*f**2 + 7*D1*b2*fd*r + 7*D1*b2*fd*s - 7*D1*b2*fd + 7*D1*bd1*f*(K - 1)*(2*r + 2*s - 1) + 7*D1*bd2*f*(r + s - 1) - 10*D1*f*fd*r - 10*D1*f*fd*s + 10*D1*f*fd - 14*D1*f*gd2*r - 14*D1*f*gd2*s + 14*D1*f*gd2 - 14*D1*fd*g2*r - 14*D1*fd*g2*s + 14*D1*fd*g2 + 28*Dd*b2*f*r + 28*Dd*b2*f*s - 21*Dd*b2*f - 20*Dd*f**2*r - 20*Dd*f**2*s + 15*Dd*f**2 - 56*Dd*f*g2*r - 56*Dd*f*g2*s + 42*Dd*f*g2))/(35*d*k3) + 1j*D1**3*Pk2*Pkd3*ct**2*k1*st**2*(b1**2*(D1*fd*(k1**2*(7*K - 7)*(r + s - 1) + 3*k2**2*(14*K*(r + s - 1) + 6*f + 7)) + 7*Dd*f*(6*K*k2**2 + k1**2*(K - 1))*(4*r + 4*s - 3)) - b1*(D1*bd1*f*(-k1**2*(7*K - 7)*(2*r + 2*s - 1) + 3*k2**2*(7*K*(-4*r - 4*s + 2) + 6*f + 7)) + D1*(-30*f**2*fd*k1**2*(5*r + 5*s - 4) - 3*f*fd*(k1**2*(4*C*(r + s - 1) + 14*r + 14*s - 5) + 3*k2**2*(8*C*(r + s - 1) - 6*K*(2*r + 2*s - 1) - 4*r - 4*s + 5)) + 14*f*gd2*(k1**2 + 6*k2**2)*(r + s - 1) + 14*fd*g2*(k1**2 + 6*k2**2)*(r + s - 1)) - Dd*f*(4*r + 4*s - 3)*(50*f**2*k1**2 + 3*f*(k1**2*(2*C + 7) + k2**2*(12*C - 18*K - 6)) - 14*g2*(k1**2 + 6*k2**2))) + f*(D1*bd1*(10*f**2*k1**2*(5*r + 5*s - 3) + 3*f*k1**2*(r*(2*C + 7) + s*(2*C + 7) - 9) - 9*f*k2**2*(-4*C*s + 6*K*(r + s - 1) + r*(2 - 4*C) + 2*s + 1) - 14*g2*(k1**2 + 6*k2**2)*(r + s)) + 3*D1*(5*f*fd*(k1**2 + k2**2*(2 - 4*C))*(3*r + 3*s - 2) - 18*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) - 18*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + 3*Dd*f*(5*f*(k1**2 + k2**2*(2 - 4*C)) + k2**2*(-18*b2 + 36*g2))*(4*r + 4*s - 3)))/(35*d*k3**3) - 1j*D1**3*Pk2*Pkd3*ct**2*k1*(-3*D1*b1*bd1*(15*f**2*k1**2*(8*r + 8*s - 7) + 21*f*(2*k1**2*(C*(2*r + 2*s - 1) + r + s - 2) + k2**2*(C*(8*r + 8*s - 4) + K*(-4*r - 4*s + 5) - 6*r - 6*s + 3)) - 70*g2*(k1**2 + 2*k2**2)*(2*r + 2*s - 1)) - 21*b1**3*(-3*D1*fd*k2**2*(r + s - 1) + Dd*(k1**2*(5*K - 5) + k2**2*(10*K - 3*f - 5))*(4*r + 4*s - 3)) - 3*b1**2*(7*D1*bd1*(k1**2*(5*K - 5) + k2**2*(10*K - 3*f - 5))*(3*r + 3*s - 2) + D1*(3*fd*(k1**2*(14*C*(r + s - 1) + 5*f*(8*r + 8*s - 5) + 7*r + 7*s + 14) - 7*k2**2*(-4*C*(r + s - 1) + K*(2*r + 2*s + 1) + 3*r + 3*s - 3)) - 70*gd2*(k1**2 + 2*k2**2)*(r + s - 1)) + Dd*(4*r + 4*s - 3)*(60*f**2*k1**2 + 21*f*(k1**2*(2*C + 1) + k2**2*(4*C - 2*K - 3)) - 70*g2*(k1**2 + 2*k2**2))) + 9*b1*(D1*(f*(5*fd*(k1**2*(K - 3)*(2*r + 2*s - 1) + k2**2*(2*C - 1)*(4*r + 4*s - 1)) + k2**2*(21*bd2 - 28*gd2)*(r + s - 1)) - 7*fd*k2**2*(-3*b2*(r + s) + g2*(4*r + 4*s + 2))) + Dd*f*(5*f*(k1**2*(K - 3) + k2**2*(4*C - 2)) + k2**2*(21*b2 - 28*g2))*(4*r + 4*s - 3)) + f*(9*D1*bd1*(5*f*(k1**2*(K - 3)*(r + s - 1) + k2**2*(2*C - 1)*(2*r + 2*s - 3)) + 7*k2**2*(3*b2*(r + s - 1) - 2*g2*(2*r + 2*s - 3))) + 5*k1**2*(42*C*D1*f*fd*r + 42*C*D1*f*fd*s - 28*C*D1*f*fd + 56*C*Dd*f**2*r + 56*C*Dd*f**2*s - 42*C*Dd*f**2 + 9*D1*bd2*f*(r + s - 1) - 21*D1*f*fd*r - 21*D1*f*fd*s + 14*D1*f*fd - 18*D1*f*gd2*r - 18*D1*f*gd2*s + 18*D1*f*gd2 - 36*D1*fd*g2*r - 36*D1*fd*g2*s + 18*D1*fd*g2 - 28*Dd*f**2*r - 28*Dd*f**2*s + 21*Dd*f**2 - 72*Dd*f*g2*r - 72*Dd*f*g2*s + 54*Dd*f*g2 + 9*b2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))))/(105*d*k3**3) - 1j*D1**3*Pk2*Pkd3*ct**2*k1*st**2*(33*D1*bd1*f*(r + s - 1)*(20*f**2*k1**2*k2**2 - 3*f*(k1**4*(K - 1) + k1**2*k2**2*(6*C + 18*K - 15) + k2**4*(12*C + 18*K - 12*b1 - 9)) - 42*k2**2*(b1*k1**2*(K - 1) + b1*k2**2*(2*K - 1) - g2*(k1**2 + 2*k2**2))) + 99*b1**2*k2**2*(D1*fd*(6*f*k2**2*(2*r + 2*s - 1) + (r + s)*(-7*k1**2*(K - 1) - 7*k2**2*(2*K - 1))) + Dd*f*(k1**2*(7 - 7*K) + k2**2*(-14*K + 6*f + 7))*(4*r + 4*s - 3)) + 33*b1*(D1*(20*f**2*fd*k1**2*k2**2*(3*r + 3*s - 2) - 3*f*fd*(2*r + 2*s - 1)*(k1**4*(K - 1) + k1**2*k2**2*(6*C + 18*K - 15) + k2**4*(12*C + 18*K - 9)) + 42*f*gd2*k2**2*(k1**2 + 2*k2**2)*(r + s - 1) + 42*fd*g2*k2**2*(k1**2 + 2*k2**2)*(r + s)) + Dd*f*(4*r + 4*s - 3)*(20*f**2*k1**2*k2**2 - 3*f*(k1**4*(K - 1) + k1**2*k2**2*(6*C + 18*K - 15) + k2**4*(12*C + 18*K - 9)) + 42*g2*k2**2*(k1**2 + 2*k2**2))) + f*(D1*(-840*f**2*fd*k1**4*(4*r + 4*s - 3) - 55*f*fd*(3*r + 3*s - 2)*(k1**4*(2*C - 2) + k1**2*k2**2*(36*C - 27) + k2**4*(36*C - 18)) + 198*f*gd2*(k1**4 + 18*k1**2*k2**2 + 18*k2**4)*(r + s - 1) + 198*fd*g2*(k1**4 + 18*k1**2*k2**2 + 18*k2**4)*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(840*f**2*k1**4 + 55*f*(k1**4*(2*C - 2) + k1**2*k2**2*(36*C - 27) + k2**4*(36*C - 18)) - 198*g2*(k1**4 + 18*k1**2*k2**2 + 18*k2**4))))/(1155*d*k3**5) - 1j*D1**3*Pk2*Pkd3*ct**2*k1*(9*b1**2*(D1*fd*(30*f*k1**2*k2**2*(2*r + 2*s - 1) + (r + s)*(-21*K*k2**4 - 7*k1**4*(K - 1) - 7*k1**2*k2**2*(6*K - 3))) + Dd*f*(4*r + 4*s - 3)*(-21*K*k2**4 + k1**4*(7 - 7*K) + k1**2*k2**2*(-42*K + 30*f + 21))) + 3*b1*(-6*D1*bd1*f*(r + s - 1)*(21*K*k2**4 + k1**4*(7*K - 7) - k1**2*k2**2*(-42*K + 30*f + 21)) + D1*(-35*f**2*fd*k1**4*(3*r + 3*s - 2) - 15*f*fd*(2*r + 2*s - 1)*(k1**4*(2*C - 2) + k1**2*k2**2*(12*C + K - 9) + k2**4*(6*C - 3)) + 42*f*gd2*(k1**4 + 6*k1**2*k2**2 + 3*k2**4)*(r + s - 1) + 42*fd*g2*(r + s)*(k1**4 + 6*k1**2*k2**2 + 3*k2**4)) - Dd*f*(4*r + 4*s - 3)*(35*f**2*k1**4 + 15*f*(k1**4*(2*C - 2) + k1**2*k2**2*(12*C + K - 9) + k2**4*(6*C - 3)) - 42*g2*(k1**4 + 6*k1**2*k2**2 + 3*k2**4))) + f*(-3*D1*bd1*(r + s - 1)*(35*f**2*k1**4 + 15*f*(k1**4*(2*C - 2) + k1**2*k2**2*(12*C + K - 9) + k2**4*(6*C - 3)) - 42*g2*(k1**4 + 6*k1**2*k2**2 + 3*k2**4)) - 5*k1**2*k2**2*(D1*(f*fd*(14*C - 7)*(3*r + 3*s - 2) - 18*f*gd2*(r + s - 1) - 18*fd*g2*(2*r + 2*s - 1)) + Dd*f*(f*(14*C - 7) - 18*g2)*(4*r + 4*s - 3))))/(105*d*k3**5) + 1j*D1**3*Pk2*Pkd3*ct*f**3*k1**2*k2**3*st**6*(D1*fd + Dd*f)*(4*r + 4*s - 3)/(11*d*k3**5) + 1j*D1**3*Pk2*Pkd3*ct*f*k2*st**4*(-30*C*D1*f*fd*k2**2*r - 30*C*D1*f*fd*k2**2*s + 20*C*D1*f*fd*k2**2 - 40*C*Dd*f**2*k2**2*r - 40*C*Dd*f**2*k2**2*s + 30*C*Dd*f**2*k2**2 + 3*D1*b1*fd*(-5*K*k2**2*(2*r + 2*s - 1) + k1**2*(5*f*(4*r + 4*s - 3) + 6*r + 6*s - 3)) - 30*D1*b2*fd*k2**2*r - 30*D1*b2*fd*k2**2*s + 15*D1*b2*fd*k2**2 + D1*bd1*f*(-15*K*k2**2*(r + s - 1) + k1**2*(5*f*(4*r + 4*s - 3) + 9*r + 9*s - 9)) - 15*D1*bd2*f*k2**2*r - 15*D1*bd2*f*k2**2*s + 15*D1*bd2*f*k2**2 + 9*D1*f*fd*k1**2*r + 9*D1*f*fd*k1**2*s - 6*D1*f*fd*k1**2 + 15*D1*f*fd*k2**2*r + 15*D1*f*fd*k2**2*s - 10*D1*f*fd*k2**2 + 30*D1*f*gd2*k2**2*r + 30*D1*f*gd2*k2**2*s - 30*D1*f*gd2*k2**2 + 60*D1*fd*g2*k2**2*r + 60*D1*fd*g2*k2**2*s - 30*D1*fd*g2*k2**2 + Dd*b1*f*(-15*K*k2**2 + k1**2*(20*f + 9))*(4*r + 4*s - 3) - 60*Dd*b2*f*k2**2*r - 60*Dd*b2*f*k2**2*s + 45*Dd*b2*f*k2**2 + 12*Dd*f**2*k1**2*r + 12*Dd*f**2*k1**2*s - 9*Dd*f**2*k1**2 + 20*Dd*f**2*k2**2*r + 20*Dd*f**2*k2**2*s - 15*Dd*f**2*k2**2 + 120*Dd*f*g2*k2**2*r + 120*Dd*f*g2*k2**2*s - 90*Dd*f*g2*k2**2)/(35*d*k3**3) - 1j*D1**3*Pk2*Pkd3*ct*f*k2*st**4*(D1*(-15*f**2*k1**2*(-11*bd1*k2**2*(r + s - 1) + 10*fd*k1**2*(4*r + 4*s - 3)) - 11*f*k2**2*(3*bd1*(5*K*k2**2 + k1**2*(6*K - 3))*(r + s - 1) - fd*(k1**2*(-12*C + 15*b1 + 9) + k2**2*(5 - 10*C))*(3*r + 3*s - 2) - 6*gd2*(6*k1**2 + 5*k2**2)*(r + s - 1)) - 33*fd*k2**2*(2*r + 2*s - 1)*(5*K*b1*k2**2 + b1*k1**2*(6*K - 3) - 2*g2*(6*k1**2 + 5*k2**2))) - Dd*f*(4*r + 4*s - 3)*(150*f**2*k1**4 - 11*f*(k1**2*k2**2*(-12*C + 15*b1 + 9) + k2**4*(5 - 10*C)) + 33*k2**2*(5*K*b1*k2**2 + b1*k1**2*(6*K - 3) - 2*g2*(6*k1**2 + 5*k2**2))))/(385*d*k3**5) - 1j*D1**3*Pk2*Pkd3*ct*k1**2*(-D1*bd1*f*(r + s - 1)*(35*f**2*k1**4 + 45*f*k2**2*(k1**2*(4*C - 8*b1 - 3) + k2**2*(6*C - 3)) + 126*k2**2*(3*K*b1*k2**2 + b1*k1**2*(2*K - 1) - g2*(2*k1**2 + 3*k2**2))) + b1*(D1*(-35*f**2*fd*k1**4*(3*r + 3*s - 2) + 9*f*k2**2*(5*fd*(k1**2*(-4*C + 4*b1 + 3) + k2**2*(3 - 6*C))*(2*r + 2*s - 1) + 14*gd2*(2*k1**2 + 3*k2**2)*(r + s - 1)) - 63*fd*k2**2*(r + s)*(3*K*b1*k2**2 + b1*k1**2*(2*K - 1) - 2*g2*(2*k1**2 + 3*k2**2))) - Dd*f*(4*r + 4*s - 3)*(35*f**2*k1**4 + 45*f*k2**2*(k1**2*(4*C - 4*b1 - 3) + k2**2*(6*C - 3)) + 63*k2**2*(3*K*b1*k2**2 + b1*k1**2*(2*K - 1) - 2*g2*(2*k1**2 + 3*k2**2)))))/(105*d*k2*k3**5) + 1j*D1**3*Pk2*Pkd3*ct*st**2*(3*D1*bd1*f*(r + s)*(f*(k1**2 + k2**2*(3 - 6*C)) + k2**2*(-7*b2 + 14*g2)) + b1**2*(D1*fd*(-21*K*k2**2 + k1**2*(18*f + 7))*(r + s - 1) + Dd*f*(-21*K*k2**2 + k1**2*(9*f + 7))*(4*r + 4*s - 3)) + b1*(D1*bd1*f*(-21*K*k2**2 + k1**2*(9*f + 7))*(2*r + 2*s - 1) + 3*D1*(r + s - 1)*(2*f*fd*(k1**2 + k2**2*(3 - 6*C)) - 7*f*k2**2*(bd2 - 2*gd2) - 7*fd*k2**2*(b2 - 2*g2)) + 3*Dd*f*(f*(k1**2 + k2**2*(3 - 6*C)) + k2**2*(-7*b2 + 14*g2))*(4*r + 4*s - 3)))/(35*d*k2*k3) + 1j*D1**3*Pk2*Pkd3*ct*st**2*(3*D1*bd1*f*(5*f**2*k1**4*(2*r + 2*s - 1) + 3*f*(k1**4*(r + s - 1) + k1**2*k2**2*(4*C*r + 4*C*s - 9*K*(r + s - 1) + 3*b1*(4*r + 4*s - 5) - 3) + k2**4*(6*C - 3)) + 7*k2**2*(3*K*b1*k2**2 + b1*k1**2*(K*(4*r + 4*s - 2) + 4*r + 4*s - 5) - 3*b2*k2**2*(r + s - 1) - 4*g2*k1**2*(r + s) - 6*g2*k2**2)) + 3*b1**2*k2**2*(D1*fd*(-21*K*k2**2 + k1**2*(14*K*(r + s - 1) + 9*f*(4*r + 4*s - 1) + 14*r + 14*s + 7)) + 2*Dd*f*k1**2*(7*K + 9*f + 7)*(4*r + 4*s - 3)) + 3*b1*(D1*(5*f**2*fd*k1**4*(6*r + 6*s - 5) + f*(3*fd*(k1**4*(2*r + 2*s - 1) + k1**2*k2**2*(8*C*(r + s - 1) - 9*K*(2*r + 2*s - 1) + 3) + k2**4*(3 - 6*C)) - 7*k2**2*(3*bd2*k2**2 + 4*gd2*k1**2)*(r + s - 1)) - 7*fd*k2**2*(3*b2*k2**2*(r + s) + 4*g2*k1**2*(r + s - 1) - 6*g2*k2**2)) + Dd*f*(4*r + 4*s - 3)*(-21*b2*k2**4 + 10*f**2*k1**4 + 3*f*(k1**4 + k1**2*k2**2*(4*C - 9*K)) - 28*g2*k1**2*k2**2)) + f*k1**2*(D1*(5*f*fd*(k1**2 + k2**2*(9 - 18*C))*(3*r + 3*s - 2) - 81*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) - 81*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + Dd*f*(5*f*(k1**2 + k2**2*(9 - 18*C)) + k2**2*(-81*b2 + 162*g2))*(4*r + 4*s - 3)))/(105*d*k2*k3**3) - 1j*D1**3*Pk2*Pkd3*ct*(-3*D1*bd1*f*k1**2*(5*f*(k1**2 + k2**2*(3 - 6*C)) + k2**2*(-21*b2 + 42*g2))*(r + s - 1) + 7*b1**3*k2**2*(6*D1*fd*k1**2*(r + s - 1) + Dd*(-5*K*k2**2 + k1**2*(-10*K + 6*f + 5))*(4*r + 4*s - 3)) + b1**2*(D1*(42*bd1*f*k1**2*k2**2*(3*r + 3*s - 2) - 35*bd1*k2**2*(K*k2**2 + k1**2*(2*K - 1))*(3*r + 3*s - 2) - 15*f*fd*k1**4*(4*r + 4*s - 3) - 21*fd*(k1**4*(r + s) + k1**2*k2**2*(4*C*(r + s - 1) - 3*K*r - 3*K*s - 3*r - 3*s + 3) + k2**4*(2*C - 1)*(r + s - 1)) + 70*gd2*k2**2*(2*k1**2 + k2**2)*(r + s - 1)) - Dd*(4*r + 4*s - 3)*(30*f**2*k1**4 + 21*f*(k1**4 + k1**2*k2**2*(4*C - 3*K - 3) + k2**4*(2*C - 1)) - 70*g2*k2**2*(2*k1**2 + k2**2))) + b1*(D1*bd1*(-15*f**2*k1**4*(4*r + 4*s - 3) - 21*f*(2*k1**4*(r + s - 1) + k1**2*k2**2*(C*(8*r + 8*s - 4) - 6*K*(r + s - 1) - 6*r - 6*s + 3) + k2**4*(2*C - 1)*(2*r + 2*s - 1)) + 70*g2*k2**2*(2*k1**2 + k2**2)*(2*r + 2*s - 1)) - 3*k1**2*(D1*(5*f*fd*(k1**2 + k2**2*(3 - 6*C))*(2*r + 2*s - 1) - 21*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) - 21*fd*k2**2*(b2 - 2*g2)*(r + s)) + Dd*f*(5*f*(k1**2 + k2**2*(3 - 6*C)) + k2**2*(-21*b2 + 42*g2))*(4*r + 4*s - 3))))/(35*d*k2*k3**3) - 1j*D1**3*Pk2*Pkd3*ct*st**2*(D1*(-693*b1*fd*k2**4*(r + s)*(K*b1*k2**2 + b1*k1**2*(2*K - 1) - 2*g2*(2*k1**2 + k2**2)) - 15*f**3*k1**4*(22*bd1*k2**2*(r + s - 1) + 7*fd*k1**2*(4*r + 4*s - 3)) - 11*f**2*k2**2*(9*bd1*(r + s - 1)*(k1**4*(2*K - 1) - k1**2*k2**2*(-12*C - 9*K + 24*b1 + 9) + k2**4*(6*C - 3)) + k1**2*(5*fd*(k1**2*(4*C + 6*b1 - 3) + k2**2*(18*C - 9))*(3*r + 3*s - 2) - 18*gd2*(2*k1**2 + 9*k2**2)*(r + s - 1))) + 99*f*k2**2*(12*b1**2*fd*k1**2*k2**2*(2*r + 2*s - 1) - b1*fd*(2*r + 2*s - 1)*(k1**4*(2*K - 1) + k1**2*k2**2*(12*C + 9*K - 9) + k2**4*(6*C - 3)) - 14*b1*k2**2*(r + s - 1)*(K*bd1*k2**2 + bd1*k1**2*(2*K - 1) - gd2*(2*k1**2 + k2**2)) + 14*bd1*g2*k2**2*(2*k1**2 + k2**2)*(r + s - 1) + 2*fd*g2*k1**2*(2*k1**2 + 9*k2**2)*(2*r + 2*s - 1))) - Dd*f*(4*r + 4*s - 3)*(693*b1*k2**4*(K*b1*k2**2 + b1*k1**2*(2*K - 1) - 2*g2*(2*k1**2 + k2**2)) + 105*f**3*k1**6 + 55*f**2*(k1**4*k2**2*(4*C + 6*b1 - 3) + k1**2*k2**4*(18*C - 9)) - 99*f*k2**2*(12*b1**2*k1**2*k2**2 + b1*(k1**4*(1 - 2*K) - k1**2*k2**2*(12*C + 9*K - 9) + k2**4*(3 - 6*C)) + 2*g2*k1**2*(2*k1**2 + 9*k2**2))))/(1155*d*k2*k3**5) + 1j*D1**3*Pk2*Pkd3*f**2*k1*k2**2*st**6*(D1*b1*fd*(3*r + 3*s - 2) + D1*bd1*f*(r + s - 1) + Dd*b1*f*(4*r + 4*s - 3))/(21*d*k3**3) + 1j*D1**3*Pk2*Pkd3*f**2*k1*k2**2*st**6*(D1*(-11*b1*fd*k2**2*(3*r + 3*s - 2) - 11*bd1*f*k2**2*(r + s - 1) + 12*f*fd*k1**2*(4*r + 4*s - 3)) + Dd*f*(-11*b1*k2**2 + 12*f*k1**2)*(4*r + 4*s - 3))/(231*d*k3**5) + 1j*D1**3*Pk2*Pkd3*f*k1*st**4*(3*D1*b1**2*fd*k2**2 + D1*bd1*f*(f*k1**2*(5*r + 5*s - 3) - 3*k2**2*(3*K*(r + s - 1) + b1)) + b1*(3*D1*fd*(-3*K*k2**2*(2*r + 2*s - 1) + f*k1**2*(5*r + 5*s - 4)) + Dd*f*(-9*K*k2**2 + 5*f*k1**2)*(4*r + 4*s - 3)) - 3*k2**2*(6*C*D1*f*fd*r + 6*C*D1*f*fd*s - 4*C*D1*f*fd + 8*C*Dd*f**2*r + 8*C*Dd*f**2*s - 6*C*Dd*f**2 + 3*D1*bd2*f*(r + s - 1) - 3*D1*f*fd*r - 3*D1*f*fd*s + 2*D1*f*fd - 6*D1*f*gd2*r - 6*D1*f*gd2*s + 6*D1*f*gd2 - 12*D1*fd*g2*r - 12*D1*fd*g2*s + 6*D1*fd*g2 - 4*Dd*f**2*r - 4*Dd*f**2*s + 3*Dd*f**2 - 24*Dd*f*g2*r - 24*Dd*f*g2*s + 18*Dd*f*g2 + 3*b2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))))/(35*d*k3**3) - 1j*D1**3*Pk2*Pkd3*f*k1*st**4*(D1*(2*f**2*k1**2*(11*bd1*k2**2*(r + s - 1) - 10*fd*k1**2*(4*r + 4*s - 3)) + 11*f*k2**2*(6*b1*bd1*k2**2*(r + s - 1) + 2*b1*fd*k1**2*(3*r + 3*s - 2) - fd*k2**2*(6*C - 3)*(3*r + 3*s - 2) + k2**2*(-9*K*bd1 + 18*gd2)*(r + s - 1)) + 33*fd*k2**4*(2*r + 2*s - 1)*(-3*K*b1 + b1**2 + 6*g2)) - Dd*f*(4*r + 4*s - 3)*(20*f**2*k1**4 - 11*f*(2*b1*k1**2*k2**2 + k2**4*(3 - 6*C)) - k2**4*(-99*K*b1 + 33*b1**2 + 198*g2)))/(385*d*k3**5) - 3*1j*D1**3*Pk2*Pkd3*k1**3*(-D1*bd1*f*k2**2*(f*(10*C - 5) - 14*g2)*(r + s - 1) + b1**2*(D1*fd*(-7*K*k2**2*(r + s) + 5*f*k1**2*(2*r + 2*s - 1)) + Dd*f*(-7*K*k2**2 + 5*f*k1**2)*(4*r + 4*s - 3)) + b1*(2*D1*bd1*f*(-7*K*k2**2 + 5*f*k1**2)*(r + s - 1) + k2**2*(D1*(-f*fd*(10*C - 5)*(2*r + 2*s - 1) + 14*f*gd2*(r + s - 1) + 14*fd*g2*(r + s)) - Dd*f*(f*(10*C - 5) - 14*g2)*(4*r + 4*s - 3))))/(35*d*k3**5) + 1j*D1**3*Pk2*Pkd3*k1*st**2*(-D1*bd1*f*(r + s)*(7*b2 + f*(6*C - 3) - 14*g2) + 7*b1**3*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + 7*b1**2*(D1*bd1*f*(3*r + 3*s - 2) - K*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))) + b1*(-12*C*D1*f*fd*r - 12*C*D1*f*fd*s + 12*C*D1*f*fd - 24*C*Dd*f**2*r - 24*C*Dd*f**2*s + 18*C*Dd*f**2 - 14*D1*K*bd1*f*r - 14*D1*K*bd1*f*s + 7*D1*K*bd1*f - 7*D1*bd2*f*(r + s - 1) + 6*D1*f*fd*r + 6*D1*f*fd*s - 6*D1*f*fd + 14*D1*f*gd2*r + 14*D1*f*gd2*s - 14*D1*f*gd2 + 14*D1*fd*g2*r + 14*D1*fd*g2*s - 14*D1*fd*g2 + 12*Dd*f**2*r + 12*Dd*f**2*s - 9*Dd*f**2 + 56*Dd*f*g2*r + 56*Dd*f*g2*s - 42*Dd*f*g2 - 7*b2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))))/(35*d*k3) + 1j*D1**3*Pk2*Pkd3*k1*st**2*(-21*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + 3*b1**2*(D1*(-7*K*fd*k2**2*(2*r + 2*s + 1) - 7*bd1*f*k2**2*(3*r + 3*s - 2) + 3*f*fd*k1**2*(8*r + 8*s - 5)) + 2*Dd*f*(-7*K*k2**2 + 6*f*k1**2)*(4*r + 4*s - 3)) + 3*b1*(D1*bd1*f*(-7*K*k2**2*(4*r + 4*s - 5) + 3*f*k1**2*(8*r + 8*s - 7)) + D1*(f*(-3*fd*(K*k1**2*(2*r + 2*s - 1) + k2**2*(2*C - 1)*(4*r + 4*s - 1)) + k2**2*(-21*bd2 + 28*gd2)*(r + s - 1)) + 7*fd*k2**2*(-3*b2*(r + s) + g2*(4*r + 4*s + 2))) - Dd*f*(4*r + 4*s - 3)*(3*K*f*k1**2 + f*k2**2*(12*C - 6) + k2**2*(21*b2 - 28*g2))) + f*(-36*C*D1*bd1*f*k2**2*r - 36*C*D1*bd1*f*k2**2*s + 54*C*D1*bd1*f*k2**2 - 30*C*D1*f*fd*k1**2*r - 30*C*D1*f*fd*k1**2*s + 20*C*D1*f*fd*k1**2 - 40*C*Dd*f**2*k1**2*r - 40*C*Dd*f**2*k1**2*s + 30*C*Dd*f**2*k1**2 - 9*D1*K*bd1*f*k1**2*r - 9*D1*K*bd1*f*k1**2*s + 9*D1*K*bd1*f*k1**2 + 18*D1*bd1*f*k2**2*r + 18*D1*bd1*f*k2**2*s - 27*D1*bd1*f*k2**2 + 84*D1*bd1*g2*k2**2*r + 84*D1*bd1*g2*k2**2*s - 126*D1*bd1*g2*k2**2 - 9*D1*bd2*f*k1**2*(r + s - 1) + 15*D1*f*fd*k1**2*r + 15*D1*f*fd*k1**2*s - 10*D1*f*fd*k1**2 + 18*D1*f*gd2*k1**2*r + 18*D1*f*gd2*k1**2*s - 18*D1*f*gd2*k1**2 + 36*D1*fd*g2*k1**2*r + 36*D1*fd*g2*k1**2*s - 18*D1*fd*g2*k1**2 + 20*Dd*f**2*k1**2*r + 20*Dd*f**2*k1**2*s - 15*Dd*f**2*k1**2 + 72*Dd*f*g2*k1**2*r + 72*Dd*f*g2*k1**2*s - 54*Dd*f*g2*k1**2 - 9*b2*(7*D1*bd1*k2**2*(r + s - 1) + D1*fd*k1**2*(2*r + 2*s - 1) + Dd*f*k1**2*(4*r + 4*s - 3))))/(105*d*k3**3) - 1j*D1**3*Pk2*Pkd3*k1*(3*D1*bd1*f*k1**2*(7*b2 + f*(10*C - 5) - 14*g2)*(r + s - 1) + 7*b1**3*(3*D1*fd*k1**2*(r + s - 1) + Dd*(-5*K*k2**2 + 3*f*k1**2)*(4*r + 4*s - 3)) + 7*b1**2*(D1*bd1*(-5*K*k2**2 + 3*f*k1**2)*(3*r + 3*s - 2) + D1*(3*K*fd*k1**2*(r + s) + fd*k2**2*(3 - 6*C)*(r + s - 1) + 10*gd2*k2**2*(r + s - 1)) + Dd*(3*f*(K*k1**2 + k2**2*(1 - 2*C)) + 10*g2*k2**2)*(4*r + 4*s - 3)) + b1*(-84*C*D1*bd1*f*k2**2*r - 84*C*D1*bd1*f*k2**2*s + 42*C*D1*bd1*f*k2**2 + 60*C*D1*f*fd*k1**2*r + 60*C*D1*f*fd*k1**2*s - 30*C*D1*f*fd*k1**2 + 120*C*Dd*f**2*k1**2*r + 120*C*Dd*f**2*k1**2*s - 90*C*Dd*f**2*k1**2 + 42*D1*K*bd1*f*k1**2*r + 42*D1*K*bd1*f*k1**2*s - 42*D1*K*bd1*f*k1**2 + 42*D1*bd1*f*k2**2*r + 42*D1*bd1*f*k2**2*s - 21*D1*bd1*f*k2**2 + 140*D1*bd1*g2*k2**2*r + 140*D1*bd1*g2*k2**2*s - 70*D1*bd1*g2*k2**2 + 21*D1*bd2*f*k1**2*(r + s - 1) - 30*D1*f*fd*k1**2*r - 30*D1*f*fd*k1**2*s + 15*D1*f*fd*k1**2 - 42*D1*f*gd2*k1**2*r - 42*D1*f*gd2*k1**2*s + 42*D1*f*gd2*k1**2 - 42*D1*fd*g2*k1**2*r - 42*D1*fd*g2*k1**2*s - 60*Dd*f**2*k1**2*r - 60*Dd*f**2*k1**2*s + 45*Dd*f**2*k1**2 - 168*Dd*f*g2*k1**2*r - 168*Dd*f*g2*k1**2*s + 126*Dd*f*g2*k1**2 + 21*b2*k1**2*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3))))/(35*d*k3**3) - 1j*D1**3*Pk2*Pkd3*k1*st**2*(-3*D1*bd1*f*(r + s - 1)*(5*f**2*k1**4 + 3*f*k2**2*(K*k1**2 - 12*b1*k1**2 + k2**2*(6*C - 3)) - k2**4*(-42*K*b1 + 42*g2)) - 9*b1**2*k2**2*(D1*fd*(7*K*k2**2*(r + s) - 6*f*k1**2*(2*r + 2*s - 1)) - Dd*f*(-7*K*k2**2 + 6*f*k1**2)*(4*r + 4*s - 3)) - 3*b1*(D1*(5*f**2*fd*k1**4*(3*r + 3*s - 2) + 3*f*fd*k2**2*(K*k1**2 + k2**2*(6*C - 3))*(2*r + 2*s - 1) - 42*f*gd2*k2**4*(r + s - 1) - 42*fd*g2*k2**4*(r + s)) + Dd*f*(4*r + 4*s - 3)*(3*K*f*k1**2*k2**2 + 5*f**2*k1**4 + f*k2**4*(18*C - 9) - 42*g2*k2**4)) + f*k1**2*k2**2*(D1*(-f*fd*(10*C - 5)*(3*r + 3*s - 2) + 18*f*gd2*(r + s - 1) + 18*fd*g2*(2*r + 2*s - 1)) - Dd*f*(f*(10*C - 5) - 18*g2)*(4*r + 4*s - 3)))/(105*d*k3**5) + 3*1j*D1**3*Pk3*b1*f*k1*st**4*(-4*Pk2 + Pkd2*k2)*(D1*b1*fd*(2*s - 1) + 2*D1*bd1*f*s + Dd*b1*f*(4*s - 1))/(35*d*k2**2) + 1j*D1**3*Pk3*ct**7*f*k1**2*k2*(-4*Pk2 + Pkd2*k2)*(D1*(63*f**2*fd*(4*s - 1) + f*fd*(154*C - 154)*(3*s - 1) - 99*f*s*(-K*bd1 + bd1 + 2*gd2) + 198*fd*g2*(1 - 2*s)) + Dd*f*(4*s - 1)*(63*f**2 + f*(154*C - 154) - 198*g2) + 99*b1*(K - 1)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)))/(231*d*k3**4) - 1j*D1**3*Pk3*ct**6*f*k1*(4*Pk2 - Pkd2*k2)*(b1*(D1*fd*(21*f*s - 7*f + 18*s - 9) + Dd*f*(7*f + 9)*(4*s - 1)) + f*(D1*bd1*s*(7*f + 9) + 7*D1*fd*(3*s - 1) + 7*Dd*f*(4*s - 1)))/(21*d*k3**2) - 1j*D1**3*Pk3*ct**6*f*k1*(D1*(7*f**2*(11*bd1*k2**2*(2*Pk2*(r - 1) + Pkd2*k2*s) + fd*(44*Pk2*k2**2*(1 - 2*r) + 27*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 11*f*(-9*bd1*(-Pk2*k1**2*s*(8*K - 8) + 2*Pk2*k2**2*(K*(r - 2*s - 1) - 2*r + 2) + Pkd2*k1**2*k2*s*(2*K - 2) + Pkd2*k2**3*s*(2*K - 1)) + fd*(k1**2*(28*C - 28)*(4*Pk2 - Pkd2*k2)*(3*s - 1) - k2**2*(2*Pk2*(2*C*(27*r - 42*s + 5) - 75*r + 42*s + 11) + Pkd2*k2*(28*C - 21)*(3*s - 1))) + 36*gd2*(-4*Pk2*k1**2*s + Pk2*k2**2*(r - 2*s - 1) + Pkd2*k1**2*k2*s + Pkd2*k2**3*s)) - 396*fd*g2*(k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(-2*Pk2*(r - 2*s + 1) + Pkd2*k2*(1 - 2*s)))) + Dd*f*(7*f**2*(44*Pk2*k2**2*(1 - 2*r) + 27*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 11*f*(k1**2*(28*C - 28)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(-8*Pk2*(2*C*(9*r - 14*s - 1) - 25*r + 14*s + 9) + Pkd2*k2*(21 - 28*C)*(4*s - 1))) - 396*g2*(k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(-4*Pk2*r + 8*Pk2*s - 4*Pkd2*k2*s + Pkd2*k2))) + 11*b1*(D1*fd*(k1**2*(18*K - 18)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(-36*K*Pk2*(r - 2*s + 1) - 18*K*Pkd2*k2*(2*s - 1) + 72*Pk2*r + 18*Pkd2*k2*s - 9*Pkd2*k2 + 7*f*(Pk2*(6*r - 2) + Pkd2*k2*(3*s - 1)))) + Dd*f*(k1**2*(18*K - 18)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(28*Pk2*f*(2*r - 1) - 72*Pk2*(-2*K*s + r*(K - 2) + 1) + Pkd2*k2*(4*s - 1)*(-18*K + 7*f + 9)))))/(231*d*k3**4) + 1j*D1**3*Pk3*ct**5*f*k1**2*k2*st**2*(-4*Pk2 + Pkd2*k2)*(D1*(147*f**2*fd*(4*s - 1) + 22*f*(fd*(10*C - 10)*(3*s - 1) + s*(9*K*bd1 - 9*bd1 - 18*gd2)) + 396*fd*g2*(1 - 2*s)) + Dd*f*(4*s - 1)*(147*f**2 + f*(220*C - 220) - 396*g2) + 198*b1*(K - 1)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)))/(231*d*k3**4) + 1j*D1**3*Pk3*ct**5*(-63*b1**2*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(D1*fd*(s - 1) + Dd*f*(4*s - 1)) - 3*b1*(30*C*f*k1**2*(4*Pk2 - Pkd2*k2)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) + D1*(5*f**2*fd*(3*Pk2*k2**2*(1 - 3*r) + 7*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) + 3*f*(5*fd*k2**2*(-K*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 2*Pk2*r) + k1**2*s*(4*Pk2 - Pkd2*k2)*(14*K*bd1 - 14*bd1 - 14*gd2)) - 42*fd*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) + Dd*f*(5*f**2*(6*Pk2*k2**2*(1 - 2*r) + 7*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 15*f*k2**2*(K*Pkd2*k2*(4*s - 1) + Pk2*(-8*K*s + 2*K - 4*r + 2)) - 42*g2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + f*(D1*(-45*b2*fd*k2**2*(-2*Pk2 + Pkd2*k2)*(2*s - 1) + 15*bd1*f**2*(-28*Pk2*k1**2*s + 3*Pk2*k2**2*(r - 1) + 7*Pkd2*k1**2*k2*s) - 5*f*(9*bd1*(8*C*Pk2*k1**2*s - 2*C*Pkd2*k1**2*k2*s + K*Pkd2*k2**3*s - Pk2*k2**2*(2*K*s + r - 1)) + 14*fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + fd*k2**2*(Pk2*(-84*C*s + 28*C - 33*r + 42*s - 3) + Pkd2*k2*(14*C - 7)*(3*s - 1)) + k2**2*s*(-2*Pk2 + Pkd2*k2)*(9*bd2 - 18*gd2)) - 18*g2*(7*bd1*k1**2*s*(-4*Pk2 + Pkd2*k2) - 5*fd*k2**2*(-2*Pk2 + Pkd2*k2)*(2*s - 1))) - 5*Dd*f*(14*f*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + f*k2**2*(Pk2*(-28*C*(4*s - 1) - 44*r + 56*s + 8) + Pkd2*k2*(14*C - 7)*(4*s - 1)) + k2**2*(-2*Pk2 + Pkd2*k2)*(9*b2 - 18*g2)*(4*s - 1))))/(105*d*k2*k3**2) - 1j*D1**3*Pk3*ct**5*(693*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(2*Pk2*(r + 2*s - 1) - Pkd2*k2*s) + Dd*f*(8*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 4*s))) + 11*b1*(3*D1*(5*f**2*fd*k2**2*(3*Pk2*k2**2*(3*r - 1) + 7*k1**2*(4*Pk2*(2*r + s - 1) + Pkd2*k2*(2*s - 1))) + 3*f*(fd*(k1**4*(5*K - 5)*(4*Pk2 - Pkd2*k2)*(2*s - 1) - 2*k1**2*k2**2*(Pk2*(-20*C*(r + 2*s - 1) + 34*K*r - 2*K*s + K - 44*r - 8*s + 4) + 5*Pkd2*k2*(K*(4*s - 2) + s*(2*C - 4) + 1)) - 5*k2**4*(K*Pk2*(8*r + 4*s - 2) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r)) - 7*k1**2*k2**2*(4*Pk2*gd2*(r + 2*s - 1) - 2*Pkd2*gd2*k2*s - bd1*(K - 1)*(4*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 2*s)))) + 42*fd*g2*k1**2*k2**2*(-2*Pk2*(r + 2*s - 1) + Pkd2*k2*s)) + Dd*f*(10*f**2*k2**2*(9*Pk2*k2**2*(2*r - 1) + 7*k1**2*(2*Pk2*(8*r + 4*s - 5) + Pkd2*k2*(4*s - 1))) + 9*f*(k1**4*(5*K - 5)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 2*k1**2*k2**2*(Pk2*(40*C*(r + 2*s - 1) - 68*K*r + 4*K*s + 33*K + 88*r + 16*s - 48) + Pkd2*k2*(4*s - 1)*(-5*C - 10*K + 10)) - 5*k2**4*(K*Pkd2*k2*(4*s - 1) + 2*Pk2*(K*(8*r + 4*s - 5) - 2*r + 1))) + 126*g2*k1**2*k2**2*(-8*Pk2*(r + 2*s - 1) + Pkd2*k2*(4*s - 1)))) + f*(D1*(-1386*bd1*g2*k1**2*k2**2*(2*Pk2*(r + 2*s - 1) - Pkd2*k2*(s - 1)) + 5*f**2*(99*Pk2*bd1*k2**4*(r - 1) - 924*Pk2*fd*k1**2*k2**2*(3*r + 2*s - 2) + 77*bd1*k1**2*k2**2*(4*Pk2*(2*r + s - 2) + Pkd2*k2*(2*s + 1)) + 189*fd*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 11*f*(-90*Pk2*bd2*k2**4*(r + s - 1) - 9*bd1*(k1**4*s*(5 - 5*K)*(4*Pk2 - Pkd2*k2) + 2*k1**2*k2**2*(-Pk2*(10*C*(r + 2*s - 1) + K*(-17*r + s + 17) + 22*r + 4*s - 22) + 5*Pkd2*k2*(C*(s - 1) + s*(2*K - 2) + 1)) + 5*k2**4*(2*K*Pk2*(2*r + s - 2) + K*Pkd2*k2*s - Pk2*r + Pk2)) + 5*fd*(k1**4*(14*C - 14)*(4*Pk2 - Pkd2*k2)*(3*s - 1) + 2*k1**2*k2**2*(Pk2*(-6*C*(27*r - 3*s - 8) + 225*r + 87*s - 104) + Pkd2*k2*(21 - 28*C)*(3*s - 1)) + k2**4*(Pk2*(-4*C*(54*r + 21*s - 25) + 141*r + 42*s - 61) + Pkd2*k2*(7 - 14*C)*(3*s - 1))) + 18*gd2*(5*k1**4*s*(-4*Pk2 + Pkd2*k2) + 2*k1**2*k2**2*(Pk2*(17*r - s - 17) + 10*Pkd2*k2*s) + 5*k2**4*(2*Pk2*(2*r + s - 2) + Pkd2*k2*s))) - 198*fd*(5*Pk2*b2*k2**4*(2*r + 2*s - 1) + g2*(5*k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1) - 2*k1**2*k2**2*(Pk2*(34*r - 2*s + 1) + 10*Pkd2*k2*(2*s - 1)) - 5*k2**4*(Pk2*(8*r + 4*s - 2) + Pkd2*k2*(2*s - 1))))) + Dd*f*(-990*Pk2*b2*k2**4*(4*r + 4*s - 3) + 105*f**2*k1**2*(-44*Pk2*k2**2*(3*r + 2*s - 2) + 9*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 55*f*(k1**4*(14*C - 14)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 2*k1**2*k2**2*(Pk2*(-6*C*(36*r - 4*s - 17) + 300*r + 116*s - 179) + Pkd2*k2*(21 - 28*C)*(4*s - 1)) + k2**4*(-4*Pk2*(C*(72*r + 28*s - 43) - 47*r - 14*s + 27) + Pkd2*k2*(7 - 14*C)*(4*s - 1))) - 198*g2*(5*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 2*k1**2*k2**2*(Pk2*(-68*r + 4*s + 33) + 10*Pkd2*k2*(1 - 4*s)) + 5*k2**4*(-2*Pk2*(8*r + 4*s - 5) + Pkd2*k2*(1 - 4*s))))))/(1155*d*k2*k3**4) - 1j*D1**3*Pk3*ct**4*f*k1*st**2*(4*Pk2 - Pkd2*k2)*(3*b1*(D1*fd*(15*f*s - 5*f + 12*s - 6) + Dd*f*(5*f + 6)*(4*s - 1)) + f*(3*D1*bd1*s*(5*f + 6) + 10*D1*fd*(3*s - 1) + 10*Dd*f*(4*s - 1)))/(21*d*k3**2) - 1j*D1**3*Pk3*ct**4*f*k1*st**2*(D1*(75*f**2*(11*bd1*k2**2*(2*Pk2*(r - 1) + Pkd2*k2*s) + fd*(44*Pk2*k2**2*(1 - 2*r) + 21*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 22*f*(-9*bd1*(-Pk2*k1**2*s*(24*K - 24) + 10*Pk2*k2**2*(K*(r - 2*s - 1) - 2*r + 2) + Pkd2*k1**2*k2*s*(6*K - 6) + Pkd2*k2**3*s*(10*K - 5)) + fd*(k1**2*(60*C - 60)*(4*Pk2 - Pkd2*k2)*(3*s - 1) - k2**2*(Pk2*(C*(444*r - 600*s + 52) - 594*r + 300*s + 98) + Pkd2*k2*(100*C - 75)*(3*s - 1))) + 36*gd2*(-12*Pk2*k1**2*s + 5*Pk2*k2**2*(r - 2*s - 1) + 3*Pkd2*k1**2*k2*s + 5*Pkd2*k2**3*s)) + 792*fd*g2*(-3*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 5*k2**2*(2*Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1)))) + Dd*f*(75*f**2*(44*Pk2*k2**2*(1 - 2*r) + 21*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 22*f*(k1**2*(60*C - 60)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(-8*Pk2*(2*C*(37*r - 50*s - 6) - 99*r + 50*s + 37) + Pkd2*k2*(75 - 100*C)*(4*s - 1))) + 792*g2*(-3*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 5*k2**2*(4*Pk2*(r - 2*s) + Pkd2*k2*(4*s - 1)))) + 33*b1*(D1*fd*(k1**2*(36*K - 36)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 5*k2**2*(-24*K*Pk2*(r - 2*s + 1) - 12*K*Pkd2*k2*(2*s - 1) + 48*Pk2*r + 12*Pkd2*k2*s - 6*Pkd2*k2 + 5*f*(Pk2*(6*r - 2) + Pkd2*k2*(3*s - 1)))) + Dd*f*(k1**2*(36*K - 36)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 5*k2**2*(20*Pk2*f*(2*r - 1) - 48*Pk2*(-2*K*s + r*(K - 2) + 1) + Pkd2*k2*(4*s - 1)*(-12*K + 5*f + 6)))))/(1155*d*k3**4) + 3*1j*D1**3*Pk3*ct**4*k1*(-4*Pk2 + Pkd2*k2)*(5*D1*bd1*f**2*s + b1**2*(D1*fd*(10*f*s - 5*f + 7*s - 7) + Dd*f*(5*f + 7)*(4*s - 1)) + b1*f*(2*D1*bd1*s*(5*f + 7) + 5*D1*fd*(2*s - 1) + 5*Dd*f*(4*s - 1)))/(35*d*k2**2) - 1j*D1**3*Pk3*ct**4*(-9*b1**2*k1**2*k2**2*(D1*fd*(-2*Pk2*(-7*K*(r - 2*s + 2) + 5*f + 7*r + 7) + Pkd2*k2*(14*K*(s - 1) + 5*f + 7)) + 14*Dd*f*(K*Pkd2*k2*(4*s - 1) + Pk2*(-8*K*s + r*(4*K - 4) + 2))) + b1*k1**2*(D1*(5*f**2*(-9*Pk2*fd*k2**2*(18*r + 15*s - 13) + 9*bd1*k2**2*(-2*Pk2 + Pkd2*k2) + 14*fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) + 9*f*(fd*(5*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(Pk2*(-4*C*(14*r - 20*s + 3) - 40*K*s + 20*K + 8*r - 106*s + 35) + 5*Pkd2*k2*(C*(4 - 8*s) + 4*K*s - 2*K + 4*s - 3))) - 7*k2**2*(Pk2*bd1*(K*(4*r - 8*s - 2) - 4*r + 4) + Pkd2*bd1*k2*(4*K*s - 1) + 4*gd2*(-Pk2*r + 2*Pk2*s + Pk2 - Pkd2*k2*s))) + 252*fd*g2*k2**2*(Pk2*(r - 2*s + 2) + Pkd2*k2*(s - 1))) + Dd*f*(5*f**2*(-9*Pk2*k2**2*(24*r + 20*s - 17) + 14*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 9*f*(5*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(Pk2*(-16*C*(7*r - 10*s - 1) - 80*K*s + 20*K + 16*r - 212*s + 45) + Pkd2*k2*(4*s - 1)*(-20*C + 10*K + 10))) + 252*g2*k2**2*(4*Pk2*(r - 2*s) + Pkd2*k2*(4*s - 1)))) + f*(D1*(-5*bd1*f**2*k1**2*(-56*Pk2*k1**2*s + 9*Pk2*k2**2*(6*r + 5*s - 4) + 14*Pkd2*k1**2*k2*s) + f*(5*fd*(Pk2*k2**4*(8*C - 4)*(3*r - 1) + 7*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k1**2*k2**2*(Pk2*(-168*C*s + 56*C - 120*r - 45*s + 55) + Pkd2*k2*(28*C - 14)*(3*s - 1))) - 9*k1**2*(bd1*(-20*Pk2*k1**2*s + Pk2*k2**2*(r*(28*C - 4) + s*(-40*C + 20*K + 53) - 14) + 5*Pkd2*k1**2*k2*s + 5*Pkd2*k2**3*(4*C*s - s*(2*K + 2) - 1)) + k2**2*s*(-2*Pk2 + Pkd2*k2)*(-10*bd2 + 20*gd2))) + 18*k1**2*k2**2*(-5*b2*fd*(2*Pk2 - Pkd2*k2)*(2*s - 1) + 2*g2*(7*bd1*(Pk2*r - 2*Pk2*s + Pkd2*k2*s) + 5*fd*(2*Pk2 - Pkd2*k2)*(2*s - 1)))) + 5*Dd*f*(f*(Pk2*k2**4*(16*C - 8)*(2*r - 1) + 7*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(-224*C*s + 56*C - 160*r - 60*s + 95) + Pkd2*k2*(28*C - 14)*(4*s - 1))) + k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(18*b2 - 36*g2)*(4*s - 1))))/(105*d*k1*k2**2*k3**2) - 1j*D1**3*Pk3*ct**4*(D1*(-693*b1*fd*k1**2*k2**2*(-b1*(k1**2*(2*K - 2)*(Pk2*(r + 3*s - 1) - Pkd2*k2*s) + k2**2*(2*Pk2*(K*(r + 2*s - 2) + r + 1) + Pkd2*k2*s*(1 - 2*K))) + 4*g2*(k1**2*(Pk2*(r + 3*s - 1) - Pkd2*k2*s) + k2**2*(Pk2*(r + 2*s - 2) - Pkd2*k2*s))) + 5*f**3*k1**2*(99*Pk2*bd1*k2**4*(4*r + 5*s - 6) - 231*Pk2*fd*k1**2*k2**2*(16*r + 20*s - 13) + 77*bd1*k1**2*k2**2*(2*Pk2*(5*r + 5*s - 6) + 3*Pkd2*k2) + 63*fd*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 11*f**2*k2**2*(-9*bd1*(k1**4*(2*Pk2*(10*C*(r + 3*s - 2) - 3*K*(4*r + 7*s - 4) + 17*r + 11*s - 7) - 5*Pkd2*k2*(4*C*(s - 1) + s*(2*K - 5) + 4)) + k1**2*k2**2*(Pk2*(12*C*r + 40*C*s + K*(-78*r - 96*s + 78) - 10*b1 + 32*r + 13*s - 34) - 5*Pkd2*k2*(4*C*(s - 1) + 2*K*s - 2*b1*s + b1 - 3*s + 3))) - 5*fd*(4*Pk2*k2**4*(C*(2 - 6*r) + 3*r - 1) + k1**4*(2*Pk2*(-18*C*(6*r + 9*s - 5) + 21*b1*(5*r + 5*s - 3) + 171*r + 246*s - 139) - 7*Pkd2*k2*(3*b1 + (4*C - 3)*(3*s - 1))) + k1**2*k2**2*(Pk2*(C*(-732*r - 768*s + 500) + 9*b1*(12*r + 15*s - 7) + 486*r + 513*s - 333) + Pkd2*k2*(14 - 28*C)*(3*s - 1))) - 18*k1**2*(-15*Pk2*bd2*k2**2*(r + s - 1) + 2*gd2*(k1**2*(3*Pk2*(4*r + 7*s - 4) + 5*Pkd2*k2*s) + k2**2*(Pk2*(39*r + 48*s - 39) + 5*Pkd2*k2*s)))) + 99*f*k1**2*k2**2*(-30*Pk2*b2*fd*k2**2*(2*r + 2*s - 1) + 10*b1**2*fd*k2**2*(Pk2 + Pkd2*k2*s) + 7*b1*bd1*(k1**2*(2*K - 2)*(Pk2*(2*r + 6*s - 3) + Pkd2*k2*(1 - 2*s)) + k2**2*(Pk2*(K*(4*r + 8*s - 2) + 4*r - 4) + Pkd2*k2*(K*(2 - 4*s) + 2*s - 1))) + b1*fd*(k1**2*(2*Pk2*(20*C*(r + 3*s - 1) - 3*K*(8*r + 14*s - 7) + 34*r + 22*s - 21) - 5*Pkd2*k2*(K*(4*s - 2) + s*(8*C - 10) + 1)) + k2**2*(Pk2*(4*C*(6*r + 20*s - 13) - 12*K*(13*r + 16*s - 8) + 64*r + 26*s - 11) + 10*Pkd2*k2*(-2*K*s + K + s*(3 - 4*C)))) + 28*b1*gd2*(k1**2*(-Pk2*(r + 3*s - 1) + Pkd2*k2*s) + k2**2*(-Pk2*(r + 2*s - 1) + Pkd2*k2*s)) - 28*bd1*g2*(k1**2*(Pk2*(r + 3*s - 2) - Pkd2*k2*(s - 1)) + k2**2*(Pk2*(r + 2*s) + k2*(-Pkd2*s + Pkd2))) + 4*fd*g2*(k1**2*(3*Pk2*(8*r + 14*s - 7) + 5*Pkd2*k2*(2*s - 1)) + k2**2*(6*Pk2*(13*r + 16*s - 8) + 5*Pkd2*k2*(2*s - 1))))) + Dd*f*(-693*b1*k1**2*k2**2*(-2*b1*k1**2*(K - 1)*(Pk2*(4*r + 12*s - 5) + Pkd2*k2*(1 - 4*s)) + b1*k2**2*(-4*Pk2*(2*K*(r + 2*s - 1) + 2*r - 1) + Pkd2*k2*(2*K - 1)*(4*s - 1)) + 4*g2*k1**2*(Pk2*(4*r + 12*s - 5) + Pkd2*k2*(1 - 4*s)) + 4*g2*k2**2*(4*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 4*s))) + 105*f**3*k1**4*(-11*Pk2*k2**2*(16*r + 20*s - 13) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 55*f**2*k2**2*(Pk2*k2**4*(16*C - 8)*(2*r - 1) + k1**4*(Pk2*(36*C*(8*r + 12*s - 7) - 70*b1*(4*r + 4*s - 3) - 456*r - 656*s + 392) + Pkd2*k2*(28*C - 21)*(4*s - 1)) + k1**2*k2**2*(Pk2*(8*C*(122*r + 128*s - 93) - 9*b1*(16*r + 20*s - 13) - 648*r - 684*s + 495) + Pkd2*k2*(28*C - 14)*(4*s - 1))) + 99*f*k1**2*k2**2*(-30*Pk2*b2*k2**2*(4*r + 4*s - 3) + 5*Pkd2*b1**2*k2**3*(4*s - 1) + b1*k1**2*(2*Pk2*(10*C*(4*r + 12*s - 5) + K*(-48*r - 84*s + 45) + 68*r + 44*s - 45) + Pkd2*k2*(4*s - 1)*(-20*C - 10*K + 25)) + b1*k2**2*(Pk2*(16*C*(3*r + 10*s - 4) - 12*K*(26*r + 32*s - 21) + 128*r + 52*s - 77) + Pkd2*k2*(4*s - 1)*(-20*C - 10*K + 15)) + 4*g2*k1**2*(Pk2*(48*r + 84*s - 45) + 5*Pkd2*k2*(4*s - 1)) + 4*g2*k2**2*(6*Pk2*(26*r + 32*s - 21) + 5*Pkd2*k2*(4*s - 1)))))/(1155*d*k1*k2**2*k3**4) + 1j*D1**3*Pk3*ct**3*f*k1**2*k2*st**4*(-4*Pk2 + Pkd2*k2)*(D1*(35*f**2*fd*(4*s - 1) + f*fd*(22*C - 22)*(3*s - 1) - 33*f*s*(-K*bd1 + bd1 + 2*gd2) + 66*fd*g2*(1 - 2*s)) + Dd*f*(4*s - 1)*(35*f**2 + f*(22*C - 22) - 66*g2) + 33*b1*(K - 1)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)))/(77*d*k3**4) + 3*1j*D1**3*Pk3*ct**3*(D1*bd1*f*(Pk2*f*(9*r + s*(20*C - 10)) + Pkd2*f*k2*s*(5 - 10*C) + s*(2*Pk2 - Pkd2*k2)*(7*b2 - 14*g2)) + 7*b1**2*(D1*fd*(K*(2*Pk2 - Pkd2*k2)*(s - 1) + Pk2*f*(2*r - 1) + Pk2*r) + Dd*f*(K*Pkd2*k2*(1 - 4*s) + Pk2*(8*K*s - 2*K + f*(4*r - 2) + 4*r - 2))) + b1*(40*C*D1*Pk2*f*fd*s - 20*C*D1*Pk2*f*fd - 20*C*D1*Pkd2*f*fd*k2*s + 10*C*D1*Pkd2*f*fd*k2 + 80*C*Dd*Pk2*f**2*s - 20*C*Dd*Pk2*f**2 - 40*C*Dd*Pkd2*f**2*k2*s + 10*C*Dd*Pkd2*f**2*k2 + 14*D1*Pk2*bd2*f*s + 18*D1*Pk2*f*fd*r - 20*D1*Pk2*f*fd*s + D1*Pk2*f*fd - 28*D1*Pk2*f*gd2*s - 28*D1*Pk2*fd*g2*s + 28*D1*Pk2*fd*g2 - 7*D1*Pkd2*bd2*f*k2*s + 10*D1*Pkd2*f*fd*k2*s - 5*D1*Pkd2*f*fd*k2 + 14*D1*Pkd2*f*gd2*k2*s + 14*D1*Pkd2*fd*g2*k2*s - 14*D1*Pkd2*fd*g2*k2 + 7*D1*bd1*f*(-2*K*Pkd2*k2*s + Pk2*(4*K*s + 2*f*r - f + 2*r - 1)) + 36*Dd*Pk2*f**2*r - 40*Dd*Pk2*f**2*s - 8*Dd*Pk2*f**2 - 112*Dd*Pk2*f*g2*s + 28*Dd*Pk2*f*g2 + 20*Dd*Pkd2*f**2*k2*s - 5*Dd*Pkd2*f**2*k2 + 56*Dd*Pkd2*f*g2*k2*s - 14*Dd*Pkd2*f*g2*k2 + 7*b2*(2*Pk2 - Pkd2*k2)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))))/(35*d*k2) + 1j*D1**3*Pk3*ct**3*st**2*(-63*b1**2*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(D1*fd*(s - 1) + Dd*f*(4*s - 1)) - 6*b1*(D1*(5*f**2*fd*(3*Pk2*k2**2*(1 - 3*r) + 5*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) + 3*f*(fd*k1**2*(3*C + 3)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 5*fd*k2**2*(-K*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 2*Pk2*r) + k1**2*s*(4*Pk2 - Pkd2*k2)*(7*K*bd1 - 7*bd1 - 7*gd2)) - 21*fd*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) + Dd*f*(5*f**2*(6*Pk2*k2**2*(1 - 2*r) + 5*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 3*f*(k1**2*(3*C + 3)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 5*k2**2*(K*Pkd2*k2*(4*s - 1) + Pk2*(K*(2 - 8*s) - 4*r + 2))) - 21*g2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) - 2*f*(D1*(45*b2*fd*k2**2*(-2*Pk2 + Pkd2*k2)*(2*s - 1) - 15*bd1*f**2*(-20*Pk2*k1**2*s + 3*Pk2*k2**2*(r - 1) + 5*Pkd2*k1**2*k2*s) + 63*bd1*g2*k1**2*s*(-4*Pk2 + Pkd2*k2) + f*(9*bd1*(5*K*Pkd2*k2**3*s + Pk2*k1**2*s*(12*C + 12) - 5*Pk2*k2**2*(2*K*s + r - 1) - Pkd2*k1**2*k2*s*(3*C + 3)) + 30*fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + fd*k2**2*(Pk2*(-300*C*s + 100*C - 147*r + 150*s - 1) + Pkd2*k2*(50*C - 25)*(3*s - 1)) + k2**2*s*(-2*Pk2 + Pkd2*k2)*(45*bd2 - 90*gd2)) - 90*fd*g2*k2**2*(-2*Pk2 + Pkd2*k2)*(2*s - 1)) + Dd*f*(30*f*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + f*k2**2*(-4*Pk2*(25*C*(4*s - 1) + 49*r - 50*s - 12) + Pkd2*k2*(50*C - 25)*(4*s - 1)) + k2**2*(-2*Pk2 + Pkd2*k2)*(45*b2 - 90*g2)*(4*s - 1))))/(105*d*k2*k3**2) - 1j*D1**3*Pk3*ct**3*(105*Dd*b1**3*k1**2*(K - 1)*(2*Pk2 - Pkd2*k2)*(4*s - 1) + 3*b1**2*(35*D1*bd1*k1**2*(K - 1)*(2*Pk2 - Pkd2*k2)*(3*s - 1) + D1*(21*K*fd*k2**2*(-2*Pk2*r + Pkd2*k2) + fd*k1**2*(30*Pk2*f*(4*s + 1) + 28*Pk2*(3*C*s - 4*K*(s - 1) + 4*s - 4) - 3*Pkd2*k2*(14*C*s + 5*f*(4*s + 1))) + 70*gd2*k1**2*s*(-2*Pk2 + Pkd2*k2)) + 2*Dd*(15*f**2*k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1) + 7*f*(6*K*Pk2*k2**2*(1 - 2*r) + k1**2*(4*s - 1)*(-3*C*Pkd2*k2 + Pk2*(6*C - 8*K + 8))) - 35*g2*k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1))) + 3*b1*(D1*bd1*(42*C*f*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 7*K*f*(32*Pk2*k1**2*s + 6*Pk2*k2**2*(2*r - 1) + 3*Pkd2*k2**3) + 224*Pk2*f*k1**2*s + 15*f**2*k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 3) - 70*g2*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1)) + D1*(-45*Pk2*f**2*fd*k1**2*(6*r + 12*s - 7) + f*(28*Pk2*gd2*(8*k1**2*s + 3*k2**2*(r - 1)) + 21*Pkd2*bd2*k2**3*s - 3*fd*(k1**2*(2*Pk2*(24*C*(2*s - 1) + 10*K*s - 5*K + 19*r - 16*s - 2) + 5*Pkd2*k2*(-2*K*s + K + 4*s)) + k2**2*(2*Pk2*(18*C*(2*r - 1) - 14*K*(r + 2*s - 1) - 18*r + 9) + Pkd2*k2*(5 - 10*C)))) + 7*fd*(32*Pk2*g2*k1**2*(s - 1) + 3*Pkd2*b2*k2**3*s - 6*g2*k2**2*(-2*Pk2*r + Pkd2*k2))) + Dd*f*(-360*Pk2*f**2*k1**2*(r + 2*s - 1) + 12*Pk2*f*k2**2*(C*(18 - 36*r) + 14*K*(r + 2*s - 1) + 18*r - 9) + 56*Pk2*g2*(4*k1**2*(4*s - 1) + 3*k2**2*(2*r - 1)) + 21*Pkd2*b2*k2**3*(4*s - 1) - 3*f*k1**2*(2*Pk2*(24*C*(4*s - 1) + 20*K*s - 5*K + 38*r - 32*s - 11) + 5*Pkd2*k2*(-4*K*s + K + 8*s - 2)))) + f*(-420*C*D1*Pk2*f*fd*k1**2*s + 140*C*D1*Pk2*f*fd*k1**2 + 780*C*D1*Pk2*f*fd*k2**2*r + 1080*C*D1*Pk2*f*fd*k2**2*s - 620*C*D1*Pk2*f*fd*k2**2 + 210*C*D1*Pkd2*f*fd*k1**2*k2*s - 70*C*D1*Pkd2*f*fd*k1**2*k2 - 560*C*Dd*Pk2*f**2*k1**2*s + 140*C*Dd*Pk2*f**2*k1**2 + 1040*C*Dd*Pk2*f**2*k2**2*r + 1440*C*Dd*Pk2*f**2*k2**2*s - 880*C*Dd*Pk2*f**2*k2**2 + 280*C*Dd*Pkd2*f**2*k1**2*k2*s - 70*C*Dd*Pkd2*f**2*k1**2*k2 - 90*D1*Pk2*bd2*f*k1**2*s + 126*D1*Pk2*bd2*f*k2**2*r + 252*D1*Pk2*bd2*f*k2**2*s - 126*D1*Pk2*bd2*f*k2**2 - 435*D1*Pk2*f*fd*k1**2*r - 810*D1*Pk2*f*fd*k1**2*s + 415*D1*Pk2*f*fd*k1**2 - 390*D1*Pk2*f*fd*k2**2*r - 540*D1*Pk2*f*fd*k2**2*s + 310*D1*Pk2*f*fd*k2**2 + 180*D1*Pk2*f*gd2*k1**2*s - 252*D1*Pk2*f*gd2*k2**2*r - 504*D1*Pk2*f*gd2*k2**2*s + 252*D1*Pk2*f*gd2*k2**2 + 360*D1*Pk2*fd*g2*k1**2*s - 180*D1*Pk2*fd*g2*k1**2 - 504*D1*Pk2*fd*g2*k2**2*r - 1008*D1*Pk2*fd*g2*k2**2*s + 504*D1*Pk2*fd*g2*k2**2 + 45*D1*Pkd2*bd2*f*k1**2*k2*s - 105*D1*Pkd2*f*fd*k1**2*k2*s + 35*D1*Pkd2*f*fd*k1**2*k2 - 90*D1*Pkd2*f*gd2*k1**2*k2*s - 180*D1*Pkd2*fd*g2*k1**2*k2*s + 90*D1*Pkd2*fd*g2*k1**2*k2 - 3*D1*bd1*(45*Pk2*f**2*k1**2*(2*r + 4*s - 1) - 21*Pkd2*b2*k2**3*(s - 1) + 3*f*(k1**2*(Pk2*(19*r + s*(48*C + 10*K - 16) + 1) - 5*Pkd2*k2*(s*(K - 2) + 2)) + k2**2*(-14*K*Pk2*(r + 2*s - 1) + (2*C - 1)*(18*Pk2*r + 5*Pkd2*k2))) - 14*g2*(16*Pk2*k1**2*s + 6*Pk2*k2**2*r + 3*Pkd2*k2**3)) - 580*Dd*Pk2*f**2*k1**2*r - 1080*Dd*Pk2*f**2*k1**2*s + 560*Dd*Pk2*f**2*k1**2 - 520*Dd*Pk2*f**2*k2**2*r - 720*Dd*Pk2*f**2*k2**2*s + 440*Dd*Pk2*f**2*k2**2 + 720*Dd*Pk2*f*g2*k1**2*s - 180*Dd*Pk2*f*g2*k1**2 - 1008*Dd*Pk2*f*g2*k2**2*r - 2016*Dd*Pk2*f*g2*k2**2*s + 1008*Dd*Pk2*f*g2*k2**2 - 140*Dd*Pkd2*f**2*k1**2*k2*s + 35*Dd*Pkd2*f**2*k1**2*k2 - 360*Dd*Pkd2*f*g2*k1**2*k2*s + 90*Dd*Pkd2*f*g2*k1**2*k2 - 9*b2*(D1*fd*(-28*Pk2*k2**2*(r + 2*s - 1) + 5*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1)) + Dd*f*(-56*Pk2*k2**2*(r + 2*s - 1) + 5*k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1)))))/(105*d*k2*k3**2) - 1j*D1**3*Pk3*ct**3*st**2*(693*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(2*Pk2*(r + 2*s - 1) - Pkd2*k2*s) + Dd*f*(8*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 4*s))) + 11*b1*(3*D1*(10*f**2*fd*k2**2*(3*Pk2*k2**2*(3*r - 1) + 5*k1**2*(4*Pk2*(2*r + s - 1) + Pkd2*k2*(2*s - 1))) + 3*f*(fd*(k1**4*(3*K - 3)*(4*Pk2 - Pkd2*k2)*(2*s - 1) - 4*k1**2*k2**2*(Pk2*(-6*C*(r + 2*s - 1) + K*(19*r - 4*s + 2) - 31*r - 14*s + 7) + 3*Pkd2*k2*(K*(4*s - 2) + s*(C - 3) + 1)) - 10*k2**4*(K*Pk2*(8*r + 4*s - 2) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r)) - 7*k1**2*k2**2*(4*Pk2*gd2*(r + 2*s - 1) - 2*Pkd2*gd2*k2*s - bd1*(K - 1)*(4*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 2*s)))) + 42*fd*g2*k1**2*k2**2*(-2*Pk2*(r + 2*s - 1) + Pkd2*k2*s)) + Dd*f*(20*f**2*k2**2*(9*Pk2*k2**2*(2*r - 1) + 5*k1**2*(2*Pk2*(8*r + 4*s - 5) + Pkd2*k2*(4*s - 1))) + 9*f*(k1**4*(3*K - 3)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 2*k1**2*k2**2*(2*Pk2*(12*C*(r + 2*s - 1) + K*(-38*r + 8*s + 17) + 62*r + 28*s - 38) + Pkd2*k2*(4*s - 1)*(-3*C - 12*K + 9)) - 10*k2**4*(K*Pkd2*k2*(4*s - 1) + 2*Pk2*(K*(8*r + 4*s - 5) - 2*r + 1))) + 126*g2*k1**2*k2**2*(-8*Pk2*(r + 2*s - 1) + Pkd2*k2*(4*s - 1)))) + f*(D1*(-1386*bd1*g2*k1**2*k2**2*(2*Pk2*(r + 2*s - 1) - Pkd2*k2*(s - 1)) + 10*f**2*(99*Pk2*bd1*k2**4*(r - 1) - 660*Pk2*fd*k1**2*k2**2*(3*r + 2*s - 2) + 55*bd1*k1**2*k2**2*(4*Pk2*(2*r + s - 2) + Pkd2*k2*(2*s + 1)) + 105*fd*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 11*f*(-180*Pk2*bd2*k2**4*(r + s - 1) - 9*bd1*(k1**4*s*(3 - 3*K)*(4*Pk2 - Pkd2*k2) + 2*k1**2*k2**2*(-Pk2*(6*C*(r + 2*s - 1) + K*(-19*r + 4*s + 19) + 31*r + 14*s - 31) + 3*Pkd2*k2*(C*(s - 1) + s*(4*K - 3) + 1)) + 10*k2**4*(2*K*Pk2*(2*r + s - 2) + K*Pkd2*k2*s - Pk2*r + Pk2)) + 2*fd*(k1**4*(15*C - 15)*(4*Pk2 - Pkd2*k2)*(3*s - 1) - 6*k1**2*k2**2*(C*Pk2*(111*r - 36*s - 25) - 13*Pk2*(12*r + 3*s - 5) + Pkd2*k2*(20*C - 15)*(3*s - 1)) + k2**4*(Pk2*(-12*C*(74*r + 25*s - 33) + 591*r + 150*s - 247) + Pkd2*k2*(25 - 50*C)*(3*s - 1))) + 18*gd2*(3*k1**4*s*(-4*Pk2 + Pkd2*k2) + 2*k1**2*k2**2*(Pk2*(19*r - 4*s - 19) + 12*Pkd2*k2*s) + 10*k2**4*(2*Pk2*(2*r + s - 2) + Pkd2*k2*s))) - 198*fd*(10*Pk2*b2*k2**4*(2*r + 2*s - 1) + g2*(3*k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1) - 4*k1**2*k2**2*(Pk2*(19*r - 4*s + 2) + 6*Pkd2*k2*(2*s - 1)) - 10*k2**4*(Pk2*(8*r + 4*s - 2) + Pkd2*k2*(2*s - 1))))) + 2*Dd*f*(-990*Pk2*b2*k2**4*(4*r + 4*s - 3) + 75*f**2*k1**2*(-44*Pk2*k2**2*(3*r + 2*s - 2) + 7*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 11*f*(k1**4*(15*C - 15)*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 6*k1**2*k2**2*(2*C*Pk2*(74*r - 24*s - 31) - 13*Pk2*(16*r + 4*s - 9) + Pkd2*k2*(20*C - 15)*(4*s - 1)) + k2**4*(-4*Pk2*(C*(296*r + 100*s - 173) - 197*r - 50*s + 111) + Pkd2*k2*(25 - 50*C)*(4*s - 1))) - 99*g2*(3*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 4*k1**2*k2**2*(Pk2*(38*r - 8*s - 17) + 6*Pkd2*k2*(4*s - 1)) - 10*k2**4*(2*Pk2*(8*r + 4*s - 5) + Pkd2*k2*(4*s - 1))))))/(1155*d*k2*k3**4) - 1j*D1**3*Pk3*ct**3*(210*Dd*Pk2*b1**3*k1**2*k2**2*(K - 1)*(4*r + 4*s - 3) + 3*b1**2*(D1*(70*Pk2*bd1*k1**2*k2**2*(K - 1)*(3*r + 3*s - 2) - 140*Pk2*gd2*k1**2*k2**2*(r + s - 1) + fd*(k1**4*s*(21*K - 21)*(2*Pk2 - Pkd2*k2) + 2*k1**2*k2**2*(Pk2*(42*C*(r + s - 1) - 7*K*(5*r + 2*s + 6) + 15*f*(4*r + 4*s - 1) + 77*r + 56*s + 63) + Pkd2*k2*s*(-42*K + 45*f + 21)) - 21*k2**4*(2*K*Pk2*(r + s + 1) + K*Pkd2*k2*s - Pk2*r + f*(-2*Pk2*r + Pk2)))) + Dd*(-140*Pk2*g2*k1**2*k2**2*(4*r + 4*s - 3) + 3*f**2*k2**2*(14*Pk2*k2**2*(2*r - 1) + 5*k1**2*(4*Pk2*(4*r + 4*s - 3) + 3*Pkd2*k2*(4*s - 1))) + 7*f*(k1**4*(3*K - 3)*(2*Pk2 - Pkd2*k2)*(4*s - 1) + 2*k1**2*k2**2*(2*Pk2*(3*C*(4*r + 4*s - 3) - 2*K*(5*r + 2*s - 3) + 22*r + 16*s - 15) + 3*Pkd2*k2*(K*(2 - 8*s) + 4*s - 1)) - 3*k2**4*(K*Pkd2*k2*(4*s - 1) + Pk2*(K*(8*r + 8*s - 6) - 4*r + 2))))) + b1*(3*D1*bd1*(-140*Pk2*g2*k1**2*k2**2*(2*r + 2*s - 1) + 3*f**2*k2**2*(7*Pk2*k2**2*(2*r - 1) + 5*k1**2*(2*Pk2*(4*r + 4*s - 5) + 3*Pkd2*k2*(2*s - 1))) + 7*f*(k1**4*(3*K - 3)*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 2*k1**2*k2**2*(Pk2*(-6*C*(2*r + 2*s - 1) + K*(10*r + 4*s - 13) - 22*r - 16*s + 28) + Pkd2*k2*(6*K - 3)*(2*s - 1)) - 3*k2**4*(K*Pk2*(4*r + 4*s - 6) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r + Pk2))) + D1*(5*f**2*fd*k1**2*(27*Pk2*k2**2*(8*s - 1) + 7*k1**2*(4*Pk2*(3*r + 6*s - 2) - Pkd2*k2*(6*s + 1))) - 3*f*(42*Pk2*bd2*k2**4*(r + s - 1) + 3*fd*(k1**4*(-2*Pk2*(20*C*s + K*(12 - 24*s) + 10*r + 14*s - 17) + Pkd2*k2*s*(20*C - 20)) + k1**2*k2**2*(2*Pk2*(C*(44*r + 8*s - 2) + K*(68*r + 134*s - 67) - 103*r - 100*s + 53) + 5*Pkd2*k2*(K*(2*s - 1) + s*(16*C - 12))) + k2**4*(Pk2*(8*C*(9*r + 5*s - 2) + 28*K*(r + 2*s - 1) - 54*r - 20*s + 17) + Pkd2*k2*s*(20*C - 10))) - 14*gd2*(k1**4*(-6*Pk2*s + 3*Pkd2*k2*s) + 2*k1**2*k2**2*(Pk2*(5*r + 2*s - 5) + 6*Pkd2*k2*s) + 3*k2**4*(2*Pk2*(r + s - 1) + Pkd2*k2*s))) + 42*fd*(-3*Pk2*b2*k2**4*(r + s) + g2*(k1**4*(-6*Pk2*s + 3*Pkd2*k2*s) + 2*k1**2*k2**2*(Pk2*(5*r + 2*s + 6) + 6*Pkd2*k2*s) + 3*k2**4*(2*Pk2*(r + s + 1) + Pkd2*k2*s)))) + Dd*f*(-126*Pk2*b2*k2**4*(4*r + 4*s - 3) + 10*f**2*k1**2*(36*Pk2*k2**2*(4*s - 1) + 7*k1**2*(8*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 4*s))) + 9*f*(2*k1**4*(Pk2*(10*C*(4*s - 1) - 48*K*s + 12*K + 20*r + 28*s - 17) + 5*Pkd2*k2*(-4*C*s + C + 4*s - 1)) + k1**2*k2**2*(-2*Pk2*(8*C*(11*r + 2*s - 6) + K*(136*r + 268*s - 135) - 206*r - 200*s + 153) + Pkd2*k2*(4*s - 1)*(-40*C - 5*K + 30)) + k2**4*(-4*Pk2*(C*(36*r + 20*s - 23) + 14*K*(r + 2*s - 1) - 27*r - 10*s + 16) + Pkd2*k2*(5 - 10*C)*(4*s - 1))) - 42*g2*(3*k1**4*(2*Pk2 - Pkd2*k2)*(4*s - 1) - 4*k1**2*k2**2*(2*Pk2*(5*r + 2*s - 3) + 3*Pkd2*k2*(4*s - 1)) - 3*k2**4*(Pk2*(8*r + 8*s - 6) + Pkd2*k2*(4*s - 1))))) + f*(D1*bd1*(-126*Pk2*b2*k2**4*(r + s - 1) + 5*f**2*k1**2*(9*Pk2*k2**2*(8*s - 5) + 7*k1**2*(4*Pk2*(r + 2*s - 2) + Pkd2*k2*(3 - 2*s))) + 9*f*(2*k1**4*(Pk2*(10*C*(s - 1) - 12*K*s + 5*r + 7*s + 5) + 5*Pkd2*k2*(-C*s + C + s - 1)) - k1**2*k2**2*(Pk2*(44*C*r + 8*C*(s - 6) + 2*K*(34*r + 67*s - 34) - 103*r - 100*s + 97) + 5*Pkd2*k2*(8*C*(s - 1) + s*(K - 6) + 6)) + k2**4*(Pk2*(-4*C*(9*r + 5*s - 10) - 14*K*(r + 2*s - 1) + 27*r + 10*s - 20) + 5*Pkd2*k2*(-2*C*(s - 1) + s - 1))) - 42*g2*(3*k1**4*(2*Pk2 - Pkd2*k2)*(s - 1) - 2*k1**2*k2**2*(Pk2*(5*r + 2*s - 8) + 6*Pkd2*k2*(s - 1)) - 3*k2**4*(2*Pk2*(r + s - 2) + Pkd2*k2*(s - 1)))) + D1*(-70*Pk2*f**2*fd*k1**4*(10*r + 24*s - 11) + f*(-270*Pk2*bd2*k1**2*k2**2*(r + s - 1) - 5*fd*(-2*Pk2*k1**4*(C*(32 - 96*s) + 21*r + 117*s - 46) + Pk2*k2**4*(4*C - 2)*(39*r + 54*s - 31) + k1**2*k2**2*(Pk2*(4*C*(150*r + 267*s - 139) - 387*r - 738*s + 375) + Pkd2*k2*(14*C - 7)*(3*s - 1))) + 18*gd2*(24*Pk2*k1**4*s + 14*Pk2*k2**4*(r + 2*s - 1) + k1**2*k2**2*(2*Pk2*(34*r + 67*s - 34) + 5*Pkd2*k2*s))) + 18*fd*(-15*Pk2*b2*k1**2*k2**2*(2*r + 2*s - 1) + g2*(24*Pk2*k1**4*(2*s - 1) + 28*Pk2*k2**4*(r + 2*s - 1) + k1**2*k2**2*(2*Pk2*(68*r + 134*s - 67) + 5*Pkd2*k2*(2*s - 1))))) + Dd*f*(-270*Pk2*b2*k1**2*k2**2*(4*r + 4*s - 3) - 70*Pk2*f**2*k1**4*(10*r + 24*s - 11) - 5*f*(2*Pk2*k1**4*(32*C*(4*s - 1) - 28*r - 156*s + 53) + Pk2*k2**4*(16*C - 8)*(13*r + 18*s - 11) + k1**2*k2**2*(4*Pk2*(C*(200*r + 356*s - 189) - 129*r - 246*s + 126) + Pkd2*k2*(14*C - 7)*(4*s - 1))) + 18*g2*(24*Pk2*k1**4*(4*s - 1) + 56*Pk2*k2**4*(r + 2*s - 1) + k1**2*k2**2*(Pk2*(272*r + 536*s - 270) + 5*Pkd2*k2*(4*s - 1))))))/(105*d*k2*k3**4) - 1j*D1**3*Pk3*ct**2*f*k1*st**4*(4*Pk2 - Pkd2*k2)*(3*b1*(D1*fd*(3*f*s - f + 2*s - 1) + Dd*f*(f + 1)*(4*s - 1)) + f*(3*D1*bd1*s*(f + 1) + D1*fd*(3*s - 1) + Dd*f*(4*s - 1)))/(7*d*k3**2) - 1j*D1**3*Pk3*ct**2*f*k1*st**4*(D1*(15*f**2*(11*bd1*k2**2*(2*Pk2*(r - 1) + Pkd2*k2*s) + fd*(44*Pk2*k2**2*(1 - 2*r) + 15*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 11*f*(-3*bd1*(-Pk2*k1**2*s*(8*K - 8) + 10*Pk2*k2**2*(K*(r - 2*s - 1) - 2*r + 2) + Pkd2*k1**2*k2*s*(2*K - 2) + Pkd2*k2**3*s*(10*K - 5)) + fd*(k1**2*(4*C - 4)*(4*Pk2 - Pkd2*k2)*(3*s - 1) - k2**2*(6*Pk2*(2*C*(7*r - 10*s + 1) - 19*r + 10*s + 3) + Pkd2*k2*(20*C - 15)*(3*s - 1))) + 12*gd2*(-4*Pk2*k1**2*s + 5*Pk2*k2**2*(r - 2*s - 1) + Pkd2*k1**2*k2*s + 5*Pkd2*k2**3*s)) + 132*fd*g2*(-k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 5*k2**2*(2*Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1)))) + Dd*f*(15*f**2*(44*Pk2*k2**2*(1 - 2*r) + 15*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 11*f*(k1**2*(4*C - 4)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(-8*Pk2*(2*C*(7*r - 10*s - 1) - 19*r + 10*s + 7) + Pkd2*k2*(15 - 20*C)*(4*s - 1))) - 132*g2*(k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 5*k2**2*(-4*Pk2*r + 8*Pk2*s - 4*Pkd2*k2*s + Pkd2*k2))) + 33*b1*(D1*fd*(k1**2*(2*K - 2)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 5*k2**2*(-4*K*Pk2*(r - 2*s + 1) + 2*K*Pkd2*k2*(1 - 2*s) + Pk2*f*(6*r - 2) + 8*Pk2*r + Pkd2*f*k2*(3*s - 1) + 2*Pkd2*k2*s - Pkd2*k2)) + Dd*f*(k1**2*(2*K - 2)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 5*k2**2*(-4*Pk2*(-4*K*s - 2*f*r + f + r*(2*K - 4) + 2) + Pkd2*k2*(4*s - 1)*(-2*K + f + 1)))))/(385*d*k3**4) + 3*1j*D1**3*Pk3*ct**2*k1*st**2*(-4*Pk2 + Pkd2*k2)*(3*D1*bd1*f**2*s + b1**2*(D1*fd*(12*f*s - 6*f + 7*s - 7) + Dd*f*(6*f + 7)*(4*s - 1)) + b1*f*(2*D1*bd1*s*(6*f + 7) + D1*fd*(6*s - 3) + 3*Dd*f*(4*s - 1)))/(35*d*k2**2) - 1j*D1**3*Pk3*ct**2*k1*(-21*b1**3*k2**2*(-3*D1*Pkd2*fd*k2*s + 20*Dd*Pk2*(K - 1)*(2*r - 1) - Dd*Pkd2*k2*(4*s - 1)*(-10*K + 3*f + 5)) + 3*b1**2*(D1*(-7*bd1*k2**2*(Pk2*(10*K - 10)*(3*r - 1) - Pkd2*k2*(3*s - 1)*(-10*K + 3*f + 5)) + fd*(Pk2*k1**2*s*(120*f + 42) - 7*Pk2*k2**2*(20*C*(r - 1) + 26*K*s - 26*K + 24*f*r - 9*f - 4*r + 33) - Pkd2*k1**2*k2*s*(60*f + 21) + Pkd2*k2**3*s*(-84*C + 42*K + 63)) + 140*gd2*k2**2*(Pk2*(r - 1) + Pkd2*k2*s)) + Dd*(6*f**2*(28*Pk2*k2**2*(1 - 2*r) + 5*k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1)) + 7*f*(3*k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(-2*Pk2*(40*C*r - 20*C + 52*K*s - 13*K - 8*r + 4) + Pkd2*k2*(4*s - 1)*(-12*C + 6*K + 9))) + 140*g2*k2**2*(Pk2*(4*r - 2) + Pkd2*k2*(4*s - 1)))) + 3*b1*(D1*bd1*(3*f**2*(7*Pk2*k2**2*(5 - 8*r) + 10*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1)) + 7*f*(3*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(Pk2*(-40*C*r - 52*K*s + 8*r + 29) + Pkd2*k2*(2*s - 1)*(-12*C + 6*K + 9))) + 140*g2*k2**2*(2*Pk2*r + Pkd2*k2*(2*s - 1))) + D1*(-90*Pk2*f**2*fd*k1**2*(3*s - 1) + f*(-3*fd*(k1**2*(Pk2*(18*s - 19) + 10*Pkd2*k2*s) + k2**2*(Pk2*(76*C*(2*s - 1) - 14*K*(2*r + 6*s - 3) + 64*r - 76*s + 25) + Pkd2*k2*s*(20 - 40*C))) + 14*k2**2*s*(26*Pk2*gd2 + 3*Pkd2*bd2*k2 - 6*Pkd2*gd2*k2)) + 14*fd*k2**2*(26*Pk2*g2*(s - 1) + 3*Pkd2*b2*k2*s - 6*Pkd2*g2*k2*s)) + Dd*f*(-90*Pk2*f**2*k1**2*(4*s - 1) - 3*f*k1**2*(9*Pk2 + 5*Pkd2*k2)*(4*s - 1) + 6*f*k2**2*(Pk2*(-38*C*(4*s - 1) + 7*K*(4*r + 12*s - 5) - 64*r + 76*s + 13) + Pkd2*k2*(10*C - 5)*(4*s - 1)) + 14*k2**2*(4*s - 1)*(26*Pk2*g2 + 3*Pkd2*b2*k2 - 6*Pkd2*g2*k2))) + f*(-3*D1*bd1*(90*Pk2*f**2*k1**2*s + 3*f*(k1**2*(Pk2*(9*s + 10) + 5*Pkd2*k2*(s - 1)) + k2**2*(Pk2*(76*C*s - 14*K*(r + 3*s - 1) + 32*r - 38*s - 19) + Pkd2*k2*(10 - 20*C)*(s - 1))) - 14*k2**2*(26*Pk2*g2*s + 3*Pkd2*b2*k2*(s - 1) - 6*Pkd2*g2*k2*(s - 1))) + Pk2*(D1*(f*(-125*fd*k1**2*(3*s - 1) + fd*k2**2*(20*C - 10)*(33*r + 81*s - 38) + k2**2*(126*bd2 - 252*gd2)*(r + 3*s - 1)) + 126*fd*k2**2*(b2 - 2*g2)*(2*r + 6*s - 3)) + Dd*f*(-125*f*k1**2*(4*s - 1) + f*k2**2*(20*C - 10)*(44*r + 108*s - 49) + k2**2*(126*b2 - 252*g2)*(4*r + 12*s - 5)))))/(105*d*k2**2*k3**2) + 1j*D1**3*Pk3*ct**2*(3*D1*Pk2*bd1*f**2*(19*k1**2*s + k2**2*r*(4 - 8*C)) - 7*b1**3*k1**2*(2*Pk2 - Pkd2*k2)*(3*D1*fd*s + Dd*(3*f + 5)*(4*s - 1)) - 7*b1**2*k1**2*(D1*bd1*(2*Pk2 - Pkd2*k2)*(3*f + 5)*(3*s - 1) + D1*fd*(Pk2*(-18*f*s + 9*f - 7*s + 13) - 3*Pkd2*k2*s) - Dd*f*(4*s - 1)*(Pk2*(9*f + 7) + 3*Pkd2*k2)) + b1*f*(7*D1*bd1*k1**2*(2*Pk2*(9*f*s + 7*s + 3) + 3*Pkd2*k2*(2*s - 1)) - 3*Pk2*(D1*fd*(k1**2*(19 - 38*s) + k2**2*(8*C - 4)*(2*r - 1)) + Dd*f*(k1**2*(19 - 76*s) + k2**2*(16*C - 8)*(2*r - 1)))))/(35*d*k1*k2**2) + 1j*D1**3*Pk3*ct**2*st**2*(3*b1**2*k1**2*k2**2*(D1*fd*(-2*Pk2*(-7*K*(r - 2*s + 2) + 6*f + 7*r + 7) + Pkd2*k2*(14*K*(s - 1) + 6*f + 7)) + 14*Dd*f*(K*Pkd2*k2*(4*s - 1) + Pk2*(-8*K*s + r*(4*K - 4) + 2))) + b1*k1**2*(D1*(f**2*(18*Pk2*fd*k2**2*(18*r + 15*s - 13) - 18*bd1*k2**2*(-2*Pk2 + Pkd2*k2) - 20*fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) + f*(fd*(-9*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(4*Pk2*(C*(26*r - 36*s + 5) + 36*K*s - 18*K + 13*r + 69*s - 26) + 9*Pkd2*k2*(C*(8*s - 4) - 8*K*s + 4*K - 4*s + 3))) + 21*k2**2*(Pk2*bd1*(K*(4*r - 8*s - 2) - 4*r + 4) + Pkd2*bd1*k2*(4*K*s - 1) + 4*gd2*(-Pk2*r + 2*Pk2*s + Pk2 - Pkd2*k2*s))) - 84*fd*g2*k2**2*(Pk2*(r - 2*s + 2) + Pkd2*k2*(s - 1))) + Dd*f*(f**2*(18*Pk2*k2**2*(24*r + 20*s - 17) - 20*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + f*(-9*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 2*k2**2*(Pk2*(8*C*(13*r - 18*s - 2) + 36*K*(4*s - 1) + 52*r + 276*s - 95) + Pkd2*k2*(4*s - 1)*(18*C - 18*K - 9))) - 84*g2*k2**2*(4*Pk2*(r - 2*s) + Pkd2*k2*(4*s - 1)))) + f*(D1*(2*bd1*f**2*k1**2*(-40*Pk2*k1**2*s + 9*Pk2*k2**2*(6*r + 5*s - 4) + 10*Pkd2*k1**2*k2*s) + f*(fd*(Pk2*k2**4*(16 - 32*C)*(3*r - 1) - 5*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1) - 2*k1**2*k2**2*(Pk2*(-120*C*s + 40*C - 81*r - 9*s + 30) + Pkd2*k2*(20*C - 10)*(3*s - 1))) + k1**2*(bd1*(-36*Pk2*k1**2*s + 2*Pk2*k2**2*(r*(26*C + 13) + s*(-36*C + 36*K + 69) - 30) + 9*Pkd2*k1**2*k2*s + 9*Pkd2*k2**3*(s*(4*C - 4*K - 2) - 1)) + k2**2*s*(-2*Pk2 + Pkd2*k2)*(-36*bd2 + 72*gd2))) - 12*k1**2*k2**2*(-3*b2*fd*(2*Pk2 - Pkd2*k2)*(2*s - 1) + 7*bd1*g2*(Pk2*(r - 2*s) + Pkd2*k2*s) + 6*fd*g2*(2*Pk2 - Pkd2*k2)*(2*s - 1))) + Dd*f*(f*(Pk2*k2**4*(32 - 64*C)*(2*r - 1) - 5*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 2*k1**2*k2**2*(40*C*Pk2*(4*s - 1) + 3*Pk2*(36*r + 4*s - 19) - Pkd2*k2*(20*C - 10)*(4*s - 1))) + k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(-36*b2 + 72*g2)*(4*s - 1))))/(35*d*k1*k2**2*k3**2) - 1j*D1**3*Pk3*ct**2*st**2*(D1*(-231*b1*fd*k1**2*k2**2*(2*b1*k1**2*(K - 1)*(-Pk2*(r + 3*s - 1) + Pkd2*k2*s) - 3*b1*k2**2*(2*Pk2*(K*(r + 2*s - 2) + r + 1) + Pkd2*k2*s*(1 - 2*K)) + 4*g2*k1**2*(Pk2*(r + 3*s - 1) - Pkd2*k2*s) + 12*g2*k2**2*(Pk2*(r + 2*s - 2) - Pkd2*k2*s)) + 6*f**3*k1**2*(99*Pk2*bd1*k2**4*(4*r + 5*s - 6) - 165*Pk2*fd*k1**2*k2**2*(16*r + 20*s - 13) + 55*bd1*k1**2*k2**2*(2*Pk2*(5*r + 5*s - 6) + 3*Pkd2*k2) + 35*fd*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 11*f**2*k2**2*(-3*bd1*(k1**4*(2*Pk2*(6*C*(r + 3*s - 2) + K*(-16*r - 21*s + 16) + 37*r + 39*s - 31) - 3*Pkd2*k2*(4*C*(s - 1) + s*(6*K - 7) + 4)) + k1**2*k2**2*(Pk2*(20*C*r + 72*C*s - 24*K*(11*r + 13*s - 11) - 36*b1 + 94*r + 66*s - 96) - 9*Pkd2*k2*(4*C*(s - 1) + 4*K*s + b1*(2 - 4*s) - 3*s + 3))) + fd*(Pk2*k2**4*(96*C - 48)*(3*r - 1) + k1**4*(Pk2*(4*C*(84*r + 81*s - 55) - 180*b1*(5*r + 5*s - 3) - 606*r - 684*s + 430) + 15*Pkd2*k2*(6*b1 + (4*C - 3)*(3*s - 1))) + 6*k1**2*k2**2*(Pk2*(8*C*(63*r + 57*s - 40) - 9*b1*(12*r + 15*s - 7) - 333*r - 297*s + 210) + Pkd2*k2*(20*C - 10)*(3*s - 1))) - 12*k1**2*(-27*Pk2*bd2*k2**2*(r + s - 1) + gd2*k1**2*(Pk2*(16*r + 21*s - 16) + 9*Pkd2*k2*s) + 6*gd2*k2**2*(Pk2*(22*r + 26*s - 22) + 3*Pkd2*k2*s))) + 33*f*k1**2*k2**2*(36*b1**2*fd*k2**2*(Pk2 + Pkd2*k2*s) + b1*(7*bd1*(k1**2*(2*K - 2)*(Pk2*(2*r + 6*s - 3) + Pkd2*k2*(1 - 2*s)) - 3*k2**2*(Pk2*(K*(-4*r - 8*s + 2) - 4*r + 4) + Pkd2*k2*(2*K - 1)*(2*s - 1))) + fd*k1**2*(2*Pk2*(12*C*(r + 3*s - 1) + K*(-32*r - 42*s + 21) + 74*r + 78*s - 45) - 3*Pkd2*k2*(6*K*(2*s - 1) + s*(8*C - 14) + 3)) + 2*fd*k2**2*(2*Pk2*(C*(10*r + 36*s - 23) - 6*K*(22*r + 26*s - 13) + 47*r + 33*s - 16) - 9*Pkd2*k2*(K*(4*s - 2) + s*(4*C - 3))) + 28*gd2*k1**2*(-Pk2*(r + 3*s - 1) + Pkd2*k2*s) + 84*gd2*k2**2*(-Pk2*(r + 2*s - 1) + Pkd2*k2*s)) - 28*bd1*g2*(k1**2*(Pk2*(r + 3*s - 2) - Pkd2*k2*(s - 1)) + 3*k2**2*(Pk2*(r + 2*s) + k2*(-Pkd2*s + Pkd2))) - 4*fd*(27*Pk2*b2*k2**2*(2*r + 2*s - 1) - g2*(k1**2*(Pk2*(32*r + 42*s - 21) + 9*Pkd2*k2*(2*s - 1)) + 6*k2**2*(Pk2*(44*r + 52*s - 26) + 3*Pkd2*k2*(2*s - 1)))))) + Dd*f*(-231*b1*k1**2*k2**2*(-2*b1*k1**2*(K - 1)*(Pk2*(4*r + 12*s - 5) + Pkd2*k2*(1 - 4*s)) + 3*b1*k2**2*(-4*Pk2*(2*K*(r + 2*s - 1) + 2*r - 1) + Pkd2*k2*(2*K - 1)*(4*s - 1)) + 4*g2*k1**2*(Pk2*(4*r + 12*s - 5) + Pkd2*k2*(1 - 4*s)) + 12*g2*k2**2*(4*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 4*s))) + 30*f**3*k1**4*(-33*Pk2*k2**2*(16*r + 20*s - 13) + 7*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 11*f**2*k2**2*(Pk2*k2**4*(192*C - 96)*(2*r - 1) + k1**4*(-4*Pk2*(C*(-112*r - 108*s + 83) + 75*b1*(4*r + 4*s - 3) + 202*r + 228*s - 158) + Pkd2*k2*(60*C - 45)*(4*s - 1)) + 6*k1**2*k2**2*(Pk2*(8*C*(84*r + 76*s - 61) - 9*b1*(16*r + 20*s - 13) - 444*r - 396*s + 321) + Pkd2*k2*(20*C - 10)*(4*s - 1))) + 33*f*k1**2*k2**2*(-108*Pk2*b2*k2**2*(4*r + 4*s - 3) + 18*Pkd2*b1**2*k2**3*(4*s - 1) + b1*k1**2*(2*Pk2*(6*C*(4*r + 12*s - 5) + K*(-64*r - 84*s + 53) + 148*r + 156*s - 113) + Pkd2*k2*(4*s - 1)*(-12*C - 18*K + 21)) + b1*k2**2*(2*Pk2*(8*C*(5*r + 18*s - 7) - 12*K*(44*r + 52*s - 35) + 188*r + 132*s - 127) + Pkd2*k2*(4*s - 1)*(-36*C - 36*K + 27)) + 4*g2*k1**2*(Pk2*(64*r + 84*s - 53) + 9*Pkd2*k2*(4*s - 1)) + 24*g2*k2**2*(2*Pk2*(44*r + 52*s - 35) + 3*Pkd2*k2*(4*s - 1)))))/(1155*d*k1*k2**2*k3**4) + 1j*D1**3*Pk3*ct**2*(3*D1*b1*(5*f**2*fd*k1**4*(-14*Pk2*k1**2*s + 3*Pk2*k2**2*(24*r - 11) + 7*Pkd2*k1**2*k2*s) + f*k2**2*(3*fd*(Pk2*k2**4*(8*C - 4)*(2*r - 1) + k1**4*(Pk2*(8*C*(14*r + 17*s - 7) + 4*K*(5*r + 24*s - 12) - 172*r - 234*s + 105) + Pkd2*k2*s*(40*C - 30)) + 2*k1**2*k2**2*(Pk2*(2*C*(84*r + 78*s - 37) + 7*K*(2*r + 6*s - 3) - 116*r - 97*s + 53) + Pkd2*k2*s*(20*C - 10))) - 14*k1**2*(-9*Pk2*bd2*k2**2*(r + s - 1) + 2*gd2*(k1**2*(Pk2*(8*r + 11*s - 8) + 3*Pkd2*k2*s) + k2**2*(Pk2*(22*r + 25*s - 22) + 3*Pkd2*k2*s)))) - 14*fd*k1**2*k2**2*(-9*Pk2*b2*k2**2*(r + s) + 2*g2*(Pk2*k1**2*(8*r + 11*s) + Pk2*k2**2*(22*r + 25*s + 3) + 3*Pkd2*k1**2*k2*s + 3*Pkd2*k2**3*s))) + D1*bd1*(-210*Pk2*b1*k1**2*k2**2*(b1*(k1**2*(K - 1) + k2**2*(2*K - 1))*(3*r + 3*s - 2) - 2*g2*(k1**2 + 2*k2**2)*(2*r + 2*s - 1)) - 5*f**3*k1**4*(9*Pk2*k2**2*(5 - 8*r) + 7*k1**2*(2*Pk2 - Pkd2*k2)*(s - 1)) + 9*f**2*k2**2*(Pk2*k2**4*r*(8*C - 4) + k1**4*(Pk2*(C*(56*r + 68*s - 68) + 10*K*r + 48*K*s - 10*K - 10*b1*(8*r + 8*s - 7) - 86*r - 117*s + 98) + 5*Pkd2*k2*(b1*(3 - 6*s) + (4*C - 3)*(s - 1))) + k1**2*k2**2*(Pk2*(4*C*(42*r + 39*s - 44) + 14*K*r + 42*K*s - 14*K - 21*b1*(4*r + 2*s - 3) - 116*r - 97*s + 107) + Pkd2*k2*(20*C - 10)*(s - 1))) + 21*f*k1**2*k2**2*(6*Pk2*b1**2*k2**2*(3*r + 3*s - 2) + 18*Pk2*b2*k2**2*(r + s - 1) + b1*(k1**2*(-2*Pk2*(6*C*(2*r + 2*s - 1) + K*(-16*r - 22*s + 19) + 22*r + 28*s - 31) + Pkd2*k2*(6*K - 3)*(2*s - 1)) + k2**2*(6*K*Pkd2*k2*(2*s - 1) + Pk2*(-24*C*(2*r + 2*s - 1) + 4*K*(22*r + 25*s - 25) + 4*r + 10*s + 11))) - 4*g2*(k1**2*(8*Pk2*r + 11*Pk2*(s - 1) + 3*Pkd2*k2*(s - 1)) + k2**2*(Pk2*(22*r + 25*s - 28) + 3*Pkd2*k2*(s - 1))))) - Dd*b1*f*(5*f**2*k1**4*(144*Pk2*k2**2*(1 - 2*r) + 7*k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1)) - 9*f*k2**2*(Pk2*k2**4*(16*C - 8)*(2*r - 1) + k1**4*(Pk2*(4*C*(56*r + 68*s - 45) + 4*K*(10*r + 48*s - 17) - 344*r - 468*s + 289) + Pkd2*k2*(20*C - 15)*(4*s - 1)) + k1**2*k2**2*(Pk2*(12*C*(56*r + 52*s - 41) + 14*K*(4*r + 12*s - 5) - 464*r - 388*s + 329) + Pkd2*k2*(20*C - 10)*(4*s - 1))) + 42*k1**2*k2**2*(-9*Pk2*b2*k2**2*(4*r + 4*s - 3) + 2*g2*(k1**2*(Pk2*(32*r + 44*s - 27) + 3*Pkd2*k2*(4*s - 1)) + k2**2*(Pk2*(88*r + 100*s - 69) + 3*Pkd2*k2*(4*s - 1))))) - 42*Pk2*b1**3*k1**2*k2**2*(-3*D1*fd*k2**2*(r + s - 1) + Dd*(k1**2*(5*K - 5) + k2**2*(10*K - 3*f - 5))*(4*r + 4*s - 3)) + Pk2*f*k1**2*(D1*(105*f**2*fd*k1**4*(4*s - 1) + f*k2**2*(90*bd2*k1**2*(r + s - 1) + 5*fd*(k1**2*(12*C*(7*r + 32*s - 13) - 42*r - 267*s + 103) + k2**2*(4*C - 2)*(33*r + 81*s - 38)) - 36*gd2*(k1**2*(5*r + 24*s - 5) + 7*k2**2*(r + 3*s - 1))) - 18*fd*k2**2*(-5*b2*k1**2*(2*r + 2*s - 1) + 4*g2*k1**2*(5*r + 24*s - 12) + 14*g2*k2**2*(2*r + 6*s - 3))) + Dd*f*(105*f**2*k1**4*(4*s - 1) + 5*f*(k1**2*k2**2*(8*C*(14*r + 64*s - 23) - 56*r - 356*s + 117) + k2**4*(4*C - 2)*(44*r + 108*s - 49)) + 18*k2**2*(5*b2*k1**2*(4*r + 4*s - 3) - 2*g2*(k1**2*(20*r + 96*s - 34) + 7*k2**2*(4*r + 12*s - 5))))) - 3*b1**2*k1**2*k2**2*(D1*(-140*Pk2*gd2*(k1**2 + 2*k2**2)*(r + s - 1) + fd*k1**2*(2*Pk2*(42*C*(r + s - 1) - 56*K*r - 77*K*s + 15*f*(8*r + 8*s - 5) + 77*r + 98*s + 42) + Pkd2*k2*s*(-42*K + 90*f + 21)) - 7*fd*k2**2*(6*K*Pkd2*k2*s + Pk2*(-24*C*(r + s - 1) + 44*K*r + 50*K*s + 6*K - 18*f*(2*r + s - 1) + 2*r + 5*s - 18))) + Dd*(-140*Pk2*g2*(k1**2 + 2*k2**2)*(4*r + 4*s - 3) + 3*f**2*(21*Pk2*k2**2*(8*r + 4*s - 5) + 5*k1**2*(8*Pk2*(4*r + 4*s - 3) + 3*Pkd2*k2*(4*s - 1))) + 7*f*(k1**2*(2*Pk2*(6*C*(4*r + 4*s - 3) + K*(-32*r - 44*s + 27) + 44*r + 56*s - 36) + 3*Pkd2*k2*(K*(2 - 8*s) + 4*s - 1)) + k2**2*(6*K*Pkd2*k2*(1 - 4*s) + Pk2*(24*C*(4*r + 4*s - 3) - 2*K*(88*r + 100*s - 69) - 8*r - 20*s + 9))))))/(105*d*k1*k2**2*k3**4) + 1j*D1**3*Pk3*ct*f**3*k1**2*k2*st**6*(-4*Pk2 + Pkd2*k2)*(4*s - 1)*(D1*fd + Dd*f)/(11*d*k3**4) + 1j*D1**3*Pk3*ct*f*st**4*(D1*(15*bd1*f**2*(-4*Pk2*k1**2*s + Pk2*k2**2*(r - 1) + Pkd2*k1**2*k2*s) + f*(-3*bd1*(5*K*Pkd2*k2**3*s + 8*Pk2*k1**2*s - 5*Pk2*k2**2*(2*K*s + r - 1) - 2*Pkd2*k1**2*k2*s) - 2*fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + fd*k2**2*(Pk2*(60*C*s - 20*C + 27*r - 30*s + 1) + Pkd2*k2*(5 - 10*C)*(3*s - 1)) + k2**2*s*(-2*Pk2 + Pkd2*k2)*(-15*bd2 + 30*gd2)) - 15*fd*k2**2*(-2*Pk2 + Pkd2*k2)*(b2 - 2*g2)*(2*s - 1)) + Dd*f*(-2*f*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + f*k2**2*(4*Pk2*(5*C*(4*s - 1) + 9*r - 10*s - 2) + Pkd2*k2*(5 - 10*C)*(4*s - 1)) - k2**2*(-2*Pk2 + Pkd2*k2)*(15*b2 - 30*g2)*(4*s - 1)) - 3*b1*(D1*fd*(k1**2*(4*Pk2 - Pkd2*k2)*(5*f*(3*s - 1) + 4*s - 2) + 5*k2**2*(-K*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 2*Pk2*r + f*(-3*Pk2*r + Pk2))) + Dd*f*(k1**2*(4*Pk2 - Pkd2*k2)*(5*f + 2)*(4*s - 1) + 5*k2**2*(K*Pkd2*k2*(4*s - 1) + 2*Pk2*(-4*K*s + K - 2*f*r + f - 2*r + 1)))))/(35*d*k2*k3**2) - 1j*D1**3*Pk3*ct*f*st**4*(D1*(5*f**2*(11*bd1*k2**2*(3*Pk2*k2**2*(r - 1) + k1**2*(4*Pk2*(2*r + s - 2) + Pkd2*k2*(2*s + 1))) + 3*fd*(-44*Pk2*k1**2*k2**2*(3*r + 2*s - 2) + 5*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1))) - 11*f*k2**2*(30*Pk2*bd2*k2**2*(r + s - 1) + 6*bd1*k1**2*(Pk2*(K*(2*r - 3*s - 2) - 5*r - 2*s + 5) + Pkd2*k2*s*(2*K - 1)) + 15*bd1*k2**2*(2*K*Pk2*(2*r + s - 2) + K*Pkd2*k2*s - Pk2*r + Pk2) + fd*k1**2*(Pk2*(4*C*(6*r - 9*s + 1) - 60*b1*(2*r + s - 1) - 42*r + 6*s + 12) + Pkd2*k2*(b1*(15 - 30*s) + (8*C - 6)*(3*s - 1))) + fd*k2**2*(Pk2*(4*C*(42*r + 15*s - 19) + b1*(15 - 45*r) - 111*r - 30*s + 47) + Pkd2*k2*(10*C - 5)*(3*s - 1)) - 6*gd2*k1**2*(Pk2*(4*r - 6*s - 4) + 4*Pkd2*k2*s) - 30*gd2*k2**2*(2*Pk2*(2*r + s - 2) + Pkd2*k2*s)) - 33*fd*k2**2*(10*Pk2*b2*k2**2*(2*r + 2*s - 1) + 2*b1*k1**2*(Pk2*(K*(4*r - 6*s + 3) - 10*r - 4*s + 2) + Pkd2*k2*(2*K - 1)*(2*s - 1)) + 5*b1*k2**2*(K*Pk2*(8*r + 4*s - 2) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r) - 4*g2*k1**2*(Pk2*(4*r - 6*s + 3) + 2*Pkd2*k2*(2*s - 1)) - 10*g2*k2**2*(Pk2*(8*r + 4*s - 2) + Pkd2*k2*(2*s - 1)))) + Dd*f*(15*f**2*k1**2*(-44*Pk2*k2**2*(3*r + 2*s - 2) + 5*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 11*f*k2**2*(2*k1**2*(Pk2*(C*(-16*r + 24*s + 2) + 10*b1*(8*r + 4*s - 5) + 28*r - 4*s - 13) + Pkd2*k2*(4*s - 1)*(-4*C + 5*b1 + 3)) + k2**2*(2*Pk2*(-2*C*(56*r + 20*s - 33) + 15*b1*(2*r - 1) + 74*r + 20*s - 42) + Pkd2*k2*(5 - 10*C)*(4*s - 1))) - 33*k2**2*(10*Pk2*b2*k2**2*(4*r + 4*s - 3) + 2*b1*k1**2*(K*Pk2*(8*r - 12*s - 1) - 4*Pk2*(5*r + 2*s - 3) + Pkd2*k2*(2*K - 1)*(4*s - 1)) + 5*b1*k2**2*(K*Pkd2*k2*(4*s - 1) + 2*Pk2*(K*(8*r + 4*s - 5) - 2*r + 1)) + 4*g2*k1**2*(-8*Pk2*r + 12*Pk2*s + Pk2 - 8*Pkd2*k2*s + 2*Pkd2*k2) + 10*g2*k2**2*(-2*Pk2*(8*r + 4*s - 5) + Pkd2*k2*(1 - 4*s)))))/(385*d*k2*k3**4) + 1j*D1**3*Pk3*ct*st**2*(D1*bd1*f*(Pk2*f*(17*r + s*(36*C - 18)) + Pkd2*f*k2*s*(9 - 18*C) + s*(2*Pk2 - Pkd2*k2)*(21*b2 - 42*g2)) + 21*b1**2*(D1*fd*(K*(2*Pk2 - Pkd2*k2)*(s - 1) + Pk2*f*(2*r - 1) + Pk2*r) + Dd*f*(K*Pkd2*k2*(1 - 4*s) + Pk2*(8*K*s - 2*K + f*(4*r - 2) + 4*r - 2))) + b1*(72*C*D1*Pk2*f*fd*s - 36*C*D1*Pk2*f*fd - 36*C*D1*Pkd2*f*fd*k2*s + 18*C*D1*Pkd2*f*fd*k2 + 144*C*Dd*Pk2*f**2*s - 36*C*Dd*Pk2*f**2 - 72*C*Dd*Pkd2*f**2*k2*s + 18*C*Dd*Pkd2*f**2*k2 + 42*D1*Pk2*bd2*f*s + 34*D1*Pk2*f*fd*r - 36*D1*Pk2*f*fd*s + D1*Pk2*f*fd - 84*D1*Pk2*f*gd2*s - 84*D1*Pk2*fd*g2*s + 84*D1*Pk2*fd*g2 - 21*D1*Pkd2*bd2*f*k2*s + 18*D1*Pkd2*f*fd*k2*s - 9*D1*Pkd2*f*fd*k2 + 42*D1*Pkd2*f*gd2*k2*s + 42*D1*Pkd2*fd*g2*k2*s - 42*D1*Pkd2*fd*g2*k2 + 21*D1*bd1*f*(-2*K*Pkd2*k2*s + Pk2*(4*K*s + 2*f*r - f + 2*r - 1)) + 68*Dd*Pk2*f**2*r - 72*Dd*Pk2*f**2*s - 16*Dd*Pk2*f**2 - 336*Dd*Pk2*f*g2*s + 84*Dd*Pk2*f*g2 + 36*Dd*Pkd2*f**2*k2*s - 9*Dd*Pkd2*f**2*k2 + 168*Dd*Pkd2*f*g2*k2*s - 42*Dd*Pkd2*f*g2*k2 + 21*b2*(2*Pk2 - Pkd2*k2)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))))/(35*d*k2) + 1j*D1**3*Pk3*ct*(2*D1*Pk2*bd1*f*s*(-5*b2 + f*(3 - 6*C) + 10*g2) + 5*b1**3*(D1*Pk2*fd*(r - 1) + Dd*K*Pkd2*k2*(1 - 4*s) + 2*Dd*Pk2*(f + 1)*(2*r - 1)) + b1**2*(5*D1*bd1*(K*Pkd2*k2*(1 - 3*s) + Pk2*(f + 1)*(3*r - 1)) + D1*(Pk2*fd*(-10*K*(s - 1) + 7*r - 7) + Pkd2*fd*k2*s*(3 - 6*C) - Pkd2*k2*s*(5*bd2 - 10*gd2)) + Dd*(2*Pk2*f*(K*(5 - 20*s) + 14*r - 7) + 3*Pkd2*f*k2*(C*(2 - 8*s) + 4*s - 1) - Pkd2*k2*(5*b2 - 10*g2)*(4*s - 1))) + b1*(D1*(f*(2*Pk2*bd1*(-10*K*s + 7*r) - Pk2*fd*(12*C - 6)*(2*s - 1) + Pk2*s*(-10*bd2 + 20*gd2) - 3*Pkd2*bd1*k2*(2*C - 1)*(2*s - 1)) + 10*g2*(2*Pk2*fd*(s - 1) + Pkd2*bd1*k2*(2*s - 1))) - 2*Dd*Pk2*f*(4*s - 1)*(f*(6*C - 3) - 10*g2) - 5*b2*(2*D1*Pk2*fd*(s - 1) + D1*Pkd2*bd1*k2*(2*s - 1) + 2*Dd*Pk2*f*(4*s - 1))))/(5*d*k2) + 1j*D1**3*Pk3*ct*st**2*(-3*b1**2*(D1*fd*(21*K*k2**2*(-2*Pk2*r + Pkd2*k2) + k1**2*(2*Pk2*(-7*K*s + 7*K + 36*f*s + 9*f + 21*s - 7) - Pkd2*k2*(36*f*s + 9*f + 14*s))) + 2*Dd*f*(42*K*Pk2*k2**2*(1 - 2*r) + k1**2*(4*s - 1)*(Pk2*(-7*K + 18*f + 21) - Pkd2*k2*(9*f + 7)))) - 3*b1*(D1*bd1*f*(-21*K*k2**2*(Pk2*(4*r - 2) + Pkd2*k2) + k1**2*(Pk2*(18*f*(4*s - 3) - 28*s*(K - 3) - 28) + Pkd2*k2*(-9*f*(4*s - 3) - 28*s + 14))) + D1*(-27*Pk2*f**2*fd*k1**2*(6*r + 12*s - 7) + f*(28*Pk2*gd2*(k1**2*s + 3*k2**2*(r - 1)) + 21*Pkd2*bd2*k2**3*s - fd*k1**2*(2*Pk2*(6*C*(2*s - 1) + 18*K*s - 9*K + 23*r + 36*s - 24) + 3*Pkd2*k2*(K*(3 - 6*s) + 4*s)) + fd*k2**2*(2*Pk2*(C*(34 - 68*r) + 42*K*(r + 2*s - 1) + 34*r - 17) + Pkd2*k2*(18*C - 9))) + 7*fd*(4*Pk2*g2*k1**2*(s - 1) + 3*Pkd2*b2*k2**3*s - 6*g2*k2**2*(-2*Pk2*r + Pkd2*k2))) + Dd*f*(-216*Pk2*f**2*k1**2*(r + 2*s - 1) + 4*Pk2*f*k2**2*(C*(34 - 68*r) + 42*K*(r + 2*s - 1) + 34*r - 17) + 28*Pk2*g2*(k1**2*(4*s - 1) + 6*k2**2*(2*r - 1)) + 21*Pkd2*b2*k2**3*(4*s - 1) + f*k1**2*(-2*Pk2*(6*C*(4*s - 1) + 36*K*s - 9*K + 46*r + 72*s - 41) + Pkd2*k2*(9*K - 6)*(4*s - 1)))) + f*(180*C*D1*Pk2*f*fd*k1**2*s - 60*C*D1*Pk2*f*fd*k1**2 - 612*C*D1*Pk2*f*fd*k2**2*r - 648*C*D1*Pk2*f*fd*k2**2*s + 420*C*D1*Pk2*f*fd*k2**2 - 90*C*D1*Pkd2*f*fd*k1**2*k2*s + 30*C*D1*Pkd2*f*fd*k1**2*k2 + 240*C*Dd*Pk2*f**2*k1**2*s - 60*C*Dd*Pk2*f**2*k1**2 - 816*C*Dd*Pk2*f**2*k2**2*r - 864*C*Dd*Pk2*f**2*k2**2*s + 624*C*Dd*Pk2*f**2*k2**2 - 120*C*Dd*Pkd2*f**2*k1**2*k2*s + 30*C*Dd*Pkd2*f**2*k1**2*k2 + 54*D1*Pk2*bd2*f*k1**2*s - 126*D1*Pk2*bd2*f*k2**2*r - 252*D1*Pk2*bd2*f*k2**2*s + 126*D1*Pk2*bd2*f*k2**2 + 123*D1*Pk2*f*fd*k1**2*r + 162*D1*Pk2*f*fd*k1**2*s - 95*D1*Pk2*f*fd*k1**2 + 306*D1*Pk2*f*fd*k2**2*r + 324*D1*Pk2*f*fd*k2**2*s - 210*D1*Pk2*f*fd*k2**2 - 108*D1*Pk2*f*gd2*k1**2*s + 252*D1*Pk2*f*gd2*k2**2*r + 504*D1*Pk2*f*gd2*k2**2*s - 252*D1*Pk2*f*gd2*k2**2 - 216*D1*Pk2*fd*g2*k1**2*s + 108*D1*Pk2*fd*g2*k1**2 + 504*D1*Pk2*fd*g2*k2**2*r + 1008*D1*Pk2*fd*g2*k2**2*s - 504*D1*Pk2*fd*g2*k2**2 - 27*D1*Pkd2*bd2*f*k1**2*k2*s + 45*D1*Pkd2*f*fd*k1**2*k2*s - 15*D1*Pkd2*f*fd*k1**2*k2 + 54*D1*Pkd2*f*gd2*k1**2*k2*s + 108*D1*Pkd2*fd*g2*k1**2*k2*s - 54*D1*Pkd2*fd*g2*k1**2*k2 + 3*D1*bd1*(27*Pk2*f**2*k1**2*(2*r + 4*s - 1) - 21*Pkd2*b2*k2**3*(s - 1) + f*k1**2*(Pk2*(23*r + s*(12*C + 18*K + 36) - 11) - 3*Pkd2*k2*(s*(3*K - 2) + 2)) + f*k2**2*(-42*K*Pk2*(r + 2*s - 1) + (2*C - 1)*(34*Pk2*r + 9*Pkd2*k2)) - 14*g2*(2*Pk2*k1**2*s + 6*Pk2*k2**2*r + 3*Pkd2*k2**3)) + 164*Dd*Pk2*f**2*k1**2*r + 216*Dd*Pk2*f**2*k1**2*s - 136*Dd*Pk2*f**2*k1**2 + 408*Dd*Pk2*f**2*k2**2*r + 432*Dd*Pk2*f**2*k2**2*s - 312*Dd*Pk2*f**2*k2**2 - 432*Dd*Pk2*f*g2*k1**2*s + 108*Dd*Pk2*f*g2*k1**2 + 1008*Dd*Pk2*f*g2*k2**2*r + 2016*Dd*Pk2*f*g2*k2**2*s - 1008*Dd*Pk2*f*g2*k2**2 + 60*Dd*Pkd2*f**2*k1**2*k2*s - 15*Dd*Pkd2*f**2*k1**2*k2 + 216*Dd*Pkd2*f*g2*k1**2*k2*s - 54*Dd*Pkd2*f*g2*k1**2*k2 + 9*b2*(D1*fd*(-28*Pk2*k2**2*(r + 2*s - 1) + 3*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1)) + Dd*f*(-56*Pk2*k2**2*(r + 2*s - 1) + 3*k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1)))))/(105*d*k2*k3**2) - 1j*D1**3*Pk3*ct*(-7*b1**3*(D1*fd*k2*(-5*Pk2*k2*(r - 1) - 3*Pkd2*k1**2*s) + Dd*(k1**2*(4*s - 1)*(Pk2*(10*K - 10) - 3*Pkd2*f*k2) + 5*k2**2*(K*Pkd2*k2*(4*s - 1) + 2*Pk2*(K*(4*r + 4*s - 3) - 2*f*r + f - 2*r + 1)))) - 7*b1**2*(D1*bd1*(k1**2*(3*s - 1)*(Pk2*(10*K - 10) - 3*Pkd2*f*k2) + 5*k2**2*(K*Pkd2*k2*(3*s - 1) + Pk2*(K*(6*r + 6*s - 4) - 3*f*r + f - 3*r + 1))) + D1*(3*Pk2*f*fd*k1**2*(12*r + 8*s - 7) + fd*(-3*K*Pkd2*k1**2*k2*s + Pk2*k1**2*(12*C*s + 13*r + 4*s) + Pk2*k2**2*(4*C*(7*r + 3*s - 7) - 10*K*(r + 1) - 21*r - 6*s + 21) + Pkd2*k2**3*s*(6*C - 3)) - 10*gd2*(2*Pk2*k1**2*s + 2*Pk2*k2**2*(r + s - 1) + Pkd2*k2**3*s)) + Dd*(24*Pk2*f**2*k1**2*(3*r + 2*s - 2) + f*(k1**2*(3*K*Pkd2*k2*(1 - 4*s) + 2*Pk2*(24*C*s - 6*C + 26*r + 8*s - 15)) + k2**2*(4*Pk2*(C*(28*r + 12*s - 17) - 10*K*r + 5*K - 21*r - 6*s + 12) + Pkd2*k2*(6*C - 3)*(4*s - 1))) - 10*g2*(2*Pk2*k1**2*(4*s - 1) + k2**2*(Pk2*(8*r + 8*s - 6) + Pkd2*k2*(4*s - 1))))) + b1*(-7*D1*bd1*(3*Pk2*f**2*k1**2*(12*r + 8*s - 9) + f*(k1**2*(3*K*Pkd2*k2*(1 - 2*s) + Pk2*(12*C*(2*s - 1) + 26*r + 8*s - 17)) + k2**2*(2*Pk2*(2*C*(14*r + 6*s - 3) - 10*K*(r - 1) - 21*r - 6*s + 3) + Pkd2*k2*(6*C - 3)*(2*s - 1))) - 10*g2*(2*Pk2*k1**2*(2*s - 1) + k2**2*(Pk2*(4*r + 4*s - 2) + Pkd2*k2*(2*s - 1)))) + D1*(f*(3*fd*(Pk2*k2**2*(8*C - 4)*(11*r - 2) + k1**2*(Pk2*(28*K*s - 14*K - 46*r - 48*s + 23) + Pkd2*k2*s*(20*C - 10))) + 7*k2*(10*Pk2*bd2*k2*(r + s - 1) - 20*Pk2*gd2*k2*(r - 1) + 3*Pkd2*bd2*k1**2*s - 6*Pkd2*gd2*k1**2*s)) + 7*fd*k2*(10*Pk2*b2*k2*(r + s) - 20*Pk2*g2*k2*(r + 1) + 3*Pkd2*b2*k1**2*s - 6*Pkd2*g2*k1**2*s)) + Dd*f*(3*f*(Pk2*k2**2*(88*C - 44)*(2*r - 1) + k1**2*(2*Pk2*(28*K*s - 7*K - 46*r - 48*s + 35) + Pkd2*k2*(10*C - 5)*(4*s - 1))) + 7*k2*(10*Pk2*b2*k2*(4*r + 4*s - 3) + 40*Pk2*g2*k2*(1 - 2*r) + 3*Pkd2*b2*k1**2*(4*s - 1) + 6*Pkd2*g2*k1**2*(1 - 4*s)))) + f*(D1*bd1*(Pk2*f*k2**2*(12*C - 6)*(11*r - 7) - 3*f*k1**2*(Pk2*(-14*K*s + 23*r + 24*s - 24) + 5*Pkd2*k2*(-2*C*s + 2*C + s - 1)) + 7*k2*(10*Pk2*b2*k2*(r + s - 1) - 20*Pk2*g2*k2*(r - 1) + 3*Pkd2*b2*k1**2*(s - 1) - 6*Pkd2*g2*k1**2*(s - 1))) + 6*Pk2*k1**2*(D1*(f*fd*(10*C - 5)*(3*s - 1) + 7*f*s*(bd2 - 2*gd2) + 14*fd*g2*(1 - 2*s)) + Dd*f*(4*s - 1)*(f*(10*C - 5) - 14*g2) + 7*b2*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)))))/(35*d*k2*k3**2) - 1j*D1**3*Pk3*ct*st**2*(3*D1*bd1*f*(f**2*k1**2*(9*Pk2*k2**2*(8*s - 5) + 5*k1**2*(4*Pk2*(r + 2*s - 2) + Pkd2*k2*(3 - 2*s))) + f*(6*Pk2*k1**4*(r - s*(K - 2) - 1) + k1**2*k2**2*(Pk2*(12*C*(s + 1) - 100*K*r - 174*K*s + 100*K + 18*b1*(4*r + 4*s - 5) + 47*r + 72*s - 53) - 3*Pkd2*k2*(8*C*(s - 1) + 3*K*s + b1*(9 - 18*s) - 6*s + 6)) + k2**4*(Pk2*(-4*C*(17*r + 9*s - 18) - 42*K*r - 84*K*s + 42*K + 21*b1*(2*r - 1) + 51*r + 18*s - 36) + 9*Pkd2*k2*(-2*C*(s - 1) + s - 1))) - 7*k2**2*(6*Pk2*b2*k2**2*(r + s - 1) - 2*b1*k1**2*(Pk2*(2*K*s + K + 8*r + 6*s - 8) + Pkd2*k2*(-4*K*s + 2*K + 2*s - 1)) + 3*b1*k2**2*(K*Pk2*(4*r + 4*s - 6) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r + Pk2) + 4*g2*k1**2*(Pk2*(s + 1) - 2*Pkd2*k2*(s - 1)) - 6*g2*k2**2*(2*Pk2*(r + s - 2) + Pkd2*k2*(s - 1)))) + 3*b1**2*k2**2*(D1*fd*(2*k1**2*(9*Pk2*f*(4*r + 4*s - 1) + 7*Pk2*(K*(s - 2) + 4*r + 3*s + 1) + Pkd2*k2*s*(-14*K + 27*f + 7)) - 21*k2**2*(2*K*Pk2*(r + s + 1) + K*Pkd2*k2*s - Pk2*r + f*(-2*Pk2*r + Pk2))) + Dd*f*(k1**2*(36*Pk2*f*(4*r + 4*s - 3) + 14*Pk2*(K*(4*s - 1) + 16*r + 12*s - 11) + Pkd2*k2*(4*s - 1)*(-28*K + 27*f + 14)) + 21*k2**2*(K*Pkd2*k2*(1 - 4*s) - 2*Pk2*(K*(4*r + 4*s - 3) - 2*f*r + f - 2*r + 1)))) + 3*b1*(D1*(f**2*fd*k1**2*(27*Pk2*k2**2*(8*s - 1) + 5*k1**2*(4*Pk2*(3*r + 6*s - 2) - Pkd2*k2*(6*s + 1))) + f*(-42*Pk2*bd2*k2**4*(r + s - 1) - 6*Pk2*fd*k1**4*(2*K*s - K - 2*r - 4*s + 2) + fd*k1**2*k2**2*(2*Pk2*(12*C*(s - 1) + K*(-100*r - 174*s + 87) + 47*r + 72*s - 33) + 3*Pkd2*k2*(K*(3 - 6*s) + s*(12 - 16*C))) + fd*k2**4*(Pk2*(-8*C*(17*r + 9*s - 4) - 84*K*(r + 2*s - 1) + 102*r + 36*s - 33) + Pkd2*k2*s*(18 - 36*C)) + 14*gd2*k2**2*(-2*Pk2*k1**2*s + 6*Pk2*k2**2*(r + s - 1) + 4*Pkd2*k1**2*k2*s + 3*Pkd2*k2**3*s)) + 14*fd*k2**2*(-3*Pk2*b2*k2**2*(r + s) + g2*k1**2*(-2*Pk2*(s - 2) + 4*Pkd2*k2*s) + 3*g2*k2**2*(2*Pk2*(r + s + 1) + Pkd2*k2*s))) + Dd*f*(2*f**2*k1**2*(36*Pk2*k2**2*(4*s - 1) + 5*k1**2*(8*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 4*s))) + f*(-6*Pk2*k1**4*(4*K*s - K - 4*r - 8*s + 4) + k1**2*k2**2*(2*Pk2*(6*C*(4*s - 1) + K*(-200*r - 348*s + 187) + 94*r + 144*s - 83) + Pkd2*k2*(4*s - 1)*(-24*C - 9*K + 18)) + k2**4*(-4*Pk2*(C*(68*r + 36*s - 43) + 42*K*(r + 2*s - 1) - 51*r - 18*s + 30) + Pkd2*k2*(9 - 18*C)*(4*s - 1))) + 14*k2**2*(-3*Pk2*b2*k2**2*(4*r + 4*s - 3) - 2*g2*k1**2*(Pk2 - 2*Pkd2*k2)*(4*s - 1) + 3*g2*k2**2*(Pk2*(8*r + 8*s - 6) + Pkd2*k2*(4*s - 1))))) + f*(D1*(-30*Pk2*f**2*fd*k1**4*(10*r + 24*s - 11) + f*(-162*Pk2*bd2*k1**2*k2**2*(r + s - 1) + fd*(10*Pk2*k1**4*(C*(2 - 6*s) + 3*r + 9*s - 4) - Pk2*k2**4*(12*C - 6)*(51*r + 54*s - 35) + k1**2*k2**2*(Pk2*(-172*C*(6*r + 9*s - 5) + 639*r + 1026*s - 555) + Pkd2*k2*(15 - 30*C)*(3*s - 1))) + 6*gd2*(6*Pk2*k1**4*s + 42*Pk2*k2**4*(r + 2*s - 1) + k1**2*k2**2*(2*Pk2*(50*r + 87*s - 50) + 9*Pkd2*k2*s))) + 6*fd*(-27*Pk2*b2*k1**2*k2**2*(2*r + 2*s - 1) + g2*(6*Pk2*k1**4*(2*s - 1) + 84*Pk2*k2**4*(r + 2*s - 1) + k1**2*k2**2*(2*Pk2*(100*r + 174*s - 87) + 9*Pkd2*k2*(2*s - 1))))) + Dd*f*(-162*Pk2*b2*k1**2*k2**2*(4*r + 4*s - 3) - 30*Pk2*f**2*k1**4*(10*r + 24*s - 11) + f*(10*Pk2*k1**4*(C*(2 - 8*s) + 4*r + 12*s - 5) - Pk2*k2**4*(48*C - 24)*(17*r + 18*s - 13) + k1**2*k2**2*(-172*C*Pk2*(8*r + 12*s - 7) + 12*Pk2*(71*r + 114*s - 64) + Pkd2*k2*(15 - 30*C)*(4*s - 1))) + 6*g2*(6*Pk2*k1**4*(4*s - 1) + 168*Pk2*k2**4*(r + 2*s - 1) + k1**2*k2**2*(Pk2*(400*r + 696*s - 374) + 9*Pkd2*k2*(4*s - 1))))))/(105*d*k2*k3**4) + 1j*D1**3*Pk3*ct*(14*Pk2*b1**3*k2**2*(6*D1*fd*k1**2*(r + s - 1) + Dd*(-5*K*k2**2 + k1**2*(-10*K + 6*f + 5))*(4*r + 4*s - 3)) + b1**2*(-3*D1*f*k1**2*(-28*Pk2*bd1*k2**2*(3*r + 3*s - 2) + 21*Pk2*fd*k2**2*(6*r + 4*s - 3) + 10*fd*k1**2*(Pk2*(4*r + 4*s - 3) + Pkd2*k2*s)) - 7*D1*(10*Pk2*bd1*k2**2*(K*k2**2 + k1**2*(2*K - 1))*(3*r + 3*s - 2) - 20*Pk2*gd2*k2**2*(2*k1**2 + k2**2)*(r + s - 1) + fd*(6*Pk2*k1**4*(r - s*(K - 2)) + 2*Pk2*k2**4*(6*C*(r + s - 1) - 5*K*s - r*(5*K + 3) - 3*s + 3) - k1**2*k2**2*(3*K*Pkd2*k2*s + Pk2*(-24*C*(r + s - 1) + 44*K*r + 56*K*s + 5*r + 2*s - 18)))) + 140*Dd*Pk2*g2*k2**2*(2*k1**2 + k2**2)*(4*r + 4*s - 3) - 3*Dd*f**2*k1**2*(84*Pk2*k2**2*(3*r + 2*s - 2) + 5*k1**2*(4*Pk2*(4*r + 4*s - 3) + Pkd2*k2*(4*s - 1))) + 7*Dd*f*(6*Pk2*k1**4*(4*K*s - K - 4*r - 8*s + 4) + Pk2*k2**4*(-12*C + 10*K + 6)*(4*r + 4*s - 3) + k1**2*k2**2*(3*K*Pkd2*k2*(4*s - 1) - 4*Pk2*(6*C*(4*r + 4*s - 3) - 4*K*(11*r + 14*s - 9) - 5*r - 2*s + 3)))) - b1*(D1*bd1*(-140*Pk2*g2*k2**2*(2*k1**2 + k2**2)*(2*r + 2*s - 1) + 3*f**2*k1**2*(21*Pk2*k2**2*(6*r + 4*s - 5) + 5*k1**2*(Pk2*(8*r + 8*s - 6) + Pkd2*k2*(2*s - 1))) - 7*f*(-6*Pk2*k1**4*(-2*K*s + K + 2*r + 4*s - 3) + 2*Pk2*k2**4*(-6*C*(2*r + 2*s - 1) + 10*K*(r + s - 1) + 6*r + 6*s - 3) + k1**2*k2**2*(3*K*Pkd2*k2*(2*s - 1) + Pk2*(-24*C*(2*r + 2*s - 1) + 4*K*(22*r + 28*s - 25) + 10*r + 4*s + 11)))) + D1*(-126*Pk2*b2*fd*k1**2*k2**2*(r + s) - 15*Pk2*f**2*fd*k1**4*(15*r + 12*s - 8) - 3*f*fd*(-10*Pk2*k1**4*(-4*C*s + 2*r + 6*s - 1) + Pk2*k2**4*(4*C - 2)*(22*r + 14*s - 11) + k1**2*k2**2*(Pk2*(8*C*(38*r + 44*s - 19) + 28*K*s - 14*K - 198*r - 224*s + 99) + Pkd2*k2*s*(20*C - 10))) + 14*f*(-9*Pk2*bd2*k1**2*k2**2*(r + s - 1) + gd2*(6*Pk2*k1**4*s + 10*Pk2*k2**4*(r + s - 1) + k1**2*k2**2*(Pk2*(44*r + 56*s - 44) + 3*Pkd2*k2*s))) + 14*fd*g2*(6*Pk2*k1**4*s + 10*Pk2*k2**4*(r + s) + k1**2*k2**2*(44*Pk2*r + 56*Pk2*s + 3*Pkd2*k2*s))) + Dd*f*(-126*Pk2*b2*k1**2*k2**2*(4*r + 4*s - 3) - 30*Pk2*f**2*k1**4*(10*r + 8*s - 7) - 3*f*(-10*Pk2*k1**4*(C*(2 - 8*s) + 4*r + 12*s - 5) + Pk2*k2**4*(4*C - 2)*(44*r + 28*s - 29) + k1**2*k2**2*(2*Pk2*(16*C*(19*r + 22*s - 15) + 28*K*s - 7*K - 198*r - 224*s + 155) + Pkd2*k2*(10*C - 5)*(4*s - 1))) + 14*g2*(6*Pk2*k1**4*(4*s - 1) + 10*Pk2*k2**4*(4*r + 4*s - 3) + k1**2*k2**2*(16*Pk2*(11*r + 14*s - 9) + 3*Pkd2*k2*(4*s - 1))))) + f*(D1*bd1*(126*Pk2*b2*k1**2*k2**2*(r + s - 1) + 15*Pk2*f**2*k1**4*(5*r + 4*s - 6) - 30*Pk2*f*k1**4*(-2*C*(s - 1) + r + 3*s - 3) + Pk2*f*k2**4*(12*C - 6)*(11*r + 7*s - 7) + 3*f*k1**2*k2**2*(Pk2*(8*C*(19*r + 22*s - 22) - 99*r + 14*s*(K - 8) + 112) + Pkd2*k2*(10*C - 5)*(s - 1)) - 14*g2*(6*Pk2*k1**4*(s - 1) + 10*Pk2*k2**4*(r + s - 1) + k1**2*k2**2*(44*Pk2*r + 56*Pk2*(s - 1) + 3*Pkd2*k2*(s - 1)))) + 6*Pk2*k1**2*k2**2*(D1*(f*fd*(10*C - 5)*(3*s - 1) - 14*f*gd2*s + 14*fd*g2*(1 - 2*s)) + Dd*f*(4*s - 1)*(f*(10*C - 5) - 14*g2))))/(35*d*k2*k3**4) - 1j*D1**3*Pk3*f**2*k1*st**6*(4*Pk2 - Pkd2*k2)*(D1*b1*fd*(3*s - 1) + D1*bd1*f*s + Dd*b1*f*(4*s - 1))/(21*d*k3**2) - 1j*D1**3*Pk3*f**2*k1*st**6*(D1*(11*b1*fd*k2**2*(Pk2*(6*r - 2) + Pkd2*k2*(3*s - 1)) + f*(11*bd1*k2**2*(2*Pk2*(r - 1) + Pkd2*k2*s) + fd*(44*Pk2*k2**2*(1 - 2*r) + 9*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)))) + Dd*f*(11*b1*k2**2*(Pk2*(8*r - 4) + Pkd2*k2*(4*s - 1)) + f*(44*Pk2*k2**2*(1 - 2*r) + 9*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))))/(231*d*k3**4) + 1j*D1**3*Pk3*f*st**4*(3*D1*b1**2*fd*k1**2*k2**2*(-2*Pk2 + Pkd2*k2) + D1*bd1*f*k1**2*(-6*K*Pkd2*k2**3*s - 8*Pk2*f*k1**2*s + 3*Pk2*k2**2*(4*K*s + f*(6*r + 5*s - 4) + 2*r + s - 2) + 2*Pkd2*f*k1**2*k2*s) + b1*k1**2*(D1*(f*(3*Pk2*fd*k2**2*(18*r + 15*s - 13) - 3*bd1*k2**2*(-2*Pk2 + Pkd2*k2) - 2*fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) - 3*fd*k2**2*(2*K*Pkd2*k2*(2*s - 1) + Pk2*(-8*K*s + 4*K - 4*r - 2*s + 1))) + Dd*f*(f*(3*Pk2*k2**2*(24*r + 20*s - 17) - 2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 3*k2**2*(2*K*Pkd2*k2*(4*s - 1) + Pk2*(-16*K*s + 4*K - 8*r - 4*s + 5)))) + k2**2*(D1*(f*(4*Pk2*fd*k2**2*(C*(2 - 6*r) + 3*r - 1) + fd*k1**2*(Pk2*(24*C*s - 8*C + 6*r - 9*s + 1) + 2*Pkd2*k2*(-6*C*s + 2*C + 3*s - 1)) + k1**2*s*(2*Pk2 - Pkd2*k2)*(6*bd2 - 12*gd2)) - 12*fd*g2*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1)) + Dd*f*(Pk2*f*k2**2*(8 - 16*C)*(2*r - 1) + f*k1**2*(Pk2*(8*C*(4*s - 1) + 8*r - 12*s - 1) + 2*Pkd2*k2*(C*(2 - 8*s) + 4*s - 1)) - 12*g2*k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1)) + 6*b2*k1**2*(2*Pk2 - Pkd2*k2)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1))))/(35*d*k1*k2**2*k3**2) - 1j*D1**3*Pk3*f*st**4*(D1*(f**2*k1**2*(33*Pk2*bd1*k2**4*(4*r + 5*s - 6) - 33*Pk2*fd*k1**2*k2**2*(16*r + 20*s - 13) + 11*bd1*k1**2*k2**2*(2*Pk2*(5*r + 5*s - 6) + 3*Pkd2*k2) + 5*fd*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 11*f*k2**2*(-3*b1*k1**2*(bd1*k2**2*(-2*Pk2 + Pkd2*k2*(2*s - 1)) + fd*(Pk2*k2**2*(12*r + 15*s - 7) + k1**2*(2*Pk2*(5*r + 5*s - 3) - Pkd2*k2))) + k2**2*(60*C*Pk2*fd*k1**2*r + 48*C*Pk2*fd*k1**2*s - 36*C*Pk2*fd*k1**2 + 24*C*Pk2*fd*k2**2*r - 8*C*Pk2*fd*k2**2 + 12*C*Pkd2*fd*k1**2*k2*s - 4*C*Pkd2*fd*k1**2*k2 + 18*Pk2*bd2*k1**2*(r + s - 1) - 36*Pk2*fd*k1**2*r - 27*Pk2*fd*k1**2*s + 21*Pk2*fd*k1**2 - 12*Pk2*fd*k2**2*r + 4*Pk2*fd*k2**2 - 60*Pk2*gd2*k1**2*r - 48*Pk2*gd2*k1**2*s + 60*Pk2*gd2*k1**2 - 6*Pkd2*fd*k1**2*k2*s + 2*Pkd2*fd*k1**2*k2 - 12*Pkd2*gd2*k1**2*k2*s + 3*bd1*k1**2*(2*K*Pkd2*k2*s + Pk2*(2*K*(5*r + 4*s - 5) - 2*r - s + 2)))) + 33*fd*k1**2*k2**4*(-6*Pk2*b2*(2*r + 2*s - 1) + 8*Pk2*g2*(5*r + 4*s - 2) + 4*Pkd2*g2*k2*(2*s - 1) + 2*b1**2*(Pk2 + Pkd2*k2*s) - b1*(2*K*Pkd2*k2*(2*s - 1) + Pk2*(4*K*(5*r + 4*s - 2) - 4*r - 2*s + 1)))) + Dd*f*(f**2*k1**4*(-33*Pk2*k2**2*(16*r + 20*s - 13) + 5*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 11*f*k2**2*(Pk2*b1*k1**2*(10*k1**2*(4*r + 4*s - 3) + 3*k2**2*(16*r + 20*s - 13)) + Pk2*k2**4*(8 - 16*C)*(2*r - 1) + k1**2*k2**2*(Pk2*(-8*C*(10*r + 8*s - 7) + 48*r + 36*s - 33) + 2*Pkd2*k2*(C*(2 - 8*s) + 4*s - 1))) + 33*k1**2*k2**4*(2*K*Pkd2*b1*k2*(1 - 4*s) + Pk2*b1*(-4*K*(10*r + 8*s - 7) + 8*r + 4*s - 5) - 6*Pk2*b2*(4*r + 4*s - 3) + 8*Pk2*g2*(10*r + 8*s - 7) + Pkd2*b1**2*k2*(4*s - 1) + 4*Pkd2*g2*k2*(4*s - 1))))/(385*d*k1*k2**2*k3**4) - 1j*D1**3*Pk3*k1*st**2*(21*Pkd2*b1**3*k2**3*(D1*fd*s + Dd*f*(4*s - 1)) + 3*b1**2*(D1*(7*Pkd2*bd1*f*k2**3*(3*s - 1) + fd*(14*K*Pkd2*k2**3*s + 24*Pk2*f*k1**2*s - 7*Pk2*k2**2*(2*K*(s - 1) + f*(8*r - 3) + 2*r + 1) - 12*Pkd2*f*k1**2*k2*s)) + 2*Dd*f*(f*(28*Pk2*k2**2*(1 - 2*r) + 3*k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1)) + 7*k2**2*(K*Pkd2*k2*(4*s - 1) + Pk2*(-4*K*s + K - 4*r + 2)))) + 3*b1*(D1*bd1*f*(f*(7*Pk2*k2**2*(5 - 8*r) + 6*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1)) + 7*k2**2*(2*K*Pkd2*k2*(2*s - 1) + Pk2*(-4*K*s - 4*r + 3))) + D1*(18*Pk2*f**2*fd*k1**2*(1 - 3*s) + f*(fd*(Pk2*k1**2*(3 - 6*s) + k2**2*(Pk2*(C*(12 - 24*s) + 14*K*(2*r + 6*s - 3) - 12*r + 12*s - 3) + Pkd2*k2*s*(24*C - 12))) + 14*k2**2*s*(Pkd2*bd2*k2 + 2*gd2*(Pk2 - Pkd2*k2))) + 14*fd*k2**2*(2*Pk2*g2*(s - 1) + Pkd2*b2*k2*s - 2*Pkd2*g2*k2*s)) + Dd*f*(18*Pk2*f**2*k1**2*(1 - 4*s) + f*(3*Pk2*k1**2*(1 - 4*s) + 2*k2**2*(Pk2*(C*(6 - 24*s) + 7*K*(4*r + 12*s - 5) - 12*r + 12*s + 3) + Pkd2*k2*(6*C - 3)*(4*s - 1))) + 14*k2**2*(4*s - 1)*(Pkd2*b2*k2 + 2*g2*(Pk2 - Pkd2*k2)))) + f*(D1*(-54*Pk2*bd1*f**2*k1**2*s + f*(Pk2*fd*(k1**2*(5 - 15*s) + k2**2*(4*C - 2)*(39*r + 81*s - 40)) + Pk2*k2**2*(42*bd2 - 84*gd2)*(r + 3*s - 1) + 3*bd1*(-3*Pk2*k1**2*s + Pk2*k2**2*(-12*C*s + 14*K*(r + 3*s - 1) - 6*r + 6*s + 3) + Pkd2*k2**3*(12*C - 6)*(s - 1))) + 42*k2**2*(Pk2*b2*fd*(2*r + 6*s - 3) - 2*Pk2*fd*g2*(2*r + 6*s - 3) + Pkd2*b2*bd1*k2*(s - 1) + 2*bd1*g2*(Pk2*s + k2*(-Pkd2*s + Pkd2)))) + Dd*Pk2*f*(f*k1**2*(5 - 20*s) + f*k2**2*(4*C - 2)*(52*r + 108*s - 53) + k2**2*(42*b2 - 84*g2)*(4*r + 12*s - 5))))/(105*d*k2**2*k3**2) + 1j*D1**3*Pk3*st**2*(D1*Pk2*bd1*f**2*(3*k1**2*s + k2**2*r*(8 - 16*C)) + Pk2*b1*f*(D1*(14*bd1*k1**2*s*(3*f + 1) + fd*k1**2*(6*s - 3) + fd*k2**2*(8 - 16*C)*(2*r - 1)) + Dd*f*(3*k1**2*(4*s - 1) + k2**2*(16 - 32*C)*(2*r - 1))) - 7*b1**3*k1**2*(2*Pk2 - Pkd2*k2)*(D1*fd*s + Dd*f*(4*s - 1)) - 7*b1**2*k1**2*(-D1*Pk2*fd*(f*(6*s - 3) + s - 1) + D1*bd1*f*(2*Pk2 - Pkd2*k2)*(3*s - 1) - Dd*Pk2*f*(3*f + 1)*(4*s - 1)))/(35*d*k1*k2**2) - 1j*D1**3*Pk3*st**2*(D1*bd1*f*(f**2*k1**4*(9*Pk2*k2**2*(5 - 8*r) + 5*k1**2*(2*Pk2 - Pkd2*k2)*(s - 1)) + 3*f*k2**2*(-48*C*Pk2*k1**2*k2**2*r - 60*C*Pk2*k1**2*k2**2*s + 72*C*Pk2*k1**2*k2**2 - 16*C*Pk2*k2**4*r - 12*C*Pkd2*k1**2*k2**3*s + 12*C*Pkd2*k1**2*k2**3 - 2*K*Pk2*k1**2*(3*k1**2*(r + 2*s - 1) + 7*k2**2*(r + 3*s - 1)) + 3*Pk2*k1**4*s + 30*Pk2*k1**2*k2**2*r + 33*Pk2*k1**2*k2**2*s - 39*Pk2*k1**2*k2**2 + 8*Pk2*k2**4*r + 6*Pkd2*k1**2*k2**3*s - 6*Pkd2*k1**2*k2**3 + 3*b1*(7*Pk2*k1**2*k2**2*(4*r + 2*s - 3) + k1**4*(2*Pk2*(8*r + 8*s - 7) + 3*Pkd2*k2*(2*s - 1)))) - 21*k1**2*k2**4*(2*Pk2*b1**2*(3*r + 3*s - 2) + 6*Pk2*b2*(r + s - 1) + b1*(2*K*Pkd2*k2*(2*s - 1) + Pk2*(4*K*(4*r + 5*s - 5) - 4*r - 2*s + 3)) - 4*g2*(Pk2*(4*r + 5*s - 6) + Pkd2*k2*(s - 1)))) - 42*Pk2*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + Pk2*f*k1**2*(D1*(15*f**2*fd*k1**4*(1 - 4*s) + f*k2**2*(-18*bd2*k1**2*(r + s - 1) - 5*fd*k1**2*(12*C*(r + 2*s - 1) - 6*r - 15*s + 7) - fd*k2**2*(4*C - 2)*(39*r + 81*s - 40) + 36*gd2*k1**2*(r + 2*s - 1) + 84*gd2*k2**2*(r + 3*s - 1)) + 6*fd*k2**2*(-3*b2*k1**2*(2*r + 2*s - 1) + 2*g2*(6*k1**2*(r + 2*s - 1) + 7*k2**2*(2*r + 6*s - 3)))) + Dd*f*(15*f**2*k1**4*(1 - 4*s) + f*k2**2*(-5*k1**2*(16*C*(r + 2*s - 1) - 8*r - 20*s + 9) + k2**2*(2 - 4*C)*(52*r + 108*s - 53)) + 6*k2**2*(-3*b2*k1**2*(4*r + 4*s - 3) + 24*g2*k1**2*(r + 2*s - 1) + 14*g2*k2**2*(4*r + 12*s - 5)))) + 3*b1**2*k1**2*k2**2*(D1*fd*(6*f*(7*Pk2*k2**2*(2*r + s - 1) + k1**2*(Pk2*(8*r + 8*s - 5) + 3*Pkd2*k2*s)) - 7*k2**2*(2*K*(4*Pk2*r + 5*Pk2*s + Pk2 + Pkd2*k2*s) - Pk2*(2*r + s))) + Dd*f*(3*f*(7*Pk2*k2**2*(8*r + 4*s - 5) + k1**2*(8*Pk2*(4*r + 4*s - 3) + 3*Pkd2*k2*(4*s - 1))) - 7*k2**2*(2*K*Pkd2*k2*(4*s - 1) + Pk2*(K*(32*r + 40*s - 26) - 8*r - 4*s + 5)))) + b1*(-3*D1*(f**2*fd*k1**4*(-10*Pk2*k1**2*s + 3*Pk2*k2**2*(24*r - 11) + 5*Pkd2*k1**2*k2*s) + f*k2**2*(fd*(3*Pk2*k1**4*(4*K*(r + 2*s - 1) - 2*s + 1) + Pk2*k2**4*(16*C - 8)*(2*r - 1) + 2*k1**2*k2**2*(Pk2*(6*C*(8*r + 10*s - 3) + 7*K*(2*r + 6*s - 3) - 30*r - 33*s + 12) + Pkd2*k2*s*(12*C - 6))) - 14*k1**2*k2**2*(-3*Pk2*bd2*(r + s - 1) + 2*gd2*(Pk2*(4*r + 5*s - 4) + Pkd2*k2*s))) - 14*fd*k1**2*k2**4*(-3*Pk2*b2*(r + s) + 2*g2*(4*Pk2*r + 5*Pk2*s + Pk2 + Pkd2*k2*s))) + Dd*f*(f**2*k1**4*(144*Pk2*k2**2*(1 - 2*r) + 5*k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1)) - 3*f*k2**2*(3*Pk2*k1**4*(8*K*(r + 2*s - 1) - 4*s + 1) + Pk2*k2**4*(32*C - 16)*(2*r - 1) + k1**2*k2**2*(Pk2*(12*C*(16*r + 20*s - 13) + 14*K*(4*r + 12*s - 5) - 120*r - 132*s + 93) + Pkd2*k2*(12*C - 6)*(4*s - 1))) + 42*k1**2*k2**4*(-3*Pk2*b2*(4*r + 4*s - 3) + 2*g2*(Pk2*(16*r + 20*s - 13) + Pkd2*k2*(4*s - 1))))))/(105*d*k1*k2**2*k3**4)
        
        return np.sqrt((4*np.pi)/3)*(perm12+perm13+perm23)
    
    def l1m1(cosmo_functions,k1,k2,k3=None,theta=None,zz=0,r=0,s=0,nonlin=False,growth2=False):
        
        #get generic cosmology parameters
        k1,k2,k3,theta,Pk1,Pk2,Pk3,Pkd1,Pkd2,Pkd3,Pkdd1,Pkdd2,Pkdd3,d,K,C,f,D1,b1,b2,g2 = cosmo_functions.get_params(k1,k2,k3,theta,zz,nonlin=nonlin,growth2=growth2)
        
        fd,Dd,gd2,bd2,bd1,fdd,Ddd,gdd2,bdd2,bdd1 = cosmo_functions.get_derivs(zz)
        
        st = np.sin(theta)
        ct= np.cos(theta)

        perm12 = -4*np.sqrt(6)*1j*np.sqrt(np.pi)*C*D1**3*Pk1*Pk2*f*k2**3*st**5*(9*D1*bd1*f*(r + s - 1) + 9*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(63*d*k3**4) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*C*D1**3*Pk1*Pk2*k1**2*k2*st*(3*D1*bd1*f**2*(r + s - 1) + 7*b1**2*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + b1*f*(14*D1*bd1*(r + s - 1) + (3*D1*fd + 6*Dd*f)*(2*r + 2*s - 1)))/(35*d*k3**4) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*C*D1**3*Pk1*Pk2*k2*st**3*(D1*bd1*f*(14*b1*k2**2 + f*(3*k1**2 + k2**2))*(r + s - 1) + 7*b1**2*k2**2*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + b1*f*(3*k1**2 + k2**2)*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + f**2*k1**2*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(35*d*k3**4) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*C*D1**3*Pk2*Pkd1*f*k1*k2*st**3*(6*D1*b1*fd*r + 3*D1*bd1*f*(r - 1) + D1*f*fd*(3*r - 1) + 3*Dd*b1*f*(4*r - 1) + Dd*f**2*(4*r - 1))/(105*d*k3**2) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*C*D1**3*Pk2*Pkd1*k1*k2*st*(3*D1*bd1*f**2*r + 7*b1**2*(D1*fd*r + Dd*f*(4*r - 1)) + b1*f*(7*D1*bd1*(2*r - 1) + 3*D1*fd*(2*r - 1) + 3*Dd*f*(4*r - 1)))/(105*d*k3**2) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**6*f*k2**3*st*(C - 1)*(9*D1*bd1*f*(r + s - 1) + 9*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + 5*f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(63*d*k3**4) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**5*f*k2**2*st*(k1**2*(24*C - 29) - 5*k2**2)*(9*D1*bd1*f*(r + s - 1) + 9*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + 5*f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(315*d*k1*k3**4) + 8*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**4*f*k2**3*st**3*(C - 1)*(3*D1*bd1*f*(r + s - 1) + 3*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(21*d*k3**4) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**4*k2*st*(-9*D1*bd1*f*(r + s - 1)*(14*b1*k2**2*(C - 1) + f*k1**2*(9*C - 15) - f*k2**2*(2*C + 9)) - 63*b1**2*k2**2*(C - 1)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) - 9*b1*f*(D1*fd + 2*Dd*f)*(k1**2*(9*C - 15) - k2**2*(2*C + 9))*(2*r + 2*s - 1) - 5*f**2*(k1**2*(9*C - 15) - k2**2*(5*C + 6))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(315*d*k3**4) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**3*f*k2**2*st**3*(k1**2*(12*C - 17) - 5*k2**2)*(3*D1*bd1*f*(r + s - 1) + 3*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(105*d*k1*k3**4) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**3*st*(9*D1*bd1*f*(-14*b1*k2**2*(k1**2*(5 - 4*C) + k2**2) + f*(k1**4*(4*C - 13) - k1**2*k2**2*(12*C + 24) - 3*k2**4))*(r + s - 1) - 63*b1**2*k2**2*(k1**2*(5 - 4*C) + k2**2)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + 9*b1*f*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1)*(k1**4*(4*C - 13) - k1**2*k2**2*(12*C + 24) - 3*k2**4) + 5*f**2*k1**2*(k1**2*(4*C - 13) - k2**2*(24*C + 9))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(315*d*k1*k3**4) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**2*f*k2**3*st**5*(C - 1)*(9*D1*bd1*f*(r + s - 1) + 9*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(63*d*k3**4) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**2*k2*st**3*(-3*D1*bd1*f*(r + s - 1)*(14*b1*k2**2*(C - 1) + f*k1**2*(3*C - 9) - f*k2**2*(9*C + 7)) - 21*b1**2*k2**2*(C - 1)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) - 3*b1*f*(D1*fd + 2*Dd*f)*(k1**2*(3*C - 9) - k2**2*(9*C + 7))*(2*r + 2*s - 1) - f**2*(k1**2*(3*C - 9) - k2**2*(10*C + 6))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(105*d*k3**4) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**2*st*(9*D1*bd1*f*(14*b1*k2**2*(-k1**2*(C - 2) + k2**2*(C + 1)) + f*(k1**4 + k1**2*k2**2*(6*C + 7) + k2**4*(3*C + 3)))*(r + s - 1) + 63*b1**2*k2**2*(-k1**2*(C - 2) + k2**2*(C + 1))*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + 9*b1*f*(D1*fd + 2*Dd*f)*(k1**4 + k1**2*k2**2*(6*C + 7) + k2**4*(3*C + 3))*(2*r + 2*s - 1) + 5*f**2*k1**2*(k1**2 + k2**2*(9*C + 1))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(315*d*k2*k3**4) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct*f*k2**2*st**5*(k1**2 + k2**2)*(9*D1*bd1*f*(r + s - 1) + 9*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(63*d*k1*k3**4) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct*k1*st*(63*b1**2*(k1**2 + k2**2*(4*C + 1))*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + 9*b1*f*(14*D1*bd1*(k1**2 + k2**2*(4*C + 1))*(r + s - 1) + (D1*fd + 2*Dd*f)*(k1**2*(4*C + 3) + k2**2*(12*C + 3))*(2*r + 2*s - 1)) + f**2*(20*C*k1**2*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)) + 9*D1*bd1*(k1**2*(4*C + 3) + k2**2*(12*C + 3))*(r + s - 1)))/(315*d*k3**4) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct*st**3*(D1*bd1*f*(14*b1*k2**2*(k1**2 + k2**2) + f*(3*k1**4 + k1**2*k2**2*(24*C + 4) + k2**4))*(r + s - 1) + 7*b1**2*k2**2*(k1**2 + k2**2)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + b1*f*(D1*fd + 2*Dd*f)*(3*k1**4 + k1**2*k2**2*(24*C + 4) + k2**4)*(2*r + 2*s - 1) + f**2*k1**2*(k1**2 + k2**2*(8*C + 1))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(35*d*k1*k3**4) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**6*f*k2*st*(C - 1)*(4*Pk2 - Pkd2*k2)*(9*b1*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) + f*(9*D1*bd1*s + 5*D1*fd*(3*s - 1) + 5*Dd*f*(4*s - 1)))/(63*d*k3**2) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**5*f**2*st*(4*Pk2 - Pkd2*k2)*(11*b1*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1)) + f*(11*D1*bd1*s + 7*D1*fd*(4*s - 1) + 7*Dd*f*(4*s - 1)))/(231*d*k1) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**5*f*st*(9*b1*(D1*fd*(k1**2*(16*C - 21)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(Pk2*(-8*C*r + 8*r - 20*s + 10) + 5*Pkd2*k2*(2*s - 1))) + Dd*f*(k1**2*(16*C - 21)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(Pk2*(-16*C*r + 4*C + 16*r - 40*s + 6) + 5*Pkd2*k2*(4*s - 1)))) + f*(9*D1*bd1*(Pk2*k1**2*s*(64*C - 84) - 2*Pk2*k2**2*(2*C*(r - 1) - 2*r + 5*s + 2) + Pkd2*k1**2*k2*s*(21 - 16*C) + 5*Pkd2*k2**3*s) + D1*fd*(k1**2*(80*C - 105)*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(-2*Pk2*(42*C*(3*r - 1) - 126*r + 75*s + 17) + 25*Pkd2*k2*(3*s - 1))) + Dd*f*k1**2*(80*C - 105)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + Dd*f*k2**2*(Pk2*(-84*C*(4*r - 1) + 336*r - 200*s - 34) + 25*Pkd2*k2*(4*s - 1))))/(315*d*k1*k3**2) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**4*f*k2*st**3*(C - 1)*(4*Pk2 - Pkd2*k2)*(3*b1*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) + f*(3*D1*bd1*s + D1*fd*(3*s - 1) + Dd*f*(4*s - 1)))/(21*d*k3**2) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**4*st*(99*b1**2*k1**2*(4*Pk2 - Pkd2*k2)*(D1*fd*(-7*K*s + 7*K + 5*f*(2*s - 1) + 7*s - 7) + Dd*f*(4*s - 1)*(-7*K + 5*f + 7)) + 11*b1*(3*D1*(5*f**2*(Pk2*fd*k2**2*r + 6*bd1*k1**2*s*(4*Pk2 - Pkd2*k2) + 5*fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) - 3*f*k1**2*(4*Pk2 - Pkd2*k2)*(3*fd*(K - 1)*(2*s - 1) + s*(14*K*bd1 - 14*bd1 - 14*gd2)) + 42*fd*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) + Dd*f*(5*f**2*(Pk2*k2**2*(4*r - 1) + 15*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 27*f*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 126*g2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + f*(5*D1*f**2*(11*bd1*(60*Pk2*k1**2*s + Pk2*k2**2*(r - 1) - 15*Pkd2*k1**2*k2*s) + 5*fd*(5*Pk2*k2**2*(1 - 4*r) + 14*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 297*D1*f*k1**2*s*(4*Pk2 - Pkd2*k2)*(-K*bd1 + bd1 + 2*gd2) + 198*D1*g2*k1**2*(4*Pk2 - Pkd2*k2)*(7*bd1*s + fd*(6*s - 3)) + 25*Dd*f**3*(5*Pk2*k2**2*(1 - 4*r) + 14*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 594*Dd*f*g2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)))/(3465*d*k1**2*k2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**4*st*(-126*b1**2*k1**2*k2**2*(C - 1)*(-2*Pk2 + Pkd2*k2)*(D1*fd*s + Dd*f*(4*s - 1)) + 9*b1*f*(2*D1*(-7*bd1*k1**2*k2**2*(C - 1)*(-2*Pk2 + Pkd2*k2)*(2*s - 1) + fd*(-3*Pk2*k2**4*r + k1**4*(3*C - 7)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(Pk2*(C*(-36*r - 80*s + 46) + 41*r + 44*s - 28) + Pkd2*k2*(C*(4*s - 5) + 14*s - 4)))) + Dd*f*(3*Pk2*k2**4*(1 - 4*r) + k1**4*(6*C - 14)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(-4*C*(36*r + 80*s - 29) + 164*r + 176*s - 85) + Pkd2*k2*(4*C + 14)*(4*s - 1)))) + f**2*(D1*(-27*Pk2*bd1*k2**4*(r - 1) + 17*Pk2*fd*k2**4*(3*r - 1) + 18*bd1*k1**4*s*(3*C - 7)*(4*Pk2 - Pkd2*k2) + 9*bd1*k1**2*k2**2*(Pk2*(-4*C*(9*r + 20*s - 6) + 41*r + 44*s - 29) + 2*Pkd2*k2*(C*(2*s + 3) + 7*s - 3)) + fd*k1**4*(30*C - 70)*(4*Pk2 - Pkd2*k2)*(3*s - 1) + fd*k1**2*k2**2*(Pk2*(-4*C*(183*r + 297*s - 160) + 903*r + 648*s - 517) + Pkd2*k2*(50*C + 40)*(3*s - 1))) + Dd*f*(17*Pk2*k2**4*(4*r - 1) + k1**4*(30*C - 70)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(-16*C*(61*r + 99*s - 40) + 1204*r + 864*s - 517) + Pkd2*k2*(50*C + 40)*(4*s - 1)))))/(315*d*k1**2*k2*k3**2) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**3*f**2*st**3*(4*Pk2 - Pkd2*k2)*(11*b1*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1)) + f*(11*D1*bd1*s + 5*D1*fd*(4*s - 1) + 5*Dd*f*(4*s - 1)))/(231*d*k1) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**3*f*st**3*(3*b1*(D1*fd*(k1**2*(8*C - 13)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(Pk2*(-r*(24*C - 24) - 20*s + 10) + 5*Pkd2*k2*(2*s - 1))) + Dd*f*(k1**2*(8*C - 13)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(-2*Pk2*(24*C*r - 6*C - 24*r + 20*s + 1) + 5*Pkd2*k2*(4*s - 1)))) + f*(3*D1*bd1*(Pk2*k1**2*s*(32*C - 52) - 2*Pk2*k2**2*(6*C*(r - 1) - 6*r + 5*s + 6) + Pkd2*k1**2*k2*s*(13 - 8*C) + 5*Pkd2*k2**3*s) + D1*fd*(k1**2*(8*C - 13)*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(-2*Pk2*(42*C*r - 14*C - 42*r + 15*s + 9) + 5*Pkd2*k2*(3*s - 1))) + Dd*f*k1**2*(8*C - 13)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + Dd*f*k2**2*(-2*Pk2*(14*C*(4*r - 1) - 56*r + 20*s + 9) + 5*Pkd2*k2*(4*s - 1))))/(105*d*k1*k3**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**3*st*(-33*b1**2*(D1*fd*(3*k1**2*(4*Pk2 - Pkd2*k2)*(8*f*s - 4*f + 7*s - 7) + k2**2*(2*Pk2*(12*f*(4*s - 1) + r*(7*K - 7) + 21*s - 21) + 3*Pkd2*k2*(f*(4 - 16*s) - 7*s + 7))) + Dd*f*(k1**2*(4*Pk2 - Pkd2*k2)*(12*f + 21)*(4*s - 1) + k2**2*(48*Pk2*f*(4*s - 1) + 14*Pk2*(K*(4*r - 1) - 4*r + 12*s - 2) - Pkd2*k2*(24*f + 21)*(4*s - 1)))) - 11*b1*(D1*(-84*Pk2*fd*g2*k2**2*r + 4*f**2*(-9*bd1*(-8*Pk2*k1**2*s + Pk2*k2**2*(2 - 8*s) + 2*Pkd2*k1**2*k2*s + Pkd2*k2**3*(4*s - 1)) + fd*(10*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(Pk2*(-72*r - 75*s + 43) + 5*Pkd2*k2*(1 - 6*s)))) + 3*f*(-28*Pk2*gd2*k2**2*r + 14*bd1*(12*Pk2*k1**2*s + Pk2*k2**2*(2*K*r - K - 2*r + 6*s + 1) - 3*Pkd2*k1**2*k2*s - 3*Pkd2*k2**3*s) + 9*fd*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + fd*k2**2*(Pk2*(44*K*r - 22*K - 44*r + 36*s + 4) + 9*Pkd2*k2*(1 - 2*s)))) + Dd*f*(84*Pk2*g2*k2**2*(1 - 4*r) + 4*f**2*(10*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(Pk2*(-96*r - 100*s + 49) + 10*Pkd2*k2*(1 - 4*s))) + 3*f*(9*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(Pk2*(88*K*r - 22*K - 88*r + 72*s + 4) + 9*Pkd2*k2*(1 - 4*s))))) + f*(D1*(132*Pk2*g2*k2**2*(7*bd1*(r - 1) + 11*fd*(2*r - 1)) - 4*f**2*(-11*bd1*(-40*Pk2*k1**2*s + Pk2*k2**2*(24*r + 25*s - 6) + 10*Pkd2*k1**2*k2*s + 5*Pkd2*k2**3*(2*s - 1)) + 5*fd*(Pk2*k2**2*(-128*r - 220*s + 87) + 7*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 33*f*(44*Pk2*gd2*k2**2*r + bd1*(-36*Pk2*k1**2*s - 2*Pk2*k2**2*(r*(11*K - 11) + 9*s) + 9*Pkd2*k1**2*k2*s + 9*Pkd2*k2**3*s))) - 4*Dd*(363*Pk2*f*g2*k2**2*(1 - 4*r) + 5*f**3*(Pk2*k2**2*(-128*r - 220*s + 87) + 7*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)))))/(3465*d*k1*k2**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**3*st*(-21*b1**2*k2**2*(D1*fd*(Pk2*k1**2*s*(22 - 16*C) + Pk2*k2**2*r*(4*C - 4) + Pkd2*k1**2*k2*s*(8*C - 11) - 3*Pkd2*k2**3*s) + Dd*f*(-k1**2*(8*C - 11)*(2*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(Pk2*(4*C - 4)*(4*r - 1) + 3*Pkd2*k2*(1 - 4*s)))) - 3*b1*f*(D1*(7*bd1*k1**2*k2**2*(8*C - 11)*(-2*Pk2 + Pkd2*k2)*(2*s - 1) + 7*bd1*k2**4*(Pk2*(4*C - 4)*(2*r - 1) + 3*Pkd2*k2*(1 - 2*s)) + 9*fd*k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1) + fd*k1**2*k2**2*(2*Pk2*(4*C*(17*r + 72*s - 42) - 134*r - 252*s + 159) + 3*Pkd2*k2*(-16*C*(s - 1) - 28*s + 3)) - 2*fd*k2**4*(Pk2*(C*(22 - 44*r) + 74*r + 96*s - 70) + 9*Pkd2*k2*s)) + Dd*f*(9*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 2*k1**2*k2**2*(Pk2*(-2*C*(68*r + 288*s - 89) + 268*r + 504*s - 193) + Pkd2*k2*(12*C + 21)*(4*s - 1)) + k2**4*(2*Pk2*(88*C*r - 22*C - 148*r - 192*s + 85) + 9*Pkd2*k2*(1 - 4*s)))) + f**2*(D1*(3*bd1*(9*k1**4*s*(-4*Pk2 + Pkd2*k2) + k1**2*k2**2*(Pk2*(-4*C*(17*r + 72*s - 5) + 134*r + 252*s - 68) + 3*Pkd2*k2*(8*C*(s + 1) + 14*s - 11)) + k2**4*(Pk2*(-44*C*r + 74*r + 96*s - 30) + 9*Pkd2*k2*(s - 1))) + fd*(2*Pk2*k2**4*(32*C*(3*r - 1) + 123*r + 192*s - 105) - 15*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k1**2*k2**2*(-124*C*Pk2*(3*r + 12*s - 5) + 14*Pk2*(57*r + 93*s - 50) + Pkd2*k2*(80*C + 15)*(3*s - 1)))) + Dd*f*(2*Pk2*k2**4*(32*C*(4*r - 1) + 164*r + 256*s - 105) - 15*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(-124*C*Pk2*(4*r + 16*s - 5) + 28*Pk2*(38*r + 62*s - 25) + Pkd2*k2*(80*C + 15)*(4*s - 1)))))/(315*d*k1*k2**2*k3**2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**2*f*k2*st**5*(C - 1)*(4*Pk2 - Pkd2*k2)*(9*b1*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) + f*(9*D1*bd1*s + D1*fd*(3*s - 1) + Dd*f*(4*s - 1)))/(63*d*k3**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**2*st**3*(-33*b1**2*k1**2*(4*Pk2 - Pkd2*k2)*(D1*fd*(-7*K*s + 7*K + 10*f*(2*s - 1) + 7*s - 7) + Dd*f*(4*s - 1)*(-7*K + 10*f + 7)) - 11*b1*(3*D1*(10*f**2*(-Pk2*fd*k2**2*r + 2*bd1*k1**2*s*(4*Pk2 - Pkd2*k2) + fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) - f*k1**2*(4*Pk2 - Pkd2*k2)*(fd*(K - 1)*(2*s - 1) + s*(14*K*bd1 - 14*bd1 - 14*gd2)) + 14*fd*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) + Dd*f*(10*f**2*(Pk2*k2**2*(1 - 4*r) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 3*f*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 42*g2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + f*(D1*(-10*f**2*(-11*bd1*(-12*Pk2*k1**2*s + Pk2*k2**2*(r - 1) + 3*Pkd2*k1**2*k2*s) + fd*(13*Pk2*k2**2*(1 - 4*r) + 10*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) - 33*f*k1**2*s*(4*Pk2 - Pkd2*k2)*(-K*bd1 + bd1 + 2*gd2) - 66*g2*k1**2*(4*Pk2 - Pkd2*k2)*(7*bd1*s + fd*(2*s - 1))) - 2*Dd*f*(5*f**2*(13*Pk2*k2**2*(1 - 4*r) + 10*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 33*g2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))))/(1155*d*k1**2*k2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**2*st*(-77*b1**3*k1**2*(2*Pk2 - Pkd2*k2)*(3*D1*fd*s + Dd*(4*s - 1)*(-5*K + 3*f + 5)) - 11*b1**2*(7*D1*bd1*k1**2*(2*Pk2 - Pkd2*k2)*(3*s - 1)*(-5*K + 3*f + 5) - D1*(Pk2*fd*k2**2*r*(12*f - 7) + fd*k1**2*(6*Pk2*f*(7*r + 4*s - 11) + 7*Pk2*(K*(20 - 18*s) + 3*r + 6*s - 8) + 9*Pkd2*f*k2*(8*s - 1) + 7*Pkd2*k2*(K*(2*s - 3) + 4*s - 3)) + 70*gd2*k1**2*s*(-2*Pk2 + Pkd2*k2)) + Dd*(-3*f**2*(2*Pk2*k2**2*(4*r - 1) + k1**2*(Pk2*(28*r + 16*s - 11) + 12*Pkd2*k2*(4*s - 1))) + 7*f*(Pk2*k2**2*(4*r - 1) + k1**2*(3*Pk2*(24*K*s - 6*K - 4*r - 8*s + 3) + Pkd2*k2*(-2*K - 4)*(4*s - 1))) + 70*g2*k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1))) + 11*b1*(-88*D1*K*Pk2*f*fd*k1**2*s + 44*D1*K*Pk2*f*fd*k1**2 + 18*D1*K*Pkd2*f*fd*k1**2*k2*s - 9*D1*K*Pkd2*f*fd*k1**2*k2 - 42*D1*Pk2*bd2*f*k1**2*s + 102*D1*Pk2*f**2*fd*k1**2*r + 234*D1*Pk2*f**2*fd*k1**2*s - 115*D1*Pk2*f**2*fd*k1**2 + 42*D1*Pk2*f**2*fd*k2**2*r - 14*D1*Pk2*f**2*fd*k2**2 + 50*D1*Pk2*f*fd*k1**2*r + 16*D1*Pk2*f*fd*k1**2*s - 33*D1*Pk2*f*fd*k1**2 + 26*D1*Pk2*f*fd*k2**2*r - 13*D1*Pk2*f*fd*k2**2 + 252*D1*Pk2*f*gd2*k1**2*s + 252*D1*Pk2*fd*g2*k1**2*s - 280*D1*Pk2*fd*g2*k1**2 + 21*D1*Pkd2*bd2*f*k1**2*k2*s + 45*D1*Pkd2*f**2*fd*k1**2*k2*s - 5*D1*Pkd2*f**2*fd*k1**2*k2 + 18*D1*Pkd2*f*fd*k1**2*k2*s - 9*D1*Pkd2*f*fd*k1**2*k2 - 28*D1*Pkd2*f*gd2*k1**2*k2*s - 28*D1*Pkd2*fd*g2*k1**2*k2*s + 42*D1*Pkd2*fd*g2*k1**2*k2 + D1*bd1*(3*f**2*(2*Pk2*k2**2*(2*r - 1) + k1**2*(Pk2*(14*r + 8*s + 11) + 3*Pkd2*k2*(8*s - 3))) - 7*f*(Pk2*k2**2*(2*r - 1) + k1**2*(Pk2*(36*K*s + 2*K - 6*r - 12*s + 1) - Pkd2*k2*(4*K*s + K + 8*s - 1))) - 70*g2*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1)) - 176*Dd*K*Pk2*f**2*k1**2*s + 44*Dd*K*Pk2*f**2*k1**2 + 36*Dd*K*Pkd2*f**2*k1**2*k2*s - 9*Dd*K*Pkd2*f**2*k1**2*k2 + 136*Dd*Pk2*f**3*k1**2*r + 312*Dd*Pk2*f**3*k1**2*s - 112*Dd*Pk2*f**3*k1**2 + 56*Dd*Pk2*f**3*k2**2*r - 14*Dd*Pk2*f**3*k2**2 + 100*Dd*Pk2*f**2*k1**2*r + 32*Dd*Pk2*f**2*k1**2*s - 33*Dd*Pk2*f**2*k1**2 + 52*Dd*Pk2*f**2*k2**2*r - 13*Dd*Pk2*f**2*k2**2 + 1008*Dd*Pk2*f*g2*k1**2*s - 252*Dd*Pk2*f*g2*k1**2 + 60*Dd*Pkd2*f**3*k1**2*k2*s - 15*Dd*Pkd2*f**3*k1**2*k2 + 36*Dd*Pkd2*f**2*k1**2*k2*s - 9*Dd*Pkd2*f**2*k1**2*k2 - 112*Dd*Pkd2*f*g2*k1**2*k2*s + 28*Dd*Pkd2*f*g2*k1**2*k2 - 21*b2*k1**2*(2*Pk2 - Pkd2*k2)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))) + f*(11*D1*bd1*(f**2*(14*Pk2*k2**2*r + k1**2*(Pk2*(34*r + 78*s + 3) + 5*Pkd2*k2*(3*s - 2))) + f*(13*Pk2*k2**2*r + k1**2*(Pk2*(-44*K*s + 25*r + 8*s) + Pkd2*k2*s*(9*K + 9))) - 14*g2*k1**2*(-2*Pk2*(9*s + 1) + Pkd2*k2*(2*s + 1))) - 33*b2*k1**2*(2*Pk2 - Pkd2*k2)*(7*D1*bd1*s + D1*fd*(6*s - 3) + 3*Dd*f*(4*s - 1)) + k1**2*(5*D1*Pk2*f**2*fd*(108*r + 352*s - 115) - 11*D1*f*s*(18*Pk2*bd2 - 88*Pk2*gd2 - 9*Pkd2*bd2*k2 + 18*Pkd2*gd2*k2) + 22*D1*fd*g2*(44*Pk2 - 9*Pkd2*k2)*(2*s - 1) + 5*Dd*Pk2*f**3*(108*r + 352*s - 115) + 22*Dd*f*g2*(44*Pk2 - 9*Pkd2*k2)*(4*s - 1))))/(1155*d*k1**2*k2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**2*st**3*(-21*b1**2*k1**2*k2**2*(C - 1)*(-2*Pk2 + Pkd2*k2)*(D1*fd*s + Dd*f*(4*s - 1)) + 3*b1*f*(D1*(-7*bd1*k1**2*k2**2*(C - 1)*(-2*Pk2 + Pkd2*k2)*(2*s - 1) + fd*(2*Pk2*k2**4*r + k1**4*(C - 5)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 2*k1**2*k2**2*(Pk2*(C*(-26*r - 54*s + 28) + 31*r + 26*s - 14) + Pkd2*k2*(C*(9*s - 5) + 5*s - 2)))) + Dd*f*(Pk2*k2**4*(4*r - 1) + k1**4*(C - 5)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(-8*C*(13*r + 27*s - 10) + 124*r + 104*s - 57) + Pkd2*k2*(9*C + 5)*(4*s - 1)))) + f**2*(D1*(3*bd1*(Pk2*k2**4*(r - 1) + k1**4*s*(C - 5)*(4*Pk2 - Pkd2*k2) + k1**2*k2**2*(Pk2*(C*(-26*r - 54*s + 24) + 31*r + 26*s - 29) + Pkd2*k2*(9*C*s + C + 5*s - 1))) + fd*(9*Pk2*k2**4*(3*r - 1) + k1**4*(C - 5)*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k1**2*k2**2*(-3*Pk2*(C*(26*r + 40*s - 22) - 39*r - 12*s + 17) + Pkd2*k2*(10*C + 4)*(3*s - 1)))) + Dd*f*(9*Pk2*k2**4*(4*r - 1) + k1**4*(C - 5)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(-2*C*(52*r + 80*s - 33) + 156*r + 48*s - 51) + Pkd2*k2*(10*C + 4)*(4*s - 1)))))/(105*d*k1**2*k2*k3**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**2*st*(21*b1**2*(D1*fd*(-Pk2*k2**4*r + k1**4*s*(2*C - 6)*(2*Pk2 - Pkd2*k2) + k1**2*k2**2*(Pk2*r*(31 - 28*C) - Pk2*s*(28*C - 28) + Pkd2*k2*s*(6*C + 4))) + Dd*f*(Pk2*k2**4*(1 - 4*r) + k1**4*(2*C - 6)*(2*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(-56*C*(2*r + 2*s - 1) + 124*r + 112*s - 59) + Pkd2*k2*(6*C + 4)*(4*s - 1)))) + 3*b1*f*(7*D1*bd1*(Pk2*k2**4*(1 - 2*r) + k1**4*(2*C - 6)*(2*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(Pk2*(-56*C*(r + s - 1) + 62*r + 56*s - 59) + Pkd2*k2*(6*C + 4)*(2*s - 1))) + D1*fd*(13*Pk2*k2**4*(2*r - 1) + k1**4*(2*Pk2*(C*(44 - 76*s) + 37*r + 118*s - 77) + 6*Pkd2*k2*(C*(4*s - 3) + 6*s)) + k1**2*k2**2*(Pk2*(232*C*s - 84*C + 268*r + 308*s - 211) + Pkd2*k2*s*(36*C + 24))) + Dd*f*(13*Pk2*k2**4*(4*r - 1) + k1**4*(Pk2*(-304*C*s + 76*C + 148*r + 472*s - 155) + Pkd2*k2*(12*C + 18)*(4*s - 1)) + 2*k1**2*k2**2*(58*C*Pk2*(4*s - 1) + 4*Pk2*(67*r + 77*s - 36) + Pkd2*k2*(9*C + 6)*(4*s - 1)))) + f**2*(-3*D1*bd1*(-13*Pk2*k2**4*r + k1**4*(Pk2*(76*C*s + 12*C - 37*r - 118*s + 1) - 6*Pkd2*k2*(2*C*s + C + 3*s - 3)) + k1**2*k2**2*(Pk2*(-116*C*s + 32*C - 134*r - 154*s + 77) + Pkd2*k2*(-18*C - 12)*(s - 1))) + k1**2*(D1*fd*(Pk2*k2**2*(12*C*(51*r + 54*s - 35) + 141*r + 414*s - 185) + k1**2*(30*C*Pkd2*k2*(3*s - 1) + Pk2*(-408*C*s + 136*C + 201*r + 642*s - 281))) + Dd*f*(Pk2*k2**2*(12*C*(68*r + 72*s - 35) + 188*r + 552*s - 185) + k1**2*(30*C*Pkd2*k2*(4*s - 1) + Pk2*(-544*C*s + 136*C + 268*r + 856*s - 281))))))/(315*d*k1**2*k2*k3**2) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct*f**2*st**5*(4*Pk2 - Pkd2*k2)*(11*b1*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1)) + f*(11*D1*bd1*s + 3*D1*fd*(4*s - 1) + 3*Dd*f*(4*s - 1)))/(231*d*k1) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct*f*st**5*(9*b1*(D1*fd*(k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(Pk2*(r*(8*C - 8) + 4*s - 2) + Pkd2*k2*(1 - 2*s))) + Dd*f*(k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(2*Pk2*(8*C*r - 2*C - 8*r + 4*s + 1) + Pkd2*k2*(1 - 4*s)))) + f*(-9*D1*bd1*(-4*Pk2*k1**2*s - 2*Pk2*k2**2*(2*C*(r - 1) - 2*r + s + 2) + Pkd2*k1**2*k2*s + Pkd2*k2**3*s) + D1*fd*(k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(2*Pk2*(6*C*r - 2*C - 6*r + 3*s + 1) + Pkd2*k2*(1 - 3*s))) + Dd*f*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + Dd*f*k2**2*(2*Pk2*(C*(8*r - 2) - 8*r + 4*s + 1) + Pkd2*k2*(1 - 4*s))))/(63*d*k1*k3**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct*st**3*(-33*b1**2*(D1*fd*(k1**2*(4*Pk2 - Pkd2*k2)*(8*f*s - 4*f + 7*s - 7) + k2**2*(2*Pk2*(4*f*(4*s - 1) + 7*r*(K - 1) + 7*s - 7) + Pkd2*k2*(f*(4 - 16*s) - 7*s + 7))) + Dd*f*(k1**2*(4*Pk2 - Pkd2*k2)*(4*f + 7)*(4*s - 1) + k2**2*(56*K*Pk2*r - 14*K*Pk2 - 56*Pk2*r + 56*Pk2*s - 28*Pkd2*k2*s + 7*Pkd2*k2 + 8*f*(2*Pk2 - Pkd2*k2)*(4*s - 1)))) - 11*b1*(D1*(-84*Pk2*fd*g2*k2**2*r + 4*f**2*(3*bd1*(8*Pk2*k1**2*s + 2*Pk2*k2**2*(4*s - 1) - 2*Pkd2*k1**2*k2*s + k2**3*(-4*Pkd2*s + Pkd2)) + fd*(2*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(Pk2*(-36*r - 33*s + 17) + Pkd2*k2*(1 - 6*s)))) + 3*f*(-28*Pk2*gd2*k2**2*r - 14*bd1*(-4*Pk2*k1**2*s - Pk2*k2**2*(2*K*r - K - 2*r + 2*s + 1) + Pkd2*k1**2*k2*s + Pkd2*k2**3*s) + fd*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + fd*k2**2*(2*K*Pk2*(2*r - 1) - 4*Pk2*r + 4*Pk2*s - 2*Pkd2*k2*s + Pkd2*k2))) + Dd*f*(84*Pk2*g2*k2**2*(1 - 4*r) + 4*f**2*(2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(Pk2*(-48*r - 44*s + 23) + 2*Pkd2*k2*(1 - 4*s))) + 3*f*(k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(8*K*Pk2*r - 2*K*Pk2 - 8*Pk2*r + 8*Pk2*s - 4*Pkd2*k2*s + Pkd2*k2)))) + f*(D1*(132*Pk2*g2*k2**2*(7*bd1*(r - 1) + fd*(2*r - 1)) - 4*f**2*(-11*bd1*(-8*Pk2*k1**2*s + Pk2*k2**2*(12*r + 11*s - 6) + 2*Pkd2*k1**2*k2*s + Pkd2*k2**3*(2*s - 1)) + fd*(Pk2*k2**2*(-192*r - 220*s + 103) + 5*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 33*f*(4*Pk2*gd2*k2**2*r + bd1*(-4*Pk2*k1**2*s - 2*Pk2*k2**2*(r*(K - 1) + s) + Pkd2*k1**2*k2*s + Pkd2*k2**3*s))) - 4*Dd*(33*Pk2*f*g2*k2**2*(1 - 4*r) + f**3*(Pk2*k2**2*(-192*r - 220*s + 103) + 5*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)))))/(1155*d*k1*k2**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct*st*(-21*b1**3*(-2*D1*fd*s*(Pkd2*k2**3 + k1**2*(-2*Pk2 + Pkd2*k2)) + Dd*(k1**2*(2*Pk2 - Pkd2*k2)*(2*f + 5)*(4*s - 1) + k2**2*(Pk2*(10*K - 10)*(4*r - 1) - Pkd2*k2*(2*f + 5)*(4*s - 1)))) - 3*b1**2*(7*D1*bd1*(k1**2*(2*Pk2 - Pkd2*k2)*(2*f + 5)*(3*s - 1) + k2**2*(Pk2*(10*K - 10)*(3*r - 1) - Pkd2*k2*(2*f + 5)*(3*s - 1))) - D1*(140*Pk2*gd2*k2**2*r + fd*k1**2*(Pk2*(6*f*(6*s - 7) + 70*s - 84) + Pkd2*k2*s*(24*f + 7)) + fd*k2**2*(2*Pk2*(-7*K*r + 7*K + f*(64*r + 84*s - 29) + 7*r + 42*s - 49) + Pkd2*k2*s*(12*f + 7))) - Dd*(140*Pk2*g2*k2**2*(4*r - 1) + 2*f**2*(3*k1**2*(3*Pk2 + 2*Pkd2*k2)*(4*s - 1) + k2**2*(2*Pk2*(64*r + 84*s - 37) + 3*Pkd2*k2*(4*s - 1))) + 7*f*(k1**2*(10*Pk2 + Pkd2*k2)*(4*s - 1) + k2**2*(2*Pk2*(-4*K*r + K + 4*r + 24*s - 7) + Pkd2*k2*(4*s - 1))))) + b1*(3*D1*bd1*(140*Pk2*g2*k2**2*(2*r - 1) + 2*f**2*(6*k1**2*(Pk2*(3*s + 2) + Pkd2*k2*(2*s - 1)) + k2**2*(Pk2*(64*r + 84*s - 45) + 3*Pkd2*k2*(2*s - 1))) + 7*f*(k1**2*(Pk2*(20*s + 2) + Pkd2*k2*(2*s - 1)) + k2**2*(4*Pk2*(-K*r + r + 6*s) + Pkd2*k2*(2*s - 1)))) + 6*D1*(2*Pk2*f*(5*fd*k1**2*(2*s - 1) + fd*k2**2*(K*(8*r - 4) + 8*r + 10*s - 9) + 7*gd2*k2**2*r) + 14*Pk2*fd*g2*k2**2*(r - 1) + f**2*fd*(Pk2*k2**2*(48*r + 54*s - 25) + k1**2*(44*Pk2*s - 18*Pk2 + 5*Pkd2*k2*s))) + 2*Dd*f*(6*Pk2*f*(5*k1**2*(4*s - 1) + k2**2*(16*K*r - 4*K + 16*r + 20*s - 9)) + 42*Pk2*g2*k2**2*(4*r - 1) + f**2*(6*Pk2*k2**2*(32*r + 36*s - 17) + k1**2*(44*Pk2 + 5*Pkd2*k2)*(4*s - 1)))) + 2*f*(D1*bd1*(6*Pk2*f*(5*k1**2*s + k2**2*(r*(4*K + 4) + 5*s)) + 42*Pk2*g2*k2**2*r + f**2*(3*Pk2*k2**2*(16*r + 18*s - 9) + k1**2*(2*Pk2*(22*s + 5) + 5*Pkd2*k2*(s - 1)))) + 3*Pk2*(5*D1*f**2*fd*k1**2*(4*s - 1) + 8*D1*f*k2**2*r*(bd2 - 2*gd2) + 8*D1*fd*k2**2*(b2 - 2*g2)*(2*r - 1) + 5*Dd*f**3*k1**2*(4*s - 1) + 8*Dd*f*k2**2*(b2 - 2*g2)*(4*r - 1))))/(315*d*k1*k2**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct*st**3*(21*b1**2*k2**2*(D1*fd*(-2*Pk2*k1**2*s + Pk2*k2**2*r*(4 - 4*C) + Pkd2*k1**2*k2*s + Pkd2*k2**3*s) - Dd*f*(k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(Pk2*(4*C - 4)*(4*r - 1) + Pkd2*k2*(1 - 4*s)))) - 3*b1*f*(D1*(7*bd1*k2**2*(k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(Pk2*(4*C - 4)*(2*r - 1) + Pkd2*k2*(1 - 2*s))) + fd*(k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(Pk2*(8*C*(r + 10*s - 5) - 52*r - 72*s + 38) + Pkd2*k2*(C*(16 - 32*s) - 4*s + 1)) - 2*k2**4*(2*Pk2*(-2*C*r + C + 11*r + 16*s - 9) + Pkd2*k2*s))) + Dd*f*(k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 2*k1**2*k2**2*(Pk2*(C*(-8*r - 80*s + 22) + 52*r + 72*s - 31) + Pkd2*k2*(8*C + 1)*(4*s - 1)) + k2**4*(2*Pk2*(8*C*r - 2*C - 44*r - 64*s + 27) + Pkd2*k2*(1 - 4*s)))) + f**2*(D1*(3*bd1*(k1**4*(-4*Pk2*s + Pkd2*k2*s) + k1**2*k2**2*(Pk2*(-4*C*(r + 10*s - 1) + 26*r + 36*s - 24) + Pkd2*k2*(s*(16*C + 2) - 1)) + k2**4*(Pk2*(-4*C*r + 22*r + 32*s - 18) + Pkd2*k2*(s - 1))) + fd*(2*Pk2*k2**4*(16*C*(3*r - 1) + 27*r + 24*s - 17) - k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k1**2*k2**2*(-2*Pk2*(C*(6*r + 60*s - 22) - 39*r - 33*s + 24) + Pkd2*k2*(16*C + 1)*(3*s - 1)))) + Dd*f*(2*Pk2*k2**4*(16*C*(4*r - 1) + 36*r + 32*s - 17) - k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(-4*Pk2*(C*(4*r + 40*s - 11) - 26*r - 22*s + 12) + Pkd2*k2*(16*C + 1)*(4*s - 1)))))/(105*d*k1*k2**2*k3**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct*st*(-21*b1**2*(-D1*fd*(2*Pk2*k2**4*(5*r + 6*s) + k1**4*(-2*Pk2*s + Pkd2*k2*s) + k1**2*k2**2*(Pk2*r*(18 - 4*C) + Pk2*s*(20 - 8*C) + Pkd2*k2*s*(8*C + 1))) + Dd*f*(-2*Pk2*k2**4*(20*r + 24*s - 11) + k1**4*(2*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(2*Pk2*(2*C*(4*r + 8*s - 3) - 36*r - 40*s + 19) - Pkd2*k2*(8*C + 1)*(4*s - 1)))) + 3*b1*f*(-7*D1*bd1*(-2*Pk2*k2**4*(10*r + 12*s - 11) + k1**4*(2*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(2*Pk2*(C*(4*r + 8*s - 6) - 18*r - 20*s + 19) - Pkd2*k2*(8*C + 1)*(2*s - 1))) + 2*D1*fd*(Pk2*k2**4*(16*C*(2*r - 1) + 30*r + 20*s - 15) + k1**4*(2*Pk2*(7*s - 5) + 3*Pkd2*k2*s) + k1**2*k2**2*(Pk2*(2*C*(22*r + 72*s - 39) + 54*r + 64*s - 37) + Pkd2*k2*s*(24*C + 3))) + Dd*f*(2*Pk2*k2**4*(64*C*r - 16*C + 60*r + 40*s - 25) + k1**4*(14*Pk2 + 3*Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(2*Pk2*(C*(88*r + 288*s - 94) + 108*r + 128*s - 59) + Pkd2*k2*(24*C + 3)*(4*s - 1)))) + f**2*(3*D1*bd1*(2*Pk2*k2**4*(r*(16*C + 15) + 10*s - 10) + k1**4*(2*Pk2*(7*s + 3) + 3*Pkd2*k2*(s - 1)) + k1**2*k2**2*(2*Pk2*(2*C*(11*r + 36*s - 8) + 27*r + 32*s - 22) + Pkd2*k2*(24*C + 3)*(s - 1))) + 4*Pk2*k1**2*(D1*fd*(7*k1**2*(3*s - 1) + k2**2*(2*C*(39*r + 81*s - 40) + 21*s - 7)) + Dd*f*(7*k1**2*(4*s - 1) + k2**2*(8*C*(13*r + 27*s - 10) + 28*s - 7)))))/(315*d*k1*k2**2*k3**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*f*k2*st**5*(9*D1*bd1*f*(Pk2*k2**2*(r - 1) + k1**2*(2*C*Pkd2*k2*s + Pk2*(-4*C*s + r - 1))) - 9*b1*(2*C*D1*fd*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 2*D1*Pk2*fd*r*(k1**2 + k2**2) + Dd*Pk2*f*k2**2*(1 - 4*r) + Dd*f*k1**2*(4*C*Pk2*(4*s - 1) + 2*C*Pkd2*k2*(1 - 4*s) - 4*Pk2*r + Pk2)) - f*(D1*fd*(Pk2*k2**2*(1 - 3*r) + k1**2*(4*C*Pk2*(3*s - 1) + 2*C*Pkd2*k2*(1 - 3*s) - 3*Pk2*r + Pk2)) + Dd*f*(Pk2*k2**2*(1 - 4*r) + k1**2*(4*C*Pk2*(4*s - 1) + 2*C*Pkd2*k2*(1 - 4*s) - 4*Pk2*r + Pk2))))/(63*d*k1**2*k3**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*f*st**5*(-99*b1**2*k1**2*(4*Pk2 - Pkd2*k2)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) - 11*b1*f*(3*D1*(-7*Pk2*fd*k2**2*r + 6*bd1*k1**2*s*(4*Pk2 - Pkd2*k2) + fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) + Dd*f*(7*Pk2*k2**2*(1 - 4*r) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + f**2*(D1*(11*bd1*(-12*Pk2*k1**2*s + 7*Pk2*k2**2*(r - 1) + 3*Pkd2*k1**2*k2*s) - 3*fd*(7*Pk2*k2**2*(1 - 4*r) + 2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) - 3*Dd*f*(7*Pk2*k2**2*(1 - 4*r) + 2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))))/(693*d*k1**2*k2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*st*(7*b1**2*(D1*fd*(Pk2*k2**2*(20*C*r + 20*C*s + r + 2*s) + k1**2*(2*C*Pkd2*k2*s + Pk2*r + 2*Pk2*s)) + Dd*f*(Pk2*k2**2*(40*C*(2*r + 2*s - 1) + 4*r + 8*s - 3) + k1**2*(2*C*Pkd2*k2*(4*s - 1) + Pk2*(4*r + 8*s - 3)))) + b1*f*(7*D1*bd1*(Pk2*k2**2*(40*C*(r + s - 1) + 2*r + 4*s - 3) + k1**2*(2*C*Pkd2*k2*(2*s - 1) + Pk2*(2*r + 4*s - 3))) + D1*fd*(Pk2*k2**2*(4*C*(30*r + 14*s - 15) + 6*r + 12*s - 3) + k1**2*(12*C*Pkd2*k2*s + Pk2*(56*C*s - 28*C + 6*r + 12*s - 3))) + Dd*f*(Pk2*k2**2*(8*C*(30*r + 14*s - 11) + 12*r + 24*s - 9) + k1**2*(28*C*Pk2*(4*s - 1) + 6*C*Pkd2*k2*(4*s - 1) + 3*Pk2*(4*r + 8*s - 3)))) + f**2*(12*C*Pk2*k1**2*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1)) + D1*bd1*(Pk2*k2**2*(4*C*(15*r + 7*s - 7) + 3*r + 6*s - 6) + k1**2*(6*C*Pkd2*k2*(s - 1) + Pk2*(28*C*s + 3*r + 6*s - 6)))))/(105*d*k2*k3**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*st**3*(-231*b1**3*k1**2*(2*Pk2 - Pkd2*k2)*(D1*fd*s + Dd*f*(4*s - 1)) - 33*b1**2*(7*D1*bd1*f*k1**2*(2*Pk2 - Pkd2*k2)*(3*s - 1) - D1*fd*(Pk2*k2**2*r*(20*f + 7) + k1**2*(2*Pk2*f*(7*r + 20*s - 13) + 7*Pk2*(-2*K*(s - 1) + r - 2*s + 2) + Pkd2*f*k2*(8*s - 1) + Pkd2*k2*(7*K + 7)*(s - 1))) - Dd*f*(Pk2*k2**2*(10*f + 7)*(4*r - 1) + k1**2*(Pk2*f*(28*r + 80*s - 27) + 7*Pk2*(K*(2 - 8*s) + 4*r - 8*s + 1) + Pkd2*k2*(4*s - 1)*(7*K + 4*f + 7)))) + 11*b1*(-12*D1*K*Pk2*f*fd*k1**2*s + 6*D1*K*Pk2*f*fd*k1**2 + 6*D1*K*Pkd2*f*fd*k1**2*k2*s - 3*D1*K*Pkd2*f*fd*k1**2*k2 - 42*D1*Pk2*bd2*f*k1**2*s + 42*D1*Pk2*f**2*fd*k1**2*r + 90*D1*Pk2*f**2*fd*k1**2*s - 41*D1*Pk2*f**2*fd*k1**2 + 30*D1*Pk2*f**2*fd*k2**2*r - 10*D1*Pk2*f**2*fd*k2**2 + 6*D1*Pk2*f*fd*k1**2*r - 12*D1*Pk2*f*fd*k1**2*s + 3*D1*Pk2*f*fd*k1**2 + 6*D1*Pk2*f*fd*k2**2*r - 3*D1*Pk2*f*fd*k2**2 + 84*D1*Pk2*f*gd2*k1**2*s + 84*D1*Pk2*fd*g2*k1**2*s - 84*D1*Pk2*fd*g2*k1**2 + 21*D1*Pkd2*bd2*f*k1**2*k2*s + 9*D1*Pkd2*f**2*fd*k1**2*k2*s - D1*Pkd2*f**2*fd*k1**2*k2 + 6*D1*Pkd2*f*fd*k1**2*k2*s - 3*D1*Pkd2*f*fd*k1**2*k2 - 42*D1*Pkd2*f*gd2*k1**2*k2*s - 42*D1*Pkd2*fd*g2*k1**2*k2*s + 42*D1*Pkd2*fd*g2*k1**2*k2 + 3*D1*bd1*f*(Pk2*k2**2*(10*f + 7)*(2*r - 1) + k1**2*(Pk2*f*(14*r + 40*s - 1) - 7*Pk2*(-2*r + s*(4*K + 4) + 1) + Pkd2*f*k2*(8*s - 3) + Pkd2*k2*s*(14*K + 14))) - 24*Dd*K*Pk2*f**2*k1**2*s + 6*Dd*K*Pk2*f**2*k1**2 + 12*Dd*K*Pkd2*f**2*k1**2*k2*s - 3*Dd*K*Pkd2*f**2*k1**2*k2 + 56*Dd*Pk2*f**3*k1**2*r + 120*Dd*Pk2*f**3*k1**2*s - 44*Dd*Pk2*f**3*k1**2 + 40*Dd*Pk2*f**3*k2**2*r - 10*Dd*Pk2*f**3*k2**2 + 12*Dd*Pk2*f**2*k1**2*r - 24*Dd*Pk2*f**2*k1**2*s + 3*Dd*Pk2*f**2*k1**2 + 12*Dd*Pk2*f**2*k2**2*r - 3*Dd*Pk2*f**2*k2**2 + 336*Dd*Pk2*f*g2*k1**2*s - 84*Dd*Pk2*f*g2*k1**2 + 12*Dd*Pkd2*f**3*k1**2*k2*s - 3*Dd*Pkd2*f**3*k1**2*k2 + 12*Dd*Pkd2*f**2*k1**2*k2*s - 3*Dd*Pkd2*f**2*k1**2*k2 - 168*Dd*Pkd2*f*g2*k1**2*k2*s + 42*Dd*Pkd2*f*g2*k1**2*k2 - 21*b2*k1**2*(2*Pk2 - Pkd2*k2)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))) + f*(11*D1*bd1*(f**2*(10*Pk2*k2**2*r + k1**2*(Pk2*(14*r + 30*s - 3) + Pkd2*k2*(3*s - 2))) + 3*f*(Pk2*k2**2*r + k1**2*(Pk2*(r - s*(2*K + 2)) + Pkd2*k2*s*(K + 1))) + 42*g2*k1**2*s*(2*Pk2 - Pkd2*k2)) - 33*b2*k1**2*(2*Pk2 - Pkd2*k2)*(7*D1*bd1*s + D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) + k1**2*(D1*Pk2*f**2*fd*(140*r + 352*s - 123) - 33*D1*f*s*(2*Pk2 - Pkd2*k2)*(bd2 - 2*gd2) + 66*D1*fd*g2*(2*Pk2 - Pkd2*k2)*(2*s - 1) + Dd*Pk2*f**3*(140*r + 352*s - 123) + 66*Dd*f*g2*(2*Pk2 - Pkd2*k2)*(4*s - 1))))/(1155*d*k1**2*k2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*st*(21*b1**3*(3*D1*Pk2*fd*k2**2*r + D1*fd*k1**2*(5*Pk2*(r + 2*s) + Pkd2*k2*s) + Dd*Pk2*k2**2*(3*f + 5)*(4*r - 1) + Dd*k1**2*(5*Pk2*(f*(4*r + 8*s - 3) + 4*r - 1) + Pkd2*k2*(4*s - 1)*(5*K + f + 5))) + 3*b1**2*(7*D1*bd1*(Pk2*k2**2*(3*f + 5)*(3*r - 1) + k1**2*(5*Pk2*(3*f*(r + 2*s - 1) + 3*r - 1) + Pkd2*k2*(3*s - 1)*(5*K + f + 5))) + D1*(Pk2*fd*k2**2*(18*f*r - 9*f + 7*r - 7) + Pkd2*k1**2*k2*s*(35*bd2 - 70*gd2) + fd*k1**2*(Pk2*(70*K*(s - 1) + f*(60*r + 112*s - 29) + 7*r + 70*s - 77) + Pkd2*k2*s*(7*K + 6*f + 7))) + Dd*(Pkd2*k1**2*k2*(35*b2 - 70*g2)*(4*s - 1) + f**2*(9*Pk2*k2**2*(4*r - 1) + k1**2*(2*Pk2*(60*r + 112*s - 43) + 3*Pkd2*k2*(4*s - 1))) + 7*f*(Pk2*k2**2*(4*r - 1) + k1**2*(Pk2*(40*K*s - 10*K + 4*r + 40*s - 11) + Pkd2*k2*(K + 1)*(4*s - 1))))) + b1*(3*D1*bd1*(70*Pkd2*g2*k1**2*k2*(1 - 2*s) + f**2*(18*Pk2*k2**2*r + k1**2*(Pk2*(60*r + 112*s - 57) + 3*Pkd2*k2*(2*s - 1))) + 7*f*(2*Pk2*k2**2*r + k1**2*(2*Pk2*(r + s*(10*K + 10)) + Pkd2*k2*(K + 1)*(2*s - 1)))) + 21*b2*k1**2*(D1*(10*Pk2*fd*(s - 1) + 5*Pkd2*bd1*k2*(2*s - 1) + Pkd2*fd*k2*s) + Dd*f*(10*Pk2 + Pkd2*k2)*(4*s - 1)) + k1**2*(D1*(Pk2*f**2*fd*(75*r + 162*s - 43) + 21*f*(2*Pk2*fd*(K + 1)*(2*s - 1) + s*(10*Pk2 + Pkd2*k2)*(bd2 - 2*gd2)) - 42*fd*g2*(10*Pk2*(s - 1) + Pkd2*k2*s)) + Dd*f*(Pk2*f**2*(100*r + 216*s - 79) + 42*Pk2*f*(K + 1)*(4*s - 1) - 42*g2*(10*Pk2 + Pkd2*k2)*(4*s - 1)))) + f*k1**2*(D1*bd1*(Pk2*f**2*(25*r + 54*s - 36) + 42*Pk2*f*s*(K + 1) - 42*g2*(10*Pk2*s + Pkd2*k2*(s - 1))) + 42*Pk2*(D1*f*s*(bd2 - 2*gd2) + D1*fd*g2*(2 - 4*s) + 2*Dd*f*g2*(1 - 4*s)) + 21*b2*(D1*(10*Pk2*bd1*s + 2*Pk2*fd*(2*s - 1) + Pkd2*bd1*k2*(s - 1)) + 2*Dd*Pk2*f*(4*s - 1))))/(315*d*k1**2*k2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*st**3*(-3*D1*bd1*f*(-7*b1*k2**2*(Pk2*k2**2*(2*r - 1) + k1**2*(2*C*Pkd2*k2*(2*s - 1) + Pk2*(2*r - 1))) + f*(-Pk2*k2**4*r + k1**4*(-2*C*Pkd2*k2*s - Pk2*(-4*C*s + r + 2*s - 1)) + k1**2*k2**2*(-2*C*Pkd2*k2*(s - 1) - Pk2*(28*C*(r + 2*s - 1) + 2*r + 2*s - 1)))) + 21*b1**2*k2**2*(D1*fd*(Pk2*k2**2*r + k1**2*(2*C*Pkd2*k2*s + Pk2*r)) + Dd*f*(Pk2*k2**2*(4*r - 1) + k1**2*(2*C*Pkd2*k2*(4*s - 1) + Pk2*(4*r - 1)))) - 3*b1*f*(D1*fd*(Pk2*k2**4*(1 - 2*r) + 2*k1**4*(C*Pkd2*k2*(1 - 2*s) - Pk2*(C*(2 - 4*s) + r + 2*s - 1)) - k1**2*k2**2*(4*C*Pkd2*k2*s + Pk2*(56*C*(r + 2*s - 1) + 4*r + 4*s - 3))) + Dd*f*(Pk2*k2**4*(1 - 4*r) + k1**4*(2*C*Pkd2*k2*(1 - 4*s) + Pk2*(16*C*s - 4*C - 4*r - 8*s + 3)) - 2*k1**2*k2**2*(C*Pkd2*k2*(4*s - 1) + 2*Pk2*(7*C*(4*r + 8*s - 3) + 2*r + 2*s - 1)))) + f**2*k1**2*(D1*fd*(Pk2*k2**2*(C*(84*r + 72*s - 52) + 3*r + 6*s - 3) + k1**2*(2*C*Pkd2*k2*(3*s - 1) + Pk2*(-12*C*s + 4*C + 3*r + 6*s - 3))) + Dd*f*(Pk2*k2**2*(4*C*(28*r + 24*s - 13) + 4*r + 8*s - 3) + k1**2*(2*C*Pkd2*k2*(4*s - 1) + Pk2*(-16*C*s + 4*C + 4*r + 8*s - 3)))))/(105*d*k1**2*k2*k3**2) - 8*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**5*f*k2**2*st*(C - 1)*(9*D1*bd1*f*(r - 1) + 9*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 5*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(315*d*k3**2) + 5*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**4*f**2*k2*st*(11*D1*bd1*f*(r - 1) + 11*b1*(3*D1*fd*r + Dd*f*(4*r - 1)) + 7*f*(4*r - 1)*(D1*fd + Dd*f))/(693*d*k1) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**4*f*k2*st*(k1**2*(4 - 3*C) + k2**2)*(9*D1*bd1*f*(r - 1) + 9*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 5*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(315*d*k1*k3**2) - 8*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**3*f*k2**2*st**3*(C - 1)*(6*D1*b1*fd*r + 3*D1*bd1*f*(r - 1) + D1*f*fd*(3*r - 1) + 3*Dd*b1*f*(4*r - 1) + Dd*f**2*(4*r - 1))/(105*d*k3**2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**3*st*(33*b1**2*(D1*fd*r*(-7*K + 12*f + 7) + Dd*f*(4*r - 1)*(-7*K + 6*f + 7)) + 11*b1*(3*D1*bd1*f*(2*r - 1)*(-7*K + 6*f + 7) + D1*(10*f**2*fd*(9*r - 1) - 9*f*fd*(K - 1)*(2*r - 1) + 42*f*gd2*r + 42*fd*g2*r) + 3*Dd*f*(4*r - 1)*(10*f**2 - 3*f*(K - 1) + 14*g2)) + f*(11*D1*bd1*(10*f**2*(3*r - 2) - 9*f*r*(K - 1) + 42*g2*(r - 1)) + 2*D1*(70*f**2*fd*(4*r - 1) + 99*f*gd2*r + 99*fd*g2*(2*r - 1)) + 2*Dd*f*(70*f**2 + 99*g2)*(4*r - 1)))/(3465*d) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**3*st*(3*D1*bd1*f*(14*b1*k2**2*(C - 1)*(2*r - 1) + 3*f*(k1**2*(2*C - 5)*(r - 1) + k2**2*(-2*C*r + 4*C - 5*r + 3))) + 42*b1**2*k2**2*(C - 1)*(D1*fd*r + Dd*f*(4*r - 1)) + 9*b1*f*(-2*D1*fd*(k1**2*r*(5 - 2*C) + k2**2*(2*C*r + C + 5*r - 1)) + Dd*f*(4*r - 1)*(k1**2*(2*C - 5) - k2**2*(2*C + 5))) + 5*f**2*(k1**2*(2*C - 5) - k2**2*(4*C + 3))*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(315*d*k3**2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**2*f**2*k2*st**3*(11*D1*bd1*f*(r - 1) + 11*b1*(3*D1*fd*r + Dd*f*(4*r - 1)) + 5*f*(4*r - 1)*(D1*fd + Dd*f))/(231*d*k1) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**2*f*k2*st**3*(-k1**2*(C - 2) + k2**2)*(6*D1*b1*fd*r + 3*D1*bd1*f*(r - 1) + D1*f*fd*(3*r - 1) + 3*Dd*b1*f*(4*r - 1) + Dd*f**2*(4*r - 1))/(105*d*k1*k3**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**2*st*(11*b1**2*(2*D1*fd*r*(k1**2*(9*f + 7) + k2**2*(18*f + 7)) + Dd*f*(4*r - 1)*(k1**2*(9*f + 14) + k2**2*(18*f + 14))) + 11*b1*f*(D1*bd1*(2*r - 1)*(k1**2*(9*f + 14) + k2**2*(18*f + 14)) + D1*fd*(k1**2*(5*f*(6*r - 1) + 12*r - 6) + 2*k2**2*(5*f*(3*r - 1) + 6*r - 3)) + 2*Dd*f*(5*f + 3)*(k1**2 + k2**2)*(4*r - 1)) + f**2*(11*D1*bd1*(5*f*(k1**2*(2*r - 1) + 2*k2**2*r) + r*(6*k1**2 + 6*k2**2)) + 35*f*k1**2*(4*r - 1)*(D1*fd + Dd*f)))/(1155*d*k1*k2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**2*st*(3*D1*bd1*f*(7*b1*k2**2*(2*r - 1)*(k1**2*(3 - 2*C) + k2**2) + 3*f*(k1**4*(r - 1) + k1**2*k2**2*(4*C*r - 6*C + 4*r - 1) + k2**4*r)) + 21*b1**2*k2**2*(k1**2*(3 - 2*C) + k2**2)*(D1*fd*r + Dd*f*(4*r - 1)) + 9*b1*f*(D1*fd*(2*k1**4*r + k1**2*k2**2*(C*(8*r + 2) + 8*r - 3) + k2**4*(2*r - 1)) + Dd*f*(4*r - 1)*(k1**4 + k1**2*k2**2*(4*C + 4) + k2**4)) + 5*f**2*k1**2*(k1**2 + k2**2*(6*C + 1))*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(315*d*k1*k2*k3**2) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct*f*st**3*(33*b1**2*(2*D1*fd*r + Dd*f*(4*r - 1)) + 11*b1*f*(3*D1*bd1*(2*r - 1) + D1*fd*(9*r - 1) + 3*Dd*f*(4*r - 1)) + f**2*(11*D1*bd1*(3*r - 2) + (4*r - 1)*(10*D1*fd + 10*Dd*f)))/(1155*d) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct*f*st**3*(k1**2 + k2**2*(4*C + 1))*(6*D1*b1*fd*r + 3*D1*bd1*f*(r - 1) + D1*f*fd*(3*r - 1) + 3*Dd*b1*f*(4*r - 1) + Dd*f**2*(4*r - 1))/(105*d*k3**2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct*st*(7*b1**3*(D1*fd*r + Dd*f*(4*r - 1)) + b1**2*(7*D1*bd1*f*(3*r - 1) + D1*fd*(3*f*(8*r - 1) + r*(7*K + 7)) + Dd*f*(4*r - 1)*(7*K + 12*f + 7)) + b1*(6*D1*K*f*fd*r - 3*D1*K*f*fd + D1*bd1*f*(3*f*(8*r - 3) + (7*K + 7)*(2*r - 1)) + 7*D1*bd2*f*r + 15*D1*f**2*fd*r - 5*D1*f**2*fd + 6*D1*f*fd*r - 3*D1*f*fd - 14*D1*f*gd2*r - 14*D1*fd*g2*r + 12*Dd*K*f**2*r - 3*Dd*K*f**2 + 20*Dd*f**3*r - 5*Dd*f**3 + 12*Dd*f**2*r - 3*Dd*f**2 - 56*Dd*f*g2*r + 14*Dd*f*g2 + 7*b2*(D1*fd*r + Dd*f*(4*r - 1))) + f*(D1*bd1*(f*r*(3*K + 5*f + 3) - 14*g2*(r - 1)) + 3*D1*(f*r*(bd2 - 2*gd2) + fd*g2*(2 - 4*r)) + 6*Dd*f*g2*(1 - 4*r) + b2*(7*D1*bd1*(r - 1) + 3*D1*fd*(2*r - 1) + 3*Dd*f*(4*r - 1))))/(105*d) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct*st*(21*b1**2*(k1**2 + k2**2*(2*C + 1))*(D1*fd*r + Dd*f*(4*r - 1)) + 3*b1*f*(7*D1*bd1*(k1**2 + k2**2*(2*C + 1))*(2*r - 1) + 3*D1*fd*(k1**2*(r*(4*C + 2) - 1) + k2**2*(2*C + 1)*(2*r - 1)) + 3*Dd*f*(2*C + 1)*(k1**2 + k2**2)*(4*r - 1)) + f**2*(10*C*k1**2*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)) + 9*D1*bd1*(2*C*(k1**2*(r - 1) + k2**2*r) + r*(k1**2 + k2**2))))/(315*d*k3**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*f**2*k2*st**5*(11*D1*bd1*f*(r - 1) + 11*b1*(3*D1*fd*r + Dd*f*(4*r - 1)) + 3*f*(4*r - 1)*(D1*fd + Dd*f))/(693*d*k1) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*f*st**3*(33*b1**2*(k1**2 + 2*k2**2)*(2*D1*fd*r + Dd*f*(4*r - 1)) + 11*b1*f*(3*D1*bd1*(k1**2 + 2*k2**2)*(2*r - 1) + D1*fd*(k1**2*(6*r - 1) + 2*k2**2*(3*r - 1)) + 2*Dd*f*(k1**2 + k2**2)*(4*r - 1)) + f**2*(11*D1*bd1*(k1**2*(2*r - 1) + 2*k2**2*r) + k1**2*(4*r - 1)*(5*D1*fd + 5*Dd*f)))/(1155*d*k1*k2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*st*(5*D1*bd1*f**3*k1**2*r + 21*b1**3*(k1**2 + k2**2)*(D1*fd*r + Dd*f*(4*r - 1)) + 3*b1**2*f*(7*D1*bd1*(k1**2 + k2**2)*(3*r - 1) + 3*D1*fd*(k1**2*(4*r - 1) + k2**2*(2*r - 1)) + 3*Dd*f*(2*k1**2 + k2**2)*(4*r - 1)) + b1*f**2*(9*D1*bd1*(k1**2*(4*r - 1) + 2*k2**2*r) + 5*k1**2*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1))))/(315*d*k1*k2)
        perm13 = 8*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**6*f*k2**5*st*(C - 1)*(9*D1*bd1*f*(r + s - 1) + 9*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 5*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(63*d*k3**6) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**6*f*k2**3*st*(C - 1)*(9*b1*(2*s - 1)*(D1*fd + 2*Dd*f) + f*(9*D1*bd1*s + 5*D1*fd*(3*s - 1) + 10*Dd*f*(2*s - 1)))/(63*d*k3**4) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**5*f*k2**4*st*(33*D1*bd1*f*(10*f*k2**2 + k1**2*(132*C - 117))*(r + s - 1) + 33*b1*(D1*fd*(10*f*k2**2*(3*r + 3*s - 2) + k1**2*(132*C - 117)*(2*r + 2*s - 1)) + Dd*f*(10*f*k2**2 + k1**2*(132*C - 117))*(4*r + 4*s - 3)) + 5*f*(D1*fd*(42*f*k2**2*(4*r + 4*s - 3) + k1**2*(484*C - 429)*(3*r + 3*s - 2)) + Dd*f*(42*f*k2**2 + k1**2*(484*C - 429))*(4*r + 4*s - 3)))/(3465*d*k1*k3**6) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**5*f*k2**2*st*(9*b1*(2*s - 1)*(D1*fd + 2*Dd*f) + f*(9*D1*bd1*s + 5*D1*fd*(3*s - 1) + 10*Dd*f*(2*s - 1)))/(63*d*k1*k3**2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**5*f*k2**2*st*(9*b1*(D1*fd*(k1**2*(36*C - 31)*(2*s - 1) + k2**2*(-4*C*r + 14*r + 10*s - 5)) + Dd*f*(k1**2*(72*C - 62)*(2*s - 1) + k2**2*(-8*C*r + 2*C + 28*r + 20*s - 17))) + f*(D1*(9*bd1*k1**2*s*(36*C - 31) + 9*bd1*k2**2*(-2*C*(r - 1) + 7*r + 5*s - 7) + fd*k1**2*(180*C - 155)*(3*s - 1) + fd*k2**2*(-42*C*(3*r - 1) + 201*r + 75*s - 92)) + Dd*f*(k1**2*(360*C - 310)*(2*s - 1) + k2**2*(-168*C*r + 42*C + 268*r + 100*s - 117))))/(315*d*k1*k3**4) + 16*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**4*f*k2**5*st**3*(C - 1)*(3*D1*bd1*f*(r + s - 1) + 3*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(21*d*k3**6) + 8*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**4*f*k2**3*st**3*(C - 1)*(3*b1*(2*s - 1)*(D1*fd + 2*Dd*f) + f*(3*D1*bd1*s + D1*fd*(3*s - 1) + 2*Dd*f*(2*s - 1)))/(21*d*k3**4) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**4*k2**3*st*(33*D1*bd1*f*(r + s - 1)*(25*f**2*k2**2 + 3*f*(k1**2*(76*C - 59) + k2**2*(3*K - 10*b1 - 3)) - k2**2*(-42*K*b1 + 42*b1 + 42*g2)) - 99*b1**2*k2**2*(D1*fd*(5*f*(2*r + 2*s - 1) + (7 - 7*K)*(r + s)) + Dd*f*(-7*K + 5*f + 7)*(4*r + 4*s - 3)) + 33*b1*(D1*(25*f**2*fd*k2**2*(3*r + 3*s - 2) + 3*f*fd*(k1**2*(76*C - 59) + k2**2*(3*K - 3))*(2*r + 2*s - 1) - 42*f*gd2*k2**2*(r + s - 1) - 42*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(25*f**2*k2**2 + f*k1**2*(228*C - 177) + 9*f*k2**2*(K - 1) - 42*g2*k2**2)) + f*(D1*(700*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(4180*C - 3245)*(3*r + 3*s - 2) - 594*f*gd2*k2**2*(r + s - 1) - 594*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(700*f**2*k2**2 + f*k1**2*(4180*C - 3245) - 594*g2*k2**2)))/(3465*d*k3**6) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**4*k2*st*(252*b1**2*k1**2*(C - 1)*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) - 9*b1*f*(2*D1*(-28*bd1*k1**2*s*(C - 1) + fd*k1**2*(4*C - 7)*(2*s - 1) - 3*fd*k2**2*r) + Dd*f*(k1**2*(16*C - 28)*(2*s - 1) + 3*k2**2*(1 - 4*r))) + f**2*(D1*(18*bd1*k1**2*s*(7 - 4*C) + 27*bd1*k2**2*(r - 1) - fd*k1**2*(100*C - 130)*(3*s - 1) + 17*fd*k2**2*(1 - 3*r)) + Dd*f*(-k1**2*(200*C - 260)*(2*s - 1) + 17*k2**2*(1 - 4*r))))/(315*d*k1**2*k3**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**4*k2*st*(2772*b1**2*k1**2*k2**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + 11*b1*f*(3*D1*(84*bd1*k1**2*k2**2*(C - 1)*(2*r + 2*s - 1) + fd*(5*f*k2**4*r + k1**4*(288*C - 210)*(2*s - 1) - 6*k1**2*k2**2*(C*(64*r + 80*s - 34) - 73*r - 94*s + 41))) + Dd*f*(5*f*k2**4*(4*r - 1) + k1**4*(1728*C - 1260)*(2*s - 1) - 9*k1**2*k2**2*(32*C*(8*r + 10*s - 7) - 292*r - 376*s + 261))) + f**2*(D1*(11*bd1*(5*f*k2**4*(r - 1) + k1**4*s*(864*C - 630) - 9*k1**2*k2**2*(C*(64*r + 80*s - 76) - 73*r - 94*s + 85)) + fd*(125*f*k2**4*(1 - 4*r) + k1**4*(5280*C - 3850)*(3*s - 1) - 11*k1**2*k2**2*(44*C*(39*r + 27*s - 22) - 1755*r - 1398*s + 1051))) + Dd*f*(125*f*k2**4*(1 - 4*r) + k1**4*(10560*C - 7700)*(2*s - 1) - 11*k1**2*k2**2*(44*C*(52*r + 36*s - 31) - 2340*r - 1864*s + 1517))))/(3465*d*k1**2*k3**4) + 8*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**3*f*k2**4*st**3*(11*D1*bd1*f*(10*f*k2**2 + k1**2*(96*C - 81))*(r + s - 1) + 11*b1*(D1*fd*(10*f*k2**2*(3*r + 3*s - 2) + k1**2*(96*C - 81)*(2*r + 2*s - 1)) + Dd*f*(10*f*k2**2 + k1**2*(96*C - 81))*(4*r + 4*s - 3)) + f*(D1*fd*(50*f*k2**2*(4*r + 4*s - 3) + k1**2*(352*C - 297)*(3*r + 3*s - 2)) + Dd*f*(50*f*k2**2 + k1**2*(352*C - 297))*(4*r + 4*s - 3)))/(1155*d*k1*k3**6) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**3*f*k2**2*st**3*(3*b1*(2*s - 1)*(D1*fd + 2*Dd*f) + f*(3*D1*bd1*s + D1*fd*(3*s - 1) + 2*Dd*f*(2*s - 1)))/(21*d*k1*k3**2) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**3*f*k2**2*st**3*(3*b1*(D1*fd*(k1**2*(28*C - 23)*(2*s - 1) + k2**2*(-12*C*r + 22*r + 10*s - 5)) + Dd*f*(k1**2*(56*C - 46)*(2*s - 1) + k2**2*(-24*C*r + 6*C + 44*r + 20*s - 21))) + f*(D1*(3*bd1*k1**2*s*(28*C - 23) + 3*bd1*k2**2*(-6*C*(r - 1) + 11*r + 5*s - 11) + fd*k1**2*(28*C - 23)*(3*s - 1) + fd*k2**2*(-42*C*r + 14*C + 57*r + 15*s - 24)) + Dd*f*(k1**2*(56*C - 46)*(2*s - 1) + k2**2*(-56*C*r + 14*C + 76*r + 20*s - 29))))/(105*d*k1*k3**4) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**3*k1*k2**2*st*(11*D1*bd1*f*(r + s - 1)*(40*f**2*k2**2 + 9*f*(k1**2*(64*C - 43) + k2**2*(12*K - 32*b1 - 9)) - k2**2*(126*b1*(3 - 4*K) + 504*g2)) - 99*b1**2*k2**2*(D1*fd*(16*f*(2*r + 2*s - 1) + (21 - 28*K)*(r + s)) + Dd*f*(-28*K + 16*f + 21)*(4*r + 4*s - 3)) + 11*b1*(D1*(40*f**2*fd*k2**2*(3*r + 3*s - 2) + 9*f*(fd*(k1**2*(64*C - 43) + k2**2*(12*K - 9))*(2*r + 2*s - 1) - 56*gd2*k2**2*(r + s - 1)) - 504*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(40*f**2*k2**2 + 9*f*(k1**2*(64*C - 43) + k2**2*(12*K - 9)) - 504*g2*k2**2)) + f*(D1*(840*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(3520*C - 2365)*(3*r + 3*s - 2) - 2376*f*gd2*k2**2*(r + s - 1) - 2376*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(840*f**2*k2**2 + f*k1**2*(3520*C - 2365) - 2376*g2*k2**2)))/(3465*d*k3**6) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**3*st*(3*D1*bd1*f**2*s + 7*b1**2*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) + b1*f*(14*D1*bd1*s + D1*fd*(6*s - 3) + 6*Dd*f*(2*s - 1)))/(35*d*k1) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**3*st*(21*b1**2*(D1*fd*(k1**2*(12*C - 9)*(s - 1) + k2**2*r*(2 - 2*C)) + 2*Dd*f*(k1**2*(12*C - 9)*(2*s - 1) + k2**2*(-4*C*r + C + 4*r - 1))) - 3*b1*f*(2*D1*(21*bd1*k1**2*s*(3 - 4*C) + 7*bd1*k2**2*(C - 1)*(2*r - 1) + fd*k1**2*(6*C - 3)*(2*s - 1) + fd*k2**2*(11*C*(2*r - 1) - 7*r + 48*s - 13)) + Dd*f*(k1**2*(24*C - 12)*(2*s - 1) + k2**2*(22*C*(4*r - 1) - 28*r + 192*s - 89))) - f**2*(D1*(18*bd1*k1**2*s*(2*C - 1) + 3*bd1*k2**2*(r*(22*C - 7) + 48*s - 15) + fd*k1**2*(80*C - 55)*(3*s - 1) + fd*k2**2*(C*(32 - 96*r) + 171*r + 192*s - 121)) + Dd*f*(k1**2*(160*C - 110)*(2*s - 1) + k2**2*(-128*C*r + 32*C + 228*r + 256*s - 185))))/(315*d*k1*k3**2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**3*st*(33*b1**2*k2**2*(D1*fd*(k1**2*(112*C - 91)*(r + s - 1) + k2**2*(12*f*(4*r + 4*s - 3) + r*(28 - 7*K) + 21*s)) + Dd*f*(k1**2*(112*C - 91)*(4*r + 4*s - 3) + k2**2*(-28*K*r + 7*K + 24*f*(4*r + 4*s - 3) + 112*r + 84*s - 70))) + 11*b1*(D1*(2*f**2*k2**4*(18*bd1*(4*r + 4*s - 3) + fd*(12*r - 75*s + 32)) + 3*f*(7*bd1*k1**2*k2**2*(16*C - 13)*(2*r + 2*s - 1) + 7*bd1*k2**4*(-2*K*r + K + 8*r + 6*s - 7) + fd*(k1**4*(84*C - 51)*(2*s - 1) + k1**2*k2**2*(-4*C*(107*r + 168*s - 72) + 338*r + 576*s - 249) + k2**4*(K*(11 - 22*r) + 40*r + 18*s - 20)) + 14*gd2*k2**4*r) + 42*fd*g2*k2**4*r) + Dd*f*(4*f**2*k2**4*(8*r - 50*s + 23) + 3*f*(k1**4*(168*C - 102)*(2*s - 1) + k1**2*k2**2*(-2*C*(428*r + 672*s - 443) + 676*r + 1152*s - 745) + k2**4*(K*(11 - 44*r) + 80*r + 36*s - 38)) + 42*g2*k2**4*(4*r - 1))) + f*(D1*(2*f**2*k2**4*(11*bd1*(4*r - 25*s + 14) - 10*fd*(96*r + 110*s - 79)) + 11*f*(3*bd1*(k1**4*s*(84*C - 51) + k1**2*k2**2*(C*(-214*r - 336*s + 262) + 169*r + 288*s - 208) + k2**4*(-11*K*r + 20*r + 9*s - 9)) + fd*k1**2*(k1**2*(140*C - 85)*(3*s - 1) + k2**2*(-2*C*(807*r + 816*s - 541) + 1248*r + 1395*s - 881)) + 66*gd2*k2**4*r) + 66*g2*k2**4*(7*bd1*(r - 1) + 11*fd*(2*r - 1))) - 2*Dd*f*(10*f**2*k2**4*(96*r + 110*s - 79) - 11*f*(k1**4*(140*C - 85)*(2*s - 1) + k1**2*k2**2*(C*(-1076*r - 1088*s + 813) + 832*r + 930*s - 673)) + 363*g2*k2**4*(1 - 4*r))))/(3465*d*k1*k3**4) + 8*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*f*k2**5*st**5*(C - 1)*(9*D1*bd1*f*(r + s - 1) + 9*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(63*d*k3**6) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*f*k2**3*st**5*(C - 1)*(9*b1*(2*s - 1)*(D1*fd + 2*Dd*f) + f*(9*D1*bd1*s + D1*fd*(3*s - 1) + 2*Dd*f*(2*s - 1)))/(63*d*k3**4) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*k1**2*k2*st*(33*D1*bd1*f*(r + s - 1)*(10*f**2*k2**2 + 3*f*(k1**2*(15 - 26*C) + k2**2*(-18*K + 36*b1 + 9)) + k2**2*(-252*K*b1 + 126*b1 + 252*g2)) + 297*b1**2*k2**2*(D1*fd*(6*f*(2*r + 2*s - 1) + (7 - 14*K)*(r + s)) + Dd*f*(-14*K + 6*f + 7)*(4*r + 4*s - 3)) + 33*b1*(D1*(10*f**2*fd*k2**2*(3*r + 3*s - 2) - 3*f*fd*(k1**2*(26*C - 15) + k2**2*(18*K - 9))*(2*r + 2*s - 1) + 252*f*gd2*k2**2*(r + s - 1) + 252*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(10*f**2*k2**2 + f*k1**2*(45 - 78*C) + 27*f*k2**2*(1 - 2*K) + 252*g2*k2**2)) + f*(D1*(-420*f**2*fd*k2**2*(4*r + 4*s - 3) - f*fd*k1**2*(1430*C - 825)*(3*r + 3*s - 2) + 3564*f*gd2*k2**2*(r + s - 1) + 3564*fd*g2*k2**2*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(420*f**2*k2**2 + f*k1**2*(1430*C - 825) - 3564*g2*k2**2)))/(3465*d*k3**6) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*k2**3*st**3*(33*D1*bd1*f*(r + s - 1)*(10*f**2*k2**2 + f*k1**2*(74*C - 52) + f*k2**2*(K - 20*b1 - 1) - k2**2*(-14*K*b1 + 14*b1 + 14*g2)) - 33*b1**2*k2**2*(D1*fd*(10*f*(2*r + 2*s - 1) + (7 - 7*K)*(r + s)) + Dd*f*(-7*K + 10*f + 7)*(4*r + 4*s - 3)) + 33*b1*(D1*(10*f**2*fd*k2**2*(3*r + 3*s - 2) + f*fd*(k1**2*(74*C - 52) + k2**2*(K - 1))*(2*r + 2*s - 1) - 14*f*gd2*k2**2*(r + s - 1) - 14*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(10*f**2*k2**2 + f*k1**2*(74*C - 52) + f*k2**2*(K - 1) - 14*g2*k2**2)) + 2*f*(D1*(100*f**2*fd*k2**2*(4*r + 4*s - 3) + 11*f*(fd*k1**2*(37*C - 26)*(3*r + 3*s - 2) - 3*gd2*k2**2*(r + s - 1)) - 33*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(100*f**2*k2**2 + f*k1**2*(407*C - 286) - 33*g2*k2**2)))/(1155*d*k3**6) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*st*(462*b1**3*k2**4*(3*D1*fd*(r + s - 1) + Dd*(-5*K + 3*f + 5)*(4*r + 4*s - 3)) - 33*b1**2*k2**2*(D1*fd*(k1**2*(196*C - 126)*(r + s - 1) + k2**2*(-14*K*(12*r + 9*s + 1) + 6*f*(45*r + 52*s - 29) + 189*r + 168*s + 14)) - 14*D1*k2**2*(bd1*(-5*K + 3*f + 5)*(3*r + 3*s - 2) + 10*gd2*(r + s - 1)) + 3*Dd*f**2*k2**2*(180*r + 208*s - 149) + 7*Dd*f*(k1**2*(28*C - 18)*(4*r + 4*s - 3) + 3*k2**2*(-4*K*(8*r + 6*s - 5) + 36*r + 32*s - 25)) - 140*Dd*g2*k2**2*(4*r + 4*s - 3)) - 33*b1*(D1*(3*f**2*k2**4*(bd1*(90*r + 104*s - 91) + fd*(50*r - 22*s + 3)) + f*(7*bd1*k2**2*(k1**2*(28*C - 18)*(2*r + 2*s - 1) + k2**2*(-4*K*(12*r + 9*s - 11) + 54*r + 48*s - 53)) + fd*k1**4*(36*C - 18)*(2*s - 1) + 2*fd*k1**2*k2**2*(-4*C*(82*r + 163*s - 71) + 201*r + 454*s - 200) + fd*k2**4*(-22*K*(10*r + 4*s - 5) + 206*r + 124*s - 103) - 42*k2**4*(bd2*(r + s - 1) - 2*gd2*(4*r + 3*s - 3))) - 14*k2**4*(3*b2*fd*(r + s) + 10*bd1*g2*(2*r + 2*s - 1) - 2*fd*g2*(12*r + 9*s + 1))) + Dd*f*(2*f**2*k2**4*(100*r - 44*s - 3) + f*(k1**4*(72*C - 36)*(2*s - 1) + k1**2*k2**2*(-16*C*(82*r + 163*s - 102) + 804*r + 1816*s - 1109) + k2**4*(-22*K*(20*r + 8*s - 9) + 412*r + 248*s - 227)) - 42*k2**4*(b2*(4*r + 4*s - 3) - 4*g2*(8*r + 6*s - 5)))) + f*(D1*(3*f**2*k2**4*(bd1*(-550*r + 242*s + 165) + 15*fd*(108*r + 176*s - 115)) - 11*f*(3*bd1*(k1**4*s*(36*C - 18) + k1**2*k2**2*(-4*C*(82*r + 163*s - 103) + 201*r + 454*s - 255) + k2**4*(-22*K*(5*r + 2*s - 2) + 103*r + 62*s - 62)) + fd*(k1**4*(60*C - 30)*(3*s - 1) + k1**2*k2**2*(-4*C*(579*r + 768*s - 449) + 1419*r + 2124*s - 1181)) + 6*k2**4*(-9*bd2*(r + s - 1) + 22*gd2*(5*r + 2*s - 2))) + 66*k2**4*(21*b2*bd1*(r + s - 1) + 9*b2*fd*(2*r + 2*s - 1) - 14*bd1*g2*(12*r + 9*s - 13) - 22*fd*g2*(10*r + 4*s - 5))) + Dd*f*(45*f**2*k2**4*(108*r + 176*s - 115) - 11*f*(k1**4*(120*C - 60)*(2*s - 1) + k1**2*k2**2*(-4*C*(772*r + 1024*s - 705) + 1892*r + 2832*s - 1889)) + 66*k2**4*(9*b2*(4*r + 4*s - 3) - 22*g2*(20*r + 8*s - 9)))))/(3465*d*k2*k3**4) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*k2*st**3*(-42*b1**2*k1**2*(C - 1)*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) + 3*b1*f*(2*D1*(-14*bd1*k1**2*s*(C - 1) + fd*k1**2*(9*C - 8)*(2*s - 1) + fd*k2**2*r) + Dd*f*(k1**2*(36*C - 32)*(2*s - 1) + k2**2*(4*r - 1))) + f**2*(D1*(6*bd1*k1**2*s*(9*C - 8) + 3*bd1*k2**2*(r - 1) + fd*k1**2*(20*C - 18)*(3*s - 1) + 9*fd*k2**2*(3*r - 1)) + Dd*f*(k1**2*(40*C - 36)*(2*s - 1) + 9*k2**2*(4*r - 1))))/(105*d*k1**2*k3**2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*k2*st**3*(462*b1**2*k1**2*k2**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) - 11*b1*f*(-3*D1*(14*bd1*k1**2*k2**2*(C - 1)*(2*r + 2*s - 1) + fd*(-5*f*k2**4*r + k1**4*(54*C - 36)*(2*s - 1) - 2*k1**2*k2**2*(C*(64*r + 54*s - 26) - 61*r - 56*s + 27))) + Dd*f*(5*f*k2**4*(4*r - 1) - k1**4*(324*C - 216)*(2*s - 1) + 3*k1**2*k2**2*(4*C*(64*r + 54*s - 43) - 244*r - 224*s + 173))) + f**2*(D1*(11*bd1*(-5*f*k2**4*(r - 1) + k1**4*s*(162*C - 108) - 3*k1**2*k2**2*(C*(64*r + 54*s - 66) - 61*r - 56*s + 63)) + fd*(65*f*k2**4*(1 - 4*r) + k1**4*(594*C - 396)*(3*s - 1) - 33*k1**2*k2**2*(C*(98*r + 40*s - 46) - 87*r - 42*s + 43))) + Dd*f*(65*f*k2**4*(1 - 4*r) + k1**4*(1188*C - 792)*(2*s - 1) - 11*k1**2*k2**2*(2*C*(196*r + 80*s - 89) - 348*r - 168*s + 171))))/(1155*d*k1**2*k3**4) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*st*(D1*bd1*f**2*(k1**2*s*(36*C - 18) + 13*k2**2*r) + 7*b1**2*(D1*fd*(k1**2*(12*C - 6)*(s - 1) - k2**2*r) + Dd*f*(k1**2*(24*C - 12)*(2*s - 1) + k2**2*(1 - 4*r))) + b1*f*(D1*(84*bd1*k1**2*s*(2*C - 1) + 7*bd1*k2**2*(1 - 2*r) + fd*k1**2*(36*C - 18)*(2*s - 1) + 13*fd*k2**2*(2*r - 1)) + Dd*f*(k1**2*(72*C - 36)*(2*s - 1) + 13*k2**2*(4*r - 1))))/(105*d*k1**2*k2) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*st*(3*b1**2*(D1*fd*(-k1**4*(84*C - 42)*(s - 1) + 7*k1**2*k2**2*(4*C*(3*r + 7*s - 7) - 9*r - 28*s + 28) + k2**4*r*(12*f - 7)) + Dd*f*(-k1**4*(168*C - 84)*(2*s - 1) + 7*k1**2*k2**2*(4*C*(12*r + 28*s - 17) - 36*r - 112*s + 65) + k2**4*(6*f - 7)*(4*r - 1))) + 3*b1*f*(D1*bd1*(-k1**4*s*(168*C - 84) + 7*k1**2*k2**2*(4*C*(6*r + 14*s - 3) - 18*r - 56*s + 9) + k2**4*(6*f - 7)*(2*r - 1)) + k2**2*(D1*fd*(k1**2*(8*C*(4*r - 29*s + 2) - 16*r + 268*s - 59) + k2**2*(14*f*(3*r - 1) + 26*r - 13)) + Dd*f*(4*k1**2*(2*C*(8*r - 58*s + 27) - 8*r + 134*s - 65) + k2**2*(14*f + 13)*(4*r - 1)))) + f**2*(D1*(3*bd1*k1**2*k2**2*(4*C*(4*r - 29*s + 21) - 8*r + 134*s - 67) + 3*bd1*k2**4*r*(14*f + 13) + fd*k1**4*(60*C - 30)*(3*s - 1) + fd*k1**2*k2**2*(-12*C*(51*r + 54*s - 35) + 447*r + 738*s - 395)) + Dd*f*k1**2*(k1**2*(120*C - 60)*(2*s - 1) + k2**2*(-12*C*(68*r + 72*s - 53) + 596*r + 984*s - 641))))/(315*d*k1**2*k2*k3**2) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*f*k2**4*st**5*(33*D1*bd1*f*(2*f*k2**2 + k1**2*(12*C - 9))*(r + s - 1) + 33*b1*(D1*fd*(2*f*k2**2*(3*r + 3*s - 2) + k1**2*(12*C - 9)*(2*r + 2*s - 1)) + Dd*f*(2*f*k2**2 + k1**2*(12*C - 9))*(4*r + 4*s - 3)) + f*(D1*fd*(18*f*k2**2*(4*r + 4*s - 3) + k1**2*(44*C - 33)*(3*r + 3*s - 2)) + Dd*f*(18*f*k2**2 + k1**2*(44*C - 33))*(4*r + 4*s - 3)))/(693*d*k1*k3**6) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*f*k2**2*st**5*(9*b1*(2*s - 1)*(D1*fd + 2*Dd*f) + f*(9*D1*bd1*s + D1*fd*(3*s - 1) + 2*Dd*f*(2*s - 1)))/(63*d*k1*k3**2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*f*k2**2*st**5*(9*b1*(D1*fd*(k1**2*(4*C - 3)*(2*s - 1) + k2**2*(-4*C*r + 6*r + 2*s - 1)) + Dd*f*(k1**2*(8*C - 6)*(2*s - 1) + k2**2*(-8*C*r + 2*C + 12*r + 4*s - 5))) + f*(D1*(9*bd1*k1**2*s*(4*C - 3) + 9*bd1*k2**2*(-2*C*(r - 1) + 3*r + s - 3) + fd*k1**2*(4*C - 3)*(3*s - 1) + fd*k2**2*(C*(2 - 6*r) + 9*r + 3*s - 4)) + Dd*f*(k1**2*(8*C - 6)*(2*s - 1) + k2**2*(-8*C*r + 2*C + 12*r + 4*s - 5))))/(63*d*k1*k3**4) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*k1**3*st*(33*D1*bd1*f*(r + s - 1)*(10*f**2*k2**2 + f*k1**2*(6 - 12*C) + 3*f*k2**2*(-12*K + 16*b1 + 3) + k2**2*(-168*K*b1 + 42*b1 + 168*g2)) + 99*b1**2*k2**2*(D1*fd*(8*f*(2*r + 2*s - 1) + (7 - 28*K)*(r + s)) + Dd*f*(-28*K + 8*f + 7)*(4*r + 4*s - 3)) + 33*b1*(D1*(10*f**2*fd*k2**2*(3*r + 3*s - 2) - 3*f*fd*(k1**2*(4*C - 2) + k2**2*(12*K - 3))*(2*r + 2*s - 1) + 168*f*gd2*k2**2*(r + s - 1) + 168*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(10*f**2*k2**2 + f*k1**2*(6 - 12*C) + 9*f*k2**2*(1 - 4*K) + 168*g2*k2**2)) + 2*f*(D1*(-35*f**2*fd*k2**2*(4*r + 4*s - 3) - f*fd*k1**2*(110*C - 55)*(3*r + 3*s - 2) + 1188*f*gd2*k2**2*(r + s - 1) + 1188*fd*g2*k2**2*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2 + f*k1**2*(110*C - 55) - 1188*g2*k2**2)))/(3465*d*k3**6) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*k1*k2**2*st**3*(11*D1*bd1*f*(r + s - 1)*(8*f**2*k2**2 + f*k1**2*(108*C - 63) - 3*f*k2**2*(-2*K + 32*b1 + 1) - k2**2*(-84*K*b1 + 42*b1 + 84*g2)) - 33*b1**2*k2**2*(D1*fd*(16*f*(2*r + 2*s - 1) + (7 - 14*K)*(r + s)) + Dd*f*(-14*K + 16*f + 7)*(4*r + 4*s - 3)) + 11*b1*(D1*(8*f**2*fd*k2**2*(3*r + 3*s - 2) + 3*f*fd*(k1**2*(36*C - 21) + k2**2*(2*K - 1))*(2*r + 2*s - 1) - 84*f*gd2*k2**2*(r + s - 1) - 84*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(8*f**2*k2**2 + f*k1**2*(108*C - 63) + 3*f*k2**2*(2*K - 1) - 84*g2*k2**2)) + 3*f*(D1*(40*f**2*fd*k2**2*(4*r + 4*s - 3) + 11*f*(fd*k1**2*(12*C - 7)*(3*r + 3*s - 2) - 4*gd2*k2**2*(r + s - 1)) - 44*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(40*f**2*k2**2 + f*k1**2*(132*C - 77) - 44*g2*k2**2)))/(1155*d*k3**6) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*k1*st*(231*b1**3*k2**2*(4*D1*fd*(r + s - 1) + Dd*(-10*K + 4*f + 5)*(4*r + 4*s - 3)) - 33*b1**2*(D1*fd*(k1**2*(28*C - 14)*(r + s - 1) + k2**2*(-7*K*(21*r + 18*s + 2) + 3*f*(36*r + 50*s - 23) + 70*r + 70*s + 7)) - 7*D1*k2**2*(bd1*(-10*K + 4*f + 5)*(3*r + 3*s - 2) + 20*gd2*(r + s - 1)) + 12*Dd*f**2*k2**2*(18*r + 25*s - 17) + 7*Dd*f*(k1**2*(4*C - 2)*(4*r + 4*s - 3) + k2**2*(K*(-84*r - 72*s + 57) + 40*r + 40*s - 30)) - 140*Dd*g2*k2**2*(4*r + 4*s - 3)) - 11*b1*(3*D1*bd1*(3*f**2*k2**2*(36*r + 50*s - 45) + 7*f*(k1**2*(4*C - 2)*(2*r + 2*s - 1) + k2**2*(K*(-42*r - 36*s + 41) + 20*r + 20*s - 21)) - 140*g2*k2**2*(2*r + 2*s - 1)) + 3*D1*(f**2*fd*k2**2*(92*r + 40*s - 29) + f*(fd*(-2*k1**2*(4*C*(10*r + 31*s - 14) - 20*r - 72*s + 33) + k2**2*(-11*K*(14*r + 8*s - 7) + 66*r + 50*s - 33)) - 42*k2**2*(bd2*(r + s - 1) + gd2*(-7*r - 6*s + 6))) + 14*fd*k2**2*(-3*b2*(r + s) + g2*(21*r + 18*s + 2))) + Dd*f*(4*f**2*k2**2*(92*r + 40*s - 43) - 3*f*(4*k1**2*(4*C*(10*r + 31*s - 18) - 20*r - 72*s + 41) + k2**2*(11*K*(28*r + 16*s - 15) - 132*r - 100*s + 83)) - 126*k2**2*(b2*(4*r + 4*s - 3) + g2*(-28*r - 24*s + 19)))) + f*(-11*D1*bd1*(f**2*k2**2*(92*r + 40*s - 85) - 3*f*(2*k1**2*(C*(20*r + 62*s - 26) - 10*r - 36*s + 13) + k2**2*(11*K*(7*r + 4*s - 4) - 33*r - 25*s + 25)) - 42*k2**2*(3*b2*(r + s - 1) + g2*(-21*r - 18*s + 23))) + 2*D1*(10*f**2*fd*k2**2*(38*r + 99*s - 59) + 11*f*(fd*k1**2*(138*C*(r + 2*s - 1) - 69*r - 159*s + 76) + 3*k2**2*(9*bd2*(r + s - 1) - 11*gd2*(7*r + 4*s - 4))) + 33*fd*k2**2*(9*b2*(2*r + 2*s - 1) - 11*g2*(14*r + 8*s - 7))) + 2*Dd*f*(10*f**2*k2**2*(38*r + 99*s - 59) + 11*f*k1**2*(46*C*(4*r + 8*s - 5) - 92*r - 212*s + 129) + 33*k2**2*(9*b2*(4*r + 4*s - 3) - 11*g2*(28*r + 16*s - 15)))))/(3465*d*k3**4) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*st**3*(D1*bd1*f**2*s + 7*b1**2*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) + b1*f*(14*D1*bd1*s + D1*fd*(2*s - 1) + 2*Dd*f*(2*s - 1)))/(35*d*k1) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*st*(D1*bd1*f**2*(r*(4 - 8*C) + 5*s) + 21*b1**2*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) + b1*f*(D1*(42*bd1*s + fd*(-16*C*r + 8*C + 8*r + 10*s - 9)) + 2*Dd*f*(C*(4 - 16*r) + 8*r + 10*s - 7)))/(105*d*k1) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*st**3*(21*b1**2*(D1*fd*(k1**2*(4*C - 3)*(s - 1) + k2**2*r*(2 - 2*C)) + 2*Dd*f*(k1**2*(4*C - 3)*(2*s - 1) + k2**2*(-4*C*r + C + 4*r - 1))) - 3*b1*f*(2*D1*(7*bd1*k1**2*s*(3 - 4*C) + 7*bd1*k2**2*(C - 1)*(2*r - 1) + fd*k1**2*(6*C - 3)*(2*s - 1) + fd*k2**2*(C*(2*r - 1) + 7*r + 16*s - 7)) + Dd*f*(k1**2*(24*C - 12)*(2*s - 1) + k2**2*(C*(8*r - 2) + 28*r + 64*s - 39))) - f**2*(D1*(18*bd1*k1**2*s*(2*C - 1) + 3*bd1*k2**2*(r*(2*C + 7) + 16*s - 9) + fd*k1**2*(16*C - 9)*(3*s - 1) + fd*k2**2*(C*(16 - 48*r) + 51*r + 24*s - 25)) + Dd*f*(k1**2*(32*C - 18)*(2*s - 1) + k2**2*(-64*C*r + 16*C + 68*r + 32*s - 33))))/(105*d*k1*k3**2) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*st*(105*Dd*b1**3*k2**2*(K - 1)*(4*r - 1) + 3*b1**2*(D1*fd*(14*k1**2*(2*C*(r + 6*s - 6) - r - 9*s + 9) + k2**2*(7*K*(r - 1) + f*(32*r + 84*s - 55) + 28*r + 42*s + 7)) + 35*D1*k2**2*(bd1*(K - 1)*(3*r - 1) - 2*gd2*r) + 4*Dd*f**2*k2**2*(16*r + 42*s - 25) + 7*Dd*f*(2*k1**2*(C*(8*r + 48*s - 26) - 4*r - 36*s + 19) + k2**2*(K*(4*r - 1) + 16*r + 24*s - 16)) + 70*Dd*g2*k2**2*(1 - 4*r)) + 3*b1*(D1*bd1*(f**2*k2**2*(32*r + 84*s - 45) + 7*f*(k1**2*(C*(8*r + 48*s - 4) - 4*r - 36*s + 2) + k2**2*(r*(2*K + 8) + 12*s - 11)) + 70*g2*k2**2*(1 - 2*r)) + D1*(f**2*fd*k2**2*(48*r + 54*s - 43) + f*(-fd*k1**2*(8*C - 4)*(11*s - 2) + fd*k2**2*(K*(8 - 16*r) + 30*r + 20*s - 15) - 14*gd2*k2**2*r) - 14*fd*g2*k2**2*(r - 1)) + Dd*f*(4*f**2*k2**2*(16*r + 18*s - 13) - f*k1**2*(88*C - 44)*(2*s - 1) + f*k2**2*(-32*K*r + 8*K + 60*r + 40*s - 35) + 14*g2*k2**2*(1 - 4*r))) + f*(3*D1*bd1*(f**2*k2**2*(16*r + 18*s - 9) - f*k1**2*(4*C - 2)*(11*s - 7) + f*k2**2*(r*(15 - 8*K) + 10*s - 10) - 14*g2*k2**2*r) - 2*D1*(f*fd*k1**2*(2*C*(39*r + 81*s - 40) - 39*r - 102*s + 47) + 12*f*k2**2*r*(bd2 - 2*gd2) + 12*fd*k2**2*(b2 - 2*g2)*(2*r - 1)) - 2*Dd*f*(f*k1**2*(2*C*(52*r + 108*s - 67) - 52*r - 136*s + 81) + k2**2*(12*b2 - 24*g2)*(4*r - 1))))/(315*d*k1*k3**2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*st**3*(33*b1**2*k2**2*(D1*fd*(k1**2*(28*C - 21)*(r + s - 1) + k2**2*(4*f*(4*r + 4*s - 3) + r*(14 - 7*K) + 7*s)) + Dd*f*(k1**2*(28*C - 21)*(4*r + 4*s - 3) + k2**2*(-28*K*r + 7*K + 8*f*(4*r + 4*s - 3) + 56*r + 28*s - 28))) - 11*b1*(D1*(2*f**2*k2**4*(-6*bd1*(4*r + 4*s - 3) + fd*(12*r + 33*s - 16)) - 3*f*(fd*(k1**4*(20*C - 11)*(2*s - 1) + k1**2*k2**2*(-4*C*(37*r + 44*s - 21) + 102*r + 128*s - 61) + k2**4*(-2*K*r + K + 4*r + 2*s - 2)) + 7*k2**2*(bd1*k1**2*(4*C - 3)*(2*r + 2*s - 1) + bd1*k2**2*(-2*K*r + K + 4*r + 2*s - 3) + 2*gd2*k2**2*r)) - 42*fd*g2*k2**4*r) + Dd*f*(4*f**2*k2**4*(8*r + 22*s - 13) - 3*f*(k1**4*(40*C - 22)*(2*s - 1) + k1**2*k2**2*(C*(-296*r - 352*s + 250) + 204*r + 256*s - 179) + k2**4*(-4*K*r + K + 8*r + 4*s - 4)) + 42*g2*k2**4*(1 - 4*r))) - f*(D1*(2*f**2*k2**4*(11*bd1*(4*r + 11*s - 10) + 2*fd*(144*r + 110*s - 91)) - 11*f*(3*bd1*(k1**4*s*(20*C - 11) + k1**2*k2**2*(C*(-74*r - 88*s + 78) + 51*r + 64*s - 54) + k2**4*(-r*(K - 2) + s - 1)) + fd*k1**2*(k1**2*(20*C - 11)*(3*s - 1) + k2**2*(-2*C*(141*r + 90*s - 77) + 186*r + 129*s - 105)) + 6*gd2*k2**4*r) - 66*g2*k2**4*(7*bd1*(r - 1) + fd*(2*r - 1))) + 2*Dd*f*(2*f**2*k2**4*(144*r + 110*s - 91) - 11*f*(k1**4*(20*C - 11)*(2*s - 1) + k1**2*k2**2*(C*(-188*r - 120*s + 107) + 124*r + 86*s - 74)) + 33*g2*k2**4*(1 - 4*r))))/(1155*d*k1*k3**4) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*f*k2**3*st**5*(33*D1*bd1*f*(k1**2*(6*C - 3) + k2**2*(-6*b1 + f))*(r + s - 1) - 99*b1**2*k2**2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 33*b1*(D1*fd*(f*k2**2*(3*r + 3*s - 2) + k1**2*(6*C - 3)*(2*r + 2*s - 1)) + Dd*f*(f*k2**2 + k1**2*(6*C - 3))*(4*r + 4*s - 3)) + f*(D1*fd*(12*f*k2**2*(4*r + 4*s - 3) + k1**2*(22*C - 11)*(3*r + 3*s - 2)) + Dd*f*(12*f*k2**2 + k1**2*(22*C - 11))*(4*r + 4*s - 3)))/(693*d*k3**6) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*f*k2*st**5*(9*b1*(2*D1*fd*(k1**2*(2*C - 1)*(2*s - 1) + k2**2*r) + Dd*f*(k1**2*(8*C - 4)*(2*s - 1) + k2**2*(4*r - 1))) + f*(D1*(18*bd1*k1**2*s*(2*C - 1) + 9*bd1*k2**2*(r - 1) + fd*k1**2*(4*C - 2)*(3*s - 1) + fd*k2**2*(3*r - 1)) + Dd*f*(k1**2*(8*C - 4)*(2*s - 1) + k2**2*(4*r - 1))))/(63*d*k1**2*k3**2) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*f*k2*st**5*(11*b1*(3*D1*fd*(7*f*k2**4*r - k1**4*(12*C - 6)*(2*s - 1) + 6*k1**2*k2**2*(C*(8*r + 4*s - 2) - 5*r - 2*s + 1)) + Dd*f*(7*f*k2**4*(4*r - 1) - k1**4*(72*C - 36)*(2*s - 1) + 9*k1**2*k2**2*(16*C*(2*r + s - 1) - 20*r - 8*s + 9))) + f*(D1*(77*bd1*f*k2**4*(r - 1) - 198*bd1*k1**4*s*(2*C - 1) + 99*bd1*k1**2*k2**2*(4*C*(2*r + s - 2) - 5*r - 2*s + 5) + 21*f*fd*k2**4*(4*r - 1) - fd*k1**4*(44*C - 22)*(3*s - 1) + 11*fd*k1**2*k2**2*(12*C*(2*r + s - 1) - 15*r - 6*s + 7)) + Dd*f*(21*f*k2**4*(4*r - 1) - k1**4*(88*C - 44)*(2*s - 1) + 11*k1**2*k2**2*(16*C*(2*r + s - 1) - 20*r - 8*s + 9))))/(693*d*k1**2*k3**4) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*k1**4*k2*st*(9*b1**2*(D1*fd*(-7*K*(r + s) + f*(2*r + 2*s - 1)) + Dd*f*(-7*K + f)*(4*r + 4*s - 3)) + b1*(18*D1*bd1*f*(-7*K + f)*(r + s - 1) + D1*(5*f**2*fd*(3*r + 3*s - 2) + 9*f*(-3*K*fd*(2*r + 2*s - 1) + 14*gd2*(r + s - 1)) + 126*fd*g2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(-27*K*f + 5*f**2 + 126*g2)) + f*(D1*bd1*(r + s - 1)*(-27*K*f + 5*f**2 + 126*g2) + 54*D1*f*gd2*(r + s - 1) + 54*D1*fd*g2*(2*r + 2*s - 1) + 54*Dd*f*g2*(4*r + 4*s - 3)))/(315*d*k3**6) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*k1**2*k2*st**3*(11*D1*bd1*f*(r + s - 1)*(2*f**2*k2**2 - 3*f*(k1**2*(6*C - 3) + k2**2*(K - 12*b1)) + k2**2*(-42*K*b1 + 42*g2)) + 33*b1**2*k2**2*(D1*fd*(-7*K*(r + s) + 6*f*(2*r + 2*s - 1)) + Dd*f*(-7*K + 6*f)*(4*r + 4*s - 3)) + 11*b1*(D1*(2*f**2*fd*k2**2*(3*r + 3*s - 2) - 3*f*fd*(K*k2**2 + k1**2*(6*C - 3))*(2*r + 2*s - 1) + 42*f*gd2*k2**2*(r + s - 1) + 42*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(2*f**2*k2**2 - 3*f*(K*k2**2 + k1**2*(6*C - 3)) + 42*g2*k2**2)) + f*(D1*(-20*f**2*fd*k2**2*(4*r + 4*s - 3) - f*fd*k1**2*(66*C - 33)*(3*r + 3*s - 2) + 66*f*gd2*k2**2*(r + s - 1) + 66*fd*g2*k2**2*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(20*f**2*k2**2 + f*k1**2*(66*C - 33) - 66*g2*k2**2)))/(1155*d*k3**6) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*k1**2*st*(42*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*(-5*K + f)*(4*r + 4*s - 3)) + 3*b1**2*k2**2*(14*D1*bd1*(-5*K + f)*(3*r + 3*s - 2) + D1*(-6*f*fd*(7*r + 14*s - 6) + 7*fd*(2*K*(10*r + 9*s + 1) - r - 2*s) + 140*gd2*(r + s - 1)) - 7*Dd*(3*f**2*(4*r + 8*s - 5) + f*(-8*K*(10*r + 9*s - 7) + 4*r + 8*s - 5) - 20*g2*(4*r + 4*s - 3))) - b1*(D1*(f**2*k2**2*(9*bd1*(14*r + 28*s - 23) + fd*(135*r + 138*s - 73)) - 3*f*(fd*(k1**2*(28*C - 14)*(2*s - 1) + k2**2*(22*K*(6*r + 4*s - 3) - 6*r - 12*s + 3)) + 7*k2**2*(bd1*(4*K*(10*r + 9*s - 10) - 2*r - 4*s + 3) + 6*bd2*(r + s - 1) - 4*gd2*(10*r + 9*s - 9))) - 42*k2**2*(3*b2*fd*(r + s) + 10*bd1*g2*(2*r + 2*s - 1) - 2*fd*g2*(10*r + 9*s + 1))) + Dd*f*(f**2*k2**2*(180*r + 184*s - 137) - 3*f*(k1**2*(56*C - 28)*(2*s - 1) + k2**2*(22*K*(12*r + 8*s - 7) - 12*r - 24*s + 15)) - 42*k2**2*(3*b2*(4*r + 4*s - 3) - 8*g2*(10*r + 9*s - 7)))) + f*(D1*(f**2*k2**2*(bd1*(-45*r - 46*s + 64) + 20*fd*(2*s - 1)) + 3*f*(bd1*(k1**2*s*(28*C - 14) + k2**2*(22*K*(3*r + 2*s - 2) - 3*r - 6*s + 6)) + fd*k1**2*(12*C - 6)*(3*s - 1) + 2*k2**2*(9*bd2*(r + s - 1) - 22*gd2*(3*r + 2*s - 2))) + 6*k2**2*(21*b2*bd1*(r + s - 1) + 9*b2*fd*(2*r + 2*s - 1) - 14*bd1*g2*(10*r + 9*s - 11) - 22*fd*g2*(6*r + 4*s - 3))) + 2*Dd*f*(10*f**2*k2**2*(2*s - 1) + f*k1**2*(36*C - 18)*(2*s - 1) + 3*k2**2*(9*b2*(4*r + 4*s - 3) - 22*g2*(12*r + 8*s - 7)))))/(315*d*k2*k3**4) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*st*(105*b1**3*k2**2*(D1*fd*(r + 2*s - 2) + Dd*(-8*K*r + 2*K + f*(4*r + 8*s - 5) + 4*r - 1)) - 3*b1**2*(D1*(fd*(k1**2*(140*C - 70)*(s - 1) + k2**2*(-14*K*(4*r + 5*s + 1) + f*(56*s - 27) + 14*s + 7)) - 35*k2**2*(bd1*(-6*K*r + 2*K + 3*f*(r + 2*s - 1) + 3*r - 1) + 4*gd2*r)) + 28*Dd*(2*f**2*k2**2*(2*s - 1) + f*k1**2*(10*C - 5)*(2*s - 1) + f*k2**2*(K*(-8*r - 10*s + 7) + 2*s - 1) + 5*g2*k2**2*(1 - 4*r))) - b1*(3*D1*bd1*(f**2*k2**2*(56*s - 29) - 7*f*(k1**2*s*(20 - 40*C) + k2**2*(4*K*(4*r + 5*s - 5) - 4*s + 3)) + 140*g2*k2**2*(1 - 2*r)) + k2**2*(-180*D1*K*f*fd*r - 84*D1*K*f*fd*s + 90*D1*K*f*fd - 210*D1*bd2*f*(r + s - 1) + 75*D1*f**2*fd*r + 162*D1*f**2*fd*s - 97*D1*f**2*fd + 18*D1*f*fd*r + 36*D1*f*fd*s - 9*D1*f*fd + 336*D1*f*gd2*r + 420*D1*f*gd2*s - 420*D1*f*gd2 + 336*D1*fd*g2*r + 420*D1*fd*g2*s + 84*D1*fd*g2 - 360*Dd*K*f**2*r - 168*Dd*K*f**2*s + 174*Dd*K*f**2 + 100*Dd*f**3*r + 216*Dd*f**3*s - 133*Dd*f**3 + 36*Dd*f**2*r + 72*Dd*f**2*s - 45*Dd*f**2 + 1344*Dd*f*g2*r + 1680*Dd*f*g2*s - 1176*Dd*f*g2 - 210*b2*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)))) + f*(D1*(bd1*f**2*k2**2*(-25*r - 54*s + 36) + 3*f*(fd*k1**2*(12*C - 6)*(3*s - 1) + k2**2*(2*K*bd1*(15*r + 7*s - 7) - 3*bd1*(r + 2*s - 2) + (2*bd2 - 4*gd2)*(15*r + 7*s - 7))) + 6*k2**2*(b2*(35*bd1*(r + s - 1) + fd*(30*r + 14*s - 15)) - 2*g2*(7*bd1*(4*r + 5*s - 5) + fd*(30*r + 14*s - 15)))) + 6*Dd*f*(f*k1**2*(12*C - 6)*(2*s - 1) + k2**2*(b2 - 2*g2)*(60*r + 28*s - 29))))/(315*d*k2*k3**2) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*st**3*(462*b1**3*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) - 33*b1**2*k2**2*(D1*(-14*bd1*f*k2**2*(3*r + 3*s - 2) + fd*k1**2*(28*C - 14)*(r + s - 1) + fd*k2**2*(-28*K*r - 14*K*s + f*(58*r + 72*s - 38) + 7*r)) + Dd*f*(k1**2*(28*C - 14)*(4*r + 4*s - 3) + k2**2*(-56*K*(2*r + s - 1) + f*(116*r + 144*s - 101) + 28*r - 7))) - 11*b1*(3*D1*(f**2*k2**4*(bd1*(58*r + 72*s - 63) + fd*(10*r - 14*s + 5)) + f*(fd*(k1**4*(4*C - 2)*(2*s - 1) + 2*k1**2*k2**2*(C*(-48*r - 72*s + 34) + 25*r + 38*s - 18) + k2**4*(-4*K*(2*r + s - 1) + 2*r - 1)) - 7*k2**2*(bd1*(k1**2*(2 - 4*C)*(2*r + 2*s - 1) + k2**2*(K*(8*r + 4*s - 6) - 2*r + 1)) + 2*k2**2*(bd2*(r + s - 1) - 2*gd2*(2*r + s - 1)))) - 14*fd*k2**4*(b2*(r + s) - 2*g2*(2*r + s))) + Dd*f*(2*f**2*k2**4*(20*r - 28*s + 9) + 3*f*(k1**4*(8*C - 4)*(2*s - 1) + k1**2*k2**2*(-96*C*(2*r + 3*s - 2) + 100*r + 152*s - 101) + k2**4*(-8*K*(2*r + s - 1) + 4*r - 1)) - 42*k2**4*(b2*(4*r + 4*s - 3) - 8*g2*(2*r + s - 1)))) + f*(D1*(f**2*k2**4*(-11*bd1*(10*r - 14*s + 3) + 3*fd*(140*r + 176*s - 123)) - 11*f*(3*bd1*(k1**4*s*(4*C - 2) + k1**2*k2**2*(C*(-48*r - 72*s + 52) + 25*r + 38*s - 27) + k2**4*(-2*K*(2*r + s - 1) + r)) + fd*(k1**4*(4*C - 2)*(3*s - 1) + 3*k1**2*k2**2*(-4*C*(13*r + 11*s - 8) + 27*r + 24*s - 17)) + 6*k2**4*(-bd2*(r + s - 1) + 2*gd2*(2*r + s - 1))) + 66*k2**4*(7*b2*bd1*(r + s - 1) + b2*fd*(2*r + 2*s - 1) - 14*bd1*g2*(2*r + s - 2) - 4*fd*g2*(2*r + s - 1))) + Dd*f*(3*f**2*k2**4*(140*r + 176*s - 123) - 11*f*(k1**4*(8*C - 4)*(2*s - 1) + k1**2*k2**2*(-4*C*(52*r + 44*s - 35) + 108*r + 96*s - 75)) + 66*k2**4*(b2*(4*r + 4*s - 3) - 8*g2*(2*r + s - 1)))))/(1155*d*k2*k3**4) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*st**3*(D1*bd1*f**2*(k1**2*s*(4*C - 2) + k2**2*r) + 7*b1**2*(D1*fd*(k1**2*(4*C - 2)*(s - 1) + k2**2*r) + Dd*f*(k1**2*(8*C - 4)*(2*s - 1) + k2**2*(4*r - 1))) + b1*f*(D1*(28*bd1*k1**2*s*(2*C - 1) + 7*bd1*k2**2*(2*r - 1) + fd*k1**2*(4*C - 2)*(2*s - 1) + fd*k2**2*(2*r - 1)) + Dd*f*(k1**2*(8*C - 4)*(2*s - 1) + k2**2*(4*r - 1))))/(35*d*k1**2*k2) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*st*(14*D1*bd1*f**2*k1**2*s*(1 - 2*C) + 7*b1**3*k2**2*(3*D1*fd*r + Dd*(3*f + 5)*(4*r - 1)) + b1**2*(D1*(7*bd1*k2**2*(3*f + 5)*(3*r - 1) - fd*k1**2*(140*C - 70)*(s - 1) + fd*k2**2*(18*f*r - 9*f + 7*r - 7)) + Dd*f*(-k1**2*(280*C - 140)*(2*s - 1) + k2**2*(9*f + 7)*(4*r - 1))) - 2*b1*f*(-D1*bd1*(k1**2*s*(70 - 140*C) + k2**2*r*(9*f + 7)) + D1*fd*k1**2*(14*C - 7)*(2*s - 1) + Dd*f*k1**2*(28*C - 14)*(2*s - 1)))/(105*d*k1**2*k2) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*st**3*(3*b1**2*(D1*fd*(-k1**4*(28*C - 14)*(s - 1) + k1**2*k2**2*r*(28*C - 21) + k2**4*r*(20*f + 7)) + Dd*f*(-k1**4*(56*C - 28)*(2*s - 1) + k1**2*k2**2*(28*C - 21)*(4*r - 1) + k2**4*(10*f + 7)*(4*r - 1))) + b1*f*(-3*D1*bd1*(k1**4*s*(56*C - 28) + k1**2*k2**2*(21 - 28*C)*(2*r - 1) - k2**4*(10*f + 7)*(2*r - 1)) + k2**2*(D1*fd*(-3*k1**2*(48*C*r + 112*C*s - 52*C - 24*r - 60*s + 27) + k2**2*(30*f*r - 10*f + 6*r - 3)) + Dd*f*(-24*k1**2*(C*(12*r + 28*s - 17) - 6*r - 15*s + 9) + k2**2*(10*f + 3)*(4*r - 1)))) + f**2*(D1*(bd1*k1**2*k2**2*(-12*C*(6*r + 14*s - 7) + 36*r + 90*s - 45) + bd1*k2**4*r*(10*f + 3) + fd*k1**4*(4*C - 2)*(3*s - 1) + fd*k1**2*k2**2*(C*(-84*r - 72*s + 52) + 45*r + 42*s - 29)) + Dd*f*k1**2*(k1**2*(8*C - 4)*(2*s - 1) + k2**2*(-4*C*(28*r + 24*s - 19) + 60*r + 56*s - 43))))/(105*d*k1**2*k2*k3**2) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**6*f*k2**5*st*(C - 1)*(9*D1*bd1*f*(r + s - 1) + 9*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 5*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(63*d*k3**5) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**5*f*k2**4*st*(9*D1*bd1*f*(r + s - 1) + 9*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 5*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(63*d*k1*k3**3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**5*f*k2**4*st*(33*D1*bd1*f*(10*f*k2**2 + k1**2*(132*C - 117))*(r + s - 1) + 33*b1*(D1*fd*(10*f*k2**2*(3*r + 3*s - 2) + k1**2*(132*C - 117)*(2*r + 2*s - 1)) + Dd*f*(10*f*k2**2 + k1**2*(132*C - 117))*(4*r + 4*s - 3)) + 5*f*(D1*fd*(42*f*k2**2*(4*r + 4*s - 3) + k1**2*(484*C - 429)*(3*r + 3*s - 2)) + Dd*f*(42*f*k2**2 + k1**2*(484*C - 429))*(4*r + 4*s - 3)))/(3465*d*k1*k3**5) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**4*f*k2**5*st**3*(C - 1)*(3*D1*bd1*f*(r + s - 1) + 3*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(21*d*k3**5) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**4*k2**3*st*(126*b1**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) - 9*b1*f*(-14*D1*bd1*(C - 1)*(2*r + 2*s - 1) + D1*fd*(C*(8*r + 8*s + 2) - 22*r - 22*s + 5) + Dd*f*(4*C - 11)*(4*r + 4*s - 3)) + f**2*(-9*D1*bd1*(2*C*(2*r + 2*s - 5) - 11*r - 11*s + 17) - (50*C - 85)*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))))/(315*d*k3**3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**4*k2**3*st*(33*D1*bd1*f*(r + s - 1)*(25*f**2*k2**2 + 3*f*(k1**2*(76*C - 59) + k2**2*(3*K - 10*b1 - 3)) - k2**2*(-42*K*b1 + 42*b1 + 42*g2)) - 99*b1**2*k2**2*(D1*fd*(5*f*(2*r + 2*s - 1) + (7 - 7*K)*(r + s)) + Dd*f*(-7*K + 5*f + 7)*(4*r + 4*s - 3)) + 33*b1*(D1*(25*f**2*fd*k2**2*(3*r + 3*s - 2) + 3*f*fd*(k1**2*(76*C - 59) + k2**2*(3*K - 3))*(2*r + 2*s - 1) - 42*f*gd2*k2**2*(r + s - 1) - 42*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(25*f**2*k2**2 + f*k1**2*(228*C - 177) + 9*f*k2**2*(K - 1) - 42*g2*k2**2)) + f*(D1*(700*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(4180*C - 3245)*(3*r + 3*s - 2) - 594*f*gd2*k2**2*(r + s - 1) - 594*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(700*f**2*k2**2 + f*k1**2*(4180*C - 3245) - 594*g2*k2**2)))/(3465*d*k3**5) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**3*f*k2**4*st**3*(3*D1*bd1*f*(r + s - 1) + 3*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(21*d*k1*k3**3) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**3*f*k2**4*st**3*(11*D1*bd1*f*(10*f*k2**2 + k1**2*(96*C - 81))*(r + s - 1) + 11*b1*(D1*fd*(10*f*k2**2*(3*r + 3*s - 2) + k1**2*(96*C - 81)*(2*r + 2*s - 1)) + Dd*f*(10*f*k2**2 + k1**2*(96*C - 81))*(4*r + 4*s - 3)) + f*(D1*fd*(50*f*k2**2*(4*r + 4*s - 3) + k1**2*(352*C - 297)*(3*r + 3*s - 2)) + Dd*f*(50*f*k2**2 + k1**2*(352*C - 297))*(4*r + 4*s - 3)))/(1155*d*k1*k3**5) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**3*k1*k2**2*st*(11*D1*bd1*f*(r + s - 1)*(40*f**2*k2**2 + 9*f*(k1**2*(64*C - 43) + k2**2*(12*K - 32*b1 - 9)) - k2**2*(126*b1*(3 - 4*K) + 504*g2)) - 99*b1**2*k2**2*(D1*fd*(16*f*(2*r + 2*s - 1) + (21 - 28*K)*(r + s)) + Dd*f*(-28*K + 16*f + 21)*(4*r + 4*s - 3)) + 11*b1*(D1*(40*f**2*fd*k2**2*(3*r + 3*s - 2) + 9*f*(fd*(k1**2*(64*C - 43) + k2**2*(12*K - 9))*(2*r + 2*s - 1) - 56*gd2*k2**2*(r + s - 1)) - 504*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(40*f**2*k2**2 + 9*f*(k1**2*(64*C - 43) + k2**2*(12*K - 9)) - 504*g2*k2**2)) + f*(D1*(840*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(3520*C - 2365)*(3*r + 3*s - 2) - 2376*f*gd2*k2**2*(r + s - 1) - 2376*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(840*f**2*k2**2 + f*k1**2*(3520*C - 2365) - 2376*g2*k2**2)))/(3465*d*k3**5) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**3*k2**2*st*(3*D1*bd1*f**2*(r + s) + 7*b1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*f*(7*D1*bd1*(2*r + 2*s - 1) + 6*D1*fd*(r + s - 1) + 3*Dd*f*(4*r + 4*s - 3)))/(35*d*k1*k3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**3*k2**2*st*(3*b1**2*(D1*fd*(k1**2*(112*C - 91)*(r + s - 1) + 3*k2**2*(4*f*(4*r + 4*s - 3) + 7*r + 7*s)) + Dd*f*(k1**2*(112*C - 91) + k2**2*(24*f + 21))*(4*r + 4*s - 3)) + b1*f*(3*D1*bd1*(k1**2*(112*C - 91)*(2*r + 2*s - 1) + 6*k2**2*(f*(8*r + 8*s - 6) + 7*r + 7*s - 7)) + D1*fd*(-9*k1**2*(8*C*(2*r + 2*s + 1) - 16*r - 16*s - 5) + k2**2*(20*f*(6*r + 6*s - 5) + 54*r + 54*s - 27)) + Dd*f*(k1**2*(72 - 72*C) + k2**2*(40*f + 27))*(4*r + 4*s - 3)) + f**2*(D1*bd1*(-9*k1**2*(8*C*(r + s - 3) - 8*r - 8*s + 21) + k2**2*(20*f*(2*r + 2*s - 1) + 27*r + 27*s - 27)) + k1**2*(105 - 120*C)*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))))/(315*d*k1*k3**3) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**2*f*k2**5*st**5*(C - 1)*(9*D1*bd1*f*(r + s - 1) + 9*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(63*d*k3**5) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**2*k1**2*k2*st*(33*D1*bd1*f*(r + s - 1)*(10*f**2*k2**2 + 3*f*(k1**2*(15 - 26*C) + k2**2*(-18*K + 36*b1 + 9)) + k2**2*(-252*K*b1 + 126*b1 + 252*g2)) + 297*b1**2*k2**2*(D1*fd*(6*f*(2*r + 2*s - 1) + (7 - 14*K)*(r + s)) + Dd*f*(-14*K + 6*f + 7)*(4*r + 4*s - 3)) + 33*b1*(D1*(10*f**2*fd*k2**2*(3*r + 3*s - 2) - 3*f*fd*(k1**2*(26*C - 15) + k2**2*(18*K - 9))*(2*r + 2*s - 1) + 252*f*gd2*k2**2*(r + s - 1) + 252*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(10*f**2*k2**2 + f*k1**2*(45 - 78*C) + 27*f*k2**2*(1 - 2*K) + 252*g2*k2**2)) + f*(D1*(-420*f**2*fd*k2**2*(4*r + 4*s - 3) - f*fd*k1**2*(1430*C - 825)*(3*r + 3*s - 2) + 3564*f*gd2*k2**2*(r + s - 1) + 3564*fd*g2*k2**2*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(420*f**2*k2**2 + f*k1**2*(1430*C - 825) - 3564*g2*k2**2)))/(3465*d*k3**5) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**2*k2**3*st**3*(21*b1**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + 3*b1*f*(7*D1*bd1*(C - 1)*(2*r + 2*s - 1) + D1*fd*(-2*C*(9*r + 9*s - 4) + 20*r + 20*s - 9) - Dd*f*(9*C - 10)*(4*r + 4*s - 3)) + f**2*(-3*D1*bd1*(C*(9*r + 9*s - 10) - 10*r - 10*s + 11) - (10*C - 11)*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))))/(105*d*k3**3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**2*k2**3*st**3*(33*D1*bd1*f*(r + s - 1)*(10*f**2*k2**2 + f*k1**2*(74*C - 52) + f*k2**2*(K - 20*b1 - 1) - k2**2*(-14*K*b1 + 14*b1 + 14*g2)) - 33*b1**2*k2**2*(D1*fd*(10*f*(2*r + 2*s - 1) + (7 - 7*K)*(r + s)) + Dd*f*(-7*K + 10*f + 7)*(4*r + 4*s - 3)) + 33*b1*(D1*(10*f**2*fd*k2**2*(3*r + 3*s - 2) + f*fd*(k1**2*(74*C - 52) + k2**2*(K - 1))*(2*r + 2*s - 1) - 14*f*gd2*k2**2*(r + s - 1) - 14*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(10*f**2*k2**2 + f*k1**2*(74*C - 52) + f*k2**2*(K - 1) - 14*g2*k2**2)) + 2*f*(D1*(100*f**2*fd*k2**2*(4*r + 4*s - 3) + 11*f*(fd*k1**2*(37*C - 26)*(3*r + 3*s - 2) - 3*gd2*k2**2*(r + s - 1)) - 33*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(100*f**2*k2**2 + f*k1**2*(407*C - 286) - 33*g2*k2**2)))/(1155*d*k3**5) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**2*k2*st*(6*C - 5)*(3*D1*bd1*f**2*(r + s) + 7*b1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*f*(7*D1*bd1*(2*r + 2*s - 1) + 6*D1*fd*(r + s - 1) + 3*Dd*f*(4*r + 4*s - 3)))/(105*d*k3) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**2*k2*st*(21*b1**3*k2**2*(3*D1*fd*(r + s - 1) + Dd*(-5*K + 3*f + 5)*(4*r + 4*s - 3)) - 3*b1**2*(D1*(fd*(k1**2*(98*C - 63)*(r + s - 1) + k2**2*(-14*K*r - 14*K*s - 7*K + 9*f*(8*r + 8*s - 5) + 35*r + 35*s + 7)) - 7*k2**2*(bd1*(-5*K + 3*f + 5)*(3*r + 3*s - 2) + 10*gd2*(r + s - 1))) + Dd*(4*r + 4*s - 3)*(36*f**2*k2**2 + 7*f*(k1**2*(14*C - 9) + k2**2*(5 - 2*K)) - 70*g2*k2**2)) - 3*b1*(D1*bd1*(9*f**2*k2**2*(8*r + 8*s - 7) + 7*f*(k1**2*(14*C - 9)*(2*r + 2*s - 1) + k2**2*(K*(-4*r - 4*s + 5) + 10*r + 10*s - 11)) - 70*g2*k2**2*(2*r + 2*s - 1)) + D1*(15*f**2*fd*k2**2*(5*r + 5*s - 4) + f*(-3*fd*(k1**2*(2*C*(4*r + 4*s + 5) - 4*r - 4*s - 7) + k2**2*(3*K - 6)*(2*r + 2*s - 1)) + k2**2*(-21*bd2 + 28*gd2)*(r + s - 1)) + 7*fd*k2**2*(-3*b2*(r + s) + g2*(4*r + 4*s + 2))) + Dd*f*(4*r + 4*s - 3)*(25*f**2*k2**2 - 3*f*(k1**2*(4*C - 2) + k2**2*(3*K - 6)) + k2**2*(-21*b2 + 28*g2))) + f*(-3*D1*bd1*(5*f**2*k2**2*(5*r + 5*s - 3) - 3*f*(k1**2*(2*C*(2*r + 2*s - 9) - 2*r - 2*s + 11) + k2**2*(3*K - 6)*(r + s - 1)) - 7*k2**2*(3*b2*(r + s - 1) - 2*g2*(2*r + 2*s - 3))) + D1*(f*fd*k1**2*(90*C - 55)*(3*r + 3*s - 2) + 27*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) + 27*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + Dd*f*(f*k1**2*(90*C - 55) + k2**2*(27*b2 - 54*g2))*(4*r + 4*s - 3)))/(315*d*k3**3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct*f*k2**4*st**5*(9*D1*bd1*f*(r + s - 1) + 9*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(63*d*k1*k3**3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct*f*k2**4*st**5*(33*D1*bd1*f*(2*f*k2**2 + k1**2*(12*C - 9))*(r + s - 1) + 33*b1*(D1*fd*(2*f*k2**2*(3*r + 3*s - 2) + k1**2*(12*C - 9)*(2*r + 2*s - 1)) + Dd*f*(2*f*k2**2 + k1**2*(12*C - 9))*(4*r + 4*s - 3)) + f*(D1*fd*(18*f*k2**2*(4*r + 4*s - 3) + k1**2*(44*C - 33)*(3*r + 3*s - 2)) + Dd*f*(18*f*k2**2 + k1**2*(44*C - 33))*(4*r + 4*s - 3)))/(693*d*k1*k3**5) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct*k1**3*st*(33*D1*bd1*f*(r + s - 1)*(10*f**2*k2**2 + f*k1**2*(6 - 12*C) + 3*f*k2**2*(-12*K + 16*b1 + 3) + k2**2*(-168*K*b1 + 42*b1 + 168*g2)) + 99*b1**2*k2**2*(D1*fd*(8*f*(2*r + 2*s - 1) + (7 - 28*K)*(r + s)) + Dd*f*(-28*K + 8*f + 7)*(4*r + 4*s - 3)) + 33*b1*(D1*(10*f**2*fd*k2**2*(3*r + 3*s - 2) - 3*f*fd*(k1**2*(4*C - 2) + k2**2*(12*K - 3))*(2*r + 2*s - 1) + 168*f*gd2*k2**2*(r + s - 1) + 168*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(10*f**2*k2**2 + f*k1**2*(6 - 12*C) + 9*f*k2**2*(1 - 4*K) + 168*g2*k2**2)) + 2*f*(D1*(-35*f**2*fd*k2**2*(4*r + 4*s - 3) - f*fd*k1**2*(110*C - 55)*(3*r + 3*s - 2) + 1188*f*gd2*k2**2*(r + s - 1) + 1188*fd*g2*k2**2*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2 + f*k1**2*(110*C - 55) - 1188*g2*k2**2)))/(3465*d*k3**5) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct*k1*k2**2*st**3*(11*D1*bd1*f*(r + s - 1)*(8*f**2*k2**2 + f*k1**2*(108*C - 63) - 3*f*k2**2*(-2*K + 32*b1 + 1) - k2**2*(-84*K*b1 + 42*b1 + 84*g2)) - 33*b1**2*k2**2*(D1*fd*(16*f*(2*r + 2*s - 1) + (7 - 14*K)*(r + s)) + Dd*f*(-14*K + 16*f + 7)*(4*r + 4*s - 3)) + 11*b1*(D1*(8*f**2*fd*k2**2*(3*r + 3*s - 2) + 3*f*fd*(k1**2*(36*C - 21) + k2**2*(2*K - 1))*(2*r + 2*s - 1) - 84*f*gd2*k2**2*(r + s - 1) - 84*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(8*f**2*k2**2 + f*k1**2*(108*C - 63) + 3*f*k2**2*(2*K - 1) - 84*g2*k2**2)) + 3*f*(D1*(40*f**2*fd*k2**2*(4*r + 4*s - 3) + 11*f*(fd*k1**2*(12*C - 7)*(3*r + 3*s - 2) - 4*gd2*k2**2*(r + s - 1)) - 44*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(40*f**2*k2**2 + f*k1**2*(132*C - 77) - 44*g2*k2**2)))/(1155*d*k3**5) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct*k1*st*(21*b1**3*k2**2*(4*D1*fd*(r + s - 1) + Dd*(-10*K + 4*f + 5)*(4*r + 4*s - 3)) - 3*b1**2*(D1*(fd*(k1**2*(28*C - 14)*(r + s - 1) + k2**2*(6*f*(4*r + 4*s - 1) + (7 - 14*K)*(2*r + 2*s + 1))) - 7*k2**2*(bd1*(-10*K + 4*f + 5)*(3*r + 3*s - 2) + 20*gd2*(r + s - 1))) + 2*Dd*(4*r + 4*s - 3)*(6*f**2*k2**2 + 7*f*(k1**2*(2*C - 1) + k2**2*(1 - 2*K)) - 70*g2*k2**2)) - b1*(3*D1*bd1*(6*f**2*k2**2*(4*r + 4*s - 5) + f*k1**2*(28*C - 14)*(2*r + 2*s - 1) - 7*f*k2**2*(2*K - 1)*(4*r + 4*s - 5) - 140*g2*k2**2*(2*r + 2*s - 1)) + 3*D1*(10*f**2*fd*k2**2*(4*r + 4*s - 3) + f*(-3*fd*(k1**2*(4*C - 2) + k2**2*(6*K - 3)*(2*r + 2*s - 1)) + k2**2*(-42*bd2 + 56*gd2)*(r + s - 1)) + 14*fd*k2**2*(-3*b2*(r + s) + g2*(4*r + 4*s + 2))) + Dd*f*k2**2*(4*r + 4*s - 3)*(-126*b2 + 40*f**2 + f*(27 - 54*K) + 168*g2)) + f*(D1*bd1*(-10*f**2*k2**2*(4*r + 4*s - 3) - 9*f*(k1**2*(4*C - 2) - k2**2*(6*K - 3)*(r + s - 1)) + 42*k2**2*(3*b2*(r + s - 1) - 2*g2*(2*r + 2*s - 3))) + 2*D1*(f*fd*k1**2*(10*C - 5)*(3*r + 3*s - 2) + 27*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) + 27*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + 2*Dd*f*(f*k1**2*(10*C - 5) + k2**2*(27*b2 - 54*g2))*(4*r + 4*s - 3)))/(315*d*k3**3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct*k2**2*st**3*(D1*bd1*f**2*(r + s) + 7*b1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*f*(7*D1*bd1*(2*r + 2*s - 1) + 2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)))/(35*d*k1*k3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct*k2**2*st**3*(3*b1**2*(D1*fd*(k1**2*(28*C - 21)*(r + s - 1) + k2**2*(4*f*(4*r + 4*s - 3) + 7*r + 7*s)) + Dd*f*(k1**2*(28*C - 21) + k2**2*(8*f + 7))*(4*r + 4*s - 3)) + b1*f*(3*D1*bd1*(k1**2*(28*C - 21)*(2*r + 2*s - 1) + 2*k2**2*(f*(8*r + 8*s - 6) + 7*r + 7*s - 7)) + D1*fd*(-3*k1**2*(8*C*(5*r + 5*s - 2) - 24*r - 24*s + 9) + k2**2*(4*f*(6*r + 6*s - 5) + 6*r + 6*s - 3)) + Dd*f*(k1**2*(36 - 60*C) + k2**2*(8*f + 3))*(4*r + 4*s - 3)) + f**2*(D1*bd1*(k1**2*(-12*C*(5*r + 5*s - 6) + 36*r + 36*s - 45) + k2**2*(f*(8*r + 8*s - 4) + 3*r + 3*s - 3)) + k1**2*(15 - 24*C)*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))))/(105*d*k1*k3**3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct*st*(-6*D1*bd1*f**2*k1**2*(2*C - 1)*(r + s) + 7*b1**3*k2**2*(2*D1*fd*(r + s - 1) + Dd*(2*f + 5)*(4*r + 4*s - 3)) + b1**2*(D1*(7*bd1*k2**2*(2*f + 5)*(3*r + 3*s - 2) - fd*(k1**2*(28*C - 14) - k2**2*(12*f + 7))*(r + s - 1)) + Dd*f*(k1**2*(14 - 28*C) + k2**2*(6*f + 7))*(4*r + 4*s - 3)) + b1*f*(-D1*bd1*(k1**2*(28*C - 14) - k2**2*(6*f + 7))*(2*r + 2*s - 1) - k1**2*(12*C - 6)*(2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))))/(105*d*k1*k3) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*f*k2**3*st**5*(2*C - 1)*(9*D1*bd1*f*(r + s - 1) + 9*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(63*d*k3**3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*f*k2**3*st**5*(33*D1*bd1*f*(k1**2*(6*C - 3) + k2**2*(-6*b1 + f))*(r + s - 1) - 99*b1**2*k2**2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 33*b1*(D1*fd*(f*k2**2*(3*r + 3*s - 2) + k1**2*(6*C - 3)*(2*r + 2*s - 1)) + Dd*f*(f*k2**2 + k1**2*(6*C - 3))*(4*r + 4*s - 3)) + f*(D1*fd*(12*f*k2**2*(4*r + 4*s - 3) + k1**2*(22*C - 11)*(3*r + 3*s - 2)) + Dd*f*(12*f*k2**2 + k1**2*(22*C - 11))*(4*r + 4*s - 3)))/(693*d*k3**5) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*k1**4*k2*st*(9*b1**2*(D1*fd*(-7*K*(r + s) + f*(2*r + 2*s - 1)) + Dd*f*(-7*K + f)*(4*r + 4*s - 3)) + b1*(18*D1*bd1*f*(-7*K + f)*(r + s - 1) + D1*(5*f**2*fd*(3*r + 3*s - 2) + 9*f*(-3*K*fd*(2*r + 2*s - 1) + 14*gd2*(r + s - 1)) + 126*fd*g2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(-27*K*f + 5*f**2 + 126*g2)) + f*(D1*bd1*(r + s - 1)*(-27*K*f + 5*f**2 + 126*g2) + 54*D1*f*gd2*(r + s - 1) + 54*D1*fd*g2*(2*r + 2*s - 1) + 54*Dd*f*g2*(4*r + 4*s - 3)))/(315*d*k3**5) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*k1**2*k2*st*(21*b1**3*(D1*fd*(r + s - 1) + Dd*(-5*K + f)*(4*r + 4*s - 3)) + 3*b1**2*(7*D1*bd1*(-5*K + f)*(3*r + 3*s - 2) + D1*(7*K*fd*(2*r + 2*s + 1) - 3*f*fd + 70*gd2*(r + s - 1)) + 14*Dd*(K*f + 5*g2)*(4*r + 4*s - 3)) + b1*(84*D1*K*bd1*f*r + 84*D1*K*bd1*f*s - 105*D1*K*bd1*f + 54*D1*K*f*fd*r + 54*D1*K*f*fd*s - 27*D1*K*f*fd + 9*D1*bd1*f**2 + 420*D1*bd1*g2*r + 420*D1*bd1*g2*s - 210*D1*bd1*g2 + 63*D1*bd2*f*(r + s - 1) - 15*D1*f**2*fd*r - 15*D1*f**2*fd*s + 10*D1*f**2*fd - 84*D1*f*gd2*r - 84*D1*f*gd2*s + 84*D1*f*gd2 - 84*D1*fd*g2*r - 84*D1*fd*g2*s - 42*D1*fd*g2 + 108*Dd*K*f**2*r + 108*Dd*K*f**2*s - 81*Dd*K*f**2 - 20*Dd*f**3*r - 20*Dd*f**3*s + 15*Dd*f**3 - 336*Dd*f*g2*r - 336*Dd*f*g2*s + 252*Dd*f*g2 + 63*b2*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3))) + f*(27*D1*K*bd1*f*r + 27*D1*K*bd1*f*s - 27*D1*K*bd1*f - 5*D1*bd1*f**2*r - 5*D1*bd1*f**2*s + 5*D1*bd1*f**2 - 84*D1*bd1*g2*r - 84*D1*bd1*g2*s + 126*D1*bd1*g2 + 27*D1*bd2*f*(r + s - 1) - 54*D1*f*gd2*r - 54*D1*f*gd2*s + 54*D1*f*gd2 - 108*D1*fd*g2*r - 108*D1*fd*g2*s + 54*D1*fd*g2 - 216*Dd*f*g2*r - 216*Dd*f*g2*s + 162*Dd*f*g2 + 9*b2*(7*D1*bd1*(r + s - 1) + 3*D1*fd*(2*r + 2*s - 1) + 3*Dd*f*(4*r + 4*s - 3))))/(315*d*k3**3) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*k1**2*k2*st**3*(11*D1*bd1*f*(r + s - 1)*(2*f**2*k2**2 - 3*f*(k1**2*(6*C - 3) + k2**2*(K - 12*b1)) + k2**2*(-42*K*b1 + 42*g2)) + 33*b1**2*k2**2*(D1*fd*(-7*K*(r + s) + 6*f*(2*r + 2*s - 1)) + Dd*f*(-7*K + 6*f)*(4*r + 4*s - 3)) + 11*b1*(D1*(2*f**2*fd*k2**2*(3*r + 3*s - 2) - 3*f*fd*(K*k2**2 + k1**2*(6*C - 3))*(2*r + 2*s - 1) + 42*f*gd2*k2**2*(r + s - 1) + 42*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(2*f**2*k2**2 - 3*f*(K*k2**2 + k1**2*(6*C - 3)) + 42*g2*k2**2)) + f*(D1*(-20*f**2*fd*k2**2*(4*r + 4*s - 3) - f*fd*k1**2*(66*C - 33)*(3*r + 3*s - 2) + 66*f*gd2*k2**2*(r + s - 1) + 66*fd*g2*k2**2*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(20*f**2*k2**2 + f*k1**2*(66*C - 33) - 66*g2*k2**2)))/(1155*d*k3**5) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*k2*st**3*(2*C - 1)*(D1*bd1*f**2*(r + s) + 7*b1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*f*(7*D1*bd1*(2*r + 2*s - 1) + 2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)))/(35*d*k3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*k2*st*(-7*D1*bd1*f*(b2 - 2*g2)*(r + s) + 7*b1**3*(D1*fd*(r + s - 1) + Dd*(-5*K + f)*(4*r + 4*s - 3)) + b1**2*(-105*D1*K*bd1*r - 105*D1*K*bd1*s + 70*D1*K*bd1 - 7*D1*K*fd*r - 7*D1*K*fd*s + 7*D1*K*fd + 21*D1*bd1*f*r + 21*D1*bd1*f*s - 14*D1*bd1*f - 35*D1*bd2*(r + s - 1) + 6*D1*f*fd*r + 6*D1*f*fd*s - 6*D1*f*fd + 70*D1*gd2*r + 70*D1*gd2*s - 70*D1*gd2 - 28*Dd*K*f*r - 28*Dd*K*f*s + 21*Dd*K*f - 35*Dd*b2*(4*r + 4*s - 3) + 12*Dd*f**2*r + 12*Dd*f**2*s - 9*Dd*f**2 + 280*Dd*g2*r + 280*Dd*g2*s - 210*Dd*g2) + b1*(-14*D1*K*bd1*f*r - 14*D1*K*bd1*f*s + 7*D1*K*bd1*f + 6*D1*bd1*f**2*r + 6*D1*bd1*f**2*s - 3*D1*bd1*f**2 + 140*D1*bd1*g2*r + 140*D1*bd1*g2*s - 70*D1*bd1*g2 - 7*D1*bd2*f*(r + s - 1) + 14*D1*f*gd2*r + 14*D1*f*gd2*s - 14*D1*f*gd2 + 14*D1*fd*g2*r + 14*D1*fd*g2*s - 14*D1*fd*g2 + 56*Dd*f*g2*r + 56*Dd*f*g2*s - 42*Dd*f*g2 - 7*b2*(5*D1*bd1*(2*r + 2*s - 1) + D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))))/(105*d*k3) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*k2*st**3*(21*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) - 3*b1**2*(D1*(-7*bd1*f*k2**2*(3*r + 3*s - 2) + fd*k1**2*(14*C - 7)*(r + s - 1) + fd*k2**2*(-7*K*(r + s) + f*(8*r + 8*s - 5))) + Dd*f*(k1**2*(14*C - 7) + k2**2*(-7*K + 4*f))*(4*r + 4*s - 3)) + b1*(-3*D1*bd1*f*(k1**2*(14*C - 7)*(2*r + 2*s - 1) + k2**2*(-14*K*(r + s - 1) + f*(8*r + 8*s - 7))) + 3*D1*(f**2*fd*k2**2*(-5*r - 5*s + 4) + f*(K*fd*k2**2*(2*r + 2*s - 1) + fd*k1**2*(2*C - 1)*(4*r + 4*s - 1) + k2**2*(7*bd2 - 14*gd2)*(r + s - 1)) + 7*fd*k2**2*(b2 - 2*g2)*(r + s)) - Dd*f*(4*r + 4*s - 3)*(5*f**2*k2**2 - 3*f*(K*k2**2 + k1**2*(4*C - 2)) - k2**2*(21*b2 - 42*g2))) + f*(D1*bd1*(f**2*k2**2*(-5*r - 5*s + 3) + 3*f*(K*k2**2*(r + s - 1) + k1**2*(2*C - 1)*(2*r + 2*s - 3)) + k2**2*(21*b2 - 42*g2)*(r + s - 1)) + 3*D1*(f*fd*k1**2*(2*C - 1)*(3*r + 3*s - 2) + f*k2**2*(bd2 - 2*gd2)*(r + s - 1) + fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + 3*Dd*f*(f*k1**2*(2*C - 1) + k2**2*(b2 - 2*g2))*(4*r + 4*s - 3)))/(105*d*k3**3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*b1*k2*st*(6*D1*bd1*f**2*r + 7*b1**2*(D1*fd*r + Dd*f*(4*r - 1)) + b1*f*(7*D1*bd1*(3*r - 1) + 3*D1*fd*(2*r - 1) + 3*Dd*f*(4*r - 1)))/(105*d*k1) - 8*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**5*f*k2**4*st*(C - 1)*(9*D1*bd1*f*(r - 1) + 9*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 5*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(315*d*k3**4) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**4*f*k2**3*st*(9*D1*bd1*f*(r - 1) + 9*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 5*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(315*d*k1*k3**2) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**4*f*k2**3*st*(11*D1*bd1*f*(r - 1)*(25*f*k2**2 + k1**2*(252*C - 216)) + 11*b1*(3*D1*fd*r*(25*f*k2**2 + k1**2*(168*C - 144)) + Dd*f*(4*r - 1)*(25*f*k2**2 + k1**2*(252*C - 216))) + 5*f*(D1*fd*(35*f*k2**2*(4*r - 1) + k1**2*(308*C - 264)*(3*r - 1)) + Dd*f*(4*r - 1)*(35*f*k2**2 + k1**2*(308*C - 264))))/(3465*d*k1*k3**4) - 8*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**3*f*k2**4*st**3*(C - 1)*(6*D1*b1*fd*r + 3*D1*bd1*f*(r - 1) + D1*f*fd*(3*r - 1) + 3*Dd*b1*f*(4*r - 1) + Dd*f**2*(4*r - 1))/(105*d*k3**4) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**3*k2**2*st*(42*b1**2*(C - 1)*(D1*fd*r + Dd*f*(4*r - 1)) + 3*b1*f*(14*D1*bd1*(C - 1)*(2*r - 1) - 6*D1*fd*(2*C*r + C - 3*r - 1) - Dd*f*(6*C - 9)*(4*r - 1)) + f**2*(-9*D1*bd1*(2*C*(r - 2) - 3*r + 5) - (20*C - 25)*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1))))/(315*d*k3**2) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**3*k2**2*st*(11*D1*bd1*f*(10*f**2*k2**2*(2*r - 3) + 9*f*(k1**2*(18*C - 13)*(r - 1) + k2**2*(b1*(2 - 4*r) + r*(K - 1))) + 21*k2**2*(b1*(K - 1)*(2*r - 1) - 2*g2*(r - 1))) - 33*b1**2*k2**2*(D1*fd*r*(-7*K + 12*f + 7) + Dd*f*(4*r - 1)*(-7*K + 6*f + 7)) + 11*b1*(D1*(10*f**2*fd*k2**2*(6*r + 1) + 3*f*(fd*k1**2*r*(108*C - 78) + 3*fd*k2**2*(K - 1)*(2*r - 1) - 14*gd2*k2**2*r) - 42*fd*g2*k2**2*r) + Dd*f*(4*r - 1)*(20*f**2*k2**2 + 9*f*(k1**2*(18*C - 13) + k2**2*(K - 1)) - 42*g2*k2**2)) + f*(D1*(210*f**2*fd*k2**2*(4*r - 1) + f*fd*k1**2*(990*C - 715)*(3*r - 1) - 198*f*gd2*k2**2*r + 198*fd*g2*k2**2*(1 - 2*r)) + Dd*f*(4*r - 1)*(210*f**2*k2**2 + f*k1**2*(990*C - 715) - 198*g2*k2**2)))/(3465*d*k3**4) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**2*f*k2**3*st**3*(6*D1*b1*fd*r + 3*D1*bd1*f*(r - 1) + D1*f*fd*(3*r - 1) + 3*Dd*b1*f*(4*r - 1) + Dd*f**2*(4*r - 1))/(105*d*k1*k3**2) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**2*f*k2**3*st**3*(11*D1*bd1*f*(r - 1)*(5*f*k2**2 + k1**2*(30*C - 24)) + 11*b1*(3*D1*fd*r*(5*f*k2**2 + k1**2*(20*C - 16)) + Dd*f*(4*r - 1)*(5*f*k2**2 + k1**2*(30*C - 24))) + f*(D1*fd*(25*f*k2**2*(4*r - 1) + k1**2*(110*C - 88)*(3*r - 1)) + Dd*f*(4*r - 1)*(25*f*k2**2 + k1**2*(110*C - 88))))/(1155*d*k1*k3**4) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**2*k1*k2*st*(33*D1*bd1*f*(15*f**2*k2**2 - 3*f*(k1**2*(20*C - 12)*(r - 1) + k2**2*(6*K*r - 18*b1*r + 9*b1 - 4*r)) - 14*k2**2*(b1*(3*K - 2)*(2*r - 1) - 6*g2*(r - 1))) + 33*b1**2*k2**2*(2*D1*fd*r*(-21*K + 27*f + 14) + Dd*f*(4*r - 1)*(-42*K + 27*f + 28)) - 99*b1*(D1*(5*f**2*fd*k2**2 + 2*f*(fd*k1**2*r*(20*C - 12) + fd*k2**2*(3*K - 2)*(2*r - 1) - 14*gd2*k2**2*r) - 28*fd*g2*k2**2*r) + 2*Dd*f*(4*r - 1)*(f*k1**2*(10*C - 6) + f*k2**2*(3*K - 2) - 14*g2*k2**2)) + f*(D1*(-315*f**2*fd*k2**2*(4*r - 1) - 44*f*(fd*k1**2*(25*C - 15)*(3*r - 1) - 27*gd2*k2**2*r) + 1188*fd*g2*k2**2*(2*r - 1)) - Dd*f*(4*r - 1)*(315*f**2*k2**2 + f*k1**2*(1100*C - 660) - 1188*g2*k2**2)))/(3465*d*k3**4) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**2*k2*st*(3*D1*bd1*f**2*r + 7*b1**2*(D1*fd*r + Dd*f*(4*r - 1)) + b1*f*(7*D1*bd1*(2*r - 1) + 3*D1*fd*(2*r - 1) + 3*Dd*f*(4*r - 1)))/(105*d*k1) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**2*k2*st*(3*b1**2*(D1*fd*r*(k1**2*(28*C - 21) + k2**2*(18*f + 7)) + Dd*f*(4*r - 1)*(k1**2*(28*C - 21) + k2**2*(9*f + 7))) + 3*b1*f*(D1*bd1*(2*r - 1)*(k1**2*(28*C - 21) + k2**2*(9*f + 7)) + D1*fd*(-3*k1**2*(4*C*(r + 1) - 2*r - 3) + k2**2*(5*f*(3*r - 1) + 6*r - 3)) + Dd*f*(4*r - 1)*(k1**2*(3 - 6*C) + k2**2*(5*f + 3))) + f**2*(3*D1*bd1*(-3*k1**2*(2*C*(r - 3) - r + 4) + k2**2*r*(5*f + 3)) - k1**2*(30*C - 20)*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1))))/(315*d*k1*k3**2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct*f*k2**2*st**3*(4*C - 3)*(6*D1*b1*fd*r + 3*D1*bd1*f*(r - 1) + D1*f*fd*(3*r - 1) + 3*Dd*b1*f*(4*r - 1) + Dd*f**2*(4*r - 1))/(105*d*k3**2) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct*f*k2**2*st**3*(11*D1*bd1*f*(k1**2*(24*C - 15)*(r - 1) + 2*k2**2*(-6*b1*r + 3*b1 + 2*f*r - 3*f)) - 66*b1**2*k2**2*(2*D1*fd*r + Dd*f*(4*r - 1)) + 11*b1*(2*D1*fd*(f*k2**2*(6*r + 1) + k1**2*r*(24*C - 15)) + Dd*f*(4*r - 1)*(4*f*k2**2 + k1**2*(24*C - 15))) + f*(D1*fd*(30*f*k2**2*(4*r - 1) + k1**2*(88*C - 55)*(3*r - 1)) + Dd*f*(4*r - 1)*(30*f*k2**2 + k1**2*(88*C - 55))))/(1155*d*k3**4) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct*k1**2*st*(11*D1*bd1*f*(5*f**2*k2**2*(2*r + 1) + f*k1**2*(9 - 18*C)*(r - 1) + 9*f*k2**2*(-3*K*r + b1*(6*r - 3) + r) - 21*k2**2*(b1*(3*K - 1)*(2*r - 1) - 6*g2*(r - 1))) + 33*b1**2*k2**2*(D1*fd*r*(-21*K + 18*f + 7) + Dd*f*(4*r - 1)*(-21*K + 9*f + 7)) + 11*b1*(3*D1*(5*f**2*fd*k2**2*(2*r - 1) - 3*f*(fd*k1**2*r*(4*C - 2) + fd*k2**2*(3*K - 1)*(2*r - 1) - 14*gd2*k2**2*r) + 42*fd*g2*k2**2*r) + Dd*f*(4*r - 1)*(10*f**2*k2**2 - 9*f*(k1**2*(2*C - 1) + k2**2*(3*K - 1)) + 126*g2*k2**2)) + f*(D1*(-35*f**2*fd*k2**2*(4*r - 1) - f*fd*k1**2*(110*C - 55)*(3*r - 1) + 594*f*gd2*k2**2*r + 594*fd*g2*k2**2*(2*r - 1)) - Dd*f*(4*r - 1)*(35*f**2*k2**2 + f*k1**2*(110*C - 55) - 594*g2*k2**2)))/(3465*d*k3**4) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct*st*(2*C - 1)*(3*D1*bd1*f**2*r + 7*b1**2*(D1*fd*r + Dd*f*(4*r - 1)) + b1*f*(7*D1*bd1*(2*r - 1) + 3*D1*fd*(2*r - 1) + 3*Dd*f*(4*r - 1)))/(105*d) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct*st*(21*b1**3*k2**2*(D1*fd*r + Dd*f*(4*r - 1)) - 3*b1**2*(D1*(7*bd1*f*k2**2*(1 - 3*r) + fd*(3*f*k2**2*(4*r + 1) + k1**2*r*(14*C - 7) - k2**2*r*(7*K - 7))) + Dd*f*(4*r - 1)*(k1**2*(14*C - 7) + k2**2*(-7*K + 6*f + 7))) - 3*b1*(D1*bd1*f*(k1**2*(14*C - 7)*(2*r - 1) + k2**2*(-14*K*r + 7*K + 3*f*(4*r - 3) + 14*r - 7)) + D1*(5*f**2*fd*k2**2*(3*r - 1) - 3*f*fd*(k1**2*(2*C - 1) + k2**2*(K - 1)*(2*r - 1)) - 7*f*k2**2*r*(bd2 - 2*gd2) - 7*fd*k2**2*r*(b2 - 2*g2)) + Dd*f*k2**2*(4*r - 1)*(-7*b2 + 5*f**2 - 3*f*(K - 1) + 14*g2)) + f*(-3*D1*bd1*(5*f**2*k2**2*r + f*k1**2*(6*C - 3) - 3*f*k2**2*r*(K - 1) - k2**2*(7*b2 - 14*g2)*(r - 1)) + D1*(f*fd*k1**2*(10*C - 5)*(3*r - 1) + 9*f*k2**2*r*(bd2 - 2*gd2) + 9*fd*k2**2*(b2 - 2*g2)*(2*r - 1)) + Dd*f*(4*r - 1)*(f*k1**2*(10*C - 5) + k2**2*(9*b2 - 18*g2))))/(315*d*k3**2) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*f**2*k2**5*st**5*(11*D1*bd1*f*(r - 1) + 11*b1*(3*D1*fd*r + Dd*f*(4*r - 1)) + 3*f*(4*r - 1)*(D1*fd + Dd*f))/(693*d*k1*k3**4) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*f*k1*k2*st**3*(33*D1*bd1*f*(k1**2*(2 - 4*C)*(r - 1) + k2**2*(6*b1*r - 3*b1 + f)) + 99*b1**2*k2**2*(2*D1*fd*r + Dd*f*(4*r - 1)) - 33*b1*(D1*fd*(f*k2**2 + k1**2*r*(8*C - 4)) + Dd*f*k1**2*(4*C - 2)*(4*r - 1)) + f*(D1*fd*(15*f*k2**2*(1 - 4*r) - k1**2*(44*C - 22)*(3*r - 1)) - Dd*f*(4*r - 1)*(15*f*k2**2 + k1**2*(44*C - 22))))/(1155*d*k3**4) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*f*k2*st**3*(-D1*bd1*f*(k1**2*(3 - 6*C)*(r - 1) + k2**2*(b1*(6*r - 3) + f*r)) - (b1*k2**2 + k1**2*(1 - 2*C))*(6*D1*b1*fd*r + D1*f*fd*(3*r - 1) + 3*Dd*b1*f*(4*r - 1) + Dd*f**2*(4*r - 1)))/(105*d*k1*k3**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*k1**3*k2*st*(3*b1**2*(2*D1*fd*r*(-7*K + 3*f) + Dd*f*(-14*K + 3*f)*(4*r - 1)) + b1*(3*D1*bd1*f*(-14*K + 3*f)*(2*r - 1) + D1*(18*K*f*fd*(1 - 2*r) + 5*f**2*fd*(3*r - 1) + 84*f*gd2*r + 84*fd*g2*r) + Dd*f*(4*r - 1)*(-18*K*f + 5*f**2 + 84*g2)) + f*(D1*bd1*(f*r*(-18*K + 5*f) + 84*g2*(r - 1)) + 36*D1*f*gd2*r + 36*D1*fd*g2*(2*r - 1) + 36*Dd*f*g2*(4*r - 1)))/(315*d*k3**4) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*k1*k2*st*(21*b1**3*(D1*fd*r + Dd*f*(4*r - 1)) + 3*b1**2*(7*D1*bd1*f*(3*r - 1) + D1*(14*K*fd*r - 3*f*fd) + 14*Dd*K*f*(4*r - 1)) + b1*(36*D1*K*f*fd*r - 18*D1*K*f*fd + 3*D1*bd1*f*(28*K*r - 14*K + 3*f) + 42*D1*bd2*f*r - 15*D1*f**2*fd*r + 5*D1*f**2*fd - 84*D1*f*gd2*r - 84*D1*fd*g2*r + 72*Dd*K*f**2*r - 18*Dd*K*f**2 - 20*Dd*f**3*r + 5*Dd*f**3 - 336*Dd*f*g2*r + 84*Dd*f*g2 + 42*b2*(D1*fd*r + Dd*f*(4*r - 1))) + f*(D1*bd1*f*r*(18*K - 5*f) - 84*D1*bd1*g2*(r - 1) + 18*D1*(f*r*(bd2 - 2*gd2) + fd*g2*(2 - 4*r)) + 36*Dd*f*g2*(1 - 4*r) + 6*b2*(7*D1*bd1*(r - 1) + 3*D1*fd*(2*r - 1) + 3*Dd*f*(4*r - 1))))/(315*d*k3**2)
        perm23 = 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**6*f*k1**2*k2**3*st*(330*C*D1*f*fd*r + 330*C*D1*f*fd*s - 220*C*D1*f*fd + 440*C*Dd*f**2*r + 440*C*Dd*f**2*s - 330*C*Dd*f**2 + 99*D1*bd1*f*(K - 1)*(r + s - 1) + 196*D1*f**2*fd*r + 196*D1*f**2*fd*s - 147*D1*f**2*fd - 330*D1*f*fd*r - 330*D1*f*fd*s + 220*D1*f*fd - 198*D1*f*gd2*r - 198*D1*f*gd2*s + 198*D1*f*gd2 - 396*D1*fd*g2*r - 396*D1*fd*g2*s + 198*D1*fd*g2 + 196*Dd*f**3*r + 196*Dd*f**3*s - 147*Dd*f**3 - 440*Dd*f**2*r - 440*Dd*f**2*s + 330*Dd*f**2 - 792*Dd*f*g2*r - 792*Dd*f*g2*s + 594*Dd*f*g2 + 99*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))/(693*d*k3**6) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**5*f*k1*k2**2*st*(-3960*C*D1*f*fd*k1**2*r - 3960*C*D1*f*fd*k1**2*s + 2640*C*D1*f*fd*k1**2 - 3300*C*D1*f*fd*k2**2*r - 3300*C*D1*f*fd*k2**2*s + 2200*C*D1*f*fd*k2**2 - 5280*C*Dd*f**2*k1**2*r - 5280*C*Dd*f**2*k1**2*s + 3960*C*Dd*f**2*k1**2 - 4400*C*Dd*f**2*k2**2*r - 4400*C*Dd*f**2*k2**2*s + 3300*C*Dd*f**2*k2**2 - 33*D1*bd1*f*(k1**2*(36*K - 36) - k2**2*(-30*K + 10*f + 15))*(r + s - 1) - 3360*D1*f**2*fd*k1**2*r - 3360*D1*f**2*fd*k1**2*s + 2520*D1*f**2*fd*k1**2 + 3960*D1*f*fd*k1**2*r + 3960*D1*f*fd*k1**2*s - 2640*D1*f*fd*k1**2 + 2475*D1*f*fd*k2**2*r + 2475*D1*f*fd*k2**2*s - 1650*D1*f*fd*k2**2 + 2376*D1*f*gd2*k1**2*r + 2376*D1*f*gd2*k1**2*s - 2376*D1*f*gd2*k1**2 + 1980*D1*f*gd2*k2**2*r + 1980*D1*f*gd2*k2**2*s - 1980*D1*f*gd2*k2**2 + 4752*D1*fd*g2*k1**2*r + 4752*D1*fd*g2*k1**2*s - 2376*D1*fd*g2*k1**2 + 3960*D1*fd*g2*k2**2*r + 3960*D1*fd*g2*k2**2*s - 1980*D1*fd*g2*k2**2 - 3360*Dd*f**3*k1**2*r - 3360*Dd*f**3*k1**2*s + 2520*Dd*f**3*k1**2 + 5280*Dd*f**2*k1**2*r + 5280*Dd*f**2*k1**2*s - 3960*Dd*f**2*k1**2 + 3300*Dd*f**2*k2**2*r + 3300*Dd*f**2*k2**2*s - 2475*Dd*f**2*k2**2 + 9504*Dd*f*g2*k1**2*r + 9504*Dd*f*g2*k1**2*s - 7128*Dd*f*g2*k1**2 + 7920*Dd*f*g2*k2**2*r + 7920*Dd*f*g2*k2**2*s - 5940*Dd*f*g2*k2**2 + 33*b1*(D1*fd*(k1**2*(36 - 36*K)*(2*r + 2*s - 1) + 5*k2**2*(f*(6*r + 6*s - 4) + (3 - 6*K)*(2*r + 2*s - 1))) + Dd*f*(k1**2*(36 - 36*K) + k2**2*(-30*K + 10*f + 15))*(4*r + 4*s - 3)))/(3465*d*k3**6) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**4*f*k1**2*k2**3*st**3*(132*C*D1*f*fd*r + 132*C*D1*f*fd*s - 88*C*D1*f*fd + 176*C*Dd*f**2*r + 176*C*Dd*f**2*s - 132*C*Dd*f**2 + 66*D1*bd1*f*(K - 1)*(r + s - 1) + 140*D1*f**2*fd*r + 140*D1*f**2*fd*s - 105*D1*f**2*fd - 132*D1*f*fd*r - 132*D1*f*fd*s + 88*D1*f*fd - 132*D1*f*gd2*r - 132*D1*f*gd2*s + 132*D1*f*gd2 - 264*D1*fd*g2*r - 264*D1*fd*g2*s + 132*D1*fd*g2 + 140*Dd*f**3*r + 140*Dd*f**3*s - 105*Dd*f**3 - 176*Dd*f**2*r - 176*Dd*f**2*s + 132*Dd*f**2 - 528*Dd*f*g2*r - 528*Dd*f*g2*s + 396*Dd*f*g2 + 66*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))/(231*d*k3**6) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**4*k2*st*(33*D1*bd1*f*(r + s - 1)*(25*f**2*k1**2*k2**2 - 3*f*(5*K*k2**4 + k1**4*(9*K - 9) + k1**2*k2**2*(6*C + 24*K - 18)) + k1**2*k2**2*(-42*K*b1 + 42*b1 + 42*g2)) - 693*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) + 33*b1*(D1*(25*f**2*fd*k1**2*k2**2*(3*r + 3*s - 2) - 3*f*fd*(2*r + 2*s - 1)*(5*K*k2**4 + k1**4*(9*K - 9) + k1**2*k2**2*(6*C + 24*K - 18)) + 42*f*gd2*k1**2*k2**2*(r + s - 1) + 42*fd*g2*k1**2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(25*f**2*k1**2*k2**2 - 3*f*(5*K*k2**4 + k1**4*(9*K - 9) + k1**2*k2**2*(6*C + 24*K - 18)) + 42*g2*k1**2*k2**2)) + f*(D1*(-1050*f**2*fd*k1**4*(4*r + 4*s - 3) - 55*f*fd*(3*r + 3*s - 2)*(k1**4*(18*C - 18) + k1**2*k2**2*(48*C - 36) + k2**4*(10*C - 5)) + 198*f*gd2*(9*k1**4 + 24*k1**2*k2**2 + 5*k2**4)*(r + s - 1) + 198*fd*g2*(9*k1**4 + 24*k1**2*k2**2 + 5*k2**4)*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(1050*f**2*k1**4 + 55*f*(k1**4*(18*C - 18) + k1**2*k2**2*(48*C - 36) + k2**4*(10*C - 5)) - 198*g2*(9*k1**4 + 24*k1**2*k2**2 + 5*k2**4))))/(3465*d*k3**6) - 8*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**3*f*k1*k2**2*st**3*(-396*C*D1*f*fd*k1**2*r - 396*C*D1*f*fd*k1**2*s + 264*C*D1*f*fd*k1**2 - 660*C*D1*f*fd*k2**2*r - 660*C*D1*f*fd*k2**2*s + 440*C*D1*f*fd*k2**2 - 528*C*Dd*f**2*k1**2*r - 528*C*Dd*f**2*k1**2*s + 396*C*Dd*f**2*k1**2 - 880*C*Dd*f**2*k2**2*r - 880*C*Dd*f**2*k2**2*s + 660*C*Dd*f**2*k2**2 - 11*D1*bd1*f*(k1**2*(18*K - 18) - k2**2*(-30*K + 10*f + 15))*(r + s - 1) - 800*D1*f**2*fd*k1**2*r - 800*D1*f**2*fd*k1**2*s + 600*D1*f**2*fd*k1**2 + 396*D1*f*fd*k1**2*r + 396*D1*f*fd*k1**2*s - 264*D1*f*fd*k1**2 + 495*D1*f*fd*k2**2*r + 495*D1*f*fd*k2**2*s - 330*D1*f*fd*k2**2 + 396*D1*f*gd2*k1**2*r + 396*D1*f*gd2*k1**2*s - 396*D1*f*gd2*k1**2 + 660*D1*f*gd2*k2**2*r + 660*D1*f*gd2*k2**2*s - 660*D1*f*gd2*k2**2 + 792*D1*fd*g2*k1**2*r + 792*D1*fd*g2*k1**2*s - 396*D1*fd*g2*k1**2 + 1320*D1*fd*g2*k2**2*r + 1320*D1*fd*g2*k2**2*s - 660*D1*fd*g2*k2**2 - 800*Dd*f**3*k1**2*r - 800*Dd*f**3*k1**2*s + 600*Dd*f**3*k1**2 + 528*Dd*f**2*k1**2*r + 528*Dd*f**2*k1**2*s - 396*Dd*f**2*k1**2 + 660*Dd*f**2*k2**2*r + 660*Dd*f**2*k2**2*s - 495*Dd*f**2*k2**2 + 1584*Dd*f*g2*k1**2*r + 1584*Dd*f*g2*k1**2*s - 1188*Dd*f*g2*k1**2 + 2640*Dd*f*g2*k2**2*r + 2640*Dd*f*g2*k2**2*s - 1980*Dd*f*g2*k2**2 + 11*b1*(D1*fd*(k1**2*(18 - 18*K)*(2*r + 2*s - 1) + 5*k2**2*(f*(6*r + 6*s - 4) + (3 - 6*K)*(2*r + 2*s - 1))) + Dd*f*(k1**2*(18 - 18*K) + k2**2*(-30*K + 10*f + 15))*(4*r + 4*s - 3)))/(1155*d*k3**6) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**3*k1*st*(11*D1*bd1*f*(r + s - 1)*(40*f**2*k1**2*k2**2 - 9*f*(k1**4*(2*K - 2) + k1**2*k2**2*(12*C + 18*K - 21) + k2**4*(12*C + 12*K - 8*b1 - 9)) - 126*k2**2*(2*b1*k1**2*(K - 1) + b1*k2**2*(2*K - 1) - 2*g2*(k1**2 + k2**2))) + 99*b1**2*k2**2*(D1*fd*(4*f*k2**2*(2*r + 2*s - 1) + (r + s)*(-7*k1**2*(2*K - 2) - 7*k2**2*(2*K - 1))) + Dd*f*(k1**2*(14 - 14*K) + k2**2*(-14*K + 4*f + 7))*(4*r + 4*s - 3)) + 11*b1*(D1*(40*f**2*fd*k1**2*k2**2*(3*r + 3*s - 2) - 9*f*fd*(2*r + 2*s - 1)*(k1**4*(2*K - 2) + k1**2*k2**2*(12*C + 18*K - 21) + k2**4*(12*C + 12*K - 9)) + 252*f*gd2*k2**2*(k1**2 + k2**2)*(r + s - 1) + 252*fd*g2*k2**2*(k1**2 + k2**2)*(r + s)) + Dd*f*(4*r + 4*s - 3)*(40*f**2*k1**2*k2**2 - 9*f*(k1**4*(2*K - 2) + k1**2*k2**2*(12*C + 18*K - 21) + k2**4*(12*C + 12*K - 9)) + 252*g2*k2**2*(k1**2 + k2**2))) + f*(D1*(-560*f**2*fd*k1**4*(4*r + 4*s - 3) - 55*f*fd*(3*r + 3*s - 2)*(k1**4*(4*C - 4) + k1**2*k2**2*(36*C - 27) + k2**4*(24*C - 12)) + 396*f*gd2*(k1**4 + 9*k1**2*k2**2 + 6*k2**4)*(r + s - 1) + 396*fd*g2*(k1**4 + 9*k1**2*k2**2 + 6*k2**4)*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(560*f**2*k1**4 + 55*f*(k1**4*(4*C - 4) + k1**2*k2**2*(36*C - 27) + k2**4*(24*C - 12)) - 396*g2*(k1**4 + 9*k1**2*k2**2 + 6*k2**4))))/(3465*d*k3**6) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**2*f*k1**2*k2**3*st**5*(66*C*D1*f*fd*r + 66*C*D1*f*fd*s - 44*C*D1*f*fd + 88*C*Dd*f**2*r + 88*C*Dd*f**2*s - 66*C*Dd*f**2 + 99*D1*bd1*f*(K - 1)*(r + s - 1) + 252*D1*f**2*fd*r + 252*D1*f**2*fd*s - 189*D1*f**2*fd - 66*D1*f*fd*r - 66*D1*f*fd*s + 44*D1*f*fd - 198*D1*f*gd2*r - 198*D1*f*gd2*s + 198*D1*f*gd2 - 396*D1*fd*g2*r - 396*D1*fd*g2*s + 198*D1*fd*g2 + 252*Dd*f**3*r + 252*Dd*f**3*s - 189*Dd*f**3 - 88*Dd*f**2*r - 88*Dd*f**2*s + 66*Dd*f**2 - 792*Dd*f*g2*r - 792*Dd*f*g2*s + 594*Dd*f*g2 + 99*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))/(693*d*k3**6) - 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**2*k2*st**3*(33*D1*bd1*f*(r + s - 1)*(10*f**2*k1**2*k2**2 - f*(10*K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(2*C + 24*K - 14)) + k1**2*k2**2*(-14*K*b1 + 14*b1 + 14*g2)) - 231*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) + 33*b1*(D1*(10*f**2*fd*k1**2*k2**2*(3*r + 3*s - 2) - f*fd*(2*r + 2*s - 1)*(10*K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(2*C + 24*K - 14)) + 14*f*gd2*k1**2*k2**2*(r + s - 1) + 14*fd*g2*k1**2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(10*f**2*k1**2*k2**2 - f*(10*K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(2*C + 24*K - 14)) + 14*g2*k1**2*k2**2)) - 2*f*(D1*(150*f**2*fd*k1**4*(4*r + 4*s - 3) + 11*f*(fd*(3*r + 3*s - 2)*(k1**4*(3*C - 3) + k1**2*k2**2*(24*C - 18) + k2**4*(10*C - 5)) - 3*gd2*(3*k1**4 + 24*k1**2*k2**2 + 10*k2**4)*(r + s - 1)) - 33*fd*g2*(3*k1**4 + 24*k1**2*k2**2 + 10*k2**4)*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(150*f**2*k1**4 + 11*f*(k1**4*(3*C - 3) + k1**2*k2**2*(24*C - 18) + k2**4*(10*C - 5)) - 33*g2*(3*k1**4 + 24*k1**2*k2**2 + 10*k2**4))))/(1155*d*k3**6) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**2*st*(D1*(693*b1*fd*k2**2*(r + s)*(b1*(K*k2**4 + k1**4*(K - 1) + k1**2*k2**2*(4*K - 2)) - 2*g2*(k1**4 + 4*k1**2*k2**2 + k2**4)) + 15*f**3*k1**4*(22*bd1*k2**2*(r + s - 1) + 7*fd*k1**2*(4*r + 4*s - 3)) + 11*f**2*k2**2*(9*bd1*(r + s - 1)*(k1**4*(6*C + 4*K - 8) - k1**2*k2**2*(-24*C - 9*K + 24*b1 + 18) + k2**4*(6*C - 3)) + k1**2*(5*fd*(k1**2*(8*C + 6*b1 - 6) + k2**2*(18*C - 9))*(3*r + 3*s - 2) - 18*gd2*(4*k1**2 + 9*k2**2)*(r + s - 1))) - 99*f*k2**2*(12*b1**2*fd*k1**2*k2**2*(2*r + 2*s - 1) + b1*(-14*bd1*(r + s - 1)*(K*k2**4 + k1**4*(K - 1) + k1**2*k2**2*(4*K - 2)) - fd*(2*r + 2*s - 1)*(k1**4*(6*C + 4*K - 8) + k1**2*k2**2*(24*C + 9*K - 18) + k2**4*(6*C - 3)) + 14*gd2*(k1**4 + 4*k1**2*k2**2 + k2**4)*(r + s - 1)) + 2*g2*(7*bd1*(k1**4 + 4*k1**2*k2**2 + k2**4)*(r + s - 1) + fd*k1**2*(4*k1**2 + 9*k2**2)*(2*r + 2*s - 1)))) + Dd*f*(4*r + 4*s - 3)*(693*b1*k2**2*(b1*(K*k2**4 + k1**4*(K - 1) + k1**2*k2**2*(4*K - 2)) - 2*g2*(k1**4 + 4*k1**2*k2**2 + k2**4)) + 105*f**3*k1**6 + 55*f**2*k1**2*k2**2*(k1**2*(8*C + 6*b1 - 6) + k2**2*(18*C - 9)) + 99*f*k2**2*(-12*b1**2*k1**2*k2**2 + b1*(k1**4*(6*C + 4*K - 8) + k1**2*k2**2*(24*C + 9*K - 18) + k2**4*(6*C - 3)) - 2*g2*k1**2*(4*k1**2 + 9*k2**2))))/(3465*d*k2*k3**6) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct*f*k1*k2**2*st**5*(D1*(6*f**2*(-11*bd1*k2**2*(r + s - 1) + 12*fd*k1**2*(4*r + 4*s - 3)) + 11*f*k2**2*(9*bd1*(2*K - 1)*(r + s - 1) - fd*(-4*C + 6*b1 + 3)*(3*r + 3*s - 2) - 36*gd2*(r + s - 1)) - 99*fd*k2**2*(2*r + 2*s - 1)*(-2*K*b1 + b1 + 4*g2)) + Dd*f*(4*r + 4*s - 3)*(72*f**2*k1**2 - f*k2**2*(-44*C + 66*b1 + 33) - k2**2*(-198*K*b1 + 99*b1 + 396*g2)))/(693*d*k3**6) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct*k1*st**3*(D1*(231*b1*fd*k2**4*(r + s)*(b1*(2*K - 1) - 4*g2) + 8*f**3*k1**2*(-11*bd1*k2**2*(r + s - 1) + 10*fd*k1**2*(4*r + 4*s - 3)) - 11*f**2*k2**2*(-3*bd1*(k1**2*(6*K - 3) + k2**2*(4*C + 12*K - 8*b1 - 3))*(r + s - 1) + fd*(k1**2*(-12*C + 8*b1 + 9) + k2**2*(12 - 24*C))*(3*r + 3*s - 2) + 36*gd2*(k1**2 + 2*k2**2)*(r + s - 1)) - 33*f*k2**2*(4*b1**2*fd*k2**2*(2*r + 2*s - 1) - b1*fd*(k1**2*(6*K - 3) + k2**2*(4*C + 12*K - 3))*(2*r + 2*s - 1) + 14*b1*k2**2*(r + s - 1)*(-2*K*bd1 + bd1 + 2*gd2) + 28*bd1*g2*k2**2*(r + s - 1) + 12*fd*g2*(k1**2 + 2*k2**2)*(2*r + 2*s - 1))) + Dd*f*(4*r + 4*s - 3)*(231*b1*k2**4*(b1*(2*K - 1) - 4*g2) + 80*f**3*k1**4 - 11*f**2*(k1**2*k2**2*(-12*C + 8*b1 + 9) + k2**4*(12 - 24*C)) - 33*f*k2**2*(4*b1**2*k2**2 + b1*k1**2*(3 - 6*K) + b1*k2**2*(-4*C - 12*K + 3) + 12*g2*(k1**2 + 2*k2**2))))/(1155*d*k3**6) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct*k1*st*(3*D1*bd1*f*(r + s - 1)*(10*f**2*k1**4 + 3*f*k2**2*(k1**2*(12*C + 2*K - 24*b1 - 9) + k2**2*(12*C - 6)) + 42*k2**2*(2*K*b1*k2**2 + b1*k1**2*(2*K - 1) - 2*g2*(k1**2 + k2**2))) + 9*b1**2*k2**2*(D1*fd*(-12*f*k1**2*(2*r + 2*s - 1) + (r + s)*(14*K*k2**2 + 7*k1**2*(2*K - 1))) - Dd*f*(-14*K*k2**2 + k1**2*(-14*K + 12*f + 7))*(4*r + 4*s - 3)) + 3*b1*(D1*(10*f**2*fd*k1**4*(3*r + 3*s - 2) + 3*f*k2**2*(fd*(k1**2*(12*C + 2*K - 9) + k2**2*(12*C - 6))*(2*r + 2*s - 1) - 28*gd2*(k1**2 + k2**2)*(r + s - 1)) - 84*fd*g2*k2**2*(k1**2 + k2**2)*(r + s)) + Dd*f*(4*r + 4*s - 3)*(10*f**2*k1**4 + 3*f*(k1**2*k2**2*(12*C + 2*K - 9) + k2**4*(12*C - 6)) - 84*g2*k2**2*(k1**2 + k2**2))) + 2*f*k1**2*k2**2*(D1*(f*fd*(10*C - 5)*(3*r + 3*s - 2) - 18*f*gd2*(r + s - 1) - 18*fd*g2*(2*r + 2*s - 1)) + Dd*f*(f*(10*C - 5) - 18*g2)*(4*r + 4*s - 3)))/(315*d*k3**6) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*f**3*k1**2*k2**3*st**7*(D1*fd + Dd*f)*(4*r + 4*s - 3)/(99*d*k3**6) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*f*k2*st**5*(D1*(3*f**2*k1**2*(-11*bd1*k2**2*(r + s - 1) + 6*fd*k1**2*(4*r + 4*s - 3)) + 11*f*k2**2*(-3*b1*fd*k1**2*(3*r + 3*s - 2) + k2**2*(fd*(2*C - 1)*(3*r + 3*s - 2) + (9*K*bd1 - 18*gd2)*(r + s - 1))) - 99*fd*k2**4*(-K*b1 + 2*g2)*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(18*f**2*k1**4 - 11*f*(3*b1*k1**2*k2**2 + k2**4*(1 - 2*C)) + k2**4*(99*K*b1 - 198*g2)))/(693*d*k3**6) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*k1**2*st*(D1*bd1*f*(r + s - 1)*(5*f**2*k1**4 - 9*f*(8*b1*k1**2*k2**2 + k2**4*(3 - 6*C)) - k2**4*(-126*K*b1 + 126*g2)) + b1*(D1*(5*f**2*fd*k1**4*(3*r + 3*s - 2) - 9*f*k2**2*(4*b1*fd*k1**2*(2*r + 2*s - 1) + k2**2*(-fd*(6*C - 3)*(2*r + 2*s - 1) + 14*gd2*(r + s - 1))) - 63*fd*k2**4*(r + s)*(-K*b1 + 2*g2)) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k1**4 - 9*f*(4*b1*k1**2*k2**2 + k2**4*(3 - 6*C)) + k2**4*(63*K*b1 - 126*g2))))/(315*d*k2*k3**6) + 4*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*st**3*(D1*(231*b1*fd*k2**6*(r + s)*(K*b1 - 2*g2) + f**3*k1**4*(22*bd1*k2**2*(r + s - 1) + 5*fd*k1**2*(4*r + 4*s - 3)) + 11*f**2*k2**2*(2*b1*k1**2*(-12*bd1*k2**2*(r + s - 1) + fd*k1**2*(3*r + 3*s - 2)) + 3*k2**2*(fd*k1**2*(2*C - 1)*(3*r + 3*s - 2) - (r + s - 1)*(-3*K*bd1*k1**2 + bd1*k2**2*(1 - 2*C) + 6*gd2*k1**2))) + 33*f*k2**4*(-4*b1**2*fd*k1**2*(2*r + 2*s - 1) + b1*fd*(3*K*k1**2 + k2**2*(2*C - 1))*(2*r + 2*s - 1) - 14*b1*k2**2*(-K*bd1 + gd2)*(r + s - 1) - 14*bd1*g2*k2**2*(r + s - 1) - 6*fd*g2*k1**2*(2*r + 2*s - 1))) + Dd*f*(4*r + 4*s - 3)*(231*b1*k2**6*(K*b1 - 2*g2) + 5*f**3*k1**6 + 11*f**2*k1**2*k2**2*(2*b1*k1**2 + k2**2*(6*C - 3)) - 33*f*k2**4*(-3*K*b1*k1**2 + 4*b1**2*k1**2 + b1*k2**2*(1 - 2*C) + 6*g2*k1**2)))/(1155*d*k2*k3**6) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*b1*st*(-D1*bd1*k2**2*(5*b2 + f*(2*C - 1) - 10*g2)*(2*r + 2*s - 1) + b1**2*(D1*fd*k1**2*(r + s - 1) + Dd*(-5*K*k2**2 + f*k1**2)*(4*r + 4*s - 3)) + b1*(D1*bd1*(-5*K*k2**2 + f*k1**2)*(3*r + 3*s - 2) + k2**2*(-2*C*D1*fd*r - 2*C*D1*fd*s + 2*C*D1*fd - 8*C*Dd*f*r - 8*C*Dd*f*s + 6*C*Dd*f - 5*D1*bd2*(r + s - 1) + D1*fd*r + D1*fd*s - D1*fd + 10*D1*gd2*r + 10*D1*gd2*s - 10*D1*gd2 - 5*Dd*b2*(4*r + 4*s - 3) + 4*Dd*f*r + 4*Dd*f*s - 3*Dd*f + 40*Dd*g2*r + 40*Dd*g2*s - 30*Dd*g2)))/(15*d*k2*k3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**6*f*k1**2*k2**3*st*(330*C*D1*f*fd*r + 330*C*D1*f*fd*s - 220*C*D1*f*fd + 440*C*Dd*f**2*r + 440*C*Dd*f**2*s - 330*C*Dd*f**2 + 99*D1*bd1*f*(K - 1)*(r + s - 1) + 196*D1*f**2*fd*r + 196*D1*f**2*fd*s - 147*D1*f**2*fd - 330*D1*f*fd*r - 330*D1*f*fd*s + 220*D1*f*fd - 198*D1*f*gd2*r - 198*D1*f*gd2*s + 198*D1*f*gd2 - 396*D1*fd*g2*r - 396*D1*fd*g2*s + 198*D1*fd*g2 + 196*Dd*f**3*r + 196*Dd*f**3*s - 147*Dd*f**3 - 440*Dd*f**2*r - 440*Dd*f**2*s + 330*Dd*f**2 - 792*Dd*f*g2*r - 792*Dd*f*g2*s + 594*Dd*f*g2 + 99*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))/(693*d*k3**5) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**5*f*k1*k2**2*st*(3*D1*bd1*f*(2*f + 3)*(r + s - 1) + 3*b1*(D1*fd*(f*(6*r + 6*s - 4) + 6*r + 6*s - 3) + Dd*f*(2*f + 3)*(4*r + 4*s - 3)) + 5*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(63*d*k3**3) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**5*f*k1*k2**2*st*(-3960*C*D1*f*fd*k1**2*r - 3960*C*D1*f*fd*k1**2*s + 2640*C*D1*f*fd*k1**2 - 3300*C*D1*f*fd*k2**2*r - 3300*C*D1*f*fd*k2**2*s + 2200*C*D1*f*fd*k2**2 - 5280*C*Dd*f**2*k1**2*r - 5280*C*Dd*f**2*k1**2*s + 3960*C*Dd*f**2*k1**2 - 4400*C*Dd*f**2*k2**2*r - 4400*C*Dd*f**2*k2**2*s + 3300*C*Dd*f**2*k2**2 - 33*D1*bd1*f*(k1**2*(36*K - 36) - k2**2*(-30*K + 10*f + 15))*(r + s - 1) - 3360*D1*f**2*fd*k1**2*r - 3360*D1*f**2*fd*k1**2*s + 2520*D1*f**2*fd*k1**2 + 3960*D1*f*fd*k1**2*r + 3960*D1*f*fd*k1**2*s - 2640*D1*f*fd*k1**2 + 2475*D1*f*fd*k2**2*r + 2475*D1*f*fd*k2**2*s - 1650*D1*f*fd*k2**2 + 2376*D1*f*gd2*k1**2*r + 2376*D1*f*gd2*k1**2*s - 2376*D1*f*gd2*k1**2 + 1980*D1*f*gd2*k2**2*r + 1980*D1*f*gd2*k2**2*s - 1980*D1*f*gd2*k2**2 + 4752*D1*fd*g2*k1**2*r + 4752*D1*fd*g2*k1**2*s - 2376*D1*fd*g2*k1**2 + 3960*D1*fd*g2*k2**2*r + 3960*D1*fd*g2*k2**2*s - 1980*D1*fd*g2*k2**2 - 3360*Dd*f**3*k1**2*r - 3360*Dd*f**3*k1**2*s + 2520*Dd*f**3*k1**2 + 5280*Dd*f**2*k1**2*r + 5280*Dd*f**2*k1**2*s - 3960*Dd*f**2*k1**2 + 3300*Dd*f**2*k2**2*r + 3300*Dd*f**2*k2**2*s - 2475*Dd*f**2*k2**2 + 9504*Dd*f*g2*k1**2*r + 9504*Dd*f*g2*k1**2*s - 7128*Dd*f*g2*k1**2 + 7920*Dd*f*g2*k2**2*r + 7920*Dd*f*g2*k2**2*s - 5940*Dd*f*g2*k2**2 + 33*b1*(D1*fd*(k1**2*(36 - 36*K)*(2*r + 2*s - 1) + 5*k2**2*(f*(6*r + 6*s - 4) + (3 - 6*K)*(2*r + 2*s - 1))) + Dd*f*(k1**2*(36 - 36*K) + k2**2*(-30*K + 10*f + 15))*(4*r + 4*s - 3)))/(3465*d*k3**5) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**4*f*k1**2*k2**3*st**3*(132*C*D1*f*fd*r + 132*C*D1*f*fd*s - 88*C*D1*f*fd + 176*C*Dd*f**2*r + 176*C*Dd*f**2*s - 132*C*Dd*f**2 + 66*D1*bd1*f*(K - 1)*(r + s - 1) + 140*D1*f**2*fd*r + 140*D1*f**2*fd*s - 105*D1*f**2*fd - 132*D1*f*fd*r - 132*D1*f*fd*s + 88*D1*f*fd - 132*D1*f*gd2*r - 132*D1*f*gd2*s + 132*D1*f*gd2 - 264*D1*fd*g2*r - 264*D1*fd*g2*s + 132*D1*fd*g2 + 140*Dd*f**3*r + 140*Dd*f**3*s - 105*Dd*f**3 - 176*Dd*f**2*r - 176*Dd*f**2*s + 132*Dd*f**2 - 528*Dd*f*g2*r - 528*Dd*f*g2*s + 396*Dd*f*g2 + 66*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))/(231*d*k3**5) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**4*k2*st*(63*b1**2*k1**2*(K - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*(63*D1*bd1*f*k1**2*(K - 1)*(2*r + 2*s - 1) + 3*D1*(36*C*f*fd*k1**2*(r + s - 1) + 25*f**2*fd*k1**2*(4*r + 4*s - 3) + f*(-15*K*fd*k2**2*(2*r + 2*s - 1) + 36*fd*k1**2*(r + s) - 42*gd2*k1**2*(r + s - 1)) - 42*fd*g2*k1**2*(r + s - 1)) + Dd*f*(4*r + 4*s - 3)*(100*f**2*k1**2 + 9*f*(-5*K*k2**2 + k1**2*(6*C + 6)) - 126*g2*k1**2)) + f*(D1*bd1*(25*f**2*k1**2*(4*r + 4*s - 3) + 9*f*(-5*K*k2**2*(r + s - 1) + 6*k1**2*(C*r + C*s + r + s - 2)) - 126*g2*k1**2*(r + s)) + 5*D1*(f*fd*(12*k1**2 + k2**2*(5 - 10*C))*(3*r + 3*s - 2) - 9*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) - 9*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + 5*Dd*f*(4*r + 4*s - 3)*(12*f*k1**2 + f*k2**2*(5 - 10*C) - k2**2*(9*b2 - 18*g2))))/(315*d*k3**3) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**4*k2*st*(33*D1*bd1*f*(r + s - 1)*(25*f**2*k1**2*k2**2 - 3*f*(5*K*k2**4 + k1**4*(9*K - 9) + k1**2*k2**2*(6*C + 24*K - 18)) + k1**2*k2**2*(-42*K*b1 + 42*b1 + 42*g2)) - 693*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) + 33*b1*(D1*(25*f**2*fd*k1**2*k2**2*(3*r + 3*s - 2) - 3*f*fd*(2*r + 2*s - 1)*(5*K*k2**4 + k1**4*(9*K - 9) + k1**2*k2**2*(6*C + 24*K - 18)) + 42*f*gd2*k1**2*k2**2*(r + s - 1) + 42*fd*g2*k1**2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(25*f**2*k1**2*k2**2 - 3*f*(5*K*k2**4 + k1**4*(9*K - 9) + k1**2*k2**2*(6*C + 24*K - 18)) + 42*g2*k1**2*k2**2)) + f*(D1*(-1050*f**2*fd*k1**4*(4*r + 4*s - 3) - 55*f*fd*(3*r + 3*s - 2)*(k1**4*(18*C - 18) + k1**2*k2**2*(48*C - 36) + k2**4*(10*C - 5)) + 198*f*gd2*(9*k1**4 + 24*k1**2*k2**2 + 5*k2**4)*(r + s - 1) + 198*fd*g2*(9*k1**4 + 24*k1**2*k2**2 + 5*k2**4)*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(1050*f**2*k1**4 + 55*f*(k1**4*(18*C - 18) + k1**2*k2**2*(48*C - 36) + k2**4*(10*C - 5)) - 198*g2*(9*k1**4 + 24*k1**2*k2**2 + 5*k2**4))))/(3465*d*k3**5) - 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**3*f*k1*k2**2*st**3*(D1*b1*fd*(f*(6*r + 6*s - 4) + 6*r + 6*s - 3) + D1*bd1*f*(2*f + 3)*(r + s - 1) + D1*f*fd*(3*r + 3*s - 2) + Dd*b1*f*(2*f + 3)*(4*r + 4*s - 3) + Dd*f**2*(4*r + 4*s - 3))/(21*d*k3**3) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**3*f*k1*k2**2*st**3*(-396*C*D1*f*fd*k1**2*r - 396*C*D1*f*fd*k1**2*s + 264*C*D1*f*fd*k1**2 - 660*C*D1*f*fd*k2**2*r - 660*C*D1*f*fd*k2**2*s + 440*C*D1*f*fd*k2**2 - 528*C*Dd*f**2*k1**2*r - 528*C*Dd*f**2*k1**2*s + 396*C*Dd*f**2*k1**2 - 880*C*Dd*f**2*k2**2*r - 880*C*Dd*f**2*k2**2*s + 660*C*Dd*f**2*k2**2 - 11*D1*bd1*f*(k1**2*(18*K - 18) - k2**2*(-30*K + 10*f + 15))*(r + s - 1) - 800*D1*f**2*fd*k1**2*r - 800*D1*f**2*fd*k1**2*s + 600*D1*f**2*fd*k1**2 + 396*D1*f*fd*k1**2*r + 396*D1*f*fd*k1**2*s - 264*D1*f*fd*k1**2 + 495*D1*f*fd*k2**2*r + 495*D1*f*fd*k2**2*s - 330*D1*f*fd*k2**2 + 396*D1*f*gd2*k1**2*r + 396*D1*f*gd2*k1**2*s - 396*D1*f*gd2*k1**2 + 660*D1*f*gd2*k2**2*r + 660*D1*f*gd2*k2**2*s - 660*D1*f*gd2*k2**2 + 792*D1*fd*g2*k1**2*r + 792*D1*fd*g2*k1**2*s - 396*D1*fd*g2*k1**2 + 1320*D1*fd*g2*k2**2*r + 1320*D1*fd*g2*k2**2*s - 660*D1*fd*g2*k2**2 - 800*Dd*f**3*k1**2*r - 800*Dd*f**3*k1**2*s + 600*Dd*f**3*k1**2 + 528*Dd*f**2*k1**2*r + 528*Dd*f**2*k1**2*s - 396*Dd*f**2*k1**2 + 660*Dd*f**2*k2**2*r + 660*Dd*f**2*k2**2*s - 495*Dd*f**2*k2**2 + 1584*Dd*f*g2*k1**2*r + 1584*Dd*f*g2*k1**2*s - 1188*Dd*f*g2*k1**2 + 2640*Dd*f*g2*k2**2*r + 2640*Dd*f*g2*k2**2*s - 1980*Dd*f*g2*k2**2 + 11*b1*(D1*fd*(k1**2*(18 - 18*K)*(2*r + 2*s - 1) + 5*k2**2*(f*(6*r + 6*s - 4) + (3 - 6*K)*(2*r + 2*s - 1))) + Dd*f*(k1**2*(18 - 18*K) + k2**2*(-30*K + 10*f + 15))*(4*r + 4*s - 3)))/(1155*d*k3**5) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**3*k1*st*(3*D1*bd1*f**2*(r + s) + b1**2*(D1*fd*(8*f + 7)*(r + s - 1) + Dd*f*(4*f + 7)*(4*r + 4*s - 3)) + b1*f*(D1*bd1*(4*f + 7)*(2*r + 2*s - 1) + 6*D1*fd*(r + s - 1) + 3*Dd*f*(4*r + 4*s - 3)))/(35*d*k3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**3*k1*st*(3*b1**2*(D1*fd*(k1**2*(14*K - 14)*(r + s - 1) + 3*k2**2*(14*K*(r + s - 1) + 4*f + 7)) + 14*Dd*f*(3*K*k2**2 + k1**2*(K - 1))*(4*r + 4*s - 3)) + b1*(-3*D1*bd1*f*(-k1**2*(14*K - 14)*(2*r + 2*s - 1) + 3*k2**2*(7*K*(-4*r - 4*s + 2) + 4*f + 7)) + 3*D1*(20*f**2*fd*k1**2*(5*r + 5*s - 4) + f*(3*fd*k1**2*(8*C*(r + s - 1) + 10*r + 10*s - 1) + 9*fd*k2**2*(8*C*(r + s - 1) + K*(-8*r - 8*s + 4) - 4*r - 4*s + 5) - 28*gd2*(k1**2 + 3*k2**2)*(r + s - 1)) - 28*fd*g2*(k1**2 + 3*k2**2)*(r + s - 1)) + Dd*f*(4*r + 4*s - 3)*(100*f**2*k1**2 + 9*f*(k1**2*(4*C + 5) + k2**2*(12*C - 12*K - 6)) - 84*g2*(k1**2 + 3*k2**2))) + f*(D1*bd1*(20*f**2*k1**2*(5*r + 5*s - 3) + 9*f*(k1**2*(4*C*s + r*(4*C + 5) + 5*s - 9) - 3*k2**2*(-4*C*r - 4*C*s + 4*K*(r + s - 1) + 2*r + 2*s + 1)) - 84*g2*(k1**2 + 3*k2**2)*(r + s)) + 3*D1*(5*f*fd*(3*k1**2 + k2**2*(4 - 8*C))*(3*r + 3*s - 2) - 36*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) - 36*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + 3*Dd*f*(5*f*(3*k1**2 + k2**2*(4 - 8*C)) + k2**2*(-36*b2 + 72*g2))*(4*r + 4*s - 3)))/(315*d*k3**3) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**3*k1*st*(11*D1*bd1*f*(r + s - 1)*(40*f**2*k1**2*k2**2 - 9*f*(k1**4*(2*K - 2) + k1**2*k2**2*(12*C + 18*K - 21) + k2**4*(12*C + 12*K - 8*b1 - 9)) - 126*k2**2*(2*b1*k1**2*(K - 1) + b1*k2**2*(2*K - 1) - 2*g2*(k1**2 + k2**2))) + 99*b1**2*k2**2*(D1*fd*(4*f*k2**2*(2*r + 2*s - 1) + (r + s)*(-7*k1**2*(2*K - 2) - 7*k2**2*(2*K - 1))) + Dd*f*(k1**2*(14 - 14*K) + k2**2*(-14*K + 4*f + 7))*(4*r + 4*s - 3)) + 11*b1*(D1*(40*f**2*fd*k1**2*k2**2*(3*r + 3*s - 2) - 9*f*fd*(2*r + 2*s - 1)*(k1**4*(2*K - 2) + k1**2*k2**2*(12*C + 18*K - 21) + k2**4*(12*C + 12*K - 9)) + 252*f*gd2*k2**2*(k1**2 + k2**2)*(r + s - 1) + 252*fd*g2*k2**2*(k1**2 + k2**2)*(r + s)) + Dd*f*(4*r + 4*s - 3)*(40*f**2*k1**2*k2**2 - 9*f*(k1**4*(2*K - 2) + k1**2*k2**2*(12*C + 18*K - 21) + k2**4*(12*C + 12*K - 9)) + 252*g2*k2**2*(k1**2 + k2**2))) + f*(D1*(-560*f**2*fd*k1**4*(4*r + 4*s - 3) - 55*f*fd*(3*r + 3*s - 2)*(k1**4*(4*C - 4) + k1**2*k2**2*(36*C - 27) + k2**4*(24*C - 12)) + 396*f*gd2*(k1**4 + 9*k1**2*k2**2 + 6*k2**4)*(r + s - 1) + 396*fd*g2*(k1**4 + 9*k1**2*k2**2 + 6*k2**4)*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(560*f**2*k1**4 + 55*f*(k1**4*(4*C - 4) + k1**2*k2**2*(36*C - 27) + k2**4*(24*C - 12)) - 396*g2*(k1**4 + 9*k1**2*k2**2 + 6*k2**4))))/(3465*d*k3**5) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**2*f*k1**2*k2**3*st**5*(66*C*D1*f*fd*r + 66*C*D1*f*fd*s - 44*C*D1*f*fd + 88*C*Dd*f**2*r + 88*C*Dd*f**2*s - 66*C*Dd*f**2 + 99*D1*bd1*f*(K - 1)*(r + s - 1) + 252*D1*f**2*fd*r + 252*D1*f**2*fd*s - 189*D1*f**2*fd - 66*D1*f*fd*r - 66*D1*f*fd*s + 44*D1*f*fd - 198*D1*f*gd2*r - 198*D1*f*gd2*s + 198*D1*f*gd2 - 396*D1*fd*g2*r - 396*D1*fd*g2*s + 198*D1*fd*g2 + 252*Dd*f**3*r + 252*Dd*f**3*s - 189*Dd*f**3 - 88*Dd*f**2*r - 88*Dd*f**2*s + 66*Dd*f**2 - 792*Dd*f*g2*r - 792*Dd*f*g2*s + 594*Dd*f*g2 + 99*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))/(693*d*k3**5) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**2*k2*st**3*(21*b1**2*k1**2*(K - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*(21*D1*bd1*f*k1**2*(K - 1)*(2*r + 2*s - 1) + 6*D1*(5*f**2*fd*k1**2*(4*r + 4*s - 3) + f*(-5*K*fd*k2**2*(2*r + 2*s - 1) + 2*fd*k1**2*(C*(r + s - 1) + 5*r + 5*s - 2) - 7*gd2*k1**2*(r + s - 1)) - 7*fd*g2*k1**2*(r + s - 1)) + 2*Dd*f*(4*r + 4*s - 3)*(20*f**2*k1**2 + 3*f*(-5*K*k2**2 + k1**2*(C + 5)) - 21*g2*k1**2)) + 2*f*(D1*bd1*(5*f**2*k1**2*(4*r + 4*s - 3) + 3*f*(-5*K*k2**2*(r + s - 1) + k1**2*(r*(C + 5) + s*(C + 5) - 6)) - 21*g2*k1**2*(r + s)) + D1*(f*fd*(6*k1**2 + k2**2*(5 - 10*C))*(3*r + 3*s - 2) - 15*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) - 15*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(6*f*k1**2 + f*k2**2*(5 - 10*C) - k2**2*(15*b2 - 30*g2))))/(105*d*k3**3) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**2*k2*st**3*(33*D1*bd1*f*(r + s - 1)*(10*f**2*k1**2*k2**2 - f*(10*K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(2*C + 24*K - 14)) + k1**2*k2**2*(-14*K*b1 + 14*b1 + 14*g2)) - 231*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) + 33*b1*(D1*(10*f**2*fd*k1**2*k2**2*(3*r + 3*s - 2) - f*fd*(2*r + 2*s - 1)*(10*K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(2*C + 24*K - 14)) + 14*f*gd2*k1**2*k2**2*(r + s - 1) + 14*fd*g2*k1**2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(10*f**2*k1**2*k2**2 - f*(10*K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(2*C + 24*K - 14)) + 14*g2*k1**2*k2**2)) - 2*f*(D1*(150*f**2*fd*k1**4*(4*r + 4*s - 3) + 11*f*(fd*(3*r + 3*s - 2)*(k1**4*(3*C - 3) + k1**2*k2**2*(24*C - 18) + k2**4*(10*C - 5)) - 3*gd2*(3*k1**4 + 24*k1**2*k2**2 + 10*k2**4)*(r + s - 1)) - 33*fd*g2*(3*k1**4 + 24*k1**2*k2**2 + 10*k2**4)*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(150*f**2*k1**4 + 11*f*(k1**4*(3*C - 3) + k1**2*k2**2*(24*C - 18) + k2**4*(10*C - 5)) - 33*g2*(3*k1**4 + 24*k1**2*k2**2 + 10*k2**4))))/(1155*d*k3**5) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**2*st*(3*D1*bd1*f*(r + s)*(2*f*k1**2 + f*k2**2*(3 - 6*C) - k2**2*(7*b2 - 14*g2)) + b1**2*(D1*fd*(-21*K*k2**2 + k1**2*(18*f + 14))*(r + s - 1) + Dd*f*(-21*K*k2**2 + k1**2*(9*f + 14))*(4*r + 4*s - 3)) + b1*(D1*bd1*f*(-21*K*k2**2 + k1**2*(9*f + 14))*(2*r + 2*s - 1) + 3*D1*(f*(4*fd*k1**2 + fd*k2**2*(6 - 12*C) - k2**2*(7*bd2 - 14*gd2)) - 7*fd*k2**2*(b2 - 2*g2))*(r + s - 1) + 3*Dd*f*(4*r + 4*s - 3)*(2*f*k1**2 + f*k2**2*(3 - 6*C) - k2**2*(7*b2 - 14*g2))))/(105*d*k2*k3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**2*st*(3*D1*bd1*(35*b1*k1**2*k2**2*(b1*(K - 1)*(3*r + 3*s - 2) - 2*g2*(2*r + 2*s - 1)) + 5*f**3*k1**4*(2*r + 2*s - 1) + 3*f**2*(2*k1**4*(r + s - 1) + k1**2*k2**2*(8*C*r + 8*C*s - 9*K*(r + s - 1) + 3*b1*(4*r + 4*s - 5) - 6) + k2**4*(6*C - 3)) + 7*f*k2**2*(3*K*b1*k2**2 + b1*k1**2*(C*(4*r + 4*s - 2) + 4*K*(2*r + 2*s - 1) + 4*r + 4*s - 8) - 3*b2*k2**2*(r + s - 1) - 8*g2*k1**2*(r + s) - 6*g2*k2**2)) + 105*Dd*b1**3*k1**2*k2**2*(K - 1)*(4*r + 4*s - 3) + 3*b1**2*k2**2*(D1*(-21*K*fd*k2**2 + fd*k1**2*(14*C*(r + s - 1) + 28*K*(r + s - 1) + 9*f*(4*r + 4*s - 1) + 14*r + 14*s + 28) - 70*gd2*k1**2*(r + s - 1)) + 2*Dd*k1**2*(9*f**2 + 7*f*(C + 2*K + 1) - 35*g2)*(4*r + 4*s - 3)) + 3*b1*(D1*(5*f**2*fd*k1**4*(6*r + 6*s - 5) + f*(3*fd*(k1**4*(4*r + 4*s - 2) + k1**2*k2**2*(16*C*(r + s - 1) - 9*K*(2*r + 2*s - 1) + 6) + k2**4*(3 - 6*C)) - 7*k2**2*(3*bd2*k2**2 + 8*gd2*k1**2)*(r + s - 1)) - 7*fd*k2**2*(3*b2*k2**2*(r + s) + 8*g2*k1**2*(r + s - 1) - 6*g2*k2**2)) + Dd*f*(4*r + 4*s - 3)*(-21*b2*k2**4 + 10*f**2*k1**4 + 6*f*k1**4 + 3*f*k1**2*k2**2*(8*C - 9*K) - 56*g2*k1**2*k2**2)) + f*k1**2*(D1*(5*f*fd*(2*k1**2 + k2**2*(9 - 18*C))*(3*r + 3*s - 2) - 81*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) - 81*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + Dd*f*(5*f*(2*k1**2 + k2**2*(9 - 18*C)) + k2**2*(-81*b2 + 162*g2))*(4*r + 4*s - 3)))/(315*d*k2*k3**3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**2*st*(D1*(693*b1*fd*k2**2*(r + s)*(b1*(K*k2**4 + k1**4*(K - 1) + k1**2*k2**2*(4*K - 2)) - 2*g2*(k1**4 + 4*k1**2*k2**2 + k2**4)) + 15*f**3*k1**4*(22*bd1*k2**2*(r + s - 1) + 7*fd*k1**2*(4*r + 4*s - 3)) + 11*f**2*k2**2*(9*bd1*(r + s - 1)*(k1**4*(6*C + 4*K - 8) - k1**2*k2**2*(-24*C - 9*K + 24*b1 + 18) + k2**4*(6*C - 3)) + k1**2*(5*fd*(k1**2*(8*C + 6*b1 - 6) + k2**2*(18*C - 9))*(3*r + 3*s - 2) - 18*gd2*(4*k1**2 + 9*k2**2)*(r + s - 1))) - 99*f*k2**2*(12*b1**2*fd*k1**2*k2**2*(2*r + 2*s - 1) + b1*(-14*bd1*(r + s - 1)*(K*k2**4 + k1**4*(K - 1) + k1**2*k2**2*(4*K - 2)) - fd*(2*r + 2*s - 1)*(k1**4*(6*C + 4*K - 8) + k1**2*k2**2*(24*C + 9*K - 18) + k2**4*(6*C - 3)) + 14*gd2*(k1**4 + 4*k1**2*k2**2 + k2**4)*(r + s - 1)) + 2*g2*(7*bd1*(k1**4 + 4*k1**2*k2**2 + k2**4)*(r + s - 1) + fd*k1**2*(4*k1**2 + 9*k2**2)*(2*r + 2*s - 1)))) + Dd*f*(4*r + 4*s - 3)*(693*b1*k2**2*(b1*(K*k2**4 + k1**4*(K - 1) + k1**2*k2**2*(4*K - 2)) - 2*g2*(k1**4 + 4*k1**2*k2**2 + k2**4)) + 105*f**3*k1**6 + 55*f**2*k1**2*k2**2*(k1**2*(8*C + 6*b1 - 6) + k2**2*(18*C - 9)) + 99*f*k2**2*(-12*b1**2*k1**2*k2**2 + b1*(k1**4*(6*C + 4*K - 8) + k1**2*k2**2*(24*C + 9*K - 18) + k2**4*(6*C - 3)) - 2*g2*k1**2*(4*k1**2 + 9*k2**2))))/(3465*d*k2*k3**5) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct*f*k1*k2**2*st**5*(3*D1*bd1*f*(2*f + 3)*(r + s - 1) + 3*b1*(D1*fd*(f*(6*r + 6*s - 4) + 6*r + 6*s - 3) + Dd*f*(2*f + 3)*(4*r + 4*s - 3)) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(63*d*k3**3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct*f*k1*k2**2*st**5*(D1*(6*f**2*(-11*bd1*k2**2*(r + s - 1) + 12*fd*k1**2*(4*r + 4*s - 3)) + 11*f*k2**2*(9*bd1*(2*K - 1)*(r + s - 1) - fd*(-4*C + 6*b1 + 3)*(3*r + 3*s - 2) - 36*gd2*(r + s - 1)) - 99*fd*k2**2*(2*r + 2*s - 1)*(-2*K*b1 + b1 + 4*g2)) + Dd*f*(4*r + 4*s - 3)*(72*f**2*k1**2 - f*k2**2*(-44*C + 66*b1 + 33) - k2**2*(-198*K*b1 + 99*b1 + 396*g2)))/(693*d*k3**5) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct*k1*st**3*(D1*bd1*f**2*(r + s) + b1**2*(D1*fd*(8*f + 7)*(r + s - 1) + Dd*f*(4*f + 7)*(4*r + 4*s - 3)) + b1*f*(D1*bd1*(4*f + 7)*(2*r + 2*s - 1) + 2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)))/(35*d*k3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct*k1*st*(-2*D1*bd1*f*(r + s)*(7*b2 + f*(6*C - 3) - 14*g2) + 7*b1**3*(2*D1*fd*(r + s - 1) + Dd*(2*f + 5)*(4*r + 4*s - 3)) + 7*b1**2*(D1*bd1*(2*f + 5)*(3*r + 3*s - 2) - (2*K - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))) + b1*(-24*C*D1*f*fd*r - 24*C*D1*f*fd*s + 24*C*D1*f*fd - 48*C*Dd*f**2*r - 48*C*Dd*f**2*s + 36*C*Dd*f**2 - 7*D1*bd1*f*(2*K - 1)*(2*r + 2*s - 1) - 14*D1*bd2*f*(r + s - 1) + 12*D1*f*fd*r + 12*D1*f*fd*s - 12*D1*f*fd + 28*D1*f*gd2*r + 28*D1*f*gd2*s - 28*D1*f*gd2 + 28*D1*fd*g2*r + 28*D1*fd*g2*s - 28*D1*fd*g2 + 24*Dd*f**2*r + 24*Dd*f**2*s - 18*Dd*f**2 + 112*Dd*f*g2*r + 112*Dd*f*g2*s - 84*Dd*f*g2 - 14*b2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))))/(105*d*k3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct*k1*st**3*(D1*bd1*f*(4*f**2*k1**2*(5*r + 5*s - 3) + 9*f*k1**2*(r + s - 1) - 3*f*k2**2*(-4*C*r - 4*C*s + 12*K*(r + s - 1) + 4*b1 + 2*r + 2*s + 1) + 21*k2**2*(b1*(K*(4*r + 4*s - 2) - 1) - 4*g2*(r + s))) + 3*b1**2*k2**2*(D1*fd*(14*K*(r + s - 1) + 4*f + 7) + 14*Dd*K*f*(4*r + 4*s - 3)) + b1*(3*D1*(4*f**2*fd*k1**2*(5*r + 5*s - 4) + f*(fd*k1**2*(6*r + 6*s - 3) + fd*k2**2*(8*C*(r + s - 1) - 12*K*(2*r + 2*s - 1) - 4*r - 4*s + 5) - 28*gd2*k2**2*(r + s - 1)) - 28*fd*g2*k2**2*(r + s - 1)) + Dd*f*(4*r + 4*s - 3)*(20*f**2*k1**2 + 9*f*k1**2 + 6*f*k2**2*(2*C - 6*K - 1) - 84*g2*k2**2)) + 3*f*(D1*(f*fd*(k1**2 + k2**2*(4 - 8*C))*(3*r + 3*s - 2) - 12*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) - 12*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + Dd*f*(f*(k1**2 + k2**2*(4 - 8*C)) + k2**2*(-12*b2 + 24*g2))*(4*r + 4*s - 3)))/(105*d*k3**3) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct*k1*st*(21*b1**3*k2**2*(2*D1*fd*(r + s - 1) + Dd*(-10*K + 2*f + 5)*(4*r + 4*s - 3)) - 3*b1**2*(D1*(35*bd1*k2**2*(2*K - 1)*(3*r + 3*s - 2) + f*(-14*bd1*k2**2*(3*r + 3*s - 2) + 6*fd*k1**2*(8*r + 8*s - 5)) + 21*fd*k1**2*(r + s) + 7*fd*k2**2*(4*C*(r + s - 1) - 2*K*(2*r + 2*s + 1) - 3*r - 3*s + 3) - 140*gd2*k2**2*(r + s - 1)) + Dd*(4*r + 4*s - 3)*(24*f**2*k1**2 + 7*f*(3*k1**2 + k2**2*(4*C - 4*K - 3)) - 140*g2*k2**2)) - 3*b1*(D1*bd1*(6*f**2*k1**2*(8*r + 8*s - 7) + 7*f*(6*k1**2*(r + s - 1) + k2**2*(C*(8*r + 8*s - 4) - 2*K*(4*r + 4*s - 5) - 6*r - 6*s + 3)) - 140*g2*k2**2*(2*r + 2*s - 1)) + D1*(f*(-3*fd*(k1**2*(2*K - 3)*(2*r + 2*s - 1) + k2**2*(4*C - 2)*(4*r + 4*s - 1)) + k2**2*(-42*bd2 + 56*gd2)*(r + s - 1)) + 14*fd*k2**2*(-3*b2*(r + s) + g2*(4*r + 4*s + 2))) - Dd*f*(3*f*(k1**2*(2*K - 3) + k2**2*(8*C - 4)) + k2**2*(42*b2 - 56*g2))*(4*r + 4*s - 3)) + f*(3*D1*bd1*(3*f*(k1**2*(2*K - 3)*(r + s - 1) + k2**2*(4*C - 2)*(2*r + 2*s - 3)) + 14*k2**2*(3*b2*(r + s - 1) - 2*g2*(2*r + 2*s - 3))) + 2*k1**2*(30*C*D1*f*fd*r + 30*C*D1*f*fd*s - 20*C*D1*f*fd + 40*C*Dd*f**2*r + 40*C*Dd*f**2*s - 30*C*Dd*f**2 + 9*D1*bd2*f*(r + s - 1) - 15*D1*f*fd*r - 15*D1*f*fd*s + 10*D1*f*fd - 18*D1*f*gd2*r - 18*D1*f*gd2*s + 18*D1*f*gd2 - 36*D1*fd*g2*r - 36*D1*fd*g2*s + 18*D1*fd*g2 - 20*Dd*f**2*r - 20*Dd*f**2*s + 15*Dd*f**2 - 72*Dd*f*g2*r - 72*Dd*f*g2*s + 54*Dd*f*g2 + 9*b2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))))/(315*d*k3**3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct*k1*st**3*(D1*(231*b1*fd*k2**4*(r + s)*(b1*(2*K - 1) - 4*g2) + 8*f**3*k1**2*(-11*bd1*k2**2*(r + s - 1) + 10*fd*k1**2*(4*r + 4*s - 3)) - 11*f**2*k2**2*(-3*bd1*(k1**2*(6*K - 3) + k2**2*(4*C + 12*K - 8*b1 - 3))*(r + s - 1) + fd*(k1**2*(-12*C + 8*b1 + 9) + k2**2*(12 - 24*C))*(3*r + 3*s - 2) + 36*gd2*(k1**2 + 2*k2**2)*(r + s - 1)) - 33*f*k2**2*(4*b1**2*fd*k2**2*(2*r + 2*s - 1) - b1*fd*(k1**2*(6*K - 3) + k2**2*(4*C + 12*K - 3))*(2*r + 2*s - 1) + 14*b1*k2**2*(r + s - 1)*(-2*K*bd1 + bd1 + 2*gd2) + 28*bd1*g2*k2**2*(r + s - 1) + 12*fd*g2*(k1**2 + 2*k2**2)*(2*r + 2*s - 1))) + Dd*f*(4*r + 4*s - 3)*(231*b1*k2**4*(b1*(2*K - 1) - 4*g2) + 80*f**3*k1**4 - 11*f**2*(k1**2*k2**2*(-12*C + 8*b1 + 9) + k2**4*(12 - 24*C)) - 33*f*k2**2*(4*b1**2*k2**2 + b1*k1**2*(3 - 6*K) + b1*k2**2*(-4*C - 12*K + 3) + 12*g2*(k1**2 + 2*k2**2))))/(1155*d*k3**5) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct*k1*st*(3*D1*bd1*f*(r + s - 1)*(10*f**2*k1**4 + 3*f*k2**2*(k1**2*(12*C + 2*K - 24*b1 - 9) + k2**2*(12*C - 6)) + 42*k2**2*(2*K*b1*k2**2 + b1*k1**2*(2*K - 1) - 2*g2*(k1**2 + k2**2))) + 9*b1**2*k2**2*(D1*fd*(-12*f*k1**2*(2*r + 2*s - 1) + (r + s)*(14*K*k2**2 + 7*k1**2*(2*K - 1))) - Dd*f*(-14*K*k2**2 + k1**2*(-14*K + 12*f + 7))*(4*r + 4*s - 3)) + 3*b1*(D1*(10*f**2*fd*k1**4*(3*r + 3*s - 2) + 3*f*k2**2*(fd*(k1**2*(12*C + 2*K - 9) + k2**2*(12*C - 6))*(2*r + 2*s - 1) - 28*gd2*(k1**2 + k2**2)*(r + s - 1)) - 84*fd*g2*k2**2*(k1**2 + k2**2)*(r + s)) + Dd*f*(4*r + 4*s - 3)*(10*f**2*k1**4 + 3*f*(k1**2*k2**2*(12*C + 2*K - 9) + k2**4*(12*C - 6)) - 84*g2*k2**2*(k1**2 + k2**2))) + 2*f*k1**2*k2**2*(D1*(f*fd*(10*C - 5)*(3*r + 3*s - 2) - 18*f*gd2*(r + s - 1) - 18*fd*g2*(2*r + 2*s - 1)) + Dd*f*(f*(10*C - 5) - 18*g2)*(4*r + 4*s - 3)))/(315*d*k3**5) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*f**3*k1**2*k2**3*st**7*(D1*fd + Dd*f)*(4*r + 4*s - 3)/(99*d*k3**5) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*f*k2*st**5*(D1*bd1*f*(-9*K*k2**2*(r + s - 1) + f*k1**2*(4*r + 4*s - 3)) + b1*(3*D1*fd*(-3*K*k2**2*(2*r + 2*s - 1) + f*k1**2*(4*r + 4*s - 3)) + Dd*f*(-9*K*k2**2 + 4*f*k1**2)*(4*r + 4*s - 3)) + k2**2*(-6*C*D1*f*fd*r - 6*C*D1*f*fd*s + 4*C*D1*f*fd - 8*C*Dd*f**2*r - 8*C*Dd*f**2*s + 6*C*Dd*f**2 - 9*D1*bd2*f*(r + s - 1) + 3*D1*f*fd*r + 3*D1*f*fd*s - 2*D1*f*fd + 18*D1*f*gd2*r + 18*D1*f*gd2*s - 18*D1*f*gd2 + 36*D1*fd*g2*r + 36*D1*fd*g2*s - 18*D1*fd*g2 + 4*Dd*f**2*r + 4*Dd*f**2*s - 3*Dd*f**2 + 72*Dd*f*g2*r + 72*Dd*f*g2*s - 54*Dd*f*g2 - 9*b2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))))/(63*d*k3**3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*f*k2*st**5*(D1*(3*f**2*k1**2*(-11*bd1*k2**2*(r + s - 1) + 6*fd*k1**2*(4*r + 4*s - 3)) + 11*f*k2**2*(-3*b1*fd*k1**2*(3*r + 3*s - 2) + k2**2*(fd*(2*C - 1)*(3*r + 3*s - 2) + (9*K*bd1 - 18*gd2)*(r + s - 1))) - 99*fd*k2**4*(-K*b1 + 2*g2)*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(18*f**2*k1**4 - 11*f*(3*b1*k1**2*k2**2 + k2**4*(1 - 2*C)) + k2**4*(99*K*b1 - 198*g2)))/(693*d*k3**5) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*k1**2*st*(D1*bd1*f*(r + s - 1)*(5*f**2*k1**4 - 9*f*(8*b1*k1**2*k2**2 + k2**4*(3 - 6*C)) - k2**4*(-126*K*b1 + 126*g2)) + b1*(D1*(5*f**2*fd*k1**4*(3*r + 3*s - 2) - 9*f*k2**2*(4*b1*fd*k1**2*(2*r + 2*s - 1) + k2**2*(-fd*(6*C - 3)*(2*r + 2*s - 1) + 14*gd2*(r + s - 1))) - 63*fd*k2**4*(r + s)*(-K*b1 + 2*g2)) + Dd*f*(4*r + 4*s - 3)*(5*f**2*k1**4 - 9*f*(4*b1*k1**2*k2**2 + k2**4*(3 - 6*C)) + k2**4*(63*K*b1 - 126*g2))))/(315*d*k2*k3**5) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*st**3*(-D1*bd1*f*k2**2*(r + s)*(7*b2 + f*(2*C - 1) - 14*g2) + b1**2*(D1*fd*(-7*K*k2**2 + 2*f*k1**2)*(r + s - 1) + Dd*f*(-7*K*k2**2 + f*k1**2)*(4*r + 4*s - 3)) + b1*(D1*bd1*f*(-7*K*k2**2 + f*k1**2)*(2*r + 2*s - 1) + k2**2*(-4*C*D1*f*fd*r - 4*C*D1*f*fd*s + 4*C*D1*f*fd - 8*C*Dd*f**2*r - 8*C*Dd*f**2*s + 6*C*Dd*f**2 - 7*D1*bd2*f*(r + s - 1) + 2*D1*f*fd*r + 2*D1*f*fd*s - 2*D1*f*fd + 14*D1*f*gd2*r + 14*D1*f*gd2*s - 14*D1*f*gd2 + 14*D1*fd*g2*r + 14*D1*fd*g2*s - 14*D1*fd*g2 + 4*Dd*f**2*r + 4*Dd*f**2*s - 3*Dd*f**2 + 56*Dd*f*g2*r + 56*Dd*f*g2*s - 42*Dd*f*g2 - 7*b2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)))))/(35*d*k2*k3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*st**3*(D1*bd1*f*(f**2*k1**4*(2*r + 2*s - 1) + 3*f*k2**2*(-3*K*k1**2*(r + s - 1) + b1*k1**2*(4*r + 4*s - 5) + k2**2*(2*C - 1)) + 21*k2**4*(K*b1 - b2*(r + s - 1) - 2*g2)) + 3*b1**2*k2**2*(D1*fd*(-7*K*k2**2 + f*k1**2*(4*r + 4*s - 1)) + 2*Dd*f**2*k1**2*(4*r + 4*s - 3)) + b1*(D1*(f**2*fd*k1**4*(6*r + 6*s - 5) - 3*f*(3*K*fd*k1**2*k2**2*(2*r + 2*s - 1) + 7*bd2*k2**4*(r + s - 1) + fd*k2**4*(2*C - 1)) - 21*fd*k2**4*(b2*(r + s) - 2*g2)) + Dd*f*(4*r + 4*s - 3)*(-9*K*f*k1**2*k2**2 - 21*b2*k2**4 + 2*f**2*k1**4)) - 3*f*k1**2*k2**2*(6*C*D1*f*fd*r + 6*C*D1*f*fd*s - 4*C*D1*f*fd + 8*C*Dd*f**2*r + 8*C*Dd*f**2*s - 6*C*Dd*f**2 + 3*D1*bd2*f*(r + s - 1) - 3*D1*f*fd*r - 3*D1*f*fd*s + 2*D1*f*fd - 6*D1*f*gd2*r - 6*D1*f*gd2*s + 6*D1*f*gd2 - 12*D1*fd*g2*r - 12*D1*fd*g2*s + 6*D1*fd*g2 - 4*Dd*f**2*r - 4*Dd*f**2*s + 3*Dd*f**2 - 24*Dd*f*g2*r - 24*Dd*f*g2*s + 18*Dd*f*g2 + 3*b2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))))/(105*d*k2*k3**3) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*st*(3*D1*bd1*f*k1**2*k2**2*(7*b2 + f*(6*C - 3) - 14*g2)*(r + s - 1) + 7*b1**3*k2**2*(2*D1*fd*k1**2*(r + s - 1) + Dd*(-5*K*k2**2 + 2*f*k1**2)*(4*r + 4*s - 3)) + b1**2*(D1*(14*bd1*f*k1**2*k2**2*(3*r + 3*s - 2) - 3*f*fd*k1**4*(4*r + 4*s - 3) - 7*fd*k2**2*(-3*K*k1**2*(r + s) + k2**2*(2*C - 1)*(r + s - 1)) - 35*k2**4*(K*bd1*(3*r + 3*s - 2) - 2*gd2*(r + s - 1))) - Dd*(4*r + 4*s - 3)*(6*f**2*k1**4 - 7*f*(3*K*k1**2*k2**2 + k2**4*(1 - 2*C)) - 70*g2*k2**4)) + b1*(D1*bd1*(42*K*f*k1**2*k2**2*(r + s - 1) - 3*f**2*k1**4*(4*r + 4*s - 3) - f*k2**4*(14*C - 7)*(2*r + 2*s - 1) + 70*g2*k2**4*(2*r + 2*s - 1)) + 3*k1**2*k2**2*(12*C*D1*f*fd*r + 12*C*D1*f*fd*s - 6*C*D1*f*fd + 24*C*Dd*f**2*r + 24*C*Dd*f**2*s - 18*C*Dd*f**2 + 7*D1*bd2*f*(r + s - 1) - 6*D1*f*fd*r - 6*D1*f*fd*s + 3*D1*f*fd - 14*D1*f*gd2*r - 14*D1*f*gd2*s + 14*D1*f*gd2 - 14*D1*fd*g2*r - 14*D1*fd*g2*s - 12*Dd*f**2*r - 12*Dd*f**2*s + 9*Dd*f**2 - 56*Dd*f*g2*r - 56*Dd*f*g2*s + 42*Dd*f*g2 + 7*b2*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)))))/(105*d*k2*k3**3) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*st**3*(D1*(231*b1*fd*k2**6*(r + s)*(K*b1 - 2*g2) + f**3*k1**4*(22*bd1*k2**2*(r + s - 1) + 5*fd*k1**2*(4*r + 4*s - 3)) + 11*f**2*k2**2*(2*b1*k1**2*(-12*bd1*k2**2*(r + s - 1) + fd*k1**2*(3*r + 3*s - 2)) + 3*k2**2*(fd*k1**2*(2*C - 1)*(3*r + 3*s - 2) - (r + s - 1)*(-3*K*bd1*k1**2 + bd1*k2**2*(1 - 2*C) + 6*gd2*k1**2))) + 33*f*k2**4*(-4*b1**2*fd*k1**2*(2*r + 2*s - 1) + b1*fd*(3*K*k1**2 + k2**2*(2*C - 1))*(2*r + 2*s - 1) - 14*b1*k2**2*(-K*bd1 + gd2)*(r + s - 1) - 14*bd1*g2*k2**2*(r + s - 1) - 6*fd*g2*k1**2*(2*r + 2*s - 1))) + Dd*f*(4*r + 4*s - 3)*(231*b1*k2**6*(K*b1 - 2*g2) + 5*f**3*k1**6 + 11*f**2*k1**2*k2**2*(2*b1*k1**2 + k2**2*(6*C - 3)) - 33*f*k2**4*(-3*K*b1*k1**2 + 4*b1**2*k1**2 + b1*k2**2*(1 - 2*C) + 6*g2*k1**2)))/(1155*d*k2*k3**5) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**6*f*k1**2*k2*st*(4*Pk2 - Pkd2*k2)*(D1*(49*f**2*fd*(4*s - 1) + f*fd*(110*C - 110)*(3*s - 1) - 99*f*s*(-K*bd1 + bd1 + 2*gd2) + 198*fd*g2*(1 - 2*s)) + Dd*f*(4*s - 1)*(49*f**2 + f*(110*C - 110) - 198*g2) + 99*b1*(K - 1)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)))/(693*d*k3**4) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**5*f*k1*st*(4*Pk2 - Pkd2*k2)*(3*b1*(D1*fd*(f*(6*s - 2) + 6*s - 3) + Dd*f*(2*f + 3)*(4*s - 1)) + f*(3*D1*bd1*s*(2*f + 3) + 5*D1*fd*(3*s - 1) + 5*Dd*f*(4*s - 1)))/(63*d*k3**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**5*f*k1*st*(D1*(30*f**2*(11*bd1*k2**2*(2*Pk2*(r - 1) + Pkd2*k2*s) + fd*(44*Pk2*k2**2*(1 - 2*r) + 21*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 11*f*(-9*bd1*(-Pk2*k1**2*s*(32*K - 32) + 10*Pk2*k2**2*(K*(r - 2*s - 1) - 2*r + 2) + Pkd2*k1**2*k2*s*(8*K - 8) + Pkd2*k2**3*s*(10*K - 5)) + fd*(k1**2*(80*C - 80)*(4*Pk2 - Pkd2*k2)*(3*s - 1) - k2**2*(6*Pk2*(2*C*(41*r - 50*s + 3) - 107*r + 50*s + 19) + Pkd2*k2*(100*C - 75)*(3*s - 1))) + 36*gd2*(-16*Pk2*k1**2*s + 5*Pk2*k2**2*(r - 2*s - 1) + 4*Pkd2*k1**2*k2*s + 5*Pkd2*k2**3*s)) + 396*fd*g2*(-4*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 5*k2**2*(2*Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1)))) + Dd*f*(30*f**2*(44*Pk2*k2**2*(1 - 2*r) + 21*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 11*f*(k1**2*(80*C - 80)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(-8*Pk2*(2*C*(41*r - 50*s - 8) - 107*r + 50*s + 41) + Pkd2*k2*(75 - 100*C)*(4*s - 1))) + 396*g2*(-4*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 5*k2**2*(4*Pk2*(r - 2*s) + Pkd2*k2*(4*s - 1)))) + 33*b1*(D1*fd*(k1**2*(24*K - 24)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 5*k2**2*(-12*K*Pk2*(r - 2*s + 1) - 6*K*Pkd2*k2*(2*s - 1) + 24*Pk2*r + 6*Pkd2*k2*s - 3*Pkd2*k2 + 2*f*(Pk2*(6*r - 2) + Pkd2*k2*(3*s - 1)))) + Dd*f*(k1**2*(24*K - 24)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 5*k2**2*(-8*Pk2*(-6*K*s - 2*f*r + f + r*(3*K - 6) + 3) + Pkd2*k2*(4*s - 1)*(-6*K + 2*f + 3)))))/(3465*d*k3**4) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**4*f*k1**2*k2*st**3*(4*Pk2 - Pkd2*k2)*(D1*(35*f**2*fd*(4*s - 1) + f*fd*(44*C - 44)*(3*s - 1) - 66*f*s*(-K*bd1 + bd1 + 2*gd2) + 132*fd*g2*(1 - 2*s)) + Dd*f*(4*s - 1)*(35*f**2 + f*(44*C - 44) - 132*g2) + 66*b1*(K - 1)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)))/(231*d*k3**4) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**4*st*(63*b1**2*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(D1*fd*(s - 1) + Dd*f*(4*s - 1)) + 3*b1*(D1*(5*f**2*fd*(3*Pk2*k2**2*(1 - 3*r) + 5*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) + 3*f*(fd*k1**2*(6*C + 2)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 5*fd*k2**2*(-K*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 2*Pk2*r) + k1**2*s*(4*Pk2 - Pkd2*k2)*(14*K*bd1 - 14*bd1 - 14*gd2)) - 42*fd*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) + Dd*f*(5*f**2*(6*Pk2*k2**2*(1 - 2*r) + 5*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 3*f*(k1**2*(6*C + 2)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 5*k2**2*(K*Pkd2*k2*(4*s - 1) + Pk2*(K*(2 - 8*s) - 4*r + 2))) - 42*g2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + f*(D1*(45*b2*fd*k2**2*(-2*Pk2 + Pkd2*k2)*(2*s - 1) - 15*bd1*f**2*(-20*Pk2*k1**2*s + 3*Pk2*k2**2*(r - 1) + 5*Pkd2*k1**2*k2*s) + f*(9*bd1*(5*K*Pkd2*k2**3*s + Pk2*k1**2*s*(24*C + 8) - 5*Pk2*k2**2*(2*K*s + r - 1) - Pkd2*k1**2*k2*s*(6*C + 2)) + 40*fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + fd*k2**2*(Pk2*(-300*C*s + 100*C - 171*r + 150*s + 7) + Pkd2*k2*(50*C - 25)*(3*s - 1)) + k2**2*s*(-2*Pk2 + Pkd2*k2)*(45*bd2 - 90*gd2)) + 18*g2*(7*bd1*k1**2*s*(-4*Pk2 + Pkd2*k2) - 5*fd*k2**2*(-2*Pk2 + Pkd2*k2)*(2*s - 1))) + Dd*f*(40*f*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + f*k2**2*(-4*Pk2*(25*C*(4*s - 1) + 57*r - 50*s - 16) + Pkd2*k2*(50*C - 25)*(4*s - 1)) + k2**2*(-2*Pk2 + Pkd2*k2)*(45*b2 - 90*g2)*(4*s - 1))))/(315*d*k2*k3**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**4*st*(693*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(2*Pk2*(r + 2*s - 1) - Pkd2*k2*s) + Dd*f*(8*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 4*s))) + 11*b1*(3*D1*(5*f**2*fd*k2**2*(3*Pk2*k2**2*(3*r - 1) + 5*k1**2*(4*Pk2*(2*r + s - 1) + Pkd2*k2*(2*s - 1))) + 3*f*(fd*(k1**4*(3*K - 3)*(4*Pk2 - Pkd2*k2)*(2*s - 1) - 4*k1**2*k2**2*(-Pk2*(6*C*(r + 2*s - 1) - 15*K*r - 2*K*s + K + 21*r + 10*s - 5) + Pkd2*k2*(3*C*s + K*(8*s - 4) - 7*s + 2)) - 5*k2**4*(K*Pk2*(8*r + 4*s - 2) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r)) - 7*k1**2*k2**2*(4*Pk2*gd2*(r + 2*s - 1) - 2*Pkd2*gd2*k2*s - bd1*(K - 1)*(4*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 2*s)))) + 42*fd*g2*k1**2*k2**2*(-2*Pk2*(r + 2*s - 1) + Pkd2*k2*s)) + Dd*f*(10*f**2*k2**2*(9*Pk2*k2**2*(2*r - 1) + 5*k1**2*(2*Pk2*(8*r + 4*s - 5) + Pkd2*k2*(4*s - 1))) + 9*f*(k1**4*(3*K - 3)*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 2*k1**2*k2**2*(-4*Pk2*(6*C*(r + 2*s - 1) + K*(-15*r - 2*s + 8) + 21*r + 10*s - 13) + Pkd2*k2*(4*s - 1)*(3*C + 8*K - 7)) - 5*k2**4*(K*Pkd2*k2*(4*s - 1) + 2*Pk2*(K*(8*r + 4*s - 5) - 2*r + 1))) + 126*g2*k1**2*k2**2*(-8*Pk2*(r + 2*s - 1) + Pkd2*k2*(4*s - 1)))) + f*(D1*(-1386*bd1*g2*k1**2*k2**2*(2*Pk2*(r + 2*s - 1) - Pkd2*k2*(s - 1)) + 5*f**2*(99*Pk2*bd1*k2**4*(r - 1) - 660*Pk2*fd*k1**2*k2**2*(3*r + 2*s - 2) + 55*bd1*k1**2*k2**2*(4*Pk2*(2*r + s - 2) + Pkd2*k2*(2*s + 1)) + 105*fd*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 11*f*(-90*Pk2*bd2*k2**4*(r + s - 1) - 9*bd1*(k1**4*s*(3 - 3*K)*(4*Pk2 - Pkd2*k2) + 2*k1**2*k2**2*(Pk2*(-6*C*(r + 2*s - 1) + K*(15*r + 2*s - 15) - 21*r - 10*s + 21) + Pkd2*k2*(3*C*(s - 1) + s*(8*K - 7) + 3)) + 5*k2**4*(2*K*Pk2*(2*r + s - 2) + K*Pkd2*k2*s - Pk2*r + Pk2)) + fd*k1**4*(30*C - 30)*(4*Pk2 - Pkd2*k2)*(3*s - 1) - 4*fd*k1**2*k2**2*(C*Pk2*(273*r - 18*s - 85) - 33*Pk2*(11*r + 4*s - 5) + Pkd2*k2*(40*C - 30)*(3*s - 1)) + fd*k2**4*(Pk2*(-4*C*(246*r + 75*s - 107) + 663*r + 150*s - 271) + Pkd2*k2*(25 - 50*C)*(3*s - 1)) + 18*gd2*(3*k1**4*s*(-4*Pk2 + Pkd2*k2) + 2*k1**2*k2**2*(Pk2*(15*r + 2*s - 15) + 8*Pkd2*k2*s) + 5*k2**4*(2*Pk2*(2*r + s - 2) + Pkd2*k2*s))) - 198*fd*(5*Pk2*b2*k2**4*(2*r + 2*s - 1) + g2*(3*k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1) - 4*k1**2*k2**2*(Pk2*(15*r + 2*s - 1) + 4*Pkd2*k2*(2*s - 1)) - 5*k2**4*(Pk2*(8*r + 4*s - 2) + Pkd2*k2*(2*s - 1))))) + Dd*f*(-990*Pk2*b2*k2**4*(4*r + 4*s - 3) + 75*f**2*k1**2*(-44*Pk2*k2**2*(3*r + 2*s - 2) + 7*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 11*f*(k1**4*(30*C - 30)*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 8*k1**2*k2**2*(2*C*Pk2*(91*r - 6*s - 44) - 11*Pk2*(22*r + 8*s - 13) + Pkd2*k2*(20*C - 15)*(4*s - 1)) + k2**4*(-4*Pk2*(C*(328*r + 100*s - 189) - 221*r - 50*s + 123) + Pkd2*k2*(25 - 50*C)*(4*s - 1))) - 198*g2*(3*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 8*k1**2*k2**2*(Pk2*(15*r + 2*s - 8) + 2*Pkd2*k2*(4*s - 1)) + 5*k2**4*(-2*Pk2*(8*r + 4*s - 5) + Pkd2*k2*(1 - 4*s))))))/(3465*d*k2*k3**4) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**3*f*k1*st**3*(4*Pk2 - Pkd2*k2)*(b1*(D1*fd*(6*f*s - 2*f + 6*s - 3) + Dd*f*(2*f + 3)*(4*s - 1)) + f*(D1*bd1*s*(2*f + 3) + D1*fd*(3*s - 1) + Dd*f*(4*s - 1)))/(21*d*k3**2) + 2*np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**3*f*k1*st**3*(D1*(10*f**2*(11*bd1*k2**2*(2*Pk2*(r - 1) + Pkd2*k2*s) + fd*(44*Pk2*k2**2*(1 - 2*r) + 15*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 11*f*(-3*bd1*(-Pk2*k1**2*s*(16*K - 16) + 10*Pk2*k2**2*(K*(r - 2*s - 1) - 2*r + 2) + Pkd2*k1**2*k2*s*(4*K - 4) + Pkd2*k2**3*s*(10*K - 5)) + fd*(k1**2*(8*C - 8)*(4*Pk2 - Pkd2*k2)*(3*s - 1) - k2**2*(2*Pk2*(C*(54*r - 60*s + 2) - 69*r + 30*s + 13) + Pkd2*k2*(20*C - 15)*(3*s - 1))) + 12*gd2*(-8*Pk2*k1**2*s + 5*Pk2*k2**2*(r - 2*s - 1) + 2*Pkd2*k1**2*k2*s + 5*Pkd2*k2**3*s)) + 132*fd*g2*(-2*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 5*k2**2*(2*Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1)))) + Dd*f*(10*f**2*(44*Pk2*k2**2*(1 - 2*r) + 15*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 11*f*(k1**2*(8*C - 8)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(-8*Pk2*(2*C*(9*r - 10*s - 2) - 23*r + 10*s + 9) + Pkd2*k2*(15 - 20*C)*(4*s - 1))) + 132*g2*(-2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 5*k2**2*(4*Pk2*(r - 2*s) + Pkd2*k2*(4*s - 1)))) + 11*b1*(D1*fd*(k1**2*(12*K - 12)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 5*k2**2*(-12*K*Pk2*(r - 2*s + 1) - 6*K*Pkd2*k2*(2*s - 1) + 24*Pk2*r + 6*Pkd2*k2*s - 3*Pkd2*k2 + 2*f*(Pk2*(6*r - 2) + Pkd2*k2*(3*s - 1)))) + Dd*f*(k1**2*(12*K - 12)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 5*k2**2*(-8*Pk2*(-6*K*s - 2*f*r + f + r*(3*K - 6) + 3) + Pkd2*k2*(4*s - 1)*(-6*K + 2*f + 3)))))/(1155*d*k3**4) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**3*k1*st*(4*Pk2 - Pkd2*k2)*(3*D1*bd1*f**2*s + b1**2*(D1*fd*(8*f*s - 4*f + 7*s - 7) + Dd*f*(4*f + 7)*(4*s - 1)) + b1*f*(2*D1*bd1*s*(4*f + 7) + D1*fd*(6*s - 3) + 3*Dd*f*(4*s - 1)))/(35*d*k2**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**3*st*(-9*b1**2*k1**2*k2**2*(D1*fd*(-2*Pk2*(-7*K*(r - 2*s + 2) + 4*f + 7*r + 7) + Pkd2*k2*(14*K*(s - 1) + 4*f + 7)) + 14*Dd*f*(K*Pkd2*k2*(4*s - 1) + Pk2*(-8*K*s + r*(4*K - 4) + 2))) + b1*k1**2*(D1*(4*f**2*(-9*Pk2*fd*k2**2*(18*r + 15*s - 13) + 9*bd1*k2**2*(-2*Pk2 + Pkd2*k2) + 10*fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) + 3*f*(fd*(9*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(-2*Pk2*(C*(68*r - 72*s + 2) + 48*K*s - 24*K - 2*r + 132*s - 41) + 3*Pkd2*k2*(C*(12 - 24*s) + 16*K*s - 8*K + 12*s - 9))) - 21*k2**2*(Pk2*bd1*(K*(4*r - 8*s - 2) - 4*r + 4) + Pkd2*bd1*k2*(4*K*s - 1) + 4*gd2*(-Pk2*r + 2*Pk2*s + Pk2 - Pkd2*k2*s))) + 252*fd*g2*k2**2*(Pk2*(r - 2*s + 2) + Pkd2*k2*(s - 1))) + Dd*f*(4*f**2*(-9*Pk2*k2**2*(24*r + 20*s - 17) + 10*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 3*f*(-8*Pk2*k2**2*(C*(34*r - 36*s - 8) + 24*K*s - 6*K - r + 66*s - 16) + Pkd2*k2**3*(4*s - 1)*(-36*C + 24*K + 18) + 9*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 252*g2*k2**2*(4*Pk2*(r - 2*s) + Pkd2*k2*(4*s - 1)))) + f*(D1*(-4*bd1*f**2*k1**2*(-40*Pk2*k1**2*s + 9*Pk2*k2**2*(6*r + 5*s - 4) + 10*Pkd2*k1**2*k2*s) + f*(fd*(Pk2*k2**4*(64*C - 32)*(3*r - 1) + 15*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1) + 2*k1**2*k2**2*(Pk2*(-240*C*s + 80*C - 213*r - 72*s + 95) + Pkd2*k2*(40*C - 20)*(3*s - 1))) - 3*k1**2*(bd1*(-36*Pk2*k1**2*s + 2*Pk2*k2**2*(r*(34*C - 1) + s*(-36*C + 24*K + 66) - 24) + 9*Pkd2*k1**2*k2*s + 3*Pkd2*k2**3*(s*(12*C - 8*K - 6) - 3)) + k2**2*s*(-2*Pk2 + Pkd2*k2)*(-24*bd2 + 48*gd2))) + 36*k1**2*k2**2*(-2*b2*fd*(2*Pk2 - Pkd2*k2)*(2*s - 1) + 7*bd1*g2*(Pk2*(r - 2*s) + Pkd2*k2*s) + 4*fd*g2*(2*Pk2 - Pkd2*k2)*(2*s - 1))) + Dd*f*(f*(Pk2*k2**4*(128*C - 64)*(2*r - 1) + 15*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 4*k1**2*k2**2*(Pk2*(-160*C*s + 40*C - 142*r - 48*s + 83) + Pkd2*k2*(20*C - 10)*(4*s - 1))) + k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(72*b2 - 144*g2)*(4*s - 1))))/(315*d*k1*k2**2*k3**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**3*st*(D1*(-231*b1*fd*k1**2*k2**2*(4*b1*k1**2*(K - 1)*(-Pk2*(r + 3*s - 1) + Pkd2*k2*s) - 3*b1*k2**2*(2*Pk2*(K*(r + 2*s - 2) + r + 1) + Pkd2*k2*s*(1 - 2*K)) + 8*g2*k1**2*(Pk2*(r + 3*s - 1) - Pkd2*k2*s) + 12*g2*k2**2*(Pk2*(r + 2*s - 2) - Pkd2*k2*s)) + 4*f**3*k1**2*(99*Pk2*bd1*k2**4*(4*r + 5*s - 6) - 165*Pk2*fd*k1**2*k2**2*(16*r + 20*s - 13) + 55*bd1*k1**2*k2**2*(2*Pk2*(5*r + 5*s - 6) + 3*Pkd2*k2) + 35*fd*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 11*f**2*k2**2*(-3*bd1*(k1**4*(Pk2*(24*C*(r + 3*s - 2) + K*(-46*r - 84*s + 46) + 76*r + 84*s - 52) - 3*Pkd2*k2*(8*C*(s - 1) + s*(6*K - 11) + 8)) + k1**2*k2**2*(Pk2*(4*C*r + 72*C*s - 12*K*(17*r + 22*s - 17) - 24*b1 + 98*r + 60*s - 84) + 3*Pkd2*k2*(-12*C*(s - 1) - 8*K*s + b1*(8*s - 4) + 9*s - 9))) + fd*(Pk2*k2**4*(64*C - 32)*(3*r - 1) + k1**4*(-2*Pk2*(-2*C*(123*r + 162*s - 95) + 60*b1*(5*r + 5*s - 3) + 381*r + 504*s - 295) + 15*Pkd2*k2*(4*b1 + (4*C - 3)*(3*s - 1))) + 2*k1**2*k2**2*(-3*Pk2*(-4*C*(101*r + 94*s - 65) + 6*b1*(12*r + 15*s - 7) + 273*r + 252*s - 175) + Pkd2*k2*(40*C - 20)*(3*s - 1))) - 12*k1**2*(-18*Pk2*bd2*k2**2*(r + s - 1) + gd2*k1**2*(Pk2*(23*r + 42*s - 23) + 9*Pkd2*k2*s) + 6*gd2*k2**2*(Pk2*(17*r + 22*s - 17) + 2*Pkd2*k2*s))) + 33*f*k1**2*k2**2*(24*b1**2*fd*k2**2*(Pk2 + Pkd2*k2*s) + b1*(7*bd1*(k1**2*(4*K - 4)*(Pk2*(2*r + 6*s - 3) + Pkd2*k2*(1 - 2*s)) - 3*k2**2*(Pk2*(K*(-4*r - 8*s + 2) - 4*r + 4) + Pkd2*k2*(2*K - 1)*(2*s - 1))) + fd*k1**2*(4*Pk2*(12*C*(r + 3*s - 1) + K*(-23*r - 42*s + 21) + 38*r + 42*s - 27) - 3*Pkd2*k2*(6*K*(2*s - 1) + s*(16*C - 22) + 3)) + 2*fd*k2**2*(Pk2*(C*(4*r + 72*s - 38) - 12*K*(17*r + 22*s - 11) + 98*r + 60*s - 37) + 3*Pkd2*k2*(K*(4 - 8*s) + s*(9 - 12*C))) + 56*gd2*k1**2*(-Pk2*(r + 3*s - 1) + Pkd2*k2*s) + 84*gd2*k2**2*(-Pk2*(r + 2*s - 1) + Pkd2*k2*s)) - 28*bd1*g2*(2*k1**2*(Pk2*(r + 3*s - 2) - Pkd2*k2*(s - 1)) + 3*k2**2*(Pk2*(r + 2*s) + k2*(-Pkd2*s + Pkd2))) - 4*fd*(18*Pk2*b2*k2**2*(2*r + 2*s - 1) - g2*(k1**2*(Pk2*(46*r + 84*s - 42) + 9*Pkd2*k2*(2*s - 1)) + 12*k2**2*(Pk2*(17*r + 22*s - 11) + Pkd2*k2*(2*s - 1)))))) + Dd*f*(-231*b1*k1**2*k2**2*(-4*b1*k1**2*(K - 1)*(Pk2*(4*r + 12*s - 5) + Pkd2*k2*(1 - 4*s)) + 3*b1*k2**2*(-4*Pk2*(2*K*(r + 2*s - 1) + 2*r - 1) + Pkd2*k2*(2*K - 1)*(4*s - 1)) + 8*g2*k1**2*(Pk2*(4*r + 12*s - 5) + Pkd2*k2*(1 - 4*s)) + 12*g2*k2**2*(4*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 4*s))) + 20*f**3*k1**4*(-33*Pk2*k2**2*(16*r + 20*s - 13) + 7*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 11*f**2*k2**2*(Pk2*k2**4*(128*C - 64)*(2*r - 1) + k1**4*(-4*Pk2*(-4*C*(41*r + 54*s - 34) + 50*b1*(4*r + 4*s - 3) + 254*r + 336*s - 211) + Pkd2*k2*(60*C - 45)*(4*s - 1)) + 4*k1**2*k2**2*(Pk2*(8*C*(101*r + 94*s - 74) - 9*b1*(16*r + 20*s - 13) - 546*r - 504*s + 399) + Pkd2*k2*(20*C - 10)*(4*s - 1))) + 33*f*k1**2*k2**2*(-72*Pk2*b2*k2**2*(4*r + 4*s - 3) + 12*Pkd2*b1**2*k2**3*(4*s - 1) + b1*(k1**2*(4*Pk2*(6*C*(4*r + 12*s - 5) + K*(-46*r - 84*s + 44) + 76*r + 84*s - 59) + Pkd2*k2*(4*s - 1)*(-24*C - 18*K + 33)) + k2**2*(8*Pk2*(2*C*(r + 18*s - 5) - 6*K*(17*r + 22*s - 14) + 49*r + 30*s - 32) + Pkd2*k2*(4*s - 1)*(-36*C - 24*K + 27))) + 4*g2*k1**2*(4*Pk2*(23*r + 42*s - 22) + 9*Pkd2*k2*(4*s - 1)) + 48*g2*k2**2*(Pk2*(34*r + 44*s - 28) + Pkd2*k2*(4*s - 1)))))/(3465*d*k1*k2**2*k3**4) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**2*f*k1**2*k2*st**5*(4*Pk2 - Pkd2*k2)*(D1*(63*f**2*fd*(4*s - 1) + f*fd*(22*C - 22)*(3*s - 1) - 99*f*s*(-K*bd1 + bd1 + 2*gd2) + 198*fd*g2*(1 - 2*s)) + Dd*f*(4*s - 1)*(63*f**2 + f*(22*C - 22) - 198*g2) + 99*b1*(K - 1)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)))/(693*d*k3**4) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**2*st*(D1*bd1*f*(Pk2*f*(-25*r + s*(18 - 36*C)) + Pkd2*f*k2*s*(18*C - 9) - s*(2*Pk2 - Pkd2*k2)*(21*b2 - 42*g2)) - 21*b1**2*(D1*fd*(K*(2*Pk2 - Pkd2*k2)*(s - 1) + Pk2*f*(2*r - 1) + Pk2*r) + Dd*f*(K*Pkd2*k2*(1 - 4*s) + Pk2*(8*K*s - 2*K + f*(4*r - 2) + 4*r - 2))) + b1*(-72*C*D1*Pk2*f*fd*s + 36*C*D1*Pk2*f*fd + 36*C*D1*Pkd2*f*fd*k2*s - 18*C*D1*Pkd2*f*fd*k2 - 144*C*Dd*Pk2*f**2*s + 36*C*Dd*Pk2*f**2 + 72*C*Dd*Pkd2*f**2*k2*s - 18*C*Dd*Pkd2*f**2*k2 - 42*D1*Pk2*bd2*f*s - 50*D1*Pk2*f*fd*r + 36*D1*Pk2*f*fd*s + 7*D1*Pk2*f*fd + 84*D1*Pk2*f*gd2*s + 84*D1*Pk2*fd*g2*s - 84*D1*Pk2*fd*g2 + 21*D1*Pkd2*bd2*f*k2*s - 18*D1*Pkd2*f*fd*k2*s + 9*D1*Pkd2*f*fd*k2 - 42*D1*Pkd2*f*gd2*k2*s - 42*D1*Pkd2*fd*g2*k2*s + 42*D1*Pkd2*fd*g2*k2 - 21*D1*bd1*f*(-2*K*Pkd2*k2*s + Pk2*(4*K*s + 2*f*r - f + 2*r - 1)) - 100*Dd*Pk2*f**2*r + 72*Dd*Pk2*f**2*s + 32*Dd*Pk2*f**2 + 336*Dd*Pk2*f*g2*s - 84*Dd*Pk2*f*g2 - 36*Dd*Pkd2*f**2*k2*s + 9*Dd*Pkd2*f**2*k2 - 168*Dd*Pkd2*f*g2*k2*s + 42*Dd*Pkd2*f*g2*k2 - 21*b2*(2*Pk2 - Pkd2*k2)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))))/(105*d*k2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**2*st**3*(21*b1**2*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(D1*fd*(s - 1) + Dd*f*(4*s - 1)) + 6*b1*(D1*(5*f**2*fd*(Pk2*k2**2*(1 - 3*r) + k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) + f*(fd*k1**2*(C + 3)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 5*fd*k2**2*(-K*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 2*Pk2*r) + k1**2*s*(4*Pk2 - Pkd2*k2)*(7*K*bd1 - 7*bd1 - 7*gd2)) - 7*fd*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) + Dd*f*(5*f**2*(2*Pk2*k2**2*(1 - 2*r) + k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + f*(k1**2*(C + 3)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 5*k2**2*(K*Pkd2*k2*(4*s - 1) + Pk2*(K*(2 - 8*s) - 4*r + 2))) - 7*g2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 2*f*(D1*(15*b2*fd*k2**2*(-2*Pk2 + Pkd2*k2)*(2*s - 1) - 15*bd1*f**2*(-4*Pk2*k1**2*s + Pk2*k2**2*(r - 1) + Pkd2*k1**2*k2*s) + 21*bd1*g2*k1**2*s*(-4*Pk2 + Pkd2*k2) + f*(-3*bd1*(-5*K*Pkd2*k2**3*s + Pk2*k1**2*s*(-4*C - 12) + 5*Pk2*k2**2*(2*K*s + r - 1) + Pkd2*k1**2*k2*s*(C + 3)) + fd*(4*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(Pk2*(-60*C*s + 20*C - 39*r + 30*s + 3) + Pkd2*k2*(10*C - 5)*(3*s - 1))) + k2**2*s*(-2*Pk2 + Pkd2*k2)*(15*bd2 - 30*gd2)) - 30*fd*g2*k2**2*(-2*Pk2 + Pkd2*k2)*(2*s - 1)) + Dd*f*(4*f*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + f*k2**2*(Pk2*(C*(20 - 80*s) - 52*r + 40*s + 16) + Pkd2*k2*(10*C - 5)*(4*s - 1)) + k2**2*(-2*Pk2 + Pkd2*k2)*(15*b2 - 30*g2)*(4*s - 1))))/(105*d*k2*k3**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**2*st*(105*Dd*b1**3*k1**2*(K - 1)*(2*Pk2 - Pkd2*k2)*(4*s - 1) + 3*b1**2*(35*D1*bd1*k1**2*(K - 1)*(2*Pk2 - Pkd2*k2)*(3*s - 1) + D1*(21*K*fd*k2**2*(-2*Pk2*r + Pkd2*k2) + fd*k1**2*(2*Pk2*(14*C*s - 49*K*s + 49*K + 9*f*(4*s + 1) + 63*s - 49) - Pkd2*k2*(9*f*(4*s + 1) + s*(14*C + 14))) + 70*gd2*k1**2*s*(-2*Pk2 + Pkd2*k2)) + 2*Dd*(9*f**2*k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1) + 7*f*(6*K*Pk2*k2**2*(1 - 2*r) + k1**2*(4*s - 1)*(Pk2*(2*C - 7*K + 9) - Pkd2*k2*(C + 1))) - 35*g2*k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1))) + 3*b1*(D1*bd1*(9*f**2*k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 3) + 7*f*(-3*K*k2**2*(Pk2*(4*r - 2) + Pkd2*k2) + 2*k1**2*(-2*Pk2*(-2*C*s + C + 7*K*s - 9*s + 1) - Pkd2*k2*(C + 1)*(2*s - 1))) - 70*g2*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1)) + D1*(-27*Pk2*f**2*fd*k1**2*(6*r + 12*s - 7) + f*(28*Pk2*gd2*(7*k1**2*s + 3*k2**2*(r - 1)) + 21*Pkd2*bd2*k2**3*s - fd*k1**2*(2*Pk2*(26*C*(2*s - 1) + 18*K*s - 9*K + 37*r + 26*s - 25) + 3*Pkd2*k2*(K*(3 - 6*s) + 8*s)) + fd*k2**2*(2*Pk2*(-50*C*(2*r - 1) + 42*K*(r + 2*s - 1) + 50*r - 25) + Pkd2*k2*(18*C - 9))) + 7*fd*(28*Pk2*g2*k1**2*(s - 1) + 3*Pkd2*b2*k2**3*s - 6*g2*k2**2*(-2*Pk2*r + Pkd2*k2))) + Dd*f*(-216*Pk2*f**2*k1**2*(r + 2*s - 1) + 4*Pk2*f*k2**2*(-50*C*(2*r - 1) + 42*K*(r + 2*s - 1) + 50*r - 25) + 28*Pk2*g2*(7*k1**2*(4*s - 1) + 6*k2**2*(2*r - 1)) + 21*Pkd2*b2*k2**3*(4*s - 1) + f*k1**2*(-2*Pk2*(26*C*(4*s - 1) + 36*K*s - 9*K + 74*r + 52*s - 50) + Pkd2*k2*(9*K - 12)*(4*s - 1)))) + f*(-180*C*D1*Pk2*f*fd*k1**2*s + 60*C*D1*Pk2*f*fd*k1**2 + 612*C*D1*Pk2*f*fd*k2**2*r + 648*C*D1*Pk2*f*fd*k2**2*s - 420*C*D1*Pk2*f*fd*k2**2 + 90*C*D1*Pkd2*f*fd*k1**2*k2*s - 30*C*D1*Pkd2*f*fd*k1**2*k2 - 240*C*Dd*Pk2*f**2*k1**2*s + 60*C*Dd*Pk2*f**2*k1**2 + 816*C*Dd*Pk2*f**2*k2**2*r + 864*C*Dd*Pk2*f**2*k2**2*s - 624*C*Dd*Pk2*f**2*k2**2 + 120*C*Dd*Pkd2*f**2*k1**2*k2*s - 30*C*Dd*Pkd2*f**2*k1**2*k2 - 54*D1*Pk2*bd2*f*k1**2*s + 126*D1*Pk2*bd2*f*k2**2*r + 252*D1*Pk2*bd2*f*k2**2*s - 126*D1*Pk2*bd2*f*k2**2 - 201*D1*Pk2*f*fd*k1**2*r - 324*D1*Pk2*f*fd*k1**2*s + 175*D1*Pk2*f*fd*k1**2 - 306*D1*Pk2*f*fd*k2**2*r - 324*D1*Pk2*f*fd*k2**2*s + 210*D1*Pk2*f*fd*k2**2 + 108*D1*Pk2*f*gd2*k1**2*s - 252*D1*Pk2*f*gd2*k2**2*r - 504*D1*Pk2*f*gd2*k2**2*s + 252*D1*Pk2*f*gd2*k2**2 + 216*D1*Pk2*fd*g2*k1**2*s - 108*D1*Pk2*fd*g2*k1**2 - 504*D1*Pk2*fd*g2*k2**2*r - 1008*D1*Pk2*fd*g2*k2**2*s + 504*D1*Pk2*fd*g2*k2**2 + 27*D1*Pkd2*bd2*f*k1**2*k2*s - 45*D1*Pkd2*f*fd*k1**2*k2*s + 15*D1*Pkd2*f*fd*k1**2*k2 - 54*D1*Pkd2*f*gd2*k1**2*k2*s - 108*D1*Pkd2*fd*g2*k1**2*k2*s + 54*D1*Pkd2*fd*g2*k1**2*k2 - 3*D1*bd1*(27*Pk2*f**2*k1**2*(2*r + 4*s - 1) - 21*Pkd2*b2*k2**3*(s - 1) + f*k1**2*(Pk2*(37*r + s*(52*C + 18*K + 26) - 13) - 3*Pkd2*k2*(s*(3*K - 4) + 4)) + f*k2**2*(-42*K*Pk2*(r + 2*s - 1) + (2*C - 1)*(50*Pk2*r + 9*Pkd2*k2)) - 14*g2*(14*Pk2*k1**2*s + 6*Pk2*k2**2*r + 3*Pkd2*k2**3)) - 268*Dd*Pk2*f**2*k1**2*r - 432*Dd*Pk2*f**2*k1**2*s + 242*Dd*Pk2*f**2*k1**2 - 408*Dd*Pk2*f**2*k2**2*r - 432*Dd*Pk2*f**2*k2**2*s + 312*Dd*Pk2*f**2*k2**2 + 432*Dd*Pk2*f*g2*k1**2*s - 108*Dd*Pk2*f*g2*k1**2 - 1008*Dd*Pk2*f*g2*k2**2*r - 2016*Dd*Pk2*f*g2*k2**2*s + 1008*Dd*Pk2*f*g2*k2**2 - 60*Dd*Pkd2*f**2*k1**2*k2*s + 15*Dd*Pkd2*f**2*k1**2*k2 - 216*Dd*Pkd2*f*g2*k1**2*k2*s + 54*Dd*Pkd2*f*g2*k1**2*k2 - 9*b2*(D1*fd*(-28*Pk2*k2**2*(r + 2*s - 1) + 3*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1)) + Dd*f*(-56*Pk2*k2**2*(r + 2*s - 1) + 3*k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1)))))/(315*d*k2*k3**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**2*st**3*(231*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(2*Pk2*(r + 2*s - 1) - Pkd2*k2*s) + Dd*f*(8*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 4*s))) + 11*b1*(3*D1*(10*f**2*fd*k2**2*(Pk2*k2**2*(3*r - 1) + k1**2*(4*Pk2*(2*r + s - 1) + Pkd2*k2*(2*s - 1))) + f*(fd*(k1**4*(K - 1)*(4*Pk2 - Pkd2*k2)*(2*s - 1) - 4*k1**2*k2**2*(-Pk2*(2*C*(r + 2*s - 1) - 15*K*r - 2*K*s + K + 25*r + 18*s - 9) + Pkd2*k2*(K*(8*s - 4) + s*(C - 5) + 2)) - 10*k2**4*(K*Pk2*(8*r + 4*s - 2) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r)) - 7*k1**2*k2**2*(4*Pk2*gd2*(r + 2*s - 1) - 2*Pkd2*gd2*k2*s - bd1*(K - 1)*(4*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 2*s)))) + 14*fd*g2*k1**2*k2**2*(-2*Pk2*(r + 2*s - 1) + Pkd2*k2*s)) + Dd*f*(20*f**2*k2**2*(3*Pk2*k2**2*(2*r - 1) + k1**2*(2*Pk2*(8*r + 4*s - 5) + Pkd2*k2*(4*s - 1))) + 3*f*(k1**4*(K - 1)*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 2*k1**2*k2**2*(-4*Pk2*(2*C*(r + 2*s - 1) + K*(-15*r - 2*s + 8) + 25*r + 18*s - 17) + Pkd2*k2*(4*s - 1)*(C + 8*K - 5)) - 10*k2**4*(K*Pkd2*k2*(4*s - 1) + 2*Pk2*(K*(8*r + 4*s - 5) - 2*r + 1))) + 42*g2*k1**2*k2**2*(-8*Pk2*(r + 2*s - 1) + Pkd2*k2*(4*s - 1)))) + f*(D1*(-462*bd1*g2*k1**2*k2**2*(2*Pk2*(r + 2*s - 1) - Pkd2*k2*(s - 1)) + 10*f**2*(11*bd1*k2**2*(3*Pk2*k2**2*(r - 1) + k1**2*(4*Pk2*(2*r + s - 2) + Pkd2*k2*(2*s + 1))) + 3*fd*(-44*Pk2*k1**2*k2**2*(3*r + 2*s - 2) + 5*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 11*f*(-60*Pk2*bd2*k2**4*(r + s - 1) - 3*bd1*(-k1**4*s*(K - 1)*(4*Pk2 - Pkd2*k2) + 2*k1**2*k2**2*(Pk2*(-2*C*(r + 2*s - 1) + K*(15*r + 2*s - 15) - 25*r - 18*s + 25) + Pkd2*k2*(C*(s - 1) + s*(8*K - 5) + 1)) + 10*k2**4*(2*K*Pk2*(2*r + s - 2) + K*Pkd2*k2*s - Pk2*r + Pk2)) + 2*fd*(k1**4*(C - 1)*(4*Pk2 - Pkd2*k2)*(3*s - 1) - 2*k1**2*k2**2*(Pk2*(9*C*(5*r - 2*s - 1) - 63*r - 12*s + 25) + Pkd2*k2*(8*C - 6)*(3*s - 1)) + k2**4*(Pk2*(-4*C*(54*r + 15*s - 23) + 147*r + 30*s - 59) + Pkd2*k2*(5 - 10*C)*(3*s - 1))) + 6*gd2*(k1**4*(-4*Pk2*s + Pkd2*k2*s) + 2*k1**2*k2**2*(Pk2*(15*r + 2*s - 15) + 8*Pkd2*k2*s) + 10*k2**4*(2*Pk2*(2*r + s - 2) + Pkd2*k2*s))) - 66*fd*(10*Pk2*b2*k2**4*(2*r + 2*s - 1) + g2*(k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1) - 4*k1**2*k2**2*(Pk2*(15*r + 2*s - 1) + 4*Pkd2*k2*(2*s - 1)) - 10*k2**4*(Pk2*(8*r + 4*s - 2) + Pkd2*k2*(2*s - 1))))) + 2*Dd*f*(-330*Pk2*b2*k2**4*(4*r + 4*s - 3) + 15*f**2*k1**2*(-44*Pk2*k2**2*(3*r + 2*s - 2) + 5*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 11*f*(k1**4*(C - 1)*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 4*k1**2*k2**2*(Pk2*(6*C*(5*r - 2*s - 2) - 42*r - 8*s + 23) + Pkd2*k2*(4*C - 3)*(4*s - 1)) + k2**4*(-4*Pk2*(C*(72*r + 20*s - 41) - 49*r - 10*s + 27) + Pkd2*k2*(5 - 10*C)*(4*s - 1))) - 33*g2*(k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 8*k1**2*k2**2*(Pk2*(15*r + 2*s - 8) + 2*Pkd2*k2*(4*s - 1)) - 10*k2**4*(2*Pk2*(8*r + 4*s - 5) + Pkd2*k2*(4*s - 1))))))/(1155*d*k2*k3**4) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**2*st*(210*Dd*Pk2*b1**3*k1**2*k2**2*(K - 1)*(4*r + 4*s - 3) + 3*b1**2*(D1*(70*Pk2*bd1*k1**2*k2**2*(K - 1)*(3*r + 3*s - 2) - 140*Pk2*gd2*k1**2*k2**2*(r + s - 1) + fd*(k1**4*s*(7*K - 7)*(2*Pk2 - Pkd2*k2) + 2*k1**2*k2**2*(Pk2*(14*C*(r + s - 1) - 7*K*(5*r + 3*s + 4) + 9*f*(4*r + 4*s - 1) + 77*r + 63*s + 28) + Pkd2*k2*s*(-28*K + 27*f + 14)) - 21*k2**4*(2*K*Pk2*(r + s + 1) + K*Pkd2*k2*s - Pk2*r + f*(-2*Pk2*r + Pk2)))) + Dd*(-140*Pk2*g2*k1**2*k2**2*(4*r + 4*s - 3) + 3*f**2*k2**2*(14*Pk2*k2**2*(2*r - 1) + k1**2*(12*Pk2*(4*r + 4*s - 3) + 9*Pkd2*k2*(4*s - 1))) + 7*f*(k1**4*(K - 1)*(2*Pk2 - Pkd2*k2)*(4*s - 1) - 2*k1**2*k2**2*(Pk2*(C*(-8*r - 8*s + 6) + K*(20*r + 12*s - 13) - 44*r - 36*s + 31) + Pkd2*k2*(4*K - 2)*(4*s - 1)) - 3*k2**4*(K*Pkd2*k2*(4*s - 1) + Pk2*(K*(8*r + 8*s - 6) - 4*r + 2))))) + 3*b1*(D1*bd1*(-140*Pk2*g2*k1**2*k2**2*(2*r + 2*s - 1) + 3*f**2*k2**2*(7*Pk2*k2**2*(2*r - 1) + 3*k1**2*(2*Pk2*(4*r + 4*s - 5) + 3*Pkd2*k2*(2*s - 1))) + 7*f*(k1**4*(K - 1)*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 4*k1**2*k2**2*(Pk2*(-2*C*r - 2*C*s + C + 5*K*r + 3*K*s - 6*K - 11*r - 9*s + 12) + Pkd2*k2*(2*K - 1)*(2*s - 1)) - 3*k2**4*(K*Pk2*(4*r + 4*s - 6) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r + Pk2))) + D1*(f**2*fd*k1**2*(27*Pk2*k2**2*(8*s - 1) + 5*k1**2*(4*Pk2*(3*r + 6*s - 2) - Pkd2*k2*(6*s + 1))) + f*(-42*Pk2*bd2*k2**4*(r + s - 1) + fd*k1**4*(Pk2*(24*C*s + K*(26 - 52*s) + 24*r + 52*s - 38) + Pkd2*k2*s*(12 - 12*C)) + fd*k1**2*k2**2*(-2*Pk2*(C*(60*r + 4*s - 6) + K*(128*r + 258*s - 129) - 145*r - 154*s + 87) + 3*Pkd2*k2*(K*(3 - 6*s) + s*(24 - 32*C))) + fd*k2**4*(Pk2*(-8*C*(25*r + 9*s - 8) - 84*K*(r + 2*s - 1) + 150*r + 36*s - 57) + Pkd2*k2*s*(18 - 36*C)) + 14*gd2*(k1**4*(-2*Pk2*s + Pkd2*k2*s) + 2*k1**2*k2**2*(Pk2*(5*r + 3*s - 5) + 4*Pkd2*k2*s) + 3*k2**4*(2*Pk2*(r + s - 1) + Pkd2*k2*s))) + 14*fd*(-3*Pk2*b2*k2**4*(r + s) + g2*(k1**4*(-2*Pk2*s + Pkd2*k2*s) + 2*k1**2*k2**2*(Pk2*(5*r + 3*s + 4) + 4*Pkd2*k2*s) + 3*k2**4*(2*Pk2*(r + s + 1) + Pkd2*k2*s)))) + Dd*f*(-42*Pk2*b2*k2**4*(4*r + 4*s - 3) + 2*f**2*k1**2*(36*Pk2*k2**2*(4*s - 1) + 5*k1**2*(8*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 4*s))) + f*(2*k1**4*(Pk2*(6*C*(4*s - 1) - 52*K*s + 13*K + 24*r + 52*s - 25) + 3*Pkd2*k2*(-4*C*s + C + 4*s - 1)) + k1**2*k2**2*(-2*Pk2*(2*C*(60*r + 4*s - 31) + K*(256*r + 516*s - 257) - 290*r - 308*s + 222) + Pkd2*k2*(4*s - 1)*(-48*C - 9*K + 36)) + k2**4*(-4*Pk2*(C*(100*r + 36*s - 59) + 42*K*(r + 2*s - 1) - 75*r - 18*s + 42) + Pkd2*k2*(9 - 18*C)*(4*s - 1))) - 14*g2*(k1**4*(2*Pk2 - Pkd2*k2)*(4*s - 1) - 2*k1**2*k2**2*(Pk2*(20*r + 12*s - 13) + 4*Pkd2*k2*(4*s - 1)) - 3*k2**4*(Pk2*(8*r + 8*s - 6) + Pkd2*k2*(4*s - 1))))) + f*(3*D1*bd1*(2*C*f*(3*k1**4*(2*Pk2 - Pkd2*k2)*(s - 1) - 2*k1**2*k2**2*(Pk2*(15*r + s - 13) + 12*Pkd2*k2*(s - 1)) + k2**4*(-2*Pk2*(25*r + 9*s - 18) - 9*Pkd2*k2*(s - 1))) - 42*Pk2*b2*k2**4*(r + s - 1) + f**2*k1**2*(9*Pk2*k2**2*(8*s - 5) + 5*k1**2*(4*Pk2*(r + 2*s - 2) + Pkd2*k2*(3 - 2*s))) + f*(2*k1**4*(6*Pk2*r - Pk2*s*(13*K - 13) + 3*Pkd2*k2*(s - 1)) + k1**2*k2**2*(Pk2*(-2*K*(64*r + 129*s - 64) + 145*r + 154*s - 125) - 9*Pkd2*k2*(s*(K - 4) + 4)) + 3*k2**4*(Pk2*(-14*K*(r + 2*s - 1) + 25*r + 6*s - 12) + 3*Pkd2*k2*(s - 1))) - 14*g2*(k1**4*(2*Pk2 - Pkd2*k2)*(s - 1) - 2*k1**2*k2**2*(Pk2*(5*r + 3*s - 7) + 4*Pkd2*k2*(s - 1)) - 3*k2**4*(2*Pk2*(r + s - 2) + Pkd2*k2*(s - 1)))) + D1*(-30*Pk2*f**2*fd*k1**4*(10*r + 24*s - 11) + f*(-162*Pk2*bd2*k1**2*k2**2*(r + s - 1) + fd*(4*Pk2*k1**4*(C*(19 - 57*s) + 15*r + 72*s - 29) + Pk2*k2**4*(6 - 12*C)*(51*r + 54*s - 35) + k1**2*k2**2*(Pk2*(-4*C*(336*r + 549*s - 295) + 873*r + 1512*s - 795) + Pkd2*k2*(15 - 30*C)*(3*s - 1))) + 6*gd2*(26*Pk2*k1**4*s + 42*Pk2*k2**4*(r + 2*s - 1) + k1**2*k2**2*(2*Pk2*(64*r + 129*s - 64) + 9*Pkd2*k2*s))) + 6*fd*(-27*Pk2*b2*k1**2*k2**2*(2*r + 2*s - 1) + g2*(26*Pk2*k1**4*(2*s - 1) + 84*Pk2*k2**4*(r + 2*s - 1) + k1**2*k2**2*(Pk2*(256*r + 516*s - 258) + 9*Pkd2*k2*(2*s - 1))))) + Dd*f*(-162*Pk2*b2*k1**2*k2**2*(4*r + 4*s - 3) - 30*Pk2*f**2*k1**4*(10*r + 24*s - 11) + f*(4*Pk2*k1**4*(C*(19 - 76*s) + 20*r + 96*s - 34) + Pk2*k2**4*(24 - 48*C)*(17*r + 18*s - 13) + k1**2*k2**2*(-2*Pk2*(2*C*(448*r + 732*s - 407) - 582*r - 1008*s + 543) + Pkd2*k2*(15 - 30*C)*(4*s - 1))) + 6*g2*(26*Pk2*k1**4*(4*s - 1) + 168*Pk2*k2**4*(r + 2*s - 1) + k1**2*k2**2*(2*Pk2*(256*r + 516*s - 257) + 9*Pkd2*k2*(4*s - 1))))))/(315*d*k2*k3**4) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*f*k1*st**5*(4*Pk2 - Pkd2*k2)*(3*b1*(D1*fd*(f*(6*s - 2) + 6*s - 3) + Dd*f*(2*f + 3)*(4*s - 1)) + f*(3*D1*bd1*s*(2*f + 3) + D1*fd*(3*s - 1) + Dd*f*(4*s - 1)))/(63*d*k3**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*f*k1*st**5*(D1*(6*f**2*(11*bd1*k2**2*(2*Pk2*(r - 1) + Pkd2*k2*s) + fd*(44*Pk2*k2**2*(1 - 2*r) + 9*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) - 11*f*k2**2*(9*bd1*(2*Pk2*(K*(r - 2*s - 1) - 2*r + 2) + Pkd2*k2*s*(2*K - 1)) + fd*(2*Pk2*(2*C*(3*r - 6*s + 1) + b1*(6 - 18*r) - 9*r + 6*s + 1) - Pkd2*k2*(3*s - 1)*(-4*C + 6*b1 + 3)) - 36*gd2*(Pk2*(r - 2*s - 1) + Pkd2*k2*s)) + 99*fd*k2**2*(b1*(-4*K*Pk2*(r - 2*s + 1) + 2*K*Pkd2*k2*(1 - 2*s) + 8*Pk2*r + Pkd2*k2*(2*s - 1)) + 4*g2*(2*Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1)))) + Dd*f*(6*f**2*(44*Pk2*k2**2*(1 - 2*r) + 9*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 11*f*k2**2*(8*Pk2*(-2*C*r + 4*C*s + b1*(6*r - 3) + 3*r - 2*s - 1) + Pkd2*k2*(4*s - 1)*(-4*C + 6*b1 + 3)) - 99*k2**2*(8*Pk2*b1*(-2*K*s + r*(K - 2) + 1) + Pkd2*b1*k2*(2*K - 1)*(4*s - 1) + 4*g2*(-4*Pk2*r + 8*Pk2*s - 4*Pkd2*k2*s + Pkd2*k2))))/(693*d*k3**4) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*k1*st**3*(4*Pk2 - Pkd2*k2)*(D1*bd1*f**2*s + b1**2*(D1*fd*(8*f*s - 4*f + 7*s - 7) + Dd*f*(4*f + 7)*(4*s - 1)) + b1*f*(2*D1*bd1*s*(4*f + 7) + D1*fd*(2*s - 1) + Dd*f*(4*s - 1)))/(35*d*k2**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*k1*st*(-21*b1**3*k2**2*(-2*D1*Pkd2*fd*k2*s + 20*Dd*Pk2*(K - 1)*(2*r - 1) - Dd*Pkd2*k2*(4*s - 1)*(-10*K + 2*f + 5)) + 3*b1**2*(D1*(-7*bd1*k2**2*(Pk2*(10*K - 10)*(3*r - 1) - Pkd2*k2*(3*s - 1)*(-10*K + 2*f + 5)) + fd*(Pk2*k1**2*s*(48*f + 14) - 14*Pk2*k2**2*(2*C*(r - 1) + 12*K*s - 12*K + 8*f*r - 3*f + 5*r + 8) - Pkd2*k1**2*k2*s*(24*f + 7) - Pkd2*k2**3*s*(28*C - 28*K - 21)) + 140*gd2*k2**2*(Pk2*(r - 1) + Pkd2*k2*s)) + Dd*(4*f**2*(28*Pk2*k2**2*(1 - 2*r) + 3*k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1)) + 7*f*(k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(-4*Pk2*(4*C*r - 2*C + 24*K*s - 6*K + 10*r - 5) - Pkd2*k2*(4*s - 1)*(4*C - 4*K - 3))) + 140*g2*k2**2*(Pk2*(4*r - 2) + Pkd2*k2*(4*s - 1)))) + 3*b1*(D1*bd1*(2*f**2*(7*Pk2*k2**2*(5 - 8*r) + 6*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1)) + 7*f*(k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1) - k2**2*(Pk2*(8*C*r + 48*K*s + 20*r - 26) + Pkd2*k2*(2*s - 1)*(4*C - 4*K - 3))) + 140*g2*k2**2*(2*Pk2*r + Pkd2*k2*(2*s - 1))) + 2*D1*(18*Pk2*f**2*fd*k1**2*(1 - 3*s) + f*(fd*k1**2*(-2*Pk2*(7*s - 5) - 3*Pkd2*k2*s) + fd*k2**2*(Pk2*(C*(40 - 80*s) + 14*K*(2*r + 6*s - 3) - 42*r + 40*s - 9) + Pkd2*k2*s*(24*C - 12)) + 14*k2**2*s*(12*Pk2*gd2 + Pkd2*bd2*k2 - 2*Pkd2*gd2*k2)) + 14*fd*k2**2*(12*Pk2*g2*(s - 1) + Pkd2*b2*k2*s - 2*Pkd2*g2*k2*s)) + Dd*f*(-36*Pk2*f**2*k1**2*(4*s - 1) - f*k1**2*(14*Pk2 + 3*Pkd2*k2)*(4*s - 1) + 4*f*k2**2*(Pk2*(C*(20 - 80*s) + 7*K*(4*r + 12*s - 5) - 42*r + 40*s + 11) + Pkd2*k2*(6*C - 3)*(4*s - 1)) + 28*k2**2*(4*s - 1)*(12*Pk2*g2 + Pkd2*b2*k2 - 2*Pkd2*g2*k2))) + f*(-3*D1*bd1*(36*Pk2*f**2*k1**2*s + f*(k1**2*(2*Pk2*(7*s + 3) + 3*Pkd2*k2*(s - 1)) - 2*k2**2*(Pk2*(-40*C*s + 14*K*(r + 3*s - 1) - 21*r + 20*s + 10) + Pkd2*k2*(12*C - 6)*(s - 1))) - 28*k2**2*(Pkd2*b2*k2*(s - 1) + 2*g2*(6*Pk2*s - Pkd2*k2*s + Pkd2*k2))) + 4*Pk2*(D1*(f*(fd*k1**2*(7 - 21*s) + fd*k2**2*(2*C - 1)*(39*r + 81*s - 40) + k2**2*(21*bd2 - 42*gd2)*(r + 3*s - 1)) + 21*fd*k2**2*(b2 - 2*g2)*(2*r + 6*s - 3)) + Dd*f*(f*k1**2*(7 - 28*s) + f*k2**2*(2*C - 1)*(52*r + 108*s - 53) + k2**2*(21*b2 - 42*g2)*(4*r + 12*s - 5)))))/(315*d*k2**2*k3**2) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*st*(4*D1*Pk2*bd1*f**2*(5*k1**2*s + k2**2*r*(4 - 8*C)) - 7*b1**3*k1**2*(2*Pk2 - Pkd2*k2)*(2*D1*fd*s + Dd*(2*f + 5)*(4*s - 1)) - 7*b1**2*k1**2*(D1*bd1*(2*Pk2 - Pkd2*k2)*(2*f + 5)*(3*s - 1) - D1*fd*(2*Pk2*(6*f*s - 3*f + 5*s - 6) + Pkd2*k2*s) - Dd*f*(4*s - 1)*(Pk2*(6*f + 10) + Pkd2*k2)) + b1*f*(7*D1*bd1*k1**2*(Pk2*s*(12*f + 20) + 2*Pk2 + Pkd2*k2*(2*s - 1)) - 4*Pk2*(D1*fd*(k1**2*(5 - 10*s) + k2**2*(8*C - 4)*(2*r - 1)) + Dd*f*(k1**2*(5 - 20*s) + k2**2*(16*C - 8)*(2*r - 1)))))/(105*d*k1*k2**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*st**3*(-3*b1**2*k1**2*k2**2*(D1*fd*(-2*Pk2*(-7*K*(r - 2*s + 2) + 4*f + 7*r + 7) + Pkd2*k2*(14*K*(s - 1) + 4*f + 7)) + 14*Dd*f*(K*Pkd2*k2*(4*s - 1) + Pk2*(-8*K*s + r*(4*K - 4) + 2))) + b1*k1**2*(D1*(4*f**2*(-3*Pk2*fd*k2**2*(18*r + 15*s - 13) + 3*bd1*k2**2*(-2*Pk2 + Pkd2*k2) + 2*fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) + 3*f*(fd*(k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) - k2**2*(2*Pk2*(C*(4*r - 8*s + 2) + 16*K*s - 8*K + 18*r + 36*s - 17) + Pkd2*k2*(C*(8*s - 4) - 16*K*s + 8*K - 4*s + 3))) - 7*k2**2*(Pk2*bd1*(K*(4*r - 8*s - 2) - 4*r + 4) + Pkd2*bd1*k2*(4*K*s - 1) + 4*gd2*(-Pk2*r + 2*Pk2*s + Pk2 - Pkd2*k2*s))) + 84*fd*g2*k2**2*(Pk2*(r - 2*s + 2) + Pkd2*k2*(s - 1))) + Dd*f*(4*f**2*(-3*Pk2*k2**2*(24*r + 20*s - 17) + 2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 3*f*(k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 2*k2**2*(4*Pk2*(2*C*r - 4*C*s + 8*K*s - 2*K + 9*r + 18*s - 9) + Pkd2*k2*(4*s - 1)*(2*C - 4*K - 1))) + 84*g2*k2**2*(4*Pk2*(r - 2*s) + Pkd2*k2*(4*s - 1)))) + f*(D1*(-4*bd1*f**2*k1**2*(-8*Pk2*k1**2*s + 3*Pk2*k2**2*(6*r + 5*s - 4) + 2*Pkd2*k1**2*k2*s) + f*(fd*(Pk2*k2**4*(32*C - 16)*(3*r - 1) + k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1) + 2*k1**2*k2**2*(Pk2*(-48*C*s + 16*C - 33*r + 11) + Pkd2*k2*(8*C - 4)*(3*s - 1))) - 3*k1**2*(bd1*(-4*Pk2*k1**2*s + 2*Pk2*k2**2*(r*(2*C + 9) + s*(-4*C + 8*K + 18) - 10) + Pkd2*k1**2*k2*s + Pkd2*k2**3*(s*(4*C - 8*K - 2) - 1)) + k2**2*s*(-2*Pk2 + Pkd2*k2)*(-8*bd2 + 16*gd2))) + 12*k1**2*k2**2*(-2*b2*fd*(2*Pk2 - Pkd2*k2)*(2*s - 1) + 7*bd1*g2*(Pk2*(r - 2*s) + Pkd2*k2*s) + 4*fd*g2*(2*Pk2 - Pkd2*k2)*(2*s - 1))) + Dd*f*(f*(Pk2*k2**4*(64*C - 32)*(2*r - 1) + k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 4*k1**2*k2**2*(Pk2*(-32*C*s + 8*C - 22*r + 11) + Pkd2*k2*(4*C - 2)*(4*s - 1))) + k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(24*b2 - 48*g2)*(4*s - 1))))/(105*d*k1*k2**2*k3**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*st**3*(D1*(-231*b1*fd*k1**2*k2**4*(-2*Pk2*b1*(K*(r + 2*s - 2) + r + 1) + 4*Pk2*g2*(r + 2*s - 2) + Pkd2*b1*k2*s*(2*K - 1) - 4*Pkd2*g2*k2*s) + 4*f**3*k1**2*(33*Pk2*bd1*k2**4*(4*r + 5*s - 6) - 33*Pk2*fd*k1**2*k2**2*(16*r + 20*s - 13) + 11*bd1*k1**2*k2**2*(2*Pk2*(5*r + 5*s - 6) + 3*Pkd2*k2) + 5*fd*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 11*f**2*k2**2*(3*bd1*(k1**4*(2*K*Pk2*(r - 1) - 8*Pk2*(r + s - 1) + Pkd2*k2*s*(2*K - 1)) + k1**2*k2**2*(Pk2*(-4*C*r - 8*C*s + K*(68*r + 88*s - 68) + 8*b1 - 22*r - 28*s + 24) + Pkd2*k2*(4*C*(s - 1) + 8*K*s + b1*(4 - 8*s) - 3*s + 3))) + fd*(Pk2*k2**4*(32*C - 16)*(3*r - 1) - k1**4*(2*Pk2*(-6*C*r + 2*C + 12*b1*(5*r + 5*s - 3) + 15*r + 12*s - 9) + Pkd2*k2*(-12*C*s + 4*C - 12*b1 + 9*s - 3)) + 2*k1**2*k2**2*(Pk2*(4*C*(51*r + 42*s - 31) - 6*b1*(12*r + 15*s - 7) - 135*r - 108*s + 81) + Pkd2*k2*(8*C - 4)*(3*s - 1))) - 12*k1**2*(-6*Pk2*bd2*k2**2*(r + s - 1) + gd2*k1**2*(Pk2*(r - 1) + Pkd2*k2*s) + 2*gd2*k2**2*(Pk2*(17*r + 22*s - 17) + 2*Pkd2*k2*s))) + 33*f*k1**2*k2**2*(-24*Pk2*b2*fd*k2**2*(2*r + 2*s - 1) + 8*b1**2*fd*k2**2*(Pk2 + Pkd2*k2*s) + b1*(fd*(k1**2*(-4*Pk2*(r*(K - 4) - 4*s + 2) + Pkd2*k2*(K*(2 - 4*s) + 2*s - 1)) - 2*k2**2*(Pk2*(C*(-4*r - 8*s + 6) + K*(68*r + 88*s - 44) - 22*r - 28*s + 13) + Pkd2*k2*(K*(8*s - 4) + s*(4*C - 3)))) - 7*k2**2*(Pk2*bd1*(K*(-4*r - 8*s + 2) - 4*r + 4) + 4*Pk2*gd2*(r + 2*s - 1) + Pkd2*bd1*k2*(2*K - 1)*(2*s - 1) - 4*Pkd2*gd2*k2*s)) - 28*bd1*g2*k2**2*(Pk2*(r + 2*s) + k2*(-Pkd2*s + Pkd2)) - 4*fd*g2*(-2*Pk2*k1**2*r - 4*Pk2*k2**2*(17*r + 22*s - 11) + Pkd2*k1**2*k2*(1 - 2*s) + Pkd2*k2**3*(4 - 8*s)))) + Dd*f*(-231*b1*k1**2*k2**4*(-4*Pk2*b1*(2*K*(r + 2*s - 1) + 2*r - 1) + 16*Pk2*g2*(r + 2*s - 1) + Pkd2*b1*k2*(2*K - 1)*(4*s - 1) + 4*Pkd2*g2*k2*(1 - 4*s)) + 4*f**3*k1**4*(-33*Pk2*k2**2*(16*r + 20*s - 13) + 5*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 11*f**2*k2**2*(Pk2*k2**4*(64*C - 32)*(2*r - 1) + k1**4*(-4*Pk2*(-4*C*r + 2*C + 10*b1*(4*r + 4*s - 3) + 10*r + 8*s - 7) + Pkd2*k2*(4*C - 3)*(4*s - 1)) + 4*k1**2*k2**2*(Pk2*(8*C*(17*r + 14*s - 12) + b1*(-48*r - 60*s + 39) - 90*r - 72*s + 63) + Pkd2*k2*(4*C - 2)*(4*s - 1))) + 33*f*k1**2*k2**2*(-24*Pk2*b2*k2**2*(4*r + 4*s - 3) + 4*Pkd2*b1**2*k2**3*(4*s - 1) + b1*k1**2*(-4*Pk2*(K*(2*r - 1) - 8*r - 8*s + 6) + Pkd2*k2*(K*(2 - 8*s) + 4*s - 1)) + b1*k2**2*(8*Pk2*(2*C*(r + 2*s - 1) + K*(-34*r - 44*s + 28) + 11*r + 14*s - 9) - Pkd2*k2*(4*s - 1)*(4*C + 8*K - 3)) + 4*g2*k1**2*(Pk2*(4*r - 2) + Pkd2*k2*(4*s - 1)) + 16*g2*k2**2*(Pk2*(34*r + 44*s - 28) + Pkd2*k2*(4*s - 1)))))/(1155*d*k1*k2**2*k3**4) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*st*(D1*bd1*(210*Pk2*b1*k1**2*k2**4*(b1*(2*K - 1)*(3*r + 3*s - 2) - 4*g2*(2*r + 2*s - 1)) + 2*f**3*k1**4*(9*Pk2*k2**2*(5 - 8*r) + 5*k1**2*(2*Pk2 - Pkd2*k2)*(s - 1)) + 3*f**2*k2**2*(Pk2*k2**4*r*(16 - 32*C) + k1**4*(2*Pk2*(-6*C*(r + 2*s - 2) - 6*K*r - 26*K*s + 6*K + 6*b1*(8*r + 8*s - 7) + 15*r + 31*s - 21) + 3*Pkd2*k2*(6*b1*(2*s - 1) - (4*C - 3)*(s - 1))) - 2*k1**2*k2**2*(Pk2*(4*C*(27*r + 22*s - 25) + 14*K*r + 42*K*s - 14*K - 21*b1*(4*r + 2*s - 3) - 75*r - 54*s + 60) + Pkd2*k2*(12*C - 6)*(s - 1))) - 21*f*k1**2*k2**2*(4*Pk2*b1**2*k2**2*(3*r + 3*s - 2) + 12*Pk2*b2*k2**2*(r + s - 1) + b1*k1**2*(2*Pk2*(K*(2*r + 4*s - 3) - 8*r - 10*s + 9) + Pkd2*k2*(2*K - 1)*(2*s - 1)) - 4*b1*k2**2*(K*Pkd2*k2*(1 - 2*s) + Pk2*(C*(4*r + 4*s - 2) - 2*K*(9*r + 10*s - 10) + 4*r + 3*s - 5)) - 4*g2*k1**2*(Pk2*(r + 2*s - 2) + Pkd2*k2*(s - 1)) - 8*g2*k2**2*(Pk2*(9*r + 10*s - 11) + Pkd2*k2*(s - 1)))) - 42*Pk2*b1**3*k1**2*k2**4*(2*D1*fd*(r + s - 1) + Dd*(-10*K + 2*f + 5)*(4*r + 4*s - 3)) - 2*Pk2*f*k1**2*(D1*(15*f**2*fd*k1**4*(4*s - 1) + 2*f*k2**2*(9*bd2*k1**2*(r + s - 1) + fd*(k1**2*(6*C*(5*r + 19*s - 8) - 15*r - 78*s + 31) + k2**2*(2*C - 1)*(39*r + 81*s - 40)) - 6*gd2*(k1**2*(3*r + 13*s - 3) + 7*k2**2*(r + 3*s - 1))) - 6*fd*k2**2*(-3*b2*k1**2*(2*r + 2*s - 1) + 2*g2*(k1**2*(6*r + 26*s - 13) + 7*k2**2*(2*r + 6*s - 3)))) + Dd*f*(15*f**2*k1**4*(4*s - 1) + 2*f*(2*k1**2*k2**2*(20*C*r + 76*C*s - 29*C - 10*r - 52*s + 18) + k2**4*(2*C - 1)*(52*r + 108*s - 53)) + 6*k2**2*(3*b2*k1**2*(4*r + 4*s - 3) - 2*g2*(k1**2*(12*r + 52*s - 19) + 7*k2**2*(4*r + 12*s - 5))))) + 3*b1**2*k1**2*k2**2*(12*D1*f*fd*(7*Pk2*k2**2*(2*r + s - 1) + k1**2*(Pk2*(8*r + 8*s - 5) + 3*Pkd2*k2*s)) + 7*D1*(-40*Pk2*gd2*k2**2*(r + s - 1) + fd*(-4*K*Pkd2*k2**3*s - 2*Pk2*k1**2*(r*(K - 4) + s*(2*K - 5)) + 2*Pk2*k2**2*(4*C*(r + s - 1) - 2*K*(9*r + 10*s + 1) + 4*r + 3*s + 3) + Pkd2*k1**2*k2*s*(1 - 2*K))) - 280*Dd*Pk2*g2*k2**2*(4*r + 4*s - 3) + 6*Dd*f**2*(7*Pk2*k2**2*(8*r + 4*s - 5) + k1**2*(8*Pk2*(4*r + 4*s - 3) + 3*Pkd2*k2*(4*s - 1))) - 7*Dd*f*(k1**2*(2*Pk2*(4*K*(r + 2*s - 1) - 16*r - 20*s + 13) + Pkd2*k2*(2*K - 1)*(4*s - 1)) + 2*k2**2*(2*K*Pkd2*k2*(4*s - 1) + Pk2*(-4*C*(4*r + 4*s - 3) + 8*K*(9*r + 10*s - 7) - 16*r - 12*s + 11)))) + b1*(-6*D1*(f**2*fd*k1**4*(-10*Pk2*k1**2*s + 3*Pk2*k2**2*(24*r - 11) + 5*Pkd2*k1**2*k2*s) + f*k2**2*(fd*(Pk2*k2**4*(16*C - 8)*(2*r - 1) + k1**4*(Pk2*(6*C*(2*r + 4*s - 1) + 2*K*(6*r + 26*s - 13) - 30*r - 62*s + 25) + Pkd2*k2*s*(12*C - 9)) + k1**2*k2**2*(Pk2*(8*C*(27*r + 22*s - 12) + 14*K*(2*r + 6*s - 3) - 150*r - 108*s + 69) + Pkd2*k2*s*(24*C - 12))) - 14*k1**2*(-3*Pk2*bd2*k2**2*(r + s - 1) + gd2*k1**2*(Pk2*(r + 2*s - 1) + Pkd2*k2*s) + 2*gd2*k2**2*(Pk2*(9*r + 10*s - 9) + Pkd2*k2*s))) - 14*fd*k1**2*k2**2*(-3*Pk2*b2*k2**2*(r + s) + g2*(Pk2*k1**2*(r + 2*s) + 2*Pk2*k2**2*(9*r + 10*s + 1) + Pkd2*k1**2*k2*s + 2*Pkd2*k2**3*s))) + Dd*f*(2*f**2*k1**4*(144*Pk2*k2**2*(1 - 2*r) + 5*k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1)) - 3*f*k2**2*(Pk2*k2**4*(64*C - 32)*(2*r - 1) + k1**4*(2*Pk2*(24*C*(r + 2*s - 1) + 2*K*(12*r + 52*s - 19) - 60*r - 124*s + 61) + Pkd2*k2*(12*C - 9)*(4*s - 1)) + 4*k1**2*k2**2*(Pk2*(8*C*(27*r + 22*s - 19) + 7*K*(4*r + 12*s - 5) - 150*r - 108*s + 102) + Pkd2*k2*(6*C - 3)*(4*s - 1))) + 84*k1**2*k2**2*(-3*Pk2*b2*k2**2*(4*r + 4*s - 3) + g2*k1**2*(4*Pk2*(r + 2*s - 1) + Pkd2*k2*(4*s - 1)) + 2*g2*k2**2*(4*Pk2*(9*r + 10*s - 7) + Pkd2*k2*(4*s - 1))))))/(315*d*k1*k2**2*k3**4) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*f**3*k1**2*k2*st**7*(-4*Pk2 + Pkd2*k2)*(4*s - 1)*(D1*fd + Dd*f)/(99*d*k3**4) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*f*st**5*(-3*D1*bd1*f*(-3*K*Pkd2*k2**3*s - 4*Pk2*f*k1**2*s + 3*Pk2*k2**2*(2*K*s + f*(r - 1) + r - 1) + Pkd2*f*k1**2*k2*s) + 3*b1*(D1*fd*(3*K*k2**2*(-2*Pk2 + Pkd2*k2)*(2*s - 1) + 3*Pk2*f*k2**2*(1 - 3*r) - 6*Pk2*k2**2*r + f*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) + Dd*f*(f*(6*Pk2*k2**2*(1 - 2*r) + k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 3*k2**2*(K*Pkd2*k2*(4*s - 1) + Pk2*(-8*K*s + 2*K - 4*r + 2)))) + k2**2*(-2*C*f*(2*Pk2 - Pkd2*k2)*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1)) - 18*D1*Pk2*bd2*f*s - 3*D1*Pk2*f*fd*r + 6*D1*Pk2*f*fd*s - D1*Pk2*f*fd + 36*D1*Pk2*f*gd2*s + 72*D1*Pk2*fd*g2*s - 36*D1*Pk2*fd*g2 + 9*D1*Pkd2*bd2*f*k2*s - 3*D1*Pkd2*f*fd*k2*s + D1*Pkd2*f*fd*k2 - 18*D1*Pkd2*f*gd2*k2*s - 36*D1*Pkd2*fd*g2*k2*s + 18*D1*Pkd2*fd*g2*k2 - 4*Dd*Pk2*f**2*r + 8*Dd*Pk2*f**2*s + 144*Dd*Pk2*f*g2*s - 36*Dd*Pk2*f*g2 - 4*Dd*Pkd2*f**2*k2*s + Dd*Pkd2*f**2*k2 - 72*Dd*Pkd2*f*g2*k2*s + 18*Dd*Pkd2*f*g2*k2 - 9*b2*(2*Pk2 - Pkd2*k2)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1))))/(63*d*k2*k3**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*f*st**5*(D1*(f**2*(99*Pk2*bd1*k2**4*(r - 1) - 132*Pk2*fd*k1**2*k2**2*(3*r + 2*s - 2) + 11*bd1*k1**2*k2**2*(4*Pk2*(2*r + s - 2) + Pkd2*k2*(2*s + 1)) + 9*fd*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 11*f*k2**2*(-3*b1*fd*(3*Pk2*k2**2*(3*r - 1) + k1**2*(4*Pk2*(2*r + s - 1) + Pkd2*k2*(2*s - 1))) + k2**2*(24*C*Pk2*fd*r + 12*C*Pk2*fd*s - 12*C*Pk2*fd + 6*C*Pkd2*fd*k2*s - 2*C*Pkd2*fd*k2 + 18*Pk2*bd2*(r + s - 1) - 15*Pk2*fd*r - 6*Pk2*fd*s + 7*Pk2*fd - 72*Pk2*gd2*r - 36*Pk2*gd2*s + 72*Pk2*gd2 - 3*Pkd2*fd*k2*s + Pkd2*fd*k2 - 18*Pkd2*gd2*k2*s + 9*bd1*(2*K*Pk2*(2*r + s - 2) + K*Pkd2*k2*s - Pk2*r + Pk2))) + 99*fd*k2**4*(-2*Pk2*b2*(2*r + 2*s - 1) + b1*(K*Pk2*(-8*r - 4*s + 2) + K*Pkd2*k2*(1 - 2*s) + 2*Pk2*r) + 2*g2*(Pk2*(8*r + 4*s - 2) + Pkd2*k2*(2*s - 1)))) + Dd*f*(3*f**2*(-44*Pk2*k1**2*k2**2*(3*r + 2*s - 2) + 3*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 11*f*(2*b1*k2**2*(9*Pk2*k2**2*(2*r - 1) + k1**2*(2*Pk2*(8*r + 4*s - 5) + Pkd2*k2*(4*s - 1))) + k2**4*(-4*Pk2*(C*(8*r + 4*s - 5) - 5*r - 2*s + 3) + Pkd2*k2*(C*(2 - 8*s) + 4*s - 1))) - 99*k2**4*(K*Pkd2*b1*k2*(4*s - 1) + 2*Pk2*b1*(K*(8*r + 4*s - 5) - 2*r + 1) + 2*Pk2*b2*(4*r + 4*s - 3) - 4*Pk2*g2*(8*r + 4*s - 5) + 2*Pkd2*g2*k2*(1 - 4*s))))/(693*d*k2*k3**4) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*st**3*(D1*bd1*f*(Pk2*f*(4*C*s + r - 2*s) + Pkd2*f*k2*s*(1 - 2*C) + s*(2*Pk2 - Pkd2*k2)*(7*b2 - 14*g2)) + 7*b1**2*(D1*fd*(K*(2*Pk2 - Pkd2*k2)*(s - 1) + Pk2*f*(2*r - 1) + Pk2*r) + Dd*f*(K*Pkd2*k2*(1 - 4*s) + Pk2*(8*K*s - 2*K + f*(4*r - 2) + 4*r - 2))) + b1*(8*C*D1*Pk2*f*fd*s - 4*C*D1*Pk2*f*fd - 4*C*D1*Pkd2*f*fd*k2*s + 2*C*D1*Pkd2*f*fd*k2 + 16*C*Dd*Pk2*f**2*s - 4*C*Dd*Pk2*f**2 - 8*C*Dd*Pkd2*f**2*k2*s + 2*C*Dd*Pkd2*f**2*k2 + 14*D1*Pk2*bd2*f*s + 2*D1*Pk2*f*fd*r - 4*D1*Pk2*f*fd*s + D1*Pk2*f*fd - 28*D1*Pk2*f*gd2*s - 28*D1*Pk2*fd*g2*s + 28*D1*Pk2*fd*g2 - 7*D1*Pkd2*bd2*f*k2*s + 2*D1*Pkd2*f*fd*k2*s - D1*Pkd2*f*fd*k2 + 14*D1*Pkd2*f*gd2*k2*s + 14*D1*Pkd2*fd*g2*k2*s - 14*D1*Pkd2*fd*g2*k2 + 7*D1*bd1*f*(-2*K*Pkd2*k2*s + Pk2*(4*K*s + 2*f*r - f + 2*r - 1)) + 4*Dd*Pk2*f**2*r - 8*Dd*Pk2*f**2*s - 112*Dd*Pk2*f*g2*s + 28*Dd*Pk2*f*g2 + 4*Dd*Pkd2*f**2*k2*s - Dd*Pkd2*f**2*k2 + 56*Dd*Pkd2*f*g2*k2*s - 14*Dd*Pkd2*f*g2*k2 + 7*b2*(2*Pk2 - Pkd2*k2)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))))/(35*d*k2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*st*(2*D1*Pk2*bd1*f*s*(5*b2 + f*(2*C - 1) - 10*g2) - 5*b1**3*(D1*Pk2*fd*(r - 1) + Dd*K*Pkd2*k2*(1 - 4*s) + 2*Dd*Pk2*(f + 1)*(2*r - 1)) + b1**2*(5*D1*Pkd2*k2*s*(bd2 - 2*gd2) - 5*D1*bd1*(K*Pkd2*k2*(1 - 3*s) + Pk2*(f + 1)*(3*r - 1)) + D1*fd*(10*K*Pk2*(s - 1) - Pk2*r + Pk2 + Pkd2*k2*s*(2*C - 1)) + 2*Dd*Pk2*f*(5*K*(4*s - 1) - 2*r + 1) + Dd*Pkd2*f*k2*(2*C - 1)*(4*s - 1) + 5*Dd*Pkd2*k2*(b2 - 2*g2)*(4*s - 1)) + b1*(D1*(f*(-2*Pk2*bd1*(-10*K*s + r) + Pk2*fd*(4*C - 2)*(2*s - 1) + Pk2*s*(10*bd2 - 20*gd2) + Pkd2*bd1*k2*(2*C - 1)*(2*s - 1)) + 10*g2*(-2*Pk2*fd*(s - 1) + Pkd2*bd1*k2*(1 - 2*s))) + 2*Dd*Pk2*f*(4*s - 1)*(f*(2*C - 1) - 10*g2) + 5*b2*(2*D1*Pk2*fd*(s - 1) + D1*Pkd2*bd1*k2*(2*s - 1) + 2*Dd*Pk2*f*(4*s - 1))))/(15*d*k2) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*st**3*(3*D1*bd1*f*(3*Pk2*f**2*k1**2*(2*r + 4*s - 1) - f*(k1**2*(-Pk2*(2*K*s + b1*(6 - 8*s) + r + 2*s - 1) + Pkd2*k2*(K*s + b1*(3 - 4*s))) + k2**2*(14*K*Pk2*(r + 2*s - 1) - (2*C - 1)*(2*Pk2*r + Pkd2*k2))) + 7*k2**2*(K*b1*(Pk2*(4*r - 2) + Pkd2*k2) - Pkd2*b2*k2*(s - 1) - 2*g2*(2*Pk2*r + Pkd2*k2))) - 3*b1**2*(D1*fd*(7*K*k2**2*(-2*Pk2*r + Pkd2*k2) + f*k1**2*(2*Pk2 - Pkd2*k2)*(4*s + 1)) + 2*Dd*f*(14*K*Pk2*k2**2*(1 - 2*r) + f*k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1))) + 3*b1*(D1*(3*Pk2*f**2*fd*k1**2*(6*r + 12*s - 7) + f*fd*(k1**2*(K*Pkd2*k2*(1 - 2*s) + 2*Pk2*(K*(2*s - 1) + r + 2*s - 1)) + k2**2*(Pk2*(C*(8*r - 4) - 28*K*(r + 2*s - 1) - 4*r + 2) + Pkd2*k2*(1 - 2*C))) - 7*f*k2**2*(4*Pk2*gd2*(r - 1) + Pkd2*bd2*k2*s) - 7*fd*k2**2*(4*Pk2*g2*r + Pkd2*b2*k2*s - 2*Pkd2*g2*k2)) + Dd*f*(24*Pk2*f**2*k1**2*(r + 2*s - 1) + f*(-4*Pk2*k2**2*(C*(2 - 4*r) + 14*K*(r + 2*s - 1) + 2*r - 1) + k1**2*(K*Pkd2*k2*(1 - 4*s) + Pk2*(8*K*s - 2*K + 4*r + 8*s - 4))) + 7*k2**2*(8*Pk2*g2*(1 - 2*r) + Pkd2*b2*k2*(1 - 4*s)))) + f*(D1*(168*Pk2*fd*g2*k2**2*(r + 2*s - 1) + f*fd*(Pk2*k2**2*(2 - 4*C)*(21*r + 18*s - 13) + k1**2*(Pk2*(12*C*s - 4*C + 3*r - 1) + Pkd2*k2*(-6*C*s + 2*C + 3*s - 1))) - 3*f*(bd2 - 2*gd2)*(-2*Pk2*k1**2*s + 14*Pk2*k2**2*(r + 2*s - 1) + Pkd2*k1**2*k2*s) - 6*fd*g2*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1)) + Dd*f*(-Pk2*f*k2**2*(16*C - 8)*(7*r + 6*s - 5) + 336*Pk2*g2*k2**2*(r + 2*s - 1) + f*k1**2*(2*Pk2*(C*(8*s - 2) + 2*r - 1) + Pkd2*k2*(C*(2 - 8*s) + 4*s - 1)) - 6*g2*k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1)) + 3*b2*(D1*fd*(-28*Pk2*k2**2*(r + 2*s - 1) + k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1)) + Dd*f*(-56*Pk2*k2**2*(r + 2*s - 1) + k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1)))))/(105*d*k2*k3**2) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*st*(-7*b1**3*k2*(-D1*fd*(5*Pk2*k2*(r - 1) + Pkd2*k1**2*s) + Dd*(5*K*Pkd2*k2**2*(4*s - 1) + 10*Pk2*k2*(K*(4*r + 4*s - 3) - 2*f*r + f - 2*r + 1) + Pkd2*f*k1**2*(1 - 4*s))) - 7*b1**2*(D1*(4*C*Pk2*fd*k2**2*r + 4*C*Pk2*fd*k2**2*s - 4*C*Pk2*fd*k2**2 + 2*C*Pkd2*fd*k2**3*s - 10*K*Pk2*fd*k2**2*r - 10*K*Pk2*fd*k2**2 - K*Pkd2*fd*k1**2*k2*s + Pk2*fd*k1**2*r + 2*Pk2*fd*k1**2*s - 3*Pk2*fd*k2**2*r - 2*Pk2*fd*k2**2*s + 3*Pk2*fd*k2**2 - 20*Pk2*gd2*k2**2*r - 20*Pk2*gd2*k2**2*s + 20*Pk2*gd2*k2**2 - Pkd2*fd*k2**3*s - 10*Pkd2*gd2*k2**3*s + 5*bd1*k2**2*(K*Pk2*(6*r + 6*s - 4) + K*Pkd2*k2*(3*s - 1) - 3*Pk2*r + Pk2) + f*(Pk2*fd*k1**2*(12*r + 8*s - 7) + bd1*k2*(5*Pk2*k2*(1 - 3*r) + Pkd2*k1**2*(1 - 3*s)))) + Dd*(8*Pk2*f**2*k1**2*(3*r + 2*s - 2) + f*(k1**2*(K*Pkd2*k2*(1 - 4*s) + 4*Pk2*(r + 2*s - 1)) + k2**2*(4*Pk2*(C*(4*r + 4*s - 3) - 10*K*r + 5*K - 3*r - 2*s + 2) + Pkd2*k2*(2*C - 1)*(4*s - 1))) - 10*g2*k2**2*(Pk2*(8*r + 8*s - 6) + Pkd2*k2*(4*s - 1)))) + b1*(-7*D1*bd1*(Pk2*f**2*k1**2*(12*r + 8*s - 9) + f*(k1**2*(K*Pkd2*k2*(1 - 2*s) + Pk2*(2*r + 4*s - 3)) + k2**2*(Pk2*(C*(8*r + 8*s - 4) - 20*K*(r - 1) - 6*r - 4*s + 2) + Pkd2*k2*(2*C - 1)*(2*s - 1))) - 10*g2*k2**2*(Pk2*(4*r + 4*s - 2) + Pkd2*k2*(2*s - 1))) + D1*(f*(fd*(Pk2*k2**2*(8*C - 4)*(15*r - 4) + k1**2*(Pk2*(28*K*s - 14*K - 6*r - 12*s + 3) + Pkd2*k2*s*(12*C - 6))) + 7*k2*(10*Pk2*bd2*k2*(r + s - 1) - 20*Pk2*gd2*k2*(r - 1) + Pkd2*bd2*k1**2*s - 2*Pkd2*gd2*k1**2*s)) + 7*fd*k2*(10*Pk2*b2*k2*(r + s) - 20*Pk2*g2*k2*(r + 1) + Pkd2*b2*k1**2*s - 2*Pkd2*g2*k1**2*s)) + Dd*f*(f*(Pk2*k2**2*(120*C - 60)*(2*r - 1) + k1**2*(2*Pk2*(28*K*s - 7*K - 6*r - 12*s + 6) + Pkd2*k2*(6*C - 3)*(4*s - 1))) + 7*k2*(10*Pk2*b2*k2*(4*r + 4*s - 3) + 40*Pk2*g2*k2*(1 - 2*r) + Pkd2*b2*k1**2*(4*s - 1) + 2*Pkd2*g2*k1**2*(1 - 4*s)))) + f*(D1*bd1*(f*(Pk2*k2**2*(4*C - 2)*(15*r - 7) + k1**2*(Pk2*(14*K*s - 3*r - 6*s + 6) + Pkd2*k2*(6*C - 3)*(s - 1))) + 7*k2*(10*Pk2*b2*k2*(r + s - 1) - 20*Pk2*g2*k2*(r - 1) + Pkd2*b2*k1**2*(s - 1) - 2*Pkd2*g2*k1**2*(s - 1))) + 2*Pk2*k1**2*(D1*(f*fd*(6*C - 3)*(3*s - 1) + 7*f*s*(bd2 - 2*gd2) + 14*fd*g2*(1 - 2*s)) + Dd*f*(4*s - 1)*(f*(6*C - 3) - 14*g2) + 7*b2*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)))))/(105*d*k2*k3**2) - np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*st**3*(D1*bd1*f*(f**2*k1**2*(3*Pk2*k2**2*(5 - 8*s) + k1**2*(-4*Pk2*(r + 2*s - 2) + Pkd2*k2*(2*s - 3))) + 3*f*k2**2*(k1**2*(-Pk2*(-2*K*(4*r + 5*s - 4) + 2*b1*(4*r + 4*s - 5) + r + 2*s - 1) + Pkd2*k2*(K*s + b1*(3 - 6*s))) + k2**2*(Pk2*(4*C*(r + s - 2) + 14*K*r + 28*K*s - 14*K + b1*(7 - 14*r) - 3*r - 2*s + 4) + Pkd2*k2*(2*C - 1)*(s - 1))) + 21*k2**4*(2*Pk2*b2*(r + s - 1) - 4*Pk2*g2*(r + s - 2) - 2*Pkd2*g2*k2*(s - 1) + b1*(K*Pk2*(4*r + 4*s - 6) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r + Pk2))) + 3*b1**2*k2**2*(D1*fd*(-f*(7*Pk2*k2**2*(2*r - 1) + k1**2*(Pk2*(8*r + 8*s - 2) + 6*Pkd2*k2*s)) + 7*k2**2*(2*K*Pk2*(r + s + 1) + K*Pkd2*k2*s - Pk2*r)) + Dd*f*(f*(14*Pk2*k2**2*(1 - 2*r) + k1**2*(-4*Pk2*(4*r + 4*s - 3) + 3*Pkd2*k2*(1 - 4*s))) + 7*k2**2*(K*Pkd2*k2*(4*s - 1) + Pk2*(K*(8*r + 8*s - 6) - 4*r + 2)))) + b1*(D1*(f**2*fd*k1**2*(9*Pk2*k2**2*(1 - 8*s) + k1**2*(-4*Pk2*(3*r + 6*s - 2) + Pkd2*k2*(6*s + 1))) + 3*f*k2**2*(fd*(k1**2*(K*Pkd2*k2*(2*s - 1) + 2*Pk2*(K*(8*r + 10*s - 5) - r - 2*s + 1)) + k2**2*(Pk2*(8*C*r + 8*C*s + 28*K*(r + 2*s - 1) - 6*r - 4*s + 1) + Pkd2*k2*s*(4*C - 2))) + 14*k2**2*(Pk2*bd2*(r + s - 1) - gd2*(2*Pk2*(r + s - 1) + Pkd2*k2*s))) - 42*fd*k2**4*(-Pk2*b2*(r + s) + 2*Pk2*g2*(r + s + 1) + Pkd2*g2*k2*s)) + Dd*f*(-2*f**2*k1**2*(12*Pk2*k2**2*(4*s - 1) + k1**2*(8*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 4*s))) + 3*f*k2**2*(k1**2*(K*Pk2*(32*r + 40*s - 26) + K*Pkd2*k2*(4*s - 1) - 4*Pk2*(r + 2*s - 1)) + k2**2*(4*Pk2*(C*(4*r + 4*s - 3) + 14*K*(r + 2*s - 1) - 3*r - 2*s + 2) + Pkd2*k2*(2*C - 1)*(4*s - 1))) + 42*k2**4*(Pk2*b2*(4*r + 4*s - 3) + Pk2*g2*(-8*r - 8*s + 6) + Pkd2*g2*k2*(1 - 4*s)))) + f*(D1*(2*Pk2*f**2*fd*k1**4*(10*r + 24*s - 11) + f*k2**2*(18*Pk2*bd2*k1**2*(r + s - 1) + Pk2*fd*k2**2*(4*C - 2)*(21*r + 18*s - 13) - 84*Pk2*gd2*k2**2*(r + 2*s - 1) + fd*k1**2*(3*Pk2*(4*C*(4*r + 5*s - 3) - 9*r - 12*s + 7) + Pkd2*k2*(2*C - 1)*(3*s - 1)) - 6*gd2*k1**2*(2*Pk2*(4*r + 5*s - 4) + Pkd2*k2*s)) + 6*fd*k2**2*(3*Pk2*b2*k1**2*(2*r + 2*s - 1) - 28*Pk2*g2*k2**2*(r + 2*s - 1) + g2*k1**2*(-2*Pk2*(8*r + 10*s - 5) + Pkd2*k2*(1 - 2*s)))) + Dd*f*(2*Pk2*f**2*k1**4*(10*r + 24*s - 11) + f*k2**2*(Pk2*k2**2*(16*C - 8)*(7*r + 6*s - 5) + k1**2*(C*Pk2*(64*r + 80*s - 52) - 6*Pk2*(6*r + 8*s - 5) + Pkd2*k2*(2*C - 1)*(4*s - 1))) + 6*k2**2*(3*Pk2*b2*k1**2*(4*r + 4*s - 3) - 56*Pk2*g2*k2**2*(r + 2*s - 1) + g2*k1**2*(Pk2*(-32*r - 40*s + 26) + Pkd2*k2*(1 - 4*s))))))/(105*d*k2*k3**4) + np.sqrt(6)*1j*np.sqrt(np.pi)*D1**3*Pk3*st*(-14*Pk2*b1**3*k2**2*(2*D1*fd*k1**2*(r + s - 1) + Dd*(-5*K*k2**2 + 2*f*k1**2)*(4*r + 4*s - 3)) + b1**2*(D1*(70*Pk2*k2**4*(K*bd1*(3*r + 3*s - 2) - 2*gd2*(r + s - 1)) + f*k1**2*(-28*Pk2*bd1*k2**2*(3*r + 3*s - 2) + 21*Pk2*fd*k2**2*(6*r + 4*s - 3) + 6*fd*k1**2*(Pk2*(4*r + 4*s - 3) + Pkd2*k2*s)) + 7*fd*k2**2*(-K*Pkd2*k1**2*k2*s + Pk2*k1**2*(-8*K*r + r + s*(2 - 12*K)) - 2*Pk2*k2**2*(-2*C*(r + s - 1) + 5*K*r + 5*K*s + r + s - 1))) + Dd*(-140*Pk2*g2*k2**4*(4*r + 4*s - 3) + 3*f**2*k1**2*(28*Pk2*k2**2*(3*r + 2*s - 2) + k1**2*(4*Pk2*(4*r + 4*s - 3) + Pkd2*k2*(4*s - 1))) - 7*f*k2**2*(Pk2*k2**2*(-4*C + 10*K + 2)*(4*r + 4*s - 3) + k1**2*(K*Pkd2*k2*(4*s - 1) + 4*Pk2*(K*(8*r + 12*s - 7) - r - 2*s + 1))))) + b1*(D1*bd1*(-140*Pk2*g2*k2**4*(2*r + 2*s - 1) + 3*f**2*k1**2*(7*Pk2*k2**2*(6*r + 4*s - 5) + k1**2*(Pk2*(8*r + 8*s - 6) + Pkd2*k2*(2*s - 1))) - 7*f*k2**2*(2*Pk2*k2**2*(C*(-4*r - 4*s + 2) + 10*K*(r + s - 1) + 2*r + 2*s - 1) + k1**2*(K*Pkd2*k2*(2*s - 1) + Pk2*(4*K*(4*r + 6*s - 5) - 2*r - 4*s + 3)))) + D1*(-3*Pk2*f**2*fd*k1**4*(15*r + 12*s - 8) + f*k2**2*(-42*Pk2*bd2*k1**2*(r + s - 1) - Pk2*fd*k2**2*(4*C - 2)*(30*r + 14*s - 15) + 140*Pk2*gd2*k2**2*(r + s - 1) + fd*k1**2*(Pk2*(-48*C*(2*r + 3*s - 1) - 28*K*s + 14*K + 54*r + 84*s - 27) + Pkd2*k2*s*(6 - 12*C)) + 14*gd2*k1**2*(4*Pk2*(2*r + 3*s - 2) + Pkd2*k2*s)) + 14*fd*k2**2*(-3*Pk2*b2*k1**2*(r + s) + 10*Pk2*g2*k2**2*(r + s) + g2*k1**2*(8*Pk2*r + 12*Pk2*s + Pkd2*k2*s))) + Dd*f*(-6*Pk2*f**2*k1**4*(10*r + 8*s - 7) + f*k2**2*(Pk2*k2**2*(2 - 4*C)*(60*r + 28*s - 37) + k1**2*(-2*Pk2*(12*C*(8*r + 12*s - 7) + 28*K*s - 7*K - 54*r - 84*s + 48) + 3*Pkd2*k2*(C*(2 - 8*s) + 4*s - 1))) + 14*k2**2*(-3*Pk2*b2*k1**2*(4*r + 4*s - 3) + 10*Pk2*g2*k2**2*(4*r + 4*s - 3) + g2*k1**2*(4*Pk2*(8*r + 12*s - 7) + Pkd2*k2*(4*s - 1))))) + f*(D1*bd1*(-3*Pk2*f**2*k1**4*(5*r + 4*s - 6) + f*k2**2*(Pk2*k2**2*(2 - 4*C)*(15*r + 7*s - 7) + k1**2*(Pk2*(-24*C*(2*r + 3*s - 3) + 27*r - 14*s*(K - 3) - 42) + 3*Pkd2*k2*(-2*C*(s - 1) + s - 1))) + 14*k2**2*(-3*Pk2*b2*k1**2*(r + s - 1) + 10*Pk2*g2*k2**2*(r + s - 1) + g2*k1**2*(4*Pk2*(2*r + 3*s - 3) + Pkd2*k2*(s - 1)))) + 2*Pk2*k1**2*k2**2*(D1*(-f*fd*(6*C - 3)*(3*s - 1) + 14*f*gd2*s + 14*fd*g2*(2*s - 1)) - Dd*f*(4*s - 1)*(f*(6*C - 3) - 14*g2))))/(105*d*k2*k3**4)
        
        return (perm12+perm13+perm23)
    
    def l3(cosmo_functions,k1,k2,k3=None,theta=None,zz=0,r=0,s=0,nonlin=False,growth2=False):
        
        #get generic cosmology parameters
        k1,k2,k3,theta,Pk1,Pk2,Pk3,Pkd1,Pkd2,Pkd3,Pkdd1,Pkdd2,Pkdd3,d,K,C,f,D1,b1,b2,g2 = cosmo_functions.get_params(k1,k2,k3,theta,zz,nonlin=nonlin,growth2=growth2)
        
        fd,Dd,gd2,bd2,bd1,fdd,Ddd,gdd2,bdd2,bdd1 = cosmo_functions.get_derivs(zz)
        
        st = np.sin(theta)
        ct= np.cos(theta)

        perm12 = -16*np.sqrt(7)*1j*np.sqrt(np.pi)*C*D1**3*Pk1*Pk2*f*k1*k2**2*st**4*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + 2*f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(385*d*k3**4) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*C*D1**3*Pk1*Pk2*k1**3*(10*D1*bd1*f**2*(r + s - 1) + 9*b1**2*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + 2*b1*f*(9*D1*bd1*(r + s - 1) + (5*D1*fd + 10*Dd*f)*(2*r + 2*s - 1)))/(315*d*k3**4) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*C*D1**3*Pk1*Pk2*k1*st**2*(11*D1*bd1*f*(54*b1*k2**2 + f*(k1**2 + 3*k2**2))*(r + s - 1) + 297*b1**2*k2**2*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + 11*b1*f*(k1**2 + 3*k2**2)*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) - 5*f**2*k1**2*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(3465*d*k3**4) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*C*D1**3*Pk2*Pkd1*f*k2**2*st**4*(11*D1*bd1*f*(r - 1) + 11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 2*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(1155*d*k3**2) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*C*D1**3*Pk2*Pkd1*k1**2*(10*D1*bd1*f**2*r + 9*b1**2*(D1*fd*r + Dd*f*(4*r - 1)) + b1*f*(9*D1*bd1*(2*r - 1) + 10*D1*fd*(2*r - 1) + 10*Dd*f*(4*r - 1)))/(315*d*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*C*D1**3*Pk2*Pkd1*st**2*(11*D1*bd1*f*(9*b1*k2**2*(2*r - 1) + f*k1**2*(r - 1) + f*k2**2*r) + 99*b1**2*k2**2*(D1*fd*r + Dd*f*(4*r - 1)) + 11*b1*f*(D1*fd*(2*k1**2*r + k2**2*(2*r - 1)) + Dd*f*(k1**2 + k2**2)*(4*r - 1)) + 5*f**2*k1**2*(D1*fd*(1 - 3*r) + Dd*(-4*f*r + f)))/(3465*d*k3**2) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**7*f*k2**3*(C - 1)*(22*D1*bd1*f*(r + s - 1) + 22*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + 21*f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(693*d*k3**4) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**6*f*k2**2*(k1**2*(7 - 6*C) + k2**2)*(22*D1*bd1*f*(r + s - 1) + 22*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + 21*f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(693*d*k1*k3**4) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**5*f*k2**3*st**2*(C - 1)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) - 5*f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(693*d*k3**4) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**5*k2*(-22*D1*bd1*f*(18*b1*k2**2*(C - 1) + 5*f*(k1**2*(6*C - 9) - 5*k2**2))*(r + s - 1) - 198*b1**2*k2**2*(C - 1)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) - 110*b1*f*(D1*fd + 2*Dd*f)*(k1**2*(6*C - 9) - 5*k2**2)*(2*r + 2*s - 1) - 105*f**2*(k1**2*(6*C - 9) - k2**2*(2*C + 3))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(3465*d*k3**4) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**4*f*k2**2*st**2*(k1**2*(18*C - 23) - 5*k2**2)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) - 5*f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(3465*d*k1*k3**4) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**4*(22*D1*bd1*f*(-9*b1*k2**2*(k1**2*(7 - 6*C) + k2**2) + 5*f*(k1**4*(2*C - 5) - 10*k1**2*k2**2 - k2**4))*(r + s - 1) - 99*b1**2*k2**2*(k1**2*(7 - 6*C) + k2**2)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + 110*b1*f*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1)*(k1**4*(2*C - 5) - 10*k1**2*k2**2 - k2**4) + 105*f**2*k1**2*(k1**2*(2*C - 5) - k2**2*(6*C + 3))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(3465*d*k1*k3**4) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**3*f*k2**3*st**4*(C - 1)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + 2*f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(231*d*k3**4) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**3*k2*st**2*(-11*D1*bd1*f*(r + s - 1)*(54*b1*k2**2*(C - 1) + f*k1**2*(9*C - 18) - f*k2**2*(7*C + 12)) - 297*b1**2*k2**2*(C - 1)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) - 11*b1*f*(D1*fd + 2*Dd*f)*(k1**2*(9*C - 18) - k2**2*(7*C + 12))*(2*r + 2*s - 1) + 5*f**2*(k1**2*(9*C - 18) - k2**2*(10*C + 9))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(3465*d*k3**4) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**3*(22*D1*bd1*f*(9*b1*k2**2*(k1**2*(9 - 6*C) + k2**2*(2*C + 3)) + 5*f*(k1**4 + 10*k1**2*k2**2 + k2**4*(2*C + 3)))*(r + s - 1) + 99*b1**2*k2**2*(k1**2*(9 - 6*C) + k2**2*(2*C + 3))*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + 110*b1*f*(D1*fd + 2*Dd*f)*(k1**4 + 10*k1**2*k2**2 + k2**4*(2*C + 3))*(2*r + 2*s - 1) + 105*f**2*k1**2*(k1**2 + k2**2*(6*C + 1))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(3465*d*k2*k3**4) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**2*f*k2**2*st**4*(k1**2*(6*C - 11) - 5*k2**2)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + 2*f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(1155*d*k1*k3**4) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**2*k1*(99*b1**2*(k1**2*(2*C - 5) - k2**2*(6*C + 3))*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + 22*b1*(9*D1*bd1*f*(k1**2*(2*C - 5) - k2**2*(6*C + 3))*(r + s - 1) - 5*f*(5*k1**2 + k2**2*(6*C + 3))*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1)) - 10*f**2*(21*C*k1**2*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)) + 11*D1*bd1*(5*k1**2 + k2**2*(6*C + 3))*(r + s - 1)))/(3465*d*k3**4) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**2*st**2*(11*D1*bd1*f*(-54*b1*k2**2*(k1**2*(3 - 2*C) + k2**2) + f*(k1**4*(2*C - 11) - k1**2*k2**2*(30*C + 18) - 3*k2**4))*(r + s - 1) - 297*b1**2*k2**2*(k1**2*(3 - 2*C) + k2**2)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + 11*b1*f*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1)*(k1**4*(2*C - 11) - k1**2*k2**2*(30*C + 18) - 3*k2**4) - 5*f**2*k1**2*(k1**2*(2*C - 11) - k2**2*(36*C + 9))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(3465*d*k1*k3**4) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct*f*k2*st**4*(3*k1**2 + k2**2*(10*C + 3))*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + 2*f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(1155*d*k3**4) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct*k1**2*(k1**2 + k2**2*(6*C + 1))*(10*D1*bd1*f**2*(r + s - 1) + 9*b1**2*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + 2*b1*f*(9*D1*bd1*(r + s - 1) + (5*D1*fd + 10*Dd*f)*(2*r + 2*s - 1)))/(315*d*k2*k3**4) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct*st**2*(11*D1*bd1*f*(54*b1*k2**2*(k1**2 + k2**2*(2*C + 1)) + f*(k1**4 + k1**2*k2**2*(18*C + 4) + k2**4*(6*C + 3)))*(r + s - 1) + 297*b1**2*k2**2*(k1**2 + k2**2*(2*C + 1))*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + 11*b1*f*(D1*fd + 2*Dd*f)*(k1**4 + k1**2*k2**2*(18*C + 4) + k2**4*(6*C + 3))*(2*r + 2*s - 1) - 5*f**2*k1**2*(k1**2 + k2**2*(18*C + 1))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(3465*d*k2*k3**4) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*k1*(2*D1*bd1*f**2*(5*k1**2*(s - 1) + k2**2*(2*C*(8*r + 9*s - 9) + 5*s - 5)) + 9*b1**2*(k1**2 + k2**2)*(D1*fd*s + Dd*f*(4*s - 1)) + b1*f*(9*D1*bd1*(k1**2 + k2**2)*(2*s - 1) + 4*D1*fd*(2*C*k2**2*(8*r + 9*s - 4) + s*(5*k1**2 + 5*k2**2)) + 2*Dd*f*(5*k1**2*(4*s - 1) + k2**2*(C*(64*r + 72*s - 34) + 20*s - 5))))/(315*d*k2**2*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*(2*D1*bd1*f*(-5*f**2*k1**2*(s - 1) + k2**2*r*(9*b2 - 18*g2)) + 18*b1**3*k2**2*(D1*fd*r + Dd*f*(4*r - 1)) - b1**2*(D1*(18*bd1*f*k2**2*(1 - 3*r) + fd*k1**2*s*(36*f + 9) + fd*k2**2*(-18*K*r + 18*K + f*(-8*r + 18*s + 4) - 18*r + 9*s + 18)) + Dd*f*(k1**2*(18*f + 9)*(4*s - 1) + k2**2*(-72*K*r + 18*K + f*(-16*r + 36*s - 5) - 72*r + 36*s + 9))) + b1*(D1*bd1*f*(-k1**2*(18*f + 9)*(2*s - 1) + k2**2*(f*(8*r - 18*s + 9) + r*(36*K + 36) - 18*s + 9)) + 6*D1*(3*b2*fd*k2**2*(r - 1) - 5*f**2*fd*k1**2*s + 3*f*k2**2*r*(bd2 - 2*gd2) - 6*fd*g2*k2**2*(r - 1)) + 2*Dd*f*(5*f**2*k1**2*(1 - 4*s) + k2**2*(9*b2 - 18*g2)*(4*r - 1))))/(315*d*k1*k2**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**7*f*k2*(C - 1)*(-4*Pk2 + Pkd2*k2)*(22*b1*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) + f*(22*D1*bd1*s + 21*D1*fd*(3*s - 1) + 21*Dd*f*(4*s - 1)))/(693*d*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**6*f**2*(4*Pk2 - Pkd2*k2)*(13*b1*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1)) + f*(13*D1*bd1*s + 12*D1*fd*(4*s - 1) + 12*Dd*f*(4*s - 1)))/(429*d*k1) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**6*f*(22*b1*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1))*(k1**2*(4*C - 5)*(4*Pk2 - Pkd2*k2) + k2**2*(-2*Pk2 + Pkd2*k2)) + f*(22*D1*bd1*s*(k1**2*(4*C - 5)*(4*Pk2 - Pkd2*k2) + k2**2*(-2*Pk2 + Pkd2*k2)) + D1*fd*(k1**2*(84*C - 105)*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(-2*Pk2*(C*(6*r - 2) - 6*r + 63*s - 19) + 21*Pkd2*k2*(3*s - 1))) + Dd*f*k1**2*(84*C - 105)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + Dd*f*k2**2*(-2*Pk2*(C*(8*r - 2) - 8*r + 84*s - 19) + 21*Pkd2*k2*(4*s - 1))))/(693*d*k1*k3**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**5*f*k2*st**2*(C - 1)*(4*Pk2 - Pkd2*k2)*(11*b1*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) + f*(11*D1*bd1*s + D1*fd*(5 - 15*s) + 5*Dd*f*(1 - 4*s)))/(693*d*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**5*(143*b1**2*k1**2*(4*Pk2 - Pkd2*k2)*(D1*fd*(-9*K*s + 9*K + 10*f*(2*s - 1) + 9*s - 9) + Dd*f*(4*s - 1)*(-9*K + 10*f + 9)) + 13*b1*(D1*(5*f**2*(60*Pk2*fd*k2**2*r + 44*bd1*k1**2*s*(4*Pk2 - Pkd2*k2) + 63*fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) - 22*f*k1**2*(4*Pk2 - Pkd2*k2)*(5*fd*(K - 1)*(2*s - 1) + s*(9*K*bd1 - 9*bd1 - 9*gd2)) + 198*fd*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) + Dd*f*(5*f**2*(20*Pk2*k2**2*(4*r - 1) + 63*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 110*f*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 198*g2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + f*(D1*(5*f**2*(13*bd1*(252*Pk2*k1**2*s + 20*Pk2*k2**2*(r - 1) - 63*Pkd2*k1**2*k2*s) + 63*fd*(3*Pk2*k2**2*(4*r - 1) + 8*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 1430*f*k1**2*s*(4*Pk2 - Pkd2*k2)*(-K*bd1 + bd1 + 2*gd2) + 286*g2*k1**2*(4*Pk2 - Pkd2*k2)*(9*bd1*s + 10*fd*(2*s - 1))) + 5*Dd*f*(63*f**2*(3*Pk2*k2**2*(4*r - 1) + 8*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 572*g2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))))/(45045*d*k1**2*k2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**5*(198*b1**2*k1**2*k2**2*(C - 1)*(-2*Pk2 + Pkd2*k2)*(D1*fd*s + Dd*f*(4*s - 1)) - 22*b1*f*(D1*(-9*bd1*k1**2*k2**2*(C - 1)*(-2*Pk2 + Pkd2*k2)*(2*s - 1) + 2*fd*(-5*Pk2*k2**4*r + k1**4*(5*C - 10)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(Pk2*(-2*C*(9*r + 28*s - 19) + 23*r + 16*s - 18) - 5*Pkd2*k2*(C - 4*s + 1)))) + Dd*f*(5*Pk2*k2**4*(1 - 4*r) + k1**4*(10*C - 20)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(C*(-72*r - 224*s + 74) + 92*r + 64*s - 39) + 20*Pkd2*k2*(4*s - 1)))) + f**2*(D1*(22*bd1*(5*Pk2*k2**4*(r - 1) - k1**4*s*(10*C - 20)*(4*Pk2 - Pkd2*k2) + k1**2*k2**2*(Pk2*(2*C*(9*r + 28*s + 1) - 23*r - 16*s + 3) - 10*Pkd2*k2*(C + 2*s - 1))) - 5*fd*(19*Pk2*k2**4*(1 - 3*r) + k1**4*(42*C - 84)*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k1**2*k2**2*(Pk2*(-8*C*(36*r + 129*s - 55) + 357*r + 528*s - 295) + Pkd2*k2*(42*C + 42)*(3*s - 1)))) - 5*Dd*f*(19*Pk2*k2**4*(1 - 4*r) + k1**4*(42*C - 84)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(-8*C*(48*r + 172*s - 55) + 476*r + 704*s - 295) + Pkd2*k2*(42*C + 42)*(4*s - 1)))))/(3465*d*k1**2*k2*k3**2) + 10*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**4*f**2*st**2*(4*Pk2 - Pkd2*k2)*(13*b1*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1)) + f*(13*D1*bd1*s + 21*D1*fd*(4*s - 1) + 21*Dd*f*(4*s - 1)))/(3003*d*k1) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**4*f*st**2*(11*b1*(D1*fd*(k1**2*(12*C - 17)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(-2*Pk2*(r*(8*C - 8) + 10*s - 5) + 5*Pkd2*k2*(2*s - 1))) + Dd*f*(k1**2*(12*C - 17)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(Pk2*(-32*C*r + 8*C + 32*r - 40*s + 2) + 5*Pkd2*k2*(4*s - 1)))) + f*(11*D1*bd1*(Pk2*k1**2*s*(48*C - 68) - 2*Pk2*k2**2*(4*C*(r - 1) - 4*r + 5*s + 4) + Pkd2*k1**2*k2*s*(17 - 12*C) + 5*Pkd2*k2**3*s) + D1*fd*(k1**2*(85 - 60*C)*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(Pk2*(-456*C*r + 152*C + 456*r + 150*s - 202) + 25*Pkd2*k2*(1 - 3*s))) + Dd*f*k1**2*(85 - 60*C)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + Dd*f*k2**2*(Pk2*(-152*C*(4*r - 1) + 608*r + 200*s - 202) + 25*Pkd2*k2*(1 - 4*s))))/(3465*d*k1*k3**2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**4*(-143*b1**2*(D1*fd*(k1**2*(4*Pk2 - Pkd2*k2)*(20*f*s - 10*f + 9*s - 9) + k2**2*(2*Pk2 - Pkd2*k2)*(40*f*s - 10*f + 9*s - 9)) + Dd*f*(4*s - 1)*(k1**2*(4*Pk2 - Pkd2*k2)*(10*f + 9) + k2**2*(2*Pk2 - Pkd2*k2)*(20*f + 9))) - 13*b1*f*(D1*(-22*bd1*(5*f*(-8*Pk2*k1**2*s + Pk2*k2**2*(2 - 8*s) + 2*Pkd2*k1**2*k2*s + Pkd2*k2**3*(4*s - 1)) + s*(9*k1**2*(-4*Pk2 + Pkd2*k2) + 9*k2**2*(-2*Pk2 + Pkd2*k2))) + fd*(10*k1**2*(4*Pk2 - Pkd2*k2)*(21*f*(3*s - 1) + 22*s - 11) + k2**2*(Pk2*(-44*K*r + 22*K - 10*f*(9*r + 39*s - 35) + 44*r + 440*s - 242) + 5*Pkd2*k2*(-21*f*(6*s - 1) - 44*s + 22)))) + 2*Dd*f*(k1**2*(4*Pk2 - Pkd2*k2)*(105*f + 55)*(4*s - 1) + k2**2*(-20*Pk2*f*(3*r + 13*s - 4) + 11*Pk2*(-4*K*r + K + 4*r + 40*s - 11) + Pkd2*k2*(-105*f - 55)*(4*s - 1)))) + f*(572*D1*Pk2*fd*g2*k2**2*(1 - 2*r) - 5*D1*f**2*(-13*bd1*(-168*Pk2*k1**2*s + 2*Pk2*k2**2*(3*r + 13*s + 19) + 42*Pkd2*k1**2*k2*s + 21*Pkd2*k2**3*(2*s - 1)) + 21*fd*(Pk2*k2**2*(-32*r - 260*s + 73) + 12*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 286*D1*f*(-2*Pk2*gd2*k2**2*r + bd1*(-20*Pk2*k1**2*s + Pk2*k2**2*(r*(K - 1) - 10*s) + 5*Pkd2*k1**2*k2*s + 5*Pkd2*k2**3*s)) - 572*Dd*Pk2*f*g2*k2**2*(4*r - 1) - 105*Dd*f**3*(Pk2*k2**2*(-32*r - 260*s + 73) + 12*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))))/(45045*d*k1*k2**2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**4*(99*b1**2*k2**2*(Pkd2*k2**3 + k1**2*(4*C - 5)*(2*Pk2 - Pkd2*k2))*(D1*fd*s + Dd*f*(4*s - 1)) - 11*b1*f*(D1*(-9*bd1*k2**2*(2*s - 1)*(Pkd2*k2**3 + k1**2*(4*C - 5)*(2*Pk2 - Pkd2*k2)) + 2*fd*(5*k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(Pk2*(2*C*(18*r + 94*s - 67) - 74*r - 114*s + 107) + 5*Pkd2*k2*(4*C - 12*s + 1)) + k2**4*(Pk2*(-4*C*r + 2*C + 6*r - 46*s + 21) - 10*Pkd2*k2*s))) + 2*Dd*f*(5*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 2*k1**2*k2**2*(Pk2*(-4*C*(9*r + 47*s - 14) + 74*r + 114*s - 47) + 15*Pkd2*k2*(4*s - 1)) + k2**4*(2*Pk2*(-4*C*r + C + 6*r - 46*s + 10) + 5*Pkd2*k2*(1 - 4*s)))) + f**2*(D1*(22*bd1*(5*k1**4*s*(-4*Pk2 + Pkd2*k2) + k1**2*k2**2*(Pk2*(-2*C*(9*r + 47*s + 11) + 37*r + 57*s + 13) + 5*Pkd2*k2*(4*C + 6*s - 5)) + k2**4*(Pk2*r*(2*C - 3) + 23*Pk2*s + Pk2 + 5*Pkd2*k2*(s - 1))) - 5*fd*(Pk2*k2**4*(C*(4 - 12*r) - 18*r - 327*s + 115) + 21*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k1**2*k2**2*(Pk2*(4*C*(69*r + 450*s - 173) - 546*r - 1497*s + 681) + Pkd2*k2*(-84*C - 21)*(3*s - 1)))) - 5*Dd*f*(Pk2*k2**4*(C*(4 - 16*r) - 24*r - 436*s + 115) + 21*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(4*C*(92*r + 600*s - 173) - 728*r - 1996*s + 681) + Pkd2*k2*(-84*C - 21)*(4*s - 1)))))/(3465*d*k1*k2**2*k3**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**3*f*k2*st**4*(C - 1)*(4*Pk2 - Pkd2*k2)*(11*b1*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) + f*(11*D1*bd1*s + D1*fd*(6*s - 2) + 2*Dd*f*(4*s - 1)))/(231*d*k3**2) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**3*st**2*(-143*b1**2*k1**2*(4*Pk2 - Pkd2*k2)*(D1*fd*(10*f*(2*s - 1) + (27 - 27*K)*(s - 1)) + Dd*f*(4*s - 1)*(-27*K + 10*f + 27)) + 13*b1*(D1*(10*f**2*(63*Pk2*fd*k2**2*r + 22*bd1*k1**2*s*(-4*Pk2 + Pkd2*k2) + 15*fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) + 33*f*k1**2*(4*Pk2 - Pkd2*k2)*(fd*(K - 1)*(2*s - 1) + s*(18*K*bd1 - 18*bd1 - 18*gd2)) - 594*fd*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) + 3*Dd*f*(10*f**2*(7*Pk2*k2**2*(4*r - 1) + 5*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 11*f*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 198*g2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) - 3*f*(D1*(-10*f**2*(75*Pk2*fd*k2**2*(4*r - 1) + 13*bd1*(20*Pk2*k1**2*s + 7*Pk2*k2**2*(r - 1) - 5*Pkd2*k1**2*k2*s) + 70*fd*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 143*f*k1**2*s*(4*Pk2 - Pkd2*k2)*(-K*bd1 + bd1 + 2*gd2) + 286*g2*k1**2*(4*Pk2 - Pkd2*k2)*(9*bd1*s + fd*(2*s - 1))) - 50*Dd*f**3*(15*Pk2*k2**2*(4*r - 1) + 14*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 286*Dd*f*g2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)))/(45045*d*k1**2*k2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**3*(-1287*b1**3*k1**2*(2*Pk2 - Pkd2*k2)*(D1*fd*s + Dd*f*(4*s - 1)) - 143*b1**2*(9*D1*bd1*f*k1**2*(2*Pk2 - Pkd2*k2)*(3*s - 1) + D1*fd*(9*K*k1**2*(2*Pk2*(s - 2) + Pkd2*k2) + 44*Pk2*f*k2**2*r + 9*Pk2*k2**2*r + 2*f*k1**2*(Pk2*(-9*r + 44*s + 8) + 5*Pkd2*k2*(1 - 8*s)) + 9*k1**2*(-Pk2*r + 2*Pk2*s - 2*Pkd2*k2*s + Pkd2*k2)) + Dd*f*(Pk2*k2**2*(22*f + 9)*(4*r - 1) - k1**2*(Pk2*f*(36*r - 176*s + 35) + 9*Pk2*(K*(2 - 8*s) + 4*r - 8*s + 1) + Pkd2*k2*(40*f + 18)*(4*s - 1)))) + 13*b1*(-1276*D1*K*Pk2*f*fd*k1**2*s + 638*D1*K*Pk2*f*fd*k1**2 + 220*D1*K*Pkd2*f*fd*k1**2*k2*s - 110*D1*K*Pkd2*f*fd*k1**2*k2 - 198*D1*Pk2*bd2*f*k1**2*s + 720*D1*Pk2*f**2*fd*k1**2*r + 2070*D1*Pk2*f**2*fd*k1**2*s - 1230*D1*Pk2*f**2*fd*k1**2 - 540*D1*Pk2*f**2*fd*k2**2*r + 180*D1*Pk2*f**2*fd*k2**2 + 176*D1*Pk2*f*fd*k1**2*r + 396*D1*Pk2*f*fd*k1**2*s - 286*D1*Pk2*f*fd*k1**2 - 264*D1*Pk2*f*fd*k2**2*r + 132*D1*Pk2*f*fd*k2**2 + 396*D1*Pk2*f*gd2*k1**2*s + 396*D1*Pk2*fd*g2*k1**2*s - 792*D1*Pk2*fd*g2*k1**2 + 99*D1*Pkd2*bd2*f*k1**2*k2*s + 945*D1*Pkd2*f**2*fd*k1**2*k2*s - 105*D1*Pkd2*f**2*fd*k1**2*k2 + 220*D1*Pkd2*f*fd*k1**2*k2*s - 110*D1*Pkd2*f*fd*k1**2*k2 + 198*D1*Pkd2*fd*g2*k1**2*k2 + 11*D1*bd1*f*(-Pk2*k2**2*(22*f + 9)*(2*r - 1) + k1**2*(Pk2*f*(18*r - 88*s + 51) + 9*Pk2*(-2*K*(2*s + 1) + 2*r - 4*s + 1) + 10*Pkd2*f*k2*(8*s - 3) + 9*Pkd2*k2*(K + 4*s - 1))) - 2552*Dd*K*Pk2*f**2*k1**2*s + 638*Dd*K*Pk2*f**2*k1**2 + 440*Dd*K*Pkd2*f**2*k1**2*k2*s - 110*Dd*K*Pkd2*f**2*k1**2*k2 + 960*Dd*Pk2*f**3*k1**2*r + 2760*Dd*Pk2*f**3*k1**2*s - 930*Dd*Pk2*f**3*k1**2 - 720*Dd*Pk2*f**3*k2**2*r + 180*Dd*Pk2*f**3*k2**2 + 352*Dd*Pk2*f**2*k1**2*r + 792*Dd*Pk2*f**2*k1**2*s - 286*Dd*Pk2*f**2*k1**2 - 528*Dd*Pk2*f**2*k2**2*r + 132*Dd*Pk2*f**2*k2**2 + 1584*Dd*Pk2*f*g2*k1**2*s - 396*Dd*Pk2*f*g2*k1**2 + 1260*Dd*Pkd2*f**3*k1**2*k2*s - 315*Dd*Pkd2*f**3*k1**2*k2 + 440*Dd*Pkd2*f**2*k1**2*k2*s - 110*Dd*Pkd2*f**2*k1**2*k2 - 99*b2*k1**2*(2*Pk2 - Pkd2*k2)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))) + f*(13*D1*bd1*(15*f**2*(-12*Pk2*k2**2*r + k1**2*(2*Pk2*(8*r + 23*s + 10) + 7*Pkd2*k2*(3*s - 2))) + 22*f*(-6*Pk2*k2**2*r + k1**2*(4*Pk2*r + Pk2*s*(9 - 29*K) + Pkd2*k2*s*(5*K + 5))) + 198*g2*k1**2*(2*Pk2*(s + 1) - Pkd2*k2)) - 143*b2*k1**2*(2*Pk2 - Pkd2*k2)*(9*D1*bd1*s + 10*D1*fd*(2*s - 1) + 10*Dd*f*(4*s - 1)) + k1**2*(105*D1*Pk2*f**2*fd*(68*r + 416*s - 121) - 286*D1*f*s*(10*Pk2*bd2 - 58*Pk2*gd2 - 5*Pkd2*bd2*k2 + 10*Pkd2*gd2*k2) + 572*D1*fd*g2*(29*Pk2 - 5*Pkd2*k2)*(2*s - 1) + 105*Dd*Pk2*f**3*(68*r + 416*s - 121) + 572*Dd*f*g2*(29*Pk2 - 5*Pkd2*k2)*(4*s - 1))))/(45045*d*k1**2*k2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**3*st**2*(-297*b1**2*k1**2*k2**2*(C - 1)*(-2*Pk2 + Pkd2*k2)*(D1*fd*s + Dd*f*(4*s - 1)) + 11*b1*f*(D1*(-27*bd1*k1**2*k2**2*(C - 1)*(-2*Pk2 + Pkd2*k2)*(2*s - 1) + fd*(-2*Pk2*k2**4*r + k1**4*(3*C - 9)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 2*k1**2*k2**2*(Pk2*(-2*C*(33*r + 67*s - 35) + 71*r + 102*s - 54) + Pkd2*k2*(C*(7*s - 5) + 9*s - 3)))) + Dd*f*(Pk2*k2**4*(1 - 4*r) + k1**4*(3*C - 9)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(-8*C*(33*r + 67*s - 25) + 284*r + 408*s - 173) + Pkd2*k2*(7*C + 9)*(4*s - 1)))) + f**2*(D1*(-11*bd1*(Pk2*k2**4*(r - 1) - k1**4*s*(3*C - 9)*(4*Pk2 - Pkd2*k2) - k1**2*k2**2*(Pk2*(-2*C*(33*r + 67*s - 30) + 71*r + 102*s - 65) + Pkd2*k2*(C*(7*s + 3) + 9*s - 3))) + fd*(101*Pk2*k2**4*(3*r - 1) - k1**4*(15*C - 45)*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k1**2*k2**2*(Pk2*(C*(-594*r + 84*s + 170) + 807*r + 396*s - 401) + Pkd2*k2*(-50*C - 30)*(3*s - 1)))) + Dd*f*(101*Pk2*k2**4*(4*r - 1) - k1**4*(15*C - 45)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(C*(-792*r + 112*s + 170) + 1076*r + 528*s - 401) + Pkd2*k2*(-50*C - 30)*(4*s - 1)))))/(3465*d*k1**2*k2*k3**2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**3*(99*b1**2*(D1*fd*(-Pk2*k2**4*r + k1**4*s*(2*C - 4)*(2*Pk2 - Pkd2*k2) + k1**2*k2**2*(Pk2*(-4*C*s + r + 4*s) + Pkd2*k2*s*(2*C + 2))) + Dd*f*(Pk2*k2**4*(1 - 4*r) + k1**4*(2*C - 4)*(2*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(C*(4 - 16*s) + 4*r + 16*s - 5) + Pkd2*k2*(2*C + 2)*(4*s - 1)))) + 11*b1*f*(9*D1*bd1*(Pk2*k2**4*(1 - 2*r) + k1**4*(2*C - 4)*(2*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(Pk2*(C*(4 - 8*s) + 2*r + 8*s - 5) + Pkd2*k2*(2*C + 2)*(2*s - 1))) - 2*D1*fd*(6*Pk2*k2**4*(2*r - 1) + k1**4*(Pk2*(76*C*s - 58*C - 28*r - 70*s + 75) + 10*Pkd2*k2*(C - 4*s)) - k1**2*k2**2*(Pk2*(C*(8*r - 4*s - 22) + 44*r + 150*s - 55) + Pkd2*k2*s*(20*C + 20))) - 2*Dd*f*(6*Pk2*k2**4*(4*r - 1) + k1**4*(38*C*Pk2*(4*s - 1) - 7*Pk2*(8*r + 20*s - 7) + 20*Pkd2*k2*(1 - 4*s)) + k1**2*k2**2*(Pk2*(C*(-16*r + 8*s + 2) - 88*r - 300*s + 97) + Pkd2*k2*(-10*C - 10)*(4*s - 1)))) + f**2*(-22*D1*bd1*(6*Pk2*k2**4*r + k1**4*(Pk2*(38*C*s + 20*C - 14*r - 35*s - 26) - 10*Pkd2*k2*(C + 2*s - 2)) - k1**2*k2**2*(Pk2*(C*(4*r - 2*s + 20) + 22*r + 75*s - 42) + Pkd2*k2*(10*C + 10)*(s - 1))) + 5*k1**2*(D1*fd*(Pk2*k2**2*(16*C*(18*r + 33*s - 17) + 75*r + 522*s - 199) + k1**2*(42*C*Pkd2*k2*(3*s - 1) + Pk2*(-768*C*s + 256*C + 201*r + 1038*s - 413))) + Dd*f*(Pk2*k2**2*(16*C*(24*r + 44*s - 17) + 100*r + 696*s - 199) + k1**2*(42*C*Pkd2*k2*(4*s - 1) + Pk2*(-256*C*(4*s - 1) + 268*r + 1384*s - 413))))))/(3465*d*k1**2*k2*k3**2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**2*f**2*st**4*(4*Pk2 - Pkd2*k2)*(26*b1*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1)) + f*(26*D1*bd1*s + 5*D1*fd*(4*s - 1) + 5*Dd*f*(4*s - 1)))/(1001*d*k1) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**2*f*st**4*(11*b1*(D1*fd*(k1**2*(4*C - 9)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(Pk2*(-r*(32*C - 32) - 20*s + 10) + 5*Pkd2*k2*(2*s - 1))) + Dd*f*(k1**2*(4*C - 9)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(-2*Pk2*(32*C*r - 8*C - 32*r + 20*s + 3) + 5*Pkd2*k2*(4*s - 1)))) + f*(D1*(11*bd1*(Pk2*k1**2*s*(16*C - 36) - 2*Pk2*k2**2*(8*C*(r - 1) - 8*r + 5*s + 8) + Pkd2*k1**2*k2*s*(9 - 4*C) + 5*Pkd2*k2**3*s) + 2*fd*(k1**2*(4*C - 9)*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(-2*Pk2*(51*C*r - 17*C - 51*r + 15*s + 12) + 5*Pkd2*k2*(3*s - 1)))) + 2*Dd*f*(k1**2*(4*C - 9)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(-2*Pk2*(68*C*r - 17*C - 68*r + 20*s + 12) + 5*Pkd2*k2*(4*s - 1)))))/(1155*d*k1*k3**2) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**2*st**2*(-429*b1**2*(D1*fd*(k1**2*(4*Pk2 - Pkd2*k2)*(4*f*s - 2*f + 9*s - 9) + k2**2*(2*Pk2*(6*K*r + 8*f*s - 2*f - 6*r + 9*s - 9) + Pkd2*k2*(-8*f*s + 2*f - 9*s + 9))) + Dd*f*(k1**2*(4*Pk2 - Pkd2*k2)*(2*f + 9)*(4*s - 1) + k2**2*(2*Pk2*(24*K*r - 6*K + 16*f*s - 4*f - 24*r + 36*s - 3) - Pkd2*k2*(4*f + 9)*(4*s - 1)))) + 13*b1*(D1*(792*Pk2*fd*g2*k2**2*r + 6*f**2*(11*bd1*(-8*Pk2*k1**2*s + Pk2*k2**2*(2 - 8*s) + 2*Pkd2*k1**2*k2*s + Pkd2*k2**3*(4*s - 1)) + fd*(10*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(Pk2*(288*r + 225*s - 97) + 5*Pkd2*k2*(1 - 6*s)))) - 11*f*(-72*Pk2*gd2*k2**2*r + 18*bd1*(12*Pk2*k1**2*s + 2*Pk2*k2**2*(2*K*r - K - 2*r + 3*s + 1) - 3*Pkd2*k1**2*k2*s - 3*Pkd2*k2**3*s) + 3*fd*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + fd*k2**2*(2*Pk2*(20*K*r - 10*K - 20*r + 6*s + 7) + 3*Pkd2*k2*(1 - 2*s)))) + Dd*f*(792*Pk2*g2*k2**2*(4*r - 1) + 6*f**2*(10*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(3*Pk2*(128*r + 100*s - 57) + 10*Pkd2*k2*(1 - 4*s))) - 11*f*(3*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(2*Pk2*(40*K*r - 10*K - 40*r + 12*s + 7) + 3*Pkd2*k2*(1 - 4*s))))) + f*(1144*D1*Pk2*g2*k2**2*(9*bd1*(r - 1) + 5*fd*(2*r - 1)) + 6*D1*f**2*(-13*bd1*(-40*Pk2*k1**2*s + Pk2*k2**2*(-96*r - 75*s + 74) + 10*Pkd2*k1**2*k2*s + 5*Pkd2*k2**3*(2*s - 1)) + 5*fd*(Pk2*k2**2*(256*r - 260*s + 1) + 21*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 143*D1*f*(40*Pk2*gd2*k2**2*r + bd1*(-12*Pk2*k1**2*s - 2*Pk2*k2**2*(r*(10*K - 10) + 3*s) + 3*Pkd2*k1**2*k2*s + 3*Pkd2*k2**3*s)) + 5720*Dd*Pk2*f*g2*k2**2*(4*r - 1) + 30*Dd*f**3*(Pk2*k2**2*(256*r - 260*s + 1) + 21*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))))/(45045*d*k1*k2**2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**2*(99*b1**3*(Pkd2*k2**3 + k1**2*(-2*Pk2 + Pkd2*k2))*(D1*fd*s + Dd*f*(4*s - 1)) - 11*b1**2*(-9*D1*bd1*f*(3*s - 1)*(Pkd2*k2**3 + k1**2*(-2*Pk2 + Pkd2*k2)) + D1*fd*(k1**2*(Pk2*(26*f*s + 27*f + 9*s + 9) - Pkd2*k2*s*(40*f + 9)) - k2**2*(Pk2*f*(-16*r + 108*s - 25) + 9*Pk2*(2*K*(r - 1) - 2*r + s + 1) + Pkd2*k2*s*(20*f + 9))) + Dd*f*(k1**2*(4*s - 1)*(Pk2*(13*f + 9) - Pkd2*k2*(20*f + 9)) + k2**2*(Pk2*f*(32*r - 216*s + 46) - 9*Pk2*(K*(8*r - 2) - 8*r + 4*s + 1) - Pkd2*k2*(10*f + 9)*(4*s - 1)))) + b1*(-11*D1*bd1*f*(k1**2*(2*Pk2*(13*f*s - 20*f + 9*s - 9) - Pkd2*k2*(20*f + 9)*(2*s - 1)) + k2**2*(Pk2*f*(16*r - 108*s + 21) - 18*Pk2*(r*(2*K - 2) + s) + 10*Pkd2*f*k2*(1 - 2*s) - 9*Pkd2*k2*(2*s - 1))) + D1*(22*Pk2*f*(14*fd*k1**2*(2*s - 1) + fd*k2**2*(-2*K*r + K - 2*r + 28*s - 13) - 18*gd2*k2**2*r) - 396*Pk2*fd*g2*k2**2*(r - 1) + 15*f**2*fd*(2*Pk2*k2**2*(6*r + 66*s - 13) + k1**2*(90*Pk2*s - 44*Pk2 + 21*Pkd2*k2*s))) + Dd*f*(22*Pk2*f*(14*k1**2*(4*s - 1) + k2**2*(-4*K*r + K - 4*r + 56*s - 13)) + 396*Pk2*g2*k2**2*(1 - 4*r) + 15*f**2*(16*Pk2*k2**2*(r + 11*s - 3) + k1**2*(30*Pk2 + 7*Pkd2*k2)*(4*s - 1)))) + f*(D1*bd1*(-22*Pk2*f*(-14*k1**2*s + k2**2*(K*r + r - 14*s)) - 396*Pk2*g2*k2**2*r + 15*f**2*(2*Pk2*k2**2*(2*r + 22*s - 11) + k1**2*(2*Pk2*(15*s + 7) + 7*Pkd2*k2*(s - 1)))) + Pk2*(315*D1*f**2*fd*k1**2*(4*s - 1) - 22*D1*f*k2**2*r*(bd2 - 2*gd2) - 22*D1*fd*k2**2*(b2 - 2*g2)*(2*r - 1) + 315*Dd*f**3*k1**2*(4*s - 1) - 22*Dd*f*k2**2*(b2 - 2*g2)*(4*r - 1))))/(3465*d*k1*k2**2) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**2*st**2*(-99*b1**2*k2**2*(D1*fd*(Pk2*k1**2*s*(14 - 8*C) + Pk2*k2**2*r*(8*C - 8) + Pkd2*k1**2*k2*s*(4*C - 7) - 3*Pkd2*k2**3*s) + Dd*f*(-k1**2*(4*C - 7)*(2*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(Pk2*(8*C - 8)*(4*r - 1) + 3*Pkd2*k2*(1 - 4*s)))) - 11*b1*f*(D1*(9*bd1*k1**2*k2**2*(4*C - 7)*(-2*Pk2 + Pkd2*k2)*(2*s - 1) + 9*bd1*k2**4*(Pk2*(8*C - 8)*(2*r - 1) + 3*Pkd2*k2*(1 - 2*s)) + 3*fd*k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1) + fd*k1**2*k2**2*(4*Pk2*(C*(22*r + 86*s - 45) - 55*r - 113*s + 60) + Pkd2*k2*(-8*C*(5*s - 3) - 20*s + 3)) - 2*fd*k2**4*(Pk2*(C*(20 - 40*r) + 94*r + 114*s - 77) + 3*Pkd2*k2*s)) + Dd*f*(3*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 2*k1**2*k2**2*(-4*Pk2*(C*(22*r + 86*s - 27) - 55*r - 113*s + 42) + Pkd2*k2*(10*C + 5)*(4*s - 1)) + k2**4*(8*Pk2*(20*C*r - 5*C - 47*r - 57*s + 26) + 3*Pkd2*k2*(1 - 4*s)))) + f**2*(D1*(11*bd1*(3*k1**4*s*(-4*Pk2 + Pkd2*k2) + k1**2*k2**2*(-2*Pk2*(2*C*(11*r + 43*s - 9) - 55*r - 113*s + 48) + Pkd2*k2*(4*C*(5*s + 1) + 10*s - 7)) + k2**4*(Pk2*(-40*C*r + 94*r + 114*s - 54) + 3*Pkd2*k2*(s - 1))) + fd*(6*Pk2*k2**4*(64*C*(3*r - 1) + 129*r + 51*s - 60) + 15*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k1**2*k2**2*(Pk2*(-4*C*(51*r - 171*s + 40) + 798*r + 432*s - 410) + Pkd2*k2*(-120*C - 15)*(3*s - 1)))) + Dd*f*(24*Pk2*k2**4*(16*C*(4*r - 1) + 43*r + 17*s - 15) + 15*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(-2*Pk2*(8*C*(17*r - 57*s + 10) - 532*r - 288*s + 205) - Pkd2*k2*(120*C + 15)*(4*s - 1)))))/(3465*d*k1*k2**2*k3**2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**2*(-99*b1**2*(-D1*fd*(Pk2*k2**4*(-2*r + s) + k1**4*(-2*Pk2*s + Pkd2*k2*s) + k1**2*k2**2*(2*Pk2*r + Pk2*s*(9 - 8*C) + Pkd2*k2*s*(4*C + 1))) + Dd*f*(Pk2*k2**4*(8*r - 4*s - 1) + k1**4*(2*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(32*C*s - 8*C - 8*r - 36*s + 11) - Pkd2*k2*(4*C + 1)*(4*s - 1)))) + 11*b1*f*(-9*D1*bd1*(Pk2*k2**4*(4*r - 2*s - 1) + k1**4*(2*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(Pk2*(16*C*s - 8*C - 4*r - 18*s + 11) - Pkd2*k2*(4*C + 1)*(2*s - 1))) + 2*D1*fd*(Pk2*k2**4*(C*(2 - 4*r) - 6*r + 28*s + 3) + 2*k1**4*(Pk2*(4*s - 7) + 5*Pkd2*k2*s) + k1**2*k2**2*(Pk2*(C*(4*r - 8*s - 38) + 66*r + 172*s - 47) + Pkd2*k2*s*(40*C + 10))) + 2*Dd*f*(Pk2*k2**4*(C*(2 - 8*r) - 12*r + 56*s - 11) + k1**4*(4*Pk2 + 5*Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(2*C*(4*r - 8*s + 1) + 132*r + 344*s - 119) + Pkd2*k2*(20*C + 5)*(4*s - 1)))) + f**2*(22*D1*bd1*(-Pk2*k2**4*(2*C*r + 3*r - 14*s + 14) + k1**4*(2*Pk2*(2*s + 5) + 5*Pkd2*k2*(s - 1)) + k1**2*k2**2*(Pk2*(2*C*(r - 2*s + 20) + 33*r + 86*s - 72) + Pkd2*k2*(20*C + 5)*(s - 1))) + 5*Pk2*k1**2*(D1*fd*(65*k1**2*(3*s - 1) + k2**2*(4*C*(69*r + 198*s - 89) + 195*s - 65)) + Dd*f*(65*k1**2*(4*s - 1) + k2**2*(4*C*(92*r + 264*s - 89) + 260*s - 65)))))/(3465*d*k1*k2**2*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct*f*st**4*(-143*b1**2*k1**2*(4*Pk2 - Pkd2*k2)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) - 13*b1*f*(D1*(-21*Pk2*fd*k2**2*r + 22*bd1*k1**2*s*(4*Pk2 - Pkd2*k2) + 6*fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) + Dd*f*(7*Pk2*k2**2*(1 - 4*r) + 6*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + f**2*(D1*(13*bd1*(-24*Pk2*k1**2*s + 7*Pk2*k2**2*(r - 1) + 6*Pkd2*k1**2*k2*s) - 2*fd*(29*Pk2*k2**2*(1 - 4*r) + 5*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) - 2*Dd*f*(29*Pk2*k2**2*(1 - 4*r) + 5*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))))/(3003*d*k1**2*k2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct*f*st**4*(11*b1*(2*D1*fd*(-3*Pk2*k2**4*r + k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(4*C*Pk2*(2*r + 6*s - 3) + 5*C*Pkd2*k2*(1 - 2*s) - 13*Pk2*r - 2*Pkd2*k2*s + Pkd2*k2)) + Dd*f*(3*Pk2*k2**4*(1 - 4*r) + 2*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(32*C*(r + 3*s - 1) - 52*r + 13) + Pkd2*k2*(-10*C - 2)*(4*s - 1)))) + f*(D1*(-11*bd1*(3*Pk2*k2**4*(r - 1) + k1**4*(-8*Pk2*s + 2*Pkd2*k2*s) + k1**2*k2**2*(-8*C*Pk2*(r + 3*s - 1) + 13*Pk2*(r - 1) + Pkd2*k2*s*(10*C + 2))) + 4*fd*(6*Pk2*k2**4*(1 - 3*r) + k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k1**2*k2**2*(Pk2*(4*C*(3*r + 9*s - 4) - 33*r + 11) - Pkd2*k2*(5*C + 1)*(3*s - 1)))) + 4*Dd*f*(6*Pk2*k2**4*(1 - 4*r) + k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(16*C*(r + 3*s - 1) - 44*r + 11) - Pkd2*k2*(5*C + 1)*(4*s - 1)))))/(1155*d*k1**2*k2*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct*(9*b1**2*(D1*fd*(Pk2*k2**2*(r - 2*s) - k1**2*(2*C*Pkd2*k2*s + Pk2*(-4*C*s + r + 6*s))) + Dd*f*(Pk2*k2**2*(4*r - 8*s + 1) + k1**2*(2*C*Pkd2*k2*(1 - 4*s) + Pk2*(16*C*s - 4*C - 4*r - 24*s + 7)))) + b1*f*(9*D1*bd1*(Pk2*k2**2*(2*r - 4*s + 1) + k1**2*(2*C*Pkd2*k2*(1 - 2*s) + Pk2*(8*C*s - 4*C - 2*r - 12*s + 7))) - 2*D1*fd*(Pk2*k2**2*(2*C*(14*r + 18*s - 7) + 6*r + 38*s - 3) + k1**2*(-2*C*Pk2*(2*s + 9) + 20*C*Pkd2*k2*s + 13*Pk2*(2*r + 6*s - 1))) - 4*Dd*f*(Pk2*k2**2*(4*C*(7*r + 9*s - 4) + 6*r + 38*s - 11) + k1**2*(5*C*Pkd2*k2*(4*s - 1) + Pk2*(-4*C*s + C + 26*r + 78*s - 26)))) - 2*f**2*(20*C*Pk2*k1**2*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1)) + D1*bd1*(Pk2*k2**2*(2*C*(7*r + 9*s - 9) + 3*r + 19*s - 19) + k1**2*(-2*C*Pk2*(s - 10) + 10*C*Pkd2*k2*(s - 1) + 13*Pk2*(r + 3*s - 3)))))/(315*d*k2*k3**2) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct*st**2*(-3861*b1**3*k1**2*(2*Pk2 - Pkd2*k2)*(D1*fd*s + Dd*f*(4*s - 1)) - 429*b1**2*(9*D1*bd1*f*k1**2*(2*Pk2 - Pkd2*k2)*(3*s - 1) - D1*fd*(Pk2*k2**2*r*(28*f + 3) + k1**2*(2*Pk2*f*(9*r + 28*s - 17) + 3*Pk2*(-8*K*(s - 1) + 3*r - 4*s + 4) + Pkd2*f*k2*(8*s - 1) + Pkd2*k2*(9*K + 9)*(s - 1))) - Dd*f*(Pk2*k2**2*(14*f + 3)*(4*r - 1) + k1**2*(Pk2*(-96*K*s + 24*K + f*(36*r + 112*s - 37) + 36*r - 48*s + 3) + Pkd2*k2*(4*s - 1)*(9*K + 4*f + 9)))) + 13*b1*(-176*D1*K*Pk2*f*fd*k1**2*s + 88*D1*K*Pk2*f*fd*k1**2 + 66*D1*K*Pkd2*f*fd*k1**2*k2*s - 33*D1*K*Pkd2*f*fd*k1**2*k2 - 594*D1*Pk2*bd2*f*k1**2*s + 774*D1*Pk2*f**2*fd*k1**2*r + 1458*D1*Pk2*f**2*fd*k1**2*s - 555*D1*Pk2*f**2*fd*k1**2 + 954*D1*Pk2*f**2*fd*k2**2*r - 318*D1*Pk2*f**2*fd*k2**2 + 418*D1*Pk2*f*fd*k1**2*r - 88*D1*Pk2*f*fd*k1**2*s - 165*D1*Pk2*f*fd*k1**2 + 374*D1*Pk2*f*fd*k2**2*r - 187*D1*Pk2*f*fd*k2**2 + 1584*D1*Pk2*f*gd2*k1**2*s + 1584*D1*Pk2*fd*g2*k1**2*s - 1584*D1*Pk2*fd*g2*k1**2 + 297*D1*Pkd2*bd2*f*k1**2*k2*s - 135*D1*Pkd2*f**2*fd*k1**2*k2*s + 15*D1*Pkd2*f**2*fd*k1**2*k2 + 66*D1*Pkd2*f*fd*k1**2*k2*s - 33*D1*Pkd2*f*fd*k1**2*k2 - 594*D1*Pkd2*f*gd2*k1**2*k2*s - 594*D1*Pkd2*fd*g2*k1**2*k2*s + 594*D1*Pkd2*fd*g2*k1**2*k2 + 33*D1*bd1*f*(Pk2*k2**2*(14*f + 3)*(2*r - 1) + k1**2*(Pk2*f*(18*r + 56*s - 3) - 3*Pk2*(16*K*s - 6*r + 8*s + 3) + Pkd2*f*k2*(8*s - 3) + Pkd2*k2*s*(18*K + 18))) - 352*Dd*K*Pk2*f**2*k1**2*s + 88*Dd*K*Pk2*f**2*k1**2 + 132*Dd*K*Pkd2*f**2*k1**2*k2*s - 33*Dd*K*Pkd2*f**2*k1**2*k2 + 1032*Dd*Pk2*f**3*k1**2*r + 1944*Dd*Pk2*f**3*k1**2*s - 744*Dd*Pk2*f**3*k1**2 + 1272*Dd*Pk2*f**3*k2**2*r - 318*Dd*Pk2*f**3*k2**2 + 836*Dd*Pk2*f**2*k1**2*r - 176*Dd*Pk2*f**2*k1**2*s - 165*Dd*Pk2*f**2*k1**2 + 748*Dd*Pk2*f**2*k2**2*r - 187*Dd*Pk2*f**2*k2**2 + 6336*Dd*Pk2*f*g2*k1**2*s - 1584*Dd*Pk2*f*g2*k1**2 - 180*Dd*Pkd2*f**3*k1**2*k2*s + 45*Dd*Pkd2*f**3*k1**2*k2 + 132*Dd*Pkd2*f**2*k1**2*k2*s - 33*Dd*Pkd2*f**2*k1**2*k2 - 2376*Dd*Pkd2*f*g2*k1**2*k2*s + 594*Dd*Pkd2*f*g2*k1**2*k2 - 297*b2*k1**2*(2*Pk2 - Pkd2*k2)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))) + f*(13*D1*bd1*(3*f**2*(106*Pk2*k2**2*r + k1**2*(Pk2*(86*r + 162*s - 63) + 5*Pkd2*k2*(2 - 3*s))) + 11*f*(17*Pk2*k2**2*r + k1**2*(19*Pk2*r - 4*Pk2*(2*K*s + s) + Pkd2*k2*s*(3*K + 3))) + 198*g2*k1**2*s*(8*Pk2 - 3*Pkd2*k2)) - 429*b2*k1**2*(2*Pk2 - Pkd2*k2)*(9*D1*bd1*s + D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) + k1**2*(15*D1*Pk2*f**2*fd*(76*r - 416*s + 85) - 143*D1*f*s*(6*Pk2*bd2 - 16*Pk2*gd2 - 3*Pkd2*bd2*k2 + 6*Pkd2*gd2*k2) + 286*D1*fd*g2*(8*Pk2 - 3*Pkd2*k2)*(2*s - 1) + 15*Dd*Pk2*f**3*(76*r - 416*s + 85) + 286*Dd*f*g2*(8*Pk2 - 3*Pkd2*k2)*(4*s - 1))))/(45045*d*k1**2*k2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct*(-99*b1**3*k2*(D1*fd*(2*Pk2*k2*r - Pkd2*k1**2*s) + Dd*f*(2*Pk2*k2*(4*r - 1) + Pkd2*k1**2*(1 - 4*s))) + 11*b1**2*(-9*D1*bd1*f*k2*(2*Pk2*k2*(3*r - 1) + Pkd2*k1**2*(1 - 3*s)) + D1*fd*(Pk2*k2**2*(-26*f*r + 13*f - 27*r + 27) + k1**2*(Pk2*f*(28*r + 144*s - 25) - 9*Pk2*(r + s*(2*K - 2) - 1) + Pkd2*k2*s*(9*K + 20*f + 9))) - Dd*Pk2*f*k2**2*(13*f + 27)*(4*r - 1) + Dd*f*k1**2*(Pk2*f*(56*r + 288*s - 86) - 9*Pk2*(K*(8*s - 2) + 4*r - 8*s + 1) + Pkd2*k2*(4*s - 1)*(9*K + 10*f + 9))) + b1*(11*D1*bd1*f*(Pk2*k2**2*r*(-26*f - 54) + k1**2*(Pk2*f*(28*r + 144*s - 61) - 18*Pk2*(K*(2*s - 1) + r - 2*s + 1) + Pkd2*k2*(2*s - 1)*(9*K + 10*f + 9))) + k1**2*(D1*(10*Pk2*f**2*fd*(39*r + 198*s - 35) + 99*f*(2*Pk2*fd*(K + 1)*(2*s - 1) + s*(4*Pk2*gd2 + Pkd2*bd2*k2 - 2*Pkd2*gd2*k2)) + 99*fd*s*(4*Pk2*g2 + Pkd2*b2*k2 - 2*Pkd2*g2*k2)) + Dd*f*(10*Pk2*f**2*(52*r + 264*s - 79) + 198*Pk2*f*(K + 1)*(4*s - 1) + (4*s - 1)*(396*Pk2*g2 + 99*Pkd2*b2*k2 - 198*Pkd2*g2*k2)))) + f*k1**2*(2*D1*bd1*(5*Pk2*f**2*(13*r + 66*s - 44) + 99*Pk2*f*s*(K + 1) + 99*g2*(2*Pk2 - Pkd2*k2)*(s - 1)) + 198*Pk2*(D1*f*s*(bd2 - 2*gd2) + D1*fd*g2*(2 - 4*s) + 2*Dd*f*g2*(1 - 4*s)) + 99*b2*(2*D1*Pk2*fd*(2*s - 1) + D1*Pkd2*bd1*k2*(s - 1) + 2*Dd*Pk2*f*(4*s - 1))))/(3465*d*k1**2*k2) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct*st**2*(-99*b1**2*(-D1*fd*(Pk2*k2**4*r + k1**4*(-4*Pk2*s + 2*Pkd2*k2*s) + k1**2*k2**2*(Pk2*r*(11 - 8*C) - Pk2*s*(4*C - 4) + Pkd2*k2*s*(6*C + 2))) + Dd*f*(Pk2*k2**4*(1 - 4*r) + 2*k1**4*(2*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(4*C*(8*r + 4*s - 3) - 44*r - 16*s + 15) + Pkd2*k2*(-6*C - 2)*(4*s - 1)))) - 11*b1*f*(9*D1*bd1*(Pk2*k2**4*(1 - 2*r) + 2*k1**4*(2*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(Pk2*(4*C*(4*r + 2*s - 3) - 22*r - 8*s + 15) + Pkd2*k2*(-6*C - 2)*(2*s - 1))) + D1*fd*(17*Pk2*k2**4*(1 - 2*r) + 2*k1**4*(Pk2*(16*C*s - 8*C - 21*r - 60*s + 32) + Pkd2*k2*(-6*C*s + 3*C - 2*s)) - k1**2*k2**2*(Pk2*(8*C*(25*r + 53*s - 26) + 92*r + 128*s - 87) + Pkd2*k2*s*(12*C + 4))) + Dd*f*(17*Pk2*k2**4*(1 - 4*r) + k1**4*(Pk2*(64*C*s - 16*C - 84*r - 240*s + 81) + Pkd2*k2*(-6*C - 2)*(4*s - 1)) - 2*k1**2*k2**2*(Pk2*(4*C*(50*r + 106*s - 39) + 92*r + 128*s - 55) + Pkd2*k2*(3*C + 1)*(4*s - 1)))) + f**2*(-11*D1*bd1*(-17*Pk2*k2**4*r + k1**4*(Pk2*(16*C*s - 21*r - 60*s + 17) - 2*Pkd2*k2*(3*C*s + s - 1)) - k1**2*k2**2*(Pk2*(4*C*(25*r + 53*s - 26) + 46*r + 64*s - 23) + Pkd2*k2*(6*C + 2)*(s - 1))) + k1**2*(D1*fd*(Pk2*k2**2*(12*C*(129*r + 66*s - 65) + 147*r + 108*s - 85) + k1**2*(30*C*Pkd2*k2*(1 - 3*s) + Pk2*(80*C*(3*s - 1) + 117*r + 48*s - 55))) + Dd*f*(Pk2*k2**2*(12*C*(172*r + 88*s - 65) + 196*r + 144*s - 85) + k1**2*(30*C*Pkd2*k2*(1 - 4*s) + Pk2*(80*C*(4*s - 1) + 156*r + 64*s - 55))))))/(3465*d*k1**2*k2*k3**2) - 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*f**2*st**6*(4*Pk2 - Pkd2*k2)*(39*b1*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1)) + f*(39*D1*bd1*s + 7*D1*fd*(4*s - 1) + 7*Dd*f*(4*s - 1)))/(3003*d*k1) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*f*st**4*(11*D1*bd1*f*(Pk2*k2**2*(2*r + s - 2) + k1**2*(4*C*Pkd2*k2*s + Pk2*(-8*C*s + 2*r + s - 2))) - 11*b1*(D1*fd*(Pk2*k2**2*(-4*r - 2*s + 1) + k1**2*(4*C*Pkd2*k2*(1 - 2*s) + Pk2*(16*C*s - 8*C - 4*r - 2*s + 1))) + Dd*f*(Pk2*k2**2*(-8*r - 4*s + 3) + k1**2*(4*C*Pkd2*k2*(1 - 4*s) + Pk2*(32*C*s - 8*C - 8*r - 4*s + 3)))) + 2*f*(D1*fd*(3*Pk2*k2**2*(6*C*(3*r - 1) + 2*r + s - 1) + k1**2*(4*C*Pkd2*k2*(3*s - 1) + Pk2*(-24*C*s + 8*C + 6*r + 3*s - 3))) + Dd*f*(Pk2*k2**2*(18*C*(4*r - 1) + 8*r + 4*s - 3) + k1**2*(4*C*Pkd2*k2*(4*s - 1) + Pk2*(-32*C*s + 8*C + 8*r + 4*s - 3)))))/(1155*d*k1*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*f*st**4*(-143*b1**2*(D1*fd*(k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(2*Pk2 - Pkd2*k2)*(4*s - 1)) + Dd*f*(4*s - 1)*(k1**2*(4*Pk2 - Pkd2*k2) - 2*k2**2*(-2*Pk2 + Pkd2*k2))) - 13*b1*f*(-11*D1*bd1*(-8*Pk2*k1**2*s + Pk2*k2**2*(2 - 8*s) + 2*Pkd2*k1**2*k2*s + Pkd2*k2**3*(4*s - 1)) + D1*fd*(4*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(-3*Pk2*(54*r + 47*s - 23) + 2*Pkd2*k2*(1 - 6*s))) + 4*Dd*f*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + Dd*f*k2**2*(Pk2*(-216*r - 188*s + 101) + 4*Pkd2*k2*(1 - 4*s))) + f**2*(13*D1*bd1*(-16*Pk2*k1**2*s + Pk2*k2**2*(54*r + 47*s - 32) + 4*Pkd2*k1**2*k2*s + 2*Pkd2*k2**3*(2*s - 1)) + D1*fd*(2*Pk2*k2**2*(336*r + 260*s - 149) - 5*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 2*Dd*Pk2*f*k2**2*(336*r + 260*s - 149) - 5*Dd*f*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)))/(15015*d*k1*k2**2) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*st**2*(99*b1**3*(Pkd2*k2**3 + k1**2*(-2*Pk2 + Pkd2*k2))*(D1*fd*s + Dd*f*(4*s - 1)) - 11*b1**2*(-9*D1*bd1*f*(3*s - 1)*(Pkd2*k2**3 + k1**2*(-2*Pk2 + Pkd2*k2)) - D1*fd*(k1**2*(Pk2*(46*f*s - 27*f + 9*s - 9) + 4*Pkd2*f*k2*s) + k2**2*(Pk2*f*(128*r + 108*s - 43) + 9*Pk2*(s - 1) + 2*Pkd2*f*k2*s)) + Dd*f*(-k1**2*(4*s - 1)*(Pk2*(23*f + 9) + 2*Pkd2*f*k2) + k2**2*(Pk2*(-2*f*(128*r + 108*s - 59) - 36*s + 9) + Pkd2*f*k2*(1 - 4*s)))) + b1*f*(11*D1*bd1*(Pk2*s*(18*k1**2 + 18*k2**2) + f*k1**2*(Pk2*(46*s + 4) + 2*Pkd2*k2*(2*s - 1)) + f*k2**2*(Pk2*(128*r + 108*s - 75) + Pkd2*k2*(2*s - 1))) + D1*fd*(Pk2*k2**2*(352*K*r - 176*K + 9*f*(64*r + 22*s - 25) + 352*r + 22*s - 187) + k1**2*(Pk2*(228*f*s - 66*f + 22*s - 11) - 15*Pkd2*f*k2*s)) + Dd*f*(Pk2*k2**2*(704*K*r - 176*K + 6*f*(128*r + 44*s - 43) + 704*r + 44*s - 187) + k1**2*(4*s - 1)*(Pk2*(76*f + 11) - 5*Pkd2*f*k2))) + f*(D1*bd1*f*(11*Pk2*(k1**2*s + k2**2*(r*(16*K + 16) + s)) + f*(3*Pk2*k2**2*(64*r + 22*s - 11) + k1**2*(2*Pk2*(38*s - 5) - 5*Pkd2*k2*(s - 1)))) + Pk2*(15*D1*f**2*fd*k1**2*(1 - 4*s) + 176*D1*f*k2**2*r*(bd2 - 2*gd2) + 176*D1*fd*k2**2*(b2 - 2*g2)*(2*r - 1) + 15*Dd*f**3*k1**2*(1 - 4*s) + 176*Dd*f*k2**2*(b2 - 2*g2)*(4*r - 1))))/(3465*d*k1*k2**2) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*st**2*(99*b1**2*k2**2*(D1*fd*(Pk2*k2**2*(2*r + s) + k1**2*(4*C*Pkd2*k2*s + 2*Pk2*r + Pk2*s)) + Dd*f*(Pk2*k2**2*(8*r + 4*s - 3) + k1**2*(4*C*Pkd2*k2*(4*s - 1) + Pk2*(8*r + 4*s - 3)))) + 11*b1*f*(D1*(9*bd1*k2**2*(Pk2*k2**2*(4*r + 2*s - 3) + k1**2*(4*C*Pkd2*k2*(2*s - 1) + Pk2*(4*r + 2*s - 3))) + fd*(Pk2*k1**4*(2*s - 1) + 2*Pk2*k2**4*(16*C*(2*r - 1) + 2*r + s - 1) + k1**2*k2**2*(8*C*Pkd2*k2*s + Pk2*(36*C*(2*r + 6*s - 3) + 4*r + 4*s - 3)))) + Dd*f*(Pk2*k1**4*(4*s - 1) + Pk2*k2**4*(32*C*(4*r - 1) + 8*r + 4*s - 3) + 4*k1**2*k2**2*(C*Pkd2*k2*(4*s - 1) + Pk2*(36*C*(r + 3*s - 1) + 2*r + 2*s - 1)))) + f**2*(D1*(Pk2*fd*k1**2*(k1**2*(5 - 15*s) + k2**2*(12*C*(27*r + 33*s - 20) - 15*s + 5)) + 11*bd1*(Pk2*k1**4*s + Pk2*k2**4*(r*(32*C + 2) + s - 1) + k1**2*k2**2*(4*C*Pkd2*k2*(s - 1) + Pk2*(36*C*(r + 3*s - 1) + 2*r + 2*s - 1)))) + Dd*Pk2*f*k1**2*(k1**2*(5 - 20*s) + k2**2*(48*C*(9*r + 11*s - 5) - 20*s + 5))))/(3465*d*k1*k2**2*k3**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**6*f*k2**2*(C - 1)*(22*D1*bd1*f*(r - 1) + 22*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 21*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(693*d*k3**2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**5*f**2*k2*(13*D1*bd1*f*(r - 1) + 13*b1*(3*D1*fd*r + Dd*f*(4*r - 1)) + 12*f*(4*r - 1)*(D1*fd + Dd*f))/(429*d*k1) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**5*f*k2*(k1**2*(5 - 4*C) + k2**2)*(22*D1*bd1*f*(r - 1) + 22*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 21*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(693*d*k1*k3**2) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**4*f*k2**2*st**2*(C - 1)*(11*D1*bd1*f*(r - 1) + 11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 5*f*(D1*fd*(1 - 3*r) + Dd*(-4*f*r + f)))/(1155*d*k3**2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**4*(143*b1**2*(D1*fd*r*(-9*K + 20*f + 9) + Dd*f*(4*r - 1)*(-9*K + 10*f + 9)) + 13*b1*(11*D1*bd1*f*(2*r - 1)*(-9*K + 10*f + 9) + D1*(105*f**2*fd*(9*r - 1) - 22*f*(5*fd*(K - 1)*(2*r - 1) - 9*gd2*r) + 198*fd*g2*r) + Dd*f*(4*r - 1)*(315*f**2 - 110*f*(K - 1) + 198*g2)) + f*(13*D1*bd1*(105*f**2*(3*r - 2) - 110*f*r*(K - 1) + 198*g2*(r - 1)) + 20*D1*(126*f**2*fd*(4*r - 1) + 143*f*gd2*r + 143*fd*g2*(2*r - 1)) + 20*Dd*f*(126*f**2 + 143*g2)*(4*r - 1)))/(45045*d) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**4*(11*D1*bd1*f*(9*b1*k2**2*(C - 1)*(2*r - 1) + 10*f*(k1**2*(C - 2)*(r - 1) + k2**2*(C - 2*r + 1))) + 99*b1**2*k2**2*(C - 1)*(D1*fd*r + Dd*f*(4*r - 1)) + 110*b1*f*(D1*fd*(k1**2*r*(2*C - 4) - k2**2*(C + 4*r - 1)) + Dd*f*(4*r - 1)*(k1**2*(C - 2) - 2*k2**2)) + 105*f**2*(k1**2*(C - 2) - k2**2*(C + 1))*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(3465*d*k3**2) - 20*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**3*f**2*k2*st**2*(13*D1*bd1*f*(r - 1) + 13*b1*(3*D1*fd*r + Dd*f*(4*r - 1)) + 21*f*(4*r - 1)*(D1*fd + Dd*f))/(9009*d*k1) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**3*f*k2*st**2*(k1**2*(3 - 2*C) + k2**2)*(11*D1*bd1*f*(r - 1) + 11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 5*f*(D1*fd*(1 - 3*r) + Dd*(-4*f*r + f)))/(1155*d*k1*k3**2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**3*(143*b1**2*(D1*fd*r*(k1**2*(20*f + 9) + k2**2*(40*f + 9)) + Dd*f*(4*r - 1)*(k1**2*(10*f + 9) + k2**2*(20*f + 9))) + 13*b1*f*(11*D1*bd1*(2*r - 1)*(k1**2*(10*f + 9) + k2**2*(20*f + 9)) + 5*D1*fd*(k1**2*(21*f*(6*r - 1) + 44*r - 22) + 2*k2**2*(21*f*(3*r - 1) + 22*r - 11)) + 10*Dd*f*(21*f + 11)*(k1**2 + k2**2)*(4*r - 1)) + 5*f**2*(13*D1*bd1*(21*f*(k1**2*(2*r - 1) + 2*k2**2*r) + r*(22*k1**2 + 22*k2**2)) + 252*f*k1**2*(4*r - 1)*(D1*fd + Dd*f)))/(45045*d*k1*k2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**3*(11*D1*bd1*f*(9*b1*k2**2*(2*r - 1)*(k1**2*(5 - 4*C) + k2**2) + 10*f*(k1**4*(r - 1) - k1**2*k2**2*(4*C - 6*r + 1) + k2**4*r)) + 99*b1**2*k2**2*(k1**2*(5 - 4*C) + k2**2)*(D1*fd*r + Dd*f*(4*r - 1)) + 110*b1*f*(D1*fd*(2*k1**4*r + k1**2*k2**2*(4*C + 12*r - 5) + k2**4*(2*r - 1)) + Dd*f*(4*r - 1)*(k1**4 + 6*k1**2*k2**2 + k2**4)) + 105*f**2*k1**2*(k1**2 + k2**2*(4*C + 1))*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(3465*d*k1*k2*k3**2) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**2*f*k2**2*st**4*(C - 1)*(11*D1*bd1*f*(r - 1) + 11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 2*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(1155*d*k3**2) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**2*st**2*(429*b1**2*(D1*fd*r*(-3*K + 4*f + 3) + Dd*f*(4*r - 1)*(-3*K + 2*f + 3)) + 13*b1*(33*D1*bd1*f*(2*r - 1)*(-3*K + 2*f + 3) + D1*(-30*f**2*fd*(9*r - 1) - 11*f*fd*(K - 1)*(2*r - 1) + 198*f*gd2*r + 198*fd*g2*r) - Dd*f*(4*r - 1)*(90*f**2 + 11*f*(K - 1) - 198*g2)) + f*(-13*D1*bd1*(30*f**2*(3*r - 2) + 11*f*r*(K - 1) - 198*g2*(r - 1)) + 2*D1*(-630*f**2*fd*(4*r - 1) + 143*f*gd2*r + 143*fd*g2*(2*r - 1)) - 2*Dd*f*(630*f**2 - 143*g2)*(4*r - 1)))/(45045*d) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**2*(99*b1**3*(D1*fd*r + Dd*f*(4*r - 1)) + 11*b1**2*(9*D1*bd1*f*(3*r - 1) + D1*fd*(9*K + 80*f*r - 10*f + 18*r - 9) + 2*Dd*f*(20*f + 9)*(4*r - 1)) + b1*(220*D1*K*f*fd*r - 110*D1*K*f*fd + 11*D1*bd1*f*(-9*K + 10*f*(8*r - 3) + 36*r - 9) + 99*D1*bd2*f*r + 945*D1*f**2*fd*r - 315*D1*f**2*fd + 220*D1*f*fd*r - 110*D1*f*fd - 198*D1*fd*g2 + 440*Dd*K*f**2*r - 110*Dd*K*f**2 + 1260*Dd*f**3*r - 315*Dd*f**3 + 440*Dd*f**2*r - 110*Dd*f**2 + 99*b2*(D1*fd*r + Dd*f*(4*r - 1))) + f*(99*D1*b2*bd1*(r - 1) + 5*D1*bd1*f*r*(22*K + 63*f + 22) + 198*D1*bd1*g2 + 110*D1*(f*r*(bd2 - 2*gd2) + fd*g2*(2 - 4*r)) + 220*Dd*f*g2*(1 - 4*r) + 110*b2*(D1*fd*(2*r - 1) + Dd*f*(4*r - 1))))/(3465*d) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**2*st**2*(11*D1*bd1*f*(9*b1*k2**2*(C - 1)*(2*r - 1) + f*k1**2*(C - 4)*(r - 1) + f*k2**2*(C*(6 - 5*r) - 4*r + 3)) + 99*b1**2*k2**2*(C - 1)*(D1*fd*r + Dd*f*(4*r - 1)) + 11*b1*f*(D1*fd*(k1**2*r*(2*C - 8) - k2**2*(10*C*r + C + 8*r - 1)) + Dd*f*(4*r - 1)*(k1**2*(C - 4) - k2**2*(5*C + 4))) - 5*f**2*(k1**2*(C - 4) - k2**2*(6*C + 3))*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(3465*d*k3**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**2*(99*b1**2*(k1**2*(C - 2) - k2**2*(C + 1))*(D1*fd*r + Dd*f*(4*r - 1)) + 11*b1*f*(9*D1*bd1*(2*r - 1)*(k1**2*(C - 2) - k2**2*(C + 1)) - 10*D1*fd*(k1**2*(C + 4*r - 2) + k2**2*(C + 1)*(2*r - 1)) - 10*Dd*f*(2*k1**2 + k2**2*(C + 1))*(4*r - 1)) - 5*f**2*(21*C*k1**2*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)) + 22*D1*bd1*(-C*k1**2 + C*k2**2*r + 2*k1**2*r + k2**2*r)))/(3465*d*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct*f**2*k2*st**4*(26*D1*bd1*f*(r - 1) + 26*b1*(3*D1*fd*r + Dd*f*(4*r - 1)) + 5*f*(4*r - 1)*(D1*fd + Dd*f))/(3003*d*k1) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct*f*k2*st**4*(k1**2 + k2**2)*(11*D1*bd1*f*(r - 1) + 11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 2*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(1155*d*k1*k3**2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct*k1*(k1**2 + k2**2*(4*C + 1))*(10*D1*bd1*f**2*r + 9*b1**2*(D1*fd*r + Dd*f*(4*r - 1)) + b1*f*(9*D1*bd1*(2*r - 1) + 10*D1*fd*(2*r - 1) + 10*Dd*f*(4*r - 1)))/(315*d*k2*k3**2) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct*st**2*(429*b1**2*(D1*fd*r*(k1**2*(2*f + 3) + k2**2*(4*f + 3)) + Dd*f*(4*r - 1)*(k1**2*(f + 3) + k2**2*(2*f + 3))) + 13*b1*f*(33*D1*bd1*(2*r - 1)*(k1**2*(f + 3) + k2**2*(2*f + 3)) + D1*fd*(k1**2*(f*(15 - 90*r) + 22*r - 11) + k2**2*(f*(30 - 90*r) + 22*r - 11)) - Dd*f*(30*f - 11)*(k1**2 + k2**2)*(4*r - 1)) + f**2*(-195*D1*bd1*f*(k1**2*(2*r - 1) + 2*k2**2*r) + 143*D1*bd1*r*(k1**2 + k2**2) - 315*f*k1**2*(4*r - 1)*(D1*fd + Dd*f)))/(45045*d*k1*k2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct*(105*D1*bd1*f**3*k1**2*r + 99*b1**3*(k1**2 + k2**2)*(D1*fd*r + Dd*f*(4*r - 1)) + 11*b1**2*(9*D1*bd1*f*(k1**2 + k2**2)*(3*r - 1) + D1*fd*(k1**2*(40*f*r - 10*f + 9*r - 9) + k2**2*(20*f*r - 10*f + 9*r - 9)) + Dd*f*(4*r - 1)*(k1**2*(20*f + 9) + k2**2*(10*f + 9))) + b1*f*(22*D1*bd1*(5*f*(k1**2*(4*r - 1) + 2*k2**2*r) + r*(9*k1**2 + 9*k2**2)) + 105*f*k1**2*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1))))/(3465*d*k1*k2) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct*st**2*(11*D1*bd1*f*(9*b1*k2**2*(k1**2 + k2**2)*(2*r - 1) + f*(k1**4*(r - 1) + k1**2*k2**2*(12*C*(r - 1) + 2*r - 1) + k2**4*r)) + 99*b1**2*k2**2*(k1**2 + k2**2)*(D1*fd*r + Dd*f*(4*r - 1)) + 11*b1*f*(D1*fd*(2*k1**4*r + k1**2*k2**2*(r*(24*C + 4) - 1) + k2**4*(2*r - 1)) + Dd*f*(4*r - 1)*(k1**4 + k1**2*k2**2*(12*C + 2) + k2**4)) - 5*f**2*k1**2*(k1**2 + k2**2*(12*C + 1))*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(3465*d*k1*k2*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*f*st**4*(143*b1**2*(2*D1*fd*r + Dd*f*(4*r - 1)) + 13*b1*f*(11*D1*bd1*(2*r - 1) + 2*D1*fd*(9*r - 1) + 6*Dd*f*(4*r - 1)) + 2*f**2*(13*D1*bd1*(3*r - 2) + (4*r - 1)*(5*D1*fd + 5*Dd*f)))/(15015*d) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*st**2*(99*b1**3*(D1*fd*r + Dd*f*(4*r - 1)) + 11*b1**2*(9*D1*bd1*f*(3*r - 1) + D1*fd*(f*(8*r - 1) + r*(9*K + 9)) + Dd*f*(4*r - 1)*(9*K + 4*f + 9)) + b1*(22*D1*K*f*fd*r - 11*D1*K*f*fd + 11*D1*bd1*f*(f*(8*r - 3) + (9*K + 9)*(2*r - 1)) + 99*D1*bd2*f*r - 45*D1*f**2*fd*r + 15*D1*f**2*fd + 22*D1*f*fd*r - 11*D1*f*fd - 198*D1*f*gd2*r - 198*D1*fd*g2*r + 44*Dd*K*f**2*r - 11*Dd*K*f**2 - 60*Dd*f**3*r + 15*Dd*f**3 + 44*Dd*f**2*r - 11*Dd*f**2 - 792*Dd*f*g2*r + 198*Dd*f*g2 + 99*b2*(D1*fd*r + Dd*f*(4*r - 1))) + f*(D1*bd1*f*r*(11*K - 15*f + 11) - 198*D1*bd1*g2*(r - 1) + 11*D1*(f*r*(bd2 - 2*gd2) + fd*g2*(2 - 4*r)) + 22*Dd*f*g2*(1 - 4*r) + 11*b2*(9*D1*bd1*(r - 1) + D1*fd*(2*r - 1) + Dd*f*(4*r - 1))))/(3465*d) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*(9*D1*bd1*f*r*(b2 - 2*g2) + 9*b1**3*(D1*fd*r + Dd*f*(4*r - 1)) + b1**2*(9*D1*bd1*f*(3*r - 1) + D1*fd*(10*f*(2*r - 1) + (9*K + 9)*(r - 1)) + Dd*f*(4*r - 1)*(9*K + 10*f + 9)) + b1*(D1*f*r*(2*bd1*(9*K + 10*f + 9) + 9*bd2 - 18*gd2) - 18*D1*fd*g2*(r - 1) + 18*Dd*f*g2*(1 - 4*r) + 9*b2*(D1*fd*(r - 1) + Dd*f*(4*r - 1))))/(315*d)
        perm13 = -32*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**7*f*k2**5*(C - 1)*(22*D1*bd1*f*(r + s - 1) + 22*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 21*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(693*d*k3**6) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**7*f*k2**3*(C - 1)*(22*b1*(2*s - 1)*(D1*fd + 2*Dd*f) + f*(22*D1*bd1*s + 21*D1*fd*(3*s - 1) + 42*Dd*f*(2*s - 1)))/(693*d*k3**4) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**6*f*k2**4*(13*D1*bd1*f*(21*f*k2**2 + k1**2*(220*C - 198))*(r + s - 1) + 13*b1*(D1*fd*(21*f*k2**2*(3*r + 3*s - 2) + k1**2*(220*C - 198)*(2*r + 2*s - 1)) + Dd*f*(21*f*k2**2 + k1**2*(220*C - 198))*(4*r + 4*s - 3)) + 21*f*(D1*fd*(12*f*k2**2*(4*r + 4*s - 3) + k1**2*(130*C - 117)*(3*r + 3*s - 2)) + Dd*f*(12*f*k2**2 + k1**2*(130*C - 117))*(4*r + 4*s - 3)))/(9009*d*k1*k3**6) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**6*f*k2**2*(22*b1*(2*s - 1)*(D1*fd + 2*Dd*f) + f*(22*D1*bd1*s + 21*D1*fd*(3*s - 1) + 42*Dd*f*(2*s - 1)))/(693*d*k1*k3**2) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**6*f*k2**2*(22*b1*(D1*fd*(k1**2*(8*C - 7)*(2*s - 1) + k2**2*(2*r + 2*s - 1)) + Dd*f*(k1**2*(16*C - 14)*(2*s - 1) + k2**2*(4*r + 4*s - 3))) + f*(22*D1*bd1*(k1**2*s*(8*C - 7) + k2**2*(r + s - 1)) + D1*fd*(k1**2*(168*C - 147)*(3*s - 1) + k2**2*(C*(2 - 6*r) + 69*r + 63*s - 44)) + Dd*f*k1**2*(336*C - 294)*(2*s - 1) + Dd*f*k2**2*(C*(2 - 8*r) + 92*r + 84*s - 65)))/(693*d*k1*k3**4) + 32*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**5*f*k2**5*st**2*(C - 1)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) - 5*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(693*d*k3**6) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**5*f*k2**3*st**2*(C - 1)*(11*b1*(2*s - 1)*(D1*fd + 2*Dd*f) + f*(11*D1*bd1*s + D1*fd*(5 - 15*s) + 10*Dd*f*(1 - 2*s)))/(693*d*k3**4) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**5*k2**3*(13*D1*bd1*f*(r + s - 1)*(315*f**2*k2**2 + 110*f*(k1**2*(20*C - 16) + k2**2*(K - 2*b1 - 1)) - k2**2*(-198*K*b1 + 198*b1 + 198*g2)) - 143*b1**2*k2**2*(D1*fd*(10*f*(2*r + 2*s - 1) + (9 - 9*K)*(r + s)) + Dd*f*(-9*K + 10*f + 9)*(4*r + 4*s - 3)) + 13*b1*(D1*(315*f**2*fd*k2**2*(3*r + 3*s - 2) + 22*f*(5*fd*(k1**2*(20*C - 16) + k2**2*(K - 1))*(2*r + 2*s - 1) - 9*gd2*k2**2*(r + s - 1)) - 198*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(315*f**2*k2**2 + 110*f*(k1**2*(20*C - 16) + k2**2*(K - 1)) - 198*g2*k2**2)) + 20*f*(D1*(252*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(1365*C - 1092)*(3*r + 3*s - 2) - 143*f*gd2*k2**2*(r + s - 1) - 143*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(252*f**2*k2**2 + f*k1**2*(1365*C - 1092) - 143*g2*k2**2)))/(45045*d*k3**6) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**5*k2*(396*b1**2*k1**2*(C - 1)*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) + 22*b1*f*(2*D1*(18*bd1*k1**2*s*(C - 1) + 5*fd*(k1**2*(2*s - 1) + k2**2*r)) + 5*Dd*f*(k1**2*(8*s - 4) + k2**2*(4*r - 1))) + 5*f**2*(D1*(44*bd1*k1**2*s + 22*bd1*k2**2*(r - 1) - fd*k1**2*(84*C - 126)*(3*s - 1) + 19*fd*k2**2*(3*r - 1)) + Dd*f*(-k1**2*(168*C - 252)*(2*s - 1) + 19*k2**2*(4*r - 1))))/(3465*d*k1**2*k3**2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**5*k2*(5148*b1**2*k1**2*k2**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + 26*b1*f*(2*D1*(99*bd1*k1**2*k2**2*(C - 1)*(2*r + 2*s - 1) + fd*(75*f*k2**4*r + k1**4*(660*C - 495)*(2*s - 1) - 11*k1**2*k2**2*(2*C*(19*r + 28*s - 9) - 53*r - 76*s + 28))) + Dd*f*(50*f*k2**4*(4*r - 1) + k1**4*(2640*C - 1980)*(2*s - 1) - 11*k1**2*k2**2*(2*C*(76*r + 112*s - 75) - 212*r - 304*s + 205))) + f**2*(D1*(26*bd1*(50*f*k2**4*(r - 1) + k1**4*s*(1320*C - 990) - 11*k1**2*k2**2*(C*(38*r + 56*s - 58) - 53*r - 76*s + 73)) + 5*fd*(189*f*k2**4*(4*r - 1) + k1**4*(6552*C - 4914)*(3*s - 1) - 13*k1**2*k2**2*(8*C*(102*r + 129*s - 77) - 999*r - 1284*s + 761))) + 5*Dd*f*(189*f*k2**4*(4*r - 1) + k1**4*(13104*C - 9828)*(2*s - 1) - 13*k1**2*k2**2*(32*C*(34*r + 43*s - 30) - 1332*r - 1712*s + 1189))))/(45045*d*k1**2*k3**4) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**4*f*k2**4*st**2*(13*D1*bd1*f*(75*f*k2**2 + k1**2*(726 - 836*C))*(r + s - 1) + 13*b1*(D1*fd*(75*f*k2**2*(3*r + 3*s - 2) + k1**2*(726 - 836*C)*(2*r + 2*s - 1)) + Dd*f*(75*f*k2**2 + k1**2*(726 - 836*C))*(4*r + 4*s - 3)) + 5*f*(D1*fd*(315*f*k2**2*(4*r + 4*s - 3) + k1**2*(988*C - 858)*(3*r + 3*s - 2)) + Dd*f*(315*f*k2**2 + k1**2*(988*C - 858))*(4*r + 4*s - 3)))/(45045*d*k1*k3**6) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**4*f*k2**2*st**2*(11*b1*(2*s - 1)*(D1*fd + 2*Dd*f) + f*(11*D1*bd1*s + D1*fd*(5 - 15*s) + 10*Dd*f*(1 - 2*s)))/(693*d*k1*k3**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**4*f*k2**2*st**2*(11*b1*(D1*fd*(k1**2*(32*C - 27)*(2*s - 1) + k2**2*(-8*C*r + 18*r + 10*s - 5)) + Dd*f*(k1**2*(64*C - 54)*(2*s - 1) + k2**2*(-16*C*r + 4*C + 36*r + 20*s - 19))) - f*(11*D1*bd1*(k1**2*s*(27 - 32*C) + k2**2*(4*C*(r - 1) - 9*r - 5*s + 9)) + D1*fd*(k1**2*(160*C - 135)*(3*s - 1) + k2**2*(76*C*(3*r - 1) - 153*r + 75*s + 26)) + Dd*f*k1**2*(320*C - 270)*(2*s - 1) + Dd*f*k2**2*(76*C*(4*r - 1) - 204*r + 100*s + 1)))/(3465*d*k1*k3**4) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**4*k1*k2**2*(26*D1*bd1*f*(r + s - 1)*(105*f**2*k2**2 + 55*f*(k1**2*(20*C - 14) + k2**2*(5*K - 8*b1 - 4)) - k2**2*(99*b1*(4 - 5*K) + 495*g2)) - 143*b1**2*k2**2*(D1*fd*(40*f*(2*r + 2*s - 1) + (36 - 45*K)*(r + s)) + Dd*f*(-45*K + 40*f + 36)*(4*r + 4*s - 3)) + 130*b1*(D1*(21*f**2*fd*k2**2*(3*r + 3*s - 2) + 11*f*(fd*(k1**2*(20*C - 14) + k2**2*(5*K - 4))*(2*r + 2*s - 1) - 9*gd2*k2**2*(r + s - 1)) - 99*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(21*f**2*k2**2 + 11*f*(k1**2*(20*C - 14) + k2**2*(5*K - 4)) - 99*g2*k2**2)) + 10*f*(D1*(756*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(2730*C - 1911)*(3*r + 3*s - 2) - 1430*f*gd2*k2**2*(r + s - 1) - 1430*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(756*f**2*k2**2 + f*k1**2*(2730*C - 1911) - 1430*g2*k2**2)))/(45045*d*k3**6) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**4*(10*D1*bd1*f**2*s + 9*b1**2*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) + 2*b1*f*(9*D1*bd1*s + 5*D1*fd*(2*s - 1) + 10*Dd*f*(2*s - 1)))/(315*d*k1) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**4*(198*b1**2*k1**2*(4*C - 3)*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) + 22*b1*f*(D1*(18*bd1*k1**2*s*(4*C - 3) + fd*k2**2*(4*C*r - 2*C - 2*r - 46*s + 25)) + Dd*f*k2**2*(C*(8*r - 2) - 4*r - 92*s + 47)) - f**2*(D1*(22*bd1*k2**2*(-2*C*r + r + 23*s + 1) + 5*fd*(k1**2*(168*C - 126)*(3*s - 1) + k2**2*(-12*C*r + 4*C + 24*r + 327*s - 117))) + 10*Dd*f*(k1**2*(168*C - 126)*(2*s - 1) + k2**2*(-8*C*r + 2*C + 16*r + 218*s - 113))))/(3465*d*k1*k3**2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**4*(286*b1**2*k2**2*(D1*fd*(k1**2*(54*C - 45)*(r + s - 1) + k2**2*(10*f*(4*r + 4*s - 3) + 9*r + 9*s)) + Dd*f*(k1**2*(54*C - 45) + k2**2*(20*f + 9))*(4*r + 4*s - 3)) + 26*b1*f*(D1*(99*bd1*k1**2*k2**2*(6*C - 5)*(2*r + 2*s - 1) + 22*bd1*k2**4*(5*f*(4*r + 4*s - 3) + 9*r + 9*s - 9) + fd*k1**4*(880*C - 550)*(2*s - 1) - 11*fd*k1**2*k2**2*(6*C*(38*r + 62*s - 21) - 190*r - 346*s + 123) + fd*k2**4*(11*K*(2*r - 1) + 5*f*(120*r - 39*s + 4) + 198*r + 220*s - 99)) + Dd*f*(k1**4*(1760*C - 1100)*(2*s - 1) - 11*k1**2*k2**2*(6*C*(76*r + 124*s - 81) - 380*r - 692*s + 441) + k2**4*(44*K*r - 11*K + 10*f*(80*r - 26*s - 7) + 396*r + 440*s - 319))) - f*(D1*(-10*f**2*k2**4*(13*bd1*(40*r - 13*s - 18) - 21*fd*(24*r + 130*s - 71)) - 13*f*(22*bd1*(k1**4*s*(80*C - 50) + k1**2*k2**2*(-6*C*(19*r + 31*s - 29) + 95*r + 173*s - 145) + k2**4*(r*(K + 9) + 10*s - 10)) + fd*k1**4*(1680*C - 1050)*(3*s - 1) + 5*fd*k1**2*k2**2*(-8*C*(297*r + 420*s - 239) + 1974*r + 3033*s - 1669) - 44*gd2*k2**4*r) + 572*fd*g2*k2**4*(2*r - 1)) + 2*Dd*f*(105*f**2*k2**4*(24*r + 130*s - 71) - 130*f*(k1**4*(168*C - 105)*(2*s - 1) + k1**2*k2**2*(-2*C*(396*r + 560*s - 379) + 658*r + 1011*s - 670)) + 286*g2*k2**4*(4*r - 1))))/(45045*d*k1*k3**4) + 32*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**3*f*k2**5*st**4*(C - 1)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 2*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(231*d*k3**6) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**3*f*k2**3*st**4*(C - 1)*(11*b1*(2*s - 1)*(D1*fd + 2*Dd*f) + f*(11*D1*bd1*s + D1*fd*(6*s - 2) + 4*Dd*f*(2*s - 1)))/(231*d*k3**4) + 32*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**3*k1**2*k2*(13*D1*bd1*f*(r + s - 1)*(105*f**2*k2**2 - 110*f*(k1**2*(5*C - 3) + k2**2*(5*K - 6*b1 - 3)) + k2**2*(198*b1*(3 - 5*K) + 990*g2)) + 429*b1**2*k2**2*(D1*fd*(10*f*(2*r + 2*s - 1) + (9 - 15*K)*(r + s)) + Dd*f*(-15*K + 10*f + 9)*(4*r + 4*s - 3)) + 65*b1*(D1*(21*f**2*fd*k2**2*(3*r + 3*s - 2) - 22*f*(fd*(k1**2*(5*C - 3) + k2**2*(5*K - 3))*(2*r + 2*s - 1) - 9*gd2*k2**2*(r + s - 1)) + 198*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(21*f**2*k2**2 - 22*f*(k1**2*(5*C - 3) + k2**2*(5*K - 3)) + 198*g2*k2**2)) - 5*f*(D1*(504*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(1365*C - 819)*(3*r + 3*s - 2) - 2860*f*gd2*k2**2*(r + s - 1) - 2860*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(504*f**2*k2**2 + f*k1**2*(1365*C - 819) - 2860*g2*k2**2)))/(45045*d*k3**6) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**3*k2**3*st**2*(13*D1*bd1*f*(r + s - 1)*(150*f**2*k2**2 - 11*f*(k1**2*(110*C - 82) + k2**2*(3*K - 20*b1 - 3)) + k2**2*(-594*K*b1 + 594*b1 + 594*g2)) + 143*b1**2*k2**2*(D1*fd*(10*f*(2*r + 2*s - 1) + (27 - 27*K)*(r + s)) + Dd*f*(-27*K + 10*f + 27)*(4*r + 4*s - 3)) + 13*b1*(D1*(150*f**2*fd*k2**2*(3*r + 3*s - 2) - 11*f*fd*(k1**2*(110*C - 82) + k2**2*(3*K - 3))*(2*r + 2*s - 1) + 594*f*gd2*k2**2*(r + s - 1) + 594*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(150*f**2*k2**2 - 11*f*(k1**2*(110*C - 82) + k2**2*(3*K - 3)) + 594*g2*k2**2)) + 2*f*(D1*(2100*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(3575*C - 2665)*(3*r + 3*s - 2) + 429*f*gd2*k2**2*(r + s - 1) + 429*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(2100*f**2*k2**2 + f*k1**2*(3575*C - 2665) + 429*g2*k2**2)))/(45045*d*k3**6) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**3*(2574*b1**3*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) - 143*b1**2*k2**2*(D1*(-18*bd1*f*k2**2*(3*r + 3*s - 2) + fd*k1**2*(108*C - 72)*(r + s - 1) + fd*k2**2*(-18*K*(r + s + 1) + 2*f*(107*r + 116*s - 68) + 45*r + 54*s + 18)) + Dd*f*(k1**2*(108*C - 72)*(4*r + 4*s - 3) + k2**2*(-9*K*(8*r + 8*s - 6) + f*(428*r + 464*s - 339) + 180*r + 216*s - 153))) - 13*b1*(D1*(f**2*k2**4*(2354*bd1*r + 319*bd1*(8*s - 7) + 10*fd*(315*r + 51*s - 68)) + 11*f*(2*fd*(k1**4*(20*C - 10)*(2*s - 1) + k1**2*k2**2*(-6*C*(38*r + 74*s - 27) + 142*r + 334*s - 127) + k2**4*(K*(-50*r - 58*s + 25) + 82*r + 98*s - 41)) + 9*k2**2*(4*bd1*k1**2*(3*C - 2)*(2*r + 2*s - 1) + bd1*k2**2*(K*(-4*r - 4*s + 6) + 10*r + 12*s - 13) + k2**2*(-2*bd2 + 4*gd2)*(r + s - 1))) + 198*fd*k2**4*(-b2*(r + s) + 2*g2*(r + s + 1))) + 2*Dd*f*(5*f**2*k2**4*(420*r + 68*s - 139) + 11*f*(k1**4*(40*C - 20)*(2*s - 1) + k1**2*k2**2*(-6*C*(76*r + 148*s - 93) + 284*r + 668*s - 405) + k2**4*(K*(-100*r - 116*s + 83) + 164*r + 196*s - 139)) + k2**4*(-99*b2 + 198*g2)*(4*r + 4*s - 3))) + f*(D1*(-5*f**2*k2**4*(26*bd1*(105*r + 17*s - 71) - 63*fd*(68*r + 208*s - 121)) - 13*f*(22*bd1*(k1**4*s*(20*C - 10) + k1**2*k2**2*(-6*C*(19*r + 37*s - 29) + 71*r + 167*s - 111) + k2**4*(K*(-25*r - 29*s + 29) + 41*r + 49*s - 49)) + fd*k1**4*(420*C - 210)*(3*s - 1) + 5*fd*k1**2*k2**2*(-16*C*(147*r + 243*s - 130) + 1503*r + 2850*s - 1451) + 44*k2**4*(-5*bd2*(r + s - 1) + 25*gd2*r + 29*gd2*(s - 1))) + 286*k2**4*(b2*(9*bd1*(r + s - 1) + 10*fd*(2*r + 2*s - 1)) - 2*g2*(9*bd1*(r + s - 2) + fd*(50*r + 58*s - 25)))) + Dd*f*(315*f**2*k2**4*(68*r + 208*s - 121) - 65*f*(k1**4*(168*C - 84)*(2*s - 1) + k1**2*k2**2*(-16*C*(196*r + 324*s - 211) + 2004*r + 3800*s - 2401)) + 572*k2**4*(5*b2*(4*r + 4*s - 3) + g2*(-100*r - 116*s + 83)))))/(45045*d*k2*k3**4) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**3*k2*st**2*(594*b1**2*k1**2*(C - 1)*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) - 11*b1*f*(-2*D1*(54*bd1*k1**2*s*(C - 1) - fd*k1**2*(7*C - 8)*(2*s - 1) + fd*k2**2*r) + Dd*f*(k1**2*(28*C - 32)*(2*s - 1) + k2**2*(1 - 4*r))) + f**2*(D1*(22*bd1*k1**2*s*(8 - 7*C) + 11*bd1*k2**2*(r - 1) + fd*k1**2*(100*C - 110)*(3*s - 1) + 101*fd*k2**2*(1 - 3*r)) + Dd*f*(k1**2*(200*C - 220)*(2*s - 1) + 101*k2**2*(1 - 4*r))))/(3465*d*k1**2*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**3*k2*st**2*(7722*b1**2*k1**2*k2**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) - 13*b1*f*(D1*(-594*bd1*k1**2*k2**2*(C - 1)*(2*r + 2*s - 1) + fd*(315*f*k2**4*r - k1**4*(814*C - 572)*(2*s - 1) + 22*k1**2*k2**2*(2*C*(50*r + 67*s - 32) - 103*r - 142*s + 68))) + Dd*f*(105*f*k2**4*(4*r - 1) - k1**4*(1628*C - 1144)*(2*s - 1) + 11*k1**2*k2**2*(8*C*(50*r + 67*s - 46) - 412*r - 568*s + 387))) + f**2*(D1*(13*bd1*(-105*f*k2**4*(r - 1) + k1**4*s*(814*C - 572) - 11*k1**2*k2**2*(2*C*(50*r + 67*s - 53) - 103*r - 142*s + 109)) + fd*(1125*f*k2**4*(1 - 4*r) - k1**4*(4810*C - 3380)*(3*s - 1) - 13*k1**2*k2**2*(6*C*(191*r - 14*s - 59) - 813*r + 204*s + 203))) + Dd*f*(1125*f*k2**4*(1 - 4*r) - k1**4*(9620*C - 6760)*(2*s - 1) - 13*k1**2*k2**2*(2*C*(764*r - 56*s - 163) - 1084*r + 272*s + 135))))/(45045*d*k1**2*k3**4) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**3*(-4*D1*bd1*f**2*(k1**2*s*(5 - 10*C) + 3*k2**2*r) + 9*b1**2*(D1*fd*(k1**2*(4*C - 2)*(s - 1) - k2**2*r) + Dd*f*(k1**2*(8*C - 4)*(2*s - 1) + k2**2*(1 - 4*r))) + b1*f*(9*D1*bd1*(k1**2*s*(8*C - 4) + k2**2*(1 - 2*r)) + 4*D1*fd*(k1**2*(10*C - 5)*(2*s - 1) + 3*k2**2*(1 - 2*r)) + Dd*f*k1**2*(80*C - 40)*(2*s - 1) + 12*Dd*f*k2**2*(1 - 4*r)))/(315*d*k1**2*k2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**3*(11*b1**2*(D1*fd*(k1**4*(36*C - 18)*(s - 1) - 9*k1**2*k2**2*(4*C*(r + s - 1) - 3*r - 4*s + 4) + k2**4*r*(44*f + 9)) + Dd*f*(k1**4*(72*C - 36)*(2*s - 1) - 9*k1**2*k2**2*(4*C*(4*r + 4*s - 3) - 12*r - 16*s + 11) + k2**4*(22*f + 9)*(4*r - 1))) + b1*f*(11*D1*bd1*(k1**4*s*(72*C - 36) - 9*k1**2*k2**2*(C*(8*r + 8*s - 4) - 6*r - 8*s + 3) + k2**4*(22*f + 9)*(2*r - 1)) + 2*k2**2*(D1*fd*(11*k1**2*(2*C*(2*r - 2*s + 9) - 2*r - 34*s + 5) + 6*k2**2*(15*f*(3*r - 1) + 22*r - 11)) + Dd*f*(11*k1**2*(C*(8*r - 8*s + 2) - 4*r - 68*s + 35) + k2**2*(90*f + 66)*(4*r - 1)))) + f**2*(D1*(2*bd1*k2**2*(11*k1**2*(2*C*(r - s - 9) - r - 17*s + 13) + k2**2*r*(90*f + 66)) - 5*fd*(k1**4*(84*C - 42)*(3*s - 1) + k1**2*k2**2*(-16*C*(18*r + 33*s - 17) + 219*r + 786*s - 335))) - 5*Dd*f*k1**2*(k1**2*(168*C - 84)*(2*s - 1) + k2**2*(-64*C*(6*r + 11*s - 7) + 292*r + 1048*s - 597))))/(3465*d*k1**2*k2*k3**2) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*f*k2**4*st**4*(13*D1*bd1*f*(30*f*k2**2 + k1**2*(286*C - 231))*(r + s - 1) + 13*b1*(D1*fd*(30*f*k2**2*(3*r + 3*s - 2) + k1**2*(286*C - 231)*(2*r + 2*s - 1)) + Dd*f*(30*f*k2**2 + k1**2*(286*C - 231))*(4*r + 4*s - 3)) + f*(D1*fd*(75*f*k2**2*(4*r + 4*s - 3) + k1**2*(676*C - 546)*(3*r + 3*s - 2)) + Dd*f*(75*f*k2**2 + k1**2*(676*C - 546))*(4*r + 4*s - 3)))/(15015*d*k1*k3**6) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*f*k2**2*st**4*(11*b1*(2*s - 1)*(D1*fd + 2*Dd*f) + f*(11*D1*bd1*s + D1*fd*(6*s - 2) + 4*Dd*f*(2*s - 1)))/(231*d*k1*k3**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*f*k2**2*st**4*(11*b1*(D1*fd*(k1**2*(24*C - 19)*(2*s - 1) + k2**2*(-16*C*r + 26*r + 10*s - 5)) + Dd*f*(k1**2*(48*C - 38)*(2*s - 1) + k2**2*(-32*C*r + 8*C + 52*r + 20*s - 23))) + f*(11*D1*bd1*(k1**2*s*(24*C - 19) + k2**2*(-8*C*r + 8*C + 13*r + 5*s - 13)) + 2*D1*fd*(k1**2*(24*C - 19)*(3*s - 1) + k2**2*(-51*C*r + 17*C + 66*r + 15*s - 27)) + Dd*f*k1**2*(96*C - 76)*(2*s - 1) + 2*Dd*f*k2**2*(-68*C*r + 17*C + 88*r + 20*s - 32)))/(1155*d*k1*k3**4) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*k1**3*(13*D1*bd1*f*(r + s - 1)*(315*f**2*k2**2 - 110*f*(k1**2*(2*C - 1) - k2**2*(-10*K + 8*b1 + 4)) + k2**2*(396*b1*(2 - 5*K) + 1980*g2)) + 286*b1**2*k2**2*(D1*fd*(20*f*(2*r + 2*s - 1) + (18 - 45*K)*(r + s)) + Dd*f*(-45*K + 20*f + 18)*(4*r + 4*s - 3)) + 65*b1*(D1*(63*f**2*fd*k2**2*(3*r + 3*s - 2) - 22*f*fd*(k1**2*(2*C - 1) + k2**2*(10*K - 4))*(2*r + 2*s - 1) + 396*f*gd2*k2**2*(r + s - 1) + 396*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(63*f**2*k2**2 - 22*f*(k1**2*(2*C - 1) + k2**2*(10*K - 4)) + 396*g2*k2**2)) - 5*f*(D1*(252*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(546*C - 273)*(3*r + 3*s - 2) - 5720*f*gd2*k2**2*(r + s - 1) - 5720*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(252*f**2*k2**2 + f*k1**2*(546*C - 273) - 5720*g2*k2**2)))/(45045*d*k3**6) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*k1*k2**2*st**2*(13*D1*bd1*f*(r + s - 1)*(60*f**2*k2**2 - 11*f*(k1**2*(74*C - 47) - k2**2*(-9*K + 48*b1 + 6)) + k2**2*(594*b1*(2 - 3*K) + 1782*g2)) + 429*b1**2*k2**2*(D1*fd*(8*f*(2*r + 2*s - 1) + (18 - 27*K)*(r + s)) + Dd*f*(-27*K + 8*f + 18)*(4*r + 4*s - 3)) + 13*b1*(D1*(60*f**2*fd*k2**2*(3*r + 3*s - 2) - 11*f*fd*(k1**2*(74*C - 47) + k2**2*(9*K - 6))*(2*r + 2*s - 1) + 1782*f*gd2*k2**2*(r + s - 1) + 1782*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(60*f**2*k2**2 - 11*f*(k1**2*(74*C - 47) + k2**2*(9*K - 6)) + 1782*g2*k2**2)) + f*(D1*(3780*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(4810*C - 3055)*(3*r + 3*s - 2) + 2574*f*gd2*k2**2*(r + s - 1) + 2574*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(3780*f**2*k2**2 + f*k1**2*(4810*C - 3055) + 2574*g2*k2**2)))/(45045*d*k3**6) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*k1*(-5148*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + 143*b1**2*(D1*(-36*bd1*f*k2**2*(3*r + 3*s - 2) + fd*k1**2*(36*C - 18)*(r + s - 1) + fd*k2**2*(-54*K*(r + s + 1) + f*(188*r + 242*s - 101) + 36*r + 63*s + 36)) + 2*Dd*f*(k1**2*(18*C - 9)*(4*r + 4*s - 3) + k2**2*(-27*K*(4*r + 4*s - 3) + 2*f*(94*r + 121*s - 84) + 72*r + 126*s - 81))) + 13*b1*(11*D1*bd1*f*(k1**2*(36*C - 18)*(2*r + 2*s - 1) + k2**2*(-54*K*(2*r + 2*s - 3) + f*(188*r + 242*s - 235) + 72*r + 126*s - 135)) + 2*D1*(15*f**2*fd*k2**2*(130*r + 84*s - 53) - 11*f*(fd*k1**2*(C*(76*r + 220*s - 90) - 38*r - 138*s + 59) + fd*k2**2*(3*K*(54*r + 58*s - 27) - 110*r - 146*s + 55) + k2**2*(27*bd2 - 54*gd2)*(r + s - 1)) + 297*fd*k2**2*(-b2*(r + s) + 2*g2*(r + s + 1))) + 2*Dd*f*(10*f**2*k2**2*(260*r + 168*s - 149) - 11*f*(k1**2*(2*C*(76*r + 220*s - 129) - 76*r - 276*s + 157) + k2**2*(3*K*(108*r + 116*s - 85) - 220*r - 292*s + 201)) + k2**2*(-297*b2 + 594*g2)*(4*r + 4*s - 3))) + f*(26*D1*bd1*(5*f**2*k2**2*(130*r + 84*s - 139) - 11*f*(k1**2*(2*C*(19*r + 55*s - 29) - 19*r - 69*s + 29) + k2**2*(81*K*r + 87*K*(s - 1) - 55*r - 73*s + 73)) - 297*k2**2*(b2*(r + s - 1) - 2*g2*(r + s - 2))) + D1*(-1260*f**2*fd*k2**2*(10*r + 39*s - 22) - 13*f*(5*fd*k1**2*(4*C*(195*r + 456*s - 217) - 390*r - 1107*s + 499) + 132*k2**2*(5*bd2*(r + s - 1) + gd2*(-27*r - 29*s + 29))) - 1716*fd*k2**2*(5*b2*(2*r + 2*s - 1) + g2*(-54*r - 58*s + 27))) - 4*Dd*f*(315*f**2*k2**2*(10*r + 39*s - 22) + 65*f*k1**2*(C*(260*r + 608*s - 369) - 130*r - 369*s + 217) + 429*k2**2*(5*b2*(4*r + 4*s - 3) + g2*(-108*r - 116*s + 85)))))/(45045*d*k3**4) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*st**2*(D1*bd1*f**2*s + 9*b1**2*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) + b1*f*(18*D1*bd1*s + D1*fd*(2*s - 1) + 2*Dd*f*(2*s - 1)))/(105*d*k1) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*(2*D1*bd1*f**2*(r*(2*C - 1) + 14*s) + 9*b1**2*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) + 2*b1*f*(D1*(9*bd1*s + fd*(4*C*r - 2*C - 2*r + 28*s - 13)) + Dd*f*(C*(8*r - 2) - 4*r + 56*s - 27)))/(315*d*k1) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*st**2*(99*b1**2*(D1*fd*k1**2*(12*C - 9)*(s - 1) + D1*fd*k2**2*r*(4 - 4*C) + Dd*f*k1**2*(24*C - 18)*(2*s - 1) + 4*Dd*f*k2**2*(-4*C*r + C + 4*r - 1)) - 11*b1*f*(D1*(54*bd1*k1**2*s*(3 - 4*C) + 36*bd1*k2**2*(C - 1)*(2*r - 1) + fd*k1**2*(12*C - 6)*(2*s - 1) + fd*k2**2*(20*C*(2*r - 1) + 14*r + 114*s - 37)) + Dd*f*(k1**2*(24*C - 12)*(2*s - 1) + k2**2*(80*C*r - 20*C + 28*r + 228*s - 121))) + f**2*(-11*D1*bd1*(k1**2*s*(12*C - 6) + k2**2*(r*(20*C + 7) + 57*s - 27)) + 3*D1*fd*(k1**2*(40*C - 25)*(3*s - 1) + k2**2*(64*C*(3*r - 1) - 225*r - 51*s + 92)) + Dd*f*k1**2*(240*C - 150)*(2*s - 1) + 3*Dd*f*k2**2*(64*C*(4*r - 1) - 300*r - 68*s + 109)))/(3465*d*k1*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*(-11*b1**2*(D1*fd*(-9*k1**2*(4*C*(r + s - 1) - 2*r - 3*s + 3) + k2**2*(18*K*(r - 1) + f*(8*r - 108*s + 83) - 9*s + 18)) + 2*Dd*f*(-18*k1**2*(C*(4*r + 4*s - 3) - 2*r - 3*s + 2) + k2**2*(9*K*(4*r - 1) + 4*f*(2*r - 27*s + 13) - 18*s + 9))) + b1*(-11*D1*bd1*f*(-18*k1**2*(C*(4*r + 4*s - 2) - 2*r - 3*s + 1) + k2**2*(36*K*r + f*(8*r - 108*s + 21) - 18*s - 9)) + 2*D1*(15*f**2*fd*k2**2*(6*r + 66*s - 35) + 11*f*(fd*k1**2*(4*C - 2)*(s - 5) + fd*k2**2*(K*(2*r - 1) - 6*r + 28*s + 3) + 18*gd2*k2**2*r) + 198*fd*g2*k2**2*(r - 1)) + 2*Dd*f*(30*f**2*k2**2*(4*r + 44*s - 23) + 11*f*(k1**2*(4*C - 2)*(2*s - 1) + k2**2*(4*K*r - K - 12*r + 56*s - 25)) + 198*g2*k2**2*(4*r - 1))) + f*(2*D1*bd1*(15*f**2*k2**2*(2*r + 22*s - 11) + 11*f*(k1**2*(2*C - 1)*(s + 9) + k2**2*(r*(K - 3) + 14*s - 14)) + 198*g2*k2**2*r) - 5*D1*f*fd*k1**2*(4*C*(69*r + 198*s - 89) - 138*r - 591*s + 243) + 22*D1*f*k2**2*r*(bd2 - 2*gd2) + 22*D1*fd*k2**2*(b2 - 2*g2)*(2*r - 1) - 20*Dd*f**2*k1**2*(C*(92*r + 264*s - 155) - 46*r - 197*s + 110) + 22*Dd*f*k2**2*(b2 - 2*g2)*(4*r - 1)))/(3465*d*k1*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*st**2*(429*b1**2*k2**2*(D1*fd*(k1**2*(42*C - 33)*(r + s - 1) + k2**2*(-6*K*r + f*(8*r + 8*s - 6) + 15*r + 9*s)) + Dd*f*(k1**2*(42*C - 33)*(4*r + 4*s - 3) + k2**2*(-24*K*r + 6*K + 4*f*(4*r + 4*s - 3) + 60*r + 36*s - 33))) - 13*b1*(D1*(-3*f**2*k2**4*(22*bd1*(4*r + 4*s - 3) + fd*(-252*r - 225*s + 128)) - 11*f*(9*bd1*k1**2*k2**2*(14*C - 11)*(2*r + 2*s - 1) + 18*bd1*k2**4*(-2*K*r + K + 5*r + 3*s - 4) + fd*(k1**4*(36*C - 21)*(2*s - 1) + 2*k1**2*k2**2*(-188*C*r - 316*C*s + 151*C + 143*r + 253*s - 121) + k2**4*(-20*K*r + 10*K + 26*r + 6*s - 13)) + 36*gd2*k2**4*r) - 396*fd*g2*k2**4*r) + Dd*f*(18*f**2*k2**4*(56*r + 50*s - 39) - 11*f*(k1**4*(72*C - 42)*(2*s - 1) + k1**2*k2**2*(-4*C*(188*r + 316*s - 205) + 572*r + 1012*s - 649) + k2**4*(K*(10 - 40*r) + 52*r + 12*s - 19)) + 396*g2*k2**4*(1 - 4*r))) - f*(D1*(3*f**2*k2**4*(13*bd1*(84*r + 75*s - 106) + 10*fd*(192*r - 130*s + 17)) + 13*f*(-11*bd1*(k1**4*s*(36*C - 21) + k1**2*k2**2*(-188*C*r - 316*C*s + 202*C + 143*r + 253*s - 154) + k2**4*(-10*K*r + 13*r + 3*s - 3)) + fd*k1**4*(180*C - 105)*(3*s - 1) + 2*fd*k1**2*k2**2*(C*(573*r + 45*s - 206) - 393*r - 36*s + 143) - 220*gd2*k2**4*r) - 572*g2*k2**4*(9*bd1*(r - 1) + 5*fd*(2*r - 1))) + 2*Dd*f*(15*f**2*k2**4*(192*r - 130*s + 17) + 13*f*(k1**4*(180*C - 105)*(2*s - 1) + k1**2*k2**2*(C*(764*r + 60*s - 221) - 524*r - 48*s + 155)) + 1430*g2*k2**4*(1 - 4*r))))/(45045*d*k1*k3**4) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*f*k2**3*st**4*(26*D1*bd1*f*(k1**2*(121*C - 77) + k2**2*(-55*b1 + 15*f))*(r + s - 1) - 715*b1**2*k2**2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 26*b1*(D1*fd*(15*f*k2**2*(3*r + 3*s - 2) + k1**2*(121*C - 77)*(2*r + 2*s - 1)) + Dd*f*(15*f*k2**2 + k1**2*(121*C - 77))*(4*r + 4*s - 3)) + 4*f*(D1*fd*(25*f*k2**2*(4*r + 4*s - 3) + k1**2*(143*C - 91)*(3*r + 3*s - 2)) + Dd*f*(25*f*k2**2 + k1**2*(143*C - 91))*(4*r + 4*s - 3)))/(15015*d*k3**6) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*f*k2*st**4*(11*b1*(2*D1*fd*(k1**2*(10*C - 7)*(2*s - 1) + 3*k2**2*r) + Dd*f*(k1**2*(40*C - 28)*(2*s - 1) + 3*k2**2*(4*r - 1))) + f*(D1*(22*bd1*k1**2*s*(10*C - 7) + 33*bd1*k2**2*(r - 1) + fd*k1**2*(40*C - 28)*(3*s - 1) + 24*fd*k2**2*(3*r - 1)) + 8*Dd*f*(k1**2*(10*C - 7)*(2*s - 1) + 3*k2**2*(4*r - 1))))/(1155*d*k1**2*k3**2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*f*k2*st**4*(13*b1*(D1*fd*(105*f*k2**4*r - k1**4*(396*C - 242)*(2*s - 1) + 22*k1**2*k2**2*(12*C*(4*r + 2*s - 1) - 39*r - 20*s + 10)) + Dd*f*(35*f*k2**4*(4*r - 1) - k1**4*(792*C - 484)*(2*s - 1) + 11*k1**2*k2**2*(96*C*(2*r + s - 1) - 156*r - 80*s + 79))) + f*(D1*(455*bd1*f*k2**4*(r - 1) - 286*bd1*k1**4*s*(18*C - 11) + 143*bd1*k1**2*k2**2*(24*C*(2*r + s - 2) - 39*r - 20*s + 39) + 290*f*fd*k2**4*(4*r - 1) - fd*k1**4*(936*C - 572)*(3*s - 1) + 52*fd*k1**2*k2**2*(18*C*(7*r + 2*s - 3) - 99*r - 30*s + 43)) + 2*Dd*f*(145*f*k2**4*(4*r - 1) - k1**4*(936*C - 572)*(2*s - 1) + 26*k1**2*k2**2*(6*C*(28*r + 8*s - 11) - 132*r - 40*s + 53))))/(15015*d*k1**2*k3**4) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*k1**4*k2*(11*b1**2*(D1*fd*(10*f*(2*r + 2*s - 1) + (9 - 45*K)*(r + s)) + Dd*f*(-45*K + 10*f + 9)*(4*r + 4*s - 3)) + b1*(22*D1*bd1*f*(-45*K + 10*f + 9)*(r + s - 1) + 5*D1*(21*f**2*fd*(3*r + 3*s - 2) - 22*f*(fd*(5*K - 1)*(2*r + 2*s - 1) - 9*gd2*(r + s - 1)) + 198*fd*g2*(r + s)) + 5*Dd*f*(21*f**2 - 22*f*(5*K - 1) + 198*g2)*(4*r + 4*s - 3)) + 5*f*(D1*bd1*(21*f**2 - 22*f*(5*K - 1) + 198*g2)*(r + s - 1) + 220*D1*f*gd2*(r + s - 1) + 220*D1*fd*g2*(2*r + 2*s - 1) + 220*Dd*f*g2*(4*r + 4*s - 3)))/(3465*d*k3**6) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*k1**2*k2*st**2*(13*D1*bd1*f*(r + s - 1)*(30*f**2*k2**2 + f*k1**2*(242*C - 132) - 33*f*k2**2*(-3*K + 12*b1 + 1) - k2**2*(-1782*K*b1 + 594*b1 + 1782*g2)) - 1287*b1**2*k2**2*(D1*fd*(f*(4*r + 4*s - 2) + (3 - 9*K)*(r + s)) + Dd*f*(-9*K + 2*f + 3)*(4*r + 4*s - 3)) + 13*b1*(D1*(30*f**2*fd*k2**2*(3*r + 3*s - 2) + 11*f*(fd*(k1**2*(22*C - 12) + k2**2*(9*K - 3))*(2*r + 2*s - 1) - 162*gd2*k2**2*(r + s - 1)) - 1782*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(30*f**2*k2**2 + f*k1**2*(242*C - 132) + 33*f*k2**2*(3*K - 1) - 1782*g2*k2**2)) - 2*f*(D1*(630*f**2*fd*k2**2*(4*r + 4*s - 3) + 13*f*(fd*k1**2*(55*C - 30)*(3*r + 3*s - 2) + 99*gd2*k2**2*(r + s - 1)) + 1287*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(630*f**2*k2**2 + f*k1**2*(715*C - 390) + 1287*g2*k2**2)))/(45045*d*k3**6) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*k1**2*(198*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + 11*b1**2*k2**2*(18*D1*bd1*f*(3*r + 3*s - 2) + D1*fd*(54*K*(r + s + 1) - 2*f*(27*r + 54*s - 17) - 9*r - 36*s - 18) - 9*Dd*f*(-6*K*(4*r + 4*s - 3) + 3*f*(4*r + 8*s - 5) + 4*r + 16*s - 9)) - b1*(D1*(f**2*k2**2*(11*bd1*(54*r + 108*s - 101) + 10*fd*(165*r + 195*s - 98)) - 11*f*(2*fd*(k1**2*(18*C - 9)*(2*s - 1) + k2**2*(K*(166*r + 174*s - 83) - 46*r - 78*s + 23)) + 9*k2**2*(bd1*(6*K*(2*r + 2*s - 3) - 2*r - 8*s + 7) + (6*bd2 - 12*gd2)*(r + s - 1))) + 594*fd*k2**2*(-b2*(r + s) + 2*g2*(r + s + 1))) + 2*Dd*f*(25*f**2*k2**2*(44*r + 52*s - 37) - 11*f*(k1**2*(36*C - 18)*(2*s - 1) + k2**2*(K*(332*r + 348*s - 257) - 92*r - 156*s + 101)) + k2**2*(-297*b2 + 594*g2)*(4*r + 4*s - 3))) + 2*f*(D1*(-5*f**2*k2**2*(bd1*(55*r + 65*s - 87) + 42*fd*(1 - 2*s)) + 11*f*(bd1*(k1**2*s*(18*C - 9) + k2**2*(83*K*r + 87*K*(s - 1) - 23*r - 39*s + 39)) + fd*k1**2*(20*C - 10)*(3*s - 1) + 2*k2**2*(15*bd2*(r + s - 1) + gd2*(-83*r - 87*s + 87))) + 11*k2**2*(27*b2*bd1*(r + s - 1) + 30*b2*fd*(2*r + 2*s - 1) - 54*bd1*g2*(r + s - 2) - 2*fd*g2*(166*r + 174*s - 83))) + 2*Dd*f*(105*f**2*k2**2*(2*s - 1) + f*k1**2*(220*C - 110)*(2*s - 1) + 11*k2**2*(15*b2*(4*r + 4*s - 3) + g2*(-332*r - 348*s + 257)))))/(3465*d*k2*k3**4) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*(D1*(-99*b1*fd*k2**2*(2*K*b1*(r - s - 1) + b1 + 4*g2*(-r + s + 1)) + 10*bd1*f**3*k2**2*(13*r + 66*s - 44) + f**2*(-10*fd*(b1*k2**2*(-39*r - 198*s + 101) + k1**2*(44*C - 22)*(3*s - 1)) + 11*k2**2*(bd1*(-2*K*(7*r + 9*s - 9) + b1*(72*s - 25) + 6*r + 38*s - 38) + (-2*bd2 + 4*gd2)*(7*r + 9*s - 9))) + 11*f*k2**2*(b1**2*fd*(72*s - 47) + b1*(-9*bd1*(K*(4*r - 4*s + 2) - 1) - 2*fd*(K*(14*r + 18*s - 7) - 6*r - 38*s + 3) + 36*gd2*(r - s + 1)) - 2*b2*fd*(14*r + 18*s - 7) + 4*g2*(9*bd1*(r - s) + fd*(14*r + 18*s - 7)))) - 2*Dd*f*(99*b1*k2**2*(K*b1 - 2*g2)*(4*r - 4*s + 1) + 5*f**2*(b1*k2**2*(-52*r - 264*s + 145) + k1**2*(88*C - 44)*(2*s - 1)) - 11*f*k2**2*(36*b1**2*(2*s - 1) + b1*(K*(-28*r - 36*s + 25) + 12*r + 76*s - 41) - (b2 - 2*g2)*(28*r + 36*s - 25))))/(3465*d*k2*k3**2) - 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*st**2*(7722*b1**3*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) - 429*b1**2*k2**2*(D1*(-18*bd1*f*k2**2*(3*r + 3*s - 2) + fd*k1**2*(60*C - 36)*(r + s - 1) + fd*k2**2*(f*(70*r + 88*s - 46) + r*(39 - 48*K) - s*(24*K - 24))) + Dd*f*(k1**2*(60*C - 36)*(4*r + 4*s - 3) + k2**2*(-96*K*(2*r + s - 1) + f*(140*r + 176*s - 123) + 156*r + 96*s - 87))) + 13*b1*(D1*(-3*f**2*k2**4*(11*bd1*(70*r + 88*s - 77) + fd*(-150*r - 414*s + 211)) - 11*f*(9*bd1*k2**2*(k1**2*(20*C - 12)*(2*r + 2*s - 1) + k2**2*(-8*K*(4*r + 2*s - 3) + 26*r + 16*s - 21)) + fd*k1**4*(12*C - 6)*(2*s - 1) + 2*fd*k1**2*k2**2*(-4*C*(58*r + 119*s - 57) + 137*r + 300*s - 144) + fd*k2**4*(-16*K*(6*r + s - 3) + 58*r + 16*s - 29) + 18*k2**4*(-3*bd2*(r + s - 1) + 8*gd2*(2*r + s - 1))) + 198*fd*k2**4*(3*b2*(r + s) - 8*g2*(2*r + s))) + Dd*f*(6*f**2*k2**4*(100*r + 276*s - 163) - 11*f*(k1**4*(24*C - 12)*(2*s - 1) + k1**2*k2**2*(-16*C*(58*r + 119*s - 74) + 548*r + 1200*s - 737) + k2**4*(-32*K*(6*r + s - 2) + 116*r + 32*s - 45)) + 198*k2**4*(3*b2*(4*r + 4*s - 3) - 32*g2*(2*r + s - 1)))) + f*(D1*(3*f**2*k2**4*(650*bd1*r + 299*bd1*(6*s - 5) + 15*fd*(76*r - 208*s + 85)) + 13*f*(-11*bd1*(k1**4*s*(12*C - 6) + k1**2*k2**2*(-4*C*(58*r + 119*s - 63) + 137*r + 300*s - 149) + k2**4*(-8*K*(6*r + s - 1) + 29*r + 8*s - 8)) + fd*k1**4*(60*C - 30)*(3*s - 1) + fd*k1**2*k2**2*(4*C*(279*r + 156*s - 145) - 645*r - 360*s + 335) - 22*k2**4*(-3*bd2*(r + s - 1) + 8*gd2*(6*r + s - 1))) + 286*k2**4*(3*b2*(9*bd1*(r + s - 1) + fd*(2*r + 2*s - 1)) - 8*g2*(9*bd1*(2*r + s - 2) + 2*fd*(6*r + s - 3)))) + Dd*f*(45*f**2*k2**4*(76*r - 208*s + 85) + 13*f*(k1**4*(120*C - 60)*(2*s - 1) + k1**2*k2**2*(1488*C*r + 832*C*s - 788*C - 860*r - 480*s + 455)) + 286*k2**4*(3*b2*(4*r + 4*s - 3) - 32*g2*(6*r + s - 2)))))/(45045*d*k2*k3**4) - 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*st**2*(D1*bd1*f**2*(k1**2*s*(12*C - 6) + 17*k2**2*r) + 9*b1**2*(D1*fd*(k1**2*(12*C - 6)*(s - 1) + k2**2*r) + Dd*f*(k1**2*(24*C - 12)*(2*s - 1) + k2**2*(4*r - 1))) + b1*f*(D1*(108*bd1*k1**2*s*(2*C - 1) + 9*bd1*k2**2*(2*r - 1) + fd*k1**2*(12*C - 6)*(2*s - 1) + 17*fd*k2**2*(2*r - 1)) + Dd*f*(k1**2*(24*C - 12)*(2*s - 1) + 17*k2**2*(4*r - 1))))/(315*d*k1**2*k2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*(18*D1*bd1*f**2*k1**2*s*(2*C - 1) + 18*b1**3*k2**2*(D1*fd*r + Dd*f*(4*r - 1)) + b1**2*k2**2*(18*D1*bd1*f*(3*r - 1) + D1*fd*(26*f*r - 13*f + 27*r - 27) + Dd*f*(13*f + 27)*(4*r - 1)) + 2*b1*f*(D1*bd1*k2**2*r*(13*f + 27) + D1*fd*k1**2*(18*C - 9)*(2*s - 1) + Dd*f*k1**2*(36*C - 18)*(2*s - 1)))/(315*d*k1**2*k2) - 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*st**2*(33*b1**2*(D1*fd*(-k1**4*(36*C - 18)*(s - 1) + 3*k1**2*k2**2*(4*C*(3*r + s - 1) - 9*r - 4*s + 4) + k2**4*r*(28*f + 3)) + Dd*f*(-k1**4*(72*C - 36)*(2*s - 1) + 3*k1**2*k2**2*(4*C*(12*r + 4*s - 5) - 36*r - 16*s + 17) + k2**4*(14*f + 3)*(4*r - 1))) + b1*f*(-33*D1*bd1*(k1**4*s*(72*C - 36) - 3*k1**2*k2**2*(4*C*(6*r + 2*s - 3) - 18*r - 8*s + 9) - k2**4*(14*f + 3)*(2*r - 1)) + k2**2*(D1*fd*(-11*k1**2*(8*C*(8*r + 53*s - 17) - 32*r - 328*s + 107) + k2**2*(318*f*(3*r - 1) + 374*r - 187)) + Dd*f*(-88*k1**2*(C*(16*r + 106*s - 57) - 8*r - 82*s + 43) + k2**2*(318*f + 187)*(4*r - 1)))) + f**2*(D1*(-11*bd1*k1**2*k2**2*(4*C*(8*r + 53*s - 27) - 16*r - 164*s + 73) + bd1*k2**4*r*(318*f + 187) - fd*k1**4*(60*C - 30)*(3*s - 1) + fd*k1**2*k2**2*(-12*C*(129*r + 66*s - 65) + 921*r + 504*s - 475)) + Dd*f*k1**2*(k1**2*(60 - 120*C)*(2*s - 1) + k2**2*(-12*C*(172*r + 88*s - 87) + 1228*r + 672*s - 643))))/(3465*d*k1**2*k2*k3**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*f**2*k2**6*st**6*(39*D1*bd1*f*(r + s - 1) + 39*b1*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)) + 7*f*(D1*fd + Dd*f)*(4*r + 4*s - 3))/(3003*d*k1*k3**6) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*f*k1*k2**2*st**4*(13*D1*bd1*f*(k1**2*(66*C - 33) + k2**2*(-88*b1 + 4*f))*(r + s - 1) - 572*b1**2*k2**2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 13*b1*(D1*fd*(4*f*k2**2*(3*r + 3*s - 2) + k1**2*(66*C - 33)*(2*r + 2*s - 1)) + Dd*f*(4*f*k2**2 + k1**2*(66*C - 33))*(4*r + 4*s - 3)) + 6*f*(D1*fd*(5*f*k2**2*(4*r + 4*s - 3) + k1**2*(26*C - 13)*(3*r + 3*s - 2)) + Dd*f*(5*f*k2**2 + k1**2*(26*C - 13))*(4*r + 4*s - 3)))/(15015*d*k3**6) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*f*st**4*(11*b1*(D1*fd*(k1**2*(8*C - 4)*(2*s - 1) + k2**2*(4*r + 2*s - 1)) + 4*Dd*f*(k1**2*(4*C - 2)*(2*s - 1) + k2**2*(2*r + s - 1))) + f*(D1*(11*bd1*(k1**2*s*(8*C - 4) + k2**2*(2*r + s - 2)) + fd*k1**2*(16*C - 8)*(3*s - 1) + 6*fd*k2**2*(C*(6 - 18*r) + 11*r + s - 4)) + 2*Dd*f*(k1**2*(16*C - 8)*(2*s - 1) + k2**2*(-72*C*r + 18*C + 44*r + 4*s - 13))))/(1155*d*k1*k3**2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*f*st**4*(-286*b1**2*k2**4*(D1*fd + 2*Dd*f)*(4*r + 4*s - 3) + 13*b1*(D1*(-22*bd1*f*k2**4*(4*r + 4*s - 3) + fd*(3*f*k2**4*(28*r + 47*s - 24) + k1**4*(44 - 88*C)*(2*s - 1) + 11*k1**2*k2**2*(16*C*(3*r + 2*s - 1) - 28*r - 18*s + 9))) + 2*Dd*f*(f*k2**4*(56*r + 94*s - 61) + k1**4*(44 - 88*C)*(2*s - 1) + 22*k1**2*k2**2*(2*C*(12*r + 8*s - 7) - 14*r - 9*s + 8))) + f*(D1*(-13*bd1*(f*k2**4*(-28*r - 47*s + 50) + k1**4*s*(88*C - 44) - 11*k1**2*k2**2*(8*C*(3*r + 2*s - 3) - 14*r - 9*s + 14)) + 2*fd*(4*f*k2**4*(126*r + 65*s - 64) + k1**4*(52 - 104*C)*(3*s - 1) + 13*k1**2*k2**2*(2*C*(63*r + 24*s - 29) - 69*r - 27*s + 32))) + 2*Dd*f*(4*f*k2**4*(126*r + 65*s - 64) + k1**4*(104 - 208*C)*(2*s - 1) + 13*k1**2*k2**2*(2*C*(84*r + 32*s - 37) - 92*r - 36*s + 41))))/(15015*d*k1*k3**4) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*k1**5*(2*D1*bd1*f*(r + s - 1)*(9*K*b1 + 5*K*f - 9*g2) + 9*K*b1**2*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) + 2*b1*(5*D1*K*f*fd*(2*r + 2*s - 1) - 9*D1*f*gd2*(r + s - 1) - 9*D1*fd*g2*(r + s) + Dd*f*(5*K*f - 9*g2)*(4*r + 4*s - 3)) - 20*f*(D1*f*gd2*(r + s - 1) + D1*fd*g2*(2*r + 2*s - 1) + Dd*f*g2*(4*r + 4*s - 3)))/(315*d*k3**6) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*k1**3*(9*b1**2*(D1*fd*(-2*K*(r + s + 1) + f*(2*s - 1) + s) + 2*Dd*f*(K*(-4*r - 4*s + 3) + f*(2*s - 1) + 2*s - 1)) + b1*(-112*D1*K*f*fd*r - 116*D1*K*f*fd*s + 56*D1*K*f*fd + 9*D1*bd1*f*(K*(-4*r - 4*s + 6) + f*(2*s - 1) + 2*s - 1) - 18*D1*bd2*f*(r + s - 1) + 30*D1*f**2*fd*s - 10*D1*f**2*fd + 20*D1*f*fd*s + 36*D1*f*gd2*r + 36*D1*f*gd2*s - 36*D1*f*gd2 + 36*D1*fd*g2*r + 36*D1*fd*g2*s + 36*D1*fd*g2 - 224*Dd*K*f**2*r - 232*Dd*K*f**2*s + 172*Dd*K*f**2 + 40*Dd*f**3*s - 20*Dd*f**3 + 40*Dd*f**2*s - 20*Dd*f**2 + 144*Dd*f*g2*r + 144*Dd*f*g2*s - 108*Dd*f*g2 - 18*b2*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3))) - 2*f*(D1*bd1*(-5*f**2*(s - 1) + f*(28*K*r + 29*K*(s - 1) - 5*s + 5) - 18*g2*(r + s - 2)) + 10*D1*bd2*f*(r + s - 1) - 2*D1*f*gd2*(28*r + 29*s - 29) - 4*D1*fd*g2*(28*r + 29*s - 14) - 4*Dd*f*g2*(56*r + 58*s - 43) + b2*(9*D1*bd1*(r + s - 1) + 10*D1*fd*(2*r + 2*s - 1) + 10*Dd*f*(4*r + 4*s - 3))))/(315*d*k3**4) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*k1**3*st**2*(13*D1*bd1*f*(r + s - 1)*(15*f**2*k2**2 + 11*f*(k1**2*(2*C - 1) + k2**2*(3*K - 8*b1)) - k2**2*(-594*K*b1 + 594*g2)) - 143*b1**2*k2**2*(D1*fd*(-27*K*(r + s) + f*(8*r + 8*s - 4)) + Dd*f*(-27*K + 4*f)*(4*r + 4*s - 3)) + 13*b1*(D1*(15*f**2*fd*k2**2*(3*r + 3*s - 2) + 11*f*(fd*(3*K*k2**2 + k1**2*(2*C - 1))*(2*r + 2*s - 1) - 54*gd2*k2**2*(r + s - 1)) - 594*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(15*f**2*k2**2 + 11*f*(3*K*k2**2 + k1**2*(2*C - 1)) - 594*g2*k2**2)) - f*(D1*(105*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(130*C - 65)*(3*r + 3*s - 2) + 858*f*gd2*k2**2*(r + s - 1) + 858*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(105*f**2*k2**2 + f*k1**2*(130*C - 65) + 858*g2*k2**2)))/(45045*d*k3**6) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*k1*(9*D1*K*b1**2*fd*s - 16*D1*K*b1*f*fd*r - 18*D1*K*b1*f*fd*s + 8*D1*K*b1*f*fd + 15*D1*b1*f**2*fd*s - 5*D1*b1*f**2*fd + 10*D1*b1*f*fd*s - 18*D1*b1*f*gd2*s + 18*D1*b1*f*gd2 - 18*D1*b1*fd*g2*s - 16*D1*b2*f*fd*r - 18*D1*b2*f*fd*s + 8*D1*b2*f*fd + D1*bd1*f*(K*f*(-8*r - 9*s + 9) - 9*b1*(-2*K*s + K) + 5*f**2*(s - 1) + 5*f*(s - 1) - 18*g2*s) + D1*bd2*f**2*(-8*r - 9*s + 9) + 16*D1*f**2*gd2*r + 18*D1*f**2*gd2*s - 18*D1*f**2*gd2 + 32*D1*f*fd*g2*r + 36*D1*f*fd*g2*s - 16*D1*f*fd*g2 + 36*Dd*K*b1**2*f*s - 18*Dd*K*b1**2*f - 32*Dd*K*b1*f**2*r - 36*Dd*K*b1*f**2*s + 26*Dd*K*b1*f**2 + 20*Dd*b1*f**3*s - 10*Dd*b1*f**3 + 20*Dd*b1*f**2*s - 10*Dd*b1*f**2 - 72*Dd*b1*f*g2*s + 36*Dd*b1*f*g2 - 32*Dd*b2*f**2*r - 36*Dd*b2*f**2*s + 26*Dd*b2*f**2 + 64*Dd*f**2*g2*r + 72*Dd*f**2*g2*s - 52*Dd*f**2*g2)/(315*d*k3**2) - 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*k1*st**2*(5148*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) - 143*b1**2*(D1*(-36*bd1*f*k2**2*(3*r + 3*s - 2) + fd*k1**2*(36*C - 18)*(r + s - 1) + fd*k2**2*(-72*K*s + f*(116*r + 170*s - 83) + 9*r*(2 - 12*K) + 9*s)) + 2*Dd*f*(k1**2*(18*C - 9)*(4*r + 4*s - 3) + 2*k2**2*(9*K*(-12*r - 8*s + 7) + f*(58*r + 85*s - 57) + 18*r + 9*s - 9))) - 13*b1*(11*D1*bd1*f*(k1**2*(36*C - 18)*(2*r + 2*s - 1) + k2**2*(-36*K*(6*r + 4*s - 5) + f*(116*r + 170*s - 145) + 36*r + 18*s - 27)) + D1*(3*f**2*fd*k2**2*(68*r - 40*s + 9) - 11*f*(fd*(k1**2*(4*C*(20*r + 56*s - 27) - 40*r - 114*s + 55) + 2*k2**2*(2*K*(14*r + 4*s - 7) - 2*r - s + 1)) + 18*k2**2*(3*bd2*(r + s - 1) - 4*gd2*(3*r + 2*s - 2))) - 198*fd*k2**2*(3*b2*(r + s) - 4*g2*(3*r + 2*s))) + 2*Dd*f*(2*f**2*k2**2*(68*r - 40*s + 3) - 11*f*(k1**2*(4*C*(20*r + 56*s - 33) - 40*r - 114*s + 67) + 2*k2**2*(K*(28*r + 8*s - 11) - 2*r - s + 1)) - 99*k2**2*(3*b2*(4*r + 4*s - 3) - 4*g2*(12*r + 8*s - 7)))) + f*(-13*D1*bd1*(f**2*k2**2*(68*r - 40*s - 15) - 11*f*(k1**2*(4*C*(10*r + 28*s - 11) - 20*r - 57*s + 22) + k2**2*(4*K*(7*r + 2*s - 2) - 2*r - s + 1)) - 198*k2**2*(3*b2*(r + s - 1) - 4*g2*(3*r + 2*s - 3))) + D1*(60*f**2*fd*k2**2*(2*r - 39*s + 19) + 13*f*(fd*k1**2*(4*C*(51*r + 69*s - 40) - 102*r - 123*s + 75) + 22*k2**2*(3*bd2*(r + s - 1) - 4*gd2*(7*r + 2*s - 2))) + 286*fd*k2**2*(b2*(6*r + 6*s - 3) - 4*g2*(14*r + 4*s - 7))) + 2*Dd*f*(30*f**2*k2**2*(2*r - 39*s + 19) + 26*f*k1**2*(C*(68*r + 92*s - 63) - 34*r - 41*s + 29) + 143*k2**2*(3*b2*(4*r + 4*s - 3) - 4*g2*(28*r + 8*s - 11)))))/(45045*d*k3**4) - 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*st**2*(D1*bd1*f**2*(r*(16 - 32*C) + s) + 9*b1**2*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) + b1*f*(D1*(18*bd1*s + fd*(-64*C*r + 32*C + 32*r + 2*s - 17)) + 2*Dd*f*(C*(16 - 64*r) + 32*r + 2*s - 9)))/(315*d*k1) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*(2*D1*bd1*f*r*(b2 - 2*g2) + b1**2*(D1*fd*(2*K*(r - 1) + f*(2*s - 1) + s) + 2*Dd*f*(K*(4*r - 1) + f*(2*s - 1) + 2*s - 1)) + b1*(2*D1*b2*fd*(r - 1) + D1*bd1*f*(4*K*r + f*(2*s - 1) + 2*s - 1) + 2*D1*f*r*(bd2 - 2*gd2) - 4*D1*fd*g2*(r - 1) + 2*Dd*b2*f*(4*r - 1) + 4*Dd*f*g2*(1 - 4*r)))/(35*d*k1) - 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*st**2*(11*b1**2*(D1*fd*(9*k1**2*(4*C*(r + s - 1) - 2*r - 3*s + 3) + k2**2*(f*(64*r + 108*s - 65) + 18*r + 9*s)) + 4*Dd*f*(9*k1**2*(C*(4*r + 4*s - 3) - 2*r - 3*s + 2) + k2**2*(f*(32*r + 54*s - 35) + 18*r + 9*s - 9))) + b1*f*(11*D1*bd1*(18*k1**2*(C*(4*r + 4*s - 2) - 2*r - 3*s + 1) + k2**2*(f*(64*r + 108*s - 75) + 36*r + 18*s - 27)) + D1*fd*(k1**2*(22 - 44*C)*(52*s - 17) + k2**2*(-352*K*r + 176*K + 3*f*(192*r + 66*s - 97) + 44*r + 22*s - 22)) + 4*Dd*f*(k1**2*(286 - 572*C)*(2*s - 1) + k2**2*(-176*K*r + 44*K + 3*f*(64*r + 22*s - 27) + 22*r + 11*s - 11))) + f*(D1*bd1*f*(k1**2*(22 - 44*C)*(26*s - 9) + k2**2*(-176*K*r + 3*f*(64*r + 22*s - 11) + 22*r + 11*s - 11)) + D1*(f*fd*k1**2*(-12*C*(27*r + 33*s - 20) + 162*r + 183*s - 115) - 176*f*k2**2*r*(bd2 - 2*gd2) - 176*fd*k2**2*(b2 - 2*g2)*(2*r - 1)) - 4*Dd*f*(f*k1**2*(3*C*(36*r + 44*s - 31) - 54*r - 61*s + 44) + k2**2*(44*b2 - 88*g2)*(4*r - 1))))/(3465*d*k1*k3**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**7*f*k2**5*(C - 1)*(22*D1*bd1*f*(r + s - 1) + 22*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 21*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(693*d*k3**5) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**6*f*k2**4*(22*D1*bd1*f*(r + s - 1) + 22*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 21*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(693*d*k1*k3**3) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**6*f*k2**4*(13*D1*bd1*f*(21*f*k2**2 + k1**2*(220*C - 198))*(r + s - 1) + 13*b1*(D1*fd*(21*f*k2**2*(3*r + 3*s - 2) + k1**2*(220*C - 198)*(2*r + 2*s - 1)) + Dd*f*(21*f*k2**2 + k1**2*(220*C - 198))*(4*r + 4*s - 3)) + 21*f*(D1*fd*(12*f*k2**2*(4*r + 4*s - 3) + k1**2*(130*C - 117)*(3*r + 3*s - 2)) + Dd*f*(12*f*k2**2 + k1**2*(130*C - 117))*(4*r + 4*s - 3)))/(9009*d*k1*k3**5) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**5*f*k2**5*st**2*(C - 1)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) - 5*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(693*d*k3**5) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**5*k2**3*(99*b1**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + 11*b1*f*(9*D1*bd1*(C - 1)*(2*r + 2*s - 1) - 10*D1*fd*(C - 2*r - 2*s) - 10*Dd*f*(-4*r - 4*s + 3)) + 5*f**2*(22*D1*bd1*(C + r + s - 2) - (21*C - 42)*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))))/(3465*d*k3**3) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**5*k2**3*(13*D1*bd1*f*(r + s - 1)*(315*f**2*k2**2 + 110*f*(k1**2*(20*C - 16) + k2**2*(K - 2*b1 - 1)) - k2**2*(-198*K*b1 + 198*b1 + 198*g2)) - 143*b1**2*k2**2*(D1*fd*(10*f*(2*r + 2*s - 1) + (9 - 9*K)*(r + s)) + Dd*f*(-9*K + 10*f + 9)*(4*r + 4*s - 3)) + 13*b1*(D1*(315*f**2*fd*k2**2*(3*r + 3*s - 2) + 22*f*(5*fd*(k1**2*(20*C - 16) + k2**2*(K - 1))*(2*r + 2*s - 1) - 9*gd2*k2**2*(r + s - 1)) - 198*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(315*f**2*k2**2 + 110*f*(k1**2*(20*C - 16) + k2**2*(K - 1)) - 198*g2*k2**2)) + 20*f*(D1*(252*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(1365*C - 1092)*(3*r + 3*s - 2) - 143*f*gd2*k2**2*(r + s - 1) - 143*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(252*f**2*k2**2 + f*k1**2*(1365*C - 1092) - 143*g2*k2**2)))/(45045*d*k3**5) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**4*f*k2**4*st**2*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) - 5*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(693*d*k1*k3**3) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**4*f*k2**4*st**2*(13*D1*bd1*f*(75*f*k2**2 + k1**2*(726 - 836*C))*(r + s - 1) + 13*b1*(D1*fd*(75*f*k2**2*(3*r + 3*s - 2) + k1**2*(726 - 836*C)*(2*r + 2*s - 1)) + Dd*f*(75*f*k2**2 + k1**2*(726 - 836*C))*(4*r + 4*s - 3)) + 5*f*(D1*fd*(315*f*k2**2*(4*r + 4*s - 3) + k1**2*(988*C - 858)*(3*r + 3*s - 2)) + Dd*f*(315*f*k2**2 + k1**2*(988*C - 858))*(4*r + 4*s - 3)))/(45045*d*k1*k3**5) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**4*k1*k2**2*(26*D1*bd1*f*(r + s - 1)*(105*f**2*k2**2 + 55*f*(k1**2*(20*C - 14) + k2**2*(5*K - 8*b1 - 4)) - k2**2*(99*b1*(4 - 5*K) + 495*g2)) - 143*b1**2*k2**2*(D1*fd*(40*f*(2*r + 2*s - 1) + (36 - 45*K)*(r + s)) + Dd*f*(-45*K + 40*f + 36)*(4*r + 4*s - 3)) + 130*b1*(D1*(21*f**2*fd*k2**2*(3*r + 3*s - 2) + 11*f*(fd*(k1**2*(20*C - 14) + k2**2*(5*K - 4))*(2*r + 2*s - 1) - 9*gd2*k2**2*(r + s - 1)) - 99*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(21*f**2*k2**2 + 11*f*(k1**2*(20*C - 14) + k2**2*(5*K - 4)) - 99*g2*k2**2)) + 10*f*(D1*(756*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(2730*C - 1911)*(3*r + 3*s - 2) - 1430*f*gd2*k2**2*(r + s - 1) - 1430*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(756*f**2*k2**2 + f*k1**2*(2730*C - 1911) - 1430*g2*k2**2)))/(45045*d*k3**5) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**4*k2**2*(10*D1*bd1*f**2*(r + s) + 9*b1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*f*(9*D1*bd1*(2*r + 2*s - 1) + 20*D1*fd*(r + s - 1) + 10*Dd*f*(4*r + 4*s - 3)))/(315*d*k1*k3) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**4*k2**2*(11*b1**2*(D1*fd*(k1**2*(54*C - 45)*(r + s - 1) + k2**2*(10*f*(4*r + 4*s - 3) + 9*r + 9*s)) + Dd*f*(k1**2*(54*C - 45) + k2**2*(20*f + 9))*(4*r + 4*s - 3)) + b1*f*(99*D1*bd1*k1**2*(6*C - 5)*(2*r + 2*s - 1) + 22*D1*bd1*k2**2*(5*f*(4*r + 4*s - 3) + 9*r + 9*s - 9) + 5*D1*fd*(-44*k1**2*(3*C - r - s - 2) + k2**2*(21*f*(6*r + 6*s - 5) + 44*r + 44*s - 22)) + 10*Dd*f*(11*k1**2 + k2**2*(21*f + 11))*(4*r + 4*s - 3)) + 5*f**2*(D1*bd1*(22*k1**2*(6*C + r + s - 6) + k2**2*(21*f*(2*r + 2*s - 1) + 22*r + 22*s - 22)) + k1**2*(126 - 126*C)*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))))/(3465*d*k1*k3**3) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**3*f*k2**5*st**4*(C - 1)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 2*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(231*d*k3**5) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**3*k1**2*k2*(13*D1*bd1*f*(r + s - 1)*(105*f**2*k2**2 - 110*f*(k1**2*(5*C - 3) + k2**2*(5*K - 6*b1 - 3)) + k2**2*(198*b1*(3 - 5*K) + 990*g2)) + 429*b1**2*k2**2*(D1*fd*(10*f*(2*r + 2*s - 1) + (9 - 15*K)*(r + s)) + Dd*f*(-15*K + 10*f + 9)*(4*r + 4*s - 3)) + 65*b1*(D1*(21*f**2*fd*k2**2*(3*r + 3*s - 2) - 22*f*(fd*(k1**2*(5*C - 3) + k2**2*(5*K - 3))*(2*r + 2*s - 1) - 9*gd2*k2**2*(r + s - 1)) + 198*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(21*f**2*k2**2 - 22*f*(k1**2*(5*C - 3) + k2**2*(5*K - 3)) + 198*g2*k2**2)) - 5*f*(D1*(504*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(1365*C - 819)*(3*r + 3*s - 2) - 2860*f*gd2*k2**2*(r + s - 1) - 2860*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(504*f**2*k2**2 + f*k1**2*(1365*C - 819) - 2860*g2*k2**2)))/(45045*d*k3**5) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**3*k2**3*st**2*(297*b1**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + 11*b1*f*(27*D1*bd1*(C - 1)*(2*r + 2*s - 1) + 2*D1*fd*(C*(-7*r - 7*s + 2) + 11*r + 11*s - 4) - Dd*f*(7*C - 11)*(4*r + 4*s - 3)) + f**2*(-11*D1*bd1*(C*(7*r + 7*s - 10) - 11*r - 11*s + 14) + (50*C - 70)*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))))/(3465*d*k3**3) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**3*k2**3*st**2*(13*D1*bd1*f*(r + s - 1)*(150*f**2*k2**2 - 11*f*(k1**2*(110*C - 82) + k2**2*(3*K - 20*b1 - 3)) + k2**2*(-594*K*b1 + 594*b1 + 594*g2)) + 143*b1**2*k2**2*(D1*fd*(10*f*(2*r + 2*s - 1) + (27 - 27*K)*(r + s)) + Dd*f*(-27*K + 10*f + 27)*(4*r + 4*s - 3)) + 13*b1*(D1*(150*f**2*fd*k2**2*(3*r + 3*s - 2) - 11*f*fd*(k1**2*(110*C - 82) + k2**2*(3*K - 3))*(2*r + 2*s - 1) + 594*f*gd2*k2**2*(r + s - 1) + 594*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(150*f**2*k2**2 - 11*f*(k1**2*(110*C - 82) + k2**2*(3*K - 3)) + 594*g2*k2**2)) + 2*f*(D1*(2100*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(3575*C - 2665)*(3*r + 3*s - 2) + 429*f*gd2*k2**2*(r + s - 1) + 429*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(2100*f**2*k2**2 + f*k1**2*(3575*C - 2665) + 429*g2*k2**2)))/(45045*d*k3**5) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**3*k2*(C - 1)*(10*D1*bd1*f**2*(r + s) + 9*b1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*f*(9*D1*bd1*(2*r + 2*s - 1) + 20*D1*fd*(r + s - 1) + 10*Dd*f*(4*r + 4*s - 3)))/(315*d*k3) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**3*k2*(99*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) - 11*b1**2*(D1*(-9*bd1*f*k2**2*(3*r + 3*s - 2) + fd*k1**2*(54*C - 36)*(r + s - 1) + fd*k2**2*(-9*K + 10*f*(8*r + 8*s - 5) + 18*r + 18*s + 9)) + 2*Dd*f*(k1**2*(27*C - 18) + k2**2*(20*f + 9))*(4*r + 4*s - 3)) - b1*(11*D1*bd1*f*(k1**2*(54*C - 36)*(2*r + 2*s - 1) + k2**2*(9*K + 10*f*(8*r + 8*s - 7) + 36*r + 36*s - 45)) + D1*(315*f**2*fd*k2**2*(5*r + 5*s - 4) - 11*f*(9*bd2*k2**2*(r + s - 1) + 10*fd*(k1**2*(6*C - 4) + k2**2*(K - 3)*(2*r + 2*s - 1))) - 99*fd*k2**2*(b2*(r + s) - 2*g2)) + Dd*f*k2**2*(-99*b2 + 5*f*(-22*K + 105*f + 66))*(4*r + 4*s - 3)) + f*(D1*bd1*(-105*f**2*k2**2*(5*r + 5*s - 3) - 110*f*(k1**2*(6*C - 4) - k2**2*(K - 3)*(r + s - 1)) + 99*k2**2*(b2*(r + s - 1) + 2*g2)) + 10*D1*(f*fd*k1**2*(63*C - 42)*(3*r + 3*s - 2) + 11*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) + 11*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + 10*Dd*f*(f*k1**2*(63*C - 42) + k2**2*(11*b2 - 22*g2))*(4*r + 4*s - 3)))/(3465*d*k3**3) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**2*f*k2**4*st**4*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 2*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(231*d*k1*k3**3) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**2*f*k2**4*st**4*(13*D1*bd1*f*(30*f*k2**2 + k1**2*(286*C - 231))*(r + s - 1) + 13*b1*(D1*fd*(30*f*k2**2*(3*r + 3*s - 2) + k1**2*(286*C - 231)*(2*r + 2*s - 1)) + Dd*f*(30*f*k2**2 + k1**2*(286*C - 231))*(4*r + 4*s - 3)) + f*(D1*fd*(75*f*k2**2*(4*r + 4*s - 3) + k1**2*(676*C - 546)*(3*r + 3*s - 2)) + Dd*f*(75*f*k2**2 + k1**2*(676*C - 546))*(4*r + 4*s - 3)))/(15015*d*k1*k3**5) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**2*k1**3*(13*D1*bd1*f*(r + s - 1)*(315*f**2*k2**2 - 110*f*(k1**2*(2*C - 1) - k2**2*(-10*K + 8*b1 + 4)) + k2**2*(396*b1*(2 - 5*K) + 1980*g2)) + 286*b1**2*k2**2*(D1*fd*(20*f*(2*r + 2*s - 1) + (18 - 45*K)*(r + s)) + Dd*f*(-45*K + 20*f + 18)*(4*r + 4*s - 3)) + 65*b1*(D1*(63*f**2*fd*k2**2*(3*r + 3*s - 2) - 22*f*fd*(k1**2*(2*C - 1) + k2**2*(10*K - 4))*(2*r + 2*s - 1) + 396*f*gd2*k2**2*(r + s - 1) + 396*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(63*f**2*k2**2 - 22*f*(k1**2*(2*C - 1) + k2**2*(10*K - 4)) + 396*g2*k2**2)) - 5*f*(D1*(252*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(546*C - 273)*(3*r + 3*s - 2) - 5720*f*gd2*k2**2*(r + s - 1) - 5720*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(252*f**2*k2**2 + f*k1**2*(546*C - 273) - 5720*g2*k2**2)))/(45045*d*k3**5) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**2*k1*k2**2*st**2*(13*D1*bd1*f*(r + s - 1)*(60*f**2*k2**2 - 11*f*(k1**2*(74*C - 47) - k2**2*(-9*K + 48*b1 + 6)) + k2**2*(594*b1*(2 - 3*K) + 1782*g2)) + 429*b1**2*k2**2*(D1*fd*(8*f*(2*r + 2*s - 1) + (18 - 27*K)*(r + s)) + Dd*f*(-27*K + 8*f + 18)*(4*r + 4*s - 3)) + 13*b1*(D1*(60*f**2*fd*k2**2*(3*r + 3*s - 2) - 11*f*fd*(k1**2*(74*C - 47) + k2**2*(9*K - 6))*(2*r + 2*s - 1) + 1782*f*gd2*k2**2*(r + s - 1) + 1782*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(60*f**2*k2**2 - 11*f*(k1**2*(74*C - 47) + k2**2*(9*K - 6)) + 1782*g2*k2**2)) + f*(D1*(3780*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(4810*C - 3055)*(3*r + 3*s - 2) + 2574*f*gd2*k2**2*(r + s - 1) + 2574*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(3780*f**2*k2**2 + f*k1**2*(4810*C - 3055) + 2574*g2*k2**2)))/(45045*d*k3**5) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**2*k1*(-198*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + 11*b1**2*(D1*(-18*bd1*f*k2**2*(3*r + 3*s - 2) + fd*k1**2*(18*C - 9)*(r + s - 1) + fd*k2**2*(-27*K + 10*f*(4*r + 4*s - 1) + 9*r + 9*s + 18)) + Dd*f*(k1**2*(18*C - 9) + k2**2*(20*f + 9))*(4*r + 4*s - 3)) + b1*(11*D1*bd1*f*(k1**2*(18*C - 9)*(2*r + 2*s - 1) + k2**2*(27*K + 10*f*(4*r + 4*s - 5) + 18*r + 18*s - 36)) + D1*(315*f**2*fd*k2**2*(4*r + 4*s - 3) - 11*f*(27*bd2*k2**2*(r + s - 1) + 10*fd*(k1**2*(2*C - 1) + k2**2*(3*K - 3)*(2*r + 2*s - 1))) - 297*fd*k2**2*(b2*(r + s) - 2*g2)) + 3*Dd*f*k2**2*(-99*b2 + 10*f*(-11*K + 14*f + 11))*(4*r + 4*s - 3)) + f*(D1*bd1*(105*f**2*k2**2*(4*r + 4*s - 3) + 110*f*(k1**2*(2*C - 1) - k2**2*(3*K - 3)*(r + s - 1)) - 297*k2**2*(b2*(r + s - 1) + 2*g2)) - 15*D1*(f*fd*k1**2*(14*C - 7)*(3*r + 3*s - 2) + 22*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) + 22*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) - 15*Dd*f*(f*k1**2*(14*C - 7) + k2**2*(22*b2 - 44*g2))*(4*r + 4*s - 3)))/(3465*d*k3**3) - 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**2*k2**2*st**2*(D1*bd1*f**2*(r + s) + 9*b1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*f*(9*D1*bd1*(2*r + 2*s - 1) + 2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)))/(105*d*k1*k3) - 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**2*k2**2*st**2*(33*b1**2*(D1*fd*(k1**2*(42*C - 33)*(r + s - 1) + k2**2*(f*(8*r + 8*s - 6) + 9*r + 9*s)) + Dd*f*(k1**2*(42*C - 33) + k2**2*(4*f + 9))*(4*r + 4*s - 3)) + b1*f*(33*D1*bd1*(k1**2*(42*C - 33)*(2*r + 2*s - 1) + 2*k2**2*(f*(4*r + 4*s - 3) + 9*r + 9*s - 9)) + D1*fd*(-11*k1**2*(C*(44*r + 44*s - 8) - 32*r - 32*s + 5) + 3*k2**2*(-10*f*(6*r + 6*s - 5) + 22*r + 22*s - 11)) - Dd*f*(k1**2*(242*C - 176) + k2**2*(60*f - 33))*(4*r + 4*s - 3)) + f**2*(D1*bd1*(-11*k1**2*(C*(22*r + 22*s - 36) - 16*r - 16*s + 27) + 3*k2**2*(-10*f*(2*r + 2*s - 1) + 11*r + 11*s - 11)) + k1**2*(180*C - 135)*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))))/(3465*d*k1*k3**3) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**2*(-10*D1*bd1*f**2*k1**2*(2*C - 1)*(r + s) + 9*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1**2*(D1*(9*bd1*f*k2**2*(3*r + 3*s - 2) - fd*(k1**2*(18*C - 9) - k2**2*(20*f + 9))*(r + s - 1)) + Dd*f*(k1**2*(9 - 18*C) + k2**2*(10*f + 9))*(4*r + 4*s - 3)) + b1*f*(-D1*bd1*(k1**2*(18*C - 9) - k2**2*(10*f + 9))*(2*r + 2*s - 1) - k1**2*(20*C - 10)*(2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))))/(315*d*k1*k3) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct*f*k2**3*st**4*(5*C - 4)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 2*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(1155*d*k3**3) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct*f*k2**3*st**4*(26*D1*bd1*f*(k1**2*(121*C - 77) + k2**2*(-55*b1 + 15*f))*(r + s - 1) - 715*b1**2*k2**2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 26*b1*(D1*fd*(15*f*k2**2*(3*r + 3*s - 2) + k1**2*(121*C - 77)*(2*r + 2*s - 1)) + Dd*f*(15*f*k2**2 + k1**2*(121*C - 77))*(4*r + 4*s - 3)) + 4*f*(D1*fd*(25*f*k2**2*(4*r + 4*s - 3) + k1**2*(143*C - 91)*(3*r + 3*s - 2)) + Dd*f*(25*f*k2**2 + k1**2*(143*C - 91))*(4*r + 4*s - 3)))/(15015*d*k3**5) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct*k1**4*k2*(11*b1**2*(D1*fd*(10*f*(2*r + 2*s - 1) + (9 - 45*K)*(r + s)) + Dd*f*(-45*K + 10*f + 9)*(4*r + 4*s - 3)) + b1*(22*D1*bd1*f*(-45*K + 10*f + 9)*(r + s - 1) + 5*D1*(21*f**2*fd*(3*r + 3*s - 2) - 22*f*(fd*(5*K - 1)*(2*r + 2*s - 1) - 9*gd2*(r + s - 1)) + 198*fd*g2*(r + s)) + 5*Dd*f*(21*f**2 - 22*f*(5*K - 1) + 198*g2)*(4*r + 4*s - 3)) + 5*f*(D1*bd1*(21*f**2 - 22*f*(5*K - 1) + 198*g2)*(r + s - 1) + 220*D1*f*gd2*(r + s - 1) + 220*D1*fd*g2*(2*r + 2*s - 1) + 220*Dd*f*g2*(4*r + 4*s - 3)))/(3465*d*k3**5) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct*k1**2*k2*(11*D1*b1**2*(9*bd1*f*(3*r + 3*s - 2) + fd*(27*K - 10*f - 9)) + 99*b1**3*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*(660*D1*K*f*fd*r + 660*D1*K*f*fd*s - 330*D1*K*f*fd + 297*D1*b2*fd*r + 297*D1*b2*fd*s + 11*D1*bd1*f*(-27*K + 10*f + 9) + 297*D1*bd2*f*(r + s - 1) - 315*D1*f**2*fd*r - 315*D1*f**2*fd*s + 210*D1*f**2*fd - 220*D1*f*fd*r - 220*D1*f*fd*s + 110*D1*f*fd - 594*D1*fd*g2 + 1320*Dd*K*f**2*r + 1320*Dd*K*f**2*s - 990*Dd*K*f**2 + 1188*Dd*b2*f*r + 1188*Dd*b2*f*s - 891*Dd*b2*f - 420*Dd*f**3*r - 420*Dd*f**3*s + 315*Dd*f**3 - 440*Dd*f**2*r - 440*Dd*f**2*s + 330*Dd*f**2) + f*(D1*bd1*(-105*f**2*(r + s - 1) + 110*f*(3*K - 1)*(r + s - 1) + 594*g2) + 330*D1*bd2*f*(r + s - 1) - 660*D1*f*gd2*(r + s - 1) - 660*D1*fd*g2*(2*r + 2*s - 1) - 660*Dd*f*g2*(4*r + 4*s - 3) + 33*b2*(9*D1*bd1*(r + s - 1) + 10*D1*fd*(2*r + 2*s - 1) + 10*Dd*f*(4*r + 4*s - 3))))/(3465*d*k3**3) - 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct*k1**2*k2*st**2*(13*D1*bd1*f*(r + s - 1)*(30*f**2*k2**2 + f*k1**2*(242*C - 132) - 33*f*k2**2*(-3*K + 12*b1 + 1) - k2**2*(-1782*K*b1 + 594*b1 + 1782*g2)) - 1287*b1**2*k2**2*(D1*fd*(f*(4*r + 4*s - 2) + (3 - 9*K)*(r + s)) + Dd*f*(-9*K + 2*f + 3)*(4*r + 4*s - 3)) + 13*b1*(D1*(30*f**2*fd*k2**2*(3*r + 3*s - 2) + 11*f*(fd*(k1**2*(22*C - 12) + k2**2*(9*K - 3))*(2*r + 2*s - 1) - 162*gd2*k2**2*(r + s - 1)) - 1782*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(30*f**2*k2**2 + f*k1**2*(242*C - 132) + 33*f*k2**2*(3*K - 1) - 1782*g2*k2**2)) - 2*f*(D1*(630*f**2*fd*k2**2*(4*r + 4*s - 3) + 13*f*(fd*k1**2*(55*C - 30)*(3*r + 3*s - 2) + 99*gd2*k2**2*(r + s - 1)) + 1287*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(630*f**2*k2**2 + f*k1**2*(715*C - 390) + 1287*g2*k2**2)))/(45045*d*k3**5) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct*k2*st**2*(3*C - 2)*(D1*bd1*f**2*(r + s) + 9*b1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*f*(9*D1*bd1*(2*r + 2*s - 1) + 2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)))/(315*d*k3) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct*k2*(-9*D1*bd1*f*(b2 - 2*g2)*(r + s) + 9*b1**3*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1**2*(9*D1*bd1*f*(3*r + 3*s - 2) + D1*fd*(-9*K + 20*f + 9)*(r + s - 1) + Dd*f*(-9*K + 10*f + 9)*(4*r + 4*s - 3)) + b1*(-9*D1*b2*fd*(r + s - 1) + D1*bd1*f*(-9*K + 10*f + 9)*(2*r + 2*s - 1) - 9*D1*bd2*f*(r + s - 1) + 18*D1*(f*gd2 + fd*g2)*(r + s - 1) - 9*Dd*b2*f*(4*r + 4*s - 3) + 18*Dd*f*g2*(4*r + 4*s - 3)))/(315*d*k3) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct*k2*st**2*(297*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) - 33*b1**2*(D1*(-9*bd1*f*k2**2*(3*r + 3*s - 2) + fd*k1**2*(30*C - 18)*(r + s - 1) + fd*k2**2*(f*(8*r + 8*s - 5) + (9 - 9*K)*(r + s))) + Dd*f*(k1**2*(30*C - 18) + k2**2*(-9*K + 4*f + 9))*(4*r + 4*s - 3)) + b1*(-33*D1*bd1*f*(k1**2*(30*C - 18)*(2*r + 2*s - 1) + k2**2*(f*(8*r + 8*s - 7) + (18 - 18*K)*(r + s - 1))) + D1*(45*f**2*fd*k2**2*(5*r + 5*s - 4) + 11*f*(2*fd*k1**2*(8*C*r + 8*C*s + C - 4*r - 4*s - 1) + 3*fd*k2**2*(K - 1)*(2*r + 2*s - 1) + k2**2*(27*bd2 - 54*gd2)*(r + s - 1)) + 297*fd*k2**2*(b2 - 2*g2)*(r + s)) + Dd*f*(4*r + 4*s - 3)*(75*f**2*k2**2 + 11*f*(k1**2*(8*C - 4) + k2**2*(3*K - 3)) + k2**2*(297*b2 - 594*g2))) + f*(D1*bd1*(15*f**2*k2**2*(5*r + 5*s - 3) + 22*f*k1**2*(C*(4*r + 4*s - 9) - 2*r - 2*s + 5) + 33*f*k2**2*(K - 1)*(r + s - 1) + k2**2*(297*b2 - 594*g2)*(r + s - 1)) + D1*(-f*fd*k1**2*(90*C - 50)*(3*r + 3*s - 2) + 33*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) + 33*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) - Dd*f*(f*k1**2*(90*C - 50) - k2**2*(33*b2 - 66*g2))*(4*r + 4*s - 3)))/(3465*d*k3**3) - 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*f**2*k2**6*st**6*(39*D1*bd1*f*(r + s - 1) + 39*b1*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)) + 7*f*(D1*fd + Dd*f)*(4*r + 4*s - 3))/(3003*d*k1*k3**5) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*f*k1*k2**2*st**4*(13*D1*bd1*f*(k1**2*(66*C - 33) + k2**2*(-88*b1 + 4*f))*(r + s - 1) - 572*b1**2*k2**2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 13*b1*(D1*fd*(4*f*k2**2*(3*r + 3*s - 2) + k1**2*(66*C - 33)*(2*r + 2*s - 1)) + Dd*f*(4*f*k2**2 + k1**2*(66*C - 33))*(4*r + 4*s - 3)) + 6*f*(D1*fd*(5*f*k2**2*(4*r + 4*s - 3) + k1**2*(26*C - 13)*(3*r + 3*s - 2)) + Dd*f*(5*f*k2**2 + k1**2*(26*C - 13))*(4*r + 4*s - 3)))/(15015*d*k3**5) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*f*k2**2*st**4*(D1*bd1*f*(k1**2*(33 - 66*C)*(r + s - 1) + k2**2*(11*b1*(4*r + 4*s - 3) + 2*f*(2*r + 2*s - 1))) + 11*b1**2*k2**2*(D1*fd + 2*Dd*f)*(4*r + 4*s - 3) + b1*(D1*fd*(2*f*k2**2*(6*r + 6*s - 5) + k1**2*(33 - 66*C)*(2*r + 2*s - 1)) + Dd*f*(4*f*k2**2 + k1**2*(33 - 66*C))*(4*r + 4*s - 3)) - f*k1**2*(12*C - 6)*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(1155*d*k1*k3**3) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*k1**5*(2*D1*bd1*f*(r + s - 1)*(9*K*b1 + 5*K*f - 9*g2) + 9*K*b1**2*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) + 2*b1*(5*D1*K*f*fd*(2*r + 2*s - 1) - 9*D1*f*gd2*(r + s - 1) - 9*D1*fd*g2*(r + s) + Dd*f*(5*K*f - 9*g2)*(4*r + 4*s - 3)) - 20*f*(D1*f*gd2*(r + s - 1) + D1*fd*g2*(2*r + 2*s - 1) + Dd*f*g2*(4*r + 4*s - 3)))/(315*d*k3**5) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*k1**3*(9*D1*K*b1**2*fd + b1*(9*D1*bd2*f*(r + s - 1) + D1*(-9*K*bd1*f + 10*K*f*fd*(2*r + 2*s - 1) - 18*fd*g2) + 10*Dd*K*f**2*(4*r + 4*s - 3)) + b2*(9*D1*bd1*f*(r + s - 1) + 9*b1*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) + 10*f*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))) + 2*f*(D1*bd1*(5*K*f*(r + s - 1) + 9*g2) + 5*D1*bd2*f*(r + s - 1) - 10*D1*f*gd2*(r + s - 1) - 10*D1*fd*g2*(2*r + 2*s - 1) - 10*Dd*f*g2*(4*r + 4*s - 3)))/(315*d*k3**3) - 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*k1**3*st**2*(13*D1*bd1*f*(r + s - 1)*(15*f**2*k2**2 + 11*f*(k1**2*(2*C - 1) + k2**2*(3*K - 8*b1)) - k2**2*(-594*K*b1 + 594*g2)) - 143*b1**2*k2**2*(D1*fd*(-27*K*(r + s) + f*(8*r + 8*s - 4)) + Dd*f*(-27*K + 4*f)*(4*r + 4*s - 3)) + 13*b1*(D1*(15*f**2*fd*k2**2*(3*r + 3*s - 2) + 11*f*(fd*(3*K*k2**2 + k1**2*(2*C - 1))*(2*r + 2*s - 1) - 54*gd2*k2**2*(r + s - 1)) - 594*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(15*f**2*k2**2 + 11*f*(3*K*k2**2 + k1**2*(2*C - 1)) - 594*g2*k2**2)) - f*(D1*(105*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(130*C - 65)*(3*r + 3*s - 2) + 858*f*gd2*k2**2*(r + s - 1) + 858*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(105*f**2*k2**2 + f*k1**2*(130*C - 65) + 858*g2*k2**2)))/(45045*d*k3**5) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*k1*(D1*bd1*f*(b2 - 2*g2)*(r + s) + K*b1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*(2*D1*K*bd1*f*r + 2*D1*K*bd1*f*s - D1*K*bd1*f + D1*b2*fd*(r + s - 1) + D1*bd2*f*(r + s - 1) - 2*D1*f*gd2*r - 2*D1*f*gd2*s + 2*D1*f*gd2 - 2*D1*fd*g2*r - 2*D1*fd*g2*s + 2*D1*fd*g2 + Dd*b2*f*(4*r + 4*s - 3) - 8*Dd*f*g2*r - 8*Dd*f*g2*s + 6*Dd*f*g2))/(35*d*k3) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*k1*st**2*(198*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) - 11*b1**2*(D1*(-18*bd1*f*k2**2*(3*r + 3*s - 2) + fd*k1**2*(18*C - 9)*(r + s - 1) + fd*k2**2*(-27*K*(r + s) + f*(4*r + 4*s - 1))) + Dd*f*(k1**2*(18*C - 9) + k2**2*(-27*K + 2*f))*(4*r + 4*s - 3)) + b1*(-11*D1*bd1*f*(k1**2*(18*C - 9)*(2*r + 2*s - 1) + k2**2*(-54*K*(r + s - 1) + f*(4*r + 4*s - 5))) + D1*(15*f**2*fd*k2**2*(4*r + 4*s - 3) + 11*f*(3*K*fd*k2**2*(2*r + 2*s - 1) + fd*k1**2*(2*C - 1) + k2**2*(27*bd2 - 54*gd2)*(r + s - 1)) + 297*fd*k2**2*(b2 - 2*g2)*(r + s)) + Dd*f*k2**2*(4*r + 4*s - 3)*(33*K*f + 297*b2 + 20*f**2 - 594*g2)) + f*(D1*bd1*(33*K*f*k2**2*(r + s - 1) + 5*f**2*k2**2*(4*r + 4*s - 3) + f*k1**2*(11 - 22*C) + k2**2*(297*b2 - 594*g2)*(r + s - 1)) + D1*(-f*fd*k1**2*(10*C - 5)*(3*r + 3*s - 2) + 33*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) + 33*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) - Dd*f*(f*k1**2*(10*C - 5) - k2**2*(33*b2 - 66*g2))*(4*r + 4*s - 3)))/(3465*d*k3**3) - 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*st**2*(-D1*bd1*f**2*k1**2*(2*C - 1)*(r + s) + 9*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1**2*(D1*(9*bd1*f*k2**2*(3*r + 3*s - 2) - fd*(-2*f*k2**2 + k1**2*(18*C - 9))*(r + s - 1)) + Dd*f*(f*k2**2 + k1**2*(9 - 18*C))*(4*r + 4*s - 3)) + b1*f*(-D1*bd1*(-f*k2**2 + k1**2*(18*C - 9))*(2*r + 2*s - 1) - k1**2*(2*C - 1)*(2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))))/(315*d*k1*k3) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*b1*ct*k2*(2*D1*bd1*f*r*(10*f + 9) + 9*b1**2*(D1*fd*r + Dd*f*(4*r - 1)) + b1*(9*D1*bd1*f*(3*r - 1) + D1*fd*(20*f*r - 10*f + 9*r - 9) + Dd*f*(10*f + 9)*(4*r - 1)))/(315*d*k1) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**6*f*k2**4*(C - 1)*(22*D1*bd1*f*(r - 1) + 22*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 21*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(693*d*k3**4) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**5*f*k2**3*(22*D1*bd1*f*(r - 1) + 22*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 21*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(693*d*k1*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**5*f*k2**3*(13*D1*bd1*f*(r - 1)*(21*f*k2**2 + k1**2*(176*C - 154)) + 13*b1*(D1*fd*r*(63*f*k2**2 + k1**2*(352*C - 308)) + Dd*f*(4*r - 1)*(21*f*k2**2 + k1**2*(176*C - 154))) + 21*f*(D1*fd*(12*f*k2**2*(4*r - 1) + k1**2*(104*C - 91)*(3*r - 1)) + Dd*f*(4*r - 1)*(12*f*k2**2 + k1**2*(104*C - 91))))/(9009*d*k1*k3**4) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**4*f*k2**4*st**2*(C - 1)*(11*D1*bd1*f*(r - 1) + 11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 5*f*(D1*fd*(1 - 3*r) + Dd*(-4*f*r + f)))/(1155*d*k3**4) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**4*k2**2*(198*b1**2*(C - 1)*(D1*fd*r + Dd*f*(4*r - 1)) + 22*b1*f*(9*D1*bd1*(C - 1)*(2*r - 1) + 10*D1*fd*(-C + r + 1) + 5*Dd*f*(4*r - 1)) + 5*f**2*(22*D1*bd1*(2*C + r - 3) - (42*C - 63)*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1))))/(3465*d*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**4*k2**2*(13*D1*bd1*f*(105*f**2*k2**2*(2*r - 3) + 110*f*(k1**2*(12*C - 9)*(r - 1) + k2**2*(-2*b1*r + b1 + r*(K - 1))) + 99*k2**2*(b1*(K - 1)*(2*r - 1) - 2*g2*(r - 1))) - 143*b1**2*k2**2*(D1*fd*r*(-9*K + 20*f + 9) + Dd*f*(4*r - 1)*(-9*K + 10*f + 9)) + 13*b1*(D1*(105*f**2*fd*k2**2*(6*r + 1) + 22*f*(5*fd*(k1**2*r*(24*C - 18) + k2**2*(K - 1)*(2*r - 1)) - 9*gd2*k2**2*r) - 198*fd*g2*k2**2*r) + 2*Dd*f*(4*r - 1)*(105*f**2*k2**2 + 55*f*(k1**2*(12*C - 9) + k2**2*(K - 1)) - 99*g2*k2**2)) + 5*f*(D1*(756*f**2*fd*k2**2*(4*r - 1) + f*fd*k1**2*(3276*C - 2457)*(3*r - 1) - 572*f*gd2*k2**2*r + 572*fd*g2*k2**2*(1 - 2*r)) + Dd*f*(4*r - 1)*(756*f**2*k2**2 + f*k1**2*(3276*C - 2457) - 572*g2*k2**2)))/(45045*d*k3**4) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**3*f*k2**3*st**2*(11*D1*bd1*f*(r - 1) + 11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 5*f*(D1*fd*(1 - 3*r) + Dd*(-4*f*r + f)))/(1155*d*k1*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**3*f*k2**3*st**2*(-13*D1*bd1*f*(r - 1)*(-25*f*k2**2 + k1**2*(198*C - 165)) + 13*b1*(3*D1*fd*r*(25*f*k2**2 + k1**2*(110 - 132*C)) + Dd*f*(4*r - 1)*(25*f*k2**2 + k1**2*(165 - 198*C))) + 15*f*(D1*fd*(35*f*k2**2*(4*r - 1) + k1**2*(78*C - 65)*(3*r - 1)) + Dd*f*(4*r - 1)*(35*f*k2**2 + k1**2*(78*C - 65))))/(45045*d*k1*k3**4) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**3*k1*k2*(13*D1*bd1*f*(315*f**2*k2**2 - 110*f*(k1**2*(8*C - 5)*(r - 1) + k2**2*(4*K*r - 6*b1*r + 3*b1 - 3*r)) - 99*k2**2*(b1*(4*K - 3)*(2*r - 1) - 8*g2*(r - 1))) + 429*b1**2*k2**2*(D1*fd*r*(-12*K + 20*f + 9) + Dd*f*(4*r - 1)*(-12*K + 10*f + 9)) - 13*b1*(D1*(315*f**2*fd*k2**2 + 22*f*(5*fd*(k1**2*r*(16*C - 10) + k2**2*(4*K - 3)*(2*r - 1)) - 36*gd2*k2**2*r) - 792*fd*g2*k2**2*r) + 22*Dd*f*(4*r - 1)*(5*f*(k1**2*(8*C - 5) + k2**2*(4*K - 3)) - 36*g2*k2**2)) - 5*f*(D1*(756*f**2*fd*k2**2*(4*r - 1) + f*fd*k1**2*(2184*C - 1365)*(3*r - 1) - 2288*f*gd2*k2**2*r + 2288*fd*g2*k2**2*(1 - 2*r)) + Dd*f*(4*r - 1)*(756*f**2*k2**2 + f*k1**2*(2184*C - 1365) - 2288*g2*k2**2)))/(45045*d*k3**4) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**3*k2*(10*D1*bd1*f**2*r + 9*b1**2*(D1*fd*r + Dd*f*(4*r - 1)) + b1*f*(9*D1*bd1*(2*r - 1) + 10*D1*fd*(2*r - 1) + 10*Dd*f*(4*r - 1)))/(315*d*k1) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**3*k2*(11*b1**2*(D1*fd*r*(k1**2*(36*C - 27) + k2**2*(40*f + 9)) + Dd*f*(4*r - 1)*(k1**2*(36*C - 27) + k2**2*(20*f + 9))) + b1*f*(11*D1*bd1*(2*r - 1)*(k1**2*(36*C - 27) + k2**2*(20*f + 9)) - 10*D1*fd*(k1**2*(44*C - 33) + k2**2*(-63*f*r + 21*f - 22*r + 11)) + 10*Dd*f*k2**2*(21*f + 11)*(4*r - 1)) + 5*f**2*(2*D1*bd1*(k1**2*(44*C - 33) + k2**2*r*(21*f + 11)) - k1**2*(84*C - 63)*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1))))/(3465*d*k1*k3**2) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**2*f*k2**4*st**4*(C - 1)*(11*D1*bd1*f*(r - 1) + 11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 2*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(1155*d*k3**4) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**2*k1**2*(13*D1*bd1*f*(105*f**2*k2**2*(2*r + 1) - 110*f*(k1**2*(2*C - 1)*(r - 1) + 3*k2**2*(2*K*r - 2*b1*r + b1 - r)) - 297*k2**2*(b1*(2*K - 1)*(2*r - 1) - 4*g2*(r - 1))) + 429*b1**2*k2**2*(D1*fd*r*(-18*K + 20*f + 9) + Dd*f*(4*r - 1)*(-18*K + 10*f + 9)) + 13*b1*(D1*(315*f**2*fd*k2**2*(2*r - 1) - 22*f*(5*fd*(k1**2*r*(4*C - 2) + k2**2*(6*K - 3)*(2*r - 1)) - 54*gd2*k2**2*r) + 1188*fd*g2*k2**2*r) + 2*Dd*f*(4*r - 1)*(105*f**2*k2**2 - 55*f*(k1**2*(2*C - 1) + k2**2*(6*K - 3)) + 594*g2*k2**2)) - 15*f*(D1*(84*f**2*fd*k2**2*(4*r - 1) + 13*f*(fd*k1**2*(14*C - 7)*(3*r - 1) - 88*gd2*k2**2*r) + 1144*fd*g2*k2**2*(1 - 2*r)) + Dd*f*(4*r - 1)*(84*f**2*k2**2 + f*k1**2*(182*C - 91) - 1144*g2*k2**2)))/(45045*d*k3**4) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**2*k2**2*st**2*(C - 1)*(99*b1**2*(D1*fd*r + Dd*f*(4*r - 1)) - 11*b1*f*(9*D1*bd1*(1 - 2*r) + D1*fd*(10*r + 1) + 5*Dd*f*(4*r - 1)) + f**2*(11*D1*bd1*(6 - 5*r) + 30*D1*fd*(3*r - 1) + 30*Dd*f*(4*r - 1)))/(3465*d*k3**2) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**2*k2**2*st**2*(13*D1*bd1*f*(30*f**2*k2**2*(2*r - 3) - 11*f*(k1**2*(38*C - 26)*(r - 1) + k2**2*(b1*(6 - 12*r) + r*(K - 1))) - 99*k2**2*(b1*(K - 1)*(2*r - 1) - 2*g2*(r - 1))) + 429*b1**2*k2**2*(D1*fd*r*(-3*K + 4*f + 3) + Dd*f*(4*r - 1)*(-3*K + 2*f + 3)) + 13*b1*(D1*(30*f**2*fd*k2**2*(6*r + 1) - 11*f*(fd*k1**2*r*(76*C - 52) + fd*k2**2*(K - 1)*(2*r - 1) - 18*gd2*k2**2*r) + 198*fd*g2*k2**2*r) + Dd*f*(4*r - 1)*(60*f**2*k2**2 - 11*f*(k1**2*(38*C - 26) + k2**2*(K - 1)) + 198*g2*k2**2)) + 2*f*(D1*(945*f**2*fd*k2**2*(4*r - 1) + f*fd*k1**2*(1235*C - 845)*(3*r - 1) + 143*f*gd2*k2**2*r + 143*fd*g2*k2**2*(2*r - 1)) + Dd*f*(4*r - 1)*(945*f**2*k2**2 + f*k1**2*(1235*C - 845) + 143*g2*k2**2)))/(45045*d*k3**4) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**2*(2*C - 1)*(10*D1*bd1*f**2*r + 9*b1**2*(D1*fd*r + Dd*f*(4*r - 1)) + b1*f*(9*D1*bd1*(2*r - 1) + 10*D1*fd*(2*r - 1) + 10*Dd*f*(4*r - 1)))/(315*d) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**2*(99*b1**3*k2**2*(D1*fd*r + Dd*f*(4*r - 1)) - 11*b1**2*(D1*(9*bd1*f*k2**2*(1 - 3*r) + fd*k1**2*r*(18*C - 9) + fd*k2**2*(-9*K + 10*f*(4*r + 1) + 9*r + 9)) + Dd*f*(4*r - 1)*(k1**2*(18*C - 9) + k2**2*(20*f + 9))) + b1*(-11*D1*bd1*f*(k1**2*(18*C - 9)*(2*r - 1) + k2**2*(9*K + 10*f*(4*r - 3) + 18*r - 18)) + D1*(99*bd2*f*k2**2*r - 315*f**2*fd*k2**2*(3*r - 1) + 110*f*fd*(k1**2*(2*C - 1) + k2**2*(K - 2)*(2*r - 1)) + 99*fd*k2**2*(b2*r - 2*g2)) + Dd*f*k2**2*(99*b2 - 5*f*(-22*K + 63*f + 44))*(4*r - 1)) + f*(D1*bd1*(-315*f**2*k2**2*r - 110*f*(k1**2*(2*C - 1) - k2**2*r*(K - 2)) + 99*k2**2*(b2*(r - 1) + 2*g2)) + 5*D1*(f*fd*k1**2*(42*C - 21)*(3*r - 1) + 22*f*k2**2*r*(bd2 - 2*gd2) + 22*fd*k2**2*(b2 - 2*g2)*(2*r - 1)) + 5*Dd*f*(4*r - 1)*(f*k1**2*(42*C - 21) + k2**2*(22*b2 - 44*g2))))/(3465*d*k3**2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct*f*k2**3*st**4*(11*D1*bd1*f*(r - 1) + 11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 2*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(1155*d*k1*k3**2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct*f*k2**3*st**4*(13*D1*bd1*f*(r - 1)*(10*f*k2**2 + k1**2*(44*C - 33)) + 13*b1*(2*D1*fd*r*(15*f*k2**2 + k1**2*(44*C - 33)) + Dd*f*(4*r - 1)*(10*f*k2**2 + k1**2*(44*C - 33))) + f*(D1*fd*(25*f*k2**2*(4*r - 1) + k1**2*(104*C - 78)*(3*r - 1)) + Dd*f*(4*r - 1)*(25*f*k2**2 + k1**2*(104*C - 78))))/(15015*d*k1*k3**4) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct*k1**3*k2*(11*b1**2*(D1*fd*r*(-36*K + 20*f + 9) + Dd*f*(4*r - 1)*(-36*K + 10*f + 9)) + b1*(11*D1*bd1*f*(2*r - 1)*(-36*K + 10*f + 9) + D1*(105*f**2*fd*(3*r - 1) - 110*f*fd*(4*K - 1)*(2*r - 1) + 792*f*gd2*r + 792*fd*g2*r) + Dd*f*(4*r - 1)*(105*f**2 - 110*f*(4*K - 1) + 792*g2)) + f*(D1*bd1*(5*f*r*(-88*K + 21*f + 22) + 792*g2*(r - 1)) + 880*D1*f*gd2*r + 880*D1*fd*g2*(2*r - 1) + 880*Dd*f*g2*(4*r - 1)))/(3465*d*k3**4) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct*k1*k2*(11*D1*b1**2*(9*bd1*f*(3*r - 1) + fd*(18*K - 10*f - 9)) + 99*b1**3*(D1*fd*r + Dd*f*(4*r - 1)) + b1*(440*D1*K*f*fd*r - 220*D1*K*f*fd + 11*D1*bd1*f*(-18*K + 10*f + 9) + 198*D1*bd2*f*r - 315*D1*f**2*fd*r + 105*D1*f**2*fd - 220*D1*f*fd*r + 110*D1*f*fd - 396*D1*fd*g2 + 880*Dd*K*f**2*r - 220*Dd*K*f**2 - 420*Dd*f**3*r + 105*Dd*f**3 - 440*Dd*f**2*r + 110*Dd*f**2 + 198*b2*(D1*fd*r + Dd*f*(4*r - 1))) + f*(D1*bd1*(-5*f*r*(-44*K + 21*f + 22) + 396*g2) + 220*D1*f*r*(bd2 - 2*gd2) + 220*D1*fd*g2*(2 - 4*r) + 440*Dd*f*g2*(1 - 4*r) + 22*b2*(9*D1*bd1*(r - 1) + 10*D1*fd*(2*r - 1) + 10*Dd*f*(4*r - 1))))/(3465*d*k3**2) - 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct*k1*k2*st**2*(13*D1*bd1*f*(45*f**2*k2**2 + 11*f*(k1**2*(16*C - 9)*(r - 1) - k2**2*(-2*K*r + 18*b1*r - 9*b1 + r)) + 99*k2**2*(b1*(2*K - 1)*(2*r - 1) - 4*g2*(r - 1))) - 1287*b1**2*k2**2*(D1*fd*r*(-2*K + 2*f + 1) + Dd*f*(4*r - 1)*(-2*K + f + 1)) + 13*b1*(-D1*(45*f**2*fd*k2**2 - 11*f*(fd*k1**2*r*(32*C - 18) + fd*k2**2*(2*K - 1)*(2*r - 1) - 36*gd2*k2**2*r) + 396*fd*g2*k2**2*r) + 11*Dd*f*(4*r - 1)*(f*k1**2*(16*C - 9) + f*k2**2*(2*K - 1) - 36*g2*k2**2)) + f*(D1*(-945*f**2*fd*k2**2*(4*r - 1) - 13*f*(fd*k1**2*(80*C - 45)*(3*r - 1) + 44*gd2*k2**2*r) + 572*fd*g2*k2**2*(1 - 2*r)) - Dd*f*(4*r - 1)*(945*f**2*k2**2 + f*k1**2*(1040*C - 585) + 572*g2*k2**2)))/(45045*d*k3**4) - 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct*k2*st**2*(D1*bd1*f**2*r + 9*b1**2*(D1*fd*r + Dd*f*(4*r - 1)) + b1*f*(9*D1*bd1*(2*r - 1) + D1*fd*(2*r - 1) + Dd*f*(4*r - 1)))/(315*d*k1) - 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct*k2*st**2*(33*b1**2*(D1*fd*r*(k1**2*(12*C - 9) + k2**2*(4*f + 3)) + Dd*f*(4*r - 1)*(k1**2*(12*C - 9) + k2**2*(2*f + 3))) + b1*f*(33*D1*bd1*(2*r - 1)*(k1**2*(12*C - 9) + k2**2*(2*f + 3)) + D1*fd*(-11*k1**2*(4*C*(4*r + 1) - 8*r - 3) + k2**2*(f*(30 - 90*r) + 22*r - 11)) - Dd*f*(4*r - 1)*(k1**2*(88*C - 44) + k2**2*(30*f - 11))) + f**2*(D1*bd1*(-11*k1**2*(8*C*r - 12*C - 4*r + 7) + k2**2*r*(11 - 30*f)) + k1**2*(60*C - 35)*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1))))/(3465*d*k1*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*f*k2**2*st**4*(2*C - 1)*(11*D1*bd1*f*(r - 1) + 11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 2*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(1155*d*k3**2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*f*k2**2*st**4*(13*D1*bd1*f*(k1**2*(22*C - 11)*(r - 1) + k2**2*(-22*b1*r + 11*b1 + 4*f*r - 6*f)) - 143*b1**2*k2**2*(2*D1*fd*r + Dd*f*(4*r - 1)) + 13*b1*(2*D1*fd*(f*k2**2*(6*r + 1) + k1**2*r*(22*C - 11)) + Dd*f*(4*r - 1)*(4*f*k2**2 + k1**2*(22*C - 11))) + f*(D1*fd*(15*f*k2**2*(4*r - 1) + k1**2*(52*C - 26)*(3*r - 1)) + Dd*f*(4*r - 1)*(15*f*k2**2 + k1**2*(52*C - 26))))/(15015*d*k3**4) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*k1**4*(D1*bd1*f*(9*K*b1*(2*r - 1) + 10*K*f*r - 18*g2*(r - 1)) + 9*K*b1**2*(D1*fd*r + Dd*f*(4*r - 1)) + 2*b1*(D1*(5*K*f*fd*(2*r - 1) - 9*f*gd2*r - 9*fd*g2*r) + Dd*f*(4*r - 1)*(5*K*f - 9*g2)) - 20*f*(D1*f*gd2*r + D1*fd*g2*(2*r - 1) + Dd*f*g2*(4*r - 1)))/(315*d*k3**4) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*k1**2*(9*D1*K*b1**2*fd + 20*D1*K*b1*f*fd*r - 10*D1*K*b1*f*fd + 9*D1*b1*bd2*f*r - 18*D1*b1*fd*g2 + D1*bd1*f*(-9*K*b1 + 10*K*f*r + 18*g2) + 10*D1*bd2*f**2*r - 20*D1*f**2*gd2*r - 40*D1*f*fd*g2*r + 20*D1*f*fd*g2 + 40*Dd*K*b1*f**2*r - 10*Dd*K*b1*f**2 - 80*Dd*f**2*g2*r + 20*Dd*f**2*g2 + b2*(9*D1*bd1*f*(r - 1) + 9*b1*(D1*fd*r + Dd*f*(4*r - 1)) + 10*f*(D1*fd*(2*r - 1) + Dd*f*(4*r - 1))))/(315*d*k3**2) - 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*k1**2*st**2*(13*D1*bd1*f*(5*f**2*k2**2*(2*r + 1) + 11*f*(k1**2*(2*C - 1)*(r - 1) + k2**2*(K*r - 6*b1*r + 3*b1)) + 99*k2**2*(K*b1*(2*r - 1) - 2*g2*(r - 1))) - 429*b1**2*k2**2*(D1*fd*r*(-3*K + 2*f) + Dd*f*(-3*K + f)*(4*r - 1)) + 13*b1*(D1*(15*f**2*fd*k2**2*(2*r - 1) + 11*f*(K*fd*k2**2*(2*r - 1) + fd*k1**2*r*(4*C - 2) - 18*gd2*k2**2*r) - 198*fd*g2*k2**2*r) + Dd*f*(4*r - 1)*(10*f**2*k2**2 + 11*f*(K*k2**2 + k1**2*(2*C - 1)) - 198*g2*k2**2)) + f*(D1*(-105*f**2*fd*k2**2*(4*r - 1) - 13*f*(fd*k1**2*(10*C - 5)*(3*r - 1) + 22*gd2*k2**2*r) + 286*fd*g2*k2**2*(1 - 2*r)) - Dd*f*(4*r - 1)*(105*f**2*k2**2 + f*k1**2*(130*C - 65) + 286*g2*k2**2)))/(45045*d*k3**4) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*st**2*(2*C - 1)*(D1*bd1*f**2*r + 9*b1**2*(D1*fd*r + Dd*f*(4*r - 1)) + b1*f*(9*D1*bd1*(2*r - 1) + D1*fd*(2*r - 1) + Dd*f*(4*r - 1)))/(315*d) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*(D1*bd1*f*r*(b2 - 2*g2) + K*b1**2*(D1*fd*(r - 1) + Dd*f*(4*r - 1)) + b1*(D1*b2*fd*(r - 1) + D1*f*r*(2*K*bd1 + bd2 - 2*gd2) - 2*D1*fd*g2*(r - 1) + Dd*b2*f*(4*r - 1) + 2*Dd*f*g2*(1 - 4*r)))/(35*d) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*st**2*(99*b1**3*k2**2*(D1*fd*r + Dd*f*(4*r - 1)) - 11*b1**2*(D1*(9*bd1*f*k2**2*(1 - 3*r) + fd*(-9*K*k2**2*r + f*k2**2*(4*r + 1) + k1**2*r*(18*C - 9))) + Dd*f*(4*r - 1)*(k1**2*(18*C - 9) + k2**2*(-9*K + 2*f))) + b1*(-11*D1*bd1*f*(k1**2*(18*C - 9)*(2*r - 1) + k2**2*(-18*K*r + 9*K + 4*f*r - 3*f)) + D1*(15*f**2*fd*k2**2*(3*r - 1) + 11*f*(K*fd*k2**2*(2*r - 1) + fd*k1**2*(2*C - 1) + k2**2*r*(9*bd2 - 18*gd2)) + 99*fd*k2**2*r*(b2 - 2*g2)) + Dd*f*k2**2*(4*r - 1)*(11*K*f + 99*b2 + 15*f**2 - 198*g2)) + f*(D1*bd1*(15*f**2*k2**2*r + 11*f*(-2*C*k1**2 + K*k2**2*r + k1**2) + k2**2*(99*b2 - 198*g2)*(r - 1)) + D1*(-f*fd*k1**2*(10*C - 5)*(3*r - 1) + 11*f*k2**2*r*(bd2 - 2*gd2) + 11*fd*k2**2*(b2 - 2*g2)*(2*r - 1)) - Dd*f*(4*r - 1)*(f*k1**2*(10*C - 5) - k2**2*(11*b2 - 22*g2))))/(3465*d*k3**2)
        perm23 = 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*b1*(D1*bd1*f*(k1**2*(2*s - 1) + k2**2*r*(8*C - 4)) + b1*(D1*fd*(k1**2*s + k2**2*(4*C - 2)*(r - 1)) + Dd*f*(k1**2*(4*s - 1) + k2**2*(8*C - 4)*(2*r - 1))))/(35*d*k1*k2**2) - 32*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**7*f*k1**2*k2**3*(819*C*D1*f*fd*r + 819*C*D1*f*fd*s - 546*C*D1*f*fd + 1092*C*Dd*f**2*r + 1092*C*Dd*f**2*s - 819*C*Dd*f**2 + 143*D1*bd1*f*(K - 1)*(r + s - 1) + 504*D1*f**2*fd*r + 504*D1*f**2*fd*s - 378*D1*f**2*fd - 819*D1*f*fd*r - 819*D1*f*fd*s + 546*D1*f*fd - 286*D1*f*gd2*r - 286*D1*f*gd2*s + 286*D1*f*gd2 - 572*D1*fd*g2*r - 572*D1*fd*g2*s + 286*D1*fd*g2 + 504*Dd*f**3*r + 504*Dd*f**3*s - 378*Dd*f**3 - 1092*Dd*f**2*r - 1092*Dd*f**2*s + 819*Dd*f**2 - 1144*Dd*f*g2*r - 1144*Dd*f*g2*s + 858*Dd*f*g2 + 143*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))/(9009*d*k3**6) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**6*f*k1*k2**2*(-4914*C*D1*f*fd*k1**2*r - 4914*C*D1*f*fd*k1**2*s + 3276*C*D1*f*fd*k1**2 - 3276*C*D1*f*fd*k2**2*r - 3276*C*D1*f*fd*k2**2*s + 2184*C*D1*f*fd*k2**2 - 6552*C*Dd*f**2*k1**2*r - 6552*C*Dd*f**2*k1**2*s + 4914*C*Dd*f**2*k1**2 - 4368*C*Dd*f**2*k2**2*r - 4368*C*Dd*f**2*k2**2*s + 3276*C*Dd*f**2*k2**2 - 13*D1*bd1*f*(k1**2*(66*K - 66) + k2**2*(44*K - 21*f - 22))*(r + s - 1) - 4032*D1*f**2*fd*k1**2*r - 4032*D1*f**2*fd*k1**2*s + 3024*D1*f**2*fd*k1**2 + 4914*D1*f*fd*k1**2*r + 4914*D1*f*fd*k1**2*s - 3276*D1*f*fd*k1**2 + 2457*D1*f*fd*k2**2*r + 2457*D1*f*fd*k2**2*s - 1638*D1*f*fd*k2**2 + 1716*D1*f*gd2*k1**2*r + 1716*D1*f*gd2*k1**2*s - 1716*D1*f*gd2*k1**2 + 1144*D1*f*gd2*k2**2*r + 1144*D1*f*gd2*k2**2*s - 1144*D1*f*gd2*k2**2 + 3432*D1*fd*g2*k1**2*r + 3432*D1*fd*g2*k1**2*s - 1716*D1*fd*g2*k1**2 + 2288*D1*fd*g2*k2**2*r + 2288*D1*fd*g2*k2**2*s - 1144*D1*fd*g2*k2**2 - 4032*Dd*f**3*k1**2*r - 4032*Dd*f**3*k1**2*s + 3024*Dd*f**3*k1**2 + 6552*Dd*f**2*k1**2*r + 6552*Dd*f**2*k1**2*s - 4914*Dd*f**2*k1**2 + 3276*Dd*f**2*k2**2*r + 3276*Dd*f**2*k2**2*s - 2457*Dd*f**2*k2**2 + 6864*Dd*f*g2*k1**2*r + 6864*Dd*f*g2*k1**2*s - 5148*Dd*f*g2*k1**2 + 4576*Dd*f*g2*k2**2*r + 4576*Dd*f*g2*k2**2*s - 3432*Dd*f*g2*k2**2 + 13*b1*(D1*fd*(k1**2*(66 - 66*K)*(2*r + 2*s - 1) + k2**2*(21*f*(3*r + 3*s - 2) + (22 - 44*K)*(2*r + 2*s - 1))) + Dd*f*(k1**2*(66 - 66*K) + k2**2*(-44*K + 21*f + 22))*(4*r + 4*s - 3)))/(9009*d*k3**6) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**5*f*k1**2*k2**3*st**2*(780*C*D1*f*fd*r + 780*C*D1*f*fd*s - 520*C*D1*f*fd + 1040*C*Dd*f**2*r + 1040*C*Dd*f**2*s - 780*C*Dd*f**2 - 286*D1*bd1*f*(K - 1)*(r + s - 1) + 1764*D1*f**2*fd*r + 1764*D1*f**2*fd*s - 1323*D1*f**2*fd - 780*D1*f*fd*r - 780*D1*f*fd*s + 520*D1*f*fd + 572*D1*f*gd2*r + 572*D1*f*gd2*s - 572*D1*f*gd2 + 1144*D1*fd*g2*r + 1144*D1*fd*g2*s - 572*D1*fd*g2 + 1764*Dd*f**3*r + 1764*Dd*f**3*s - 1323*Dd*f**3 - 1040*Dd*f**2*r - 1040*Dd*f**2*s + 780*Dd*f**2 + 2288*Dd*f*g2*r + 2288*Dd*f*g2*s - 1716*Dd*f*g2 - 286*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))/(9009*d*k3**6) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**5*k2*(13*D1*bd1*f*(r + s - 1)*(315*f**2*k1**2*k2**2 - 110*f*(K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(2*C + 6*K - 5)) + k1**2*k2**2*(-198*K*b1 + 198*b1 + 198*g2)) - 1287*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) + 13*b1*(D1*(315*f**2*fd*k1**2*k2**2*(3*r + 3*s - 2) - 22*f*(5*fd*(2*r + 2*s - 1)*(K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(2*C + 6*K - 5)) - 9*gd2*k1**2*k2**2*(r + s - 1)) + 198*fd*g2*k1**2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(315*f**2*k1**2*k2**2 - 110*f*(K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(2*C + 6*K - 5)) + 198*g2*k1**2*k2**2)) - 5*f*(D1*(1512*f**2*fd*k1**4*(4*r + 4*s - 3) + 273*f*fd*(3*r + 3*s - 2)*(k1**4*(6*C - 6) + k1**2*k2**2*(12*C - 9) + k2**4*(2*C - 1)) - 572*f*gd2*(3*k1**4 + 6*k1**2*k2**2 + k2**4)*(r + s - 1) - 572*fd*g2*(3*k1**4 + 6*k1**2*k2**2 + k2**4)*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(1512*f**2*k1**4 + 273*f*(k1**4*(6*C - 6) + k1**2*k2**2*(12*C - 9) + k2**4*(2*C - 1)) - 572*g2*(3*k1**4 + 6*k1**2*k2**2 + k2**4))))/(45045*d*k3**6) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**4*f*k1*k2**2*st**2*(-13*D1*bd1*f*(k1**2*(198*K - 198) + k2**2*(220*K + 75*f - 110))*(r + s - 1) + 2*D1*(3150*f**2*fd*k1**2*(4*r + 4*s - 3) + 65*f*fd*(k1**2*(18*C - 18) + k2**2*(20*C - 15))*(3*r + 3*s - 2) + 286*f*gd2*(9*k1**2 + 10*k2**2)*(r + s - 1) + 286*fd*g2*(9*k1**2 + 10*k2**2)*(2*r + 2*s - 1)) + 2*Dd*f*(4*r + 4*s - 3)*(3150*f**2*k1**2 + 65*f*(k1**2*(18*C - 18) + k2**2*(20*C - 15)) + 286*g2*(9*k1**2 + 10*k2**2)) - 13*b1*(D1*fd*(k1**2*(198*K - 198)*(2*r + 2*s - 1) + 5*k2**2*(15*f*(3*r + 3*s - 2) + (44*K - 22)*(2*r + 2*s - 1))) + Dd*f*(k1**2*(198*K - 198) + k2**2*(220*K + 75*f - 110))*(4*r + 4*s - 3)))/(45045*d*k3**6) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**4*k1*(26*D1*bd1*f*(r + s - 1)*(105*f**2*k1**2*k2**2 - 55*f*(k1**4*(K - 1) + k1**2*k2**2*(6*C + 6*K - 9) + k2**4*(4*C + 3*K - 2*b1 - 3)) + 99*k2**2*(-3*b1*k1**2*(K - 1) + b1*k2**2*(1 - 2*K) + g2*(3*k1**2 + 2*k2**2))) + 143*b1**2*k2**2*(D1*fd*(10*f*k2**2*(2*r + 2*s - 1) + (r + s)*(-9*k1**2*(3*K - 3) - 9*k2**2*(2*K - 1))) + Dd*f*(k1**2*(27 - 27*K) + k2**2*(-18*K + 10*f + 9))*(4*r + 4*s - 3)) + 26*b1*(D1*(105*f**2*fd*k1**2*k2**2*(3*r + 3*s - 2) - 55*f*fd*(2*r + 2*s - 1)*(k1**4*(K - 1) + k1**2*k2**2*(6*C + 6*K - 9) + k2**4*(4*C + 3*K - 3)) + 99*f*gd2*k2**2*(3*k1**2 + 2*k2**2)*(r + s - 1) + 99*fd*g2*k2**2*(3*k1**2 + 2*k2**2)*(r + s)) + Dd*f*(4*r + 4*s - 3)*(105*f**2*k1**2*k2**2 - 55*f*(k1**4*(K - 1) + k1**2*k2**2*(6*C + 6*K - 9) + k2**4*(4*C + 3*K - 3)) + 99*g2*k2**2*(3*k1**2 + 2*k2**2))) - 5*f*(D1*(1008*f**2*fd*k1**4*(4*r + 4*s - 3) + 273*f*fd*(3*r + 3*s - 2)*(k1**4*(2*C - 2) + k1**2*k2**2*(12*C - 9) + k2**4*(6*C - 3)) - 572*f*gd2*(k1**4 + 6*k1**2*k2**2 + 3*k2**4)*(r + s - 1) - 572*fd*g2*(k1**4 + 6*k1**2*k2**2 + 3*k2**4)*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(1008*f**2*k1**4 + 273*f*(k1**4*(2*C - 2) + k1**2*k2**2*(12*C - 9) + k2**4*(6*C - 3)) - 572*g2*(k1**4 + 6*k1**2*k2**2 + 3*k2**4))))/(45045*d*k3**6) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**3*f*k1**2*k2**3*st**4*(156*C*D1*f*fd*r + 156*C*D1*f*fd*s - 104*C*D1*f*fd + 208*C*Dd*f**2*r + 208*C*Dd*f**2*s - 156*C*Dd*f**2 + 143*D1*bd1*f*(K - 1)*(r + s - 1) + 140*D1*f**2*fd*r + 140*D1*f**2*fd*s - 105*D1*f**2*fd - 156*D1*f*fd*r - 156*D1*f*fd*s + 104*D1*f*fd - 286*D1*f*gd2*r - 286*D1*f*gd2*s + 286*D1*f*gd2 - 572*D1*fd*g2*r - 572*D1*fd*g2*s + 286*D1*fd*g2 + 140*Dd*f**3*r + 140*Dd*f**3*s - 105*Dd*f**3 - 208*Dd*f**2*r - 208*Dd*f**2*s + 156*Dd*f**2 - 1144*Dd*f*g2*r - 1144*Dd*f*g2*s + 858*Dd*f*g2 + 143*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))/(3003*d*k3**6) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**3*k2*st**2*(13*D1*bd1*f*(r + s - 1)*(150*f**2*k1**2*k2**2 + 11*f*(10*K*k2**4 + k1**4*(9*K - 9) + k1**2*k2**2*(6*C + 36*K - 24)) - k1**2*k2**2*(-594*K*b1 + 594*b1 + 594*g2)) + 3861*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) + 13*b1*(D1*(150*f**2*fd*k1**2*k2**2*(3*r + 3*s - 2) + 11*f*(fd*(2*r + 2*s - 1)*(10*K*k2**4 + k1**4*(9*K - 9) + k1**2*k2**2*(6*C + 36*K - 24)) - 54*gd2*k1**2*k2**2*(r + s - 1)) - 594*fd*g2*k1**2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(150*f**2*k1**2*k2**2 + 11*f*(10*K*k2**4 + k1**4*(9*K - 9) + k1**2*k2**2*(6*C + 36*K - 24)) - 594*g2*k1**2*k2**2)) - 2*f*(D1*(3150*f**2*fd*k1**4*(4*r + 4*s - 3) + 65*f*fd*(3*r + 3*s - 2)*(k1**4*(9*C - 9) + k1**2*k2**2*(36*C - 27) + k2**4*(10*C - 5)) + 143*f*gd2*(9*k1**4 + 36*k1**2*k2**2 + 10*k2**4)*(r + s - 1) + 143*fd*g2*(9*k1**4 + 36*k1**2*k2**2 + 10*k2**4)*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(3150*f**2*k1**4 + 65*f*(k1**4*(9*C - 9) + k1**2*k2**2*(36*C - 27) + k2**4*(10*C - 5)) + 143*g2*(9*k1**4 + 36*k1**2*k2**2 + 10*k2**4))))/(45045*d*k3**6) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**3*(D1*(1287*b1*fd*k2**2*(r + s)*(b1*(K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(6*K - 3)) - 2*g2*(3*k1**4 + 6*k1**2*k2**2 + k2**4)) + 210*f**3*k1**4*(13*bd1*k2**2*(r + s - 1) + 6*fd*k1**2*(4*r + 4*s - 3)) + 65*f**2*k2**2*(22*bd1*(r + s - 1)*(k1**4*(6*C + 2*K - 7) + k1**2*k2**2*(12*C + 3*K - 8*b1 - 9) + k2**4*(2*C - 1)) + k1**2*(21*fd*(k1**2*(4*C + 2*b1 - 3) + k2**2*(6*C - 3))*(3*r + 3*s - 2) - 44*gd2*(2*k1**2 + 3*k2**2)*(r + s - 1))) - 286*f*k2**2*(20*b1**2*fd*k1**2*k2**2*(2*r + 2*s - 1) - 9*b1*bd1*(r + s - 1)*(K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(6*K - 3)) - 5*b1*fd*(2*r + 2*s - 1)*(k1**4*(6*C + 2*K - 7) + k1**2*k2**2*(12*C + 3*K - 9) + k2**4*(2*C - 1)) + 9*b1*gd2*(3*k1**4 + 6*k1**2*k2**2 + k2**4)*(r + s - 1) + 9*bd1*g2*(3*k1**4 + 6*k1**2*k2**2 + k2**4)*(r + s - 1) + 10*fd*g2*k1**2*(2*k1**2 + 3*k2**2)*(2*r + 2*s - 1))) + Dd*f*(4*r + 4*s - 3)*(1287*b1*k2**2*(b1*(K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(6*K - 3)) - 2*g2*(3*k1**4 + 6*k1**2*k2**2 + k2**4)) + 1260*f**3*k1**6 + 1365*f**2*(k1**4*k2**2*(4*C + 2*b1 - 3) + k1**2*k2**4*(6*C - 3)) - 1430*f*k2**2*(4*b1**2*k1**2*k2**2 + b1*(k1**4*(-6*C - 2*K + 7) - k1**2*k2**2*(12*C + 3*K - 9) + k2**4*(1 - 2*C)) + 4*g2*k1**4 + 6*g2*k1**2*k2**2)))/(45045*d*k2*k3**6) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**2*f*k1*k2**2*st**4*(-13*D1*bd1*f*(k1**2*(33*K - 33) - k2**2*(-110*K + 30*f + 55))*(r + s - 1) - 2*D1*(150*f**2*fd*k1**2*(4*r + 4*s - 3) + 13*f*(fd*(k1**2*(6*C - 6) + k2**2*(20*C - 15))*(3*r + 3*s - 2) - 11*gd2*(3*k1**2 + 10*k2**2)*(r + s - 1)) - 143*fd*g2*(3*k1**2 + 10*k2**2)*(2*r + 2*s - 1)) - 2*Dd*f*(4*r + 4*s - 3)*(150*f**2*k1**2 + f*k1**2*(78*C - 78) + f*k2**2*(260*C - 195) - 143*g2*(3*k1**2 + 10*k2**2)) + 13*b1*(D1*fd*(k1**2*(33 - 33*K)*(2*r + 2*s - 1) + 5*k2**2*(6*f*(3*r + 3*s - 2) + (11 - 22*K)*(2*r + 2*s - 1))) + Dd*f*(k1**2*(33 - 33*K) + k2**2*(-110*K + 30*f + 55))*(4*r + 4*s - 3)))/(15015*d*k3**6) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**2*k1*st**2*(13*D1*bd1*f*(r + s - 1)*(60*f**2*k1**2*k2**2 + 11*f*(k1**4*(K - 1) + k1**2*k2**2*(6*C + 18*K - 15) + k2**4*(12*C + 18*K - 12*b1 - 9)) + 594*k2**2*(b1*k1**2*(K - 1) + b1*k2**2*(2*K - 1) - g2*(k1**2 + 2*k2**2))) - 429*b1**2*k2**2*(D1*fd*(2*f*k2**2*(2*r + 2*s - 1) + (r + s)*(-9*k1**2*(K - 1) - 9*k2**2*(2*K - 1))) + Dd*f*(k1**2*(9 - 9*K) + k2**2*(-18*K + 2*f + 9))*(4*r + 4*s - 3)) + 13*b1*(D1*(60*f**2*fd*k1**2*k2**2*(3*r + 3*s - 2) + 11*f*(fd*(2*r + 2*s - 1)*(k1**4*(K - 1) + k1**2*k2**2*(6*C + 18*K - 15) + k2**4*(12*C + 18*K - 9)) - 54*gd2*k2**2*(k1**2 + 2*k2**2)*(r + s - 1)) - 594*fd*g2*k2**2*(k1**2 + 2*k2**2)*(r + s)) + Dd*f*(4*r + 4*s - 3)*(60*f**2*k1**2*k2**2 + 11*f*(k1**4*(K - 1) + k1**2*k2**2*(6*C + 18*K - 15) + k2**4*(12*C + 18*K - 9)) - 594*g2*k2**2*(k1**2 + 2*k2**2))) - f*(D1*(2520*f**2*fd*k1**4*(4*r + 4*s - 3) + 65*f*fd*(3*r + 3*s - 2)*(k1**4*(2*C - 2) + k1**2*k2**2*(36*C - 27) + k2**4*(36*C - 18)) + 286*f*gd2*(k1**4 + 18*k1**2*k2**2 + 18*k2**4)*(r + s - 1) + 286*fd*g2*(k1**4 + 18*k1**2*k2**2 + 18*k2**4)*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(2520*f**2*k1**4 + 65*f*(k1**4*(2*C - 2) + k1**2*k2**2*(36*C - 27) + k2**4*(36*C - 18)) + 286*g2*(k1**4 + 18*k1**2*k2**2 + 18*k2**4))))/(45045*d*k3**6) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**2*k1*(33*b1**2*(D1*fd*(20*f*k1**2*k2**2*(2*r + 2*s - 1) + (r + s)*(-9*K*k2**4 - 3*k1**4*(K - 1) - 3*k1**2*k2**2*(6*K - 3))) + Dd*f*(4*r + 4*s - 3)*(-9*K*k2**4 + k1**4*(3 - 3*K) + k1**2*k2**2*(-18*K + 20*f + 9))) + b1*(-66*D1*bd1*f*(r + s - 1)*(9*K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(18*K - 20*f - 9)) + D1*(-315*f**2*fd*k1**4*(3*r + 3*s - 2) - 22*f*(5*fd*(2*r + 2*s - 1)*(k1**4*(2*C - 2) + k1**2*k2**2*(12*C + K - 9) + k2**4*(6*C - 3)) - 9*gd2*(k1**4 + 6*k1**2*k2**2 + 3*k2**4)*(r + s - 1)) + 198*fd*g2*(r + s)*(k1**4 + 6*k1**2*k2**2 + 3*k2**4)) - Dd*f*(4*r + 4*s - 3)*(315*f**2*k1**4 + 110*f*(k1**4*(2*C - 2) + k1**2*k2**2*(12*C + K - 9) + k2**4*(6*C - 3)) - 198*g2*(k1**4 + 6*k1**2*k2**2 + 3*k2**4))) + f*(-D1*bd1*(r + s - 1)*(315*f**2*k1**4 + 110*f*(k1**4*(2*C - 2) + k1**2*k2**2*(12*C + K - 9) + k2**4*(6*C - 3)) - 198*g2*(k1**4 + 6*k1**2*k2**2 + 3*k2**4)) - 5*k1**2*k2**2*(D1*(f*fd*(42*C - 21)*(3*r + 3*s - 2) - 44*f*gd2*(r + s - 1) - 44*fd*g2*(2*r + 2*s - 1)) + Dd*f*(f*(42*C - 21) - 44*g2)*(4*r + 4*s - 3))))/(3465*d*k3**6) + 56*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct*f**3*k1**2*k2**3*st**6*(D1*fd + Dd*f)*(4*r + 4*s - 3)/(429*d*k3**6) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct*f*k2*st**4*(D1*(-30*f**2*k1**2*(-13*bd1*k2**2*(r + s - 1) + 5*fd*k1**2*(4*r + 4*s - 3)) - 13*f*k2**2*(11*bd1*(5*K*k2**2 + k1**2*(6*K - 3))*(r + s - 1) - 2*fd*(k1**2*(-12*C + 15*b1 + 9) + k2**2*(5 - 10*C))*(3*r + 3*s - 2) - 22*gd2*(6*k1**2 + 5*k2**2)*(r + s - 1)) - 143*fd*k2**2*(2*r + 2*s - 1)*(5*K*b1*k2**2 + b1*k1**2*(6*K - 3) - 2*g2*(6*k1**2 + 5*k2**2))) - Dd*f*(4*r + 4*s - 3)*(150*f**2*k1**4 - 26*f*(k1**2*k2**2*(-12*C + 15*b1 + 9) + k2**4*(5 - 10*C)) + 143*k2**2*(5*K*b1*k2**2 + b1*k1**2*(6*K - 3) - 2*g2*(6*k1**2 + 5*k2**2))))/(15015*d*k3**6) - 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct*k1**2*(-D1*b1*(-105*f**2*fd*k1**4*(3*r + 3*s - 2) + 22*f*k2**2*(5*fd*(k1**2*(-4*C + 4*b1 + 3) + k2**2*(3 - 6*C))*(2*r + 2*s - 1) + 9*gd2*(2*k1**2 + 3*k2**2)*(r + s - 1)) - 99*fd*k2**2*(r + s)*(3*K*b1*k2**2 + b1*k1**2*(2*K - 1) - 2*g2*(2*k1**2 + 3*k2**2))) + D1*bd1*f*(r + s - 1)*(105*f**2*k1**4 + 110*f*k2**2*(k1**2*(4*C - 8*b1 - 3) + k2**2*(6*C - 3)) + 198*k2**2*(3*K*b1*k2**2 + b1*k1**2*(2*K - 1) - g2*(2*k1**2 + 3*k2**2))) + Dd*b1*f*(4*r + 4*s - 3)*(105*f**2*k1**4 + 110*f*k2**2*(k1**2*(4*C - 4*b1 - 3) + k2**2*(6*C - 3)) + 99*k2**2*(3*K*b1*k2**2 + b1*k1**2*(2*K - 1) - 2*g2*(2*k1**2 + 3*k2**2))))/(3465*d*k2*k3**6) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct*st**2*(D1*(-3861*b1*fd*k2**4*(r + s)*(K*b1*k2**2 + b1*k1**2*(2*K - 1) - 2*g2*(2*k1**2 + k2**2)) + 15*f**3*k1**4*(26*bd1*k2**2*(r + s - 1) + 21*fd*k1**2*(4*r + 4*s - 3)) - 13*f**2*k2**2*(11*bd1*(r + s - 1)*(k1**4*(2*K - 1) - k1**2*k2**2*(-12*C - 9*K + 24*b1 + 9) + k2**4*(6*C - 3)) - k1**2*(5*fd*(k1**2*(4*C + 6*b1 - 3) + k2**2*(18*C - 9))*(3*r + 3*s - 2) + 22*gd2*(2*k1**2 + 9*k2**2)*(r + s - 1))) + 143*f*k2**2*(12*b1**2*fd*k1**2*k2**2*(2*r + 2*s - 1) - b1*fd*(2*r + 2*s - 1)*(k1**4*(2*K - 1) + k1**2*k2**2*(12*C + 9*K - 9) + k2**4*(6*C - 3)) - 54*b1*k2**2*(r + s - 1)*(K*bd1*k2**2 + bd1*k1**2*(2*K - 1) - gd2*(2*k1**2 + k2**2)) + 54*bd1*g2*k2**2*(2*k1**2 + k2**2)*(r + s - 1) + 2*fd*g2*k1**2*(2*k1**2 + 9*k2**2)*(2*r + 2*s - 1))) + Dd*f*(4*r + 4*s - 3)*(-3861*b1*k2**4*(K*b1*k2**2 + b1*k1**2*(2*K - 1) - 2*g2*(2*k1**2 + k2**2)) + 315*f**3*k1**6 + 65*f**2*(k1**4*k2**2*(4*C + 6*b1 - 3) + k1**2*k2**4*(18*C - 9)) + 143*f*k2**2*(12*b1**2*k1**2*k2**2 + b1*(k1**4*(1 - 2*K) - k1**2*k2**2*(12*C + 9*K - 9) + k2**4*(3 - 6*C)) + 2*g2*k1**2*(2*k1**2 + 9*k2**2))))/(45045*d*k2*k3**6) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*f**2*k1*k2**2*st**6*(D1*(-39*b1*fd*k2**2*(3*r + 3*s - 2) - 39*bd1*f*k2**2*(r + s - 1) + 28*f*fd*k1**2*(4*r + 4*s - 3)) + Dd*f*(-39*b1*k2**2 + 28*f*k1**2)*(4*r + 4*s - 3))/(3003*d*k3**6) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*f*k1*st**4*(D1*(4*f**2*k1**2*(-13*bd1*k2**2*(r + s - 1) + 5*fd*k1**2*(4*r + 4*s - 3)) - 13*f*k2**2*(22*b1*bd1*k2**2*(r + s - 1) + 4*b1*fd*k1**2*(3*r + 3*s - 2) - fd*k2**2*(12*C - 6)*(3*r + 3*s - 2) + k2**2*(-33*K*bd1 + 66*gd2)*(r + s - 1)) - 143*fd*k2**4*(2*r + 2*s - 1)*(-3*K*b1 + b1**2 + 6*g2)) + Dd*f*(4*r + 4*s - 3)*(20*f**2*k1**4 - 26*f*(2*b1*k1**2*k2**2 + k2**4*(3 - 6*C)) - k2**4*(-429*K*b1 + 143*b1**2 + 858*g2)))/(15015*d*k3**6) + 16*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*k1**3*(-2*D1*bd1*f*k2**2*(f*(10*C - 5) - 9*g2)*(r + s - 1) + b1**2*(D1*fd*(-9*K*k2**2*(r + s) + 10*f*k1**2*(2*r + 2*s - 1)) + Dd*f*(-9*K*k2**2 + 10*f*k1**2)*(4*r + 4*s - 3)) + 2*b1*(D1*bd1*f*(-9*K*k2**2 + 10*f*k1**2)*(r + s - 1) + k2**2*(D1*(-f*fd*(10*C - 5)*(2*r + 2*s - 1) + 9*f*gd2*(r + s - 1) + 9*fd*g2*(r + s)) - Dd*f*(f*(10*C - 5) - 9*g2)*(4*r + 4*s - 3))))/(315*d*k3**6) - 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*k1*st**2*(D1*bd1*f*(r + s - 1)*(15*f**2*k1**4 - 11*f*k2**2*(K*k1**2 - 12*b1*k1**2 + k2**2*(6*C - 3)) + k2**4*(-594*K*b1 + 594*g2)) - 33*b1**2*k2**2*(D1*fd*(9*K*k2**2*(r + s) - 2*f*k1**2*(2*r + 2*s - 1)) - Dd*f*(-9*K*k2**2 + 2*f*k1**2)*(4*r + 4*s - 3)) + b1*(D1*(15*f**2*fd*k1**4*(3*r + 3*s - 2) - 11*f*fd*k2**2*(K*k1**2 + k2**2*(6*C - 3))*(2*r + 2*s - 1) + 594*f*gd2*k2**4*(r + s - 1) + 594*fd*g2*k2**4*(r + s)) + Dd*f*(4*r + 4*s - 3)*(15*f**2*k1**4 - 11*f*(K*k1**2*k2**2 + k2**4*(6*C - 3)) + 594*g2*k2**4)) + f*k1**2*k2**2*(D1*(f*fd*(10*C - 5)*(3*r + 3*s - 2) + 22*f*gd2*(r + s - 1) + 22*fd*g2*(2*r + 2*s - 1)) + Dd*f*(f*(10*C - 5) + 22*g2)*(4*r + 4*s - 3)))/(3465*d*k3**6) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*k1*(D1*bd1*f*(10*f**2*k1**4*(s - 1) + f*k2**2*(k1**2*(40*C*(r + 2*s - 2) - 9*b1*(8*r + 6*s - 7) - 20*r - 50*s + 50) + k2**2*(4*C - 2)*(8*r + 9*s - 9)) + 9*k2**2*(2*b1**2*k1**2*(3*r + 3*s - 2) + b1*(k1**2*(K*(4*r + 8*s - 6) - 2*s + 1) + k2**2*(2 - 4*C)*(2*r + 2*s - 1)) + 2*k1**2*(b2*(r + s - 1) - 2*g2*(r + 2*s - 2)))) + b1*(D1*(18*b1**2*fd*k1**2*k2**2*(r + s - 1) - 9*b1*fd*k2**2*(2*f*k1**2*(4*r + 3*s - 2) + k1**2*(-2*K*(r + 2*s) + s) + k2**2*(4*C - 2)*(r + s - 1)) + 18*bd2*f*k1**2*k2**2*(r + s - 1) + 30*f**2*fd*k1**4*s + 4*f*k2**2*(5*fd*k1**2*(C*(4*r + 8*s - 2) - 2*r - 5*s + 1) + fd*k2**2*(2*C - 1)*(8*r + 9*s - 4) - 9*gd2*k1**2*(r + 2*s - 1)) + 18*fd*k1**2*k2**2*(b2*(r + s) - 2*g2*(r + 2*s))) + Dd*f*(10*f**2*k1**4*(4*s - 1) + f*k2**2*(k1**2*(160*C*(r + 2*s - 1) - 9*b1*(16*r + 12*s - 11) - 80*r - 200*s + 90) + k2**2*(4*C - 2)*(32*r + 36*s - 25)) + 9*k2**2*(2*b1**2*k1**2*(4*r + 4*s - 3) + b1*(k1**2*(8*K*(r + 2*s - 1) - 4*s + 1) + k2**2*(2 - 4*C)*(4*r + 4*s - 3)) + 2*k1**2*(b2*(4*r + 4*s - 3) - 8*g2*(r + 2*s - 1))))))/(315*d*k2**2*k3**4) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*(-2*D1*bd1*f**2*k1**2*(-5*k1**2*(s - 1) + k2**2*(2*C - 1)*(8*r + 9*s - 9)) + 9*b1**2*(D1*fd*(k1**4*s*(4*f + 1) + k1**2*k2**2*s*(4*C - 3) + k2**4*(2 - 4*C)*(r - 1)) + Dd*f*(k1**4*(2*f + 1)*(4*s - 1) + k1**2*k2**2*(4*C - 3)*(4*s - 1) + 4*k2**4*(-4*C*r + 2*C + 2*r - 1))) + b1*f*(9*D1*bd1*(k1**4*(2*f + 1)*(2*s - 1) + k1**2*k2**2*(4*C - 3)*(2*s - 1) + k2**4*r*(4 - 8*C)) + 2*k1**2*(2*D1*fd*(5*k1**2*s - k2**2*(2*C - 1)*(8*r + 9*s - 4)) + Dd*f*(5*k1**2*(4*s - 1) - k2**2*(2*C - 1)*(32*r + 36*s - 25)))))/(315*d*k1*k2**2*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*b1*ct*(D1*bd1*f*(k1**2*(b1*(3*r + 3*s - 2) + 2*r + 2*s - 1) - k2**2*(2*C - 1)*(2*r + 2*s - 1)) + b1*(k1**2*(b1 + 1) + k2**2*(1 - 2*C))*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)))/(35*d*k2*k3) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*b1*f*k1*st**4*(2*D1*b1*fd*(r + s - 1) + D1*bd1*f*(2*r + 2*s - 1) + Dd*b1*f*(4*r + 4*s - 3))/(105*d*k3) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*b1*k1*(2*C - 1)*(D1*b1*fd*(r + s - 1) + D1*bd1*f*(2*r + 2*s - 1) + Dd*b1*f*(4*r + 4*s - 3))/(35*d*k3) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**7*f*k1**2*k2**3*(819*C*D1*f*fd*r + 819*C*D1*f*fd*s - 546*C*D1*f*fd + 1092*C*Dd*f**2*r + 1092*C*Dd*f**2*s - 819*C*Dd*f**2 + 143*D1*bd1*f*(K - 1)*(r + s - 1) + 504*D1*f**2*fd*r + 504*D1*f**2*fd*s - 378*D1*f**2*fd - 819*D1*f*fd*r - 819*D1*f*fd*s + 546*D1*f*fd - 286*D1*f*gd2*r - 286*D1*f*gd2*s + 286*D1*f*gd2 - 572*D1*fd*g2*r - 572*D1*fd*g2*s + 286*D1*fd*g2 + 504*Dd*f**3*r + 504*Dd*f**3*s - 378*Dd*f**3 - 1092*Dd*f**2*r - 1092*Dd*f**2*s + 819*Dd*f**2 - 1144*Dd*f*g2*r - 1144*Dd*f*g2*s + 858*Dd*f*g2 + 143*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))/(9009*d*k3**5) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**6*f*k1*k2**2*(D1*bd1*f*(21*f + 22)*(r + s - 1) + b1*(D1*fd*(21*f*(3*r + 3*s - 2) + 44*r + 44*s - 22) + Dd*f*(21*f + 22)*(4*r + 4*s - 3)) + 21*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(693*d*k3**3) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**6*f*k1*k2**2*(-4914*C*D1*f*fd*k1**2*r - 4914*C*D1*f*fd*k1**2*s + 3276*C*D1*f*fd*k1**2 - 3276*C*D1*f*fd*k2**2*r - 3276*C*D1*f*fd*k2**2*s + 2184*C*D1*f*fd*k2**2 - 6552*C*Dd*f**2*k1**2*r - 6552*C*Dd*f**2*k1**2*s + 4914*C*Dd*f**2*k1**2 - 4368*C*Dd*f**2*k2**2*r - 4368*C*Dd*f**2*k2**2*s + 3276*C*Dd*f**2*k2**2 - 13*D1*bd1*f*(k1**2*(66*K - 66) + k2**2*(44*K - 21*f - 22))*(r + s - 1) - 4032*D1*f**2*fd*k1**2*r - 4032*D1*f**2*fd*k1**2*s + 3024*D1*f**2*fd*k1**2 + 4914*D1*f*fd*k1**2*r + 4914*D1*f*fd*k1**2*s - 3276*D1*f*fd*k1**2 + 2457*D1*f*fd*k2**2*r + 2457*D1*f*fd*k2**2*s - 1638*D1*f*fd*k2**2 + 1716*D1*f*gd2*k1**2*r + 1716*D1*f*gd2*k1**2*s - 1716*D1*f*gd2*k1**2 + 1144*D1*f*gd2*k2**2*r + 1144*D1*f*gd2*k2**2*s - 1144*D1*f*gd2*k2**2 + 3432*D1*fd*g2*k1**2*r + 3432*D1*fd*g2*k1**2*s - 1716*D1*fd*g2*k1**2 + 2288*D1*fd*g2*k2**2*r + 2288*D1*fd*g2*k2**2*s - 1144*D1*fd*g2*k2**2 - 4032*Dd*f**3*k1**2*r - 4032*Dd*f**3*k1**2*s + 3024*Dd*f**3*k1**2 + 6552*Dd*f**2*k1**2*r + 6552*Dd*f**2*k1**2*s - 4914*Dd*f**2*k1**2 + 3276*Dd*f**2*k2**2*r + 3276*Dd*f**2*k2**2*s - 2457*Dd*f**2*k2**2 + 6864*Dd*f*g2*k1**2*r + 6864*Dd*f*g2*k1**2*s - 5148*Dd*f*g2*k1**2 + 4576*Dd*f*g2*k2**2*r + 4576*Dd*f*g2*k2**2*s - 3432*Dd*f*g2*k2**2 + 13*b1*(D1*fd*(k1**2*(66 - 66*K)*(2*r + 2*s - 1) + k2**2*(21*f*(3*r + 3*s - 2) + (22 - 44*K)*(2*r + 2*s - 1))) + Dd*f*(k1**2*(66 - 66*K) + k2**2*(-44*K + 21*f + 22))*(4*r + 4*s - 3)))/(9009*d*k3**5) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**5*f*k1**2*k2**3*st**2*(780*C*D1*f*fd*r + 780*C*D1*f*fd*s - 520*C*D1*f*fd + 1040*C*Dd*f**2*r + 1040*C*Dd*f**2*s - 780*C*Dd*f**2 - 286*D1*bd1*f*(K - 1)*(r + s - 1) + 1764*D1*f**2*fd*r + 1764*D1*f**2*fd*s - 1323*D1*f**2*fd - 780*D1*f*fd*r - 780*D1*f*fd*s + 520*D1*f*fd + 572*D1*f*gd2*r + 572*D1*f*gd2*s - 572*D1*f*gd2 + 1144*D1*fd*g2*r + 1144*D1*fd*g2*s - 572*D1*fd*g2 + 1764*Dd*f**3*r + 1764*Dd*f**3*s - 1323*Dd*f**3 - 1040*Dd*f**2*r - 1040*Dd*f**2*s + 780*Dd*f**2 + 2288*Dd*f*g2*r + 2288*Dd*f*g2*s - 1716*Dd*f*g2 - 286*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))/(9009*d*k3**5) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**5*k2*(99*b1**2*k1**2*(K - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*(99*D1*bd1*f*k1**2*(K - 1)*(2*r + 2*s - 1) + D1*(315*f**2*fd*k1**2*(4*r + 4*s - 3) + 22*f*(5*fd*(K*k2**2*(-2*r - 2*s + 1) + k1**2*(4*C*(r + s - 1) + 2*r + 2*s + 1)) - 9*gd2*k1**2*(r + s - 1)) - 198*fd*g2*k1**2*(r + s - 1)) + 2*Dd*f*(4*r + 4*s - 3)*(210*f**2*k1**2 + 55*f*(-K*k2**2 + k1**2*(2*C + 1)) - 99*g2*k1**2)) + f*(D1*bd1*(105*f**2*k1**2*(4*r + 4*s - 3) + 110*f*(-K*k2**2*(r + s - 1) + k1**2*(2*C*r + 2*C*s + r + s - 3)) - 198*g2*k1**2*(r + s)) + 5*D1*(21*f*fd*(3*k1**2 + k2**2*(1 - 2*C))*(3*r + 3*s - 2) - 22*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) - 22*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + 5*Dd*f*(21*f*(3*k1**2 + k2**2*(1 - 2*C)) + k2**2*(-22*b2 + 44*g2))*(4*r + 4*s - 3)))/(3465*d*k3**3) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**5*k2*(13*D1*bd1*f*(r + s - 1)*(315*f**2*k1**2*k2**2 - 110*f*(K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(2*C + 6*K - 5)) + k1**2*k2**2*(-198*K*b1 + 198*b1 + 198*g2)) - 1287*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) + 13*b1*(D1*(315*f**2*fd*k1**2*k2**2*(3*r + 3*s - 2) - 22*f*(5*fd*(2*r + 2*s - 1)*(K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(2*C + 6*K - 5)) - 9*gd2*k1**2*k2**2*(r + s - 1)) + 198*fd*g2*k1**2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(315*f**2*k1**2*k2**2 - 110*f*(K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(2*C + 6*K - 5)) + 198*g2*k1**2*k2**2)) - 5*f*(D1*(1512*f**2*fd*k1**4*(4*r + 4*s - 3) + 273*f*fd*(3*r + 3*s - 2)*(k1**4*(6*C - 6) + k1**2*k2**2*(12*C - 9) + k2**4*(2*C - 1)) - 572*f*gd2*(3*k1**4 + 6*k1**2*k2**2 + k2**4)*(r + s - 1) - 572*fd*g2*(3*k1**4 + 6*k1**2*k2**2 + k2**4)*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(1512*f**2*k1**4 + 273*f*(k1**4*(6*C - 6) + k1**2*k2**2*(12*C - 9) + k2**4*(2*C - 1)) - 572*g2*(3*k1**4 + 6*k1**2*k2**2 + k2**4))))/(45045*d*k3**5) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**4*f*k1*k2**2*st**2*(D1*bd1*f*(15*f - 22)*(r + s - 1) + b1*(D1*fd*(15*f*(3*r + 3*s - 2) - 44*r - 44*s + 22) + Dd*f*(15*f - 22)*(4*r + 4*s - 3)) + 10*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(693*d*k3**3) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**4*f*k1*k2**2*st**2*(-13*D1*bd1*f*(k1**2*(198*K - 198) + k2**2*(220*K + 75*f - 110))*(r + s - 1) + 2*D1*(3150*f**2*fd*k1**2*(4*r + 4*s - 3) + 65*f*fd*(k1**2*(18*C - 18) + k2**2*(20*C - 15))*(3*r + 3*s - 2) + 286*f*gd2*(9*k1**2 + 10*k2**2)*(r + s - 1) + 286*fd*g2*(9*k1**2 + 10*k2**2)*(2*r + 2*s - 1)) + 2*Dd*f*(4*r + 4*s - 3)*(3150*f**2*k1**2 + 65*f*(k1**2*(18*C - 18) + k2**2*(20*C - 15)) + 286*g2*(9*k1**2 + 10*k2**2)) - 13*b1*(D1*fd*(k1**2*(198*K - 198)*(2*r + 2*s - 1) + 5*k2**2*(15*f*(3*r + 3*s - 2) + (44*K - 22)*(2*r + 2*s - 1))) + Dd*f*(k1**2*(198*K - 198) + k2**2*(220*K + 75*f - 110))*(4*r + 4*s - 3)))/(45045*d*k3**5) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**4*k1*(10*D1*bd1*f**2*(r + s) + b1**2*(D1*fd*(20*f + 9)*(r + s - 1) + Dd*f*(10*f + 9)*(4*r + 4*s - 3)) + b1*f*(D1*bd1*(10*f + 9)*(2*r + 2*s - 1) + 20*D1*fd*(r + s - 1) + 10*Dd*f*(4*r + 4*s - 3)))/(315*d*k3) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**4*k1*(11*b1**2*(D1*fd*(k1**2*(9*K - 9)*(r + s - 1) + k2**2*(18*K*(r + s - 1) + 10*f + 9)) + 9*Dd*f*(2*K*k2**2 + k1**2*(K - 1))*(4*r + 4*s - 3)) + b1*(-11*D1*bd1*f*(-k1**2*(9*K - 9)*(2*r + 2*s - 1) + k2**2*(9*K*(-4*r - 4*s + 2) + 10*f + 9)) + D1*(315*f**2*fd*k1**2*(5*r + 5*s - 4) + 22*f*(5*fd*(k1**2*(4*C*(r + s - 1) + 2*r + 2*s + 1) + k2**2*(8*C*(r + s - 1) + K*(-6*r - 6*s + 3) - 4*r - 4*s + 5)) - 9*gd2*(k1**2 + 2*k2**2)*(r + s - 1)) - 198*fd*g2*(k1**2 + 2*k2**2)*(r + s - 1)) + Dd*f*(4*r + 4*s - 3)*(525*f**2*k1**2 + 110*f*(k1**2*(2*C + 1) + k2**2*(4*C - 3*K - 2)) - 198*g2*(k1**2 + 2*k2**2))) + f*(D1*bd1*(105*f**2*k1**2*(5*r + 5*s - 3) + 110*f*(k1**2*(2*C*r + 2*C*s + r + s - 3) - k2**2*(-4*C*r - 4*C*s + 3*K*(r + s - 1) + 2*r + 2*s + 1)) - 198*g2*(k1**2 + 2*k2**2)*(r + s)) + 15*D1*(21*f*fd*(k1**2 + k2**2*(1 - 2*C))*(3*r + 3*s - 2) - 22*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) - 22*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + 15*Dd*f*(21*f*(k1**2 + k2**2*(1 - 2*C)) + k2**2*(-22*b2 + 44*g2))*(4*r + 4*s - 3)))/(3465*d*k3**3) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**4*k1*(26*D1*bd1*f*(r + s - 1)*(105*f**2*k1**2*k2**2 - 55*f*(k1**4*(K - 1) + k1**2*k2**2*(6*C + 6*K - 9) + k2**4*(4*C + 3*K - 2*b1 - 3)) + 99*k2**2*(-3*b1*k1**2*(K - 1) + b1*k2**2*(1 - 2*K) + g2*(3*k1**2 + 2*k2**2))) + 143*b1**2*k2**2*(D1*fd*(10*f*k2**2*(2*r + 2*s - 1) + (r + s)*(-9*k1**2*(3*K - 3) - 9*k2**2*(2*K - 1))) + Dd*f*(k1**2*(27 - 27*K) + k2**2*(-18*K + 10*f + 9))*(4*r + 4*s - 3)) + 26*b1*(D1*(105*f**2*fd*k1**2*k2**2*(3*r + 3*s - 2) - 55*f*fd*(2*r + 2*s - 1)*(k1**4*(K - 1) + k1**2*k2**2*(6*C + 6*K - 9) + k2**4*(4*C + 3*K - 3)) + 99*f*gd2*k2**2*(3*k1**2 + 2*k2**2)*(r + s - 1) + 99*fd*g2*k2**2*(3*k1**2 + 2*k2**2)*(r + s)) + Dd*f*(4*r + 4*s - 3)*(105*f**2*k1**2*k2**2 - 55*f*(k1**4*(K - 1) + k1**2*k2**2*(6*C + 6*K - 9) + k2**4*(4*C + 3*K - 3)) + 99*g2*k2**2*(3*k1**2 + 2*k2**2))) - 5*f*(D1*(1008*f**2*fd*k1**4*(4*r + 4*s - 3) + 273*f*fd*(3*r + 3*s - 2)*(k1**4*(2*C - 2) + k1**2*k2**2*(12*C - 9) + k2**4*(6*C - 3)) - 572*f*gd2*(k1**4 + 6*k1**2*k2**2 + 3*k2**4)*(r + s - 1) - 572*fd*g2*(k1**4 + 6*k1**2*k2**2 + 3*k2**4)*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(1008*f**2*k1**4 + 273*f*(k1**4*(2*C - 2) + k1**2*k2**2*(12*C - 9) + k2**4*(6*C - 3)) - 572*g2*(k1**4 + 6*k1**2*k2**2 + 3*k2**4))))/(45045*d*k3**5) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**3*f*k1**2*k2**3*st**4*(156*C*D1*f*fd*r + 156*C*D1*f*fd*s - 104*C*D1*f*fd + 208*C*Dd*f**2*r + 208*C*Dd*f**2*s - 156*C*Dd*f**2 + 143*D1*bd1*f*(K - 1)*(r + s - 1) + 140*D1*f**2*fd*r + 140*D1*f**2*fd*s - 105*D1*f**2*fd - 156*D1*f*fd*r - 156*D1*f*fd*s + 104*D1*f*fd - 286*D1*f*gd2*r - 286*D1*f*gd2*s + 286*D1*f*gd2 - 572*D1*fd*g2*r - 572*D1*fd*g2*s + 286*D1*fd*g2 + 140*Dd*f**3*r + 140*Dd*f**3*s - 105*Dd*f**3 - 208*Dd*f**2*r - 208*Dd*f**2*s + 156*Dd*f**2 - 1144*Dd*f*g2*r - 1144*Dd*f*g2*s + 858*Dd*f*g2 + 143*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))/(3003*d*k3**5) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**3*k2*st**2*(-297*b1**2*k1**2*(K - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*(-297*D1*bd1*f*k1**2*(K - 1)*(2*r + 2*s - 1) + 2*D1*(55*K*f*fd*k2**2*(2*r + 2*s - 1) + 75*f**2*fd*k1**2*(4*r + 4*s - 3) - 33*f*fd*k1**2*(2*C*(r + s - 1) + 4*r + 4*s - 1) + 297*f*gd2*k1**2*(r + s - 1) + 297*fd*g2*k1**2*(r + s - 1)) + 2*Dd*f*(4*r + 4*s - 3)*(55*K*f*k2**2 + 100*f**2*k1**2 + f*k1**2*(-33*C - 66) + 297*g2*k1**2)) + 2*f*(D1*bd1*(55*K*f*k2**2*(r + s - 1) + 25*f**2*k1**2*(4*r + 4*s - 3) - 33*f*k1**2*(r*(C + 2) + s*(C + 2) - 3) + 297*g2*k1**2*(r + s)) + 5*D1*(f*fd*(9*k1**2 + k2**2*(5 - 10*C))*(3*r + 3*s - 2) + 11*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) + 11*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + 5*Dd*f*(4*r + 4*s - 3)*(9*f*k1**2 + f*k2**2*(5 - 10*C) + k2**2*(11*b2 - 22*g2))))/(3465*d*k3**3) - 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**3*k2*st**2*(13*D1*bd1*f*(r + s - 1)*(150*f**2*k1**2*k2**2 + 11*f*(10*K*k2**4 + k1**4*(9*K - 9) + k1**2*k2**2*(6*C + 36*K - 24)) - k1**2*k2**2*(-594*K*b1 + 594*b1 + 594*g2)) + 3861*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) + 13*b1*(D1*(150*f**2*fd*k1**2*k2**2*(3*r + 3*s - 2) + 11*f*(fd*(2*r + 2*s - 1)*(10*K*k2**4 + k1**4*(9*K - 9) + k1**2*k2**2*(6*C + 36*K - 24)) - 54*gd2*k1**2*k2**2*(r + s - 1)) - 594*fd*g2*k1**2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(150*f**2*k1**2*k2**2 + 11*f*(10*K*k2**4 + k1**4*(9*K - 9) + k1**2*k2**2*(6*C + 36*K - 24)) - 594*g2*k1**2*k2**2)) - 2*f*(D1*(3150*f**2*fd*k1**4*(4*r + 4*s - 3) + 65*f*fd*(3*r + 3*s - 2)*(k1**4*(9*C - 9) + k1**2*k2**2*(36*C - 27) + k2**4*(10*C - 5)) + 143*f*gd2*(9*k1**4 + 36*k1**2*k2**2 + 10*k2**4)*(r + s - 1) + 143*fd*g2*(9*k1**4 + 36*k1**2*k2**2 + 10*k2**4)*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(3150*f**2*k1**4 + 65*f*(k1**4*(9*C - 9) + k1**2*k2**2*(36*C - 27) + k2**4*(10*C - 5)) + 143*g2*(9*k1**4 + 36*k1**2*k2**2 + 10*k2**4))))/(45045*d*k3**5) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**3*(D1*bd1*f*(r + s)*(10*f*(k1**2 + k2**2*(1 - 2*C)) + k2**2*(-9*b2 + 18*g2)) + b1**2*(D1*fd*(-9*K*k2**2 + k1**2*(20*f + 9))*(r + s - 1) + Dd*f*(-9*K*k2**2 + k1**2*(10*f + 9))*(4*r + 4*s - 3)) + b1*(D1*bd1*f*(-9*K*k2**2 + k1**2*(10*f + 9))*(2*r + 2*s - 1) + D1*(r + s - 1)*(20*f*fd*(k1**2 + k2**2*(1 - 2*C)) - 9*f*k2**2*(bd2 - 2*gd2) - 9*fd*k2**2*(b2 - 2*g2)) + Dd*f*(10*f*(k1**2 + k2**2*(1 - 2*C)) + k2**2*(-9*b2 + 18*g2))*(4*r + 4*s - 3)))/(315*d*k2*k3) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**3*(D1*bd1*f*(105*f**2*k1**4*(2*r + 2*s - 1) + 110*f*(k1**4*(r + s - 1) + k1**2*k2**2*(4*C*r + 4*C*s - 3*K*(r + s - 1) + b1*(4*r + 4*s - 5) - 3) + k2**4*(2*C - 1)) + 99*k2**2*(b1*(K*k2**2 + k1**2*(C*(4*r + 4*s - 2) + K*(4*r + 4*s - 2) - 3)) - b2*k2**2*(r + s - 1) - 2*g2*(2*k1**2*(r + s) + k2**2))) + 11*b1**2*k2**2*(18*C*k1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + D1*fd*(-9*K*k2**2 + k1**2*(18*K*(r + s - 1) + 10*f*(4*r + 4*s - 1) + 27)) + 2*Dd*f*k1**2*(9*K + 10*f)*(4*r + 4*s - 3)) + b1*(D1*(105*f**2*fd*k1**4*(6*r + 6*s - 5) + 11*f*(10*fd*(k1**4*(2*r + 2*s - 1) + k1**2*k2**2*(8*C*(r + s - 1) + K*(-6*r - 6*s + 3) + 3) + k2**4*(1 - 2*C)) - 9*k2**2*(bd2*k2**2 + 4*gd2*k1**2)*(r + s - 1)) - 99*fd*k2**2*(b2*k2**2*(r + s) + 4*g2*k1**2*(r + s - 1) - 2*g2*k2**2)) + Dd*f*(4*r + 4*s - 3)*(-99*b2*k2**4 + 210*f**2*k1**4 + 110*f*(k1**4 + k1**2*k2**2*(4*C - 3*K)) - 396*g2*k1**2*k2**2)) + 15*f*k1**2*(D1*(7*f*fd*(k1**2 + k2**2*(3 - 6*C))*(3*r + 3*s - 2) - 22*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) - 22*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + Dd*f*(7*f*(k1**2 + k2**2*(3 - 6*C)) + k2**2*(-22*b2 + 44*g2))*(4*r + 4*s - 3)))/(3465*d*k2*k3**3) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**3*(D1*(1287*b1*fd*k2**2*(r + s)*(b1*(K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(6*K - 3)) - 2*g2*(3*k1**4 + 6*k1**2*k2**2 + k2**4)) + 210*f**3*k1**4*(13*bd1*k2**2*(r + s - 1) + 6*fd*k1**2*(4*r + 4*s - 3)) + 65*f**2*k2**2*(22*bd1*(r + s - 1)*(k1**4*(6*C + 2*K - 7) + k1**2*k2**2*(12*C + 3*K - 8*b1 - 9) + k2**4*(2*C - 1)) + k1**2*(21*fd*(k1**2*(4*C + 2*b1 - 3) + k2**2*(6*C - 3))*(3*r + 3*s - 2) - 44*gd2*(2*k1**2 + 3*k2**2)*(r + s - 1))) - 286*f*k2**2*(20*b1**2*fd*k1**2*k2**2*(2*r + 2*s - 1) - 9*b1*bd1*(r + s - 1)*(K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(6*K - 3)) - 5*b1*fd*(2*r + 2*s - 1)*(k1**4*(6*C + 2*K - 7) + k1**2*k2**2*(12*C + 3*K - 9) + k2**4*(2*C - 1)) + 9*b1*gd2*(3*k1**4 + 6*k1**2*k2**2 + k2**4)*(r + s - 1) + 9*bd1*g2*(3*k1**4 + 6*k1**2*k2**2 + k2**4)*(r + s - 1) + 10*fd*g2*k1**2*(2*k1**2 + 3*k2**2)*(2*r + 2*s - 1))) + Dd*f*(4*r + 4*s - 3)*(1287*b1*k2**2*(b1*(K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(6*K - 3)) - 2*g2*(3*k1**4 + 6*k1**2*k2**2 + k2**4)) + 1260*f**3*k1**6 + 1365*f**2*(k1**4*k2**2*(4*C + 2*b1 - 3) + k1**2*k2**4*(6*C - 3)) - 1430*f*k2**2*(4*b1**2*k1**2*k2**2 + b1*(k1**4*(-6*C - 2*K + 7) - k1**2*k2**2*(12*C + 3*K - 9) + k2**4*(1 - 2*C)) + 4*g2*k1**4 + 6*g2*k1**2*k2**2)))/(45045*d*k2*k3**5) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**2*f*k1*k2**2*st**4*(D1*bd1*f*(6*f + 11)*(r + s - 1) + b1*(D1*fd*(6*f*(3*r + 3*s - 2) + 22*r + 22*s - 11) + Dd*f*(6*f + 11)*(4*r + 4*s - 3)) + 2*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(231*d*k3**3) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**2*f*k1*k2**2*st**4*(-13*D1*bd1*f*(k1**2*(33*K - 33) - k2**2*(-110*K + 30*f + 55))*(r + s - 1) - 2*D1*(150*f**2*fd*k1**2*(4*r + 4*s - 3) + 13*f*(fd*(k1**2*(6*C - 6) + k2**2*(20*C - 15))*(3*r + 3*s - 2) - 11*gd2*(3*k1**2 + 10*k2**2)*(r + s - 1)) - 143*fd*g2*(3*k1**2 + 10*k2**2)*(2*r + 2*s - 1)) - 2*Dd*f*(4*r + 4*s - 3)*(150*f**2*k1**2 + f*k1**2*(78*C - 78) + f*k2**2*(260*C - 195) - 143*g2*(3*k1**2 + 10*k2**2)) + 13*b1*(D1*fd*(k1**2*(33 - 33*K)*(2*r + 2*s - 1) + 5*k2**2*(6*f*(3*r + 3*s - 2) + (11 - 22*K)*(2*r + 2*s - 1))) + Dd*f*(k1**2*(33 - 33*K) + k2**2*(-110*K + 30*f + 55))*(4*r + 4*s - 3)))/(15015*d*k3**5) - 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**2*k1*st**2*(D1*bd1*f**2*(r + s) + b1**2*(D1*fd*(4*f + 9)*(r + s - 1) + Dd*f*(2*f + 9)*(4*r + 4*s - 3)) + b1*f*(D1*bd1*(2*f + 9)*(2*r + 2*s - 1) + 2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)))/(105*d*k3) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**2*k1*(-D1*bd1*f*(r + s)*(20*C*f + 9*b2 - 10*f - 18*g2) + 9*b1**3*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + 9*b1**2*(D1*bd1*f*(3*r + 3*s - 2) - (K - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))) + b1*(-40*C*D1*f*fd*r - 40*C*D1*f*fd*s + 40*C*D1*f*fd - 80*C*Dd*f**2*r - 80*C*Dd*f**2*s + 60*C*Dd*f**2 - 9*D1*b2*fd*r - 9*D1*b2*fd*s + 9*D1*b2*fd - 9*D1*bd1*f*(K - 1)*(2*r + 2*s - 1) - 9*D1*bd2*f*(r + s - 1) + 20*D1*f*fd*r + 20*D1*f*fd*s - 20*D1*f*fd + 18*D1*f*gd2*r + 18*D1*f*gd2*s - 18*D1*f*gd2 + 18*D1*fd*g2*r + 18*D1*fd*g2*s - 18*D1*fd*g2 - 36*Dd*b2*f*r - 36*Dd*b2*f*s + 27*Dd*b2*f + 40*Dd*f**2*r + 40*Dd*f**2*s - 30*Dd*f**2 + 72*Dd*f*g2*r + 72*Dd*f*g2*s - 54*Dd*f*g2))/(315*d*k3) - 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**2*k1*st**2*(33*b1**2*(D1*fd*(k1**2*(3*K - 3)*(r + s - 1) + k2**2*(18*K*(r + s - 1) + 2*f + 9)) + 3*Dd*f*(6*K*k2**2 + k1**2*(K - 1))*(4*r + 4*s - 3)) - b1*(33*D1*bd1*f*(-k1**2*(3*K - 3)*(2*r + 2*s - 1) + k2**2*(9*K*(-4*r - 4*s + 2) + 2*f + 9)) + D1*(90*f**2*fd*k1**2*(5*r + 5*s - 4) - 11*f*(fd*k1**2*(4*C*(r + s - 1) + 14*r + 14*s - 5) + 3*fd*k2**2*(8*C*(r + s - 1) - 6*K*(2*r + 2*s - 1) - 4*r - 4*s + 5) - 18*gd2*(k1**2 + 6*k2**2)*(r + s - 1)) + 198*fd*g2*(k1**2 + 6*k2**2)*(r + s - 1)) + Dd*f*(4*r + 4*s - 3)*(150*f**2*k1**2 - 11*f*(k1**2*(2*C + 7) + k2**2*(12*C - 18*K - 6)) + 198*g2*(k1**2 + 6*k2**2))) - f*(D1*bd1*(30*f**2*k1**2*(5*r + 5*s - 3) - 11*f*k1**2*(r*(2*C + 7) + s*(2*C + 7) - 9) + 33*f*k2**2*(-4*C*s + 6*K*(r + s - 1) + r*(2 - 4*C) + 2*s + 1) + 198*g2*(k1**2 + 6*k2**2)*(r + s)) + 9*D1*(5*f*fd*(k1**2 + k2**2*(2 - 4*C))*(3*r + 3*s - 2) + 22*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) + 22*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + 9*Dd*f*(5*f*(k1**2 + k2**2*(2 - 4*C)) + k2**2*(22*b2 - 44*g2))*(4*r + 4*s - 3)))/(3465*d*k3**3) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**2*k1*(-99*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + 11*b1**2*(D1*(-9*bd1*f*k2**2*(3*r + 3*s - 2) + fd*k1**2*(18*C*(r + s - 1) + 10*f*(8*r + 8*s - 5) + 9*r + 9*s + 18) - 9*fd*k2**2*(-4*C*(r + s - 1) + K*(2*r + 2*s + 1) + 3*r + 3*s - 3)) + Dd*f*(k1**2*(18*C + 40*f + 9) + k2**2*(36*C - 18*K - 27))*(4*r + 4*s - 3)) + 11*b1*(D1*bd1*f*(2*k1**2*(9*C*(2*r + 2*s - 1) + 5*f*(8*r + 8*s - 7) + 9*r + 9*s - 18) + 9*k2**2*(C*(8*r + 8*s - 4) + K*(-4*r - 4*s + 5) - 6*r - 6*s + 3)) + D1*(f*(-10*fd*(k1**2*(K - 3)*(2*r + 2*s - 1) + k2**2*(2*C - 1)*(4*r + 4*s - 1)) + k2**2*(-27*bd2 + 36*gd2)*(r + s - 1)) + 9*fd*k2**2*(-3*b2*(r + s) + g2*(4*r + 4*s + 2))) - Dd*f*(10*f*(k1**2*(K - 3) + k2**2*(4*C - 2)) + k2**2*(27*b2 - 36*g2))*(4*r + 4*s - 3)) + f*(-11*D1*bd1*(10*f*(k1**2*(K - 3)*(r + s - 1) + k2**2*(2*C - 1)*(2*r + 2*s - 3)) + 9*k2**2*(3*b2*(r + s - 1) - 2*g2*(2*r + 2*s - 3))) - 5*k1**2*(126*C*D1*f*fd*r + 126*C*D1*f*fd*s - 84*C*D1*f*fd + 168*C*Dd*f**2*r + 168*C*Dd*f**2*s - 126*C*Dd*f**2 + 22*D1*bd2*f*(r + s - 1) - 63*D1*f*fd*r - 63*D1*f*fd*s + 42*D1*f*fd - 44*D1*f*gd2*r - 44*D1*f*gd2*s + 44*D1*f*gd2 - 88*D1*fd*g2*r - 88*D1*fd*g2*s + 44*D1*fd*g2 - 84*Dd*f**2*r - 84*Dd*f**2*s + 63*Dd*f**2 - 176*Dd*f*g2*r - 176*Dd*f*g2*s + 132*Dd*f*g2 + 22*b2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))))/(3465*d*k3**3) - 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**2*k1*st**2*(13*D1*bd1*f*(r + s - 1)*(60*f**2*k1**2*k2**2 + 11*f*(k1**4*(K - 1) + k1**2*k2**2*(6*C + 18*K - 15) + k2**4*(12*C + 18*K - 12*b1 - 9)) + 594*k2**2*(b1*k1**2*(K - 1) + b1*k2**2*(2*K - 1) - g2*(k1**2 + 2*k2**2))) - 429*b1**2*k2**2*(D1*fd*(2*f*k2**2*(2*r + 2*s - 1) + (r + s)*(-9*k1**2*(K - 1) - 9*k2**2*(2*K - 1))) + Dd*f*(k1**2*(9 - 9*K) + k2**2*(-18*K + 2*f + 9))*(4*r + 4*s - 3)) + 13*b1*(D1*(60*f**2*fd*k1**2*k2**2*(3*r + 3*s - 2) + 11*f*(fd*(2*r + 2*s - 1)*(k1**4*(K - 1) + k1**2*k2**2*(6*C + 18*K - 15) + k2**4*(12*C + 18*K - 9)) - 54*gd2*k2**2*(k1**2 + 2*k2**2)*(r + s - 1)) - 594*fd*g2*k2**2*(k1**2 + 2*k2**2)*(r + s)) + Dd*f*(4*r + 4*s - 3)*(60*f**2*k1**2*k2**2 + 11*f*(k1**4*(K - 1) + k1**2*k2**2*(6*C + 18*K - 15) + k2**4*(12*C + 18*K - 9)) - 594*g2*k2**2*(k1**2 + 2*k2**2))) - f*(D1*(2520*f**2*fd*k1**4*(4*r + 4*s - 3) + 65*f*fd*(3*r + 3*s - 2)*(k1**4*(2*C - 2) + k1**2*k2**2*(36*C - 27) + k2**4*(36*C - 18)) + 286*f*gd2*(k1**4 + 18*k1**2*k2**2 + 18*k2**4)*(r + s - 1) + 286*fd*g2*(k1**4 + 18*k1**2*k2**2 + 18*k2**4)*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(2520*f**2*k1**4 + 65*f*(k1**4*(2*C - 2) + k1**2*k2**2*(36*C - 27) + k2**4*(36*C - 18)) + 286*g2*(k1**4 + 18*k1**2*k2**2 + 18*k2**4))))/(45045*d*k3**5) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**2*k1*(33*b1**2*(D1*fd*(20*f*k1**2*k2**2*(2*r + 2*s - 1) + (r + s)*(-9*K*k2**4 - 3*k1**4*(K - 1) - 3*k1**2*k2**2*(6*K - 3))) + Dd*f*(4*r + 4*s - 3)*(-9*K*k2**4 + k1**4*(3 - 3*K) + k1**2*k2**2*(-18*K + 20*f + 9))) + b1*(-66*D1*bd1*f*(r + s - 1)*(9*K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(18*K - 20*f - 9)) + D1*(-315*f**2*fd*k1**4*(3*r + 3*s - 2) - 22*f*(5*fd*(2*r + 2*s - 1)*(k1**4*(2*C - 2) + k1**2*k2**2*(12*C + K - 9) + k2**4*(6*C - 3)) - 9*gd2*(k1**4 + 6*k1**2*k2**2 + 3*k2**4)*(r + s - 1)) + 198*fd*g2*(r + s)*(k1**4 + 6*k1**2*k2**2 + 3*k2**4)) - Dd*f*(4*r + 4*s - 3)*(315*f**2*k1**4 + 110*f*(k1**4*(2*C - 2) + k1**2*k2**2*(12*C + K - 9) + k2**4*(6*C - 3)) - 198*g2*(k1**4 + 6*k1**2*k2**2 + 3*k2**4))) + f*(-D1*bd1*(r + s - 1)*(315*f**2*k1**4 + 110*f*(k1**4*(2*C - 2) + k1**2*k2**2*(12*C + K - 9) + k2**4*(6*C - 3)) - 198*g2*(k1**4 + 6*k1**2*k2**2 + 3*k2**4)) - 5*k1**2*k2**2*(D1*(f*fd*(42*C - 21)*(3*r + 3*s - 2) - 44*f*gd2*(r + s - 1) - 44*fd*g2*(2*r + 2*s - 1)) + Dd*f*(f*(42*C - 21) - 44*g2)*(4*r + 4*s - 3))))/(3465*d*k3**5) - 14*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct*f**3*k1**2*k2**3*st**6*(D1*fd + Dd*f)*(4*r + 4*s - 3)/(429*d*k3**5) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct*f*k2*st**4*(-60*C*D1*f*fd*k2**2*r - 60*C*D1*f*fd*k2**2*s + 40*C*D1*f*fd*k2**2 - 80*C*Dd*f**2*k2**2*r - 80*C*Dd*f**2*k2**2*s + 60*C*Dd*f**2*k2**2 + D1*b1*fd*(-55*K*k2**2*(2*r + 2*s - 1) + 3*k1**2*(10*f*(4*r + 4*s - 3) + 22*r + 22*s - 11)) - 110*D1*b2*fd*k2**2*r - 110*D1*b2*fd*k2**2*s + 55*D1*b2*fd*k2**2 + D1*bd1*f*(-55*K*k2**2*(r + s - 1) + k1**2*(10*f*(4*r + 4*s - 3) + 33*r + 33*s - 33)) - 55*D1*bd2*f*k2**2*r - 55*D1*bd2*f*k2**2*s + 55*D1*bd2*f*k2**2 + 18*D1*f*fd*k1**2*r + 18*D1*f*fd*k1**2*s - 12*D1*f*fd*k1**2 + 30*D1*f*fd*k2**2*r + 30*D1*f*fd*k2**2*s - 20*D1*f*fd*k2**2 + 110*D1*f*gd2*k2**2*r + 110*D1*f*gd2*k2**2*s - 110*D1*f*gd2*k2**2 + 220*D1*fd*g2*k2**2*r + 220*D1*fd*g2*k2**2*s - 110*D1*fd*g2*k2**2 + Dd*b1*f*(-55*K*k2**2 + k1**2*(40*f + 33))*(4*r + 4*s - 3) - 220*Dd*b2*f*k2**2*r - 220*Dd*b2*f*k2**2*s + 165*Dd*b2*f*k2**2 + 24*Dd*f**2*k1**2*r + 24*Dd*f**2*k1**2*s - 18*Dd*f**2*k1**2 + 40*Dd*f**2*k2**2*r + 40*Dd*f**2*k2**2*s - 30*Dd*f**2*k2**2 + 440*Dd*f*g2*k2**2*r + 440*Dd*f*g2*k2**2*s - 330*Dd*f*g2*k2**2)/(1155*d*k3**3) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct*f*k2*st**4*(D1*(-30*f**2*k1**2*(-13*bd1*k2**2*(r + s - 1) + 5*fd*k1**2*(4*r + 4*s - 3)) - 13*f*k2**2*(11*bd1*(5*K*k2**2 + k1**2*(6*K - 3))*(r + s - 1) - 2*fd*(k1**2*(-12*C + 15*b1 + 9) + k2**2*(5 - 10*C))*(3*r + 3*s - 2) - 22*gd2*(6*k1**2 + 5*k2**2)*(r + s - 1)) - 143*fd*k2**2*(2*r + 2*s - 1)*(5*K*b1*k2**2 + b1*k1**2*(6*K - 3) - 2*g2*(6*k1**2 + 5*k2**2))) - Dd*f*(4*r + 4*s - 3)*(150*f**2*k1**4 - 26*f*(k1**2*k2**2*(-12*C + 15*b1 + 9) + k2**4*(5 - 10*C)) + 143*k2**2*(5*K*b1*k2**2 + b1*k1**2*(6*K - 3) - 2*g2*(6*k1**2 + 5*k2**2))))/(15015*d*k3**5) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct*k1**2*(-D1*b1*(-105*f**2*fd*k1**4*(3*r + 3*s - 2) + 22*f*k2**2*(5*fd*(k1**2*(-4*C + 4*b1 + 3) + k2**2*(3 - 6*C))*(2*r + 2*s - 1) + 9*gd2*(2*k1**2 + 3*k2**2)*(r + s - 1)) - 99*fd*k2**2*(r + s)*(3*K*b1*k2**2 + b1*k1**2*(2*K - 1) - 2*g2*(2*k1**2 + 3*k2**2))) + D1*bd1*f*(r + s - 1)*(105*f**2*k1**4 + 110*f*k2**2*(k1**2*(4*C - 8*b1 - 3) + k2**2*(6*C - 3)) + 198*k2**2*(3*K*b1*k2**2 + b1*k1**2*(2*K - 1) - g2*(2*k1**2 + 3*k2**2))) + Dd*b1*f*(4*r + 4*s - 3)*(105*f**2*k1**4 + 110*f*k2**2*(k1**2*(4*C - 4*b1 - 3) + k2**2*(6*C - 3)) + 99*k2**2*(3*K*b1*k2**2 + b1*k1**2*(2*K - 1) - 2*g2*(2*k1**2 + 3*k2**2))))/(3465*d*k2*k3**5) - 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct*st**2*(D1*bd1*f*(r + s)*(f*(k1**2 + k2**2*(3 - 6*C)) + k2**2*(-27*b2 + 54*g2)) + 3*b1**2*(D1*fd*(-9*K*k2**2 + k1**2*(2*f + 3))*(r + s - 1) + Dd*f*(-9*K*k2**2 + k1**2*(f + 3))*(4*r + 4*s - 3)) + b1*(3*D1*bd1*f*(-9*K*k2**2 + k1**2*(f + 3))*(2*r + 2*s - 1) + D1*(r + s - 1)*(2*f*fd*(k1**2 + k2**2*(3 - 6*C)) - 27*f*k2**2*(bd2 - 2*gd2) - 27*fd*k2**2*(b2 - 2*g2)) + Dd*f*(f*(k1**2 + k2**2*(3 - 6*C)) + k2**2*(-27*b2 + 54*g2))*(4*r + 4*s - 3)))/(315*d*k2*k3) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct*st**2*(D1*bd1*f*(15*f**2*k1**4*(2*r + 2*s - 1) - 11*f*(k1**4*(r + s - 1) + k1**2*k2**2*(4*C*r + 4*C*s - 9*K*(r + s - 1) + 3*b1*(4*r + 4*s - 5) - 3) + k2**4*(6*C - 3)) - 99*k2**2*(3*K*b1*k2**2 + b1*k1**2*(K*(4*r + 4*s - 2) + 4*r + 4*s - 5) - 3*b2*k2**2*(r + s - 1) - 4*g2*k1**2*(r + s) - 6*g2*k2**2)) - 33*b1**2*k2**2*(D1*fd*(-9*K*k2**2 + k1**2*(6*K*(r + s - 1) + f*(4*r + 4*s - 1) + 6*r + 6*s + 3)) + 2*Dd*f*k1**2*(3*K + f + 3)*(4*r + 4*s - 3)) + b1*(D1*(15*f**2*fd*k1**4*(6*r + 6*s - 5) - 11*f*(fd*(k1**4*(2*r + 2*s - 1) + k1**2*k2**2*(8*C*(r + s - 1) - 9*K*(2*r + 2*s - 1) + 3) + k2**4*(3 - 6*C)) - 9*k2**2*(3*bd2*k2**2 + 4*gd2*k1**2)*(r + s - 1)) + 99*fd*k2**2*(3*b2*k2**2*(r + s) + 4*g2*k1**2*(r + s - 1) - 6*g2*k2**2)) + Dd*f*(4*r + 4*s - 3)*(297*b2*k2**4 + 30*f**2*k1**4 - 11*f*(k1**4 + k1**2*k2**2*(4*C - 9*K)) + 396*g2*k1**2*k2**2)) + f*k1**2*(D1*(5*f*fd*(k1**2 + k2**2*(9 - 18*C))*(3*r + 3*s - 2) + 99*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) + 99*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + Dd*f*(5*f*(k1**2 + k2**2*(9 - 18*C)) + k2**2*(99*b2 - 198*g2))*(4*r + 4*s - 3)))/(3465*d*k2*k3**3) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct*(D1*bd1*f*k1**2*(10*f*(k1**2 + k2**2*(3 - 6*C)) + k2**2*(-27*b2 + 54*g2))*(r + s - 1) - 18*b1**3*k1**2*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1**2*(D1*(2*f*k1**2*(-9*bd1*k2**2*(3*r + 3*s - 2) + 5*fd*k1**2*(4*r + 4*s - 3)) + 9*fd*(k1**4*(r + s) + k1**2*k2**2*(4*C*(r + s - 1) - 3*K*r - 3*K*s - 3*r - 3*s + 3) + k2**4*(2*C - 1)*(r + s - 1))) + Dd*f*(4*r + 4*s - 3)*(k1**4*(20*f + 9) + k1**2*k2**2*(36*C - 27*K - 27) + k2**4*(18*C - 9))) + b1*(D1*bd1*f*(2*k1**4*(5*f*(4*r + 4*s - 3) + 9*r + 9*s - 9) + 9*k1**2*k2**2*(C*(8*r + 8*s - 4) - 6*K*(r + s - 1) - 6*r - 6*s + 3) + k2**4*(18*C - 9)*(2*r + 2*s - 1)) + k1**2*(D1*(10*f*fd*(k1**2 + k2**2*(3 - 6*C))*(2*r + 2*s - 1) - 27*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) - 27*fd*k2**2*(b2 - 2*g2)*(r + s)) + Dd*f*(10*f*(k1**2 + k2**2*(3 - 6*C)) + k2**2*(-27*b2 + 54*g2))*(4*r + 4*s - 3))))/(315*d*k2*k3**3) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct*st**2*(D1*(-3861*b1*fd*k2**4*(r + s)*(K*b1*k2**2 + b1*k1**2*(2*K - 1) - 2*g2*(2*k1**2 + k2**2)) + 15*f**3*k1**4*(26*bd1*k2**2*(r + s - 1) + 21*fd*k1**2*(4*r + 4*s - 3)) - 13*f**2*k2**2*(11*bd1*(r + s - 1)*(k1**4*(2*K - 1) - k1**2*k2**2*(-12*C - 9*K + 24*b1 + 9) + k2**4*(6*C - 3)) - k1**2*(5*fd*(k1**2*(4*C + 6*b1 - 3) + k2**2*(18*C - 9))*(3*r + 3*s - 2) + 22*gd2*(2*k1**2 + 9*k2**2)*(r + s - 1))) + 143*f*k2**2*(12*b1**2*fd*k1**2*k2**2*(2*r + 2*s - 1) - b1*fd*(2*r + 2*s - 1)*(k1**4*(2*K - 1) + k1**2*k2**2*(12*C + 9*K - 9) + k2**4*(6*C - 3)) - 54*b1*k2**2*(r + s - 1)*(K*bd1*k2**2 + bd1*k1**2*(2*K - 1) - gd2*(2*k1**2 + k2**2)) + 54*bd1*g2*k2**2*(2*k1**2 + k2**2)*(r + s - 1) + 2*fd*g2*k1**2*(2*k1**2 + 9*k2**2)*(2*r + 2*s - 1))) + Dd*f*(4*r + 4*s - 3)*(-3861*b1*k2**4*(K*b1*k2**2 + b1*k1**2*(2*K - 1) - 2*g2*(2*k1**2 + k2**2)) + 315*f**3*k1**6 + 65*f**2*(k1**4*k2**2*(4*C + 6*b1 - 3) + k1**2*k2**4*(18*C - 9)) + 143*f*k2**2*(12*b1**2*k1**2*k2**2 + b1*(k1**4*(1 - 2*K) - k1**2*k2**2*(12*C + 9*K - 9) + k2**4*(3 - 6*C)) + 2*g2*k1**2*(2*k1**2 + 9*k2**2))))/(45045*d*k2*k3**5) - 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*f**2*k1*k2**2*st**6*(D1*b1*fd*(3*r + 3*s - 2) + D1*bd1*f*(r + s - 1) + Dd*b1*f*(4*r + 4*s - 3))/(77*d*k3**3) - 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*f**2*k1*k2**2*st**6*(D1*(-39*b1*fd*k2**2*(3*r + 3*s - 2) - 39*bd1*f*k2**2*(r + s - 1) + 28*f*fd*k1**2*(4*r + 4*s - 3)) + Dd*f*(-39*b1*k2**2 + 28*f*k1**2)*(4*r + 4*s - 3))/(3003*d*k3**5) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*f*k1*st**4*(11*D1*b1**2*fd*k2**2 + D1*bd1*f*(2*f*k1**2*(5*r + 5*s - 3) - 11*k2**2*(3*K*(r + s - 1) + b1)) + b1*(-33*D1*K*fd*k2**2*(2*r + 2*s - 1) + 6*D1*f*fd*k1**2*(5*r + 5*s - 4) + Dd*f*(-33*K*k2**2 + 10*f*k1**2)*(4*r + 4*s - 3)) - 3*k2**2*(11*D1*bd2*f*(r + s - 1) + 2*D1*(f*fd*(2*C - 1)*(3*r + 3*s - 2) - 11*f*gd2*(r + s - 1) - 11*fd*g2*(2*r + 2*s - 1)) + 2*Dd*f*(f*(2*C - 1) - 11*g2)*(4*r + 4*s - 3) + 11*b2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))))/(1155*d*k3**3) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*f*k1*st**4*(D1*(4*f**2*k1**2*(-13*bd1*k2**2*(r + s - 1) + 5*fd*k1**2*(4*r + 4*s - 3)) - 13*f*k2**2*(22*b1*bd1*k2**2*(r + s - 1) + 4*b1*fd*k1**2*(3*r + 3*s - 2) - fd*k2**2*(12*C - 6)*(3*r + 3*s - 2) + k2**2*(-33*K*bd1 + 66*gd2)*(r + s - 1)) - 143*fd*k2**4*(2*r + 2*s - 1)*(-3*K*b1 + b1**2 + 6*g2)) + Dd*f*(4*r + 4*s - 3)*(20*f**2*k1**4 - 26*f*(2*b1*k1**2*k2**2 + k2**4*(3 - 6*C)) - k2**4*(-429*K*b1 + 143*b1**2 + 858*g2)))/(15015*d*k3**5) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*k1**3*(-2*D1*bd1*f*k2**2*(f*(10*C - 5) - 9*g2)*(r + s - 1) + b1**2*(D1*fd*(-9*K*k2**2*(r + s) + 10*f*k1**2*(2*r + 2*s - 1)) + Dd*f*(-9*K*k2**2 + 10*f*k1**2)*(4*r + 4*s - 3)) + 2*b1*(D1*bd1*f*(-9*K*k2**2 + 10*f*k1**2)*(r + s - 1) + k2**2*(D1*(-f*fd*(10*C - 5)*(2*r + 2*s - 1) + 9*f*gd2*(r + s - 1) + 9*fd*g2*(r + s)) - Dd*f*(f*(10*C - 5) - 9*g2)*(4*r + 4*s - 3))))/(315*d*k3**5) - 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*k1*st**2*(-D1*bd1*f*(r + s)*(9*b2 + f*(2*C - 1) - 18*g2) + 9*b1**3*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + 9*b1**2*(D1*bd1*f*(3*r + 3*s - 2) - K*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))) + b1*(-4*C*D1*f*fd*r - 4*C*D1*f*fd*s + 4*C*D1*f*fd - 8*C*Dd*f**2*r - 8*C*Dd*f**2*s + 6*C*Dd*f**2 - 18*D1*K*bd1*f*r - 18*D1*K*bd1*f*s + 9*D1*K*bd1*f - 9*D1*bd2*f*(r + s - 1) + 2*D1*f*fd*r + 2*D1*f*fd*s - 2*D1*f*fd + 18*D1*f*gd2*r + 18*D1*f*gd2*s - 18*D1*f*gd2 + 18*D1*fd*g2*r + 18*D1*fd*g2*s - 18*D1*fd*g2 + 4*Dd*f**2*r + 4*Dd*f**2*s - 3*Dd*f**2 + 72*Dd*f*g2*r + 72*Dd*f*g2*s - 54*Dd*f*g2 - 9*b2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))))/(315*d*k3) - 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*k1*st**2*(-99*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + 11*b1**2*(D1*(-9*K*fd*k2**2*(2*r + 2*s + 1) - 9*bd1*f*k2**2*(3*r + 3*s - 2) + f*fd*k1**2*(8*r + 8*s - 5)) + 2*Dd*f*(-9*K*k2**2 + 2*f*k1**2)*(4*r + 4*s - 3)) + 11*b1*(D1*bd1*f*(-9*K*k2**2*(4*r + 4*s - 5) + f*k1**2*(8*r + 8*s - 7)) + D1*(f*(-fd*(K*k1**2*(2*r + 2*s - 1) + k2**2*(2*C - 1)*(4*r + 4*s - 1)) + k2**2*(-27*bd2 + 36*gd2)*(r + s - 1)) + 9*fd*k2**2*(-3*b2*(r + s) + g2*(4*r + 4*s + 2))) - Dd*f*(4*r + 4*s - 3)*(K*f*k1**2 + f*k2**2*(4*C - 2) + k2**2*(27*b2 - 36*g2))) + f*(-44*C*D1*bd1*f*k2**2*r - 44*C*D1*bd1*f*k2**2*s + 66*C*D1*bd1*f*k2**2 + 30*C*D1*f*fd*k1**2*r + 30*C*D1*f*fd*k1**2*s - 20*C*D1*f*fd*k1**2 + 40*C*Dd*f**2*k1**2*r + 40*C*Dd*f**2*k1**2*s - 30*C*Dd*f**2*k1**2 - 11*D1*K*bd1*f*k1**2*r - 11*D1*K*bd1*f*k1**2*s + 11*D1*K*bd1*f*k1**2 + 22*D1*bd1*f*k2**2*r + 22*D1*bd1*f*k2**2*s - 33*D1*bd1*f*k2**2 + 396*D1*bd1*g2*k2**2*r + 396*D1*bd1*g2*k2**2*s - 594*D1*bd1*g2*k2**2 - 11*D1*bd2*f*k1**2*(r + s - 1) - 15*D1*f*fd*k1**2*r - 15*D1*f*fd*k1**2*s + 10*D1*f*fd*k1**2 + 22*D1*f*gd2*k1**2*r + 22*D1*f*gd2*k1**2*s - 22*D1*f*gd2*k1**2 + 44*D1*fd*g2*k1**2*r + 44*D1*fd*g2*k1**2*s - 22*D1*fd*g2*k1**2 - 20*Dd*f**2*k1**2*r - 20*Dd*f**2*k1**2*s + 15*Dd*f**2*k1**2 + 88*Dd*f*g2*k1**2*r + 88*Dd*f*g2*k1**2*s - 66*Dd*f*g2*k1**2 - 11*b2*(27*D1*bd1*k2**2*(r + s - 1) + D1*fd*k1**2*(2*r + 2*s - 1) + Dd*f*k1**2*(4*r + 4*s - 3))))/(3465*d*k3**3) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*k1*(D1*bd1*f*k1**2*(r + s - 1)*(20*C*f + 9*b2 - 10*f - 18*g2) + 9*b1**3*k1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + 9*b1**2*(D1*bd1*f*k1**2*(3*r + 3*s - 2) + D1*fd*(K*k1**2*(r + s) - k2**2*(2*C - 1)*(r + s - 1)) + Dd*f*(K*k1**2 + k2**2*(1 - 2*C))*(4*r + 4*s - 3)) + b1*(-36*C*D1*bd1*f*k2**2*r - 36*C*D1*bd1*f*k2**2*s + 18*C*D1*bd1*f*k2**2 + 40*C*D1*f*fd*k1**2*r + 40*C*D1*f*fd*k1**2*s - 20*C*D1*f*fd*k1**2 + 80*C*Dd*f**2*k1**2*r + 80*C*Dd*f**2*k1**2*s - 60*C*Dd*f**2*k1**2 + 18*D1*K*bd1*f*k1**2*r + 18*D1*K*bd1*f*k1**2*s - 18*D1*K*bd1*f*k1**2 + 18*D1*bd1*f*k2**2*r + 18*D1*bd1*f*k2**2*s - 9*D1*bd1*f*k2**2 + 9*D1*bd2*f*k1**2*(r + s - 1) - 20*D1*f*fd*k1**2*r - 20*D1*f*fd*k1**2*s + 10*D1*f*fd*k1**2 - 18*D1*f*gd2*k1**2*r - 18*D1*f*gd2*k1**2*s + 18*D1*f*gd2*k1**2 - 18*D1*fd*g2*k1**2*r - 18*D1*fd*g2*k1**2*s - 40*Dd*f**2*k1**2*r - 40*Dd*f**2*k1**2*s + 30*Dd*f**2*k1**2 - 72*Dd*f*g2*k1**2*r - 72*Dd*f*g2*k1**2*s + 54*Dd*f*g2*k1**2 + 9*b2*k1**2*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3))))/(315*d*k3**3) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*k1*st**2*(D1*bd1*f*(r + s - 1)*(15*f**2*k1**4 - 11*f*k2**2*(K*k1**2 - 12*b1*k1**2 + k2**2*(6*C - 3)) + k2**4*(-594*K*b1 + 594*g2)) - 33*b1**2*k2**2*(D1*fd*(9*K*k2**2*(r + s) - 2*f*k1**2*(2*r + 2*s - 1)) - Dd*f*(-9*K*k2**2 + 2*f*k1**2)*(4*r + 4*s - 3)) + b1*(D1*(15*f**2*fd*k1**4*(3*r + 3*s - 2) - 11*f*fd*k2**2*(K*k1**2 + k2**2*(6*C - 3))*(2*r + 2*s - 1) + 594*f*gd2*k2**4*(r + s - 1) + 594*fd*g2*k2**4*(r + s)) + Dd*f*(4*r + 4*s - 3)*(15*f**2*k1**4 - 11*f*(K*k1**2*k2**2 + k2**4*(6*C - 3)) + 594*g2*k2**4)) + f*k1**2*k2**2*(D1*(f*fd*(10*C - 5)*(3*r + 3*s - 2) + 22*f*gd2*(r + s - 1) + 22*fd*g2*(2*r + 2*s - 1)) + Dd*f*(f*(10*C - 5) + 22*g2)*(4*r + 4*s - 3)))/(3465*d*k3**5) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*b1*f*k1*st**4*(4*Pk2 - Pkd2*k2)*(D1*b1*fd*(2*s - 1) + 2*D1*bd1*f*s + Dd*b1*f*(4*s - 1))/(105*d*k2**2) + 8*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**7*f*k1**2*k2*(-4*Pk2 + Pkd2*k2)*(D1*(126*f**2*fd*(4*s - 1) + f*fd*(273*C - 273)*(3*s - 1) - 143*f*s*(-K*bd1 + bd1 + 2*gd2) + 286*fd*g2*(1 - 2*s)) + Dd*f*(4*s - 1)*(126*f**2 + f*(273*C - 273) - 286*g2) + 143*b1*(K - 1)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)))/(9009*d*k3**4) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**6*f*k1*(4*Pk2 - Pkd2*k2)*(b1*(D1*fd*(63*f*s - 21*f + 44*s - 22) + Dd*f*(21*f + 22)*(4*s - 1)) + f*(D1*bd1*s*(21*f + 22) + 21*D1*fd*(3*s - 1) + 21*Dd*f*(4*s - 1)))/(693*d*k3**2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**6*f*k1*(D1*(21*f**2*(13*bd1*k2**2*(2*Pk2*(r - 1) + Pkd2*k2*s) + 4*fd*(13*Pk2*k2**2*(1 - 2*r) + 9*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 13*f*(-22*bd1*(-Pk2*k1**2*s*(8*K - 8) + 2*Pk2*k2**2*(K*(r - 2*s - 1) - 2*r + 2) + Pkd2*k1**2*k2*s*(2*K - 2) + Pkd2*k2**3*s*(2*K - 1)) + fd*(k1**2*(84*C - 84)*(4*Pk2 - Pkd2*k2)*(3*s - 1) - k2**2*(Pk2*(8*C*(33*r - 63*s + 10) - 390*r + 252*s + 46) + Pkd2*k2*(84*C - 63)*(3*s - 1))) + 88*gd2*(-4*Pk2*k1**2*s + Pk2*k2**2*(r - 2*s - 1) + Pkd2*k1**2*k2*s + Pkd2*k2**3*s)) - 1144*fd*g2*(k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(-2*Pk2*(r - 2*s + 1) + Pkd2*k2*(1 - 2*s)))) + Dd*f*(84*f**2*(13*Pk2*k2**2*(1 - 2*r) + 9*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 13*f*(k1**2*(84*C - 84)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(-8*Pk2*(C*(44*r - 84*s - 1) - 65*r + 42*s + 22) + Pkd2*k2*(63 - 84*C)*(4*s - 1))) - 1144*g2*(k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(-4*Pk2*r + 8*Pk2*s - 4*Pkd2*k2*s + Pkd2*k2))) + 13*b1*(D1*fd*(k1**2*(44*K - 44)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(-88*K*Pk2*(r - 2*s + 1) - 44*K*Pkd2*k2*(2*s - 1) + 176*Pk2*r + 44*Pkd2*k2*s - 22*Pkd2*k2 + 21*f*(Pk2*(6*r - 2) + Pkd2*k2*(3*s - 1)))) + Dd*f*(k1**2*(44*K - 44)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(84*Pk2*f*(2*r - 1) - 176*Pk2*(-2*K*s + r*(K - 2) + 1) + Pkd2*k2*(4*s - 1)*(-44*K + 21*f + 22)))))/(9009*d*k3**4) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**5*f*k1**2*k2*st**2*(-4*Pk2 + Pkd2*k2)*(D1*(441*f**2*fd*(4*s - 1) + f*fd*(260*C - 260)*(3*s - 1) + 286*f*s*(-K*bd1 + bd1 + 2*gd2) + 572*fd*g2*(2*s - 1)) + Dd*f*(4*s - 1)*(441*f**2 + f*(260*C - 260) + 572*g2) - 286*b1*(K - 1)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)))/(9009*d*k3**4) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**5*(99*b1**2*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(D1*fd*(s - 1) + Dd*f*(4*s - 1)) + b1*(220*C*f*k1**2*(4*Pk2 - Pkd2*k2)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) + D1*(5*f**2*fd*(22*Pk2*k2**2*(1 - 3*r) + 63*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) + 22*f*(5*fd*k2**2*(-K*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 2*Pk2*r) + k1**2*s*(4*Pk2 - Pkd2*k2)*(9*K*bd1 - 9*bd1 - 9*gd2)) - 198*fd*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) + Dd*f*(5*f**2*(44*Pk2*k2**2*(1 - 2*r) + 63*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 110*f*k2**2*(K*Pkd2*k2*(4*s - 1) + Pk2*(-8*K*s + 2*K - 4*r + 2)) - 198*g2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + f*(D1*(110*b2*fd*k2**2*(-2*Pk2 + Pkd2*k2)*(2*s - 1) - 5*bd1*f**2*(-252*Pk2*k1**2*s + 22*Pk2*k2**2*(r - 1) + 63*Pkd2*k1**2*k2*s) + 198*bd1*g2*k1**2*s*(-4*Pk2 + Pkd2*k2) + 5*f*(22*bd1*(8*C*Pk2*k1**2*s - 2*C*Pkd2*k1**2*k2*s + K*Pkd2*k2**3*s - Pk2*k2**2*(2*K*s + r - 1)) + 42*fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + fd*k2**2*(Pk2*(-252*C*s + 84*C - 69*r + 126*s - 19) + Pkd2*k2*(42*C - 21)*(3*s - 1)) + k2**2*s*(-2*Pk2 + Pkd2*k2)*(22*bd2 - 44*gd2)) - 220*fd*g2*k2**2*(-2*Pk2 + Pkd2*k2)*(2*s - 1)) + 5*Dd*f*(42*f*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + f*k2**2*(Pk2*(-84*C*(4*s - 1) - 92*r + 168*s + 4) + Pkd2*k2*(42*C - 21)*(4*s - 1)) + k2**2*(-2*Pk2 + Pkd2*k2)*(22*b2 - 44*g2)*(4*s - 1))))/(3465*d*k2*k3**2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**5*(1287*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(2*Pk2*(r + 2*s - 1) - Pkd2*k2*s) + Dd*f*(8*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 4*s))) + 13*b1*(D1*(5*f**2*fd*k2**2*(22*Pk2*k2**2*(3*r - 1) + 63*k1**2*(4*Pk2*(2*r + s - 1) + Pkd2*k2*(2*s - 1))) + 11*f*(2*fd*(k1**4*(5*K - 5)*(4*Pk2 - Pkd2*k2)*(2*s - 1) - 2*k1**2*k2**2*(Pk2*(-20*C*(r + 2*s - 1) + K*(29*r - 12*s + 6) - 39*r + 2*s - 1) + 5*Pkd2*k2*(K*(4*s - 2) + s*(2*C - 4) + 1)) - 5*k2**4*(K*Pk2*(8*r + 4*s - 2) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r)) - 9*k1**2*k2**2*(4*Pk2*gd2*(r + 2*s - 1) - 2*Pkd2*gd2*k2*s - bd1*(K - 1)*(4*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 2*s)))) + 198*fd*g2*k1**2*k2**2*(-2*Pk2*(r + 2*s - 1) + Pkd2*k2*s)) + 2*Dd*f*(5*f**2*k2**2*(22*Pk2*k2**2*(2*r - 1) + 21*k1**2*(2*Pk2*(8*r + 4*s - 5) + Pkd2*k2*(4*s - 1))) + 11*f*(k1**4*(5*K - 5)*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 2*k1**2*k2**2*(Pk2*(-40*C*(r + 2*s - 1) + K*(58*r - 24*s - 23) - 78*r + 4*s + 38) + Pkd2*k2*(4*s - 1)*(5*C + 10*K - 10)) - 5*k2**4*(K*Pkd2*k2*(4*s - 1) + 2*Pk2*(K*(8*r + 4*s - 5) - 2*r + 1))) + 99*g2*k1**2*k2**2*(-8*Pk2*(r + 2*s - 1) + Pkd2*k2*(4*s - 1)))) + f*(D1*(-2574*bd1*g2*k1**2*k2**2*(2*Pk2*(r + 2*s - 1) - Pkd2*k2*(s - 1)) + 5*f**2*(286*Pk2*bd1*k2**4*(r - 1) - 3276*Pk2*fd*k1**2*k2**2*(3*r + 2*s - 2) + 273*bd1*k1**2*k2**2*(4*Pk2*(2*r + s - 2) + Pkd2*k2*(2*s + 1)) + 756*fd*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 13*f*(-220*Pk2*bd2*k2**4*(r + s - 1) - 22*bd1*(k1**4*s*(5 - 5*K)*(4*Pk2 - Pkd2*k2) + k1**2*k2**2*(Pk2*(-20*C*(r + 2*s - 1) + K*(29*r - 12*s - 29) - 39*r + 2*s + 39) + 10*Pkd2*k2*(C*(s - 1) + s*(2*K - 2) + 1)) + 5*k2**4*(2*K*Pk2*(2*r + s - 2) + K*Pkd2*k2*s - Pk2*r + Pk2)) + 5*fd*(k1**4*(42*C - 42)*(4*Pk2 - Pkd2*k2)*(3*s - 1) - 2*k1**2*k2**2*(Pk2*(2*C*(198*r - 57*s - 47) - 585*r - 201*s + 262) + Pkd2*k2*(84*C - 63)*(3*s - 1)) + k2**4*(-4*C*Pk2*(132*r + 63*s - 65) + 9*Pk2*(37*r + 14*s - 17) + Pkd2*k2*(21 - 42*C)*(3*s - 1))) + 44*gd2*(5*k1**4*s*(-4*Pk2 + Pkd2*k2) + k1**2*k2**2*(Pk2*(29*r - 12*s - 29) + 20*Pkd2*k2*s) + 5*k2**4*(2*Pk2*(2*r + s - 2) + Pkd2*k2*s))) - 572*fd*(5*Pk2*b2*k2**4*(2*r + 2*s - 1) + g2*(5*k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1) - 2*k1**2*k2**2*(Pk2*(29*r - 12*s + 6) + 10*Pkd2*k2*(2*s - 1)) - 5*k2**4*(Pk2*(8*r + 4*s - 2) + Pkd2*k2*(2*s - 1))))) + Dd*f*(-2860*Pk2*b2*k2**4*(4*r + 4*s - 3) + 1260*f**2*k1**2*(-13*Pk2*k2**2*(3*r + 2*s - 2) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 65*f*(k1**4*(42*C - 42)*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 2*k1**2*k2**2*(Pk2*(2*C*(264*r - 76*s - 113) - 780*r - 268*s + 457) + Pkd2*k2*(84*C - 63)*(4*s - 1)) + k2**4*(-4*Pk2*(C*(176*r + 84*s - 109) - 111*r - 42*s + 66) + Pkd2*k2*(21 - 42*C)*(4*s - 1))) - 572*g2*(5*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 2*k1**2*k2**2*(Pk2*(-58*r + 24*s + 23) + 10*Pkd2*k2*(1 - 4*s)) + 5*k2**4*(-2*Pk2*(8*r + 4*s - 5) + Pkd2*k2*(1 - 4*s))))))/(45045*d*k2*k3**4) - 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**4*f*k1*st**2*(4*Pk2 - Pkd2*k2)*(b1*(D1*fd*(45*f*s - 15*f - 44*s + 22) + Dd*f*(15*f - 22)*(4*s - 1)) + f*(D1*bd1*s*(15*f - 22) + 10*D1*fd*(3*s - 1) + 10*Dd*f*(4*s - 1)))/(693*d*k3**2) - 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**4*f*k1*st**2*(D1*(75*f**2*(13*bd1*k2**2*(2*Pk2*(r - 1) + Pkd2*k2*s) + fd*(52*Pk2*k2**2*(1 - 2*r) + 63*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 26*f*(11*bd1*(-Pk2*k1**2*s*(24*K - 24) + 10*Pk2*k2**2*(K*(r - 2*s - 1) - 2*r + 2) + Pkd2*k1**2*k2*s*(6*K - 6) + Pkd2*k2**3*s*(10*K - 5)) + fd*k1**2*(60*C - 60)*(4*Pk2 - Pkd2*k2)*(3*s - 1) + fd*k2**2*(2*Pk2*(2*C*(69*r + 150*s - 73) - 63*r - 150*s + 71) + Pkd2*k2*(75 - 100*C)*(3*s - 1)) - 44*gd2*(-12*Pk2*k1**2*s + 5*Pk2*k2**2*(r - 2*s - 1) + 3*Pkd2*k1**2*k2*s + 5*Pkd2*k2**3*s)) + 1144*fd*g2*(3*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) - 5*k2**2*(2*Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1)))) + Dd*f*(75*f**2*(52*Pk2*k2**2*(1 - 2*r) + 63*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 26*f*(k1**2*(60*C - 60)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(8*Pk2*(2*C*(23*r + 50*s - 24) - 21*r - 50*s + 23) + Pkd2*k2*(75 - 100*C)*(4*s - 1))) + 1144*g2*(3*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 5*k2**2*(-4*Pk2*r + 8*Pk2*s - 4*Pkd2*k2*s + Pkd2*k2))) + 13*b1*(D1*fd*(k1**2*(132 - 132*K)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 5*k2**2*(88*K*Pk2*(r - 2*s + 1) + 44*K*Pkd2*k2*(2*s - 1) - 176*Pk2*r - 44*Pkd2*k2*s + 22*Pkd2*k2 + 15*f*(Pk2*(6*r - 2) + Pkd2*k2*(3*s - 1)))) + Dd*f*(k1**2*(132 - 132*K)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 5*k2**2*(60*Pk2*f*(2*r - 1) + 176*Pk2*(-2*K*s + r*(K - 2) + 1) + Pkd2*k2*(4*s - 1)*(44*K + 15*f - 22)))))/(45045*d*k3**4) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**4*k1*(-4*Pk2 + Pkd2*k2)*(10*D1*bd1*f**2*s + b1**2*(D1*fd*(20*f*s - 10*f + 9*s - 9) + Dd*f*(10*f + 9)*(4*s - 1)) + 2*b1*f*(D1*bd1*s*(10*f + 9) + 5*D1*fd*(2*s - 1) + 5*Dd*f*(4*s - 1)))/(315*d*k2**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**4*(11*b1**2*k1**2*k2**2*(D1*fd*(-2*Pk2*(-9*K*(r - 2*s + 2) + 10*f + 9*r + 9) + Pkd2*k2*(18*K*(s - 1) + 10*f + 9)) + 18*Dd*f*(K*Pkd2*k2*(4*s - 1) + Pk2*(-8*K*s + r*(4*K - 4) + 2))) + b1*k1**2*(D1*(-10*f**2*(-11*Pk2*fd*k2**2*(18*r + 15*s - 13) + 11*bd1*k2**2*(-2*Pk2 + Pkd2*k2) + 21*fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) - 22*f*fd*(5*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) - k2**2*(Pk2*(C*(36*r - 80*s + 22) + 40*K*s - 20*K + 2*r + 86*s - 35) + 5*Pkd2*k2*(C*(8*s - 4) - 4*K*s + 2*K - 4*s + 3))) + 99*f*k2**2*(Pk2*bd1*(K*(4*r - 8*s - 2) - 4*r + 4) + Pkd2*bd1*k2*(4*K*s - 1) + 4*gd2*(-Pk2*r + 2*Pk2*s + Pk2 - Pkd2*k2*s)) - 396*fd*g2*k2**2*(Pk2*(r - 2*s + 2) + Pkd2*k2*(s - 1))) - 2*Dd*f*(5*f**2*(-11*Pk2*k2**2*(24*r + 20*s - 17) + 21*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 11*f*(5*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) - k2**2*(Pk2*(4*C*(18*r - 40*s + 1) + 80*K*s - 20*K + 4*r + 172*s - 45) + Pkd2*k2*(4*s - 1)*(20*C - 10*K - 10))) + 198*g2*k2**2*(4*Pk2*(r - 2*s) + Pkd2*k2*(4*s - 1)))) + f*(D1*(10*bd1*f**2*k1**2*(-84*Pk2*k1**2*s + 11*Pk2*k2**2*(6*r + 5*s - 4) + 21*Pkd2*k1**2*k2*s) + f*(-5*fd*(Pk2*k2**4*(4*C - 2)*(3*r - 1) + 21*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k1**2*k2**2*(Pk2*(-504*C*s + 168*C - 270*r - 75*s + 115) + Pkd2*k2*(84*C - 42)*(3*s - 1))) + 22*k1**2*(bd1*(-20*Pk2*k1**2*s + Pk2*k2**2*(18*C*r + r + s*(-40*C + 20*K + 43) - 9) + 5*Pkd2*k1**2*k2*s + 5*Pkd2*k2**3*(4*C*s - s*(2*K + 2) - 1)) + k2**2*s*(-2*Pk2 + Pkd2*k2)*(-10*bd2 + 20*gd2))) - 44*k1**2*k2**2*(-5*b2*fd*(2*Pk2 - Pkd2*k2)*(2*s - 1) + 9*bd1*g2*(Pk2*(r - 2*s) + Pkd2*k2*s) + 10*fd*g2*(2*Pk2 - Pkd2*k2)*(2*s - 1))) - 5*Dd*f*(f*(Pk2*k2**4*(8*C - 4)*(2*r - 1) + 21*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(-168*C*Pk2*(4*s - 1) - 5*Pk2*(72*r + 20*s - 41) + Pkd2*k2*(84*C - 42)*(4*s - 1))) + k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(44*b2 - 88*g2)*(4*s - 1))))/(3465*d*k1*k2**2*k3**2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**4*(D1*(-1287*b1*fd*k1**2*k2**2*(-b1*(k1**2*(2*K - 2)*(Pk2*(r + 3*s - 1) - Pkd2*k2*s) + k2**2*(2*Pk2*(K*(r + 2*s - 2) + r + 1) + Pkd2*k2*s*(1 - 2*K))) + 4*g2*(k1**2*(Pk2*(r + 3*s - 1) - Pkd2*k2*s) + k2**2*(Pk2*(r + 2*s - 2) - Pkd2*k2*s))) + 5*f**3*k1**2*(286*Pk2*bd1*k2**4*(4*r + 5*s - 6) - 819*Pk2*fd*k1**2*k2**2*(16*r + 20*s - 13) + 273*bd1*k1**2*k2**2*(2*Pk2*(5*r + 5*s - 6) + 3*Pkd2*k2) + 252*fd*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 13*f**2*k2**2*(-22*bd1*(k1**4*(Pk2*(20*C*(r + 3*s - 2) + K*(-19*r - 27*s + 19) + 29*r + 7*s - 9) - 5*Pkd2*k2*(4*C*(s - 1) + s*(2*K - 5) + 4)) + k1**2*k2**2*(Pk2*(22*C*r + 40*C*s + K*(-68*r - 76*s + 68) - 10*b1 + 17*r + 3*s - 29) - 5*Pkd2*k2*(4*C*(s - 1) + 2*K*s - 2*b1*s + b1 - 3*s + 3))) - 5*fd*(2*Pk2*k2**4*(C*(2 - 6*r) + 3*r - 1) + k1**4*(2*Pk2*(-44*C*(6*r + 9*s - 5) + 63*b1*(5*r + 5*s - 3) + 453*r + 648*s - 367) - 21*Pkd2*k2*(3*b1 + (4*C - 3)*(3*s - 1))) + k1**2*k2**2*(Pk2*(-4*C*(459*r + 516*s - 325) + 22*b1*(12*r + 15*s - 7) + 1188*r + 1359*s - 849) + Pkd2*k2*(42 - 84*C)*(3*s - 1))) - 44*k1**2*(-15*Pk2*bd2*k2**2*(r + s - 1) + gd2*k1**2*(Pk2*(19*r + 27*s - 19) + 10*Pkd2*k2*s) + 2*gd2*k2**2*(Pk2*(34*r + 38*s - 34) + 5*Pkd2*k2*s))) + 143*f*k1**2*k2**2*(20*b1**2*fd*k2**2*(Pk2 + Pkd2*k2*s) + b1*(9*bd1*(k1**2*(2*K - 2)*(Pk2*(2*r + 6*s - 3) + Pkd2*k2*(1 - 2*s)) + k2**2*(Pk2*(K*(4*r + 8*s - 2) + 4*r - 4) + Pkd2*k2*(K*(2 - 4*s) + 2*s - 1))) + 2*fd*(k1**2*(Pk2*(40*C*(r + 3*s - 1) + K*(-38*r - 54*s + 27) + 58*r + 14*s - 27) - 5*Pkd2*k2*(K*(4*s - 2) + s*(8*C - 10) + 1)) + k2**2*(Pk2*(C*(44*r + 80*s - 62) - 4*K*(34*r + 38*s - 19) + 34*r + 6*s + 9) + 10*Pkd2*k2*(-2*K*s + K + s*(3 - 4*C)))) + 36*gd2*(k1**2*(-Pk2*(r + 3*s - 1) + Pkd2*k2*s) + k2**2*(-Pk2*(r + 2*s - 1) + Pkd2*k2*s))) - 36*bd1*g2*(k1**2*(Pk2*(r + 3*s - 2) - Pkd2*k2*(s - 1)) + k2**2*(Pk2*(r + 2*s) + k2*(-Pkd2*s + Pkd2))) - 4*fd*(15*Pk2*b2*k2**2*(2*r + 2*s - 1) - g2*(k1**2*(Pk2*(38*r + 54*s - 27) + 10*Pkd2*k2*(2*s - 1)) + 2*k2**2*(Pk2*(68*r + 76*s - 38) + 5*Pkd2*k2*(2*s - 1)))))) + Dd*f*(-1287*b1*k1**2*k2**2*(-2*b1*k1**2*(K - 1)*(Pk2*(4*r + 12*s - 5) + Pkd2*k2*(1 - 4*s)) + b1*k2**2*(-4*Pk2*(2*K*(r + 2*s - 1) + 2*r - 1) + Pkd2*k2*(2*K - 1)*(4*s - 1)) + 4*g2*k1**2*(Pk2*(4*r + 12*s - 5) + Pkd2*k2*(1 - 4*s)) + 4*g2*k2**2*(4*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 4*s))) + 315*f**3*k1**4*(-13*Pk2*k2**2*(16*r + 20*s - 13) + 4*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 65*f**2*k2**2*(Pk2*k2**4*(8*C - 4)*(2*r - 1) + k1**4*(-2*Pk2*(-44*C*(8*r + 12*s - 7) + 105*b1*(4*r + 4*s - 3) + 604*r + 864*s - 518) + Pkd2*k2*(84*C - 63)*(4*s - 1)) + k1**2*k2**2*(Pk2*(8*C*(306*r + 344*s - 239) - 22*b1*(16*r + 20*s - 13) - 1584*r - 1812*s + 1245) + Pkd2*k2*(84*C - 42)*(4*s - 1))) + 286*f*k1**2*k2**2*(-30*Pk2*b2*k2**2*(4*r + 4*s - 3) + 5*Pkd2*b1**2*k2**3*(4*s - 1) + b1*(k1**2*(Pk2*(20*C*(4*r + 12*s - 5) + K*(-76*r - 108*s + 65) + 116*r + 28*s - 65) + Pkd2*k2*(4*s - 1)*(-20*C - 10*K + 25)) + k2**2*(Pk2*(4*C*(22*r + 40*s - 21) - 4*K*(68*r + 76*s - 53) + 68*r + 12*s - 37) + Pkd2*k2*(4*s - 1)*(-20*C - 10*K + 15))) + 2*g2*k1**2*(Pk2*(76*r + 108*s - 65) + 10*Pkd2*k2*(4*s - 1)) + 4*g2*k2**2*(2*Pk2*(68*r + 76*s - 53) + 5*Pkd2*k2*(4*s - 1)))))/(45045*d*k1*k2**2*k3**4) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**3*f*k1**2*k2*st**4*(4*Pk2 - Pkd2*k2)*(D1*(35*f**2*fd*(4*s - 1) + f*fd*(52*C - 52)*(3*s - 1) - 143*f*s*(-K*bd1 + bd1 + 2*gd2) + 286*fd*g2*(1 - 2*s)) + Dd*f*(4*s - 1)*(35*f**2 + f*(52*C - 52) - 286*g2) + 143*b1*(K - 1)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)))/(3003*d*k3**4) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**3*(D1*bd1*f*(4*Pk2*f*(2*r + s*(10*C - 5)) + Pkd2*f*k2*s*(10 - 20*C) + s*(2*Pk2 - Pkd2*k2)*(9*b2 - 18*g2)) + 9*b1**2*(D1*fd*(K*(2*Pk2 - Pkd2*k2)*(s - 1) + Pk2*f*(2*r - 1) + Pk2*r) + Dd*f*(K*Pkd2*k2*(1 - 4*s) + Pk2*(8*K*s - 2*K + f*(4*r - 2) + 4*r - 2))) + b1*(80*C*D1*Pk2*f*fd*s - 40*C*D1*Pk2*f*fd - 40*C*D1*Pkd2*f*fd*k2*s + 20*C*D1*Pkd2*f*fd*k2 + 160*C*Dd*Pk2*f**2*s - 40*C*Dd*Pk2*f**2 - 80*C*Dd*Pkd2*f**2*k2*s + 20*C*Dd*Pkd2*f**2*k2 + 18*D1*Pk2*bd2*f*s + 16*D1*Pk2*f*fd*r - 40*D1*Pk2*f*fd*s + 12*D1*Pk2*f*fd - 36*D1*Pk2*f*gd2*s - 36*D1*Pk2*fd*g2*s + 36*D1*Pk2*fd*g2 - 9*D1*Pkd2*bd2*f*k2*s + 20*D1*Pkd2*f*fd*k2*s - 10*D1*Pkd2*f*fd*k2 + 18*D1*Pkd2*f*gd2*k2*s + 18*D1*Pkd2*fd*g2*k2*s - 18*D1*Pkd2*fd*g2*k2 + 9*D1*bd1*f*(-2*K*Pkd2*k2*s + Pk2*(4*K*s + 2*f*r - f + 2*r - 1)) + 32*Dd*Pk2*f**2*r - 80*Dd*Pk2*f**2*s + 4*Dd*Pk2*f**2 - 144*Dd*Pk2*f*g2*s + 36*Dd*Pk2*f*g2 + 40*Dd*Pkd2*f**2*k2*s - 10*Dd*Pkd2*f**2*k2 + 72*Dd*Pkd2*f*g2*k2*s - 18*Dd*Pkd2*f*g2*k2 + 9*b2*(2*Pk2 - Pkd2*k2)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))))/(315*d*k2) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**3*st**2*(297*b1**2*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(D1*fd*(s - 1) + Dd*f*(4*s - 1)) - 2*b1*(D1*(5*f**2*fd*(11*Pk2*k2**2*(3*r - 1) + 15*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) - 11*f*(fd*k1**2*(3*C + 3)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 5*fd*k2**2*(-K*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 2*Pk2*r) + k1**2*s*(4*Pk2 - Pkd2*k2)*(27*K*bd1 - 27*bd1 - 27*gd2)) + 297*fd*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) + Dd*f*(5*f**2*(22*Pk2*k2**2*(2*r - 1) + 15*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 11*f*(k1**2*(3*C + 3)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 5*k2**2*(K*Pkd2*k2*(4*s - 1) + Pk2*(K*(2 - 8*s) - 4*r + 2))) + 297*g2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) - 2*f*(D1*(-55*b2*fd*k2**2*(-2*Pk2 + Pkd2*k2)*(2*s - 1) + 5*bd1*f**2*(60*Pk2*k1**2*s + 11*Pk2*k2**2*(r - 1) - 15*Pkd2*k1**2*k2*s) - 297*bd1*g2*k1**2*s*(-4*Pk2 + Pkd2*k2) + f*(11*bd1*(-5*K*Pkd2*k2**3*s + Pk2*k1**2*s*(-12*C - 12) + 5*Pk2*k2**2*(2*K*s + r - 1) + Pkd2*k1**2*k2*s*(3*C + 3)) + 30*fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + fd*k2**2*(Pk2*(-300*C*s + 100*C + 213*r + 150*s - 121) + Pkd2*k2*(50*C - 25)*(3*s - 1)) + k2**2*s*(-2*Pk2 + Pkd2*k2)*(-55*bd2 + 110*gd2)) + 110*fd*g2*k2**2*(-2*Pk2 + Pkd2*k2)*(2*s - 1)) + Dd*f*(30*f*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + f*k2**2*(4*Pk2*(-25*C*(4*s - 1) + 71*r + 50*s - 48) + Pkd2*k2*(50*C - 25)*(4*s - 1)) - k2**2*(-2*Pk2 + Pkd2*k2)*(55*b2 - 110*g2)*(4*s - 1))))/(3465*d*k2*k3**2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**3*(11*b1**2*(D1*fd*(9*K*k2**2*(-2*Pk2*r + Pkd2*k2) + 2*k1**2*(-9*C*Pkd2*k2*s + 10*Pk2*f*(4*s + 1) + 9*Pk2*(2*C*s - K*s + K + s - 1) - 5*Pkd2*f*k2*(4*s + 1))) + 2*Dd*f*(18*K*Pk2*k2**2*(1 - 2*r) + k1**2*(4*s - 1)*(Pk2*(18*C - 9*K + 20*f + 9) - Pkd2*k2*(9*C + 10*f)))) + 11*b1*(D1*bd1*f*(18*C*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 9*K*(4*Pk2*k1**2*s + 2*Pk2*k2**2*(2*r - 1) + Pkd2*k2**3) + 36*Pk2*k1**2*s + 10*f*k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 3)) + D1*(-30*Pk2*f**2*fd*k1**2*(6*r + 12*s - 7) + f*(36*Pk2*gd2*(k1**2*s + k2**2*(r - 1)) + 9*Pkd2*bd2*k2**3*s - 2*fd*(k1**2*(Pk2*(38*C*(2*s - 1) + 20*K*s - 10*K + 28*r - 42*s + 1) + 5*Pkd2*k2*(-2*K*s + K + 4*s)) + k2**2*(2*Pk2*(8*C*(2*r - 1) - 9*K*(r + 2*s - 1) - 8*r + 4) + Pkd2*k2*(5 - 10*C)))) + 9*fd*(4*Pk2*g2*k1**2*(s - 1) + Pkd2*b2*k2**3*s - 2*g2*k2**2*(-2*Pk2*r + Pkd2*k2))) + Dd*f*(-240*Pk2*f**2*k1**2*(r + 2*s - 1) + 8*Pk2*f*k2**2*(C*(8 - 16*r) + 9*K*(r + 2*s - 1) + 8*r - 4) + 36*Pk2*g2*(k1**2*(4*s - 1) + 2*k2**2*(2*r - 1)) + 9*Pkd2*b2*k2**3*(4*s - 1) - 2*f*k1**2*(Pk2*(38*C*(4*s - 1) + 40*K*s - 10*K + 56*r - 84*s - 7) + 5*Pkd2*k2*(-4*K*s + K + 8*s - 2)))) + f*(-1260*C*D1*Pk2*f*fd*k1**2*s + 420*C*D1*Pk2*f*fd*k1**2 + 1440*C*D1*Pk2*f*fd*k2**2*r + 2640*C*D1*Pk2*f*fd*k2**2*s - 1360*C*D1*Pk2*f*fd*k2**2 + 630*C*D1*Pkd2*f*fd*k1**2*k2*s - 210*C*D1*Pkd2*f*fd*k1**2*k2 - 1680*C*Dd*Pk2*f**2*k1**2*s + 420*C*Dd*Pk2*f**2*k1**2 + 1920*C*Dd*Pk2*f**2*k2**2*r + 3520*C*Dd*Pk2*f**2*k2**2*s - 1840*C*Dd*Pk2*f**2*k2**2 + 840*C*Dd*Pkd2*f**2*k1**2*k2*s - 210*C*Dd*Pkd2*f**2*k1**2*k2 - 220*D1*Pk2*bd2*f*k1**2*s + 198*D1*Pk2*bd2*f*k2**2*r + 396*D1*Pk2*bd2*f*k2**2*s - 198*D1*Pk2*bd2*f*k2**2 - 1005*D1*Pk2*f*fd*k1**2*r - 1980*D1*Pk2*f*fd*k1**2*s + 995*D1*Pk2*f*fd*k1**2 - 720*D1*Pk2*f*fd*k2**2*r - 1320*D1*Pk2*f*fd*k2**2*s + 680*D1*Pk2*f*fd*k2**2 + 440*D1*Pk2*f*gd2*k1**2*s - 396*D1*Pk2*f*gd2*k2**2*r - 792*D1*Pk2*f*gd2*k2**2*s + 396*D1*Pk2*f*gd2*k2**2 + 880*D1*Pk2*fd*g2*k1**2*s - 440*D1*Pk2*fd*g2*k1**2 - 792*D1*Pk2*fd*g2*k2**2*r - 1584*D1*Pk2*fd*g2*k2**2*s + 792*D1*Pk2*fd*g2*k2**2 + 110*D1*Pkd2*bd2*f*k1**2*k2*s - 315*D1*Pkd2*f*fd*k1**2*k2*s + 105*D1*Pkd2*f*fd*k1**2*k2 - 220*D1*Pkd2*f*gd2*k1**2*k2*s - 440*D1*Pkd2*fd*g2*k1**2*k2*s + 220*D1*Pkd2*fd*g2*k1**2*k2 - 11*D1*bd1*(30*Pk2*f**2*k1**2*(2*r + 4*s - 1) - 9*Pkd2*b2*k2**3*(s - 1) + 2*f*(k1**2*(Pk2*(14*r + s*(38*C + 10*K - 21) + 6) - 5*Pkd2*k2*(s*(K - 2) + 2)) + k2**2*(-9*K*Pk2*(r + 2*s - 1) + (2*C - 1)*(8*Pk2*r + 5*Pkd2*k2))) - 18*g2*(2*Pk2*k1**2*s + 2*Pk2*k2**2*r + Pkd2*k2**3)) - 1340*Dd*Pk2*f**2*k1**2*r - 2640*Dd*Pk2*f**2*k1**2*s + 1330*Dd*Pk2*f**2*k1**2 - 960*Dd*Pk2*f**2*k2**2*r - 1760*Dd*Pk2*f**2*k2**2*s + 920*Dd*Pk2*f**2*k2**2 + 1760*Dd*Pk2*f*g2*k1**2*s - 440*Dd*Pk2*f*g2*k1**2 - 1584*Dd*Pk2*f*g2*k2**2*r - 3168*Dd*Pk2*f*g2*k2**2*s + 1584*Dd*Pk2*f*g2*k2**2 - 420*Dd*Pkd2*f**2*k1**2*k2*s + 105*Dd*Pkd2*f**2*k1**2*k2 - 880*Dd*Pkd2*f*g2*k1**2*k2*s + 220*Dd*Pkd2*f*g2*k1**2*k2 - 22*b2*(D1*fd*(-18*Pk2*k2**2*(r + 2*s - 1) + 5*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1)) + Dd*f*(-36*Pk2*k2**2*(r + 2*s - 1) + 5*k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1)))))/(3465*d*k2*k3**2) - 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**3*st**2*(-3861*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(2*Pk2*(r + 2*s - 1) - Pkd2*k2*s) + Dd*f*(8*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 4*s))) + 13*b1*(D1*(10*f**2*fd*k2**2*(11*Pk2*k2**2*(1 - 3*r) + 15*k1**2*(4*Pk2*(2*r + s - 1) + Pkd2*k2*(2*s - 1))) - 11*f*(fd*(k1**4*(3*K - 3)*(4*Pk2 - Pkd2*k2)*(2*s - 1) - 12*k1**2*k2**2*(Pk2*(-2*C*(r + 2*s - 1) + K*(13*r + 12*s - 6) - 17*r - 18*s + 9) + Pkd2*k2*(K*(4*s - 2) + s*(C - 3) + 1)) - 10*k2**4*(K*Pk2*(8*r + 4*s - 2) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r)) - 27*k1**2*k2**2*(4*Pk2*gd2*(r + 2*s - 1) - 2*Pkd2*gd2*k2*s - bd1*(K - 1)*(4*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 2*s)))) - 594*fd*g2*k1**2*k2**2*(-2*Pk2*(r + 2*s - 1) + Pkd2*k2*s)) + Dd*f*(20*f**2*k2**2*(11*Pk2*k2**2*(1 - 2*r) + 5*k1**2*(2*Pk2*(8*r + 4*s - 5) + Pkd2*k2*(4*s - 1))) - 11*f*(k1**4*(3*K - 3)*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 6*k1**2*k2**2*(-2*Pk2*(4*C*(r + 2*s - 1) + K*(-26*r - 24*s + 19) + 34*r + 36*s - 26) + Pkd2*k2*(4*s - 1)*(C + 4*K - 3)) - 10*k2**4*(K*Pkd2*k2*(4*s - 1) + 2*Pk2*(K*(8*r + 4*s - 5) - 2*r + 1))) - 594*g2*k1**2*k2**2*(-8*Pk2*(r + 2*s - 1) + Pkd2*k2*(4*s - 1)))) + f*(D1*(-7722*bd1*g2*k1**2*k2**2*(-2*Pk2*(r + 2*s - 1) + Pkd2*k2*(s - 1)) + 10*f**2*(-143*Pk2*bd1*k2**4*(r - 1) - 780*Pk2*fd*k1**2*k2**2*(3*r + 2*s - 2) + 65*bd1*k1**2*k2**2*(4*Pk2*(2*r + s - 2) + Pkd2*k2*(2*s + 1)) + 315*fd*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 13*f*(220*Pk2*bd2*k2**4*(r + s - 1) + 11*bd1*(k1**4*s*(3 - 3*K)*(4*Pk2 - Pkd2*k2) + 6*k1**2*k2**2*(Pk2*(-2*C*(r + 2*s - 1) + K*(13*r + 12*s - 13) - 17*r - 18*s + 17) + Pkd2*k2*(C*(s - 1) + s*(4*K - 3) + 1)) + 10*k2**4*(2*K*Pk2*(2*r + s - 2) + K*Pkd2*k2*s - Pk2*r + Pk2)) + 2*fd*(k1**4*(15*C - 15)*(4*Pk2 - Pkd2*k2)*(3*s - 1) - 6*k1**2*k2**2*(Pk2*(-3*C*(23*r + 52*s - 25) + 24*r + 81*s - 35) + Pkd2*k2*(20*C - 15)*(3*s - 1)) + k2**4*(Pk2*(12*C*(46*r - 25*s - 7) - 489*r + 150*s + 113) + Pkd2*k2*(25 - 50*C)*(3*s - 1))) - 22*gd2*(3*k1**4*s*(-4*Pk2 + Pkd2*k2) + 6*k1**2*k2**2*(Pk2*(13*r + 12*s - 13) + 4*Pkd2*k2*s) + 10*k2**4*(2*Pk2*(2*r + s - 2) + Pkd2*k2*s))) + 286*fd*(10*Pk2*b2*k2**4*(2*r + 2*s - 1) + g2*(3*k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1) - 12*k1**2*k2**2*(Pk2*(13*r + 12*s - 6) + 2*Pkd2*k2*(2*s - 1)) - 10*k2**4*(Pk2*(8*r + 4*s - 2) + Pkd2*k2*(2*s - 1))))) + 2*Dd*f*(1430*Pk2*b2*k2**4*(4*r + 4*s - 3) + 75*f**2*k1**2*(-52*Pk2*k2**2*(3*r + 2*s - 2) + 21*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 13*f*(k1**4*(15*C - 15)*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 6*k1**2*k2**2*(Pk2*(C*(-92*r - 208*s + 98) + 32*r + 108*s - 43) + Pkd2*k2*(20*C - 15)*(4*s - 1)) + k2**4*(4*Pk2*(C*(184*r - 100*s - 67) - 163*r + 50*s + 69) + Pkd2*k2*(25 - 50*C)*(4*s - 1))) + 143*g2*(3*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 12*k1**2*k2**2*(Pk2*(26*r + 24*s - 19) + 2*Pkd2*k2*(4*s - 1)) - 10*k2**4*(2*Pk2*(8*r + 4*s - 5) + Pkd2*k2*(4*s - 1))))))/(45045*d*k2*k3**4) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**3*(11*b1**2*(D1*fd*(k1**4*s*(9*K - 9)*(2*Pk2 - Pkd2*k2) + 2*k1**2*k2**2*(Pk2*(18*C*(r + s - 1) + 9*K*(s - 2) + 10*f*(4*r + 4*s - 1) + 18*r + 9*s + 27) + Pkd2*k2*s*(-18*K + 30*f + 9)) - 9*k2**4*(2*K*Pk2*(r + s + 1) + K*Pkd2*k2*s - Pk2*r + f*(-2*Pk2*r + Pk2))) + Dd*f*(k1**4*(9*K - 9)*(2*Pk2 - Pkd2*k2)*(4*s - 1) + 2*k1**2*k2**2*(Pk2*(18*C*(4*r + 4*s - 3) + 36*K*s - 9*K + 20*f*(4*r + 4*s - 3) + 72*r + 36*s - 45) + Pkd2*k2*(4*s - 1)*(-18*K + 15*f + 9)) + 9*k2**4*(K*Pkd2*k2*(1 - 4*s) - 2*Pk2*(K*(4*r + 4*s - 3) - 2*f*r + f - 2*r + 1)))) + b1*(11*D1*bd1*f*(k1**4*(9*K - 9)*(2*Pk2 - Pkd2*k2)*(2*s - 1) + 2*k1**2*k2**2*(Pk2*(18*C*(2*r + 2*s - 1) + 18*K*s + 9*K + 10*f*(4*r + 4*s - 5) + 36*r + 18*s - 54) + Pkd2*k2*(2*s - 1)*(-18*K + 15*f + 9)) - 9*k2**4*(K*Pkd2*k2*(2*s - 1) + Pk2*(K*(4*r + 4*s - 6) - 2*f*r + f - 2*r + 1))) + D1*(15*f**2*fd*k1**2*(22*Pk2*k2**2*(8*s - 1) + 7*k1**2*(4*Pk2*(3*r + 6*s - 2) - Pkd2*k2*(6*s + 1))) - 22*f*(9*Pk2*bd2*k2**4*(r + s - 1) + fd*(k1**4*(-Pk2*(40*C*s + K*(19 - 38*s) + 20*r + 18*s - 29) + Pkd2*k2*s*(20*C - 20)) + k1**2*k2**2*(Pk2*(C*(28*r - 4*s + 26) + 4*K*(29*r + 52*s - 26) - 136*r - 150*s + 61) + 5*Pkd2*k2*(K*(2*s - 1) + s*(16*C - 12))) + 2*k2**4*(Pk2*(2*C*(8*r + 10*s + 1) + 9*K*(r + 2*s - 1) - 12*r - 10*s + 1) + Pkd2*k2*s*(10*C - 5))) - 9*gd2*(-2*Pk2*k1**4*s - 2*Pk2*k1**2*k2**2*s + 2*Pk2*k2**4*(r + s - 1) + Pkd2*k1**4*k2*s + 4*Pkd2*k1**2*k2**3*s + Pkd2*k2**5*s)) + 198*fd*(-Pk2*b2*k2**4*(r + s) + g2*(k1**4*(-2*Pk2*s + Pkd2*k2*s) + 2*k1**2*k2**2*(-Pk2*(s - 2) + 2*Pkd2*k2*s) + k2**4*(2*Pk2*(r + s + 1) + Pkd2*k2*s)))) + 2*Dd*f*(-99*Pk2*b2*k2**4*(4*r + 4*s - 3) + 5*f**2*k1**2*(88*Pk2*k2**2*(4*s - 1) + 21*k1**2*(8*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 4*s))) + 11*f*(k1**4*(Pk2*(20*C*(4*s - 1) - 76*K*s + 19*K + 40*r + 36*s - 29) + Pkd2*k2*(10 - 10*C)*(4*s - 1)) + k1**2*k2**2*(Pk2*(C*(-56*r + 8*s + 26) - 4*K*(58*r + 104*s - 55) + 272*r + 300*s - 211) + Pkd2*k2*(4*s - 1)*(-40*C - 5*K + 30)) + k2**4*(Pk2*(C*(-64*r - 80*s + 52) - 36*K*(r + 2*s - 1) + 48*r + 40*s - 34) + Pkd2*k2*(5 - 10*C)*(4*s - 1))) - 99*g2*(k1**4*(2*Pk2 - Pkd2*k2)*(4*s - 1) - 2*k1**2*k2**2*(-Pk2 + 2*Pkd2*k2)*(4*s - 1) + k2**4*(Pk2*(-8*r - 8*s + 6) + Pkd2*k2*(1 - 4*s))))) + f*(D1*bd1*(-198*Pk2*b2*k2**4*(r + s - 1) + 5*f**2*k1**2*(22*Pk2*k2**2*(8*s - 5) + 21*k1**2*(4*Pk2*(r + 2*s - 2) + Pkd2*k2*(3 - 2*s))) + 22*f*(k1**4*(Pk2*(20*C*(s - 1) - 19*K*s + 10*r + 9*s + 10) + Pkd2*k2*(10 - 10*C)*(s - 1)) + k1**2*k2**2*(Pk2*(2*C*(-7*r + s + 19) - 2*K*(29*r + 52*s - 29) + 68*r + 75*s - 82) - 5*Pkd2*k2*(8*C*(s - 1) + s*(K - 6) + 6)) + k2**4*(Pk2*(-4*C*(4*r + 5*s - 10) - 9*K*(r + 2*s - 1) + 12*r + 10*s - 20) + 5*Pkd2*k2*(-2*C*(s - 1) + s - 1))) - 198*g2*(k1**4*(2*Pk2 - Pkd2*k2)*(s - 1) + 2*k1**2*k2**2*(Pk2*(s + 1) - 2*Pkd2*k2*(s - 1)) + k2**4*(-2*Pk2*(r + s - 2) - Pkd2*k2*(s - 1)))) + D1*(-210*Pk2*f**2*fd*k1**4*(10*r + 24*s - 11) + f*(-660*Pk2*bd2*k1**2*k2**2*(r + s - 1) - 5*fd*(2*Pk2*k1**4*(86*C*(3*s - 1) - 63*r - 321*s + 128) + Pk2*k2**4*(16*C - 8)*(18*r + 33*s - 17) + k1**2*k2**2*(Pk2*(4*C*(390*r + 711*s - 367) - 981*r - 1944*s + 975) + Pkd2*k2*(42*C - 21)*(3*s - 1))) + 44*gd2*(19*Pk2*k1**4*s + 9*Pk2*k2**4*(r + 2*s - 1) + k1**2*k2**2*(2*Pk2*(29*r + 52*s - 29) + 5*Pkd2*k2*s))) + 44*fd*(-15*Pk2*b2*k1**2*k2**2*(2*r + 2*s - 1) + g2*(19*Pk2*k1**4*(2*s - 1) + 18*Pk2*k2**4*(r + 2*s - 1) + k1**2*k2**2*(4*Pk2*(29*r + 52*s - 26) + 5*Pkd2*k2*(2*s - 1))))) + Dd*f*(-660*Pk2*b2*k1**2*k2**2*(4*r + 4*s - 3) - 210*Pk2*f**2*k1**4*(10*r + 24*s - 11) - 5*f*(2*Pk2*k1**4*(86*C*(4*s - 1) - 84*r - 428*s + 149) + Pk2*k2**4*(16*C - 8)*(24*r + 44*s - 23) + k1**2*k2**2*(2*Pk2*(2*C*(520*r + 948*s - 497) - 654*r - 1296*s + 651) + Pkd2*k2*(42*C - 21)*(4*s - 1))) + 44*g2*(19*Pk2*k1**4*(4*s - 1) + 36*Pk2*k2**4*(r + 2*s - 1) + k1**2*k2**2*(4*Pk2*(58*r + 104*s - 55) + 5*Pkd2*k2*(4*s - 1))))))/(3465*d*k2*k3**4) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**2*f*k1*st**4*(4*Pk2 - Pkd2*k2)*(b1*(D1*fd*(18*f*s - 6*f + 22*s - 11) + Dd*f*(6*f + 11)*(4*s - 1)) + f*(D1*bd1*s*(6*f + 11) + D1*fd*(6*s - 2) + 2*Dd*f*(4*s - 1)))/(231*d*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**2*f*k1*st**4*(D1*(15*f**2*(26*bd1*k2**2*(2*Pk2*(r - 1) + Pkd2*k2*s) + fd*(104*Pk2*k2**2*(1 - 2*r) + 15*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 13*f*(-11*bd1*(-Pk2*k1**2*s*(8*K - 8) + 10*Pk2*k2**2*(K*(r - 2*s - 1) - 2*r + 2) + Pkd2*k1**2*k2*s*(2*K - 2) + Pkd2*k2**3*s*(10*K - 5)) + fd*k1**2*(8*C - 8)*(4*Pk2 - Pkd2*k2)*(3*s - 1) - 2*fd*k2**2*(2*Pk2*(57*C*r - 60*C*s + C - 72*r + 30*s + 14) + Pkd2*k2*(20*C - 15)*(3*s - 1)) + 44*gd2*(-4*Pk2*k1**2*s + 5*Pk2*k2**2*(r - 2*s - 1) + Pkd2*k1**2*k2*s + 5*Pkd2*k2**3*s)) + 572*fd*g2*(-k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 5*k2**2*(2*Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1)))) + Dd*f*(15*f**2*(104*Pk2*k2**2*(1 - 2*r) + 15*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 26*f*(k1**2*(4*C - 4)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(-4*Pk2*(C*(38*r - 40*s - 9) - 48*r + 20*s + 19) + Pkd2*k2*(15 - 20*C)*(4*s - 1))) - 572*g2*(k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 5*k2**2*(-4*Pk2*r + 8*Pk2*s - 4*Pkd2*k2*s + Pkd2*k2))) + 13*b1*(D1*fd*(k1**2*(22*K - 22)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 5*k2**2*(-44*K*Pk2*(r - 2*s + 1) - 22*K*Pkd2*k2*(2*s - 1) + 88*Pk2*r + 22*Pkd2*k2*s - 11*Pkd2*k2 + 6*f*(Pk2*(6*r - 2) + Pkd2*k2*(3*s - 1)))) + Dd*f*(k1**2*(22*K - 22)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 5*k2**2*(8*Pk2*f*(6*r - 3) - 88*Pk2*(-2*K*s + r*(K - 2) + 1) + Pkd2*k2*(4*s - 1)*(-22*K + 6*f + 11)))))/(15015*d*k3**4) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**2*k1*st**2*(4*Pk2 - Pkd2*k2)*(D1*bd1*f**2*s + b1**2*(D1*fd*(4*f*s - 2*f + 9*s - 9) + Dd*f*(2*f + 9)*(4*s - 1)) + b1*f*(2*D1*bd1*s*(2*f + 9) + D1*fd*(2*s - 1) + Dd*f*(4*s - 1)))/(105*d*k2**2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**2*k1*(99*Pkd2*b1**3*k2**3*(D1*fd*s + Dd*f*(4*s - 1)) + 11*b1**2*(9*D1*Pkd2*bd1*f*k2**3*(3*s - 1) + D1*fd*(Pk2*k1**2*s*(80*f + 18) - 9*Pk2*k2**2*(2*K*(s - 1) + f*(8*r - 3) + 2*r + 1) - Pkd2*k1**2*k2*s*(40*f + 9) - Pkd2*k2**3*s*(36*C - 18*K - 27)) + Dd*f*k1**2*(2*Pk2 - Pkd2*k2)*(20*f + 9)*(4*s - 1) + 9*Dd*f*k2**2*(2*Pk2*(-4*K*s + K + f*(4 - 8*r) - 4*r + 2) - Pkd2*k2*(4*s - 1)*(4*C - 2*K - 3))) + 11*b1*(D1*bd1*f*(k1**2*(2*Pk2 - Pkd2*k2)*(20*f + 9)*(2*s - 1) - 9*k2**2*(Pk2*(4*K*s + f*(8*r - 5) + 4*r - 3) + Pkd2*k2*(2*s - 1)*(4*C - 2*K - 3))) + 2*D1*(30*Pk2*f**2*fd*k1**2*(1 - 3*s) + f*(fd*(-2*k1**2*(Pk2*(4*s - 7) + 5*Pkd2*k2*s) + k2**2*(Pk2*(-56*C*(2*s - 1) + 9*K*(2*r + 6*s - 3) - 34*r + 56*s - 25) + Pkd2*k2*s*(40*C - 20))) + 9*k2**2*s*(Pkd2*bd2*k2 + 2*gd2*(Pk2 - Pkd2*k2))) + 9*fd*k2**2*(2*Pk2*g2*(s - 1) + Pkd2*b2*k2*s - 2*Pkd2*g2*k2*s)) + 2*Dd*f*(-30*Pk2*f**2*k1**2*(4*s - 1) + f*(-k1**2*(4*Pk2 + 5*Pkd2*k2)*(4*s - 1) + k2**2*(Pk2*(-56*C*(4*s - 1) + 9*K*(4*r + 12*s - 5) - 68*r + 112*s + 6) + Pkd2*k2*(20*C - 10)*(4*s - 1))) + 9*k2**2*(4*s - 1)*(Pkd2*b2*k2 + 2*g2*(Pk2 - Pkd2*k2)))) + f*(-22*D1*bd1*(30*Pk2*f**2*k1**2*s + f*(k1**2*(2*Pk2*(2*s + 5) + 5*Pkd2*k2*(s - 1)) + k2**2*(Pk2*(56*C*s - 9*K*(r + 3*s - 1) + 17*r - 28*s - 14) + Pkd2*k2*(10 - 20*C)*(s - 1))) - 9*k2**2*(Pkd2*b2*k2*(s - 1) + 2*g2*(Pk2*s - Pkd2*k2*s + Pkd2*k2))) + Pk2*(D1*(f*(-325*fd*k1**2*(3*s - 1) + fd*k2**2*(20*C - 10)*(69*r + 198*s - 89) + k2**2*(198*bd2 - 396*gd2)*(r + 3*s - 1)) + 198*fd*k2**2*(b2 - 2*g2)*(2*r + 6*s - 3)) + Dd*f*(-325*f*k1**2*(4*s - 1) + f*k2**2*(80*C - 40)*(23*r + 66*s - 28) + k2**2*(198*b2 - 396*g2)*(4*r + 12*s - 5)))))/(3465*d*k2**2*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**2*(2*D1*Pk2*bd1*f**2*(14*k1**2*s + k2**2*r*(2*C - 1)) - 9*b1**3*k1**2*(2*Pk2 - Pkd2*k2)*(D1*fd*s + Dd*f*(4*s - 1)) - 9*b1**2*k1**2*(D1*bd1*f*(2*Pk2 - Pkd2*k2)*(3*s - 1) + D1*fd*(Pk2*(-6*f*s + 3*f + s + 1) - Pkd2*k2*s) - Dd*f*(4*s - 1)*(Pk2*(3*f - 1) + Pkd2*k2)) + b1*f*(9*D1*bd1*k1**2*(Pk2*(6*f*s - 2*s + 2) + Pkd2*k2*(2*s - 1)) + 2*Pk2*(D1*fd*(14*k1**2*(2*s - 1) + k2**2*(2*C - 1)*(2*r - 1)) + 2*Dd*f*(7*k1**2*(4*s - 1) + k2**2*(2*C - 1)*(2*r - 1)))))/(315*d*k1*k2**2) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**2*st**2*(-33*b1**2*k1**2*k2**2*(D1*fd*(-2*Pk2*(-9*K*(r - 2*s + 2) + 2*f + 9*r + 9) + Pkd2*k2*(18*K*(s - 1) + 2*f + 9)) + 18*Dd*f*(K*Pkd2*k2*(4*s - 1) + Pk2*(-8*K*s + r*(4*K - 4) + 2))) + b1*k1**2*(D1*(-6*f**2*(11*Pk2*fd*k2**2*(18*r + 15*s - 13) - 11*bd1*k2**2*(-2*Pk2 + Pkd2*k2) + 10*fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) + 11*f*(fd*(3*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(-4*Pk2*(C*(22*r - 12*s - 5) + 12*K*s - 6*K + 11*r + 63*s - 22) + 3*Pkd2*k2*(C*(4 - 8*s) + 8*K*s - 4*K + 4*s - 3))) - 27*k2**2*(Pk2*bd1*(K*(4*r - 8*s - 2) - 4*r + 4) + Pkd2*bd1*k2*(4*K*s - 1) + 4*gd2*(-Pk2*r + 2*Pk2*s + Pk2 - Pkd2*k2*s))) + 1188*fd*g2*k2**2*(Pk2*(r - 2*s + 2) + Pkd2*k2*(s - 1))) + Dd*f*(-6*f**2*(11*Pk2*k2**2*(24*r + 20*s - 17) + 10*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 11*f*(3*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 2*k2**2*(Pk2*(8*C*(11*r - 6*s - 4) + 48*K*s - 12*K + 44*r + 252*s - 85) + Pkd2*k2*(4*s - 1)*(6*C - 6*K - 3))) + 1188*g2*k2**2*(4*Pk2*(r - 2*s) + Pkd2*k2*(4*s - 1)))) - f*(D1*(-6*bd1*f**2*k1**2*(-40*Pk2*k1**2*s - 11*Pk2*k2**2*(6*r + 5*s - 4) + 10*Pkd2*k1**2*k2*s) + f*(3*fd*(Pk2*k2**4*(64 - 128*C)*(3*r - 1) + 5*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1) + 2*k1**2*k2**2*(Pk2*(-120*C*s + 40*C + 99*r + 111*s - 70) + Pkd2*k2*(20*C - 10)*(3*s - 1))) + 11*k1**2*(bd1*(-12*Pk2*k1**2*s + 2*Pk2*k2**2*(r*(22*C + 11) + s*(-12*C + 12*K + 63) - 30) + 3*Pkd2*k1**2*k2*s + 3*Pkd2*k2**3*(s*(4*C - 4*K - 2) - 1)) + k2**2*s*(-2*Pk2 + Pkd2*k2)*(-12*bd2 + 24*gd2))) - 132*k1**2*k2**2*(-b2*fd*(2*Pk2 - Pkd2*k2)*(2*s - 1) + 9*bd1*g2*(Pk2*(r - 2*s) + Pkd2*k2*s) + 2*fd*g2*(2*Pk2 - Pkd2*k2)*(2*s - 1))) + 3*Dd*f*(f*(Pk2*k2**4*(128 - 256*C)*(2*r - 1) + 5*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 2*k1**2*k2**2*(Pk2*(-160*C*s + 40*C + 132*r + 148*s - 103) + Pkd2*k2*(20*C - 10)*(4*s - 1))) + k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(-44*b2 + 88*g2)*(4*s - 1))))/(3465*d*k1*k2**2*k3**2) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**2*st**2*(D1*(-1287*b1*fd*k1**2*k2**2*(2*b1*k1**2*(K - 1)*(-Pk2*(r + 3*s - 1) + Pkd2*k2*s) - 3*b1*k2**2*(2*Pk2*(K*(r + 2*s - 2) + r + 1) + Pkd2*k2*s*(1 - 2*K)) + 4*g2*k1**2*(Pk2*(r + 3*s - 1) - Pkd2*k2*s) + 12*g2*k2**2*(Pk2*(r + 2*s - 2) - Pkd2*k2*s)) - 6*f**3*k1**2*(-143*Pk2*bd1*k2**4*(4*r + 5*s - 6) - 195*Pk2*fd*k1**2*k2**2*(16*r + 20*s - 13) + 65*bd1*k1**2*k2**2*(2*Pk2*(5*r + 5*s - 6) + 3*Pkd2*k2) + 105*fd*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 13*f**2*k2**2*(-11*bd1*k1**2*(k1**2*(2*Pk2*(2*C*(r + 3*s - 2) - 3*K*(4*r + 9*s - 4) + 19*r + 33*s - 17) + Pkd2*k2*(-4*C*(s - 1) + s*(7 - 6*K) - 4)) + k2**2*(-2*Pk2*(10*C*r - 12*C*s + 12*K*(7*r + 11*s - 7) + 6*b1 - 49*r - 51*s + 36) - 3*Pkd2*k2*(4*C*(s - 1) + 4*K*s + b1*(2 - 4*s) - 3*s + 3))) - 3*fd*(Pk2*k2**4*(64 - 128*C)*(3*r - 1) + k1**4*(-2*Pk2*(6*C*(4*r + 11*s - 5) + 30*b1*(5*r + 5*s - 3) + 21*r - 6*s - 5) + 5*Pkd2*k2*(6*b1 + (4*C - 3)*(3*s - 1))) + 2*k1**2*k2**2*(Pk2*(-8*C*(27*r + 3*s - 10) + 11*b1*(12*r + 15*s - 7) + 207*r + 63*s - 90) + Pkd2*k2*(20*C - 10)*(3*s - 1))) - 132*k1**2*(-3*Pk2*bd2*k2**2*(r + s - 1) + gd2*k1**2*(Pk2*(4*r + 9*s - 4) + Pkd2*k2*s) + 2*gd2*k2**2*(2*Pk2*(7*r + 11*s - 7) + Pkd2*k2*s))) + 143*f*k1**2*k2**2*(12*b1**2*fd*k2**2*(Pk2 + Pkd2*k2*s) + b1*(9*bd1*(k1**2*(2*K - 2)*(Pk2*(2*r + 6*s - 3) + Pkd2*k2*(1 - 2*s)) - 3*k2**2*(Pk2*(K*(-4*r - 8*s + 2) - 4*r + 4) + Pkd2*k2*(2*K - 1)*(2*s - 1))) + fd*(k1**2*(2*Pk2*(4*C*(r + 3*s - 1) - 3*K*(8*r + 18*s - 9) + 38*r + 66*s - 35) + Pkd2*k2*(K*(6 - 12*s) + s*(14 - 8*C) - 3)) - 2*k2**2*(2*Pk2*(10*C*r - 12*C*s + C + 84*K*r + 132*K*s - 66*K - 49*r - 51*s + 32) + 3*Pkd2*k2*(K*(4*s - 2) + s*(4*C - 3)))) + 36*gd2*(k1**2*(-Pk2*(r + 3*s - 1) + Pkd2*k2*s) + 3*k2**2*(-Pk2*(r + 2*s - 1) + Pkd2*k2*s))) - 36*bd1*g2*(k1**2*(Pk2*(r + 3*s - 2) - Pkd2*k2*(s - 1)) + 3*k2**2*(Pk2*(r + 2*s) + k2*(-Pkd2*s + Pkd2))) - 12*fd*(3*Pk2*b2*k2**2*(2*r + 2*s - 1) + g2*k1**2*(Pk2*(-8*r - 18*s + 9) + Pkd2*k2*(1 - 2*s)) + 2*g2*k2**2*(Pk2*(-28*r - 44*s + 22) + Pkd2*k2*(1 - 2*s))))) + Dd*f*(-1287*b1*k1**2*k2**2*(-2*b1*k1**2*(K - 1)*(Pk2*(4*r + 12*s - 5) + Pkd2*k2*(1 - 4*s)) + 3*b1*k2**2*(-4*Pk2*(2*K*(r + 2*s - 1) + 2*r - 1) + Pkd2*k2*(2*K - 1)*(4*s - 1)) + 4*g2*k1**2*(Pk2*(4*r + 12*s - 5) + Pkd2*k2*(1 - 4*s)) + 12*g2*k2**2*(4*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 4*s))) - 90*f**3*k1**4*(-13*Pk2*k2**2*(16*r + 20*s - 13) + 7*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 39*f**2*k2**2*(Pk2*k2**4*(128 - 256*C)*(2*r - 1) + k1**4*(-4*Pk2*(C*(16*r + 44*s - 19) + 25*b1*(4*r + 4*s - 3) + 14*r - 4*s - 6) + Pkd2*k2*(20*C - 15)*(4*s - 1)) + 2*k1**2*k2**2*(Pk2*(-8*C*(36*r + 4*s - 19) + 11*b1*(16*r + 20*s - 13) + 276*r + 84*s - 159) + Pkd2*k2*(20*C - 10)*(4*s - 1))) + 143*f*k1**2*k2**2*(-36*Pk2*b2*k2**2*(4*r + 4*s - 3) + 6*Pkd2*b1**2*k2**3*(4*s - 1) + b1*k1**2*(2*Pk2*(2*C*(4*r + 12*s - 5) - 3*K*(16*r + 36*s - 17) + 76*r + 132*s - 71) - Pkd2*k2*(4*s - 1)*(4*C + 6*K - 7)) + b1*k2**2*(Pk2*(C*(-80*r + 96*s + 16) - 24*K*(28*r + 44*s - 25) + 392*r + 408*s - 298) + Pkd2*k2*(4*s - 1)*(-12*C - 12*K + 9)) + 12*g2*k1**2*(Pk2*(16*r + 36*s - 17) + Pkd2*k2*(4*s - 1)) + 24*g2*k2**2*(Pk2*(56*r + 88*s - 50) + Pkd2*k2*(4*s - 1)))))/(45045*d*k1*k2**2*k3**4) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**2*(D1*bd1*f*(5*f**2*k1**4*(22*Pk2*k2**2*(5 - 8*r) + 21*k1**2*(2*Pk2 - Pkd2*k2)*(s - 1)) + 11*f*k2**2*(Pk2*k2**4*r*(4*C - 2) + 2*k1**4*(2*Pk2*(C*(-18*r - 29*s + 29) - 5*K*r - 19*K*s + 5*K + 5*b1*(8*r + 8*s - 7) + 33*r + 51*s - 44) + 5*Pkd2*k2*(b1*(6*s - 3) - (4*C - 3)*(s - 1))) + k1**2*k2**2*(27*Pk2*b1*(4*r + 2*s - 3) - 2*Pk2*(4*C*(27*r + 34*s - 39) + 9*K*(r + 3*s - 1) - 71*r - 82*s + 92) + Pkd2*k2*(20 - 40*C)*(s - 1))) - 99*k1**2*k2**2*(2*Pk2*b1**2*k2**2*(3*r + 3*s - 2) + 6*Pk2*b2*k2**2*(r + s - 1) + b1*(k1**2*(-2*Pk2*(C*(4*r + 4*s - 2) + K*(-2*r - 4*s + 3) + 4*r + 6*s - 7) + Pkd2*k2*(2*K - 1)*(2*s - 1)) + k2**2*(2*K*Pkd2*k2*(2*s - 1) + Pk2*(-8*C*(2*r + 2*s - 1) + 4*K*(4*r + 5*s - 5) + 8*r + 10*s - 3))) - 4*g2*(k1**2*(Pk2*(r + 2*s - 2) + Pkd2*k2*(s - 1)) + k2**2*(Pk2*(4*r + 5*s - 6) + Pkd2*k2*(s - 1))))) - 198*Pk2*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + Pk2*f*k1**2*(D1*(-315*f**2*fd*k1**4*(4*s - 1) + f*k2**2*(-220*bd2*k1**2*(r + s - 1) - 5*fd*(k1**2*(4*C*(63*r + 258*s - 107) - 126*r - 711*s + 279) + k2**2*(4*C - 2)*(69*r + 198*s - 89)) + 44*gd2*(2*k1**2*(5*r + 19*s - 5) + 9*k2**2*(r + 3*s - 1))) + 44*fd*k2**2*(-5*b2*k1**2*(2*r + 2*s - 1) + g2*k1**2*(20*r + 76*s - 38) + 9*g2*k2**2*(2*r + 6*s - 3))) + Dd*f*(-315*f**2*k1**4*(4*s - 1) - 5*f*k2**2*(k1**2*(16*C*(21*r + 86*s - 32) - 168*r - 948*s + 321) + k2**2*(16*C - 8)*(23*r + 66*s - 28)) + 44*k2**2*(-5*b2*k1**2*(4*r + 4*s - 3) + 2*g2*k1**2*(20*r + 76*s - 29) + 9*g2*k2**2*(4*r + 12*s - 5)))) + 11*b1**2*k1**2*k2**2*(D1*fd*(k1**2*(2*Pk2*(18*C*(r + s - 1) - 18*K*s + 10*f*(8*r + 8*s - 5) - 9*r*(K - 2) + 27*s + 18) + Pkd2*k2*s*(-18*K + 60*f + 9)) - 9*k2**2*(2*K*Pkd2*k2*s + Pk2*(-8*C*(r + s - 1) + 8*K*r + 10*K*s + 2*K - 6*f*(2*r + s - 1) + 4*r + 5*s - 6))) + Dd*f*(k1**2*(2*Pk2*(18*C*(4*r + 4*s - 3) - 36*K*(r + 2*s - 1) + 40*f*(4*r + 4*s - 3) + 72*r + 108*s - 63) + Pkd2*k2*(4*s - 1)*(-18*K + 30*f + 9)) + 9*k2**2*(2*K*Pkd2*k2*(1 - 4*s) + Pk2*(8*C*(4*r + 4*s - 3) + 3*f*(8*r + 4*s - 5) - (2*K + 1)*(16*r + 20*s - 13))))) + b1*(D1*(-5*f**2*fd*k1**4*(-126*Pk2*k1**2*s + 22*Pk2*k2**2*(24*r - 11) + 63*Pkd2*k1**2*k2*s) + 22*f*k2**2*(fd*(Pk2*k2**4*(2*C - 1)*(2*r - 1) - 2*k1**4*(Pk2*(2*C*(18*r + 29*s - 9) + K*(10*r + 38*s - 19) - 66*r - 102*s + 40) + Pkd2*k2*s*(20*C - 15)) + k1**2*k2**2*(Pk2*(-8*C*(27*r + 34*s - 11) - 9*K*(2*r + 6*s - 3) + 142*r + 164*s - 61) + Pkd2*k2*s*(20 - 40*C))) + 9*k1**2*(-3*Pk2*bd2*k2**2*(r + s - 1) + 2*gd2*(k1**2*(Pk2*(r + 2*s - 1) + Pkd2*k2*s) + k2**2*(Pk2*(4*r + 5*s - 4) + Pkd2*k2*s)))) + 198*fd*k1**2*k2**2*(-3*Pk2*b2*k2**2*(r + s) + 2*g2*(Pk2*k1**2*(r + 2*s) + Pk2*k2**2*(4*r + 5*s + 1) + Pkd2*k1**2*k2*s + Pkd2*k2**3*s))) + Dd*f*(5*f**2*k1**4*(352*Pk2*k2**2*(1 - 2*r) + 21*k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1)) - 22*f*k2**2*(2*Pk2*k2**4*(C*(2 - 4*r) + 2*r - 1) + k1**4*(2*Pk2*(C*(72*r + 116*s - 65) + K*(20*r + 76*s - 29) - 132*r - 204*s + 117) + Pkd2*k2*(20*C - 15)*(4*s - 1)) + k1**2*k2**2*(Pk2*(16*C*(27*r + 34*s - 22) + 9*K*(4*r + 12*s - 5) - 284*r - 328*s + 224) + Pkd2*k2*(20*C - 10)*(4*s - 1))) + 198*k1**2*k2**2*(-3*Pk2*b2*k2**2*(4*r + 4*s - 3) + 2*g2*(k1**2*(4*Pk2*(r + 2*s - 1) + Pkd2*k2*(4*s - 1)) + k2**2*(Pk2*(16*r + 20*s - 13) + Pkd2*k2*(4*s - 1)))))))/(3465*d*k1*k2**2*k3**4) - 14*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*f**3*k1**2*k2*st**6*(-4*Pk2 + Pkd2*k2)*(4*s - 1)*(D1*fd + Dd*f)/(429*d*k3**4) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*f*st**4*(D1*(-5*bd1*f**2*(-24*Pk2*k1**2*s + 11*Pk2*k2**2*(r - 1) + 6*Pkd2*k1**2*k2*s) + f*(11*bd1*(5*K*Pkd2*k2**3*s + 8*Pk2*k1**2*s - 5*Pk2*k2**2*(2*K*s + r - 1) - 2*Pkd2*k1**2*k2*s) + 4*fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + 2*fd*k2**2*(Pk2*(-60*C*s + 20*C - 42*r + 30*s + 4) + Pkd2*k2*(10*C - 5)*(3*s - 1)) + k2**2*s*(-2*Pk2 + Pkd2*k2)*(55*bd2 - 110*gd2)) + 55*fd*k2**2*(-2*Pk2 + Pkd2*k2)*(b2 - 2*g2)*(2*s - 1)) + Dd*f*(4*f*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 2*f*k2**2*(Pk2*(C*(20 - 80*s) - 56*r + 40*s + 18) + Pkd2*k2*(10*C - 5)*(4*s - 1)) + k2**2*(-2*Pk2 + Pkd2*k2)*(55*b2 - 110*g2)*(4*s - 1)) + b1*(D1*fd*(2*k1**2*(4*Pk2 - Pkd2*k2)*(15*f*(3*s - 1) + 22*s - 11) + 55*k2**2*(-K*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 2*Pk2*r + f*(-3*Pk2*r + Pk2))) + Dd*f*(k1**2*(4*Pk2 - Pkd2*k2)*(30*f + 22)*(4*s - 1) + 55*k2**2*(K*Pkd2*k2*(4*s - 1) + 2*Pk2*(-4*K*s + K - 2*f*r + f - 2*r + 1)))))/(1155*d*k2*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*f*st**4*(D1*(5*f**2*(143*Pk2*bd1*k2**4*(r - 1) - 312*Pk2*fd*k1**2*k2**2*(3*r + 2*s - 2) + 26*bd1*k1**2*k2**2*(4*Pk2*(2*r + s - 2) + Pkd2*k2*(2*s + 1)) + 15*fd*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 13*f*k2**2*(110*Pk2*bd2*k2**2*(r + s - 1) + 11*bd1*(2*k1**2*(Pk2*(K*(2*r - 3*s - 2) - 5*r - 2*s + 5) + Pkd2*k2*s*(2*K - 1)) + 5*k2**2*(2*K*Pk2*(2*r + s - 2) + K*Pkd2*k2*s - Pk2*r + Pk2)) - 2*fd*k1**2*(2*Pk2*(-2*C*(6*r - 9*s + 1) + 30*b1*(2*r + s - 1) + 21*r - 3*s - 6) + Pkd2*k2*(15*b1*(2*s - 1) - (8*C - 6)*(3*s - 1))) + fd*k2**2*(-55*Pk2*b1*(3*r - 1) + 4*Pk2*(6*C*(19*r + 5*s - 8) - 78*r - 15*s + 31) + Pkd2*k2*(20*C - 10)*(3*s - 1)) - 22*gd2*(k1**2*(Pk2*(4*r - 6*s - 4) + 4*Pkd2*k2*s) + 5*k2**2*(2*Pk2*(2*r + s - 2) + Pkd2*k2*s))) - 143*fd*k2**2*(10*Pk2*b2*k2**2*(2*r + 2*s - 1) + 2*b1*k1**2*(Pk2*(K*(4*r - 6*s + 3) - 10*r - 4*s + 2) + Pkd2*k2*(2*K - 1)*(2*s - 1)) + 5*b1*k2**2*(K*Pk2*(8*r + 4*s - 2) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r) - 4*g2*k1**2*(Pk2*(4*r - 6*s + 3) + 2*Pkd2*k2*(2*s - 1)) - 10*g2*k2**2*(Pk2*(8*r + 4*s - 2) + Pkd2*k2*(2*s - 1)))) + Dd*f*(15*f**2*k1**2*(-104*Pk2*k2**2*(3*r + 2*s - 2) + 5*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 26*f*k2**2*(2*k1**2*(Pk2*(C*(-16*r + 24*s + 2) + 10*b1*(8*r + 4*s - 5) + 28*r - 4*s - 13) + Pkd2*k2*(4*s - 1)*(-4*C + 5*b1 + 3)) + k2**2*(Pk2*(-4*C*(76*r + 20*s - 43) + 55*b1*(2*r - 1) + 208*r + 40*s - 114) + Pkd2*k2*(5 - 10*C)*(4*s - 1))) - 143*k2**2*(10*Pk2*b2*k2**2*(4*r + 4*s - 3) + 2*b1*k1**2*(K*Pk2*(8*r - 12*s - 1) - 4*Pk2*(5*r + 2*s - 3) + Pkd2*k2*(2*K - 1)*(4*s - 1)) + 5*b1*k2**2*(K*Pkd2*k2*(4*s - 1) + 2*Pk2*(K*(8*r + 4*s - 5) - 2*r + 1)) + 4*g2*k1**2*(-8*Pk2*r + 12*Pk2*s + Pk2 - 8*Pkd2*k2*s + 2*Pkd2*k2) + 10*g2*k2**2*(-2*Pk2*(8*r + 4*s - 5) + Pkd2*k2*(1 - 4*s)))))/(15015*d*k2*k3**4) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*st**2*(D1*bd1*f*(Pk2*f*(-19*r + s*(6 - 12*C)) + Pkd2*f*k2*s*(6*C - 3) - s*(2*Pk2 - Pkd2*k2)*(27*b2 - 54*g2)) - 27*b1**2*(D1*fd*(K*(2*Pk2 - Pkd2*k2)*(s - 1) + Pk2*f*(2*r - 1) + Pk2*r) + Dd*f*(K*Pkd2*k2*(1 - 4*s) + Pk2*(8*K*s - 2*K + f*(4*r - 2) + 4*r - 2))) + b1*(-24*C*D1*Pk2*f*fd*s + 12*C*D1*Pk2*f*fd + 12*C*D1*Pkd2*f*fd*k2*s - 6*C*D1*Pkd2*f*fd*k2 - 48*C*Dd*Pk2*f**2*s + 12*C*Dd*Pk2*f**2 + 24*C*Dd*Pkd2*f**2*k2*s - 6*C*Dd*Pkd2*f**2*k2 - 54*D1*Pk2*bd2*f*s - 38*D1*Pk2*f*fd*r + 12*D1*Pk2*f*fd*s + 13*D1*Pk2*f*fd + 108*D1*Pk2*f*gd2*s + 108*D1*Pk2*fd*g2*s - 108*D1*Pk2*fd*g2 + 27*D1*Pkd2*bd2*f*k2*s - 6*D1*Pkd2*f*fd*k2*s + 3*D1*Pkd2*f*fd*k2 - 54*D1*Pkd2*f*gd2*k2*s - 54*D1*Pkd2*fd*g2*k2*s + 54*D1*Pkd2*fd*g2*k2 - 27*D1*bd1*f*(-2*K*Pkd2*k2*s + Pk2*(4*K*s + 2*f*r - f + 2*r - 1)) - 76*Dd*Pk2*f**2*r + 24*Dd*Pk2*f**2*s + 32*Dd*Pk2*f**2 + 432*Dd*Pk2*f*g2*s - 108*Dd*Pk2*f*g2 - 12*Dd*Pkd2*f**2*k2*s + 3*Dd*Pkd2*f**2*k2 - 216*Dd*Pkd2*f*g2*k2*s + 54*Dd*Pkd2*f*g2*k2 - 27*b2*(2*Pk2 - Pkd2*k2)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))))/(315*d*k2) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*(2*D1*Pk2*bd1*f**2*s*(2*C - 1) + b1**2*(D1*fd*(Pk2*(r - 1) + Pkd2*k2*s*(2*C - 1)) + Dd*f*(Pk2*(4*r - 2) + Pkd2*k2*(2*C - 1)*(4*s - 1))) + b1*f*(D1*(2*Pk2*bd1*r + Pk2*fd*(4*C - 2)*(2*s - 1) + Pkd2*bd1*k2*(2*C - 1)*(2*s - 1)) + Dd*Pk2*f*(4*C - 2)*(4*s - 1)))/(35*d*k2) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*st**2*(33*b1**2*(D1*fd*(9*K*k2**2*(-2*Pk2*r + Pkd2*k2) + k1**2*(2*Pk2*(-3*K*s + 3*K + 4*f*s + f + 9*s - 3) - Pkd2*k2*(4*f*s + f + 6*s))) + 2*Dd*f*(18*K*Pk2*k2**2*(1 - 2*r) + k1**2*(4*s - 1)*(Pk2*(-3*K + 2*f + 9) - Pkd2*k2*(f + 3)))) + 11*b1*(3*D1*bd1*f*(-9*K*k2**2*(Pk2*(4*r - 2) + Pkd2*k2) + k1**2*(2*Pk2*(f*(4*s - 3) - s*(6*K - 18) - 6) + Pkd2*k2*(f*(3 - 4*s) - 12*s + 6))) + D1*(-9*Pk2*f**2*fd*k1**2*(6*r + 12*s - 7) + f*(36*Pk2*gd2*(k1**2*s + 3*k2**2*(r - 1)) + 27*Pkd2*bd2*k2**3*s - fd*k1**2*(2*Pk2*(C*(4*s - 2) + 6*K*s - 3*K + 21*r + 52*s - 28) + Pkd2*k2*(K*(3 - 6*s) + 4*s)) + fd*k2**2*(2*Pk2*(C*(38 - 76*r) + 54*K*(r + 2*s - 1) + 38*r - 19) + Pkd2*k2*(6*C - 3))) + 9*fd*(4*Pk2*g2*k1**2*(s - 1) + 3*Pkd2*b2*k2**3*s - 6*g2*k2**2*(-2*Pk2*r + Pkd2*k2))) + Dd*f*(-72*Pk2*f**2*k1**2*(r + 2*s - 1) + 4*Pk2*f*k2**2*(C*(38 - 76*r) + 54*K*(r + 2*s - 1) + 38*r - 19) + 36*Pk2*g2*(k1**2*(4*s - 1) + 6*k2**2*(2*r - 1)) + 27*Pkd2*b2*k2**3*(4*s - 1) + f*k1**2*(-2*Pk2*(C*(8*s - 2) + 12*K*s - 3*K + 42*r + 104*s - 47) + Pkd2*k2*(3*K - 2)*(4*s - 1)))) + f*(-11*D1*bd1*(9*Pk2*f**2*k1**2*(2*r + 4*s - 1) - 27*Pkd2*b2*k2**3*(s - 1) + f*k1**2*(Pk2*(21*r + s*(4*C + 6*K + 52) - 17) + Pkd2*k2*(s*(2 - 3*K) - 2)) + f*k2**2*(-54*K*Pk2*(r + 2*s - 1) + (2*C - 1)*(38*Pk2*r + 3*Pkd2*k2)) - 18*g2*(2*Pk2*k1**2*s + 6*Pk2*k2**2*r + 3*Pkd2*k2**3)) - 3*D1*(792*Pk2*fd*g2*k2**2*(r + 2*s - 1) + f*fd*(Pk2*k2**2*(2 - 4*C)*(129*r + 66*s - 65) + k1**2*(Pk2*(-60*C*s + 20*C + 39*r + 66*s - 35) + Pkd2*k2*(10*C - 5)*(3*s - 1))) - 11*f*(bd2 - 2*gd2)*(-2*Pk2*k1**2*s + 18*Pk2*k2**2*(r + 2*s - 1) + Pkd2*k1**2*k2*s) - 22*fd*g2*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1)) - 3*Dd*f*(-Pk2*f*k2**2*(16*C - 8)*(43*r + 22*s - 27) + 1584*Pk2*g2*k2**2*(r + 2*s - 1) + f*k1**2*(4*Pk2*(C*(5 - 20*s) + 13*r + 22*s - 12) + Pkd2*k2*(10*C - 5)*(4*s - 1)) - 22*g2*k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1)) - 33*b2*(D1*fd*(-36*Pk2*k2**2*(r + 2*s - 1) + k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1)) + Dd*f*(-72*Pk2*k2**2*(r + 2*s - 1) + k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1)))))/(3465*d*k2*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*(-9*Pkd2*b1**3*k1**2*k2*(D1*fd*s + Dd*f*(4*s - 1)) + 9*b1**2*(2*C*(D1*fd*(2*Pk2*k1**2*s + 2*Pk2*k2**2*(-r + s + 1) + Pkd2*k2**3*s) + Dd*f*(2*Pk2*k1**2*(4*s - 1) + k2**2*(Pk2*(-8*r + 8*s + 2) + Pkd2*k2*(4*s - 1)))) + D1*(f*k1**2*(Pk2*fd*(12*r + 8*s - 7) + Pkd2*bd1*k2*(1 - 3*s)) - fd*(K*Pkd2*k1**2*k2*s - Pk2*k1**2*(r - 2*s) + Pk2*k2**2*(-3*r + 2*s + 3) + Pkd2*k2**3*s)) + Dd*f*(K*Pkd2*k1**2*k2*(1 - 4*s) + 8*Pk2*f*k1**2*(3*r + 2*s - 2) + 4*Pk2*k1**2*(r - 2*s) + 4*Pk2*k2**2*(3*r - 2*s - 1) + k2**3*(-4*Pkd2*s + Pkd2))) + b1*(9*D1*bd1*f*(k1**2*(K*Pkd2*k2*(1 - 2*s) + Pk2*(C*(8*s - 4) + f*(12*r + 8*s - 9) + 2*r - 4*s + 1)) + k2**2*(Pk2*(C*(-8*r + 8*s - 4) + 6*r - 4*s + 2) + Pkd2*k2*(2*C - 1)*(2*s - 1))) + D1*(-9*Pkd2*fd*k1**2*k2*s*(b2 - 2*g2) + f*(Pk2*fd*k2**2*(4 - 8*C)*(7*r + 1) - Pkd2*k1**2*k2*s*(9*bd2 - 18*gd2) + fd*k1**2*(Pk2*(-36*K*s + 18*K + 52*r + 76*s - 26) + Pkd2*k2*s*(20 - 40*C)))) + Dd*f*(Pkd2*k1**2*k2*(-9*b2 + 18*g2)*(4*s - 1) - 2*f*(Pk2*k2**2*(28*C - 14)*(2*r - 1) + k1**2*(Pk2*(36*K*s - 9*K - 52*r - 76*s + 45) + Pkd2*k2*(10*C - 5)*(4*s - 1))))) + f*(D1*bd1*(Pk2*f*k2**2*(2 - 4*C)*(7*r - 9) - Pkd2*k1**2*k2*(9*b2 - 18*g2)*(s - 1) + 2*f*k1**2*(Pk2*(-9*K*s + 13*r + 19*s - 19) + 5*Pkd2*k2*(-2*C*(s - 1) + s - 1))) - 2*Pk2*k1**2*(D1*(f*fd*(20*C - 10)*(3*s - 1) + 9*f*s*(bd2 - 2*gd2) + 18*fd*g2*(1 - 2*s)) + 2*Dd*f*(4*s - 1)*(f*(10*C - 5) - 9*g2) + 9*b2*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)))))/(315*d*k2*k3**2) - 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*st**2*(D1*bd1*f*(3*f**2*k1**2*(11*Pk2*k2**2*(5 - 8*s) + 5*k1**2*(4*Pk2*(r + 2*s - 2) + Pkd2*k2*(3 - 2*s))) + 11*f*(-2*Pk2*k1**4*(r - s*(K - 2) - 1) - k1**2*k2**2*(Pk2*(4*C*(s + 1) - 60*K*r - 138*K*s + 60*K + 6*b1*(4*r + 4*s - 5) + 29*r + 64*s - 31) + Pkd2*k2*(-8*C*(s - 1) - 3*K*s + 9*b1*(2*s - 1) + 6*s - 6)) + k2**4*(Pk2*(4*C*(19*r + 3*s - 6) + 54*K*(r + 2*s - 1) + b1*(27 - 54*r) - 57*r - 6*s + 12) + Pkd2*k2*(6*C - 3)*(s - 1))) + 99*k2**2*(6*Pk2*b2*k2**2*(r + s - 1) - 2*b1*k1**2*(Pk2*(2*K*s + K + 8*r + 6*s - 8) + Pkd2*k2*(-4*K*s + 2*K + 2*s - 1)) + 3*b1*k2**2*(K*Pk2*(4*r + 4*s - 6) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r + Pk2) + 4*g2*k1**2*(Pk2*(s + 1) - 2*Pkd2*k2*(s - 1)) - 6*g2*k2**2*(2*Pk2*(r + s - 2) + Pkd2*k2*(s - 1)))) - 33*b1**2*k2**2*(D1*fd*(2*k1**2*(Pk2*(3*K*(s - 2) + f*(4*r + 4*s - 1) + 12*r + 9*s + 3) + Pkd2*k2*s*(-6*K + 3*f + 3)) - 9*k2**2*(2*K*Pk2*(r + s + 1) + K*Pkd2*k2*s - Pk2*r + f*(-2*Pk2*r + Pk2))) + Dd*f*(k1**2*(2*Pk2*(12*K*s - 3*K + f*(8*r + 8*s - 6) + 48*r + 36*s - 33) + Pkd2*k2*(4*s - 1)*(-12*K + 3*f + 6)) + 9*k2**2*(K*Pkd2*k2*(1 - 4*s) - 2*Pk2*(K*(4*r + 4*s - 3) - 2*f*r + f - 2*r + 1)))) + b1*(D1*(3*f**2*fd*k1**2*(33*Pk2*k2**2*(1 - 8*s) + 5*k1**2*(4*Pk2*(3*r + 6*s - 2) - Pkd2*k2*(6*s + 1))) + 11*f*(54*Pk2*bd2*k2**4*(r + s - 1) + fd*(2*Pk2*k1**4*(2*K*s - K - 2*r - 4*s + 2) + k1**2*k2**2*(2*Pk2*(-4*C*(s - 1) + 3*K*(20*r + 46*s - 23) - 29*r - 64*s + 31) + Pkd2*k2*(K*(6*s - 3) + s*(16*C - 12))) + k2**4*(8*C*Pk2*(19*r + 3*s - 8) + 3*Pk2*(36*K*(r + 2*s - 1) - 38*r - 4*s + 17) + Pkd2*k2*s*(12*C - 6))) - 18*gd2*k2**2*(-2*Pk2*k1**2*s + 6*Pk2*k2**2*(r + s - 1) + 4*Pkd2*k1**2*k2*s + 3*Pkd2*k2**3*s)) - 198*fd*k2**2*(-3*Pk2*b2*k2**2*(r + s) + g2*k1**2*(-2*Pk2*(s - 2) + 4*Pkd2*k2*s) + 3*g2*k2**2*(2*Pk2*(r + s + 1) + Pkd2*k2*s))) + Dd*f*(6*f**2*k1**2*(44*Pk2*k2**2*(1 - 4*s) + 5*k1**2*(8*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 4*s))) + 11*f*(2*Pk2*k1**4*(4*K*s - K - 4*r - 8*s + 4) + k1**2*k2**2*(2*Pk2*(C*(2 - 8*s) + 3*K*(40*r + 92*s - 43) - 58*r - 128*s + 61) + Pkd2*k2*(4*s - 1)*(8*C + 3*K - 6)) + k2**4*(4*Pk2*(C*(76*r + 12*s - 41) + 54*K*(r + 2*s - 1) - 57*r - 6*s + 30) + Pkd2*k2*(6*C - 3)*(4*s - 1))) + 198*k2**2*(3*Pk2*b2*k2**2*(4*r + 4*s - 3) + 2*g2*k1**2*(Pk2 - 2*Pkd2*k2)*(4*s - 1) - 3*g2*k2**2*(Pk2*(8*r + 8*s - 6) + Pkd2*k2*(4*s - 1))))) - f*(D1*(30*Pk2*f**2*fd*k1**4*(10*r + 24*s - 11) + f*(-198*Pk2*bd2*k1**2*k2**2*(r + s - 1) + fd*(-10*Pk2*k1**4*(C*(2 - 6*s) + 3*r + 9*s - 4) - Pk2*k2**4*(12*C - 6)*(129*r + 66*s - 65) + 3*k1**2*k2**2*(4*C*Pk2*(6*r + 9*s - 5) + 3*Pk2*(9*r + 6*s - 5) + Pkd2*k2*(10*C - 5)*(3*s - 1))) + 22*gd2*(2*Pk2*k1**4*s + 54*Pk2*k2**4*(r + 2*s - 1) + 3*k1**2*k2**2*(Pk2*(20*r + 46*s - 20) + Pkd2*k2*s))) + 22*fd*(-9*Pk2*b2*k1**2*k2**2*(2*r + 2*s - 1) + g2*(2*Pk2*k1**4*(2*s - 1) + 108*Pk2*k2**4*(r + 2*s - 1) + 3*k1**2*k2**2*(Pk2*(40*r + 92*s - 46) + Pkd2*k2*(2*s - 1))))) + Dd*f*(-198*Pk2*b2*k1**2*k2**2*(4*r + 4*s - 3) + 30*Pk2*f**2*k1**4*(10*r + 24*s - 11) + f*(-10*Pk2*k1**4*(C*(2 - 8*s) + 4*r + 12*s - 5) - Pk2*k2**4*(48*C - 24)*(43*r + 22*s - 27) + 3*k1**2*k2**2*(4*Pk2*(C*(8*r + 12*s - 7) + 9*r + 6*s - 6) + Pkd2*k2*(10*C - 5)*(4*s - 1))) + 22*g2*(2*Pk2*k1**4*(4*s - 1) + 216*Pk2*k2**4*(r + 2*s - 1) + 3*k1**2*k2**2*(2*Pk2*(40*r + 92*s - 43) + Pkd2*k2*(4*s - 1))))))/(3465*d*k2*k3**4) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*(-36*Pk2*b1**3*k1**2*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1**2*(D1*(f*k1**2*(-36*Pk2*bd1*k2**2*(3*r + 3*s - 2) + 27*Pk2*fd*k2**2*(6*r + 4*s - 3) + 20*fd*k1**2*(Pk2*(4*r + 4*s - 3) + Pkd2*k2*s)) + 9*fd*(2*Pk2*k1**4*(r - s*(K - 2)) + Pk2*k2**4*(4*C - 2)*(r + s - 1) - k1**2*k2**2*(K*Pkd2*k2*s + Pk2*(-8*C*(r + s - 1) + 8*K*r + 12*K*s + 5*r + 4*s - 6)))) + Dd*f*(Pk2*k2**4*(36*C - 18)*(4*r + 4*s - 3) + 2*k1**4*(20*Pk2*f*(4*r + 4*s - 3) + 9*Pk2*(-4*K*s + K + 4*r + 8*s - 4) + 5*Pkd2*f*k2*(4*s - 1)) - 9*k1**2*k2**2*(K*Pkd2*k2*(4*s - 1) - 2*Pk2*(4*C*(4*r + 4*s - 3) - 16*K*r - 24*K*s + 14*K + 6*f*(3*r + 2*s - 2) - 10*r - 8*s + 7)))) + b1*(D1*bd1*f*(Pk2*k2**4*(36*C - 18)*(2*r + 2*s - 1) + 2*k1**4*(10*Pk2*f*(4*r + 4*s - 3) + 9*Pk2*(-2*K*s + K + 2*r + 4*s - 3) + 5*Pkd2*f*k2*(2*s - 1)) - 9*k1**2*k2**2*(K*Pkd2*k2*(2*s - 1) + Pk2*(-8*C*(2*r + 2*s - 1) + 16*K*r + 24*K*s - 20*K - 3*f*(6*r + 4*s - 5) + 10*r + 8*s - 3))) - 2*D1*(5*Pk2*f**2*fd*k1**4*(15*r + 12*s - 8) + f*(fd*(-10*Pk2*k1**4*(-4*C*s + 2*r + 6*s - 1) + Pk2*k2**4*(2*C - 1)*(14*r + 18*s - 7) + k1**2*k2**2*(Pk2*(8*C*(28*r + 39*s - 14) + 18*K*s - 9*K - 138*r - 194*s + 69) + Pkd2*k2*s*(20*C - 10))) - 9*k1**2*(-3*Pk2*bd2*k2**2*(r + s - 1) + gd2*(2*Pk2*k1**2*s + 4*Pk2*k2**2*(2*r + 3*s - 2) + Pkd2*k2**3*s))) - 9*fd*k1**2*(-3*Pk2*b2*k2**2*(r + s) + g2*(2*Pk2*k1**2*s + 4*Pk2*k2**2*(2*r + 3*s) + Pkd2*k2**3*s))) - 2*Dd*f*(10*Pk2*f**2*k1**4*(10*r + 8*s - 7) + f*(-10*Pk2*k1**4*(C*(2 - 8*s) + 4*r + 12*s - 5) + Pk2*k2**4*(2*C - 1)*(28*r + 36*s - 23) + k1**2*k2**2*(Pk2*(4*C*(112*r + 156*s - 95) + 36*K*s - 9*K - 276*r - 388*s + 235) + Pkd2*k2*(10*C - 5)*(4*s - 1))) + 9*k1**2*(3*Pk2*b2*k2**2*(4*r + 4*s - 3) + Pk2*g2*k1**2*(2 - 8*s) + g2*k2**2*(-4*Pk2*(8*r + 12*s - 7) + Pkd2*k2*(1 - 4*s))))) - 2*f*(D1*bd1*(5*Pk2*f**2*k1**4*(5*r + 4*s - 6) + f*(-10*Pk2*k1**4*(-2*C*(s - 1) + r + 3*s - 3) + Pk2*k2**4*(2*C - 1)*(7*r + 9*s - 9) + k1**2*k2**2*(Pk2*(4*C*(28*r + 39*s - 39) + 9*K*s - 69*r - 97*s + 97) + Pkd2*k2*(10*C - 5)*(s - 1))) + 9*k1**2*(3*Pk2*b2*k2**2*(r + s - 1) - 2*Pk2*g2*k1**2*(s - 1) + g2*k2**2*(-4*Pk2*(2*r + 3*s - 3) - Pkd2*k2*(s - 1)))) + 2*Pk2*k1**2*k2**2*(D1*(f*fd*(10*C - 5)*(3*s - 1) - 9*f*gd2*s + 9*fd*g2*(1 - 2*s)) + Dd*f*(4*s - 1)*(f*(10*C - 5) - 9*g2))))/(315*d*k2*k3**4) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*f**2*k1*st**6*(4*Pk2 - Pkd2*k2)*(D1*b1*fd*(3*s - 1) + D1*bd1*f*s + Dd*b1*f*(4*s - 1))/(77*d*k3**2) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*f**2*k1*st**6*(D1*(13*b1*fd*k2**2*(Pk2*(6*r - 2) + Pkd2*k2*(3*s - 1)) + f*(13*bd1*k2**2*(2*Pk2*(r - 1) + Pkd2*k2*s) + fd*(52*Pk2*k2**2*(1 - 2*r) + 7*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)))) + Dd*f*(13*b1*k2**2*(Pk2*(8*r - 4) + Pkd2*k2*(4*s - 1)) + f*(52*Pk2*k2**2*(1 - 2*r) + 7*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))))/(1001*d*k3**4) - 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*f*st**4*(11*D1*b1**2*fd*k1**2*k2**2*(-2*Pk2 + Pkd2*k2) + D1*bd1*f*k1**2*(-22*K*Pkd2*k2**3*s - 16*Pk2*f*k1**2*s + 11*Pk2*k2**2*(4*K*s + f*(6*r + 5*s - 4) + 2*r + s - 2) + 4*Pkd2*f*k1**2*k2*s) + b1*k1**2*(D1*(f*(11*Pk2*fd*k2**2*(18*r + 15*s - 13) - 11*bd1*k2**2*(-2*Pk2 + Pkd2*k2) - 4*fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) - 11*fd*k2**2*(2*K*Pkd2*k2*(2*s - 1) + Pk2*(-8*K*s + 4*K - 4*r - 2*s + 1))) + Dd*f*(f*(11*Pk2*k2**2*(24*r + 20*s - 17) - 4*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 11*k2**2*(2*K*Pkd2*k2*(4*s - 1) + Pk2*(-16*K*s + 4*K - 8*r - 4*s + 5)))) - 2*k2**2*(-D1*f*(Pk2*fd*k2**2*(9 - 18*C)*(3*r - 1) + fd*k1**2*(Pk2*(8*C*(3*s - 1) + 6*r - 9*s + 1) + 2*Pkd2*k2*(C*(2 - 6*s) + 3*s - 1)) + k1**2*s*(2*Pk2 - Pkd2*k2)*(11*bd2 - 22*gd2)) + 22*D1*fd*g2*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1) + Dd*f*(Pk2*f*k2**2*(36*C - 18)*(2*r - 1) + f*k1**2*(Pk2*(C*(8 - 32*s) - 8*r + 12*s + 1) + Pkd2*k2*(4*C - 2)*(4*s - 1)) + 22*g2*k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1)) - 11*b2*k1**2*(2*Pk2 - Pkd2*k2)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1))))/(1155*d*k1*k2**2*k3**2) + 4*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*f*st**4*(D1*(f**2*k1**2*(143*Pk2*bd1*k2**4*(4*r + 5*s - 6) - 78*Pk2*fd*k1**2*k2**2*(16*r + 20*s - 13) + 13*bd1*k1**2*k2**2*(4*Pk2*(5*r + 5*s - 6) + 6*Pkd2*k2) + 5*fd*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 13*f*k2**2*(b1*k1**2*(11*bd1*k2**2*(2*Pk2 + Pkd2*k2*(1 - 2*s)) + fd*(-11*Pk2*k2**2*(12*r + 15*s - 7) + 6*k1**2*(-2*Pk2*(5*r + 5*s - 3) + Pkd2*k2))) + k2**2*(66*Pk2*bd2*k1**2*(r + s - 1) + 11*bd1*k1**2*(2*K*Pkd2*k2*s + Pk2*(2*K*(5*r + 4*s - 5) - 2*r - s + 2)) + 2*fd*(Pk2*k2**2*(18*C - 9)*(3*r - 1) + k1**2*(3*Pk2*(4*C*(5*r + 4*s - 3) - 12*r - 9*s + 7) + Pkd2*k2*(4*C - 2)*(3*s - 1))) - 44*gd2*k1**2*(Pk2*(5*r + 4*s - 5) + Pkd2*k2*s))) + 143*fd*k1**2*k2**4*(-6*Pk2*b2*(2*r + 2*s - 1) + 8*Pk2*g2*(5*r + 4*s - 2) + 4*Pkd2*g2*k2*(2*s - 1) + 2*b1**2*(Pk2 + Pkd2*k2*s) - b1*(2*K*Pkd2*k2*(2*s - 1) + Pk2*(4*K*(5*r + 4*s - 2) - 4*r - 2*s + 1)))) + Dd*f*(f**2*k1**4*(-78*Pk2*k2**2*(16*r + 20*s - 13) + 5*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 13*f*k2**2*(20*Pk2*b1*k1**4*(4*r + 4*s - 3) + 11*Pk2*b1*k1**2*k2**2*(16*r + 20*s - 13) + Pk2*k2**4*(36 - 72*C)*(2*r - 1) - 2*k1**2*k2**2*(Pk2*(8*C*(10*r + 8*s - 7) - 48*r - 36*s + 33) + Pkd2*k2*(4*C - 2)*(4*s - 1))) + 143*k1**2*k2**4*(2*K*Pkd2*b1*k2*(1 - 4*s) + Pk2*b1*(-4*K*(10*r + 8*s - 7) + 8*r + 4*s - 5) - 6*Pk2*b2*(4*r + 4*s - 3) + 8*Pk2*g2*(10*r + 8*s - 7) + Pkd2*b1**2*k2*(4*s - 1) + 4*Pkd2*g2*k2*(4*s - 1))))/(15015*d*k1*k2**2*k3**4) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*k1*st**2*(99*Pkd2*b1**3*k2**3*(D1*fd*s + Dd*f*(4*s - 1)) + 11*b1**2*(D1*(9*Pkd2*bd1*f*k2**3*(3*s - 1) + fd*(18*K*Pkd2*k2**3*s + 8*Pk2*f*k1**2*s - 9*Pk2*k2**2*(2*K*(s - 1) + f*(8*r - 3) + 2*r + 1) - 4*Pkd2*f*k1**2*k2*s)) + 2*Dd*f*(f*(36*Pk2*k2**2*(1 - 2*r) + k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1)) + 9*k2**2*(K*Pkd2*k2*(4*s - 1) + Pk2*(-4*K*s + K - 4*r + 2)))) + 11*b1*(D1*bd1*f*(f*(9*Pk2*k2**2*(5 - 8*r) + 2*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1)) + 9*k2**2*(2*K*Pkd2*k2*(2*s - 1) + Pk2*(-4*K*s - 4*r + 3))) + D1*(6*Pk2*f**2*fd*k1**2*(1 - 3*s) + f*(fd*(k1**2*(-2*Pk2*s + Pk2) + k2**2*(Pk2*(C*(4 - 8*s) + 18*K*(2*r + 6*s - 3) - 4*r + 4*s - 1) + Pkd2*k2*s*(8*C - 4))) + 18*k2**2*s*(Pkd2*bd2*k2 + 2*gd2*(Pk2 - Pkd2*k2))) + 18*fd*k2**2*(2*Pk2*g2*(s - 1) + Pkd2*b2*k2*s - 2*Pkd2*g2*k2*s)) + Dd*f*(6*Pk2*f**2*k1**2*(1 - 4*s) + f*(k1**2*(-4*Pk2*s + Pk2) + 2*k2**2*(Pk2*(C*(2 - 8*s) + 9*K*(4*r + 12*s - 5) - 4*r + 4*s + 1) + Pkd2*k2*(2*C - 1)*(4*s - 1))) + 18*k2**2*(4*s - 1)*(Pkd2*b2*k2 + 2*g2*(Pk2 - Pkd2*k2)))) + f*(D1*(-66*Pk2*bd1*f**2*k1**2*s + f*(5*Pk2*fd*k1**2*(3*s - 1) + Pk2*fd*k2**2*(12*C - 6)*(27*r + 33*s - 20) + Pk2*k2**2*(198*bd2 - 396*gd2)*(r + 3*s - 1) + 11*bd1*(-Pk2*k1**2*s + Pk2*k2**2*(-4*C*s + 18*K*(r + 3*s - 1) - 2*r + 2*s + 1) + Pkd2*k2**3*(4*C - 2)*(s - 1))) + 198*k2**2*(Pk2*b2*fd*(2*r + 6*s - 3) - 2*Pk2*fd*g2*(2*r + 6*s - 3) + Pkd2*b2*bd1*k2*(s - 1) + 2*bd1*g2*(Pk2*s + k2*(-Pkd2*s + Pkd2)))) + Dd*Pk2*f*(5*f*k1**2*(4*s - 1) + f*k2**2*(12*C - 6)*(36*r + 44*s - 29) + k2**2*(198*b2 - 396*g2)*(4*r + 12*s - 5))))/(3465*d*k2**2*k3**2) - 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*st**2*(D1*Pk2*bd1*f**2*(k1**2*s + k2**2*r*(16 - 32*C)) + Pk2*b1*f*(D1*(18*bd1*k1**2*s*(3*f + 1) + fd*k1**2*(2*s - 1) + fd*k2**2*(16 - 32*C)*(2*r - 1)) + Dd*f*(k1**2*(4*s - 1) + k2**2*(32 - 64*C)*(2*r - 1))) - 9*b1**3*k1**2*(2*Pk2 - Pkd2*k2)*(D1*fd*s + Dd*f*(4*s - 1)) - 9*b1**2*k1**2*(-D1*Pk2*fd*(f*(6*s - 3) + s - 1) + D1*bd1*f*(2*Pk2 - Pkd2*k2)*(3*s - 1) - Dd*Pk2*f*(3*f + 1)*(4*s - 1)))/(315*d*k1*k2**2) + 2*np.sqrt(7)*1j*np.sqrt(np.pi)*D1**3*Pk3*st**2*(D1*bd1*f*(f**2*k1**4*(11*Pk2*k2**2*(5 - 8*r) - 5*k1**2*(2*Pk2 - Pkd2*k2)*(s - 1)) + 11*f*k2**2*(-16*C*Pk2*k1**2*k2**2*r - 20*C*Pk2*k1**2*k2**2*s + 24*C*Pk2*k1**2*k2**2 - 32*C*Pk2*k2**4*r - 4*C*Pkd2*k1**2*k2**3*s + 4*C*Pkd2*k1**2*k2**3 - 2*K*Pk2*k1**2*(k1**2*(r + 2*s - 1) + 9*k2**2*(r + 3*s - 1)) + Pk2*k1**4*s + 10*Pk2*k1**2*k2**2*r + 11*Pk2*k1**2*k2**2*s - 13*Pk2*k1**2*k2**2 + 16*Pk2*k2**4*r + 2*Pkd2*k1**2*k2**3*s - 2*Pkd2*k1**2*k2**3 + b1*(27*Pk2*k1**2*k2**2*(4*r + 2*s - 3) + k1**4*(2*Pk2*(8*r + 8*s - 7) + 3*Pkd2*k2*(2*s - 1)))) - 99*k1**2*k2**4*(2*Pk2*b1**2*(3*r + 3*s - 2) + 6*Pk2*b2*(r + s - 1) + b1*(2*K*Pkd2*k2*(2*s - 1) + Pk2*(4*K*(4*r + 5*s - 5) - 4*r - 2*s + 3)) - 4*g2*(Pk2*(4*r + 5*s - 6) + Pkd2*k2*(s - 1)))) - 198*Pk2*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + Pk2*f*k1**2*(D1*(15*f**2*fd*k1**4*(4*s - 1) + f*k2**2*(-22*bd2*k1**2*(r + s - 1) + fd*(5*k1**2*(12*C*(r + 2*s - 1) - 6*r - 15*s + 7) + k2**2*(6 - 12*C)*(27*r + 33*s - 20)) + 44*gd2*(k1**2*(r + 2*s - 1) + 9*k2**2*(r + 3*s - 1))) + 22*fd*k2**2*(b2*k1**2*(-2*r - 2*s + 1) + 4*g2*k1**2*(r + 2*s - 1) + 18*g2*k2**2*(2*r + 6*s - 3))) + Dd*f*(15*f**2*k1**4*(4*s - 1) + f*k2**2*(5*k1**2*(16*C*(r + 2*s - 1) - 8*r - 20*s + 9) + k2**2*(6 - 12*C)*(36*r + 44*s - 29)) + 22*k2**2*(b2*k1**2*(-4*r - 4*s + 3) + 8*g2*k1**2*(r + 2*s - 1) + 18*g2*k2**2*(4*r + 12*s - 5)))) + 11*b1**2*k1**2*k2**2*(D1*fd*(-18*K*k2**2*(4*Pk2*r + 5*Pk2*s + Pk2 + Pkd2*k2*s) + 54*Pk2*f*k2**2*(2*r + s - 1) + 9*Pk2*k2**2*(2*r + s) + 2*f*k1**2*(Pk2*(8*r + 8*s - 5) + 3*Pkd2*k2*s)) + Dd*f*(f*(27*Pk2*k2**2*(8*r + 4*s - 5) + k1**2*(8*Pk2*(4*r + 4*s - 3) + 3*Pkd2*k2*(4*s - 1))) - 9*k2**2*(2*K*Pkd2*k2*(4*s - 1) + Pk2*(K*(32*r + 40*s - 26) - 8*r - 4*s + 5)))) + b1*(D1*(f**2*fd*k1**4*(-30*Pk2*k1**2*s + 11*Pk2*k2**2*(11 - 24*r) + 15*Pkd2*k1**2*k2*s) - 11*f*k2**2*(fd*(Pk2*k1**4*(4*K*(r + 2*s - 1) - 2*s + 1) + Pk2*k2**4*(32*C - 16)*(2*r - 1) + 2*k1**2*k2**2*(Pk2*(2*C*(8*r + 10*s - 3) + 9*K*(2*r + 6*s - 3) - 10*r - 11*s + 4) + Pkd2*k2*s*(4*C - 2))) - 18*k1**2*k2**2*(-3*Pk2*bd2*(r + s - 1) + 2*gd2*(Pk2*(4*r + 5*s - 4) + Pkd2*k2*s))) + 198*fd*k1**2*k2**4*(-3*Pk2*b2*(r + s) + 2*g2*(4*Pk2*r + 5*Pk2*s + Pk2 + Pkd2*k2*s))) - Dd*f*(f**2*k1**4*(176*Pk2*k2**2*(2*r - 1) + 5*k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1)) + 11*f*k2**2*(Pk2*k1**4*(8*K*(r + 2*s - 1) - 4*s + 1) + Pk2*k2**4*(64*C - 32)*(2*r - 1) + k1**2*k2**2*(Pk2*(C*(64*r + 80*s - 52) + 18*K*(4*r + 12*s - 5) - 40*r - 44*s + 31) + Pkd2*k2*(4*C - 2)*(4*s - 1))) + 198*k1**2*k2**4*(3*Pk2*b2*(4*r + 4*s - 3) + 2*g2*(Pk2*(-16*r - 20*s + 13) + Pkd2*k2*(1 - 4*s))))))/(3465*d*k1*k2**2*k3**4)
        
        return (perm12+perm13+perm23)
    
    def l3m1(cosmo_functions,k1,k2,k3=None,theta=None,zz=0,r=0,s=0,nonlin=False,growth2=False):
        
        #get generic cosmology parameters
        k1,k2,k3,theta,Pk1,Pk2,Pk3,Pkd1,Pkd2,Pkd3,Pkdd1,Pkdd2,Pkdd3,d,K,C,f,D1,b1,b2,g2 = cosmo_functions.get_params(k1,k2,k3,theta,zz,nonlin=nonlin,growth2=growth2)
        
        fd,Dd,gd2,bd2,bd1,fdd,Ddd,gdd2,bdd2,bdd1 = cosmo_functions.get_derivs(zz)
        
        st = np.sin(theta)
        ct= np.cos(theta)

        perm12 = 8*np.sqrt(21)*1j*np.sqrt(np.pi)*C*D1**3*Pk1*Pk2*f*k2**3*st**5*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) - f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(693*d*k3**4) - 16*np.sqrt(21)*1j*np.sqrt(np.pi)*C*D1**3*Pk1*Pk2*k1**2*k2*st*(2*D1*bd1*f**2*(r + s - 1) + 3*b1**2*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + 2*b1*f*(3*D1*bd1*(r + s - 1) + (D1*fd + 2*Dd*f)*(2*r + 2*s - 1)))/(105*d*k3**4) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*C*D1**3*Pk1*Pk2*k2*st**3*(11*D1*bd1*f*(-6*b1*k2**2 + f*(3*k1**2 + k2**2))*(r + s - 1) - 33*b1**2*k2**2*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + 11*b1*f*(3*k1**2 + k2**2)*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + 21*f**2*k1**2*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(1155*d*k3**4) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*C*D1**3*Pk2*Pkd1*f*k1*k2*st**3*(11*D1*bd1*f*(r - 1) + 11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 7*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(1155*d*k3**2) + 16*np.sqrt(21)*1j*np.sqrt(np.pi)*C*D1**3*Pk2*Pkd1*k1*k2*st*(2*D1*bd1*f**2*r + 3*b1**2*(D1*fd*r + Dd*f*(4*r - 1)) + b1*f*(3*D1*bd1*(2*r - 1) + 4*D1*fd*r - 2*D1*fd + 8*Dd*f*r - 2*Dd*f))/(315*d*k3**2) + 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**6*f*k2**3*st*(C - 1)*(22*D1*bd1*f*(r + s - 1) + 22*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + 15*f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(693*d*k3**4) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**5*f*k2**2*st*(k1**2*(24*C - 29) - 5*k2**2)*(22*D1*bd1*f*(r + s - 1) + 22*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + 15*f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(3465*d*k1*k3**4) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**4*f*k2**3*st**3*(C - 1)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + 7*f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(231*d*k3**4) - 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**4*k2*st*(-22*D1*bd1*f*(r + s - 1)*(9*b1*k2**2*(C - 1) + f*k1**2*(9*C - 15) - f*k2**2*(2*C + 9)) - 99*b1**2*k2**2*(C - 1)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) - 22*b1*f*(D1*fd + 2*Dd*f)*(k1**2*(9*C - 15) - k2**2*(2*C + 9))*(2*r + 2*s - 1) - 15*f**2*(k1**2*(9*C - 15) - k2**2*(5*C + 6))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(3465*d*k3**4) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**3*f*k2**2*st**3*(k1**2*(12*C - 17) - 5*k2**2)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + 7*f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(1155*d*k1*k3**4) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**3*st*(22*D1*bd1*f*(-9*b1*k2**2*(k1**2*(5 - 4*C) + k2**2) + f*(k1**4*(4*C - 13) - k1**2*k2**2*(12*C + 24) - 3*k2**4))*(r + s - 1) - 99*b1**2*k2**2*(k1**2*(5 - 4*C) + k2**2)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + 22*b1*f*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1)*(k1**4*(4*C - 13) - k1**2*k2**2*(12*C + 24) - 3*k2**4) + 15*f**2*k1**2*(k1**2*(4*C - 13) - k2**2*(24*C + 9))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(3465*d*k1*k3**4) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**2*f*k2**3*st**5*(C - 1)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) - f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(693*d*k3**4) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**2*k2*st**3*(-11*D1*bd1*f*(r + s - 1)*(-6*b1*k2**2*(C - 1) + f*k1**2*(3*C - 9) - f*k2**2*(9*C + 7)) + 33*b1**2*k2**2*(C - 1)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) - 11*b1*f*(D1*fd + 2*Dd*f)*(k1**2*(3*C - 9) - k2**2*(9*C + 7))*(2*r + 2*s - 1) - 7*f**2*(k1**2*(3*C - 9) - k2**2*(10*C + 6))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(1155*d*k3**4) - 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**2*st*(22*D1*bd1*f*(9*b1*k2**2*(-k1**2*(C - 2) + k2**2*(C + 1)) + f*(k1**4 + k1**2*k2**2*(6*C + 7) + k2**4*(3*C + 3)))*(r + s - 1) + 99*b1**2*k2**2*(-k1**2*(C - 2) + k2**2*(C + 1))*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + 22*b1*f*(D1*fd + 2*Dd*f)*(k1**4 + k1**2*k2**2*(6*C + 7) + k2**4*(3*C + 3))*(2*r + 2*s - 1) + 15*f**2*k1**2*(k1**2 + k2**2*(9*C + 1))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(3465*d*k2*k3**4) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct*f*k2**2*st**5*(k1**2 + k2**2)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) - f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(693*d*k1*k3**4) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct*k1*st*(99*b1**2*(k1**2 + k2**2*(4*C + 1))*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + 22*b1*f*(9*D1*bd1*(k1**2 + k2**2*(4*C + 1))*(r + s - 1) + (D1*fd + 2*Dd*f)*(k1**2*(4*C + 3) + k2**2*(12*C + 3))*(2*r + 2*s - 1)) + 2*f**2*(30*C*k1**2*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)) + 11*D1*bd1*(k1**2*(4*C + 3) + k2**2*(12*C + 3))*(r + s - 1)))/(3465*d*k3**4) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct*st**3*(11*D1*bd1*f*(-6*b1*k2**2*(k1**2 + k2**2) + f*(3*k1**4 + k1**2*k2**2*(24*C + 4) + k2**4))*(r + s - 1) - 33*b1**2*k2**2*(k1**2 + k2**2)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + 11*b1*f*(D1*fd + 2*Dd*f)*(3*k1**4 + k1**2*k2**2*(24*C + 4) + k2**4)*(2*r + 2*s - 1) + 21*f**2*k1**2*(k1**2 + k2**2*(8*C + 1))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(1155*d*k1*k3**4) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**6*f*k2*st*(C - 1)*(4*Pk2 - Pkd2*k2)*(22*b1*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) + f*(22*D1*bd1*s + 15*D1*fd*(3*s - 1) + 15*Dd*f*(4*s - 1)))/(693*d*k3**2) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**5*f**2*st*(4*Pk2 - Pkd2*k2)*(39*b1*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1)) + f*(39*D1*bd1*s + 28*D1*fd*(4*s - 1) + 28*Dd*f*(4*s - 1)))/(3003*d*k1) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**5*f*st*(22*b1*(D1*fd*(k1**2*(16*C - 21)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(Pk2*(-8*C*r + 8*r - 20*s + 10) + 5*Pkd2*k2*(2*s - 1))) + Dd*f*(k1**2*(16*C - 21)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(Pk2*(-16*C*r + 4*C + 16*r - 40*s + 6) + 5*Pkd2*k2*(4*s - 1)))) + f*(22*D1*bd1*(Pk2*k1**2*s*(64*C - 84) - 2*Pk2*k2**2*(2*C*(r - 1) - 2*r + 5*s + 2) + Pkd2*k1**2*k2*s*(21 - 16*C) + 5*Pkd2*k2**3*s) + D1*fd*(k1**2*(240*C - 315)*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(-2*Pk2*(86*C*(3*r - 1) - 258*r + 225*s + 11) + 75*Pkd2*k2*(3*s - 1))) + Dd*f*k1**2*(240*C - 315)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + Dd*f*k2**2*(-2*Pk2*(86*C*(4*r - 1) - 344*r + 300*s + 11) + 75*Pkd2*k2*(4*s - 1))))/(3465*d*k1*k3**2) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**4*f*k2*st**3*(C - 1)*(4*Pk2 - Pkd2*k2)*(11*b1*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) + f*(11*D1*bd1*s + 7*D1*fd*(3*s - 1) + 7*Dd*f*(4*s - 1)))/(231*d*k3**2) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**4*st*(143*b1**2*k1**2*(4*Pk2 - Pkd2*k2)*(D1*fd*(-9*K*s + 9*K + 10*f*(2*s - 1) + 9*s - 9) + Dd*f*(4*s - 1)*(-9*K + 10*f + 9)) + 13*b1*(D1*(5*f**2*(24*Pk2*fd*k2**2*r + 44*bd1*k1**2*s*(4*Pk2 - Pkd2*k2) + 45*fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) - 66*f*k1**2*(4*Pk2 - Pkd2*k2)*(fd*(K - 1)*(2*s - 1) + s*(3*K*bd1 - 3*bd1 - 3*gd2)) + 198*fd*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) + Dd*f*(5*f**2*(8*Pk2*k2**2*(4*r - 1) + 45*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 66*f*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 198*g2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + f*(5*D1*f**2*(13*bd1*(180*Pk2*k1**2*s + 8*Pk2*k2**2*(r - 1) - 45*Pkd2*k1**2*k2*s) + 5*fd*(5*Pk2*k2**2*(1 - 4*r) + 56*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 858*D1*f*k1**2*s*(4*Pk2 - Pkd2*k2)*(-K*bd1 + bd1 + 2*gd2) + 858*D1*g2*k1**2*(4*Pk2 - Pkd2*k2)*(3*bd1*s + fd*(4*s - 2)) + 25*Dd*f**3*(5*Pk2*k2**2*(1 - 4*r) + 56*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 1716*Dd*f*g2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)))/(45045*d*k1**2*k2) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**4*st*(-198*b1**2*k1**2*k2**2*(C - 1)*(-2*Pk2 + Pkd2*k2)*(D1*fd*s + Dd*f*(4*s - 1)) + 22*b1*f*(D1*(-9*bd1*k1**2*k2**2*(C - 1)*(-2*Pk2 + Pkd2*k2)*(2*s - 1) + 2*fd*(-3*Pk2*k2**4*r + k1**4*(3*C - 7)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(Pk2*(C*(-26*r - 60*s + 36) + 31*r + 24*s - 18) + Pkd2*k2*(C*(4*s - 5) + 14*s - 4)))) + Dd*f*(3*Pk2*k2**4*(1 - 4*r) + k1**4*(6*C - 14)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(-2*C*(52*r + 120*s - 43) + 124*r + 96*s - 55) + Pkd2*k2*(4*C + 14)*(4*s - 1)))) + f**2*(D1*(-66*Pk2*bd1*k2**4*(r - 1) + 11*Pk2*fd*k2**4*(3*r - 1) + 44*bd1*k1**4*s*(3*C - 7)*(4*Pk2 - Pkd2*k2) + 22*bd1*k1**2*k2**2*(Pk2*(-2*C*(13*r + 30*s - 7) + 31*r + 24*s - 19) + 2*Pkd2*k2*(C*(2*s + 3) + 7*s - 3)) + fd*k1**4*(90*C - 210)*(4*Pk2 - Pkd2*k2)*(3*s - 1) + fd*k1**2*k2**2*(Pk2*(-36*C*(46*r + 89*s - 45) + 2049*r + 1584*s - 1211) + Pkd2*k2*(150*C + 120)*(3*s - 1))) + Dd*f*(11*Pk2*k2**4*(4*r - 1) + k1**4*(90*C - 210)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(-12*C*(184*r + 356*s - 135) + 2732*r + 2112*s - 1211) + Pkd2*k2*(150*C + 120)*(4*s - 1)))))/(3465*d*k1**2*k2*k3**2) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**3*f**2*st**3*(4*Pk2 - Pkd2*k2)*(91*b1*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1)) + f*(91*D1*bd1*s + 55*D1*fd*(4*s - 1) + 55*Dd*f*(4*s - 1)))/(3003*d*k1) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**3*f*st**3*(11*b1*(D1*fd*(k1**2*(8*C - 13)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(Pk2*(-r*(24*C - 24) - 20*s + 10) + 5*Pkd2*k2*(2*s - 1))) + Dd*f*(k1**2*(8*C - 13)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(-2*Pk2*(24*C*r - 6*C - 24*r + 20*s + 1) + 5*Pkd2*k2*(4*s - 1)))) + f*(11*D1*bd1*(Pk2*k1**2*s*(32*C - 52) - 2*Pk2*k2**2*(6*C*(r - 1) - 6*r + 5*s + 6) + Pkd2*k1**2*k2*s*(13 - 8*C) + 5*Pkd2*k2**3*s) + D1*fd*(k1**2*(56*C - 91)*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(-2*Pk2*(58*C*(3*r - 1) - 174*r + 105*s + 23) + 35*Pkd2*k2*(3*s - 1))) + Dd*f*k1**2*(56*C - 91)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + Dd*f*k2**2*(-2*Pk2*(58*C*(4*r - 1) - 232*r + 140*s + 23) + 35*Pkd2*k2*(4*s - 1))))/(1155*d*k1*k3**2) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**3*st*(-143*b1**2*(D1*fd*(k1**2*(4*Pk2 - Pkd2*k2)*(16*f*s - 8*f + 9*s - 9) + k2**2*(2*Pk2*(3*K*r + 32*f*s - 8*f - 3*r + 9*s - 9) + Pkd2*k2*(-32*f*s + 8*f - 9*s + 9))) + Dd*f*(k1**2*(4*Pk2 - Pkd2*k2)*(8*f + 9)*(4*s - 1) + k2**2*(2*Pk2*(12*K*r - 3*K + 64*f*s - 16*f - 12*r + 36*s - 6) - Pkd2*k2*(16*f + 9)*(4*s - 1)))) - 26*b1*(D1*(-66*Pk2*fd*g2*k2**2*r + 2*f**2*(-22*bd1*(-8*Pk2*k1**2*s + Pk2*k2**2*(2 - 8*s) + 2*Pkd2*k1**2*k2*s + Pkd2*k2**3*(4*s - 1)) + fd*(30*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(-2*Pk2*(63*r + 75*s - 47) + 15*Pkd2*k2*(1 - 6*s)))) + 11*f*(-6*Pk2*gd2*k2**2*r + 3*bd1*(12*Pk2*k1**2*s + Pk2*k2**2*(2*K*r - K - 2*r + 6*s + 1) - 3*Pkd2*k1**2*k2*s - 3*Pkd2*k2**3*s) + fd*(3*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(2*Pk2*(4*K*r - 2*K - 4*r + 6*s - 1) + 3*Pkd2*k2*(1 - 2*s))))) + Dd*f*(66*Pk2*g2*k2**2*(1 - 4*r) + 4*f**2*(15*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(-2*Pk2*(42*r + 50*s - 23) + 15*Pkd2*k2*(1 - 4*s))) + 11*f*(3*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(2*Pk2*(8*K*r - 2*K - 8*r + 12*s - 1) + 3*Pkd2*k2*(1 - 4*s))))) + 2*f*(D1*(286*Pk2*g2*k2**2*(3*bd1*(r - 1) + 4*fd*(2*r - 1)) + 2*f**2*(13*bd1*(-120*Pk2*k1**2*s + 2*Pk2*k2**2*(21*r + 25*s + 1) + 30*Pkd2*k1**2*k2*s + 15*Pkd2*k2**3*(2*s - 1)) - 5*fd*(Pk2*k2**2*(-352*r - 780*s + 283) + 28*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 143*f*(8*Pk2*gd2*k2**2*r + bd1*(-12*Pk2*k1**2*s - 2*Pk2*k2**2*(r*(2*K - 2) + 3*s) + 3*Pkd2*k1**2*k2*s + 3*Pkd2*k2**3*s))) - 2*Dd*(572*Pk2*f*g2*k2**2*(1 - 4*r) + 5*f**3*(Pk2*k2**2*(-352*r - 780*s + 283) + 28*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)))))/(45045*d*k1*k2**2) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**3*st*(-33*b1**2*k2**2*(D1*fd*(Pk2*k1**2*s*(22 - 16*C) + Pk2*k2**2*r*(4*C - 4) + Pkd2*k1**2*k2*s*(8*C - 11) - 3*Pkd2*k2**3*s) + Dd*f*(-k1**2*(8*C - 11)*(2*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(Pk2*(4*C - 4)*(4*r - 1) + 3*Pkd2*k2*(1 - 4*s)))) - 11*b1*f*(D1*(3*bd1*k1**2*k2**2*(8*C - 11)*(-2*Pk2 + Pkd2*k2)*(2*s - 1) + 3*bd1*k2**4*(Pk2*(4*C - 4)*(2*r - 1) + 3*Pkd2*k2*(1 - 2*s)) + 6*fd*k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 2*fd*k1**2*k2**2*(2*Pk2*(2*C*(8*r + 38*s - 23) - 33*r - 54*s + 38) + Pkd2*k2*(-16*C*(s - 1) - 28*s + 3)) - 4*fd*k2**4*(Pk2*(C*(4 - 8*r) + 13*r + 22*s - 15) + 3*Pkd2*k2*s)) + 2*Dd*f*(3*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(4*C*Pk2*(16*r + 76*s - 23) - 3*Pk2*(44*r + 72*s - 29) + Pkd2*k2*(-8*C - 14)*(4*s - 1)) + k2**4*(Pk2*(8*C*(4*r - 1) - 52*r - 88*s + 35) + 3*Pkd2*k2*(1 - 4*s)))) + f**2*(D1*(22*bd1*(3*k1**4*s*(-4*Pk2 + Pkd2*k2) + k1**2*k2**2*(Pk2*(-76*C*s + r*(33 - 16*C) + 54*s - 11) + Pkd2*k2*(8*C*(s + 1) + 14*s - 11)) + k2**4*(Pk2*(-8*C*r + 13*r + 22*s - 5) + 3*Pkd2*k2*(s - 1))) + fd*(4*Pk2*k2**4*(28*C*(3*r - 1) + 117*r + 243*s - 120) - 45*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k1**2*k2**2*(-2*Pk2*(C*(438*r + 2052*s - 830) - 942*r - 1683*s + 875) + Pkd2*k2*(240*C + 45)*(3*s - 1)))) + Dd*f*(16*Pk2*k2**4*(7*C*(4*r - 1) + 39*r + 81*s - 30) - 45*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(-2*Pk2*(C*(584*r + 2736*s - 830) - 1256*r - 2244*s + 875) + Pkd2*k2*(240*C + 45)*(4*s - 1)))))/(3465*d*k1*k2**2*k3**2) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**2*f*k2*st**5*(C - 1)*(4*Pk2 - Pkd2*k2)*(11*b1*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) + f*(D1*(11*bd1*s - 3*fd*s + fd) + Dd*(-4*f*s + f)))/(693*d*k3**2) - np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**2*st**3*(143*b1**2*k1**2*(4*Pk2 - Pkd2*k2)*(D1*fd*(10*f*(2*s - 1) + (3*K - 3)*(s - 1)) + Dd*f*(4*s - 1)*(3*K + 10*f - 3)) + 13*b1*(D1*(10*f**2*(9*Pk2*fd*k2**2*r + 22*bd1*k1**2*s*(4*Pk2 - Pkd2*k2) + 21*fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) - 11*f*k1**2*(4*Pk2 - Pkd2*k2)*(fd*(K - 1)*(2*s - 1) + s*(-6*K*bd1 + 6*bd1 + 6*gd2)) - 66*fd*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) + Dd*f*(30*f**2*(Pk2*k2**2*(4*r - 1) + 7*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 11*f*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 66*g2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + f*(10*D1*f**2*(39*bd1*(28*Pk2*k1**2*s + Pk2*k2**2*(r - 1) - 7*Pkd2*k1**2*k2*s) + fd*(53*Pk2*k2**2*(1 - 4*r) + 110*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 143*D1*f*k1**2*s*(4*Pk2 - Pkd2*k2)*(-K*bd1 + bd1 + 2*gd2) - 286*D1*g2*k1**2*(4*Pk2 - Pkd2*k2)*(3*bd1*s - 2*fd*s + fd) + 10*Dd*f**3*(53*Pk2*k2**2*(1 - 4*r) + 110*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 286*Dd*f*g2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)))/(15015*d*k1**2*k2) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**2*st*(-1287*b1**3*k1**2*(2*Pk2 - Pkd2*k2)*(D1*fd*s + Dd*f*(4*s - 1)) - 429*b1**2*(3*D1*bd1*f*k1**2*(2*Pk2 - Pkd2*k2)*(3*s - 1) + D1*fd*(Pk2*k2**2*r*(4*f + 1) + k1**2*(Pk2*(8*K*s - 10*K + f*(-6*r + 8*s + 8) - 3*r + 4*s - 2) + Pkd2*k2*(-2*K*s + 3*K + f*(2 - 16*s) - 4*s + 3))) + Dd*f*(Pk2*k2**2*(2*f + 1)*(4*r - 1) - k1**2*(Pk2*(-32*K*s + 8*K + 12*f*r - 16*f*s + f + 12*r - 16*s + 1) + Pkd2*k2*(4*s - 1)*(2*K + 8*f + 4)))) + 13*b1*(-572*D1*K*Pk2*f*fd*k1**2*s + 286*D1*K*Pk2*f*fd*k1**2 + 132*D1*K*Pkd2*f*fd*k1**2*k2*s - 66*D1*K*Pkd2*f*fd*k1**2*k2 - 198*D1*Pk2*bd2*f*k1**2*s + 648*D1*Pk2*f**2*fd*k1**2*r + 1566*D1*Pk2*f**2*fd*k1**2*s - 810*D1*Pk2*f**2*fd*k1**2 + 108*D1*Pk2*f**2*fd*k2**2*r - 36*D1*Pk2*f**2*fd*k2**2 + 220*D1*Pk2*f*fd*k1**2*r + 44*D1*Pk2*f*fd*k1**2*s - 132*D1*Pk2*f*fd*k1**2 + 44*D1*Pk2*f*fd*k2**2*r - 22*D1*Pk2*f*fd*k2**2 + 528*D1*Pk2*f*gd2*k1**2*s + 528*D1*Pk2*fd*g2*k1**2*s - 660*D1*Pk2*fd*g2*k1**2 + 99*D1*Pkd2*bd2*f*k1**2*k2*s + 405*D1*Pkd2*f**2*fd*k1**2*k2*s - 45*D1*Pkd2*f**2*fd*k1**2*k2 + 132*D1*Pkd2*f*fd*k1**2*k2*s - 66*D1*Pkd2*f*fd*k1**2*k2 - 132*D1*Pkd2*f*gd2*k1**2*k2*s - 132*D1*Pkd2*fd*g2*k1**2*k2*s + 198*D1*Pkd2*fd*g2*k1**2*k2 + 33*D1*bd1*f*(-Pk2*k2**2*(2*f + 1)*(2*r - 1) + k1**2*(Pk2*(-2*K*(8*s + 1) + f*(6*r - 8*s + 9) + 6*r - 8*s - 1) + Pkd2*k2*(4*K*s + K + 2*f*(8*s - 3) + 8*s - 1))) - 1144*Dd*K*Pk2*f**2*k1**2*s + 286*Dd*K*Pk2*f**2*k1**2 + 264*Dd*K*Pkd2*f**2*k1**2*k2*s - 66*Dd*K*Pkd2*f**2*k1**2*k2 + 864*Dd*Pk2*f**3*k1**2*r + 2088*Dd*Pk2*f**3*k1**2*s - 738*Dd*Pk2*f**3*k1**2 + 144*Dd*Pk2*f**3*k2**2*r - 36*Dd*Pk2*f**3*k2**2 + 440*Dd*Pk2*f**2*k1**2*r + 88*Dd*Pk2*f**2*k1**2*s - 132*Dd*Pk2*f**2*k1**2 + 88*Dd*Pk2*f**2*k2**2*r - 22*Dd*Pk2*f**2*k2**2 + 2112*Dd*Pk2*f*g2*k1**2*s - 528*Dd*Pk2*f*g2*k1**2 + 540*Dd*Pkd2*f**3*k1**2*k2*s - 135*Dd*Pkd2*f**3*k1**2*k2 + 264*Dd*Pkd2*f**2*k1**2*k2*s - 66*Dd*Pkd2*f**2*k1**2*k2 - 528*Dd*Pkd2*f*g2*k1**2*k2*s + 132*Dd*Pkd2*f*g2*k1**2*k2 - 99*b2*k1**2*(2*Pk2 - Pkd2*k2)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))) + f*(13*D1*bd1*(9*f**2*(4*Pk2*k2**2*r + k1**2*(Pk2*(24*r + 58*s + 8) + 5*Pkd2*k2*(3*s - 2))) + 22*f*(Pk2*k2**2*r + k1**2*(Pk2*(-13*K*s + 5*r + s) + Pkd2*k2*s*(3*K + 3))) + 66*g2*k1**2*(Pk2*(8*s + 2) - Pkd2*k2*(2*s + 1))) - 429*b2*k1**2*(2*Pk2 - Pkd2*k2)*(3*D1*bd1*s + D1*fd*(4*s - 2) + 2*Dd*f*(4*s - 1)) + k1**2*(15*D1*Pk2*f**2*fd*(332*r + 1248*s - 395) - 286*D1*f*s*(6*Pk2*bd2 - 26*Pk2*gd2 - 3*Pkd2*bd2*k2 + 6*Pkd2*gd2*k2) + 572*D1*fd*g2*(13*Pk2 - 3*Pkd2*k2)*(2*s - 1) + 15*Dd*Pk2*f**3*(332*r + 1248*s - 395) + 572*Dd*f*g2*(13*Pk2 - 3*Pkd2*k2)*(4*s - 1))))/(45045*d*k1**2*k2) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**2*st**3*(-33*b1**2*k1**2*k2**2*(C - 1)*(-2*Pk2 + Pkd2*k2)*(D1*fd*s + Dd*f*(4*s - 1)) - 11*b1*f*(D1*(3*bd1*k1**2*k2**2*(C - 1)*(-2*Pk2 + Pkd2*k2)*(2*s - 1) + fd*(2*Pk2*k2**4*r + k1**4*(C - 5)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 2*k1**2*k2**2*(Pk2*(-2*C*(3*r + 7*s - 4) + 11*r - 14*s + 6) + Pkd2*k2*(C*(9*s - 5) + 5*s - 2)))) + Dd*f*(Pk2*k2**4*(4*r - 1) + k1**4*(C - 5)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(-4*C*(6*r + 14*s - 5) + 44*r - 56*s + 3) + Pkd2*k2*(9*C + 5)*(4*s - 1)))) + f**2*(D1*(11*bd1*(-Pk2*k2**4*(r - 1) - k1**4*s*(C - 5)*(4*Pk2 - Pkd2*k2) + k1**2*k2**2*(Pk2*(2*C*(3*r + 7*s - 2) - 11*r + 14*s + 9) - Pkd2*k2*(9*C*s + C + 5*s - 1))) + fd*(23*Pk2*k2**4*(1 - 3*r) - k1**4*(7*C - 35)*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k1**2*k2**2*(Pk2*(C*(366*r + 720*s - 362) - 519*r - 132*s + 217) + Pkd2*k2*(-70*C - 28)*(3*s - 1)))) + Dd*f*(23*Pk2*k2**4*(1 - 4*r) - k1**4*(7*C - 35)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(C*(488*r + 960*s - 362) - 692*r - 176*s + 217) + Pkd2*k2*(-70*C - 28)*(4*s - 1)))))/(1155*d*k1**2*k2*k3**2) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**2*st*(33*b1**2*(D1*fd*(-Pk2*k2**4*r + k1**4*s*(2*C - 6)*(2*Pk2 - Pkd2*k2) + k1**2*k2**2*(Pk2*r*(11 - 8*C) - Pk2*s*(8*C - 8) + Pkd2*k2*s*(6*C + 4))) + Dd*f*(Pk2*k2**4*(1 - 4*r) + k1**4*(2*C - 6)*(2*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(-16*C*(2*r + 2*s - 1) + 44*r + 32*s - 19) + Pkd2*k2*(6*C + 4)*(4*s - 1)))) + 11*b1*f*(3*D1*bd1*(Pk2*k2**4*(1 - 2*r) + k1**4*(2*C - 6)*(2*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(Pk2*(-16*C*(r + s - 1) + 22*r + 16*s - 19) + Pkd2*k2*(6*C + 4)*(2*s - 1))) + 2*D1*fd*(Pk2*k2**4*(2*r - 1) + 2*k1**4*(Pk2*(-22*C*s + 13*C + 9*r + 26*s - 19) + Pkd2*k2*(4*C*s - 3*C + 6*s)) + k1**2*k2**2*(Pk2*(44*C*s - 18*C + 56*r + 76*s - 47) + Pkd2*k2*s*(12*C + 8))) + 2*Dd*f*(Pk2*k2**4*(4*r - 1) + k1**4*(Pk2*(-88*C*s + 22*C + 36*r + 104*s - 35) + Pkd2*k2*(4*C + 6)*(4*s - 1)) + 2*k1**2*k2**2*(Pk2*(44*C*s - 11*C + 56*r + 76*s - 33) + Pkd2*k2*(3*C + 2)*(4*s - 1)))) + f**2*(-22*D1*bd1*(-Pk2*k2**4*r + k1**4*(Pk2*(22*C*s + 4*C - 9*r - 26*s - 3) - 2*Pkd2*k2*(2*C*s + C + 3*s - 3)) + k1**2*k2**2*(Pk2*(-22*C*s + 4*C - 28*r - 38*s + 19) + Pkd2*k2*(-6*C - 4)*(s - 1))) + k1**2*(D1*fd*(Pk2*k2**2*(48*C*(27*r + 33*s - 20) + 303*r + 1062*s - 455) + k1**2*(90*C*Pkd2*k2*(3*s - 1) + Pk2*(-388*C*(3*s - 1) + 483*r + 1686*s - 723))) + Dd*f*(Pk2*k2**2*(192*C*(9*r + 11*s - 5) + 404*r + 1416*s - 455) + k1**2*(90*C*Pkd2*k2*(4*s - 1) + Pk2*(-388*C*(4*s - 1) + 644*r + 2248*s - 723))))))/(3465*d*k1**2*k2*k3**2) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct*f**2*st**5*(4*Pk2 - Pkd2*k2)*(13*b1*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1)) + f*(13*D1*bd1*s + 9*D1*fd*(4*s - 1) + 9*Dd*f*(4*s - 1)))/(3003*d*k1) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct*f*st**5*(-11*b1*(D1*fd*(k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(Pk2*(r*(8*C - 8) + 4*s - 2) + Pkd2*k2*(1 - 2*s))) + Dd*f*(k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(2*Pk2*(8*C*r - 2*C - 8*r + 4*s + 1) + Pkd2*k2*(1 - 4*s)))) + f*(11*D1*bd1*(-4*Pk2*k1**2*s - 2*Pk2*k2**2*(2*C*(r - 1) - 2*r + s + 2) + Pkd2*k1**2*k2*s + Pkd2*k2**3*s) + D1*fd*(k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(2*Pk2*(6*C*r - 2*C - 6*r + 3*s + 1) + Pkd2*k2*(1 - 3*s))) + Dd*f*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + Dd*f*k2**2*(2*Pk2*(C*(8*r - 2) - 8*r + 4*s + 1) + Pkd2*k2*(1 - 4*s))))/(693*d*k1*k3**2) + np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct*st**3*(-143*b1**2*(D1*fd*(k1**2*(4*Pk2 - Pkd2*k2)*(f*(8*s - 4) - 3*s + 3) + k2**2*(Pk2*(-6*K*r + 32*f*s - 8*f + 6*r - 6*s + 6) + Pkd2*k2*(-16*f*s + 4*f + 3*s - 3))) + Dd*f*(k1**2*(4*Pk2 - Pkd2*k2)*(4*f - 3)*(4*s - 1) + k2**2*(3*K*Pk2*(2 - 8*r) + 24*Pk2*(r - s) + 3*Pkd2*k2*(4*s - 1) + 8*f*(2*Pk2 - Pkd2*k2)*(4*s - 1)))) - 13*b1*(D1*(132*Pk2*fd*g2*k2**2*r + 4*f**2*(-11*bd1*(-8*Pk2*k1**2*s + Pk2*k2**2*(2 - 8*s) + 2*Pkd2*k1**2*k2*s + Pkd2*k2**3*(4*s - 1)) + fd*(14*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(Pk2*(-72*r - 81*s + 49) + 7*Pkd2*k2*(1 - 6*s)))) + 11*f*(12*Pk2*gd2*k2**2*r + 6*bd1*(-4*Pk2*k1**2*s - Pk2*k2**2*(2*K*r - K - 2*r + 2*s + 1) + Pkd2*k1**2*k2*s + Pkd2*k2**3*s) + fd*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + fd*k2**2*(2*K*Pk2*(2*r - 1) - 4*Pk2*r + 4*Pk2*s - 2*Pkd2*k2*s + Pkd2*k2))) + Dd*f*(132*Pk2*g2*k2**2*(4*r - 1) + 4*f**2*(14*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(-3*Pk2*(32*r + 36*s - 17) + 14*Pkd2*k2*(1 - 4*s))) + 11*f*(k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(8*K*Pk2*r - 2*K*Pk2 - 8*Pk2*r + 8*Pk2*s - 4*Pkd2*k2*s + Pkd2*k2)))) + f*(D1*(-572*Pk2*g2*k2**2*(3*bd1*(r - 1) - 2*fd*r + fd) - 4*f**2*(-13*bd1*(-56*Pk2*k1**2*s + Pk2*k2**2*(24*r + 27*s - 2) + 14*Pkd2*k1**2*k2*s + 7*Pkd2*k2**3*(2*s - 1)) + fd*(Pk2*k2**2*(-1152*r - 1820*s + 743) + 55*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 143*f*(4*Pk2*gd2*k2**2*r + bd1*(-4*Pk2*k1**2*s - 2*Pk2*k2**2*(r*(K - 1) + s) + Pkd2*k1**2*k2*s + Pkd2*k2**3*s))) - 4*Dd*(143*Pk2*f*g2*k2**2*(1 - 4*r) + f**3*(Pk2*k2**2*(-1152*r - 1820*s + 743) + 55*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)))))/(15015*d*k1*k2**2) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct*st*(66*b1**3*(Pkd2*k2**3 + k1**2*(-2*Pk2 + Pkd2*k2))*(D1*fd*s + Dd*f*(4*s - 1)) - 11*b1**2*(-6*D1*bd1*f*(3*s - 1)*(Pkd2*k2**3 + k1**2*(-2*Pk2 + Pkd2*k2)) - D1*fd*(k1**2*(2*Pk2*(2*f*s - 9*f - 3) + Pkd2*k2*s*(16*f + 3)) + k2**2*(2*Pk2*f*(16*r + 36*s - 11) + 6*Pk2*(-K*r + K + r + s - 2) + Pkd2*k2*s*(8*f + 3))) - Dd*f*(2*f*(k1**2*(Pk2 + 4*Pkd2*k2)*(4*s - 1) + 2*k2**2*(Pk2*(16*r + 36*s - 13) + Pkd2*k2*(4*s - 1))) + 3*k2*(2*Pk2*k2*(-4*K*r + K + 4*r + 4*s - 2) + Pkd2*k1**2*(4*s - 1) + Pkd2*k2**2*(4*s - 1)))) + b1*(11*D1*bd1*f*(k1**2*(4*Pk2*f*(s + 4) + 6*Pk2 + Pkd2*k2*(8*f + 3)*(2*s - 1)) + k2**2*(Pk2*f*(32*r + 72*s - 30) + 12*Pk2*(-K*r + r + s) + 4*Pkd2*f*k2*(2*s - 1) + 3*Pkd2*k2*(2*s - 1))) + 2*D1*(11*Pk2*f*(5*fd*k1**2*(2*s - 1) + fd*k2**2*(K*(4*r - 2) + 4*r + 10*s - 7) + 6*gd2*k2**2*r) + 66*Pk2*fd*g2*k2**2*(r - 1) + 3*f**2*fd*(2*Pk2*k2**2*(42*r + 66*s - 25) + k1**2*(102*Pk2*s - 44*Pk2 + 15*Pkd2*k2*s))) + 2*Dd*f*(11*Pk2*f*(5*k1**2*(4*s - 1) + k2**2*(8*K*r - 2*K + 8*r + 20*s - 7)) + 66*Pk2*g2*k2**2*(4*r - 1) + 3*f**2*(8*Pk2*k2**2*(14*r + 22*s - 9) + k1**2*(34*Pk2 + 5*Pkd2*k2)*(4*s - 1)))) + 2*f*(D1*bd1*(11*Pk2*f*(5*k1**2*s + k2**2*(r*(2*K + 2) + 5*s)) + 66*Pk2*g2*k2**2*r + 3*f**2*(2*Pk2*k2**2*(14*r + 22*s - 11) + k1**2*(2*Pk2*(17*s + 5) + 5*Pkd2*k2*(s - 1)))) + Pk2*(45*D1*f**2*fd*k1**2*(4*s - 1) + 22*D1*f*k2**2*r*(bd2 - 2*gd2) + 22*D1*fd*k2**2*(b2 - 2*g2)*(2*r - 1) + 45*Dd*f**3*k1**2*(4*s - 1) + 22*Dd*f*k2**2*(b2 - 2*g2)*(4*r - 1))))/(3465*d*k1*k2**2) + np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct*st**3*(-33*b1**2*k2**2*(D1*fd*(-2*Pk2*k1**2*s + Pk2*k2**2*r*(4 - 4*C) + Pkd2*k1**2*k2*s + Pkd2*k2**3*s) - Dd*f*(k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(Pk2*(4*C - 4)*(4*r - 1) + Pkd2*k2*(1 - 4*s)))) - 11*b1*f*(D1*(-3*bd1*k2**2*(k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(Pk2*(4*C - 4)*(2*r - 1) + Pkd2*k2*(1 - 2*s))) + fd*(k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(2*Pk2*(4*C*(r + 10*s - 5) - 6*r + 4*s - 1) + Pkd2*k2*(C*(16 - 32*s) - 4*s + 1)) - 2*k2**4*(2*Pk2*(-2*C*r + C + r - 4*s + 1) + Pkd2*k2*s))) + Dd*f*(k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 2*k1**2*k2**2*(-Pk2*(C*(8*r + 80*s - 22) - 12*r + 8*s + 1) + Pkd2*k2*(8*C + 1)*(4*s - 1)) + k2**4*(2*Pk2*(8*C*r - 2*C - 4*r + 16*s - 3) + Pkd2*k2*(1 - 4*s)))) + f**2*(D1*(11*bd1*(k1**4*(-4*Pk2*s + Pkd2*k2*s) + k1**2*k2**2*(-2*Pk2*(2*C*(r + 10*s - 1) - 3*r + 2*s + 2) + Pkd2*k2*(s*(16*C + 2) - 1)) + k2**4*(Pk2*(-4*C*r + 2*r - 8*s + 2) + Pkd2*k2*(s - 1))) + fd*(2*Pk2*k2**4*(32*C*(3*r - 1) + 99*r + 108*s - 69) - 7*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k1**2*k2**2*(Pk2*(-28*C*(3*r + 30*s - 11) + 366*r + 342*s - 236) + Pkd2*k2*(112*C + 7)*(3*s - 1)))) + Dd*f*(2*Pk2*k2**4*(32*C*(4*r - 1) + 132*r + 144*s - 69) - 7*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(-4*Pk2*(7*C*(4*r + 40*s - 11) - 122*r - 114*s + 59) + Pkd2*k2*(112*C + 7)*(4*s - 1)))))/(1155*d*k1*k2**2*k3**2) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct*st*(-33*b1**2*(-D1*fd*(2*Pk2*k2**4*s + k1**4*(-2*Pk2*s + Pkd2*k2*s) + k1**2*k2**2*(Pk2*r*(8 - 4*C) + Pk2*s*(10 - 8*C) + Pkd2*k2*s*(8*C + 1))) + Dd*f*(2*Pk2*k2**4*(1 - 4*s) + k1**4*(2*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(2*Pk2*(2*C*(4*r + 8*s - 3) - 16*r - 20*s + 9) - Pkd2*k2*(8*C + 1)*(4*s - 1)))) + 11*b1*f*(-3*D1*bd1*(2*Pk2*k2**4*(1 - 2*s) + k1**4*(2*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(2*Pk2*(C*(4*r + 8*s - 6) - 8*r - 10*s + 9) - Pkd2*k2*(8*C + 1)*(2*s - 1))) + 2*D1*fd*(Pk2*k2**4*(8*C*r - 4*C + 10*r + 10*s - 5) + k1**4*(Pk2*(6*s - 5) + 2*Pkd2*k2*s) + 2*k1**2*k2**2*(Pk2*(4*C*(2*r + 7*s - 4) + 13*r + 18*s - 9) + Pkd2*k2*s*(8*C + 1))) + 2*Dd*f*(2*Pk2*k2**4*(8*C*r - 2*C + 10*r + 10*s - 5) + k1**4*(3*Pk2 + Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(4*C*(8*r + 28*s - 9) + 52*r + 72*s - 31) + Pkd2*k2*(8*C + 1)*(4*s - 1)))) + 2*f**2*(11*D1*bd1*(Pk2*k2**4*(4*C*r + 5*r + 5*s - 5) + k1**4*(Pk2*(3*s + 2) + Pkd2*k2*(s - 1)) + k1**2*k2**2*(Pk2*(4*C*(2*r + 7*s - 1) + 13*r + 18*s - 13) + Pkd2*k2*(8*C + 1)*(s - 1))) + Pk2*k1**2*(D1*fd*(37*k1**2*(3*s - 1) + k2**2*(4*C*(87*r + 198*s - 95) + 111*s - 37)) + Dd*f*(37*k1**2*(4*s - 1) + k2**2*(4*C*(116*r + 264*s - 95) + 148*s - 37)))))/(3465*d*k1*k2**2*k3**2) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*f*k2*st**5*(11*D1*bd1*f*(Pk2*k2**2*(r - 1) + k1**2*(2*C*Pkd2*k2*s + Pk2*(-4*C*s + r - 1))) - 11*b1*(2*C*D1*fd*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 2*D1*Pk2*fd*r*(k1**2 + k2**2) + Dd*Pk2*f*k2**2*(1 - 4*r) + Dd*f*k1**2*(4*C*Pk2*(4*s - 1) + 2*C*Pkd2*k2*(1 - 4*s) - 4*Pk2*r + Pk2)) + f*(D1*fd*(Pk2*k2**2*(1 - 3*r) + k1**2*(4*C*Pk2*(3*s - 1) + 2*C*Pkd2*k2*(1 - 3*s) - 3*Pk2*r + Pk2)) + Dd*f*(Pk2*k2**2*(1 - 4*r) + k1**2*(4*C*Pk2*(4*s - 1) + 2*C*Pkd2*k2*(1 - 4*s) - 4*Pk2*r + Pk2))))/(693*d*k1**2*k3**2) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*f*st**5*(-143*b1**2*k1**2*(4*Pk2 - Pkd2*k2)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) + 13*b1*f*(D1*(39*Pk2*fd*k2**2*r + 22*bd1*k1**2*s*(-4*Pk2 + Pkd2*k2) + 3*fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) + Dd*f*(13*Pk2*k2**2*(4*r - 1) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + f**2*(D1*(13*bd1*(12*Pk2*k1**2*s + 13*Pk2*k2**2*(r - 1) - 3*Pkd2*k1**2*k2*s) + 3*fd*(Pk2*k2**2*(1 - 4*r) + 6*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 3*Dd*f*(Pk2*k2**2*(1 - 4*r) + 6*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))))/(9009*d*k1**2*k2) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*st*(3*b1**2*(D1*fd*(Pk2*k2**2*(r + 2*s) + k1**2*(2*C*Pkd2*k2*s + Pk2*r + 2*Pk2*s)) + Dd*f*(Pk2*k2**2*(4*r + 8*s - 3) + k1**2*(2*C*Pkd2*k2*(4*s - 1) + Pk2*(4*r + 8*s - 3)))) + b1*f*(3*D1*bd1*(Pk2*k2**2*(2*r + 4*s - 3) + k1**2*(2*C*Pkd2*k2*(2*s - 1) + Pk2*(2*r + 4*s - 3))) + 2*D1*fd*(Pk2*k2**2*(2*C*(10*r + 6*s - 5) + 2*r + 4*s - 1) + k1**2*(4*C*Pkd2*k2*s + Pk2*(12*C*s - 6*C + 2*r + 4*s - 1))) + 2*Dd*f*(Pk2*k2**2*(8*C*(5*r + 3*s - 2) + 4*r + 8*s - 3) + k1**2*(2*C*Pkd2*k2*(4*s - 1) + Pk2*(24*C*s - 6*C + 4*r + 8*s - 3)))) + 2*f**2*(4*C*Pk2*k1**2*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1)) + D1*bd1*(Pk2*k2**2*(2*C*(5*r + 3*s - 3) + r + 2*s - 2) + k1**2*(2*C*Pkd2*k2*(s - 1) + Pk2*(6*C*s + r + 2*s - 2)))))/(315*d*k2*k3**2) + np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*st**3*(429*b1**3*k1**2*(2*Pk2 - Pkd2*k2)*(D1*fd*s + Dd*f*(4*s - 1)) + 143*b1**2*(3*D1*bd1*f*k1**2*(2*Pk2 - Pkd2*k2)*(3*s - 1) - D1*fd*(Pk2*k2**2*r*(20*f + 3) + k1**2*(Pk2*(-6*K*s + 6*K + 2*f*(3*r + 20*s - 7) + 3*r - 6*s + 6) + Pkd2*k2*(-8*f*s + f + (3*K + 3)*(s - 1)))) - Dd*f*(Pk2*k2**2*(10*f + 3)*(4*r - 1) + k1**2*(Pk2*(-24*K*s + 6*K + f*(12*r + 80*s - 23) + 12*r - 24*s + 3) - Pkd2*k2*(4*s - 1)*(-3*K + 4*f - 3)))) - 13*b1*(44*D1*K*Pk2*f*fd*k1**2*s - 22*D1*K*Pk2*f*fd*k1**2 - 22*D1*K*Pkd2*f*fd*k1**2*k2*s + 11*D1*K*Pkd2*f*fd*k1**2*k2 - 66*D1*Pk2*bd2*f*k1**2*s - 114*D1*Pk2*f**2*fd*k1**2*r - 270*D1*Pk2*f**2*fd*k1**2*s + 137*D1*Pk2*f**2*fd*k1**2 - 30*D1*Pk2*f**2*fd*k2**2*r + 10*D1*Pk2*f**2*fd*k2**2 - 22*D1*Pk2*f*fd*k1**2*r + 44*D1*Pk2*f*fd*k1**2*s - 11*D1*Pk2*f*fd*k1**2 - 22*D1*Pk2*f*fd*k2**2*r + 11*D1*Pk2*f*fd*k2**2 + 132*D1*Pk2*f*gd2*k1**2*s + 132*D1*Pk2*fd*g2*k1**2*s - 132*D1*Pk2*fd*g2*k1**2 + 33*D1*Pkd2*bd2*f*k1**2*k2*s - 63*D1*Pkd2*f**2*fd*k1**2*k2*s + 7*D1*Pkd2*f**2*fd*k1**2*k2 - 22*D1*Pkd2*f*fd*k1**2*k2*s + 11*D1*Pkd2*f*fd*k1**2*k2 - 66*D1*Pkd2*f*gd2*k1**2*k2*s - 66*D1*Pkd2*fd*g2*k1**2*k2*s + 66*D1*Pkd2*fd*g2*k1**2*k2 + 11*D1*bd1*f*(Pk2*k2**2*(10*f + 3)*(2*r - 1) + k1**2*(Pk2*f*(6*r + 40*s - 9) - 3*Pk2*(-2*r + s*(4*K + 4) + 1) + Pkd2*f*k2*(3 - 8*s) + Pkd2*k2*s*(6*K + 6))) + 88*Dd*K*Pk2*f**2*k1**2*s - 22*Dd*K*Pk2*f**2*k1**2 - 44*Dd*K*Pkd2*f**2*k1**2*k2*s + 11*Dd*K*Pkd2*f**2*k1**2*k2 - 152*Dd*Pk2*f**3*k1**2*r - 360*Dd*Pk2*f**3*k1**2*s + 128*Dd*Pk2*f**3*k1**2 - 40*Dd*Pk2*f**3*k2**2*r + 10*Dd*Pk2*f**3*k2**2 - 44*Dd*Pk2*f**2*k1**2*r + 88*Dd*Pk2*f**2*k1**2*s - 11*Dd*Pk2*f**2*k1**2 - 44*Dd*Pk2*f**2*k2**2*r + 11*Dd*Pk2*f**2*k2**2 + 528*Dd*Pk2*f*g2*k1**2*s - 132*Dd*Pk2*f*g2*k1**2 - 84*Dd*Pkd2*f**3*k1**2*k2*s + 21*Dd*Pkd2*f**3*k1**2*k2 - 44*Dd*Pkd2*f**2*k1**2*k2*s + 11*Dd*Pkd2*f**2*k1**2*k2 - 264*Dd*Pkd2*f*g2*k1**2*k2*s + 66*Dd*Pkd2*f*g2*k1**2*k2 - 33*b2*k1**2*(2*Pk2 - Pkd2*k2)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))) + f*(13*D1*bd1*(f**2*(10*Pk2*k2**2*r + k1**2*(Pk2*(38*r + 90*s + 9) + 7*Pkd2*k2*(3*s - 2))) + 11*f*(Pk2*k2**2*r + k1**2*(Pk2*(r - s*(2*K + 2)) + Pkd2*k2*s*(K + 1))) + 66*g2*k1**2*s*(-2*Pk2 + Pkd2*k2)) - 143*b2*k1**2*(2*Pk2 - Pkd2*k2)*(-D1*(3*bd1*s - 2*fd*s + fd) + Dd*f*(4*s - 1)) + k1**2*(D1*Pk2*f**2*fd*(940*r + 2912*s - 963) - 143*D1*f*s*(2*Pk2 - Pkd2*k2)*(bd2 - 2*gd2) + 286*D1*fd*g2*(2*Pk2 - Pkd2*k2)*(2*s - 1) + Dd*Pk2*f**3*(940*r + 2912*s - 963) + 286*Dd*f*g2*(2*Pk2 - Pkd2*k2)*(4*s - 1))))/(15015*d*k1**2*k2) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*st*(-33*b1**3*k2*(D1*fd*(2*Pk2*k2*r - Pkd2*k1**2*s) + Dd*f*(2*Pk2*k2*(4*r - 1) + Pkd2*k1**2*(1 - 4*s))) + 11*b1**2*(-3*D1*bd1*f*k2*(2*Pk2*k2*(3*r - 1) + Pkd2*k1**2*(1 - 3*s)) + D1*fd*(Pk2*k2**2*(2*f*r - f + 3*r - 3) + k1**2*(Pk2*f*(20*r + 48*s - 11) + 3*Pk2*(r - 1) + Pkd2*k2*s*(3*K + 4*f + 3))) + Dd*Pk2*f*k2**2*(f + 3)*(4*r - 1) + Dd*f*k1**2*(Pk2*(f*(40*r + 96*s - 34) + 12*r - 3) + Pkd2*k2*(4*s - 1)*(3*K + 2*f + 3))) + b1*(11*D1*bd1*f*(6*Pk2*k2**2*r + f*(2*Pk2*k2**2*r + k1**2*(Pk2*(20*r + 48*s - 23) + 2*Pkd2*k2*(2*s - 1))) + k1**2*(6*Pk2*r + Pkd2*k2*(3*K + 3)*(2*s - 1))) + k1**2*(D1*(2*Pk2*f**2*fd*(75*r + 198*s - 47) + 33*Pkd2*fd*k2*s*(b2 - 2*g2) + 33*f*(2*Pk2*fd*(K + 1)*(2*s - 1) + Pkd2*k2*s*(bd2 - 2*gd2))) + Dd*f*(2*Pk2*f**2*(100*r + 264*s - 91) + 66*Pk2*f*(K + 1)*(4*s - 1) + Pkd2*k2*(33*b2 - 66*g2)*(4*s - 1)))) + f*k1**2*(2*D1*bd1*(Pk2*f**2*(25*r + 66*s - 44) + 33*Pk2*f*s*(K + 1) - 33*Pkd2*g2*k2*(s - 1)) + 66*Pk2*(D1*f*s*(bd2 - 2*gd2) + D1*fd*g2*(2 - 4*s) + 2*Dd*f*g2*(1 - 4*s)) + 33*b2*(2*D1*Pk2*fd*(2*s - 1) + D1*Pkd2*bd1*k2*(s - 1) + 2*Dd*Pk2*f*(4*s - 1))))/(3465*d*k1**2*k2) + np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*st**3*(-11*D1*bd1*f*(3*b1*k2**2*(Pk2*k2**2*(2*r - 1) + k1**2*(2*C*Pkd2*k2*(2*s - 1) + Pk2*(2*r - 1))) + f*(-Pk2*k2**4*r + k1**4*(-2*C*Pkd2*k2*s - Pk2*(-4*C*s + r + 2*s - 1)) + k1**2*k2**2*(-2*C*Pkd2*k2*(s - 1) + Pk2*(12*C*(r + 2*s - 1) - 2*r - 2*s + 1)))) - 33*b1**2*k2**2*(D1*fd*(Pk2*k2**2*r + k1**2*(2*C*Pkd2*k2*s + Pk2*r)) + Dd*f*(Pk2*k2**2*(4*r - 1) + k1**2*(2*C*Pkd2*k2*(4*s - 1) + Pk2*(4*r - 1)))) - 11*b1*f*(D1*fd*(Pk2*k2**4*(1 - 2*r) + 2*k1**4*(C*Pkd2*k2*(1 - 2*s) - Pk2*(C*(2 - 4*s) + r + 2*s - 1)) + k1**2*k2**2*(-4*C*Pkd2*k2*s + Pk2*(24*C*(r + 2*s - 1) - 4*r - 4*s + 3))) + Dd*f*(Pk2*k2**4*(1 - 4*r) + k1**4*(2*C*Pkd2*k2*(1 - 4*s) + Pk2*(16*C*s - 4*C - 4*r - 8*s + 3)) + 2*k1**2*k2**2*(C*Pkd2*k2*(1 - 4*s) + 2*Pk2*(3*C*(4*r + 8*s - 3) - 2*r - 2*s + 1)))) + f**2*k1**2*(D1*fd*(Pk2*k2**2*(4*C*(57*r + 66*s - 41) + 21*r + 42*s - 21) - 7*k1**2*(2*C*Pkd2*k2*(1 - 3*s) + Pk2*(12*C*s - 4*C - 3*r - 6*s + 3))) + Dd*f*(Pk2*k2**2*(4*C*(76*r + 88*s - 41) + 28*r + 56*s - 21) - 7*k1**2*(2*C*Pkd2*k2*(1 - 4*s) + Pk2*(16*C*s - 4*C - 4*r - 8*s + 3)))))/(1155*d*k1**2*k2*k3**2) - 32*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**5*f*k2**2*st*(C - 1)*(22*D1*bd1*f*(r - 1) + 22*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 15*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(3465*d*k3**2) + 20*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**4*f**2*k2*st*(39*D1*bd1*f*(r - 1) + 39*b1*(3*D1*fd*r + Dd*f*(4*r - 1)) + 28*f*(4*r - 1)*(D1*fd + Dd*f))/(9009*d*k1) + 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**4*f*k2*st*(k1**2*(4 - 3*C) + k2**2)*(22*D1*bd1*f*(r - 1) + 22*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 15*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(3465*d*k1*k3**2) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**3*f*k2**2*st**3*(C - 1)*(11*D1*bd1*f*(r - 1) + 11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 7*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(1155*d*k3**2) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**3*st*(26*D1*bd1*f*(15*f**2*(3*r - 2) - 11*f*r*(K - 1) + 33*g2*(r - 1)) + 143*b1**2*(D1*fd*r*(-3*K + 8*f + 3) + Dd*f*(4*r - 1)*(-3*K + 4*f + 3)) + 13*b1*(11*D1*bd1*f*(2*r - 1)*(-3*K + 4*f + 3) + 2*D1*(15*f**2*fd*(9*r - 1) - 11*f*fd*(K - 1)*(2*r - 1) + 33*f*gd2*r + 33*fd*g2*r) + 2*Dd*f*(4*r - 1)*(45*f**2 - 11*f*(K - 1) + 33*g2)) + 4*f*(D1*(140*f**2*fd*(4*r - 1) + 143*f*gd2*r + 143*fd*g2*(2*r - 1)) + Dd*f*(140*f**2 + 143*g2)*(4*r - 1)))/(45045*d) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**3*st*(22*D1*bd1*f*(3*b1*k2**2*(C - 1)*(2*r - 1) + f*k1**2*(2*C - 5)*(r - 1) + f*k2**2*(-2*C*(r - 2) - 5*r + 3)) + 66*b1**2*k2**2*(C - 1)*(D1*fd*r + Dd*f*(4*r - 1)) + 22*b1*f*(-2*D1*fd*(k1**2*r*(5 - 2*C) + k2**2*(2*C*r + C + 5*r - 1)) + Dd*f*(4*r - 1)*(k1**2*(2*C - 5) - k2**2*(2*C + 5))) + 15*f**2*(k1**2*(2*C - 5) - k2**2*(4*C + 3))*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(3465*d*k3**2) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**2*f**2*k2*st**3*(91*D1*bd1*f*(r - 1) + 91*b1*(3*D1*fd*r + Dd*f*(4*r - 1)) + 55*f*(4*r - 1)*(D1*fd + Dd*f))/(3003*d*k1) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**2*f*k2*st**3*(-k1**2*(C - 2) + k2**2)*(11*D1*bd1*f*(r - 1) + 11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 7*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(1155*d*k1*k3**2) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**2*st*(858*b1**2*(D1*fd*r*(k1**2*(2*f + 1) + k2**2*(4*f + 1)) + Dd*f*(4*r - 1)*(k1**2*(f + 1) + k2**2*(2*f + 1))) + 13*b1*f*(66*D1*bd1*(2*r - 1)*(k1**2*(f + 1) + k2**2*(2*f + 1)) + D1*fd*(k1**2*(45*f*(6*r - 1) + 88*r - 44) + 2*k2**2*(45*f*(3*r - 1) + 44*r - 22)) + 2*Dd*f*(45*f + 22)*(k1**2 + k2**2)*(4*r - 1)) + f**2*(13*D1*bd1*(45*f*(k1**2*(2*r - 1) + 2*k2**2*r) + r*(44*k1**2 + 44*k2**2)) + 420*f*k1**2*(4*r - 1)*(D1*fd + Dd*f)))/(45045*d*k1*k2) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**2*st*(11*D1*bd1*f*(3*b1*k2**2*(2*r - 1)*(k1**2*(3 - 2*C) + k2**2) + 2*f*(k1**4*(r - 1) + k1**2*k2**2*(4*C*r - 6*C + 4*r - 1) + k2**4*r)) + 33*b1**2*k2**2*(k1**2*(3 - 2*C) + k2**2)*(D1*fd*r + Dd*f*(4*r - 1)) + 22*b1*f*(D1*fd*(2*k1**4*r + k1**2*k2**2*(C*(8*r + 2) + 8*r - 3) + k2**4*(2*r - 1)) + Dd*f*(4*r - 1)*(k1**4 + k1**2*k2**2*(4*C + 4) + k2**4)) + 15*f**2*k1**2*(k1**2 + k2**2*(6*C + 1))*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(3465*d*k1*k2*k3**2) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct*f*st**3*(143*b1**2*(2*D1*fd*r + Dd*f*(4*r - 1)) + 13*b1*f*(11*D1*bd1*(2*r - 1) + 7*D1*fd*(9*r - 1) + 21*Dd*f*(4*r - 1)) + f**2*(91*D1*bd1*(3*r - 2) + (4*r - 1)*(110*D1*fd + 110*Dd*f)))/(15015*d) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct*f*st**3*(k1**2 + k2**2*(4*C + 1))*(11*D1*bd1*f*(r - 1) + 11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 7*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(1155*d*k3**2) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct*st*(33*b1**3*(D1*fd*r + Dd*f*(4*r - 1)) + 11*b1**2*(3*D1*bd1*f*(3*r - 1) + D1*fd*(2*f*(8*r - 1) + r*(3*K + 3)) + Dd*f*(4*r - 1)*(3*K + 8*f + 3)) + b1*(44*D1*K*f*fd*r - 22*D1*K*f*fd + 11*D1*bd1*f*(2*f*(8*r - 3) + (3*K + 3)*(2*r - 1)) + 33*D1*bd2*f*r + 135*D1*f**2*fd*r - 45*D1*f**2*fd + 44*D1*f*fd*r - 22*D1*f*fd - 66*D1*f*gd2*r - 66*D1*fd*g2*r + 88*Dd*K*f**2*r - 22*Dd*K*f**2 + 180*Dd*f**3*r - 45*Dd*f**3 + 88*Dd*f**2*r - 22*Dd*f**2 - 264*Dd*f*g2*r + 66*Dd*f*g2 + 33*b2*(D1*fd*r + Dd*f*(4*r - 1))) + f*(D1*bd1*f*r*(22*K + 45*f + 22) - 66*D1*bd1*g2*(r - 1) + 22*D1*(f*r*(bd2 - 2*gd2) + fd*g2*(2 - 4*r)) + 44*Dd*f*g2*(1 - 4*r) + 11*b2*(3*D1*bd1*(r - 1) + 2*D1*fd*(2*r - 1) + 2*Dd*f*(4*r - 1))))/(3465*d) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct*st*(33*b1**2*(k1**2 + k2**2*(2*C + 1))*(D1*fd*r + Dd*f*(4*r - 1)) + 11*b1*f*(3*D1*bd1*(k1**2 + k2**2*(2*C + 1))*(2*r - 1) + 2*D1*fd*(k1**2*(r*(4*C + 2) - 1) + k2**2*(2*C + 1)*(2*r - 1)) + 2*Dd*f*(2*C + 1)*(k1**2 + k2**2)*(4*r - 1)) + 2*f**2*(15*C*k1**2*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)) + 11*D1*bd1*(2*C*(k1**2*(r - 1) + k2**2*r) + r*(k1**2 + k2**2))))/(3465*d*k3**2) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*f**2*k2*st**5*(13*D1*bd1*f*(r - 1) + 13*b1*(3*D1*fd*r + Dd*f*(4*r - 1)) + 9*f*(4*r - 1)*(D1*fd + Dd*f))/(9009*d*k1) + np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*f*st**3*(143*b1**2*(k1**2 + 2*k2**2)*(2*D1*fd*r + Dd*f*(4*r - 1)) + 13*b1*f*(11*D1*bd1*(k1**2 + 2*k2**2)*(2*r - 1) + 7*D1*fd*(k1**2*(6*r - 1) + 2*k2**2*(3*r - 1)) + 14*Dd*f*(k1**2 + k2**2)*(4*r - 1)) + f**2*(91*D1*bd1*(k1**2*(2*r - 1) + 2*k2**2*r) + k1**2*(4*r - 1)*(55*D1*fd + 55*Dd*f)))/(15015*d*k1*k2) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*st*(15*D1*bd1*f**3*k1**2*r + 33*b1**3*(k1**2 + k2**2)*(D1*fd*r + Dd*f*(4*r - 1)) + 11*b1**2*f*(3*D1*bd1*(k1**2 + k2**2)*(3*r - 1) + 2*D1*fd*(k1**2*(4*r - 1) + k2**2*(2*r - 1)) + 2*Dd*f*(2*k1**2 + k2**2)*(4*r - 1)) + b1*f**2*(22*D1*bd1*(k1**2*(4*r - 1) + 2*k2**2*r) + 15*k1**2*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1))))/(3465*d*k1*k2)
        perm13 = 32*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**6*f*k2**5*st*(C - 1)*(22*D1*bd1*f*(r + s - 1) + 22*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 15*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(693*d*k3**6) + 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**6*f*k2**3*st*(C - 1)*(22*b1*(2*s - 1)*(D1*fd + 2*Dd*f) + f*(22*D1*bd1*s + 15*D1*fd*(3*s - 1) + 30*Dd*f*(2*s - 1)))/(693*d*k3**4) + 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**5*f*k2**4*st*(26*D1*bd1*f*(45*f*k2**2 + k1**2*(484*C - 429))*(r + s - 1) + 26*b1*(D1*fd*(45*f*k2**2*(3*r + 3*s - 2) + k1**2*(484*C - 429)*(2*r + 2*s - 1)) + Dd*f*(45*f*k2**2 + k1**2*(484*C - 429))*(4*r + 4*s - 3)) + 15*f*(D1*fd*(56*f*k2**2*(4*r + 4*s - 3) + k1**2*(572*C - 507)*(3*r + 3*s - 2)) + Dd*f*(56*f*k2**2 + k1**2*(572*C - 507))*(4*r + 4*s - 3)))/(45045*d*k1*k3**6) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**5*f*k2**2*st*(22*b1*(2*s - 1)*(D1*fd + 2*Dd*f) + f*(22*D1*bd1*s + 15*D1*fd*(3*s - 1) + 30*Dd*f*(2*s - 1)))/(693*d*k1*k3**2) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**5*f*k2**2*st*(22*b1*(D1*fd*(k1**2*(36*C - 31)*(2*s - 1) + k2**2*(-4*C*r + 14*r + 10*s - 5)) + Dd*f*(k1**2*(72*C - 62)*(2*s - 1) + k2**2*(-8*C*r + 2*C + 28*r + 20*s - 17))) + f*(22*D1*bd1*(k1**2*s*(36*C - 31) + k2**2*(-2*C*(r - 1) + 7*r + 5*s - 7)) + D1*fd*(k1**2*(540*C - 465)*(3*s - 1) + k2**2*(-86*C*(3*r - 1) + 483*r + 225*s - 236)) + Dd*f*k1**2*(1080*C - 930)*(2*s - 1) + Dd*f*k2**2*(-86*C*(4*r - 1) + 644*r + 300*s - 311)))/(3465*d*k1*k3**4) + 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**4*f*k2**5*st**3*(C - 1)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 7*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(231*d*k3**6) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**4*f*k2**3*st**3*(C - 1)*(11*b1*(2*s - 1)*(D1*fd + 2*Dd*f) + f*(11*D1*bd1*s + 7*D1*fd*(3*s - 1) + 14*Dd*f*(2*s - 1)))/(231*d*k3**4) + 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**4*k2**3*st*(13*D1*bd1*f*(r + s - 1)*(225*f**2*k2**2 + 22*f*(k1**2*(76*C - 59) + k2**2*(3*K - 10*b1 - 3)) - k2**2*(-198*K*b1 + 198*b1 + 198*g2)) - 143*b1**2*k2**2*(D1*fd*(10*f*(2*r + 2*s - 1) + (9 - 9*K)*(r + s)) + Dd*f*(-9*K + 10*f + 9)*(4*r + 4*s - 3)) + 13*b1*(D1*(225*f**2*fd*k2**2*(3*r + 3*s - 2) + 22*f*(fd*(k1**2*(76*C - 59) + k2**2*(3*K - 3))*(2*r + 2*s - 1) - 9*gd2*k2**2*(r + s - 1)) - 198*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(225*f**2*k2**2 + 22*f*(k1**2*(76*C - 59) + k2**2*(3*K - 3)) - 198*g2*k2**2)) + f*(D1*(2800*f**2*fd*k2**2*(4*r + 4*s - 3) + 39*f*(fd*k1**2*(380*C - 295)*(3*r + 3*s - 2) - 44*gd2*k2**2*(r + s - 1)) - 1716*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(2800*f**2*k2**2 + f*k1**2*(14820*C - 11505) - 1716*g2*k2**2)))/(45045*d*k3**6) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**4*k2*st*(396*b1**2*k1**2*(C - 1)*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) - 22*b1*f*(2*D1*(-18*bd1*k1**2*s*(C - 1) + fd*k1**2*(4*C - 7)*(2*s - 1) - 3*fd*k2**2*r) + Dd*f*(k1**2*(16*C - 28)*(2*s - 1) + 3*k2**2*(1 - 4*r))) + f**2*(D1*(44*bd1*k1**2*s*(7 - 4*C) + 66*bd1*k2**2*(r - 1) - fd*k1**2*(300*C - 390)*(3*s - 1) + 11*fd*k2**2*(1 - 3*r)) + Dd*f*(-k1**2*(600*C - 780)*(2*s - 1) + 11*k2**2*(1 - 4*r))))/(3465*d*k1**2*k3**2) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**4*k2*st*(5148*b1**2*k1**2*k2**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + 26*b1*f*(2*D1*(99*bd1*k1**2*k2**2*(C - 1)*(2*r + 2*s - 1) + fd*(30*f*k2**4*r + k1**4*(528*C - 385)*(2*s - 1) - 11*k1**2*k2**2*(6*C*(9*r + 10*s - 4) - 63*r - 74*s + 31))) + Dd*f*(20*f*k2**4*(4*r - 1) + k1**4*(2112*C - 1540)*(2*s - 1) - 11*k1**2*k2**2*(6*C*(36*r + 40*s - 29) - 252*r - 296*s + 211))) + f**2*(D1*(26*bd1*(20*f*k2**4*(r - 1) + k1**4*s*(1056*C - 770) - 11*k1**2*k2**2*(6*C*(9*r + 10*s - 11) - 63*r - 74*s + 75)) + fd*(125*f*k2**4*(1 - 4*r) + k1**4*(18720*C - 13650)*(3*s - 1) - 13*k1**2*k2**2*(4*C*(1032*r + 801*s - 611) - 4365*r - 3834*s + 2733))) + Dd*f*(125*f*k2**4*(1 - 4*r) + k1**4*(37440*C - 27300)*(2*s - 1) - 13*k1**2*k2**2*(8*C*(688*r + 534*s - 439) - 5820*r - 5112*s + 4011))))/(45045*d*k1**2*k3**4) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**3*f*k2**4*st**3*(13*D1*bd1*f*(70*f*k2**2 + k1**2*(352*C - 297))*(r + s - 1) + 13*b1*(D1*fd*(70*f*k2**2*(3*r + 3*s - 2) + k1**2*(352*C - 297)*(2*r + 2*s - 1)) + Dd*f*(70*f*k2**2 + k1**2*(352*C - 297))*(4*r + 4*s - 3)) + f*(D1*fd*(550*f*k2**2*(4*r + 4*s - 3) + k1**2*(2912*C - 2457)*(3*r + 3*s - 2)) + Dd*f*(550*f*k2**2 + k1**2*(2912*C - 2457))*(4*r + 4*s - 3)))/(15015*d*k1*k3**6) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**3*f*k2**2*st**3*(11*b1*(2*s - 1)*(D1*fd + 2*Dd*f) + f*(11*D1*bd1*s + 7*D1*fd*(3*s - 1) + 14*Dd*f*(2*s - 1)))/(231*d*k1*k3**2) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**3*f*k2**2*st**3*(11*b1*(D1*fd*(k1**2*(28*C - 23)*(2*s - 1) + k2**2*(-12*C*r + 22*r + 10*s - 5)) + Dd*f*(k1**2*(56*C - 46)*(2*s - 1) + k2**2*(-24*C*r + 6*C + 44*r + 20*s - 21))) + f*(11*D1*bd1*(k1**2*s*(28*C - 23) + k2**2*(-6*C*r + 6*C + 11*r + 5*s - 11)) + D1*fd*(k1**2*(196*C - 161)*(3*s - 1) + k2**2*(-174*C*r + 58*C + 279*r + 105*s - 128)) + Dd*f*k1**2*(392*C - 322)*(2*s - 1) + Dd*f*k2**2*(-58*C*(4*r - 1) + 372*r + 140*s - 163)))/(1155*d*k1*k3**4) + 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**3*k1*k2**2*st*(26*D1*bd1*f*(r + s - 1)*(60*f**2*k2**2 + 11*f*(k1**2*(64*C - 43) + k2**2*(12*K - 32*b1 - 9)) - k2**2*(99*b1*(3 - 4*K) + 396*g2)) - 143*b1**2*k2**2*(D1*fd*(32*f*(2*r + 2*s - 1) + (27 - 36*K)*(r + s)) + Dd*f*(-36*K + 32*f + 27)*(4*r + 4*s - 3)) + 26*b1*(D1*(60*f**2*fd*k2**2*(3*r + 3*s - 2) + 11*f*(fd*(k1**2*(64*C - 43) + k2**2*(12*K - 9))*(2*r + 2*s - 1) - 36*gd2*k2**2*(r + s - 1)) - 396*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(60*f**2*k2**2 + 11*f*(k1**2*(64*C - 43) + k2**2*(12*K - 9)) - 396*g2*k2**2)) + 3*f*(D1*(1120*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(4160*C - 2795)*(3*r + 3*s - 2) - 2288*f*gd2*k2**2*(r + s - 1) - 2288*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(1120*f**2*k2**2 + f*k1**2*(4160*C - 2795) - 2288*g2*k2**2)))/(45045*d*k3**6) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**3*st*(2*D1*bd1*f**2*s + 3*b1**2*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) + 2*b1*f*(3*D1*bd1*s + D1*fd*(2*s - 1) + 2*Dd*f*(2*s - 1)))/(105*d*k1) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**3*st*(33*b1**2*(D1*fd*(k1**2*(12*C - 9)*(s - 1) + k2**2*r*(2 - 2*C)) + 2*Dd*f*(k1**2*(12*C - 9)*(2*s - 1) + k2**2*(-4*C*r + C + 4*r - 1))) - 11*b1*f*(2*D1*(9*bd1*k1**2*s*(3 - 4*C) + 3*bd1*k2**2*(C - 1)*(2*r - 1) + fd*k1**2*(4*C - 2)*(2*s - 1) + fd*k2**2*(C*(8*r - 4) - 3*r + 22*s - 7)) + Dd*f*(k1**2*(16*C - 8)*(2*s - 1) + k2**2*(8*C*(4*r - 1) - 12*r + 88*s - 41))) - f**2*(D1*(44*bd1*k1**2*s*(2*C - 1) + 11*bd1*k2**2*(r*(8*C - 3) + 22*s - 5) + fd*k1**2*(240*C - 165)*(3*s - 1) + 2*fd*k2**2*(C*(28 - 84*r) + 159*r + 243*s - 134)) + 2*Dd*f*(k1**2*(240*C - 165)*(2*s - 1) + k2**2*(-112*C*r + 28*C + 212*r + 324*s - 215))))/(3465*d*k1*k3**2) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**3*st*(143*b1**2*k2**2*(D1*fd*(k1**2*(48*C - 39)*(r + s - 1) + k2**2*(8*f*(4*r + 4*s - 3) + r*(12 - 3*K) + 9*s)) + Dd*f*(k1**2*(48*C - 39)*(4*r + 4*s - 3) + k2**2*(-12*K*r + 3*K + 16*f*(4*r + 4*s - 3) + 48*r + 36*s - 30))) + 13*b1*(D1*(4*f**2*k2**4*(22*bd1*(4*r + 4*s - 3) + fd*(48*r - 75*s + 28)) + 11*f*(3*bd1*k1**2*k2**2*(16*C - 13)*(2*r + 2*s - 1) + 3*bd1*k2**4*(-2*K*r + K + 8*r + 6*s - 7) + 2*fd*(k1**4*(28*C - 17)*(2*s - 1) + k1**2*k2**2*(-2*C*(58*r + 82*s - 33) + 91*r + 142*s - 58) + k2**4*(K*(2 - 4*r) + 10*r + 6*s - 5)) + 6*gd2*k2**4*r) + 66*fd*g2*k2**4*r) + Dd*f*(8*f**2*k2**4*(32*r - 50*s + 17) + 11*f*(k1**4*(112*C - 68)*(2*s - 1) + k1**2*k2**2*(C*(-464*r - 656*s + 444) + 364*r + 568*s - 375) + 2*k2**4*(K*(2 - 8*r) + 20*r + 12*s - 11)) + 66*g2*k2**4*(4*r - 1))) + f*(D1*(4*f**2*k2**4*(13*bd1*(16*r - 25*s + 6) - 15*fd*(88*r + 130*s - 87)) + 13*f*(11*bd1*(k1**4*s*(56*C - 34) + k1**2*k2**2*(-4*C*(29*r + 41*s - 37) + 91*r + 142*s - 117) + 2*k2**4*(-2*K*r + 5*r + 3*s - 3)) + fd*k1**4*(420*C - 255)*(3*s - 1) + fd*k1**2*k2**2*(C*(-4062*r - 4356*s + 2806) + 3159*r + 3735*s - 2298) + 88*gd2*k2**4*r) + 286*g2*k2**4*(3*bd1*(r - 1) + 4*fd*(2*r - 1))) + Dd*f*(-60*f**2*k2**4*(88*r + 130*s - 87) + 13*f*(k1**4*(840*C - 510)*(2*s - 1) + k1**2*k2**2*(C*(-5416*r - 5808*s + 4258) + 4212*r + 4980*s - 3543)) + 1144*g2*k2**4*(4*r - 1))))/(45045*d*k1*k3**4) - 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*f*k2**5*st**5*(C - 1)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) - f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(693*d*k3**6) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*f*k2**3*st**5*(C - 1)*(D1*f*(11*bd1*s - 3*fd*s + fd) + Dd*f**2*(2 - 4*s) + 11*b1*(2*s - 1)*(D1*fd + 2*Dd*f))/(693*d*k3**4) - 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*k1**2*k2*st*(26*D1*bd1*f*(r + s - 1)*(45*f**2*k2**2 + f*k1**2*(165 - 286*C) + 99*f*k2**2*(-2*K + 4*b1 + 1) + k2**2*(-594*K*b1 + 297*b1 + 594*g2)) + 1287*b1**2*k2**2*(D1*fd*(f*(8*r + 8*s - 4) + (3 - 6*K)*(r + s)) + Dd*f*(-6*K + 4*f + 3)*(4*r + 4*s - 3)) + 26*b1*(D1*(45*f**2*fd*k2**2*(3*r + 3*s - 2) - 11*f*fd*(k1**2*(26*C - 15) + k2**2*(18*K - 9))*(2*r + 2*s - 1) + 594*f*gd2*k2**2*(r + s - 1) + 594*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(45*f**2*k2**2 - 11*f*(k1**2*(26*C - 15) + k2**2*(18*K - 9)) + 594*g2*k2**2)) - 3*f*(D1*(560*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(1690*C - 975)*(3*r + 3*s - 2) - 3432*f*gd2*k2**2*(r + s - 1) - 3432*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(560*f**2*k2**2 + f*k1**2*(1690*C - 975) - 3432*g2*k2**2)))/(45045*d*k3**6) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*k2**3*st**3*(13*D1*bd1*f*(r + s - 1)*(210*f**2*k2**2 + 11*f*(k1**2*(74*C - 52) + k2**2*(K - 20*b1 - 1)) + k2**2*(-66*K*b1 + 66*b1 + 66*g2)) - 143*b1**2*k2**2*(D1*fd*(10*f*(2*r + 2*s - 1) + (3*K - 3)*(r + s)) + Dd*f*(3*K + 10*f - 3)*(4*r + 4*s - 3)) + 13*b1*(D1*(210*f**2*fd*k2**2*(3*r + 3*s - 2) + 11*f*(fd*(k1**2*(74*C - 52) + k2**2*(K - 1))*(2*r + 2*s - 1) + 6*gd2*k2**2*(r + s - 1)) + 66*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(210*f**2*k2**2 + 11*f*(k1**2*(74*C - 52) + k2**2*(K - 1)) + 66*g2*k2**2)) + 2*f*(D1*(1100*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(3367*C - 2366)*(3*r + 3*s - 2) - 143*f*gd2*k2**2*(r + s - 1) - 143*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(1100*f**2*k2**2 + f*k1**2*(3367*C - 2366) - 143*g2*k2**2)))/(15015*d*k3**6) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*st*(2574*b1**3*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) - 429*b1**2*k2**2*(D1*(-6*bd1*f*k2**2*(3*r + 3*s - 2) + fd*k1**2*(28*C - 18)*(r + s - 1) + fd*k2**2*(-2*K*(7*r + 4*s + 1) + f*(50*r + 56*s - 32) + 17*r + 14*s + 2)) + Dd*f*(k1**2*(28*C - 18)*(4*r + 4*s - 3) + k2**2*(K*(-56*r - 32*s + 30) + f*(100*r + 112*s - 81) + 68*r + 56*s - 45))) - 13*b1*(D1*(3*f**2*k2**4*(11*bd1*(50*r + 56*s - 49) + 2*fd*(225*r - 39*s - 14)) + 11*f*(6*bd1*k1**2*k2**2*(14*C - 9)*(2*r + 2*s - 1) + 3*bd1*k2**4*(-4*K*(7*r + 4*s - 6) + 34*r + 28*s - 33) - 18*bd2*k2**4*(r + s - 1) + 2*fd*(k1**4*(12*C - 6)*(2*s - 1) - 2*k1**2*k2**2*(C*(86*r + 154*s - 63) - 52*r - 108*s + 45) + k2**4*(K*(-50*r - 26*s + 25) + 52*r + 38*s - 26)) + 12*gd2*k2**4*(7*r + 4*s - 4)) + 66*fd*k2**4*(-3*b2*(r + s) + 2*g2*(7*r + 4*s + 1))) + 2*Dd*f*(3*f**2*k2**4*(300*r - 52*s - 49) + 11*f*(k1**4*(24*C - 12)*(2*s - 1) + 2*k1**2*k2**2*(C*(-172*r - 308*s + 197) + 104*r + 216*s - 134) + k2**4*(K*(-100*r - 52*s + 51) + 104*r + 76*s - 64)) - 33*k2**4*(3*b2*(4*r + 4*s - 3) - 2*g2*(28*r + 16*s - 15)))) + f*(D1*(-3*f**2*k2**4*(26*bd1*(75*r - 13*s - 35) - 15*fd*(332*r + 624*s - 395)) - 13*f*(22*bd1*(k1**4*s*(12*C - 6) - 2*k1**2*k2**2*(C*(43*r + 77*s - 57) - 26*r - 54*s + 35) + k2**4*(K*(-25*r - 13*s + 13) + 26*r + 19*s - 19)) + fd*k1**4*(180*C - 90)*(3*s - 1) + fd*k1**2*k2**2*(-12*C*(494*r + 673*s - 389) + 3627*r + 5592*s - 3073) + 44*k2**4*(-3*bd2*(r + s - 1) + 25*gd2*r + 13*gd2*(s - 1))) + 286*k2**4*(9*b2*bd1*(r + s - 1) + 6*b2*fd*(2*r + 2*s - 1) - 2*g2*(3*bd1*(7*r + 4*s - 8) + fd*(50*r + 26*s - 25)))) + Dd*f*(45*f**2*k2**4*(332*r + 624*s - 395) - 13*f*(k1**4*(360*C - 180)*(2*s - 1) + k1**2*k2**2*(-16*C*(494*r + 673*s - 460) + 4836*r + 7456*s - 4937)) + 572*k2**4*(3*b2*(4*r + 4*s - 3) + g2*(-100*r - 52*s + 51)))))/(45045*d*k2*k3**4) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*k2*st**3*(66*b1**2*k1**2*(C - 1)*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) + 11*b1*f*(2*D1*(6*bd1*k1**2*s*(C - 1) + fd*k1**2*(9*C - 8)*(2*s - 1) + fd*k2**2*r) + Dd*f*(k1**2*(36*C - 32)*(2*s - 1) + k2**2*(4*r - 1))) + f**2*(D1*(22*bd1*k1**2*s*(9*C - 8) + 11*bd1*k2**2*(r - 1) + fd*k1**2*(140*C - 126)*(3*s - 1) + 23*fd*k2**2*(3*r - 1)) + Dd*f*(k1**2*(280*C - 252)*(2*s - 1) + 23*k2**2*(4*r - 1))))/(1155*d*k1**2*k3**2) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*k2*st**3*(-858*b1**2*k1**2*k2**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + 13*b1*f*(D1*(-66*bd1*k1**2*k2**2*(C - 1)*(2*r + 2*s - 1) + fd*(45*f*k2**4*r + k1**4*(594*C - 396)*(2*s - 1) - 22*k1**2*k2**2*(2*C*(22*r + 7*s - 3) - 41*r - 16*s + 7))) + Dd*f*(15*f*k2**4*(4*r - 1) + k1**4*(1188*C - 792)*(2*s - 1) - 11*k1**2*k2**2*(8*C*(22*r + 7*s - 9) - 164*r - 64*s + 73))) + f**2*(D1*(13*bd1*(15*f*k2**4*(r - 1) + k1**4*s*(594*C - 396) - 11*k1**2*k2**2*(2*C*(22*r + 7*s - 23) - 41*r - 16*s + 43)) + fd*(265*f*k2**4*(1 - 4*r) + k1**4*(4914*C - 3276)*(3*s - 1) - 13*k1**2*k2**2*(2*C*(699*r + 360*s - 353) - 1287*r - 762*s + 683))) + Dd*f*(265*f*k2**4*(1 - 4*r) + k1**4*(9828*C - 6552)*(2*s - 1) - 13*k1**2*k2**2*(2*C*(932*r + 480*s - 473) - 1716*r - 1016*s + 937))))/(15015*d*k1**2*k3**4) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*st*(2*D1*bd1*f**2*(k1**2*s*(12*C - 6) + k2**2*r) + 3*b1**2*(D1*fd*(k1**2*(12*C - 6)*(s - 1) - k2**2*r) + Dd*f*(k1**2*(24*C - 12)*(2*s - 1) + k2**2*(1 - 4*r))) + b1*f*(D1*(36*bd1*k1**2*s*(2*C - 1) + 3*bd1*k2**2*(1 - 2*r) + fd*k1**2*(24*C - 12)*(2*s - 1) + 2*fd*k2**2*(2*r - 1)) + 2*Dd*f*(k1**2*(24*C - 12)*(2*s - 1) + k2**2*(4*r - 1))))/(315*d*k1**2*k2) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*st*(33*b1**2*(D1*fd*(k1**4*(12*C - 6)*(s - 1) + k1**2*k2**2*(-4*C*(3*r + 2*s - 2) + 9*r + 8*s - 8) + k2**4*r*(4*f + 1)) + Dd*f*(k1**4*(24*C - 12)*(2*s - 1) + k1**2*k2**2*(-4*C*(12*r + 8*s - 7) + 36*r + 32*s - 25) + k2**4*(2*f + 1)*(4*r - 1))) + b1*f*(33*D1*bd1*(k1**4*s*(24*C - 12) + k1**2*k2**2*(-4*C*(6*r + 4*s - 3) + 18*r + 16*s - 9) + k2**4*(2*f + 1)*(2*r - 1)) - 2*k2**2*(D1*fd*(11*k1**2*(C*(4*r - 44*s + 2) - 2*r + 56*s - 13) + k2**2*(18*f*(3*r - 1) + 22*r - 11)) + Dd*f*(11*k1**2*(C*(8*r - 88*s + 42) - 4*r + 112*s - 55) + k2**2*(18*f + 11)*(4*r - 1)))) - f**2*(D1*(22*bd1*k1**2*k2**2*(2*C*(r - 11*s + 9) - r + 28*s - 14) + 2*bd1*k2**4*r*(18*f + 11) + fd*k1**4*(180*C - 90)*(3*s - 1) + fd*k1**2*k2**2*(-48*C*(27*r + 33*s - 20) + 951*r + 1854*s - 935)) + Dd*f*k1**2*(k1**2*(360*C - 180)*(2*s - 1) + k2**2*(-48*C*(36*r + 44*s - 31) + 1268*r + 2472*s - 1553))))/(3465*d*k1**2*k2*k3**2) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*f*k2**4*st**5*(13*D1*bd1*f*(6*f*k2**2 + k1**2*(33 - 44*C))*(r + s - 1) + 13*b1*(D1*fd*(6*f*k2**2*(3*r + 3*s - 2) + k1**2*(33 - 44*C)*(2*r + 2*s - 1)) + Dd*f*(6*f*k2**2 + k1**2*(33 - 44*C))*(4*r + 4*s - 3)) + f*(D1*fd*(54*f*k2**2*(4*r + 4*s - 3) + k1**2*(52*C - 39)*(3*r + 3*s - 2)) + Dd*f*(54*f*k2**2 + k1**2*(52*C - 39))*(4*r + 4*s - 3)))/(9009*d*k1*k3**6) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*f*k2**2*st**5*(D1*f*(11*bd1*s - 3*fd*s + fd) + Dd*f**2*(2 - 4*s) + 11*b1*(2*s - 1)*(D1*fd + 2*Dd*f))/(693*d*k1*k3**2) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*f*k2**2*st**5*(11*b1*(D1*fd*(k1**2*(4*C - 3)*(2*s - 1) + k2**2*(-4*C*r + 6*r + 2*s - 1)) + Dd*f*(k1**2*(8*C - 6)*(2*s - 1) + k2**2*(-8*C*r + 2*C + 12*r + 4*s - 5))) + f*(11*D1*bd1*(k1**2*s*(4*C - 3) + k2**2*(-2*C*(r - 1) + 3*r + s - 3)) + D1*fd*(-k1**2*(4*C - 3)*(3*s - 1) + k2**2*(C*(6*r - 2) - 9*r - 3*s + 4)) - Dd*f*k1**2*(8*C - 6)*(2*s - 1) + Dd*f*k2**2*(C*(8*r - 2) - 12*r - 4*s + 5)))/(693*d*k1*k3**4) - 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*k1**3*st*(26*D1*bd1*f*(r + s - 1)*(45*f**2*k2**2 - 11*f*(k1**2*(4*C - 2) + k2**2*(12*K - 16*b1 - 3)) + k2**2*(-396*K*b1 + 99*b1 + 396*g2)) + 143*b1**2*k2**2*(D1*fd*(16*f*(2*r + 2*s - 1) + (9 - 36*K)*(r + s)) + Dd*f*(-36*K + 16*f + 9)*(4*r + 4*s - 3)) + 26*b1*(D1*(45*f**2*fd*k2**2*(3*r + 3*s - 2) - 11*f*fd*(k1**2*(4*C - 2) + k2**2*(12*K - 3))*(2*r + 2*s - 1) + 396*f*gd2*k2**2*(r + s - 1) + 396*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(45*f**2*k2**2 - 11*f*(k1**2*(4*C - 2) + k2**2*(12*K - 3)) + 396*g2*k2**2)) - 2*f*(D1*(140*f**2*fd*k2**2*(4*r + 4*s - 3) + 39*f*(fd*k1**2*(10*C - 5)*(3*r + 3*s - 2) - 88*gd2*k2**2*(r + s - 1)) - 3432*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(140*f**2*k2**2 + f*k1**2*(390*C - 195) - 3432*g2*k2**2)))/(45045*d*k3**6) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*k1*k2**2*st**3*(13*D1*bd1*f*(r + s - 1)*(56*f**2*k2**2 + 11*f*(k1**2*(36*C - 21) + k2**2*(2*K - 32*b1 - 1)) + k2**2*(-132*K*b1 + 66*b1 + 132*g2)) - 143*b1**2*k2**2*(D1*fd*(16*f*(2*r + 2*s - 1) + (6*K - 3)*(r + s)) + Dd*f*(6*K + 16*f - 3)*(4*r + 4*s - 3)) + 13*b1*(D1*(56*f**2*fd*k2**2*(3*r + 3*s - 2) + 11*f*(fd*(k1**2*(36*C - 21) + k2**2*(2*K - 1))*(2*r + 2*s - 1) + 12*gd2*k2**2*(r + s - 1)) + 132*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(56*f**2*k2**2 + 11*f*(k1**2*(36*C - 21) + k2**2*(2*K - 1)) + 132*g2*k2**2)) + f*(D1*(1320*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(3276*C - 1911)*(3*r + 3*s - 2) - 572*f*gd2*k2**2*(r + s - 1) - 572*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(1320*f**2*k2**2 + f*k1**2*(3276*C - 1911) - 572*g2*k2**2)))/(15015*d*k3**6) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*k1*st*(-1716*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + 143*b1**2*(D1*(-12*bd1*f*k2**2*(3*r + 3*s - 2) + fd*k1**2*(12*C - 6)*(r + s - 1) + fd*k2**2*(-3*K*(11*r + 8*s + 2) + f*(52*r + 70*s - 31) + 15*r + 15*s + 3)) + Dd*f*(k1**2*(12*C - 6)*(4*r + 4*s - 3) + k2**2*(-132*K*r - 96*K*s + 81*K + 4*f*(26*r + 35*s - 24) + 60*r + 60*s - 45))) + 13*b1*(11*D1*bd1*f*(k1**2*(12*C - 6)*(2*r + 2*s - 1) + k2**2*(K*(-66*r - 48*s + 63) + f*(52*r + 70*s - 65) + 30*r + 30*s - 33)) + D1*(6*f**2*fd*k2**2*(118*r + 60*s - 41) - 11*f*(fd*(k1**2*(8*C*(5*r + 14*s - 6) - 20*r - 66*s + 29) + k2**2*(K*(76*r + 52*s - 38) - 34*r - 30*s + 17)) + 6*k2**2*(3*bd2*(r + s - 1) + gd2*(-11*r - 8*s + 8))) + 66*fd*k2**2*(-3*b2*(r + s) + g2*(11*r + 8*s + 2))) + Dd*f*(4*f**2*k2**2*(236*r + 120*s - 119) - 11*f*(4*k1**2*(C*(20*r + 56*s - 33) - 10*r - 33*s + 19) + k2**2*(2*K*(76*r + 52*s - 45) - 68*r - 60*s + 47)) - 66*k2**2*(3*b2*(4*r + 4*s - 3) + g2*(-44*r - 32*s + 27)))) + f*(13*D1*bd1*(2*f**2*k2**2*(118*r + 60*s - 115) - 11*f*(k1**2*(4*C*(5*r + 14*s - 7) - 10*r - 33*s + 14) + k2**2*(38*K*r + 26*K*(s - 1) - 17*r - 15*s + 15)) - 66*k2**2*(3*b2*(r + s - 1) + g2*(-11*r - 8*s + 13))) + D1*(-20*f**2*fd*k2**2*(122*r + 351*s - 206) - 13*f*(fd*k1**2*(708*C*(r + 2*s - 1) - 354*r - 819*s + 391) + 44*k2**2*(3*bd2*(r + s - 1) + gd2*(-19*r - 13*s + 13))) - 572*fd*k2**2*(b2*(6*r + 6*s - 3) + g2*(-38*r - 26*s + 19))) - 4*Dd*f*(5*f**2*k2**2*(122*r + 351*s - 206) + 13*f*k1**2*(59*C*(4*r + 8*s - 5) - 118*r - 273*s + 166) + 143*k2**2*(3*b2*(4*r + 4*s - 3) + g2*(-76*r - 52*s + 45)))))/(45045*d*k3**4) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*st**3*(-D1*bd1*f**2*s + 3*b1**2*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) + b1*f*(D1*(6*bd1*s - 2*fd*s + fd) + Dd*f*(2 - 4*s)))/(105*d*k1) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*st*(D1*bd1*f**2*(r*(2 - 4*C) + 5*s) + 3*b1**2*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) + b1*f*(D1*(6*bd1*s + fd*(-8*C*r + 4*C + 4*r + 10*s - 7)) - 4*Dd*f*(C*(4*r - 1) - 2*r - 5*s + 3)))/(315*d*k1) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*st**3*(33*b1**2*(D1*fd*(k1**2*(4*C - 3)*(s - 1) + k2**2*r*(2 - 2*C)) + 2*Dd*f*(k1**2*(4*C - 3)*(2*s - 1) + k2**2*(-4*C*r + C + 4*r - 1))) + 11*b1*f*(-6*D1*bd1*(k1**2*s*(3 - 4*C) + k2**2*(C - 1)*(2*r - 1)) + 2*D1*fd*(k1**2*(6*C - 3)*(2*s - 1) + k2**2*(C*(2*r - 1) - 3*r - 4*s + 3)) + Dd*f*k1**2*(24*C - 12)*(2*s - 1) + Dd*f*k2**2*(C*(8*r - 2) - 12*r - 16*s + 11)) + f**2*(D1*(66*bd1*k1**2*s*(2*C - 1) + 11*bd1*k2**2*(r*(2*C - 3) - 4*s + 1) + fd*k1**2*(112*C - 63)*(3*s - 1) + fd*k2**2*(C*(32 - 96*r) + 147*r + 108*s - 85)) + Dd*f*(k1**2*(224*C - 126)*(2*s - 1) + k2**2*(-128*C*r + 32*C + 196*r + 144*s - 121))))/(1155*d*k1*k3**2) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*st*(11*b1**2*(D1*fd*(3*k1**2*(4*C*(r + s - 1) - 2*r - 3*s + 3) + k2**2*(3*K*(r - 1) + f*(8*r + 36*s - 25) - 3*r + 3*s + 3)) + Dd*f*(12*k1**2*(C*(4*r + 4*s - 3) - 2*r - 3*s + 2) + k2**2*(12*K*r - 3*K + 8*f*(2*r + 9*s - 5) - 12*r + 12*s - 3))) + b1*(11*D1*bd1*f*(6*k1**2*(C*(4*r + 4*s - 2) - 2*r - 3*s + 1) + k2**2*(f*(8*r + 36*s - 15) + r*(6*K - 6) + 6*s - 3)) + D1*(6*f**2*fd*k2**2*(42*r + 66*s - 47) - 11*f*(fd*k1**2*(4*C - 2)*(8*s - 1) + fd*k2**2*(4*K*r - 2*K - 10*r - 10*s + 5) + 6*gd2*k2**2*r) - 66*fd*g2*k2**2*(r - 1)) + Dd*f*(12*f**2*k2**2*(28*r + 44*s - 29) - 11*f*(k1**2*(32*C - 16)*(2*s - 1) + k2**2*(8*K*r - 2*K - 20*r - 20*s + 15)) + 66*g2*k2**2*(1 - 4*r))) + f*(D1*bd1*(6*f**2*k2**2*(14*r + 22*s - 11) - 11*f*(k1**2*(4*C - 2)*(4*s - 3) + k2**2*(2*K*r - 5*r - 5*s + 5)) - 66*g2*k2**2*r) + D1*(f*fd*k1**2*(-4*C*(87*r + 198*s - 95) + 174*r + 507*s - 227) - 22*f*k2**2*r*(bd2 - 2*gd2) - 22*fd*k2**2*(b2 - 2*g2)*(2*r - 1)) - 2*Dd*f*(2*f*k1**2*(C*(116*r + 264*s - 161) - 58*r - 169*s + 99) + k2**2*(11*b2 - 22*g2)*(4*r - 1))))/(3465*d*k1*k3**2) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*st**3*(143*b1**2*k2**2*(D1*fd*(k1**2*(9 - 12*C)*(r + s - 1) + k2**2*(4*f*(4*r + 4*s - 3) + r*(3*K - 6) - 3*s)) + Dd*f*(k1**2*(9 - 12*C)*(4*r + 4*s - 3) + k2**2*(12*K*r - 3*K + 8*f*(4*r + 4*s - 3) - 24*r - 12*s + 12))) + 13*b1*(D1*(2*f**2*k2**4*(22*bd1*(4*r + 4*s - 3) + fd*(36*r - 81*s + 32)) + 11*f*(-3*bd1*k1**2*k2**2*(4*C - 3)*(2*r + 2*s - 1) - 3*bd1*k2**4*(-2*K*r + K + 4*r + 2*s - 3) + fd*(k1**4*(20*C - 11)*(2*s - 1) - k1**2*k2**2*(4*C*(17*r + 4*s - 1) - 42*r - 8*s + 1) + k2**4*(-2*K*r + K + 4*r + 2*s - 2)) - 6*gd2*k2**4*r) - 66*fd*g2*k2**4*r) + Dd*f*(12*f**2*k2**4*(8*r - 18*s + 7) + 11*f*(k1**4*(40*C - 22)*(2*s - 1) + k1**2*k2**2*(-2*C*(68*r + 16*s - 25) + 84*r + 16*s - 29) + k2**4*(-4*K*r + K + 8*r + 4*s - 4)) + 66*g2*k2**4*(1 - 4*r))) + f*(D1*(2*f**2*k2**4*(13*bd1*(12*r - 27*s + 10) - 2*fd*(864*r + 910*s - 671)) + 13*f*(11*bd1*(k1**4*s*(20*C - 11) + k1**2*k2**2*(C*(-34*r - 8*s + 38) + 21*r + 4*s - 24) + k2**4*(-r*(K - 2) + s - 1)) + fd*k1**4*(140*C - 77)*(3*s - 1) + fd*k1**2*k2**2*(-6*C*(229*r + 170*s - 133) + 912*r + 723*s - 545) + 22*gd2*k2**4*r) - 286*g2*k2**4*(3*bd1*(r - 1) - 2*fd*r + fd)) - 2*Dd*f*(2*f**2*k2**4*(864*r + 910*s - 671) - 13*f*(k1**4*(140*C - 77)*(2*s - 1) + k1**2*k2**2*(C*(-916*r - 680*s + 569) + 608*r + 482*s - 393)) + 143*g2*k2**4*(1 - 4*r))))/(15015*d*k1*k3**4) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*f*k2**3*st**5*(13*D1*bd1*f*(k1**2*(11 - 22*C) + k2**2*(22*b1 + 3*f))*(r + s - 1) + 143*b1**2*k2**2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 13*b1*(D1*fd*(3*f*k2**2*(3*r + 3*s - 2) + k1**2*(11 - 22*C)*(2*r + 2*s - 1)) + Dd*f*(3*f*k2**2 + k1**2*(11 - 22*C))*(4*r + 4*s - 3)) + f*(D1*fd*(36*f*k2**2*(4*r + 4*s - 3) + k1**2*(26*C - 13)*(3*r + 3*s - 2)) + Dd*f*(36*f*k2**2 + k1**2*(26*C - 13))*(4*r + 4*s - 3)))/(9009*d*k3**6) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*f*k2*st**5*(11*b1*(2*D1*fd*(k1**2*(2*C - 1)*(2*s - 1) + k2**2*r) + Dd*f*(k1**2*(8*C - 4)*(2*s - 1) + k2**2*(4*r - 1))) + f*(D1*(22*bd1*k1**2*s*(2*C - 1) + 11*bd1*k2**2*(r - 1) - fd*k1**2*(4*C - 2)*(3*s - 1) + fd*k2**2*(1 - 3*r)) + Dd*f*(-k1**2*(8*C - 4)*(2*s - 1) + k2**2*(1 - 4*r))))/(693*d*k1**2*k3**2) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*f*k2*st**5*(13*b1*(D1*fd*(39*f*k2**4*r - k1**4*(44*C - 22)*(2*s - 1) + 22*k1**2*k2**2*(C*(8*r + 4*s - 2) - 5*r - 2*s + 1)) + Dd*f*(13*f*k2**4*(4*r - 1) - k1**4*(88*C - 44)*(2*s - 1) + 11*k1**2*k2**2*(16*C*(2*r + s - 1) - 20*r - 8*s + 9))) + f*(D1*(169*bd1*f*k2**4*(r - 1) - 286*bd1*k1**4*s*(2*C - 1) + 143*bd1*k1**2*k2**2*(4*C*(2*r + s - 2) - 5*r - 2*s + 5) + 3*f*fd*k2**4*(1 - 4*r) + fd*k1**4*(52*C - 26)*(3*s - 1) - 13*fd*k1**2*k2**2*(12*C*(2*r + s - 1) - 15*r - 6*s + 7)) + Dd*f*(3*f*k2**4*(1 - 4*r) + k1**4*(104*C - 52)*(2*s - 1) - 13*k1**2*k2**2*(16*C*(2*r + s - 1) - 20*r - 8*s + 9))))/(9009*d*k1**2*k3**4) - 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*k1**4*k2*st*(11*b1**2*(D1*fd*(-9*K*(r + s) + f*(4*r + 4*s - 2)) + Dd*f*(-9*K + 2*f)*(4*r + 4*s - 3)) + b1*(22*D1*bd1*f*(-9*K + 2*f)*(r + s - 1) + 3*D1*(5*f**2*fd*(3*r + 3*s - 2) + 22*f*(K*fd*(-2*r - 2*s + 1) + 3*gd2*(r + s - 1)) + 66*fd*g2*(r + s)) + 3*Dd*f*(4*r + 4*s - 3)*(-22*K*f + 5*f**2 + 66*g2)) + 3*f*(D1*bd1*(r + s - 1)*(-22*K*f + 5*f**2 + 66*g2) + 44*D1*f*gd2*(r + s - 1) + 44*D1*fd*g2*(2*r + 2*s - 1) + 44*Dd*f*g2*(4*r + 4*s - 3)))/(3465*d*k3**6) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*k1**2*k2*st**3*(13*D1*bd1*f*(r + s - 1)*(14*f**2*k2**2 - 11*f*(k1**2*(6*C - 3) + k2**2*(K - 12*b1)) - k2**2*(-66*K*b1 + 66*g2)) + 429*b1**2*k2**2*(D1*fd*(K*(r + s) + f*(4*r + 4*s - 2)) + Dd*f*(K + 2*f)*(4*r + 4*s - 3)) + 13*b1*(D1*(14*f**2*fd*k2**2*(3*r + 3*s - 2) - 11*f*(fd*(K*k2**2 + k1**2*(6*C - 3))*(2*r + 2*s - 1) + 6*gd2*k2**2*(r + s - 1)) - 66*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(14*f**2*k2**2 - 11*f*(K*k2**2 + k1**2*(6*C - 3)) - 66*g2*k2**2)) + f*(D1*(-220*f**2*fd*k2**2*(4*r + 4*s - 3) - f*fd*k1**2*(546*C - 273)*(3*r + 3*s - 2) + 286*f*gd2*k2**2*(r + s - 1) + 286*fd*g2*k2**2*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(220*f**2*k2**2 + f*k1**2*(546*C - 273) - 286*g2*k2**2)))/(15015*d*k3**6) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*k1**2*st*(66*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + 11*b1**2*k2**2*(6*D1*bd1*f*(3*r + 3*s - 2) + D1*fd*(6*K*(5*r + 4*s + 1) - 2*f*(9*r + 18*s - 7) - 3*r - 6*s) - 3*Dd*f*(K*(-40*r - 32*s + 26) + 3*f*(4*r + 8*s - 5) + 4*r + 8*s - 5)) - b1*(D1*(f**2*k2**2*(11*bd1*(18*r + 36*s - 31) + 2*fd*(165*r + 177*s - 92)) - 11*f*(2*fd*(k1**2*(6*C - 3)*(2*s - 1) + k2**2*(K*(34*r + 26*s - 17) - 2*r - 4*s + 1)) + 3*k2**2*(bd1*(4*K*(5*r + 4*s - 5) - 2*r - 4*s + 3) + 6*bd2*(r + s - 1) - 4*gd2*(5*r + 4*s - 4))) + 66*fd*k2**2*(-3*b2*(r + s) + 2*g2*(5*r + 4*s + 1))) + 2*Dd*f*(f**2*k2**2*(220*r + 236*s - 173) - 11*f*(k1**2*(12*C - 6)*(2*s - 1) + k2**2*(K*(68*r + 52*s - 43) - 4*r - 8*s + 5)) - 33*k2**2*(3*b2*(4*r + 4*s - 3) - 2*g2*(20*r + 16*s - 13)))) + 2*f*(D1*(f**2*k2**2*(bd1*(-55*r - 59*s + 81) + 30*fd*(2*s - 1)) + 11*f*(bd1*(k1**2*s*(6*C - 3) + k2**2*(17*K*r + 13*K*(s - 1) - r - 2*s + 2)) + fd*k1**2*(4*C - 2)*(3*s - 1) + 2*k2**2*(3*bd2*(r + s - 1) + gd2*(-17*r - 13*s + 13))) + 11*k2**2*(9*b2*bd1*(r + s - 1) + 6*b2*fd*(2*r + 2*s - 1) - 2*g2*(3*bd1*(5*r + 4*s - 6) + fd*(34*r + 26*s - 17)))) + 2*Dd*f*(15*f**2*k2**2*(2*s - 1) + f*k1**2*(44*C - 22)*(2*s - 1) + 11*k2**2*(3*b2*(4*r + 4*s - 3) + g2*(-68*r - 52*s + 43)))))/(3465*d*k2*k3**4) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*st*(D1*(33*b1*fd*k2**2*(2*K*b1*(r - 1) + 2*b1*s + b1 - 4*g2*(r - 1)) + 2*bd1*f**3*k2**2*(25*r + 66*s - 44) + f**2*(2*fd*(b1*k2**2*(75*r + 198*s - 113) + k1**2*(22 - 44*C)*(3*s - 1)) + 11*k2**2*(b1*bd1*(24*s - 11) + 2*bd1*(K*(-5*r - 3*s + 3) + r + 2*s - 2) - (2*bd2 - 4*gd2)*(5*r + 3*s - 3))) + 11*f*k2**2*(b1**2*fd*(24*s - 13) + 3*b1*bd1*(4*K*r + 4*s - 3) - 2*b1*(fd*(K*(10*r + 6*s - 5) - 2*r - 4*s + 1) + 6*gd2*r) - 2*b2*fd*(10*r + 6*s - 5) - 12*bd1*g2*r + 4*fd*g2*(10*r + 6*s - 5))) - 2*Dd*f*(-33*b1*k2**2*(b1*(4*K*r - K + 4*s - 2) - 8*g2*r + 2*g2) + f**2*(b1*k2**2*(-100*r - 264*s + 157) + k1**2*(88*C - 44)*(2*s - 1)) - 11*f*k2**2*(12*b1**2*(2*s - 1) + b1*(K*(-20*r - 12*s + 11) + 4*r + 8*s - 5) - (b2 - 2*g2)*(20*r + 12*s - 11))))/(3465*d*k2*k3**2) + np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*st**3*(858*b1**3*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) - 143*b1**2*k2**2*(D1*(-6*bd1*f*k2**2*(3*r + 3*s - 2) + fd*k1**2*(12*C - 6)*(r + s - 1) + fd*k2**2*(-12*K*r - 6*K*s + 2*f*(r + 4*s - 1) + 3*r)) + Dd*f*(k1**2*(12*C - 6)*(4*r + 4*s - 3) + k2**2*(-24*K*(2*r + s - 1) + f*(4*r + 16*s - 9) + 12*r - 3))) + 13*b1*(D1*(-f**2*k2**4*(11*bd1*(2*r + 8*s - 7) + fd*(-210*r + 54*s + 5)) + 11*f*(3*bd1*k2**2*(k1**2*(2 - 4*C)*(2*r + 2*s - 1) + k2**2*(K*(8*r + 4*s - 6) - 2*r + 1)) + fd*(k1**4*(4*C - 2)*(2*s - 1) - 2*k1**2*k2**2*(C*(8*r - 8*s + 6) - 5*r + 2*s - 2) + k2**4*(-4*K*(2*r + s - 1) + 2*r - 1)) + 6*k2**4*(bd2*(r + s - 1) - 2*gd2*(2*r + s - 1))) + 66*fd*k2**4*(b2*(r + s) - 2*g2*(2*r + s))) + Dd*f*(2*f**2*k2**4*(140*r - 36*s - 17) + 11*f*(k1**4*(8*C - 4)*(2*s - 1) - k1**2*k2**2*(8*C*(4*r - 4*s + 1) - 20*r + 8*s + 1) + k2**4*(-8*K*(2*r + s - 1) + 4*r - 1)) + 66*k2**4*(b2*(4*r + 4*s - 3) - 8*g2*(2*r + s - 1)))) - f*(D1*(f**2*k2**4*(bd1*(-910*r + 234*s + 377) + 3*fd*(940*r + 1456*s - 963)) - 13*f*(11*bd1*(k1**4*s*(4*C - 2) + k1**2*k2**2*(C*(-8*r + 8*s + 12) + 5*r - 2*s - 7) + k2**4*(-2*K*(2*r + s - 1) + r)) + fd*k1**4*(28*C - 14)*(3*s - 1) + fd*k1**2*k2**2*(C*(-732*r - 684*s + 472) + 387*r + 384*s - 257) + 22*k2**4*(-bd2*(r + s - 1) + 2*gd2*(2*r + s - 1))) - 286*k2**4*(b2*(3*bd1*(r + s - 1) - 2*fd*r - 2*fd*s + fd) - 6*bd1*g2*(2*r + s - 2) + 4*fd*g2*(2*r + s - 1))) + Dd*f*(3*f**2*k2**4*(940*r + 1456*s - 963) - 13*f*(k1**4*(56*C - 28)*(2*s - 1) + k1**2*k2**2*(C*(-976*r - 912*s + 700) + 516*r + 512*s - 385)) + 286*k2**4*(b2*(4*r + 4*s - 3) - 8*g2*(2*r + s - 1)))))/(15015*d*k2*k3**4) + np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*st**3*(-D1*bd1*f**2*(k1**2*s*(4*C - 2) + k2**2*r) + 3*b1**2*(D1*fd*(k1**2*(4*C - 2)*(s - 1) + k2**2*r) + Dd*f*(k1**2*(8*C - 4)*(2*s - 1) + k2**2*(4*r - 1))) + b1*f*(D1*(12*bd1*k1**2*s*(2*C - 1) + 3*bd1*k2**2*(2*r - 1) + fd*k1**2*(C*(4 - 8*s) + 4*s - 2) + fd*k2**2*(1 - 2*r)) + Dd*f*(-k1**2*(8*C - 4)*(2*s - 1) + k2**2*(1 - 4*r))))/(105*d*k1**2*k2) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*st*(6*D1*bd1*f**2*k1**2*s*(2*C - 1) + 6*b1**3*k2**2*(D1*fd*r + Dd*f*(4*r - 1)) + b1**2*k2**2*(6*D1*bd1*f*(3*r - 1) + D1*fd*(-2*f*r + f - 3*r + 3) - Dd*f*(f + 3)*(4*r - 1)) + 2*b1*f*(-D1*bd1*k2**2*r*(f + 3) + D1*fd*k1**2*(6*C - 3)*(2*s - 1) + Dd*f*k1**2*(12*C - 6)*(2*s - 1)))/(315*d*k1**2*k2) + np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*st**3*(11*b1**2*(D1*fd*(-k1**4*(12*C - 6)*(s - 1) + k1**2*k2**2*r*(12*C - 9) + k2**4*r*(20*f + 3)) + Dd*f*(-k1**4*(24*C - 12)*(2*s - 1) + k1**2*k2**2*(12*C - 9)*(4*r - 1) + k2**4*(10*f + 3)*(4*r - 1))) + b1*f*(-11*D1*bd1*(k1**4*s*(24*C - 12) + k1**2*k2**2*(9 - 12*C)*(2*r - 1) - k2**4*(10*f + 3)*(2*r - 1)) + k2**2*(D1*fd*(-11*k1**2*(4*C*(8*r + 12*s - 7) - 16*r - 20*s + 13) + k2**2*(f*(10 - 30*r) - 22*r + 11)) + Dd*f*(-44*k1**2*(8*C*(2*r + 3*s - 2) - 8*r - 10*s + 7) - k2**2*(10*f + 11)*(4*r - 1)))) - f**2*(D1*(11*bd1*k1**2*k2**2*(4*C*(4*r + 6*s - 3) - 8*r - 10*s + 5) + bd1*k2**4*r*(10*f + 11) + fd*k1**4*(28*C - 14)*(3*s - 1) + fd*k1**2*k2**2*(-4*C*(57*r + 66*s - 41) + 135*r + 174*s - 103)) + Dd*f*k1**2*(k1**2*(56*C - 28)*(2*s - 1) + k2**2*(-4*C*(76*r + 88*s - 63) + 180*r + 232*s - 161))))/(1155*d*k1**2*k2*k3**2) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**6*f*k2**5*st*(C - 1)*(22*D1*bd1*f*(r + s - 1) + 22*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 15*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(693*d*k3**5) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**5*f*k2**4*st*(22*D1*bd1*f*(r + s - 1) + 22*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 15*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(693*d*k1*k3**3) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**5*f*k2**4*st*(26*D1*bd1*f*(45*f*k2**2 + k1**2*(484*C - 429))*(r + s - 1) + 26*b1*(D1*fd*(45*f*k2**2*(3*r + 3*s - 2) + k1**2*(484*C - 429)*(2*r + 2*s - 1)) + Dd*f*(45*f*k2**2 + k1**2*(484*C - 429))*(4*r + 4*s - 3)) + 15*f*(D1*fd*(56*f*k2**2*(4*r + 4*s - 3) + k1**2*(572*C - 507)*(3*r + 3*s - 2)) + Dd*f*(56*f*k2**2 + k1**2*(572*C - 507))*(4*r + 4*s - 3)))/(45045*d*k1*k3**5) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**4*f*k2**5*st**3*(C - 1)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 7*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(231*d*k3**5) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**4*k2**3*st*(198*b1**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) - 22*b1*f*(-9*D1*bd1*(C - 1)*(2*r + 2*s - 1) + D1*fd*(C*(8*r + 8*s + 2) - 22*r - 22*s + 5) + Dd*f*(4*C - 11)*(4*r + 4*s - 3)) + f**2*(-22*D1*bd1*(2*C*(2*r + 2*s - 5) - 11*r - 11*s + 17) - (150*C - 255)*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))))/(3465*d*k3**3) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**4*k2**3*st*(13*D1*bd1*f*(r + s - 1)*(225*f**2*k2**2 + 22*f*(k1**2*(76*C - 59) + k2**2*(3*K - 10*b1 - 3)) - k2**2*(-198*K*b1 + 198*b1 + 198*g2)) - 143*b1**2*k2**2*(D1*fd*(10*f*(2*r + 2*s - 1) + (9 - 9*K)*(r + s)) + Dd*f*(-9*K + 10*f + 9)*(4*r + 4*s - 3)) + 13*b1*(D1*(225*f**2*fd*k2**2*(3*r + 3*s - 2) + 22*f*(fd*(k1**2*(76*C - 59) + k2**2*(3*K - 3))*(2*r + 2*s - 1) - 9*gd2*k2**2*(r + s - 1)) - 198*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(225*f**2*k2**2 + 22*f*(k1**2*(76*C - 59) + k2**2*(3*K - 3)) - 198*g2*k2**2)) + f*(D1*(2800*f**2*fd*k2**2*(4*r + 4*s - 3) + 39*f*(fd*k1**2*(380*C - 295)*(3*r + 3*s - 2) - 44*gd2*k2**2*(r + s - 1)) - 1716*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(2800*f**2*k2**2 + f*k1**2*(14820*C - 11505) - 1716*g2*k2**2)))/(45045*d*k3**5) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**3*f*k2**4*st**3*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 7*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(231*d*k1*k3**3) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**3*f*k2**4*st**3*(13*D1*bd1*f*(70*f*k2**2 + k1**2*(352*C - 297))*(r + s - 1) + 13*b1*(D1*fd*(70*f*k2**2*(3*r + 3*s - 2) + k1**2*(352*C - 297)*(2*r + 2*s - 1)) + Dd*f*(70*f*k2**2 + k1**2*(352*C - 297))*(4*r + 4*s - 3)) + f*(D1*fd*(550*f*k2**2*(4*r + 4*s - 3) + k1**2*(2912*C - 2457)*(3*r + 3*s - 2)) + Dd*f*(550*f*k2**2 + k1**2*(2912*C - 2457))*(4*r + 4*s - 3)))/(15015*d*k1*k3**5) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**3*k1*k2**2*st*(26*D1*bd1*f*(r + s - 1)*(60*f**2*k2**2 + 11*f*(k1**2*(64*C - 43) + k2**2*(12*K - 32*b1 - 9)) - k2**2*(99*b1*(3 - 4*K) + 396*g2)) - 143*b1**2*k2**2*(D1*fd*(32*f*(2*r + 2*s - 1) + (27 - 36*K)*(r + s)) + Dd*f*(-36*K + 32*f + 27)*(4*r + 4*s - 3)) + 26*b1*(D1*(60*f**2*fd*k2**2*(3*r + 3*s - 2) + 11*f*(fd*(k1**2*(64*C - 43) + k2**2*(12*K - 9))*(2*r + 2*s - 1) - 36*gd2*k2**2*(r + s - 1)) - 396*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(60*f**2*k2**2 + 11*f*(k1**2*(64*C - 43) + k2**2*(12*K - 9)) - 396*g2*k2**2)) + 3*f*(D1*(1120*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(4160*C - 2795)*(3*r + 3*s - 2) - 2288*f*gd2*k2**2*(r + s - 1) - 2288*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(1120*f**2*k2**2 + f*k1**2*(4160*C - 2795) - 2288*g2*k2**2)))/(45045*d*k3**5) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**3*k2**2*st*(2*D1*bd1*f**2*(r + s) + 3*b1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*f*(3*D1*bd1*(2*r + 2*s - 1) + 4*D1*fd*(r + s - 1) + 2*Dd*f*(4*r + 4*s - 3)))/(105*d*k1*k3) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**3*k2**2*st*(11*b1**2*(D1*fd*(k1**2*(48*C - 39)*(r + s - 1) + k2**2*(8*f*(4*r + 4*s - 3) + 9*r + 9*s)) + Dd*f*(k1**2*(48*C - 39) + k2**2*(16*f + 9))*(4*r + 4*s - 3)) + b1*f*(33*D1*bd1*k1**2*(16*C - 13)*(2*r + 2*s - 1) + 22*D1*bd1*k2**2*(4*f*(4*r + 4*s - 3) + 9*r + 9*s - 9) + 2*D1*fd*(-11*k1**2*(8*C*(2*r + 2*s + 1) - 16*r - 16*s - 5) + 3*k2**2*(10*f*(6*r + 6*s - 5) + 22*r + 22*s - 11)) + 2*Dd*f*(k1**2*(88 - 88*C) + k2**2*(60*f + 33))*(4*r + 4*s - 3)) + f**2*(-22*D1*bd1*k1**2*(8*C*(r + s - 3) - 8*r - 8*s + 21) + 6*D1*bd1*k2**2*(10*f*(2*r + 2*s - 1) + 11*r + 11*s - 11) - k1**2*(360*C - 315)*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))))/(3465*d*k1*k3**3) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**2*f*k2**5*st**5*(C - 1)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) - f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(693*d*k3**5) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**2*k1**2*k2*st*(26*D1*bd1*f*(r + s - 1)*(45*f**2*k2**2 + f*k1**2*(165 - 286*C) + 99*f*k2**2*(-2*K + 4*b1 + 1) + k2**2*(-594*K*b1 + 297*b1 + 594*g2)) + 1287*b1**2*k2**2*(D1*fd*(f*(8*r + 8*s - 4) + (3 - 6*K)*(r + s)) + Dd*f*(-6*K + 4*f + 3)*(4*r + 4*s - 3)) + 26*b1*(D1*(45*f**2*fd*k2**2*(3*r + 3*s - 2) - 11*f*fd*(k1**2*(26*C - 15) + k2**2*(18*K - 9))*(2*r + 2*s - 1) + 594*f*gd2*k2**2*(r + s - 1) + 594*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(45*f**2*k2**2 - 11*f*(k1**2*(26*C - 15) + k2**2*(18*K - 9)) + 594*g2*k2**2)) - 3*f*(D1*(560*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(1690*C - 975)*(3*r + 3*s - 2) - 3432*f*gd2*k2**2*(r + s - 1) - 3432*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(560*f**2*k2**2 + f*k1**2*(1690*C - 975) - 3432*g2*k2**2)))/(45045*d*k3**5) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**2*k2**3*st**3*(33*b1**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + 11*b1*f*(3*D1*bd1*(C - 1)*(2*r + 2*s - 1) + D1*fd*(2*C*(9*r + 9*s - 4) - 20*r - 20*s + 9) + Dd*f*(9*C - 10)*(4*r + 4*s - 3)) + f**2*(11*D1*bd1*(C*(9*r + 9*s - 10) - 10*r - 10*s + 11) + (70*C - 77)*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))))/(1155*d*k3**3) - np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**2*k2**3*st**3*(13*D1*bd1*f*(r + s - 1)*(210*f**2*k2**2 + 11*f*(k1**2*(74*C - 52) + k2**2*(K - 20*b1 - 1)) + k2**2*(-66*K*b1 + 66*b1 + 66*g2)) - 143*b1**2*k2**2*(D1*fd*(10*f*(2*r + 2*s - 1) + (3*K - 3)*(r + s)) + Dd*f*(3*K + 10*f - 3)*(4*r + 4*s - 3)) + 13*b1*(D1*(210*f**2*fd*k2**2*(3*r + 3*s - 2) + 11*f*(fd*(k1**2*(74*C - 52) + k2**2*(K - 1))*(2*r + 2*s - 1) + 6*gd2*k2**2*(r + s - 1)) + 66*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(210*f**2*k2**2 + 11*f*(k1**2*(74*C - 52) + k2**2*(K - 1)) + 66*g2*k2**2)) + 2*f*(D1*(1100*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(3367*C - 2366)*(3*r + 3*s - 2) - 143*f*gd2*k2**2*(r + s - 1) - 143*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(1100*f**2*k2**2 + f*k1**2*(3367*C - 2366) - 143*g2*k2**2)))/(15015*d*k3**5) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**2*k2*st*(6*C - 5)*(2*D1*bd1*f**2*(r + s) + 3*b1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*f*(3*D1*bd1*(2*r + 2*s - 1) + 4*D1*fd*(r + s - 1) + 2*Dd*f*(4*r + 4*s - 3)))/(315*d*k3) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**2*k2*st*(99*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) - 33*b1**2*(D1*(-3*bd1*f*k2**2*(3*r + 3*s - 2) + fd*k1**2*(14*C - 9)*(r + s - 1) + fd*k2**2*(-K*(2*r + 2*s + 1) + 2*f*(8*r + 8*s - 5) + 5*r + 5*s + 1)) + Dd*f*(k1**2*(14*C - 9) + k2**2*(-2*K + 8*f + 5))*(4*r + 4*s - 3)) - b1*(33*D1*bd1*f*(k1**2*(14*C - 9)*(2*r + 2*s - 1) + k2**2*(K*(-4*r - 4*s + 5) + 2*f*(8*r + 8*s - 7) + 10*r + 10*s - 11)) + D1*(135*f**2*fd*k2**2*(5*r + 5*s - 4) - 11*f*(2*fd*k1**2*(2*C*(4*r + 4*s + 5) - 4*r - 4*s - 7) + 6*fd*k2**2*(K - 2)*(2*r + 2*s - 1) + k2**2*(9*bd2 - 12*gd2)*(r + s - 1)) + 33*fd*k2**2*(-3*b2*(r + s) + g2*(4*r + 4*s + 2))) + Dd*f*(4*r + 4*s - 3)*(225*f**2*k2**2 - 22*f*(k1**2*(4*C - 2) + k2**2*(3*K - 6)) + k2**2*(-99*b2 + 132*g2))) + f*(D1*bd1*(-45*f**2*k2**2*(5*r + 5*s - 3) + 22*f*(k1**2*(2*C*(2*r + 2*s - 9) - 2*r - 2*s + 11) + k2**2*(3*K - 6)*(r + s - 1)) + 33*k2**2*(3*b2*(r + s - 1) - 2*g2*(2*r + 2*s - 3))) + 3*D1*(f*fd*k1**2*(90*C - 55)*(3*r + 3*s - 2) + 22*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) + 22*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + 3*Dd*f*(f*k1**2*(90*C - 55) + k2**2*(22*b2 - 44*g2))*(4*r + 4*s - 3)))/(3465*d*k3**3) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct*f*k2**4*st**5*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) - f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(693*d*k1*k3**3) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct*f*k2**4*st**5*(13*D1*bd1*f*(6*f*k2**2 + k1**2*(33 - 44*C))*(r + s - 1) + 13*b1*(D1*fd*(6*f*k2**2*(3*r + 3*s - 2) + k1**2*(33 - 44*C)*(2*r + 2*s - 1)) + Dd*f*(6*f*k2**2 + k1**2*(33 - 44*C))*(4*r + 4*s - 3)) + f*(D1*fd*(54*f*k2**2*(4*r + 4*s - 3) + k1**2*(52*C - 39)*(3*r + 3*s - 2)) + Dd*f*(54*f*k2**2 + k1**2*(52*C - 39))*(4*r + 4*s - 3)))/(9009*d*k1*k3**5) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct*k1**3*st*(26*D1*bd1*f*(r + s - 1)*(45*f**2*k2**2 - 11*f*(k1**2*(4*C - 2) + k2**2*(12*K - 16*b1 - 3)) + k2**2*(-396*K*b1 + 99*b1 + 396*g2)) + 143*b1**2*k2**2*(D1*fd*(16*f*(2*r + 2*s - 1) + (9 - 36*K)*(r + s)) + Dd*f*(-36*K + 16*f + 9)*(4*r + 4*s - 3)) + 26*b1*(D1*(45*f**2*fd*k2**2*(3*r + 3*s - 2) - 11*f*fd*(k1**2*(4*C - 2) + k2**2*(12*K - 3))*(2*r + 2*s - 1) + 396*f*gd2*k2**2*(r + s - 1) + 396*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(45*f**2*k2**2 - 11*f*(k1**2*(4*C - 2) + k2**2*(12*K - 3)) + 396*g2*k2**2)) - 2*f*(D1*(140*f**2*fd*k2**2*(4*r + 4*s - 3) + 39*f*(fd*k1**2*(10*C - 5)*(3*r + 3*s - 2) - 88*gd2*k2**2*(r + s - 1)) - 3432*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(140*f**2*k2**2 + f*k1**2*(390*C - 195) - 3432*g2*k2**2)))/(45045*d*k3**5) - np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct*k1*k2**2*st**3*(13*D1*bd1*f*(r + s - 1)*(56*f**2*k2**2 + 11*f*(k1**2*(36*C - 21) + k2**2*(2*K - 32*b1 - 1)) + k2**2*(-132*K*b1 + 66*b1 + 132*g2)) - 143*b1**2*k2**2*(D1*fd*(16*f*(2*r + 2*s - 1) + (6*K - 3)*(r + s)) + Dd*f*(6*K + 16*f - 3)*(4*r + 4*s - 3)) + 13*b1*(D1*(56*f**2*fd*k2**2*(3*r + 3*s - 2) + 11*f*(fd*(k1**2*(36*C - 21) + k2**2*(2*K - 1))*(2*r + 2*s - 1) + 12*gd2*k2**2*(r + s - 1)) + 132*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(56*f**2*k2**2 + 11*f*(k1**2*(36*C - 21) + k2**2*(2*K - 1)) + 132*g2*k2**2)) + f*(D1*(1320*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(3276*C - 1911)*(3*r + 3*s - 2) - 572*f*gd2*k2**2*(r + s - 1) - 572*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(1320*f**2*k2**2 + f*k1**2*(3276*C - 1911) - 572*g2*k2**2)))/(15015*d*k3**5) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct*k1*st*(-132*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + 11*b1**2*(D1*(-12*bd1*f*k2**2*(3*r + 3*s - 2) + fd*k1**2*(12*C - 6)*(r + s - 1) + fd*k2**2*(4*f*(4*r + 4*s - 1) + (3 - 6*K)*(2*r + 2*s + 1))) + 2*Dd*f*(k1**2*(6*C - 3) + k2**2*(-6*K + 4*f + 3))*(4*r + 4*s - 3)) + b1*(11*D1*bd1*f*(k1**2*(12*C - 6)*(2*r + 2*s - 1) + k2**2*(-6*K + 4*f + 3)*(4*r + 4*s - 5)) + 90*D1*f**2*fd*k2**2*(4*r + 4*s - 3) - 22*D1*f*(fd*k1**2*(4*C - 2) + 3*fd*k2**2*(2*K - 1)*(2*r + 2*s - 1) + k2**2*(9*bd2 - 12*gd2)*(r + s - 1)) + 66*D1*fd*k2**2*(-3*b2*(r + s) + g2*(4*r + 4*s + 2)) + 6*Dd*f*k2**2*(4*r + 4*s - 3)*(-33*b2 + 20*f**2 + f*(11 - 22*K) + 44*g2)) - 2*f*(D1*bd1*(-15*f**2*k2**2*(4*r + 4*s - 3) - 11*f*(k1**2*(4*C - 2) - k2**2*(6*K - 3)*(r + s - 1)) + 33*k2**2*(3*b2*(r + s - 1) - 2*g2*(2*r + 2*s - 3))) + 3*D1*(f*fd*k1**2*(10*C - 5)*(3*r + 3*s - 2) + 22*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) + 22*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + 3*Dd*f*(f*k1**2*(10*C - 5) + k2**2*(22*b2 - 44*g2))*(4*r + 4*s - 3)))/(3465*d*k3**3) - np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct*k2**2*st**3*(D1*bd1*f**2*(r + s) - 3*b1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*f*(-3*D1*bd1*(2*r + 2*s - 1) + 2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)))/(105*d*k1*k3) - np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct*k2**2*st**3*(11*b1**2*(D1*fd*(k1**2*(9 - 12*C)*(r + s - 1) + k2**2*(4*f*(4*r + 4*s - 3) - 3*r - 3*s)) + Dd*f*(k1**2*(9 - 12*C) + k2**2*(8*f - 3))*(4*r + 4*s - 3)) + b1*f*(-11*D1*bd1*(k1**2*(12*C - 9)*(2*r + 2*s - 1) + 2*k2**2*(f*(-8*r - 8*s + 6) + 3*r + 3*s - 3)) + D1*fd*(-11*k1**2*(8*C*(5*r + 5*s - 2) - 24*r - 24*s + 9) + k2**2*(28*f*(6*r + 6*s - 5) + 22*r + 22*s - 11)) + Dd*f*(k1**2*(132 - 220*C) + k2**2*(56*f + 11))*(4*r + 4*s - 3)) + f**2*(D1*bd1*(-11*k1**2*(4*C*(5*r + 5*s - 6) - 12*r - 12*s + 15) + k2**2*(28*f*(2*r + 2*s - 1) + 11*r + 11*s - 11)) + k1**2*(105 - 168*C)*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))))/(1155*d*k1*k3**3) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct*st*(-4*D1*bd1*f**2*k1**2*(2*C - 1)*(r + s) + 6*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1**2*(D1*(6*bd1*f*k2**2*(3*r + 3*s - 2) - fd*(k1**2*(12*C - 6) - k2**2*(8*f + 3))*(r + s - 1)) + Dd*f*(k1**2*(6 - 12*C) + k2**2*(4*f + 3))*(4*r + 4*s - 3)) + b1*f*(-D1*bd1*(k1**2*(12*C - 6) - k2**2*(4*f + 3))*(2*r + 2*s - 1) - k1**2*(8*C - 4)*(2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))))/(315*d*k1*k3) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*f*k2**3*st**5*(2*C - 1)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) - f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(693*d*k3**3) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*f*k2**3*st**5*(13*D1*bd1*f*(k1**2*(11 - 22*C) + k2**2*(22*b1 + 3*f))*(r + s - 1) + 143*b1**2*k2**2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 13*b1*(D1*fd*(3*f*k2**2*(3*r + 3*s - 2) + k1**2*(11 - 22*C)*(2*r + 2*s - 1)) + Dd*f*(3*f*k2**2 + k1**2*(11 - 22*C))*(4*r + 4*s - 3)) + f*(D1*fd*(36*f*k2**2*(4*r + 4*s - 3) + k1**2*(26*C - 13)*(3*r + 3*s - 2)) + Dd*f*(36*f*k2**2 + k1**2*(26*C - 13))*(4*r + 4*s - 3)))/(9009*d*k3**5) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*k1**4*k2*st*(11*b1**2*(D1*fd*(-9*K*(r + s) + f*(4*r + 4*s - 2)) + Dd*f*(-9*K + 2*f)*(4*r + 4*s - 3)) + b1*(22*D1*bd1*f*(-9*K + 2*f)*(r + s - 1) + 3*D1*(5*f**2*fd*(3*r + 3*s - 2) + 22*f*(K*fd*(-2*r - 2*s + 1) + 3*gd2*(r + s - 1)) + 66*fd*g2*(r + s)) + 3*Dd*f*(4*r + 4*s - 3)*(-22*K*f + 5*f**2 + 66*g2)) + 3*f*(D1*bd1*(r + s - 1)*(-22*K*f + 5*f**2 + 66*g2) + 44*D1*f*gd2*(r + s - 1) + 44*D1*fd*g2*(2*r + 2*s - 1) + 44*Dd*f*g2*(4*r + 4*s - 3)))/(3465*d*k3**5) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*k1**2*k2*st*(33*b1**3*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + 11*b1**2*(3*D1*bd1*f*(3*r + 3*s - 2) + D1*fd*(6*K*r + 6*K*s + 3*K - 2*f) + 6*Dd*K*f*(4*r + 4*s - 3)) + b1*(132*D1*K*bd1*f*r + 132*D1*K*bd1*f*s - 165*D1*K*bd1*f + 132*D1*K*f*fd*r + 132*D1*K*f*fd*s - 66*D1*K*f*fd + 22*D1*bd1*f**2 + 99*D1*bd2*f*(r + s - 1) - 45*D1*f**2*fd*r - 45*D1*f**2*fd*s + 30*D1*f**2*fd - 132*D1*f*gd2*r - 132*D1*f*gd2*s + 132*D1*f*gd2 - 132*D1*fd*g2*r - 132*D1*fd*g2*s - 66*D1*fd*g2 + 264*Dd*K*f**2*r + 264*Dd*K*f**2*s - 198*Dd*K*f**2 - 60*Dd*f**3*r - 60*Dd*f**3*s + 45*Dd*f**3 - 528*Dd*f*g2*r - 528*Dd*f*g2*s + 396*Dd*f*g2 + 99*b2*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3))) + 3*f*(22*D1*K*bd1*f*r + 22*D1*K*bd1*f*s - 22*D1*K*bd1*f - 5*D1*bd1*f**2*r - 5*D1*bd1*f**2*s + 5*D1*bd1*f**2 - 44*D1*bd1*g2*r - 44*D1*bd1*g2*s + 66*D1*bd1*g2 + 22*D1*bd2*f*(r + s - 1) - 44*D1*f*gd2*r - 44*D1*f*gd2*s + 44*D1*f*gd2 - 88*D1*fd*g2*r - 88*D1*fd*g2*s + 44*D1*fd*g2 - 176*Dd*f*g2*r - 176*Dd*f*g2*s + 132*Dd*f*g2 + 11*b2*(3*D1*bd1*(r + s - 1) + 2*D1*fd*(2*r + 2*s - 1) + 2*Dd*f*(4*r + 4*s - 3))))/(3465*d*k3**3) + np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*k1**2*k2*st**3*(13*D1*bd1*f*(r + s - 1)*(14*f**2*k2**2 - 11*f*(k1**2*(6*C - 3) + k2**2*(K - 12*b1)) - k2**2*(-66*K*b1 + 66*g2)) + 429*b1**2*k2**2*(D1*fd*(K*(r + s) + f*(4*r + 4*s - 2)) + Dd*f*(K + 2*f)*(4*r + 4*s - 3)) + 13*b1*(D1*(14*f**2*fd*k2**2*(3*r + 3*s - 2) - 11*f*(fd*(K*k2**2 + k1**2*(6*C - 3))*(2*r + 2*s - 1) + 6*gd2*k2**2*(r + s - 1)) - 66*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(14*f**2*k2**2 - 11*f*(K*k2**2 + k1**2*(6*C - 3)) - 66*g2*k2**2)) + f*(D1*(-220*f**2*fd*k2**2*(4*r + 4*s - 3) - f*fd*k1**2*(546*C - 273)*(3*r + 3*s - 2) + 286*f*gd2*k2**2*(r + s - 1) + 286*fd*g2*k2**2*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(220*f**2*k2**2 + f*k1**2*(546*C - 273) - 286*g2*k2**2)))/(15015*d*k3**5) + np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*k2*st**3*(2*C - 1)*(D1*bd1*f**2*(r + s) - 3*b1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*f*(-3*D1*bd1*(2*r + 2*s - 1) + 2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)))/(105*d*k3) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*k2*st*(-3*D1*bd1*f*(b2 - 2*g2)*(r + s) + 3*b1**3*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1**2*(3*D1*bd1*f*(3*r + 3*s - 2) + D1*fd*(-3*K + 4*f)*(r + s - 1) + Dd*f*(-3*K + 2*f)*(4*r + 4*s - 3)) + b1*(-6*D1*K*bd1*f*r - 6*D1*K*bd1*f*s + 3*D1*K*bd1*f + 4*D1*bd1*f**2*r + 4*D1*bd1*f**2*s - 2*D1*bd1*f**2 - 3*D1*bd2*f*(r + s - 1) + 6*D1*f*gd2*r + 6*D1*f*gd2*s - 6*D1*f*gd2 + 6*D1*fd*g2*r + 6*D1*fd*g2*s - 6*D1*fd*g2 + 24*Dd*f*g2*r + 24*Dd*f*g2*s - 18*Dd*f*g2 - 3*b2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))))/(315*d*k3) - np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*k2*st**3*(33*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + 11*b1**2*(D1*(3*bd1*f*k2**2*(3*r + 3*s - 2) + fd*k1**2*(3 - 6*C)*(r + s - 1) + fd*k2**2*(3*K*(r + s) + f*(8*r + 8*s - 5))) + Dd*f*(k1**2*(3 - 6*C) + k2**2*(3*K + 4*f))*(4*r + 4*s - 3)) + b1*(11*D1*bd1*f*(k1**2*(3 - 6*C)*(2*r + 2*s - 1) + k2**2*(6*K*(r + s - 1) + f*(8*r + 8*s - 7))) + D1*(21*f**2*fd*k2**2*(5*r + 5*s - 4) - 11*f*(K*fd*k2**2*(2*r + 2*s - 1) + fd*k1**2*(2*C - 1)*(4*r + 4*s - 1) + k2**2*(-3*bd2 + 6*gd2)*(r + s - 1)) + 33*fd*k2**2*(b2 - 2*g2)*(r + s)) + Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2 - 11*f*(K*k2**2 + k1**2*(4*C - 2)) + k2**2*(33*b2 - 66*g2))) + f*(D1*bd1*(7*f**2*k2**2*(5*r + 5*s - 3) - 11*f*(K*k2**2*(r + s - 1) + k1**2*(2*C - 1)*(2*r + 2*s - 3)) + k2**2*(33*b2 - 66*g2)*(r + s - 1)) + D1*(-f*fd*k1**2*(42*C - 21)*(3*r + 3*s - 2) - 11*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) - 11*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) - Dd*f*(f*k1**2*(42*C - 21) + k2**2*(11*b2 - 22*g2))*(4*r + 4*s - 3)))/(1155*d*k3**3) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*b1*k2*st*(4*D1*bd1*f**2*r + 3*b1**2*(D1*fd*r + Dd*f*(4*r - 1)) + b1*f*(3*D1*bd1*(3*r - 1) + 4*D1*fd*r - 2*D1*fd + 8*Dd*f*r - 2*Dd*f))/(315*d*k1) - 32*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**5*f*k2**4*st*(C - 1)*(22*D1*bd1*f*(r - 1) + 22*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 15*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(3465*d*k3**4) - 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**4*f*k2**3*st*(22*D1*bd1*f*(r - 1) + 22*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 15*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(3465*d*k1*k3**2) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**4*f*k2**3*st*(13*D1*bd1*f*(r - 1)*(75*f*k2**2 + k1**2*(616*C - 528)) + 13*b1*(D1*fd*r*(225*f*k2**2 + k1**2*(1232*C - 1056)) + Dd*f*(4*r - 1)*(75*f*k2**2 + k1**2*(616*C - 528))) + 20*f*(D1*fd*(35*f*k2**2*(4*r - 1) + k1**2*(273*C - 234)*(3*r - 1)) + Dd*f*(4*r - 1)*(35*f*k2**2 + k1**2*(273*C - 234))))/(45045*d*k1*k3**4) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**3*f*k2**4*st**3*(C - 1)*(11*D1*bd1*f*(r - 1) + 11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 7*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(1155*d*k3**4) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**3*k2**2*st*(66*b1**2*(C - 1)*(D1*fd*r + Dd*f*(4*r - 1)) + 22*b1*f*(3*D1*bd1*(C - 1)*(2*r - 1) - 2*D1*fd*(2*C*r + C - 3*r - 1) - Dd*f*(2*C - 3)*(4*r - 1)) + f**2*(-22*D1*bd1*(2*C*(r - 2) - 3*r + 5) - (60*C - 75)*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1))))/(3465*d*k3**2) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**3*k2**2*st*(13*D1*bd1*f*(30*f**2*k2**2*(2*r - 3) + 22*f*(k1**2*(18*C - 13)*(r - 1) + k2**2*(b1*(2 - 4*r) + r*(K - 1))) + 33*k2**2*(b1*(K - 1)*(2*r - 1) - 2*g2*(r - 1))) - 143*b1**2*k2**2*(D1*fd*r*(-3*K + 8*f + 3) + Dd*f*(4*r - 1)*(-3*K + 4*f + 3)) + 26*b1*(D1*(15*f**2*fd*k2**2*(6*r + 1) + 11*f*(fd*k1**2*r*(36*C - 26) + fd*k2**2*(K - 1)*(2*r - 1) - 3*gd2*k2**2*r) - 33*fd*g2*k2**2*r) + Dd*f*(4*r - 1)*(30*f**2*k2**2 + 11*f*(k1**2*(18*C - 13) + k2**2*(K - 1)) - 33*g2*k2**2)) + f*(D1*(840*f**2*fd*k2**2*(4*r - 1) + f*fd*k1**2*(3510*C - 2535)*(3*r - 1) - 572*f*gd2*k2**2*r + 572*fd*g2*k2**2*(1 - 2*r)) + Dd*f*(4*r - 1)*(840*f**2*k2**2 + f*k1**2*(3510*C - 2535) - 572*g2*k2**2)))/(45045*d*k3**4) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**2*f*k2**3*st**3*(11*D1*bd1*f*(r - 1) + 11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 7*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(1155*d*k1*k3**2) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**2*f*k2**3*st**3*(13*D1*bd1*f*(r - 1)*(35*f*k2**2 + k1**2*(110*C - 88)) + 13*b1*(D1*fd*r*(105*f*k2**2 + k1**2*(220*C - 176)) + Dd*f*(4*r - 1)*(35*f*k2**2 + k1**2*(110*C - 88))) + f*(D1*fd*(275*f*k2**2*(4*r - 1) + k1**2*(910*C - 728)*(3*r - 1)) + Dd*f*(4*r - 1)*(275*f*k2**2 + k1**2*(910*C - 728))))/(15015*d*k1*k3**4) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**2*k1*k2*st*(13*D1*bd1*f*(135*f**2*k2**2 - 22*f*(k1**2*(20*C - 12)*(r - 1) + k2**2*(6*K*r - 18*b1*r + 9*b1 - 4*r)) - 66*k2**2*(b1*(3*K - 2)*(2*r - 1) - 6*g2*(r - 1))) + 858*b1**2*k2**2*(D1*fd*r*(-3*K + 6*f + 2) + Dd*f*(4*r - 1)*(-3*K + 3*f + 2)) - 13*b1*(D1*(135*f**2*fd*k2**2 + 44*f*(fd*k1**2*r*(20*C - 12) + fd*k2**2*(3*K - 2)*(2*r - 1) - 9*gd2*k2**2*r) - 396*fd*g2*k2**2*r) + 44*Dd*f*(4*r - 1)*(f*k1**2*(10*C - 6) + f*k2**2*(3*K - 2) - 9*g2*k2**2)) - 12*f*(D1*(105*f**2*fd*k2**2*(4*r - 1) + f*fd*k1**2*(325*C - 195)*(3*r - 1) - 286*f*gd2*k2**2*r + 286*fd*g2*k2**2*(1 - 2*r)) + Dd*f*(4*r - 1)*(105*f**2*k2**2 + f*k1**2*(325*C - 195) - 286*g2*k2**2)))/(45045*d*k3**4) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**2*k2*st*(2*D1*bd1*f**2*r + 3*b1**2*(D1*fd*r + Dd*f*(4*r - 1)) + b1*f*(3*D1*bd1*(2*r - 1) + 4*D1*fd*r - 2*D1*fd + 8*Dd*f*r - 2*Dd*f))/(315*d*k1) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**2*k2*st*(33*b1**2*(D1*fd*r*(k1**2*(4*C - 3) + k2**2*(4*f + 1)) + Dd*f*(4*r - 1)*(k1**2*(4*C - 3) + k2**2*(2*f + 1))) + b1*f*(33*D1*bd1*(2*r - 1)*(k1**2*(4*C - 3) + k2**2*(2*f + 1)) + D1*fd*(-22*k1**2*(4*C*(r + 1) - 2*r - 3) + k2**2*(45*f*(3*r - 1) + 44*r - 22)) + Dd*f*(4*r - 1)*(k1**2*(22 - 44*C) + k2**2*(45*f + 22))) + f**2*(D1*bd1*(-22*k1**2*(2*C*(r - 3) - r + 4) + k2**2*r*(45*f + 22)) - k1**2*(90*C - 60)*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1))))/(3465*d*k1*k3**2) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct*f*k2**2*st**3*(4*C - 3)*(11*D1*bd1*f*(r - 1) + 11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 7*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(1155*d*k3**2) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct*f*k2**2*st**3*(13*D1*bd1*f*(k1**2*(88*C - 55)*(r - 1) + 2*k2**2*(b1*(11 - 22*r) + 7*f*(2*r - 3))) - 286*b1**2*k2**2*(2*D1*fd*r + Dd*f*(4*r - 1)) + 13*b1*(2*D1*fd*(7*f*k2**2*(6*r + 1) + k1**2*r*(88*C - 55)) + Dd*f*(4*r - 1)*(28*f*k2**2 + k1**2*(88*C - 55))) + f*(D1*fd*(330*f*k2**2*(4*r - 1) + k1**2*(728*C - 455)*(3*r - 1)) + Dd*f*(4*r - 1)*(330*f*k2**2 + k1**2*(728*C - 455))))/(15015*d*k3**4) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct*k1**2*st*(13*D1*bd1*f*(15*f**2*k2**2*(2*r + 1) - 22*f*(k1**2*(2*C - 1)*(r - 1) - k2**2*(-3*K*r + 6*b1*r - 3*b1 + r)) - 33*k2**2*(b1*(3*K - 1)*(2*r - 1) - 6*g2*(r - 1))) + 429*b1**2*k2**2*(D1*fd*r*(-3*K + 4*f + 1) + Dd*f*(4*r - 1)*(-3*K + 2*f + 1)) + 13*b1*(D1*(45*f**2*fd*k2**2*(2*r - 1) - 22*f*(fd*k1**2*r*(4*C - 2) + fd*k2**2*(3*K - 1)*(2*r - 1) - 9*gd2*k2**2*r) + 198*fd*g2*k2**2*r) + 2*Dd*f*(4*r - 1)*(15*f**2*k2**2 - 11*f*(k1**2*(2*C - 1) + k2**2*(3*K - 1)) + 99*g2*k2**2)) + f*(D1*(-140*f**2*fd*k2**2*(4*r - 1) - 39*f*(fd*k1**2*(10*C - 5)*(3*r - 1) - 44*gd2*k2**2*r) + 1716*fd*g2*k2**2*(2*r - 1)) - Dd*f*(4*r - 1)*(140*f**2*k2**2 + f*k1**2*(390*C - 195) - 1716*g2*k2**2)))/(45045*d*k3**4) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct*st*(2*C - 1)*(2*D1*bd1*f**2*r + 3*b1**2*(D1*fd*r + Dd*f*(4*r - 1)) + b1*f*(3*D1*bd1*(2*r - 1) + 4*D1*fd*r - 2*D1*fd + 8*Dd*f*r - 2*Dd*f))/(315*d) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct*st*(33*b1**3*k2**2*(D1*fd*r + Dd*f*(4*r - 1)) - 11*b1**2*(D1*(3*bd1*f*k2**2*(1 - 3*r) + fd*(2*f*k2**2*(4*r + 1) + k1**2*r*(6*C - 3) - k2**2*r*(3*K - 3))) + Dd*f*(4*r - 1)*(k1**2*(6*C - 3) + k2**2*(-3*K + 4*f + 3))) + b1*(-11*D1*bd1*f*(k1**2*(6*C - 3)*(2*r - 1) + k2**2*(f*(8*r - 6) + (3 - 3*K)*(2*r - 1))) + D1*(-45*f**2*fd*k2**2*(3*r - 1) + 22*f*fd*(k1**2*(2*C - 1) + k2**2*(K - 1)*(2*r - 1)) + 33*f*k2**2*r*(bd2 - 2*gd2) + 33*fd*k2**2*r*(b2 - 2*g2)) + Dd*f*k2**2*(4*r - 1)*(33*b2 - 45*f**2 + 22*f*(K - 1) - 66*g2)) + f*(D1*bd1*(-45*f**2*k2**2*r + f*k1**2*(22 - 44*C) + 22*f*k2**2*r*(K - 1) + k2**2*(33*b2 - 66*g2)*(r - 1)) + D1*(f*fd*k1**2*(30*C - 15)*(3*r - 1) + 22*f*k2**2*r*(bd2 - 2*gd2) + 22*fd*k2**2*(b2 - 2*g2)*(2*r - 1)) + Dd*f*(4*r - 1)*(f*k1**2*(30*C - 15) + k2**2*(22*b2 - 44*g2))))/(3465*d*k3**2) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*f**2*k2**5*st**5*(13*D1*bd1*f*(r - 1) + 13*b1*(3*D1*fd*r + Dd*f*(4*r - 1)) + 9*f*(4*r - 1)*(D1*fd + Dd*f))/(9009*d*k1*k3**4) + np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*f*k1*k2*st**3*(13*D1*bd1*f*(k1**2*(22 - 44*C)*(r - 1) + 3*k2**2*(22*b1*r - 11*b1 + 7*f)) + 429*b1**2*k2**2*(2*D1*fd*r + Dd*f*(4*r - 1)) - 13*b1*(D1*fd*(21*f*k2**2 + k1**2*r*(88*C - 44)) + Dd*f*k1**2*(44*C - 22)*(4*r - 1)) + f*(D1*fd*(165*f*k2**2*(1 - 4*r) - k1**2*(364*C - 182)*(3*r - 1)) - Dd*f*(4*r - 1)*(165*f*k2**2 + k1**2*(364*C - 182))))/(15015*d*k3**4) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*f*k2*st**3*(D1*bd1*f*(k1**2*(11 - 22*C)*(r - 1) + k2**2*(11*b1*(2*r - 1) + 7*f*r)) + (b1*k2**2 + k1**2*(1 - 2*C))*(11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 7*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1))))/(1155*d*k1*k3**2) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*k1**3*k2*st*(22*b1**2*(D1*fd*r*(-3*K + 2*f) + Dd*f*(-3*K + f)*(4*r - 1)) + b1*(22*D1*bd1*f*(-3*K + f)*(2*r - 1) + D1*(15*f**2*fd*(3*r - 1) + 44*f*(fd*(-2*K*r + K) + 3*gd2*r) + 132*fd*g2*r) + Dd*f*(4*r - 1)*(-44*K*f + 15*f**2 + 132*g2)) + f*(D1*bd1*(f*r*(-44*K + 15*f) + 132*g2*(r - 1)) + 88*D1*f*gd2*r + 88*D1*fd*g2*(2*r - 1) + 88*Dd*f*g2*(4*r - 1)))/(3465*d*k3**4) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*k1*k2*st*(33*b1**3*(D1*fd*r + Dd*f*(4*r - 1)) + 11*b1**2*(3*D1*bd1*f*(3*r - 1) - 2*D1*fd*(-3*K*r + f) + 6*Dd*K*f*(4*r - 1)) + b1*(88*D1*K*f*fd*r - 44*D1*K*f*fd + 22*D1*bd1*f*(6*K*r - 3*K + f) + 66*D1*bd2*f*r - 45*D1*f**2*fd*r + 15*D1*f**2*fd - 132*D1*f*gd2*r - 132*D1*fd*g2*r + 176*Dd*K*f**2*r - 44*Dd*K*f**2 - 60*Dd*f**3*r + 15*Dd*f**3 - 528*Dd*f*g2*r + 132*Dd*f*g2 + 66*b2*(D1*fd*r + Dd*f*(4*r - 1))) + f*(D1*bd1*f*r*(44*K - 15*f) - 132*D1*bd1*g2*(r - 1) + 44*D1*(f*r*(bd2 - 2*gd2) + fd*g2*(2 - 4*r)) + 88*Dd*f*g2*(1 - 4*r) + 22*b2*(3*D1*bd1*(r - 1) + 2*D1*fd*(2*r - 1) + 2*Dd*f*(4*r - 1))))/(3465*d*k3**2)
        perm23 = 32*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**6*f*k1**2*k2**3*st*(585*C*D1*f*fd*r + 585*C*D1*f*fd*s - 390*C*D1*f*fd + 780*C*Dd*f**2*r + 780*C*Dd*f**2*s - 585*C*Dd*f**2 + 143*D1*bd1*f*(K - 1)*(r + s - 1) + 392*D1*f**2*fd*r + 392*D1*f**2*fd*s - 294*D1*f**2*fd - 585*D1*f*fd*r - 585*D1*f*fd*s + 390*D1*f*fd - 286*D1*f*gd2*r - 286*D1*f*gd2*s + 286*D1*f*gd2 - 572*D1*fd*g2*r - 572*D1*fd*g2*s + 286*D1*fd*g2 + 392*Dd*f**3*r + 392*Dd*f**3*s - 294*Dd*f**3 - 780*Dd*f**2*r - 780*Dd*f**2*s + 585*Dd*f**2 - 1144*Dd*f*g2*r - 1144*Dd*f*g2*s + 858*Dd*f*g2 + 143*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))/(9009*d*k3**6) - 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**5*f*k1*k2**2*st*(-14040*C*D1*f*fd*k1**2*r - 14040*C*D1*f*fd*k1**2*s + 9360*C*D1*f*fd*k1**2 - 11700*C*D1*f*fd*k2**2*r - 11700*C*D1*f*fd*k2**2*s + 7800*C*D1*f*fd*k2**2 - 18720*C*Dd*f**2*k1**2*r - 18720*C*Dd*f**2*k1**2*s + 14040*C*Dd*f**2*k1**2 - 15600*C*Dd*f**2*k2**2*r - 15600*C*Dd*f**2*k2**2*s + 11700*C*Dd*f**2*k2**2 - 26*D1*bd1*f*(k1**2*(132*K - 132) - k2**2*(-110*K + 45*f + 55))*(r + s - 1) - 13440*D1*f**2*fd*k1**2*r - 13440*D1*f**2*fd*k1**2*s + 10080*D1*f**2*fd*k1**2 + 14040*D1*f*fd*k1**2*r + 14040*D1*f*fd*k1**2*s - 9360*D1*f*fd*k1**2 + 8775*D1*f*fd*k2**2*r + 8775*D1*f*fd*k2**2*s - 5850*D1*f*fd*k2**2 + 6864*D1*f*gd2*k1**2*r + 6864*D1*f*gd2*k1**2*s - 6864*D1*f*gd2*k1**2 + 5720*D1*f*gd2*k2**2*r + 5720*D1*f*gd2*k2**2*s - 5720*D1*f*gd2*k2**2 + 13728*D1*fd*g2*k1**2*r + 13728*D1*fd*g2*k1**2*s - 6864*D1*fd*g2*k1**2 + 11440*D1*fd*g2*k2**2*r + 11440*D1*fd*g2*k2**2*s - 5720*D1*fd*g2*k2**2 - 13440*Dd*f**3*k1**2*r - 13440*Dd*f**3*k1**2*s + 10080*Dd*f**3*k1**2 + 18720*Dd*f**2*k1**2*r + 18720*Dd*f**2*k1**2*s - 14040*Dd*f**2*k1**2 + 11700*Dd*f**2*k2**2*r + 11700*Dd*f**2*k2**2*s - 8775*Dd*f**2*k2**2 + 27456*Dd*f*g2*k1**2*r + 27456*Dd*f*g2*k1**2*s - 20592*Dd*f*g2*k1**2 + 22880*Dd*f*g2*k2**2*r + 22880*Dd*f*g2*k2**2*s - 17160*Dd*f*g2*k2**2 + 26*b1*(D1*fd*(k1**2*(132 - 132*K)*(2*r + 2*s - 1) + 5*k2**2*(9*f*(3*r + 3*s - 2) + (11 - 22*K)*(2*r + 2*s - 1))) + Dd*f*(k1**2*(132 - 132*K) + k2**2*(-110*K + 45*f + 55))*(4*r + 4*s - 3)))/(45045*d*k3**6) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**4*f*k1**2*k2**3*st**3*(1092*C*D1*f*fd*r + 1092*C*D1*f*fd*s - 728*C*D1*f*fd + 1456*C*Dd*f**2*r + 1456*C*Dd*f**2*s - 1092*C*Dd*f**2 + 286*D1*bd1*f*(K - 1)*(r + s - 1) + 1540*D1*f**2*fd*r + 1540*D1*f**2*fd*s - 1155*D1*f**2*fd - 1092*D1*f*fd*r - 1092*D1*f*fd*s + 728*D1*f*fd - 572*D1*f*gd2*r - 572*D1*f*gd2*s + 572*D1*f*gd2 - 1144*D1*fd*g2*r - 1144*D1*fd*g2*s + 572*D1*fd*g2 + 1540*Dd*f**3*r + 1540*Dd*f**3*s - 1155*Dd*f**3 - 1456*Dd*f**2*r - 1456*Dd*f**2*s + 1092*Dd*f**2 - 2288*Dd*f*g2*r - 2288*Dd*f*g2*s + 1716*Dd*f*g2 + 286*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))/(3003*d*k3**6) - 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**4*k2*st*(13*D1*bd1*f*(r + s - 1)*(225*f**2*k1**2*k2**2 - 22*f*(5*K*k2**4 + k1**4*(9*K - 9) + k1**2*k2**2*(6*C + 24*K - 18)) + k1**2*k2**2*(-198*K*b1 + 198*b1 + 198*g2)) - 1287*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) + 13*b1*(D1*(225*f**2*fd*k1**2*k2**2*(3*r + 3*s - 2) - 22*f*(fd*(2*r + 2*s - 1)*(5*K*k2**4 + k1**4*(9*K - 9) + k1**2*k2**2*(6*C + 24*K - 18)) - 9*gd2*k1**2*k2**2*(r + s - 1)) + 198*fd*g2*k1**2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(225*f**2*k1**2*k2**2 - 22*f*(5*K*k2**4 + k1**4*(9*K - 9) + k1**2*k2**2*(6*C + 24*K - 18)) + 198*g2*k1**2*k2**2)) + f*(D1*(-4200*f**2*fd*k1**4*(4*r + 4*s - 3) - 195*f*fd*(3*r + 3*s - 2)*(k1**4*(18*C - 18) + k1**2*k2**2*(48*C - 36) + k2**4*(10*C - 5)) + 572*f*gd2*(9*k1**4 + 24*k1**2*k2**2 + 5*k2**4)*(r + s - 1) + 572*fd*g2*(9*k1**4 + 24*k1**2*k2**2 + 5*k2**4)*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(4200*f**2*k1**4 + 195*f*(k1**4*(18*C - 18) + k1**2*k2**2*(48*C - 36) + k2**4*(10*C - 5)) - 572*g2*(9*k1**4 + 24*k1**2*k2**2 + 5*k2**4))))/(45045*d*k3**6) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**3*f*k1*k2**2*st**3*(-3276*C*D1*f*fd*k1**2*r - 3276*C*D1*f*fd*k1**2*s + 2184*C*D1*f*fd*k1**2 - 5460*C*D1*f*fd*k2**2*r - 5460*C*D1*f*fd*k2**2*s + 3640*C*D1*f*fd*k2**2 - 4368*C*Dd*f**2*k1**2*r - 4368*C*Dd*f**2*k1**2*s + 3276*C*Dd*f**2*k1**2 - 7280*C*Dd*f**2*k2**2*r - 7280*C*Dd*f**2*k2**2*s + 5460*C*Dd*f**2*k2**2 - 13*D1*bd1*f*(k1**2*(66*K - 66) - k2**2*(-110*K + 70*f + 55))*(r + s - 1) - 8800*D1*f**2*fd*k1**2*r - 8800*D1*f**2*fd*k1**2*s + 6600*D1*f**2*fd*k1**2 + 3276*D1*f*fd*k1**2*r + 3276*D1*f*fd*k1**2*s - 2184*D1*f*fd*k1**2 + 4095*D1*f*fd*k2**2*r + 4095*D1*f*fd*k2**2*s - 2730*D1*f*fd*k2**2 + 1716*D1*f*gd2*k1**2*r + 1716*D1*f*gd2*k1**2*s - 1716*D1*f*gd2*k1**2 + 2860*D1*f*gd2*k2**2*r + 2860*D1*f*gd2*k2**2*s - 2860*D1*f*gd2*k2**2 + 3432*D1*fd*g2*k1**2*r + 3432*D1*fd*g2*k1**2*s - 1716*D1*fd*g2*k1**2 + 5720*D1*fd*g2*k2**2*r + 5720*D1*fd*g2*k2**2*s - 2860*D1*fd*g2*k2**2 - 8800*Dd*f**3*k1**2*r - 8800*Dd*f**3*k1**2*s + 6600*Dd*f**3*k1**2 + 4368*Dd*f**2*k1**2*r + 4368*Dd*f**2*k1**2*s - 3276*Dd*f**2*k1**2 + 5460*Dd*f**2*k2**2*r + 5460*Dd*f**2*k2**2*s - 4095*Dd*f**2*k2**2 + 6864*Dd*f*g2*k1**2*r + 6864*Dd*f*g2*k1**2*s - 5148*Dd*f*g2*k1**2 + 11440*Dd*f*g2*k2**2*r + 11440*Dd*f*g2*k2**2*s - 8580*Dd*f*g2*k2**2 + 13*b1*(D1*fd*(k1**2*(66 - 66*K)*(2*r + 2*s - 1) + 5*k2**2*(14*f*(3*r + 3*s - 2) + (11 - 22*K)*(2*r + 2*s - 1))) + Dd*f*(k1**2*(66 - 66*K) + k2**2*(-110*K + 70*f + 55))*(4*r + 4*s - 3)))/(15015*d*k3**6) - 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**3*k1*st*(26*D1*bd1*f*(r + s - 1)*(60*f**2*k1**2*k2**2 - 11*f*(k1**4*(2*K - 2) + k1**2*k2**2*(12*C + 18*K - 21) + k2**4*(12*C + 12*K - 8*b1 - 9)) - 99*k2**2*(2*b1*k1**2*(K - 1) + b1*k2**2*(2*K - 1) - 2*g2*(k1**2 + k2**2))) + 143*b1**2*k2**2*(D1*fd*(8*f*k2**2*(2*r + 2*s - 1) + (r + s)*(-9*k1**2*(2*K - 2) - 9*k2**2*(2*K - 1))) + Dd*f*(k1**2*(18 - 18*K) + k2**2*(-18*K + 8*f + 9))*(4*r + 4*s - 3)) + 26*b1*(D1*(60*f**2*fd*k1**2*k2**2*(3*r + 3*s - 2) - 11*f*fd*(2*r + 2*s - 1)*(k1**4*(2*K - 2) + k1**2*k2**2*(12*C + 18*K - 21) + k2**4*(12*C + 12*K - 9)) + 198*f*gd2*k2**2*(k1**2 + k2**2)*(r + s - 1) + 198*fd*g2*k2**2*(k1**2 + k2**2)*(r + s)) + Dd*f*(4*r + 4*s - 3)*(60*f**2*k1**2*k2**2 - 11*f*(k1**4*(2*K - 2) + k1**2*k2**2*(12*C + 18*K - 21) + k2**4*(12*C + 12*K - 9)) + 198*g2*k2**2*(k1**2 + k2**2))) + f*(D1*(-2240*f**2*fd*k1**4*(4*r + 4*s - 3) - 195*f*fd*(3*r + 3*s - 2)*(k1**4*(4*C - 4) + k1**2*k2**2*(36*C - 27) + k2**4*(24*C - 12)) + 1144*f*gd2*(k1**4 + 9*k1**2*k2**2 + 6*k2**4)*(r + s - 1) + 1144*fd*g2*(k1**4 + 9*k1**2*k2**2 + 6*k2**4)*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(2240*f**2*k1**4 + 195*f*(k1**4*(4*C - 4) + k1**2*k2**2*(36*C - 27) + k2**4*(24*C - 12)) - 1144*g2*(k1**4 + 9*k1**2*k2**2 + 6*k2**4))))/(45045*d*k3**6) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**2*f*k1**2*k2**3*st**5*(78*C*D1*f*fd*r + 78*C*D1*f*fd*s - 52*C*D1*f*fd + 104*C*Dd*f**2*r + 104*C*Dd*f**2*s - 78*C*Dd*f**2 - 143*D1*bd1*f*(K - 1)*(r + s - 1) + 756*D1*f**2*fd*r + 756*D1*f**2*fd*s - 567*D1*f**2*fd - 78*D1*f*fd*r - 78*D1*f*fd*s + 52*D1*f*fd + 286*D1*f*gd2*r + 286*D1*f*gd2*s - 286*D1*f*gd2 + 572*D1*fd*g2*r + 572*D1*fd*g2*s - 286*D1*fd*g2 + 756*Dd*f**3*r + 756*Dd*f**3*s - 567*Dd*f**3 - 104*Dd*f**2*r - 104*Dd*f**2*s + 78*Dd*f**2 + 1144*Dd*f*g2*r + 1144*Dd*f*g2*s - 858*Dd*f*g2 - 143*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))/(9009*d*k3**6) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**2*k2*st**3*(13*D1*bd1*f*(r + s - 1)*(210*f**2*k1**2*k2**2 - 11*f*(10*K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(2*C + 24*K - 14)) - k1**2*k2**2*(-66*K*b1 + 66*b1 + 66*g2)) + 429*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) + 13*b1*(D1*(210*f**2*fd*k1**2*k2**2*(3*r + 3*s - 2) - 11*f*(fd*(2*r + 2*s - 1)*(10*K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(2*C + 24*K - 14)) + 6*gd2*k1**2*k2**2*(r + s - 1)) - 66*fd*g2*k1**2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(210*f**2*k1**2*k2**2 - 11*f*(10*K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(2*C + 24*K - 14)) - 66*g2*k1**2*k2**2)) - 2*f*(D1*(1650*f**2*fd*k1**4*(4*r + 4*s - 3) + 91*f*fd*(3*r + 3*s - 2)*(k1**4*(3*C - 3) + k1**2*k2**2*(24*C - 18) + k2**4*(10*C - 5)) - 143*f*gd2*(3*k1**4 + 24*k1**2*k2**2 + 10*k2**4)*(r + s - 1) - 143*fd*g2*(3*k1**4 + 24*k1**2*k2**2 + 10*k2**4)*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(1650*f**2*k1**4 + 91*f*(k1**4*(3*C - 3) + k1**2*k2**2*(24*C - 18) + k2**4*(10*C - 5)) - 143*g2*(3*k1**4 + 24*k1**2*k2**2 + 10*k2**4))))/(15015*d*k3**6) + 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**2*st*(D1*(1287*b1*fd*k2**2*(r + s)*(b1*(K*k2**4 + k1**4*(K - 1) + k1**2*k2**2*(4*K - 2)) - 2*g2*(k1**4 + 4*k1**2*k2**2 + k2**4)) + 30*f**3*k1**4*(39*bd1*k2**2*(r + s - 1) + 14*fd*k1**2*(4*r + 4*s - 3)) + 13*f**2*k2**2*(22*bd1*(r + s - 1)*(k1**4*(6*C + 4*K - 8) - k1**2*k2**2*(-24*C - 9*K + 24*b1 + 18) + k2**4*(6*C - 3)) + k1**2*(15*fd*(k1**2*(8*C + 6*b1 - 6) + k2**2*(18*C - 9))*(3*r + 3*s - 2) - 44*gd2*(4*k1**2 + 9*k2**2)*(r + s - 1))) - 286*f*k2**2*(12*b1**2*fd*k1**2*k2**2*(2*r + 2*s - 1) - 9*b1*bd1*(r + s - 1)*(K*k2**4 + k1**4*(K - 1) + k1**2*k2**2*(4*K - 2)) - b1*fd*(2*r + 2*s - 1)*(k1**4*(6*C + 4*K - 8) + k1**2*k2**2*(24*C + 9*K - 18) + k2**4*(6*C - 3)) + 9*b1*gd2*(k1**4 + 4*k1**2*k2**2 + k2**4)*(r + s - 1) + 9*bd1*g2*(k1**4 + 4*k1**2*k2**2 + k2**4)*(r + s - 1) + 2*fd*g2*k1**2*(4*k1**2 + 9*k2**2)*(2*r + 2*s - 1))) + Dd*f*(4*r + 4*s - 3)*(1287*b1*k2**2*(b1*(K*k2**4 + k1**4*(K - 1) + k1**2*k2**2*(4*K - 2)) - 2*g2*(k1**4 + 4*k1**2*k2**2 + k2**4)) + 420*f**3*k1**6 + 195*f**2*k1**2*k2**2*(k1**2*(8*C + 6*b1 - 6) + k2**2*(18*C - 9)) + 286*f*k2**2*(-12*b1**2*k1**2*k2**2 + b1*(k1**4*(6*C + 4*K - 8) + k1**2*k2**2*(24*C + 9*K - 18) + k2**4*(6*C - 3)) - 2*g2*k1**2*(4*k1**2 + 9*k2**2))))/(45045*d*k2*k3**6) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct*f*k1*k2**2*st**5*(D1*(f**2*(-78*bd1*k2**2*(r + s - 1) + 216*fd*k1**2*(4*r + 4*s - 3)) - 13*f*k2**2*(11*bd1*(2*K - 1)*(r + s - 1) + fd*(-4*C + 6*b1 + 3)*(3*r + 3*s - 2) - 44*gd2*(r + s - 1)) + 143*fd*k2**2*(2*r + 2*s - 1)*(-2*K*b1 + b1 + 4*g2)) + Dd*f*(4*r + 4*s - 3)*(216*f**2*k1**2 - f*k2**2*(-52*C + 78*b1 + 39) + k2**2*(-286*K*b1 + 143*b1 + 572*g2)))/(9009*d*k3**6) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct*k1*st**3*(D1*(-429*b1*fd*k2**4*(r + s)*(b1*(2*K - 1) - 4*g2) + 8*f**3*k1**2*(-91*bd1*k2**2*(r + s - 1) + 110*fd*k1**2*(4*r + 4*s - 3)) - 13*f**2*k2**2*(-11*bd1*(k1**2*(6*K - 3) + k2**2*(4*C + 12*K - 8*b1 - 3))*(r + s - 1) + 7*fd*(k1**2*(-12*C + 8*b1 + 9) + k2**2*(12 - 24*C))*(3*r + 3*s - 2) + 132*gd2*(k1**2 + 2*k2**2)*(r + s - 1)) - 143*f*k2**2*(4*b1**2*fd*k2**2*(2*r + 2*s - 1) - b1*(fd*(k1**2*(6*K - 3) + k2**2*(4*C + 12*K - 3))*(2*r + 2*s - 1) + k2**2*(r + s - 1)*(-12*K*bd1 + 6*bd1 + 12*gd2)) + 12*g2*(-bd1*k2**2*(r + s - 1) + fd*(k1**2 + 2*k2**2)*(2*r + 2*s - 1)))) + Dd*f*(4*r + 4*s - 3)*(-429*b1*k2**4*(b1*(2*K - 1) - 4*g2) + 880*f**3*k1**4 - 91*f**2*(k1**2*k2**2*(-12*C + 8*b1 + 9) + k2**4*(12 - 24*C)) - 143*f*k2**2*(4*b1**2*k2**2 + b1*k1**2*(3 - 6*K) + b1*k2**2*(-4*C - 12*K + 3) + 12*g2*(k1**2 + 2*k2**2))))/(15015*d*k3**6) + 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct*k1*st*(2*D1*bd1*f*(r + s - 1)*(45*f**2*k1**4 + 11*f*k2**2*(k1**2*(12*C + 2*K - 24*b1 - 9) + k2**2*(12*C - 6)) + 99*k2**2*(2*K*b1*k2**2 + b1*k1**2*(2*K - 1) - 2*g2*(k1**2 + k2**2))) + 33*b1**2*k2**2*(D1*fd*(-8*f*k1**2*(2*r + 2*s - 1) + (r + s)*(6*K*k2**2 + 3*k1**2*(2*K - 1))) - Dd*f*(-6*K*k2**2 + k1**2*(-6*K + 8*f + 3))*(4*r + 4*s - 3)) + 2*b1*(D1*(45*f**2*fd*k1**4*(3*r + 3*s - 2) + 11*f*k2**2*(fd*(k1**2*(12*C + 2*K - 9) + k2**2*(12*C - 6))*(2*r + 2*s - 1) - 18*gd2*(k1**2 + k2**2)*(r + s - 1)) - 198*fd*g2*k2**2*(k1**2 + k2**2)*(r + s)) + Dd*f*(4*r + 4*s - 3)*(45*f**2*k1**4 + 11*f*(k1**2*k2**2*(12*C + 2*K - 9) + k2**4*(12*C - 6)) - 198*g2*k2**2*(k1**2 + k2**2))) + 2*f*k1**2*k2**2*(D1*(f*fd*(30*C - 15)*(3*r + 3*s - 2) - 44*f*gd2*(r + s - 1) - 44*fd*g2*(2*r + 2*s - 1)) + Dd*f*(f*(30*C - 15) - 44*g2)*(4*r + 4*s - 3)))/(3465*d*k3**6) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*f**3*k1**2*k2**3*st**7*(D1*fd + Dd*f)*(4*r + 4*s - 3)/(1287*d*k3**6) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*f*k2*st**5*(D1*(3*f**2*k1**2*(-13*bd1*k2**2*(r + s - 1) + 18*fd*k1**2*(4*r + 4*s - 3)) + 13*f*k2**2*(-3*b1*fd*k1**2*(3*r + 3*s - 2) + k2**2*(fd*(2*C - 1)*(3*r + 3*s - 2) + (-11*K*bd1 + 22*gd2)*(r + s - 1))) + 143*fd*k2**4*(-K*b1 + 2*g2)*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(54*f**2*k1**4 - 13*f*(3*b1*k1**2*k2**2 + k2**4*(1 - 2*C)) + k2**4*(-143*K*b1 + 286*g2)))/(9009*d*k3**6) + 16*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*k1**2*st*(D1*bd1*f*(r + s - 1)*(15*f**2*k1**4 - 22*f*(8*b1*k1**2*k2**2 + k2**4*(3 - 6*C)) - k2**4*(-198*K*b1 + 198*g2)) + b1*(D1*(-88*b1*f*fd*k1**2*k2**2*(2*r + 2*s - 1) + 15*f**2*fd*k1**4*(3*r + 3*s - 2) + 66*f*k2**4*(fd*(2*C - 1)*(2*r + 2*s - 1) - 3*gd2*(r + s - 1)) - 99*fd*k2**4*(r + s)*(-K*b1 + 2*g2)) + Dd*f*(4*r + 4*s - 3)*(15*f**2*k1**4 - 22*f*(4*b1*k1**2*k2**2 + k2**4*(3 - 6*C)) + k2**4*(99*K*b1 - 198*g2))))/(3465*d*k2*k3**6) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*st**3*(D1*(-429*b1*fd*k2**6*(r + s)*(K*b1 - 2*g2) + f**3*k1**4*(182*bd1*k2**2*(r + s - 1) + 55*fd*k1**2*(4*r + 4*s - 3)) + 13*f**2*k2**2*(2*b1*k1**2*(-44*bd1*k2**2*(r + s - 1) + 7*fd*k1**2*(3*r + 3*s - 2)) + k2**2*(fd*k1**2*(42*C - 21)*(3*r + 3*s - 2) + (r + s - 1)*(33*K*bd1*k1**2 - 11*bd1*k2**2*(1 - 2*C) - 66*gd2*k1**2))) + 143*f*k2**4*(-4*b1**2*fd*k1**2*(2*r + 2*s - 1) + b1*fd*(3*K*k1**2 + k2**2*(2*C - 1))*(2*r + 2*s - 1) + 6*b1*k2**2*(-K*bd1 + gd2)*(r + s - 1) + 6*bd1*g2*k2**2*(r + s - 1) - 6*fd*g2*k1**2*(2*r + 2*s - 1))) + Dd*f*(4*r + 4*s - 3)*(-429*b1*k2**6*(K*b1 - 2*g2) + 55*f**3*k1**6 + 91*f**2*k1**2*k2**2*(2*b1*k1**2 + k2**2*(6*C - 3)) - 143*f*k2**4*(-3*K*b1*k1**2 + 4*b1**2*k1**2 + b1*k2**2*(1 - 2*C) + 6*g2*k1**2)))/(15015*d*k2*k3**6) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*b1*st*(-D1*bd1*f*k2**2*(2*C - 1)*(2*r + 2*s - 1) + b1**2*k1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*(D1*bd1*f*k1**2*(3*r + 3*s - 2) - k2**2*(2*C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))))/(105*d*k2*k3) - 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**6*f*k1**2*k2**3*st*(585*C*D1*f*fd*r + 585*C*D1*f*fd*s - 390*C*D1*f*fd + 780*C*Dd*f**2*r + 780*C*Dd*f**2*s - 585*C*Dd*f**2 + 143*D1*bd1*f*(K - 1)*(r + s - 1) + 392*D1*f**2*fd*r + 392*D1*f**2*fd*s - 294*D1*f**2*fd - 585*D1*f*fd*r - 585*D1*f*fd*s + 390*D1*f*fd - 286*D1*f*gd2*r - 286*D1*f*gd2*s + 286*D1*f*gd2 - 572*D1*fd*g2*r - 572*D1*fd*g2*s + 286*D1*fd*g2 + 392*Dd*f**3*r + 392*Dd*f**3*s - 294*Dd*f**3 - 780*Dd*f**2*r - 780*Dd*f**2*s + 585*Dd*f**2 - 1144*Dd*f*g2*r - 1144*Dd*f*g2*s + 858*Dd*f*g2 + 143*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))/(9009*d*k3**5) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**5*f*k1*k2**2*st*(2*D1*bd1*f*(9*f + 11)*(r + s - 1) + b1*(2*D1*fd*(9*f*(3*r + 3*s - 2) + 22*r + 22*s - 11) + 2*Dd*f*(9*f + 11)*(4*r + 4*s - 3)) + 15*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(693*d*k3**3) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**5*f*k1*k2**2*st*(-14040*C*D1*f*fd*k1**2*r - 14040*C*D1*f*fd*k1**2*s + 9360*C*D1*f*fd*k1**2 - 11700*C*D1*f*fd*k2**2*r - 11700*C*D1*f*fd*k2**2*s + 7800*C*D1*f*fd*k2**2 - 18720*C*Dd*f**2*k1**2*r - 18720*C*Dd*f**2*k1**2*s + 14040*C*Dd*f**2*k1**2 - 15600*C*Dd*f**2*k2**2*r - 15600*C*Dd*f**2*k2**2*s + 11700*C*Dd*f**2*k2**2 - 26*D1*bd1*f*(k1**2*(132*K - 132) - k2**2*(-110*K + 45*f + 55))*(r + s - 1) - 13440*D1*f**2*fd*k1**2*r - 13440*D1*f**2*fd*k1**2*s + 10080*D1*f**2*fd*k1**2 + 14040*D1*f*fd*k1**2*r + 14040*D1*f*fd*k1**2*s - 9360*D1*f*fd*k1**2 + 8775*D1*f*fd*k2**2*r + 8775*D1*f*fd*k2**2*s - 5850*D1*f*fd*k2**2 + 6864*D1*f*gd2*k1**2*r + 6864*D1*f*gd2*k1**2*s - 6864*D1*f*gd2*k1**2 + 5720*D1*f*gd2*k2**2*r + 5720*D1*f*gd2*k2**2*s - 5720*D1*f*gd2*k2**2 + 13728*D1*fd*g2*k1**2*r + 13728*D1*fd*g2*k1**2*s - 6864*D1*fd*g2*k1**2 + 11440*D1*fd*g2*k2**2*r + 11440*D1*fd*g2*k2**2*s - 5720*D1*fd*g2*k2**2 - 13440*Dd*f**3*k1**2*r - 13440*Dd*f**3*k1**2*s + 10080*Dd*f**3*k1**2 + 18720*Dd*f**2*k1**2*r + 18720*Dd*f**2*k1**2*s - 14040*Dd*f**2*k1**2 + 11700*Dd*f**2*k2**2*r + 11700*Dd*f**2*k2**2*s - 8775*Dd*f**2*k2**2 + 27456*Dd*f*g2*k1**2*r + 27456*Dd*f*g2*k1**2*s - 20592*Dd*f*g2*k1**2 + 22880*Dd*f*g2*k2**2*r + 22880*Dd*f*g2*k2**2*s - 17160*Dd*f*g2*k2**2 + 26*b1*(D1*fd*(k1**2*(132 - 132*K)*(2*r + 2*s - 1) + 5*k2**2*(9*f*(3*r + 3*s - 2) + (11 - 22*K)*(2*r + 2*s - 1))) + Dd*f*(k1**2*(132 - 132*K) + k2**2*(-110*K + 45*f + 55))*(4*r + 4*s - 3)))/(45045*d*k3**5) - np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**4*f*k1**2*k2**3*st**3*(1092*C*D1*f*fd*r + 1092*C*D1*f*fd*s - 728*C*D1*f*fd + 1456*C*Dd*f**2*r + 1456*C*Dd*f**2*s - 1092*C*Dd*f**2 + 286*D1*bd1*f*(K - 1)*(r + s - 1) + 1540*D1*f**2*fd*r + 1540*D1*f**2*fd*s - 1155*D1*f**2*fd - 1092*D1*f*fd*r - 1092*D1*f*fd*s + 728*D1*f*fd - 572*D1*f*gd2*r - 572*D1*f*gd2*s + 572*D1*f*gd2 - 1144*D1*fd*g2*r - 1144*D1*fd*g2*s + 572*D1*fd*g2 + 1540*Dd*f**3*r + 1540*Dd*f**3*s - 1155*Dd*f**3 - 1456*Dd*f**2*r - 1456*Dd*f**2*s + 1092*Dd*f**2 - 2288*Dd*f*g2*r - 2288*Dd*f*g2*s + 1716*Dd*f*g2 + 286*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))/(3003*d*k3**5) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**4*k2*st*(99*b1**2*k1**2*(K - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*(99*D1*bd1*f*k1**2*(K - 1)*(2*r + 2*s - 1) + D1*(264*C*f*fd*k1**2*(r + s - 1) + 225*f**2*fd*k1**2*(4*r + 4*s - 3) - 22*f*(5*K*fd*k2**2*(2*r + 2*s - 1) - 12*fd*k1**2*(r + s) + 9*gd2*k1**2*(r + s - 1)) - 198*fd*g2*k1**2*(r + s - 1)) + 2*Dd*f*(4*r + 4*s - 3)*(-55*K*f*k2**2 + 150*f**2*k1**2 + f*k1**2*(66*C + 66) - 99*g2*k1**2)) + f*(D1*bd1*(75*f**2*k1**2*(4*r + 4*s - 3) + 22*f*(-5*K*k2**2*(r + s - 1) + 6*k1**2*(C*r + C*s + r + s - 2)) - 198*g2*k1**2*(r + s)) + 5*D1*(3*f*fd*(12*k1**2 + k2**2*(5 - 10*C))*(3*r + 3*s - 2) - 22*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) - 22*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + 5*Dd*f*(4*r + 4*s - 3)*(36*f*k1**2 + f*k2**2*(15 - 30*C) - k2**2*(22*b2 - 44*g2))))/(3465*d*k3**3) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**4*k2*st*(13*D1*bd1*f*(r + s - 1)*(225*f**2*k1**2*k2**2 - 22*f*(5*K*k2**4 + k1**4*(9*K - 9) + k1**2*k2**2*(6*C + 24*K - 18)) + k1**2*k2**2*(-198*K*b1 + 198*b1 + 198*g2)) - 1287*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) + 13*b1*(D1*(225*f**2*fd*k1**2*k2**2*(3*r + 3*s - 2) - 22*f*(fd*(2*r + 2*s - 1)*(5*K*k2**4 + k1**4*(9*K - 9) + k1**2*k2**2*(6*C + 24*K - 18)) - 9*gd2*k1**2*k2**2*(r + s - 1)) + 198*fd*g2*k1**2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(225*f**2*k1**2*k2**2 - 22*f*(5*K*k2**4 + k1**4*(9*K - 9) + k1**2*k2**2*(6*C + 24*K - 18)) + 198*g2*k1**2*k2**2)) + f*(D1*(-4200*f**2*fd*k1**4*(4*r + 4*s - 3) - 195*f*fd*(3*r + 3*s - 2)*(k1**4*(18*C - 18) + k1**2*k2**2*(48*C - 36) + k2**4*(10*C - 5)) + 572*f*gd2*(9*k1**4 + 24*k1**2*k2**2 + 5*k2**4)*(r + s - 1) + 572*fd*g2*(9*k1**4 + 24*k1**2*k2**2 + 5*k2**4)*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(4200*f**2*k1**4 + 195*f*(k1**4*(18*C - 18) + k1**2*k2**2*(48*C - 36) + k2**4*(10*C - 5)) - 572*g2*(9*k1**4 + 24*k1**2*k2**2 + 5*k2**4))))/(45045*d*k3**5) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**3*f*k1*k2**2*st**3*(D1*bd1*f*(14*f + 11)*(r + s - 1) + b1*(D1*fd*(14*f*(3*r + 3*s - 2) + 22*r + 22*s - 11) + Dd*f*(14*f + 11)*(4*r + 4*s - 3)) + 7*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(231*d*k3**3) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**3*f*k1*k2**2*st**3*(-3276*C*D1*f*fd*k1**2*r - 3276*C*D1*f*fd*k1**2*s + 2184*C*D1*f*fd*k1**2 - 5460*C*D1*f*fd*k2**2*r - 5460*C*D1*f*fd*k2**2*s + 3640*C*D1*f*fd*k2**2 - 4368*C*Dd*f**2*k1**2*r - 4368*C*Dd*f**2*k1**2*s + 3276*C*Dd*f**2*k1**2 - 7280*C*Dd*f**2*k2**2*r - 7280*C*Dd*f**2*k2**2*s + 5460*C*Dd*f**2*k2**2 - 13*D1*bd1*f*(k1**2*(66*K - 66) - k2**2*(-110*K + 70*f + 55))*(r + s - 1) - 8800*D1*f**2*fd*k1**2*r - 8800*D1*f**2*fd*k1**2*s + 6600*D1*f**2*fd*k1**2 + 3276*D1*f*fd*k1**2*r + 3276*D1*f*fd*k1**2*s - 2184*D1*f*fd*k1**2 + 4095*D1*f*fd*k2**2*r + 4095*D1*f*fd*k2**2*s - 2730*D1*f*fd*k2**2 + 1716*D1*f*gd2*k1**2*r + 1716*D1*f*gd2*k1**2*s - 1716*D1*f*gd2*k1**2 + 2860*D1*f*gd2*k2**2*r + 2860*D1*f*gd2*k2**2*s - 2860*D1*f*gd2*k2**2 + 3432*D1*fd*g2*k1**2*r + 3432*D1*fd*g2*k1**2*s - 1716*D1*fd*g2*k1**2 + 5720*D1*fd*g2*k2**2*r + 5720*D1*fd*g2*k2**2*s - 2860*D1*fd*g2*k2**2 - 8800*Dd*f**3*k1**2*r - 8800*Dd*f**3*k1**2*s + 6600*Dd*f**3*k1**2 + 4368*Dd*f**2*k1**2*r + 4368*Dd*f**2*k1**2*s - 3276*Dd*f**2*k1**2 + 5460*Dd*f**2*k2**2*r + 5460*Dd*f**2*k2**2*s - 4095*Dd*f**2*k2**2 + 6864*Dd*f*g2*k1**2*r + 6864*Dd*f*g2*k1**2*s - 5148*Dd*f*g2*k1**2 + 11440*Dd*f*g2*k2**2*r + 11440*Dd*f*g2*k2**2*s - 8580*Dd*f*g2*k2**2 + 13*b1*(D1*fd*(k1**2*(66 - 66*K)*(2*r + 2*s - 1) + 5*k2**2*(14*f*(3*r + 3*s - 2) + (11 - 22*K)*(2*r + 2*s - 1))) + Dd*f*(k1**2*(66 - 66*K) + k2**2*(-110*K + 70*f + 55))*(4*r + 4*s - 3)))/(15015*d*k3**5) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**3*k1*st*(6*D1*bd1*f**2*(r + s) + b1**2*(D1*fd*(16*f + 9)*(r + s - 1) + Dd*f*(8*f + 9)*(4*r + 4*s - 3)) + b1*f*(D1*bd1*(8*f + 9)*(2*r + 2*s - 1) + 12*D1*fd*(r + s - 1) + 6*Dd*f*(4*r + 4*s - 3)))/(315*d*k3) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**3*k1*st*(-11*D1*b1*bd1*f*(-k1**2*(6*K - 6)*(2*r + 2*s - 1) + k2**2*(9*K*(-4*r - 4*s + 2) + 8*f + 9)) + 11*b1**2*(D1*fd*(k1**2*(6*K - 6)*(r + s - 1) + k2**2*(18*K*(r + s - 1) + 8*f + 9)) + 6*Dd*f*(3*K*k2**2 + k1**2*(K - 1))*(4*r + 4*s - 3)) + 2*b1*(D1*(90*f**2*fd*k1**2*(5*r + 5*s - 4) + 11*f*(fd*k1**2*(8*C*(r + s - 1) + 10*r + 10*s - 1) + 3*fd*k2**2*(8*C*(r + s - 1) + K*(-8*r - 8*s + 4) - 4*r - 4*s + 5) - 6*gd2*(k1**2 + 3*k2**2)*(r + s - 1)) - 66*fd*g2*(k1**2 + 3*k2**2)*(r + s - 1)) + Dd*f*(4*r + 4*s - 3)*(150*f**2*k1**2 + 11*f*(k1**2*(4*C + 5) + k2**2*(12*C - 12*K - 6)) - 66*g2*(k1**2 + 3*k2**2))) + f*(2*D1*bd1*(30*f**2*k1**2*(5*r + 5*s - 3) + 11*f*(k1**2*(4*C*s + r*(4*C + 5) + 5*s - 9) - 3*k2**2*(-4*C*r - 4*C*s + 4*K*(r + s - 1) + 2*r + 2*s + 1)) - 66*g2*(k1**2 + 3*k2**2)*(r + s)) + 3*D1*(15*f*fd*(3*k1**2 + k2**2*(4 - 8*C))*(3*r + 3*s - 2) - 88*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) - 88*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + 3*Dd*f*(4*r + 4*s - 3)*(45*f*k1**2 + f*k2**2*(60 - 120*C) - k2**2*(88*b2 - 176*g2))))/(3465*d*k3**3) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**3*k1*st*(26*D1*bd1*f*(r + s - 1)*(60*f**2*k1**2*k2**2 - 11*f*(k1**4*(2*K - 2) + k1**2*k2**2*(12*C + 18*K - 21) + k2**4*(12*C + 12*K - 8*b1 - 9)) - 99*k2**2*(2*b1*k1**2*(K - 1) + b1*k2**2*(2*K - 1) - 2*g2*(k1**2 + k2**2))) + 143*b1**2*k2**2*(D1*fd*(8*f*k2**2*(2*r + 2*s - 1) + (r + s)*(-9*k1**2*(2*K - 2) - 9*k2**2*(2*K - 1))) + Dd*f*(k1**2*(18 - 18*K) + k2**2*(-18*K + 8*f + 9))*(4*r + 4*s - 3)) + 26*b1*(D1*(60*f**2*fd*k1**2*k2**2*(3*r + 3*s - 2) - 11*f*fd*(2*r + 2*s - 1)*(k1**4*(2*K - 2) + k1**2*k2**2*(12*C + 18*K - 21) + k2**4*(12*C + 12*K - 9)) + 198*f*gd2*k2**2*(k1**2 + k2**2)*(r + s - 1) + 198*fd*g2*k2**2*(k1**2 + k2**2)*(r + s)) + Dd*f*(4*r + 4*s - 3)*(60*f**2*k1**2*k2**2 - 11*f*(k1**4*(2*K - 2) + k1**2*k2**2*(12*C + 18*K - 21) + k2**4*(12*C + 12*K - 9)) + 198*g2*k2**2*(k1**2 + k2**2))) + f*(D1*(-2240*f**2*fd*k1**4*(4*r + 4*s - 3) - 195*f*fd*(3*r + 3*s - 2)*(k1**4*(4*C - 4) + k1**2*k2**2*(36*C - 27) + k2**4*(24*C - 12)) + 1144*f*gd2*(k1**4 + 9*k1**2*k2**2 + 6*k2**4)*(r + s - 1) + 1144*fd*g2*(k1**4 + 9*k1**2*k2**2 + 6*k2**4)*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(2240*f**2*k1**4 + 195*f*(k1**4*(4*C - 4) + k1**2*k2**2*(36*C - 27) + k2**4*(24*C - 12)) - 1144*g2*(k1**4 + 9*k1**2*k2**2 + 6*k2**4))))/(45045*d*k3**5) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**2*f*k1**2*k2**3*st**5*(78*C*D1*f*fd*r + 78*C*D1*f*fd*s - 52*C*D1*f*fd + 104*C*Dd*f**2*r + 104*C*Dd*f**2*s - 78*C*Dd*f**2 - 143*D1*bd1*f*(K - 1)*(r + s - 1) + 756*D1*f**2*fd*r + 756*D1*f**2*fd*s - 567*D1*f**2*fd - 78*D1*f*fd*r - 78*D1*f*fd*s + 52*D1*f*fd + 286*D1*f*gd2*r + 286*D1*f*gd2*s - 286*D1*f*gd2 + 572*D1*fd*g2*r + 572*D1*fd*g2*s - 286*D1*fd*g2 + 756*Dd*f**3*r + 756*Dd*f**3*s - 567*Dd*f**3 - 104*Dd*f**2*r - 104*Dd*f**2*s + 78*Dd*f**2 + 1144*Dd*f*g2*r + 1144*Dd*f*g2*s - 858*Dd*f*g2 - 143*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))/(9009*d*k3**5) + np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**2*k2*st**3*(33*b1**2*k1**2*(K - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*(33*D1*bd1*f*k1**2*(K - 1)*(2*r + 2*s - 1) - 2*D1*(105*f**2*fd*k1**2*(4*r + 4*s - 3) + 11*f*(-5*K*fd*k2**2*(2*r + 2*s - 1) + 2*fd*k1**2*(C*(r + s - 1) + 5*r + 5*s - 2) + 3*gd2*k1**2*(r + s - 1)) + 33*fd*g2*k1**2*(r + s - 1)) - 2*Dd*f*(4*r + 4*s - 3)*(140*f**2*k1**2 + 11*f*(-5*K*k2**2 + k1**2*(C + 5)) + 33*g2*k1**2)) - 2*f*(D1*bd1*(35*f**2*k1**2*(4*r + 4*s - 3) + 11*f*(-5*K*k2**2*(r + s - 1) + k1**2*(r*(C + 5) + s*(C + 5) - 6)) + 33*g2*k1**2*(r + s)) + D1*(7*f*fd*(6*k1**2 + k2**2*(5 - 10*C))*(3*r + 3*s - 2) - 55*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) - 55*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + Dd*f*(7*f*(6*k1**2 + k2**2*(5 - 10*C)) + k2**2*(-55*b2 + 110*g2))*(4*r + 4*s - 3)))/(1155*d*k3**3) + np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**2*k2*st**3*(13*D1*bd1*f*(r + s - 1)*(210*f**2*k1**2*k2**2 - 11*f*(10*K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(2*C + 24*K - 14)) - k1**2*k2**2*(-66*K*b1 + 66*b1 + 66*g2)) + 429*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) + 13*b1*(D1*(210*f**2*fd*k1**2*k2**2*(3*r + 3*s - 2) - 11*f*(fd*(2*r + 2*s - 1)*(10*K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(2*C + 24*K - 14)) + 6*gd2*k1**2*k2**2*(r + s - 1)) - 66*fd*g2*k1**2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(210*f**2*k1**2*k2**2 - 11*f*(10*K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(2*C + 24*K - 14)) - 66*g2*k1**2*k2**2)) - 2*f*(D1*(1650*f**2*fd*k1**4*(4*r + 4*s - 3) + 91*f*fd*(3*r + 3*s - 2)*(k1**4*(3*C - 3) + k1**2*k2**2*(24*C - 18) + k2**4*(10*C - 5)) - 143*f*gd2*(3*k1**4 + 24*k1**2*k2**2 + 10*k2**4)*(r + s - 1) - 143*fd*g2*(3*k1**4 + 24*k1**2*k2**2 + 10*k2**4)*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(1650*f**2*k1**4 + 91*f*(k1**4*(3*C - 3) + k1**2*k2**2*(24*C - 18) + k2**4*(10*C - 5)) - 143*g2*(3*k1**4 + 24*k1**2*k2**2 + 10*k2**4))))/(15015*d*k3**5) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**2*st*(D1*bd1*f*(r + s)*(4*f*k1**2 + f*k2**2*(6 - 12*C) - k2**2*(9*b2 - 18*g2)) + 3*b1**2*(D1*fd*(-3*K*k2**2 + k1**2*(4*f + 2))*(r + s - 1) + Dd*f*(-3*K*k2**2 + k1**2*(2*f + 2))*(4*r + 4*s - 3)) + b1*(3*D1*bd1*f*(-3*K*k2**2 + k1**2*(2*f + 2))*(2*r + 2*s - 1) + D1*(f*(8*fd*k1**2 + fd*k2**2*(12 - 24*C) - k2**2*(9*bd2 - 18*gd2)) - 9*fd*k2**2*(b2 - 2*g2))*(r + s - 1) + Dd*f*(4*r + 4*s - 3)*(4*f*k1**2 + f*k2**2*(6 - 12*C) - k2**2*(9*b2 - 18*g2))))/(315*d*k2*k3) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**2*st*(D1*bd1*f*(45*f**2*k1**4*(2*r + 2*s - 1) + 22*f*(2*k1**4*(r + s - 1) + k1**2*k2**2*(8*C*r + 8*C*s - 9*K*(r + s - 1) + 3*b1*(4*r + 4*s - 5) - 6) + k2**4*(6*C - 3)) + 33*k2**2*(3*K*b1*k2**2 + b1*k1**2*(C*(4*r + 4*s - 2) + 4*K*(2*r + 2*s - 1) + 4*r + 4*s - 8) - 3*b2*k2**2*(r + s - 1) - 8*g2*k1**2*(r + s) - 6*g2*k2**2)) + 33*b1**2*k2**2*(D1*fd*(-3*K*k2**2 + 2*k1**2*(C*(r + s - 1) + 2*K*r + 2*K*s - 2*K + f*(4*r + 4*s - 1) + r + s + 2)) + 2*Dd*f*k1**2*(4*r + 4*s - 3)*(C + 2*K + 2*f + 1)) + b1*(D1*(45*f**2*fd*k1**4*(6*r + 6*s - 5) + 11*f*(2*fd*(k1**4*(4*r + 4*s - 2) + k1**2*k2**2*(16*C*(r + s - 1) - 9*K*(2*r + 2*s - 1) + 6) + k2**4*(3 - 6*C)) - 3*k2**2*(3*bd2*k2**2 + 8*gd2*k1**2)*(r + s - 1)) - 33*fd*k2**2*(3*b2*k2**2*(r + s) + 8*g2*k1**2*(r + s - 1) - 6*g2*k2**2)) + Dd*f*(4*r + 4*s - 3)*(-99*b2*k2**4 + 90*f**2*k1**4 + 22*f*(2*k1**4 + k1**2*k2**2*(8*C - 9*K)) - 264*g2*k1**2*k2**2)) + 3*f*k1**2*(D1*(5*f*fd*(2*k1**2 + k2**2*(9 - 18*C))*(3*r + 3*s - 2) - 66*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) - 66*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + Dd*f*(5*f*(2*k1**2 + k2**2*(9 - 18*C)) + k2**2*(-66*b2 + 132*g2))*(4*r + 4*s - 3)))/(3465*d*k2*k3**3) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**2*st*(D1*(1287*b1*fd*k2**2*(r + s)*(b1*(K*k2**4 + k1**4*(K - 1) + k1**2*k2**2*(4*K - 2)) - 2*g2*(k1**4 + 4*k1**2*k2**2 + k2**4)) + 30*f**3*k1**4*(39*bd1*k2**2*(r + s - 1) + 14*fd*k1**2*(4*r + 4*s - 3)) + 13*f**2*k2**2*(22*bd1*(r + s - 1)*(k1**4*(6*C + 4*K - 8) - k1**2*k2**2*(-24*C - 9*K + 24*b1 + 18) + k2**4*(6*C - 3)) + k1**2*(15*fd*(k1**2*(8*C + 6*b1 - 6) + k2**2*(18*C - 9))*(3*r + 3*s - 2) - 44*gd2*(4*k1**2 + 9*k2**2)*(r + s - 1))) - 286*f*k2**2*(12*b1**2*fd*k1**2*k2**2*(2*r + 2*s - 1) - 9*b1*bd1*(r + s - 1)*(K*k2**4 + k1**4*(K - 1) + k1**2*k2**2*(4*K - 2)) - b1*fd*(2*r + 2*s - 1)*(k1**4*(6*C + 4*K - 8) + k1**2*k2**2*(24*C + 9*K - 18) + k2**4*(6*C - 3)) + 9*b1*gd2*(k1**4 + 4*k1**2*k2**2 + k2**4)*(r + s - 1) + 9*bd1*g2*(k1**4 + 4*k1**2*k2**2 + k2**4)*(r + s - 1) + 2*fd*g2*k1**2*(4*k1**2 + 9*k2**2)*(2*r + 2*s - 1))) + Dd*f*(4*r + 4*s - 3)*(1287*b1*k2**2*(b1*(K*k2**4 + k1**4*(K - 1) + k1**2*k2**2*(4*K - 2)) - 2*g2*(k1**4 + 4*k1**2*k2**2 + k2**4)) + 420*f**3*k1**6 + 195*f**2*k1**2*k2**2*(k1**2*(8*C + 6*b1 - 6) + k2**2*(18*C - 9)) + 286*f*k2**2*(-12*b1**2*k1**2*k2**2 + b1*(k1**4*(6*C + 4*K - 8) + k1**2*k2**2*(24*C + 9*K - 18) + k2**4*(6*C - 3)) - 2*g2*k1**2*(4*k1**2 + 9*k2**2))))/(45045*d*k2*k3**5) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct*f*k1*k2**2*st**5*(D1*b1*fd*(6*f*(3*r + 3*s - 2) - 22*r - 22*s + 11) + D1*bd1*f*(6*f - 11)*(r + s - 1) + D1*f*fd*(3*r + 3*s - 2) + Dd*b1*f*(6*f - 11)*(4*r + 4*s - 3) + Dd*f**2*(4*r + 4*s - 3))/(693*d*k3**3) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct*f*k1*k2**2*st**5*(D1*(f**2*(-78*bd1*k2**2*(r + s - 1) + 216*fd*k1**2*(4*r + 4*s - 3)) - 13*f*k2**2*(11*bd1*(2*K - 1)*(r + s - 1) + fd*(-4*C + 6*b1 + 3)*(3*r + 3*s - 2) - 44*gd2*(r + s - 1)) + 143*fd*k2**2*(2*r + 2*s - 1)*(-2*K*b1 + b1 + 4*g2)) + Dd*f*(4*r + 4*s - 3)*(216*f**2*k1**2 - f*k2**2*(-52*C + 78*b1 + 39) + k2**2*(-286*K*b1 + 143*b1 + 572*g2)))/(9009*d*k3**5) - np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct*k1*st**3*(D1*bd1*f**2*(r + s) + b1**2*(D1*fd*(8*f - 3)*(r + s - 1) + Dd*f*(4*f - 3)*(4*r + 4*s - 3)) + b1*f*(D1*bd1*(4*f - 3)*(2*r + 2*s - 1) + 2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)))/(105*d*k3) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct*k1*st*(-2*D1*bd1*f*(r + s)*(3*b2 + f*(4*C - 2) - 6*g2) + 6*b1**3*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + 3*b1**2*(2*D1*bd1*f*(3*r + 3*s - 2) - (2*K - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))) + b1*(-3*D1*bd1*f*(2*K - 1)*(2*r + 2*s - 1) - 6*D1*bd2*f*(r + s - 1) + 4*D1*(r + s - 1)*(f*fd*(2 - 4*C) + 3*f*gd2 + 3*fd*g2) - 4*Dd*f*(f*(2*C - 1) - 3*g2)*(4*r + 4*s - 3) - 6*b2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))))/(315*d*k3) - np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct*k1*st**3*(D1*bd1*f*(28*f**2*k1**2*(5*r + 5*s - 3) + 11*f*(3*k1**2*(r + s - 1) - k2**2*(-4*C*r - 4*C*s + 12*K*(r + s - 1) + 4*b1 + 2*r + 2*s + 1)) - 33*k2**2*(b1*(K*(4*r + 4*s - 2) - 1) - 4*g2*(r + s))) + 11*b1**2*k2**2*(D1*fd*(-6*K*(r + s - 1) + 4*f - 3) - 6*Dd*K*f*(4*r + 4*s - 3)) + b1*(D1*(84*f**2*fd*k1**2*(5*r + 5*s - 4) + 11*f*(fd*k1**2*(6*r + 6*s - 3) + fd*k2**2*(8*C*(r + s - 1) - 12*K*(2*r + 2*s - 1) - 4*r - 4*s + 5) + 12*gd2*k2**2*(r + s - 1)) + 132*fd*g2*k2**2*(r + s - 1)) + Dd*f*(4*r + 4*s - 3)*(140*f**2*k1**2 + 33*f*k1**2 + 22*f*k2**2*(2*C - 6*K - 1) + 132*g2*k2**2)) + 3*f*(D1*(7*f*fd*(k1**2 + k2**2*(4 - 8*C))*(3*r + 3*s - 2) - 44*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) - 44*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + Dd*f*(7*f*(k1**2 + k2**2*(4 - 8*C)) + k2**2*(-44*b2 + 88*g2))*(4*r + 4*s - 3)))/(1155*d*k3**3) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct*k1*st*(66*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) - 11*b1**2*(D1*(-6*bd1*f*k2**2*(3*r + 3*s - 2) + 4*f*fd*k1**2*(8*r + 8*s - 5) + 9*fd*k1**2*(r + s) + 3*fd*k2**2*(4*C*(r + s - 1) - 2*K*(2*r + 2*s + 1) - 3*r - 3*s + 3)) + Dd*f*(k1**2*(16*f + 9) + k2**2*(12*C - 12*K - 9))*(4*r + 4*s - 3)) - 11*b1*(D1*bd1*f*(2*k1**2*(2*f*(8*r + 8*s - 7) + 9*r + 9*s - 9) + 3*k2**2*(C*(8*r + 8*s - 4) - 2*K*(4*r + 4*s - 5) - 6*r - 6*s + 3)) - 2*D1*(f*(fd*k1**2*(2*K - 3)*(2*r + 2*s - 1) + fd*k2**2*(4*C - 2)*(4*r + 4*s - 1) + k2**2*(9*bd2 - 12*gd2)*(r + s - 1)) - 3*fd*k2**2*(-3*b2*(r + s) + g2*(4*r + 4*s + 2))) - 2*Dd*f*(4*r + 4*s - 3)*(f*k1**2*(2*K - 3) + f*k2**2*(8*C - 4) + k2**2*(9*b2 - 12*g2))) + 2*f*(11*D1*bd1*(9*b2*k2**2*(r + s - 1) + f*k1**2*(2*K - 3)*(r + s - 1) + f*k2**2*(4*C - 2)*(2*r + 2*s - 3) - 6*g2*k2**2*(2*r + 2*s - 3)) + k1**2*(90*C*D1*f*fd*r + 90*C*D1*f*fd*s - 60*C*D1*f*fd + 120*C*Dd*f**2*r + 120*C*Dd*f**2*s - 90*C*Dd*f**2 + 22*D1*bd2*f*(r + s - 1) - 45*D1*f*fd*r - 45*D1*f*fd*s + 30*D1*f*fd - 44*D1*f*gd2*r - 44*D1*f*gd2*s + 44*D1*f*gd2 - 88*D1*fd*g2*r - 88*D1*fd*g2*s + 44*D1*fd*g2 - 60*Dd*f**2*r - 60*Dd*f**2*s + 45*Dd*f**2 - 176*Dd*f*g2*r - 176*Dd*f*g2*s + 132*Dd*f*g2 + 22*b2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))))/(3465*d*k3**3) - np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct*k1*st**3*(D1*(-429*b1*fd*k2**4*(r + s)*(b1*(2*K - 1) - 4*g2) + 8*f**3*k1**2*(-91*bd1*k2**2*(r + s - 1) + 110*fd*k1**2*(4*r + 4*s - 3)) - 13*f**2*k2**2*(-11*bd1*(k1**2*(6*K - 3) + k2**2*(4*C + 12*K - 8*b1 - 3))*(r + s - 1) + 7*fd*(k1**2*(-12*C + 8*b1 + 9) + k2**2*(12 - 24*C))*(3*r + 3*s - 2) + 132*gd2*(k1**2 + 2*k2**2)*(r + s - 1)) - 143*f*k2**2*(4*b1**2*fd*k2**2*(2*r + 2*s - 1) - b1*(fd*(k1**2*(6*K - 3) + k2**2*(4*C + 12*K - 3))*(2*r + 2*s - 1) + k2**2*(r + s - 1)*(-12*K*bd1 + 6*bd1 + 12*gd2)) + 12*g2*(-bd1*k2**2*(r + s - 1) + fd*(k1**2 + 2*k2**2)*(2*r + 2*s - 1)))) + Dd*f*(4*r + 4*s - 3)*(-429*b1*k2**4*(b1*(2*K - 1) - 4*g2) + 880*f**3*k1**4 - 91*f**2*(k1**2*k2**2*(-12*C + 8*b1 + 9) + k2**4*(12 - 24*C)) - 143*f*k2**2*(4*b1**2*k2**2 + b1*k1**2*(3 - 6*K) + b1*k2**2*(-4*C - 12*K + 3) + 12*g2*(k1**2 + 2*k2**2))))/(15015*d*k3**5) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct*k1*st*(2*D1*bd1*f*(r + s - 1)*(45*f**2*k1**4 + 11*f*k2**2*(k1**2*(12*C + 2*K - 24*b1 - 9) + k2**2*(12*C - 6)) + 99*k2**2*(2*K*b1*k2**2 + b1*k1**2*(2*K - 1) - 2*g2*(k1**2 + k2**2))) + 33*b1**2*k2**2*(D1*fd*(-8*f*k1**2*(2*r + 2*s - 1) + (r + s)*(6*K*k2**2 + 3*k1**2*(2*K - 1))) - Dd*f*(-6*K*k2**2 + k1**2*(-6*K + 8*f + 3))*(4*r + 4*s - 3)) + 2*b1*(D1*(45*f**2*fd*k1**4*(3*r + 3*s - 2) + 11*f*k2**2*(fd*(k1**2*(12*C + 2*K - 9) + k2**2*(12*C - 6))*(2*r + 2*s - 1) - 18*gd2*(k1**2 + k2**2)*(r + s - 1)) - 198*fd*g2*k2**2*(k1**2 + k2**2)*(r + s)) + Dd*f*(4*r + 4*s - 3)*(45*f**2*k1**4 + 11*f*(k1**2*k2**2*(12*C + 2*K - 9) + k2**4*(12*C - 6)) - 198*g2*k2**2*(k1**2 + k2**2))) + 2*f*k1**2*k2**2*(D1*(f*fd*(30*C - 15)*(3*r + 3*s - 2) - 44*f*gd2*(r + s - 1) - 44*fd*g2*(2*r + 2*s - 1)) + Dd*f*(f*(30*C - 15) - 44*g2)*(4*r + 4*s - 3)))/(3465*d*k3**5) - np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*f**3*k1**2*k2**3*st**7*(D1*fd + Dd*f)*(4*r + 4*s - 3)/(1287*d*k3**5) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*f*k2*st**5*(D1*bd1*f*(11*K*k2**2*(r + s - 1) + f*k1**2*(4*r + 4*s - 3)) + b1*(D1*fd*(11*K*k2**2*(2*r + 2*s - 1) + 3*f*k1**2*(4*r + 4*s - 3)) + Dd*f*(11*K*k2**2 + 4*f*k1**2)*(4*r + 4*s - 3)) + k2**2*(-6*C*D1*f*fd*r - 6*C*D1*f*fd*s + 4*C*D1*f*fd - 8*C*Dd*f**2*r - 8*C*Dd*f**2*s + 6*C*Dd*f**2 + 11*D1*bd2*f*(r + s - 1) + 3*D1*f*fd*r + 3*D1*f*fd*s - 2*D1*f*fd - 22*D1*f*gd2*r - 22*D1*f*gd2*s + 22*D1*f*gd2 - 44*D1*fd*g2*r - 44*D1*fd*g2*s + 22*D1*fd*g2 + 4*Dd*f**2*r + 4*Dd*f**2*s - 3*Dd*f**2 - 88*Dd*f*g2*r - 88*Dd*f*g2*s + 66*Dd*f*g2 + 11*b2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))))/(693*d*k3**3) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*f*k2*st**5*(D1*(3*f**2*k1**2*(-13*bd1*k2**2*(r + s - 1) + 18*fd*k1**2*(4*r + 4*s - 3)) + 13*f*k2**2*(-3*b1*fd*k1**2*(3*r + 3*s - 2) + k2**2*(fd*(2*C - 1)*(3*r + 3*s - 2) + (-11*K*bd1 + 22*gd2)*(r + s - 1))) + 143*fd*k2**4*(-K*b1 + 2*g2)*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(54*f**2*k1**4 - 13*f*(3*b1*k1**2*k2**2 + k2**4*(1 - 2*C)) + k2**4*(-143*K*b1 + 286*g2)))/(9009*d*k3**5) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*k1**2*st*(D1*bd1*f*(r + s - 1)*(15*f**2*k1**4 - 22*f*(8*b1*k1**2*k2**2 + k2**4*(3 - 6*C)) - k2**4*(-198*K*b1 + 198*g2)) + b1*(D1*(-88*b1*f*fd*k1**2*k2**2*(2*r + 2*s - 1) + 15*f**2*fd*k1**4*(3*r + 3*s - 2) + 66*f*k2**4*(fd*(2*C - 1)*(2*r + 2*s - 1) - 3*gd2*(r + s - 1)) - 99*fd*k2**4*(r + s)*(-K*b1 + 2*g2)) + Dd*f*(4*r + 4*s - 3)*(15*f**2*k1**4 - 22*f*(4*b1*k1**2*k2**2 + k2**4*(3 - 6*C)) + k2**4*(99*K*b1 - 198*g2))))/(3465*d*k2*k3**5) - np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*st**3*(D1*bd1*f*k2**2*(r + s)*(-2*C*f + 3*b2 + f - 6*g2) + b1**2*(D1*fd*(3*K*k2**2 + 2*f*k1**2)*(r + s - 1) + Dd*f*(3*K*k2**2 + f*k1**2)*(4*r + 4*s - 3)) + b1*(D1*bd1*f*(3*K*k2**2 + f*k1**2)*(2*r + 2*s - 1) + k2**2*(-4*C*D1*f*fd*r - 4*C*D1*f*fd*s + 4*C*D1*f*fd - 8*C*Dd*f**2*r - 8*C*Dd*f**2*s + 6*C*Dd*f**2 + 3*D1*bd2*f*(r + s - 1) + 2*D1*f*fd*r + 2*D1*f*fd*s - 2*D1*f*fd - 6*D1*f*gd2*r - 6*D1*f*gd2*s + 6*D1*f*gd2 - 6*D1*fd*g2*r - 6*D1*fd*g2*s + 6*D1*fd*g2 + 4*Dd*f**2*r + 4*Dd*f**2*s - 3*Dd*f**2 - 24*Dd*f*g2*r - 24*Dd*f*g2*s + 18*Dd*f*g2 + 3*b2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)))))/(105*d*k2*k3) - np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*st**3*(D1*bd1*f*(7*f**2*k1**4*(2*r + 2*s - 1) + 11*f*k2**2*(-3*K*k1**2*(r + s - 1) + b1*k1**2*(4*r + 4*s - 5) + k2**2*(2*C - 1)) + 33*k2**4*(-K*b1 + b2*(r + s - 1) + 2*g2)) + 11*b1**2*k2**2*(D1*fd*(3*K*k2**2 + f*k1**2*(4*r + 4*s - 1)) + 2*Dd*f**2*k1**2*(4*r + 4*s - 3)) + b1*(D1*(7*f**2*fd*k1**4*(6*r + 6*s - 5) - 11*f*(3*K*fd*k1**2*k2**2*(2*r + 2*s - 1) - 3*bd2*k2**4*(r + s - 1) + fd*k2**4*(2*C - 1)) + 33*fd*k2**4*(b2*(r + s) - 2*g2)) + Dd*f*(4*r + 4*s - 3)*(-33*K*f*k1**2*k2**2 + 33*b2*k2**4 + 14*f**2*k1**4)) - 3*f*k1**2*k2**2*(42*C*D1*f*fd*r + 42*C*D1*f*fd*s - 28*C*D1*f*fd + 56*C*Dd*f**2*r + 56*C*Dd*f**2*s - 42*C*Dd*f**2 + 11*D1*bd2*f*(r + s - 1) - 21*D1*f*fd*r - 21*D1*f*fd*s + 14*D1*f*fd - 22*D1*f*gd2*r - 22*D1*f*gd2*s + 22*D1*f*gd2 - 44*D1*fd*g2*r - 44*D1*fd*g2*s + 22*D1*fd*g2 - 28*Dd*f**2*r - 28*Dd*f**2*s + 21*Dd*f**2 - 88*Dd*f*g2*r - 88*Dd*f*g2*s + 66*Dd*f*g2 + 11*b2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))))/(1155*d*k2*k3**3) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*st*(3*D1*bd1*f*k1**2*k2**2*(3*b2 + f*(4*C - 2) - 6*g2)*(r + s - 1) + 6*b1**3*k1**2*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1**2*(D1*(9*K*fd*k1**2*k2**2*(r + s) + 6*bd1*f*k1**2*k2**2*(3*r + 3*s - 2) - 2*f*fd*k1**4*(4*r + 4*s - 3) + fd*k2**4*(3 - 6*C)*(r + s - 1)) - Dd*f*(4*r + 4*s - 3)*(6*C*k2**4 - 9*K*k1**2*k2**2 + 4*f*k1**4 - 3*k2**4)) + b1*(D1*bd1*f*(18*K*k1**2*k2**2*(r + s - 1) - 2*f*k1**4*(4*r + 4*s - 3) - k2**4*(6*C - 3)*(2*r + 2*s - 1)) + 3*k1**2*k2**2*(3*D1*b2*fd*(r + s) + 3*D1*bd2*f*(r + s - 1) + 2*D1*(f*fd*(2*C - 1)*(2*r + 2*s - 1) - 3*f*gd2*(r + s - 1) - 3*fd*g2*(r + s)) + 3*Dd*b2*f*(4*r + 4*s - 3) + 2*Dd*f*(f*(2*C - 1) - 3*g2)*(4*r + 4*s - 3))))/(315*d*k2*k3**3) - np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*st**3*(D1*(-429*b1*fd*k2**6*(r + s)*(K*b1 - 2*g2) + f**3*k1**4*(182*bd1*k2**2*(r + s - 1) + 55*fd*k1**2*(4*r + 4*s - 3)) + 13*f**2*k2**2*(2*b1*k1**2*(-44*bd1*k2**2*(r + s - 1) + 7*fd*k1**2*(3*r + 3*s - 2)) + k2**2*(fd*k1**2*(42*C - 21)*(3*r + 3*s - 2) + (r + s - 1)*(33*K*bd1*k1**2 - 11*bd1*k2**2*(1 - 2*C) - 66*gd2*k1**2))) + 143*f*k2**4*(-4*b1**2*fd*k1**2*(2*r + 2*s - 1) + b1*fd*(3*K*k1**2 + k2**2*(2*C - 1))*(2*r + 2*s - 1) + 6*b1*k2**2*(-K*bd1 + gd2)*(r + s - 1) + 6*bd1*g2*k2**2*(r + s - 1) - 6*fd*g2*k1**2*(2*r + 2*s - 1))) + Dd*f*(4*r + 4*s - 3)*(-429*b1*k2**6*(K*b1 - 2*g2) + 55*f**3*k1**6 + 91*f**2*k1**2*k2**2*(2*b1*k1**2 + k2**2*(6*C - 3)) - 143*f*k2**4*(-3*K*b1*k1**2 + 4*b1**2*k1**2 + b1*k2**2*(1 - 2*C) + 6*g2*k1**2)))/(15015*d*k2*k3**5) + 8*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**6*f*k1**2*k2*st*(4*Pk2 - Pkd2*k2)*(D1*(98*f**2*fd*(4*s - 1) + f*fd*(195*C - 195)*(3*s - 1) - 143*f*s*(-K*bd1 + bd1 + 2*gd2) + 286*fd*g2*(1 - 2*s)) + Dd*f*(4*s - 1)*(98*f**2 + f*(195*C - 195) - 286*g2) + 143*b1*(K - 1)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)))/(9009*d*k3**4) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**5*f*k1*st*(4*Pk2 - Pkd2*k2)*(2*b1*(D1*fd*(27*f*s - 9*f + 22*s - 11) + Dd*f*(9*f + 11)*(4*s - 1)) + f*(2*D1*bd1*s*(9*f + 11) + 15*D1*fd*(3*s - 1) + 15*Dd*f*(4*s - 1)))/(693*d*k3**2) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**5*f*k1*st*(D1*(90*f**2*(13*bd1*k2**2*(2*Pk2*(r - 1) + Pkd2*k2*s) + 4*fd*(13*Pk2*k2**2*(1 - 2*r) + 7*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 13*f*(-22*bd1*(-Pk2*k1**2*s*(32*K - 32) + 10*Pk2*k2**2*(K*(r - 2*s - 1) - 2*r + 2) + Pkd2*k1**2*k2*s*(8*K - 8) + Pkd2*k2**3*s*(10*K - 5)) + fd*(k1**2*(240*C - 240)*(4*Pk2 - Pkd2*k2)*(3*s - 1) - k2**2*(2*Pk2*(C*(618*r - 900*s + 94) - 843*r + 450*s + 131) + Pkd2*k2*(300*C - 225)*(3*s - 1))) + 88*gd2*(-16*Pk2*k1**2*s + 5*Pk2*k2**2*(r - 2*s - 1) + 4*Pkd2*k1**2*k2*s + 5*Pkd2*k2**3*s)) + 1144*fd*g2*(-4*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 5*k2**2*(2*Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1)))) + Dd*f*(360*f**2*(13*Pk2*k2**2*(1 - 2*r) + 7*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 13*f*(k1**2*(240*C - 240)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(-8*Pk2*(206*C*r - 4*C*(75*s + 7) - 281*r + 150*s + 103) + Pkd2*k2*(225 - 300*C)*(4*s - 1))) + 1144*g2*(-4*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 5*k2**2*(4*Pk2*(r - 2*s) + Pkd2*k2*(4*s - 1)))) + 26*b1*(D1*fd*(k1**2*(88*K - 88)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 5*k2**2*(-44*K*Pk2*(r - 2*s + 1) - 22*K*Pkd2*k2*(2*s - 1) + 88*Pk2*r + 22*Pkd2*k2*s - 11*Pkd2*k2 + 9*f*(Pk2*(6*r - 2) + Pkd2*k2*(3*s - 1)))) + Dd*f*(k1**2*(88*K - 88)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 5*k2**2*(36*Pk2*f*(2*r - 1) - 88*Pk2*(-2*K*s + r*(K - 2) + 1) + Pkd2*k2*(4*s - 1)*(-22*K + 9*f + 11)))))/(45045*d*k3**4) + np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**4*f*k1**2*k2*st**3*(4*Pk2 - Pkd2*k2)*(D1*(385*f**2*fd*(4*s - 1) + f*fd*(364*C - 364)*(3*s - 1) - 286*f*s*(-K*bd1 + bd1 + 2*gd2) + 572*fd*g2*(1 - 2*s)) + Dd*f*(4*s - 1)*(385*f**2 + f*(364*C - 364) - 572*g2) + 286*b1*(K - 1)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)))/(3003*d*k3**4) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**4*st*(99*b1**2*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(D1*fd*(s - 1) + Dd*f*(4*s - 1)) + b1*(D1*(5*f**2*fd*(22*Pk2*k2**2*(1 - 3*r) + 45*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) + 22*f*(fd*k1**2*(6*C + 2)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 5*fd*k2**2*(-K*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 2*Pk2*r) + k1**2*s*(4*Pk2 - Pkd2*k2)*(9*K*bd1 - 9*bd1 - 9*gd2)) - 198*fd*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) + Dd*f*(5*f**2*(44*Pk2*k2**2*(1 - 2*r) + 45*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 22*f*(k1**2*(6*C + 2)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 5*k2**2*(K*Pkd2*k2*(4*s - 1) + Pk2*(K*(2 - 8*s) - 4*r + 2))) - 198*g2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + f*(D1*(110*b2*fd*k2**2*(-2*Pk2 + Pkd2*k2)*(2*s - 1) - 5*bd1*f**2*(-180*Pk2*k1**2*s + 22*Pk2*k2**2*(r - 1) + 45*Pkd2*k1**2*k2*s) + 198*bd1*g2*k1**2*s*(-4*Pk2 + Pkd2*k2) + f*(22*bd1*(5*K*Pkd2*k2**3*s + Pk2*k1**2*s*(24*C + 8) - 5*Pk2*k2**2*(2*K*s + r - 1) - Pkd2*k1**2*k2*s*(6*C + 2)) + 120*fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + fd*k2**2*(Pk2*(-900*C*s + 300*C - 393*r + 450*s - 19) + Pkd2*k2*(150*C - 75)*(3*s - 1)) + k2**2*s*(-2*Pk2 + Pkd2*k2)*(110*bd2 - 220*gd2)) - 220*fd*g2*k2**2*(-2*Pk2 + Pkd2*k2)*(2*s - 1)) + Dd*f*(120*f*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + f*k2**2*(-4*Pk2*(75*C*(4*s - 1) + 131*r - 150*s - 28) + Pkd2*k2*(150*C - 75)*(4*s - 1)) + k2**2*(-2*Pk2 + Pkd2*k2)*(110*b2 - 220*g2)*(4*s - 1))))/(3465*d*k2*k3**2) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**4*st*(1287*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(2*Pk2*(r + 2*s - 1) - Pkd2*k2*s) + Dd*f*(8*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 4*s))) + 13*b1*(D1*(5*f**2*fd*k2**2*(22*Pk2*k2**2*(3*r - 1) + 45*k1**2*(4*Pk2*(2*r + s - 1) + Pkd2*k2*(2*s - 1))) + 11*f*(2*fd*(k1**4*(3*K - 3)*(4*Pk2 - Pkd2*k2)*(2*s - 1) - 2*k1**2*k2**2*(Pk2*(-12*C*(r + 2*s - 1) + K*(25*r - 6*s + 3) - 37*r - 10*s + 5) + 2*Pkd2*k2*(K*(8*s - 4) + s*(3*C - 7) + 2)) - 5*k2**4*(K*Pk2*(8*r + 4*s - 2) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r)) - 9*k1**2*k2**2*(4*Pk2*gd2*(r + 2*s - 1) - 2*Pkd2*gd2*k2*s - bd1*(K - 1)*(4*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 2*s)))) + 198*fd*g2*k1**2*k2**2*(-2*Pk2*(r + 2*s - 1) + Pkd2*k2*s)) + 2*Dd*f*(5*f**2*k2**2*(22*Pk2*k2**2*(2*r - 1) + 15*k1**2*(2*Pk2*(8*r + 4*s - 5) + Pkd2*k2*(4*s - 1))) + 11*f*(k1**4*(3*K - 3)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 2*k1**2*k2**2*(2*Pk2*(12*C*(r + 2*s - 1) + K*(-25*r + 6*s + 11) + 37*r + 10*s - 21) - Pkd2*k2*(4*s - 1)*(3*C + 8*K - 7)) - 5*k2**4*(K*Pkd2*k2*(4*s - 1) + 2*Pk2*(K*(8*r + 4*s - 5) - 2*r + 1))) + 99*g2*k1**2*k2**2*(-8*Pk2*(r + 2*s - 1) + Pkd2*k2*(4*s - 1)))) + f*(D1*(-2574*bd1*g2*k1**2*k2**2*(2*Pk2*(r + 2*s - 1) - Pkd2*k2*(s - 1)) + 5*f**2*(13*bd1*k2**2*(22*Pk2*k2**2*(r - 1) + 15*k1**2*(4*Pk2*(2*r + s - 2) + Pkd2*k2*(2*s + 1))) + 60*fd*(-39*Pk2*k1**2*k2**2*(3*r + 2*s - 2) + 7*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 13*f*(-220*Pk2*bd2*k2**4*(r + s - 1) - 22*bd1*(k1**4*s*(3 - 3*K)*(4*Pk2 - Pkd2*k2) + k1**2*k2**2*(-Pk2*(12*C*(r + 2*s - 1) + K*(-25*r + 6*s + 25) + 37*r + 10*s - 37) + 2*Pkd2*k2*(3*C*(s - 1) + s*(8*K - 7) + 3)) + 5*k2**4*(2*K*Pk2*(2*r + s - 2) + K*Pkd2*k2*s - Pk2*r + Pk2)) + fd*(k1**4*(90*C - 90)*(4*Pk2 - Pkd2*k2)*(3*s - 1) - 24*k1**2*k2**2*(Pk2*(6*C*(19*r - 4*s - 5) - 159*r - 51*s + 70) + Pkd2*k2*(20*C - 15)*(3*s - 1)) + k2**4*(-4*C*Pk2*(618*r + 225*s - 281) + 9*Pk2*(181*r + 50*s - 77) + Pkd2*k2*(75 - 150*C)*(3*s - 1))) + 44*gd2*(3*k1**4*s*(-4*Pk2 + Pkd2*k2) + k1**2*k2**2*(Pk2*(25*r - 6*s - 25) + 16*Pkd2*k2*s) + 5*k2**4*(2*Pk2*(2*r + s - 2) + Pkd2*k2*s))) - 572*fd*(5*Pk2*b2*k2**4*(2*r + 2*s - 1) + g2*(3*k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1) - 2*k1**2*k2**2*(Pk2*(25*r - 6*s + 3) + 8*Pkd2*k2*(2*s - 1)) - 5*k2**4*(Pk2*(8*r + 4*s - 2) + Pkd2*k2*(2*s - 1))))) + Dd*f*(-2860*Pk2*b2*k2**4*(4*r + 4*s - 3) + 300*f**2*k1**2*(-39*Pk2*k2**2*(3*r + 2*s - 2) + 7*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 13*f*(k1**4*(90*C - 90)*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 24*k1**2*k2**2*(Pk2*(4*C*(38*r - 8*s - 17) - 212*r - 68*s + 123) + Pkd2*k2*(20*C - 15)*(4*s - 1)) + k2**4*(-4*Pk2*(C*(824*r + 300*s - 487) - 543*r - 150*s + 309) + Pkd2*k2*(75 - 150*C)*(4*s - 1))) - 572*g2*(3*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 4*k1**2*k2**2*(Pk2*(25*r - 6*s - 11) + 4*Pkd2*k2*(4*s - 1)) + 5*k2**4*(-2*Pk2*(8*r + 4*s - 5) + Pkd2*k2*(1 - 4*s))))))/(45045*d*k2*k3**4) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**3*f*k1*st**3*(4*Pk2 - Pkd2*k2)*(b1*(D1*fd*(42*f*s - 14*f + 22*s - 11) + Dd*f*(14*f + 11)*(4*s - 1)) + f*(D1*bd1*s*(14*f + 11) + 7*D1*fd*(3*s - 1) + 7*Dd*f*(4*s - 1)))/(231*d*k3**2) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**3*f*k1*st**3*(D1*(10*f**2*(91*bd1*k2**2*(2*Pk2*(r - 1) + Pkd2*k2*s) + fd*(364*Pk2*k2**2*(1 - 2*r) + 165*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 13*f*(-11*bd1*(-Pk2*k1**2*s*(16*K - 16) + 10*Pk2*k2**2*(K*(r - 2*s - 1) - 2*r + 2) + Pkd2*k1**2*k2*s*(4*K - 4) + Pkd2*k2**3*s*(10*K - 5)) + fd*(k1**2*(56*C - 56)*(4*Pk2 - Pkd2*k2)*(3*s - 1) - k2**2*(6*Pk2*(2*C*(43*r - 70*s + 9) - 121*r + 70*s + 17) + Pkd2*k2*(140*C - 105)*(3*s - 1))) + 44*gd2*(-8*Pk2*k1**2*s + 5*Pk2*k2**2*(r - 2*s - 1) + 2*Pkd2*k1**2*k2*s + 5*Pkd2*k2**3*s)) + 572*fd*g2*(-2*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 5*k2**2*(2*Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1)))) + Dd*f*(10*f**2*(364*Pk2*k2**2*(1 - 2*r) + 165*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 13*f*(k1**2*(56*C - 56)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(-8*Pk2*(2*C*(43*r - 70*s - 4) - 121*r + 70*s + 43) + Pkd2*k2*(105 - 140*C)*(4*s - 1))) + 572*g2*(-2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 5*k2**2*(4*Pk2*(r - 2*s) + Pkd2*k2*(4*s - 1)))) + 13*b1*(D1*fd*(k1**2*(44*K - 44)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 5*k2**2*(-44*K*Pk2*(r - 2*s + 1) - 22*K*Pkd2*k2*(2*s - 1) + 88*Pk2*r + 22*Pkd2*k2*s - 11*Pkd2*k2 + 14*f*(Pk2*(6*r - 2) + Pkd2*k2*(3*s - 1)))) + Dd*f*(k1**2*(44*K - 44)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 5*k2**2*(56*Pk2*f*(2*r - 1) - 88*Pk2*(-2*K*s + r*(K - 2) + 1) + Pkd2*k2*(4*s - 1)*(-22*K + 14*f + 11)))))/(15015*d*k3**4) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**3*k1*st*(4*Pk2 - Pkd2*k2)*(6*D1*bd1*f**2*s + b1**2*(D1*fd*(16*f*s - 8*f + 9*s - 9) + Dd*f*(8*f + 9)*(4*s - 1)) + 2*b1*f*(D1*bd1*s*(8*f + 9) + D1*fd*(6*s - 3) + 3*Dd*f*(4*s - 1)))/(315*d*k2**2) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**3*st*(11*b1**2*k1**2*k2**2*(D1*fd*(-2*Pk2*(-9*K*(r - 2*s + 2) + 8*f + 9*r + 9) + Pkd2*k2*(18*K*(s - 1) + 8*f + 9)) + 18*Dd*f*(K*Pkd2*k2*(4*s - 1) + Pk2*(-8*K*s + r*(4*K - 4) + 2))) + b1*k1**2*(D1*(-8*f**2*(-11*Pk2*fd*k2**2*(18*r + 15*s - 13) + 11*bd1*k2**2*(-2*Pk2 + Pkd2*k2) + 15*fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) - 11*f*(6*fd*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) - 2*fd*k2**2*(2*Pk2*(4*C*(4*r - 6*s + 1) + 16*K*s - 8*K + r + 34*s - 12) + Pkd2*k2*(12*C*(2*s - 1) - 16*K*s + 8*K - 12*s + 9)) - 9*k2**2*(Pk2*bd1*(K*(4*r - 8*s - 2) - 4*r + 4) + Pkd2*bd1*k2*(4*K*s - 1) + 4*gd2*(-Pk2*r + 2*Pk2*s + Pk2 - Pkd2*k2*s))) - 396*fd*g2*k2**2*(Pk2*(r - 2*s + 2) + Pkd2*k2*(s - 1))) - 2*Dd*f*(4*f**2*(-11*Pk2*k2**2*(24*r + 20*s - 17) + 15*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 11*f*(-4*Pk2*k2**2*(2*C*(8*r - 12*s - 1) + 16*K*s - 4*K + r + 34*s - 9) + Pkd2*k2**3*(4*s - 1)*(-12*C + 8*K + 6) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 198*g2*k2**2*(4*Pk2*(r - 2*s) + Pkd2*k2*(4*s - 1)))) + f*(D1*(8*bd1*f**2*k1**2*(-60*Pk2*k1**2*s + 11*Pk2*k2**2*(6*r + 5*s - 4) + 15*Pkd2*k1**2*k2*s) + f*(fd*(Pk2*k2**4*(56 - 112*C)*(3*r - 1) - 45*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1) - 12*k1**2*k2**2*(Pk2*(-120*C*s + 40*C - 84*r - 21*s + 35) + Pkd2*k2*(20*C - 10)*(3*s - 1))) + 22*k1**2*(bd1*(-12*Pk2*k1**2*s + Pk2*k2**2*(16*C*r + r + s*(-24*C + 16*K + 34) - 11) + 3*Pkd2*k1**2*k2*s + Pkd2*k2**3*(s*(12*C - 8*K - 6) - 3)) + k2**2*s*(-2*Pk2 + Pkd2*k2)*(-8*bd2 + 16*gd2))) - 44*k1**2*k2**2*(-4*b2*fd*(2*Pk2 - Pkd2*k2)*(2*s - 1) + 9*bd1*g2*(Pk2*(r - 2*s) + Pkd2*k2*s) + 8*fd*g2*(2*Pk2 - Pkd2*k2)*(2*s - 1))) + Dd*f*(f*(Pk2*k2**4*(112 - 224*C)*(2*r - 1) - 45*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 12*k1**2*k2**2*(-40*C*Pk2*(4*s - 1) - 7*Pk2*(16*r + 4*s - 9) + Pkd2*k2*(20*C - 10)*(4*s - 1))) + k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(-176*b2 + 352*g2)*(4*s - 1))))/(3465*d*k1*k2**2*k3**2) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**3*st*(D1*(-429*b1*fd*k1**2*k2**2*(4*b1*k1**2*(K - 1)*(-Pk2*(r + 3*s - 1) + Pkd2*k2*s) - 3*b1*k2**2*(2*Pk2*(K*(r + 2*s - 2) + r + 1) + Pkd2*k2*s*(1 - 2*K)) + 8*g2*k1**2*(Pk2*(r + 3*s - 1) - Pkd2*k2*s) + 12*g2*k2**2*(Pk2*(r + 2*s - 2) - Pkd2*k2*s)) + 4*f**3*k1**2*(286*Pk2*bd1*k2**4*(4*r + 5*s - 6) - 585*Pk2*fd*k1**2*k2**2*(16*r + 20*s - 13) + 195*bd1*k1**2*k2**2*(2*Pk2*(5*r + 5*s - 6) + 3*Pkd2*k2) + 140*fd*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 13*f**2*k2**2*(-22*bd1*(k1**4*(2*Pk2*(4*C*(r + 3*s - 2) + K*(-6*r - 9*s + 6) + 11*r + 9*s - 7) + Pkd2*k2*(-8*C*(s - 1) + s*(11 - 6*K) - 8)) + k1**2*k2**2*(Pk2*(8*C*r + 24*C*s + K*(-58*r - 68*s + 58) - 8*b1 + 21*r + 10*s - 23) + Pkd2*k2*(-12*C*(s - 1) - 8*K*s + b1*(8*s - 4) + 9*s - 9))) + fd*(Pk2*k2**4*(112*C - 56)*(3*r - 1) + k1**4*(-2*Pk2*(C*(-618*r - 792*s + 470) + 180*b1*(5*r + 5*s - 3) + 1023*r + 1332*s - 785) + 45*Pkd2*k2*(4*b1 + (4*C - 3)*(3*s - 1))) + 4*k1**2*k2**2*(Pk2*(12*C*(129*r + 126*s - 85) - 22*b1*(12*r + 15*s - 7) - 1026*r - 999*s + 675) + Pkd2*k2*(60*C - 30)*(3*s - 1))) - 88*k1**2*(-6*Pk2*bd2*k2**2*(r + s - 1) + 3*gd2*k1**2*(Pk2*(2*r + 3*s - 2) + Pkd2*k2*s) + gd2*k2**2*(Pk2*(29*r + 34*s - 29) + 4*Pkd2*k2*s))) + 143*f*k1**2*k2**2*(-48*Pk2*b2*fd*k2**2*(2*r + 2*s - 1) + 16*b1**2*fd*k2**2*(Pk2 + Pkd2*k2*s) + b1*(3*bd1*(k1**2*(4*K - 4)*(Pk2*(2*r + 6*s - 3) + Pkd2*k2*(1 - 2*s)) - 3*k2**2*(Pk2*(K*(-4*r - 8*s + 2) - 4*r + 4) + Pkd2*k2*(2*K - 1)*(2*s - 1))) + 2*fd*k1**2*(2*Pk2*(8*C*(r + 3*s - 1) - 3*K*(4*r + 6*s - 3) + 22*r + 18*s - 13) + Pkd2*k2*(K*(6 - 12*s) + s*(22 - 16*C) - 3)) - 4*fd*k2**2*(Pk2*(-8*C*(r + 3*s - 2) + K*(58*r + 68*s - 34) - 21*r - 10*s + 4) + Pkd2*k2*(K*(8*s - 4) + s*(12*C - 9))) + 24*gd2*k1**2*(-Pk2*(r + 3*s - 1) + Pkd2*k2*s) + 36*gd2*k2**2*(-Pk2*(r + 2*s - 1) + Pkd2*k2*s)) - 24*bd1*g2*k1**2*(Pk2*(r + 3*s - 2) - Pkd2*k2*(s - 1)) - 36*bd1*g2*k2**2*(Pk2*(r + 2*s) + k2*(-Pkd2*s + Pkd2)) + 24*fd*g2*k1**2*(Pk2*(4*r + 6*s - 3) + Pkd2*k2*(2*s - 1)) + 16*fd*g2*k2**2*(Pk2*(29*r + 34*s - 17) + 2*Pkd2*k2*(2*s - 1)))) + Dd*f*(-429*b1*k1**2*k2**2*(-4*b1*k1**2*(K - 1)*(Pk2*(4*r + 12*s - 5) + Pkd2*k2*(1 - 4*s)) + 3*b1*k2**2*(-4*Pk2*(2*K*(r + 2*s - 1) + 2*r - 1) + Pkd2*k2*(2*K - 1)*(4*s - 1)) + 8*g2*k1**2*(Pk2*(4*r + 12*s - 5) + Pkd2*k2*(1 - 4*s)) + 12*g2*k2**2*(4*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 4*s))) + 20*f**3*k1**4*(-117*Pk2*k2**2*(16*r + 20*s - 13) + 28*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 13*f**2*k2**2*(Pk2*k2**4*(224*C - 112)*(2*r - 1) + k1**4*(-4*Pk2*(C*(-412*r - 528*s + 338) + 150*b1*(4*r + 4*s - 3) + 682*r + 888*s - 563) + Pkd2*k2*(180*C - 135)*(4*s - 1)) + 4*k1**2*k2**2*(-22*Pk2*b1*(16*r + 20*s - 13) + 3*Pk2*(16*C*(43*r + 42*s - 32) - 456*r - 444*s + 339) + Pkd2*k2*(60*C - 30)*(4*s - 1))) + 286*f*k1**2*k2**2*(-24*Pk2*b2*k2**2*(4*r + 4*s - 3) + 4*Pkd2*b1**2*k2**3*(4*s - 1) + b1*k1**2*(Pk2*(8*C*(4*r + 12*s - 5) - 6*K*(8*r + 12*s - 7) + 88*r + 72*s - 62) - Pkd2*k2*(4*s - 1)*(8*C + 6*K - 11)) + b1*k2**2*(4*Pk2*(2*C*(4*r + 12*s - 5) + K*(-58*r - 68*s + 46) + 21*r + 10*s - 13) - Pkd2*k2*(4*s - 1)*(12*C + 8*K - 9)) + 12*g2*k1**2*(Pk2*(8*r + 12*s - 7) + Pkd2*k2*(4*s - 1)) + 16*g2*k2**2*(Pk2*(29*r + 34*s - 23) + Pkd2*k2*(4*s - 1)))))/(45045*d*k1*k2**2*k3**4) - 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**2*f*k1**2*k2*st**5*(-4*Pk2 + Pkd2*k2)*(D1*(189*f**2*fd*(4*s - 1) + f*fd*(26*C - 26)*(3*s - 1) + 143*f*s*(-K*bd1 + bd1 + 2*gd2) + 286*fd*g2*(2*s - 1)) + Dd*f*(4*s - 1)*(189*f**2 + f*(26*C - 26) + 286*g2) - 143*b1*(K - 1)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)))/(9009*d*k3**4) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**2*st*(D1*bd1*f*(2*Pk2*f*(5*r + s*(12*C - 6)) + Pkd2*f*k2*s*(6 - 12*C) + s*(2*Pk2 - Pkd2*k2)*(9*b2 - 18*g2)) + 9*b1**2*(D1*fd*(K*(2*Pk2 - Pkd2*k2)*(s - 1) + Pk2*f*(2*r - 1) + Pk2*r) + Dd*f*(K*Pkd2*k2*(1 - 4*s) + Pk2*(8*K*s - 2*K + f*(4*r - 2) + 4*r - 2))) + b1*(48*C*D1*Pk2*f*fd*s - 24*C*D1*Pk2*f*fd - 24*C*D1*Pkd2*f*fd*k2*s + 12*C*D1*Pkd2*f*fd*k2 + 96*C*Dd*Pk2*f**2*s - 24*C*Dd*Pk2*f**2 - 48*C*Dd*Pkd2*f**2*k2*s + 12*C*Dd*Pkd2*f**2*k2 + 18*D1*Pk2*bd2*f*s + 20*D1*Pk2*f*fd*r - 24*D1*Pk2*f*fd*s + 2*D1*Pk2*f*fd - 36*D1*Pk2*f*gd2*s - 36*D1*Pk2*fd*g2*s + 36*D1*Pk2*fd*g2 - 9*D1*Pkd2*bd2*f*k2*s + 12*D1*Pkd2*f*fd*k2*s - 6*D1*Pkd2*f*fd*k2 + 18*D1*Pkd2*f*gd2*k2*s + 18*D1*Pkd2*fd*g2*k2*s - 18*D1*Pkd2*fd*g2*k2 + 9*D1*bd1*f*(-2*K*Pkd2*k2*s + Pk2*(4*K*s + 2*f*r - f + 2*r - 1)) + 40*Dd*Pk2*f**2*r - 48*Dd*Pk2*f**2*s - 8*Dd*Pk2*f**2 - 144*Dd*Pk2*f*g2*s + 36*Dd*Pk2*f*g2 + 24*Dd*Pkd2*f**2*k2*s - 6*Dd*Pkd2*f**2*k2 + 72*Dd*Pkd2*f*g2*k2*s - 18*Dd*Pkd2*f*g2*k2 + 9*b2*(2*Pk2 - Pkd2*k2)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))))/(315*d*k2) - np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**2*st**3*(33*b1**2*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(D1*fd*(s - 1) + Dd*f*(4*s - 1)) - 2*b1*(D1*(5*f**2*fd*(11*Pk2*k2**2*(1 - 3*r) + 21*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) + 11*f*(fd*k1**2*(C + 3)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 5*fd*k2**2*(-K*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 2*Pk2*r) + k1**2*s*(4*Pk2 - Pkd2*k2)*(-3*K*bd1 + 3*bd1 + 3*gd2)) + 33*fd*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) + Dd*f*(5*f**2*(22*Pk2*k2**2*(1 - 2*r) + 21*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 11*f*(k1**2*(C + 3)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 5*k2**2*(K*Pkd2*k2*(4*s - 1) + Pk2*(K*(2 - 8*s) - 4*r + 2))) + 33*g2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) - 2*f*(D1*(55*b2*fd*k2**2*(-2*Pk2 + Pkd2*k2)*(2*s - 1) - 5*bd1*f**2*(-84*Pk2*k1**2*s + 11*Pk2*k2**2*(r - 1) + 21*Pkd2*k1**2*k2*s) + 33*bd1*g2*k1**2*s*(4*Pk2 - Pkd2*k2) + f*(-11*bd1*(-5*K*Pkd2*k2**3*s + Pk2*k1**2*s*(-4*C - 12) + 5*Pk2*k2**2*(2*K*s + r - 1) + Pkd2*k1**2*k2*s*(C + 3)) + fd*(28*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(Pk2*(-420*C*s + 140*C - 153*r + 210*s - 19) + Pkd2*k2*(70*C - 35)*(3*s - 1))) + k2**2*s*(-2*Pk2 + Pkd2*k2)*(55*bd2 - 110*gd2)) - 110*fd*g2*k2**2*(-2*Pk2 + Pkd2*k2)*(2*s - 1)) + Dd*f*(28*f*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + f*k2**2*(-4*Pk2*(35*C*(4*s - 1) + 51*r - 70*s - 8) + Pkd2*k2*(70*C - 35)*(4*s - 1)) + k2**2*(-2*Pk2 + Pkd2*k2)*(55*b2 - 110*g2)*(4*s - 1))))/(1155*d*k2*k3**2) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**2*st*(33*b1**2*(D1*fd*(3*K*k2**2*(-2*Pk2*r + Pkd2*k2) + 2*k1**2*(2*Pk2*(C*s - K*s + K + 4*f*s + f + 2*s - 1) - Pkd2*k2*(C*s + 4*f*s + f + s))) + 2*Dd*f*(6*K*Pk2*k2**2*(1 - 2*r) + k1**2*(4*s - 1)*(Pk2*(2*C - 2*K + 4*f + 4) - Pkd2*k2*(C + 2*f + 1)))) + 11*b1*(3*D1*bd1*f*(-3*K*k2**2*(Pk2*(4*r - 2) + Pkd2*k2) + 2*k1**2*(-2*Pk2*(-2*C*s + C + 2*K*s + f*(3 - 4*s) - 4*s + 1) + Pkd2*k2*(-2*C*s + C + f*(3 - 4*s) - 2*s + 1))) + D1*(-18*Pk2*f**2*fd*k1**2*(6*r + 12*s - 7) + f*(12*Pk2*gd2*(2*k1**2*s + 3*k2**2*(r - 1)) + 9*Pkd2*bd2*k2**3*s - 2*fd*(k1**2*(2*Pk2*(7*C*(2*s - 1) + 6*K*s - 3*K + 9*r + 2*s - 5) + Pkd2*k2*(K*(3 - 6*s) + 8*s)) + k2**2*(2*Pk2*(10*C*(2*r - 1) - 9*K*(r + 2*s - 1) - 10*r + 5) + Pkd2*k2*(3 - 6*C)))) + 3*fd*(8*Pk2*g2*k1**2*(s - 1) + 3*Pkd2*b2*k2**3*s - 6*g2*k2**2*(-2*Pk2*r + Pkd2*k2))) + Dd*f*(-144*Pk2*f**2*k1**2*(r + 2*s - 1) + 8*Pk2*f*k2**2*(C*(10 - 20*r) + 9*K*(r + 2*s - 1) + 10*r - 5) + 24*Pk2*g2*(k1**2*(4*s - 1) + 3*k2**2*(2*r - 1)) + 9*Pkd2*b2*k2**3*(4*s - 1) - 2*f*k1**2*(2*Pk2*(7*C*(4*s - 1) + 12*K*s - 3*K + 18*r + 4*s - 10) - Pkd2*k2*(3*K - 4)*(4*s - 1)))) + f*(-540*C*D1*Pk2*f*fd*k1**2*s + 180*C*D1*Pk2*f*fd*k1**2 + 1296*C*D1*Pk2*f*fd*k2**2*r + 1584*C*D1*Pk2*f*fd*k2**2*s - 960*C*D1*Pk2*f*fd*k2**2 + 270*C*D1*Pkd2*f*fd*k1**2*k2*s - 90*C*D1*Pkd2*f*fd*k1**2*k2 - 720*C*Dd*Pk2*f**2*k1**2*s + 180*C*Dd*Pk2*f**2*k1**2 + 1728*C*Dd*Pk2*f**2*k2**2*r + 2112*C*Dd*Pk2*f**2*k2**2*s - 1392*C*Dd*Pk2*f**2*k2**2 + 360*C*Dd*Pkd2*f**2*k1**2*k2*s - 90*C*Dd*Pkd2*f**2*k1**2*k2 - 132*D1*Pk2*bd2*f*k1**2*s + 198*D1*Pk2*bd2*f*k2**2*r + 396*D1*Pk2*bd2*f*k2**2*s - 198*D1*Pk2*bd2*f*k2**2 - 483*D1*Pk2*f*fd*k1**2*r - 792*D1*Pk2*f*fd*k1**2*s + 425*D1*Pk2*f*fd*k1**2 - 648*D1*Pk2*f*fd*k2**2*r - 792*D1*Pk2*f*fd*k2**2*s + 480*D1*Pk2*f*fd*k2**2 + 264*D1*Pk2*f*gd2*k1**2*s - 396*D1*Pk2*f*gd2*k2**2*r - 792*D1*Pk2*f*gd2*k2**2*s + 396*D1*Pk2*f*gd2*k2**2 + 528*D1*Pk2*fd*g2*k1**2*s - 264*D1*Pk2*fd*g2*k1**2 - 792*D1*Pk2*fd*g2*k2**2*r - 1584*D1*Pk2*fd*g2*k2**2*s + 792*D1*Pk2*fd*g2*k2**2 + 66*D1*Pkd2*bd2*f*k1**2*k2*s - 135*D1*Pkd2*f*fd*k1**2*k2*s + 45*D1*Pkd2*f*fd*k1**2*k2 - 132*D1*Pkd2*f*gd2*k1**2*k2*s - 264*D1*Pkd2*fd*g2*k1**2*k2*s + 132*D1*Pkd2*fd*g2*k1**2*k2 - 11*D1*bd1*(18*Pk2*f**2*k1**2*(2*r + 4*s - 1) - 9*Pkd2*b2*k2**3*(s - 1) + 2*f*(k1**2*(Pk2*(9*r + s*(14*C + 6*K + 2) - 1) + Pkd2*k2*(s*(4 - 3*K) - 4)) + k2**2*(-9*K*Pk2*(r + 2*s - 1) + (2*C - 1)*(10*Pk2*r + 3*Pkd2*k2))) - 6*g2*(4*Pk2*k1**2*s + 6*Pk2*k2**2*r + 3*Pkd2*k2**3)) - 644*Dd*Pk2*f**2*k1**2*r - 1056*Dd*Pk2*f**2*k1**2*s + 586*Dd*Pk2*f**2*k1**2 - 864*Dd*Pk2*f**2*k2**2*r - 1056*Dd*Pk2*f**2*k2**2*s + 696*Dd*Pk2*f**2*k2**2 + 1056*Dd*Pk2*f*g2*k1**2*s - 264*Dd*Pk2*f*g2*k1**2 - 1584*Dd*Pk2*f*g2*k2**2*r - 3168*Dd*Pk2*f*g2*k2**2*s + 1584*Dd*Pk2*f*g2*k2**2 - 180*Dd*Pkd2*f**2*k1**2*k2*s + 45*Dd*Pkd2*f**2*k1**2*k2 - 528*Dd*Pkd2*f*g2*k1**2*k2*s + 132*Dd*Pkd2*f*g2*k1**2*k2 - 66*b2*(D1*fd*(-6*Pk2*k2**2*(r + 2*s - 1) + k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1)) + Dd*f*(-12*Pk2*k2**2*(r + 2*s - 1) + k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1)))))/(3465*d*k2*k3**2) - np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**2*st**3*(429*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(2*Pk2*(r + 2*s - 1) - Pkd2*k2*s) + Dd*f*(8*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 4*s))) - 13*b1*(D1*(10*f**2*fd*k2**2*(11*Pk2*k2**2*(3*r - 1) + 21*k1**2*(4*Pk2*(2*r + s - 1) + Pkd2*k2*(2*s - 1))) + 11*f*(fd*(k1**4*(K - 1)*(4*Pk2 - Pkd2*k2)*(2*s - 1) - 4*k1**2*k2**2*(Pk2*(-2*C*(r + 2*s - 1) + K*(5*r - 18*s + 9) - 15*r + 2*s - 1) + Pkd2*k2*(K*(8*s - 4) + s*(C - 5) + 2)) - 10*k2**4*(K*Pk2*(8*r + 4*s - 2) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r)) + 3*k1**2*k2**2*(4*Pk2*gd2*(r + 2*s - 1) - 2*Pkd2*gd2*k2*s - bd1*(K - 1)*(4*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 2*s)))) - 66*fd*g2*k1**2*k2**2*(-2*Pk2*(r + 2*s - 1) + Pkd2*k2*s)) + Dd*f*(20*f**2*k2**2*(11*Pk2*k2**2*(2*r - 1) + 7*k1**2*(2*Pk2*(8*r + 4*s - 5) + Pkd2*k2*(4*s - 1))) + 11*f*(k1**4*(K - 1)*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 2*k1**2*k2**2*(4*Pk2*(-2*C*(r + 2*s - 1) + K*(5*r - 18*s + 2) - 15*r + 2*s + 7) + Pkd2*k2*(4*s - 1)*(C + 8*K - 5)) - 10*k2**4*(K*Pkd2*k2*(4*s - 1) + 2*Pk2*(K*(8*r + 4*s - 5) - 2*r + 1))) - 66*g2*k1**2*k2**2*(-8*Pk2*(r + 2*s - 1) + Pkd2*k2*(4*s - 1)))) - f*(D1*(-858*bd1*g2*k1**2*k2**2*(-2*Pk2*(r + 2*s - 1) + Pkd2*k2*(s - 1)) + 10*f**2*(143*Pk2*bd1*k2**4*(r - 1) - 1092*Pk2*fd*k1**2*k2**2*(3*r + 2*s - 2) + 91*bd1*k1**2*k2**2*(4*Pk2*(2*r + s - 2) + Pkd2*k2*(2*s + 1)) + 165*fd*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 13*f*(-220*Pk2*bd2*k2**4*(r + s - 1) - 11*bd1*(-k1**4*s*(K - 1)*(4*Pk2 - Pkd2*k2) + 2*k1**2*k2**2*(Pk2*(-2*C*(r + 2*s - 1) + K*(5*r - 18*s - 5) - 15*r + 2*s + 15) + Pkd2*k2*(C*(s - 1) + s*(8*K - 5) + 1)) + 10*k2**4*(2*K*Pk2*(2*r + s - 2) + K*Pkd2*k2*s - Pk2*r + Pk2)) + 2*fd*(k1**4*(7*C - 7)*(4*Pk2 - Pkd2*k2)*(3*s - 1) + 2*k1**2*k2**2*(Pk2*(C*(-225*r + 186*s + 13) + 351*r + 24*s - 125) + Pkd2*k2*(42 - 56*C)*(3*s - 1)) + k2**4*(Pk2*(-4*C*(258*r + 105*s - 121) + 669*r + 210*s - 293) + Pkd2*k2*(35 - 70*C)*(3*s - 1))) + 22*gd2*(k1**4*(-4*Pk2*s + Pkd2*k2*s) + 2*k1**2*k2**2*(Pk2*(5*r - 18*s - 5) + 8*Pkd2*k2*s) + 10*k2**4*(2*Pk2*(2*r + s - 2) + Pkd2*k2*s))) - 286*fd*(10*Pk2*b2*k2**4*(2*r + 2*s - 1) + g2*(k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1) - 4*k1**2*k2**2*(Pk2*(5*r - 18*s + 9) + 4*Pkd2*k2*(2*s - 1)) - 10*k2**4*(Pk2*(8*r + 4*s - 2) + Pkd2*k2*(2*s - 1))))) + 2*Dd*f*(-1430*Pk2*b2*k2**4*(4*r + 4*s - 3) + 15*f**2*k1**2*(-364*Pk2*k2**2*(3*r + 2*s - 2) + 55*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 13*f*(k1**4*(7*C - 7)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 4*k1**2*k2**2*(Pk2*(C*(-150*r + 124*s + 44) + 234*r + 16*s - 121) + Pkd2*k2*(21 - 28*C)*(4*s - 1)) + k2**4*(-4*Pk2*(C*(344*r + 140*s - 207) - 223*r - 70*s + 129) + Pkd2*k2*(35 - 70*C)*(4*s - 1))) - 143*g2*(k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 8*k1**2*k2**2*(Pk2*(5*r - 18*s + 2) + 2*Pkd2*k2*(4*s - 1)) - 10*k2**4*(2*Pk2*(8*r + 4*s - 5) + Pkd2*k2*(4*s - 1))))))/(15015*d*k2*k3**4) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**2*st*(33*b1**2*(D1*fd*(k1**4*s*(K - 1)*(2*Pk2 - Pkd2*k2) + 4*k1**2*k2**2*(Pk2*(C*(r + s - 1) + K*s - 2*K + f*(4*r + 4*s - 1) + 3*r + 2*s + 2) + Pkd2*k2*s*(-2*K + 3*f + 1)) - 3*k2**4*(2*K*Pk2*(r + s + 1) + K*Pkd2*k2*s - Pk2*r + f*(-2*Pk2*r + Pk2))) + Dd*f*(k1**4*(K - 1)*(2*Pk2 - Pkd2*k2)*(4*s - 1) + 2*k1**2*k2**2*(2*Pk2*(C*(4*r + 4*s - 3) + 4*K*s - K + f*(8*r + 8*s - 6) + 12*r + 8*s - 8) + Pkd2*k2*(4*s - 1)*(-4*K + 3*f + 2)) + 3*k2**4*(K*Pkd2*k2*(1 - 4*s) - 2*Pk2*(K*(4*r + 4*s - 3) - 2*f*r + f - 2*r + 1)))) + b1*(33*D1*bd1*f*(k1**4*(K - 1)*(2*Pk2 - Pkd2*k2)*(2*s - 1) + 2*k1**2*k2**2*(2*Pk2*(C*(2*r + 2*s - 1) + 2*K*s + K + f*(4*r + 4*s - 5) + 6*r + 4*s - 7) + Pkd2*k2*(2*s - 1)*(-4*K + 3*f + 2)) - 3*k2**4*(K*Pkd2*k2*(2*s - 1) + Pk2*(K*(4*r + 4*s - 6) - 2*f*r + f - 2*r + 1))) + D1*(9*f**2*fd*k1**2*(22*Pk2*k2**2*(8*s - 1) + 5*k1**2*(4*Pk2*(3*r + 6*s - 2) - Pkd2*k2*(6*s + 1))) - 22*f*(9*Pk2*bd2*k2**4*(r + s - 1) + fd*(k1**4*(-Pk2*(8*C*s + K*(7 - 14*s) + 8*r + 14*s - 11) + Pkd2*k2*s*(4*C - 4)) + k1**2*k2**2*(2*Pk2*(C*(10*r - 2*s + 3) + K*(36*r + 66*s - 33) - 35*r - 38*s + 19) + Pkd2*k2*(K*(6*s - 3) + s*(32*C - 24))) + k2**4*(Pk2*(8*C*(5*r + 3*s - 1) + 18*K*(r + 2*s - 1) - 30*r - 12*s + 9) + Pkd2*k2*s*(12*C - 6))) - 3*gd2*(-2*Pk2*k1**4*s - 4*Pk2*k1**2*k2**2*s + 6*Pk2*k2**4*(r + s - 1) + Pkd2*k1**4*k2*s + 8*Pkd2*k1**2*k2**3*s + 3*Pkd2*k2**5*s)) + 66*fd*(-3*Pk2*b2*k2**4*(r + s) + g2*(k1**4*(-2*Pk2*s + Pkd2*k2*s) + 4*k1**2*k2**2*(-Pk2*(s - 2) + 2*Pkd2*k2*s) + 3*k2**4*(2*Pk2*(r + s + 1) + Pkd2*k2*s)))) + 2*Dd*f*(-99*Pk2*b2*k2**4*(4*r + 4*s - 3) + 3*f**2*k1**2*(88*Pk2*k2**2*(4*s - 1) + 15*k1**2*(8*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 4*s))) + 11*f*(k1**4*(Pk2*(4*C*(4*s - 1) - 28*K*s + 7*K + 16*r + 28*s - 15) + 2*Pkd2*k2*(-4*C*s + C + 4*s - 1)) + k1**2*k2**2*(-2*Pk2*(C*(20*r - 4*s - 9) + 3*K*(24*r + 44*s - 23) - 70*r - 76*s + 54) - Pkd2*k2*(4*s - 1)*(16*C + 3*K - 12)) + k2**4*(-4*Pk2*(C*(20*r + 12*s - 13) + 9*K*(r + 2*s - 1) - 15*r - 6*s + 9) + 3*Pkd2*k2*(C*(2 - 8*s) + 4*s - 1))) - 33*g2*(k1**4*(2*Pk2 - Pkd2*k2)*(4*s - 1) - 4*k1**2*k2**2*(-Pk2 + 2*Pkd2*k2)*(4*s - 1) - 3*k2**4*(Pk2*(8*r + 8*s - 6) + Pkd2*k2*(4*s - 1))))) + f*(D1*bd1*(44*C*f*(k1**4*(2*Pk2 - Pkd2*k2)*(s - 1) + k1**2*k2**2*(Pk2*(-5*r + s + 7) - 8*Pkd2*k2*(s - 1)) + k2**4*(-2*Pk2*(5*r + 3*s - 6) - 3*Pkd2*k2*(s - 1))) - 198*Pk2*b2*k2**4*(r + s - 1) + 3*f**2*k1**2*(22*Pk2*k2**2*(8*s - 5) + 15*k1**2*(4*Pk2*(r + 2*s - 2) + Pkd2*k2*(3 - 2*s))) + 22*f*(k1**4*(4*Pk2*r - Pk2*s*(7*K - 7) + 2*Pkd2*k2*(s - 1)) + k1**2*k2**2*(Pk2*(-6*K*(6*r + 11*s - 6) + 35*r + 38*s - 35) - 3*Pkd2*k2*(s*(K - 4) + 4)) + 3*k2**4*(Pk2*(-3*K*(r + 2*s - 1) + 5*r + 2*s - 4) + Pkd2*k2*(s - 1))) - 66*g2*(k1**4*(2*Pk2 - Pkd2*k2)*(s - 1) + 4*k1**2*k2**2*(Pk2*(s + 1) - 2*Pkd2*k2*(s - 1)) - 3*k2**4*(2*Pk2*(r + s - 2) + Pkd2*k2*(s - 1)))) + D1*(-90*Pk2*f**2*fd*k1**4*(10*r + 24*s - 11) + f*(-396*Pk2*bd2*k1**2*k2**2*(r + s - 1) + fd*(4*Pk2*k1**4*(-52*C*(3*s - 1) + 45*r + 201*s - 82) + Pk2*k2**4*(24 - 48*C)*(27*r + 33*s - 20) + k1**2*k2**2*(-4*C*Pk2*(888*r + 1467*s - 785) + 3*Pk2*(753*r + 1332*s - 695) + Pkd2*k2*(45 - 90*C)*(3*s - 1))) + 44*gd2*(7*Pk2*k1**4*s + 9*Pk2*k2**4*(r + 2*s - 1) + 3*k1**2*k2**2*(2*Pk2*(6*r + 11*s - 6) + Pkd2*k2*s))) + 44*fd*(-9*Pk2*b2*k1**2*k2**2*(2*r + 2*s - 1) + g2*(7*Pk2*k1**4*(2*s - 1) + 18*Pk2*k2**4*(r + 2*s - 1) + 3*k1**2*k2**2*(Pk2*(24*r + 44*s - 22) + Pkd2*k2*(2*s - 1))))) + Dd*f*(-396*Pk2*b2*k1**2*k2**2*(4*r + 4*s - 3) - 90*Pk2*f**2*k1**4*(10*r + 24*s - 11) + f*(4*Pk2*k1**4*(-52*C*(4*s - 1) + 60*r + 268*s - 97) + Pk2*k2**4*(24 - 48*C)*(36*r + 44*s - 29) + k1**2*k2**2*(C*Pk2*(-4736*r - 7824*s + 4324) + 6*Pk2*(502*r + 888*s - 473) - Pkd2*k2*(90*C - 45)*(4*s - 1))) + 44*g2*(7*Pk2*k1**4*(4*s - 1) + 36*Pk2*k2**4*(r + 2*s - 1) + 3*k1**2*k2**2*(Pk2*(48*r + 88*s - 46) + Pkd2*k2*(4*s - 1))))))/(3465*d*k2*k3**4) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*f*k1*st**5*(4*Pk2 - Pkd2*k2)*(b1*(D1*fd*(18*f*s - 6*f - 22*s + 11) + Dd*f*(6*f - 11)*(4*s - 1)) + f*(D1*bd1*s*(6*f - 11) + D1*fd*(3*s - 1) + Dd*f*(4*s - 1)))/(693*d*k3**2) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*f*k1*st**5*(D1*(6*f**2*(13*bd1*k2**2*(2*Pk2*(r - 1) + Pkd2*k2*s) + fd*(52*Pk2*k2**2*(1 - 2*r) + 27*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 13*f*k2**2*(11*bd1*(2*Pk2*(K*(r - 2*s - 1) - 2*r + 2) + Pkd2*k2*s*(2*K - 1)) + fd*(-2*Pk2*(2*C*(3*r - 6*s + 1) + b1*(6 - 18*r) - 9*r + 6*s + 1) + Pkd2*k2*(3*s - 1)*(-4*C + 6*b1 + 3)) - 44*gd2*(Pk2*(r - 2*s - 1) + Pkd2*k2*s)) + 143*fd*k2**2*(b1*(4*K*Pk2*(r - 2*s + 1) + 2*K*Pkd2*k2*(2*s - 1) - 8*Pk2*r - 2*Pkd2*k2*s + Pkd2*k2) - 4*g2*(2*Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1)))) + Dd*f*(6*f**2*(52*Pk2*k2**2*(1 - 2*r) + 27*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 13*f*k2**2*(8*Pk2*(-2*C*r + 4*C*s + b1*(6*r - 3) + 3*r - 2*s - 1) + Pkd2*k2*(4*s - 1)*(-4*C + 6*b1 + 3)) + 143*k2**2*(8*Pk2*b1*(-2*K*s + r*(K - 2) + 1) + Pkd2*b1*k2*(2*K - 1)*(4*s - 1) + 4*g2*(-4*Pk2*r + 8*Pk2*s - 4*Pkd2*k2*s + Pkd2*k2))))/(9009*d*k3**4) + np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*k1*st**3*(4*Pk2 - Pkd2*k2)*(D1*bd1*f**2*s + b1**2*(D1*fd*(f*(8*s - 4) - 3*s + 3) + Dd*f*(4*f - 3)*(4*s - 1)) + b1*f*(2*D1*bd1*s*(4*f - 3) + D1*fd*(2*s - 1) + Dd*f*(4*s - 1)))/(105*d*k2**2) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*k1*st*(66*Pkd2*b1**3*k2**3*(D1*fd*s + Dd*f*(4*s - 1)) + 11*b1**2*(6*D1*Pkd2*bd1*f*k2**3*(3*s - 1) + D1*fd*(Pk2*k1**2*s*(32*f + 6) - 6*Pk2*k2**2*(2*C*(r - 1) + 2*K*s - 2*K + 8*f*r - 3*f + 3) - Pkd2*k1**2*k2*s*(16*f + 3) + Pkd2*k2**3*s*(-12*C + 12*K + 9)) + Dd*f*k1**2*(2*Pk2 - Pkd2*k2)*(8*f + 3)*(4*s - 1) - 3*Dd*f*k2**2*(4*C*(Pk2*(4*r - 2) + Pkd2*k2*(4*s - 1)) + 16*Pk2*f*(2*r - 1) + (4*s - 1)*(4*K*Pk2 - 4*K*Pkd2*k2 - 3*Pkd2*k2))) + 11*b1*(D1*bd1*f*(k1**2*(2*Pk2 - Pkd2*k2)*(8*f + 3)*(2*s - 1) - 3*k2**2*(2*Pk2*(4*C*r + 4*K*s + f*(8*r - 5) - 3) + Pkd2*k2*(2*s - 1)*(4*C - 4*K - 3))) + 2*D1*(12*Pk2*f**2*fd*k1**2*(1 - 3*s) + f*(fd*(k1**2*(Pk2*(5 - 6*s) - 2*Pkd2*k2*s) + 2*k2**2*(Pk2*(C*(10 - 20*s) + 3*K*(2*r + 6*s - 3) - 9*r + 10*s - 3) + Pkd2*k2*s*(8*C - 4))) + 6*k2**2*s*(Pkd2*bd2*k2 + 2*gd2*(Pk2 - Pkd2*k2))) + 6*fd*k2**2*(2*Pk2*g2*(s - 1) + Pkd2*b2*k2*s - 2*Pkd2*g2*k2*s)) + 2*Dd*f*(12*Pk2*f**2*k1**2*(1 - 4*s) + f*(-k1**2*(3*Pk2 + Pkd2*k2)*(4*s - 1) + 2*k2**2*(Pk2*(C*(10 - 40*s) + 3*K*(4*r + 12*s - 5) - 18*r + 20*s + 4) + Pkd2*k2*(4*C - 2)*(4*s - 1))) + 6*k2**2*(4*s - 1)*(Pkd2*b2*k2 + 2*g2*(Pk2 - Pkd2*k2)))) + 2*f*(-11*D1*bd1*(12*Pk2*f**2*k1**2*s + f*(k1**2*(Pk2*(3*s + 2) + Pkd2*k2*(s - 1)) + k2**2*(Pk2*(20*C*s - 6*K*(r + 3*s - 1) + 9*r - 10*s - 5) + 4*Pkd2*k2*(-2*C*(s - 1) + s - 1))) - 6*k2**2*(Pkd2*b2*k2*(s - 1) + 2*g2*(Pk2*s - Pkd2*k2*s + Pkd2*k2))) + Pk2*(D1*(f*(-37*fd*k1**2*(3*s - 1) + fd*k2**2*(4*C - 2)*(87*r + 198*s - 95) + k2**2*(66*bd2 - 132*gd2)*(r + 3*s - 1)) + 66*fd*k2**2*(b2 - 2*g2)*(2*r + 6*s - 3)) + Dd*f*(-37*f*k1**2*(4*s - 1) + f*k2**2*(16*C - 8)*(29*r + 66*s - 31) + k2**2*(66*b2 - 132*g2)*(4*r + 12*s - 5)))))/(3465*d*k2**2*k3**2) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*st*(2*D1*Pk2*bd1*f**2*(5*k1**2*s + k2**2*r*(2 - 4*C)) - 6*b1**3*k1**2*(2*Pk2 - Pkd2*k2)*(D1*fd*s + Dd*f*(4*s - 1)) - 3*b1**2*k1**2*(2*D1*bd1*f*(2*Pk2 - Pkd2*k2)*(3*s - 1) + D1*fd*(Pk2*(-12*f*s + 6*f + 2) - Pkd2*k2*s) - Dd*f*(4*s - 1)*(6*Pk2*f + Pkd2*k2)) + b1*f*(3*D1*bd1*k1**2*(2*Pk2*(6*f*s + 1) + Pkd2*k2*(2*s - 1)) - 2*Pk2*(D1*fd*(k1**2*(5 - 10*s) + k2**2*(4*C - 2)*(2*r - 1)) + Dd*f*(k1**2*(5 - 20*s) + k2**2*(8*C - 4)*(2*r - 1)))))/(315*d*k1*k2**2) + np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*st**3*(11*b1**2*k1**2*k2**2*(D1*fd*(2*Pk2*(3*K*(r - 2*s + 2) + 4*f - 3*r - 3) + Pkd2*k2*(6*K*(s - 1) - 4*f + 3)) + 6*Dd*f*(K*Pkd2*k2*(4*s - 1) + Pk2*(-8*K*s + r*(4*K - 4) + 2))) + b1*k1**2*(D1*(4*f**2*(-11*Pk2*fd*k2**2*(18*r + 15*s - 13) + 11*bd1*k2**2*(-2*Pk2 + Pkd2*k2) + 14*fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) + 11*f*(fd*(k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(-2*Pk2*(C*(4*r - 8*s + 2) + 16*K*s - 8*K - 2*r - 4*s + 3) + Pkd2*k2*(C*(4 - 8*s) + 16*K*s - 8*K + 4*s - 3))) + 3*k2**2*(Pk2*bd1*(K*(4*r - 8*s - 2) - 4*r + 4) + Pkd2*bd1*k2*(4*K*s - 1) + 4*gd2*(-Pk2*r + 2*Pk2*s + Pk2 - Pkd2*k2*s))) - 132*fd*g2*k2**2*(Pk2*(r - 2*s + 2) + Pkd2*k2*(s - 1))) + Dd*f*(4*f**2*(-11*Pk2*k2**2*(24*r + 20*s - 17) + 14*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 11*f*(8*Pk2*k2**2*(-2*C*r + 4*C*s + K*(2 - 8*s) + r + 2*s - 1) + Pkd2*k2**3*(4*s - 1)*(-4*C + 8*K + 2) + k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 132*g2*k2**2*(4*Pk2*(r - 2*s) + Pkd2*k2*(4*s - 1)))) + f*(D1*(-4*bd1*f**2*k1**2*(-56*Pk2*k1**2*s + 11*Pk2*k2**2*(6*r + 5*s - 4) + 14*Pkd2*k1**2*k2*s) + f*(fd*(Pk2*k2**4*(64*C - 32)*(3*r - 1) + 7*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1) + 2*k1**2*k2**2*(Pk2*(-336*C*s + 112*C - 141*r + 60*s + 27) + Pkd2*k2*(56*C - 28)*(3*s - 1))) - 11*k1**2*(bd1*(-4*Pk2*k1**2*s + 2*Pk2*k2**2*(r*(2*C - 1) - s*(4*C - 8*K + 2)) + Pkd2*k1**2*k2*s + Pkd2*k2**3*(s*(4*C - 8*K - 2) - 1)) + k2**2*s*(-2*Pk2 + Pkd2*k2)*(-8*bd2 + 16*gd2))) + 44*k1**2*k2**2*(-2*b2*fd*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 3*bd1*g2*(Pk2*(r - 2*s) + Pkd2*k2*s) + 4*fd*g2*(2*Pk2 - Pkd2*k2)*(2*s - 1))) + Dd*f*(f*(Pk2*k2**4*(128*C - 64)*(2*r - 1) + 7*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 4*k1**2*k2**2*(Pk2*(-56*C*(4*s - 1) - 94*r + 40*s + 37) + Pkd2*k2*(28*C - 14)*(4*s - 1))) + k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(88*b2 - 176*g2)*(4*s - 1))))/(1155*d*k1*k2**2*k3**2) + np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*st**3*(D1*(429*b1*fd*k1**2*k2**4*(-2*Pk2*b1*(K*(r + 2*s - 2) + r + 1) + 4*Pk2*g2*(r + 2*s - 2) + Pkd2*b1*k2*s*(2*K - 1) - 4*Pkd2*g2*k2*s) + 4*f**3*k1**2*(143*Pk2*bd1*k2**4*(4*r + 5*s - 6) - 273*Pk2*fd*k1**2*k2**2*(16*r + 20*s - 13) + 91*bd1*k1**2*k2**2*(2*Pk2*(5*r + 5*s - 6) + 3*Pkd2*k2) + 55*fd*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 13*f**2*k2**2*(11*bd1*(k1**4*(2*K*Pk2*(r - 1) - 8*Pk2*(r + s - 1) + Pkd2*k2*s*(2*K - 1)) + k1**2*k2**2*(2*Pk2*(-2*C*r - 4*C*s + 2*K*(7*r + 2*s - 7) + 4*b1 - r + 6*s + 2) + Pkd2*k2*(4*C*(s - 1) + 8*K*s + b1*(4 - 8*s) - 3*s + 3))) + fd*(Pk2*k2**4*(64*C - 32)*(3*r - 1) - 7*k1**4*(2*Pk2*(-6*C*r + 2*C + 12*b1*(5*r + 5*s - 3) + 15*r + 12*s - 9) + Pkd2*k2*(-12*C*s + 4*C - 12*b1 + 9*s - 3)) + 2*k1**2*k2**2*(Pk2*(4*C*(267*r + 234*s - 167) - 22*b1*(12*r + 15*s - 7) - 675*r - 576*s + 417) + Pkd2*k2*(56*C - 28)*(3*s - 1))) - 44*k1**2*(-6*Pk2*bd2*k2**2*(r + s - 1) + gd2*k1**2*(Pk2*(r - 1) + Pkd2*k2*s) + 2*gd2*k2**2*(Pk2*(7*r + 2*s - 7) + 2*Pkd2*k2*s))) + 143*f*k1**2*k2**2*(-24*Pk2*b2*fd*k2**2*(2*r + 2*s - 1) + 8*b1**2*fd*k2**2*(Pk2 + Pkd2*k2*s) + b1*fd*(k1**2*(-4*Pk2*(r*(K - 4) - 4*s + 2) + Pkd2*k2*(K*(2 - 4*s) + 2*s - 1)) - 2*k2**2*(Pk2*(C*(-4*r - 8*s + 6) + 4*K*(7*r + 2*s - 1) - 2*r + 12*s - 7) + Pkd2*k2*(K*(8*s - 4) + s*(4*C - 3)))) + 3*b1*k2**2*(Pk2*bd1*(K*(-4*r - 8*s + 2) - 4*r + 4) + 4*Pk2*gd2*(r + 2*s - 1) + Pkd2*bd1*k2*(2*K - 1)*(2*s - 1) - 4*Pkd2*gd2*k2*s) + 12*bd1*g2*k2**2*(Pk2*(r + 2*s) + k2*(-Pkd2*s + Pkd2)) + 4*fd*g2*(2*Pk2*k1**2*r + 4*Pk2*k2**2*(7*r + 2*s - 1) + Pkd2*k1**2*k2*(2*s - 1) + 4*Pkd2*k2**3*(2*s - 1)))) + Dd*f*(429*b1*k1**2*k2**4*(-4*Pk2*b1*(2*K*(r + 2*s - 1) + 2*r - 1) + 16*Pk2*g2*(r + 2*s - 1) + Pkd2*b1*k2*(2*K - 1)*(4*s - 1) + 4*Pkd2*g2*k2*(1 - 4*s)) + 4*f**3*k1**4*(-273*Pk2*k2**2*(16*r + 20*s - 13) + 55*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 13*f**2*k2**2*(Pk2*k2**4*(128*C - 64)*(2*r - 1) - 7*k1**4*(4*Pk2*(-4*C*r + 2*C + 10*b1*(4*r + 4*s - 3) + 10*r + 8*s - 7) - Pkd2*k2*(4*C - 3)*(4*s - 1)) + 4*k1**2*k2**2*(Pk2*(8*C*(89*r + 78*s - 64) - 11*b1*(16*r + 20*s - 13) - 450*r - 384*s + 321) + Pkd2*k2*(28*C - 14)*(4*s - 1))) + 143*f*k1**2*k2**2*(-24*Pk2*b2*k2**2*(4*r + 4*s - 3) + 4*Pkd2*b1**2*k2**3*(4*s - 1) + b1*k1**2*(-4*Pk2*(K*(2*r - 1) - 8*r - 8*s + 6) + Pkd2*k2*(K*(2 - 8*s) + 4*s - 1)) + b1*k2**2*(8*Pk2*(2*C*(r + 2*s - 1) - 2*K*(7*r + 2*s - 4) + r - 6*s + 1) - Pkd2*k2*(4*s - 1)*(4*C + 8*K - 3)) + 4*g2*k1**2*(Pk2*(4*r - 2) + Pkd2*k2*(4*s - 1)) + 16*g2*k2**2*(2*Pk2*(7*r + 2*s - 4) + Pkd2*k2*(4*s - 1)))))/(15015*d*k1*k2**2*k3**4) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*st*(D1*bd1*f*(2*f**2*k1**4*(22*Pk2*k2**2*(5 - 8*r) + 15*k1**2*(2*Pk2 - Pkd2*k2)*(s - 1)) + 22*f*k2**2*(Pk2*k2**4*r*(2 - 4*C) + k1**4*(Pk2*(-4*C*(r + 2*s - 2) - 4*K*r - 14*K*s + 4*K + 4*b1*(8*r + 8*s - 7) + 10*r + 19*s - 14) + Pkd2*k2*(6*b1*(2*s - 1) - (4*C - 3)*(s - 1))) + k1**2*k2**2*(Pk2*(C*(-52*r - 52*s + 60) - 6*K*r - 18*K*s + 6*K + 9*b1*(4*r + 2*s - 3) + 35*r + 31*s - 35) + 4*Pkd2*k2*(-2*C*(s - 1) + s - 1))) - 33*k1**2*k2**2*(4*Pk2*b1**2*k2**2*(3*r + 3*s - 2) + 12*Pk2*b2*k2**2*(r + s - 1) + b1*k1**2*(2*Pk2*(K*(2*r + 4*s - 3) - 8*r - 10*s + 9) + Pkd2*k2*(2*K - 1)*(2*s - 1)) + 4*b1*k2**2*(-2*C*Pk2*(2*r + 2*s - 1) + 2*K*Pk2*(4*r + 5*s - 5) + K*Pkd2*k2*(2*s - 1) + Pk2*(r + 2*s)) - 4*g2*k1**2*(Pk2*(r + 2*s - 2) + Pkd2*k2*(s - 1)) - 8*g2*k2**2*(Pk2*(4*r + 5*s - 6) + Pkd2*k2*(s - 1)))) - 132*Pk2*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) - 2*Pk2*f*k1**2*(D1*(45*f**2*fd*k1**4*(4*s - 1) + f*k2**2*(44*bd2*k1**2*(r + s - 1) + fd*(k1**2*(4*C*(45*r + 156*s - 67) - 90*r - 423*s + 171) + k2**2*(4*C - 2)*(87*r + 198*s - 95)) - 44*gd2*(k1**2*(2*r + 7*s - 2) + 3*k2**2*(r + 3*s - 1))) - 44*fd*k2**2*(b2*k1**2*(-2*r - 2*s + 1) + g2*k1**2*(4*r + 14*s - 7) + 3*g2*k2**2*(2*r + 6*s - 3))) + Dd*f*(45*f**2*k1**4*(4*s - 1) + f*k2**2*(k1**2*(8*C*(30*r + 104*s - 41) - 120*r - 564*s + 201) + k2**2*(16*C - 8)*(29*r + 66*s - 31)) - 44*k2**2*(b2*k1**2*(-4*r - 4*s + 3) + g2*k1**2*(8*r + 28*s - 11) + 3*g2*k2**2*(4*r + 12*s - 5)))) + 11*b1**2*k1**2*k2**2*(D1*fd*(-12*K*Pkd2*k2**3*s - 6*Pk2*k1**2*(r*(K - 4) + s*(2*K - 5)) - 6*Pk2*k2**2*(-4*C*(r + s - 1) + 2*K*(4*r + 5*s + 1) + r + 2*s - 3) - 3*Pkd2*k1**2*k2*s*(2*K - 1) + 4*f*(9*Pk2*k2**2*(2*r + s - 1) + 2*k1**2*(Pk2*(8*r + 8*s - 5) + 3*Pkd2*k2*s))) + Dd*f*(k1**2*(2*Pk2*(-12*K*(r + 2*s - 1) + 16*f*(4*r + 4*s - 3) + 48*r + 60*s - 39) + Pkd2*k2*(4*s - 1)*(-6*K + 12*f + 3)) + 6*k2**2*(2*K*Pkd2*k2*(1 - 4*s) + Pk2*(4*C*(4*r + 4*s - 3) - 32*K*r - 40*K*s + 26*K + 3*f*(8*r + 4*s - 5) - 4*r - 8*s + 4)))) + 2*b1*(D1*(f**2*fd*k1**4*(90*Pk2*k1**2*s + 22*Pk2*k2**2*(11 - 24*r) - 45*Pkd2*k1**2*k2*s) - 11*f*k2**2*(fd*(Pk2*k2**4*(4*C - 2)*(2*r - 1) + k1**4*(Pk2*(4*C*(2*r + 4*s - 1) + 2*K*(4*r + 14*s - 7) - 20*r - 38*s + 15) + Pkd2*k2*s*(8*C - 6)) + k1**2*k2**2*(Pk2*(4*C*(26*r + 26*s - 11) + 6*K*(2*r + 6*s - 3) - 70*r - 62*s + 31) + Pkd2*k2*s*(16*C - 8))) - 6*k1**2*(-3*Pk2*bd2*k2**2*(r + s - 1) + gd2*k1**2*(Pk2*(r + 2*s - 1) + Pkd2*k2*s) + 2*gd2*k2**2*(Pk2*(4*r + 5*s - 4) + Pkd2*k2*s))) + 66*fd*k1**2*k2**2*(-3*Pk2*b2*k2**2*(r + s) + g2*(Pk2*k1**2*(r + 2*s) + 2*Pk2*k2**2*(4*r + 5*s + 1) + Pkd2*k1**2*k2*s + 2*Pkd2*k2**3*s))) + Dd*f*(f**2*k1**4*(352*Pk2*k2**2*(1 - 2*r) + 15*k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1)) - 11*f*k2**2*(Pk2*k2**4*(8*C - 4)*(2*r - 1) + k1**4*(Pk2*(16*C*(r + 2*s - 1) + 2*K*(8*r + 28*s - 11) - 40*r - 76*s + 39) + Pkd2*k2*(4*C - 3)*(4*s - 1)) + k1**2*k2**2*(Pk2*(52*C*(4*r + 4*s - 3) + 6*K*(4*r + 12*s - 5) - 140*r - 124*s + 101) + Pkd2*k2*(8*C - 4)*(4*s - 1))) + 66*k1**2*k2**2*(-3*Pk2*b2*k2**2*(4*r + 4*s - 3) + g2*k1**2*(4*Pk2*(r + 2*s - 1) + Pkd2*k2*(4*s - 1)) + 2*g2*k2**2*(Pk2*(16*r + 20*s - 13) + Pkd2*k2*(4*s - 1))))))/(3465*d*k1*k2**2*k3**4) - np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*f**3*k1**2*k2*st**7*(-4*Pk2 + Pkd2*k2)*(4*s - 1)*(D1*fd + Dd*f)/(1287*d*k3**4) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*f*st**5*(D1*bd1*f*(-11*K*Pkd2*k2**3*s + 12*Pk2*f*k1**2*s + 11*Pk2*k2**2*(2*K*s + f*(r - 1) + r - 1) - 3*Pkd2*f*k1**2*k2*s) + b1*(D1*fd*(f*(11*Pk2*k2**2*(3*r - 1) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) + 11*k2**2*(K*(2*Pk2 - Pkd2*k2)*(2*s - 1) + 2*Pk2*r)) + Dd*f*(f*(22*Pk2*k2**2*(2*r - 1) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 11*k2**2*(K*Pkd2*k2*(4*s - 1) + Pk2*(-8*K*s + 2*K - 4*r + 2)))) + k2**2*(-2*C*f*(2*Pk2 - Pkd2*k2)*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1)) + 22*D1*Pk2*bd2*f*s - 3*D1*Pk2*f*fd*r + 6*D1*Pk2*f*fd*s - D1*Pk2*f*fd - 44*D1*Pk2*f*gd2*s - 88*D1*Pk2*fd*g2*s + 44*D1*Pk2*fd*g2 - 11*D1*Pkd2*bd2*f*k2*s - 3*D1*Pkd2*f*fd*k2*s + D1*Pkd2*f*fd*k2 + 22*D1*Pkd2*f*gd2*k2*s + 44*D1*Pkd2*fd*g2*k2*s - 22*D1*Pkd2*fd*g2*k2 - 4*Dd*Pk2*f**2*r + 8*Dd*Pk2*f**2*s - 176*Dd*Pk2*f*g2*s + 44*Dd*Pk2*f*g2 - 4*Dd*Pkd2*f**2*k2*s + Dd*Pkd2*f**2*k2 + 88*Dd*Pkd2*f*g2*k2*s - 22*Dd*Pkd2*f*g2*k2 + 11*b2*(2*Pk2 - Pkd2*k2)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1))))/(693*d*k2*k3**2) + 2*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*f*st**5*(D1*(f**2*(13*bd1*k2**2*(-11*Pk2*k2**2*(r - 1) + k1**2*(4*Pk2*(2*r + s - 2) + Pkd2*k2*(2*s + 1))) + 3*fd*(-52*Pk2*k1**2*k2**2*(3*r + 2*s - 2) + 9*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 13*f*k2**2*(b1*fd*(11*Pk2*k2**2*(1 - 3*r) + 3*k1**2*(4*Pk2*(2*r + s - 1) + Pkd2*k2*(2*s - 1))) + k2**2*(-24*C*Pk2*fd*r - 12*C*Pk2*fd*s + 12*C*Pk2*fd - 6*C*Pkd2*fd*k2*s + 2*C*Pkd2*fd*k2 + 22*Pk2*bd2*(r + s - 1) + 15*Pk2*fd*r + 6*Pk2*fd*s - 7*Pk2*fd - 88*Pk2*gd2*r - 44*Pk2*gd2*s + 88*Pk2*gd2 + 3*Pkd2*fd*k2*s - Pkd2*fd*k2 - 22*Pkd2*gd2*k2*s + 11*bd1*(2*K*Pk2*(2*r + s - 2) + K*Pkd2*k2*s - Pk2*r + Pk2))) - 143*fd*k2**4*(-2*Pk2*b2*(2*r + 2*s - 1) + b1*(K*Pk2*(-8*r - 4*s + 2) + K*Pkd2*k2*(1 - 2*s) + 2*Pk2*r) + 2*g2*(Pk2*(8*r + 4*s - 2) + Pkd2*k2*(2*s - 1)))) + Dd*f*(3*f**2*k1**2*(-52*Pk2*k2**2*(3*r + 2*s - 2) + 9*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 13*f*k2**2*(22*Pk2*b1*k2**2*(1 - 2*r) - 4*Pk2*k2**2*(C*(8*r + 4*s - 5) - 5*r - 2*s + 3) + Pkd2*k2**3*(C*(2 - 8*s) + 4*s - 1) + 2*b1*k1**2*(2*Pk2*(8*r + 4*s - 5) + Pkd2*k2*(4*s - 1))) + 143*k2**4*(K*Pkd2*b1*k2*(4*s - 1) + 2*Pk2*b1*(K*(8*r + 4*s - 5) - 2*r + 1) + 2*Pk2*b2*(4*r + 4*s - 3) - 4*Pk2*g2*(8*r + 4*s - 5) + 2*Pkd2*g2*k2*(1 - 4*s))))/(9009*d*k2*k3**4) - np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*st**3*(D1*bd1*f*(Pk2*f*(4*C*s + r - 2*s) + Pkd2*f*k2*s*(1 - 2*C) - s*(2*Pk2 - Pkd2*k2)*(3*b2 - 6*g2)) - 3*b1**2*(D1*fd*(K*(2*Pk2 - Pkd2*k2)*(s - 1) + Pk2*f*(2*r - 1) + Pk2*r) + Dd*f*(K*Pkd2*k2*(1 - 4*s) + Pk2*(8*K*s - 2*K + f*(4*r - 2) + 4*r - 2))) + b1*(8*C*D1*Pk2*f*fd*s - 4*C*D1*Pk2*f*fd - 4*C*D1*Pkd2*f*fd*k2*s + 2*C*D1*Pkd2*f*fd*k2 + 16*C*Dd*Pk2*f**2*s - 4*C*Dd*Pk2*f**2 - 8*C*Dd*Pkd2*f**2*k2*s + 2*C*Dd*Pkd2*f**2*k2 - 6*D1*Pk2*bd2*f*s + 2*D1*Pk2*f*fd*r - 4*D1*Pk2*f*fd*s + D1*Pk2*f*fd + 12*D1*Pk2*f*gd2*s + 12*D1*Pk2*fd*g2*s - 12*D1*Pk2*fd*g2 + 3*D1*Pkd2*bd2*f*k2*s + 2*D1*Pkd2*f*fd*k2*s - D1*Pkd2*f*fd*k2 - 6*D1*Pkd2*f*gd2*k2*s - 6*D1*Pkd2*fd*g2*k2*s + 6*D1*Pkd2*fd*g2*k2 + 3*D1*bd1*f*(2*K*Pkd2*k2*s + Pk2*(-4*K*s - 2*f*r + f - 2*r + 1)) + 4*Dd*Pk2*f**2*r - 8*Dd*Pk2*f**2*s + 48*Dd*Pk2*f*g2*s - 12*Dd*Pk2*f*g2 + 4*Dd*Pkd2*f**2*k2*s - Dd*Pkd2*f**2*k2 - 24*Dd*Pkd2*f*g2*k2*s + 6*Dd*Pkd2*f*g2*k2 - 3*b2*(2*Pk2 - Pkd2*k2)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))))/(105*d*k2) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*st*(2*D1*Pk2*bd1*f**2*s*(2*C - 1) + b1**2*(D1*fd*(-Pk2*r + Pk2 + Pkd2*k2*s*(2*C - 1)) + Dd*f*(Pk2*(2 - 4*r) + Pkd2*k2*(2*C - 1)*(4*s - 1))) + b1*f*(D1*(-2*Pk2*bd1*r + Pk2*fd*(4*C - 2)*(2*s - 1) + Pkd2*bd1*k2*(2*C - 1)*(2*s - 1)) + Dd*Pk2*f*(4*C - 2)*(4*s - 1)))/(105*d*k2) - np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*st**3*(11*D1*bd1*f*(3*Pk2*f**2*k1**2*(2*r + 4*s - 1) + f*(k1**2*(Pk2*(2*K*s - 8*b1*s + 6*b1 + r + 2*s - 1) + Pkd2*k2*(-K*s + 4*b1*s - 3*b1)) + k2**2*(6*K*Pk2*(r + 2*s - 1) + (2*C - 1)*(2*Pk2*r + Pkd2*k2))) + 3*k2**2*(-K*b1*(Pk2*(4*r - 2) + Pkd2*k2) + Pkd2*b2*k2*(s - 1) + 2*g2*(2*Pk2*r + Pkd2*k2))) - 11*b1**2*(D1*fd*(-3*K*k2**2*(-2*Pk2*r + Pkd2*k2) + f*k1**2*(2*Pk2 - Pkd2*k2)*(4*s + 1)) + 2*Dd*f*(6*K*Pk2*k2**2*(2*r - 1) + f*k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1))) + 11*b1*(D1*(3*Pk2*f**2*fd*k1**2*(6*r + 12*s - 7) + f*fd*(k1**2*(K*Pkd2*k2*(1 - 2*s) + 2*Pk2*(K*(2*s - 1) + r + 2*s - 1)) + k2**2*(2*Pk2*(C*(4*r - 2) + 6*K*(r + 2*s - 1) - 2*r + 1) + Pkd2*k2*(1 - 2*C))) + 3*f*k2**2*(4*Pk2*gd2*(r - 1) + Pkd2*bd2*k2*s) + 3*fd*k2**2*(4*Pk2*g2*r + Pkd2*b2*k2*s - 2*Pkd2*g2*k2)) + Dd*f*(24*Pk2*f**2*k1**2*(r + 2*s - 1) + f*(4*Pk2*k2**2*(C*(4*r - 2) + 6*K*(r + 2*s - 1) - 2*r + 1) + k1**2*(K*Pkd2*k2*(1 - 4*s) + Pk2*(8*K*s - 2*K + 4*r + 8*s - 4))) + 3*k2**2*(8*Pk2*g2*(2*r - 1) + Pkd2*b2*k2*(4*s - 1)))) + f*(D1*(f*(fd*(Pk2*k2**2*(2 - 4*C)*(57*r + 66*s - 41) + 7*k1**2*(Pk2*(12*C*s - 4*C + 3*r - 1) + Pkd2*k2*(-6*C*s + 2*C + 3*s - 1))) + (11*bd2 - 22*gd2)*(2*Pk2*k1**2*s + 6*Pk2*k2**2*(r + 2*s - 1) - Pkd2*k1**2*k2*s)) - 22*fd*g2*(12*Pk2*k2**2*(r + 2*s - 1) + k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1))) + Dd*f*(f*(Pk2*k2**2*(8 - 16*C)*(19*r + 22*s - 15) + 7*k1**2*(2*Pk2*(8*C*s - 2*C + 2*r - 1) + Pkd2*k2*(-8*C*s + 2*C + 4*s - 1))) - 22*g2*(24*Pk2*k2**2*(r + 2*s - 1) + k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1))) + 11*b2*(D1*fd*(12*Pk2*k2**2*(r + 2*s - 1) + k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1)) + Dd*f*(24*Pk2*k2**2*(r + 2*s - 1) + k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1)))))/(1155*d*k2*k3**2) - 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*st*(-3*Pkd2*b1**3*k1**2*k2*(D1*fd*s + Dd*f*(4*s - 1)) + 3*b1**2*(D1*f*k1**2*(Pk2*fd*(12*r + 8*s - 7) + Pkd2*bd1*k2*(1 - 3*s)) + D1*fd*(-K*Pkd2*k1**2*k2*s + Pk2*k1**2*(r + 2*s) + Pk2*k2**2*(4*C*(r + s - 1) - 3*r - 2*s + 3) + Pkd2*k2**3*s*(2*C - 1)) + Dd*f*k1**2*(K*Pkd2*k2*(1 - 4*s) + 4*Pk2*(f*(6*r + 4*s - 4) + r + 2*s - 1)) + Dd*f*k2**2*(4*Pk2*(C*(4*r + 4*s - 3) - 3*r - 2*s + 2) + Pkd2*k2*(2*C - 1)*(4*s - 1))) + b1*(3*D1*bd1*f*(k1**2*(K*Pkd2*k2*(1 - 2*s) + Pk2*(f*(12*r + 8*s - 9) + 2*r + 4*s - 3)) + k2**2*(Pk2*(C*(8*r + 8*s - 4) - 6*r - 4*s + 2) + Pkd2*k2*(2*C - 1)*(2*s - 1))) + D1*(-3*Pkd2*fd*k1**2*k2*s*(b2 - 2*g2) + f*(Pk2*fd*k2**2*(4 - 8*C)*(5*r - 1) - Pkd2*k1**2*k2*s*(3*bd2 - 6*gd2) - 2*fd*k1**2*(Pk2*(6*K*s - 3*K - 2*r - 4*s + 1) + Pkd2*k2*s*(4*C - 2)))) + Dd*f*(Pkd2*k1**2*k2*(-3*b2 + 6*g2)*(4*s - 1) - 2*f*(Pk2*k2**2*(20*C - 10)*(2*r - 1) + k1**2*(Pk2*(12*K*s - 3*K - 4*r - 8*s + 4) + Pkd2*k2*(2*C - 1)*(4*s - 1))))) + f*(D1*bd1*(Pk2*f*k2**2*(2 - 4*C)*(5*r - 3) - Pkd2*k1**2*k2*(3*b2 - 6*g2)*(s - 1) + 2*f*k1**2*(Pk2*(-3*K*s + r + 2*s - 2) + Pkd2*k2*(-2*C*(s - 1) + s - 1))) - 2*Pk2*k1**2*(D1*(f*fd*(4*C - 2)*(3*s - 1) + 3*f*s*(bd2 - 2*gd2) + 6*fd*g2*(1 - 2*s)) + 2*Dd*f*(4*s - 1)*(f*(2*C - 1) - 3*g2) + 3*b2*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)))))/(315*d*k2*k3**2) + np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*st**3*(D1*bd1*f*(f**2*k1**2*(11*Pk2*k2**2*(8*s - 5) + 7*k1**2*(4*Pk2*(r + 2*s - 2) + Pkd2*k2*(3 - 2*s))) + 11*f*k2**2*(k1**2*(Pk2*(-2*K*(4*r + 5*s - 4) + 2*b1*(4*r + 4*s - 5) + r + 2*s - 1) + Pkd2*k2*(-K*s + b1*(6*s - 3))) + k2**2*(Pk2*(-4*C*(r + s - 2) + 6*K*r + 12*K*s - 6*K + b1*(3 - 6*r) + 3*r + 2*s - 4) + Pkd2*k2*(-2*C*(s - 1) + s - 1))) + 33*k2**4*(2*Pk2*b2*(r + s - 1) - 4*Pk2*g2*(r + s - 2) - 2*Pkd2*g2*k2*(s - 1) + b1*(K*Pk2*(4*r + 4*s - 6) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r + Pk2))) + 11*b1**2*k2**2*(D1*fd*(f*(3*Pk2*k2**2*(1 - 2*r) + k1**2*(Pk2*(8*r + 8*s - 2) + 6*Pkd2*k2*s)) + 3*k2**2*(2*K*Pk2*(r + s + 1) + K*Pkd2*k2*s - Pk2*r)) + Dd*f*(f*(6*Pk2*k2**2*(1 - 2*r) + k1**2*(4*Pk2*(4*r + 4*s - 3) + 3*Pkd2*k2*(4*s - 1))) + 3*k2**2*(K*Pkd2*k2*(4*s - 1) + Pk2*(K*(8*r + 8*s - 6) - 4*r + 2)))) + b1*(D1*(f**2*fd*k1**2*(33*Pk2*k2**2*(8*s - 1) + 7*k1**2*(4*Pk2*(3*r + 6*s - 2) - Pkd2*k2*(6*s + 1))) - 11*f*k2**2*(fd*(k1**2*(K*Pkd2*k2*(2*s - 1) + 2*Pk2*(K*(8*r + 10*s - 5) - r - 2*s + 1)) + k2**2*(Pk2*(8*C*r + 8*C*s - 12*K*(r + 2*s - 1) - 6*r - 4*s + 1) + Pkd2*k2*s*(4*C - 2))) + 6*k2**2*(-Pk2*bd2*(r + s - 1) + 2*Pk2*gd2*(r + s - 1) + Pkd2*gd2*k2*s)) - 66*fd*k2**4*(-Pk2*b2*(r + s) + 2*Pk2*g2*(r + s + 1) + Pkd2*g2*k2*s)) + Dd*f*(2*f**2*k1**2*(44*Pk2*k2**2*(4*s - 1) + 7*k1**2*(8*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 4*s))) - 11*f*k2**2*(k1**2*(K*Pk2*(32*r + 40*s - 26) + K*Pkd2*k2*(4*s - 1) - 4*Pk2*(r + 2*s - 1)) + k2**2*(4*Pk2*(C*(4*r + 4*s - 3) - 6*K*(r + 2*s - 1) - 3*r - 2*s + 2) + Pkd2*k2*(2*C - 1)*(4*s - 1))) + 66*k2**4*(Pk2*b2*(4*r + 4*s - 3) + Pk2*g2*(-8*r - 8*s + 6) + Pkd2*g2*k2*(1 - 4*s)))) - f*(D1*(14*Pk2*f**2*fd*k1**4*(10*r + 24*s - 11) + f*k2**2*(66*Pk2*bd2*k1**2*(r + s - 1) + Pk2*fd*k2**2*(4*C - 2)*(57*r + 66*s - 41) + 132*Pk2*gd2*k2**2*(r + 2*s - 1) + 7*fd*k1**2*(3*Pk2*(4*C*(4*r + 5*s - 3) - 9*r - 12*s + 7) + Pkd2*k2*(2*C - 1)*(3*s - 1)) - 22*gd2*k1**2*(2*Pk2*(4*r + 5*s - 4) + Pkd2*k2*s)) + 22*fd*k2**2*(3*Pk2*b2*k1**2*(2*r + 2*s - 1) + 12*Pk2*g2*k2**2*(r + 2*s - 1) + g2*k1**2*(-2*Pk2*(8*r + 10*s - 5) + Pkd2*k2*(1 - 2*s)))) + Dd*f*(14*Pk2*f**2*k1**4*(10*r + 24*s - 11) + f*k2**2*(Pk2*k2**2*(16*C - 8)*(19*r + 22*s - 15) + 7*k1**2*(C*Pk2*(64*r + 80*s - 52) - 6*Pk2*(6*r + 8*s - 5) + Pkd2*k2*(2*C - 1)*(4*s - 1))) + 22*k2**2*(3*Pk2*b2*k1**2*(4*r + 4*s - 3) + 24*Pk2*g2*k2**2*(r + 2*s - 1) + g2*k1**2*(Pk2*(-32*r - 40*s + 26) + Pkd2*k2*(1 - 4*s))))))/(1155*d*k2*k3**4) + 4*np.sqrt(21)*1j*np.sqrt(np.pi)*D1**3*Pk3*st*(-12*Pk2*b1**3*k1**2*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1**2*(D1*(f*k1**2*(-12*Pk2*bd1*k2**2*(3*r + 3*s - 2) + 9*Pk2*fd*k2**2*(6*r + 4*s - 3) + 4*fd*k1**2*(Pk2*(4*r + 4*s - 3) + Pkd2*k2*s)) + 3*fd*k2**2*(-K*Pkd2*k1**2*k2*s + Pk2*k1**2*(-8*K*r + r + s*(2 - 12*K)) + Pk2*k2**2*(4*C - 2)*(r + s - 1))) + Dd*f*(Pk2*k2**4*(12*C - 6)*(4*r + 4*s - 3) + 2*f*(18*Pk2*k1**2*k2**2*(3*r + 2*s - 2) + k1**4*(4*Pk2*(4*r + 4*s - 3) + Pkd2*k2*(4*s - 1))) + 3*k1**2*k2**2*(K*Pkd2*k2*(1 - 4*s) - 4*Pk2*(K*(8*r + 12*s - 7) - r - 2*s + 1)))) + b1*(D1*bd1*f*(Pk2*k2**4*(12*C - 6)*(2*r + 2*s - 1) + f*(9*Pk2*k1**2*k2**2*(6*r + 4*s - 5) + 2*k1**4*(Pk2*(8*r + 8*s - 6) + Pkd2*k2*(2*s - 1))) + 3*k1**2*k2**2*(K*Pkd2*k2*(1 - 2*s) + Pk2*(-4*K*(4*r + 6*s - 5) + 2*r + 4*s - 3))) - 2*D1*(Pk2*f**2*fd*k1**4*(15*r + 12*s - 8) + f*k2**2*(9*Pk2*bd2*k1**2*(r + s - 1) + fd*(Pk2*k2**2*(2*C - 1)*(10*r + 6*s - 5) + k1**2*(Pk2*(16*C*(2*r + 3*s - 1) + 6*K*s - 3*K - 18*r - 28*s + 9) + Pkd2*k2*s*(4*C - 2))) - 3*gd2*k1**2*(4*Pk2*(2*r + 3*s - 2) + Pkd2*k2*s)) - 3*fd*k1**2*k2**2*(-3*Pk2*b2*(r + s) + g2*(8*Pk2*r + 12*Pk2*s + Pkd2*k2*s))) - 2*Dd*f*(2*Pk2*f**2*k1**4*(10*r + 8*s - 7) + f*k2**2*(Pk2*k2**2*(2*C - 1)*(20*r + 12*s - 13) + k1**2*(Pk2*(8*C*(8*r + 12*s - 7) + 12*K*s - 3*K - 36*r - 56*s + 32) + Pkd2*k2*(2*C - 1)*(4*s - 1))) + 3*k1**2*k2**2*(3*Pk2*b2*(4*r + 4*s - 3) - 4*Pk2*g2*(8*r + 12*s - 7) + Pkd2*g2*k2*(1 - 4*s)))) - 2*f*(D1*bd1*(Pk2*f**2*k1**4*(5*r + 4*s - 6) + f*k2**2*(Pk2*k2**2*(2*C - 1)*(5*r + 3*s - 3) + k1**2*(Pk2*(8*C*(2*r + 3*s - 3) + 3*K*s - 9*r - 14*s + 14) + Pkd2*k2*(2*C - 1)*(s - 1))) + 3*k1**2*k2**2*(3*Pk2*b2*(r + s - 1) - 4*Pk2*g2*(2*r + 3*s - 3) - Pkd2*g2*k2*(s - 1))) + 2*Pk2*k1**2*k2**2*(D1*(f*fd*(2*C - 1)*(3*s - 1) - 3*f*gd2*s + 3*fd*g2*(1 - 2*s)) + Dd*f*(4*s - 1)*(f*(2*C - 1) - 3*g2))))/(315*d*k2*k3**4)
        
        return (perm12+perm13+perm23)
    
    def l3m2(cosmo_functions,k1,k2,k3=None,theta=None,zz=0,r=0,s=0,nonlin=False,growth2=False):
        
        #get generic cosmology parameters
        k1,k2,k3,theta,Pk1,Pk2,Pk3,Pkd1,Pkd2,Pkd3,Pkdd1,Pkdd2,Pkdd3,d,K,C,f,D1,b1,b2,g2 = cosmo_functions.get_params(k1,k2,k3,theta,zz,nonlin=nonlin,growth2=growth2)
        
        fd,Dd,gd2,bd2,bd1,fdd,Ddd,gdd2,bdd2,bdd1 = cosmo_functions.get_derivs(zz)
        
        st = np.sin(theta)
        ct= np.cos(theta)

        perm12 = 8*np.sqrt(210)*1j*np.sqrt(np.pi)*C*D1**3*Pk1*Pk2*f*k1*k2**2*st**4*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + 3*f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(1155*d*k3**4) + 4*np.sqrt(210)*1j*np.sqrt(np.pi)*C*D1**3*Pk1*Pk2*k1*st**2*(11*D1*bd1*f*(18*b1*k2**2 + f*(k1**2 + 3*k2**2))*(r + s - 1) + 99*b1**2*k2**2*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + 11*b1*f*(k1**2 + 3*k2**2)*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + 5*f**2*k1**2*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(3465*d*k3**4) - 4*np.sqrt(210)*1j*np.sqrt(np.pi)*C*D1**3*Pk2*Pkd1*f*k2**2*st**4*(11*D1*bd1*f*(r - 1) + 11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 3*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(3465*d*k3**2) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*C*D1**3*Pk2*Pkd1*st**2*(11*D1*bd1*f*(3*b1*k2**2*(2*r - 1) + f*k1**2*(r - 1) + f*k2**2*r) + 33*b1**2*k2**2*(D1*fd*r + Dd*f*(4*r - 1)) + 11*b1*f*(D1*fd*(2*k1**2*r + k2**2*(2*r - 1)) + Dd*f*(k1**2 + k2**2)*(4*r - 1)) + 5*f**2*k1**2*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(3465*d*k3**2) - 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**5*f*k2**3*st**2*(C - 1)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + 5*f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(693*d*k3**4) + 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**4*f*k2**2*st**2*(k1**2*(23 - 18*C) + 5*k2**2)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + 5*f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(3465*d*k1*k3**4) - 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**3*f*k2**3*st**4*(C - 1)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + 3*f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(693*d*k3**4) + 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**3*k2*st**2*(-11*D1*bd1*f*(r + s - 1)*(18*b1*k2**2*(C - 1) + f*k1**2*(9*C - 18) - f*k2**2*(7*C + 12)) - 99*b1**2*k2**2*(C - 1)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) - 11*b1*f*(D1*fd + 2*Dd*f)*(k1**2*(9*C - 18) - k2**2*(7*C + 12))*(2*r + 2*s - 1) - 5*f**2*(k1**2*(9*C - 18) - k2**2*(10*C + 9))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(3465*d*k3**4) + 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**2*f*k2**2*st**4*(k1**2*(11 - 6*C) + 5*k2**2)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + 3*f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(3465*d*k1*k3**4) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**2*st**2*(11*D1*bd1*f*(-18*b1*k2**2*(k1**2*(3 - 2*C) + k2**2) + f*(k1**4*(2*C - 11) - k1**2*k2**2*(30*C + 18) - 3*k2**4))*(r + s - 1) - 99*b1**2*k2**2*(k1**2*(3 - 2*C) + k2**2)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + 11*b1*f*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1)*(k1**4*(2*C - 11) - k1**2*k2**2*(30*C + 18) - 3*k2**4) + 5*f**2*k1**2*(k1**2*(2*C - 11) - k2**2*(36*C + 9))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(3465*d*k1*k3**4) + 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct*f*k2*st**4*(3*k1**2 + k2**2*(10*C + 3))*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + 3*f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(3465*d*k3**4) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct*st**2*(11*D1*bd1*f*(18*b1*k2**2*(k1**2 + k2**2*(2*C + 1)) + f*(k1**4 + k1**2*k2**2*(18*C + 4) + k2**4*(6*C + 3)))*(r + s - 1) + 99*b1**2*k2**2*(k1**2 + k2**2*(2*C + 1))*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + 11*b1*f*(D1*fd + 2*Dd*f)*(k1**4 + k1**2*k2**2*(18*C + 4) + k2**4*(6*C + 3))*(2*r + 2*s - 1) + 5*f**2*k1**2*(k1**2 + k2**2*(18*C + 1))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(3465*d*k2*k3**4) + 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**5*f*k2*st**2*(C - 1)*(-4*Pk2 + Pkd2*k2)*(11*b1*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) + f*(11*D1*bd1*s + 5*D1*fd*(3*s - 1) + 5*Dd*f*(4*s - 1)))/(693*d*k3**2) + 5*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**4*f**2*st**2*(4*Pk2 - Pkd2*k2)*(13*b1*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1)) + f*(13*D1*bd1*s + 7*D1*fd*(4*s - 1) + 7*Dd*f*(4*s - 1)))/(3003*d*k1) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**4*f*st**2*(11*b1*(D1*fd*(k1**2*(12*C - 17)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(-2*Pk2*(r*(8*C - 8) + 10*s - 5) + 5*Pkd2*k2*(2*s - 1))) + Dd*f*(k1**2*(12*C - 17)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(Pk2*(-32*C*r + 8*C + 32*r - 40*s + 2) + 5*Pkd2*k2*(4*s - 1)))) + f*(11*D1*bd1*(Pk2*k1**2*s*(48*C - 68) - 2*Pk2*k2**2*(4*C*(r - 1) - 4*r + 5*s + 4) + Pkd2*k1**2*k2*s*(17 - 12*C) + 5*Pkd2*k2**3*s) + D1*fd*(k1**2*(60*C - 85)*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(-2*Pk2*(56*C*(3*r - 1) - 168*r + 75*s + 31) + 25*Pkd2*k2*(3*s - 1))) + Dd*f*k1**2*(60*C - 85)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + Dd*f*k2**2*(-2*Pk2*(56*C*(4*r - 1) - 224*r + 100*s + 31) + 25*Pkd2*k2*(4*s - 1))))/(3465*d*k1*k3**2) + 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**3*f*k2*st**4*(C - 1)*(-4*Pk2 + Pkd2*k2)*(11*b1*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) + f*(11*D1*bd1*s + D1*fd*(9*s - 3) + 3*Dd*f*(4*s - 1)))/(693*d*k3**2) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**3*st**2*(143*b1**2*k1**2*(4*Pk2 - Pkd2*k2)*(D1*fd*(-9*K*s + 9*K + 10*f*(2*s - 1) + 9*s - 9) + Dd*f*(4*s - 1)*(-9*K + 10*f + 9)) + 13*b1*(D1*(10*f**2*(-3*Pk2*fd*k2**2*r + 22*bd1*k1**2*s*(4*Pk2 - Pkd2*k2) + 15*fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) - 33*f*k1**2*(4*Pk2 - Pkd2*k2)*(fd*(K - 1)*(2*s - 1) + s*(6*K*bd1 - 6*bd1 - 6*gd2)) + 198*fd*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) + Dd*f*(10*f**2*(Pk2*k2**2*(1 - 4*r) + 15*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 33*f*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 198*g2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + f*(D1*(10*f**2*(55*Pk2*fd*k2**2*(1 - 4*r) - 13*bd1*(-60*Pk2*k1**2*s + Pk2*k2**2*(r - 1) + 15*Pkd2*k1**2*k2*s) + 70*fd*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 429*f*k1**2*s*(4*Pk2 - Pkd2*k2)*(-K*bd1 + bd1 + 2*gd2) + 858*g2*k1**2*(4*Pk2 - Pkd2*k2)*(3*bd1*s + fd*(2*s - 1))) + 50*Dd*f**3*(11*Pk2*k2**2*(1 - 4*r) + 14*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 858*Dd*f*g2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)))/(45045*d*k1**2*k2) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**3*st**2*(-99*b1**2*k1**2*k2**2*(C - 1)*(-2*Pk2 + Pkd2*k2)*(D1*fd*s + Dd*f*(4*s - 1)) + 11*b1*f*(D1*(-9*bd1*k1**2*k2**2*(C - 1)*(-2*Pk2 + Pkd2*k2)*(2*s - 1) + fd*(-2*Pk2*k2**4*r + k1**4*(3*C - 9)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 2*k1**2*k2**2*(Pk2*(C*(-30*r - 62*s + 34) + 35*r + 30*s - 18) + Pkd2*k2*(C*(7*s - 5) + 9*s - 3)))) + Dd*f*(Pk2*k2**4*(1 - 4*r) + k1**4*(3*C - 9)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(-4*C*Pk2*(30*r + 62*s - 23) + 5*Pk2*(28*r + 24*s - 13) + Pkd2*k2*(7*C + 9)*(4*s - 1)))) + f**2*(D1*(-11*bd1*(Pk2*k2**4*(r - 1) - k1**4*s*(3*C - 9)*(4*Pk2 - Pkd2*k2) - k1**2*k2**2*(Pk2*(C*(-30*r - 62*s + 24) + 35*r + 30*s - 29) + Pkd2*k2*(C*(7*s + 3) + 9*s - 3))) + fd*(31*Pk2*k2**4*(3*r - 1) + k1**4*(15*C - 45)*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k1**2*k2**2*(Pk2*(C*(-594*r - 876*s + 490) + 777*r + 396*s - 391) + Pkd2*k2*(50*C + 30)*(3*s - 1)))) + Dd*f*(31*Pk2*k2**4*(4*r - 1) + k1**4*(15*C - 45)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(-2*C*(396*r + 584*s - 245) + 1036*r + 528*s - 391) + Pkd2*k2*(50*C + 30)*(4*s - 1)))))/(3465*d*k1**2*k2*k3**2) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**2*f**2*st**4*(4*Pk2 - Pkd2*k2)*(13*b1*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1)) + f*(13*D1*bd1*s + 5*D1*fd*(4*s - 1) + 5*Dd*f*(4*s - 1)))/(1001*d*k1) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**2*f*st**4*(11*b1*(D1*fd*(k1**2*(4*C - 9)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(Pk2*(-r*(32*C - 32) - 20*s + 10) + 5*Pkd2*k2*(2*s - 1))) + Dd*f*(k1**2*(4*C - 9)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(-2*Pk2*(32*C*r - 8*C - 32*r + 20*s + 3) + 5*Pkd2*k2*(4*s - 1)))) + f*(11*D1*bd1*(Pk2*k1**2*s*(16*C - 36) - 2*Pk2*k2**2*(8*C*(r - 1) - 8*r + 5*s + 8) + Pkd2*k1**2*k2*s*(9 - 4*C) + 5*Pkd2*k2**3*s) + D1*fd*(k1**2*(12*C - 27)*(4*Pk2 - Pkd2*k2)*(3*s - 1) + 5*k2**2*(-2*Pk2*(8*C*(3*r - 1) - 24*r + 9*s + 5) + 3*Pkd2*k2*(3*s - 1))) + Dd*f*k1**2*(12*C - 27)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 5*Dd*f*k2**2*(-2*Pk2*(8*C*(4*r - 1) - 32*r + 12*s + 5) + 3*Pkd2*k2*(4*s - 1))))/(3465*d*k1*k3**2) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**2*st**2*(-429*b1**2*(D1*fd*(k1**2*(4*Pk2 - Pkd2*k2)*(4*f*s - 2*f + 3*s - 3) + k2**2*(2*Pk2*(2*K*r + 8*f*s - 2*f - 2*r + 3*s - 3) + Pkd2*k2*(-8*f*s + 2*f - 3*s + 3))) + Dd*f*(k1**2*(4*Pk2 - Pkd2*k2)*(2*f + 3)*(4*s - 1) + k2**2*(2*Pk2*(8*K*r - 2*K + 4*f*(4*s - 1) - 8*r + 12*s - 1) - Pkd2*k2*(4*f + 3)*(4*s - 1)))) - 13*b1*(D1*(-264*Pk2*fd*g2*k2**2*r + 6*f**2*(-11*bd1*(-8*Pk2*k1**2*s + Pk2*k2**2*(2 - 8*s) + 2*Pkd2*k1**2*k2*s + Pkd2*k2**3*(4*s - 1)) + fd*(10*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(-3*Pk2*(36*r + 35*s - 19) + 5*Pkd2*k2*(1 - 6*s)))) + 11*f*(-24*Pk2*gd2*k2**2*r + 6*bd1*(12*Pk2*k1**2*s + 2*Pk2*k2**2*(2*K*r - K - 2*r + 3*s + 1) - 3*Pkd2*k1**2*k2*s - 3*Pkd2*k2**3*s) + 3*fd*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + fd*k2**2*(2*Pk2*(8*K*r - 4*K - 8*r + 6*s + 1) + 3*Pkd2*k2*(1 - 2*s)))) + Dd*f*(264*Pk2*g2*k2**2*(1 - 4*r) + 6*f**2*(10*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(Pk2*(-144*r - 140*s + 71) + 10*Pkd2*k2*(1 - 4*s))) + 11*f*(3*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(Pk2*(32*K*r - 8*K - 32*r + 24*s + 2) + 3*Pkd2*k2*(1 - 4*s))))) + f*(1144*D1*Pk2*g2*k2**2*(3*bd1*(r - 1) + 2*fd*(2*r - 1)) - 6*D1*f**2*(-13*bd1*(-40*Pk2*k1**2*s + Pk2*k2**2*(36*r + 35*s - 14) + 10*Pkd2*k1**2*k2*s + 5*Pkd2*k2**3*(2*s - 1)) + 5*fd*(Pk2*k2**2*(-192*r - 260*s + 113) + 7*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 143*D1*f*(16*Pk2*gd2*k2**2*r + bd1*(-12*Pk2*k1**2*s - 2*Pk2*k2**2*(r*(4*K - 4) + 3*s) + 3*Pkd2*k1**2*k2*s + 3*Pkd2*k2**3*s)) + 2288*Dd*Pk2*f*g2*k2**2*(4*r - 1) - 30*Dd*f**3*(Pk2*k2**2*(-192*r - 260*s + 113) + 7*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))))/(45045*d*k1*k2**2) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**2*st**2*(-33*b1**2*k2**2*(D1*fd*(Pk2*k1**2*s*(14 - 8*C) + Pk2*k2**2*r*(8*C - 8) + Pkd2*k1**2*k2*s*(4*C - 7) - 3*Pkd2*k2**3*s) + Dd*f*(-k1**2*(4*C - 7)*(2*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(Pk2*(8*C - 8)*(4*r - 1) + 3*Pkd2*k2*(1 - 4*s)))) - 11*b1*f*(D1*(3*bd1*k1**2*k2**2*(4*C - 7)*(-2*Pk2 + Pkd2*k2)*(2*s - 1) + 3*bd1*k2**4*(Pk2*(8*C - 8)*(2*r - 1) + 3*Pkd2*k2*(1 - 2*s)) + 3*fd*k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1) + fd*k1**2*k2**2*(4*Pk2*(C*(10*r + 50*s - 27) - 25*r - 41*s + 24) + Pkd2*k2*(-8*C*(5*s - 3) - 20*s + 3)) - 2*fd*k2**4*(Pk2*(C*(8 - 16*r) + 34*r + 42*s - 29) + 3*Pkd2*k2*s)) + Dd*f*(3*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 2*k1**2*k2**2*(-2*Pk2*(10*C*(2*r + 10*s - 3) - 50*r - 82*s + 33) + Pkd2*k2*(10*C + 5)*(4*s - 1)) + k2**4*(4*Pk2*(16*C*r - 4*C - 34*r - 42*s + 19) + 3*Pkd2*k2*(1 - 4*s)))) + f**2*(D1*(11*bd1*(3*k1**4*s*(-4*Pk2 + Pkd2*k2) + k1**2*k2**2*(-2*Pk2*(2*C*(5*r + 25*s - 3) - 25*r - 41*s + 18) + Pkd2*k2*(4*C*(5*s + 1) + 10*s - 7)) + k2**4*(-2*Pk2*(8*C*r - 17*r - 21*s + 9) + 3*Pkd2*k2*(s - 1))) - 3*fd*(-2*Pk2*k2**4*(24*C*(3*r - 1) + 69*r + 81*s - 50) + 5*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k1**2*k2**2*(2*Pk2*(2*C*(27*r + 123*s - 50) - 153*r - 192*s + 115) + Pkd2*k2*(-40*C - 5)*(3*s - 1)))) - 3*Dd*f*(-4*Pk2*k2**4*(12*C*(4*r - 1) + 46*r + 54*s - 25) + 5*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(2*Pk2*(4*C*(18*r + 82*s - 25) - 204*r - 256*s + 115) + Pkd2*k2*(-40*C - 5)*(4*s - 1)))))/(3465*d*k1*k2**2*k3**2) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct*f*st**4*(143*b1**2*k1**2*(4*Pk2 - Pkd2*k2)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) + 13*b1*f*(D1*(-15*Pk2*fd*k2**2*r + 22*bd1*k1**2*s*(4*Pk2 - Pkd2*k2) + 9*fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) + Dd*f*(5*Pk2*k2**2*(1 - 4*r) + 9*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + f**2*(57*D1*Pk2*fd*k2**2*(1 - 4*r) - 13*D1*bd1*(-36*Pk2*k1**2*s + 5*Pk2*k2**2*(r - 1) + 9*Pkd2*k1**2*k2*s) + 30*D1*fd*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 57*Dd*Pk2*f*k2**2*(1 - 4*r) + 30*Dd*f*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)))/(9009*d*k1**2*k2) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct*f*st**4*(11*b1*(2*D1*fd*(-3*Pk2*k2**4*r + k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(4*C*Pk2*(2*r + 6*s - 3) + 5*C*Pkd2*k2*(1 - 2*s) - 13*Pk2*r - 2*Pkd2*k2*s + Pkd2*k2)) + Dd*f*(3*Pk2*k2**4*(1 - 4*r) + 2*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(32*C*(r + 3*s - 1) - 52*r + 13) + Pkd2*k2*(-10*C - 2)*(4*s - 1)))) + f*(D1*(-11*bd1*(3*Pk2*k2**4*(r - 1) + k1**4*(-8*Pk2*s + 2*Pkd2*k2*s) + k1**2*k2**2*(-8*C*Pk2*(r + 3*s - 1) + 13*Pk2*(r - 1) + Pkd2*k2*s*(10*C + 2))) + fd*(25*Pk2*k2**4*(1 - 3*r) + 6*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k1**2*k2**2*(Pk2*(24*C*(3*r + 9*s - 4) - 165*r + 55) + Pkd2*k2*(-30*C - 6)*(3*s - 1)))) + Dd*f*(25*Pk2*k2**4*(1 - 4*r) + 6*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(96*C*(r + 3*s - 1) - 220*r + 55) + Pkd2*k2*(-30*C - 6)*(4*s - 1)))))/(3465*d*k1**2*k2*k3**2) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct*st**2*(-1287*b1**3*k1**2*(2*Pk2 - Pkd2*k2)*(D1*fd*s + Dd*f*(4*s - 1)) - 429*b1**2*(3*D1*bd1*f*k1**2*(2*Pk2 - Pkd2*k2)*(3*s - 1) - D1*fd*(Pk2*k2**2*r*(4*f + 1) + k1**2*(Pk2*(-8*K*s + 8*K + 2*f*(3*r + 4*s - 5) + 3*r - 4*s + 4) + Pkd2*k2*(f*(8*s - 1) + (3*K + 3)*(s - 1)))) - Dd*f*(Pk2*k2**2*(2*f + 1)*(4*r - 1) + k1**2*(Pk2*(-32*K*s + 8*K + f*(12*r + 16*s - 7) + 12*r - 16*s + 1) + Pkd2*k2*(4*s - 1)*(3*K + 4*f + 3)))) + 13*b1*(-176*D1*K*Pk2*f*fd*k1**2*s + 88*D1*K*Pk2*f*fd*k1**2 + 66*D1*K*Pkd2*f*fd*k1**2*k2*s - 33*D1*K*Pkd2*f*fd*k1**2*k2 - 198*D1*Pk2*bd2*f*k1**2*s + 414*D1*Pk2*f**2*fd*k1**2*r + 918*D1*Pk2*f**2*fd*k1**2*s - 435*D1*Pk2*f**2*fd*k1**2 + 234*D1*Pk2*f**2*fd*k2**2*r - 78*D1*Pk2*f**2*fd*k2**2 + 154*D1*Pk2*f*fd*k1**2*r - 88*D1*Pk2*f*fd*k1**2*s - 33*D1*Pk2*f*fd*k1**2 + 110*D1*Pk2*f*fd*k2**2*r - 55*D1*Pk2*f*fd*k2**2 + 528*D1*Pk2*f*gd2*k1**2*s + 528*D1*Pk2*fd*g2*k1**2*s - 528*D1*Pk2*fd*g2*k1**2 + 99*D1*Pkd2*bd2*f*k1**2*k2*s + 135*D1*Pkd2*f**2*fd*k1**2*k2*s - 15*D1*Pkd2*f**2*fd*k1**2*k2 + 66*D1*Pkd2*f*fd*k1**2*k2*s - 33*D1*Pkd2*f*fd*k1**2*k2 - 198*D1*Pkd2*f*gd2*k1**2*k2*s - 198*D1*Pkd2*fd*g2*k1**2*k2*s + 198*D1*Pkd2*fd*g2*k1**2*k2 + 33*D1*bd1*f*(Pk2*k2**2*(2*f + 1)*(2*r - 1) + k1**2*(Pk2*(-16*K*s + f*(6*r + 8*s + 3) + 6*r - 8*s - 3) + Pkd2*k2*(f*(8*s - 3) + s*(6*K + 6)))) - 352*Dd*K*Pk2*f**2*k1**2*s + 88*Dd*K*Pk2*f**2*k1**2 + 132*Dd*K*Pkd2*f**2*k1**2*k2*s - 33*Dd*K*Pkd2*f**2*k1**2*k2 + 552*Dd*Pk2*f**3*k1**2*r + 1224*Dd*Pk2*f**3*k1**2*s - 444*Dd*Pk2*f**3*k1**2 + 312*Dd*Pk2*f**3*k2**2*r - 78*Dd*Pk2*f**3*k2**2 + 308*Dd*Pk2*f**2*k1**2*r - 176*Dd*Pk2*f**2*k1**2*s - 33*Dd*Pk2*f**2*k1**2 + 220*Dd*Pk2*f**2*k2**2*r - 55*Dd*Pk2*f**2*k2**2 + 2112*Dd*Pk2*f*g2*k1**2*s - 528*Dd*Pk2*f*g2*k1**2 + 180*Dd*Pkd2*f**3*k1**2*k2*s - 45*Dd*Pkd2*f**3*k1**2*k2 + 132*Dd*Pkd2*f**2*k1**2*k2*s - 33*Dd*Pkd2*f**2*k1**2*k2 - 792*Dd*Pkd2*f*g2*k1**2*k2*s + 198*Dd*Pkd2*f*g2*k1**2*k2 - 99*b2*k1**2*(2*Pk2 - Pkd2*k2)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))) + f*(13*D1*bd1*(3*f**2*(26*Pk2*k2**2*r + k1**2*(Pk2*(46*r + 102*s - 3) + 5*Pkd2*k2*(3*s - 2))) + 11*f*(5*Pk2*k2**2*r + k1**2*(7*Pk2*r - 4*Pk2*(2*K*s + s) + Pkd2*k2*s*(3*K + 3))) + 66*g2*k1**2*s*(8*Pk2 - 3*Pkd2*k2)) - 429*b2*k1**2*(2*Pk2 - Pkd2*k2)*(3*D1*bd1*s + D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) + k1**2*(15*D1*Pk2*f**2*fd*(148*r + 416*s - 141) - 143*D1*f*s*(6*Pk2*bd2 - 16*Pk2*gd2 - 3*Pkd2*bd2*k2 + 6*Pkd2*gd2*k2) + 286*D1*fd*g2*(8*Pk2 - 3*Pkd2*k2)*(2*s - 1) + 15*Dd*Pk2*f**3*(148*r + 416*s - 141) + 286*Dd*f*g2*(8*Pk2 - 3*Pkd2*k2)*(4*s - 1))))/(45045*d*k1**2*k2) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct*st**2*(-33*b1**2*(-D1*fd*(Pk2*k2**4*r + k1**4*(-4*Pk2*s + 2*Pkd2*k2*s) + k1**2*k2**2*(Pk2*r*(11 - 8*C) - Pk2*s*(4*C - 4) + Pkd2*k2*s*(6*C + 2))) + Dd*f*(Pk2*k2**4*(1 - 4*r) + 2*k1**4*(2*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(4*C*(8*r + 4*s - 3) - 44*r - 16*s + 15) + Pkd2*k2*(-6*C - 2)*(4*s - 1)))) - 11*b1*f*(3*D1*bd1*(Pk2*k2**4*(1 - 2*r) + 2*k1**4*(2*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(Pk2*(4*C*(4*r + 2*s - 3) - 22*r - 8*s + 15) + Pkd2*k2*(-6*C - 2)*(2*s - 1))) + D1*fd*(5*Pk2*k2**4*(1 - 2*r) + 2*k1**4*(Pk2*(16*C*s - 8*C - 9*r - 24*s + 14) + Pkd2*k2*(-6*C*s + 3*C - 2*s)) - k1**2*k2**2*(Pk2*(8*C*(7*r + 17*s - 8) + 44*r + 56*s - 39) + Pkd2*k2*s*(12*C + 4))) + Dd*f*(5*Pk2*k2**4*(1 - 4*r) + k1**4*(Pk2*(64*C*s - 16*C - 36*r - 96*s + 33) + Pkd2*k2*(-6*C - 2)*(4*s - 1)) - 2*k1**2*k2**2*(Pk2*(8*C*(7*r + 17*s - 6) + 44*r + 56*s - 25) + Pkd2*k2*(3*C + 1)*(4*s - 1)))) + f**2*(-11*D1*bd1*(-5*Pk2*k2**4*r + k1**4*(Pk2*(-9*r + s*(16*C - 24) + 5) - 2*Pkd2*k2*(3*C*s + s - 1)) - k1**2*k2**2*(Pk2*(4*C*(7*r + 17*s - 8) + 22*r + 28*s - 11) + Pkd2*k2*(6*C + 2)*(s - 1))) + k1**2*(D1*fd*(9*Pk2*k2**2*(C*(92*r + 88*s - 60) + 13*r + 32*s - 15) + k1**2*(30*C*Pkd2*k2*(3*s - 1) + Pk2*(-240*C*s + 80*C + 147*r + 348*s - 165))) + Dd*f*(3*Pk2*k2**2*(4*C*(92*r + 88*s - 45) + 52*r + 128*s - 45) + k1**2*(30*C*Pkd2*k2*(4*s - 1) + Pk2*(-320*C*s + 80*C + 196*r + 464*s - 165))))))/(3465*d*k1**2*k2*k3**2) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*f**2*st**6*(4*Pk2 - Pkd2*k2)*(13*b1*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1)) + f*(13*D1*bd1*s + 3*D1*fd*(4*s - 1) + 3*Dd*f*(4*s - 1)))/(3003*d*k1) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*f*st**4*(-11*D1*bd1*f*(Pk2*k2**2*(2*r + s - 2) + k1**2*(4*C*Pkd2*k2*s + Pk2*(-8*C*s + 2*r + s - 2))) + 11*b1*(D1*fd*(Pk2*k2**2*(-4*r - 2*s + 1) + k1**2*(4*C*Pkd2*k2*(1 - 2*s) + Pk2*(16*C*s - 8*C - 4*r - 2*s + 1))) + Dd*f*(Pk2*k2**2*(-8*r - 4*s + 3) + k1**2*(4*C*Pkd2*k2*(1 - 4*s) + Pk2*(32*C*s - 8*C - 8*r - 4*s + 3)))) + f*(D1*fd*(Pk2*k2**2*(C*(32 - 96*r) - 18*r - 9*s + 9) + 3*k1**2*(4*C*Pkd2*k2*(1 - 3*s) + Pk2*(24*C*s - 8*C - 6*r - 3*s + 3))) + Dd*f*(Pk2*k2**2*(-128*C*r + 32*C - 24*r - 12*s + 9) + 3*k1**2*(4*C*Pkd2*k2*(1 - 4*s) + Pk2*(32*C*s - 8*C - 8*r - 4*s + 3)))))/(3465*d*k1*k3**2) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*f*st**4*(-143*b1**2*(D1*fd*(k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(2*Pk2 - Pkd2*k2)*(4*s - 1)) + Dd*f*(4*s - 1)*(k1**2*(4*Pk2 - Pkd2*k2) - 2*k2**2*(-2*Pk2 + Pkd2*k2))) - 13*b1*f*(-11*D1*bd1*(-8*Pk2*k1**2*s + Pk2*k2**2*(2 - 8*s) + 2*Pkd2*k1**2*k2*s + Pkd2*k2**3*(4*s - 1)) + D1*fd*(6*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(Pk2*(-144*r - 129*s + 65) + 3*Pkd2*k2*(1 - 6*s))) + 6*Dd*f*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + Dd*f*k2**2*(Pk2*(-192*r - 172*s + 91) + 6*Pkd2*k2*(1 - 4*s))) + f**2*(D1*(13*bd1*(-24*Pk2*k1**2*s + Pk2*k2**2*(48*r + 43*s - 26) + 6*Pkd2*k1**2*k2*s + 3*Pkd2*k2**3*(2*s - 1)) + 3*fd*(Pk2*k2**2*(256*r + 260*s - 129) - 5*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 3*Dd*f*(Pk2*k2**2*(256*r + 260*s - 129) - 5*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))))/(45045*d*k1*k2**2) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*st**2*(33*b1**3*(Pkd2*k2**3 + k1**2*(-2*Pk2 + Pkd2*k2))*(D1*fd*s + Dd*f*(4*s - 1)) - 11*b1**2*(-3*D1*bd1*f*(3*s - 1)*(Pkd2*k2**3 + k1**2*(-2*Pk2 + Pkd2*k2)) - D1*fd*(k1**2*(Pk2*(10*f*s - 9*f + 3*s - 3) + 4*Pkd2*f*k2*s) + k2**2*(Pk2*f*(32*r + 36*s - 13) + 3*Pk2*(s - 1) + 2*Pkd2*f*k2*s)) + Dd*f*(-k1**2*(4*s - 1)*(Pk2*(5*f + 3) + 2*Pkd2*f*k2) + k2**2*(Pk2*(f*(-64*r - 72*s + 34) - 12*s + 3) + Pkd2*f*k2*(1 - 4*s)))) + b1*f*(11*D1*bd1*(Pk2*s*(6*k1**2 + 6*k2**2) + 2*f*k1**2*(Pk2*(5*s + 2) + Pkd2*k2*(2*s - 1)) + f*k2**2*(Pk2*(32*r + 36*s - 21) + Pkd2*k2*(2*s - 1))) + D1*fd*(Pk2*k2**2*(88*K*r - 44*K + 3*f*(72*r + 66*s - 35) + 88*r + 22*s - 55) + k1**2*(Pk2*(168*f*s - 66*f + 22*s - 11) + 15*Pkd2*f*k2*s)) + Dd*f*(Pk2*k2**2*(176*K*r - 44*K + 6*f*(48*r + 44*s - 23) + 176*r + 44*s - 55) + k1**2*(4*s - 1)*(Pk2*(56*f + 11) + 5*Pkd2*f*k2))) + f*(D1*bd1*f*(11*Pk2*(k1**2*s + k2**2*(r*(4*K + 4) + s)) + f*(3*Pk2*k2**2*(24*r + 22*s - 11) + k1**2*(2*Pk2*(28*s + 5) + 5*Pkd2*k2*(s - 1)))) + Pk2*(15*D1*f**2*fd*k1**2*(4*s - 1) + 44*D1*f*k2**2*r*(bd2 - 2*gd2) + 44*D1*fd*k2**2*(b2 - 2*g2)*(2*r - 1) + 15*Dd*f**3*k1**2*(4*s - 1) + 44*Dd*f*k2**2*(b2 - 2*g2)*(4*r - 1))))/(3465*d*k1*k2**2) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*st**2*(33*b1**2*k2**2*(D1*fd*(Pk2*k2**2*(2*r + s) + k1**2*(4*C*Pkd2*k2*s + 2*Pk2*r + Pk2*s)) + Dd*f*(Pk2*k2**2*(8*r + 4*s - 3) + k1**2*(4*C*Pkd2*k2*(4*s - 1) + Pk2*(8*r + 4*s - 3)))) + 11*b1*f*(D1*(3*bd1*k2**2*(Pk2*k2**2*(4*r + 2*s - 3) + k1**2*(4*C*Pkd2*k2*(2*s - 1) + Pk2*(4*r + 2*s - 3))) + fd*(Pk2*k1**4*(2*s - 1) + 2*Pk2*k2**4*(C*(8*r - 4) + 2*r + s - 1) + k1**2*k2**2*(8*C*Pkd2*k2*s + Pk2*(12*C*(2*r + 6*s - 3) + 4*r + 4*s - 3)))) + Dd*f*(Pk2*k1**4*(4*s - 1) + Pk2*k2**4*(8*C*(4*r - 1) + 8*r + 4*s - 3) + 4*k1**2*k2**2*(C*Pkd2*k2*(4*s - 1) + Pk2*(12*C*(r + 3*s - 1) + 2*r + 2*s - 1)))) + f**2*(D1*(Pk2*fd*k1**2*(5*k1**2*(3*s - 1) + k2**2*(4*C*(51*r + 99*s - 50) + 15*s - 5)) + 11*bd1*(Pk2*k1**4*s + Pk2*k2**4*(r*(8*C + 2) + s - 1) + k1**2*k2**2*(4*C*Pkd2*k2*(s - 1) + Pk2*(12*C*(r + 3*s - 1) + 2*r + 2*s - 1)))) + Dd*Pk2*f*k1**2*(5*k1**2*(4*s - 1) + k2**2*(8*C*(34*r + 66*s - 25) + 20*s - 5))))/(3465*d*k1*k2**2*k3**2) + 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**4*f*k2**2*st**2*(C - 1)*(11*D1*bd1*f*(r - 1) + 11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 5*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(1155*d*k3**2) - 10*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**3*f**2*k2*st**2*(13*D1*bd1*f*(r - 1) + 13*b1*(3*D1*fd*r + Dd*f*(4*r - 1)) + 7*f*(4*r - 1)*(D1*fd + Dd*f))/(9009*d*k1) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**3*f*k2*st**2*(k1**2*(3 - 2*C) + k2**2)*(11*D1*bd1*f*(r - 1) + 11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 5*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(1155*d*k1*k3**2) + 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**2*f*k2**2*st**4*(C - 1)*(11*D1*bd1*f*(r - 1) + 11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 3*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(3465*d*k3**2) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**2*st**2*(429*b1**2*(D1*fd*r*(-K + 4*f + 1) + Dd*f*(4*r - 1)*(-K + 2*f + 1)) + 13*b1*(33*D1*bd1*f*(2*r - 1)*(-K + 2*f + 1) + D1*(30*f**2*fd*(9*r - 1) - 11*f*fd*(K - 1)*(2*r - 1) + 66*f*gd2*r + 66*fd*g2*r) + Dd*f*(4*r - 1)*(90*f**2 - 11*f*(K - 1) + 66*g2)) + f*(13*D1*bd1*(30*f**2*(3*r - 2) - 11*f*r*(K - 1) + 66*g2*(r - 1)) + 2*D1*(210*f**2*fd*(4*r - 1) + 143*f*gd2*r + 143*fd*g2*(2*r - 1)) + 2*Dd*f*(210*f**2 + 143*g2)*(4*r - 1)))/(45045*d) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**2*st**2*(11*D1*bd1*f*(3*b1*k2**2*(C - 1)*(2*r - 1) + f*k1**2*(C - 4)*(r - 1) + f*k2**2*(C*(6 - 5*r) - 4*r + 3)) + 33*b1**2*k2**2*(C - 1)*(D1*fd*r + Dd*f*(4*r - 1)) + 11*b1*f*(D1*fd*(k1**2*r*(2*C - 8) - k2**2*(10*C*r + C + 8*r - 1)) + Dd*f*(4*r - 1)*(k1**2*(C - 4) - k2**2*(5*C + 4))) + 5*f**2*(k1**2*(C - 4) - k2**2*(6*C + 3))*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(3465*d*k3**2) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct*f**2*k2*st**4*(13*D1*bd1*f*(r - 1) + 13*b1*(3*D1*fd*r + Dd*f*(4*r - 1)) + 5*f*(4*r - 1)*(D1*fd + Dd*f))/(3003*d*k1) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct*f*k2*st**4*(k1**2 + k2**2)*(11*D1*bd1*f*(r - 1) + 11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 3*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(3465*d*k1*k3**2) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct*st**2*(429*b1**2*(D1*fd*r*(k1**2*(2*f + 1) + k2**2*(4*f + 1)) + Dd*f*(4*r - 1)*(k1**2*(f + 1) + k2**2*(2*f + 1))) + 13*b1*f*(33*D1*bd1*(2*r - 1)*(k1**2*(f + 1) + k2**2*(2*f + 1)) + D1*fd*(k1**2*(15*f*(6*r - 1) + 22*r - 11) + k2**2*(30*f*(3*r - 1) + 22*r - 11)) + Dd*f*(30*f + 11)*(k1**2 + k2**2)*(4*r - 1)) + f**2*(13*D1*bd1*(15*f*(k1**2*(2*r - 1) + 2*k2**2*r) + r*(11*k1**2 + 11*k2**2)) + 105*f*k1**2*(4*r - 1)*(D1*fd + Dd*f)))/(45045*d*k1*k2) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct*st**2*(11*D1*bd1*f*(3*b1*k2**2*(k1**2 + k2**2)*(2*r - 1) + f*(k1**4*(r - 1) + k1**2*k2**2*(12*C*(r - 1) + 2*r - 1) + k2**4*r)) + 33*b1**2*k2**2*(k1**2 + k2**2)*(D1*fd*r + Dd*f*(4*r - 1)) + 11*b1*f*(D1*fd*(2*k1**4*r + k1**2*k2**2*(r*(24*C + 4) - 1) + k2**4*(2*r - 1)) + Dd*f*(4*r - 1)*(k1**4 + k1**2*k2**2*(12*C + 2) + k2**4)) + 5*f**2*k1**2*(k1**2 + k2**2*(12*C + 1))*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(3465*d*k1*k2*k3**2) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*f*st**4*(143*b1**2*(2*D1*fd*r + Dd*f*(4*r - 1)) + 13*b1*f*(11*D1*bd1*(2*r - 1) + 3*D1*fd*(9*r - 1) + 9*Dd*f*(4*r - 1)) + 3*f**2*(13*D1*bd1*(3*r - 2) + (4*r - 1)*(10*D1*fd + 10*Dd*f)))/(45045*d) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*st**2*(33*b1**3*(D1*fd*r + Dd*f*(4*r - 1)) + 11*b1**2*(3*D1*bd1*f*(3*r - 1) + D1*fd*(f*(8*r - 1) + r*(3*K + 3)) + Dd*f*(4*r - 1)*(3*K + 4*f + 3)) + b1*(22*D1*K*f*fd*r - 11*D1*K*f*fd + 11*D1*bd1*f*(f*(8*r - 3) + (3*K + 3)*(2*r - 1)) + 33*D1*bd2*f*r + 45*D1*f**2*fd*r - 15*D1*f**2*fd + 22*D1*f*fd*r - 11*D1*f*fd - 66*D1*f*gd2*r - 66*D1*fd*g2*r + 44*Dd*K*f**2*r - 11*Dd*K*f**2 + 60*Dd*f**3*r - 15*Dd*f**3 + 44*Dd*f**2*r - 11*Dd*f**2 - 264*Dd*f*g2*r + 66*Dd*f*g2 + 33*b2*(D1*fd*r + Dd*f*(4*r - 1))) + f*(D1*bd1*f*r*(11*K + 15*f + 11) - 66*D1*bd1*g2*(r - 1) + 11*D1*(f*r*(bd2 - 2*gd2) + fd*g2*(2 - 4*r)) + 22*Dd*f*g2*(1 - 4*r) + 11*b2*(3*D1*bd1*(r - 1) + D1*fd*(2*r - 1) + Dd*f*(4*r - 1))))/(3465*d)
        perm13 = -16*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**5*f*k2**5*st**2*(C - 1)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 5*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(693*d*k3**6) - 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**5*f*k2**3*st**2*(C - 1)*(11*b1*(2*s - 1)*(D1*fd + 2*Dd*f) + f*(11*D1*bd1*s + 5*D1*fd*(3*s - 1) + 10*Dd*f*(2*s - 1)))/(693*d*k3**4) - 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**4*f*k2**4*st**2*(13*D1*bd1*f*(75*f*k2**2 + k1**2*(836*C - 726))*(r + s - 1) + 13*b1*(D1*fd*(75*f*k2**2*(3*r + 3*s - 2) + k1**2*(836*C - 726)*(2*r + 2*s - 1)) + Dd*f*(75*f*k2**2 + k1**2*(836*C - 726))*(4*r + 4*s - 3)) + 5*f*(D1*fd*(105*f*k2**2*(4*r + 4*s - 3) + k1**2*(988*C - 858)*(3*r + 3*s - 2)) + Dd*f*(105*f*k2**2 + k1**2*(988*C - 858))*(4*r + 4*s - 3)))/(45045*d*k1*k3**6) - 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**4*f*k2**2*st**2*(11*b1*(2*s - 1)*(D1*fd + 2*Dd*f) + f*(11*D1*bd1*s + 5*D1*fd*(3*s - 1) + 10*Dd*f*(2*s - 1)))/(693*d*k1*k3**2) - 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**4*f*k2**2*st**2*(11*b1*(D1*fd*(k1**2*(32*C - 27)*(2*s - 1) + k2**2*(-8*C*r + 18*r + 10*s - 5)) + Dd*f*(k1**2*(64*C - 54)*(2*s - 1) + k2**2*(-16*C*r + 4*C + 36*r + 20*s - 19))) + f*(11*D1*bd1*(k1**2*s*(32*C - 27) + k2**2*(-4*C*r + 4*C + 9*r + 5*s - 9)) + D1*fd*(k1**2*(160*C - 135)*(3*s - 1) + k2**2*(-168*C*r + 56*C + 243*r + 75*s - 106)) + Dd*f*k1**2*(320*C - 270)*(2*s - 1) + Dd*f*k2**2*(-56*C*(4*r - 1) + 324*r + 100*s - 131)))/(3465*d*k1*k3**4) - 16*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**3*f*k2**5*st**4*(C - 1)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 3*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(693*d*k3**6) - 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**3*f*k2**3*st**4*(C - 1)*(11*b1*(2*s - 1)*(D1*fd + 2*Dd*f) + f*(11*D1*bd1*s + D1*fd*(9*s - 3) + 6*Dd*f*(2*s - 1)))/(693*d*k3**4) - 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**3*k2**3*st**2*(13*D1*bd1*f*(r + s - 1)*(150*f**2*k2**2 + 11*f*(k1**2*(110*C - 82) + k2**2*(3*K - 20*b1 - 3)) - k2**2*(-198*K*b1 + 198*b1 + 198*g2)) - 143*b1**2*k2**2*(D1*fd*(10*f*(2*r + 2*s - 1) + (9 - 9*K)*(r + s)) + Dd*f*(-9*K + 10*f + 9)*(4*r + 4*s - 3)) + 13*b1*(D1*(150*f**2*fd*k2**2*(3*r + 3*s - 2) + 11*f*(fd*(k1**2*(110*C - 82) + k2**2*(3*K - 3))*(2*r + 2*s - 1) - 18*gd2*k2**2*(r + s - 1)) - 198*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(150*f**2*k2**2 + f*k1**2*(1210*C - 902) + 33*f*k2**2*(K - 1) - 198*g2*k2**2)) + 2*f*(D1*(700*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(3575*C - 2665)*(3*r + 3*s - 2) - 429*f*gd2*k2**2*(r + s - 1) - 429*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(700*f**2*k2**2 + f*k1**2*(3575*C - 2665) - 429*g2*k2**2)))/(45045*d*k3**6) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**3*k2*st**2*(198*b1**2*k1**2*(C - 1)*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) - 11*b1*f*(-2*D1*(18*bd1*k1**2*s*(C - 1) - fd*k1**2*(7*C - 8)*(2*s - 1) + fd*k2**2*r) + Dd*f*(k1**2*(28*C - 32)*(2*s - 1) + k2**2*(1 - 4*r))) + f**2*(D1*(22*bd1*k1**2*s*(8 - 7*C) + 11*bd1*k2**2*(r - 1) - fd*k1**2*(100*C - 110)*(3*s - 1) + 31*fd*k2**2*(1 - 3*r)) + Dd*f*(-k1**2*(200*C - 220)*(2*s - 1) + 31*k2**2*(1 - 4*r))))/(3465*d*k1**2*k3**2) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**3*k2*st**2*(2574*b1**2*k1**2*k2**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) - 13*b1*f*(D1*(-198*bd1*k1**2*k2**2*(C - 1)*(2*r + 2*s - 1) + fd*(15*f*k2**4*r - k1**4*(814*C - 572)*(2*s - 1) + 22*k1**2*k2**2*(C*(64*r + 62*s - 28) - 67*r - 70*s + 32))) + Dd*f*(5*f*k2**4*(4*r - 1) - k1**4*(1628*C - 1144)*(2*s - 1) + 11*k1**2*k2**2*(4*C*(64*r + 62*s - 47) - 268*r - 280*s + 207))) + f**2*(D1*(13*bd1*(-5*f*k2**4*(r - 1) + k1**4*s*(814*C - 572) - 11*k1**2*k2**2*(C*(64*r + 62*s - 70) - 67*r - 70*s + 73)) + fd*(275*f*k2**4*(1 - 4*r) + k1**4*(4810*C - 3380)*(3*s - 1) - 13*k1**2*k2**2*(6*C*(271*r + 146*s - 139) - 1563*r - 996*s + 853))) + Dd*f*(275*f*k2**4*(1 - 4*r) + k1**4*(9620*C - 6760)*(2*s - 1) - 13*k1**2*k2**2*(2*C*(1084*r + 584*s - 563) - 2084*r - 1328*s + 1185))))/(45045*d*k1**2*k3**4) - 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*f*k2**4*st**4*(13*D1*bd1*f*(45*f*k2**2 + k1**2*(286*C - 231))*(r + s - 1) + 13*b1*(D1*fd*(45*f*k2**2*(3*r + 3*s - 2) + k1**2*(286*C - 231)*(2*r + 2*s - 1)) + Dd*f*(45*f*k2**2 + k1**2*(286*C - 231))*(4*r + 4*s - 3)) + 3*f*(D1*fd*(75*f*k2**2*(4*r + 4*s - 3) + k1**2*(338*C - 273)*(3*r + 3*s - 2)) + Dd*f*(75*f*k2**2 + k1**2*(338*C - 273))*(4*r + 4*s - 3)))/(45045*d*k1*k3**6) - 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*f*k2**2*st**4*(11*b1*(2*s - 1)*(D1*fd + 2*Dd*f) + f*(11*D1*bd1*s + D1*fd*(9*s - 3) + 6*Dd*f*(2*s - 1)))/(693*d*k1*k3**2) - 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*f*k2**2*st**4*(11*b1*(D1*fd*(k1**2*(24*C - 19)*(2*s - 1) + k2**2*(-16*C*r + 26*r + 10*s - 5)) + Dd*f*(k1**2*(48*C - 38)*(2*s - 1) + k2**2*(-32*C*r + 8*C + 52*r + 20*s - 23))) + f*(11*D1*bd1*(k1**2*s*(24*C - 19) + k2**2*(-8*C*(r - 1) + 13*r + 5*s - 13)) + D1*fd*(k1**2*(72*C - 57)*(3*s - 1) + 5*k2**2*(C*(8 - 24*r) + 33*r + 9*s - 14)) + Dd*f*k1**2*(144*C - 114)*(2*s - 1) + 5*Dd*f*k2**2*(C*(8 - 32*r) + 44*r + 12*s - 17)))/(3465*d*k1*k3**4) - 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*k1*k2**2*st**2*(13*D1*bd1*f*(r + s - 1)*(60*f**2*k2**2 + 11*f*(k1**2*(74*C - 47) - k2**2*(-9*K + 48*b1 + 6)) - k2**2*(198*b1*(2 - 3*K) + 594*g2)) - 429*b1**2*k2**2*(D1*fd*(8*f*(2*r + 2*s - 1) + (6 - 9*K)*(r + s)) + Dd*f*(-9*K + 8*f + 6)*(4*r + 4*s - 3)) + 13*b1*(D1*(60*f**2*fd*k2**2*(3*r + 3*s - 2) + 11*f*(fd*(k1**2*(74*C - 47) + k2**2*(9*K - 6))*(2*r + 2*s - 1) - 54*gd2*k2**2*(r + s - 1)) - 594*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(60*f**2*k2**2 + 11*f*(k1**2*(74*C - 47) + k2**2*(9*K - 6)) - 594*g2*k2**2)) + f*(D1*(1260*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(4810*C - 3055)*(3*r + 3*s - 2) - 2574*f*gd2*k2**2*(r + s - 1) - 2574*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(1260*f**2*k2**2 + f*k1**2*(4810*C - 3055) - 2574*g2*k2**2)))/(45045*d*k3**6) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*st**2*(D1*bd1*f**2*s + 3*b1**2*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) + b1*f*(6*D1*bd1*s + D1*fd*(2*s - 1) + 2*Dd*f*(2*s - 1)))/(105*d*k1) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*st**2*(33*b1**2*(D1*fd*k1**2*(12*C - 9)*(s - 1) + D1*fd*k2**2*r*(4 - 4*C) + Dd*f*k1**2*(24*C - 18)*(2*s - 1) + 4*Dd*f*k2**2*(-4*C*r + C + 4*r - 1)) - 11*b1*f*(D1*(18*bd1*k1**2*s*(3 - 4*C) + 12*bd1*k2**2*(C - 1)*(2*r - 1) + fd*k1**2*(12*C - 6)*(2*s - 1) + fd*k2**2*(8*C*(2*r - 1) + 2*r + 42*s - 13)) + Dd*f*(k1**2*(24*C - 12)*(2*s - 1) + k2**2*(32*C*r - 8*C + 4*r + 84*s - 43))) - f**2*(11*D1*bd1*(k1**2*s*(12*C - 6) + k2**2*(8*C*r + r + 21*s - 9)) + 3*D1*fd*(k1**2*(40*C - 25)*(3*s - 1) + k2**2*(C*(24 - 72*r) + 105*r + 81*s - 62)) + Dd*f*k1**2*(240*C - 150)*(2*s - 1) + 3*Dd*f*k2**2*(C*(24 - 96*r) + 140*r + 108*s - 89)))/(3465*d*k1*k3**2) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*st**2*(429*b1**2*k2**2*(D1*fd*(k1**2*(14*C - 11)*(r + s - 1) + k2**2*(-2*K*r + f*(8*r + 8*s - 6) + 5*r + 3*s)) + Dd*f*(k1**2*(14*C - 11)*(4*r + 4*s - 3) + k2**2*(-8*K*r + 2*K + 4*f*(4*r + 4*s - 3) + 20*r + 12*s - 11))) - 13*b1*(D1*(-3*f**2*k2**4*(22*bd1*(4*r + 4*s - 3) - 3*fd*(4*r + 35*s - 16)) - 11*f*(3*bd1*k1**2*k2**2*(14*C - 11)*(2*r + 2*s - 1) + 6*bd1*k2**4*(-2*K*r + K + 5*r + 3*s - 4) + fd*k1**4*(36*C - 21)*(2*s - 1) - 2*fd*k1**2*k2**2*(C*(104*r + 136*s - 61) - 77*r - 109*s + 49) + fd*k2**4*(K*(4 - 8*r) + 14*r + 6*s - 7) + 12*gd2*k2**4*r) - 132*fd*g2*k2**4*r) + Dd*f*(6*f**2*k2**4*(8*r + 70*s - 37) - 11*f*(k1**4*(72*C - 42)*(2*s - 1) + k1**2*k2**2*(-8*C*(52*r + 68*s - 47) + 308*r + 436*s - 295) + k2**4*(K*(4 - 16*r) + 28*r + 12*s - 13)) + 132*g2*k2**4*(1 - 4*r))) - f*(D1*(3*f**2*k2**4*(13*bd1*(4*r + 35*s - 26) + 10*fd*(144*r + 130*s - 101)) - 13*f*(11*bd1*(k1**4*s*(36*C - 21) + k1**2*k2**2*(-2*C*(52*r + 68*s - 59) + 77*r + 109*s - 88) + k2**4*(-4*K*r + 7*r + 3*s - 3)) + fd*k1**4*(180*C - 105)*(3*s - 1) + 6*fd*k1**2*k2**2*(C*(-381*r - 315*s + 232) + 276*r + 252*s - 176) + 88*gd2*k2**4*r) - 572*g2*k2**4*(3*bd1*(r - 1) + 2*fd*(2*r - 1))) + 2*Dd*f*(15*f**2*k2**4*(144*r + 130*s - 101) - 39*f*(k1**4*(60*C - 35)*(2*s - 1) + k1**2*k2**2*(C*(-508*r - 420*s + 337) + 368*r + 336*s - 260)) + 572*g2*k2**4*(1 - 4*r))))/(45045*d*k1*k3**4) - 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*f*k2**3*st**4*(13*D1*bd1*f*(k1**2*(242*C - 154) + k2**2*(-110*b1 + 45*f))*(r + s - 1) - 715*b1**2*k2**2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 13*b1*(D1*fd*(45*f*k2**2*(3*r + 3*s - 2) + k1**2*(242*C - 154)*(2*r + 2*s - 1)) + Dd*f*(45*f*k2**2 + k1**2*(242*C - 154))*(4*r + 4*s - 3)) + 6*f*(D1*fd*(50*f*k2**2*(4*r + 4*s - 3) + k1**2*(143*C - 91)*(3*r + 3*s - 2)) + Dd*f*(50*f*k2**2 + k1**2*(143*C - 91))*(4*r + 4*s - 3)))/(45045*d*k3**6) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*f*k2*st**4*(11*b1*(2*D1*fd*(k1**2*(10*C - 7)*(2*s - 1) + 3*k2**2*r) + Dd*f*(k1**2*(40*C - 28)*(2*s - 1) + 3*k2**2*(4*r - 1))) + f*(D1*(22*bd1*k1**2*s*(10*C - 7) + 33*bd1*k2**2*(r - 1) + fd*k1**2*(60*C - 42)*(3*s - 1) + 25*fd*k2**2*(3*r - 1)) + Dd*f*(k1**2*(120*C - 84)*(2*s - 1) + 25*k2**2*(4*r - 1))))/(3465*d*k1**2*k3**2) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*f*k2*st**4*(13*b1*(D1*fd*(75*f*k2**4*r - k1**4*(396*C - 242)*(2*s - 1) + 22*k1**2*k2**2*(12*C*(4*r + 2*s - 1) - 39*r - 20*s + 10)) + Dd*f*(25*f*k2**4*(4*r - 1) - k1**4*(792*C - 484)*(2*s - 1) + 11*k1**2*k2**2*(96*C*(2*r + s - 1) - 156*r - 80*s + 79))) + f*(D1*(325*bd1*f*k2**4*(r - 1) - 286*bd1*k1**4*s*(18*C - 11) + 143*bd1*k1**2*k2**2*(24*C*(2*r + s - 2) - 39*r - 20*s + 39) + 285*f*fd*k2**4*(4*r - 1) - fd*k1**4*(1404*C - 858)*(3*s - 1) + 13*fd*k1**2*k2**2*(8*C*(78*r + 27*s - 35) - 495*r - 180*s + 225)) + Dd*f*(285*f*k2**4*(4*r - 1) - k1**4*(2808*C - 1716)*(2*s - 1) + 13*k1**2*k2**2*(32*C*(26*r + 9*s - 11) - 660*r - 240*s + 285))))/(45045*d*k1**2*k3**4) + 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*k1**2*k2*st**2*(13*D1*bd1*f*(r + s - 1)*(30*f**2*k2**2 + f*k1**2*(132 - 242*C) + 33*f*k2**2*(-3*K + 12*b1 + 1) + k2**2*(-594*K*b1 + 198*b1 + 594*g2)) + 1287*b1**2*k2**2*(D1*fd*(f*(4*r + 4*s - 2) - (3*K - 1)*(r + s)) + Dd*f*(-3*K + 2*f + 1)*(4*r + 4*s - 3)) + 13*b1*(D1*(30*f**2*fd*k2**2*(3*r + 3*s - 2) - 11*f*fd*(k1**2*(22*C - 12) + k2**2*(9*K - 3))*(2*r + 2*s - 1) + 594*f*gd2*k2**2*(r + s - 1) + 594*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(30*f**2*k2**2 - 11*f*(k1**2*(22*C - 12) + k2**2*(9*K - 3)) + 594*g2*k2**2)) - 2*f*(D1*(210*f**2*fd*k2**2*(4*r + 4*s - 3) + 13*f*(fd*k1**2*(55*C - 30)*(3*r + 3*s - 2) - 99*gd2*k2**2*(r + s - 1)) - 1287*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(210*f**2*k2**2 + f*k1**2*(715*C - 390) - 1287*g2*k2**2)))/(45045*d*k3**6) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*st**2*(2574*b1**3*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) - 429*b1**2*k2**2*(D1*(-6*bd1*f*k2**2*(3*r + 3*s - 2) + fd*k1**2*(20*C - 12)*(r + s - 1) + fd*k2**2*(f*(34*r + 40*s - 22) + r*(13 - 16*K) - s*(8*K - 8))) + Dd*f*(k1**2*(20*C - 12)*(4*r + 4*s - 3) + k2**2*(-32*K*(2*r + s - 1) + f*(68*r + 80*s - 57) + 52*r + 32*s - 29))) - 13*b1*(D1*(3*f**2*k2**4*(11*bd1*(34*r + 40*s - 35) + fd*(150*r - 114*s + 31)) + 11*f*(3*bd1*k2**2*(k1**2*(20*C - 12)*(2*r + 2*s - 1) + k2**2*(-8*K*(4*r + 2*s - 3) + 26*r + 16*s - 21)) + fd*(k1**4*(12*C - 6)*(2*s - 1) - 2*k1**2*k2**2*(4*C*(28*r + 47*s - 21) - 65*r - 120*s + 54) + k2**4*(-8*K*(6*r + 2*s - 3) + 34*r + 16*s - 17)) + 6*k2**4*(-3*bd2*(r + s - 1) + 8*gd2*(2*r + s - 1))) - 66*fd*k2**4*(3*b2*(r + s) - 8*g2*(2*r + s))) + Dd*f*(6*f**2*k2**4*(100*r - 76*s + 13) + 11*f*(k1**4*(24*C - 12)*(2*s - 1) + k1**2*k2**2*(-8*C*(56*r + 94*s - 61) + 260*r + 480*s - 305) + k2**4*(-8*K*(12*r + 4*s - 5) + 68*r + 32*s - 33)) - 66*k2**4*(3*b2*(4*r + 4*s - 3) - 32*g2*(2*r + s - 1)))) + f*(D1*(3*f**2*k2**4*(bd1*(-650*r + 494*s + 65) + 15*fd*(148*r + 208*s - 141)) - 13*f*(11*bd1*(k1**4*s*(12*C - 6) + k1**2*k2**2*(-4*C*(28*r + 47*s - 33) + 65*r + 120*s - 77) + k2**4*(-8*K*(3*r + s - 1) + 17*r + 8*s - 8)) + fd*k1**4*(60*C - 30)*(3*s - 1) + fd*k1**2*k2**2*(-12*C*(193*r + 212*s - 135) + 1335*r + 1620*s - 985) + 22*k2**4*(-3*bd2*(r + s - 1) + 8*gd2*(3*r + s - 1))) + 286*k2**4*(b2*(9*bd1*(r + s - 1) + 3*fd*(2*r + 2*s - 1)) - 8*g2*(3*bd1*(2*r + s - 2) + fd*(6*r + 2*s - 3)))) + Dd*f*(45*f**2*k2**4*(148*r + 208*s - 141) - 13*f*(k1**4*(120*C - 60)*(2*s - 1) + k1**2*k2**2*(-4*C*(772*r + 848*s - 617) + 1780*r + 2160*s - 1525)) + 286*k2**4*(3*b2*(4*r + 4*s - 3) - 8*g2*(12*r + 4*s - 5)))))/(45045*d*k2*k3**4) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*st**2*(D1*bd1*f**2*(k1**2*s*(12*C - 6) + 5*k2**2*r) + 3*b1**2*(D1*fd*(k1**2*(12*C - 6)*(s - 1) + k2**2*r) + Dd*f*(k1**2*(24*C - 12)*(2*s - 1) + k2**2*(4*r - 1))) + b1*f*(D1*(36*bd1*k1**2*s*(2*C - 1) + 3*bd1*k2**2*(2*r - 1) + fd*k1**2*(12*C - 6)*(2*s - 1) + 5*fd*k2**2*(2*r - 1)) + Dd*f*(k1**2*(24*C - 12)*(2*s - 1) + 5*k2**2*(4*r - 1))))/(315*d*k1**2*k2) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*st**2*(33*b1**2*(D1*fd*(-k1**4*(12*C - 6)*(s - 1) + k1**2*k2**2*(4*C*(3*r + s - 1) - 9*r - 4*s + 4) + k2**4*r*(4*f + 1)) + Dd*f*(-k1**4*(24*C - 12)*(2*s - 1) + k1**2*k2**2*(4*C*(12*r + 4*s - 5) - 36*r - 16*s + 17) + k2**4*(2*f + 1)*(4*r - 1))) + b1*f*(-33*D1*bd1*(k1**4*s*(24*C - 12) + k1**2*k2**2*(-4*C*(6*r + 2*s - 3) + 18*r + 8*s - 9) - k2**4*(2*f + 1)*(2*r - 1)) + k2**2*(D1*fd*(-11*k1**2*(8*C*(2*r + 17*s - 5) - 8*r - 112*s + 35) + k2**2*(78*f*(3*r - 1) + 110*r - 55)) + Dd*f*(-44*k1**2*(4*C*(2*r + 17*s - 9) - 4*r - 56*s + 29) + k2**2*(78*f + 55)*(4*r - 1)))) + f**2*(D1*(bd1*k2**2*(-11*k1**2*(4*C*(2*r + 17*s - 9) - 4*r - 56*s + 25) + k2**2*r*(78*f + 55)) + fd*k1**4*(60*C - 30)*(3*s - 1) - 9*fd*k1**2*k2**2*(C*(92*r + 88*s - 60) - 59*r - 76*s + 45)) + 3*Dd*f*k1**2*(k1**2*(40*C - 20)*(2*s - 1) + k2**2*(-4*C*(92*r + 88*s - 67) + 236*r + 304*s - 211))))/(3465*d*k1**2*k2*k3**2) - 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*f**2*k2**6*st**6*(13*D1*bd1*f*(r + s - 1) + 13*b1*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)) + 3*f*(D1*fd + Dd*f)*(4*r + 4*s - 3))/(3003*d*k1*k3**6) - 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*f*k1*k2**2*st**4*(13*D1*bd1*f*(k1**2*(66*C - 33) + k2**2*(-88*b1 + 6*f))*(r + s - 1) - 572*b1**2*k2**2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 39*b1*(D1*fd*(2*f*k2**2*(3*r + 3*s - 2) + k1**2*(22*C - 11)*(2*r + 2*s - 1)) + Dd*f*(2*f*k2**2 + k1**2*(22*C - 11))*(4*r + 4*s - 3)) + 9*f*(D1*fd*(10*f*k2**2*(4*r + 4*s - 3) + k1**2*(26*C - 13)*(3*r + 3*s - 2)) + Dd*f*(10*f*k2**2 + k1**2*(26*C - 13))*(4*r + 4*s - 3)))/(45045*d*k3**6) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*f*st**4*(11*b1*(D1*fd*(k1**2*(8*C - 4)*(2*s - 1) + k2**2*(4*r + 2*s - 1)) + 4*Dd*f*(k1**2*(4*C - 2)*(2*s - 1) + k2**2*(2*r + s - 1))) + f*(D1*(44*bd1*k1**2*s*(2*C - 1) + 11*bd1*k2**2*(2*r + s - 2) + fd*k1**2*(24*C - 12)*(3*s - 1) + fd*k2**2*(C*(32 - 96*r) + 66*r + 9*s - 25)) + 4*Dd*f*(k1**2*(12*C - 6)*(2*s - 1) + k2**2*(-32*C*r + 8*C + 22*r + 3*s - 7))))/(3465*d*k1*k3**2) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*f*st**4*(-286*b1**2*k2**4*(D1*fd + 2*Dd*f)*(4*r + 4*s - 3) + 13*b1*(D1*(-22*bd1*f*k2**4*(4*r + 4*s - 3) + fd*(f*k2**4*(60*r + 129*s - 64) + k1**4*(44 - 88*C)*(2*s - 1) + 11*k1**2*k2**2*(16*C*(3*r + 2*s - 1) - 28*r - 18*s + 9))) + 2*Dd*f*(f*k2**4*(40*r + 86*s - 53) + k1**4*(44 - 88*C)*(2*s - 1) + 22*k1**2*k2**2*(2*C*(12*r + 8*s - 7) - 14*r - 9*s + 8))) + f*(D1*(-13*bd1*(f*k2**4*(-20*r - 43*s + 42) + k1**4*s*(88*C - 44) - 11*k1**2*k2**2*(8*C*(3*r + 2*s - 3) - 14*r - 9*s + 14)) + fd*(6*f*k2**4*(192*r + 130*s - 113) + k1**4*(156 - 312*C)*(3*s - 1) + 13*k1**2*k2**2*(8*C*(39*r + 18*s - 19) - 174*r - 81*s + 85))) + 2*Dd*f*(3*f*k2**4*(192*r + 130*s - 113) + k1**4*(156 - 312*C)*(2*s - 1) + 26*k1**2*k2**2*(2*C*(52*r + 24*s - 25) - 58*r - 27*s + 28))))/(45045*d*k1*k3**4) + 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*k1**3*st**2*(13*D1*bd1*f*(r + s - 1)*(15*f**2*k2**2 - 11*f*(k1**2*(2*C - 1) + k2**2*(3*K - 8*b1)) + k2**2*(-198*K*b1 + 198*g2)) + 143*b1**2*k2**2*(D1*fd*(-9*K*(r + s) + f*(8*r + 8*s - 4)) + Dd*f*(-9*K + 4*f)*(4*r + 4*s - 3)) + 13*b1*(D1*(15*f**2*fd*k2**2*(3*r + 3*s - 2) - 11*f*fd*(3*K*k2**2 + k1**2*(2*C - 1))*(2*r + 2*s - 1) + 198*f*gd2*k2**2*(r + s - 1) + 198*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(15*f**2*k2**2 - 11*f*(3*K*k2**2 + k1**2*(2*C - 1)) + 198*g2*k2**2)) + f*(D1*(-35*f**2*fd*k2**2*(4*r + 4*s - 3) - f*fd*k1**2*(130*C - 65)*(3*r + 3*s - 2) + 858*f*gd2*k2**2*(r + s - 1) + 858*fd*g2*k2**2*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2 + f*k1**2*(130*C - 65) - 858*g2*k2**2)))/(45045*d*k3**6) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*k1*st**2*(1716*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) - 143*b1**2*(-12*D1*bd1*f*k2**2*(3*r + 3*s - 2) + D1*fd*k1**2*(12*C - 6)*(r + s - 1) + D1*fd*k2**2*(-24*K*s + f*(44*r + 62*s - 29) + 3*r*(2 - 12*K) + 3*s) + Dd*f*k1**2*(12*C - 6)*(4*r + 4*s - 3) + 4*Dd*f*k2**2*(3*K*(-12*r - 8*s + 7) + f*(22*r + 31*s - 21) + 6*r + 3*s - 3)) - 13*b1*(11*D1*bd1*f*(k1**2*(12*C - 6)*(2*r + 2*s - 1) + k2**2*(-12*K*(6*r + 4*s - 5) + f*(44*r + 62*s - 55) + 12*r + 6*s - 9)) + D1*(3*f**2*fd*k2**2*(108*r + 40*s - 31) - 11*f*(fd*(k1**2*(4*C*(8*r + 20*s - 9) - 16*r - 42*s + 19) + k2**2*(16*K - 2)*(2*r + s - 1)) + 6*k2**2*(3*bd2*(r + s - 1) - 4*gd2*(3*r + 2*s - 2))) - 66*fd*k2**2*(3*b2*(r + s) - 4*g2*(3*r + 2*s))) + 2*Dd*f*(2*f**2*k2**2*(108*r + 40*s - 47) - 11*f*(k1**2*(16*C*(2*r + 5*s - 3) - 16*r - 42*s + 25) + k2**2*(16*K - 2)*(2*r + s - 1)) - 33*k2**2*(3*b2*(4*r + 4*s - 3) - 4*g2*(12*r + 8*s - 7)))) + f*(-13*D1*bd1*(f**2*k2**2*(108*r + 40*s - 95) - 11*f*(k1**2*(4*C*(4*r + 10*s - 5) - 8*r - 21*s + 10) + k2**2*(8*K - 1)*(2*r + s - 1)) - 66*k2**2*(3*b2*(r + s - 1) - 4*g2*(3*r + 2*s - 3))) + D1*(20*f**2*fd*k2**2*(50*r + 117*s - 71) + 13*f*(fd*k1**2*(4*C*(81*r + 129*s - 70) - 162*r - 273*s + 145) + 22*k2**2*(3*bd2*(r + s - 1) - 8*gd2*(2*r + s - 1))) + 286*fd*k2**2*(b2*(6*r + 6*s - 3) - 16*g2*(2*r + s - 1))) + 2*Dd*f*(10*f**2*k2**2*(50*r + 117*s - 71) + 26*f*k1**2*(C*(108*r + 172*s - 113) - 54*r - 91*s + 59) + 143*k2**2*(3*b2*(4*r + 4*s - 3) - 32*g2*(2*r + s - 1)))))/(45045*d*k3**4) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*st**2*(D1*bd1*f**2*(r*(4 - 8*C) + s) + 3*b1**2*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) + b1*f*(D1*(6*bd1*s + fd*(-16*C*r + 8*C + 8*r + 2*s - 5)) + 2*Dd*f*(C*(4 - 16*r) + 8*r + 2*s - 3)))/(315*d*k1) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*st**2*(11*b1**2*(D1*fd*(3*k1**2*(4*C*(r + s - 1) - 2*r - 3*s + 3) + k2**2*(f*(16*r + 36*s - 23) + 6*r + 3*s)) + 4*Dd*f*(3*k1**2*(C*(4*r + 4*s - 3) - 2*r - 3*s + 2) + k2**2*(f*(8*r + 18*s - 11) + 6*r + 3*s - 3))) + b1*f*(11*D1*bd1*(6*k1**2*(C*(4*r + 4*s - 2) - 2*r - 3*s + 1) + k2**2*(f*(16*r + 36*s - 21) + 12*r + 6*s - 9)) + D1*fd*(k1**2*(22 - 44*C)*(16*s - 5) + k2**2*(-88*K*r + 44*K + 9*f*(24*r + 22*s - 19) + 44*r + 22*s - 22)) + 4*Dd*f*(k1**2*(88 - 176*C)*(2*s - 1) + k2**2*(-44*K*r + 11*K + f*(72*r + 66*s - 51) + 22*r + 11*s - 11))) + f*(D1*bd1*f*(k1**2*(22 - 44*C)*(8*s - 3) + k2**2*(-44*K*r + f*(72*r + 66*s - 33) + 22*r + 11*s - 11)) + D1*(f*fd*k1**2*(-4*C*(51*r + 99*s - 50) + 102*r + 213*s - 105) - 44*f*k2**2*r*(bd2 - 2*gd2) - 44*fd*k2**2*(b2 - 2*g2)*(2*r - 1)) - 4*Dd*f*(f*k1**2*(C*(68*r + 132*s - 83) - 34*r - 71*s + 44) + k2**2*(11*b2 - 22*g2)*(4*r - 1))))/(3465*d*k1*k3**2) + 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**5*f*k2**5*st**2*(C - 1)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 5*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(693*d*k3**5) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**4*f*k2**4*st**2*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 5*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(693*d*k1*k3**3) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**4*f*k2**4*st**2*(13*D1*bd1*f*(75*f*k2**2 + k1**2*(836*C - 726))*(r + s - 1) + 13*b1*(D1*fd*(75*f*k2**2*(3*r + 3*s - 2) + k1**2*(836*C - 726)*(2*r + 2*s - 1)) + Dd*f*(75*f*k2**2 + k1**2*(836*C - 726))*(4*r + 4*s - 3)) + 5*f*(D1*fd*(105*f*k2**2*(4*r + 4*s - 3) + k1**2*(988*C - 858)*(3*r + 3*s - 2)) + Dd*f*(105*f*k2**2 + k1**2*(988*C - 858))*(4*r + 4*s - 3)))/(45045*d*k1*k3**5) + 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**3*f*k2**5*st**4*(C - 1)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 3*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(693*d*k3**5) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**3*k2**3*st**2*(99*b1**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + 11*b1*f*(9*D1*bd1*(C - 1)*(2*r + 2*s - 1) + 2*D1*fd*(C*(-7*r - 7*s + 2) + 11*r + 11*s - 4) - Dd*f*(7*C - 11)*(4*r + 4*s - 3)) + f**2*(-11*D1*bd1*(C*(7*r + 7*s - 10) - 11*r - 11*s + 14) + (70 - 50*C)*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))))/(3465*d*k3**3) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**3*k2**3*st**2*(13*D1*bd1*f*(r + s - 1)*(150*f**2*k2**2 + 11*f*(k1**2*(110*C - 82) + k2**2*(3*K - 20*b1 - 3)) - k2**2*(-198*K*b1 + 198*b1 + 198*g2)) - 143*b1**2*k2**2*(D1*fd*(10*f*(2*r + 2*s - 1) + (9 - 9*K)*(r + s)) + Dd*f*(-9*K + 10*f + 9)*(4*r + 4*s - 3)) + 13*b1*(D1*(150*f**2*fd*k2**2*(3*r + 3*s - 2) + 11*f*(fd*(k1**2*(110*C - 82) + k2**2*(3*K - 3))*(2*r + 2*s - 1) - 18*gd2*k2**2*(r + s - 1)) - 198*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(150*f**2*k2**2 + f*k1**2*(1210*C - 902) + 33*f*k2**2*(K - 1) - 198*g2*k2**2)) + 2*f*(D1*(700*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(3575*C - 2665)*(3*r + 3*s - 2) - 429*f*gd2*k2**2*(r + s - 1) - 429*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(700*f**2*k2**2 + f*k1**2*(3575*C - 2665) - 429*g2*k2**2)))/(45045*d*k3**5) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**2*f*k2**4*st**4*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 3*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(693*d*k1*k3**3) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**2*f*k2**4*st**4*(13*D1*bd1*f*(45*f*k2**2 + k1**2*(286*C - 231))*(r + s - 1) + 13*b1*(D1*fd*(45*f*k2**2*(3*r + 3*s - 2) + k1**2*(286*C - 231)*(2*r + 2*s - 1)) + Dd*f*(45*f*k2**2 + k1**2*(286*C - 231))*(4*r + 4*s - 3)) + 3*f*(D1*fd*(75*f*k2**2*(4*r + 4*s - 3) + k1**2*(338*C - 273)*(3*r + 3*s - 2)) + Dd*f*(75*f*k2**2 + k1**2*(338*C - 273))*(4*r + 4*s - 3)))/(45045*d*k1*k3**5) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**2*k1*k2**2*st**2*(13*D1*bd1*f*(r + s - 1)*(60*f**2*k2**2 + 11*f*(k1**2*(74*C - 47) - k2**2*(-9*K + 48*b1 + 6)) - k2**2*(198*b1*(2 - 3*K) + 594*g2)) - 429*b1**2*k2**2*(D1*fd*(8*f*(2*r + 2*s - 1) + (6 - 9*K)*(r + s)) + Dd*f*(-9*K + 8*f + 6)*(4*r + 4*s - 3)) + 13*b1*(D1*(60*f**2*fd*k2**2*(3*r + 3*s - 2) + 11*f*(fd*(k1**2*(74*C - 47) + k2**2*(9*K - 6))*(2*r + 2*s - 1) - 54*gd2*k2**2*(r + s - 1)) - 594*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(60*f**2*k2**2 + 11*f*(k1**2*(74*C - 47) + k2**2*(9*K - 6)) - 594*g2*k2**2)) + f*(D1*(1260*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(4810*C - 3055)*(3*r + 3*s - 2) - 2574*f*gd2*k2**2*(r + s - 1) - 2574*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(1260*f**2*k2**2 + f*k1**2*(4810*C - 3055) - 2574*g2*k2**2)))/(45045*d*k3**5) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**2*k2**2*st**2*(D1*bd1*f**2*(r + s) + 3*b1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*f*(3*D1*bd1*(2*r + 2*s - 1) + 2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)))/(105*d*k1*k3) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**2*k2**2*st**2*(33*b1**2*(D1*fd*(k1**2*(14*C - 11)*(r + s - 1) + k2**2*(f*(8*r + 8*s - 6) + 3*r + 3*s)) + Dd*f*(k1**2*(14*C - 11) + k2**2*(4*f + 3))*(4*r + 4*s - 3)) + b1*f*(33*D1*bd1*(k1**2*(14*C - 11)*(2*r + 2*s - 1) + 2*k2**2*(f*(4*r + 4*s - 3) + 3*r + 3*s - 3)) + D1*fd*(-11*k1**2*(C*(44*r + 44*s - 8) - 32*r - 32*s + 5) + 3*k2**2*(10*f*(6*r + 6*s - 5) + 22*r + 22*s - 11)) + Dd*f*(k1**2*(176 - 242*C) + k2**2*(60*f + 33))*(4*r + 4*s - 3)) + f**2*(D1*bd1*(-11*k1**2*(C*(22*r + 22*s - 36) - 16*r - 16*s + 27) + 3*k2**2*(10*f*(2*r + 2*s - 1) + 11*r + 11*s - 11)) + k1**2*(135 - 180*C)*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))))/(3465*d*k1*k3**3) - 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct*f*k2**3*st**4*(5*C - 4)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 3*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(3465*d*k3**3) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct*f*k2**3*st**4*(13*D1*bd1*f*(k1**2*(242*C - 154) + k2**2*(-110*b1 + 45*f))*(r + s - 1) - 715*b1**2*k2**2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 13*b1*(D1*fd*(45*f*k2**2*(3*r + 3*s - 2) + k1**2*(242*C - 154)*(2*r + 2*s - 1)) + Dd*f*(45*f*k2**2 + k1**2*(242*C - 154))*(4*r + 4*s - 3)) + 6*f*(D1*fd*(50*f*k2**2*(4*r + 4*s - 3) + k1**2*(143*C - 91)*(3*r + 3*s - 2)) + Dd*f*(50*f*k2**2 + k1**2*(143*C - 91))*(4*r + 4*s - 3)))/(45045*d*k3**5) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct*k1**2*k2*st**2*(13*D1*bd1*f*(r + s - 1)*(30*f**2*k2**2 + f*k1**2*(132 - 242*C) + 33*f*k2**2*(-3*K + 12*b1 + 1) + k2**2*(-594*K*b1 + 198*b1 + 594*g2)) + 1287*b1**2*k2**2*(D1*fd*(f*(4*r + 4*s - 2) - (3*K - 1)*(r + s)) + Dd*f*(-3*K + 2*f + 1)*(4*r + 4*s - 3)) + 13*b1*(D1*(30*f**2*fd*k2**2*(3*r + 3*s - 2) - 11*f*fd*(k1**2*(22*C - 12) + k2**2*(9*K - 3))*(2*r + 2*s - 1) + 594*f*gd2*k2**2*(r + s - 1) + 594*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(30*f**2*k2**2 - 11*f*(k1**2*(22*C - 12) + k2**2*(9*K - 3)) + 594*g2*k2**2)) - 2*f*(D1*(210*f**2*fd*k2**2*(4*r + 4*s - 3) + 13*f*(fd*k1**2*(55*C - 30)*(3*r + 3*s - 2) - 99*gd2*k2**2*(r + s - 1)) - 1287*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(210*f**2*k2**2 + f*k1**2*(715*C - 390) - 1287*g2*k2**2)))/(45045*d*k3**5) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct*k2*st**2*(3*C - 2)*(D1*bd1*f**2*(r + s) + 3*b1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*f*(3*D1*bd1*(2*r + 2*s - 1) + 2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)))/(315*d*k3) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct*k2*st**2*(99*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) - 33*b1**2*(D1*(-3*bd1*f*k2**2*(3*r + 3*s - 2) + fd*k1**2*(10*C - 6)*(r + s - 1) + fd*k2**2*(f*(8*r + 8*s - 5) + (3 - 3*K)*(r + s))) + Dd*f*(k1**2*(10*C - 6) + k2**2*(-3*K + 4*f + 3))*(4*r + 4*s - 3)) - b1*(33*D1*bd1*f*(k1**2*(10*C - 6)*(2*r + 2*s - 1) + k2**2*(f*(8*r + 8*s - 7) + (6 - 6*K)*(r + s - 1))) + D1*(45*f**2*fd*k2**2*(5*r + 5*s - 4) - 11*f*(2*fd*k1**2*(8*C*r + 8*C*s + C - 4*r - 4*s - 1) + 3*fd*k2**2*(K - 1)*(2*r + 2*s - 1) + k2**2*(9*bd2 - 18*gd2)*(r + s - 1)) - 99*fd*k2**2*(b2 - 2*g2)*(r + s)) + Dd*f*(4*r + 4*s - 3)*(75*f**2*k2**2 - 11*f*(k1**2*(8*C - 4) + k2**2*(3*K - 3)) - k2**2*(99*b2 - 198*g2))) + f*(D1*bd1*(-15*f**2*k2**2*(5*r + 5*s - 3) + 22*f*k1**2*(C*(4*r + 4*s - 9) - 2*r - 2*s + 5) + 33*f*k2**2*(K - 1)*(r + s - 1) + k2**2*(99*b2 - 198*g2)*(r + s - 1)) + D1*(f*fd*k1**2*(90*C - 50)*(3*r + 3*s - 2) + 33*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) + 33*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + Dd*f*(f*k1**2*(90*C - 50) + k2**2*(33*b2 - 66*g2))*(4*r + 4*s - 3)))/(3465*d*k3**3) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*f**2*k2**6*st**6*(13*D1*bd1*f*(r + s - 1) + 13*b1*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)) + 3*f*(D1*fd + Dd*f)*(4*r + 4*s - 3))/(3003*d*k1*k3**5) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*f*k1*k2**2*st**4*(13*D1*bd1*f*(k1**2*(66*C - 33) + k2**2*(-88*b1 + 6*f))*(r + s - 1) - 572*b1**2*k2**2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 39*b1*(D1*fd*(2*f*k2**2*(3*r + 3*s - 2) + k1**2*(22*C - 11)*(2*r + 2*s - 1)) + Dd*f*(2*f*k2**2 + k1**2*(22*C - 11))*(4*r + 4*s - 3)) + 9*f*(D1*fd*(10*f*k2**2*(4*r + 4*s - 3) + k1**2*(26*C - 13)*(3*r + 3*s - 2)) + Dd*f*(10*f*k2**2 + k1**2*(26*C - 13))*(4*r + 4*s - 3)))/(45045*d*k3**5) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*f*k2**2*st**4*(D1*bd1*f*(k1**2*(33 - 66*C)*(r + s - 1) + k2**2*(11*b1*(4*r + 4*s - 3) + 3*f*(2*r + 2*s - 1))) + 11*b1**2*k2**2*(D1*fd + 2*Dd*f)*(4*r + 4*s - 3) + 3*b1*(D1*fd*(f*k2**2*(6*r + 6*s - 5) + k1**2*(11 - 22*C)*(2*r + 2*s - 1)) + Dd*f*(2*f*k2**2 + k1**2*(11 - 22*C))*(4*r + 4*s - 3)) - f*k1**2*(18*C - 9)*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(3465*d*k1*k3**3) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*k1**3*st**2*(13*D1*bd1*f*(r + s - 1)*(15*f**2*k2**2 - 11*f*(k1**2*(2*C - 1) + k2**2*(3*K - 8*b1)) + k2**2*(-198*K*b1 + 198*g2)) + 143*b1**2*k2**2*(D1*fd*(-9*K*(r + s) + f*(8*r + 8*s - 4)) + Dd*f*(-9*K + 4*f)*(4*r + 4*s - 3)) + 13*b1*(D1*(15*f**2*fd*k2**2*(3*r + 3*s - 2) - 11*f*fd*(3*K*k2**2 + k1**2*(2*C - 1))*(2*r + 2*s - 1) + 198*f*gd2*k2**2*(r + s - 1) + 198*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(15*f**2*k2**2 - 11*f*(3*K*k2**2 + k1**2*(2*C - 1)) + 198*g2*k2**2)) + f*(D1*(-35*f**2*fd*k2**2*(4*r + 4*s - 3) - f*fd*k1**2*(130*C - 65)*(3*r + 3*s - 2) + 858*f*gd2*k2**2*(r + s - 1) + 858*fd*g2*k2**2*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(35*f**2*k2**2 + f*k1**2*(130*C - 65) - 858*g2*k2**2)))/(45045*d*k3**5) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*k1*st**2*(66*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) - 11*b1**2*(D1*(-6*bd1*f*k2**2*(3*r + 3*s - 2) + fd*k1**2*(6*C - 3)*(r + s - 1) + fd*k2**2*(-9*K*(r + s) + f*(4*r + 4*s - 1))) + Dd*f*(k1**2*(6*C - 3) + k2**2*(-9*K + 2*f))*(4*r + 4*s - 3)) + b1*(-11*D1*bd1*f*(k1**2*(6*C - 3)*(2*r + 2*s - 1) + k2**2*(-18*K*(r + s - 1) + f*(4*r + 4*s - 5))) + D1*(-15*f**2*fd*k2**2*(4*r + 4*s - 3) + 11*f*(3*K*fd*k2**2*(2*r + 2*s - 1) + fd*k1**2*(2*C - 1) + k2**2*(9*bd2 - 18*gd2)*(r + s - 1)) + 99*fd*k2**2*(b2 - 2*g2)*(r + s)) + Dd*f*k2**2*(4*r + 4*s - 3)*(33*K*f + 99*b2 - 20*f**2 - 198*g2)) + f*(D1*bd1*(33*K*f*k2**2*(r + s - 1) - 5*f**2*k2**2*(4*r + 4*s - 3) + f*k1**2*(11 - 22*C) + k2**2*(99*b2 - 198*g2)*(r + s - 1)) + D1*(f*fd*k1**2*(10*C - 5)*(3*r + 3*s - 2) + 33*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) + 33*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + Dd*f*(f*k1**2*(10*C - 5) + k2**2*(33*b2 - 66*g2))*(4*r + 4*s - 3)))/(3465*d*k3**3) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*st**2*(-D1*bd1*f**2*k1**2*(2*C - 1)*(r + s) + 3*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1**2*(D1*(3*bd1*f*k2**2*(3*r + 3*s - 2) - fd*(-2*f*k2**2 + k1**2*(6*C - 3))*(r + s - 1)) + Dd*f*(f*k2**2 + k1**2*(3 - 6*C))*(4*r + 4*s - 3)) + b1*f*(-D1*bd1*(-f*k2**2 + k1**2*(6*C - 3))*(2*r + 2*s - 1) - k1**2*(2*C - 1)*(2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))))/(315*d*k1*k3) + 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**4*f*k2**4*st**2*(C - 1)*(11*D1*bd1*f*(r - 1) + 11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 5*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(1155*d*k3**4) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**3*f*k2**3*st**2*(11*D1*bd1*f*(r - 1) + 11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 5*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(1155*d*k1*k3**2) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**3*f*k2**3*st**2*(13*D1*bd1*f*(r - 1)*(25*f*k2**2 + k1**2*(198*C - 165)) + 13*b1*(3*D1*fd*r*(25*f*k2**2 + k1**2*(132*C - 110)) + Dd*f*(4*r - 1)*(25*f*k2**2 + k1**2*(198*C - 165))) + 5*f*(D1*fd*(35*f*k2**2*(4*r - 1) + k1**2*(234*C - 195)*(3*r - 1)) + Dd*f*(4*r - 1)*(35*f*k2**2 + k1**2*(234*C - 195))))/(45045*d*k1*k3**4) + 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**2*f*k2**4*st**4*(C - 1)*(11*D1*bd1*f*(r - 1) + 11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 3*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(3465*d*k3**4) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**2*k2**2*st**2*(C - 1)*(33*b1**2*(D1*fd*r + Dd*f*(4*r - 1)) - 11*b1*f*(D1*bd1*(3 - 6*r) + D1*fd*(10*r + 1) + 5*Dd*f*(4*r - 1)) + f**2*(11*D1*bd1*(6 - 5*r) - 30*D1*fd*(3*r - 1) - 30*Dd*f*(4*r - 1)))/(3465*d*k3**2) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**2*k2**2*st**2*(13*D1*bd1*f*(30*f**2*k2**2*(2*r - 3) + 11*f*(k1**2*(38*C - 26)*(r - 1) + k2**2*(b1*(6 - 12*r) + r*(K - 1))) + 33*k2**2*(b1*(K - 1)*(2*r - 1) - 2*g2*(r - 1))) - 429*b1**2*k2**2*(D1*fd*r*(-K + 4*f + 1) + Dd*f*(4*r - 1)*(-K + 2*f + 1)) + 13*b1*(D1*(30*f**2*fd*k2**2*(6*r + 1) + 11*f*(fd*k1**2*r*(76*C - 52) + fd*k2**2*(K - 1)*(2*r - 1) - 6*gd2*k2**2*r) - 66*fd*g2*k2**2*r) + Dd*f*(4*r - 1)*(60*f**2*k2**2 + 11*f*(k1**2*(38*C - 26) + k2**2*(K - 1)) - 66*g2*k2**2)) + 2*f*(D1*(315*f**2*fd*k2**2*(4*r - 1) + f*fd*k1**2*(1235*C - 845)*(3*r - 1) - 143*f*gd2*k2**2*r + 143*fd*g2*k2**2*(1 - 2*r)) + Dd*f*(4*r - 1)*(315*f**2*k2**2 + f*k1**2*(1235*C - 845) - 143*g2*k2**2)))/(45045*d*k3**4) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct*f*k2**3*st**4*(11*D1*bd1*f*(r - 1) + 11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 3*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(3465*d*k1*k3**2) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct*f*k2**3*st**4*(13*D1*bd1*f*(r - 1)*(15*f*k2**2 + k1**2*(44*C - 33)) + 13*b1*(D1*fd*r*(45*f*k2**2 + k1**2*(88*C - 66)) + Dd*f*(4*r - 1)*(15*f*k2**2 + k1**2*(44*C - 33))) + 3*f*(D1*fd*(25*f*k2**2*(4*r - 1) + k1**2*(52*C - 39)*(3*r - 1)) + Dd*f*(4*r - 1)*(25*f*k2**2 + k1**2*(52*C - 39))))/(45045*d*k1*k3**4) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct*k1*k2*st**2*(13*D1*bd1*f*(45*f**2*k2**2 - 11*f*(k1**2*(16*C - 9)*(r - 1) - k2**2*(-2*K*r + 18*b1*r - 9*b1 + r)) - 33*k2**2*(b1*(2*K - 1)*(2*r - 1) - 4*g2*(r - 1))) + 429*b1**2*k2**2*(D1*fd*r*(-2*K + 6*f + 1) + Dd*f*(4*r - 1)*(-2*K + 3*f + 1)) - 13*b1*(D1*(45*f**2*fd*k2**2 + 11*f*(fd*k1**2*r*(32*C - 18) + fd*k2**2*(2*K - 1)*(2*r - 1) - 12*gd2*k2**2*r) - 132*fd*g2*k2**2*r) + 11*Dd*f*(4*r - 1)*(f*k1**2*(16*C - 9) + f*k2**2*(2*K - 1) - 12*g2*k2**2)) + f*(D1*(-315*f**2*fd*k2**2*(4*r - 1) - f*fd*k1**2*(1040*C - 585)*(3*r - 1) + 572*f*gd2*k2**2*r + 572*fd*g2*k2**2*(2*r - 1)) - Dd*f*(4*r - 1)*(315*f**2*k2**2 + f*k1**2*(1040*C - 585) - 572*g2*k2**2)))/(45045*d*k3**4) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct*k2*st**2*(D1*bd1*f**2*r + 3*b1**2*(D1*fd*r + Dd*f*(4*r - 1)) + b1*f*(3*D1*bd1*(2*r - 1) + D1*fd*(2*r - 1) + Dd*f*(4*r - 1)))/(315*d*k1) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct*k2*st**2*(33*b1**2*(D1*fd*r*(k1**2*(4*C - 3) + k2**2*(4*f + 1)) + Dd*f*(4*r - 1)*(k1**2*(4*C - 3) + k2**2*(2*f + 1))) + b1*f*(33*D1*bd1*(2*r - 1)*(k1**2*(4*C - 3) + k2**2*(2*f + 1)) + D1*fd*(-11*k1**2*(4*C*(4*r + 1) - 8*r - 3) + k2**2*(30*f*(3*r - 1) + 22*r - 11)) + Dd*f*(4*r - 1)*(k1**2*(44 - 88*C) + k2**2*(30*f + 11))) + f**2*(D1*bd1*(-11*k1**2*(8*C*r - 12*C - 4*r + 7) + k2**2*r*(30*f + 11)) + k1**2*(35 - 60*C)*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1))))/(3465*d*k1*k3**2) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*f*k2**2*st**4*(2*C - 1)*(11*D1*bd1*f*(r - 1) + 11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 3*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(3465*d*k3**2) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*f*k2**2*st**4*(13*D1*bd1*f*(k1**2*(22*C - 11)*(r - 1) + k2**2*(-22*b1*r + 11*b1 + 6*f*r - 9*f)) - 143*b1**2*k2**2*(2*D1*fd*r + Dd*f*(4*r - 1)) + 13*b1*(D1*fd*(3*f*k2**2*(6*r + 1) + k1**2*r*(44*C - 22)) + Dd*f*(4*r - 1)*(6*f*k2**2 + k1**2*(22*C - 11))) + 3*f*(D1*fd*(15*f*k2**2*(4*r - 1) + k1**2*(26*C - 13)*(3*r - 1)) + Dd*f*(4*r - 1)*(15*f*k2**2 + k1**2*(26*C - 13))))/(45045*d*k3**4) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*k1**2*st**2*(-13*D1*bd1*f*(5*f**2*k2**2*(2*r + 1) - 11*f*(k1**2*(2*C - 1)*(r - 1) + k2**2*(K*r - 6*b1*r + 3*b1)) + 33*k2**2*(K*b1*(1 - 2*r) + 2*g2*(r - 1))) - 429*b1**2*k2**2*(D1*fd*r*(-K + 2*f) + Dd*f*(-K + f)*(4*r - 1)) - 13*b1*(D1*(15*f**2*fd*k2**2*(2*r - 1) - 11*f*(K*fd*k2**2*(2*r - 1) + fd*k1**2*r*(4*C - 2) - 6*gd2*k2**2*r) + 66*fd*g2*k2**2*r) + Dd*f*(4*r - 1)*(10*f**2*k2**2 - 11*f*(K*k2**2 + k1**2*(2*C - 1)) + 66*g2*k2**2)) + f*(D1*(35*f**2*fd*k2**2*(4*r - 1) + f*fd*k1**2*(130*C - 65)*(3*r - 1) - 286*f*gd2*k2**2*r + 286*fd*g2*k2**2*(1 - 2*r)) + Dd*f*(4*r - 1)*(35*f**2*k2**2 + f*k1**2*(130*C - 65) - 286*g2*k2**2)))/(45045*d*k3**4) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*st**2*(2*C - 1)*(D1*bd1*f**2*r + 3*b1**2*(D1*fd*r + Dd*f*(4*r - 1)) + b1*f*(3*D1*bd1*(2*r - 1) + D1*fd*(2*r - 1) + Dd*f*(4*r - 1)))/(315*d) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*st**2*(33*b1**3*k2**2*(D1*fd*r + Dd*f*(4*r - 1)) - 11*b1**2*(D1*(3*bd1*f*k2**2*(1 - 3*r) + fd*(-3*K*k2**2*r + f*k2**2*(4*r + 1) + k1**2*r*(6*C - 3))) + Dd*f*(4*r - 1)*(k1**2*(6*C - 3) + k2**2*(-3*K + 2*f))) + b1*(-11*D1*bd1*f*(k1**2*(6*C - 3)*(2*r - 1) + k2**2*(-6*K*r + 3*K + 4*f*r - 3*f)) + D1*(15*f**2*fd*k2**2*(1 - 3*r) + 11*f*(K*fd*k2**2*(2*r - 1) + fd*k1**2*(2*C - 1) + k2**2*r*(3*bd2 - 6*gd2)) + 33*fd*k2**2*r*(b2 - 2*g2)) + Dd*f*k2**2*(4*r - 1)*(11*K*f + 33*b2 - 15*f**2 - 66*g2)) + f*(D1*bd1*(-15*f**2*k2**2*r + 11*f*(-2*C*k1**2 + K*k2**2*r + k1**2) + k2**2*(33*b2 - 66*g2)*(r - 1)) + D1*(f*fd*k1**2*(10*C - 5)*(3*r - 1) + 11*f*k2**2*r*(bd2 - 2*gd2) + 11*fd*k2**2*(b2 - 2*g2)*(2*r - 1)) + Dd*f*(4*r - 1)*(f*k1**2*(10*C - 5) + k2**2*(11*b2 - 22*g2))))/(3465*d*k3**2)
        perm23 = -4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**5*f*k1**2*k2**3*st**2*(780*C*D1*f*fd*r + 780*C*D1*f*fd*s - 520*C*D1*f*fd + 1040*C*Dd*f**2*r + 1040*C*Dd*f**2*s - 780*C*Dd*f**2 + 286*D1*bd1*f*(K - 1)*(r + s - 1) + 588*D1*f**2*fd*r + 588*D1*f**2*fd*s - 441*D1*f**2*fd - 780*D1*f*fd*r - 780*D1*f*fd*s + 520*D1*f*fd - 572*D1*f*gd2*r - 572*D1*f*gd2*s + 572*D1*f*gd2 - 1144*D1*fd*g2*r - 1144*D1*fd*g2*s + 572*D1*fd*g2 + 588*Dd*f**3*r + 588*Dd*f**3*s - 441*Dd*f**3 - 1040*Dd*f**2*r - 1040*Dd*f**2*s + 780*Dd*f**2 - 2288*Dd*f*g2*r - 2288*Dd*f*g2*s + 1716*Dd*f*g2 + 286*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))/(9009*d*k3**6) + 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**4*f*k1*k2**2*st**2*(-13*D1*bd1*f*(k1**2*(198*K - 198) - k2**2*(-220*K + 75*f + 110))*(r + s - 1) - 2*D1*(1050*f**2*fd*k1**2*(4*r + 4*s - 3) + 65*f*fd*(k1**2*(18*C - 18) + k2**2*(20*C - 15))*(3*r + 3*s - 2) - 286*f*gd2*(9*k1**2 + 10*k2**2)*(r + s - 1) - 286*fd*g2*(9*k1**2 + 10*k2**2)*(2*r + 2*s - 1)) - 2*Dd*f*(4*r + 4*s - 3)*(1050*f**2*k1**2 + 65*f*(k1**2*(18*C - 18) + k2**2*(20*C - 15)) - 286*g2*(9*k1**2 + 10*k2**2)) + 13*b1*(D1*fd*(k1**2*(198 - 198*K)*(2*r + 2*s - 1) + 5*k2**2*(15*f*(3*r + 3*s - 2) + (22 - 44*K)*(2*r + 2*s - 1))) + Dd*f*(k1**2*(198 - 198*K) + k2**2*(-220*K + 75*f + 110))*(4*r + 4*s - 3)))/(45045*d*k3**6) - 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**3*f*k1**2*k2**3*st**4*(234*C*D1*f*fd*r + 234*C*D1*f*fd*s - 156*C*D1*f*fd + 312*C*Dd*f**2*r + 312*C*Dd*f**2*s - 234*C*Dd*f**2 + 143*D1*bd1*f*(K - 1)*(r + s - 1) + 420*D1*f**2*fd*r + 420*D1*f**2*fd*s - 315*D1*f**2*fd - 234*D1*f*fd*r - 234*D1*f*fd*s + 156*D1*f*fd - 286*D1*f*gd2*r - 286*D1*f*gd2*s + 286*D1*f*gd2 - 572*D1*fd*g2*r - 572*D1*fd*g2*s + 286*D1*fd*g2 + 420*Dd*f**3*r + 420*Dd*f**3*s - 315*Dd*f**3 - 312*Dd*f**2*r - 312*Dd*f**2*s + 234*Dd*f**2 - 1144*Dd*f*g2*r - 1144*Dd*f*g2*s + 858*Dd*f*g2 + 143*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))/(9009*d*k3**6) + 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**3*k2*st**2*(13*D1*bd1*f*(r + s - 1)*(150*f**2*k1**2*k2**2 - 11*f*(10*K*k2**4 + k1**4*(9*K - 9) + k1**2*k2**2*(6*C + 36*K - 24)) + k1**2*k2**2*(-198*K*b1 + 198*b1 + 198*g2)) - 1287*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) + 13*b1*(D1*(150*f**2*fd*k1**2*k2**2*(3*r + 3*s - 2) - 11*f*fd*(2*r + 2*s - 1)*(10*K*k2**4 + k1**4*(9*K - 9) + k1**2*k2**2*(6*C + 36*K - 24)) + 198*f*gd2*k1**2*k2**2*(r + s - 1) + 198*fd*g2*k1**2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(150*f**2*k1**2*k2**2 - 11*f*(10*K*k2**4 + k1**4*(9*K - 9) + k1**2*k2**2*(6*C + 36*K - 24)) + 198*g2*k1**2*k2**2)) - 2*f*(D1*(1050*f**2*fd*k1**4*(4*r + 4*s - 3) + 65*f*fd*(3*r + 3*s - 2)*(k1**4*(9*C - 9) + k1**2*k2**2*(36*C - 27) + k2**4*(10*C - 5)) - 143*f*gd2*(9*k1**4 + 36*k1**2*k2**2 + 10*k2**4)*(r + s - 1) - 143*fd*g2*(9*k1**4 + 36*k1**2*k2**2 + 10*k2**4)*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(1050*f**2*k1**4 + 65*f*(k1**4*(9*C - 9) + k1**2*k2**2*(36*C - 27) + k2**4*(10*C - 5)) - 143*g2*(9*k1**4 + 36*k1**2*k2**2 + 10*k2**4))))/(45045*d*k3**6) + 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**2*f*k1*k2**2*st**4*(-702*C*D1*f*fd*k1**2*r - 702*C*D1*f*fd*k1**2*s + 468*C*D1*f*fd*k1**2 - 2340*C*D1*f*fd*k2**2*r - 2340*C*D1*f*fd*k2**2*s + 1560*C*D1*f*fd*k2**2 - 936*C*Dd*f**2*k1**2*r - 936*C*Dd*f**2*k1**2*s + 702*C*Dd*f**2*k1**2 - 3120*C*Dd*f**2*k2**2*r - 3120*C*Dd*f**2*k2**2*s + 2340*C*Dd*f**2*k2**2 - 13*D1*bd1*f*(k1**2*(33*K - 33) - k2**2*(-110*K + 45*f + 55))*(r + s - 1) - 3600*D1*f**2*fd*k1**2*r - 3600*D1*f**2*fd*k1**2*s + 2700*D1*f**2*fd*k1**2 + 702*D1*f*fd*k1**2*r + 702*D1*f*fd*k1**2*s - 468*D1*f*fd*k1**2 + 1755*D1*f*fd*k2**2*r + 1755*D1*f*fd*k2**2*s - 1170*D1*f*fd*k2**2 + 858*D1*f*gd2*k1**2*r + 858*D1*f*gd2*k1**2*s - 858*D1*f*gd2*k1**2 + 2860*D1*f*gd2*k2**2*r + 2860*D1*f*gd2*k2**2*s - 2860*D1*f*gd2*k2**2 + 1716*D1*fd*g2*k1**2*r + 1716*D1*fd*g2*k1**2*s - 858*D1*fd*g2*k1**2 + 5720*D1*fd*g2*k2**2*r + 5720*D1*fd*g2*k2**2*s - 2860*D1*fd*g2*k2**2 - 3600*Dd*f**3*k1**2*r - 3600*Dd*f**3*k1**2*s + 2700*Dd*f**3*k1**2 + 936*Dd*f**2*k1**2*r + 936*Dd*f**2*k1**2*s - 702*Dd*f**2*k1**2 + 2340*Dd*f**2*k2**2*r + 2340*Dd*f**2*k2**2*s - 1755*Dd*f**2*k2**2 + 3432*Dd*f*g2*k1**2*r + 3432*Dd*f*g2*k1**2*s - 2574*Dd*f*g2*k1**2 + 11440*Dd*f*g2*k2**2*r + 11440*Dd*f*g2*k2**2*s - 8580*Dd*f*g2*k2**2 + 13*b1*(D1*fd*(k1**2*(33 - 33*K)*(2*r + 2*s - 1) + 5*k2**2*(9*f*(3*r + 3*s - 2) + (11 - 22*K)*(2*r + 2*s - 1))) + Dd*f*(k1**2*(33 - 33*K) + k2**2*(-110*K + 45*f + 55))*(4*r + 4*s - 3)))/(45045*d*k3**6) + 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**2*k1*st**2*(13*D1*bd1*f*(r + s - 1)*(60*f**2*k1**2*k2**2 - 11*f*(k1**4*(K - 1) + k1**2*k2**2*(6*C + 18*K - 15) + k2**4*(12*C + 18*K - 12*b1 - 9)) - 198*k2**2*(b1*k1**2*(K - 1) + b1*k2**2*(2*K - 1) - g2*(k1**2 + 2*k2**2))) + 429*b1**2*k2**2*(D1*fd*(2*f*k2**2*(2*r + 2*s - 1) + (r + s)*(-3*k1**2*(K - 1) - 3*k2**2*(2*K - 1))) + Dd*f*(k1**2*(3 - 3*K) + k2**2*(-6*K + 2*f + 3))*(4*r + 4*s - 3)) + 13*b1*(D1*(60*f**2*fd*k1**2*k2**2*(3*r + 3*s - 2) - 11*f*fd*(2*r + 2*s - 1)*(k1**4*(K - 1) + k1**2*k2**2*(6*C + 18*K - 15) + k2**4*(12*C + 18*K - 9)) + 198*f*gd2*k2**2*(k1**2 + 2*k2**2)*(r + s - 1) + 198*fd*g2*k2**2*(k1**2 + 2*k2**2)*(r + s)) + Dd*f*(4*r + 4*s - 3)*(60*f**2*k1**2*k2**2 - 11*f*(k1**4*(K - 1) + k1**2*k2**2*(6*C + 18*K - 15) + k2**4*(12*C + 18*K - 9)) + 198*g2*k2**2*(k1**2 + 2*k2**2))) + f*(D1*(-840*f**2*fd*k1**4*(4*r + 4*s - 3) - 65*f*fd*(3*r + 3*s - 2)*(k1**4*(2*C - 2) + k1**2*k2**2*(36*C - 27) + k2**4*(36*C - 18)) + 286*f*gd2*(k1**4 + 18*k1**2*k2**2 + 18*k2**4)*(r + s - 1) + 286*fd*g2*(k1**4 + 18*k1**2*k2**2 + 18*k2**4)*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(840*f**2*k1**4 + 65*f*(k1**4*(2*C - 2) + k1**2*k2**2*(36*C - 27) + k2**4*(36*C - 18)) - 286*g2*(k1**4 + 18*k1**2*k2**2 + 18*k2**4))))/(45045*d*k3**6) - 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct*f**3*k1**2*k2**3*st**6*(D1*fd + Dd*f)*(4*r + 4*s - 3)/(143*d*k3**6) + 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct*f*k2*st**4*(D1*(-45*f**2*k1**2*(-13*bd1*k2**2*(r + s - 1) + 10*fd*k1**2*(4*r + 4*s - 3)) - 13*f*k2**2*(11*bd1*(5*K*k2**2 + k1**2*(6*K - 3))*(r + s - 1) - 3*fd*(k1**2*(-12*C + 15*b1 + 9) + k2**2*(5 - 10*C))*(3*r + 3*s - 2) - 22*gd2*(6*k1**2 + 5*k2**2)*(r + s - 1)) - 143*fd*k2**2*(2*r + 2*s - 1)*(5*K*b1*k2**2 + b1*k1**2*(6*K - 3) - 2*g2*(6*k1**2 + 5*k2**2))) - Dd*f*(4*r + 4*s - 3)*(450*f**2*k1**4 - 39*f*(k1**2*k2**2*(-12*C + 15*b1 + 9) + k2**4*(5 - 10*C)) + 143*k2**2*(5*K*b1*k2**2 + b1*k1**2*(6*K - 3) - 2*g2*(6*k1**2 + 5*k2**2))))/(45045*d*k3**6) - 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct*st**2*(D1*(1287*b1*fd*k2**4*(r + s)*(K*b1*k2**2 + b1*k1**2*(2*K - 1) - 2*g2*(2*k1**2 + k2**2)) + 15*f**3*k1**4*(26*bd1*k2**2*(r + s - 1) + 7*fd*k1**2*(4*r + 4*s - 3)) + 13*f**2*k2**2*(11*bd1*(r + s - 1)*(k1**4*(2*K - 1) - k1**2*k2**2*(-12*C - 9*K + 24*b1 + 9) + k2**4*(6*C - 3)) + k1**2*(5*fd*(k1**2*(4*C + 6*b1 - 3) + k2**2*(18*C - 9))*(3*r + 3*s - 2) - 22*gd2*(2*k1**2 + 9*k2**2)*(r + s - 1))) - 143*f*k2**2*(12*b1**2*fd*k1**2*k2**2*(2*r + 2*s - 1) - b1*fd*(2*r + 2*s - 1)*(k1**4*(2*K - 1) + k1**2*k2**2*(12*C + 9*K - 9) + k2**4*(6*C - 3)) - 18*b1*k2**2*(r + s - 1)*(K*bd1*k2**2 + bd1*k1**2*(2*K - 1) - gd2*(2*k1**2 + k2**2)) + 18*bd1*g2*k2**2*(2*k1**2 + k2**2)*(r + s - 1) + 2*fd*g2*k1**2*(2*k1**2 + 9*k2**2)*(2*r + 2*s - 1))) + Dd*f*(4*r + 4*s - 3)*(1287*b1*k2**4*(K*b1*k2**2 + b1*k1**2*(2*K - 1) - 2*g2*(2*k1**2 + k2**2)) + 105*f**3*k1**6 + 65*f**2*(k1**4*k2**2*(4*C + 6*b1 - 3) + k1**2*k2**4*(18*C - 9)) - 143*f*k2**2*(12*b1**2*k1**2*k2**2 + b1*(k1**4*(1 - 2*K) - k1**2*k2**2*(12*C + 9*K - 9) + k2**4*(3 - 6*C)) + 2*g2*k1**2*(2*k1**2 + 9*k2**2))))/(45045*d*k2*k3**6) - 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*f**2*k1*k2**2*st**6*(D1*(-13*b1*fd*k2**2*(3*r + 3*s - 2) - 13*bd1*f*k2**2*(r + s - 1) + 12*f*fd*k1**2*(4*r + 4*s - 3)) + Dd*f*(-13*b1*k2**2 + 12*f*k1**2)*(4*r + 4*s - 3))/(3003*d*k3**6) - 8*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*f*k1*st**4*(D1*(6*f**2*k1**2*(-13*bd1*k2**2*(r + s - 1) + 10*fd*k1**2*(4*r + 4*s - 3)) - 13*f*k2**2*(22*b1*bd1*k2**2*(r + s - 1) + 6*b1*fd*k1**2*(3*r + 3*s - 2) + 3*k2**2*(-fd*(6*C - 3)*(3*r + 3*s - 2) + (-11*K*bd1 + 22*gd2)*(r + s - 1))) - 143*fd*k2**4*(2*r + 2*s - 1)*(-3*K*b1 + b1**2 + 6*g2)) + Dd*f*(4*r + 4*s - 3)*(60*f**2*k1**4 - 39*f*(2*b1*k1**2*k2**2 + k2**4*(3 - 6*C)) - k2**4*(-429*K*b1 + 143*b1**2 + 858*g2)))/(45045*d*k3**6) - 4*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*k1*st**2*(D1*bd1*f*(r + s - 1)*(15*f**2*k1**4 + 11*f*k2**2*(K*k1**2 - 12*b1*k1**2 + k2**2*(6*C - 3)) - k2**4*(-198*K*b1 + 198*g2)) + 33*b1**2*k2**2*(D1*fd*(3*K*k2**2*(r + s) - 2*f*k1**2*(2*r + 2*s - 1)) - Dd*f*(-3*K*k2**2 + 2*f*k1**2)*(4*r + 4*s - 3)) + b1*(D1*(15*f**2*fd*k1**4*(3*r + 3*s - 2) + 11*f*k2**2*(fd*(K*k1**2 + k2**2*(6*C - 3))*(2*r + 2*s - 1) - 18*gd2*k2**2*(r + s - 1)) - 198*fd*g2*k2**4*(r + s)) + Dd*f*(4*r + 4*s - 3)*(15*f**2*k1**4 + 11*f*(K*k1**2*k2**2 + k2**4*(6*C - 3)) - 198*g2*k2**4)) + f*k1**2*k2**2*(D1*(f*fd*(10*C - 5)*(3*r + 3*s - 2) - 22*f*gd2*(r + s - 1) - 22*fd*g2*(2*r + 2*s - 1)) + Dd*f*(f*(10*C - 5) - 22*g2)*(4*r + 4*s - 3)))/(3465*d*k3**6) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*b1*f*k1*st**4*(2*D1*b1*fd*(r + s - 1) + D1*bd1*f*(2*r + 2*s - 1) + Dd*b1*f*(4*r + 4*s - 3))/(315*d*k3) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**5*f*k1**2*k2**3*st**2*(780*C*D1*f*fd*r + 780*C*D1*f*fd*s - 520*C*D1*f*fd + 1040*C*Dd*f**2*r + 1040*C*Dd*f**2*s - 780*C*Dd*f**2 + 286*D1*bd1*f*(K - 1)*(r + s - 1) + 588*D1*f**2*fd*r + 588*D1*f**2*fd*s - 441*D1*f**2*fd - 780*D1*f*fd*r - 780*D1*f*fd*s + 520*D1*f*fd - 572*D1*f*gd2*r - 572*D1*f*gd2*s + 572*D1*f*gd2 - 1144*D1*fd*g2*r - 1144*D1*fd*g2*s + 572*D1*fd*g2 + 588*Dd*f**3*r + 588*Dd*f**3*s - 441*Dd*f**3 - 1040*Dd*f**2*r - 1040*Dd*f**2*s + 780*Dd*f**2 - 2288*Dd*f*g2*r - 2288*Dd*f*g2*s + 1716*Dd*f*g2 + 286*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))/(9009*d*k3**5) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**4*f*k1*k2**2*st**2*(D1*bd1*f*(15*f + 22)*(r + s - 1) + b1*(D1*fd*(15*f*(3*r + 3*s - 2) + 44*r + 44*s - 22) + Dd*f*(15*f + 22)*(4*r + 4*s - 3)) + 10*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(693*d*k3**3) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**4*f*k1*k2**2*st**2*(-13*D1*bd1*f*(k1**2*(198*K - 198) - k2**2*(-220*K + 75*f + 110))*(r + s - 1) - 2*D1*(1050*f**2*fd*k1**2*(4*r + 4*s - 3) + 65*f*fd*(k1**2*(18*C - 18) + k2**2*(20*C - 15))*(3*r + 3*s - 2) - 286*f*gd2*(9*k1**2 + 10*k2**2)*(r + s - 1) - 286*fd*g2*(9*k1**2 + 10*k2**2)*(2*r + 2*s - 1)) - 2*Dd*f*(4*r + 4*s - 3)*(1050*f**2*k1**2 + 65*f*(k1**2*(18*C - 18) + k2**2*(20*C - 15)) - 286*g2*(9*k1**2 + 10*k2**2)) + 13*b1*(D1*fd*(k1**2*(198 - 198*K)*(2*r + 2*s - 1) + 5*k2**2*(15*f*(3*r + 3*s - 2) + (22 - 44*K)*(2*r + 2*s - 1))) + Dd*f*(k1**2*(198 - 198*K) + k2**2*(-220*K + 75*f + 110))*(4*r + 4*s - 3)))/(45045*d*k3**5) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**3*f*k1**2*k2**3*st**4*(234*C*D1*f*fd*r + 234*C*D1*f*fd*s - 156*C*D1*f*fd + 312*C*Dd*f**2*r + 312*C*Dd*f**2*s - 234*C*Dd*f**2 + 143*D1*bd1*f*(K - 1)*(r + s - 1) + 420*D1*f**2*fd*r + 420*D1*f**2*fd*s - 315*D1*f**2*fd - 234*D1*f*fd*r - 234*D1*f*fd*s + 156*D1*f*fd - 286*D1*f*gd2*r - 286*D1*f*gd2*s + 286*D1*f*gd2 - 572*D1*fd*g2*r - 572*D1*fd*g2*s + 286*D1*fd*g2 + 420*Dd*f**3*r + 420*Dd*f**3*s - 315*Dd*f**3 - 312*Dd*f**2*r - 312*Dd*f**2*s + 234*Dd*f**2 - 1144*Dd*f*g2*r - 1144*Dd*f*g2*s + 858*Dd*f*g2 + 143*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))/(9009*d*k3**5) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**3*k2*st**2*(99*b1**2*k1**2*(K - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*(99*D1*bd1*f*k1**2*(K - 1)*(2*r + 2*s - 1) + 2*D1*(75*f**2*fd*k1**2*(4*r + 4*s - 3) + 11*f*(-5*K*fd*k2**2*(2*r + 2*s - 1) + 3*fd*k1**2*(2*C*(r + s - 1) + 4*r + 4*s - 1) - 9*gd2*k1**2*(r + s - 1)) - 99*fd*g2*k1**2*(r + s - 1)) + 2*Dd*f*(4*r + 4*s - 3)*(-55*K*f*k2**2 + 100*f**2*k1**2 + f*k1**2*(33*C + 66) - 99*g2*k1**2)) + 2*f*(D1*bd1*(-55*K*f*k2**2*(r + s - 1) + 25*f**2*k1**2*(4*r + 4*s - 3) + 33*f*k1**2*(r*(C + 2) + s*(C + 2) - 3) - 99*g2*k1**2*(r + s)) + 5*D1*(f*fd*(9*k1**2 + k2**2*(5 - 10*C))*(3*r + 3*s - 2) - 11*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) - 11*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + 5*Dd*f*(4*r + 4*s - 3)*(9*f*k1**2 + f*k2**2*(5 - 10*C) - k2**2*(11*b2 - 22*g2))))/(3465*d*k3**3) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**3*k2*st**2*(13*D1*bd1*f*(r + s - 1)*(150*f**2*k1**2*k2**2 - 11*f*(10*K*k2**4 + k1**4*(9*K - 9) + k1**2*k2**2*(6*C + 36*K - 24)) + k1**2*k2**2*(-198*K*b1 + 198*b1 + 198*g2)) - 1287*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) + 13*b1*(D1*(150*f**2*fd*k1**2*k2**2*(3*r + 3*s - 2) - 11*f*fd*(2*r + 2*s - 1)*(10*K*k2**4 + k1**4*(9*K - 9) + k1**2*k2**2*(6*C + 36*K - 24)) + 198*f*gd2*k1**2*k2**2*(r + s - 1) + 198*fd*g2*k1**2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(150*f**2*k1**2*k2**2 - 11*f*(10*K*k2**4 + k1**4*(9*K - 9) + k1**2*k2**2*(6*C + 36*K - 24)) + 198*g2*k1**2*k2**2)) - 2*f*(D1*(1050*f**2*fd*k1**4*(4*r + 4*s - 3) + 65*f*fd*(3*r + 3*s - 2)*(k1**4*(9*C - 9) + k1**2*k2**2*(36*C - 27) + k2**4*(10*C - 5)) - 143*f*gd2*(9*k1**4 + 36*k1**2*k2**2 + 10*k2**4)*(r + s - 1) - 143*fd*g2*(9*k1**4 + 36*k1**2*k2**2 + 10*k2**4)*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(1050*f**2*k1**4 + 65*f*(k1**4*(9*C - 9) + k1**2*k2**2*(36*C - 27) + k2**4*(10*C - 5)) - 143*g2*(9*k1**4 + 36*k1**2*k2**2 + 10*k2**4))))/(45045*d*k3**5) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**2*f*k1*k2**2*st**4*(D1*bd1*f*(9*f + 11)*(r + s - 1) + b1*(D1*fd*(9*f*(3*r + 3*s - 2) + 22*r + 22*s - 11) + Dd*f*(9*f + 11)*(4*r + 4*s - 3)) + 3*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(693*d*k3**3) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**2*f*k1*k2**2*st**4*(-702*C*D1*f*fd*k1**2*r - 702*C*D1*f*fd*k1**2*s + 468*C*D1*f*fd*k1**2 - 2340*C*D1*f*fd*k2**2*r - 2340*C*D1*f*fd*k2**2*s + 1560*C*D1*f*fd*k2**2 - 936*C*Dd*f**2*k1**2*r - 936*C*Dd*f**2*k1**2*s + 702*C*Dd*f**2*k1**2 - 3120*C*Dd*f**2*k2**2*r - 3120*C*Dd*f**2*k2**2*s + 2340*C*Dd*f**2*k2**2 - 13*D1*bd1*f*(k1**2*(33*K - 33) - k2**2*(-110*K + 45*f + 55))*(r + s - 1) - 3600*D1*f**2*fd*k1**2*r - 3600*D1*f**2*fd*k1**2*s + 2700*D1*f**2*fd*k1**2 + 702*D1*f*fd*k1**2*r + 702*D1*f*fd*k1**2*s - 468*D1*f*fd*k1**2 + 1755*D1*f*fd*k2**2*r + 1755*D1*f*fd*k2**2*s - 1170*D1*f*fd*k2**2 + 858*D1*f*gd2*k1**2*r + 858*D1*f*gd2*k1**2*s - 858*D1*f*gd2*k1**2 + 2860*D1*f*gd2*k2**2*r + 2860*D1*f*gd2*k2**2*s - 2860*D1*f*gd2*k2**2 + 1716*D1*fd*g2*k1**2*r + 1716*D1*fd*g2*k1**2*s - 858*D1*fd*g2*k1**2 + 5720*D1*fd*g2*k2**2*r + 5720*D1*fd*g2*k2**2*s - 2860*D1*fd*g2*k2**2 - 3600*Dd*f**3*k1**2*r - 3600*Dd*f**3*k1**2*s + 2700*Dd*f**3*k1**2 + 936*Dd*f**2*k1**2*r + 936*Dd*f**2*k1**2*s - 702*Dd*f**2*k1**2 + 2340*Dd*f**2*k2**2*r + 2340*Dd*f**2*k2**2*s - 1755*Dd*f**2*k2**2 + 3432*Dd*f*g2*k1**2*r + 3432*Dd*f*g2*k1**2*s - 2574*Dd*f*g2*k1**2 + 11440*Dd*f*g2*k2**2*r + 11440*Dd*f*g2*k2**2*s - 8580*Dd*f*g2*k2**2 + 13*b1*(D1*fd*(k1**2*(33 - 33*K)*(2*r + 2*s - 1) + 5*k2**2*(9*f*(3*r + 3*s - 2) + (11 - 22*K)*(2*r + 2*s - 1))) + Dd*f*(k1**2*(33 - 33*K) + k2**2*(-110*K + 45*f + 55))*(4*r + 4*s - 3)))/(45045*d*k3**5) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**2*k1*st**2*(D1*bd1*f**2*(r + s) + b1**2*(D1*fd*(4*f + 3)*(r + s - 1) + Dd*f*(2*f + 3)*(4*r + 4*s - 3)) + b1*f*(D1*bd1*(2*f + 3)*(2*r + 2*s - 1) + 2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)))/(105*d*k3) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**2*k1*st**2*(33*b1**2*(D1*fd*(k1**2*(K - 1)*(r + s - 1) + k2**2*(6*K*(r + s - 1) + 2*f + 3)) + Dd*f*(6*K*k2**2 + k1**2*(K - 1))*(4*r + 4*s - 3)) - b1*(33*D1*bd1*f*(-k1**2*(K - 1)*(2*r + 2*s - 1) + k2**2*(-6*K*(2*r + 2*s - 1) + 2*f + 3)) + D1*(-90*f**2*fd*k1**2*(5*r + 5*s - 4) - 11*f*(fd*k1**2*(4*C*(r + s - 1) + 14*r + 14*s - 5) + 3*fd*k2**2*(8*C*(r + s - 1) - 6*K*(2*r + 2*s - 1) - 4*r - 4*s + 5) - 6*gd2*(k1**2 + 6*k2**2)*(r + s - 1)) + 66*fd*g2*(k1**2 + 6*k2**2)*(r + s - 1)) - Dd*f*(4*r + 4*s - 3)*(150*f**2*k1**2 + 11*f*(k1**2*(2*C + 7) + k2**2*(12*C - 18*K - 6)) - 66*g2*(k1**2 + 6*k2**2))) + f*(D1*bd1*(30*f**2*k1**2*(5*r + 5*s - 3) + 11*f*(k1**2*(2*C*s + r*(2*C + 7) + 7*s - 9) - 3*k2**2*(-4*C*r - 4*C*s + 6*K*(r + s - 1) + 2*r + 2*s + 1)) - 66*g2*(k1**2 + 6*k2**2)*(r + s)) + 9*D1*(5*f*fd*(k1**2 + k2**2*(2 - 4*C))*(3*r + 3*s - 2) - 22*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) - 22*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + 9*Dd*f*(5*f*(k1**2 + k2**2*(2 - 4*C)) + k2**2*(-22*b2 + 44*g2))*(4*r + 4*s - 3)))/(3465*d*k3**3) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**2*k1*st**2*(13*D1*bd1*f*(r + s - 1)*(60*f**2*k1**2*k2**2 - 11*f*(k1**4*(K - 1) + k1**2*k2**2*(6*C + 18*K - 15) + k2**4*(12*C + 18*K - 12*b1 - 9)) - 198*k2**2*(b1*k1**2*(K - 1) + b1*k2**2*(2*K - 1) - g2*(k1**2 + 2*k2**2))) + 429*b1**2*k2**2*(D1*fd*(2*f*k2**2*(2*r + 2*s - 1) + (r + s)*(-3*k1**2*(K - 1) - 3*k2**2*(2*K - 1))) + Dd*f*(k1**2*(3 - 3*K) + k2**2*(-6*K + 2*f + 3))*(4*r + 4*s - 3)) + 13*b1*(D1*(60*f**2*fd*k1**2*k2**2*(3*r + 3*s - 2) - 11*f*fd*(2*r + 2*s - 1)*(k1**4*(K - 1) + k1**2*k2**2*(6*C + 18*K - 15) + k2**4*(12*C + 18*K - 9)) + 198*f*gd2*k2**2*(k1**2 + 2*k2**2)*(r + s - 1) + 198*fd*g2*k2**2*(k1**2 + 2*k2**2)*(r + s)) + Dd*f*(4*r + 4*s - 3)*(60*f**2*k1**2*k2**2 - 11*f*(k1**4*(K - 1) + k1**2*k2**2*(6*C + 18*K - 15) + k2**4*(12*C + 18*K - 9)) + 198*g2*k2**2*(k1**2 + 2*k2**2))) + f*(D1*(-840*f**2*fd*k1**4*(4*r + 4*s - 3) - 65*f*fd*(3*r + 3*s - 2)*(k1**4*(2*C - 2) + k1**2*k2**2*(36*C - 27) + k2**4*(36*C - 18)) + 286*f*gd2*(k1**4 + 18*k1**2*k2**2 + 18*k2**4)*(r + s - 1) + 286*fd*g2*(k1**4 + 18*k1**2*k2**2 + 18*k2**4)*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(840*f**2*k1**4 + 65*f*(k1**4*(2*C - 2) + k1**2*k2**2*(36*C - 27) + k2**4*(36*C - 18)) - 286*g2*(k1**4 + 18*k1**2*k2**2 + 18*k2**4))))/(45045*d*k3**5) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct*f**3*k1**2*k2**3*st**6*(D1*fd + Dd*f)*(4*r + 4*s - 3)/(143*d*k3**5) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct*f*k2*st**4*(-90*C*D1*f*fd*k2**2*r - 90*C*D1*f*fd*k2**2*s + 60*C*D1*f*fd*k2**2 - 120*C*Dd*f**2*k2**2*r - 120*C*Dd*f**2*k2**2*s + 90*C*Dd*f**2*k2**2 + D1*b1*fd*(-55*K*k2**2*(2*r + 2*s - 1) + 3*k1**2*(15*f*(4*r + 4*s - 3) + 22*r + 22*s - 11)) - 110*D1*b2*fd*k2**2*r - 110*D1*b2*fd*k2**2*s + 55*D1*b2*fd*k2**2 + D1*bd1*f*(-55*K*k2**2*(r + s - 1) + k1**2*(15*f*(4*r + 4*s - 3) + 33*r + 33*s - 33)) - 55*D1*bd2*f*k2**2*r - 55*D1*bd2*f*k2**2*s + 55*D1*bd2*f*k2**2 + 27*D1*f*fd*k1**2*r + 27*D1*f*fd*k1**2*s - 18*D1*f*fd*k1**2 + 45*D1*f*fd*k2**2*r + 45*D1*f*fd*k2**2*s - 30*D1*f*fd*k2**2 + 110*D1*f*gd2*k2**2*r + 110*D1*f*gd2*k2**2*s - 110*D1*f*gd2*k2**2 + 220*D1*fd*g2*k2**2*r + 220*D1*fd*g2*k2**2*s - 110*D1*fd*g2*k2**2 + Dd*b1*f*(-55*K*k2**2 + k1**2*(60*f + 33))*(4*r + 4*s - 3) - 220*Dd*b2*f*k2**2*r - 220*Dd*b2*f*k2**2*s + 165*Dd*b2*f*k2**2 + 36*Dd*f**2*k1**2*r + 36*Dd*f**2*k1**2*s - 27*Dd*f**2*k1**2 + 60*Dd*f**2*k2**2*r + 60*Dd*f**2*k2**2*s - 45*Dd*f**2*k2**2 + 440*Dd*f*g2*k2**2*r + 440*Dd*f*g2*k2**2*s - 330*Dd*f*g2*k2**2)/(3465*d*k3**3) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct*f*k2*st**4*(D1*(-45*f**2*k1**2*(-13*bd1*k2**2*(r + s - 1) + 10*fd*k1**2*(4*r + 4*s - 3)) - 13*f*k2**2*(11*bd1*(5*K*k2**2 + k1**2*(6*K - 3))*(r + s - 1) - 3*fd*(k1**2*(-12*C + 15*b1 + 9) + k2**2*(5 - 10*C))*(3*r + 3*s - 2) - 22*gd2*(6*k1**2 + 5*k2**2)*(r + s - 1)) - 143*fd*k2**2*(2*r + 2*s - 1)*(5*K*b1*k2**2 + b1*k1**2*(6*K - 3) - 2*g2*(6*k1**2 + 5*k2**2))) - Dd*f*(4*r + 4*s - 3)*(450*f**2*k1**4 - 39*f*(k1**2*k2**2*(-12*C + 15*b1 + 9) + k2**4*(5 - 10*C)) + 143*k2**2*(5*K*b1*k2**2 + b1*k1**2*(6*K - 3) - 2*g2*(6*k1**2 + 5*k2**2))))/(45045*d*k3**5) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct*st**2*(D1*bd1*f*(r + s)*(f*(k1**2 + k2**2*(3 - 6*C)) + k2**2*(-9*b2 + 18*g2)) + 3*b1**2*(D1*fd*(-3*K*k2**2 + k1**2*(2*f + 1))*(r + s - 1) + Dd*f*(-3*K*k2**2 + k1**2*(f + 1))*(4*r + 4*s - 3)) + b1*(3*D1*bd1*f*(-3*K*k2**2 + k1**2*(f + 1))*(2*r + 2*s - 1) + D1*(r + s - 1)*(2*f*fd*(k1**2 + k2**2*(3 - 6*C)) - 9*f*k2**2*(bd2 - 2*gd2) - 9*fd*k2**2*(b2 - 2*g2)) + Dd*f*(f*(k1**2 + k2**2*(3 - 6*C)) + k2**2*(-9*b2 + 18*g2))*(4*r + 4*s - 3)))/(315*d*k2*k3) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct*st**2*(D1*bd1*f*(15*f**2*k1**4*(2*r + 2*s - 1) + 11*f*(k1**4*(r + s - 1) + k1**2*k2**2*(4*C*r + 4*C*s - 9*K*(r + s - 1) + 3*b1*(4*r + 4*s - 5) - 3) + k2**4*(6*C - 3)) + 33*k2**2*(3*K*b1*k2**2 + b1*k1**2*(K*(4*r + 4*s - 2) + 4*r + 4*s - 5) - 3*b2*k2**2*(r + s - 1) - 4*g2*k1**2*(r + s) - 6*g2*k2**2)) + 33*b1**2*k2**2*(D1*fd*(-3*K*k2**2 + k1**2*(2*K*(r + s - 1) + f*(4*r + 4*s - 1) + 2*r + 2*s + 1)) + 2*Dd*f*k1**2*(K + f + 1)*(4*r + 4*s - 3)) + b1*(D1*(15*f**2*fd*k1**4*(6*r + 6*s - 5) + 11*f*(fd*(k1**4*(2*r + 2*s - 1) + k1**2*k2**2*(8*C*(r + s - 1) - 9*K*(2*r + 2*s - 1) + 3) + k2**4*(3 - 6*C)) - 3*k2**2*(3*bd2*k2**2 + 4*gd2*k1**2)*(r + s - 1)) - 33*fd*k2**2*(3*b2*k2**2*(r + s) + 4*g2*k1**2*(r + s - 1) - 6*g2*k2**2)) + Dd*f*(4*r + 4*s - 3)*(-99*b2*k2**4 + 30*f**2*k1**4 + 11*f*(k1**4 + k1**2*k2**2*(4*C - 9*K)) - 132*g2*k1**2*k2**2)) + f*k1**2*(D1*(5*f*fd*(k1**2 + k2**2*(9 - 18*C))*(3*r + 3*s - 2) - 99*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) - 99*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + Dd*f*(5*f*(k1**2 + k2**2*(9 - 18*C)) + k2**2*(-99*b2 + 198*g2))*(4*r + 4*s - 3)))/(3465*d*k2*k3**3) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct*st**2*(D1*(1287*b1*fd*k2**4*(r + s)*(K*b1*k2**2 + b1*k1**2*(2*K - 1) - 2*g2*(2*k1**2 + k2**2)) + 15*f**3*k1**4*(26*bd1*k2**2*(r + s - 1) + 7*fd*k1**2*(4*r + 4*s - 3)) + 13*f**2*k2**2*(11*bd1*(r + s - 1)*(k1**4*(2*K - 1) - k1**2*k2**2*(-12*C - 9*K + 24*b1 + 9) + k2**4*(6*C - 3)) + k1**2*(5*fd*(k1**2*(4*C + 6*b1 - 3) + k2**2*(18*C - 9))*(3*r + 3*s - 2) - 22*gd2*(2*k1**2 + 9*k2**2)*(r + s - 1))) - 143*f*k2**2*(12*b1**2*fd*k1**2*k2**2*(2*r + 2*s - 1) - b1*fd*(2*r + 2*s - 1)*(k1**4*(2*K - 1) + k1**2*k2**2*(12*C + 9*K - 9) + k2**4*(6*C - 3)) - 18*b1*k2**2*(r + s - 1)*(K*bd1*k2**2 + bd1*k1**2*(2*K - 1) - gd2*(2*k1**2 + k2**2)) + 18*bd1*g2*k2**2*(2*k1**2 + k2**2)*(r + s - 1) + 2*fd*g2*k1**2*(2*k1**2 + 9*k2**2)*(2*r + 2*s - 1))) + Dd*f*(4*r + 4*s - 3)*(1287*b1*k2**4*(K*b1*k2**2 + b1*k1**2*(2*K - 1) - 2*g2*(2*k1**2 + k2**2)) + 105*f**3*k1**6 + 65*f**2*(k1**4*k2**2*(4*C + 6*b1 - 3) + k1**2*k2**4*(18*C - 9)) - 143*f*k2**2*(12*b1**2*k1**2*k2**2 + b1*(k1**4*(1 - 2*K) - k1**2*k2**2*(12*C + 9*K - 9) + k2**4*(3 - 6*C)) + 2*g2*k1**2*(2*k1**2 + 9*k2**2))))/(45045*d*k2*k3**5) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*f**2*k1*k2**2*st**6*(D1*b1*fd*(3*r + 3*s - 2) + D1*bd1*f*(r + s - 1) + Dd*b1*f*(4*r + 4*s - 3))/(231*d*k3**3) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*f**2*k1*k2**2*st**6*(D1*(-13*b1*fd*k2**2*(3*r + 3*s - 2) - 13*bd1*f*k2**2*(r + s - 1) + 12*f*fd*k1**2*(4*r + 4*s - 3)) + Dd*f*(-13*b1*k2**2 + 12*f*k1**2)*(4*r + 4*s - 3))/(3003*d*k3**5) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*f*k1*st**4*(11*D1*b1**2*fd*k2**2 + D1*bd1*f*(3*f*k1**2*(5*r + 5*s - 3) - 11*k2**2*(3*K*(r + s - 1) + b1)) + 3*b1*(D1*fd*(-11*K*k2**2*(2*r + 2*s - 1) + 3*f*k1**2*(5*r + 5*s - 4)) + Dd*f*(-11*K*k2**2 + 5*f*k1**2)*(4*r + 4*s - 3)) - 3*k2**2*(18*C*D1*f*fd*r + 18*C*D1*f*fd*s - 12*C*D1*f*fd + 24*C*Dd*f**2*r + 24*C*Dd*f**2*s - 18*C*Dd*f**2 + 11*D1*bd2*f*(r + s - 1) - 9*D1*f*fd*r - 9*D1*f*fd*s + 6*D1*f*fd - 22*D1*f*gd2*r - 22*D1*f*gd2*s + 22*D1*f*gd2 - 44*D1*fd*g2*r - 44*D1*fd*g2*s + 22*D1*fd*g2 - 12*Dd*f**2*r - 12*Dd*f**2*s + 9*Dd*f**2 - 88*Dd*f*g2*r - 88*Dd*f*g2*s + 66*Dd*f*g2 + 11*b2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))))/(3465*d*k3**3) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*f*k1*st**4*(D1*(6*f**2*k1**2*(-13*bd1*k2**2*(r + s - 1) + 10*fd*k1**2*(4*r + 4*s - 3)) - 13*f*k2**2*(22*b1*bd1*k2**2*(r + s - 1) + 6*b1*fd*k1**2*(3*r + 3*s - 2) + 3*k2**2*(-fd*(6*C - 3)*(3*r + 3*s - 2) + (-11*K*bd1 + 22*gd2)*(r + s - 1))) - 143*fd*k2**4*(2*r + 2*s - 1)*(-3*K*b1 + b1**2 + 6*g2)) + Dd*f*(4*r + 4*s - 3)*(60*f**2*k1**4 - 39*f*(2*b1*k1**2*k2**2 + k2**4*(3 - 6*C)) - k2**4*(-429*K*b1 + 143*b1**2 + 858*g2)))/(45045*d*k3**5) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*k1*st**2*(-D1*bd1*f*(r + s)*(3*b2 + f*(2*C - 1) - 6*g2) + 3*b1**3*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + 3*b1**2*(D1*bd1*f*(3*r + 3*s - 2) - K*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))) + b1*(-4*C*D1*f*fd*r - 4*C*D1*f*fd*s + 4*C*D1*f*fd - 8*C*Dd*f**2*r - 8*C*Dd*f**2*s + 6*C*Dd*f**2 - 6*D1*K*bd1*f*r - 6*D1*K*bd1*f*s + 3*D1*K*bd1*f - 3*D1*bd2*f*(r + s - 1) + 2*D1*f*fd*r + 2*D1*f*fd*s - 2*D1*f*fd + 6*D1*f*gd2*r + 6*D1*f*gd2*s - 6*D1*f*gd2 + 6*D1*fd*g2*r + 6*D1*fd*g2*s - 6*D1*fd*g2 + 4*Dd*f**2*r + 4*Dd*f**2*s - 3*Dd*f**2 + 24*Dd*f*g2*r + 24*Dd*f*g2*s - 18*Dd*f*g2 - 3*b2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))))/(315*d*k3) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*k1*st**2*(-33*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + 11*b1**2*(D1*(-3*K*fd*k2**2*(2*r + 2*s + 1) - 3*bd1*f*k2**2*(3*r + 3*s - 2) + f*fd*k1**2*(8*r + 8*s - 5)) + 2*Dd*f*(-3*K*k2**2 + 2*f*k1**2)*(4*r + 4*s - 3)) + 11*b1*(D1*bd1*f*(-3*K*k2**2*(4*r + 4*s - 5) + f*k1**2*(8*r + 8*s - 7)) + D1*(f*(-fd*(K*k1**2*(2*r + 2*s - 1) + k2**2*(2*C - 1)*(4*r + 4*s - 1)) + k2**2*(-9*bd2 + 12*gd2)*(r + s - 1)) + 3*fd*k2**2*(-3*b2*(r + s) + g2*(4*r + 4*s + 2))) - Dd*f*(4*r + 4*s - 3)*(K*f*k1**2 + f*k2**2*(4*C - 2) + k2**2*(9*b2 - 12*g2))) + f*(-44*C*D1*bd1*f*k2**2*r - 44*C*D1*bd1*f*k2**2*s + 66*C*D1*bd1*f*k2**2 - 30*C*D1*f*fd*k1**2*r - 30*C*D1*f*fd*k1**2*s + 20*C*D1*f*fd*k1**2 - 40*C*Dd*f**2*k1**2*r - 40*C*Dd*f**2*k1**2*s + 30*C*Dd*f**2*k1**2 - 11*D1*K*bd1*f*k1**2*r - 11*D1*K*bd1*f*k1**2*s + 11*D1*K*bd1*f*k1**2 + 22*D1*bd1*f*k2**2*r + 22*D1*bd1*f*k2**2*s - 33*D1*bd1*f*k2**2 + 132*D1*bd1*g2*k2**2*r + 132*D1*bd1*g2*k2**2*s - 198*D1*bd1*g2*k2**2 - 11*D1*bd2*f*k1**2*(r + s - 1) + 15*D1*f*fd*k1**2*r + 15*D1*f*fd*k1**2*s - 10*D1*f*fd*k1**2 + 22*D1*f*gd2*k1**2*r + 22*D1*f*gd2*k1**2*s - 22*D1*f*gd2*k1**2 + 44*D1*fd*g2*k1**2*r + 44*D1*fd*g2*k1**2*s - 22*D1*fd*g2*k1**2 + 20*Dd*f**2*k1**2*r + 20*Dd*f**2*k1**2*s - 15*Dd*f**2*k1**2 + 88*Dd*f*g2*k1**2*r + 88*Dd*f*g2*k1**2*s - 66*Dd*f*g2*k1**2 - 11*b2*(9*D1*bd1*k2**2*(r + s - 1) + D1*fd*k1**2*(2*r + 2*s - 1) + Dd*f*k1**2*(4*r + 4*s - 3))))/(3465*d*k3**3) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*k1*st**2*(D1*bd1*f*(r + s - 1)*(15*f**2*k1**4 + 11*f*k2**2*(K*k1**2 - 12*b1*k1**2 + k2**2*(6*C - 3)) - k2**4*(-198*K*b1 + 198*g2)) + 33*b1**2*k2**2*(D1*fd*(3*K*k2**2*(r + s) - 2*f*k1**2*(2*r + 2*s - 1)) - Dd*f*(-3*K*k2**2 + 2*f*k1**2)*(4*r + 4*s - 3)) + b1*(D1*(15*f**2*fd*k1**4*(3*r + 3*s - 2) + 11*f*k2**2*(fd*(K*k1**2 + k2**2*(6*C - 3))*(2*r + 2*s - 1) - 18*gd2*k2**2*(r + s - 1)) - 198*fd*g2*k2**4*(r + s)) + Dd*f*(4*r + 4*s - 3)*(15*f**2*k1**4 + 11*f*(K*k1**2*k2**2 + k2**4*(6*C - 3)) - 198*g2*k2**4)) + f*k1**2*k2**2*(D1*(f*fd*(10*C - 5)*(3*r + 3*s - 2) - 22*f*gd2*(r + s - 1) - 22*fd*g2*(2*r + 2*s - 1)) + Dd*f*(f*(10*C - 5) - 22*g2)*(4*r + 4*s - 3)))/(3465*d*k3**5) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*b1*f*k1*st**4*(-4*Pk2 + Pkd2*k2)*(D1*b1*fd*(2*s - 1) + 2*D1*bd1*f*s + Dd*b1*f*(4*s - 1))/(315*d*k2**2) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**5*f*k1**2*k2*st**2*(-4*Pk2 + Pkd2*k2)*(D1*(147*f**2*fd*(4*s - 1) + f*fd*(260*C - 260)*(3*s - 1) - 286*f*s*(-K*bd1 + bd1 + 2*gd2) + 572*fd*g2*(1 - 2*s)) + Dd*f*(4*s - 1)*(147*f**2 + f*(260*C - 260) - 572*g2) + 286*b1*(K - 1)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)))/(9009*d*k3**4) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**4*f*k1*st**2*(4*Pk2 - Pkd2*k2)*(b1*(D1*fd*(45*f*s - 15*f + 44*s - 22) + Dd*f*(15*f + 22)*(4*s - 1)) + f*(D1*bd1*s*(15*f + 22) + 10*D1*fd*(3*s - 1) + 10*Dd*f*(4*s - 1)))/(693*d*k3**2) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**4*f*k1*st**2*(D1*(75*f**2*(13*bd1*k2**2*(2*Pk2*(r - 1) + Pkd2*k2*s) + fd*(52*Pk2*k2**2*(1 - 2*r) + 21*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 26*f*(-11*bd1*(-Pk2*k1**2*s*(24*K - 24) + 10*Pk2*k2**2*(K*(r - 2*s - 1) - 2*r + 2) + Pkd2*k1**2*k2*s*(6*K - 6) + Pkd2*k2**3*s*(10*K - 5)) + fd*(k1**2*(60*C - 60)*(4*Pk2 - Pkd2*k2)*(3*s - 1) - k2**2*(2*Pk2*(2*C*(129*r - 150*s + 7) - 333*r + 150*s + 61) + Pkd2*k2*(100*C - 75)*(3*s - 1))) + 44*gd2*(-12*Pk2*k1**2*s + 5*Pk2*k2**2*(r - 2*s - 1) + 3*Pkd2*k1**2*k2*s + 5*Pkd2*k2**3*s)) + 1144*fd*g2*(-3*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 5*k2**2*(2*Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1)))) + Dd*f*(75*f**2*(52*Pk2*k2**2*(1 - 2*r) + 21*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 26*f*(k1**2*(60*C - 60)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(-8*Pk2*(2*C*(43*r - 50*s - 9) - 111*r + 50*s + 43) + Pkd2*k2*(75 - 100*C)*(4*s - 1))) + 1144*g2*(-3*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 5*k2**2*(4*Pk2*(r - 2*s) + Pkd2*k2*(4*s - 1)))) + 13*b1*(D1*fd*(k1**2*(132*K - 132)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 5*k2**2*(-88*K*Pk2*(r - 2*s + 1) - 44*K*Pkd2*k2*(2*s - 1) + 176*Pk2*r + 44*Pkd2*k2*s - 22*Pkd2*k2 + 15*f*(Pk2*(6*r - 2) + Pkd2*k2*(3*s - 1)))) + Dd*f*(k1**2*(132*K - 132)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 5*k2**2*(60*Pk2*f*(2*r - 1) - 176*Pk2*(-2*K*s + r*(K - 2) + 1) + Pkd2*k2*(4*s - 1)*(-44*K + 15*f + 22)))))/(45045*d*k3**4) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**3*f*k1**2*k2*st**4*(-4*Pk2 + Pkd2*k2)*(D1*(105*f**2*fd*(4*s - 1) + f*fd*(78*C - 78)*(3*s - 1) - 143*f*s*(-K*bd1 + bd1 + 2*gd2) + 286*fd*g2*(1 - 2*s)) + Dd*f*(4*s - 1)*(105*f**2 + f*(78*C - 78) - 286*g2) + 143*b1*(K - 1)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)))/(9009*d*k3**4) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**3*st**2*(99*b1**2*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(D1*fd*(s - 1) + Dd*f*(4*s - 1)) + 2*b1*(D1*(5*f**2*fd*(11*Pk2*k2**2*(1 - 3*r) + 15*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) + 11*f*(fd*k1**2*(3*C + 3)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 5*fd*k2**2*(-K*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 2*Pk2*r) + k1**2*s*(4*Pk2 - Pkd2*k2)*(9*K*bd1 - 9*bd1 - 9*gd2)) - 99*fd*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) + Dd*f*(5*f**2*(22*Pk2*k2**2*(1 - 2*r) + 15*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 11*f*(k1**2*(3*C + 3)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 5*k2**2*(K*Pkd2*k2*(4*s - 1) + Pk2*(K*(2 - 8*s) - 4*r + 2))) - 99*g2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 2*f*(D1*(55*b2*fd*k2**2*(-2*Pk2 + Pkd2*k2)*(2*s - 1) + 5*bd1*f**2*(60*Pk2*k1**2*s - 11*Pk2*k2**2*(r - 1) - 15*Pkd2*k1**2*k2*s) + 99*bd1*g2*k1**2*s*(-4*Pk2 + Pkd2*k2) + f*(11*bd1*(5*K*Pkd2*k2**3*s + Pk2*k1**2*s*(12*C + 12) - 5*Pk2*k2**2*(2*K*s + r - 1) - Pkd2*k1**2*k2*s*(3*C + 3)) + 30*fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + fd*k2**2*(Pk2*(-300*C*s + 100*C - 183*r + 150*s + 11) + Pkd2*k2*(50*C - 25)*(3*s - 1)) + k2**2*s*(-2*Pk2 + Pkd2*k2)*(55*bd2 - 110*gd2)) - 110*fd*g2*k2**2*(-2*Pk2 + Pkd2*k2)*(2*s - 1)) + Dd*f*(30*f*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + f*k2**2*(-4*Pk2*(25*C*(4*s - 1) + 61*r - 50*s - 18) + Pkd2*k2*(50*C - 25)*(4*s - 1)) + k2**2*(-2*Pk2 + Pkd2*k2)*(55*b2 - 110*g2)*(4*s - 1))))/(3465*d*k2*k3**2) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**3*st**2*(1287*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(2*Pk2*(r + 2*s - 1) - Pkd2*k2*s) + Dd*f*(8*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 4*s))) + 13*b1*(D1*(10*f**2*fd*k2**2*(11*Pk2*k2**2*(3*r - 1) + 15*k1**2*(4*Pk2*(2*r + s - 1) + Pkd2*k2*(2*s - 1))) + 11*f*(fd*(k1**4*(3*K - 3)*(4*Pk2 - Pkd2*k2)*(2*s - 1) - 12*k1**2*k2**2*(Pk2*(-2*C*(r + 2*s - 1) + r*(7*K - 11) - 6*s + 3) + Pkd2*k2*(K*(4*s - 2) + s*(C - 3) + 1)) - 10*k2**4*(K*Pk2*(8*r + 4*s - 2) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r)) - 9*k1**2*k2**2*(4*Pk2*gd2*(r + 2*s - 1) - 2*Pkd2*gd2*k2*s - bd1*(K - 1)*(4*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 2*s)))) + 198*fd*g2*k1**2*k2**2*(-2*Pk2*(r + 2*s - 1) + Pkd2*k2*s)) + Dd*f*(20*f**2*k2**2*(11*Pk2*k2**2*(2*r - 1) + 5*k1**2*(2*Pk2*(8*r + 4*s - 5) + Pkd2*k2*(4*s - 1))) + 11*f*(k1**4*(3*K - 3)*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 6*k1**2*k2**2*(-2*Pk2*(4*C*(r + 2*s - 1) - 14*K*r + 7*K + 22*r + 12*s - 14) + Pkd2*k2*(4*s - 1)*(C + 4*K - 3)) - 10*k2**4*(K*Pkd2*k2*(4*s - 1) + 2*Pk2*(K*(8*r + 4*s - 5) - 2*r + 1))) + 198*g2*k1**2*k2**2*(-8*Pk2*(r + 2*s - 1) + Pkd2*k2*(4*s - 1)))) + f*(D1*(-2574*bd1*g2*k1**2*k2**2*(2*Pk2*(r + 2*s - 1) - Pkd2*k2*(s - 1)) + 10*f**2*(143*Pk2*bd1*k2**4*(r - 1) - 780*Pk2*fd*k1**2*k2**2*(3*r + 2*s - 2) + 65*bd1*k1**2*k2**2*(4*Pk2*(2*r + s - 2) + Pkd2*k2*(2*s + 1)) + 105*fd*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 13*f*(-220*Pk2*bd2*k2**4*(r + s - 1) - 11*bd1*(k1**4*s*(3 - 3*K)*(4*Pk2 - Pkd2*k2) + 6*k1**2*k2**2*(-Pk2*(2*C*(r + 2*s - 1) - 7*K*r + 7*K + 11*r + 6*s - 11) + Pkd2*k2*(C*(s - 1) + 4*K*s - 3*s + 1)) + 10*k2**4*(2*K*Pk2*(2*r + s - 2) + K*Pkd2*k2*s - Pk2*r + Pk2)) + 2*fd*(k1**4*(15*C - 15)*(4*Pk2 - Pkd2*k2)*(3*s - 1) - 6*k1**2*k2**2*(Pk2*(C*(129*r - 24*s - 35) - 174*r - 51*s + 75) + Pkd2*k2*(20*C - 15)*(3*s - 1)) + k2**4*(Pk2*(-12*C*(86*r + 25*s - 37) + 699*r + 150*s - 283) + Pkd2*k2*(25 - 50*C)*(3*s - 1))) + 22*gd2*(3*k1**4*s*(-4*Pk2 + Pkd2*k2) + 6*k1**2*k2**2*(7*Pk2*(r - 1) + 4*Pkd2*k2*s) + 10*k2**4*(2*Pk2*(2*r + s - 2) + Pkd2*k2*s))) - 286*fd*(10*Pk2*b2*k2**4*(2*r + 2*s - 1) + g2*(3*k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1) - 12*k1**2*k2**2*(7*Pk2*r + 2*Pkd2*k2*(2*s - 1)) - 10*k2**4*(Pk2*(8*r + 4*s - 2) + Pkd2*k2*(2*s - 1))))) + 2*Dd*f*(-1430*Pk2*b2*k2**4*(4*r + 4*s - 3) + 75*f**2*k1**2*(-52*Pk2*k2**2*(3*r + 2*s - 2) + 7*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 13*f*(k1**4*(15*C - 15)*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 6*k1**2*k2**2*(Pk2*(2*C*(86*r - 16*s - 39) - 232*r - 68*s + 133) + Pkd2*k2*(20*C - 15)*(4*s - 1)) + k2**4*(-4*Pk2*(C*(344*r + 100*s - 197) - 233*r - 50*s + 129) + Pkd2*k2*(25 - 50*C)*(4*s - 1))) - 143*g2*(3*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 12*k1**2*k2**2*(7*Pk2*(2*r - 1) + 2*Pkd2*k2*(4*s - 1)) - 10*k2**4*(2*Pk2*(8*r + 4*s - 5) + Pkd2*k2*(4*s - 1))))))/(45045*d*k2*k3**4) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**2*f*k1*st**4*(4*Pk2 - Pkd2*k2)*(b1*(D1*fd*(27*f*s - 9*f + 22*s - 11) + Dd*f*(9*f + 11)*(4*s - 1)) + f*(D1*bd1*s*(9*f + 11) + D1*fd*(9*s - 3) + 3*Dd*f*(4*s - 1)))/(693*d*k3**2) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**2*f*k1*st**4*(D1*(45*f**2*(13*bd1*k2**2*(2*Pk2*(r - 1) + Pkd2*k2*s) + fd*(52*Pk2*k2**2*(1 - 2*r) + 15*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 13*f*(-11*bd1*(-Pk2*k1**2*s*(8*K - 8) + 10*Pk2*k2**2*(K*(r - 2*s - 1) - 2*r + 2) + Pkd2*k1**2*k2*s*(2*K - 2) + Pkd2*k2**3*s*(10*K - 5)) + fd*(k1**2*(12*C - 12)*(4*Pk2 - Pkd2*k2)*(3*s - 1) - k2**2*(2*Pk2*(2*C*(69*r - 90*s + 7) - 183*r + 90*s + 31) + Pkd2*k2*(60*C - 45)*(3*s - 1))) + 44*gd2*(-4*Pk2*k1**2*s + 5*Pk2*k2**2*(r - 2*s - 1) + Pkd2*k1**2*k2*s + 5*Pkd2*k2**3*s)) + 572*fd*g2*(-k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 5*k2**2*(2*Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1)))) + Dd*f*(45*f**2*(52*Pk2*k2**2*(1 - 2*r) + 15*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 13*f*(k1**2*(12*C - 12)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(-8*Pk2*(C*(46*r - 60*s - 8) - 61*r + 30*s + 23) + Pkd2*k2*(45 - 60*C)*(4*s - 1))) - 572*g2*(k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 5*k2**2*(-4*Pk2*r + 8*Pk2*s - 4*Pkd2*k2*s + Pkd2*k2))) + 13*b1*(D1*fd*(k1**2*(22*K - 22)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 5*k2**2*(-44*K*Pk2*(r - 2*s + 1) - 22*K*Pkd2*k2*(2*s - 1) + 88*Pk2*r + 22*Pkd2*k2*s - 11*Pkd2*k2 + 9*f*(Pk2*(6*r - 2) + Pkd2*k2*(3*s - 1)))) + Dd*f*(k1**2*(22*K - 22)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 5*k2**2*(36*Pk2*f*(2*r - 1) - 88*Pk2*(-2*K*s + r*(K - 2) + 1) + Pkd2*k2*(4*s - 1)*(-22*K + 9*f + 11)))))/(45045*d*k3**4) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**2*k1*st**2*(-4*Pk2 + Pkd2*k2)*(D1*bd1*f**2*s + b1**2*(D1*fd*(4*f*s - 2*f + 3*s - 3) + Dd*f*(2*f + 3)*(4*s - 1)) + b1*f*(2*D1*bd1*s*(2*f + 3) + D1*fd*(2*s - 1) + Dd*f*(4*s - 1)))/(105*d*k2**2) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**2*st**2*(33*b1**2*k1**2*k2**2*(D1*fd*(-2*Pk2*(-3*K*(r - 2*s + 2) + 2*f + 3*r + 3) + Pkd2*k2*(6*K*(s - 1) + 2*f + 3)) + 6*Dd*f*(K*Pkd2*k2*(4*s - 1) + Pk2*(-8*K*s + r*(4*K - 4) + 2))) + b1*k1**2*(D1*(-6*f**2*(-11*Pk2*fd*k2**2*(18*r + 15*s - 13) + 11*bd1*k2**2*(-2*Pk2 + Pkd2*k2) + 10*fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) - 11*f*(fd*(3*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) - k2**2*(4*Pk2*(10*C*r - 12*C*s + C + 12*K*s - 6*K + 5*r + 27*s - 10) + 3*Pkd2*k2*(8*C*s - 4*C - 8*K*s + 4*K - 4*s + 3))) - 9*k2**2*(Pk2*bd1*(K*(4*r - 8*s - 2) - 4*r + 4) + Pkd2*bd1*k2*(4*K*s - 1) + 4*gd2*(-Pk2*r + 2*Pk2*s + Pk2 - Pkd2*k2*s))) - 396*fd*g2*k2**2*(Pk2*(r - 2*s + 2) + Pkd2*k2*(s - 1))) + Dd*f*(-6*f**2*(-11*Pk2*k2**2*(24*r + 20*s - 17) + 10*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 11*f*(3*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 2*k2**2*(Pk2*(C*(-40*r + 48*s + 8) - 48*K*s + 12*K - 20*r - 108*s + 37) + Pkd2*k2*(4*s - 1)*(-6*C + 6*K + 3))) - 396*g2*k2**2*(4*Pk2*(r - 2*s) + Pkd2*k2*(4*s - 1)))) + f*(D1*(6*bd1*f**2*k1**2*(-40*Pk2*k1**2*s + 11*Pk2*k2**2*(6*r + 5*s - 4) + 10*Pkd2*k1**2*k2*s) + f*(-3*fd*(Pk2*k2**4*(48*C - 24)*(3*r - 1) + 5*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1) + 2*k1**2*k2**2*(Pk2*(-120*C*s + 40*C - 99*r - 21*s + 40) + Pkd2*k2*(20*C - 10)*(3*s - 1))) + 11*k1**2*(bd1*(-12*Pk2*k1**2*s + 2*Pk2*k2**2*(r*(10*C + 5) - 3*s*(4*C - 4*K - 9) - 12) + 3*Pkd2*k1**2*k2*s + 3*Pkd2*k2**3*(s*(4*C - 4*K - 2) - 1)) + k2**2*s*(-2*Pk2 + Pkd2*k2)*(-12*bd2 + 24*gd2))) - 132*k1**2*k2**2*(-b2*fd*(2*Pk2 - Pkd2*k2)*(2*s - 1) + 3*bd1*g2*(Pk2*(r - 2*s) + Pkd2*k2*s) + 2*fd*g2*(2*Pk2 - Pkd2*k2)*(2*s - 1))) - 3*Dd*f*(f*(Pk2*k2**4*(96*C - 48)*(2*r - 1) + 5*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 2*k1**2*k2**2*(Pk2*(-160*C*s + 40*C - 132*r - 28*s + 73) + Pkd2*k2*(20*C - 10)*(4*s - 1))) + k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(44*b2 - 88*g2)*(4*s - 1))))/(3465*d*k1*k2**2*k3**2) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**2*st**2*(D1*(-429*b1*fd*k1**2*k2**2*(2*b1*k1**2*(K - 1)*(-Pk2*(r + 3*s - 1) + Pkd2*k2*s) - 3*b1*k2**2*(2*Pk2*(K*(r + 2*s - 2) + r + 1) + Pkd2*k2*s*(1 - 2*K)) + 4*g2*k1**2*(Pk2*(r + 3*s - 1) - Pkd2*k2*s) + 12*g2*k2**2*(Pk2*(r + 2*s - 2) - Pkd2*k2*s)) + 6*f**3*k1**2*(143*Pk2*bd1*k2**4*(4*r + 5*s - 6) - 195*Pk2*fd*k1**2*k2**2*(16*r + 20*s - 13) + 65*bd1*k1**2*k2**2*(2*Pk2*(5*r + 5*s - 6) + 3*Pkd2*k2) + 35*fd*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 13*f**2*k2**2*(-11*bd1*(k1**4*(2*Pk2*(2*C*(r + 3*s - 2) + K*(-6*r - 9*s + 6) + 13*r + 15*s - 11) + Pkd2*k2*(-4*C*(s - 1) + s*(7 - 6*K) - 4)) + k1**2*k2**2*(Pk2*(4*C*r + 24*C*s - 24*K*(4*r + 5*s - 4) - 12*b1 + 38*r + 30*s - 36) - 3*Pkd2*k2*(4*C*(s - 1) + 4*K*s + b1*(2 - 4*s) - 3*s + 3))) + fd*(Pk2*k2**4*(144*C - 72)*(3*r - 1) + k1**4*(Pk2*(4*C*(96*r + 99*s - 65) - 180*b1*(5*r + 5*s - 3) - 654*r - 756*s + 470) + 15*Pkd2*k2*(6*b1 + (4*C - 3)*(3*s - 1))) + 6*k1**2*k2**2*(Pk2*(72*C*(8*r + 7*s - 5) - 11*b1*(12*r + 15*s - 7) - 387*r - 333*s + 240) + Pkd2*k2*(20*C - 10)*(3*s - 1))) - 132*k1**2*(-3*Pk2*bd2*k2**2*(r + s - 1) + gd2*k1**2*(Pk2*(2*r + 3*s - 2) + Pkd2*k2*s) + 2*gd2*k2**2*(2*Pk2*(4*r + 5*s - 4) + Pkd2*k2*s))) + 143*f*k1**2*k2**2*(12*b1**2*fd*k2**2*(Pk2 + Pkd2*k2*s) + b1*(6*bd1*k1**2*(K - 1)*(Pk2*(2*r + 6*s - 3) + Pkd2*k2*(1 - 2*s)) - 9*bd1*k2**2*(Pk2*(K*(-4*r - 8*s + 2) - 4*r + 4) + Pkd2*k2*(2*K - 1)*(2*s - 1)) + fd*k1**2*(2*Pk2*(4*C*(r + 3*s - 1) - 3*K*(4*r + 6*s - 3) + 26*r + 30*s - 17) + Pkd2*k2*(K*(6 - 12*s) + s*(14 - 8*C) - 3)) + 2*fd*k2**2*(2*Pk2*(C*(2*r + 12*s - 7) - 6*K*(8*r + 10*s - 5) + 19*r + 15*s - 8) + 3*Pkd2*k2*(K*(2 - 4*s) + s*(3 - 4*C))) + 12*gd2*k1**2*(-Pk2*(r + 3*s - 1) + Pkd2*k2*s) + 36*gd2*k2**2*(-Pk2*(r + 2*s - 1) + Pkd2*k2*s)) - 12*bd1*g2*(k1**2*(Pk2*(r + 3*s - 2) - Pkd2*k2*(s - 1)) + 3*k2**2*(Pk2*(r + 2*s) + k2*(-Pkd2*s + Pkd2))) - 12*fd*(3*Pk2*b2*k2**2*(2*r + 2*s - 1) + g2*k1**2*(Pk2*(-4*r - 6*s + 3) + Pkd2*k2*(1 - 2*s)) + 2*g2*k2**2*(-2*Pk2*(8*r + 10*s - 5) + Pkd2*k2*(1 - 2*s))))) + Dd*f*(-429*b1*k1**2*k2**2*(-2*b1*k1**2*(K - 1)*(Pk2*(4*r + 12*s - 5) + Pkd2*k2*(1 - 4*s)) + 3*b1*k2**2*(-4*Pk2*(2*K*(r + 2*s - 1) + 2*r - 1) + Pkd2*k2*(2*K - 1)*(4*s - 1)) + 4*g2*k1**2*(Pk2*(4*r + 12*s - 5) + Pkd2*k2*(1 - 4*s)) + 12*g2*k2**2*(4*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 4*s))) + 30*f**3*k1**4*(-39*Pk2*k2**2*(16*r + 20*s - 13) + 7*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 13*f**2*k2**2*(Pk2*k2**4*(288*C - 144)*(2*r - 1) + k1**4*(-4*Pk2*(C*(-128*r - 132*s + 97) + 75*b1*(4*r + 4*s - 3) + 218*r + 252*s - 172) + Pkd2*k2*(60*C - 45)*(4*s - 1)) + 6*k1**2*k2**2*(Pk2*(24*C*(32*r + 28*s - 23) - 11*b1*(16*r + 20*s - 13) - 516*r - 444*s + 369) + Pkd2*k2*(20*C - 10)*(4*s - 1))) + 143*f*k1**2*k2**2*(-36*Pk2*b2*k2**2*(4*r + 4*s - 3) + 6*Pkd2*b1**2*k2**3*(4*s - 1) + b1*k1**2*(2*Pk2*(2*C*(4*r + 12*s - 5) - 3*K*(8*r + 12*s - 7) + 52*r + 60*s - 41) - Pkd2*k2*(4*s - 1)*(4*C + 6*K - 7)) + b1*k2**2*(2*Pk2*(8*C*(r + 6*s - 2) - 12*K*(16*r + 20*s - 13) + 76*r + 60*s - 53) + Pkd2*k2*(4*s - 1)*(-12*C - 12*K + 9)) + 12*g2*k1**2*(Pk2*(8*r + 12*s - 7) + Pkd2*k2*(4*s - 1)) + 24*g2*k2**2*(Pk2*(32*r + 40*s - 26) + Pkd2*k2*(4*s - 1)))))/(45045*d*k1*k2**2*k3**4) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*f**3*k1**2*k2*st**6*(-4*Pk2 + Pkd2*k2)*(4*s - 1)*(D1*fd + Dd*f)/(143*d*k3**4) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*f*st**4*(D1*(-5*bd1*f**2*(-36*Pk2*k1**2*s + 11*Pk2*k2**2*(r - 1) + 9*Pkd2*k1**2*k2*s) + f*(11*bd1*(5*K*Pkd2*k2**3*s + 8*Pk2*k1**2*s - 5*Pk2*k2**2*(2*K*s + r - 1) - 2*Pkd2*k1**2*k2*s) + 6*fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + fd*k2**2*(Pk2*(-180*C*s + 60*C - 93*r + 90*s + 1) + Pkd2*k2*(30*C - 15)*(3*s - 1)) + k2**2*s*(-2*Pk2 + Pkd2*k2)*(55*bd2 - 110*gd2)) + 55*fd*k2**2*(-2*Pk2 + Pkd2*k2)*(b2 - 2*g2)*(2*s - 1)) + Dd*f*(6*f*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + f*k2**2*(-4*Pk2*(15*C*(4*s - 1) + 31*r - 30*s - 8) + Pkd2*k2*(30*C - 15)*(4*s - 1)) + k2**2*(-2*Pk2 + Pkd2*k2)*(55*b2 - 110*g2)*(4*s - 1)) + b1*(D1*fd*(k1**2*(4*Pk2 - Pkd2*k2)*(45*f*(3*s - 1) + 44*s - 22) + 55*k2**2*(-K*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 2*Pk2*r + f*(-3*Pk2*r + Pk2))) + Dd*f*(k1**2*(4*Pk2 - Pkd2*k2)*(45*f + 22)*(4*s - 1) + 55*k2**2*(K*Pkd2*k2*(4*s - 1) + 2*Pk2*(-4*K*s + K - 2*f*r + f - 2*r + 1)))))/(3465*d*k2*k3**2) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*f*st**4*(D1*(5*f**2*(143*Pk2*bd1*k2**4*(r - 1) - 468*Pk2*fd*k1**2*k2**2*(3*r + 2*s - 2) + 39*bd1*k1**2*k2**2*(4*Pk2*(2*r + s - 2) + Pkd2*k2*(2*s + 1)) + 45*fd*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 13*f*k2**2*(110*Pk2*bd2*k2**2*(r + s - 1) + 11*bd1*(2*k1**2*(Pk2*(K*(2*r - 3*s - 2) - 5*r - 2*s + 5) + Pkd2*k2*s*(2*K - 1)) + 5*k2**2*(2*K*Pk2*(2*r + s - 2) + K*Pkd2*k2*s - Pk2*r + Pk2)) - 3*fd*k1**2*(2*Pk2*(-2*C*(6*r - 9*s + 1) + 30*b1*(2*r + s - 1) + 21*r - 3*s - 6) + Pkd2*k2*(15*b1*(2*s - 1) - (8*C - 6)*(3*s - 1))) + fd*k2**2*(Pk2*(4*C*(138*r + 45*s - 61) - 55*b1*(3*r - 1) - 369*r - 90*s + 153) + Pkd2*k2*(30*C - 15)*(3*s - 1)) - 22*gd2*(k1**2*(Pk2*(4*r - 6*s - 4) + 4*Pkd2*k2*s) + 5*k2**2*(2*Pk2*(2*r + s - 2) + Pkd2*k2*s))) - 143*fd*k2**2*(10*Pk2*b2*k2**2*(2*r + 2*s - 1) + 2*b1*k1**2*(Pk2*(K*(4*r - 6*s + 3) - 10*r - 4*s + 2) + Pkd2*k2*(2*K - 1)*(2*s - 1)) + 5*b1*k2**2*(K*Pk2*(8*r + 4*s - 2) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r) - 4*g2*k1**2*(Pk2*(4*r - 6*s + 3) + 2*Pkd2*k2*(2*s - 1)) - 10*g2*k2**2*(Pk2*(8*r + 4*s - 2) + Pkd2*k2*(2*s - 1)))) + Dd*f*(45*f**2*k1**2*(-52*Pk2*k2**2*(3*r + 2*s - 2) + 5*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 13*f*k2**2*(6*k1**2*(Pk2*(C*(-16*r + 24*s + 2) + 10*b1*(8*r + 4*s - 5) + 28*r - 4*s - 13) + Pkd2*k2*(4*s - 1)*(-4*C + 5*b1 + 3)) + k2**2*(2*Pk2*(-368*C*r - 120*C*s + 214*C + 55*b1*(2*r - 1) + 246*r + 60*s - 138) + Pkd2*k2*(15 - 30*C)*(4*s - 1))) - 143*k2**2*(10*Pk2*b2*k2**2*(4*r + 4*s - 3) + 2*b1*k1**2*(K*Pk2*(8*r - 12*s - 1) - 4*Pk2*(5*r + 2*s - 3) + Pkd2*k2*(2*K - 1)*(4*s - 1)) + 5*b1*k2**2*(K*Pkd2*k2*(4*s - 1) + 2*Pk2*(K*(8*r + 4*s - 5) - 2*r + 1)) + 4*g2*k1**2*(-8*Pk2*r + 12*Pk2*s + Pk2 - 8*Pkd2*k2*s + 2*Pkd2*k2) + 10*g2*k2**2*(-2*Pk2*(8*r + 4*s - 5) + Pkd2*k2*(1 - 4*s)))))/(45045*d*k2*k3**4) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*st**2*(D1*bd1*f*(Pk2*f*(7*r + s*(12*C - 6)) + Pkd2*f*k2*s*(3 - 6*C) + s*(2*Pk2 - Pkd2*k2)*(9*b2 - 18*g2)) + 9*b1**2*(D1*fd*(K*(2*Pk2 - Pkd2*k2)*(s - 1) + Pk2*f*(2*r - 1) + Pk2*r) + Dd*f*(K*Pkd2*k2*(1 - 4*s) + Pk2*(8*K*s - 2*K + f*(4*r - 2) + 4*r - 2))) + b1*(24*C*D1*Pk2*f*fd*s - 12*C*D1*Pk2*f*fd - 12*C*D1*Pkd2*f*fd*k2*s + 6*C*D1*Pkd2*f*fd*k2 + 48*C*Dd*Pk2*f**2*s - 12*C*Dd*Pk2*f**2 - 24*C*Dd*Pkd2*f**2*k2*s + 6*C*Dd*Pkd2*f**2*k2 + 18*D1*Pk2*bd2*f*s + 14*D1*Pk2*f*fd*r - 12*D1*Pk2*f*fd*s - D1*Pk2*f*fd - 36*D1*Pk2*f*gd2*s - 36*D1*Pk2*fd*g2*s + 36*D1*Pk2*fd*g2 - 9*D1*Pkd2*bd2*f*k2*s + 6*D1*Pkd2*f*fd*k2*s - 3*D1*Pkd2*f*fd*k2 + 18*D1*Pkd2*f*gd2*k2*s + 18*D1*Pkd2*fd*g2*k2*s - 18*D1*Pkd2*fd*g2*k2 + 9*D1*bd1*f*(-2*K*Pkd2*k2*s + Pk2*(4*K*s + 2*f*r - f + 2*r - 1)) + 28*Dd*Pk2*f**2*r - 24*Dd*Pk2*f**2*s - 8*Dd*Pk2*f**2 - 144*Dd*Pk2*f*g2*s + 36*Dd*Pk2*f*g2 + 12*Dd*Pkd2*f**2*k2*s - 3*Dd*Pkd2*f**2*k2 + 72*Dd*Pkd2*f*g2*k2*s - 18*Dd*Pkd2*f*g2*k2 + 9*b2*(2*Pk2 - Pkd2*k2)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))))/(315*d*k2) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*st**2*(33*b1**2*(D1*fd*(3*K*k2**2*(-2*Pk2*r + Pkd2*k2) + k1**2*(2*Pk2*(-K*s + K + 4*f*s + f + 3*s - 1) - Pkd2*k2*(4*f*s + f + 2*s))) + 2*Dd*f*(6*K*Pk2*k2**2*(1 - 2*r) + k1**2*(4*s - 1)*(Pk2*(-K + 2*f + 3) - Pkd2*k2*(f + 1)))) + 11*b1*(3*D1*bd1*f*(-3*K*k2**2*(Pk2*(4*r - 2) + Pkd2*k2) + k1**2*(-2*Pk2*(f*(3 - 4*s) + s*(2*K - 6) + 2) + Pkd2*k2*(f*(3 - 4*s) - 4*s + 2))) + D1*(-9*Pk2*f**2*fd*k1**2*(6*r + 12*s - 7) + f*(12*Pk2*gd2*(k1**2*s + 3*k2**2*(r - 1)) + 9*Pkd2*bd2*k2**3*s + fd*(-k1**2*(2*Pk2*(C*(4*s - 2) + 6*K*s - 3*K + 9*r + 16*s - 10) + Pkd2*k2*(K*(3 - 6*s) + 4*s)) + k2**2*(Pk2*(C*(28 - 56*r) + 36*K*(r + 2*s - 1) + 28*r - 14) + Pkd2*k2*(6*C - 3)))) + 3*fd*(4*Pk2*g2*k1**2*(s - 1) + 3*Pkd2*b2*k2**3*s - 6*g2*k2**2*(-2*Pk2*r + Pkd2*k2))) + Dd*f*(-72*Pk2*f**2*k1**2*(r + 2*s - 1) + 12*Pk2*g2*(k1**2*(4*s - 1) + 6*k2**2*(2*r - 1)) + 9*Pkd2*b2*k2**3*(4*s - 1) + f*(4*Pk2*k2**2*(C*(14 - 28*r) + 18*K*(r + 2*s - 1) + 14*r - 7) + k1**2*(-2*Pk2*(C*(8*s - 2) + 12*K*s - 3*K + 18*r + 32*s - 17) + Pkd2*k2*(3*K - 2)*(4*s - 1))))) + f*(-180*C*D1*Pk2*f*fd*k1**2*s + 60*C*D1*Pk2*f*fd*k1**2 + 828*C*D1*Pk2*f*fd*k2**2*r + 792*C*D1*Pk2*f*fd*k2**2*s - 540*C*D1*Pk2*f*fd*k2**2 + 90*C*D1*Pkd2*f*fd*k1**2*k2*s - 30*C*D1*Pkd2*f*fd*k1**2*k2 - 240*C*Dd*Pk2*f**2*k1**2*s + 60*C*Dd*Pk2*f**2*k1**2 + 1104*C*Dd*Pk2*f**2*k2**2*r + 1056*C*Dd*Pk2*f**2*k2**2*s - 816*C*Dd*Pk2*f**2*k2**2 + 120*C*Dd*Pkd2*f**2*k1**2*k2*s - 30*C*Dd*Pkd2*f**2*k1**2*k2 - 66*D1*Pk2*bd2*f*k1**2*s + 198*D1*Pk2*bd2*f*k2**2*r + 396*D1*Pk2*bd2*f*k2**2*s - 198*D1*Pk2*bd2*f*k2**2 - 147*D1*Pk2*f*fd*k1**2*r - 198*D1*Pk2*f*fd*k1**2*s + 115*D1*Pk2*f*fd*k1**2 - 414*D1*Pk2*f*fd*k2**2*r - 396*D1*Pk2*f*fd*k2**2*s + 270*D1*Pk2*f*fd*k2**2 + 132*D1*Pk2*f*gd2*k1**2*s - 396*D1*Pk2*f*gd2*k2**2*r - 792*D1*Pk2*f*gd2*k2**2*s + 396*D1*Pk2*f*gd2*k2**2 + 264*D1*Pk2*fd*g2*k1**2*s - 132*D1*Pk2*fd*g2*k1**2 - 792*D1*Pk2*fd*g2*k2**2*r - 1584*D1*Pk2*fd*g2*k2**2*s + 792*D1*Pk2*fd*g2*k2**2 + 33*D1*Pkd2*bd2*f*k1**2*k2*s - 45*D1*Pkd2*f*fd*k1**2*k2*s + 15*D1*Pkd2*f*fd*k1**2*k2 - 66*D1*Pkd2*f*gd2*k1**2*k2*s - 132*D1*Pkd2*fd*g2*k1**2*k2*s + 66*D1*Pkd2*fd*g2*k1**2*k2 - 11*D1*bd1*(9*Pk2*f**2*k1**2*(2*r + 4*s - 1) - 9*Pkd2*b2*k2**3*(s - 1) + f*k1**2*(Pk2*(9*r + s*(4*C + 6*K + 16) - 5) + Pkd2*k2*(s*(2 - 3*K) - 2)) + f*k2**2*(-18*K*Pk2*(r + 2*s - 1) + (2*C - 1)*(14*Pk2*r + 3*Pkd2*k2)) - 6*g2*(2*Pk2*k1**2*s + 6*Pk2*k2**2*r + 3*Pkd2*k2**3)) - 196*Dd*Pk2*f**2*k1**2*r - 264*Dd*Pk2*f**2*k1**2*s + 164*Dd*Pk2*f**2*k1**2 - 552*Dd*Pk2*f**2*k2**2*r - 528*Dd*Pk2*f**2*k2**2*s + 408*Dd*Pk2*f**2*k2**2 + 528*Dd*Pk2*f*g2*k1**2*s - 132*Dd*Pk2*f*g2*k1**2 - 1584*Dd*Pk2*f*g2*k2**2*r - 3168*Dd*Pk2*f*g2*k2**2*s + 1584*Dd*Pk2*f*g2*k2**2 - 60*Dd*Pkd2*f**2*k1**2*k2*s + 15*Dd*Pkd2*f**2*k1**2*k2 - 264*Dd*Pkd2*f*g2*k1**2*k2*s + 66*Dd*Pkd2*f*g2*k1**2*k2 - 33*b2*(D1*fd*(-12*Pk2*k2**2*(r + 2*s - 1) + k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1)) + Dd*f*(-24*Pk2*k2**2*(r + 2*s - 1) + k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1)))))/(3465*d*k2*k3**2) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*st**2*(D1*bd1*f*(3*f**2*k1**2*(11*Pk2*k2**2*(8*s - 5) + 5*k1**2*(4*Pk2*(r + 2*s - 2) + Pkd2*k2*(3 - 2*s))) - 11*f*(-2*Pk2*k1**4*(r - s*(K - 2) - 1) - k1**2*k2**2*(Pk2*(4*C*(s + 1) - 36*K*r - 66*K*s + 36*K + 6*b1*(4*r + 4*s - 5) + 17*r + 28*s - 19) + Pkd2*k2*(-8*C*(s - 1) - 3*K*s + 9*b1*(2*s - 1) + 6*s - 6)) + k2**4*(Pk2*(4*C*(7*r + 3*s - 6) + 18*K*(r + 2*s - 1) + b1*(9 - 18*r) - 21*r - 6*s + 12) + Pkd2*k2*(6*C - 3)*(s - 1))) - 33*k2**2*(6*Pk2*b2*k2**2*(r + s - 1) - 2*b1*k1**2*(Pk2*(2*K*s + K + 8*r + 6*s - 8) + Pkd2*k2*(-4*K*s + 2*K + 2*s - 1)) + 3*b1*k2**2*(K*Pk2*(4*r + 4*s - 6) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r + Pk2) + 4*g2*k1**2*(Pk2*(s + 1) - 2*Pkd2*k2*(s - 1)) - 6*g2*k2**2*(2*Pk2*(r + s - 2) + Pkd2*k2*(s - 1)))) + 33*b1**2*k2**2*(D1*fd*(2*k1**2*(Pk2*(K*(s - 2) + f*(4*r + 4*s - 1) + 4*r + 3*s + 1) + Pkd2*k2*s*(-2*K + 3*f + 1)) - 3*k2**2*(2*K*Pk2*(r + s + 1) + K*Pkd2*k2*s - Pk2*r + f*(-2*Pk2*r + Pk2))) + Dd*f*(k1**2*(2*Pk2*(4*K*s - K + f*(8*r + 8*s - 6) + 16*r + 12*s - 11) + Pkd2*k2*(4*s - 1)*(-4*K + 3*f + 2)) + 3*k2**2*(K*Pkd2*k2*(1 - 4*s) - 2*Pk2*(K*(4*r + 4*s - 3) - 2*f*r + f - 2*r + 1)))) + b1*(D1*(3*f**2*fd*k1**2*(33*Pk2*k2**2*(8*s - 1) + 5*k1**2*(4*Pk2*(3*r + 6*s - 2) - Pkd2*k2*(6*s + 1))) - 11*f*(18*Pk2*bd2*k2**4*(r + s - 1) + fd*(2*Pk2*k1**4*(2*K*s - K - 2*r - 4*s + 2) + k1**2*k2**2*(2*Pk2*(-4*C*(s - 1) + K*(36*r + 66*s - 33) - 17*r - 28*s + 13) + Pkd2*k2*(K*(6*s - 3) + s*(16*C - 12))) + k2**4*(Pk2*(8*C*(7*r + 3*s - 2) + 36*K*(r + 2*s - 1) - 42*r - 12*s + 15) + Pkd2*k2*s*(12*C - 6))) - 6*gd2*k2**2*(-2*Pk2*k1**2*s + 6*Pk2*k2**2*(r + s - 1) + 4*Pkd2*k1**2*k2*s + 3*Pkd2*k2**3*s)) + 66*fd*k2**2*(-3*Pk2*b2*k2**2*(r + s) + g2*k1**2*(-2*Pk2*(s - 2) + 4*Pkd2*k2*s) + 3*g2*k2**2*(2*Pk2*(r + s + 1) + Pkd2*k2*s))) + Dd*f*(6*f**2*k1**2*(44*Pk2*k2**2*(4*s - 1) + 5*k1**2*(8*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 4*s))) - 11*f*(2*Pk2*k1**4*(4*K*s - K - 4*r - 8*s + 4) + k1**2*k2**2*(2*Pk2*(C*(2 - 8*s) + 3*K*(24*r + 44*s - 23) - 34*r - 56*s + 31) + Pkd2*k2*(4*s - 1)*(8*C + 3*K - 6)) + k2**4*(4*Pk2*(C*(28*r + 12*s - 17) + 18*K*(r + 2*s - 1) - 21*r - 6*s + 12) + Pkd2*k2*(6*C - 3)*(4*s - 1))) + 66*k2**2*(-3*Pk2*b2*k2**2*(4*r + 4*s - 3) - 2*g2*k1**2*(Pk2 - 2*Pkd2*k2)*(4*s - 1) + 3*g2*k2**2*(Pk2*(8*r + 8*s - 6) + Pkd2*k2*(4*s - 1))))) + f*(D1*(-30*Pk2*f**2*fd*k1**4*(10*r + 24*s - 11) + f*(-198*Pk2*bd2*k1**2*k2**2*(r + s - 1) + fd*(10*Pk2*k1**4*(C*(2 - 6*s) + 3*r + 9*s - 4) - Pk2*k2**4*(36*C - 18)*(23*r + 22*s - 15) + k1**2*k2**2*(Pk2*(-188*C*(6*r + 9*s - 5) + 711*r + 1134*s - 615) + Pkd2*k2*(15 - 30*C)*(3*s - 1))) + 22*gd2*(2*Pk2*k1**4*s + 18*Pk2*k2**4*(r + 2*s - 1) + 3*k1**2*k2**2*(2*Pk2*(6*r + 11*s - 6) + Pkd2*k2*s))) + 22*fd*(-9*Pk2*b2*k1**2*k2**2*(2*r + 2*s - 1) + g2*(2*Pk2*k1**4*(2*s - 1) + 36*Pk2*k2**4*(r + 2*s - 1) + 3*k1**2*k2**2*(Pk2*(24*r + 44*s - 22) + Pkd2*k2*(2*s - 1))))) + Dd*f*(-198*Pk2*b2*k1**2*k2**2*(4*r + 4*s - 3) - 30*Pk2*f**2*k1**4*(10*r + 24*s - 11) + f*(10*Pk2*k1**4*(C*(2 - 8*s) + 4*r + 12*s - 5) - Pk2*k2**4*(48*C - 24)*(23*r + 22*s - 17) + k1**2*k2**2*(-188*C*Pk2*(8*r + 12*s - 7) + 12*Pk2*(79*r + 126*s - 71) + Pkd2*k2*(15 - 30*C)*(4*s - 1))) + 22*g2*(2*Pk2*k1**4*(4*s - 1) + 72*Pk2*k2**4*(r + 2*s - 1) + 3*k1**2*k2**2*(Pk2*(48*r + 88*s - 46) + Pkd2*k2*(4*s - 1))))))/(3465*d*k2*k3**4) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*f**2*k1*st**6*(4*Pk2 - Pkd2*k2)*(D1*b1*fd*(3*s - 1) + D1*bd1*f*s + Dd*b1*f*(4*s - 1))/(231*d*k3**2) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*f**2*k1*st**6*(D1*(13*b1*fd*k2**2*(Pk2*(6*r - 2) + Pkd2*k2*(3*s - 1)) + f*(13*bd1*k2**2*(2*Pk2*(r - 1) + Pkd2*k2*s) + fd*(52*Pk2*k2**2*(1 - 2*r) + 9*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)))) + Dd*f*(13*b1*k2**2*(Pk2*(8*r - 4) + Pkd2*k2*(4*s - 1)) + f*(52*Pk2*k2**2*(1 - 2*r) + 9*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))))/(3003*d*k3**4) + 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*f*st**4*(11*D1*b1**2*fd*k1**2*k2**2*(-2*Pk2 + Pkd2*k2) + D1*bd1*f*k1**2*(-22*K*Pkd2*k2**3*s - 24*Pk2*f*k1**2*s + 11*Pk2*k2**2*(4*K*s + f*(6*r + 5*s - 4) + 2*r + s - 2) + 6*Pkd2*f*k1**2*k2*s) + b1*k1**2*(D1*(f*(11*Pk2*fd*k2**2*(18*r + 15*s - 13) - 11*bd1*k2**2*(-2*Pk2 + Pkd2*k2) - 6*fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) - 11*fd*k2**2*(2*K*Pkd2*k2*(2*s - 1) + Pk2*(-8*K*s + 4*K - 4*r - 2*s + 1))) + Dd*f*(f*(11*Pk2*k2**2*(24*r + 20*s - 17) - 6*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 11*k2**2*(2*K*Pkd2*k2*(4*s - 1) + Pk2*(-16*K*s + 4*K - 8*r - 4*s + 5)))) + k2**2*(D1*(f*(Pk2*fd*k2**2*(16 - 32*C)*(3*r - 1) + 3*fd*k1**2*(Pk2*(24*C*s - 8*C + 6*r - 9*s + 1) + 2*Pkd2*k2*(-6*C*s + 2*C + 3*s - 1)) + k1**2*s*(2*Pk2 - Pkd2*k2)*(22*bd2 - 44*gd2)) - 44*fd*g2*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1)) + Dd*f*(Pk2*f*k2**2*(32 - 64*C)*(2*r - 1) + 3*f*k1**2*(Pk2*(8*C*(4*s - 1) + 8*r - 12*s - 1) + 2*Pkd2*k2*(C*(2 - 8*s) + 4*s - 1)) - 44*g2*k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1)) + 22*b2*k1**2*(2*Pk2 - Pkd2*k2)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1))))/(3465*d*k1*k2**2*k3**2) - 2*np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*f*st**4*(D1*(f**2*k1**2*(13*bd1*k2**2*(11*Pk2*k2**2*(4*r + 5*s - 6) + k1**2*(6*Pk2*(5*r + 5*s - 6) + 9*Pkd2*k2)) + 3*fd*(-39*Pk2*k1**2*k2**2*(16*r + 20*s - 13) + 5*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1))) - 13*f*k2**2*(b1*k1**2*(11*bd1*k2**2*(2*Pk2 + Pkd2*k2*(1 - 2*s)) + fd*(-11*Pk2*k2**2*(12*r + 15*s - 7) + 9*k1**2*(-2*Pk2*(5*r + 5*s - 3) + Pkd2*k2))) + k2**2*(180*C*Pk2*fd*k1**2*r + 144*C*Pk2*fd*k1**2*s - 108*C*Pk2*fd*k1**2 + 96*C*Pk2*fd*k2**2*r - 32*C*Pk2*fd*k2**2 + 36*C*Pkd2*fd*k1**2*k2*s - 12*C*Pkd2*fd*k1**2*k2 + 66*Pk2*bd2*k1**2*(r + s - 1) - 108*Pk2*fd*k1**2*r - 81*Pk2*fd*k1**2*s + 63*Pk2*fd*k1**2 - 48*Pk2*fd*k2**2*r + 16*Pk2*fd*k2**2 - 220*Pk2*gd2*k1**2*r - 176*Pk2*gd2*k1**2*s + 220*Pk2*gd2*k1**2 - 18*Pkd2*fd*k1**2*k2*s + 6*Pkd2*fd*k1**2*k2 - 44*Pkd2*gd2*k1**2*k2*s + 11*bd1*k1**2*(2*K*Pkd2*k2*s + Pk2*(2*K*(5*r + 4*s - 5) - 2*r - s + 2)))) + 143*fd*k1**2*k2**4*(-6*Pk2*b2*(2*r + 2*s - 1) + 8*Pk2*g2*(5*r + 4*s - 2) + 4*Pkd2*g2*k2*(2*s - 1) + 2*b1**2*(Pk2 + Pkd2*k2*s) - b1*(2*K*Pkd2*k2*(2*s - 1) + Pk2*(4*K*(5*r + 4*s - 2) - 4*r - 2*s + 1)))) + Dd*f*(3*f**2*k1**4*(-39*Pk2*k2**2*(16*r + 20*s - 13) + 5*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 13*f*k2**2*(Pk2*b1*k1**2*(30*k1**2*(4*r + 4*s - 3) + 11*k2**2*(16*r + 20*s - 13)) + Pk2*k2**4*(32 - 64*C)*(2*r - 1) - 3*k1**2*k2**2*(Pk2*(8*C*(10*r + 8*s - 7) - 48*r - 36*s + 33) + Pkd2*k2*(4*C - 2)*(4*s - 1))) + 143*k1**2*k2**4*(2*K*Pkd2*b1*k2*(1 - 4*s) + Pk2*b1*(-4*K*(10*r + 8*s - 7) + 8*r + 4*s - 5) - 6*Pk2*b2*(4*r + 4*s - 3) + 8*Pk2*g2*(10*r + 8*s - 7) + Pkd2*b1**2*k2*(4*s - 1) + 4*Pkd2*g2*k2*(4*s - 1))))/(45045*d*k1*k2**2*k3**4) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*k1*st**2*(33*Pkd2*b1**3*k2**3*(D1*fd*s + Dd*f*(4*s - 1)) + 11*b1**2*(D1*(3*Pkd2*bd1*f*k2**3*(3*s - 1) + fd*(6*K*Pkd2*k2**3*s + 8*Pk2*f*k1**2*s - 3*Pk2*k2**2*(2*K*(s - 1) + f*(8*r - 3) + 2*r + 1) - 4*Pkd2*f*k1**2*k2*s)) + 2*Dd*f*(f*(12*Pk2*k2**2*(1 - 2*r) + k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1)) + 3*k2**2*(K*Pkd2*k2*(4*s - 1) + Pk2*(-4*K*s + K - 4*r + 2)))) + 11*b1*(D1*bd1*f*(6*K*Pkd2*k2**3*(2*s - 1) + 3*Pk2*f*k2**2*(5 - 8*r) - 3*Pk2*k2**2*(4*K*s + 4*r - 3) + 2*f*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1)) + D1*(6*Pk2*f**2*fd*k1**2*(1 - 3*s) + f*(fd*(k1**2*(-2*Pk2*s + Pk2) + k2**2*(Pk2*(C*(4 - 8*s) + 6*K*(2*r + 6*s - 3) - 4*r + 4*s - 1) + Pkd2*k2*s*(8*C - 4))) + 6*k2**2*s*(Pkd2*bd2*k2 + 2*gd2*(Pk2 - Pkd2*k2))) + 6*fd*k2**2*(2*Pk2*g2*(s - 1) + Pkd2*b2*k2*s - 2*Pkd2*g2*k2*s)) + Dd*f*(6*Pk2*f**2*k1**2*(1 - 4*s) + f*(k1**2*(-4*Pk2*s + Pk2) + 2*k2**2*(Pk2*(C*(2 - 8*s) + 3*K*(4*r + 12*s - 5) - 4*r + 4*s + 1) + Pkd2*k2*(2*C - 1)*(4*s - 1))) + 6*k2**2*(4*s - 1)*(Pkd2*b2*k2 + 2*g2*(Pk2 - Pkd2*k2)))) + f*(D1*(-66*Pk2*bd1*f**2*k1**2*s + f*(Pk2*fd*k1**2*(5 - 15*s) + Pk2*fd*k2**2*(4*C - 2)*(51*r + 99*s - 50) + Pk2*k2**2*(66*bd2 - 132*gd2)*(r + 3*s - 1) + 11*bd1*(-Pk2*k1**2*s + Pk2*k2**2*(-4*C*s + 6*K*(r + 3*s - 1) - 2*r + 2*s + 1) + Pkd2*k2**3*(4*C - 2)*(s - 1))) + 66*k2**2*(Pk2*b2*fd*(2*r + 6*s - 3) - 2*Pk2*fd*g2*(2*r + 6*s - 3) + Pkd2*b2*bd1*k2*(s - 1) + 2*bd1*g2*(Pk2*s + k2*(-Pkd2*s + Pkd2)))) + Dd*Pk2*f*(f*k1**2*(5 - 20*s) + f*k2**2*(4*C - 2)*(68*r + 132*s - 67) + k2**2*(66*b2 - 132*g2)*(4*r + 12*s - 5))))/(3465*d*k2**2*k3**2) + np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*st**2*(D1*Pk2*bd1*f**2*(k1**2*s + k2**2*r*(4 - 8*C)) + Pk2*b1*f*(D1*(6*bd1*k1**2*s*(3*f + 1) + fd*k1**2*(2*s - 1) + 4*fd*k2**2*(C*(2 - 4*r) + 2*r - 1)) + Dd*f*(k1**2*(4*s - 1) + k2**2*(8 - 16*C)*(2*r - 1))) - 3*b1**3*k1**2*(2*Pk2 - Pkd2*k2)*(D1*fd*s + Dd*f*(4*s - 1)) - 3*b1**2*k1**2*(-D1*Pk2*fd*(f*(6*s - 3) + s - 1) + D1*bd1*f*(2*Pk2 - Pkd2*k2)*(3*s - 1) - Dd*Pk2*f*(3*f + 1)*(4*s - 1)))/(315*d*k1*k2**2) - np.sqrt(210)*1j*np.sqrt(np.pi)*D1**3*Pk3*st**2*(D1*bd1*f*(f**2*k1**4*(11*Pk2*k2**2*(5 - 8*r) + 5*k1**2*(2*Pk2 - Pkd2*k2)*(s - 1)) + 11*f*k2**2*(-16*C*Pk2*k1**2*k2**2*r - 20*C*Pk2*k1**2*k2**2*s + 24*C*Pk2*k1**2*k2**2 - 8*C*Pk2*k2**4*r - 4*C*Pkd2*k1**2*k2**3*s + 4*C*Pkd2*k1**2*k2**3 - 2*K*Pk2*k1**2*(k1**2*(r + 2*s - 1) + 3*k2**2*(r + 3*s - 1)) + Pk2*k1**4*s + 10*Pk2*k1**2*k2**2*r + 11*Pk2*k1**2*k2**2*s - 13*Pk2*k1**2*k2**2 + 4*Pk2*k2**4*r + 2*Pkd2*k1**2*k2**3*s - 2*Pkd2*k1**2*k2**3 + b1*(9*Pk2*k1**2*k2**2*(4*r + 2*s - 3) + k1**4*(2*Pk2*(8*r + 8*s - 7) + 3*Pkd2*k2*(2*s - 1)))) - 33*k1**2*k2**4*(2*Pk2*b1**2*(3*r + 3*s - 2) + 6*Pk2*b2*(r + s - 1) + b1*(2*K*Pkd2*k2*(2*s - 1) + Pk2*(4*K*(4*r + 5*s - 5) - 4*r - 2*s + 3)) - 4*g2*(Pk2*(4*r + 5*s - 6) + Pkd2*k2*(s - 1)))) - 66*Pk2*b1**3*k1**2*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + Pk2*f*k1**2*(D1*(15*f**2*fd*k1**4*(1 - 4*s) + f*k2**2*(-22*bd2*k1**2*(r + s - 1) + fd*(-5*k1**2*(12*C*(r + 2*s - 1) - 6*r - 15*s + 7) + k2**2*(2 - 4*C)*(51*r + 99*s - 50)) + 44*gd2*(k1**2*(r + 2*s - 1) + 3*k2**2*(r + 3*s - 1))) + 22*fd*k2**2*(b2*k1**2*(-2*r - 2*s + 1) + 4*g2*k1**2*(r + 2*s - 1) + 6*g2*k2**2*(2*r + 6*s - 3))) + Dd*f*(15*f**2*k1**4*(1 - 4*s) + f*k2**2*(-5*k1**2*(16*C*(r + 2*s - 1) - 8*r - 20*s + 9) + k2**2*(2 - 4*C)*(68*r + 132*s - 67)) + 22*k2**2*(b2*k1**2*(-4*r - 4*s + 3) + 8*g2*k1**2*(r + 2*s - 1) + 6*g2*k2**2*(4*r + 12*s - 5)))) + 11*b1**2*k1**2*k2**2*(D1*fd*(-6*K*k2**2*(4*Pk2*r + 5*Pk2*s + Pk2 + Pkd2*k2*s) + 18*Pk2*f*k2**2*(2*r + s - 1) + 3*Pk2*k2**2*(2*r + s) + 2*f*k1**2*(Pk2*(8*r + 8*s - 5) + 3*Pkd2*k2*s)) + Dd*f*(f*(9*Pk2*k2**2*(8*r + 4*s - 5) + k1**2*(8*Pk2*(4*r + 4*s - 3) + 3*Pkd2*k2*(4*s - 1))) - 3*k2**2*(2*K*Pkd2*k2*(4*s - 1) + Pk2*(K*(32*r + 40*s - 26) - 8*r - 4*s + 5)))) + b1*(D1*(f**2*fd*k1**4*(30*Pk2*k1**2*s + 11*Pk2*k2**2*(11 - 24*r) - 15*Pkd2*k1**2*k2*s) - 11*f*k2**2*(fd*(Pk2*k1**4*(4*K*(r + 2*s - 1) - 2*s + 1) + Pk2*k2**4*(8*C - 4)*(2*r - 1) + 2*k1**2*k2**2*(Pk2*(2*C*(8*r + 10*s - 3) + 3*K*(2*r + 6*s - 3) - 10*r - 11*s + 4) + Pkd2*k2*s*(4*C - 2))) - 6*k1**2*k2**2*(-3*Pk2*bd2*(r + s - 1) + 2*gd2*(Pk2*(4*r + 5*s - 4) + Pkd2*k2*s))) + 66*fd*k1**2*k2**4*(-3*Pk2*b2*(r + s) + 2*g2*(4*Pk2*r + 5*Pk2*s + Pk2 + Pkd2*k2*s))) + Dd*f*(f**2*k1**4*(176*Pk2*k2**2*(1 - 2*r) + 5*k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1)) - 11*f*k2**2*(Pk2*k1**4*(8*K*(r + 2*s - 1) - 4*s + 1) + Pk2*k2**4*(16*C - 8)*(2*r - 1) + k1**2*k2**2*(Pk2*(C*(64*r + 80*s - 52) + 6*K*(4*r + 12*s - 5) - 40*r - 44*s + 31) + Pkd2*k2*(4*C - 2)*(4*s - 1))) + 66*k1**2*k2**4*(-3*Pk2*b2*(4*r + 4*s - 3) + 2*g2*(Pk2*(16*r + 20*s - 13) + Pkd2*k2*(4*s - 1))))))/(3465*d*k1*k2**2*k3**4)
        
        return (perm12+perm13+perm23)
    
    def l3m3(cosmo_functions,k1,k2,k3=None,theta=None,zz=0,r=0,s=0,nonlin=False,growth2=False):
        
        #get generic cosmology parameters
        k1,k2,k3,theta,Pk1,Pk2,Pk3,Pkd1,Pkd2,Pkd3,Pkdd1,Pkdd2,Pkdd3,d,K,C,f,D1,b1,b2,g2 = cosmo_functions.get_params(k1,k2,k3,theta,zz,nonlin=nonlin,growth2=growth2)
        
        fd,Dd,gd2,bd2,bd1,fdd,Ddd,gdd2,bdd2,bdd1 = cosmo_functions.get_derivs(zz)
        
        st = np.sin(theta)
        ct= np.cos(theta)

        perm12 = -8*np.sqrt(35)*1j*np.sqrt(np.pi)*C*D1**3*Pk1*Pk2*f*k2**3*st**5*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(693*d*k3**4) - 4*np.sqrt(35)*1j*np.sqrt(np.pi)*C*D1**3*Pk1*Pk2*k2*st**3*(11*D1*bd1*f*(18*b1*k2**2 + f*(3*k1**2 + k2**2))*(r + s - 1) + 99*b1**2*k2**2*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + 11*b1*f*(3*k1**2 + k2**2)*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + 9*f**2*k1**2*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(3465*d*k3**4) + 4*np.sqrt(35)*1j*np.sqrt(np.pi)*C*D1**3*Pk2*Pkd1*f*k1*k2*st**3*(11*D1*bd1*f*(r - 1) + 11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 3*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(3465*d*k3**2) + 8*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**4*f*k2**3*st**3*(C - 1)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + 3*f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(693*d*k3**4) + 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**3*f*k2**2*st**3*(k1**2*(12*C - 17) - 5*k2**2)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + 3*f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(3465*d*k1*k3**4) + 8*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**2*f*k2**3*st**5*(C - 1)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(693*d*k3**4) - 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct**2*k2*st**3*(-11*D1*bd1*f*(r + s - 1)*(18*b1*k2**2*(C - 1) + f*k1**2*(3*C - 9) - f*k2**2*(9*C + 7)) - 99*b1**2*k2**2*(C - 1)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) - 11*b1*f*(D1*fd + 2*Dd*f)*(k1**2*(3*C - 9) - k2**2*(9*C + 7))*(2*r + 2*s - 1) - 3*f**2*(k1**2*(3*C - 9) - k2**2*(10*C + 6))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(3465*d*k3**4) - 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct*f*k2**2*st**5*(k1**2 + k2**2)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd + 2*Dd*f)*(2*r + 2*s - 1) + f*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(693*d*k1*k3**4) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk2*ct*st**3*(11*D1*bd1*f*(18*b1*k2**2*(k1**2 + k2**2) + f*(3*k1**4 + k1**2*k2**2*(24*C + 4) + k2**4))*(r + s - 1) + 99*b1**2*k2**2*(k1**2 + k2**2)*(D1*fd*(r + s) + 2*Dd*f*(2*r + 2*s - 1)) + 11*b1*f*(D1*fd + 2*Dd*f)*(3*k1**4 + k1**2*k2**2*(24*C + 4) + k2**4)*(2*r + 2*s - 1) + 9*f**2*k1**2*(k1**2 + k2**2*(8*C + 1))*(D1*fd*(3*r + 3*s - 2) + 2*Dd*f*(2*r + 2*s - 1)))/(3465*d*k1*k3**4) + 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**4*f*k2*st**3*(C - 1)*(4*Pk2 - Pkd2*k2)*(11*b1*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) + f*(11*D1*bd1*s + D1*fd*(9*s - 3) + 3*Dd*f*(4*s - 1)))/(693*d*k3**2) - 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**3*f**2*st**3*(4*Pk2 - Pkd2*k2)*(13*b1*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1)) + f*(13*D1*bd1*s + 5*D1*fd*(4*s - 1) + 5*Dd*f*(4*s - 1)))/(3003*d*k1) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**3*f*st**3*(11*b1*(D1*fd*(k1**2*(8*C - 13)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(Pk2*(-r*(24*C - 24) - 20*s + 10) + 5*Pkd2*k2*(2*s - 1))) + Dd*f*(k1**2*(8*C - 13)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(-2*Pk2*(24*C*r - 6*C - 24*r + 20*s + 1) + 5*Pkd2*k2*(4*s - 1)))) + f*(11*D1*bd1*(Pk2*k1**2*s*(32*C - 52) - 2*Pk2*k2**2*(6*C*(r - 1) - 6*r + 5*s + 6) + Pkd2*k1**2*k2*s*(13 - 8*C) + 5*Pkd2*k2**3*s) + D1*fd*(k1**2*(24*C - 39)*(4*Pk2 - Pkd2*k2)*(3*s - 1) + 5*k2**2*(-2*Pk2*(10*C*(3*r - 1) - 30*r + 9*s + 7) + 3*Pkd2*k2*(3*s - 1))) + Dd*f*k1**2*(24*C - 39)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 5*Dd*f*k2**2*(-2*Pk2*(10*C*(4*r - 1) - 40*r + 12*s + 7) + 3*Pkd2*k2*(4*s - 1))))/(3465*d*k1*k3**2) + 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**2*f*k2*st**5*(C - 1)*(4*Pk2 - Pkd2*k2)*(11*b1*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) + f*(11*D1*bd1*s + D1*fd*(3*s - 1) + Dd*f*(4*s - 1)))/(693*d*k3**2) + np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**2*st**3*(-143*b1**2*k1**2*(4*Pk2 - Pkd2*k2)*(D1*fd*(-9*K*s + 9*K + 10*f*(2*s - 1) + 9*s - 9) + Dd*f*(4*s - 1)*(-9*K + 10*f + 9)) - 13*b1*(D1*(10*f**2*(-15*Pk2*fd*k2**2*r + 22*bd1*k1**2*s*(4*Pk2 - Pkd2*k2) + 9*fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) - 11*f*k1**2*(4*Pk2 - Pkd2*k2)*(fd*(K - 1)*(2*s - 1) + s*(18*K*bd1 - 18*bd1 - 18*gd2)) + 198*fd*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) + Dd*f*(10*f**2*(5*Pk2*k2**2*(1 - 4*r) + 9*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 11*f*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 198*g2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + f*(-10*D1*f**2*(57*Pk2*fd*k2**2*(1 - 4*r) - 13*bd1*(-36*Pk2*k1**2*s + 5*Pk2*k2**2*(r - 1) + 9*Pkd2*k1**2*k2*s) + 30*fd*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 143*D1*f*k1**2*s*(4*Pk2 - Pkd2*k2)*(-K*bd1 + bd1 + 2*gd2) - 286*D1*g2*k1**2*(4*Pk2 - Pkd2*k2)*(9*bd1*s + fd*(2*s - 1)) - 30*Dd*f**3*(19*Pk2*k2**2*(1 - 4*r) + 10*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 286*Dd*f*g2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)))/(45045*d*k1**2*k2) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct**2*st**3*(-99*b1**2*k1**2*k2**2*(C - 1)*(-2*Pk2 + Pkd2*k2)*(D1*fd*s + Dd*f*(4*s - 1)) + 11*b1*f*(D1*(-9*bd1*k1**2*k2**2*(C - 1)*(-2*Pk2 + Pkd2*k2)*(2*s - 1) + fd*(2*Pk2*k2**4*r + k1**4*(C - 5)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 2*k1**2*k2**2*(Pk2*(C*(-30*r - 62*s + 32) + 35*r + 34*s - 18) + Pkd2*k2*(C*(9*s - 5) + 5*s - 2)))) + Dd*f*(Pk2*k2**4*(4*r - 1) + k1**4*(C - 5)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(-4*C*(30*r + 62*s - 23) + 140*r + 136*s - 69) + Pkd2*k2*(9*C + 5)*(4*s - 1)))) + f**2*(D1*(11*bd1*(Pk2*k2**4*(r - 1) + k1**4*s*(C - 5)*(4*Pk2 - Pkd2*k2) + k1**2*k2**2*(Pk2*(C*(-30*r - 62*s + 28) + 35*r + 34*s - 33) + Pkd2*k2*(9*C*s + C + 5*s - 1))) + fd*(35*Pk2*k2**4*(3*r - 1) + k1**4*(3*C - 15)*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k1**2*k2**2*(Pk2*(C*(-270*r - 384*s + 218) + 411*r + 132*s - 181) + Pkd2*k2*(30*C + 12)*(3*s - 1)))) + Dd*f*(35*Pk2*k2**4*(4*r - 1) + k1**4*(3*C - 15)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(Pk2*(C*(-360*r - 512*s + 218) + 548*r + 176*s - 181) + Pkd2*k2*(30*C + 12)*(4*s - 1)))))/(3465*d*k1**2*k2*k3**2) - 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct*f**2*st**5*(4*Pk2 - Pkd2*k2)*(13*b1*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1)) + f*(13*D1*bd1*s + 3*D1*fd*(4*s - 1) + 3*Dd*f*(4*s - 1)))/(3003*d*k1) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct*f*st**5*(11*b1*(D1*fd*(k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(Pk2*(r*(8*C - 8) + 4*s - 2) + Pkd2*k2*(1 - 2*s))) + Dd*f*(k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(2*Pk2*(8*C*r - 2*C - 8*r + 4*s + 1) + Pkd2*k2*(1 - 4*s)))) + f*(-11*D1*bd1*(-4*Pk2*k1**2*s - 2*Pk2*k2**2*(2*C*(r - 1) - 2*r + s + 2) + Pkd2*k1**2*k2*s + Pkd2*k2**3*s) + D1*fd*(k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(2*Pk2*(6*C*r - 2*C - 6*r + 3*s + 1) + Pkd2*k2*(1 - 3*s))) + Dd*f*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + Dd*f*k2**2*(2*Pk2*(C*(8*r - 2) - 8*r + 4*s + 1) + Pkd2*k2*(1 - 4*s))))/(693*d*k1*k3**2) + np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct*st**3*(-143*b1**2*(D1*fd*(k1**2*(4*Pk2 - Pkd2*k2)*(8*f*s - 4*f + 9*s - 9) + k2**2*(2*Pk2*(4*f*(4*s - 1) + 9*r*(K - 1) + 9*s - 9) + Pkd2*k2*(f*(4 - 16*s) - 9*s + 9))) + Dd*f*(k1**2*(4*Pk2 - Pkd2*k2)*(4*f + 9)*(4*s - 1) + k2**2*(72*K*Pk2*r - 18*K*Pk2 - 72*Pk2*r + 72*Pk2*s - 36*Pkd2*k2*s + 9*Pkd2*k2 + 8*f*(2*Pk2 - Pkd2*k2)*(4*s - 1)))) - 13*b1*(D1*(-396*Pk2*fd*g2*k2**2*r + 4*f**2*(-11*bd1*(-8*Pk2*k1**2*s + Pk2*k2**2*(2 - 8*s) + 2*Pkd2*k1**2*k2*s + Pkd2*k2**3*(4*s - 1)) + fd*(6*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(Pk2*(-144*r - 129*s + 65) + 3*Pkd2*k2*(1 - 6*s)))) + 11*f*(-36*Pk2*gd2*k2**2*r - 18*bd1*(-4*Pk2*k1**2*s - Pk2*k2**2*(2*K*r - K - 2*r + 2*s + 1) + Pkd2*k1**2*k2*s + Pkd2*k2**3*s) + fd*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + fd*k2**2*(2*K*Pk2*(2*r - 1) - 4*Pk2*r + 4*Pk2*s - 2*Pkd2*k2*s + Pkd2*k2))) + Dd*f*(396*Pk2*g2*k2**2*(1 - 4*r) + 4*f**2*(6*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(Pk2*(-192*r - 172*s + 91) + 6*Pkd2*k2*(1 - 4*s))) + 11*f*(k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(8*K*Pk2*r - 2*K*Pk2 - 8*Pk2*r + 8*Pk2*s - 4*Pkd2*k2*s + Pkd2*k2)))) + f*(D1*(572*Pk2*g2*k2**2*(9*bd1*(r - 1) + fd*(2*r - 1)) - 4*f**2*(-13*bd1*(-24*Pk2*k1**2*s + Pk2*k2**2*(48*r + 43*s - 26) + 6*Pkd2*k1**2*k2*s + 3*Pkd2*k2**3*(2*s - 1)) + 3*fd*(Pk2*k2**2*(-256*r - 260*s + 129) + 5*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 143*f*(4*Pk2*gd2*k2**2*r + bd1*(-4*Pk2*k1**2*s - 2*Pk2*k2**2*(r*(K - 1) + s) + Pkd2*k1**2*k2*s + Pkd2*k2**3*s))) - 4*Dd*(143*Pk2*f*g2*k2**2*(1 - 4*r) + 3*f**3*(Pk2*k2**2*(-256*r - 260*s + 129) + 5*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)))))/(45045*d*k1*k2**2) + np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*ct*st**3*(99*b1**2*k2**2*(D1*fd*(-2*Pk2*k1**2*s + Pk2*k2**2*r*(4 - 4*C) + Pkd2*k1**2*k2*s + Pkd2*k2**3*s) - Dd*f*(k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(Pk2*(4*C - 4)*(4*r - 1) + Pkd2*k2*(1 - 4*s)))) - 11*b1*f*(D1*(9*bd1*k2**2*(k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1) + k2**2*(Pk2*(4*C - 4)*(2*r - 1) + Pkd2*k2*(1 - 2*s))) + fd*(k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1) + k1**2*k2**2*(Pk2*(8*C*(r + 10*s - 5) - 60*r - 88*s + 46) + Pkd2*k2*(C*(16 - 32*s) - 4*s + 1)) - 2*k2**4*(Pk2*(-4*C*r + 2*C + 26*r + 40*s - 22) + Pkd2*k2*s))) + Dd*f*(k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 2*k1**2*k2**2*(Pk2*(C*(-8*r - 80*s + 22) + 60*r + 88*s - 37) + Pkd2*k2*(8*C + 1)*(4*s - 1)) + k2**4*(2*Pk2*(8*C*r - 2*C - 52*r - 80*s + 33) + Pkd2*k2*(1 - 4*s)))) + f**2*(D1*(11*bd1*(k1**4*(-4*Pk2*s + Pkd2*k2*s) + k1**2*k2**2*(Pk2*(-4*C*(r + 10*s - 1) + 30*r + 44*s - 28) + Pkd2*k2*(s*(16*C + 2) - 1)) + k2**4*(Pk2*(-4*C*r + 26*r + 40*s - 22) + Pkd2*k2*(s - 1))) + fd*(2*Pk2*k2**4*(64*C*(3*r - 1) + 99*r + 84*s - 61) - 3*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k1**2*k2**2*(-2*Pk2*(6*C*(3*r + 30*s - 11) - 135*r - 111*s + 82) + Pkd2*k2*(48*C + 3)*(3*s - 1)))) + Dd*f*(2*Pk2*k2**4*(64*C*(4*r - 1) + 132*r + 112*s - 61) - 3*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k1**2*k2**2*(-4*Pk2*(3*C*(4*r + 40*s - 11) - 90*r - 74*s + 41) + Pkd2*k2*(48*C + 3)*(4*s - 1)))))/(3465*d*k1*k2**2*k3**2) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*f*k2*st**5*(11*D1*bd1*f*(Pk2*k2**2*(r - 1) + k1**2*(2*C*Pkd2*k2*s + Pk2*(-4*C*s + r - 1))) - 11*b1*(2*C*D1*fd*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 2*D1*Pk2*fd*r*(k1**2 + k2**2) + Dd*Pk2*f*k2**2*(1 - 4*r) + Dd*f*k1**2*(4*C*Pk2*(4*s - 1) + 2*C*Pkd2*k2*(1 - 4*s) - 4*Pk2*r + Pk2)) - f*(D1*fd*(Pk2*k2**2*(1 - 3*r) + k1**2*(4*C*Pk2*(3*s - 1) + 2*C*Pkd2*k2*(1 - 3*s) - 3*Pk2*r + Pk2)) + Dd*f*(Pk2*k2**2*(1 - 4*r) + k1**2*(4*C*Pk2*(4*s - 1) + 2*C*Pkd2*k2*(1 - 4*s) - 4*Pk2*r + Pk2))))/(693*d*k1**2*k3**2) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*f*st**5*(-143*b1**2*k1**2*(4*Pk2 - Pkd2*k2)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) - 13*b1*f*(22*D1*bd1*k1**2*s*(4*Pk2 - Pkd2*k2) + 3*D1*fd*(-9*Pk2*k2**2*r + k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) + 9*Dd*Pk2*f*k2**2*(1 - 4*r) + 3*Dd*f*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 3*f**2*(13*D1*bd1*(-4*Pk2*k1**2*s + 3*Pk2*k2**2*(r - 1) + Pkd2*k1**2*k2*s) + D1*fd*(9*Pk2*k2**2*(4*r - 1) - 2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 9*Dd*Pk2*f*k2**2*(4*r - 1) - 2*Dd*f*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)))/(9009*d*k1**2*k2) + np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*st**3*(-1287*b1**3*k1**2*(2*Pk2 - Pkd2*k2)*(D1*fd*s + Dd*f*(4*s - 1)) - 143*b1**2*(9*D1*bd1*f*k1**2*(2*Pk2 - Pkd2*k2)*(3*s - 1) - D1*fd*(Pk2*k2**2*r*(28*f + 9) + k1**2*(2*Pk2*f*(9*r + 28*s - 17) + 9*Pk2*(-2*K*(s - 1) + r - 2*s + 2) + Pkd2*f*k2*(8*s - 1) + Pkd2*k2*(9*K + 9)*(s - 1))) - Dd*f*(Pk2*k2**2*(14*f + 9)*(4*r - 1) + k1**2*(Pk2*f*(36*r + 112*s - 37) + 9*Pk2*(K*(2 - 8*s) + 4*r - 8*s + 1) + Pkd2*k2*(4*s - 1)*(9*K + 4*f + 9)))) + 13*b1*(-44*D1*K*Pk2*f*fd*k1**2*s + 22*D1*K*Pk2*f*fd*k1**2 + 22*D1*K*Pkd2*f*fd*k1**2*k2*s - 11*D1*K*Pkd2*f*fd*k1**2*k2 - 198*D1*Pk2*bd2*f*k1**2*s + 162*D1*Pk2*f**2*fd*k1**2*r + 342*D1*Pk2*f**2*fd*k1**2*s - 153*D1*Pk2*f**2*fd*k1**2 + 126*D1*Pk2*f**2*fd*k2**2*r - 42*D1*Pk2*f**2*fd*k2**2 + 22*D1*Pk2*f*fd*k1**2*r - 44*D1*Pk2*f*fd*k1**2*s + 11*D1*Pk2*f*fd*k1**2 + 22*D1*Pk2*f*fd*k2**2*r - 11*D1*Pk2*f*fd*k2**2 + 396*D1*Pk2*f*gd2*k1**2*s + 396*D1*Pk2*fd*g2*k1**2*s - 396*D1*Pk2*fd*g2*k1**2 + 99*D1*Pkd2*bd2*f*k1**2*k2*s + 27*D1*Pkd2*f**2*fd*k1**2*k2*s - 3*D1*Pkd2*f**2*fd*k1**2*k2 + 22*D1*Pkd2*f*fd*k1**2*k2*s - 11*D1*Pkd2*f*fd*k1**2*k2 - 198*D1*Pkd2*f*gd2*k1**2*k2*s - 198*D1*Pkd2*fd*g2*k1**2*k2*s + 198*D1*Pkd2*fd*g2*k1**2*k2 + 11*D1*bd1*f*(Pk2*k2**2*(14*f + 9)*(2*r - 1) + k1**2*(Pk2*f*(18*r + 56*s - 3) - 9*Pk2*(-2*r + s*(4*K + 4) + 1) + Pkd2*f*k2*(8*s - 3) + Pkd2*k2*s*(18*K + 18))) - 88*Dd*K*Pk2*f**2*k1**2*s + 22*Dd*K*Pk2*f**2*k1**2 + 44*Dd*K*Pkd2*f**2*k1**2*k2*s - 11*Dd*K*Pkd2*f**2*k1**2*k2 + 216*Dd*Pk2*f**3*k1**2*r + 456*Dd*Pk2*f**3*k1**2*s - 168*Dd*Pk2*f**3*k1**2 + 168*Dd*Pk2*f**3*k2**2*r - 42*Dd*Pk2*f**3*k2**2 + 44*Dd*Pk2*f**2*k1**2*r - 88*Dd*Pk2*f**2*k1**2*s + 11*Dd*Pk2*f**2*k1**2 + 44*Dd*Pk2*f**2*k2**2*r - 11*Dd*Pk2*f**2*k2**2 + 1584*Dd*Pk2*f*g2*k1**2*s - 396*Dd*Pk2*f*g2*k1**2 + 36*Dd*Pkd2*f**3*k1**2*k2*s - 9*Dd*Pkd2*f**3*k1**2*k2 + 44*Dd*Pkd2*f**2*k1**2*k2*s - 11*Dd*Pkd2*f**2*k1**2*k2 - 792*Dd*Pkd2*f*g2*k1**2*k2*s + 198*Dd*Pkd2*f*g2*k1**2*k2 - 99*b2*k1**2*(2*Pk2 - Pkd2*k2)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))) + f*(13*D1*bd1*(3*f**2*(14*Pk2*k2**2*r + k1**2*(Pk2*(18*r + 38*s - 5) + Pkd2*k2*(3*s - 2))) + 11*f*(Pk2*k2**2*r + k1**2*(Pk2*(r - s*(2*K + 2)) + Pkd2*k2*s*(K + 1))) + 198*g2*k1**2*s*(2*Pk2 - Pkd2*k2)) - 143*b2*k1**2*(2*Pk2 - Pkd2*k2)*(9*D1*bd1*s + D1*fd*(2*s - 1) + Dd*f*(4*s - 1)) + k1**2*(3*D1*Pk2*f**2*fd*(180*r + 416*s - 149) - 143*D1*f*s*(2*Pk2 - Pkd2*k2)*(bd2 - 2*gd2) + 286*D1*fd*g2*(2*Pk2 - Pkd2*k2)*(2*s - 1) + 3*Dd*Pk2*f**3*(180*r + 416*s - 149) + 286*Dd*f*g2*(2*Pk2 - Pkd2*k2)*(4*s - 1))))/(45045*d*k1**2*k2) + np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*st**3*(-11*D1*bd1*f*(-9*b1*k2**2*(Pk2*k2**2*(2*r - 1) + k1**2*(2*C*Pkd2*k2*(2*s - 1) + Pk2*(2*r - 1))) + f*(-Pk2*k2**4*r + k1**4*(-2*C*Pkd2*k2*s - Pk2*(-4*C*s + r + 2*s - 1)) + k1**2*k2**2*(-2*C*Pkd2*k2*(s - 1) - Pk2*(36*C*(r + 2*s - 1) + 2*r + 2*s - 1)))) + 99*b1**2*k2**2*(D1*fd*(Pk2*k2**2*r + k1**2*(2*C*Pkd2*k2*s + Pk2*r)) + Dd*f*(Pk2*k2**2*(4*r - 1) + k1**2*(2*C*Pkd2*k2*(4*s - 1) + Pk2*(4*r - 1)))) - 11*b1*f*(D1*fd*(Pk2*k2**4*(1 - 2*r) + 2*k1**4*(C*Pkd2*k2*(1 - 2*s) - Pk2*(C*(2 - 4*s) + r + 2*s - 1)) - k1**2*k2**2*(4*C*Pkd2*k2*s + Pk2*(72*C*(r + 2*s - 1) + 4*r + 4*s - 3))) + Dd*f*(Pk2*k2**4*(1 - 4*r) + k1**4*(2*C*Pkd2*k2*(1 - 4*s) + Pk2*(16*C*s - 4*C - 4*r - 8*s + 3)) - 2*k1**2*k2**2*(C*Pkd2*k2*(4*s - 1) + 2*Pk2*(9*C*(4*r + 8*s - 3) + 2*r + 2*s - 1)))) + f**2*k1**2*(D1*fd*(Pk2*k2**2*(4*C*(81*r + 66*s - 49) + 9*r + 18*s - 9) - 3*k1**2*(2*C*Pkd2*k2*(1 - 3*s) + Pk2*(12*C*s - 4*C - 3*r - 6*s + 3))) + Dd*f*(Pk2*k2**2*(4*C*(108*r + 88*s - 49) + 12*r + 24*s - 9) - 3*k1**2*(2*C*Pkd2*k2*(1 - 4*s) + Pk2*(16*C*s - 4*C - 4*r - 8*s + 3)))))/(3465*d*k1**2*k2*k3**2) - 8*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**3*f*k2**2*st**3*(C - 1)*(11*D1*bd1*f*(r - 1) + 11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 3*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(3465*d*k3**2) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**2*f**2*k2*st**3*(13*D1*bd1*f*(r - 1) + 13*b1*(3*D1*fd*r + Dd*f*(4*r - 1)) + 5*f*(4*r - 1)*(D1*fd + Dd*f))/(3003*d*k1) + 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct**2*f*k2*st**3*(-k1**2*(C - 2) + k2**2)*(11*D1*bd1*f*(r - 1) + 11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 3*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(3465*d*k1*k3**2) + 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct*f*st**3*(143*b1**2*(2*D1*fd*r + Dd*f*(4*r - 1)) + 13*b1*f*(11*D1*bd1*(2*r - 1) + 3*D1*fd*(9*r - 1) + 9*Dd*f*(4*r - 1)) + 3*f**2*(13*D1*bd1*(3*r - 2) + (4*r - 1)*(10*D1*fd + 10*Dd*f)))/(45045*d) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*ct*f*st**3*(k1**2 + k2**2*(4*C + 1))*(11*D1*bd1*f*(r - 1) + 11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 3*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(3465*d*k3**2) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*f**2*k2*st**5*(13*D1*bd1*f*(r - 1) + 13*b1*(3*D1*fd*r + Dd*f*(4*r - 1)) + 3*f*(4*r - 1)*(D1*fd + Dd*f))/(9009*d*k1) + np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd1*f*st**3*(143*b1**2*(k1**2 + 2*k2**2)*(2*D1*fd*r + Dd*f*(4*r - 1)) + 13*b1*f*(11*D1*bd1*(k1**2 + 2*k2**2)*(2*r - 1) + 3*D1*fd*(k1**2*(6*r - 1) + 2*k2**2*(3*r - 1)) + 6*Dd*f*(k1**2 + k2**2)*(4*r - 1)) + 3*f**2*(13*D1*bd1*(k1**2*(2*r - 1) + 2*k2**2*r) + k1**2*(4*r - 1)*(5*D1*fd + 5*Dd*f)))/(45045*d*k1*k2)
        perm13 = 16*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**4*f*k2**5*st**3*(C - 1)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 3*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(693*d*k3**6) + 8*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**4*f*k2**3*st**3*(C - 1)*(11*b1*(2*s - 1)*(D1*fd + 2*Dd*f) + f*(11*D1*bd1*s + D1*fd*(9*s - 3) + 6*Dd*f*(2*s - 1)))/(693*d*k3**4) + 8*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**3*f*k2**4*st**3*(13*D1*bd1*f*(30*f*k2**2 + k1**2*(352*C - 297))*(r + s - 1) + 13*b1*(D1*fd*(30*f*k2**2*(3*r + 3*s - 2) + k1**2*(352*C - 297)*(2*r + 2*s - 1)) + Dd*f*(30*f*k2**2 + k1**2*(352*C - 297))*(4*r + 4*s - 3)) + 3*f*(D1*fd*(50*f*k2**2*(4*r + 4*s - 3) + k1**2*(416*C - 351)*(3*r + 3*s - 2)) + Dd*f*(50*f*k2**2 + k1**2*(416*C - 351))*(4*r + 4*s - 3)))/(45045*d*k1*k3**6) + 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**3*f*k2**2*st**3*(11*b1*(2*s - 1)*(D1*fd + 2*Dd*f) + f*(11*D1*bd1*s + D1*fd*(9*s - 3) + 6*Dd*f*(2*s - 1)))/(693*d*k1*k3**2) + 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**3*f*k2**2*st**3*(11*b1*(D1*fd*(k1**2*(28*C - 23)*(2*s - 1) + k2**2*(-12*C*r + 22*r + 10*s - 5)) + Dd*f*(k1**2*(56*C - 46)*(2*s - 1) + k2**2*(-24*C*r + 6*C + 44*r + 20*s - 21))) + f*(11*D1*bd1*(k1**2*s*(28*C - 23) + k2**2*(-6*C*r + 6*C + 11*r + 5*s - 11)) + D1*fd*(k1**2*(84*C - 69)*(3*s - 1) + 5*k2**2*(-30*C*r + 10*C + 39*r + 9*s - 16)) + Dd*f*k1**2*(168*C - 138)*(2*s - 1) + 5*Dd*f*k2**2*(C*(10 - 40*r) + 52*r + 12*s - 19)))/(3465*d*k1*k3**4) + 16*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*f*k2**5*st**5*(C - 1)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(693*d*k3**6) + 8*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*f*k2**3*st**5*(C - 1)*(11*b1*(2*s - 1)*(D1*fd + 2*Dd*f) + f*(11*D1*bd1*s + D1*fd*(3*s - 1) + 2*Dd*f*(2*s - 1)))/(693*d*k3**4) + 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*k2**3*st**3*(13*D1*bd1*f*(r + s - 1)*(90*f**2*k2**2 + 11*f*(k1**2*(74*C - 52) + k2**2*(K - 20*b1 - 1)) - k2**2*(-198*K*b1 + 198*b1 + 198*g2)) - 143*b1**2*k2**2*(D1*fd*(10*f*(2*r + 2*s - 1) + (9 - 9*K)*(r + s)) + Dd*f*(-9*K + 10*f + 9)*(4*r + 4*s - 3)) + 13*b1*(D1*(90*f**2*fd*k2**2*(3*r + 3*s - 2) + 11*f*(fd*(k1**2*(74*C - 52) + k2**2*(K - 1))*(2*r + 2*s - 1) - 18*gd2*k2**2*(r + s - 1)) - 198*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(90*f**2*k2**2 + 11*f*(k1**2*(74*C - 52) + k2**2*(K - 1)) - 198*g2*k2**2)) + 2*f*(D1*(300*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(1443*C - 1014)*(3*r + 3*s - 2) - 143*f*gd2*k2**2*(r + s - 1) - 143*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(300*f**2*k2**2 + f*k1**2*(1443*C - 1014) - 143*g2*k2**2)))/(45045*d*k3**6) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*k2*st**3*(198*b1**2*k1**2*(C - 1)*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) - 11*b1*f*(2*D1*(-18*bd1*k1**2*s*(C - 1) + fd*k1**2*(9*C - 8)*(2*s - 1) + fd*k2**2*r) + Dd*f*(k1**2*(36*C - 32)*(2*s - 1) + k2**2*(4*r - 1))) + f**2*(-11*D1*bd1*(k1**2*s*(18*C - 16) + k2**2*(r - 1)) + D1*fd*(-k1**2*(60*C - 54)*(3*s - 1) + 35*k2**2*(1 - 3*r)) - Dd*f*k1**2*(120*C - 108)*(2*s - 1) + 35*Dd*f*k2**2*(1 - 4*r)))/(3465*d*k1**2*k3**2) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct**2*k2*st**3*(2574*b1**2*k1**2*k2**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) - 13*b1*f*(D1*(-198*bd1*k1**2*k2**2*(C - 1)*(2*r + 2*s - 1) + fd*(75*f*k2**4*r - k1**4*(594*C - 396)*(2*s - 1) + 22*k1**2*k2**2*(C*(68*r + 62*s - 30) - 65*r - 64*s + 31))) + Dd*f*(25*f*k2**4*(4*r - 1) - k1**4*(1188*C - 792)*(2*s - 1) + 11*k1**2*k2**2*(8*C*(34*r + 31*s - 24) - 260*r - 256*s + 193))) + f**2*(D1*(13*bd1*(-25*f*k2**4*(r - 1) + k1**4*s*(594*C - 396) - 11*k1**2*k2**2*(C*(68*r + 62*s - 70) - 65*r - 64*s + 67)) + fd*(285*f*k2**4*(1 - 4*r) + k1**4*(2106*C - 1404)*(3*s - 1) - 13*k1**2*k2**2*(2*C*(507*r + 192*s - 233) - 891*r - 402*s + 431))) + Dd*f*(285*f*k2**4*(1 - 4*r) + k1**4*(4212*C - 2808)*(2*s - 1) - 13*k1**2*k2**2*(2*C*(676*r + 256*s - 297) - 1188*r - 536*s + 565))))/(45045*d*k1**2*k3**4) + 8*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*f*k2**4*st**5*(13*D1*bd1*f*(6*f*k2**2 + k1**2*(44*C - 33))*(r + s - 1) + 13*b1*(D1*fd*(6*f*k2**2*(3*r + 3*s - 2) + k1**2*(44*C - 33)*(2*r + 2*s - 1)) + Dd*f*(6*f*k2**2 + k1**2*(44*C - 33))*(4*r + 4*s - 3)) + f*(D1*fd*(18*f*k2**2*(4*r + 4*s - 3) + k1**2*(52*C - 39)*(3*r + 3*s - 2)) + Dd*f*(18*f*k2**2 + k1**2*(52*C - 39))*(4*r + 4*s - 3)))/(9009*d*k1*k3**6) + 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*f*k2**2*st**5*(11*b1*(2*s - 1)*(D1*fd + 2*Dd*f) + f*(11*D1*bd1*s + D1*fd*(3*s - 1) + 2*Dd*f*(2*s - 1)))/(693*d*k1*k3**2) + 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*f*k2**2*st**5*(11*b1*(D1*fd*(k1**2*(4*C - 3)*(2*s - 1) + k2**2*(-4*C*r + 6*r + 2*s - 1)) + Dd*f*(k1**2*(8*C - 6)*(2*s - 1) + k2**2*(-8*C*r + 2*C + 12*r + 4*s - 5))) + f*(11*D1*bd1*(k1**2*s*(4*C - 3) + k2**2*(-2*C*(r - 1) + 3*r + s - 3)) + D1*fd*(k1**2*(4*C - 3)*(3*s - 1) + k2**2*(C*(2 - 6*r) + 9*r + 3*s - 4)) + Dd*f*k1**2*(8*C - 6)*(2*s - 1) + Dd*f*k2**2*(C*(2 - 8*r) + 12*r + 4*s - 5)))/(693*d*k1*k3**4) + 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*k1*k2**2*st**3*(13*D1*bd1*f*(r + s - 1)*(24*f**2*k2**2 + 11*f*(k1**2*(36*C - 21) + k2**2*(2*K - 32*b1 - 1)) - k2**2*(-396*K*b1 + 198*b1 + 396*g2)) - 143*b1**2*k2**2*(D1*fd*(16*f*(2*r + 2*s - 1) + (9 - 18*K)*(r + s)) + Dd*f*(-18*K + 16*f + 9)*(4*r + 4*s - 3)) + 13*b1*(D1*(24*f**2*fd*k2**2*(3*r + 3*s - 2) + 11*f*(fd*(k1**2*(36*C - 21) + k2**2*(2*K - 1))*(2*r + 2*s - 1) - 36*gd2*k2**2*(r + s - 1)) - 396*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(24*f**2*k2**2 + 11*f*(k1**2*(36*C - 21) + k2**2*(2*K - 1)) - 396*g2*k2**2)) + f*(D1*(360*f**2*fd*k2**2*(4*r + 4*s - 3) + 13*f*(fd*k1**2*(108*C - 63)*(3*r + 3*s - 2) - 44*gd2*k2**2*(r + s - 1)) - 572*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(360*f**2*k2**2 + f*k1**2*(1404*C - 819) - 572*g2*k2**2)))/(45045*d*k3**6) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*st**3*(D1*bd1*f**2*s + 9*b1**2*(D1*fd*(s - 1) + 2*Dd*f*(2*s - 1)) + b1*f*(18*D1*bd1*s + D1*fd*(2*s - 1) + 2*Dd*f*(2*s - 1)))/(315*d*k1) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*st**3*(99*b1**2*(D1*fd*(k1**2*(4*C - 3)*(s - 1) + k2**2*r*(2 - 2*C)) + 2*Dd*f*(k1**2*(4*C - 3)*(2*s - 1) + k2**2*(-4*C*r + C + 4*r - 1))) - 11*b1*f*(2*D1*(9*bd1*k1**2*s*(3 - 4*C) + 9*bd1*k2**2*(C - 1)*(2*r - 1) + fd*k1**2*(6*C - 3)*(2*s - 1) + fd*k2**2*(C*(2*r - 1) + 9*r + 20*s - 9)) + Dd*f*(k1**2*(24*C - 12)*(2*s - 1) + k2**2*(C*(8*r - 2) + 36*r + 80*s - 49))) - f**2*(D1*(66*bd1*k1**2*s*(2*C - 1) + 11*bd1*k2**2*(r*(2*C + 9) + 20*s - 11) + fd*k1**2*(48*C - 27)*(3*s - 1) + fd*k2**2*(-64*C*(3*r - 1) + 195*r + 84*s - 93)) + Dd*f*(k1**2*(96*C - 54)*(2*s - 1) + k2**2*(-256*C*r + 64*C + 260*r + 112*s - 121))))/(3465*d*k1*k3**2) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*ct*st**3*(143*b1**2*k2**2*(D1*fd*(k1**2*(36*C - 27)*(r + s - 1) + k2**2*(4*f*(4*r + 4*s - 3) + r*(18 - 9*K) + 9*s)) + Dd*f*(k1**2*(36*C - 27)*(4*r + 4*s - 3) + k2**2*(-36*K*r + 9*K + 8*f*(4*r + 4*s - 3) + 72*r + 36*s - 36))) - 13*b1*(D1*(-2*f**2*k2**4*(22*bd1*(4*r + 4*s - 3) + fd*(-60*r - 129*s + 64)) - 11*f*(fd*(k1**4*(20*C - 11)*(2*s - 1) + k1**2*k2**2*(-4*C*(41*r + 52*s - 25) + 114*r + 152*s - 73) + k2**4*(-2*K*r + K + 4*r + 2*s - 2)) + 9*k2**2*(bd1*k1**2*(4*C - 3)*(2*r + 2*s - 1) + bd1*k2**2*(-2*K*r + K + 4*r + 2*s - 3) + 2*gd2*k2**2*r)) - 198*fd*g2*k2**4*r) + Dd*f*(4*f**2*k2**4*(40*r + 86*s - 53) - 11*f*(k1**4*(40*C - 22)*(2*s - 1) + k1**2*k2**2*(-328*C*r - 416*C*s + 290*C + 228*r + 304*s - 209) + k2**4*(-4*K*r + K + 8*r + 4*s - 4)) + 198*g2*k2**4*(1 - 4*r))) - f*(D1*(2*f**2*k2**4*(13*bd1*(20*r + 43*s - 42) + 6*fd*(192*r + 130*s - 113)) - 13*f*(11*bd1*(k1**4*s*(20*C - 11) + k1**2*k2**2*(-2*C*(41*r + 52*s - 43) + 57*r + 76*s - 60) + k2**4*(-r*(K - 2) + s - 1)) + fd*k1**4*(60*C - 33)*(3*s - 1) + fd*k1**2*k2**2*(-14*C*(69*r + 42*s - 37) + 636*r + 423*s - 353) + 22*gd2*k2**4*r) - 286*g2*k2**4*(9*bd1*(r - 1) + fd*(2*r - 1))) + 2*Dd*f*(6*f**2*k2**4*(192*r + 130*s - 113) - 13*f*(k1**4*(60*C - 33)*(2*s - 1) + k1**2*k2**2*(-7*C*(92*r + 56*s - 51) + 424*r + 282*s - 247)) + 143*g2*k2**4*(1 - 4*r))))/(45045*d*k1*k3**4) + 8*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*f*k2**3*st**5*(13*D1*bd1*f*(k1**2*(22*C - 11) + k2**2*(-22*b1 + 3*f))*(r + s - 1) - 143*b1**2*k2**2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 13*b1*(D1*fd*(3*f*k2**2*(3*r + 3*s - 2) + k1**2*(22*C - 11)*(2*r + 2*s - 1)) + Dd*f*(3*f*k2**2 + k1**2*(22*C - 11))*(4*r + 4*s - 3)) + f*(D1*fd*(12*f*k2**2*(4*r + 4*s - 3) + k1**2*(26*C - 13)*(3*r + 3*s - 2)) + Dd*f*(12*f*k2**2 + k1**2*(26*C - 13))*(4*r + 4*s - 3)))/(9009*d*k3**6) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*f*k2*st**5*(11*b1*(2*D1*fd*(k1**2*(2*C - 1)*(2*s - 1) + k2**2*r) + Dd*f*(k1**2*(8*C - 4)*(2*s - 1) + k2**2*(4*r - 1))) + f*(D1*(22*bd1*k1**2*s*(2*C - 1) + 11*bd1*k2**2*(r - 1) + fd*k1**2*(4*C - 2)*(3*s - 1) + fd*k2**2*(3*r - 1)) + Dd*f*(k1**2*(8*C - 4)*(2*s - 1) + k2**2*(4*r - 1))))/(693*d*k1**2*k3**2) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*f*k2*st**5*(13*b1*(D1*fd*(27*f*k2**4*r - k1**4*(44*C - 22)*(2*s - 1) + 22*k1**2*k2**2*(C*(8*r + 4*s - 2) - 5*r - 2*s + 1)) + Dd*f*(9*f*k2**4*(4*r - 1) - k1**4*(88*C - 44)*(2*s - 1) + 11*k1**2*k2**2*(16*C*(2*r + s - 1) - 20*r - 8*s + 9))) + f*(D1*(-13*bd1*(-9*f*k2**4*(r - 1) + k1**4*s*(44*C - 22) - 11*k1**2*k2**2*(4*C*(2*r + s - 2) - 5*r - 2*s + 5)) + fd*(27*f*k2**4*(4*r - 1) - k1**4*(52*C - 26)*(3*s - 1) + 13*k1**2*k2**2*(12*C*(2*r + s - 1) - 15*r - 6*s + 7))) + Dd*f*(27*f*k2**4*(4*r - 1) - k1**4*(104*C - 52)*(2*s - 1) + 13*k1**2*k2**2*(16*C*(2*r + s - 1) - 20*r - 8*s + 9))))/(9009*d*k1**2*k3**4) - 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*k1**2*k2*st**3*(13*D1*bd1*f*(r + s - 1)*(6*f**2*k2**2 - 11*f*(k1**2*(6*C - 3) + k2**2*(K - 12*b1)) + k2**2*(-198*K*b1 + 198*g2)) + 429*b1**2*k2**2*(D1*fd*(-3*K*(r + s) + f*(4*r + 4*s - 2)) + Dd*f*(-3*K + 2*f)*(4*r + 4*s - 3)) + 13*b1*(D1*(6*f**2*fd*k2**2*(3*r + 3*s - 2) - 11*f*fd*(K*k2**2 + k1**2*(6*C - 3))*(2*r + 2*s - 1) + 198*f*gd2*k2**2*(r + s - 1) + 198*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(6*f**2*k2**2 - 11*f*(K*k2**2 + k1**2*(6*C - 3)) + 198*g2*k2**2)) + f*(D1*(-60*f**2*fd*k2**2*(4*r + 4*s - 3) - f*fd*k1**2*(234*C - 117)*(3*r + 3*s - 2) + 286*f*gd2*k2**2*(r + s - 1) + 286*fd*g2*k2**2*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(60*f**2*k2**2 + f*k1**2*(234*C - 117) - 286*g2*k2**2)))/(45045*d*k3**6) - np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*st**3*(2574*b1**3*k2**4*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) - 143*b1**2*k2**2*(D1*(-18*bd1*f*k2**2*(3*r + 3*s - 2) + fd*k1**2*(36*C - 18)*(r + s - 1) + fd*k2**2*(-36*K*r - 18*K*s + f*(70*r + 88*s - 46) + 9*r)) + Dd*f*(k1**2*(36*C - 18)*(4*r + 4*s - 3) + k2**2*(-72*K*(2*r + s - 1) + f*(140*r + 176*s - 123) + 36*r - 9))) - 13*b1*(D1*(f**2*k2**4*(11*bd1*(70*r + 88*s - 77) + fd*(90*r - 174*s + 67)) + 11*f*(fd*(k1**4*(4*C - 2)*(2*s - 1) - 2*k1**2*k2**2*(C*(56*r + 88*s - 42) - 29*r - 46*s + 22) + k2**4*(-4*K*(2*r + s - 1) + 2*r - 1)) - 9*k2**2*(bd1*(k1**2*(2 - 4*C)*(2*r + 2*s - 1) + k2**2*(K*(8*r + 4*s - 6) - 2*r + 1)) + 2*k2**2*(bd2*(r + s - 1) - 2*gd2*(2*r + s - 1)))) - 198*fd*k2**4*(b2*(r + s) - 2*g2*(2*r + s))) + Dd*f*(2*f**2*k2**4*(60*r - 116*s + 43) + 11*f*(k1**4*(8*C - 4)*(2*s - 1) + k1**2*k2**2*(-8*C*(28*r + 44*s - 29) + 116*r + 184*s - 121) + k2**4*(-8*K*(2*r + s - 1) + 4*r - 1)) - 198*k2**4*(b2*(4*r + 4*s - 3) - 8*g2*(2*r + s - 1)))) + f*(D1*(f**2*k2**4*(-13*bd1*(30*r - 58*s + 19) + 9*fd*(180*r + 208*s - 149)) - 13*f*(11*bd1*(k1**4*s*(4*C - 2) + k1**2*k2**2*(C*(-56*r - 88*s + 60) + 29*r + 46*s - 31) + k2**4*(-2*K*(2*r + s - 1) + r)) + fd*k1**4*(12*C - 6)*(3*s - 1) + fd*k1**2*k2**2*(-4*C*(135*r + 111*s - 82) + 279*r + 240*s - 173) + 22*k2**4*(-bd2*(r + s - 1) + 2*gd2*(2*r + s - 1))) + 286*k2**4*(9*b2*bd1*(r + s - 1) + b2*fd*(2*r + 2*s - 1) - 18*bd1*g2*(2*r + s - 2) - 4*fd*g2*(2*r + s - 1))) + Dd*f*(9*f**2*k2**4*(180*r + 208*s - 149) - 13*f*(k1**4*(24*C - 12)*(2*s - 1) + k1**2*k2**2*(C*(-720*r - 592*s + 476) + 372*r + 320*s - 253)) + 286*k2**4*(b2*(4*r + 4*s - 3) - 8*g2*(2*r + s - 1)))))/(45045*d*k2*k3**4) - np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*st**3*(D1*bd1*f**2*(k1**2*s*(4*C - 2) + k2**2*r) + 9*b1**2*(D1*fd*(k1**2*(4*C - 2)*(s - 1) + k2**2*r) + Dd*f*(k1**2*(8*C - 4)*(2*s - 1) + k2**2*(4*r - 1))) + b1*f*(D1*(36*bd1*k1**2*s*(2*C - 1) + 9*bd1*k2**2*(2*r - 1) + fd*k1**2*(4*C - 2)*(2*s - 1) + fd*k2**2*(2*r - 1)) + Dd*f*(k1**2*(8*C - 4)*(2*s - 1) + k2**2*(4*r - 1))))/(315*d*k1**2*k2) - np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pk3*st**3*(11*b1**2*(D1*fd*(-k1**4*(36*C - 18)*(s - 1) + k1**2*k2**2*r*(36*C - 27) + k2**4*r*(28*f + 9)) + Dd*f*(-k1**4*(72*C - 36)*(2*s - 1) + k1**2*k2**2*(36*C - 27)*(4*r - 1) + k2**4*(14*f + 9)*(4*r - 1))) + b1*f*(-11*D1*bd1*(k1**4*s*(72*C - 36) + k1**2*k2**2*(27 - 36*C)*(2*r - 1) - k2**4*(14*f + 9)*(2*r - 1)) + k2**2*(D1*fd*(-11*k1**2*(4*C*(16*r + 36*s - 17) - 32*r - 76*s + 35) + k2**2*(42*f*(3*r - 1) + 22*r - 11)) + Dd*f*(-44*k1**2*(4*C*(8*r + 18*s - 11) - 16*r - 38*s + 23) + k2**2*(42*f + 11)*(4*r - 1)))) + f**2*(D1*(-11*bd1*k1**2*k2**2*(4*C*(8*r + 18*s - 9) - 16*r - 38*s + 19) + bd1*k2**4*r*(42*f + 11) + fd*k1**4*(12*C - 6)*(3*s - 1) + fd*k1**2*k2**2*(-4*C*(81*r + 66*s - 49) + 171*r + 150*s - 107)) + Dd*f*k1**2*(k1**2*(24*C - 12)*(2*s - 1) + k2**2*(-4*C*(108*r + 88*s - 71) + 228*r + 200*s - 157))))/(3465*d*k1**2*k2*k3**2) - 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**4*f*k2**5*st**3*(C - 1)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 3*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(693*d*k3**5) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**3*f*k2**4*st**3*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 3*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(693*d*k1*k3**3) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**3*f*k2**4*st**3*(13*D1*bd1*f*(30*f*k2**2 + k1**2*(352*C - 297))*(r + s - 1) + 13*b1*(D1*fd*(30*f*k2**2*(3*r + 3*s - 2) + k1**2*(352*C - 297)*(2*r + 2*s - 1)) + Dd*f*(30*f*k2**2 + k1**2*(352*C - 297))*(4*r + 4*s - 3)) + 3*f*(D1*fd*(50*f*k2**2*(4*r + 4*s - 3) + k1**2*(416*C - 351)*(3*r + 3*s - 2)) + Dd*f*(50*f*k2**2 + k1**2*(416*C - 351))*(4*r + 4*s - 3)))/(45045*d*k1*k3**5) - 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**2*f*k2**5*st**5*(C - 1)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(693*d*k3**5) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**2*k2**3*st**3*(99*b1**2*(C - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + 11*b1*f*(9*D1*bd1*(C - 1)*(2*r + 2*s - 1) + D1*fd*(-2*C*(9*r + 9*s - 4) + 20*r + 20*s - 9) - Dd*f*(9*C - 10)*(4*r + 4*s - 3)) + f**2*(-11*D1*bd1*(C*(9*r + 9*s - 10) - 10*r - 10*s + 11) + (33 - 30*C)*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))))/(3465*d*k3**3) - np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct**2*k2**3*st**3*(13*D1*bd1*f*(r + s - 1)*(90*f**2*k2**2 + 11*f*(k1**2*(74*C - 52) + k2**2*(K - 20*b1 - 1)) - k2**2*(-198*K*b1 + 198*b1 + 198*g2)) - 143*b1**2*k2**2*(D1*fd*(10*f*(2*r + 2*s - 1) + (9 - 9*K)*(r + s)) + Dd*f*(-9*K + 10*f + 9)*(4*r + 4*s - 3)) + 13*b1*(D1*(90*f**2*fd*k2**2*(3*r + 3*s - 2) + 11*f*(fd*(k1**2*(74*C - 52) + k2**2*(K - 1))*(2*r + 2*s - 1) - 18*gd2*k2**2*(r + s - 1)) - 198*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(90*f**2*k2**2 + 11*f*(k1**2*(74*C - 52) + k2**2*(K - 1)) - 198*g2*k2**2)) + 2*f*(D1*(300*f**2*fd*k2**2*(4*r + 4*s - 3) + f*fd*k1**2*(1443*C - 1014)*(3*r + 3*s - 2) - 143*f*gd2*k2**2*(r + s - 1) - 143*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(300*f**2*k2**2 + f*k1**2*(1443*C - 1014) - 143*g2*k2**2)))/(45045*d*k3**5) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct*f*k2**4*st**5*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(693*d*k1*k3**3) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct*f*k2**4*st**5*(13*D1*bd1*f*(6*f*k2**2 + k1**2*(44*C - 33))*(r + s - 1) + 13*b1*(D1*fd*(6*f*k2**2*(3*r + 3*s - 2) + k1**2*(44*C - 33)*(2*r + 2*s - 1)) + Dd*f*(6*f*k2**2 + k1**2*(44*C - 33))*(4*r + 4*s - 3)) + f*(D1*fd*(18*f*k2**2*(4*r + 4*s - 3) + k1**2*(52*C - 39)*(3*r + 3*s - 2)) + Dd*f*(18*f*k2**2 + k1**2*(52*C - 39))*(4*r + 4*s - 3)))/(9009*d*k1*k3**5) - np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct*k1*k2**2*st**3*(13*D1*bd1*f*(r + s - 1)*(24*f**2*k2**2 + 11*f*(k1**2*(36*C - 21) + k2**2*(2*K - 32*b1 - 1)) - k2**2*(-396*K*b1 + 198*b1 + 396*g2)) - 143*b1**2*k2**2*(D1*fd*(16*f*(2*r + 2*s - 1) + (9 - 18*K)*(r + s)) + Dd*f*(-18*K + 16*f + 9)*(4*r + 4*s - 3)) + 13*b1*(D1*(24*f**2*fd*k2**2*(3*r + 3*s - 2) + 11*f*(fd*(k1**2*(36*C - 21) + k2**2*(2*K - 1))*(2*r + 2*s - 1) - 36*gd2*k2**2*(r + s - 1)) - 396*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(24*f**2*k2**2 + 11*f*(k1**2*(36*C - 21) + k2**2*(2*K - 1)) - 396*g2*k2**2)) + f*(D1*(360*f**2*fd*k2**2*(4*r + 4*s - 3) + 13*f*(fd*k1**2*(108*C - 63)*(3*r + 3*s - 2) - 44*gd2*k2**2*(r + s - 1)) - 572*fd*g2*k2**2*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(360*f**2*k2**2 + f*k1**2*(1404*C - 819) - 572*g2*k2**2)))/(45045*d*k3**5) - np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct*k2**2*st**3*(D1*bd1*f**2*(r + s) + 9*b1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*f*(9*D1*bd1*(2*r + 2*s - 1) + 2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)))/(315*d*k1*k3) - np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*ct*k2**2*st**3*(11*b1**2*(D1*fd*(k1**2*(36*C - 27)*(r + s - 1) + k2**2*(4*f*(4*r + 4*s - 3) + 9*r + 9*s)) + Dd*f*(k1**2*(36*C - 27) + k2**2*(8*f + 9))*(4*r + 4*s - 3)) + b1*f*(11*D1*bd1*(k1**2*(36*C - 27)*(2*r + 2*s - 1) + 2*k2**2*(f*(8*r + 8*s - 6) + 9*r + 9*s - 9)) + D1*fd*(-11*k1**2*(8*C*(5*r + 5*s - 2) - 24*r - 24*s + 9) + k2**2*(12*f*(6*r + 6*s - 5) + 22*r + 22*s - 11)) + Dd*f*(k1**2*(132 - 220*C) + k2**2*(24*f + 11))*(4*r + 4*s - 3)) + f**2*(D1*bd1*(-11*k1**2*(4*C*(5*r + 5*s - 6) - 12*r - 12*s + 15) + k2**2*(12*f*(2*r + 2*s - 1) + 11*r + 11*s - 11)) + k1**2*(45 - 72*C)*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3))))/(3465*d*k1*k3**3) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*f*k2**3*st**5*(2*C - 1)*(11*D1*bd1*f*(r + s - 1) + 11*b1*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(693*d*k3**3) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*f*k2**3*st**5*(13*D1*bd1*f*(k1**2*(22*C - 11) + k2**2*(-22*b1 + 3*f))*(r + s - 1) - 143*b1**2*k2**2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)) + 13*b1*(D1*fd*(3*f*k2**2*(3*r + 3*s - 2) + k1**2*(22*C - 11)*(2*r + 2*s - 1)) + Dd*f*(3*f*k2**2 + k1**2*(22*C - 11))*(4*r + 4*s - 3)) + f*(D1*fd*(12*f*k2**2*(4*r + 4*s - 3) + k1**2*(26*C - 13)*(3*r + 3*s - 2)) + Dd*f*(12*f*k2**2 + k1**2*(26*C - 13))*(4*r + 4*s - 3)))/(9009*d*k3**5) + np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*k1**2*k2*st**3*(13*D1*bd1*f*(r + s - 1)*(6*f**2*k2**2 - 11*f*(k1**2*(6*C - 3) + k2**2*(K - 12*b1)) + k2**2*(-198*K*b1 + 198*g2)) + 429*b1**2*k2**2*(D1*fd*(-3*K*(r + s) + f*(4*r + 4*s - 2)) + Dd*f*(-3*K + 2*f)*(4*r + 4*s - 3)) + 13*b1*(D1*(6*f**2*fd*k2**2*(3*r + 3*s - 2) - 11*f*fd*(K*k2**2 + k1**2*(6*C - 3))*(2*r + 2*s - 1) + 198*f*gd2*k2**2*(r + s - 1) + 198*fd*g2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(6*f**2*k2**2 - 11*f*(K*k2**2 + k1**2*(6*C - 3)) + 198*g2*k2**2)) + f*(D1*(-60*f**2*fd*k2**2*(4*r + 4*s - 3) - f*fd*k1**2*(234*C - 117)*(3*r + 3*s - 2) + 286*f*gd2*k2**2*(r + s - 1) + 286*fd*g2*k2**2*(2*r + 2*s - 1)) - Dd*f*(4*r + 4*s - 3)*(60*f**2*k2**2 + f*k1**2*(234*C - 117) - 286*g2*k2**2)))/(45045*d*k3**5) + np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*k2*st**3*(2*C - 1)*(D1*bd1*f**2*(r + s) + 9*b1**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*f*(9*D1*bd1*(2*r + 2*s - 1) + 2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)))/(315*d*k3) + np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk1*Pkd3*k2*st**3*(99*b1**3*k2**2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) - 11*b1**2*(D1*(-9*bd1*f*k2**2*(3*r + 3*s - 2) + fd*k1**2*(18*C - 9)*(r + s - 1) + fd*k2**2*(-9*K*(r + s) + f*(8*r + 8*s - 5))) + Dd*f*(k1**2*(18*C - 9) + k2**2*(-9*K + 4*f))*(4*r + 4*s - 3)) + b1*(-11*D1*bd1*f*(k1**2*(18*C - 9)*(2*r + 2*s - 1) + k2**2*(-18*K*(r + s - 1) + f*(8*r + 8*s - 7))) + D1*(-9*f**2*fd*k2**2*(5*r + 5*s - 4) + 11*f*(K*fd*k2**2*(2*r + 2*s - 1) + fd*k1**2*(2*C - 1)*(4*r + 4*s - 1) + k2**2*(9*bd2 - 18*gd2)*(r + s - 1)) + 99*fd*k2**2*(b2 - 2*g2)*(r + s)) - Dd*f*(4*r + 4*s - 3)*(15*f**2*k2**2 - 11*f*(K*k2**2 + k1**2*(4*C - 2)) - k2**2*(99*b2 - 198*g2))) + f*(D1*bd1*(-3*f**2*k2**2*(5*r + 5*s - 3) + 11*f*(K*k2**2*(r + s - 1) + k1**2*(2*C - 1)*(2*r + 2*s - 3)) + k2**2*(99*b2 - 198*g2)*(r + s - 1)) + D1*(f*fd*k1**2*(18*C - 9)*(3*r + 3*s - 2) + 11*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) + 11*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + Dd*f*(f*k1**2*(18*C - 9) + k2**2*(11*b2 - 22*g2))*(4*r + 4*s - 3)))/(3465*d*k3**3) - 8*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**3*f*k2**4*st**3*(C - 1)*(11*D1*bd1*f*(r - 1) + 11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 3*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(3465*d*k3**4) - 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**2*f*k2**3*st**3*(11*D1*bd1*f*(r - 1) + 11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 3*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(3465*d*k1*k3**2) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct**2*f*k2**3*st**3*(13*D1*bd1*f*(r - 1)*(15*f*k2**2 + k1**2*(110*C - 88)) + 13*b1*(D1*fd*r*(45*f*k2**2 + k1**2*(220*C - 176)) + Dd*f*(4*r - 1)*(15*f*k2**2 + k1**2*(110*C - 88))) + 3*f*(D1*fd*(25*f*k2**2*(4*r - 1) + k1**2*(130*C - 104)*(3*r - 1)) + Dd*f*(4*r - 1)*(25*f*k2**2 + k1**2*(130*C - 104))))/(45045*d*k1*k3**4) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct*f*k2**2*st**3*(4*C - 3)*(11*D1*bd1*f*(r - 1) + 11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 3*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1)))/(3465*d*k3**2) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*ct*f*k2**2*st**3*(13*D1*bd1*f*(k1**2*(88*C - 55)*(r - 1) + 2*k2**2*(-22*b1*r + 11*b1 + 6*f*r - 9*f)) - 286*b1**2*k2**2*(2*D1*fd*r + Dd*f*(4*r - 1)) + 13*b1*(2*D1*fd*(3*f*k2**2*(6*r + 1) + k1**2*r*(88*C - 55)) + Dd*f*(4*r - 1)*(12*f*k2**2 + k1**2*(88*C - 55))) + 3*f*(D1*fd*(30*f*k2**2*(4*r - 1) + k1**2*(104*C - 65)*(3*r - 1)) + Dd*f*(4*r - 1)*(30*f*k2**2 + k1**2*(104*C - 65))))/(45045*d*k3**4) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*f**2*k2**5*st**5*(13*D1*bd1*f*(r - 1) + 13*b1*(3*D1*fd*r + Dd*f*(4*r - 1)) + 3*f*(4*r - 1)*(D1*fd + Dd*f))/(9009*d*k1*k3**4) + np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*f*k1*k2*st**3*(13*D1*bd1*f*(k1**2*(22 - 44*C)*(r - 1) + 3*k2**2*(22*b1*r - 11*b1 + 3*f)) + 429*b1**2*k2**2*(2*D1*fd*r + Dd*f*(4*r - 1)) - 13*b1*(D1*fd*(9*f*k2**2 + k1**2*r*(88*C - 44)) + Dd*f*k1**2*(44*C - 22)*(4*r - 1)) - 3*f*(D1*fd*(15*f*k2**2*(4*r - 1) + k1**2*(52*C - 26)*(3*r - 1)) + Dd*f*(4*r - 1)*(15*f*k2**2 + k1**2*(52*C - 26))))/(45045*d*k3**4) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk3*Pkd1*f*k2*st**3*(D1*bd1*f*(k1**2*(11 - 22*C)*(r - 1) + k2**2*(11*b1*(2*r - 1) + 3*f*r)) + (b1*k2**2 + k1**2*(1 - 2*C))*(11*b1*(2*D1*fd*r + Dd*f*(4*r - 1)) + 3*f*(D1*fd*(3*r - 1) + Dd*f*(4*r - 1))))/(3465*d*k1*k3**2)
        perm23 = 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**4*f*k1**2*k2**3*st**3*(468*C*D1*f*fd*r + 468*C*D1*f*fd*s - 312*C*D1*f*fd + 624*C*Dd*f**2*r + 624*C*Dd*f**2*s - 468*C*Dd*f**2 + 286*D1*bd1*f*(K - 1)*(r + s - 1) + 420*D1*f**2*fd*r + 420*D1*f**2*fd*s - 315*D1*f**2*fd - 468*D1*f*fd*r - 468*D1*f*fd*s + 312*D1*f*fd - 572*D1*f*gd2*r - 572*D1*f*gd2*s + 572*D1*f*gd2 - 1144*D1*fd*g2*r - 1144*D1*fd*g2*s + 572*D1*fd*g2 + 420*Dd*f**3*r + 420*Dd*f**3*s - 315*Dd*f**3 - 624*Dd*f**2*r - 624*Dd*f**2*s + 468*Dd*f**2 - 2288*Dd*f*g2*r - 2288*Dd*f*g2*s + 1716*Dd*f*g2 + 286*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))/(9009*d*k3**6) - 8*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**3*f*k1*k2**2*st**3*(-1404*C*D1*f*fd*k1**2*r - 1404*C*D1*f*fd*k1**2*s + 936*C*D1*f*fd*k1**2 - 2340*C*D1*f*fd*k2**2*r - 2340*C*D1*f*fd*k2**2*s + 1560*C*D1*f*fd*k2**2 - 1872*C*Dd*f**2*k1**2*r - 1872*C*Dd*f**2*k1**2*s + 1404*C*Dd*f**2*k1**2 - 3120*C*Dd*f**2*k2**2*r - 3120*C*Dd*f**2*k2**2*s + 2340*C*Dd*f**2*k2**2 - 13*D1*bd1*f*(k1**2*(66*K - 66) - k2**2*(-110*K + 30*f + 55))*(r + s - 1) - 2400*D1*f**2*fd*k1**2*r - 2400*D1*f**2*fd*k1**2*s + 1800*D1*f**2*fd*k1**2 + 1404*D1*f*fd*k1**2*r + 1404*D1*f*fd*k1**2*s - 936*D1*f*fd*k1**2 + 1755*D1*f*fd*k2**2*r + 1755*D1*f*fd*k2**2*s - 1170*D1*f*fd*k2**2 + 1716*D1*f*gd2*k1**2*r + 1716*D1*f*gd2*k1**2*s - 1716*D1*f*gd2*k1**2 + 2860*D1*f*gd2*k2**2*r + 2860*D1*f*gd2*k2**2*s - 2860*D1*f*gd2*k2**2 + 3432*D1*fd*g2*k1**2*r + 3432*D1*fd*g2*k1**2*s - 1716*D1*fd*g2*k1**2 + 5720*D1*fd*g2*k2**2*r + 5720*D1*fd*g2*k2**2*s - 2860*D1*fd*g2*k2**2 - 2400*Dd*f**3*k1**2*r - 2400*Dd*f**3*k1**2*s + 1800*Dd*f**3*k1**2 + 1872*Dd*f**2*k1**2*r + 1872*Dd*f**2*k1**2*s - 1404*Dd*f**2*k1**2 + 2340*Dd*f**2*k2**2*r + 2340*Dd*f**2*k2**2*s - 1755*Dd*f**2*k2**2 + 6864*Dd*f*g2*k1**2*r + 6864*Dd*f*g2*k1**2*s - 5148*Dd*f*g2*k1**2 + 11440*Dd*f*g2*k2**2*r + 11440*Dd*f*g2*k2**2*s - 8580*Dd*f*g2*k2**2 + 13*b1*(D1*fd*(k1**2*(66 - 66*K)*(2*r + 2*s - 1) + 5*k2**2*(6*f*(3*r + 3*s - 2) + (11 - 22*K)*(2*r + 2*s - 1))) + Dd*f*(k1**2*(66 - 66*K) + k2**2*(-110*K + 30*f + 55))*(4*r + 4*s - 3)))/(45045*d*k3**6) + 8*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**2*f*k1**2*k2**3*st**5*(78*C*D1*f*fd*r + 78*C*D1*f*fd*s - 52*C*D1*f*fd + 104*C*Dd*f**2*r + 104*C*Dd*f**2*s - 78*C*Dd*f**2 + 143*D1*bd1*f*(K - 1)*(r + s - 1) + 252*D1*f**2*fd*r + 252*D1*f**2*fd*s - 189*D1*f**2*fd - 78*D1*f*fd*r - 78*D1*f*fd*s + 52*D1*f*fd - 286*D1*f*gd2*r - 286*D1*f*gd2*s + 286*D1*f*gd2 - 572*D1*fd*g2*r - 572*D1*fd*g2*s + 286*D1*fd*g2 + 252*Dd*f**3*r + 252*Dd*f**3*s - 189*Dd*f**3 - 104*Dd*f**2*r - 104*Dd*f**2*s + 78*Dd*f**2 - 1144*Dd*f*g2*r - 1144*Dd*f*g2*s + 858*Dd*f*g2 + 143*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))/(9009*d*k3**6) - 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct**2*k2*st**3*(13*D1*bd1*f*(r + s - 1)*(90*f**2*k1**2*k2**2 - 11*f*(10*K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(2*C + 24*K - 14)) + k1**2*k2**2*(-198*K*b1 + 198*b1 + 198*g2)) - 1287*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) + 13*b1*(D1*(90*f**2*fd*k1**2*k2**2*(3*r + 3*s - 2) - 11*f*fd*(2*r + 2*s - 1)*(10*K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(2*C + 24*K - 14)) + 198*f*gd2*k1**2*k2**2*(r + s - 1) + 198*fd*g2*k1**2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(90*f**2*k1**2*k2**2 - 11*f*(10*K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(2*C + 24*K - 14)) + 198*g2*k1**2*k2**2)) - 2*f*(D1*(450*f**2*fd*k1**4*(4*r + 4*s - 3) + 39*f*fd*(3*r + 3*s - 2)*(k1**4*(3*C - 3) + k1**2*k2**2*(24*C - 18) + k2**4*(10*C - 5)) - 143*f*gd2*(3*k1**4 + 24*k1**2*k2**2 + 10*k2**4)*(r + s - 1) - 143*fd*g2*(3*k1**4 + 24*k1**2*k2**2 + 10*k2**4)*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(450*f**2*k1**4 + 39*f*(k1**4*(3*C - 3) + k1**2*k2**2*(24*C - 18) + k2**4*(10*C - 5)) - 143*g2*(3*k1**4 + 24*k1**2*k2**2 + 10*k2**4))))/(45045*d*k3**6) + 8*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct*f*k1*k2**2*st**5*(D1*(6*f**2*(-13*bd1*k2**2*(r + s - 1) + 12*fd*k1**2*(4*r + 4*s - 3)) + 13*f*k2**2*(11*bd1*(2*K - 1)*(r + s - 1) - fd*(-4*C + 6*b1 + 3)*(3*r + 3*s - 2) - 44*gd2*(r + s - 1)) - 143*fd*k2**2*(2*r + 2*s - 1)*(-2*K*b1 + b1 + 4*g2)) + Dd*f*(4*r + 4*s - 3)*(72*f**2*k1**2 - f*k2**2*(-52*C + 78*b1 + 39) - k2**2*(-286*K*b1 + 143*b1 + 572*g2)))/(9009*d*k3**6) + 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*ct*k1*st**3*(D1*(1287*b1*fd*k2**4*(r + s)*(b1*(2*K - 1) - 4*g2) + 24*f**3*k1**2*(-13*bd1*k2**2*(r + s - 1) + 10*fd*k1**2*(4*r + 4*s - 3)) - 13*f**2*k2**2*(-11*bd1*(k1**2*(6*K - 3) + k2**2*(4*C + 12*K - 8*b1 - 3))*(r + s - 1) + 3*fd*(k1**2*(-12*C + 8*b1 + 9) + k2**2*(12 - 24*C))*(3*r + 3*s - 2) + 132*gd2*(k1**2 + 2*k2**2)*(r + s - 1)) - 143*f*k2**2*(4*b1**2*fd*k2**2*(2*r + 2*s - 1) - b1*fd*(k1**2*(6*K - 3) + k2**2*(4*C + 12*K - 3))*(2*r + 2*s - 1) + 18*b1*k2**2*(r + s - 1)*(-2*K*bd1 + bd1 + 2*gd2) + 36*bd1*g2*k2**2*(r + s - 1) + 12*fd*g2*(k1**2 + 2*k2**2)*(2*r + 2*s - 1))) + Dd*f*(4*r + 4*s - 3)*(1287*b1*k2**4*(b1*(2*K - 1) - 4*g2) + 240*f**3*k1**4 - 39*f**2*(k1**2*k2**2*(-12*C + 8*b1 + 9) + k2**4*(12 - 24*C)) - 143*f*k2**2*(4*b1**2*k2**2 + b1*k1**2*(3 - 6*K) + b1*k2**2*(-4*C - 12*K + 3) + 12*g2*(k1**2 + 2*k2**2))))/(45045*d*k3**6) + 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*f**3*k1**2*k2**3*st**7*(D1*fd + Dd*f)*(4*r + 4*s - 3)/(429*d*k3**6) + 8*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*f*k2*st**5*(D1*(3*f**2*k1**2*(-13*bd1*k2**2*(r + s - 1) + 6*fd*k1**2*(4*r + 4*s - 3)) + 13*f*k2**2*(-3*b1*fd*k1**2*(3*r + 3*s - 2) + k2**2*(fd*(2*C - 1)*(3*r + 3*s - 2) + (11*K*bd1 - 22*gd2)*(r + s - 1))) - 143*fd*k2**4*(-K*b1 + 2*g2)*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(18*f**2*k1**4 - 13*f*(3*b1*k1**2*k2**2 + k2**4*(1 - 2*C)) + k2**4*(143*K*b1 - 286*g2)))/(9009*d*k3**6) + 4*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pk3*st**3*(D1*(1287*b1*fd*k2**6*(r + s)*(K*b1 - 2*g2) + 3*f**3*k1**4*(26*bd1*k2**2*(r + s - 1) + 5*fd*k1**2*(4*r + 4*s - 3)) + 13*f**2*k2**2*(-88*b1*bd1*k1**2*k2**2*(r + s - 1) + 6*b1*fd*k1**4*(3*r + 3*s - 2) + k2**2*(fd*k1**2*(18*C - 9)*(3*r + 3*s - 2) + (r + s - 1)*(33*K*bd1*k1**2 - 11*bd1*k2**2*(1 - 2*C) - 66*gd2*k1**2))) + 143*f*k2**4*(-4*b1**2*fd*k1**2*(2*r + 2*s - 1) + b1*(fd*(3*K*k1**2 + k2**2*(2*C - 1))*(2*r + 2*s - 1) + k2**2*(18*K*bd1 - 18*gd2)*(r + s - 1)) - 6*g2*(3*bd1*k2**2*(r + s - 1) + fd*k1**2*(2*r + 2*s - 1)))) + Dd*f*(4*r + 4*s - 3)*(1287*b1*k2**6*(K*b1 - 2*g2) + 15*f**3*k1**6 + 39*f**2*k1**2*k2**2*(2*b1*k1**2 + k2**2*(6*C - 3)) - 143*f*k2**4*(-3*K*b1*k1**2 + 4*b1**2*k1**2 + b1*k2**2*(1 - 2*C) + 6*g2*k1**2)))/(45045*d*k2*k3**6) - np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**4*f*k1**2*k2**3*st**3*(468*C*D1*f*fd*r + 468*C*D1*f*fd*s - 312*C*D1*f*fd + 624*C*Dd*f**2*r + 624*C*Dd*f**2*s - 468*C*Dd*f**2 + 286*D1*bd1*f*(K - 1)*(r + s - 1) + 420*D1*f**2*fd*r + 420*D1*f**2*fd*s - 315*D1*f**2*fd - 468*D1*f*fd*r - 468*D1*f*fd*s + 312*D1*f*fd - 572*D1*f*gd2*r - 572*D1*f*gd2*s + 572*D1*f*gd2 - 1144*D1*fd*g2*r - 1144*D1*fd*g2*s + 572*D1*fd*g2 + 420*Dd*f**3*r + 420*Dd*f**3*s - 315*Dd*f**3 - 624*Dd*f**2*r - 624*Dd*f**2*s + 468*Dd*f**2 - 2288*Dd*f*g2*r - 2288*Dd*f*g2*s + 1716*Dd*f*g2 + 286*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))/(9009*d*k3**5) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**3*f*k1*k2**2*st**3*(D1*bd1*f*(6*f + 11)*(r + s - 1) + b1*(D1*fd*(6*f*(3*r + 3*s - 2) + 22*r + 22*s - 11) + Dd*f*(6*f + 11)*(4*r + 4*s - 3)) + 3*f*(D1*fd*(3*r + 3*s - 2) + Dd*f*(4*r + 4*s - 3)))/(693*d*k3**3) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**3*f*k1*k2**2*st**3*(-1404*C*D1*f*fd*k1**2*r - 1404*C*D1*f*fd*k1**2*s + 936*C*D1*f*fd*k1**2 - 2340*C*D1*f*fd*k2**2*r - 2340*C*D1*f*fd*k2**2*s + 1560*C*D1*f*fd*k2**2 - 1872*C*Dd*f**2*k1**2*r - 1872*C*Dd*f**2*k1**2*s + 1404*C*Dd*f**2*k1**2 - 3120*C*Dd*f**2*k2**2*r - 3120*C*Dd*f**2*k2**2*s + 2340*C*Dd*f**2*k2**2 - 13*D1*bd1*f*(k1**2*(66*K - 66) - k2**2*(-110*K + 30*f + 55))*(r + s - 1) - 2400*D1*f**2*fd*k1**2*r - 2400*D1*f**2*fd*k1**2*s + 1800*D1*f**2*fd*k1**2 + 1404*D1*f*fd*k1**2*r + 1404*D1*f*fd*k1**2*s - 936*D1*f*fd*k1**2 + 1755*D1*f*fd*k2**2*r + 1755*D1*f*fd*k2**2*s - 1170*D1*f*fd*k2**2 + 1716*D1*f*gd2*k1**2*r + 1716*D1*f*gd2*k1**2*s - 1716*D1*f*gd2*k1**2 + 2860*D1*f*gd2*k2**2*r + 2860*D1*f*gd2*k2**2*s - 2860*D1*f*gd2*k2**2 + 3432*D1*fd*g2*k1**2*r + 3432*D1*fd*g2*k1**2*s - 1716*D1*fd*g2*k1**2 + 5720*D1*fd*g2*k2**2*r + 5720*D1*fd*g2*k2**2*s - 2860*D1*fd*g2*k2**2 - 2400*Dd*f**3*k1**2*r - 2400*Dd*f**3*k1**2*s + 1800*Dd*f**3*k1**2 + 1872*Dd*f**2*k1**2*r + 1872*Dd*f**2*k1**2*s - 1404*Dd*f**2*k1**2 + 2340*Dd*f**2*k2**2*r + 2340*Dd*f**2*k2**2*s - 1755*Dd*f**2*k2**2 + 6864*Dd*f*g2*k1**2*r + 6864*Dd*f*g2*k1**2*s - 5148*Dd*f*g2*k1**2 + 11440*Dd*f*g2*k2**2*r + 11440*Dd*f*g2*k2**2*s - 8580*Dd*f*g2*k2**2 + 13*b1*(D1*fd*(k1**2*(66 - 66*K)*(2*r + 2*s - 1) + 5*k2**2*(6*f*(3*r + 3*s - 2) + (11 - 22*K)*(2*r + 2*s - 1))) + Dd*f*(k1**2*(66 - 66*K) + k2**2*(-110*K + 30*f + 55))*(4*r + 4*s - 3)))/(45045*d*k3**5) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**2*f*k1**2*k2**3*st**5*(78*C*D1*f*fd*r + 78*C*D1*f*fd*s - 52*C*D1*f*fd + 104*C*Dd*f**2*r + 104*C*Dd*f**2*s - 78*C*Dd*f**2 + 143*D1*bd1*f*(K - 1)*(r + s - 1) + 252*D1*f**2*fd*r + 252*D1*f**2*fd*s - 189*D1*f**2*fd - 78*D1*f*fd*r - 78*D1*f*fd*s + 52*D1*f*fd - 286*D1*f*gd2*r - 286*D1*f*gd2*s + 286*D1*f*gd2 - 572*D1*fd*g2*r - 572*D1*fd*g2*s + 286*D1*fd*g2 + 252*Dd*f**3*r + 252*Dd*f**3*s - 189*Dd*f**3 - 104*Dd*f**2*r - 104*Dd*f**2*s + 78*Dd*f**2 - 1144*Dd*f*g2*r - 1144*Dd*f*g2*s + 858*Dd*f*g2 + 143*b1*(K - 1)*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3)))/(9009*d*k3**5) - np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**2*k2*st**3*(99*b1**2*k1**2*(K - 1)*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)) + b1*(99*D1*bd1*f*k1**2*(K - 1)*(2*r + 2*s - 1) + 2*D1*(45*f**2*fd*k1**2*(4*r + 4*s - 3) + 11*f*(-5*K*fd*k2**2*(2*r + 2*s - 1) + 2*fd*k1**2*(C*(r + s - 1) + 5*r + 5*s - 2) - 9*gd2*k1**2*(r + s - 1)) - 99*fd*g2*k1**2*(r + s - 1)) + 2*Dd*f*(4*r + 4*s - 3)*(60*f**2*k1**2 + 11*f*(-5*K*k2**2 + k1**2*(C + 5)) - 99*g2*k1**2)) + 2*f*(D1*bd1*(15*f**2*k1**2*(4*r + 4*s - 3) + 11*f*(-5*K*k2**2*(r + s - 1) + k1**2*(r*(C + 5) + s*(C + 5) - 6)) - 99*g2*k1**2*(r + s)) + D1*(3*f*fd*(6*k1**2 + k2**2*(5 - 10*C))*(3*r + 3*s - 2) - 55*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) - 55*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + Dd*f*(3*f*(6*k1**2 + k2**2*(5 - 10*C)) + k2**2*(-55*b2 + 110*g2))*(4*r + 4*s - 3)))/(3465*d*k3**3) + np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct**2*k2*st**3*(13*D1*bd1*f*(r + s - 1)*(90*f**2*k1**2*k2**2 - 11*f*(10*K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(2*C + 24*K - 14)) + k1**2*k2**2*(-198*K*b1 + 198*b1 + 198*g2)) - 1287*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(r + s) + Dd*f*(4*r + 4*s - 3)) + 13*b1*(D1*(90*f**2*fd*k1**2*k2**2*(3*r + 3*s - 2) - 11*f*fd*(2*r + 2*s - 1)*(10*K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(2*C + 24*K - 14)) + 198*f*gd2*k1**2*k2**2*(r + s - 1) + 198*fd*g2*k1**2*k2**2*(r + s)) + Dd*f*(4*r + 4*s - 3)*(90*f**2*k1**2*k2**2 - 11*f*(10*K*k2**4 + k1**4*(3*K - 3) + k1**2*k2**2*(2*C + 24*K - 14)) + 198*g2*k1**2*k2**2)) - 2*f*(D1*(450*f**2*fd*k1**4*(4*r + 4*s - 3) + 39*f*fd*(3*r + 3*s - 2)*(k1**4*(3*C - 3) + k1**2*k2**2*(24*C - 18) + k2**4*(10*C - 5)) - 143*f*gd2*(3*k1**4 + 24*k1**2*k2**2 + 10*k2**4)*(r + s - 1) - 143*fd*g2*(3*k1**4 + 24*k1**2*k2**2 + 10*k2**4)*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(450*f**2*k1**4 + 39*f*(k1**4*(3*C - 3) + k1**2*k2**2*(24*C - 18) + k2**4*(10*C - 5)) - 143*g2*(3*k1**4 + 24*k1**2*k2**2 + 10*k2**4))))/(45045*d*k3**5) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct*f*k1*k2**2*st**5*(D1*b1*fd*(6*f*(3*r + 3*s - 2) + 22*r + 22*s - 11) + D1*bd1*f*(6*f + 11)*(r + s - 1) + D1*f*fd*(3*r + 3*s - 2) + Dd*b1*f*(6*f + 11)*(4*r + 4*s - 3) + Dd*f**2*(4*r + 4*s - 3))/(693*d*k3**3) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct*f*k1*k2**2*st**5*(D1*(6*f**2*(-13*bd1*k2**2*(r + s - 1) + 12*fd*k1**2*(4*r + 4*s - 3)) + 13*f*k2**2*(11*bd1*(2*K - 1)*(r + s - 1) - fd*(-4*C + 6*b1 + 3)*(3*r + 3*s - 2) - 44*gd2*(r + s - 1)) - 143*fd*k2**2*(2*r + 2*s - 1)*(-2*K*b1 + b1 + 4*g2)) + Dd*f*(4*r + 4*s - 3)*(72*f**2*k1**2 - f*k2**2*(-52*C + 78*b1 + 39) - k2**2*(-286*K*b1 + 143*b1 + 572*g2)))/(9009*d*k3**5) - np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct*k1*st**3*(D1*bd1*f**2*(r + s) + b1**2*(D1*fd*(8*f + 9)*(r + s - 1) + Dd*f*(4*f + 9)*(4*r + 4*s - 3)) + b1*f*(D1*bd1*(4*f + 9)*(2*r + 2*s - 1) + 2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)))/(315*d*k3) - np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct*k1*st**3*(D1*bd1*f*(12*f**2*k1**2*(5*r + 5*s - 3) + 11*f*(3*k1**2*(r + s - 1) - k2**2*(-4*C*r - 4*C*s + 12*K*(r + s - 1) + 4*b1 + 2*r + 2*s + 1)) + 99*k2**2*(b1*(K*(4*r + 4*s - 2) - 1) - 4*g2*(r + s))) + 11*b1**2*k2**2*(D1*fd*(18*K*(r + s - 1) + 4*f + 9) + 18*Dd*K*f*(4*r + 4*s - 3)) + b1*(D1*(36*f**2*fd*k1**2*(5*r + 5*s - 4) + 11*f*(fd*k1**2*(6*r + 6*s - 3) + fd*k2**2*(8*C*(r + s - 1) - 12*K*(2*r + 2*s - 1) - 4*r - 4*s + 5) - 36*gd2*k2**2*(r + s - 1)) - 396*fd*g2*k2**2*(r + s - 1)) + Dd*f*(4*r + 4*s - 3)*(60*f**2*k1**2 + 33*f*k1**2 + 22*f*k2**2*(2*C - 6*K - 1) - 396*g2*k2**2)) + 3*f*(D1*(3*f*fd*(k1**2 + k2**2*(4 - 8*C))*(3*r + 3*s - 2) - 44*f*k2**2*(bd2 - 2*gd2)*(r + s - 1) - 44*fd*k2**2*(b2 - 2*g2)*(2*r + 2*s - 1)) + Dd*f*(3*f*(k1**2 + k2**2*(4 - 8*C)) + k2**2*(-44*b2 + 88*g2))*(4*r + 4*s - 3)))/(3465*d*k3**3) - np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*ct*k1*st**3*(D1*(1287*b1*fd*k2**4*(r + s)*(b1*(2*K - 1) - 4*g2) + 24*f**3*k1**2*(-13*bd1*k2**2*(r + s - 1) + 10*fd*k1**2*(4*r + 4*s - 3)) - 13*f**2*k2**2*(-11*bd1*(k1**2*(6*K - 3) + k2**2*(4*C + 12*K - 8*b1 - 3))*(r + s - 1) + 3*fd*(k1**2*(-12*C + 8*b1 + 9) + k2**2*(12 - 24*C))*(3*r + 3*s - 2) + 132*gd2*(k1**2 + 2*k2**2)*(r + s - 1)) - 143*f*k2**2*(4*b1**2*fd*k2**2*(2*r + 2*s - 1) - b1*fd*(k1**2*(6*K - 3) + k2**2*(4*C + 12*K - 3))*(2*r + 2*s - 1) + 18*b1*k2**2*(r + s - 1)*(-2*K*bd1 + bd1 + 2*gd2) + 36*bd1*g2*k2**2*(r + s - 1) + 12*fd*g2*(k1**2 + 2*k2**2)*(2*r + 2*s - 1))) + Dd*f*(4*r + 4*s - 3)*(1287*b1*k2**4*(b1*(2*K - 1) - 4*g2) + 240*f**3*k1**4 - 39*f**2*(k1**2*k2**2*(-12*C + 8*b1 + 9) + k2**4*(12 - 24*C)) - 143*f*k2**2*(4*b1**2*k2**2 + b1*k1**2*(3 - 6*K) + b1*k2**2*(-4*C - 12*K + 3) + 12*g2*(k1**2 + 2*k2**2))))/(45045*d*k3**5) - np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*f**3*k1**2*k2**3*st**7*(D1*fd + Dd*f)*(4*r + 4*s - 3)/(429*d*k3**5) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*f*k2*st**5*(D1*bd1*f*(-11*K*k2**2*(r + s - 1) + f*k1**2*(4*r + 4*s - 3)) + b1*(D1*fd*(-11*K*k2**2*(2*r + 2*s - 1) + 3*f*k1**2*(4*r + 4*s - 3)) + Dd*f*(-11*K*k2**2 + 4*f*k1**2)*(4*r + 4*s - 3)) + k2**2*(-6*C*D1*f*fd*r - 6*C*D1*f*fd*s + 4*C*D1*f*fd - 8*C*Dd*f**2*r - 8*C*Dd*f**2*s + 6*C*Dd*f**2 - 11*D1*bd2*f*(r + s - 1) + 3*D1*f*fd*r + 3*D1*f*fd*s - 2*D1*f*fd + 22*D1*f*gd2*r + 22*D1*f*gd2*s - 22*D1*f*gd2 + 44*D1*fd*g2*r + 44*D1*fd*g2*s - 22*D1*fd*g2 + 4*Dd*f**2*r + 4*Dd*f**2*s - 3*Dd*f**2 + 88*Dd*f*g2*r + 88*Dd*f*g2*s - 66*Dd*f*g2 - 11*b2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))))/(693*d*k3**3) - 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*f*k2*st**5*(D1*(3*f**2*k1**2*(-13*bd1*k2**2*(r + s - 1) + 6*fd*k1**2*(4*r + 4*s - 3)) + 13*f*k2**2*(-3*b1*fd*k1**2*(3*r + 3*s - 2) + k2**2*(fd*(2*C - 1)*(3*r + 3*s - 2) + (11*K*bd1 - 22*gd2)*(r + s - 1))) - 143*fd*k2**4*(-K*b1 + 2*g2)*(2*r + 2*s - 1)) + Dd*f*(4*r + 4*s - 3)*(18*f**2*k1**4 - 13*f*(3*b1*k1**2*k2**2 + k2**4*(1 - 2*C)) + k2**4*(143*K*b1 - 286*g2)))/(9009*d*k3**5) - np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*st**3*(-D1*bd1*f*k2**2*(r + s)*(9*b2 + f*(2*C - 1) - 18*g2) + b1**2*(D1*fd*(-9*K*k2**2 + 2*f*k1**2)*(r + s - 1) + Dd*f*(-9*K*k2**2 + f*k1**2)*(4*r + 4*s - 3)) + b1*(D1*bd1*f*(-9*K*k2**2 + f*k1**2)*(2*r + 2*s - 1) + k2**2*(-4*C*D1*f*fd*r - 4*C*D1*f*fd*s + 4*C*D1*f*fd - 8*C*Dd*f**2*r - 8*C*Dd*f**2*s + 6*C*Dd*f**2 - 9*D1*bd2*f*(r + s - 1) + 2*D1*f*fd*r + 2*D1*f*fd*s - 2*D1*f*fd + 18*D1*f*gd2*r + 18*D1*f*gd2*s - 18*D1*f*gd2 + 18*D1*fd*g2*r + 18*D1*fd*g2*s - 18*D1*fd*g2 + 4*Dd*f**2*r + 4*Dd*f**2*s - 3*Dd*f**2 + 72*Dd*f*g2*r + 72*Dd*f*g2*s - 54*Dd*f*g2 - 9*b2*(D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)))))/(315*d*k2*k3) - np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*st**3*(D1*bd1*f*(3*f**2*k1**4*(2*r + 2*s - 1) + 11*f*k2**2*(-3*K*k1**2*(r + s - 1) + b1*k1**2*(4*r + 4*s - 5) + k2**2*(2*C - 1)) + 99*k2**4*(K*b1 - b2*(r + s - 1) - 2*g2)) + 11*b1**2*k2**2*(D1*fd*(-9*K*k2**2 + f*k1**2*(4*r + 4*s - 1)) + 2*Dd*f**2*k1**2*(4*r + 4*s - 3)) + b1*(D1*(3*f**2*fd*k1**4*(6*r + 6*s - 5) - 11*f*(3*K*fd*k1**2*k2**2*(2*r + 2*s - 1) + 9*bd2*k2**4*(r + s - 1) + fd*k2**4*(2*C - 1)) - 99*fd*k2**4*(b2*(r + s) - 2*g2)) + 3*Dd*f*(4*r + 4*s - 3)*(-11*K*f*k1**2*k2**2 - 33*b2*k2**4 + 2*f**2*k1**4)) - 3*f*k1**2*k2**2*(18*C*D1*f*fd*r + 18*C*D1*f*fd*s - 12*C*D1*f*fd + 24*C*Dd*f**2*r + 24*C*Dd*f**2*s - 18*C*Dd*f**2 + 11*D1*bd2*f*(r + s - 1) - 9*D1*f*fd*r - 9*D1*f*fd*s + 6*D1*f*fd - 22*D1*f*gd2*r - 22*D1*f*gd2*s + 22*D1*f*gd2 - 44*D1*fd*g2*r - 44*D1*fd*g2*s + 22*D1*fd*g2 - 12*Dd*f**2*r - 12*Dd*f**2*s + 9*Dd*f**2 - 88*Dd*f*g2*r - 88*Dd*f*g2*s + 66*Dd*f*g2 + 11*b2*(D1*fd*(2*r + 2*s - 1) + Dd*f*(4*r + 4*s - 3))))/(3465*d*k2*k3**3) - np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk2*Pkd3*st**3*(D1*(1287*b1*fd*k2**6*(r + s)*(K*b1 - 2*g2) + 3*f**3*k1**4*(26*bd1*k2**2*(r + s - 1) + 5*fd*k1**2*(4*r + 4*s - 3)) + 13*f**2*k2**2*(-88*b1*bd1*k1**2*k2**2*(r + s - 1) + 6*b1*fd*k1**4*(3*r + 3*s - 2) + k2**2*(fd*k1**2*(18*C - 9)*(3*r + 3*s - 2) + (r + s - 1)*(33*K*bd1*k1**2 - 11*bd1*k2**2*(1 - 2*C) - 66*gd2*k1**2))) + 143*f*k2**4*(-4*b1**2*fd*k1**2*(2*r + 2*s - 1) + b1*(fd*(3*K*k1**2 + k2**2*(2*C - 1))*(2*r + 2*s - 1) + k2**2*(18*K*bd1 - 18*gd2)*(r + s - 1)) - 6*g2*(3*bd1*k2**2*(r + s - 1) + fd*k1**2*(2*r + 2*s - 1)))) + Dd*f*(4*r + 4*s - 3)*(1287*b1*k2**6*(K*b1 - 2*g2) + 15*f**3*k1**6 + 39*f**2*k1**2*k2**2*(2*b1*k1**2 + k2**2*(6*C - 3)) - 143*f*k2**4*(-3*K*b1*k1**2 + 4*b1**2*k1**2 + b1*k2**2*(1 - 2*C) + 6*g2*k1**2)))/(45045*d*k2*k3**5) + np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**4*f*k1**2*k2*st**3*(4*Pk2 - Pkd2*k2)*(D1*(105*f**2*fd*(4*s - 1) + 26*f*(fd*(6*C - 6)*(3*s - 1) + s*(11*K*bd1 - 11*bd1 - 22*gd2)) + 572*fd*g2*(1 - 2*s)) + Dd*f*(4*s - 1)*(105*f**2 + f*(156*C - 156) - 572*g2) + 286*b1*(K - 1)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)))/(9009*d*k3**4) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**3*f*k1*st**3*(4*Pk2 - Pkd2*k2)*(b1*(D1*fd*(18*f*s - 6*f + 22*s - 11) + Dd*f*(6*f + 11)*(4*s - 1)) + f*(D1*bd1*s*(6*f + 11) + D1*fd*(9*s - 3) + 3*Dd*f*(4*s - 1)))/(693*d*k3**2) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**3*f*k1*st**3*(D1*(30*f**2*(13*bd1*k2**2*(2*Pk2*(r - 1) + Pkd2*k2*s) + fd*(52*Pk2*k2**2*(1 - 2*r) + 15*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 13*f*(-11*bd1*(-Pk2*k1**2*s*(16*K - 16) + 10*Pk2*k2**2*(K*(r - 2*s - 1) - 2*r + 2) + Pkd2*k1**2*k2*s*(4*K - 4) + Pkd2*k2**3*s*(10*K - 5)) + fd*(k1**2*(24*C - 24)*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(Pk2*(C*(-372*r + 360*s + 4) + 462*r - 180*s - 94) + Pkd2*k2*(45 - 60*C)*(3*s - 1))) + 44*gd2*(-8*Pk2*k1**2*s + 5*Pk2*k2**2*(r - 2*s - 1) + 2*Pkd2*k1**2*k2*s + 5*Pkd2*k2**3*s)) + 572*fd*g2*(-2*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 5*k2**2*(2*Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1)))) + Dd*f*(30*f**2*(52*Pk2*k2**2*(1 - 2*r) + 15*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 13*f*(k1**2*(24*C - 24)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + k2**2*(-8*Pk2*(2*C*(31*r - 30*s - 8) - 77*r + 30*s + 31) + Pkd2*k2*(45 - 60*C)*(4*s - 1))) + 572*g2*(-2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 5*k2**2*(4*Pk2*(r - 2*s) + Pkd2*k2*(4*s - 1)))) + 13*b1*(D1*fd*(k1**2*(44*K - 44)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 5*k2**2*(-44*K*Pk2*(r - 2*s + 1) - 22*K*Pkd2*k2*(2*s - 1) + 88*Pk2*r + 22*Pkd2*k2*s - 11*Pkd2*k2 + 6*f*(Pk2*(6*r - 2) + Pkd2*k2*(3*s - 1)))) + Dd*f*(k1**2*(44*K - 44)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 5*k2**2*(8*Pk2*f*(6*r - 3) - 88*Pk2*(-2*K*s + r*(K - 2) + 1) + Pkd2*k2*(4*s - 1)*(-22*K + 6*f + 11)))))/(45045*d*k3**4) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**2*f*k1**2*k2*st**5*(4*Pk2 - Pkd2*k2)*(D1*(63*f**2*fd*(4*s - 1) + f*fd*(26*C - 26)*(3*s - 1) - 143*f*s*(-K*bd1 + bd1 + 2*gd2) + 286*fd*g2*(1 - 2*s)) + Dd*f*(4*s - 1)*(63*f**2 + f*(26*C - 26) - 286*g2) + 143*b1*(K - 1)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1)))/(9009*d*k3**4) + np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**2*st**3*(99*b1**2*k1**2*(K - 1)*(4*Pk2 - Pkd2*k2)*(D1*fd*(s - 1) + Dd*f*(4*s - 1)) + 2*b1*(D1*(5*f**2*fd*(11*Pk2*k2**2*(1 - 3*r) + 9*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) + 11*f*(fd*k1**2*(C + 3)*(4*Pk2 - Pkd2*k2)*(2*s - 1) + 5*fd*k2**2*(-K*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 2*Pk2*r) + k1**2*s*(4*Pk2 - Pkd2*k2)*(9*K*bd1 - 9*bd1 - 9*gd2)) - 99*fd*g2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)) + Dd*f*(5*f**2*(22*Pk2*k2**2*(1 - 2*r) + 9*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 11*f*(k1**2*(C + 3)*(4*Pk2 - Pkd2*k2)*(4*s - 1) + 5*k2**2*(K*Pkd2*k2*(4*s - 1) + Pk2*(K*(2 - 8*s) - 4*r + 2))) - 99*g2*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) + 2*f*(D1*(55*b2*fd*k2**2*(-2*Pk2 + Pkd2*k2)*(2*s - 1) - 5*bd1*f**2*(-36*Pk2*k1**2*s + 11*Pk2*k2**2*(r - 1) + 9*Pkd2*k1**2*k2*s) + 99*bd1*g2*k1**2*s*(-4*Pk2 + Pkd2*k2) + f*(-11*bd1*(-5*K*Pkd2*k2**3*s + Pk2*k1**2*s*(-4*C - 12) + 5*Pk2*k2**2*(2*K*s + r - 1) + Pkd2*k1**2*k2*s*(C + 3)) + fd*(12*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1) + k2**2*(Pk2*(-180*C*s + 60*C - 141*r + 90*s + 17) + Pkd2*k2*(30*C - 15)*(3*s - 1))) + k2**2*s*(-2*Pk2 + Pkd2*k2)*(55*bd2 - 110*gd2)) - 110*fd*g2*k2**2*(-2*Pk2 + Pkd2*k2)*(2*s - 1)) + Dd*f*(12*f*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) + f*k2**2*(-4*Pk2*(15*C*(4*s - 1) + 47*r - 30*s - 16) + Pkd2*k2*(30*C - 15)*(4*s - 1)) + k2**2*(-2*Pk2 + Pkd2*k2)*(55*b2 - 110*g2)*(4*s - 1))))/(3465*d*k2*k3**2) + np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct**2*st**3*(1287*b1**2*k1**2*k2**2*(K - 1)*(D1*fd*(2*Pk2*(r + 2*s - 1) - Pkd2*k2*s) + Dd*f*(8*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 4*s))) + 13*b1*(D1*(10*f**2*fd*k2**2*(11*Pk2*k2**2*(3*r - 1) + 9*k1**2*(4*Pk2*(2*r + s - 1) + Pkd2*k2*(2*s - 1))) + 11*f*(fd*(k1**4*(K - 1)*(4*Pk2 - Pkd2*k2)*(2*s - 1) - 4*k1**2*k2**2*(Pk2*(-2*C*(r + 2*s - 1) + K*(17*r + 6*s - 3) - 27*r - 22*s + 11) + Pkd2*k2*(K*(8*s - 4) + s*(C - 5) + 2)) - 10*k2**4*(K*Pk2*(8*r + 4*s - 2) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r)) - 9*k1**2*k2**2*(4*Pk2*gd2*(r + 2*s - 1) - 2*Pkd2*gd2*k2*s - bd1*(K - 1)*(4*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 2*s)))) + 198*fd*g2*k1**2*k2**2*(-2*Pk2*(r + 2*s - 1) + Pkd2*k2*s)) + Dd*f*(20*f**2*k2**2*(11*Pk2*k2**2*(2*r - 1) + 3*k1**2*(2*Pk2*(8*r + 4*s - 5) + Pkd2*k2*(4*s - 1))) + 11*f*(k1**4*(K - 1)*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 2*k1**2*k2**2*(-4*Pk2*(2*C*(r + 2*s - 1) + K*(-17*r - 6*s + 10) + 27*r + 22*s - 19) + Pkd2*k2*(4*s - 1)*(C + 8*K - 5)) - 10*k2**4*(K*Pkd2*k2*(4*s - 1) + 2*Pk2*(K*(8*r + 4*s - 5) - 2*r + 1))) + 198*g2*k1**2*k2**2*(-8*Pk2*(r + 2*s - 1) + Pkd2*k2*(4*s - 1)))) + f*(D1*(-2574*bd1*g2*k1**2*k2**2*(2*Pk2*(r + 2*s - 1) - Pkd2*k2*(s - 1)) + 10*f**2*(143*Pk2*bd1*k2**4*(r - 1) - 468*Pk2*fd*k1**2*k2**2*(3*r + 2*s - 2) + 39*bd1*k1**2*k2**2*(4*Pk2*(2*r + s - 2) + Pkd2*k2*(2*s + 1)) + 45*fd*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 13*f*(-220*Pk2*bd2*k2**4*(r + s - 1) - 11*bd1*(-k1**4*s*(K - 1)*(4*Pk2 - Pkd2*k2) + 2*k1**2*k2**2*(Pk2*(-2*C*(r + 2*s - 1) + K*(17*r + 6*s - 17) - 27*r - 22*s + 27) + Pkd2*k2*(C*(s - 1) + s*(8*K - 5) + 1)) + 10*k2**4*(2*K*Pk2*(2*r + s - 2) + K*Pkd2*k2*s - Pk2*r + Pk2)) + 2*fd*(k1**4*(3*C - 3)*(4*Pk2 - Pkd2*k2)*(3*s - 1) + 2*k1**2*k2**2*(Pk2*(C*(-153*r + 42*s + 37) + 207*r + 48*s - 85) + Pkd2*k2*(18 - 24*C)*(3*s - 1)) + k2**4*(Pk2*(-4*C*(186*r + 45*s - 77) + 513*r + 90*s - 201) + Pkd2*k2*(15 - 30*C)*(3*s - 1))) + 22*gd2*(k1**4*(-4*Pk2*s + Pkd2*k2*s) + 2*k1**2*k2**2*(Pk2*(17*r + 6*s - 17) + 8*Pkd2*k2*s) + 10*k2**4*(2*Pk2*(2*r + s - 2) + Pkd2*k2*s))) - 286*fd*(10*Pk2*b2*k2**4*(2*r + 2*s - 1) + g2*(k1**4*(4*Pk2 - Pkd2*k2)*(2*s - 1) - 4*k1**2*k2**2*(Pk2*(17*r + 6*s - 3) + 4*Pkd2*k2*(2*s - 1)) - 10*k2**4*(Pk2*(8*r + 4*s - 2) + Pkd2*k2*(2*s - 1))))) + 2*Dd*f*(-1430*Pk2*b2*k2**4*(4*r + 4*s - 3) + 45*f**2*k1**2*(-52*Pk2*k2**2*(3*r + 2*s - 2) + 5*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 13*f*(k1**4*(3*C - 3)*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 4*k1**2*k2**2*(Pk2*(2*C*(51*r - 14*s - 22) - 138*r - 32*s + 77) + Pkd2*k2*(12*C - 9)*(4*s - 1)) + k2**4*(-4*Pk2*(C*(248*r + 60*s - 139) - 171*r - 30*s + 93) + Pkd2*k2*(15 - 30*C)*(4*s - 1))) - 143*g2*(k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 8*k1**2*k2**2*(Pk2*(17*r + 6*s - 10) + 2*Pkd2*k2*(4*s - 1)) - 10*k2**4*(2*Pk2*(8*r + 4*s - 5) + Pkd2*k2*(4*s - 1))))))/(45045*d*k2*k3**4) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*f*k1*st**5*(4*Pk2 - Pkd2*k2)*(b1*(D1*fd*(18*f*s - 6*f + 22*s - 11) + Dd*f*(6*f + 11)*(4*s - 1)) + f*(D1*bd1*s*(6*f + 11) + D1*fd*(3*s - 1) + Dd*f*(4*s - 1)))/(693*d*k3**2) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*f*k1*st**5*(D1*(6*f**2*(13*bd1*k2**2*(2*Pk2*(r - 1) + Pkd2*k2*s) + fd*(52*Pk2*k2**2*(1 - 2*r) + 9*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1))) - 13*f*k2**2*(11*bd1*(2*Pk2*(K*(r - 2*s - 1) - 2*r + 2) + Pkd2*k2*s*(2*K - 1)) + fd*(2*Pk2*(2*C*(3*r - 6*s + 1) + b1*(6 - 18*r) - 9*r + 6*s + 1) - Pkd2*k2*(3*s - 1)*(-4*C + 6*b1 + 3)) - 44*gd2*(Pk2*(r - 2*s - 1) + Pkd2*k2*s)) + 143*fd*k2**2*(b1*(-4*K*Pk2*(r - 2*s + 1) + 2*K*Pkd2*k2*(1 - 2*s) + 8*Pk2*r + Pkd2*k2*(2*s - 1)) + 4*g2*(2*Pk2*(r - 2*s + 1) + Pkd2*k2*(2*s - 1)))) + Dd*f*(6*f**2*(52*Pk2*k2**2*(1 - 2*r) + 9*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 13*f*k2**2*(8*Pk2*(-2*C*r + 4*C*s + b1*(6*r - 3) + 3*r - 2*s - 1) + Pkd2*k2*(4*s - 1)*(-4*C + 6*b1 + 3)) - 143*k2**2*(8*Pk2*b1*(-2*K*s + r*(K - 2) + 1) + Pkd2*b1*k2*(2*K - 1)*(4*s - 1) + 4*g2*(-4*Pk2*r + 8*Pk2*s - 4*Pkd2*k2*s + Pkd2*k2))))/(9009*d*k3**4) + np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*k1*st**3*(4*Pk2 - Pkd2*k2)*(D1*bd1*f**2*s + b1**2*(D1*fd*(8*f*s - 4*f + 9*s - 9) + Dd*f*(4*f + 9)*(4*s - 1)) + b1*f*(2*D1*bd1*s*(4*f + 9) + D1*fd*(2*s - 1) + Dd*f*(4*s - 1)))/(315*d*k2**2) - np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*st**3*(11*b1**2*k1**2*k2**2*(D1*fd*(-2*Pk2*(-9*K*(r - 2*s + 2) + 4*f + 9*r + 9) + Pkd2*k2*(18*K*(s - 1) + 4*f + 9)) + 18*Dd*f*(K*Pkd2*k2*(4*s - 1) + Pk2*(-8*K*s + r*(4*K - 4) + 2))) + b1*k1**2*(D1*(f**2*(44*Pk2*fd*k2**2*(18*r + 15*s - 13) - 44*bd1*k2**2*(-2*Pk2 + Pkd2*k2) - 24*fd*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) - 11*f*(fd*(k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1) - k2**2*(2*Pk2*(C*(4*r - 8*s + 2) + 16*K*s - 8*K + 22*r + 44*s - 21) + Pkd2*k2*(C*(8*s - 4) - 16*K*s + 8*K - 4*s + 3))) - 9*k2**2*(Pk2*bd1*(K*(4*r - 8*s - 2) - 4*r + 4) + Pkd2*bd1*k2*(4*K*s - 1) + 4*gd2*(-Pk2*r + 2*Pk2*s + Pk2 - Pkd2*k2*s))) - 396*fd*g2*k2**2*(Pk2*(r - 2*s + 2) + Pkd2*k2*(s - 1))) + Dd*f*(-4*f**2*(-11*Pk2*k2**2*(24*r + 20*s - 17) + 6*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 11*f*(k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 2*k2**2*(4*Pk2*(2*C*r - 4*C*s + 8*K*s - 2*K + 11*r + 22*s - 11) + Pkd2*k2*(4*s - 1)*(2*C - 4*K - 1))) - 396*g2*k2**2*(4*Pk2*(r - 2*s) + Pkd2*k2*(4*s - 1)))) + f*(D1*(4*bd1*f**2*k1**2*(-24*Pk2*k1**2*s + 11*Pk2*k2**2*(6*r + 5*s - 4) + 6*Pkd2*k1**2*k2*s) + f*(fd*(Pk2*k2**4*(64 - 128*C)*(3*r - 1) - 3*k1**4*(4*Pk2 - Pkd2*k2)*(3*s - 1) + 2*k1**2*k2**2*(Pk2*(48*C*(3*s - 1) + 117*r + 12*s - 43) + Pkd2*k2*(12 - 24*C)*(3*s - 1))) + 11*k1**2*(bd1*(-4*Pk2*k1**2*s + 2*Pk2*k2**2*(r*(2*C + 11) + s*(-4*C + 8*K + 22) - 12) + Pkd2*k1**2*k2*s + Pkd2*k2**3*(s*(4*C - 8*K - 2) - 1)) + k2**2*s*(-2*Pk2 + Pkd2*k2)*(-8*bd2 + 16*gd2))) - 44*k1**2*k2**2*(-2*b2*fd*(2*Pk2 - Pkd2*k2)*(2*s - 1) + 9*bd1*g2*(Pk2*(r - 2*s) + Pkd2*k2*s) + 4*fd*g2*(2*Pk2 - Pkd2*k2)*(2*s - 1))) + Dd*f*(f*(Pk2*k2**4*(128 - 256*C)*(2*r - 1) - 3*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1) - 4*k1**2*k2**2*(Pk2*(-96*C*s + 24*C - 78*r - 8*s + 41) + Pkd2*k2*(12*C - 6)*(4*s - 1))) + k1**2*k2**2*(-2*Pk2 + Pkd2*k2)*(-88*b2 + 176*g2)*(4*s - 1))))/(3465*d*k1*k2**2*k3**2) + np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk3*ct*st**3*(D1*(-1287*b1*fd*k1**2*k2**4*(-2*Pk2*b1*(K*(r + 2*s - 2) + r + 1) + 4*Pk2*g2*(r + 2*s - 2) + Pkd2*b1*k2*s*(2*K - 1) - 4*Pkd2*g2*k2*s) + 4*f**3*k1**2*(13*bd1*k2**2*(11*Pk2*k2**2*(4*r + 5*s - 6) + k1**2*(6*Pk2*(5*r + 5*s - 6) + 9*Pkd2*k2)) + 3*fd*(-39*Pk2*k1**2*k2**2*(16*r + 20*s - 13) + 5*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1))) - 13*f**2*k2**2*(11*bd1*(k1**4*(2*K*Pk2*(r - 1) - 8*Pk2*(r + s - 1) + Pkd2*k2*s*(2*K - 1)) + k1**2*k2**2*(2*Pk2*(-2*C*r - 4*C*s + K*(38*r + 52*s - 38) + 4*b1 - 13*r - 18*s + 14) + Pkd2*k2*(4*C*(s - 1) + 8*K*s + b1*(4 - 8*s) - 3*s + 3))) + fd*(Pk2*k2**4*(128*C - 64)*(3*r - 1) - 3*k1**4*(2*Pk2*(-6*C*r + 2*C + 12*b1*(5*r + 5*s - 3) + 15*r + 12*s - 9) + Pkd2*k2*(-12*C*s + 4*C - 12*b1 + 9*s - 3)) + 2*k1**2*k2**2*(Pk2*(C*(684*r + 552*s - 412) - 22*b1*(12*r + 15*s - 7) - 459*r - 360*s + 273) + Pkd2*k2*(24*C - 12)*(3*s - 1))) - 44*k1**2*(-6*Pk2*bd2*k2**2*(r + s - 1) + gd2*k1**2*(Pk2*(r - 1) + Pkd2*k2*s) + 2*gd2*k2**2*(Pk2*(19*r + 26*s - 19) + 2*Pkd2*k2*s))) + 143*f*k1**2*k2**2*(-24*Pk2*b2*fd*k2**2*(2*r + 2*s - 1) + 8*b1**2*fd*k2**2*(Pk2 + Pkd2*k2*s) + b1*(fd*(k1**2*(-4*Pk2*(r*(K - 4) - 4*s + 2) + Pkd2*k2*(K*(2 - 4*s) + 2*s - 1)) - 2*k2**2*(Pk2*(C*(-4*r - 8*s + 6) + 4*K*(19*r + 26*s - 13) - 26*r - 36*s + 17) + Pkd2*k2*(K*(8*s - 4) + s*(4*C - 3)))) - 9*k2**2*(Pk2*bd1*(K*(-4*r - 8*s + 2) - 4*r + 4) + 4*Pk2*gd2*(r + 2*s - 1) + Pkd2*bd1*k2*(2*K - 1)*(2*s - 1) - 4*Pkd2*gd2*k2*s)) - 36*bd1*g2*k2**2*(Pk2*(r + 2*s) + k2*(-Pkd2*s + Pkd2)) - 4*fd*g2*(-2*Pk2*k1**2*r - 4*Pk2*k2**2*(19*r + 26*s - 13) + Pkd2*k1**2*k2*(1 - 2*s) + Pkd2*k2**3*(4 - 8*s)))) + Dd*f*(-1287*b1*k1**2*k2**4*(-4*Pk2*b1*(2*K*(r + 2*s - 1) + 2*r - 1) + 16*Pk2*g2*(r + 2*s - 1) + Pkd2*b1*k2*(2*K - 1)*(4*s - 1) + 4*Pkd2*g2*k2*(1 - 4*s)) + 12*f**3*k1**4*(-39*Pk2*k2**2*(16*r + 20*s - 13) + 5*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 13*f**2*k2**2*(Pk2*k2**4*(256*C - 128)*(2*r - 1) - 3*k1**4*(4*Pk2*(-4*C*r + 2*C + 10*b1*(4*r + 4*s - 3) + 10*r + 8*s - 7) - Pkd2*k2*(4*C - 3)*(4*s - 1)) + 4*k1**2*k2**2*(Pk2*(8*C*(57*r + 46*s - 40) - 11*b1*(16*r + 20*s - 13) - 306*r - 240*s + 213) + Pkd2*k2*(12*C - 6)*(4*s - 1))) + 143*f*k1**2*k2**2*(-24*Pk2*b2*k2**2*(4*r + 4*s - 3) + 4*Pkd2*b1**2*k2**3*(4*s - 1) + b1*k1**2*(-4*Pk2*(K*(2*r - 1) - 8*r - 8*s + 6) + Pkd2*k2*(K*(2 - 8*s) + 4*s - 1)) + b1*k2**2*(8*Pk2*(2*C*(r + 2*s - 1) + K*(-38*r - 52*s + 32) + 13*r + 18*s - 11) - Pkd2*k2*(4*s - 1)*(4*C + 8*K - 3)) + 4*g2*k1**2*(Pk2*(4*r - 2) + Pkd2*k2*(4*s - 1)) + 16*g2*k2**2*(Pk2*(38*r + 52*s - 32) + Pkd2*k2*(4*s - 1)))))/(45045*d*k1*k2**2*k3**4) - np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk3*f**3*k1**2*k2*st**7*(-4*Pk2 + Pkd2*k2)*(4*s - 1)*(D1*fd + Dd*f)/(429*d*k3**4) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk3*f*st**5*(D1*bd1*f*(11*K*Pkd2*k2**3*s + 12*Pk2*f*k1**2*s - 11*Pk2*k2**2*(2*K*s + f*(r - 1) + r - 1) - 3*Pkd2*f*k1**2*k2*s) + b1*(D1*fd*(f*(11*Pk2*k2**2*(1 - 3*r) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(3*s - 1)) + 11*k2**2*(-K*(2*Pk2 - Pkd2*k2)*(2*s - 1) - 2*Pk2*r)) + Dd*f*(f*(22*Pk2*k2**2*(1 - 2*r) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 11*k2**2*(K*Pkd2*k2*(4*s - 1) + Pk2*(-8*K*s + 2*K - 4*r + 2)))) + k2**2*(-2*C*f*(2*Pk2 - Pkd2*k2)*(D1*fd*(3*s - 1) + Dd*f*(4*s - 1)) - 22*D1*Pk2*bd2*f*s - 3*D1*Pk2*f*fd*r + 6*D1*Pk2*f*fd*s - D1*Pk2*f*fd + 44*D1*Pk2*f*gd2*s + 88*D1*Pk2*fd*g2*s - 44*D1*Pk2*fd*g2 + 11*D1*Pkd2*bd2*f*k2*s - 3*D1*Pkd2*f*fd*k2*s + D1*Pkd2*f*fd*k2 - 22*D1*Pkd2*f*gd2*k2*s - 44*D1*Pkd2*fd*g2*k2*s + 22*D1*Pkd2*fd*g2*k2 - 4*Dd*Pk2*f**2*r + 8*Dd*Pk2*f**2*s + 176*Dd*Pk2*f*g2*s - 44*Dd*Pk2*f*g2 - 4*Dd*Pkd2*f**2*k2*s + Dd*Pkd2*f**2*k2 - 88*Dd*Pkd2*f*g2*k2*s + 22*Dd*Pkd2*f*g2*k2 - 11*b2*(2*Pk2 - Pkd2*k2)*(D1*fd*(2*s - 1) + Dd*f*(4*s - 1))))/(693*d*k2*k3**2) + 2*np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk3*f*st**5*(D1*(f**2*(143*Pk2*bd1*k2**4*(r - 1) - 156*Pk2*fd*k1**2*k2**2*(3*r + 2*s - 2) + 13*bd1*k1**2*k2**2*(4*Pk2*(2*r + s - 2) + Pkd2*k2*(2*s + 1)) + 9*fd*k1**4*(4*Pk2 - Pkd2*k2)*(4*s - 1)) - 13*f*k2**2*(b1*fd*(11*Pk2*k2**2*(1 - 3*r) - 3*k1**2*(4*Pk2*(2*r + s - 1) + Pkd2*k2*(2*s - 1))) + k2**2*(24*C*Pk2*fd*r + 12*C*Pk2*fd*s - 12*C*Pk2*fd + 6*C*Pkd2*fd*k2*s - 2*C*Pkd2*fd*k2 + 22*Pk2*bd2*(r + s - 1) - 15*Pk2*fd*r - 6*Pk2*fd*s + 7*Pk2*fd - 88*Pk2*gd2*r - 44*Pk2*gd2*s + 88*Pk2*gd2 - 3*Pkd2*fd*k2*s + Pkd2*fd*k2 - 22*Pkd2*gd2*k2*s + 11*bd1*(2*K*Pk2*(2*r + s - 2) + K*Pkd2*k2*s - Pk2*r + Pk2))) + 143*fd*k2**4*(-2*Pk2*b2*(2*r + 2*s - 1) + b1*(K*Pk2*(-8*r - 4*s + 2) + K*Pkd2*k2*(1 - 2*s) + 2*Pk2*r) + 2*g2*(Pk2*(8*r + 4*s - 2) + Pkd2*k2*(2*s - 1)))) + Dd*f*(3*f**2*k1**2*(-52*Pk2*k2**2*(3*r + 2*s - 2) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(4*s - 1)) + 13*f*k2**2*(22*Pk2*b1*k2**2*(2*r - 1) - 4*Pk2*k2**2*(C*(8*r + 4*s - 5) - 5*r - 2*s + 3) + Pkd2*k2**3*(C*(2 - 8*s) + 4*s - 1) + 2*b1*k1**2*(2*Pk2*(8*r + 4*s - 5) + Pkd2*k2*(4*s - 1))) - 143*k2**4*(K*Pkd2*b1*k2*(4*s - 1) + 2*Pk2*b1*(K*(8*r + 4*s - 5) - 2*r + 1) + 2*Pk2*b2*(4*r + 4*s - 3) - 4*Pk2*g2*(8*r + 4*s - 5) + 2*Pkd2*g2*k2*(1 - 4*s))))/(9009*d*k2*k3**4) - np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk3*st**3*(D1*bd1*f*(Pk2*f*(4*C*s + r - 2*s) + Pkd2*f*k2*s*(1 - 2*C) + s*(2*Pk2 - Pkd2*k2)*(9*b2 - 18*g2)) + 9*b1**2*(D1*fd*(K*(2*Pk2 - Pkd2*k2)*(s - 1) + Pk2*f*(2*r - 1) + Pk2*r) + Dd*f*(K*Pkd2*k2*(1 - 4*s) + Pk2*(8*K*s - 2*K + f*(4*r - 2) + 4*r - 2))) + b1*(8*C*D1*Pk2*f*fd*s - 4*C*D1*Pk2*f*fd - 4*C*D1*Pkd2*f*fd*k2*s + 2*C*D1*Pkd2*f*fd*k2 + 16*C*Dd*Pk2*f**2*s - 4*C*Dd*Pk2*f**2 - 8*C*Dd*Pkd2*f**2*k2*s + 2*C*Dd*Pkd2*f**2*k2 + 18*D1*Pk2*bd2*f*s + 2*D1*Pk2*f*fd*r - 4*D1*Pk2*f*fd*s + D1*Pk2*f*fd - 36*D1*Pk2*f*gd2*s - 36*D1*Pk2*fd*g2*s + 36*D1*Pk2*fd*g2 - 9*D1*Pkd2*bd2*f*k2*s + 2*D1*Pkd2*f*fd*k2*s - D1*Pkd2*f*fd*k2 + 18*D1*Pkd2*f*gd2*k2*s + 18*D1*Pkd2*fd*g2*k2*s - 18*D1*Pkd2*fd*g2*k2 + 9*D1*bd1*f*(-2*K*Pkd2*k2*s + Pk2*(4*K*s + 2*f*r - f + 2*r - 1)) + 4*Dd*Pk2*f**2*r - 8*Dd*Pk2*f**2*s - 144*Dd*Pk2*f*g2*s + 36*Dd*Pk2*f*g2 + 4*Dd*Pkd2*f**2*k2*s - Dd*Pkd2*f**2*k2 + 72*Dd*Pkd2*f*g2*k2*s - 18*Dd*Pkd2*f*g2*k2 + 9*b2*(2*Pk2 - Pkd2*k2)*(D1*fd*(s - 1) + Dd*f*(4*s - 1))))/(315*d*k2) - np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk3*st**3*(11*D1*bd1*f*(3*Pk2*f**2*k1**2*(2*r + 4*s - 1) - f*(k1**2*(-Pk2*(2*K*s + b1*(6 - 8*s) + r + 2*s - 1) + Pkd2*k2*(K*s + b1*(3 - 4*s))) + k2**2*(18*K*Pk2*(r + 2*s - 1) - (2*C - 1)*(2*Pk2*r + Pkd2*k2))) + 9*k2**2*(K*b1*(Pk2*(4*r - 2) + Pkd2*k2) - Pkd2*b2*k2*(s - 1) - 2*g2*(2*Pk2*r + Pkd2*k2))) - 11*b1**2*(D1*fd*(9*K*k2**2*(-2*Pk2*r + Pkd2*k2) + f*k1**2*(2*Pk2 - Pkd2*k2)*(4*s + 1)) + 2*Dd*f*(18*K*Pk2*k2**2*(1 - 2*r) + f*k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1))) + 11*b1*(D1*(3*Pk2*f**2*fd*k1**2*(6*r + 12*s - 7) + f*fd*(k1**2*(K*Pkd2*k2*(1 - 2*s) + 2*Pk2*(K*(2*s - 1) + r + 2*s - 1)) + k2**2*(Pk2*(C*(8*r - 4) - 36*K*(r + 2*s - 1) - 4*r + 2) + Pkd2*k2*(1 - 2*C))) - 9*f*k2**2*(4*Pk2*gd2*(r - 1) + Pkd2*bd2*k2*s) - 9*fd*k2**2*(4*Pk2*g2*r + Pkd2*b2*k2*s - 2*Pkd2*g2*k2)) + Dd*f*(24*Pk2*f**2*k1**2*(r + 2*s - 1) + f*(-4*Pk2*k2**2*(C*(2 - 4*r) + 18*K*(r + 2*s - 1) + 2*r - 1) + k1**2*(K*Pkd2*k2*(1 - 4*s) + Pk2*(8*K*s - 2*K + 4*r + 8*s - 4))) + 9*k2**2*(8*Pk2*g2*(1 - 2*r) + Pkd2*b2*k2*(1 - 4*s)))) + f*(D1*(792*Pk2*fd*g2*k2**2*(r + 2*s - 1) + f*fd*(Pk2*k2**2*(2 - 4*C)*(81*r + 66*s - 49) + 3*k1**2*(Pk2*(12*C*s - 4*C + 3*r - 1) + Pkd2*k2*(-6*C*s + 2*C + 3*s - 1))) - 11*f*(bd2 - 2*gd2)*(-2*Pk2*k1**2*s + 18*Pk2*k2**2*(r + 2*s - 1) + Pkd2*k1**2*k2*s) - 22*fd*g2*k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1)) + Dd*f*(-Pk2*f*k2**2*(16*C - 8)*(27*r + 22*s - 19) + 1584*Pk2*g2*k2**2*(r + 2*s - 1) + 3*f*k1**2*(2*Pk2*(C*(8*s - 2) + 2*r - 1) + Pkd2*k2*(C*(2 - 8*s) + 4*s - 1)) - 22*g2*k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1)) + 11*b2*(D1*fd*(-36*Pk2*k2**2*(r + 2*s - 1) + k1**2*(2*Pk2 - Pkd2*k2)*(2*s - 1)) + Dd*f*(-72*Pk2*k2**2*(r + 2*s - 1) + k1**2*(2*Pk2 - Pkd2*k2)*(4*s - 1)))))/(3465*d*k2*k3**2) + np.sqrt(35)*1j*np.sqrt(np.pi)*D1**3*Pk3*st**3*(D1*bd1*f*(f**2*k1**2*(11*Pk2*k2**2*(8*s - 5) + 3*k1**2*(4*Pk2*(r + 2*s - 2) + Pkd2*k2*(3 - 2*s))) - 11*f*k2**2*(k1**2*(-Pk2*(-2*K*(4*r + 5*s - 4) + 2*b1*(4*r + 4*s - 5) + r + 2*s - 1) + Pkd2*k2*(K*s + b1*(3 - 6*s))) + k2**2*(Pk2*(4*C*(r + s - 2) + 18*K*r + 36*K*s - 18*K + b1*(9 - 18*r) - 3*r - 2*s + 4) + Pkd2*k2*(2*C - 1)*(s - 1))) - 99*k2**4*(2*Pk2*b2*(r + s - 1) - 4*Pk2*g2*(r + s - 2) - 2*Pkd2*g2*k2*(s - 1) + b1*(K*Pk2*(4*r + 4*s - 6) + K*Pkd2*k2*(2*s - 1) - 2*Pk2*r + Pk2))) - 11*b1**2*k2**2*(D1*fd*(-f*(9*Pk2*k2**2*(2*r - 1) + k1**2*(Pk2*(8*r + 8*s - 2) + 6*Pkd2*k2*s)) + 9*k2**2*(2*K*Pk2*(r + s + 1) + K*Pkd2*k2*s - Pk2*r)) + Dd*f*(f*(18*Pk2*k2**2*(1 - 2*r) + k1**2*(-4*Pk2*(4*r + 4*s - 3) + 3*Pkd2*k2*(1 - 4*s))) + 9*k2**2*(K*Pkd2*k2*(4*s - 1) + Pk2*(K*(8*r + 8*s - 6) - 4*r + 2)))) + b1*(D1*(3*f**2*fd*k1**2*(11*Pk2*k2**2*(8*s - 1) + k1**2*(4*Pk2*(3*r + 6*s - 2) - Pkd2*k2*(6*s + 1))) - 11*f*k2**2*(fd*(k1**2*(K*Pkd2*k2*(2*s - 1) + 2*Pk2*(K*(8*r + 10*s - 5) - r - 2*s + 1)) + k2**2*(Pk2*(8*C*r + 8*C*s + 36*K*(r + 2*s - 1) - 6*r - 4*s + 1) + Pkd2*k2*s*(4*C - 2))) + 18*k2**2*(Pk2*bd2*(r + s - 1) - gd2*(2*Pk2*(r + s - 1) + Pkd2*k2*s))) + 198*fd*k2**4*(-Pk2*b2*(r + s) + 2*Pk2*g2*(r + s + 1) + Pkd2*g2*k2*s)) + Dd*f*(2*f**2*k1**2*(44*Pk2*k2**2*(4*s - 1) + 3*k1**2*(8*Pk2*(r + 2*s - 1) + Pkd2*k2*(1 - 4*s))) - 11*f*k2**2*(k1**2*(K*Pk2*(32*r + 40*s - 26) + K*Pkd2*k2*(4*s - 1) - 4*Pk2*(r + 2*s - 1)) + k2**2*(4*Pk2*(C*(4*r + 4*s - 3) + 18*K*(r + 2*s - 1) - 3*r - 2*s + 2) + Pkd2*k2*(2*C - 1)*(4*s - 1))) + 198*k2**4*(Pk2*b2*(-4*r - 4*s + 3) + Pk2*g2*(8*r + 8*s - 6) + Pkd2*g2*k2*(4*s - 1)))) + f*(D1*(-6*Pk2*f**2*fd*k1**4*(10*r + 24*s - 11) + f*k2**2*(-66*Pk2*bd2*k1**2*(r + s - 1) - Pk2*fd*k2**2*(4*C - 2)*(81*r + 66*s - 49) + 396*Pk2*gd2*k2**2*(r + 2*s - 1) - 3*fd*k1**2*(3*Pk2*(4*C*(4*r + 5*s - 3) - 9*r - 12*s + 7) + Pkd2*k2*(2*C - 1)*(3*s - 1)) + 22*gd2*k1**2*(2*Pk2*(4*r + 5*s - 4) + Pkd2*k2*s)) + 22*fd*k2**2*(-3*Pk2*b2*k1**2*(2*r + 2*s - 1) + 36*Pk2*g2*k2**2*(r + 2*s - 1) + g2*k1**2*(2*Pk2*(8*r + 10*s - 5) + Pkd2*k2*(2*s - 1)))) + Dd*f*(-6*Pk2*f**2*k1**4*(10*r + 24*s - 11) + f*k2**2*(Pk2*k2**2*(8 - 16*C)*(27*r + 22*s - 19) - 3*k1**2*(C*Pk2*(64*r + 80*s - 52) - 6*Pk2*(6*r + 8*s - 5) + Pkd2*k2*(2*C - 1)*(4*s - 1))) + 22*k2**2*(-3*Pk2*b2*k1**2*(4*r + 4*s - 3) + 72*Pk2*g2*k2**2*(r + 2*s - 1) + g2*k1**2*(Pk2*(32*r + 40*s - 26) + Pkd2*k2*(4*s - 1))))))/(3465*d*k2*k3**4)
        
        return (perm12+perm13+perm23)
