import numpy as np

#second order wide angle terms theta and phi
def WA_2(mu,phi,cosmo_functions,k1,k2,k3=None,theta=None,zz=0,r=0,s=0):
    
    #get generic cosmology parameters
    k1,k2,k3,theta,Pk1,Pk2,Pk3,Pkd1,Pkd2,Pkd3,Pkdd1,Pkdd2,Pkdd3,d,K,C,f,D1,b1,b2,g2 = cosmo_functions.get_params(k1,k2,k3,theta,zz)
    

    mu2 = mu*np.cos(theta)+np.sqrt((1-mu**2)) *np.sin(theta)*np.cos(phi)
    st = np.sin(theta)
    ct= np.cos(theta)
    cosphi = np.cos(phi)

    perm12 = 64*D1**4*Pk1*Pk2*ct**4*f**3*k2**4*mu**2*mu2**4*(3*r**2 - 2*r + 1)/(7*d**2*k3**6) + 128*D1**4*Pk1*Pk2*ct**4*f**3*k2**3*mu**3*mu2**3*(k1**2*(3*r**2 - 2*r + 1) + k3**2*(cosphi**2 - 1)*(3*r - 1)*(2*r + 2*s - 1))/(7*d**2*k1*k3**6) - 96*D1**4*Pk1*Pk2*f**4*mu**7*mu2**3*(10*r**2 - 5*r + 1)/(d**2*k1*k2) - 2*D1**4*Pk1*b1*ct**4*f*(2*b1*(8*Pk2*k2**2*k3**4*r**2*(2*k2**2 + k3**2) + 4*cosphi**2*k1**2*k3**2*(4*Pk2*k2**4*(r + s)**2 - 2*k2**2*k3**2*s*(2*Pk2*(r - s) + Pkd2*k2*s) + k3**4*(4*Pk2 - Pkd2*k2)*(s - 1)**2) + 2*k1**4*(32*Pk2*k2**4*(r + s)**2 + 8*Pk2*k3**4*s**2 - 8*Pkd2*k2**3*k3**2*s*(r + s) - 5*Pkd2*k2*k3**4*s**2 + k2**2*k3**2*s*(16*Pk2*(r + s) + Pkdd2*k3**2*s)) + k1**2*k3**2*(32*Pk2*k2**4*r*(r + s) + 8*Pk2*k3**4*s**2 - 8*Pkd2*k2**3*k3**2*r*s - 5*Pkd2*k2*k3**4*s**2 + k2**2*k3**2*s*(16*Pk2*r + Pkdd2*k3**2*s))) + 7*g2*k3**6*(8*Pk2*k1**2*s**2 - 5*Pkd2*k1**2*k2*s**2 + 4*cosphi**2*k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)**2 + k2**2*(8*Pk2*r**2 + Pkdd2*k1**2*s**2)))/(7*d**2*k1**2*k2**2*k3**6) - D1**4*Pk1*b1*ct**3*f*mu2**2*(f*(336*Pk2*k2**6*k3**4*r**2 + k1**6*(8*Pk2*k2**4*(155*r**2 + 2*r*(155*s - 51) + 155*s**2 - 102*s + 7) + 168*Pk2*k3**4*s**2 - 8*Pkd2*k2**3*k3**2*s*(18*r + 18*s - 7) - 63*Pkd2*k2*k3**4*s**2 + k2**2*k3**2*s*(32*Pk2*(18*r + 18*s - 7) + 7*Pkdd2*k3**2*s)) + k1**4*(16*Pk2*k2**6*(129*r**2 + 2*r*(129*s - 61) + 129*s**2 - 122*s + 23) + 168*Pk2*k3**6*s**2 - 4*Pkd2*k2**5*k3**2*(r*(139*s - 40) + 139*s**2 - 109*s + 8) + 2*Pkd2*k2**3*k3**4*(-42*cosphi**2*(1 - 2*s)**2 + s*(16*r - 131*s + 48)) - 63*Pkd2*k2*k3**6*s**2 + 2*k2**4*(4*Pk2*k3**2*(7*cosphi**2*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) - 20*r**2 + 59*r*s + 16*r + 79*s**2 - 45*s + 8) + Pkdd2*k3**4*s*(31*s - 16)) + k2**2*k3**4*(336*Pk2*cosphi**2*(1 - 2*s)**2 + s*(-128*Pk2*r + 304*Pk2*s + 7*Pkdd2*k3**2*s))) + k1**2*k2**2*(56*Pk2*k2**6*(r + s - 1)**2 + 56*Pk2*k3**6*s**2 - 28*Pkd2*k2**5*k3**2*s*(r + s - 1) - Pkd2*k2**3*k3**4*(84*cosphi**2*(1 - 2*s)**2 + 12*r*(23*s - 8) + 7*s**2) - 35*Pkd2*k2*k3**6*s**2 + k2**4*k3**2*(56*Pk2*cosphi**2*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) + 24*Pk2*r*(37*r + 37*s - 15) + 7*Pkdd2*k3**2*s**2) + k2**2*k3**4*(-8*Pk2*cosphi**2*(48*r**2 + 2*r*(69*s - 38) - 21*(1 - 2*s)**2) - 24*Pk2*r*(4*r - 7*s) + 7*Pkdd2*k3**2*s**2))) - 8*k1**2*k2**2*(b1*(Pk2*k2**4*(k1**2*(87*r**2 + 160*r*s + 80*s**2) + 7*k2**2*r**2) + 4*k2**2*k3**2*(14*Pk2*k1**2*s*(r + s) + 2*Pk2*k2**2*r*(2*r + 3*s) - 7*Pkd2*k1**2*k2*s*(r + s)) + 6*k3**6*r*(4*Pk2 - Pkd2*k2)*(s - 1) + 4*k3**4*s*(8*Pk2*k1**2*s - 5*Pkd2*k1**2*k2*s - 3*Pkd2*k2**3*r + k2**2*(6*Pk2*r + Pkdd2*k1**2*s))) + 21*g2*k3**6*r*(4*Pk2 - Pkd2*k2)*(s - 1)))/(7*d**2*k1**3*k2**3*k3**6) - D1**4*Pk1*b1*ct**3*f*(b1*(56*Pk2*k2**4*k3**4*r**2*(k2**2 + k3**2) + 4*cosphi**2*k1**2*k3**2*(14*Pk2*k2**6*(r + s)**2 + 7*k1**2*(2*Pk2*k2**4*(r + s)**2 - k2**2*k3**2*s*(2*Pk2*(r - s) + Pkd2*k2*s) + k3**4*(4*Pk2 - Pkd2*k2)*(s - 1)**2) - k2**4*k3**2*(4*Pk2*r*(4*r + 11*s) + 7*Pkd2*k2*s**2) + k2**2*k3**4*(s - 1)*(-2*Pk2*(4*r - 7*s + 7) - 7*Pkd2*k2*(s - 1))) + k1**6*(480*Pk2*k2**4*(r + s)**2 + 56*Pk2*k3**4*s**2 - 88*Pkd2*k2**3*k3**2*s*(r + s) - 35*Pkd2*k2*k3**4*s**2 + k2**2*k3**2*s*(176*Pk2*(r + s) + 7*Pkdd2*k3**2*s)) + k1**4*(480*Pk2*k2**6*(r + s)**2 + 56*Pk2*k3**6*s**2 - 152*Pkd2*k2**5*k3**2*s*(r + s) + Pkd2*k2**3*k3**4*s*(32*r - 7*s) - 35*Pkd2*k2*k3**6*s**2 + k2**4*k3**2*(-96*Pk2*(r + s)**2 + 23*Pkdd2*k3**2*s**2) + k2**2*k3**4*s*(-32*Pk2*(2*r + s) + 7*Pkdd2*k3**2*s)) + k1**2*k2**3*k3**2*(176*Pk2*k2**3*r*(r + s) - 4*k2*k3**2*r*(8*Pk2*(r + 2*s) + 15*Pkd2*k2*s) + k3**4*(-16*Pkd2*r*(s - 1) - 7*Pkd2*s**2 + 7*Pkdd2*k2*s**2))) - 56*g2*k1**2*k2**2*k3**6*r*(s - 1)*(2*Pk2*cosphi**2 + Pkd2*k2))/(7*d**2*k1**3*k2**3*k3**6) - 32*D1**4*Pk1*b1*ct**2*f**2*mu2**6*(8*Pk2*k2**4*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) + 24*Pk2*k3**4*(3*s**2 - 3*s + 1) - 2*Pkd2*k2**3*k3**2*(r*(6*s - 3) + 6*s**2 - 6*s + 2) - 9*Pkd2*k2*k3**4*(3*s**2 - 3*s + 1) + k2**2*(8*Pk2*k3**2*(6*r*s - 3*r + 6*s**2 - 6*s + 2) + Pkdd2*k3**4*(3*s**2 - 3*s + 1)))/(7*d**2*k3**6) + D1**4*Pk1*b1*ct**2*f*(7*b1**2*k3**6*s*(4*cosphi**2*(2*Pk2*k2**2*r + k1**2*(Pk2*r - 2*Pk2*s + Pkd2*k2*s)) + k2*(Pkd2*k1**2*s + 2*Pkd2*k2**2*r - Pkdd2*k1**2*k2*s)) + 2*b1*(-28*Pk2*k2**6*k3**2*r*(r + s) + 2*cosphi**2*(Pk2*k2**2*k3**4*(7*k2**2*r*(r + s) - k3**2*(2*r**2 + r*(3 - 7*s) + 2)) + k1**2*k3**2*(4*Pk2*k2**4*(r + s)**2 + k2**2*k3**2*(Pk2*(3*r**2 + 15*r*s + 16*s**2) - 2*Pkd2*k2*s**2) + k3**4*(s - 1)*(Pk2*(7*r - 4*s + 4) + 6*Pkd2*k2*(s - 1)))) - 2*k1**6*(r + s)*(72*Pk2*k2**2*(r + s) + 14*Pk2*k3**2*s - 7*Pkd2*k2*k3**2*s) + k1**4*(-384*Pk2*k2**4*(r + s)**2 + 2*Pk2*k3**4*s*(21*r + 20*s) + 96*Pkd2*k2**3*k3**2*s*(r + s) - Pkd2*k2*k3**4*s*(21*r + 10*s) + 2*k2**2*k3**2*(Pk2*(69*r**2 + 128*r*s + 59*s**2) - 5*Pkdd2*k3**2*s**2)) - k1**2*(144*Pk2*k2**6*(r + s)**2 - 2*Pk2*k3**6*s*(7*r + 10*s - 7) - 58*Pkd2*k2**5*k3**2*s*(r + s) + Pkd2*k2**3*k3**4*s*(39*r + 37*s) + Pkd2*k2*k3**6*s*(7*r + 5*s - 7) + k2**4*(-2*Pk2*k3**2*(59*r**2 + 128*r*s + 69*s**2) + 11*Pkdd2*k3**4*s**2) + k2**2*(8*Pk2*k3**4*(r**2 - 4*r*s + s**2) + Pkdd2*k3**6*(7*s**2 - 4*s + 2))) + 2*k2**4*k3**4*r*(20*Pk2*r + 21*Pk2*s + 7*Pkd2*k2*s) + k2**2*k3**6*(2*Pk2*r*(10*r + 7*s - 7) + 7*Pkd2*k2*(r*(3*s - 2) - s))) + 7*k3**6*(b2*k1**2*(-4*cosphi**2*(2*Pk2 - Pkd2*k2)*(s - 1)**2 + k2*s**2*(Pkd2 - Pkdd2*k2)) + 2*g2*(10*Pk2*k2**2*r**2 + 2*cosphi**2*(-Pk2*k2**2*(r - 1)**2 + 4*k1**2*(3*Pk2 - Pkd2*k2)*(s - 1)**2) + k1**2*(10*Pk2*s**2 - 6*Pkd2*k2*s**2 + Pkdd2*k2**2*(2*s - 1)))))/(7*d**2*k1**2*k2**2*k3**6) - 2*D1**4*Pk1*b1*ct*f**2*mu2**6*(168*Pk2*f*k3**6*s*(1 - 3*s) + 112*Pk2*k2**6*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) + 63*Pkd2*f*k2*k3**6*s*(3*s - 1) - 28*Pkd2*k2**5*k3**2*(r*(6*s - 3) + 6*s**2 - 6*s + 2) + 2*Pkd2*k2**3*k3**4*(48*r*(2*s - 1) - 105*s**2 + 105*s - 35) + 14*k1**2*(8*Pk2*k2**4*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) + 24*Pk2*k3**4*(3*s**2 - 3*s + 1) - 2*Pkd2*k2**3*k3**2*(r*(6*s - 3) + 6*s**2 - 6*s + 2) - 9*Pkd2*k2*k3**4*(3*s**2 - 3*s + 1) + k2**2*(8*Pk2*k3**2*(6*r*s - 3*r + 6*s**2 - 6*s + 2) + Pkdd2*k3**4*(3*s**2 - 3*s + 1))) + 2*k2**4*k3**2*(-4*Pk2*(48*r**2 + 6*r*s - 3*r - 42*s**2 + 42*s - 14) + 7*Pkdd2*k3**2*(3*s**2 - 3*s + 1)) + k2**2*k3**4*(-16*Pk2*(48*r*s - 24*r - 21*s**2 + 21*s - 7) + 7*Pkdd2*f*k3**2*s*(1 - 3*s)))/(7*d**2*k1*k2*k3**6) + D1**4*Pk1*b1*ct*f*mu2**2*(14*b1**2*k1**2*k3**6*s**2*(k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + k2**3*(-Pkd2 + Pkdd2*k2)) + b1*(-56*Pk2*k2**4*k3**4*r**2*(k2**2 + k3**2) + 56*k1**6*k2**2*(r + s)*(5*Pk2*k2**2*(r + s) + 2*Pk2*k3**2*s - Pkd2*k2*k3**2*s) + k1**4*(8*Pk2*k2**6*(123*r**2 + 260*r*s + 130*s**2) - 2*k2**4*k3**2*(Pk2*(232*r**2 + 370*r*s + 103*s**2) + 182*Pkd2*k2*s*(r + s)) + k2**2*k3**4*s*(-2*Pk2*(84*r + 71*s) + k2*(112*Pkd2*r + 12*Pkd2*s + 59*Pkdd2*k2*s)) + 7*k3**6*(36*Pk2 + k2*(-24*Pkd2 + 5*Pkdd2*k2))*(s - 1)**2) + k1**2*k2**2*(56*Pk2*k2**6*(4*r**2 + 10*r*s + 5*s**2) - 2*k2**4*k3**2*(Pk2*(212*r**2 + 426*r*s + 147*s**2) + 70*Pkd2*k2*s*(r + s)) + k2**2*k3**4*(16*Pk2*r*(4*r + 7*s) + k2*s*(216*Pkd2*r + 112*Pkd2*s + 35*Pkdd2*k2*s)) - k3**6*(s - 1)*(2*Pk2*(80*r + 7*s - 7) + k2*(-4*Pkd2*(20*r - 7*s + 7) - 35*Pkdd2*k2*(s - 1))))) - f*(56*Pk2*k1**8*k2**2*(r + s)**2 + 14*Pk2*k2**4*k3**4*(k2**2*(cosphi**2*(2*r**2 - 2*r + 1) - 17*r**2 - 2*r + 1) + k3**2*(6*b1*r**2 + cosphi**2*(2*r**2 - 2*r + 1) + r**2 - 2*r + 1)) + k1**6*(8*Pk2*k2**4*(104*r**2 + r*(208*s - 66) + 104*s**2 - 66*s + 7) - 2*Pk2*k2**2*k3**2*(49*r**2 + r*(78*s + 28) + s*(29*s - 28)) - 84*Pk2*k3**4*s**2 - 4*Pkd2*k2**3*k3**2*(r + s)*(27*s - 14) + 21*Pkd2*k2*k3**4*s**2) + k1**4*(8*Pk2*k2**6*(211*r**2 + r*(422*s - 204) + 211*s**2 - 204*s + 38) + 28*Pk2*k3**6*s*(b1*(9*s - 4) - 3*s) - 4*Pkd2*k2**5*k3**2*(r*(141*s - 65) + 141*s**2 - 122*s + 13) + 2*Pkd2*k2**3*k3**4*(42*cosphi**2*(1 - 2*s)**2 + 96*r*s - 28*r - 9*s**2 + 22*s - 21) + 7*Pkd2*k2*k3**6*s*(-2*b1*(9*s - 5) + 3*s) + k2**4*(-4*Pk2*k3**2*(14*cosphi**2*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) + 282*r**2 + 370*r*s - 108*r + 88*s**2 - 90*s - 19) + Pkdd2*k3**4*(78*s**2 - 66*s + 7)) + k2**2*(2*Pk2*k3**4*(14*cosphi**2*(r**2 - 12*(1 - 2*s)**2) + 21*r**2 - 160*r*s + 28*r - 12*s**2 - 42*s + 21) + 7*Pkdd2*b1*k3**6*s*(3*s - 2))) + k1**2*k2**2*(56*Pk2*k2**6*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1) + 14*Pk2*k3**6*(cosphi**2*(2*r**2 - 2*r + 1) + s**2*(6*b1 - 3)) - 28*Pkd2*k2**5*k3**2*(r*(6*s - 3) + 6*s**2 - 6*s + 1) + Pkd2*k2**3*k3**4*(84*cosphi**2*(1 - 2*s)**2 + 276*r*s - 96*r + 105*s**2 - 84*s - 14) + 7*Pkd2*k2*k3**6*s*(b1*(2 - 12*s) + 3*s) + k2**4*k3**2*(-2*Pk2*(28*cosphi**2*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) + 395*r**2 + 542*r*s - 208*r + 147*s**2 - 140*s - 14) + 7*Pkdd2*k3**2*(6*s**2 - 6*s + 1)) + 2*k2**2*k3**4*(Pk2*(cosphi**2*(220*r**2 + 552*r*s - 318*r - 336*s**2 + 336*s - 77) + 48*r**2 - 84*r*s - 14) + 7*Pkdd2*b1*k3**2*s*(3*s - 1)))) + 280*g2*k1**2*k2**2*k3**6*r*(-2*Pk2 + Pkd2*k2)*(s - 1))/(7*d**2*k1**3*k2**3*k3**6) - D1**4*Pk1*b1*ct*f*(7*b1**2*k3**6*(2*Pk2*k1**4*s**2 - 2*Pkd2*k1**4*k2*s**2 + 2*Pkd2*k1**2*k2**3*s**2 + Pkdd2*k1**4*k2**2*s**2 + k2**4*(2*Pk2*r**2 + Pkdd2*k1**2*s**2)) + b1*(56*Pk2*k1**8*k2**2*(r + s)**2 + 14*Pk2*k2**4*k3**4*(-3*k2**2*r**2 + k3**2*(cosphi**2*(r - 1)**2 - 2*r**2 - 2*r + 1)) + k1**6*(360*Pk2*k2**4*(r + s)**2 - 2*Pk2*k2**2*k3**2*(49*r**2 + 130*r*s + 81*s**2) - 42*Pk2*k3**4*s**2 - 52*Pkd2*k2**3*k3**2*s*(r + s) + 21*Pkd2*k2*k3**4*s**2) + k1**4*(360*Pk2*k2**6*(r + s)**2 - 4*k2**4*k3**2*(r + s)*(Pk2*(14*cosphi**2 + 95)*(r + s) + 32*Pkd2*k2*s) + k2**2*k3**4*(2*Pk2*(r**2*(7*cosphi**2 + 21) + r*s*(28*cosphi**2 + 32) + s**2*(16 - 28*cosphi**2)) + k2*s*(80*Pkd2*r + Pkd2*s*(28*cosphi**2 + 91) + 19*Pkdd2*k2*s)) - 7*k3**6*(2*Pk2*(8*cosphi**2*(s - 1)**2 + 2*s**2 + 2*s - 1) - k2*(Pkd2*(4*cosphi**2*(s - 1)**2 + s**2 + 4*s - 2) + Pkdd2*k2*(s - 1)**2))) + k1**2*k2**2*(2*cosphi**2*k3**2*(-28*Pk2*k2**4*(r + s)**2 + k2**2*k3**2*(Pk2*r*(39*r + 88*s) + 14*Pkd2*k2*s**2) + k3**4*(Pk2*(7*r**2 + 16*r*s - 30*r - 28*s**2 + 56*s - 21) + 14*Pkd2*k2*(s - 1)**2)) + k2*(56*Pk2*k2**5*(r + s)**2 - 2*k2**3*k3**2*(r + s)*(81*Pk2*r + 49*Pk2*s + 14*Pkd2*k2*s) + k2*k3**4*(Pk2*(32*r**2 + 64*r*s + 42*s**2) + k2*s*(60*Pkd2*r + 42*Pkd2*s + 7*Pkdd2*k2*s)) + k3**6*(16*Pkd2*r*(s - 1) + 7*Pkd2*(5*s**2 - 4*s + 2) + 7*Pkdd2*k2*(s - 1)**2)))) + 56*g2*k1**2*k2**2*k3**6*r*(s - 1)*(2*Pk2*cosphi**2 + Pkd2*k2))/(7*d**2*k1**3*k2**3*k3**6) - 4*D1**4*Pk1*b1*f**3*mu*mu2**7*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(6*s**2 - 4*s + 1)/(d**2*k1*k2) - 2*D1**4*Pk1*b1*f**2*mu2**6*(2*k1**2*(168*Pk2*b1*k3**6*(3*s**2 - 3*s + 1) + 48*Pk2*k2**6*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) - 63*Pkd2*b1*k2*k3**6*(3*s**2 - 3*s + 1) - 12*Pkd2*k2**5*k3**2*(r*(6*s - 3) + 6*s**2 - 6*s + 2) + 3*Pkd2*k2**3*k3**4*(14*r*s - 7*r - 30*s**2 + 30*s - 10) + 6*k2**4*(Pk2*k3**2*(-14*r**2 + 10*r*s - 5*r + 24*s**2 - 24*s + 8) + Pkdd2*k3**4*(3*s**2 - 3*s + 1)) + k2**2*(-12*Pk2*k3**4*(14*r*s - 7*r - 12*s**2 + 12*s - 4) + 7*Pkdd2*b1*k3**6*(3*s**2 - 3*s + 1))) + k2**2*k3**2*r*(28*Pk2*f*k3**4 - 84*Pk2*k2**4*(2*r + 2*s - 1) + 12*Pk2*k2**2*k3**2*(8*r - 14*s + 7) - 7*Pkd2*f*k2*k3**4 + 42*Pkd2*k2**3*k3**2*(2*s - 1)))/(7*d**2*k1**2*k2**2*k3**6) - D1**4*Pk1*b1*f*(7*b1**2*k3**6*(2*cosphi**2*(2*Pk2*k1**2*s*(r - 2*s) + Pk2*k2**2*r*(r + 4*s) + 2*Pkd2*k1**2*k2*s**2) + s*(-2*Pk2*k2**2*r + k1**2*(-2*Pk2*r + k2*(2*Pkd2*r + Pkd2*s + Pkdd2*k2*s)))) + 2*b1*(2*Pk2*k1**6*(r + s)*(12*k2**2*(r + s) - 7*k3**2*s) - 14*Pk2*k2**6*k3**2*r*(r + s) + 2*cosphi**2*(Pk2*k2**2*k3**4*(7*k2**2*r*(r + s) + k3**2*(5*r**2 + r*(7*s - 17) + 5)) + k1**2*k3**2*(-12*Pk2*k2**4*(r + s)**2 + k2**2*k3**2*(Pk2*r*(10*r + 31*s) + 6*Pkd2*k2*s**2) + k3**4*(s - 1)*(Pk2*(7*r - 20*s + 20) + 10*Pkd2*k2*(s - 1)))) + k1**4*(48*Pk2*k2**4*(r + s)**2 - 2*Pk2*k2**2*k3**2*(22*r**2 + 51*r*s + 29*s**2) + Pk2*k3**4*s*(21*r + 8*s) - 12*Pkd2*k2**3*k3**2*s*(r + s) + 10*Pkd2*k2*k3**4*s**2) + k1**2*(24*Pk2*k2**6*(r + s)**2 + Pk2*k3**6*(7*r + s*(4*s - 7)) - 12*Pkd2*k2**5*k3**2*s*(r + s) + 19*Pkd2*k2**3*k3**4*s*(r + s) + Pkd2*k2*k3**6*(7*r*(s - 1) + 5*s**2) + k2**4*(-2*Pk2*k3**2*(29*r**2 + 51*r*s + 22*s**2) + 3*Pkdd2*k3**4*s**2) + k2**2*(2*Pk2*k3**4*(10*r**2 + 21*r*s + 10*s**2) + 5*Pkdd2*k3**6*(s - 1)**2)) + k2**4*k3**4*r*(8*Pk2*r + 21*Pk2*s + 7*Pkd2*k2*s) + k2**2*k3**6*(Pk2*(4*r**2 - 7*r + 7*s) + 7*Pkd2*k2*r*(s - 1))) + 7*k3**6*(b2*(2*cosphi**2*(Pk2*k2**2*(r - 1)**2 - 2*k1**2*(2*Pk2 - Pkd2*k2)*(s - 1)**2) + k1**2*k2*(Pkd2*s**2 + Pkdd2*k2*(s - 1)**2)) - 2*g2*(-2*Pk2*k2**2*r**2 + cosphi**2*(2*Pk2*k2**2*(r - 1)**2 - 4*k1**2*(2*Pk2 - Pkd2*k2)*(s - 1)**2) + k1**2*(-2*Pk2*s**2 + Pkd2*k2*s**2 + Pkdd2*k2**2*(s - 1)**2))))/(7*d**2*k1**2*k2**2*k3**6) + D1**4*Pk1*ct**4*f**3*k1**2*mu**6*(32*cosphi**2 - 32)*(3*s - 1)*(2*Pk2*k2**2*(r + s - 1) + 4*Pk2*k3**2*(s - 1) - Pkd2*k2*k3**2*(s - 1))/(7*d**2*k2**2*k3**4) + D1**4*Pk1*ct**4*f**3*k1*mu**5*mu2*(64*cosphi**2 - 64)*(2*Pk2*k2**2*(6*r**2 + r*(15*s - 11) + 9*s**2 - 11*s + 4) + 4*Pk2*k3**2*(9*s**2 - 9*s + 2) + Pkd2*k2*k3**2*(-9*s**2 + 9*s - 2))/(7*d**2*k2*k3**4) + 32*D1**4*Pk1*ct**4*f**3*mu**4*mu2**2*(2*Pk2*k1**2*k2**2*(3*r**2 - 2*r + 1) + k3**2*(3*cosphi**2 - 3)*(2*Pk2*k2**2*(9*r**2 + r*(15*s - 11) + 6*s**2 - 8*s + 3) + 4*Pk2*k3**2*(6*s**2 - 5*s + 1) - Pkd2*k2*k3**2*(6*s**2 - 5*s + 1)))/(7*d**2*k3**6) - 8*D1**4*Pk1*ct**4*f**2*mu2**4*(-16*Pk2*b1*k2**4*r**2 + f*(8*Pk2*k2**4*(r + s - 1)**2 + 24*Pk2*k3**4*s**2 - 4*Pkd2*k2**3*k3**2*s*(r + s - 1) - 9*Pkd2*k2*k3**4*s**2 + k2**2*k3**2*s*(16*Pk2*(r + s - 1) + Pkdd2*k3**2*s)))/(7*d**2*k3**6) - 8*D1**4*Pk1*ct**4*f**2*mu**4*(-2*b1*(2*k1**2*(2*Pk2*k2**4*(2*r**2 - 2*r + 1) + Pk2*k2**2*k3**2*(2*cosphi**2 - 2)*(2*s - 1)*(r + s - 1) + Pk2*k3**4*(4*cosphi**2 - 4)*(2*s**2 - 3*s + 1) - Pkd2*k2*k3**4*(cosphi**2 - 1)*(2*s**2 - 3*s + 1)) + k3**2*(cosphi**2 - 1)*(4*Pk2*k2**4*(6*r**2 + r*(8*s - 3) + s*(2*s - 3)) - 4*k2**2*k3**2*s*(Pk2*(6*r - 2*s - 3) + Pkd2*k2*s) + k3**4*(4*Pk2 - Pkd2*k2)*(2*s**2 - 3*s + 1))) + 4*f*(2*Pk2*k1**4*k2**2*(r + s - 1)**2 + 6*Pk2*k2**2*k3**4*r**2 + k1**2*k3**2*(4*Pk2*k2**2*r*(r + s - 1) + cosphi**2*(3*s - 1)*(2*Pk2*k2**2*(r + s - 1) + 4*Pk2*k3**2*(s - 1) - Pkd2*k2*k3**2*(s - 1)))) + g2*k3**6*(7 - 7*cosphi**2)*(4*Pk2 - Pkd2*k2)*(2*s**2 - 3*s + 1))/(7*d**2*k2**2*k3**6) - 64*D1**4*Pk1*ct**4*f**2*mu**3*mu2*(-2*Pk2*b1*k2**2*k3**2*(cosphi**2 - 1)*(2*r - 1)*(k2**2*(r + s) - k3**2*s) + 18*Pk2*f*k2**2*k3**4*r**2 + b1*k1**2*(-2*Pk2*k2**4*(2*r**2 - 2*r + 1) - Pk2*k2**2*k3**2*(2*cosphi**2 - 2)*(2*r**2 + r*(8*s - 5) + 6*s**2 - 7*s + 2) - Pk2*k3**4*(4*cosphi**2 - 4)*(6*s**2 - 7*s + 2) + Pkd2*k2*k3**4*(cosphi**2 - 1)*(6*s**2 - 7*s + 2)) + 2*f*k1**4*(r + s - 1)*(Pk2*k2**2*(7*r + 7*s - 3) + 4*Pk2*k3**2*s - Pkd2*k2*k3**2*s) + f*k1**2*k3**2*(cosphi**2*(2*Pk2*k2**2*(6*r**2 + 15*r*s - 11*r + 9*s**2 - 11*s + 4) + 4*Pk2*k3**2*(9*s**2 - 9*s + 2) + Pkd2*k2*k3**2*(-9*s**2 + 9*s - 2)) + 4*r*(Pk2*k2**2*(5*r + 5*s - 3) + 4*Pk2*k3**2*s - Pkd2*k2*k3**2*s)))/(7*d**2*k1*k2*k3**6) - 16*D1**4*Pk1*ct**4*f**2*mu*mu2**3*(-16*Pk2*b1*k1**2*k2**4*r**2 + f*k1**2*(8*Pk2*k2**4*(7*r**2 + 2*r*(7*s - 5) + 7*s**2 - 10*s + 3) + 72*Pk2*k3**4*s**2 - 4*Pkd2*k2**3*k3**2*s*(5*r + 5*s - 3) - 27*Pkd2*k2*k3**4*s**2 + k2**2*k3**2*s*(16*Pk2*(5*r + 5*s - 3) + 3*Pkdd2*k3**2*s)) + 8*f*k2**2*k3**2*(Pk2*cosphi**2*k2**2*(3*r - 1)*(2*r + 2*s - 1) + 4*Pk2*k2**2*r*(r + s - 1) + 8*Pk2*k3**2*r*s - 2*Pkd2*k2*k3**2*r*s))/(7*d**2*k1*k2*k3**6) - 16*D1**4*Pk1*ct**4*f**2*mu**2*mu2**2*(-2*b1*k1**2*k2**2*(2*Pk2*k2**4*(2*r**2 - 2*r + 1) + 2*Pk2*k2**2*(2*k1**2*r**2 + k3**2*(cosphi**2 - 1)*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2)) + Pk2*k3**4*(1 - 2*s)**2*(12*cosphi**2 - 12) - Pkd2*k2*k3**4*(1 - 2*s)**2*(3*cosphi**2 - 3)) + f*(72*Pk2*k2**4*k3**4*r**2 + k1**4*(8*Pk2*k2**4*(15*r**2 + 6*r*(5*s - 3) + 15*s**2 - 18*s + 5) + 72*Pk2*k3**4*s**2 - 6*Pkd2*k2**3*k3**2*s*(5*r + 5*s - 3) - 27*Pkd2*k2*k3**4*s**2 + 3*k2**2*k3**2*s*(8*Pk2*(5*r + 5*s - 3) + Pkdd2*k3**2*s)) + 6*k1**2*k2**2*k3**2*(cosphi**2*(2*Pk2*k2**2*(9*r**2 + 15*r*s - 11*r + 6*s**2 - 8*s + 3) + 4*Pk2*k3**2*(6*s**2 - 5*s + 1) - Pkd2*k2*k3**2*(6*s**2 - 5*s + 1)) + 2*r*(2*Pk2*k2**2*(5*r + 5*s - 3) + 12*Pk2*k3**2*s - 3*Pkd2*k2*k3**2*s))))/(7*d**2*k1**2*k2**2*k3**6) - 16*D1**4*Pk1*ct**4*f*mu*mu2*(-8*Pk2*b1**2*k1**2*k2**4*r**2 + b1*f*(8*Pk2*k2**4*k3**2*(cosphi**2*r*(2*s - 1) - cosphi**2*s + r**2*(2*cosphi**2 + 2) + 2*r*(s - 1)) + 8*Pk2*k2**2*k3**4*(cosphi**2*s + 3*r**2 - r*s*(2*cosphi**2 - 2)) + 16*Pk2*k3**6*r*s - 8*Pkd2*k2**3*k3**4*r*s - 4*Pkd2*k2*k3**6*r*s + 4*k1**4*(r + s - 1)*(2*Pk2*k2**2*(5*r + 5*s - 1) + 4*Pk2*k3**2*s - Pkd2*k2*k3**2*s) + k1**2*(8*Pk2*k2**4*(5*r**2 + 2*r*(5*s - 3) + 5*s**2 - 6*s + 1) + 8*Pk2*k3**4*(2*cosphi**2*(6*s**2 - 7*s + 2) + s*(2*r + 3*s)) - 8*Pkd2*k2**3*k3**2*s*(2*r + 2*s - 1) - Pkd2*k2*k3**4*(4*cosphi**2*(6*s**2 - 7*s + 2) + s*(4*r + 15*s)) + k2**2*k3**2*(8*Pk2*cosphi**2*(2*r**2 + r*(8*s - 5) + 6*s**2 - 7*s + 2) + 16*Pk2*(2*r**2 + r*(4*s - 1) + s*(2*s - 1)) + 3*Pkdd2*k3**2*s**2))) + 14*f*g2*k3**6*r*s*(4*Pk2 - Pkd2*k2))/(7*d**2*k1*k2*k3**6) - 8*D1**4*Pk1*ct**4*f*mu**2*(-2*b1**2*k1**2*(4*Pk2*k1**2*k2**4*r**2 + Pk2*k2**4*k3**2*(4*cosphi**2 - 4)*(r + s)**2 - k2**2*k3**4*s*(2*cosphi**2 - 2)*(2*Pk2*(r - s) + Pkd2*k2*s) + k3**6*(4*Pk2 - Pkd2*k2)*(cosphi**2 - 1)*(s - 1)**2) + b1*(2*f*(4*Pk2*k1**6*k2**2*(r + s - 1)**2 + 6*Pk2*k2**2*k3**4*r**2*(2*k2**2 + k3**2) + k1**4*(4*Pk2*k2**4*(13*r**2 + 2*r*(13*s - 5) + 13*s**2 - 10*s + 1) + 8*Pk2*k3**4*(cosphi**2*(2*s**2 - 3*s + 1) + 3*s**2) - 6*Pkd2*k2**3*k3**2*s*(3*r + 3*s - 1) - Pkd2*k2*k3**4*(cosphi**2*(4*s**2 - 6*s + 2) + 15*s**2) + k2**2*k3**2*(4*Pk2*cosphi**2*(2*s - 1)*(r + s - 1) + 4*Pk2*(r**2 + 10*r*s - r + 9*s**2 - 3*s) + 3*Pkdd2*k3**2*s**2)) + k1**2*k3**2*(cosphi**2*(4*Pk2*k2**4*(6*r**2 + r*(8*s - 3) + s*(2*s - 3)) - 4*k2**2*k3**2*s*(Pk2*(6*r - 2*s - 3) + Pkd2*k2*s) + k3**4*(4*Pk2 - Pkd2*k2)*(2*s**2 - 3*s + 1)) + 4*k2**2*r*(4*Pk2*k2**2*(2*r + 2*s - 1) + Pk2*k3**2*(r + 6*s) - 3*Pkd2*k2*k3**2*s))) + g2*k1**2*k3**6*(7 - 7*cosphi**2)*(4*Pk2 - Pkd2*k2)*(s - 1)**2) - 7*f*g2*k3**6*(-6*Pk2*k2**2*r**2 - cosphi**2*k1**2*(4*Pk2 - Pkd2*k2)*(2*s**2 - 3*s + 1)))/(7*d**2*k1**2*k2**2*k3**6) - 2*D1**4*Pk1*ct**4*f*mu2**2*(-32*Pk2*b1**2*k1**2*k2**6*r**2 + 2*b1*f*(96*Pk2*k2**4*k3**4*r**2 + 2*k1**4*(8*Pk2*k2**4*(13*r**2 + 2*r*(13*s - 5) + 13*s**2 - 10*s + 1) + 24*Pk2*k3**4*s**2 - 8*Pkd2*k2**3*k3**2*s*(2*r + 2*s - 1) - 9*Pkd2*k2*k3**4*s**2 + k2**2*k3**2*s*(32*Pk2*(2*r + 2*s - 1) + Pkdd2*k3**2*s)) + k1**2*(16*Pk2*k2**6*(r + s - 1)**2 + 24*Pk2*k3**6*s**2 - 8*Pkd2*k2**5*k3**2*s*(r + s - 1) - 2*Pkd2*k2**3*k3**4*(12*cosphi**2*(1 - 2*s)**2 + s*(12*r + 5*s)) - 9*Pkd2*k2*k3**6*s**2 + 2*k2**4*k3**2*(8*Pk2*cosphi**2*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) + 8*Pk2*(9*r**2 + r*(10*s - 3) + s*(s - 1)) + Pkdd2*k3**2*s**2) + k2**2*k3**4*(96*Pk2*cosphi**2*(1 - 2*s)**2 + s*(16*Pk2*(6*r + s) + Pkdd2*k3**2*s)))) + 7*f*g2*k1**2*k3**6*s**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2)))/(7*d**2*k1**2*k2**2*k3**6) + D1**4*Pk1*ct**3*f**3*k1*mu**6*(4*cosphi**2 - 4)*(3*s - 1)*(7*k1**2*(2*Pk2*k2**2*(r + s - 1) + 4*Pk2*k3**2*(s - 1) - Pkd2*k2*k3**2*(s - 1)) + k2**2*(14*Pk2*k2**2*(r + s - 1) - 2*Pk2*k3**2*(8*r - 7*s + 7) - 7*Pkd2*k2*k3**2*(s - 1)))/(7*d**2*k2**3*k3**4) + 32*D1**4*Pk1*ct**3*f**3*mu*mu2**5*(8*Pk2*k2**4*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 24*Pk2*k3**4*s*(3*s - 1) - 2*Pkd2*k2**3*k3**2*(r*(6*s - 1) + 6*s**2 - 6*s + 1) + 9*Pkd2*k2*k3**4*s*(1 - 3*s) + k2**2*(8*Pk2*k3**2*(6*r*s - r + 6*s**2 - 6*s + 1) + Pkdd2*k3**4*s*(3*s - 1)))/(7*d**2*k3**6) + 8*D1**4*Pk1*ct**3*f**3*mu**5*mu2*(32*Pk2*k1**4*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + k1**2*(2*Pk2*k2**2*k3**2*(7*cosphi**2*(6*r**2 + r*(15*s - 11) + 9*s**2 - 11*s + 4) + 54*r**2 + 3*r*(5*s - 9) - 39*s**2 + 29*s - 4) + 4*Pk2*k3**4*(3*s - 1)*(7*cosphi**2*(3*s - 2) - 13*s + 6) - Pkd2*k2*k3**4*(3*s - 1)*(7*cosphi**2*(3*s - 2) - 13*s + 6)) + k2**2*k3**2*(Pk2*k2**2*(14*cosphi**2 - 14)*(6*r**2 + r*(15*s - 11) + 9*s**2 - 11*s + 4) + 2*Pk2*k3**2*(r**2*(192 - 48*cosphi**2) - 2*r*(cosphi**2*(57*s - 41) - 57*s + 65) + s*(7*cosphi**2 - 7)*(9*s - 7)) + Pkd2*k2*k3**2*(7 - 7*cosphi**2)*(9*s**2 - 9*s + 2)))/(7*d**2*k2**2*k3**6) + 4*D1**4*Pk1*ct**3*f**3*mu**4*mu2**2*(2*k1**4*(Pk2*k2**2*(645*r**2 + 6*r*(208*s - 141) + 624*s**2 - 832*s + 295) + 16*Pk2*k3**2*(3*r*(7*s - 1) + 21*s**2 - 19*s + 3) - 4*Pkd2*k2*k3**2*(3*r*(7*s - 1) + 21*s**2 - 19*s + 3)) + k1**2*(14*Pk2*k2**4*(3*r**2 - 2*r + 1) + 6*Pk2*k2**2*k3**2*(7*cosphi**2*(9*r**2 + r*(15*s - 11) + 6*s**2 - 8*s + 3) + 281*r**2 + r*(359*s - 275) + 54*s**2 - 120*s + 51) + 4*Pk2*k3**4*(21*cosphi**2*(6*s**2 - 5*s + 1) + 48*r*(7*s - 1) + 162*s**2 - 263*s + 43) - Pkd2*k2*k3**4*(21*cosphi**2*(6*s**2 - 5*s + 1) + 48*r*(7*s - 1) + 162*s**2 - 263*s + 43)) + 3*k2**2*k3**2*(Pk2*k2**2*(14*cosphi**2 - 14)*(9*r**2 + r*(15*s - 11) + 6*s**2 - 8*s + 3) - 2*Pk2*k3**2*(cosphi**2*(72*r**2 + r*(111*s - 82) - 42*s**2 + 14*s + 7) - 360*r**2 - 111*r*s + 178*r + 42*s**2 - 14*s - 7) + Pkd2*k2*k3**2*(7 - 7*cosphi**2)*(6*s**2 - 5*s + 1)))/(7*d**2*k1*k2*k3**6) + 8*D1**4*Pk1*ct**3*f**3*mu**2*mu2**4*(k1**2*(Pk2*k2**4*(645*r**2 + 6*r*(208*s - 141) + 624*s**2 - 832*s + 295) + 288*Pk2*k3**4*s*(3*s - 1) - 4*Pkd2*k2**3*k3**2*(r*(57*s - 11) + 57*s**2 - 47*s + 7) - 108*Pkd2*k2*k3**4*s*(3*s - 1) + 4*k2**2*k3**2*(4*Pk2*(57*r*s - 11*r + 57*s**2 - 47*s + 7) + 3*Pkdd2*k3**2*s*(3*s - 1))) + k2**2*(7*Pk2*k2**4*(3*r**2 - 2*r + 1) + 16*Pk2*k2**2*k3**2*(30*r**2 + 33*r*s - 27*r - 7*s + 4) + 32*Pk2*k3**4*(21*r*s - 5*r - 3*s) - 8*Pkd2*k2*k3**4*(21*r*s - 5*r - 3*s)))/(7*d**2*k1*k2*k3**6) + 16*D1**4*Pk1*ct**3*f**3*mu**3*mu2**3*(Pk2*k2**4*k3**2*(3*r - 1)*(k2**2*(7*cosphi**2 - 7)*(2*r + 2*s - 1) + k3**2*(cosphi**2*(-16*r - 14*s + 7) + 112*r + 14*s - 7)) + k1**4*(Pk2*k2**4*(549*r**2 + 2*r*(528*s - 343) + 528*s**2 - 672*s + 231) + 96*Pk2*k3**4*s*(3*s - 1) - 4*Pkd2*k2**3*k3**2*(r*(33*s - 6) + 33*s**2 - 27*s + 4) - 36*Pkd2*k2*k3**4*s*(3*s - 1) + 4*k2**2*(4*Pk2*k3**2*(33*r*s - 6*r + 33*s**2 - 27*s + 4) + Pkdd2*k3**4*s*(3*s - 1))) + k1**2*k2**2*(7*Pk2*k2**4*(3*r**2 - 2*r + 1) + Pk2*k2**2*k3**2*(7*cosphi**2*(3*r - 1)*(2*r + 2*s - 1) + 642*r**2 + 9*r*(94*s - 69) + 144*s**2 - 274*s + 109) + 16*Pk2*k3**4*(r*(42*s - 8) + 18*s**2 - 23*s + 3) - 4*Pkd2*k2*k3**4*(r*(42*s - 8) + 18*s**2 - 23*s + 3)))/(7*d**2*k1**2*k2**2*k3**6) - D1**4*Pk1*ct**3*f**2*mu2**4*(-16*b1*(k1**2*(Pk2*k2**4*(119*r**2 + 32*r*(7*s - 3) + 112*s**2 - 96*s + 24) + 48*Pk2*k3**4*s*(2*s - 1) - 2*Pkd2*k2**3*k3**2*(r*(18*s - 7) + 18*s**2 - 14*s + 3) + 18*Pkd2*k2*k3**4*s*(1 - 2*s) + 2*k2**2*k3**2*(4*Pk2*(18*r*s - 7*r + 18*s**2 - 14*s + 3) + Pkdd2*k3**2*s*(2*s - 1))) + k2**2*r*(7*Pk2*k2**4*r + 4*Pk2*k2**2*k3**2*(8*r + 10*s - 5) + 40*Pk2*k3**4*(2*s - 1) + 10*Pkd2*k2*k3**4*(1 - 2*s))) + f*(k1**2*(184*Pk2*k2**4*(r + s - 1)**2 + 168*Pk2*k3**4*s**2 - 60*Pkd2*k2**3*k3**2*s*(r + s - 1) - 63*Pkd2*k2*k3**4*s**2 + k2**2*k3**2*s*(240*Pk2*(r + s - 1) + 7*Pkdd2*k3**2*s)) + 7*k2**2*(8*Pk2*k2**4*(r + s - 1)**2 + 8*Pk2*k3**4*s**2 - 4*Pkd2*k2**3*k3**2*s*(r + s - 1) - 5*Pkd2*k2*k3**4*s**2 + k2**2*k3**2*s*(8*Pk2*(r + s - 1) + Pkdd2*k3**2*s))))/(7*d**2*k1*k2*k3**6) - 4*D1**4*Pk1*ct**3*f**2*mu**4*(Pk2*g2*k2**2*k3**6*r*(28*cosphi**2 - 28)*(2*s - 1) - b1*(Pk2*k2**6*k3**2*(14*cosphi**2 - 14)*(6*r**2 + r*(8*s - 3) + s*(2*s - 3)) + k1**4*(2*Pk2*k2**4*(238*r**2 + r*(448*s - 206) + 224*s**2 - 192*s + 55) + 2*Pk2*k2**2*k3**2*(7*cosphi**2*(2*s - 1)*(r + s - 1) + r*(66*s + 7) + 66*s**2 - 19*s - 7) + Pk2*k3**4*(28*cosphi**2 - 28)*(2*s**2 - 3*s + 1) - 40*Pkd2*k2**3*k3**2*s*(2*r + 2*s - 1) - Pkd2*k2*k3**4*(7*cosphi**2 - 7)*(2*s**2 - 3*s + 1)) + k1**2*(14*Pk2*k2**6*(2*r**2 - 2*r + 1) + 2*Pk2*k2**4*k3**2*(7*cosphi**2*(6*r**2 + 2*r*(5*s - 2) + 4*s**2 - 6*s + 1) + 198*r**2 + 2*r*(109*s - 74) - 28*s**2 - 70*s + 17) - 2*Pk2*k2**2*k3**4*(cosphi**2*(58*r*s - 8*r - 28*s**2 - 7) + r*(8 - 218*s) + 28*s**2 + 80*s + 7) + Pk2*k3**6*(28*cosphi**2 - 28)*(2*s**2 - 3*s + 1) + Pkd2*k2**3*k3**4*(-7*cosphi**2*(4*s**2 - 3*s + 1) + 28*s**2 + s*(59 - 160*r) + 7) - Pkd2*k2*k3**6*(7*cosphi**2 - 7)*(2*s**2 - 3*s + 1)) - 2*k2**4*k3**4*(Pk2*r**2*(48*cosphi**2 - 240) + 4*Pk2*r*(cosphi**2*(25*s - 6) - 25*s + 30) - Pk2*s*(42*cosphi**2 - 42) + Pkd2*k2*s**2*(7*cosphi**2 - 7)) + k2**2*k3**6*(cosphi**2 - 1)*(2*s - 1)*(-2*Pk2*(4*r - 7*s + 7) - 7*Pkd2*k2*(s - 1))) + f*(14*Pk2*k1**6*k2**2*(r + s - 1)**2 + 42*Pk2*k2**4*k3**4*r**2 + k1**4*(28*Pk2*cosphi**2*k3**4*(3*s**2 - 4*s + 1) + 46*Pk2*k2**4*(r + s - 1)**2 + 14*Pk2*k2**2*k3**2*(cosphi**2*(3*s - 1) + r)*(r + s - 1) - 7*Pkd2*cosphi**2*k2*k3**4*(3*s**2 - 4*s + 1) - 8*Pkd2*k2**3*k3**2*(s - 1)*(r + s - 1)) + k1**2*k2**2*k3**2*(cosphi**2*(3*s - 1)*(14*Pk2*k2**2*(r + s - 1) - 2*Pk2*k3**2*(8*r - 7*s + 7) - 7*Pkd2*k2*k3**2*(s - 1)) + 2*r*(30*Pk2*k2**2*(r + s - 1) + 7*Pk2*k3**2*r - 8*Pkd2*k2*k3**2*(s - 1)))))/(7*d**2*k1*k2**3*k3**6) + 8*D1**4*Pk1*ct**3*f**2*mu**3*mu2*(b1*(32*Pk2*k1**6*k2**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 2*Pk2*k2**2*k3**2*(2*r - 1)*(k2**4*(7*cosphi**2 - 7)*(r + s) - 2*k2**2*k3**2*(r*(4*cosphi**2 - 28) + s*(7*cosphi**2 - 7)) + k3**4*(cosphi**2*(-4*r - 7*s + 7) + 28*r + 7*s - 7)) + k1**4*(2*Pk2*k2**4*(270*r**2 + r*(512*s - 254) + 256*s**2 - 240*s + 71) + 4*Pk2*k3**4*(7*cosphi**2*(6*s**2 - 7*s + 2) + 6*s**2 + 25*s - 6) - 16*Pkd2*k2**3*k3**2*s*(9*r + 9*s - 4) - Pkd2*k2*k3**4*(7*cosphi**2*(6*s**2 - 7*s + 2) + 54*s**2 + 25*s - 6) + 2*k2**2*(Pk2*k3**2*(7*cosphi**2*(2*r**2 + 8*r*s - 5*r + 6*s**2 - 7*s + 2) + 18*r**2 + 136*r*s + 3*r + 118*s**2 - 39*s - 6) + 8*Pkdd2*k3**4*s**2)) + k1**2*(14*Pk2*k2**6*(2*r**2 - 2*r + 1) + 4*Pk2*k2**4*k3**2*(7*cosphi**2*(2*r**2 + r*(5*s - 3) + 3*s**2 - 4*s + 1) + 102*r**2 + r*(109*s - 67) - 13*s**2 - 24*s + 7) - 4*Pk2*k2**2*k3**4*(cosphi**2*(8*r**2 + 38*r*s - 19*r - 21*s**2 + 21*s - 7) - 24*r**2 + r*(19 - 94*s) + 13*s**2 - s + 7) + 16*Pk2*k3**6*(2*s**2 - 3*s + 1) + Pkd2*k2**3*k3**4*(-7*cosphi**2*(6*s**2 - 7*s + 2) + 26*s**2 - s*(160*r - 15) + 14) - 4*Pkd2*k2*k3**6*(2*s**2 - 3*s + 1))) - f*(126*Pk2*k2**4*k3**4*r**2 + 2*k1**6*(r + s - 1)*(Pk2*k2**2*(81*r + 81*s - 37) + 28*Pk2*k3**2*s - 7*Pkd2*k2*k3**2*s) + k1**4*(2*Pk2*k2**4*(129*r**2 + 2*r*(129*s - 91) + 129*s**2 - 182*s + 53) + 4*Pk2*k3**4*(7*cosphi**2*(9*s**2 - 9*s + 2) + 2*s*(7*r + 4*s)) - 2*Pkd2*k2**3*k3**2*(r*(35*s - 16) + 35*s**2 - 43*s + 8) - Pkd2*k2*k3**4*(7*cosphi**2*(9*s**2 - 9*s + 2) + 2*s*(7*r + 16*s - 12)) + 2*k2**2*k3**2*(7*Pk2*cosphi**2*(6*r**2 + r*(15*s - 11) + 9*s**2 - 11*s + 4) + Pk2*(59*r**2 + 97*r*s - 29*r + 38*s**2 - 30*s) + 4*Pkdd2*k3**2*s*(s - 1))) + k1**2*k2**2*k3**2*(cosphi**2*(14*Pk2*k2**2*(6*r**2 + r*(15*s - 11) + 9*s**2 - 11*s + 4) - 2*Pk2*k3**2*(48*r**2 + 2*r*(57*s - 41) + s*(49 - 63*s)) - 7*Pkd2*k2*k3**2*(9*s**2 - 9*s + 2)) + 2*r*(2*Pk2*k2**2*(59*r + 59*s - 37) + Pk2*k3**2*(37*r + 28*s) + 2*Pkd2*k2*k3**2*(8 - 19*s)))) + 14*g2*k3**6*(Pk2*k2**2*r*(14 - 2*cosphi**2)*(2*r - 1) + k1**2*(4*Pk2 - Pkd2*k2)*(2*s**2 - 3*s + 1)))/(7*d**2*k1**2*k2**2*k3**6) - 2*D1**4*Pk1*ct**3*f**2*mu*mu2**3*(-8*b1*(64*Pk2*k2**4*k3**4*r**2 + 2*k1**4*(Pk2*k2**4*(135*r**2 + 8*r*(32*s - 15) + 128*s**2 - 120*s + 32) + 24*Pk2*k3**4*s*(2*s - 1) - 2*Pkd2*k2**3*k3**2*(r*(14*s - 5) + 14*s**2 - 12*s + 3) + 9*Pkd2*k2*k3**4*s*(1 - 2*s) + k2**2*(8*Pk2*k3**2*(14*r*s - 5*r + 14*s**2 - 12*s + 3) + Pkdd2*k3**4*s*(2*s - 1))) + k1**2*(2*Pk2*k2**6*(23*r**2 + 8*r*(4*s - 3) + 16*s**2 - 24*s + 8) + 24*Pk2*k3**6*s*(2*s - 1) - 4*Pkd2*k2**5*k3**2*s*(4*r + 4*s - 3) - 4*Pkd2*k2**3*k3**4*(2*r*(5*s - 2) + 17*s**2 - 12*s + 3) + 9*Pkd2*k2*k3**6*s*(1 - 2*s) + 4*k2**4*(Pk2*k3**2*(42*r**2 + 4*r*(20*s - 9) + 32*s**2 - 30*s + 6) + Pkdd2*k3**4*s**2) + k2**2*(16*Pk2*k3**4*(10*r*s - 4*r + 14*s**2 - 12*s + 3) + Pkdd2*k3**6*s*(2*s - 1)))) + f*(k1**4*(8*Pk2*k2**4*(129*r**2 + 2*r*(129*s - 91) + 129*s**2 - 182*s + 53) + 504*Pk2*k3**4*s**2 - 4*Pkd2*k2**3*k3**2*s*(59*r + 59*s - 37) - 189*Pkd2*k2*k3**4*s**2 + k2**2*k3**2*s*(16*Pk2*(59*r + 59*s - 37) + 21*Pkdd2*k3**2*s)) + k1**2*k2**2*(8*Pk2*k2**4*(81*r**2 + 2*r*(81*s - 59) + 81*s**2 - 118*s + 37) + 8*Pk2*k3**4*s*(28*r + 37*s) - 4*Pkd2*k2**3*k3**2*(r*(67*s - 8) + 67*s**2 - 53*s + 8) + Pkd2*k2*k3**4*s*(-56*r - 233*s + 48) + k2**2*k3**2*(56*Pk2*cosphi**2*(3*r - 1)*(2*r + 2*s - 1) + 8*Pk2*(38*r**2 + r*(97*s - 30) + s*(59*s - 29)) + Pkdd2*k3**2*s*(53*s - 16))) + 8*k2**4*k3**2*(Pk2*cosphi**2*(3*r - 1)*(7*k2**2*(2*r + 2*s - 1) + k3**2*(-16*r - 14*s + 7)) + 2*r*(14*Pk2*k2**2*(r + s - 1) + 2*Pk2*k3**2*(4*r + 7*s) - 7*Pkd2*k2*k3**2*s))) - 28*g2*k1**2*k3**6*s*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(2*s - 1))/(7*d**2*k1**2*k2**2*k3**6) + 2*D1**4*Pk1*ct**3*f**2*mu**2*mu2**2*(2*b1*k1**2*k2**2*(14*Pk2*k2**6*(2*r**2 - 2*r + 1) + 2*Pk2*k2**4*k3**2*(7*cosphi**2*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) + 150*r**2 + r*(98*s - 90) - 84*s**2 + 4*s + 11) - 2*Pk2*k2**2*k3**4*(cosphi**2*(48*r**2 + 2*r*(69*s - 38) - 21*(1 - 2*s)**2) - 240*r**2 + r*(76 - 234*s) + 84*s**2 - 68*s + 21) + 32*Pk2*k3**6*(r*(10*s - 3) - 3*s) + Pkd2*k2**3*k3**4*(-21*cosphi**2*(1 - 2*s)**2 + 84*s**2 - s*(160*r + 36) + 21) + 8*Pkd2*k2*k3**6*(r*(3 - 10*s) + 3*s) + 4*k1**4*(Pk2*k2**2*(183*r**2 + 32*r*(11*s - 6) + 176*s**2 - 192*s + 56) + 8*Pk2*k3**2*(r*(10*s - 3) + 10*s**2 - 10*s + 3) - 2*Pkd2*k2*k3**2*(r*(10*s - 3) + 10*s**2 - 10*s + 3)) + k1**2*(2*Pk2*k2**4*(380*r**2 + r*(704*s - 398) + 352*s**2 - 384*s + 119) + 4*Pk2*k3**4*(21*cosphi**2*(1 - 2*s)**2 + 80*r*s - 24*r + 204*s**2 - 140*s + 43) - 136*Pkd2*k2**3*k3**2*s*(2*r + 2*s - 1) - Pkd2*k2*k3**4*(21*cosphi**2*(1 - 2*s)**2 + 80*r*s - 24*r + 348*s**2 - 140*s + 43) + 2*k2**2*(Pk2*k3**2*(7*cosphi**2*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) + 262*r**2 + 674*r*s - 226*r + 380*s**2 - 276*s + 43) + 24*Pkdd2*k3**4*s**2))) - f*(504*Pk2*k2**6*k3**4*r**2 + 3*k1**6*(40*Pk2*k2**4*(15*r**2 + 6*r*(5*s - 3) + 15*s**2 - 18*s + 5) + 168*Pk2*k3**4*s**2 - 2*Pkd2*k2**3*k3**2*s*(51*r + 51*s - 29) - 63*Pkd2*k2*k3**4*s**2 + k2**2*k3**2*s*(8*Pk2*(51*r + 51*s - 29) + 7*Pkdd2*k3**2*s)) + k1**4*k2**2*(120*Pk2*k2**4*(15*r**2 + 6*r*(5*s - 3) + 15*s**2 - 18*s + 5) + 24*Pk2*k3**4*(7*cosphi**2*(6*s**2 - 5*s + 1) + s*(21*r + 19*s)) - 2*Pkd2*k2**3*k3**2*(9*r*(33*s - 8) + 297*s**2 - 255*s + 40) - 3*Pkd2*k2*k3**4*(14*cosphi**2*(6*s**2 - 5*s + 1) + s*(42*r + 131*s - 48)) + 3*k2**2*k3**2*(28*Pk2*cosphi**2*(9*r**2 + r*(15*s - 11) + 6*s**2 - 8*s + 3) + 4*Pk2*(71*r**2 + r*(142*s - 37) + s*(71*s - 37)) + Pkdd2*k3**2*s*(31*s - 16))) + 6*k1**2*k2**4*k3**2*(cosphi**2*(14*Pk2*k2**2*(9*r**2 + 15*r*s - 11*r + 6*s**2 - 8*s + 3) - 2*Pk2*k3**2*(72*r**2 + 111*r*s - 82*r - 42*s**2 + 14*s + 7) - 7*Pkd2*k2*k3**2*(6*s**2 - 5*s + 1)) + 2*r*(2*Pk2*k2**2*(51*r + 51*s - 29) + 2*Pk2*k3**2*(19*r + 21*s) + Pkd2*k2*k3**2*(8 - 37*s)))) - 56*g2*k1**2*k2**2*k3**6*(-4*Pk2 + Pkd2*k2)*(r*(10*s - 3) - 3*s))/(7*d**2*k1**3*k2**3*k3**6) - 2*D1**4*Pk1*ct**3*f*mu*mu2*(-8*b1**2*(8*Pk2*k2**2*k3**4*r**2*(2*k2**2 + k3**2) + k1**4*(Pk2*k2**4*(87*r**2 + 160*r*s + 80*s**2) + 16*Pk2*k3**4*s**2 - 20*Pkd2*k2**3*k3**2*s*(r + s) - 10*Pkd2*k2*k3**4*s**2 + 2*k2**2*k3**2*s*(20*Pk2*(r + s) + Pkdd2*k3**2*s)) + k1**2*(7*Pk2*k2**6*r**2 + 4*Pk2*k2**4*k3**2*(9*r**2 + 14*r*s + 2*s**2) - 4*k2**2*k3**4*s*(-2*Pk2*(2*r + s) + Pkd2*k2*(3*r + s)) + k3**6*(8*Pk2*(2*s**2 - 2*s + 1) + k2*(Pkd2*(-7*s**2 + 4*s - 2) + Pkdd2*k2*s**2)))) + b1*(f*(4*k1**6*(r + s - 1)*(2*Pk2*k2**2*(51*r + 51*s - 7) + 28*Pk2*k3**2*s - 7*Pkd2*k2*k3**2*s) + k1**4*(16*Pk2*k2**4*(99*r**2 + 2*r*(99*s - 61) + 99*s**2 - 122*s + 23) + 8*Pk2*k3**4*(14*cosphi**2*(6*s**2 - 7*s + 2) + 29*s**2) - 4*Pkd2*k2**3*k3**2*(3*r*(33*s - 8) + 99*s**2 - 85*s + 8) + Pkd2*k2*k3**4*(-28*cosphi**2*(6*s**2 - 7*s + 2) + s*(48 - 169*s)) + k2**2*(8*Pk2*k3**2*(7*cosphi**2*(2*r**2 + 8*r*s - 5*r + 6*s**2 - 7*s + 2) - 4*r**2 + 67*r*s + 8*r + 71*s**2 - 45*s + 4) + Pkdd2*k3**4*s*(37*s - 16))) + k1**2*(8*Pk2*k2**6*(51*r**2 + 2*r*(51*s - 29) + 51*s**2 - 58*s + 7) + 16*Pk2*k3**6*s*(7*r + 2*s) - 88*Pkd2*k2**5*k3**2*s*(2*r + 2*s - 1) - Pkd2*k2**3*k3**4*(28*cosphi**2*(6*s**2 - 7*s + 2) + 8*r*(19*s - 8) + 21*s**2) - 4*Pkd2*k2*k3**6*s*(7*r + 8*s - 6) + k2**4*k3**2*(8*Pk2*(14*cosphi**2*(2*r**2 + 5*r*s - 3*r + 3*s**2 - 4*s + 1) + 71*r**2 + 67*r*s - 45*r - 4*s**2 + 8*s + 4) + 37*Pkdd2*k3**2*s**2) + 8*k2**2*k3**4*(-2*Pk2*cosphi**2*(8*r**2 + 38*r*s - 19*r - 21*s**2 + 21*s - 7) - 2*Pk2*(2*r**2 - 7*r*s + 2*s**2) + Pkdd2*k3**2*s*(s - 1))) + 8*k2**2*k3**2*(-Pk2*cosphi**2*(2*r - 1)*(-7*k2**4*(r + s) + 2*k2**2*k3**2*(4*r + 7*s) + k3**4*(4*r + 7*s - 7)) + r*(14*Pk2*k2**4*(r + s - 1) + 29*Pk2*k2**2*k3**2*r + 2*Pk2*k3**4*(2*r + 7*s) - 7*Pkd2*k2**3*k3**2*s - 7*Pkd2*k2*k3**4*s))) - 28*g2*k3**6*(8*Pk2*k2**2*r**2 + k1**2*(8*Pk2*(2*s**2 - 2*s + 1) + k2*(Pkd2*(-7*s**2 + 4*s - 2) + Pkdd2*k2*s**2)))) - 28*f*g2*k3**6*(4*Pk2*cosphi**2*k2**2*r*(2*r - 1) - 4*Pk2*k1**2*s**2 + Pkd2*k1**2*k2*s*(4*s - 3) + k2**2*(-4*Pk2*r**2 - Pkdd2*k1**2*s*(s - 1))))/(7*d**2*k1**2*k2**2*k3**6) - 2*D1**4*Pk1*ct**3*f*mu**2*(-2*b1**2*k1**2*(Pk2*k2**6*k3**2*(14*cosphi**2 - 14)*(r + s)**2 + 2*k1**4*k2**2*(Pk2*k2**2*(87*r**2 + 160*r*s + 80*s**2) + 24*Pk2*k3**2*s*(r + s) - 12*Pkd2*k2*k3**2*s*(r + s)) + k1**2*(14*Pk2*k2**6*r**2 + 2*Pk2*k2**4*k3**2*(r**2*(7*cosphi**2 + 33) + r*s*(14*cosphi**2 + 42) + s**2*(7*cosphi**2 - 7)) + k2**2*k3**4*s*(Pk2*r*(62 - 14*cosphi**2) + Pk2*s*(14*cosphi**2 - 14) - 24*Pkd2*k2*r - Pkd2*k2*s*(7*cosphi**2 - 7)) + k3**6*(4*Pk2 - Pkd2*k2)*(7*cosphi**2 - 7)*(s - 1)**2) + k2**4*k3**4*(4*Pk2*r*(r*(20 - 4*cosphi**2) - s*(11*cosphi**2 - 11)) + Pkd2*k2*s**2*(7 - 7*cosphi**2)) + k2**2*k3**6*(-2*Pk2*(cosphi**2*(s - 1)*(4*r - 7*s + 7) - 28*r*s + 4*r + 7*s**2 + 10*s + 7) + Pkd2*k2*(-7*cosphi**2*(s - 1)**2 - 24*r*s + 7*s**2 + 10*s + 7))) + b1*(f*(28*Pk2*k1**8*k2**2*(r + s - 1)**2 + 84*Pk2*k2**4*k3**4*r**2*(k2**2 + k3**2) + k1**6*(8*Pk2*k2**4*(129*r**2 + 2*r*(129*s - 61) + 129*s**2 - 122*s + 23) + 56*Pk2*k3**4*(cosphi**2*(2*s**2 - 3*s + 1) + 3*s**2) - 2*Pkd2*k2**3*k3**2*(r*(119*s - 8) + 119*s**2 - 61*s + 8) - 7*Pkd2*k2*k3**4*(cosphi**2*(4*s**2 - 6*s + 2) + 15*s**2) + k2**2*k3**2*(28*Pk2*cosphi**2*(2*s - 1)*(r + s - 1) + 3*s*(4*Pk2*(37*r + 37*s - 15) + 7*Pkdd2*k3**2*s))) + k1**4*(56*Pk2*cosphi**2*k3**6*(2*s**2 - 3*s + 1) + 4*Pk2*k2**6*(155*r**2 + 2*r*(155*s - 51) + 155*s**2 - 102*s + 7) - 4*Pk2*k2**2*k3**4*(cosphi**2*(58*r*s - 8*r - 28*s**2 - 7) + 3*s*(-7*r + 4*s)) - 14*Pkd2*cosphi**2*k2*k3**6*(2*s**2 - 3*s + 1) - 2*Pkd2*k2**5*k3**2*s*(119*r + 119*s - 37) - Pkd2*k2**3*k3**4*(14*cosphi**2*(4*s**2 - 3*s + 1) + 58*r*s - 16*r + 21*s**2) + k2**4*(4*Pk2*k3**2*(7*cosphi**2*(6*r**2 + 10*r*s - 4*r + 4*s**2 - 6*s + 1) + 79*r**2 + 59*r*s - 45*r - 20*s**2 + 16*s + 8) + 45*Pkdd2*k3**4*s**2)) + 2*k1**2*k2**2*k3**2*(cosphi**2*(14*Pk2*k2**4*(6*r**2 + r*(8*s - 3) + s*(2*s - 3)) - 2*k2**2*k3**2*(48*Pk2*r**2 + 4*Pk2*r*(25*s - 6) - 42*Pk2*s + 7*Pkd2*k2*s**2) + k3**4*(2*s - 1)*(-2*Pk2*(4*r - 7*s + 7) - 7*Pkd2*k2*(s - 1))) + 2*r*(4*Pk2*k2**4*(18*r + 18*s - 7) + 2*Pk2*k2**2*k3**2*(19*r - 8*s) + 7*Pk2*k3**4*r - 29*Pkd2*k2**3*k3**2*s - 4*Pkd2*k2*k3**4*(s - 1)))) + 56*g2*k1**2*k2**2*k3**6*(Pk2*(cosphi**2*r*(s - 1) - 7*r*s + r + 6*s) + 3*Pkd2*k2*s*(r - 1))) - 56*f*g2*k1**2*k2**2*k3**6*r*(Pk2*cosphi**2*(2*s - 1) + Pkd2*k2*(s - 1)))/(7*d**2*k1**3*k2**3*k3**6) - D1**4*Pk1*ct**2*f**4*k1*mu**7*mu2*(-4*Pk2 + Pkd2*k2)*(4*cosphi**2 - 4)*(12*s**2 - 11*s + 2)/(d**2*k2**3) - 32*D1**4*Pk1*ct**2*f**3*mu**2*mu2**6*(8*Pk2*k2**4*(6*r**2 + 4*r*(3*s - 2) + 6*s**2 - 8*s + 3) + 24*Pk2*k3**4*(6*s**2 - 4*s + 1) - 2*Pkd2*k2**3*k3**2*(4*r*(3*s - 1) + 3*(1 - 2*s)**2) - 9*Pkd2*k2*k3**4*(6*s**2 - 4*s + 1) + k2**2*(8*Pk2*k3**2*(4*r*(3*s - 1) + 3*(1 - 2*s)**2) + Pkdd2*k3**4*(6*s**2 - 4*s + 1)))/(7*d**2*k3**6) - 8*D1**4*Pk1*ct**2*f**3*mu**6*mu2**2*(-Pk2*f*k3**6*(84*cosphi**2 - 84)*(8*s**2 - 6*s + 1) + 32*Pk2*k1**4*k2**2*(6*r**2 + 4*r*(3*s - 2) + 6*s**2 - 8*s + 3) + 32*Pk2*k1**2*k2**2*k3**2*(12*r**2 + 12*r*(s - 1) - 4*s + 3) + 96*Pk2*k2**2*k3**4*(6*r**2 - 4*r + 1) + Pkd2*f*k2*k3**6*(21*cosphi**2 - 21)*(8*s**2 - 6*s + 1))/(7*d**2*k2**2*k3**6) - 8*D1**4*Pk1*ct**2*f**3*mu**5*mu2**3*(-Pk2*f*k3**6*(28*cosphi**2 - 28)*(20*s**2 - 13*s + 2) + 192*Pk2*k2**2*k3**4*(6*r**2 - 4*r + 1) + Pkd2*f*k2*k3**6*(7*cosphi**2 - 7)*(20*s**2 - 13*s + 2) + 8*k1**4*(16*Pk2*k2**2*(6*r**2 + 4*r*(3*s - 2) + 6*s**2 - 8*s + 3) + 4*Pk2*k3**2*(4*r*(3*s - 1) + 3*(1 - 2*s)**2) + Pkd2*k2*k3**2*(r*(4 - 12*s) - 3*(1 - 2*s)**2)) + 16*k1**2*(6*Pk2*k2**2*k3**2*(12*r**2 + 12*r*(s - 1) - 4*s + 3) + 4*Pk2*k3**4*(4*r*(3*s - 1) - 4*s + 1) + Pkd2*k2*k3**4*(r*(4 - 12*s) + 4*s - 1)))/(7*d**2*k1*k2*k3**6) - 64*D1**4*Pk1*ct**2*f**3*mu**3*mu2**5*(k1**2*(16*Pk2*k2**4*(6*r**2 + 4*r*(3*s - 2) + 6*s**2 - 8*s + 3) + 24*Pk2*k3**4*(6*s**2 - 4*s + 1) - 3*Pkd2*k2**3*k3**2*(4*r*(3*s - 1) + 3*(1 - 2*s)**2) - 9*Pkd2*k2*k3**4*(6*s**2 - 4*s + 1) + k2**2*k3**2*(48*Pk2*r*(3*s - 1) + 36*Pk2*(1 - 2*s)**2 + Pkdd2*k3**2*(6*s**2 - 4*s + 1))) + 2*k2**2*k3**2*(2*Pk2*k2**2*(12*r**2 + 12*r*(s - 1) - 4*s + 3) + 4*Pk2*k3**2*(4*r*(3*s - 1) - 4*s + 1) + Pkd2*k2*k3**2*(r*(4 - 12*s) + 4*s - 1)))/(7*d**2*k1*k2*k3**6) - 32*D1**4*Pk1*ct**2*f**3*mu**4*mu2**4*(24*Pk2*k2**4*k3**4*(6*r**2 - 4*r + 1) + k1**4*(48*Pk2*k2**4*(6*r**2 + 4*r*(3*s - 2) + 6*s**2 - 8*s + 3) + 24*Pk2*k3**4*(6*s**2 - 4*s + 1) - 6*Pkd2*k2**3*k3**2*(4*r*(3*s - 1) + 3*(1 - 2*s)**2) - 9*Pkd2*k2*k3**4*(6*s**2 - 4*s + 1) + k2**2*k3**2*(96*Pk2*r*(3*s - 1) + 72*Pk2*(1 - 2*s)**2 + Pkdd2*k3**2*(6*s**2 - 4*s + 1))) + 8*k1**2*k2**2*k3**2*(3*Pk2*k2**2*(12*r**2 + 12*r*(s - 1) - 4*s + 3) + 4*Pk2*k3**2*(4*r*(3*s - 1) - 4*s + 1) + Pkd2*k2*k3**2*(r*(4 - 12*s) + 4*s - 1)))/(7*d**2*k1**2*k2**2*k3**6) - 4*D1**4*Pk1*ct**2*f**2*mu**6*(b1*(Pk2*f*k3**6*(7*cosphi**2 - 7)*(-18*s**2 + s*(15*r + 3) - 2) + 64*Pk2*k1**4*k2**2*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) + 64*Pk2*k1**2*k2**2*k3**2*(6*r**2 + 6*r*(s - 1) - 3*s + 2) + 192*Pk2*k2**2*k3**4*(3*r**2 - 3*r + 1) + Pkd2*f*k2*k3**6*(7*cosphi**2 - 7)*(9*s**2 - 4*s + 1)) + f*k3**2*(3*s - 1)*(Pk2*k2**2*k3**2*r*(7*cosphi**2 - 7) + k1**2*(Pk2*k2**2*(4*cosphi**2 + 12)*(r + s - 1) + Pk2*k3**2*(cosphi**2*(7*r + 20*s - 20) - 7*r + 12*s - 12) - Pkd2*k2*k3**2*(2*cosphi**2 + 6)*(s - 1))))/(7*d**2*k2**2*k3**6) - D1**4*Pk1*ct**2*f**2*mu*mu2**5*(64*b1*(k1**2*(16*Pk2*k2**4*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) + 24*Pk2*k3**4*(3*s**2 - 3*s + 1) - 3*Pkd2*k2**3*k3**2*(r*(6*s - 3) + 6*s**2 - 6*s + 2) - 9*Pkd2*k2*k3**4*(3*s**2 - 3*s + 1) + k2**2*(12*Pk2*k3**2*(6*r*s - 3*r + 6*s**2 - 6*s + 2) + Pkdd2*k3**4*(3*s**2 - 3*s + 1))) + 3*k2**2*k3**2*r*(2*Pk2*k2**2*(2*r + 2*s - 1) + 4*Pk2*k3**2*(2*s - 1) + Pkd2*k2*k3**2*(1 - 2*s))) + f*(504*Pk2*f*k3**6*s**2 - 224*Pk2*k2**6*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - 189*Pkd2*f*k2*k3**6*s**2 + 56*Pkd2*k2**5*k3**2*(r*(6*s - 1) + 6*s**2 - 6*s + 1) - 4*Pkd2*k2**3*k3**4*(8*r*(6*s + 1) + s*(19 - 105*s)) - 4*k1**2*(120*Pk2*k2**4*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 168*Pk2*k3**4*s*(3*s - 1) - 2*Pkd2*k2**3*k3**2*(3*r*(22*s - 5) + 66*s**2 - 74*s + 15) - 63*Pkd2*k2*k3**4*s*(3*s - 1) + k2**2*k3**2*(8*Pk2*(66*r*s - 15*r + 66*s**2 - 74*s + 15) + 7*Pkdd2*k3**2*s*(3*s - 1))) + 4*k2**4*k3**2*(4*Pk2*(60*r**2 + 30*r*s - 61*r - 42*s**2 + 18*s + 5) + 7*Pkdd2*k3**2*s*(1 - 3*s)) + k2**2*k3**4*(32*Pk2*(4*r*(6*s + 1) - s*(21*s + 1)) + 21*Pkdd2*f*k3**2*s**2)))/(7*d**2*k1*k2*k3**6) + 4*D1**4*Pk1*ct**2*f**2*mu**5*mu2*(-16*b1*k2**2*(24*Pk2*k2**2*k3**4*(3*r**2 - 3*r + 1) + k1**4*(16*Pk2*k2**2*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) + 6*Pk2*k3**2*s*(2*r + 2*s - 1) - 3*Pkd2*k2*k3**2*s*(2*r + 2*s - 1)) + 6*k1**2*k3**2*(2*Pk2*k2**2*(6*r**2 + 6*r*(s - 1) - 3*s + 2) + 2*Pk2*k3**2*s*(2*r - 1) + Pkd2*k2*k3**2*s*(1 - 2*r))) - 7*f**2*k3**6*(18*Pk2*k2**2*r**2 + cosphi**2*k1**2*(4*Pk2 - Pkd2*k2)*(12*s**2 - 11*s + 2)) + f*(56*Pk2*k1**6*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 2*k1**4*(60*Pk2*k2**4*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 2*Pk2*k2**2*k3**2*(42*r**2 + r*(39*s - 41) - 3*s**2 + s + 6) + 28*Pk2*k3**4*(3*s**2 - 4*s + 1) - 8*Pkd2*k2**3*k3**2*(s - 1)*(3*r + 3*s - 2) - 7*Pkd2*k2*k3**4*(3*s**2 - 4*s + 1)) - 2*k1**2*k3**2*(-28*Pk2*b1*k3**4*(cosphi**2 - 1)*(9*s**2 - 9*s + 2) + 2*Pk2*k2**4*(2*cosphi**2*(6*r**2 + r*(15*s - 11) + 9*s**2 - 11*s + 4) - 96*r**2 + r*(89 - 63*s) + 33*s**2 - 8*s - 13) + Pk2*k2**2*k3**2*(cosphi**2*(42*r**2 + 135*r*s - 107*r + 180*s**2 - 204*s + 64) - 126*r**2 + 9*r*s + 87*r + 66*s**2 - 12*s - 14) + 7*Pkd2*b1*k2*k3**4*(cosphi**2 - 1)*(9*s**2 - 9*s + 2) + Pkd2*k2**3*k3**2*(-2*cosphi**2*(9*s**2 - 9*s + 2) + 48*r*(s - 1) - 33*s**2 + 10*s + 11)) - 7*k2**2*k3**4*(2*Pk2*k2**2*r*(cosphi**2*(6*r + 9*s - 5) - 42*r - 9*s + 17) + b1*k3**2*(cosphi**2 - 1)*(Pk2*(24*r*(3*s - 1) - 36*s**2 - 6*s + 4) + Pkd2*k2*(18*s**2 - 9*s + 2)))))/(7*d**2*k1*k2**3*k3**6) - 4*D1**4*Pk1*ct**2*f**2*mu**4*mu2**2*(336*Pk2*g2*k2**2*k3**6*(3*r**2 - 3*r + 1) + b1*(64*Pk2*k1**6*k2**2*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) + 6*Pk2*k2**2*k3**4*(32*k2**2*(3*r**2 - 3*r + 1) + k3**2*(f*(7*cosphi**2 - 7)*(3*r - 1)*(3*s - 1) + 48*r**2 - 48*r + 16)) + 24*k1**4*(16*Pk2*k2**4*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) + 8*Pk2*k3**4*s**2 - 6*Pkd2*k2**3*k3**2*s*(2*r + 2*s - 1) - 5*Pkd2*k2*k3**4*s**2 + k2**2*(4*Pk2*k3**2*(2*r**2 + 8*r*s - r + 6*s**2 - 3*s) + Pkdd2*k3**4*s**2)) + 3*k1**2*k3**2*(-Pk2*f*k3**4*(84*cosphi**2 - 84)*(6*s**2 - 5*s + 1) + 64*Pk2*k2**4*(6*r**2 + 6*r*(s - 1) - 3*s + 2) + 64*Pk2*k2**2*k3**2*(r**2 + 4*r*s - 2*s) + Pkd2*f*k2*k3**4*(21*cosphi**2 - 21)*(6*s**2 - 5*s + 1) - 64*Pkd2*k2**3*k3**2*s*(2*r - 1))) + 21*f**2*k3**6*(2*cosphi**2*k1**2*(4*Pk2 - Pkd2*k2)*(8*s**2 - 6*s + 1) + r*(20*Pk2*k1**2*s + 24*Pk2*k2**2*r - 5*Pkd2*k1**2*k2*s)) - f*(-21*Pk2*k2**4*k3**4*r*(cosphi**2*(9*r + 6*s - 5) - 81*r - 6*s + 29) + k1**6*(4*Pk2*k2**2*(381*r**2 + 6*r*(127*s - 82) + 381*s**2 - 492*s + 166) + 28*Pk2*k3**2*(3*r*(7*s - 1) + 21*s**2 - 19*s + 3) - 7*Pkd2*k2*k3**2*(3*r*(7*s - 1) + 21*s**2 - 19*s + 3)) + k1**4*(4*Pk2*k2**4*(474*r**2 + r*(954*s - 650) + 477*s**2 - 652*s + 229) + 4*Pk2*k3**4*(21*r*(7*s - 1) + 150*s**2 - 251*s + 62) + Pkd2*k2**3*k3**2*(r*(189 - 411*s) - 411*s**2 + 493*s - 141) + Pkd2*k2*k3**4*(-21*r*(7*s - 1) - 240*s**2 + 359*s - 92) + k2**2*(Pk2*k3**2*(1293*r**2 + 6*r*(302*s - 217) + 426*s**2 - 812*s + 341) + 2*Pkdd2*k3**4*(15*s**2 - 18*s + 5))) + k1**2*k2**2*k3**2*(Pk2*k2**2*(-12*cosphi**2*(9*r**2 + 15*r*s - 11*r + 6*s**2 - 8*s + 3) + 2079*r**2 + 2472*r*s - 2042*r + 288*s**2 - 828*s + 405) + Pk2*k3**2*(-3*cosphi**2*(39*r**2 + 150*r*s - 91*r + 120*s**2 - 136*s + 36) + 513*r**2 - 450*r*s + 43*r + 288*s**2 - 556*s + 168) + 2*Pkd2*k2*k3**2*(3*cosphi**2*(6*s**2 - 5*s + 1) - 291*r*s + 117*r - 72*s**2 + 164*s - 51))))/(7*d**2*k1**2*k2**2*k3**6) - 4*D1**4*Pk1*ct**2*f**2*mu**2*mu2**4*(4*b1*(48*Pk2*k2**4*k3**4*r**2 + 2*k1**4*(48*Pk2*k2**4*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) + 24*Pk2*k3**4*(3*s**2 - 3*s + 1) - 6*Pkd2*k2**3*k3**2*(r*(6*s - 3) + 6*s**2 - 6*s + 2) - 9*Pkd2*k2*k3**4*(3*s**2 - 3*s + 1) + k2**2*(24*Pk2*k3**2*(6*r*s - 3*r + 6*s**2 - 6*s + 2) + Pkdd2*k3**4*(3*s**2 - 3*s + 1))) + k1**2*(16*Pk2*k2**6*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) + 24*Pk2*k3**6*(3*s**2 - 3*s + 1) - 12*Pkd2*k2**5*k3**2*s*(2*r + 2*s - 1) - 6*Pkd2*k2**3*k3**4*(r*(8*s - 4) + 5*s**2) - 9*Pkd2*k2*k3**6*(3*s**2 - 3*s + 1) + 6*k2**4*(4*Pk2*k3**2*(6*r**2 + r*(8*s - 3) + s*(2*s - 1)) + Pkdd2*k3**4*s**2) + k2**2*(48*Pk2*k3**4*(4*r*s - 2*r + s**2) + Pkdd2*k3**6*(3*s**2 - 3*s + 1)))) + 21*f**2*k3**6*s*(24*Pk2*k1**2*s - 9*Pkd2*k1**2*k2*s - 5*Pkd2*k2**3*r + k2**2*(20*Pk2*r + Pkdd2*k1**2*s)) - f*(k1**4*(4*Pk2*k2**4*(477*r**2 + r*(954*s - 652) + 477*s**2 - 652*s + 230) + 504*Pk2*k3**4*s*(3*s - 1) + Pkd2*k2**3*k3**2*(r*(125 - 543*s) - 543*s**2 + 473*s - 81) - 189*Pkd2*k2*k3**4*s*(3*s - 1) + k2**2*(4*Pk2*k3**2*(543*r*s - 125*r + 543*s**2 - 473*s + 81) + 21*Pkdd2*k3**4*s*(3*s - 1))) + k1**2*k2**2*(4*Pk2*k2**4*(378*r**2 + r*(762*s - 490) + 381*s**2 - 492*s + 165) + 4*Pk2*k3**4*(r*(3*s - 59) + 69*s - 2) - 5*Pkd2*k2**3*k3**2*(3*r*(41*s - 11) + 123*s**2 - 109*s + 21) + Pkd2*k2*k3**4*(r*(59 - 3*s) - 351*s**2 + 126*s - 28) + k2**2*(Pk2*k3**2*(-33*r**2 + 636*r*s - 74*r + 762*s**2 - 492*s + 107) + Pkdd2*k3**4*(117*s**2 - 65*s + 10))) + k2**4*k3**2*(7*Pk2*k2**2*(123*r**2 + 22*r*(6*s - 5) - 28*s + 17) + 4*Pk2*k3**2*(cosphi**2*(3*r**2 - 2*r + 1) - 153*r**2 + 63*r*s + 29*r + 7*s + 7) + 14*Pkd2*k2*k3**2*(r*(5 - 21*s) + 3*s))) + 14*g2*k1**2*k3**6*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(3*s**2 - 3*s + 1))/(7*d**2*k1**2*k2**2*k3**6) - 2*D1**4*Pk1*ct**2*f**2*mu**3*mu2**3*(4*b1*k1**2*k2**2*(32*Pk2*k2**4*k3**2*(6*r**2 + 6*r*(s - 1) - 3*s + 2) + 96*Pk2*k2**2*k3**4*(2*r**2 + 2*r*s - s) - 4*Pk2*k3**6*(f*(7*cosphi**2 - 7)*(15*s**2 - 11*s + 2) + 8*r*(3 - 6*s) + 24*s - 8) + 48*Pkd2*k2**3*k3**4*s*(1 - 2*r) + Pkd2*k2*k3**6*(f*(7*cosphi**2 - 7)*(15*s**2 - 11*s + 2) + 8*r*(3 - 6*s) + 24*s - 8) + 8*k1**4*(16*Pk2*k2**2*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) + 4*Pk2*k3**2*(r*(6*s - 3) + 6*s**2 - 6*s + 2) + Pkd2*k2*k3**2*(r*(3 - 6*s) - 6*s**2 + 6*s - 2)) + 8*k1**2*(16*Pk2*k2**4*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) + 12*Pk2*k3**4*(r*(2*s - 1) + 2*s**2) - 9*Pkd2*k2**3*k3**2*s*(2*r + 2*s - 1) - 3*Pkd2*k2*k3**4*(r*(2*s - 1) + 5*s**2) + 3*k2**2*(6*Pk2*k3**2*(2*r**2 + r*(4*s - 1) + s*(2*s - 1)) + Pkdd2*k3**4*s**2))) - 7*f**2*k3**6*(-120*Pk2*k1**4*s**2 - 120*Pk2*k2**4*r**2 + 45*Pkd2*k1**4*k2*s**2 + 64*Pkd2*k1**2*k2**3*r*s + 4*cosphi**2*k1**2*k2**2*(-4*Pk2 + Pkd2*k2)*(20*s**2 - 13*s + 2) - k1**2*k2**2*s*(256*Pk2*r + 5*Pkdd2*k1**2*s)) - 4*f*(Pk2*k2**6*k3**4*r*(182 - 14*cosphi**2)*(3*r - 1) + k1**6*(44*Pk2*k2**4*(33*r**2 + 6*r*(11*s - 7) + 33*s**2 - 42*s + 14) + 168*Pk2*k3**4*s*(3*s - 1) + Pkd2*k2**3*k3**2*(r*(58 - 279*s) - 279*s**2 + 229*s - 36) - 63*Pkd2*k2*k3**4*s*(3*s - 1) + k2**2*(4*Pk2*k3**2*(279*r*s - 58*r + 279*s**2 - 229*s + 36) + 7*Pkdd2*k3**4*s*(3*s - 1))) + k1**4*k2**2*(4*Pk2*k2**4*(360*r**2 + r*(726*s - 460) + 363*s**2 - 462*s + 153) + 4*Pk2*k3**4*(9*r*(11*s - 4) + 66*s**2 - 75*s + 23) + Pkd2*k2**3*k3**2*(r*(146 - 447*s) - 447*s**2 + 437*s - 100) + Pkd2*k2*k3**4*(r*(36 - 99*s) - 255*s**2 + 216*s - 53) + k2**2*(2*Pk2*k3**2*(366*r**2 + 669*r*s - 386*r + 291*s**2 - 331*s + 111) + Pkdd2*k3**4*(63*s**2 - 47*s + 10))) + k1**2*k2**4*k3**2*(-2*Pk2*k2**2*(2*cosphi**2*(3*r - 1)*(2*r + 2*s - 1) - 669*r**2 - 837*r*s + 631*r - 126*s**2 + 272*s - 115) + 2*Pk2*k3**2*(r**2*(-3*cosphi**2 - 117) + r*(cosphi**2*(13 - 36*s) - 99*s + 101) + 126*s**2 + 3*s*(4*cosphi**2 - 42) + 39) + Pkd2*k2*k3**2*(-26*r*(15*s - 4) - 126*s**2 + 193*s - 37))) - 112*g2*k1**2*k2**2*k3**6*(-4*Pk2 + Pkd2*k2)*(r*(6*s - 3) - 3*s + 1))/(7*d**2*k1**3*k2**3*k3**6) - 4*D1**4*Pk1*ct**2*f*mu**4*(b1**2*(32*Pk2*k2**2*(2*k1**6*(r + s)**2 + 2*k1**4*k3**2*r*(r + s) + 2*k1**2*k3**4*r**2 + 3*k3**6*(r - 1)**2) - f*k3**6*(7*cosphi**2 - 7)*(6*Pk2*k2**2*s*(1 - 2*r) + k1**2*(Pk2*(16*s**2 - s*(12*r + 3) + 2) + Pkd2*k2*(-8*s**2 + 3*s - 1)))) + b1*(336*Pk2*g2*k2**2*k3**6*(r - 1)**2 - 7*f**2*k3**6*(cosphi**2*k1**2*(Pk2*(15*r*s - 18*s**2 + 3*s - 2) + Pkd2*k2*(9*s**2 - 4*s + 1)) + r*(-10*Pk2*k1**2*s - 18*Pk2*k2**2*r + 5*Pkd2*k1**2*k2*s)) - f*(-7*Pk2*k2**2*k3**4*r*(k2**2*(cosphi**2*(6*r + 2*s - 3) - 54*r - 2*s + 27) + k3**2*(cosphi**2 - 1)*(2*s - 1)) + k1**6*(4*Pk2*k2**2*(170*r**2 + 4*r*(85*s - 39) + 170*s**2 - 156*s + 41) + 70*Pk2*k3**2*s*(2*r + 2*s - 1) - 35*Pkd2*k2*k3**2*s*(2*r + 2*s - 1)) + k1**4*(8*Pk2*k2**4*(68*r**2 + r*(138*s - 53) + 69*s**2 - 54*s + 12) - Pk2*k3**4*(cosphi**2*(2*s - 1)*(7*r + 20*s - 20) - 154*r*s + 7*r + 192*s**2 + 34*s + 12) - 59*Pkd2*k2**3*k3**2*s*(2*r + 2*s - 1) + Pkd2*k2*k3**4*(cosphi**2*(4*s**2 - 6*s + 2) - 70*r*s + 92*s**2 + 17*s + 6) + k2**2*(Pk2*k3**2*(-4*cosphi**2*(2*s - 1)*(r + s - 1) + 438*r**2 + 180*r*s - 370*r - 320*s**2 - 86*s + 83) + 4*Pkdd2*k3**4*s**2)) + k1**2*k3**2*(Pk2*k2**4*(r**2*(490 - 24*cosphi**2) + r*(-4*cosphi**2*(8*s - 3) + 536*s - 350) - s**2*(8*cosphi**2 + 24) + s*(12*cosphi**2 - 224) + 49) + 2*Pk2*k2**2*k3**2*(cosphi**2*(3*r**2 - 2*r*(19*s + 5) - 16*s**2 + 12*s + 12) + 225*r**2 - 2*r*(21*s + 95) - 20*s + 66) + Pk2*k3**4*(2*s - 1)*(cosphi**2*(-7*r + 4*s - 4) + 7*r - 20*s + 20) + 2*Pkd2*k2**3*k3**2*s*(-102*r + s*(2*cosphi**2 + 6) + 51) - Pkd2*k2*k3**4*(6*cosphi**2 - 10)*(2*s**2 - 3*s + 1)))) + f*k1**2*(f*(k1**4*(r + s - 1)*(40*Pk2*k2**2*(r + s - 1) + 7*Pk2*k3**2*(s - 1) - 7*Pkd2*k2*k3**2*(s - 1)) + k1**2*(44*Pk2*k2**4*(r + s - 1)**2 + Pk2*k3**4*(-cosphi**2*(3*s - 1)*(7*r + 20*s - 20) + 7*r*(s - 1)) - 15*Pkd2*k2**3*k3**2*(s - 1)*(r + s - 1) + Pkd2*k2*k3**4*(s - 1)*(cosphi**2*(6*s - 2) - 7*r) + k2**2*k3**2*(Pk2*(r + s - 1)*(cosphi**2*(4 - 12*s) + 6*r - 11*s + 11) + 2*Pkdd2*k3**2*(s - 1)**2)) + 7*k2**2*k3**2*r*(4*Pk2*k2**2*(r + s - 1) + Pk2*k3**2*(-3*cosphi**2*s + cosphi**2 - 4*r - 2*s + 2) - 2*Pkd2*k2*k3**2*(s - 1))) - 7*k3**6*(b2*(2*Pk2 - Pkd2*k2)*(cosphi**2 - 1) - 2*g2*(Pk2*(6*cosphi**2 - 2) + Pkd2*k2*(1 - 2*cosphi**2)))*(2*s**2 - 3*s + 1)))/(7*d**2*k1**2*k2**2*k3**6) - 2*D1**4*Pk1*ct**2*f*mu**2*mu2**2*(-2*b1**2*(-32*Pk2*k2**2*k3**4*r**2*(2*k2**2 + k3**2) + f*k3**6*(7*cosphi**2 - 7)*(4*Pk2*k2**2*r*(1 - 3*s) + 3*k1**2*(1 - 2*s)**2*(4*Pk2 - Pkd2*k2)) - 8*k1**4*(48*Pk2*k2**4*(r + s)**2 + 8*Pk2*k3**4*s**2 - 12*Pkd2*k2**3*k3**2*s*(r + s) - 5*Pkd2*k2*k3**4*s**2 + k2**2*k3**2*s*(24*Pk2*(r + s) + Pkdd2*k3**2*s)) - 4*k1**2*(48*Pk2*k2**4*k3**2*r*(r + s) + 8*Pk2*k3**6*s**2 - 16*Pkd2*k2**3*k3**4*r*s - 5*Pkd2*k2*k3**6*s**2 + k2**2*k3**4*s*(32*Pk2*r + Pkdd2*k3**2*s))) + b1*(21*f**2*k3**6*(24*Pk2*k1**2*s*(r + s) - 3*Pkd2*k1**2*k2*s*(2*r + 5*s) - 12*Pkd2*k2**3*r*s + 2*cosphi**2*(3*s - 1)*(2*Pk2*k2**2*(1 - 3*r) + 3*k1**2*(4*Pk2 - Pkd2*k2)*(2*s - 1)) + 3*k2**2*(8*Pk2*r*(r + s) + Pkdd2*k1**2*s**2)) - 2*f*(k1**6*(4*Pk2*k2**2*(194*r**2 + 4*r*(97*s - 48) + 194*s**2 - 192*s + 53) + 28*Pk2*k3**2*(r*(10*s - 3) + 10*s**2 - 10*s + 3) - 7*Pkd2*k2*k3**2*(r*(10*s - 3) + 10*s**2 - 10*s + 3)) + k1**4*(8*Pk2*k2**4*(289*r**2 + 4*r*(145*s - 84) + 290*s**2 - 336*s + 101) + 8*Pk2*k3**4*(112*s**2 - 92*s + 31) + Pkd2*k2**3*k3**2*(r*(141 - 580*s) - 580*s**2 + 477*s - 93) - 2*Pkd2*k2*k3**4*(205*s**2 - 134*s + 46) + 2*k2**2*(Pk2*k3**2*(-13*r**2 + 492*r*s - 69*r + 488*s**2 - 373*s + 79) + Pkdd2*k3**4*(31*s**2 - 14*s + 5))) + k1**2*(8*Pk2*k2**6*(96*r**2 + r*(194*s - 95) + 97*s**2 - 96*s + 26) + 4*Pk2*k3**6*(7*r*(10*s - 3) - 14*s**2 - 15*s + 3) + Pkd2*k2**5*k3**2*s*(-318*r - 318*s + 143) + Pkd2*k2**3*k3**4*(6*cosphi**2*(1 - 2*s)**2 + r*(85 - 140*s) - 90*s**2 + 97*s - 38) + Pkd2*k2*k3**6*(r*(21 - 70*s) - 16*s**2 + 57*s - 18) + k2**4*k3**2*(Pk2*(-4*cosphi**2*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) + 748*r**2 + 8*r*(98*s - 79) + 56*s**2 - 130*s + 169) + 62*Pkdd2*k3**2*s**2) + k2**2*k3**4*(-2*Pk2*(cosphi**2*(17*r**2 + r*(78*s - 45) + 30*(1 - 2*s)**2) + 71*r**2 + 230*r*s - 134*r - 28*s**2 + 93*s - 38) + Pkdd2*k3**2*(10*s**2 - 14*s + 5))) + k2**2*k3**2*(7*Pk2*k2**4*(50*r**2 + 14*r*(4*s - 3) - 20*s + 9) + 2*Pk2*k2**2*k3**2*(cosphi**2*(-17*r**2 - 42*r*s + 17*r + 2) + 129*r**2 - 70*r*s - 41*r + 56*s + 42) + 2*Pk2*k3**4*(cosphi**2*(2*r**2 - 2*r + 1) - 30*r**2 + 84*r*s + 4*r - 14*s - 7) + 14*Pkd2*k2**3*k3**2*s*(3 - 10*r) + 14*Pkd2*k2*k3**4*(r*(3 - 10*s) + 3*s))) + 28*g2*k3**6*(8*Pk2*k1**2*s**2 - 5*Pkd2*k1**2*k2*s**2 + k2**2*(8*Pk2*r**2 + Pkdd2*k1**2*s**2))) + f*(f*(6*k1**6*(4*Pk2*k2**2*(43*r**2 + r*(86*s - 50) + 43*s**2 - 50*s + 13) + 28*Pk2*k3**2*s*(2*r + 2*s - 1) - 7*Pkd2*k2*k3**2*s*(2*r + 2*s - 1)) + k1**4*(96*Pk2*k2**4*(31*r**2 + r*(62*s - 38) + 31*s**2 - 38*s + 11) - 84*Pk2*k3**4*s*(2*r - 2*s + 1) - 2*Pkd2*k2**3*k3**2*(3*r*(124*s - 37) + 372*s**2 - 339*s + 67) + 3*Pkd2*k2*k3**4*s*(14*r - 95*s + 49) + 3*k2**2*(2*Pk2*k3**2*(-22*r**2 + 76*r*s + 29*r + 98*s**2 - 43*s + 4) + Pkdd2*k3**4*s*(27*s - 14))) + k1**2*k2**2*(24*Pk2*k2**4*(43*r**2 + r*(86*s - 50) + 43*s**2 - 50*s + 13) - 6*Pk2*k3**4*(cosphi**2*(39*r**2 + r*(150*s - 91) + 120*s**2 - 136*s + 36) + r*(128*s - 7) - 7*s) - 2*Pkd2*k2**3*k3**2*(3*r*(72*s - 29) + 216*s**2 - 216*s + 43) + Pkd2*k2*k3**4*(12*cosphi**2*(6*s**2 - 5*s + 1) - 90*r*(s - 1) - 63*s**2 + 21*s - 16) + k2**2*k3**2*(-6*Pk2*(4*cosphi**2*(9*r**2 + 15*r*s - 11*r + 6*s**2 - 8*s + 3) - 98*r**2 - 76*r*s + 43*r + 22*s**2 - 29*s - 4) + Pkdd2*k3**2*(87*s**2 - 66*s + 4))) + 42*k2**4*k3**2*r*(4*Pk2*k2**2*(2*r + 2*s - 1) - Pk2*k3**2*(cosphi**2*(9*r + 6*s - 5) - 4*r + 4*s + 2) + 2*Pkd2*k2*k3**2*(1 - 2*s))) + 7*g2*k3**6*(-2*Pk2*k2**2*(cosphi**2*(2*r**2 - 2*r + 1) - 30*r**2 - 10*r + 21) + k1**2*(4*Pk2*(14*s**2 - 6*s - 3) + k2*(2*Pkd2*(8*s**2 - 18*s + 9) + Pkdd2*k2*(-10*s**2 + 14*s - 5))))))/(7*d**2*k1**2*k2**2*k3**6) - 2*D1**4*Pk1*ct**2*f*mu**2*(14*b1**3*k3**6*s*(cosphi**2 - 1)*(2*Pk2*k2**2*r + k1**2*(Pk2*(r - 2*s) + Pkd2*k2*s)) - b1**2*(2*k1**6*(r + s)*(220*Pk2*k2**2*(r + s) + 42*Pk2*k3**2*s - 21*Pkd2*k2*k3**2*s) + k1**4*(8*Pk2*k2**4*(54*r**2 + 110*r*s + 55*s**2) - 88*Pk2*k3**4*s**2 - 90*Pkd2*k2**3*k3**2*s*(r + s) + 40*Pkd2*k2*k3**4*s**2 + k2**2*(-2*Pk2*k3**2*(29*r**2 + 120*r*s + 108*s**2) + 4*Pkdd2*k3**4*s**2)) + k1**2*k3**2*(-2*Pk2*k2**4*(r**2*(4*cosphi**2 - 97) + r*s*(8*cosphi**2 - 106) + s**2*(4*cosphi**2 + 12)) - 2*k2**2*k3**2*(Pk2*(16*cosphi**2*s**2 + r**2*(3*cosphi**2 - 19) + r*s*(15*cosphi**2 + 33)) + Pkd2*k2*s*(37*r - s*(2*cosphi**2 + 6))) + k3**4*(2*Pk2*(cosphi**2*(7*f*(-16*s**2 + s*(12*r + 3) - 2) - (s - 1)*(7*r - 4*s + 4)) - 7*r*(6*f*s - 7*s + 1) - 42*s**2 - 2*s - 20) + k2*(Pkd2*(2*cosphi**2*(7*f*(8*s**2 - 3*s + 1) - 6*(s - 1)**2) + s**2*(21*f + 40) + s*(r*(42*f - 42) + 2) + 20) + Pkdd2*k2*s**2*(2 - 21*f)))) + 2*k2**2*k3**4*(7*Pk2*k2**2*r*(-cosphi**2*s - r*(cosphi**2 - 9) + s) + k3**2*(Pk2*(cosphi**2*(-42*f*s + 2*r**2 + r*(84*f*s - 7*s + 3) + 2) + 7*r**2*(6 - 8*f) + 7*r*(s - 13) + 42) + 21*Pkd2*k2*s*(r*(f - 2) + 2)))) + b1*(f*(2*k1**6*(4*Pk2*k2**2*(97*r**2 + 2*r*(97*s - 50) + 97*s**2 - 100*s + 21) + 7*Pk2*k3**2*(r*(13*s - 1) + 13*s**2 - 8*s + 1) - 7*Pkd2*k2*k3**2*(r*(7*s - 1) + 7*s**2 - 5*s + 1)) + k1**4*(24*Pk2*k2**4*(55*r**2 + 2*r*(55*s - 23) + 55*s**2 - 46*s + 7) - 2*Pk2*k3**4*(cosphi**2*(2*s - 1)*(7*r + 20*s - 20) + 3*s*(14*r + 40*s - 7)) - 2*Pkd2*k2**3*k3**2*(r*(184*s - 15) + 184*s**2 - 99*s + 15) + Pkd2*k2*k3**4*(4*cosphi**2*(2*s**2 - 3*s + 1) + 3*s*(14*r + 27*s - 7)) + k2**2*k3**2*(-2*Pk2*(4*cosphi**2*(2*s - 1)*(r + s - 1) + 86*r**2 + 320*r*s - 111*r + 234*s**2 - 159*s - 8) + Pkdd2*k3**2*(43*s**2 - 8*s + 4))) + k1**2*(16*Pk2*k2**6*(16*r**2 + r*(32*s - 7) + s*(16*s - 7)) + 2*Pk2*k3**6*(-cosphi**2*(2*s - 1)*(7*r - 4*s + 4) + 7*r*(s - 1)) - 2*Pkd2*k2**5*k3**2*s*(57*r + 57*s - 14) + Pkd2*k2**3*k3**4*(r*(14 - 58*s) + s*(s*(8*cosphi**2 + 79) + 21)) - 2*Pkd2*k2*k3**6*(s - 1)*(6*cosphi**2*(2*s - 1) + 7*r) + k2**4*k3**2*(-2*Pk2*(r**2*(24*cosphi**2 - 134) + r*(4*cosphi**2*(8*s - 3) - 9*s + 74) + s**2*(8*cosphi**2 + 125) - s*(12*cosphi**2 + 7) - 21) + 25*Pkdd2*k3**2*s**2) + 2*k2**2*k3**4*(2*Pk2*cosphi**2*(3*r**2 - 2*r*(19*s + 5) - 16*s**2 + 12*s + 12) + Pk2*(-20*r**2 - 158*r*s + 21*r + 4*s**2) + Pkdd2*k3**2*(s - 1)**2)) + 14*k2**2*k3**2*r*(4*Pk2*k2**4*(r + s) - Pk2*k2**2*k3**2*(cosphi**2*(6*r + 2*s - 3) - 8*r + 6*s + 4) + Pk2*k3**4*(cosphi**2*(1 - 2*s) - 2*s + 2) - 2*Pkd2*k2**3*k3**2*s - 2*Pkd2*k2*k3**4*(s - 1))) - 7*k3**6*(Pk2*g2*k2**2*(2*cosphi**2 + 42)*(r - 1)**2 + 2*b2*k1**2*(2*Pk2 - Pkd2*k2)*(cosphi**2 - 1)*(s - 1)**2 + g2*k1**2*(-2*Pk2*(12*cosphi**2*(s - 1)**2 + 7*s**2 + 8*s - 4) + k2*(2*Pkd2*(4*cosphi**2*(s - 1)**2 + 3*s**2 + 4*s - 2) + Pkdd2*k2*s**2)))) + 7*f*k3**6*(4*Pk2*b2*k2**2*r**2 + 2*b2*cosphi**2*k1**2*(2*Pk2 - Pkd2*k2)*(2*s**2 - 3*s + 1) - 8*cosphi**2*g2*k1**2*(3*Pk2 - Pkd2*k2)*(2*s**2 - 3*s + 1) + g2*k2**2*(-28*Pk2*r**2 + Pkdd2*k1**2*(s - 1)**2)))/(7*d**2*k1**2*k2**2*k3**6) - D1**4*Pk1*ct**2*f*mu2**4*(16*b1**2*k1**2*(16*Pk2*k2**6*(r + s)**2 - 8*k2**4*k3**2*s*(-2*Pk2 + Pkd2*k2)*(r + s) + 2*k2**2*k3**4*s**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + k3**6*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(s - 1)**2) + b1*(7*f**2*k3**6*s*(72*Pk2*k1**2*s - 27*Pkd2*k1**2*k2*s - 10*Pkd2*k2**3*r + k2**2*(40*Pk2*r + 3*Pkdd2*k1**2*s)) - 4*f*(k1**4*(4*Pk2*k2**4*(138*r**2 + 12*r*(23*s - 9) + 138*s**2 - 108*s + 25) + 168*Pk2*k3**4*s*(2*s - 1) + Pkd2*k2**3*k3**2*(r*(65 - 158*s) - 158*s**2 + 114*s - 21) - 63*Pkd2*k2*k3**4*s*(2*s - 1) + k2**2*(4*Pk2*k3**2*(158*r*s - 65*r + 158*s**2 - 114*s + 21) + 7*Pkdd2*k3**4*s*(2*s - 1))) + k1**2*k2**2*(4*Pk2*k2**4*(168*r**2 + 4*r*(85*s - 39) + 170*s**2 - 156*s + 41) - 8*Pk2*k3**4*(4*r*(8*s - 1) + 8*s**2 - 15*s + 1) + Pkd2*k2**3*k3**2*(r*(121 - 270*s) - 270*s**2 + 242*s - 61) + Pkd2*k2*k3**4*(8*r*(8*s - 1) - 134*s**2 + 99*s - 28) + k2**2*(Pk2*k3**2*(-366*r**2 + r*(38 - 84*s) + 308*s**2 - 252*s + 78) + Pkdd2*k3**4*(50*s**2 - 43*s + 10))) + k2**4*k3**2*r*(14*Pk2*k2**2*(9*r + 10*s - 5) - 2*Pk2*k3**2*(76*r - 70*s + 35) + 35*Pkd2*k2*k3**2*(1 - 2*s))) + 56*g2*k1**2*k3**6*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(s - 1)**2) + 2*f**2*k2**2*(2*k1**4*(r + s - 1)*(44*Pk2*k2**2*(r + s - 1) + 28*Pk2*k3**2*s - 7*Pkd2*k2*k3**2*s) + k1**2*(80*Pk2*k2**4*(r + s - 1)**2 - 28*Pk2*k3**4*s*(r + 2*s - 1) - 26*Pkd2*k2**3*k3**2*s*(r + s - 1) + Pkd2*k2*k3**4*s*(7*r + 5*s - 7) + k2**2*k3**2*(-2*Pk2*(11*r**2 + r*(5*s - 22) - 6*s**2 - 5*s + 11) + 3*Pkdd2*k3**2*s**2)) + k2**2*k3**2*(14*Pk2*k2**2*(r - 1)*(r + s - 1) + 2*Pk2*k3**2*(4*cosphi**2*(3*r**2 - 2*r + 1) + s*(7*r - 7)) - 7*Pkd2*k2*k3**2*s*(r - 1))))/(7*d**2*k1**2*k2**2*k3**6) - D1**4*Pk1*ct**2*f*mu2**2*(-4*b1**2*(k1**4*(220*Pk2*k2**4*(r + s)**2 + 56*Pk2*k3**4*s**2 - 65*Pkd2*k2**3*k3**2*s*(r + s) - 35*Pkd2*k2*k3**4*s**2 + k2**2*k3**2*s*(130*Pk2*(r + s) + 7*Pkdd2*k3**2*s)) - k1**2*(-4*Pk2*k2**6*(54*r**2 + 110*r*s + 55*s**2) + k2**4*k3**2*(Pk2*(111*r**2 + 152*r*s + 28*s**2) + 89*Pkd2*k2*s*(r + s)) + k2**2*k3**4*s*(4*Pk2*(12*r + 7*s) + k2*(-32*Pkd2*r + 3*Pkd2*s - 17*Pkdd2*k2*s)) + k3**6*(4*Pk2*(21*cosphi**2*f*(1 - 2*s)**2 + s**2*(14*f - 3) + 6*s - 3) + k2*(Pkd2*(-21*cosphi**2*f*(1 - 2*s)**2 + s**2*(18 - 35*f) - 36*s + 18) + Pkdd2*k2*(s**2*(7*f - 5) + 10*s - 5)))) + k2**2*k3**2*r*(7*Pk2*k2**4*(5*r + 6*s) - 3*k2**2*k3**2*(12*Pk2*r + 7*Pkd2*k2*s) + k3**4*(28*Pk2*cosphi**2*f*(3*s - 1) - 6*Pk2*(3*r + s*(7*f - 7) + 7) + 21*Pkd2*k2*(s*(f - 1) + 1)))) + 2*b1*(f*(2*k1**6*(r + s)*(8*Pk2*k2**2*(16*r + 16*s - 7) + 28*Pk2*k3**2*s - 7*Pkd2*k2*k3**2*s) + k1**4*(24*Pk2*k2**4*(55*r**2 + 2*r*(55*s - 23) + 55*s**2 - 46*s + 7) - 28*Pk2*k3**4*s*(3*r - 4*s + 2) - 2*Pkd2*k2**3*k3**2*(r*(146*s - 51) + 146*s**2 - 105*s + 7) + Pkd2*k2*k3**4*s*(21*r - 100*s + 56) + 2*k2**2*(Pk2*k3**2*(-125*r**2 + 9*r*s + 7*r + 134*s**2 - 74*s + 21) + Pkdd2*k3**4*s*(12*s - 7))) + k1**2*(8*Pk2*k2**6*(97*r**2 + 2*r*(97*s - 50) + 97*s**2 - 100*s + 21) - 28*Pk2*k3**6*s*(r - 1) - 2*Pkd2*k2**5*k3**2*(r*(145*s - 59) + 145*s**2 - 131*s + 15) + Pkd2*k2**3*k3**4*(12*cosphi**2*(1 - 2*s)**2 + 2*r*(55*s - 8) - 4*s**2 - 7*s - 16) + Pkd2*k2*k3**6*s*(7*r - 15*s - 7) + 2*k2**4*k3**2*(-Pk2*(4*cosphi**2*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) + 234*r**2 + 320*r*s - 159*r + 86*s**2 - 111*s - 8) + Pkdd2*k3**2*(24*s**2 - 19*s + 2)) + k2**2*k3**4*(-4*Pk2*cosphi**2*(17*r**2 + r*(78*s - 45) + 30*(1 - 2*s)**2) + Pk2*(8*r**2 - 316*r*s - 40*s**2 + 42*s) + 5*Pkdd2*k3**2*s**2)) + k2**2*k3**2*(14*Pk2*k2**4*(13*r**2 + r*(13*s - 8) - s + 1) - 2*Pk2*k2**2*k3**2*(cosphi**2*(34*r**2 + 84*r*s - 34*r - 4) + 3*r*(40*r + 14*s - 7)) + 2*Pk2*k3**4*(cosphi**2*(4*r**2 - 4*r + 2) + s*(7*r - 7)) + 7*Pkd2*k2**3*k3**2*(r*(6 - 13*s) + s) - 7*Pkd2*k2*k3**4*s*(r - 1))) - 7*g2*k3**6*(-18*Pk2*k2**2*r**2 + k1**2*(12*Pk2 + k2*(-18*Pkd2 + 5*Pkdd2*k2))*(s - 1)**2)) + 7*f*k3**6*(4*Pk2*cosphi**2*g2*k2**2*(2*r**2 - 2*r + 1) + k1**2*s**2*(8*Pk2*b2 - 56*Pk2*g2 + b2*k2*(-5*Pkd2 + Pkdd2*k2) - 2*g2*k2*(-10*Pkd2 + Pkdd2*k2))))/(7*d**2*k1**2*k2**2*k3**6) - 2*D1**4*Pk1*ct**2*f*mu**3*mu2*(2*b1**2*k1**2*(-f*k3**6*(7*cosphi**2 - 7)*(k1**2*(4*Pk2 - Pkd2*k2)*(6*s**2 - 7*s + 2) + k2**2*(Pk2*(-32*r*s + 8*r + 24*s**2 - 10*s + 4) + Pkd2*k2*(-12*s**2 + 7*s - 2))) + 32*k2**2*(4*Pk2*k2**2*k3**4*r**2 + 2*Pk2*k3**6*s*(r - 1) - Pkd2*k2*k3**6*s*(r - 1) + k1**4*(r + s)*(8*Pk2*k2**2*(r + s) + 2*Pk2*k3**2*s - Pkd2*k2*k3**2*s) + k1**2*k3**2*r*(6*Pk2*k2**2*(r + s) + 2*Pk2*k3**2*s - Pkd2*k2*k3**2*s))) + b1*(7*f**2*k3**6*(72*Pk2*k2**4*r**2 + 2*cosphi**2*(2*k1**4*(4*Pk2 - Pkd2*k2)*(9*s**2 - 9*s + 2) + k1**2*k2**2*(Pk2*(-72*r*s + 24*r + 36*s**2 + 6*s - 4) + Pkd2*k2*(-18*s**2 + 9*s - 2))) + 5*k1**4*s**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + 24*k1**2*k2**2*r*(Pk2*(r + 4*s) - 2*Pkd2*k2*s)) - 4*f*(28*Pk2*k1**8*k2**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + Pk2*k2**4*k3**4*r*(91 - 7*cosphi**2)*(k2**2 + k3**2)*(2*r - 1) + k1**6*(4*Pk2*k2**4*(230*r**2 + r*(460*s - 246) + 230*s**2 - 246*s + 71) + 28*Pk2*k3**4*(6*s**2 - 3*s + 1) - 2*Pkd2*k2**3*k3**2*(r*(87*s - 8) + 87*s**2 - 48*s + 4) - 7*Pkd2*k2*k3**4*(12*s**2 - 3*s + 1) + 2*k2**2*(Pk2*k3**2*(156*r*s + r + 156*s**2 - 65*s - 1) + 7*Pkdd2*k3**4*s**2)) + k1**4*(4*Pk2*k2**6*(150*r**2 + r*(304*s - 127) + 152*s**2 - 129*s + 31) - Pk2*k2**2*k3**4*(cosphi**2*(14*r**2 + r*(66*s - 45) + 120*s**2 - 140*s + 40) - 14*r**2 + 6*r*s + 13*r + 152*s**2 - 60*s + 10) + 28*Pk2*k3**6*(2*s**2 - 3*s + 1) - 10*Pkd2*k2**5*k3**2*s*(19*r + 19*s - 8) + Pkd2*k2**3*k3**4*(2*cosphi**2*(6*s**2 - 7*s + 2) - 54*r*s + 16*r + 50*s**2 - 9*s + 5) - 7*Pkd2*k2*k3**6*(2*s**2 - 3*s + 1) + 2*k2**4*(-Pk2*k3**2*(2*cosphi**2*(2*r**2 + 8*r*s - 5*r + 6*s**2 - 7*s + 2) - 208*r**2 - 108*r*s + 175*r + 108*s**2 + 7*s - 46) + 13*Pkdd2*k3**4*s**2)) + k1**2*k2**2*k3**2*(2*Pk2*k2**4*(2*cosphi**2*s + r**2*(230 - 4*cosphi**2) + r*(cosphi**2*(2 - 4*s) + 272*s - 171) + 14*s**2 - 101*s + 28) + 2*Pk2*k2**2*k3**2*(cosphi**2*(-2*r**2 - 29*r*s + 2*r + 4*s + 6) + 98*r**2 - 119*r*s - 104*r + 38*s + 54) + Pk2*k3**4*(-cosphi**2*(2*r - 1)*(7*r + 20*s - 20) + 70*r**2 - 8*r*s - 51*r + 28*s**2 - 70*s + 34) - 2*Pkd2*k2**3*k3**2*s*(86*r + 7*s - 36) - Pkd2*k2*k3**4*(s - 1)*(16*r + 14*s - 15))) - 224*g2*k1**2*k2**2*k3**6*s*(-2*Pk2 + Pkd2*k2)*(r - 1)) + 4*f*k1**2*(f*(28*Pk2*k1**6*k2**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + k1**4*(8*Pk2*k2**4*(43*r**2 + r*(86*s - 62) + 43*s**2 - 62*s + 19) + 28*Pk2*k3**4*s*(2*s - 1) - 11*Pkd2*k2**3*k3**2*(r*(7*s - 4) + 7*s**2 - 9*s + 2) - 7*Pkd2*k2*k3**4*s*(5*s - 4) + k2**2*(Pk2*k3**2*(69*r*s - 7*r + 69*s**2 - 54*s + 7) + 7*Pkdd2*k3**4*s*(s - 1))) + k1**2*k2**2*(4*Pk2*k2**4*(47*r**2 + r*(94*s - 65) + 47*s**2 - 65*s + 18) - Pk2*k3**4*(cosphi**2*(42*r**2 + 135*r*s - 107*r + 180*s**2 - 204*s + 64) + 83*r*s + 7*r - 14*s) + Pkd2*k2**3*k3**2*(r*(44 - 73*s) - 73*s**2 + 95*s - 22) + Pkd2*k2*k3**4*(2*cosphi**2*(9*s**2 - 9*s + 2) - 17*r*s + 22*r - 7*s**2 - 4) + k2**2*(-Pk2*k3**2*(4*cosphi**2*(6*r**2 + 15*r*s - 11*r + 9*s**2 - 11*s + 4) - 66*r**2 - 33*r*s + 15*r + 33*s**2 - 58*s + 3) + Pkdd2*k3**4*(13*s**2 - 15*s + 2))) + 7*k2**4*k3**2*r*(4*Pk2*k2**2*(3*r + 3*s - 2) - Pk2*k3**2*(cosphi**2*(6*r + 9*s - 5) + 4*r + 6*s - 2) + 2*Pkd2*k2*k3**2*(2 - 3*s))) + 14*k2**2*k3**6*(Pk2*b2*(cosphi**2 - 1)*(2*r - 1)*(s - 1) + 2*g2*(Pk2*(cosphi**2*(-2*r*s + 2*r + s - 1) + 8*r*s - 5*r + 1) + Pkd2*k2*(2*r - 1)*(s - 1)))))/(7*d**2*k1**3*k2**3*k3**6) - 2*D1**4*Pk1*ct**2*f*mu*mu2**3*(32*b1**2*k1**2*k2**2*(16*Pk2*k1**2*k2**4*(r + s)**2 + 2*k2**2*k3**2*(r + s)*(6*Pk2*k1**2*s + 2*Pk2*k2**2*r - 3*Pkd2*k1**2*k2*s) + k3**6*r*(4*Pk2 - Pkd2*k2)*(s - 1) + k3**4*s*(8*Pk2*k1**2*s - 5*Pkd2*k1**2*k2*s - 2*Pkd2*k2**3*r + k2**2*(4*Pk2*r + Pkdd2*k1**2*s))) + b1*(-7*f**2*k3**6*(-72*Pk2*k1**4*s**2 + 27*Pkd2*k1**4*k2*s**2 + 3*Pkd2*k1**2*k2**3*s*(8*r + 5*s) + 4*cosphi**2*k1**2*k2**2*(-4*Pk2 + Pkd2*k2)*(15*s**2 - 11*s + 2) - 3*k1**2*k2**2*s*(8*Pk2*(4*r + s) + Pkdd2*k1**2*s) - k2**4*(40*Pk2*r**2 + 3*Pkdd2*k1**2*s**2)) - 2*f*(224*Pk2*k2**6*k3**4*r**2 + k1**6*(8*Pk2*k2**4*(152*r**2 + r*(304*s - 129) + 152*s**2 - 129*s + 32) + 168*Pk2*k3**4*s*(2*s - 1) - 2*Pkd2*k2**3*k3**2*(r*(114*s - 43) + 114*s**2 - 92*s + 21) - 63*Pkd2*k2*k3**4*s*(2*s - 1) + k2**2*(8*Pk2*k3**2*(114*r*s - 43*r + 114*s**2 - 92*s + 21) + 7*Pkdd2*k3**4*s*(2*s - 1))) + k1**4*(8*Pk2*k2**6*(228*r**2 + r*(460*s - 246) + 230*s**2 - 246*s + 71) + 168*Pk2*k3**6*s*(2*s - 1) - 2*Pkd2*k2**5*k3**2*(r*(286*s - 115) + 286*s**2 - 281*s + 69) + Pkd2*k2**3*k3**4*(8*r*(8*s - 1) - 420*s**2 + 347*s - 106) - 63*Pkd2*k2*k3**6*s*(2*s - 1) + k2**4*(-4*Pk2*k3**2*(76*r**2 - 148*r*s + 37*r - 222*s**2 + 213*s - 60) + Pkdd2*k3**4*(84*s**2 - 71*s + 20)) + k2**2*(8*Pk2*k3**4*(r*(4 - 32*s) + 84*s**2 - 67*s + 23) + 7*Pkdd2*k3**6*s*(2*s - 1))) + k1**2*k2**2*(56*Pk2*k2**6*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 8*Pk2*k3**6*(r*(8*s + 2) + s*(3 - 14*s)) - 14*Pkd2*k2**5*k3**2*s*(4*r + 4*s - 3) - 2*Pkd2*k2**3*k3**4*(r*(86*s - 44) + 91*s**2 - 76*s + 21) + Pkd2*k2*k3**6*(4*r*(4*s + 1) + s*(27 - 70*s)) + 2*k2**4*(2*Pk2*k3**2*(162*r**2 + 6*r*(42*s - 19) + 84*s**2 - 68*s + 17) + 7*Pkdd2*k3**4*s**2) + k2**2*(-4*Pk2*k3**4*(100*r**2 + 4*r*(25*s - 16) - 21*(1 - 2*s)**2) + 7*Pkdd2*k3**6*s*(2*s - 1)))) - 112*g2*k1**2*k2**2*k3**6*r*(-4*Pk2 + Pkd2*k2)*(s - 1)) + 2*f*k2**2*(f*(-28*Pk2*k2**4*k3**4*r*(cosphi**2*(3*r - 1) - 4*r + 2) + 2*k1**6*(4*Pk2*k2**2*(47*r**2 + r*(94*s - 65) + 47*s**2 - 65*s + 18) + 28*Pk2*k3**2*s*(3*r + 3*s - 2) - 7*Pkd2*k2*k3**2*s*(3*r + 3*s - 2)) + k1**4*(16*Pk2*k2**4*(43*r**2 + r*(86*s - 62) + 43*s**2 - 62*s + 19) - 28*Pk2*k3**4*s*(3*r + 2*s - 1) - 2*Pkd2*k2**3*k3**2*(5*r*(19*s - 3) + 95*s**2 - 84*s + 15) + Pkd2*k2*k3**4*s*(21*r - 55*s + 14) + k2**2*(-2*Pk2*k3**2*(33*r**2 - 33*r*s - 58*r - 66*s**2 + 15*s + 3) + Pkdd2*k3**4*s*(23*s - 7))) + k1**2*k2**2*(56*Pk2*k2**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 2*Pk2*k3**4*(6*cosphi**2*r**2 + r*(cosphi**2*(72*s - 26) + 83*s - 14) + s*(7 - 24*cosphi**2)) - 14*Pkd2*k2**3*k3**2*(r*(4*s - 1) + (1 - 2*s)**2) + Pkd2*k2*k3**4*(r*(8 - 13*s) - s*(14*s - 14)) + k2**2*(-2*Pk2*k3**2*(4*cosphi**2*(3*r - 1)*(2*r + 2*s - 1) - 69*r**2 - 69*r*s + 54*r + 7*s - 7) + 7*Pkdd2*k3**4*s*(2*s - 1)))) + 14*g2*k1**2*k3**6*(4*Pk2 - Pkd2*k2)*(4*r*s + r - 2*s)))/(7*d**2*k1**3*k2**3*k3**6) - D1**4*Pk1*ct**2*f*mu*mu2*(-b1**2*(112*Pk2*k2**4*k3**4*r**2*(2*k2**2 + k3**2*(2 - 3*f)) + 4*k1**6*(440*Pk2*k2**4*(r + s)**2 + 56*Pk2*k3**4*s**2 - 86*Pkd2*k2**3*k3**2*s*(r + s) - 35*Pkd2*k2*k3**4*s**2 + k2**2*k3**2*s*(172*Pk2*(r + s) + 7*Pkdd2*k3**2*s)) - 2*k1**4*(-16*Pk2*k2**6*(54*r**2 + 110*r*s + 55*s**2) + 4*k2**4*k3**2*(Pk2*(48*r**2 + 92*r*s + 46*s**2) + 67*Pkd2*k2*s*(r + s)) + 2*k2**2*k3**4*s*(4*Pk2*(23*r + 7*s) + k2*(-32*Pkd2*r + 5*Pkd2*s - 19*Pkdd2*k2*s)) + 7*k3**6*(8*Pk2*(cosphi**2*f*(6*s**2 - 7*s + 2) + s**2*(3*f - 4) + 4*s - 2) + k2*(Pkd2*(-2*cosphi**2*f*(6*s**2 - 7*s + 2) + s**2*(14 - 15*f) - 8*s + 4) + Pkdd2*k2*s**2*(3*f - 2)))) + k1**2*k2**2*k3**2*(16*Pk2*k2**4*(43*r**2 + 57*r*s + 7*s**2) - 8*k2**2*k3**2*(4*Pk2*r*(7*r + 19*s) + Pkd2*k2*s*(29*r + 7*s)) + k3**4*(8*Pk2*(7*cosphi**2*f*(4*r*(4*s - 1) - 12*s**2 + 5*s - 2) - 2*r*s*(28*f + 12) + 16*r + 14*s**2 - 20*s + 14) + k2*(Pkd2*(28*cosphi**2*f*(12*s**2 - 7*s + 2) + 21*f*s**2 + 32*r*(7*f*s + 1) - 84*s**2 + 80*s - 56) + Pkdd2*k2*s**2*(28 - 21*f))))) + 4*b1*(f*(56*Pk2*k1**8*k2**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + Pk2*k2**4*k3**4*r*(28 - 14*cosphi**2)*(k2**2 + k3**2)*(2*r - 1) + k1**6*(56*Pk2*k2**4*(14*r**2 + r*(28*s - 17) + 14*s**2 - 17*s + 3) + 28*Pk2*k3**4*s*(2*s - 1) - 2*Pkd2*k2**3*k3**2*(r*(70*s - 29) + 70*s**2 - 70*s + 7) - 7*Pkd2*k2*k3**4*s*(5*s - 4) + k2**2*(-2*Pk2*k3**2*(28*r**2 - 59*r*s - 87*s**2 + 65*s - 14) + 7*Pkdd2*k3**4*s*(s - 1))) + k1**4*(56*Pk2*k2**6*(14*r**2 + r*(28*s - 17) + 14*s**2 - 17*s + 3) + 28*Pk2*k3**6*s*(2*s - 1) - 2*Pkd2*k2**5*k3**2*(r*(126*s - 37) + 126*s**2 - 115*s + 15) + Pkd2*k2**3*k3**4*(4*cosphi**2*(6*s**2 - 7*s + 2) + r*(53*s - 8) + 37*s**2 - 14*s - 8) - 7*Pkd2*k2*k3**6*s*(5*s - 4) + k2**4*k3**2*(-2*Pk2*(4*cosphi**2*(2*r**2 + r*(8*s - 5) + 6*s**2 - 7*s + 2) + 125*r**2 + 5*r*(50*s - 27) + 125*s**2 - 135*s - 8) + Pkdd2*k3**2*(35*s**2 - 23*s + 4)) - k2**2*k3**4*(2*Pk2*cosphi**2*(14*r**2 + r*(66*s - 45) + 120*s**2 - 140*s + 40) + s*(6*Pk2*(23*r + 20*s - 7) - 7*Pkdd2*k3**2*(s - 1)))) + k1**2*k2**2*(56*Pk2*k2**6*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*Pk2*k3**6*(-cosphi**2*(2*r - 1)*(7*r + 20*s - 20) + r*(7 - 12*s) + 7*s) - 14*Pkd2*k2**5*k3**2*s*(2*r + 2*s - 1) + Pkd2*k2**3*k3**4*(r*(28 - 59*s) + 7*s*(3*s + 2)) + Pkd2*k2*k3**6*(r*(4 - 12*s) - 7*s**2) + k2**4*k3**2*(-2*Pk2*(-4*cosphi**2*s + r**2*(8*cosphi**2 - 87) + r*(cosphi**2*(8*s - 4) - 59*s + 65) + 28*s**2 - 14) + 7*Pkdd2*k3**2*s**2) + k2**2*k3**4*(-4*Pk2*cosphi**2*(2*r**2 + r*(29*s - 2) - 4*s - 6) - 6*Pk2*r*(20*r + 23*s - 7) + 7*Pkdd2*k3**2*s*(s - 1)))) - 28*g2*k1**2*k2**2*k3**6*(Pk2*r*(4 - 6*s) + 2*Pk2*s + Pkd2*k2*(r - s))) - 56*f*k1**2*k2**2*k3**6*(2*Pk2*b2*cosphi**2*(2*r - 1)*(s - 1) - 4*Pk2*cosphi**2*g2*(2*r - 1)*(s - 1) + b2*r*s*(-2*Pk2 + Pkd2*k2) + g2*r*(20*Pk2*s - k2*(4*Pkd2*s + Pkd2))))/(7*d**2*k1**3*k2**3*k3**6) - 2*D1**4*Pk1*ct*f**3*mu**2*mu2**6*(504*Pk2*f*k3**6*s*(1 - 4*s) + 112*Pk2*k2**6*(6*r**2 + 4*r*(3*s - 2) + 6*s**2 - 8*s + 3) + 189*Pkd2*f*k2*k3**6*s*(4*s - 1) - 28*Pkd2*k2**5*k3**2*(4*r*(3*s - 1) + 3*(1 - 2*s)**2) + 2*Pkd2*k2**3*k3**4*(64*r*(3*s - 1) - 210*s**2 + 76*s - 19) + 14*k1**2*(8*Pk2*k2**4*(6*r**2 + 4*r*(3*s - 2) + 6*s**2 - 8*s + 3) + 24*Pk2*k3**4*(6*s**2 - 4*s + 1) - 2*Pkd2*k2**3*k3**2*(4*r*(3*s - 1) + 3*(1 - 2*s)**2) - 9*Pkd2*k2*k3**4*(6*s**2 - 4*s + 1) + k2**2*(8*Pk2*k3**2*(4*r*(3*s - 1) + 3*(1 - 2*s)**2) + Pkdd2*k3**4*(6*s**2 - 4*s + 1))) + 2*k2**4*k3**2*(-4*Pk2*(96*r**2 + 4*r*(3*s - 17) - 84*s**2 + 52*s + 3) + 7*Pkdd2*k3**2*(6*s**2 - 4*s + 1)) + k2**2*k3**4*(16*Pk2*(r*(32 - 96*s) + 42*s**2 + 4*s - 1) + 21*Pkdd2*f*k3**2*s*(1 - 4*s)))/(7*d**2*k1*k2*k3**6) - 8*D1**4*Pk1*ct*f**3*mu**6*mu2**2*(28*Pk2*k1**6*k2**2*(6*r**2 + 4*r*(3*s - 2) + 6*s**2 - 8*s + 3) + 2*Pk2*k1**4*k2**2*(14*k2**2*(6*r**2 + 4*r*(3*s - 2) + 6*s**2 - 8*s + 3) + k3**2*(84*r**2 - 4*r*(3*s + 13) - 96*s**2 + 68*s - 3)) - 42*Pk2*k2**2*k3**4*(3*f*k3**2*r*(4*r - 1) - 2*k2**2*(6*r**2 - 4*r + 1)) + k1**2*(-28*Pk2*f*k3**6*(12*s**2 - 11*s + 2) + 28*Pk2*k2**4*k3**2*(12*r**2 + 12*r*(s - 1) - 4*s + 3) + 4*Pk2*k2**2*k3**4*(42*r**2 + r*(4 - 96*s) + 32*s - 1) + 7*Pkd2*f*k2*k3**6*(12*s**2 - 11*s + 2)))/(7*d**2*k1*k2**3*k3**6) - 8*D1**4*Pk1*ct*f**3*mu**5*mu2**3*(168*Pk2*k2**2*k3**4*(2*f*k3**2*r*(1 - 4*r) + k2**2*(6*r**2 - 4*r + 1)) + 7*k1**6*(16*Pk2*k2**2*(6*r**2 + 4*r*(3*s - 2) + 6*s**2 - 8*s + 3) + 4*Pk2*k3**2*(4*r*(3*s - 1) + 3*(1 - 2*s)**2) + Pkd2*k2*k3**2*(r*(4 - 12*s) - 3*(1 - 2*s)**2)) + k1**4*(112*Pk2*k2**4*(6*r**2 + 4*r*(3*s - 2) + 6*s**2 - 8*s + 3) + 8*Pk2*k2**2*k3**2*(39*r**2 - 2*r*(6*s + 11) - 51*s**2 + 38*s - 3) + 4*Pk2*k3**4*(28*r*(3*s - 1) - 96*s**2 + 36*s - 9) - 7*Pkd2*k2**3*k3**2*(4*r*(3*s - 1) + 3*(1 - 2*s)**2) + Pkd2*k2*k3**4*(r*(28 - 84*s) + 96*s**2 - 36*s + 9)) + 2*k1**2*(-28*Pk2*f*k3**6*(18*r*s - 2*r + 24*s**2 - 21*s + 3) + 42*Pk2*k2**4*k3**2*(12*r**2 + 12*r*(s - 1) - 4*s + 3) - 2*Pk2*k2**2*k3**4*(12*r**2 + 4*r*(27*s - 11) - 36*s + 11) + 7*Pkd2*f*k2*k3**6*(18*r*s - 2*r + 24*s**2 - 21*s + 3) - 7*Pkd2*k2**3*k3**4*(4*r*(3*s - 1) - 4*s + 1)))/(7*d**2*k1**2*k2**2*k3**6) + 8*D1**4*Pk1*ct*f**3*mu**3*mu2**5*(-7*k1**4*(16*Pk2*k2**4*(6*r**2 + 4*r*(3*s - 2) + 6*s**2 - 8*s + 3) + 24*Pk2*k3**4*(6*s**2 - 4*s + 1) - 3*Pkd2*k2**3*k3**2*(4*r*(3*s - 1) + 3*(1 - 2*s)**2) - 9*Pkd2*k2*k3**4*(6*s**2 - 4*s + 1) + k2**2*k3**2*(48*Pk2*r*(3*s - 1) + 36*Pk2*(1 - 2*s)**2 + Pkdd2*k3**2*(6*s**2 - 4*s + 1))) + k1**2*(336*Pk2*f*k3**6*s*(4*s - 1) - 112*Pk2*k2**6*(6*r**2 + 4*r*(3*s - 2) + 6*s**2 - 8*s + 3) - 126*Pkd2*f*k2*k3**6*s*(4*s - 1) + 21*Pkd2*k2**5*k3**2*(4*r*(3*s - 1) + 3*(1 - 2*s)**2) + 2*Pkd2*k2**3*k3**4*(r*(18 - 54*s) + 57*s**2 - 20*s + 5) + k2**4*(8*Pk2*k3**2*(51*r**2 + 12*r*s - 38*r - 39*s**2 + 22*s + 3) - 7*Pkdd2*k3**4*(6*s**2 - 4*s + 1)) + 2*k2**2*(Pk2*k3**4*(72*r*(3*s - 1) + 24*s**2 - 88*s + 22) + 7*Pkdd2*f*k3**6*s*(4*s - 1))) - 2*k2**2*k3**2*(28*Pk2*f*k3**4*(r*(3 - 18*s) + 2*s) + 14*Pk2*k2**4*(12*r**2 + 12*r*(s - 1) - 4*s + 3) - 2*Pk2*k2**2*k3**2*(96*r**2 - 12*r*(7*s + 3) + 28*s + 9) + 7*Pkd2*f*k2*k3**4*(3*r*(6*s - 1) - 2*s) - 7*Pkd2*k2**3*k3**2*(4*r*(3*s - 1) - 4*s + 1)))/(7*d**2*k1**2*k2**2*k3**6) - 2*D1**4*Pk1*ct*f**3*mu**4*mu2**4*(-168*Pk2*k2**4*k3**4*(5*f*k3**2*r*(4*r - 1) - 2*k2**2*(6*r**2 - 4*r + 1)) + 14*k1**6*(48*Pk2*k2**4*(6*r**2 + 4*r*(3*s - 2) + 6*s**2 - 8*s + 3) + 24*Pk2*k3**4*(6*s**2 - 4*s + 1) - 6*Pkd2*k2**3*k3**2*(4*r*(3*s - 1) + 3*(1 - 2*s)**2) - 9*Pkd2*k2*k3**4*(6*s**2 - 4*s + 1) + k2**2*k3**2*(96*Pk2*r*(3*s - 1) + 72*Pk2*(1 - 2*s)**2 + Pkdd2*k3**2*(6*s**2 - 4*s + 1))) + k1**4*(840*Pk2*f*k3**6*s*(1 - 4*s) + 672*Pk2*k2**6*(6*r**2 + 4*r*(3*s - 2) + 6*s**2 - 8*s + 3) + 315*Pkd2*f*k2*k3**6*s*(4*s - 1) - 84*Pkd2*k2**5*k3**2*(4*r*(3*s - 1) + 3*(1 - 2*s)**2) + 2*Pkd2*k2**3*k3**4*(-48*r*(3*s - 1) + 174*s**2 - 68*s + 17) + 2*k2**4*(-24*Pk2*k3**2*(6*r**2 + 12*r*s - 8*r + 6*s**2 - 8*s + 3) + 7*Pkdd2*k3**4*(6*s**2 - 4*s + 1)) + k2**2*(16*Pk2*k3**4*(24*r*(3*s - 1) - 150*s**2 + 76*s - 19) + 35*Pkdd2*f*k3**6*s*(1 - 4*s))) + 8*k1**2*k2**2*k3**2*(-28*Pk2*f*k3**4*(r*(36*s - 5) + 20*s**2 - 18*s + 2) + 42*Pk2*k2**4*(12*r**2 + 12*r*(s - 1) - 4*s + 3) - 2*Pk2*k2**2*k3**2*(150*r**2 - 4*r*(18*s + 19) + 24*s + 19) + 7*Pkd2*f*k2*k3**4*(r*(36*s - 5) + 20*s**2 - 18*s + 2) - 14*Pkd2*k2**3*k3**2*(4*r*(3*s - 1) - 4*s + 1)))/(7*d**2*k1**3*k2**3*k3**6) - 4*D1**4*Pk1*ct*f**2*mu**6*(4*Pk2*b1*k2**2*(-21*f*k3**6*r*(3*r - 1) + 14*k1**6*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) + k1**4*(14*k2**2*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) + k3**2*(42*r**2 - 6*r*(s + 7) - 48*s**2 + 3*s + 14)) + 2*k1**2*(7*k2**2*k3**2*(6*r**2 + 6*r*(s - 1) - 3*s + 2) + k3**4*(21*r**2 - 3*r*(16*s + 7) + 24*s + 7)) - 21*k2**2*k3**4*(-6*r**2 + 6*r - 2)) + cosphi**2*f*k1**2*k3**2*(3*s - 1)*(7*k1**2*(2*Pk2*k2**2*(r + s - 1) + 4*Pk2*k3**2*(s - 1) - Pkd2*k2*k3**2*(s - 1)) + k2**2*(14*Pk2*k2**2*(r + s - 1) - 2*Pk2*k3**2*(8*r - 7*s + 7) - 7*Pkd2*k2*k3**2*(s - 1))))/(7*d**2*k1*k2**3*k3**6) - 8*D1**4*Pk1*ct*f**2*mu**5*mu2*(b1*(84*Pk2*k2**2*k3**4*(3*f*k3**2*r*(1 - 3*r) + k2**2*(6*r**2 - 6*r + 2)) + 7*k1**6*(16*Pk2*k2**2*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) + 6*Pk2*k3**2*s*(2*r + 2*s - 1) - 3*Pkd2*k2*k3**2*s*(2*r + 2*s - 1)) + k1**4*(112*Pk2*k2**4*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) + 2*Pk2*k2**2*k3**2*(78*r**2 - 6*r*(11*s + 13) - 144*s**2 + 33*s + 26) + 6*Pk2*k3**4*s*(14*r - 16*s - 7) - 21*Pkd2*k2**3*k3**2*s*(2*r + 2*s - 1) + 3*Pkd2*k2*k3**4*s*(-14*r + 16*s + 7)) + k1**2*k3**2*(-7*Pk2*f*k3**4*(18*s**2 + s*(27*r - 15) + 2) + 84*Pk2*k2**4*(6*r**2 + 6*r*(s - 1) - 3*s + 2) - 8*Pk2*k2**2*k3**2*(3*r**2 + r*(48*s - 3) - 24*s + 1) + 7*Pkd2*f*k2*k3**4*(9*s**2 + s*(21*r - 10) + 1) + 42*Pkd2*k2**3*k3**2*s*(1 - 2*r))) + f*k1**2*(14*Pk2*f*k3**6*r*(3*s - 2) + 14*Pk2*k2**4*k3**2*(cosphi**2*(6*r**2 + r*(15*s - 11) + 9*s**2 - 11*s + 4) + (2 - 6*r)*(r + s - 1)) + Pk2*k2**2*k3**4*(14*cosphi**2*s*(9*s - 7) + r**2*(24 - 96*cosphi**2) + r*(-4*cosphi**2*(57*s - 41) + 105*s - 71) + 14) - 7*Pkd2*f*k2*k3**6*r*(3*s - 2) - 7*Pkd2*k2**3*k3**4*(cosphi**2*(9*s**2 - 9*s + 2) + (2 - 6*r)*(s - 1)) + k1**4*(-52*Pk2*k2**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 7*Pk2*k3**2*(2*r - 1) + 7*Pkd2*k2*k3**2*(s - 1)*(3*r + 3*s - 2)) + k1**2*(-28*Pk2*k2**4*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + Pk2*k2**2*k3**2*(14*cosphi**2*(6*r**2 + r*(15*s - 11) + 9*s**2 - 11*s + 4) - 66*r**2 + r*(64 - 12*s) + 54*s**2 - 60*s - 1) + Pk2*k3**4*(28*cosphi**2*(9*s**2 - 9*s + 2) + 7*r*(3*s + 1) - 12*s**2 + 46*s - 11) + 7*Pkd2*k2**3*k3**2*(s - 1)*(3*r + 3*s - 2) + Pkd2*k2*k3**4*(-7*cosphi**2*(9*s**2 - 9*s + 2) + (s - 1)*(21*r - 6*s - 5)))))/(7*d**2*k1**2*k2**2*k3**6) + 2*D1**4*Pk1*ct*f**2*mu**3*mu2**3*(-4*b1*(7*k1**6*(16*Pk2*k2**2*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) + 4*Pk2*k3**2*(r*(6*s - 3) + 6*s**2 - 6*s + 2) + Pkd2*k2*k3**2*(r*(3 - 6*s) - 6*s**2 + 6*s - 2)) + k1**4*(224*Pk2*k2**4*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) - 8*Pk2*k3**4*(3*s**2 - 24*s + 8) - 7*Pkd2*k2**3*k3**2*(3*r*(8*s - 1) + 24*s**2 - 15*s + 2) + Pkd2*k2*k3**4*(-57*s**2 - 48*s + 16) + k2**2*(2*Pk2*k3**2*(-48*r**2 - 24*r*s + 75*r + 24*s**2 + 39*s - 34) + 21*Pkdd2*k3**4*s**2)) + k1**2*(112*Pk2*k2**6*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) - 4*Pk2*k3**6*(7*f*(21*r*s - 4*r + 72*s**2 - 49*s + 9) - 42*r*s + 21*r + 24*s**2 - 3*s + 1) - 63*Pkd2*k2**5*k3**2*s*(2*r + 2*s - 1) + 3*Pkd2*k2**3*k3**4*(r*(4*s + 7) + s*(9*s - 9)) + Pkd2*k2*k3**6*(7*f*(21*r*s - 4*r + 99*s**2 - 52*s + 9) - 42*r*s + 21*r + 24*s**2 - 3*s + 1) + k2**4*(2*Pk2*k3**2*(24*r**2 - 24*r*s + 39*r - 48*s**2 + 75*s - 34) + 21*Pkdd2*k3**4*s**2) + k2**2*(-6*Pk2*k3**4*(16*r**2 + 9*r*(4*s - 1) + s*(16*s - 9)) + 7*Pkdd2*f*k3**6*s*(1 - 9*s))) + 2*k2**2*k3**2*(14*Pk2*k2**4*(6*r**2 + 6*r*(s - 1) - 3*s + 2) - 4*Pk2*k2**2*k3**2*(3*r**2 - 24*r + 8) - Pk2*k3**4*(7*f*(36*r**2 + 15*r*s + r + s - 3) + 48*r**2 - 84*r*s - 6*r + 42*s + 2) + 21*Pkd2*k2**3*k3**2*s*(1 - 2*r) + 7*Pkd2*k2*k3**4*(-4*f*s + r*(21*f*s - 2*f - 6*s + 3) + 3*s - 1))) + 28*f**2*k3**6*(-4*Pk2*k1**2*s*(5*r + 12*s - 6) + Pkd2*k1**2*k2*s*(5*r + 24*s - 12) + 2*Pkd2*k2**3*r*(5*s - 2) + k2**2*(-4*Pk2*r*(12*r + 5*s - 6) + 2*Pkdd2*k1**2*s*(1 - 2*s))) + f*(28*k1**6*(2*Pk2*k2**2*(33*r**2 + 6*r*(11*s - 7) + 33*s**2 - 42*s + 14) + 4*Pk2*k3**2*(3*s - 1)*(2*r + 2*s - 1) - Pkd2*k2*k3**2*(3*s - 1)*(2*r + 2*s - 1)) + k1**4*(8*Pk2*k2**4*(837*r**2 + 22*r*(78*s - 49) + 858*s**2 - 1092*s + 357) + 4*Pk2*k3**4*(-111*s**2 + s*(86 - 168*r) + 35) - 4*Pkd2*k2**3*k3**2*(3*r*(143*s - 47) + 429*s**2 - 414*s + 94) + 14*Pkd2*k2*k3**4*(-39*s**2 + s*(12*r + 29) - 10) + k2**2*(2*Pk2*k3**2*(-528*r**2 - 306*r*s + 410*r + 327*s**2 - 132*s + 45) + Pkdd2*k3**4*(219*s**2 - 164*s + 35))) + k1**2*k2**2*(56*Pk2*k2**4*(30*r**2 + r*(66*s - 40) + 33*s**2 - 42*s + 13) + 2*Pk2*k3**4*(21*cosphi**2*(3*r**2 - 2*r + 1) - 399*r**2 - 1380*r*s + 632*r - 21*s**2 + 362*s - 74) - 28*Pkd2*k2**3*k3**2*(r*(27*s - 13) + 27*s**2 - 31*s + 9) - 2*Pkd2*k2*k3**4*(42*r + 15*s**2 - 49*s + 16) + k2**2*(-2*Pk2*k3**2*(28*cosphi**2*(3*r - 1)*(2*r + 2*s - 1) - 1152*r**2 - 774*r*s + 986*r + 285*s**2 + 96*s - 257) + 7*Pkdd2*k3**4*(21*s**2 - 20*s + 5))) - 2*k2**4*k3**2*(Pk2*k2**2*(28*cosphi**2 - 56)*(3*r - 1)*(2*r + 2*s - 1) + Pk2*k3**2*(cosphi**2*(-255*r**2 - 168*r*s + 190*r + 56*s - 49) - 9*r**2 + 12*r*(49*s + 16) - 217) + 28*Pkd2*k2*k3**2*(3*r - 1)*(2*s - 1))) + 112*g2*k3**6*(4*Pk2*k2**2*(3*r**2 - 3*r + 1) + k1**2*(4*Pk2 - Pkd2*k2)*(3*s**2 - 3*s + 1)))/(7*d**2*k1**2*k2**2*k3**6) - 4*D1**4*Pk1*ct*f**2*mu*mu2**5*(b1*(14*k1**4*(16*Pk2*k2**4*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) + 24*Pk2*k3**4*(3*s**2 - 3*s + 1) - 3*Pkd2*k2**3*k3**2*(r*(6*s - 3) + 6*s**2 - 6*s + 2) - 9*Pkd2*k2*k3**4*(3*s**2 - 3*s + 1) + k2**2*(12*Pk2*k3**2*(6*r*s - 3*r + 6*s**2 - 6*s + 2) + Pkdd2*k3**4*(3*s**2 - 3*s + 1))) + k1**2*(504*Pk2*f*k3**6*s*(1 - 3*s) + 224*Pk2*k2**6*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) + 189*Pkd2*f*k2*k3**6*s*(3*s - 1) - 42*Pkd2*k2**5*k3**2*(r*(6*s - 3) + 6*s**2 - 6*s + 2) + 2*Pkd2*k2**3*k3**4*(96*r*s - 48*r - 57*s**2 + 57*s - 19) + 2*k2**4*(-2*Pk2*k3**2*(144*r**2 + 66*r*s - 33*r - 78*s**2 + 78*s - 26) + 7*Pkdd2*k3**4*(3*s**2 - 3*s + 1)) + k2**2*(-16*Pk2*k3**4*(48*r*s - 24*r + 3*s**2 - 3*s + 1) + 21*Pkdd2*f*k3**6*s*(1 - 3*s))) + 3*k2**2*k3**2*r*(28*Pk2*f*k3**4*(2 - 7*s) + 28*Pk2*k2**4*(2*r + 2*s - 1) - 4*Pk2*k2**2*k3**2*(16*r - 14*s + 7) + 7*Pkd2*f*k2*k3**4*(7*s - 2) + 14*Pkd2*k2**3*k3**2*(1 - 2*s))) + f*k2**2*(-14*k1**4*(r + s - 1)*(4*Pk2*k2**2*(3*r + 3*s - 2) + 4*Pk2*k3**2*(3*s - 1) + Pkd2*k2*k3**2*(1 - 3*s)) + k1**2*(-104*Pk2*k2**4*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 4*Pk2*k3**4*(12*s**2 + s*(42*r - 32) + 7) + 2*Pkd2*k2**3*k3**2*(r*(57*s - 13) + 57*s**2 - 64*s + 13) + 7*Pkd2*k2*k3**4*(6*s**2 + s*(2 - 6*r) - 1) + k2**2*(2*Pk2*k3**2*(153*r**2 + 4*r*(27*s - 41) - 66*s**2 + 24*s + 18) + 6*Pkdd2*k3**4*s*(1 - 3*s))) - k3**2*(28*Pk2*f*k3**4*s*(2 - 3*r) - 14*Pk2*k2**4*(9*r**2 + 4*r*(3*s - 2) - 2*s) + 2*Pk2*k2**2*k3**2*(48*r**2 + 28*r*(3*s - 2) - 42*s + 5) + 7*Pkd2*f*k2*k3**4*s*(3*r - 2) + 7*Pkd2*k2**3*k3**2*(2*r + 2*s - 1))))/(7*d**2*k1**2*k2**2*k3**6) - D1**4*Pk1*ct*f**2*mu**4*mu2**2*(2*b1*(112*Pk2*k1**8*k2**2*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) + 336*Pk2*k2**4*k3**4*(k2**2*(3*r**2 - 3*r + 1) + k3**2*(r**2*(3 - 9*f) + r*(3*f - 3) + 1)) + 2*k1**6*(392*Pk2*k2**4*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) + 168*Pk2*k3**4*s**2 - 126*Pkd2*k2**3*k3**2*s*(2*r + 2*s - 1) - 105*Pkd2*k2*k3**4*s**2 + k2**2*(4*Pk2*k3**2*(78*r*s + 24*r + 78*s**2 - 15*s - 16) + 21*Pkdd2*k3**4*s**2)) + k1**4*(-56*Pk2*f*k3**6*(51*s**2 - 36*s + 8) + 672*Pk2*k2**6*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) + 7*Pkd2*f*k2*k3**6*(147*s**2 - 72*s + 16) - 252*Pkd2*k2**5*k3**2*s*(2*r + 2*s - 1) + 18*Pkd2*k2**3*k3**4*s*(-8*r + 19*s + 4) + 6*k2**4*(4*Pk2*k3**2*(8*r**2 - 40*r*s - r - 48*s**2 + 27*s - 2) + 7*Pkdd2*k3**4*s**2) - 3*k2**2*(16*Pk2*k3**4*(2*r*(s - 2) + s*(16*s + 3)) + 35*Pkdd2*f*k3**6*s**2)) + 4*k1**2*k2**2*k3**2*(84*Pk2*k2**4*(6*r**2 + 6*r*(s - 1) - 3*s + 2) - 4*Pk2*k2**2*k3**2*(54*r**2 + r*(48*s - 75) - 24*s + 25) - 2*Pk2*k3**4*(7*f*(18*r**2 + 27*r*s + 6*r + 18*s**2 - 12*s - 2) - 42*r**2 + 48*r*s + 18*r - 24*s - 6) + 7*Pkd2*f*k2*k3**4*(r*(63*s - 3) + 18*s**2 - 24*s + 2) - 84*Pkd2*k2**3*k3**2*s*(2*r - 1))) + k1**2*(-448*Pk2*g2*k2**2*k3**6*(r*(6*s - 3) - 3*s + 1) - 7*f**2*k3**6*(20*Pk2*k1**2*s*(4 - 9*s) + 10*Pkd2*k1**2*k2*s*(9*s - 5) + 48*Pkd2*k2**3*r*(2*s - 1) + k2**2*(-12*Pk2*r*(15*r + 16*s - 12) + 5*Pkdd2*k1**2*s*(2 - 3*s))) - f*(56*Pk2*k1**6*k2**2*(27*r**2 + r*(54*s - 32) + 27*s**2 - 32*s + 10) + k1**4*(8*Pk2*k2**4*(993*r**2 + 6*r*(338*s - 223) + 1014*s**2 - 1352*s + 461) - 28*Pk2*k3**4*(9*s**2 + 10*s - 9) - 12*Pkd2*k2**3*k3**2*(r*(119*s - 55) + 119*s**2 - 143*s + 41) - 28*Pkd2*k2*k3**4*(9*s**2 - 16*s + 6) + k2**2*k3**2*(-4*Pk2*r*(117*s + 5) - 6*Pk2*(71*s**2 + 40*s - 55) + 7*Pkdd2*k3**2*(15*s**2 - 18*s + 5))) + k1**2*k2**2*(56*Pk2*k2**4*(48*r**2 + 2*r*(51*s - 35) + 51*s**2 - 72*s + 25) + 2*Pk2*k3**4*(42*cosphi**2*(3*r**2 - 2*r - 24*s**2 + 20*s - 3) - 252*r**2 - 1920*r*s + 936*r + 303*s**2 - 170*s + 5) - 84*Pkd2*k2**3*k3**2*(r*(11*s - 7) + 11*s**2 - 15*s + 5) + 4*Pkd2*k2*k3**4*(21*cosphi**2*(6*s**2 - 5*s + 1) - 132*r*s + 30*r - 30*s**2 + 106*s - 35) + k2**2*(-2*Pk2*k3**2*(84*cosphi**2*(9*r**2 + 15*r*s - 11*r + 6*s**2 - 8*s + 3) - 2100*r**2 - 1638*r*s + 1866*r + 489*s**2 + 200*s - 389) + 7*Pkdd2*k3**4*(15*s**2 - 18*s + 5))) + 4*k2**4*k3**2*(-14*Pk2*k2**2*(3*cosphi**2*(9*r**2 + r*(15*s - 11) + 6*s**2 - 8*s + 3) + (4 - 12*r)*(3*r + 3*s - 2)) + Pk2*k3**2*(3*cosphi**2*(165*r**2 + 2*r*(111*s - 89) - 84*s**2 + 28*s + 21) + 108*r**2 + r*(76 - 756*s) + 84) + 7*Pkd2*k2*k3**2*(3*cosphi**2*(6*s**2 - 5*s + 1) + 4*r*(6 - 9*s) + 12*s - 8)))))/(7*d**2*k1**3*k2**3*k3**6) - D1**4*Pk1*ct*f**2*mu**2*mu2**4*(2*b1*(168*Pk2*k2**4*k3**4*r**2*(-5*f*k3**2 + 2*k2**2) + 14*k1**6*(48*Pk2*k2**4*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) + 24*Pk2*k3**4*(3*s**2 - 3*s + 1) - 6*Pkd2*k2**3*k3**2*(r*(6*s - 3) + 6*s**2 - 6*s + 2) - 9*Pkd2*k2*k3**4*(3*s**2 - 3*s + 1) + k2**2*(24*Pk2*k3**2*(6*r*s - 3*r + 6*s**2 - 6*s + 2) + Pkdd2*k3**4*(3*s**2 - 3*s + 1))) + 2*k1**4*(392*Pk2*k2**6*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) - 168*Pk2*k3**6*(s**2*(9*f - 3) - s*(3*f - 3) - 1) - 42*Pkd2*k2**5*k3**2*(r*(8*s - 3) + 8*s**2 - 7*s + 2) + Pkd2*k2**3*k3**4*(48*r*(2*s - 1) - 18*s**2 - 87*s + 29) + 63*Pkd2*k2*k3**6*(s**2*(9*f - 3) - s*(3*f - 3) - 1) + k2**4*(-12*Pk2*k3**2*(48*r**2 + 40*r*s - 27*r - 8*s**2 + s + 2) + 7*Pkdd2*k3**4*(6*s**2 - 3*s + 1)) + k2**2*(-8*Pk2*k3**4*(24*r*(2*s - 1) + 54*s**2 - 75*s + 25) + 7*Pkdd2*k3**6*(s**2*(3 - 9*f) + s*(3*f - 3) + 1))) + k1**2*k2**2*(112*Pk2*k2**6*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) - 8*Pk2*k3**6*(7*f*(63*r*s - 15*r + 78*s**2 - 50*s + 8) + 48*r*s - 24*r - 42*s**2 + 18*s - 6) - 84*Pkd2*k2**5*k3**2*s*(2*r + 2*s - 1) - 6*Pkd2*k2**3*k3**4*(4*r*(6*s - 7) + s*(7*s + 16)) + Pkd2*k2*k3**6*(7*f*(6*r*(21*s - 5) + 210*s**2 - 109*s + 16) + 48*r*(2*s - 1) - 210*s**2 + 162*s - 54) + 2*k2**4*(4*Pk2*k3**2*(78*r**2 + 78*r*s - 15*r + 24*s - 16) + 21*Pkdd2*k3**4*s**2) + k2**2*(-48*Pk2*k3**4*(16*r**2 + r*(2*s + 3) - 4*s) - 7*Pkdd2*k3**6*(s**2*(18*f - 6) - s*(3*f - 6) - 2)))) + k2**2*(7*f**2*k3**6*(12*Pk2*k1**2*s*(16*r + 15*s - 12) - 6*Pkd2*k1**2*k2*s*(8*r + 15*s - 9) + k2**2*(20*Pk2*r*(9*r - 4) + 3*Pkdd2*k1**2*s*(5*s - 2))) + f*(-14*Pk2*k2**4*k3**4*(cosphi**2*(3*r**2 - 2*r + 1) - 30*r**2 - 44*r + 30) - 56*k1**6*(Pk2*k2**2*(51*r**2 + 6*r*(17*s - 12) + 51*s**2 - 72*s + 26) + 4*Pk2*k3**2*(3*s - 1)*(3*r + 3*s - 2) - Pkd2*k2*k3**2*(3*s - 1)*(3*r + 3*s - 2)) + k1**4*(-8*Pk2*k2**4*(993*r**2 + 6*r*(338*s - 223) + 1014*s**2 - 1352*s + 461) + 4*Pk2*k3**4*(291*s**2 + s*(504*r - 398) + 21) + 4*Pkd2*k2**3*k3**2*(r*(657*s - 185) + 657*s**2 - 597*s + 119) + 28*Pkd2*k2*k3**4*(33*s**2 - s*(18*r + 10) + 3) + k2**2*(2*Pk2*k3**2*(1752*r**2 + 978*r*s - 1486*r - 1047*s**2 + 184*s + 119) + Pkdd2*k3**4*(-405*s**2 + 226*s - 35))) + k1**2*k2**2*(-56*Pk2*k2**4*(24*r**2 + 6*r*(9*s - 5) + 27*s**2 - 32*s + 9) + 2*Pk2*k3**4*(-7*cosphi**2*(3*r**2 - 2*r + 1) + 174*r**2 + 180*r*s + 44*r + 525*s**2 - 542*s + 89) + 28*Pkd2*k2**3*k3**2*(r*(27*s - 11) + 27*s**2 - 27*s + 7) - 8*Pkd2*k2*k3**4*(r*(45*s - 8) + 42*s**2 - 32*s + 1) + k2**2*(2*Pk2*k3**2*(12*r**2 + 834*r*s - 14*r + 525*s**2 - 456*s - 129) - 7*Pkdd2*k3**4*(27*s**2 - 22*s + 5)))) - 112*g2*k1**2*k3**6*(4*Pk2 - Pkd2*k2)*(r*(6*s - 3) - 3*s + 1)))/(7*d**2*k1**3*k2**3*k3**6) + 2*D1**4*Pk1*ct*f*mu**3*mu2*(4*b1**2*(-4*Pk2*k1**2*k3**2*s*(7*k1**4*(r + s) - 8*k1**2*k3**2*s + k3**4*(7*r - 4*s - 7)) - 28*Pk2*k2**4*(4*k1**4*(r + s)**2 + 3*k1**2*k3**2*r*(r + s) + 2*k3**4*r**2) + 16*Pk2*k2**2*(-7*k1**6*(r + s)**2 + 2*k1**4*k3**2*(r**2 + 4*r*s + 3*s**2) + 2*k1**2*k3**4*r*(r + 2*s) + 2*k3**6*(r - 1)**2) - 2*Pkd2*k1**2*k2*k3**2*s*(-7*k1**4*(r + s) + 8*k1**2*k3**2*s + k3**4*(-7*r + 4*s + 7)) + 14*Pkd2*k2**3*k3**2*s*(k1**4*(r + s) + k1**2*k3**2*r + 2*k3**4*(r - 1)) + 7*f*k3**6*(k1**2*(Pk2*(16*s**2 + s*(8*r - 7) + 2) + k2*(-Pkd2*(10*r*s + 10*s**2 - 5*s + 1) + 2*Pkdd2*k2*s**2)) + 2*k2**2*(Pk2*(16*r**2 - 6*r*s - 2*r + 3*s) + Pkd2*k2*s*(2 - 5*r)))) - 2*b1*(14*f**2*k3**6*(k1**2*(2*Pk2*(r*(8*s - 2) + s*(3*s - 2)) + k2*(Pkd2*r*(2 - 8*s) + 3*Pkd2*s*(1 - 2*s) + Pkdd2*k2*s*(3*s - 1))) + 2*k2**2*r*(6*Pk2*(3*r - 1) + Pkd2*k2*(1 - 3*s))) - f*(2*k1**6*(2*Pk2*k2**2*(206*r**2 + r*(412*s - 246) + 206*s**2 - 246*s + 75) + 7*Pk2*k3**2*(r*(8*s - 1) + s*(8*s - 3)) - 7*Pkd2*k2*k3**2*(3*s - 1)*(2*r + 2*s - 1)) + k1**4*(4*Pk2*k2**4*(430*r**2 + r*(888*s - 418) + 444*s**2 - 432*s + 111) - 2*Pk2*k3**4*(28*cosphi**2*(6*s**2 - 7*s + 2) + r*(70*s - 7) + 105*s**2 - 8*s - 4) - 2*Pkd2*k2**3*k3**2*(2*r*(103*s - 7) + 206*s**2 - 104*s + 7) + 2*Pkd2*k2*k3**4*(7*cosphi**2*(6*s**2 - 7*s + 2) + 38*s**2 + s*(28*r - 20) + 2) + k2**2*k3**2*(-2*Pk2*(14*cosphi**2*(2*r**2 + r*(8*s - 5) + 6*s**2 - 7*s + 2) + 110*r**2 + 14*r*(39*s - 8) + 401*s**2 - 323*s + 6) + 45*Pkdd2*k3**2*s**2)) + k1**2*(56*Pk2*k2**6*(4*r**2 + 2*r*(5*s - 1) + s*(5*s - 3)) + Pk2*k2**2*k3**4*(cosphi**2*(106*r**2 + 2*r*(152*s - 97) - 168*s**2 + 168*s - 35) - 206*r**2 + r*(142 - 968*s) + 32*s**2 + 400*s - 1) + 2*Pk2*k3**6*(32*s**2 - s*(14*r + 66) + 23) - 14*Pkd2*k2**5*k3**2*s*(8*r + 8*s - 3) + 2*Pkd2*k2**3*k3**4*(7*cosphi**2*(6*s**2 - 7*s + 2) + r*(14 - 40*s) + 15*s*(4*s + 1)) - 2*Pkd2*k2*k3**6*(s - 1)*(14*r + 12*s - 13) + k2**4*k3**2*(-2*Pk2*(28*cosphi**2*(2*r**2 + 5*r*s - 3*r + 3*s**2 - 4*s + 1) - 402*r**2 - 174*r*s + 411*r + 197*s**2 + 106*s - 130) + 21*Pkdd2*k3**2*s**2)) + k2**2*k3**2*(-Pk2*k2**4*(28*cosphi**2 - 56)*(r + s)*(2*r - 1) + Pk2*k2**2*k3**2*(cosphi**2*(106*r**2 + 2*r*(56*s - 37) - 56*s + 21) + 374*r**2 - 12*r*(21*s + 43) + 56*s + 245) + 2*Pk2*k3**4*(2*cosphi**2*(2*r - 1)*(4*r + 7*s - 7) + 48*r**2 + r*(25 - 70*s) - 14) + 28*Pkd2*k2**3*k3**2*s*(1 - 2*r) - 28*Pkd2*k2*k3**4*(2*r - 1)*(s - 1))) + 56*g2*k3**6*(-2*Pk2*k1**2*s**2 - 4*Pk2*k2**2*(r - 1)**2 + Pkd2*k1**2*k2*s**2)) + f*(f*(252*Pk2*k2**4*k3**4*r**2 - 4*k1**6*(52*Pk2*k2**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 7*Pk2*k3**2*(1 - 2*r) - 7*Pkd2*k2*k3**2*(s - 1)*(2*r + 2*s - 1)) + k1**4*(-8*Pk2*k2**4*(109*r**2 + 2*r*(109*s - 77) + 109*s**2 - 154*s + 45) + 2*Pk2*k3**4*(56*cosphi**2*(9*s**2 - 9*s + 2) - 13*s**2 + s*(112*r + 14) - 7) + 4*Pkd2*k2**3*k3**2*(r*(77*s - 52) + 77*s**2 - 103*s + 26) - 2*Pkd2*k2*k3**4*(14*cosphi**2*(9*s**2 - 9*s + 2) + 28*r*s - 13*s**2 + s - 7) + k2**2*k3**2*(2*Pk2*(28*cosphi**2*(6*r**2 + r*(15*s - 11) + 9*s**2 - 11*s + 4) + 159*r**2 + 26*r*(9*s - 5) + 75*s**2 - 134*s + 7) + Pkdd2*k3**2*(-45*s**2 + 52*s - 7))) + k1**2*k2**2*(-56*Pk2*k2**4*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 2*Pk2*k3**4*(28*cosphi**2*s*(9*s - 7) + r**2*(71 - 192*cosphi**2) - 4*r*(2*cosphi**2*(57*s - 41) - 28*s + 7) + 14) + 28*Pkd2*k2**3*k3**2*(r*(3*s - 2) + 3*s**2 - 4*s + 1) - 2*Pkd2*k2*k3**4*(14*cosphi**2*(9*s**2 - 9*s + 2) + 12*r*s + 20*r + 21*s**2 - 21*s - 7) + k2**2*(2*Pk2*k3**2*(28*cosphi**2*(6*r**2 + 15*r*s - 11*r + 9*s**2 - 11*s + 4) + 87*r**2 + 150*r*s - 58*r + 63*s**2 - 70*s - 7) - 7*Pkdd2*k3**4*(3*s**2 - 4*s + 1)))) + 28*k3**6*(4*Pk2*b2*k2**2*r*(2*r - 1) + Pk2*g2*k2**2*r*(4*cosphi**2 - 16)*(2*r - 1) + b2*k1**2*(2*Pk2 - Pkd2*k2)*(2*s**2 - 3*s + 1) + 2*g2*k1**2*(Pk2*(-6*s**2 + 8*s - 3) + 2*Pkd2*k2*(2*s**2 - 3*s + 1)))))/(7*d**2*k1**2*k2**2*k3**6) + 2*D1**4*Pk1*ct*f*mu*mu2**3*(-2*b1**2*(14*k1**4*(16*Pk2*k2**4*(r + s)**2 + 8*Pk2*k3**4*s**2 - 6*Pkd2*k2**3*k3**2*s*(r + s) - 5*Pkd2*k2*k3**4*s**2 + k2**2*k3**2*s*(12*Pk2*(r + s) + Pkdd2*k3**2*s)) + k1**2*(224*Pk2*k2**6*(r + s)**2 - 4*k2**4*k3**2*(r + s)*(16*Pk2*(3*r + s) + 21*Pkd2*k2*s) + 2*k2**2*k3**4*s*(-32*Pk2*(2*r + s) + k2*(32*Pkd2*r + 9*Pkd2*s + 7*Pkdd2*k2*s)) + k3**6*(-8*Pk2*(7*f*(20*s**2 - 13*s + 3) + 8*(s - 1)**2) + k2*(7*Pkd2*f*(64*s**2 - 29*s + 6) + 16*Pkd2*(s - 1)**2 + 7*Pkdd2*f*k2*s*(1 - 8*s)))) + 4*k2**2*k3**2*r*(14*Pk2*k2**4*(r + s) - k2**2*k3**2*(16*Pk2*r + 7*Pkd2*k2*s) - k3**4*(2*Pk2*(14*f*s + 4*r - 7*s + 7) + 7*Pkd2*k2*(-5*f*s + f + s - 1)))) + b1*(14*f**2*k3**6*(24*Pk2*k1**2*s*(1 - 3*s) + 3*Pkd2*k1**2*k2*s*(12*s - 5) + 4*Pkd2*k2**3*(r*(4*s - 1) - s) + k2**2*(-4*Pk2*(3*r**2 + 8*r*s - 2*r - 2*s) + 3*Pkdd2*k1**2*s*(1 - 2*s))) + f*(28*k1**6*(2*Pk2*k2**2*(10*r**2 + r*(20*s - 6) + 10*s**2 - 6*s + 1) + 4*Pk2*k3**2*(r + s)*(2*s - 1) - Pkd2*k2*k3**2*(r + s)*(2*s - 1)) + k1**4*(16*Pk2*k2**4*(215*r**2 + 12*r*(37*s - 18) + 222*s**2 - 216*s + 59) + 4*Pk2*k3**4*(-28*r*(4*s - 1) + 26*s**2 - 48*s + 49) - 4*Pkd2*k2**3*k3**2*(r*(238*s - 107) + 238*s**2 - 233*s + 60) - 14*Pkd2*k2*k3**4*(r*(2 - 8*s) + 28*s**2 - 30*s + 11) + k2**2*(-2*Pk2*k3**2*(456*r**2 + 68*r*s - 430*s**2 + 492*s - 173) + Pkdd2*k3**4*(122*s**2 - 124*s + 35))) + k1**2*(8*Pk2*k2**6*(192*r**2 + r*(412*s - 246) + 206*s**2 - 246*s + 75) + 8*Pk2*k3**6*(24*s**2 + s*(9 - 28*r) - 7) - 8*Pkd2*k2**5*k3**2*(r*(82*s - 35) + 82*s**2 - 86*s + 21) + 2*Pkd2*k2**3*k3**4*(8*r*(35*s - 16) - 32*s**2 + 31*s - 27) + 14*Pkd2*k2*k3**6*(-12*s**2 + s*(4*r + 3) + 1) + k2**4*(-2*Pk2*k3**2*(708*r**2 + 988*r*s - 618*r + 170*s**2 - 254*s + 41) + Pkdd2*k3**4*(122*s**2 - 112*s + 35)) + 2*k2**2*(Pk2*k3**4*(-6*r**2 - 632*r*s + 284*r + 6*s**2 - 42*s + 19) + 10*Pkdd2*k3**6*s*(2*s - 1))) + 2*k2**2*k3**2*(14*Pk2*k2**4*(6*r**2 + r*(4*s - 3) + s + 1) - 2*Pk2*k2**2*k3**2*(141*r**2 + 84*r*s - 86*r + 28*s + 16) + 2*Pk2*k3**4*(r*(28*s - 34) - 21*s + 13) + 7*Pkd2*k2**3*k3**2*(r*(4 - 8*s) + s) + 7*Pkd2*k2*k3**4*(2*r + s - 1))) + 112*g2*k3**6*(2*Pk2*k2**2*r**2 + k1**2*(4*Pk2 - Pkd2*k2)*(s - 1)**2)) - f*(f*(56*Pk2*k1**6*k2**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + k1**4*(8*Pk2*k2**4*(109*r**2 + 2*r*(109*s - 77) + 109*s**2 - 154*s + 45) - 2*Pk2*k2**2*k3**2*(63*r**2 + 10*r*(15*s - 7) + 87*s**2 - 58*s - 7) - 252*Pk2*k3**4*s**2 - 4*Pkd2*k2**3*k3**2*(r*(32*s - 7) + 32*s**2 - 33*s + 7) + 63*Pkd2*k2*k3**4*s**2) + k1**2*k2**2*(208*Pk2*k2**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 2*Pk2*k3**4*(21*cosphi**2*(3*r**2 - 2*r + 1) - 112*r*s - 71*s**2 + 28*s - 14) - 4*Pkd2*k2**3*k3**2*(r*(38*s - 13) + 38*s**2 - 45*s + 13) + Pkd2*k2*k3**4*(79*s**2 + s*(56*r - 48) + 14) + 2*k2**2*(-Pk2*k3**2*(28*cosphi**2*(3*r - 1)*(2*r + 2*s - 1) + 75*r**2 + 234*r*s - 134*r + 159*s**2 - 130*s + 7) + 6*Pkdd2*k3**4*s*(2*s - 1))) + 2*k2**4*k3**2*(-14*Pk2*k2**2*(2*cosphi**2*(3*r - 1)*(2*r + 2*s - 1) + 2*s - 1) + Pk2*k3**2*(cosphi**2*(255*r**2 + 2*r*(84*s - 95) - 56*s + 49) + 13*r**2 - 14*r*(8*s + 1) + 7) + 7*Pkd2*k2*k3**2*(2*r + 2*s - 1))) - 14*k3**6*(b2*k1**2*s*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(2*s - 1) + 2*g2*(16*Pk2*k1**2*s*(1 - 2*s) + 7*Pkd2*k1**2*k2*s*(2*s - 1) + k2**2*(4*Pk2*(r - 1) + Pkdd2*k1**2*s*(1 - 2*s))))))/(7*d**2*k1**2*k2**2*k3**6) - 2*D1**4*Pk1*ct*f*mu*mu2*(14*b1**3*k3**6*s*(k1**2*(2*Pk2*(r - 2*s) + k2*s*(3*Pkd2 - Pkdd2*k2)) + k2**2*r*(4*Pk2 + 3*Pkd2*k2)) + b1**2*(-28*k1**6*(r + s)*(10*Pk2*k2**2*(r + s) + 2*Pk2*k3**2*s - Pkd2*k2*k3**2*s) + k1**4*(-8*Pk2*k2**4*(123*r**2 + 260*r*s + 130*s**2) + 2*Pk2*k3**4*s*(56*r + 39*s) + 260*Pkd2*k2**3*k3**2*s*(r + s) - 2*Pkd2*k2*k3**4*s*(28*r + 3*s) + k2**2*(Pk2*k3**2*(316*r**2 + 684*r*s + 326*s**2) - 33*Pkdd2*k3**4*s**2)) + k1**2*(-56*Pk2*k2**6*(4*r**2 + 10*r*s + 5*s**2) + 2*k2**4*k3**2*(Pk2*(98*r**2 + 294*r*s + 155*s**2) + 56*Pkd2*k2*s*(r + s)) - k2**2*k3**4*(-2*Pk2*(7*r**2 + 94*r*s - 16*s**2) + k2*s*(124*Pkd2*r + 78*Pkd2*s + 21*Pkdd2*k2*s)) + 2*k3**6*(2*Pk2*(7*r*(3*s - 1) + s**2*(28*f - 8) + 18*s - 16) + k2*(Pkd2*(7*f*s + s**2*(14 - 56*f) - s*(14*r + 10) + 12) + Pkdd2*k2*s*(7*f*(4*s - 1) - 10*s)))) + 2*k2**2*k3**2*(-28*Pk2*k2**4*r*(r + s) + k2**2*k3**2*r*(39*Pk2*r + 70*Pk2*s + 14*Pkd2*k2*s) + k3**4*(2*Pk2*(r**2*(28*f + 16) + r*(21*s - 37) + 8) - 7*Pkd2*k2*(-2*f*s + r*(9*f*s - 2*f - 2*s + 2))))) + b1*(f*(4*k1**6*(2*Pk2*k2**2*(47*r**2 + r*(94*s - 54) + 47*s**2 - 54*s + 7) + 7*Pk2*k3**2*(-r + s) - 7*Pkd2*k2*k3**2*(r + s)*(s - 1)) + k1**4*(16*Pk2*k2**4*(83*r**2 + 2*r*(83*s - 51) + 83*s**2 - 102*s + 19) - 4*Pk2*k3**4*(28*cosphi**2*(6*s**2 - 7*s + 2) + 28*r*s - 7*r + 23*s**2 + 14*s - 7) - 4*Pkd2*k2**3*k3**2*(r*(83*s - 39) + 83*s**2 - 90*s + 13) + Pkd2*k2*k3**4*(28*cosphi**2*(6*s**2 - 7*s + 2) + 56*r*s - 28*r + 29*s**2 + 36*s - 28) + k2**2*(-4*Pk2*k3**2*(14*cosphi**2*(2*r**2 + 8*r*s - 5*r + 6*s**2 - 7*s + 2) + 125*r**2 + 232*r*s - 89*r + 107*s**2 - 97*s - 13) + Pkdd2*k3**4*(33*s**2 - 40*s + 7))) + k1**2*(8*Pk2*k2**6*(47*r**2 + r*(94*s - 54) + 47*s**2 - 54*s + 7) + 2*Pk2*k3**6*(12*s**2 + s*(14 - 56*r) - 7) - 4*Pkd2*k2**5*k3**2*(2*r*(20*s - 7) + 40*s**2 - 41*s + 7) + Pkd2*k2**3*k3**4*(28*cosphi**2*(6*s**2 - 7*s + 2) + 8*r*(19*s - 8) + 7*s*(23*s - 10)) + 2*Pkd2*k2*k3**6*(-12*s**2 + s*(14*r - 5) + 7) + k2**4*k3**2*(-4*Pk2*(28*cosphi**2*(2*r**2 + 5*r*s - 3*r + 3*s**2 - 4*s + 1) + 107*r**2 + 232*r*s - 97*r + 125*s**2 - 89*s - 13) + Pkdd2*k3**2*(33*s**2 - 28*s + 7)) + 2*k2**2*k3**4*(Pk2*cosphi**2*(106*r**2 + 2*r*(152*s - 97) - 168*s**2 + 168*s - 35) + 2*Pk2*(8*r**2 - 28*r*s + 8*s**2 - 7) + 10*Pkdd2*k3**2*s*(s - 1))) - 2*k2**2*k3**2*(14*Pk2*k2**4*(4*cosphi**2*r**2 - 2*cosphi**2*s + r*(cosphi**2*(4*s - 2) - 1) + s) + Pk2*k2**2*k3**2*(cosphi**2*(-106*r**2 - 112*r*s + 74*r + 56*s - 21) + 46*r**2 + 28*r*(2*s + 1) - 14*s - 14) + Pk2*k3**4*(-4*cosphi**2*(2*r - 1)*(4*r + 7*s - 7) - 12*r**2 + 56*r*s - 14*r + 7) - 7*Pkd2*k2**3*k3**2*s - 7*Pkd2*k2*k3**4*(2*r + s - 1))) - 14*k3**6*(b2*k1**2*(4*Pk2*(s - 1)**2 + k2*(Pkd2*(-3*s**2 + 4*s - 2) + Pkdd2*k2*s**2)) - 2*g2*(4*Pk2*k2**2*(2*r**2 - 2*r + 1) + k1**2*(2*Pk2*(5*s**2 - 6*s + 3) + k2*(Pkd2*(-7*s**2 + 8*s - 4) + Pkdd2*k2*s**2))))) + 14*f*k3**6*(8*Pk2*cosphi**2*g2*k2**2*r*(2*r - 1) + b2*(2*Pk2*k1**2*s**2 + Pkd2*k1**2*k2*s*(1 - 2*s) + k2**2*(2*Pk2*r**2 + Pkdd2*k1**2*s*(s - 1))) - 2*g2*(4*Pk2*k1**2*s**2 + Pkd2*k1**2*k2*s*(3 - 4*s) + k2**2*(4*Pk2*r**2 + Pkdd2*k1**2*s*(s - 1)))))/(7*d**2*k1**2*k2**2*k3**6) - D1**4*Pk1*ct*f*mu**4*(8*b1**2*k2**2*(28*Pk2*k1**8*(r + s)**2 + 4*Pk2*k1**6*(r + s)*(7*k2**2*(r + s) - 8*k3**2*s) + 4*Pk2*k1**4*k3**2*r*(7*k2**2*(r + s) - 8*k3**2*s) - 42*Pk2*k2**2*k3**6*(r**2*(2*f - 2) - r*(f - 4) - 2) + k1**2*(28*Pk2*k2**2*k3**4*r**2 + k3**6*(Pk2*(14*f*r + r**2*(28 - 56*f) - 8*r*(4*s + 7) + 32*s + 28) + 35*Pkd2*f*k2*s*(2*r - 1)))) - b1*k1**2*(896*Pk2*g2*k2**2*k3**6*s*(r - 1) + 7*f**2*k3**6*(-10*Pk2*k1**2*s**2 + 10*Pkd2*k1**2*k2*s**2 + 8*Pkd2*k2**3*r*(3*s - 1) + k2**2*(4*Pk2*r*(4 - 15*r) - 5*Pkdd2*k1**2*s**2)) + 2*f*(28*Pk2*k1**6*k2**2*(18*r**2 + 18*r*(2*s - 1) + 18*s**2 - 18*s + 5) + k1**4*(4*Pk2*k2**4*(350*r**2 + r*(728*s - 298) + 364*s**2 - 312*s + 71) - 14*Pk2*k3**4*(4*cosphi**2*(2*s**2 - 3*s + 1) + 11*s**2) - 102*Pkd2*k2**3*k3**2*s*(2*r + 2*s - 1) + 14*Pkd2*k2*k3**4*(cosphi**2*(2*s**2 - 3*s + 1) + 5*s**2) + k2**2*(Pk2*k3**2*(-28*cosphi**2*(2*s - 1)*(r + s - 1) + 84*r**2 - 772*r*s - 84*r - 842*s**2 + 330*s + 56) + 7*Pkdd2*k3**4*s**2)) + k1**2*(-56*Pk2*cosphi**2*k3**6*(2*s**2 - 3*s + 1) + 56*Pk2*k2**6*(4*r**2 + 2*r*(5*s - 1) + s*(5*s - 3)) + 2*Pk2*k2**2*k3**4*(cosphi**2*(42*r**2 + 58*r*(2*s - 1) - 56*s**2 + 7) + 70*r**2 - 2*r*(188*s + 35) + 32*s**2 + 160*s + 42) + 14*Pkd2*cosphi**2*k2*k3**6*(2*s**2 - 3*s + 1) - 42*Pkd2*k2**5*k3**2*s*(2*r + 2*s - 1) + 2*Pkd2*k2**3*k3**4*(7*cosphi**2*(4*s**2 - 3*s + 1) + 9*s*(-8*r + 9*s + 4)) + k2**4*k3**2*(-2*Pk2*(14*cosphi**2*(6*r**2 + 10*r*s - 4*r + 4*s**2 - 6*s + 1) - 454*r**2 - 182*r*s + 410*r + 281*s**2 + 159*s - 110) + 7*Pkdd2*k3**2*s**2)) + 2*k2**2*k3**2*(2*Pk2*cosphi**2*k3**4*(2*s - 1)*(4*r - 7*s + 7) - 14*Pk2*k2**4*(r + s)*(cosphi**2*(6*r + 2*s - 3) - 8*r + 4) + Pk2*k2**2*k3**2*(cosphi**2*(138*r**2 + 10*r*(20*s - 9) - 84*s + 21) + 332*r**2 - 224*r*s - 348*r + 56*s + 140) + 7*Pkd2*cosphi**2*k2*k3**4*(2*s**2 - 3*s + 1) + 14*Pkd2*k2**3*k3**2*s*(cosphi**2*s - 4*r + 2)))) + f*k1**2*(112*Pk2*cosphi**2*g2*k2**2*k3**6*r*(1 - 2*s) + f*(-84*Pk2*k2**4*k3**4*r**2 + k1**4*(152*Pk2*k2**4*(r + s - 1)**2 - 14*Pk2*k3**4*(s - 1)*(8*cosphi**2*(3*s - 1) - s + 1) - 52*Pkd2*k2**3*k3**2*(s - 1)*(r + s - 1) + 14*Pkd2*k2*k3**4*(s - 1)*(cosphi**2*(6*s - 2) - s + 1) + 7*k2**2*k3**2*(-2*Pk2*(r + s - 1)*(4*cosphi**2*(3*s - 1) + 3*r - s + 1) + Pkdd2*k3**2*(s - 1)**2)) + k1**2*k2**2*(56*Pk2*k2**4*(r + s - 1)**2 + 2*Pk2*k3**4*(4*cosphi**2*(3*s - 1)*(8*r - 7*s + 7) - 21*r**2) - 28*Pkd2*k2**3*k3**2*(s - 1)*(r + s - 1) + 2*Pkd2*k2*k3**4*(s - 1)*(14*cosphi**2*(3*s - 1) + 4*r + 7*s - 7) + k2**2*k3**2*(-2*Pk2*(r + s - 1)*(28*cosphi**2*(3*s - 1) + 29*r + 21*s - 21) + 7*Pkdd2*k3**2*(s - 1)**2)))))/(7*d**2*k1**3*k2**3*k3**6) + D1**4*Pk1*ct*f*mu**2*mu2**2*(4*b1**2*(-56*Pk2*k2**4*k3**4*r**2*(k2**2 + k3**2) + 7*f*k3**6*(48*Pk2*k2**4*r**2 + 2*k1**4*(4*Pk2*(12*s**2 - 7*s + 2) + k2*(Pkd2*(-21*s**2 + 7*s - 2) + 3*Pkdd2*k2*s**2)) + k1**2*k2**2*(2*Pk2*(r*(8*s + 5) + 24*s**2 - 13*s + 4) + k2*(Pkd2*(-40*r*s + 3*r - 27*s**2 + 17*s - 4) + 3*Pkdd2*k2*s**2))) - 7*k1**6*(48*Pk2*k2**4*(r + s)**2 + 8*Pk2*k3**4*s**2 - 12*Pkd2*k2**3*k3**2*s*(r + s) - 5*Pkd2*k2*k3**4*s**2 + k2**2*k3**2*s*(24*Pk2*(r + s) + Pkdd2*k3**2*s)) + k1**4*(-336*Pk2*k2**6*(r + s)**2 - 56*Pk2*k3**6*s**2 + 84*Pkd2*k2**5*k3**2*s*(r + s) - Pkd2*k2**3*k3**4*s*(32*r + 57*s) + 35*Pkd2*k2*k3**6*s**2 + k2**4*k3**2*(192*Pk2*(r + s)**2 - 7*Pkdd2*k3**2*s**2) + k2**2*k3**4*s*(64*Pk2*(r + 2*s) - 7*Pkdd2*k3**2*s)) + k1**2*k2**2*k3**2*(-168*Pk2*k2**4*r*(r + s) + 8*k2**2*k3**2*r*(8*Pk2*(2*r + s) + 7*Pkd2*k2*s) + k3**4*(32*Pk2*(r*(2*s - 1) - s) + k2*s*(Pkd2*(-16*r + 7*s + 16) - 7*Pkdd2*k2*s)))) + b1*(-42*f**2*k3**6*(4*Pk2*k2**4*r*(9*r - 4) + k1**4*s*(4*Pk2*(9*s - 4) + k2*(-2*Pkd2*(9*s - 5) + Pkdd2*k2*(3*s - 2))) + k1**2*k2**2*(6*Pk2*(r**2 + r*(8*s - 2) + s*(s - 2)) + k2*(Pkd2*r*(6 - 24*s) + Pkd2*s*(7 - 6*s) + Pkdd2*k2*s*(3*s - 1)))) + f*(56*Pk2*k1**8*k2**2*(10*r**2 + r*(20*s - 6) + 10*s**2 - 6*s + 1) + 14*Pk2*k2**4*k3**4*(k2**2 + k3**2)*(cosphi**2*(2*r**2 - 2*r + 1) + 20*r**2 - 52*r + 30) + k1**6*(8*Pk2*k2**4*(796*r**2 + 54*r*(30*s - 17) + 810*s**2 - 918*s + 273) + 28*Pk2*k3**4*(6*s**2 - 14*s + 9) - 4*Pkd2*k2**3*k3**2*(r*(298*s - 123) + 298*s**2 - 312*s + 81) - 28*Pkd2*k2*k3**4*(9*s**2 - 14*s + 6) + k2**2*(2*Pk2*k3**2*(-308*r**2 + 116*r*s + 38*r + 438*s**2 - 538*s + 201) + 7*Pkdd2*k3**4*(10*s**2 - 14*s + 5))) + k1**4*(16*Pk2*k2**6*(391*r**2 + r*(810*s - 452) + 405*s**2 - 459*s + 133) + 28*Pk2*k3**6*(6*s**2 - 14*s + 9) - 4*Pkd2*k2**5*k3**2*(r*(512*s - 105) + 512*s**2 - 375*s + 63) + 4*Pkd2*k2**3*k3**4*(21*cosphi**2*(1 - 2*s)**2 + 164*r*s - 56*r + 26*s**2 + 7*s - 23) - 28*Pkd2*k2*k3**6*(9*s**2 - 14*s + 6) + k2**4*(-2*Pk2*k3**2*(28*cosphi**2*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) + 1272*r**2 + 2528*r*s - 1262*r + 1044*s**2 - 1308*s + 127) + Pkdd2*k3**4*(284*s**2 - 98*s + 35)) + k2**2*(2*Pk2*k3**4*(14*cosphi**2*(r**2 - 12*(1 - 2*s)**2) - 84*r**2 - 1016*r*s + 520*r - 196*s**2 - 270*s + 89) + 7*Pkdd2*k3**6*(10*s**2 - 14*s + 5))) + k1**2*k2**2*(112*Pk2*k2**6*(4*r**2 + 2*r*(5*s - 1) + s*(5*s - 3)) + 2*Pk2*k3**6*(7*cosphi**2*(2*r**2 - 2*r + 1) - 112*r**2 - 240*r*s + 356*r - 98*s**2 + 282*s - 141) - 28*Pkd2*k2**5*k3**2*s*(10*r + 10*s - 3) + 4*Pkd2*k2**3*k3**4*(21*cosphi**2*(1 - 2*s)**2 - 64*r*s + 56*r + 77*s**2 + s) + 4*Pkd2*k2*k3**6*(r*(2 - 60*s) + 7*s**2 + 18*s + 1) + 2*k2**4*(-2*Pk2*k3**2*(14*cosphi**2*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) - 358*r**2 - 70*r*s + 416*r + 189*s**2 + s - 164) + 35*Pkdd2*k3**4*s**2) + k2**2*k3**4*(2*Pk2*cosphi**2*(220*r**2 + 6*r*(92*s - 53) - 336*s**2 + 336*s - 77) - 4*Pk2*(400*r**2 + 20*r*(26*s - 17) - 108*s + 75) + 7*Pkdd2*k3**2*(10*s**2 - 14*s + 5)))) - 224*g2*k1**2*k2**2*k3**6*(2*Pk2*(-2*r*s + r + s) + Pkd2*k2*s*(r - 1))) + f*(-f*(56*Pk2*k1**8*k2**2*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1) - 504*Pk2*k2**6*k3**4*r**2 + 2*k1**6*(12*Pk2*k2**4*(116*r**2 + 2*r*(116*s - 71) + 116*s**2 - 142*s + 41) - 3*Pk2*k2**2*k3**2*(42*r**2 + 2*r*(50*s - 7) + 58*s**2 - 22*s - 21) - 252*Pk2*k3**4*s**2 - 2*Pkd2*k2**3*k3**2*(r*(99*s - 42) + 99*s**2 - 102*s + 28) + 63*Pkd2*k2*k3**4*s**2) + k1**4*k2**2*(24*Pk2*k2**4*(116*r**2 + 2*r*(116*s - 71) + 116*s**2 - 142*s + 41) + 6*Pk2*k3**4*(14*cosphi**2*(3*r**2 - 2*r - 24*s**2 + 20*s - 3) - 168*r*s - 40*s**2 + 14*s - 7) - 4*Pkd2*k2**3*k3**2*(3*r*(83*s - 39) + 249*s**2 - 270*s + 65) + 2*Pkd2*k2*k3**4*(42*cosphi**2*(6*s**2 - 5*s + 1) + 126*r*s + 57*s**2 - 60*s + 7) + k2**2*(-12*Pk2*k3**2*(14*cosphi**2*(9*r**2 + 15*r*s - 11*r + 6*s**2 - 8*s + 3) + 86*r**2 + 172*r*s - 88*r + 86*s**2 - 88*s + 7) + Pkdd2*k3**4*(150*s**2 - 114*s + 7))) + k1**2*k2**4*(56*Pk2*k2**4*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1) + 6*Pk2*k3**4*(2*cosphi**2*(165*r**2 + 2*r*(111*s - 89) - 84*s**2 + 28*s + 21) - 40*r**2 + r*(14 - 168*s) - 7) - 28*Pkd2*k2**3*k3**2*(r*(6*s - 3) + 6*s**2 - 6*s + 1) + 2*Pkd2*k2*k3**4*(42*cosphi**2*(6*s**2 - 5*s + 1) + 24*r*(s + 3) + 42*s**2 - 35) + k2**2*k3**2*(-6*Pk2*(28*cosphi**2*(9*r**2 + 15*r*s - 11*r + 6*s**2 - 8*s + 3) + 58*r**2 + 100*r*s - 22*r + 42*s**2 - 14*s - 21) + 7*Pkdd2*k3**2*(6*s**2 - 6*s + 1)))) - 28*k1**2*k2**2*k3**6*(-b2*(2*Pk2*(2*r*s + 5*r + s - 4) + Pkd2*k2*(-10*r*s + 3*r + 3*s)) - 4*g2*(Pk2*(-22*r*s + 3*r + 8*s + 3) + Pkd2*k2*(10*r*s - 5*r - 3*s + 1)))))/(7*d**2*k1**3*k2**3*k3**6) - D1**4*Pk1*ct*f*mu**2*(-28*b1**3*k2**3*k3**6*r*(4*Pk2*k2*r - 3*Pkd2*k1**2*s) + b1**2*(-280*Pk2*k1**8*k2**2*(r + s)**2 + 28*Pk2*k2**4*k3**6*(r**2*(9*f - 15) + r*(30 - 4*f) - 15) + 2*cosphi**2*k3**2*(-7*Pk2*k2**4*k3**4*(r - 1)**2 + 7*k1**4*(4*Pk2*k2**4*(r + s)**2 - k2**2*k3**2*(Pk2*(r**2 + 4*r*s - 4*s**2) + 2*Pkd2*k2*s**2) + 2*k3**4*(4*Pk2 - Pkd2*k2)*(s - 1)**2) + k1**2*k2**2*(28*Pk2*k2**4*(r + s)**2 - k2**2*k3**2*(Pk2*r*(39*r + 88*s) + 14*Pkd2*k2*s**2) + k3**4*(Pk2*(-7*r**2 - 16*r*s + 30*r + 28*s**2 - 56*s + 21) - 14*Pkd2*k2*(s - 1)**2))) + k1**6*(-8*Pk2*k2**4*(123*r**2 + 260*r*s + 130*s**2) + 70*Pk2*k3**4*s**2 + 156*Pkd2*k2**3*k3**2*s*(r + s) - 28*Pkd2*k2*k3**4*s**2 + k2**2*(Pk2*k3**2*(224*r**2 + 740*r*s + 502*s**2) - 7*Pkdd2*k3**4*s**2)) - k1**4*(56*Pk2*k2**6*(4*r**2 + 10*r*s + 5*s**2) + Pk2*k3**6*s**2*(-84*f - 70) - 84*Pkd2*k2**5*k3**2*s*(r + s) + 8*Pkd2*k2**3*k3**4*s*(4*r + 15*s) + Pkd2*k2*k3**6*s**2*(84*f + 28) + k2**4*(-2*Pk2*k3**2*(60*r**2 + 314*r*s + 239*s**2) + 7*Pkdd2*k3**4*s**2) + k2**2*(4*Pk2*k3**4*(7*r**2 - 16*r*s + 16*s**2) + Pkdd2*k3**6*s**2*(7 - 42*f))) + k1**2*k2**2*k3**2*(-112*Pk2*k2**4*r*(r + s) + 4*k2**2*k3**2*r*(11*Pk2*r + 56*Pk2*s + 14*Pkd2*k2*s) + k3**4*(12*Pk2*(r**2*(7*f - 7) + 2*r*(8*s + 7) - 16*s - 7) + k2*(7*f*(Pkd2*r*(4 - 40*s) + 6*Pkd2*s*(s + 2) + 3*Pkdd2*k2*s**2) + s*(8*Pkd2*(13*r - 7*s - 13) - 7*Pkdd2*k2*s))))) + b1*(f*(56*Pk2*k1**8*k2**2*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1) - 84*Pk2*k2**4*k3**4*r**2*(k2**2 + k3**2) + k1**6*(8*Pk2*k2**4*(211*r**2 + r*(422*s - 204) + 211*s**2 - 204*s + 38) - 14*Pk2*k3**4*(8*cosphi**2*(2*s**2 - 3*s + 1) + 17*s**2 + 2*s - 1) - 4*Pkd2*k2**3*k3**2*(r*(70*s - 13) + 70*s**2 - 58*s + 13) + 14*Pkd2*k2*k3**4*(cosphi**2*(4*s**2 - 6*s + 2) + 8*s**2 + 2*s - 1) + k2**2*k3**2*(-2*Pk2*(28*cosphi**2*(2*s - 1)*(r + s - 1) + 147*r**2 + 542*r*s - 140*r + 395*s**2 - 208*s - 14) + 7*Pkdd2*k3**2*(s - 1)**2)) + k1**4*(8*Pk2*k2**6*(104*r**2 + r*(208*s - 66) + 104*s**2 - 66*s + 7) - 14*Pk2*k3**6*(s - 1)*(8*cosphi**2*(2*s - 1) - s + 1) - 4*Pkd2*k2**5*k3**2*(r*(77*s - 7) + 77*s**2 - 40*s + 7) + 2*Pkd2*k2**3*k3**4*(14*cosphi**2*(4*s**2 - 3*s + 1) + 58*r*s - 16*r + 161*s**2 - 28*s + 7) + 14*Pkd2*k2*k3**6*(s - 1)*(cosphi**2*(4*s - 2) - s + 1) + k2**4*k3**2*(-4*Pk2*(14*cosphi**2*(6*r**2 + 10*r*s - 4*r + 4*s**2 - 6*s + 1) + 88*r**2 + 370*r*s - 90*r + 282*s**2 - 108*s - 19) + Pkdd2*k3**2*(50*s**2 - 14*s + 7)) + k2**2*k3**4*(4*Pk2*(cosphi**2*(42*r**2 + 58*r*(2*s - 1) - 56*s**2 + 7) - 42*r*s + 24*s**2 - 7) + 7*Pkdd2*k3**2*(s - 1)**2)) + k1**2*k2**2*(56*Pk2*k2**6*(r + s)**2 + 2*Pk2*k3**6*(4*cosphi**2*(2*s - 1)*(4*r - 7*s + 7) - 21*r**2) - 28*Pkd2*k2**5*k3**2*s*(r + s) + 2*Pkd2*k2**3*k3**4*s*(4*r + s*(28*cosphi**2 + 21) + 14) + 2*Pkd2*k2*k3**6*(s - 1)*(14*cosphi**2*(2*s - 1) - 12*r + 7*s - 7) + k2**4*k3**2*(-2*Pk2*(r**2*(168*cosphi**2 + 29) + r*(28*cosphi**2*(8*s - 3) + 78*s - 28) + 7*s*(4*cosphi**2*(2*s - 3) + 7*s + 4)) + 7*Pkdd2*k3**2*s**2) + k2**2*k3**4*(Pk2*(4*cosphi**2*(138*r**2 + 200*r*s - 90*r - 84*s + 21) - 24*r**2 - 320*r*s - 84*r + 42*s**2 + 56*s + 42) + 7*Pkdd2*k3**2*(s - 1)**2))) + 28*k1**2*k2**2*k3**6*(-4*Pk2*cosphi**2*g2*r*(s - 1) + s*(r - 1)*(24*Pk2*g2 + 3*Pkd2*b2*k2 - 8*Pkd2*g2*k2))) - 28*f*k1**2*k2**2*k3**6*r*(4*Pk2*cosphi**2*g2*(1 - 2*s) + Pkd2*k2*(b2 - 4*g2)*(s - 1)))/(7*d**2*k1**3*k2**3*k3**6) - D1**4*Pk1*ct*f*mu2**4*(-2*b1**2*k1**2*(-112*Pk2*k2**8*(r + s)**2 + 7*k1**2*(-16*Pk2*k2**6*(r + s)**2 + 8*k2**4*k3**2*s*(-2*Pk2 + Pkd2*k2)*(r + s) - 2*k2**2*k3**4*s**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + k3**6*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(s**2*(2*f - 2) - s*(f - 4) - 2)) + 8*k2**6*k3**2*(r + s)*(16*Pk2*r + 7*Pkd2*k2*s) - 2*k2**4*k3**4*s*(-64*Pk2*r + k2*(32*Pkd2*r - 7*Pkd2*s + 7*Pkdd2*k2*s)) + k2**2*k3**6*(8*Pk2*(16*r*(s - 1) + s**2*(28*f - 14) - s*(7*f - 28) - 14) + k2*(Pkd2*(-32*r*(s - 1) + 35*s**2*(2 - 4*f) + 35*s*(f - 4) + 70) + 7*Pkdd2*k2*(s**2*(4*f - 2) - s*(f - 4) - 2)))) + b1*k2**2*(7*f**2*k3**6*(4*Pk2*k1**2*s*(15*s - 4) + 10*Pkd2*k1**2*k2*s*(1 - 3*s) + k2**2*(10*Pk2*r**2 + Pkdd2*k1**2*s*(5*s - 2))) + f*(280*Pk2*k2**4*k3**4*r**2 - 56*k1**6*(Pk2*k2**2*(10*r**2 + r*(20*s - 6) + 10*s**2 - 6*s + 1) + 4*Pk2*k3**2*(r + s)*(2*s - 1) - Pkd2*k2*k3**2*(r + s)*(2*s - 1)) + k1**4*(-16*Pk2*k2**4*(175*r**2 + 52*r*(7*s - 3) + 182*s**2 - 156*s + 39) + 4*Pk2*k3**4*(56*r*(4*s - 1) + 46*s**2 - 30*s - 35) + 4*Pkd2*k2**3*k3**2*(r*(262*s - 119) + 262*s**2 - 224*s + 53) + 28*Pkd2*k2*k3**4*(r*(2 - 8*s) + 17*s**2 - 15*s + 5) + k2**2*(2*Pk2*k3**2*(660*r**2 + 140*r*s + 38*r - 590*s**2 + 502*s - 145) + Pkdd2*k3**4*(-174*s**2 + 150*s - 35))) + k1**2*k2**2*(-56*Pk2*k2**4*(16*r**2 + 18*r*(2*s - 1) + 18*s**2 - 18*s + 5) + 2*Pk2*k3**4*(-192*r**2 + 8*r*(25*s - 2) + 266*s**2 - 266*s + 35) + 28*Pkd2*k2**3*k3**2*(9*r*(2*s - 1) + 18*s**2 - 18*s + 5) - 4*Pkd2*k2*k3**4*(4*r*(43*s - 18) + s*(35*s - 35)) + k2**2*(2*Pk2*k3**2*(876*r**2 + 1276*r*s - 610*r + 266*s**2 - 266*s + 35) - 7*Pkdd2*k3**4*(18*s**2 - 18*s + 5)))) - 224*g2*k1**2*k3**6*r*(4*Pk2 - Pkd2*k2)*(s - 1)) + f**2*k2**2*(56*Pk2*k1**6*k2**2*(r + s - 1)**2 + 14*Pk2*k2**4*k3**4*(cosphi**2*(3*r**2 - 2*r + 1) + (r - 1)**2) + k1**4*(152*Pk2*k2**4*(r + s - 1)**2 - 2*Pk2*k2**2*k3**2*(21*r**2 + r*(50*s - 42) + 29*s**2 - 50*s + 21) - 84*Pk2*k3**4*s**2 - 24*Pkd2*k2**3*k3**2*s*(r + s - 1) + 21*Pkd2*k2*k3**4*s**2) + 7*k1**2*k2**2*k3**2*(2*Pk2*k2**2*(r**2 - 2*r*(s + 1) - 3*s**2 + 2*s + 1) + 2*Pk2*k3**2*(cosphi**2*(3*r**2 - 2*r + 1) - 3*s**2) + 3*Pkd2*k2*k3**2*s**2)))/(7*d**2*k1**3*k2**3*k3**6) - 4*D1**4*Pk1*f**4*mu**3*mu2**7*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(10*s**2 - 5*s + 1)/(d**2*k1*k2) + 16*D1**4*Pk1*f**4*mu**6*mu2**4*(-12*Pk2*k2**2*(10*r**2 - 5*r + 1) - k1**2*(4*Pk2 - Pkd2*k2)*(5*r*(4*s - 1) - 5*s + 1))/(d**2*k1**2*k2**2) - 8*D1**4*Pk1*f**4*mu**4*mu2**6*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(10*s**2 - 5*s + 1) - 2*k2**2*(-4*Pk2 + Pkd2*k2)*(5*r*(4*s - 1) - 5*s + 1))/(d**2*k1**2*k2**2) - 4*D1**4*Pk1*f**4*mu**5*mu2**5*(24*Pk2*k2**4*(10*r**2 - 5*r + 1) + k1**4*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(10*s**2 - 5*s + 1) - 8*k1**2*k2**2*(-4*Pk2 + Pkd2*k2)*(5*r*(4*s - 1) - 5*s + 1))/(d**2*k1**3*k2**3) - 4*D1**4*Pk1*f**3*mu**7*mu2*(24*Pk2*b1*k2**2*(6*r**2 - 4*r + 1) + cosphi**2*f*k1**2*(4*Pk2 - Pkd2*k2)*(12*s**2 - 11*s + 2))/(d**2*k1*k2**3) - 8*D1**4*Pk1*f**3*mu**6*mu2**2*(252*Pk2*b1*k2**2*k3**6*(6*r**2 - 4*r + 1) + Pk2*k1**6*(24*k2**2*(6*r**2 + 4*r*(3*s - 2) + 6*s**2 - 8*s + 3) - 7*k3**2*(4*r*(3*s - 1) + 3*(1 - 2*s)**2)) + Pk2*k1**4*k3**2*(k2**2*(144*r**2 + 4*r*(15*s - 29) - 84*s**2 + 36*s + 15) + k3**2*(r*(28 - 84*s) + 48*s**2 - 4*s + 1)) + k1**2*(2*Pk2*k2**2*k3**4*(72*r**2 - 4*r*(21*s + 5) + 28*s + 5) + 7*Pk2*k3**6*(16*b1*s*(3*r - 1) + f*(12*cosphi**2*(8*s**2 - 6*s + 1) - 24*r*s + 16*r + 9*s - 4)) - 7*Pkd2*k2*k3**6*(8*b1*s*(3*r - 1) + 3*cosphi**2*f*(8*s**2 - 6*s + 1) - f*(4*r - 1)*(3*s - 2))))/(7*d**2*k1**2*k2**2*k3**6) + 2*D1**4*Pk1*f**3*mu**4*mu2**4*(-2*k1**4*(288*Pk2*k2**4*(6*r**2 + 4*r*(3*s - 2) + 6*s**2 - 8*s + 3) - 4*Pk2*k3**4*(28*r*(3*s - 1) + 96*s**2 - 92*s + 23) - 36*Pkd2*k2**3*k3**2*(4*r*(3*s - 1) + 3*(1 - 2*s)**2) + Pkd2*k2*k3**4*(28*r*(3*s - 1) - 12*s**2 - 20*s + 5) + 6*k2**2*(-2*Pk2*k3**2*(42*r**2 + 4*r*(3*s - 8) - 30*s**2 + 16*s + 3) + Pkdd2*k3**4*(6*s**2 - 4*s + 1))) + k1**2*(-24*Pk2*k2**4*k3**2*(30*r**2 - 4*r*(3*s + 4) - 42*s**2 + 32*s - 3) - 28*Pk2*k3**6*(8*b1*(12*r*s - 4*r + 9*s**2 - 4*s + 1) + f*(-40*r*s + 15*r - 20*s**2 + 26*s - 15)) + 2*Pkd2*k2**3*k3**4*(68*r*(3*s - 1) - 168*s**2 + 44*s - 11) + 7*Pkd2*k2*k3**6*(2*b1*(48*r*s - 16*r + 90*s**2 - 28*s + 7) + f*(-40*r*s + 15*r - 128*s**2 + 104*s - 30)) + k2**2*(8*Pk2*k3**4*(60*r**2 + r*(12 - 156*s) + 60*s**2 + 12*s + 7) - 7*Pkdd2*k3**6*(b1*(36*s**2 - 8*s + 2) + f*(-36*s**2 + 26*s - 5)))) + 4*k2**2*k3**4*(2*Pk2*k2**2*(96*r**2 + r*(84*s - 92) - 28*s + 23) - 7*Pk2*k3**2*(8*b1*(9*r**2 + 4*r*(3*s - 1) - 4*s + 1) - f*(3*cosphi**2*(4*r**2 - 2*r + 1) + 120*r**2 + 20*r*(2*s - 5) - 15*s + 28)) + 7*Pkd2*k2*k3**2*(2*b1*(4*r*(6*s - 1) - 8*s + 1) - f*(4*r - 1)*(5*s - 2))))/(7*d**2*k1**2*k2**2*k3**6) - 2*D1**4*Pk1*f**3*mu**2*mu2**6*(2*k1**2*(504*Pk2*b1*k3**6*(6*s**2 - 4*s + 1) + 48*Pk2*k2**6*(6*r**2 + 4*r*(3*s - 2) + 6*s**2 - 8*s + 3) - 189*Pkd2*b1*k2*k3**6*(6*s**2 - 4*s + 1) - 12*Pkd2*k2**5*k3**2*(4*r*(3*s - 1) + 3*(1 - 2*s)**2) + Pkd2*k2**3*k3**4*(28*r*(3*s - 1) - 180*s**2 + 92*s - 23) + 2*k2**4*(Pk2*k3**2*(-84*r**2 + 60*r*s + 36*r + 144*s**2 - 116*s + 15) + 3*Pkdd2*k3**4*(6*s**2 - 4*s + 1)) + k2**2*(4*Pk2*k3**4*(r*(28 - 84*s) + 72*s**2 - 20*s + 5) + 21*Pkdd2*b1*k3**6*(6*s**2 - 4*s + 1))) + k2**2*k3**2*(-28*Pk2*k2**4*(12*r**2 + 12*r*(s - 1) - 4*s + 3) + 4*Pk2*k2**2*k3**2*(48*r**2 - 4*r*(21*s + 1) + 28*s + 1) + 28*Pk2*k3**4*(16*b1*r*(3*s - 1) + f*(-24*r*s + 9*r + 16*s - 4)) + 14*Pkd2*k2**3*k3**2*(4*r*(3*s - 1) - 4*s + 1) + 7*Pkd2*k2*k3**4*(16*b1*r*(1 - 3*s) + f*(24*r*s - 9*r - 16*s + 4))))/(7*d**2*k1**2*k2**2*k3**6) - D1**4*Pk1*f**3*mu**5*mu2**3*(1344*Pk2*b1*k2**4*k3**6*(6*r**2 - 4*r + 1) + 8*k1**6*(96*Pk2*k2**4*(6*r**2 + 4*r*(3*s - 2) + 6*s**2 - 8*s + 3) - 4*Pk2*k2**2*k3**2*(21*r**2 + 6*r*(8*s - 5) + 27*s**2 - 34*s + 12) - 28*Pk2*k3**4*(6*s**2 - 4*s + 1) - 6*Pkd2*k2**3*k3**2*(4*r*(3*s - 1) + 3*(1 - 2*s)**2) + 7*Pkd2*k2*k3**4*(6*s**2 - 4*s + 1)) + k1**4*(32*Pk2*k2**4*k3**2*(87*r**2 + 6*r*(4*s - 11) - 63*s**2 + 34*s + 6) + 28*Pk2*k3**6*(48*b1*s**2 + f*(-36*s**2 + 28*s - 13)) + 8*Pkd2*k2**3*k3**4*(r*(24 - 72*s) + 42*s**2 - 4*s + 1) + 28*Pkd2*k2*k3**6*(-30*b1*s**2 + f*(30*s**2 - 25*s + 7)) + k2**2*(-16*Pk2*k3**4*(42*r**2 - 4*r*(9*s + 4) - 6*s**2 + 16*s + 3) + 7*Pkdd2*k3**6*(24*b1*s**2 + f*(-28*s**2 + 24*s - 5)))) + 4*k1**2*k2**2*k3**4*(16*Pk2*k2**2*(15*r**2 + r*(4 - 42*s) + 14*s - 1) + 7*Pk2*k3**2*(16*b1*(6*r**2 + 2*r*(9*s - 2) - 6*s + 1) + f*(cosphi**2*(-20*r**2 + 10*r + 160*s**2 - 104*s + 11) - 152*r**2 - 128*r*s + 158*r + 48*s - 42)) - 14*Pkd2*k2*k3**2*(b1*(8*r*(9*s - 1) - 24*s + 2) + f*(cosphi**2*(20*s**2 - 13*s + 2) + (4 - 16*r)*(2*s - 1)))))/(7*d**2*k1**3*k2**3*k3**6) - D1**4*Pk1*f**3*mu**3*mu2**5*(-14*Pk2*k2**4*k3**4*(16*k2**2*(6*r**2 - 4*r + 1) + k3**2*(-96*b1*r**2 + 3*cosphi**2*f*(4*r**2 - 2*r + 1) + 4*f*(44*r**2 - 37*r + 11))) + 8*k1**4*(168*Pk2*b1*k3**6*(6*s**2 - 4*s + 1) + 96*Pk2*k2**6*(6*r**2 + 4*r*(3*s - 2) + 6*s**2 - 8*s + 3) - 63*Pkd2*b1*k2*k3**6*(6*s**2 - 4*s + 1) - 18*Pkd2*k2**5*k3**2*(4*r*(3*s - 1) + 3*(1 - 2*s)**2) + 2*Pkd2*k2**3*k3**4*(14*r*(3*s - 1) - 69*s**2 + 32*s - 8) + 2*k2**4*(-2*Pk2*k3**2*(63*r**2 - 24*r*s - 34*r - 87*s**2 + 66*s - 6) + 3*Pkdd2*k3**4*(6*s**2 - 4*s + 1)) + k2**2*(8*Pk2*k3**4*(r*(14 - 42*s) + 15*s**2 + 4*s - 1) + 7*Pkdd2*b1*k3**6*(6*s**2 - 4*s + 1))) + k1**2*k2**2*k3**2*(-32*Pk2*k2**4*(27*r**2 + 48*r*s - 34*r + 21*s**2 - 30*s + 12) + 28*Pk2*k3**4*(16*b1*(18*r*s - 6*r + 6*s**2 - 4*s + 1) + f*(-128*r*s + 48*r + 12*s**2 + 52*s - 25)) + 16*Pkd2*k2**3*k3**2*(r*(6*s - 2) + 21*s**2 - 16*s + 4) - 28*Pkd2*k2*k3**4*(b1*(72*r*s - 24*r + 60*s**2 - 28*s + 7) - 2*f*(16*r*s - 6*r + 15*s**2 - 17*s + 5)) + k2**2*(16*Pk2*k3**2*(6*r**2 + 4*r*(9*s - 4) - 42*s**2 + 16*s - 3) + 7*Pkdd2*k3**4*(4*b1*(12*s**2 - 4*s + 1) + f*(-44*s**2 + 28*s - 5)))))/(7*d**2*k1**3*k2**3*k3**6) - 4*D1**4*Pk1*f**2*mu**6*(168*Pk2*b1**2*k2**2*k3**6*(3*r**2 - 3*r + 1) + b1*k1**2*(7*Pk2*f*k3**6*(cosphi**2*(18*s**2 - s*(15*r + 3) + 2) + 2*s) + 6*Pk2*k1**4*(8*k2**2*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) - 7*k3**2*s*(2*r + 2*s - 1)) + 6*Pk2*k1**2*k3**2*(k2**2*(24*r**2 + 2*r*(5*s - 12) - 14*s**2 - 5*s + 8) + k3**2*s*(-14*r + 8*s + 7)) + 12*Pk2*k2**2*k3**4*(12*r**2 - 2*r*(7*s + 6) + 7*s + 4) - 7*Pkd2*f*k2*k3**6*(cosphi**2*(9*s**2 - 4*s + 1) + s*(2 - 6*r))) + cosphi**2*f*k1**2*k3**2*(3*s - 1)*(-7*Pk2*k2**2*k3**2*r + k1**2*(12*Pk2*k2**2*(r + s - 1) + Pk2*k3**2*(-7*r + 12*s - 12) - 6*Pkd2*k2*k3**2*(s - 1))))/(7*d**2*k1**2*k2**2*k3**6) - D1**4*Pk1*f**2*mu**4*mu2**2*(112*Pk2*k3**6*(2*b2*k2**2*(3*r**2 - 3*r + 1) + g2*k1**2*(3*s**2 - 3*s + 1) - 4*g2*k2**2*(3*r**2 - 3*r + 1)) - 28*b1**2*k3**6*(12*Pk2*k1**2*s*(1 - 4*r) + 3*Pkd2*k1**2*k2*s*(8*r + s - 2) + 12*Pkd2*k2**3*s*(2*r - 1) - k2**2*(8*Pk2*(12*r**2 - 3*r + 1) + 3*Pkdd2*k1**2*s**2)) + b1*(8*Pk2*k1**6*(24*k2**2*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) - 7*k3**2*(r*(6*s - 3) + 6*s**2 - 6*s + 2)) + 4*k1**4*(288*Pk2*k2**4*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) - 2*Pk2*k3**4*(60*s**2 + s*(42*r + 3) - 8) - 108*Pkd2*k2**3*k3**2*s*(2*r + 2*s - 1) + 3*Pkd2*k2*k3**4*s*(14*r + 22*s - 7) + 2*k2**2*(-7*Pk2*k3**2*(18*r**2 + 42*r*s - 21*r + 24*s**2 - 24*s + 8) + 9*Pkdd2*k3**4*s**2)) + k1**2*k3**2*(48*Pk2*k2**4*(15*r**2 - 3*r*(2*s + 5) - 21*s**2 + 3*s + 5) + 2*Pk2*k3**4*(7*f*(72*cosphi**2*(6*s**2 - 5*s + 1) - 162*r*s + 48*r - 9*s**2 + 54*s - 13) + 12*r*(7 - 14*s) + 48*s**2 + 36*s - 12) - 14*Pkd2*f*k2*k3**4*(18*cosphi**2*(6*s**2 - 5*s + 1) - 66*r*s + 24*r - 27*s**2 + 28*s - 9) + 12*Pkd2*k2**3*k3**2*s*(-34*r + 28*s + 17) + k2**2*(-8*Pk2*k3**2*(60*r**2 - 3*r*(4*s + 27) - 24*s**2 + 27*s + 20) - 7*Pkdd2*f*k3**4*(45*s**2 - 18*s + 5))) - 4*k2**2*k3**4*(4*Pk2*k2**2*(48*r**2 + 6*r*(7*s - 8) - 21*s + 16) + Pk2*k3**2*(21*f*(cosphi**2*(9*r**2 + 6*r*(3*s - 2) - 6*s + 5) + 96*r**2 - 76*r - 4*s + 24) - 240*r**2 + 12*r*(14*s + 13) - 84*s - 52) - 28*Pkd2*f*k2*k3**2*(3*r - 1)*(3*s - 1))) - 14*f**2*k3**6*(24*Pk2*k2**2*r**2 + k1**2*(Pk2*(48*cosphi**2*(8*s**2 - 6*s + 1) - 15*r*(s - 2) - 36*s**2 + 54*s - 22) - k2*(3*Pkd2*(4*cosphi**2*(8*s**2 - 6*s + 1) - 5*r*s + 5*r - 8*s**2 + 10*s - 4) + Pkdd2*k2*(6*s**2 - 6*s + 1)))) - 2*f*(2*Pk2*k1**6*(12*k2**2*(27*r**2 + r*(54*s - 32) + 27*s**2 - 32*s + 10) - 7*k3**2*(27*r*s - 5*r + 27*s**2 - 21*s + 3)) + 42*Pk2*k2**4*k3**4*r*(cosphi**2*(9*r + 6*s - 5) - 12*r + 4) + k1**4*(24*Pk2*k2**4*(48*r**2 + 2*r*(51*s - 35) + 51*s**2 - 72*s + 25) + Pk2*k3**4*(-21*r*(17*s - 7) - 18*s**2 + 209*s - 46) - 36*Pkd2*k2**3*k3**2*(r*(11*s - 7) + 11*s**2 - 15*s + 5) + 3*Pkd2*k2*k3**4*(7*r*(5*s - 3) + 24*s**2 - 29*s + 4) + 3*k2**2*(-4*Pk2*k3**2*(14*r**2 + 70*r*s - 23*r + 51*s**2 - 41*s + 1) + Pkdd2*k3**4*(15*s**2 - 18*s + 5))) + k1**2*k2**2*k3**2*(-2*Pk2*k2**2*(36*cosphi**2*(9*r**2 + 15*r*s - 11*r + 6*s**2 - 8*s + 3) - 6*r**2 + 141*r*s - r + 126*s**2 - 75*s - 6) + Pk2*k3**2*(6*cosphi**2*(81*r**2 + 150*r*s - 119*r - 72*s**2 + 24*s + 18) + 96*r**2 - 237*r*s - 145*r + 89*s + 56) + 3*Pkd2*k2*k3**2*(12*cosphi**2*(6*s**2 - 5*s + 1) - 37*r*s + 27*r + 42*s**2 - 25*s - 2))))/(7*d**2*k1**2*k2**2*k3**6) - D1**4*Pk1*f**2*mu**2*mu2**4*(28*b1**2*k3**6*(k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(12*s**2 - 3*s + 1) - 6*k2**2*r*(-2*Pk2 + Pkd2*k2)*(4*s - 1)) + b1*(4*k1**4*(288*Pk2*k2**4*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) - 4*Pk2*k3**4*(42*r*s - 21*r + 48*s**2 - 48*s + 16) - 36*Pkd2*k2**3*k3**2*(r*(6*s - 3) + 6*s**2 - 6*s + 2) + Pkd2*k2*k3**4*(21*r*(2*s - 1) - 6*s**2 + 6*s - 2) + 6*k2**2*(-2*Pk2*k3**2*(21*r**2 + 6*r*s - 3*r - 15*s**2 + 15*s - 5) + Pkdd2*k3**4*(3*s**2 - 3*s + 1))) + k1**2*(192*Pk2*k2**6*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) + 4*Pk2*k3**6*(21*f*(4*r - 21*s**2 + 14*s - 11) - 168*r*s + 84*r + 240*s**2 - 156*s + 52) - 144*Pkd2*k2**5*k3**2*s*(2*r + 2*s - 1) + 4*Pkd2*k2**3*k3**4*(21*r*(4*s - 1) + 66*s**2 - 105*s + 28) - 2*Pkd2*k2*k3**6*(21*f*(2*r - 51*s**2 + 40*s - 13) - 84*r*s + 42*r + 300*s**2 - 258*s + 86) + 8*k2**4*(-7*Pk2*k3**2*(24*r**2 + 6*r*(7*s - 4) + 18*s**2 - 21*s + 8) + 9*Pkdd2*k3**4*s**2) + k2**2*(8*Pk2*k3**4*(24*r**2 + 3*r*(4*s - 9) - 60*s**2 + 81*s - 20) + Pkdd2*k3**6*(-21*f*(27*s**2 - 22*s + 5) + 120*s**2 - 120*s + 40))) - 2*k2**2*k3**2*(28*Pk2*k2**4*(6*r**2 + 6*r*(s - 1) - 3*s + 2) + 4*Pk2*k2**2*k3**2*(60*r**2 + r*(42*s + 3) - 8) + Pk2*k3**4*(7*f*(cosphi**2*(9*r**2 - 2*r + 1) + 54*r**2 + 240*r*s - 98*r - 84*s + 30) - 48*r**2 - 12*r*(3 - 14*s) - 84*s + 12) + 42*Pkd2*k2**3*k3**2*s*(1 - 2*r) - 7*Pkd2*k2*k3**4*(f*(66*r*s - 21*r - 24*s + 4) + 12*r*s - 6*r - 6*s + 2))) - 14*f**2*k3**6*(24*Pk2*k1**2*s**2 - Pk2*k2**2*(12*cosphi**2*(4*r**2 - 2*r + 1) + 36*r**2 + 15*r*s - 54*r - 30*s + 22) - 6*Pkd2*k1**2*k2*s**2 + Pkd2*k2**3*(3*r*(5*s - 3) - 10*s + 4)) + 2*f*(-2*k1**4*(12*Pk2*k2**4*(51*r**2 + 6*r*(17*s - 12) + 51*s**2 - 72*s + 26) - Pk2*k2**2*k3**2*(126*r**2 + 3*r*(47*s - 25) + 15*s**2 - 15*s + 1) + 84*Pk2*k3**4*s*(1 - 3*s) - 12*Pkd2*k2**3*k3**2*(3*s - 1)*(3*r + 3*s - 2) + 21*Pkd2*k2*k3**4*s*(3*s - 1)) + k1**2*k2**2*(-24*Pk2*k2**4*(24*r**2 + 6*r*(9*s - 5) + 27*s**2 - 32*s + 9) - Pk2*k3**4*(252*r**2 + r*(621*s - 469) - 330*s**2 + 9*s + 88) + 12*Pkd2*k2**3*k3**2*(r*(27*s - 11) + 27*s**2 - 27*s + 7) + Pkd2*k2*k3**4*(r*(41 - 189*s) - 144*s**2 + 101*s + 4) + k2**2*(4*Pk2*k3**2*(228*r**2 + 462*r*s - 251*r + 165*s**2 - 217*s + 33) - 3*Pkdd2*k3**4*(27*s**2 - 22*s + 5))) + k2**4*k3**2*(14*Pk2*k2**2*(24*r**2 + r*(27*s - 19) - 5*s + 2) + Pk2*k3**2*(-6*cosphi**2*(3*r**2 - 2*r + 1) - 300*r**2 + 147*r*s + 9*r - 161*s + 66) - 7*Pkd2*k2*k3**2*(r*(27*s - 11) - 5*s + 2))) + 28*k3**6*(4*Pk2*g2*k2**2*(3*r**2 - 3*r + 1) + b2*k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(3*s**2 - 3*s + 1) - 2*g2*k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(3*s**2 - 3*s + 1)))/(7*d**2*k1**2*k2**2*k3**6) - D1**4*Pk1*f**2*mu**5*mu2*(112*b1**2*k2**2*k3**6*(6*Pk2*k2**2*(3*r**2 - 3*r + 1) + k1**2*(2*Pk2*(6*r**2 - 3*r + 1) + 3*Pkd2*k2*s*(1 - 2*r))) + b1*(8*k1**6*(96*Pk2*k2**4*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) - 14*Pk2*k2**2*k3**2*(3*r**2 + 3*r*(4*s - 1) + (1 - 3*s)**2) - 42*Pk2*k3**4*s**2 - 18*Pkd2*k2**3*k3**2*s*(2*r + 2*s - 1) + 21*Pkd2*k2*k3**4*s**2) + k1**4*k3**2*(14*Pk2*f*k3**4*(16*cosphi**2*(9*s**2 - 9*s + 2) - 3*s**2) + 16*Pk2*k2**4*(87*r**2 + 3*r*(8*s - 29) - 63*s**2 - 12*s + 29) - 28*Pkd2*f*k2*k3**4*(2*cosphi**2*(9*s**2 - 9*s + 2) - 3*s**2) + 24*Pkd2*k2**3*k3**2*s*(-12*r + 7*s + 6) + k2**2*(-16*Pk2*k3**2*(21*r**2 + 3*r*(6*s - 7) - 24*s**2 - 9*s + 7) - 63*Pkdd2*f*k3**4*s**2)) + 4*k1**2*k2**2*k3**4*(-7*Pk2*f*k3**2*(cosphi**2*(15*r**2 + r*(72*s - 34) - 36*s**2 - 6*s + 9) + 120*r**2 - 86*r - 12*s + 26) + 8*Pk2*k2**2*(15*r**2 - 3*r*(14*s + 5) + 21*s + 5) - 7*Pkd2*f*k2*k3**2*(cosphi**2*(18*s**2 - 9*s + 2) + 4*r*(3 - 9*s) + 12*s - 4))) + f*k1**2*(-28*Pk2*k2**2*k3**4*r*(3*f*k3**2*r + 2*k2**2*(cosphi**2*(6*r + 9*s - 5) - 6*r + 2)) - 4*k1**4*(48*Pk2*k2**4*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - 2*Pk2*k2**2*k3**2*(21*r**2 + 21*r*(2*s - 1) + 21*s**2 - 34*s + 7) - 14*Pk2*k3**4*(3*s**2 - 3*s + 1) - 12*Pkd2*k2**3*k3**2*(s - 1)*(3*r + 3*s - 2) + 7*Pkd2*k2*k3**4*(3*s**2 - 4*s + 1)) + k1**2*k3**2*(-14*Pk2*f*k3**4*(8*cosphi**2*(12*s**2 - 11*s + 2) - 9*s**2 + 12*s - 5) + 8*Pk2*k2**4*(12*cosphi**2*(6*r**2 + r*(15*s - 11) + 9*s**2 - 11*s + 4) - 15*r**2 + 3*r*(2*s + 9) + 21*s**2 - 16*s - 5) + 14*Pkd2*f*k2*k3**4*(cosphi**2*(24*s**2 - 22*s + 4) - 6*s**2 + 8*s - 3) - 4*Pkd2*k2**3*k3**2*(12*cosphi**2*(9*s**2 - 9*s + 2) - (s - 1)*(36*r - 21*s - 5)) + k2**2*k3**2*(-8*Pk2*(r**2*(42*cosphi**2 - 21) + r*(cosphi**2*(135*s - 107) + 24*s - 1) + s*(-12*cosphi**2*(9*s - 7) - 13)) + 7*Pkdd2*f*k3**2*(3*s**2 - 4*s + 1)))))/(7*d**2*k1**3*k2**3*k3**6) - D1**4*Pk1*f**2*mu**3*mu2**3*(84*b1**2*k3**6*(16*Pk2*k2**4*r**2 + 2*k1**4*s**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + k1**2*k2**2*(4*Pk2*r*(8*s - 1) - 4*Pk2*s - Pkd2*k2*(2*r*(8*s - 1) + s*(s - 2)) + Pkdd2*k2**2*s**2)) + b1*(-28*Pk2*k2**4*k3**4*(8*k2**2*(3*r**2 - 3*r + 1) + k3**2*(cosphi**2*f*(9*r**2 - 6*r + 3) + 4*f*(36*r**2 - 33*r + 11) + 24*r**2 - 24*r + 8)) + 8*k1**6*(96*Pk2*k2**4*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) - 6*Pk2*k2**2*k3**2*(7*r**2 + 8*r*(2*s - 1) + 9*s**2 - 9*s + 3) - 28*Pk2*k3**4*(3*s**2 - 3*s + 1) - 6*Pkd2*k2**3*k3**2*(r*(6*s - 3) + 6*s**2 - 6*s + 2) + 7*Pkd2*k2*k3**4*(3*s**2 - 3*s + 1)) + 2*k1**4*(384*Pk2*k2**6*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) - 28*Pk2*k3**6*(f*(33*s**2 - 28*s + 13) + 12*s**2 - 12*s + 4) - 216*Pkd2*k2**5*k3**2*s*(2*r + 2*s - 1) + 4*Pkd2*k2**3*k3**4*(24*s**2 + s*(42*r - 42) + 7) + 28*Pkd2*k2*k3**6*(f*(24*s**2 - 22*s + 7) + 3*s**2 - 3*s + 1) + 24*k2**4*(-7*Pk2*k3**2*(4*r**2 + 8*r*s - 5*r + 4*s**2 - 5*s + 2) + 3*Pkdd2*k3**4*s**2) - k2**2*(8*Pk2*k3**4*(6*r*(3*s + 2) + 18*s**2 - 18*s - 1) + 7*Pkdd2*f*k3**6*(21*s**2 - 20*s + 5))) - k1**2*k2**2*k3**2*(48*Pk2*k2**4*(9*r**2 + r*(16*s - 9) + 7*s**2 - 8*s + 3) + 2*Pk2*k3**4*(7*f*(cosphi**2*(18*r**2 - 6*r - 240*s**2 + 176*s - 29) + 60*r**2 + 432*r*s - 170*r - 18*s**2 - 132*s + 47) + 168*r**2 + 8*r*(15 - 72*s) + 168*s**2 + 120*s + 16) - 24*Pkd2*k2**3*k3**2*s*(2*r + 7*s - 1) + 8*Pkd2*k2*k3**4*(7*f*(cosphi**2*(15*s**2 - 11*s + 2) - 36*r*s + 12*r - 3*s**2 + 12*s - 3) + 60*r*s - 30*r - 21*s**2 - 9*s + 3) + k2**2*(16*Pk2*k3**2*(18*r**2 + 18*r*(s - 1) + 12*s - 1) + 7*Pkdd2*f*k3**4*(42*s**2 - 20*s + 5)))) + 7*f**2*k3**6*(-40*Pk2*k2**4*r**2 + 10*k1**4*s**2*(-4*Pk2 + Pkd2*k2) + k1**2*k2**2*(4*Pk2*(cosphi**2*(20*r**2 - 10*r - 160*s**2 + 104*s - 11) + 15*r**2 + 4*r*(4*s - 9) + 15*s**2 - 36*s + 17) + k2*(2*Pkd2*(cosphi**2*(80*s**2 - 52*s + 8) - 32*r*s + 24*r - 20*s**2 + 32*s - 13) + Pkdd2*k2*(10*s**2 - 8*s + 1)))) - 4*f*(Pk2*k2**6*k3**4*r*(28*cosphi**2 - 56)*(3*r - 1) + 2*k1**6*(12*Pk2*k2**4*(33*r**2 + 6*r*(11*s - 7) + 33*s**2 - 42*s + 14) - Pk2*k2**2*k3**2*(42*r**2 + 3*r*(53*s - 13) + 117*s**2 - 108*s + 16) + 28*Pk2*k3**4*s*(1 - 3*s) - 6*Pkd2*k2**3*k3**2*(3*s - 1)*(2*r + 2*s - 1) + 7*Pkd2*k2*k3**4*s*(3*s - 1)) + k1**4*k2**2*(24*Pk2*k2**4*(30*r**2 + r*(66*s - 40) + 33*s**2 - 42*s + 13) + Pk2*k3**4*(42*r**2 - r*(117*s + 35) - 54*s**2 + 117*s + 18) - 12*Pkd2*k2**3*k3**2*(r*(27*s - 13) + 27*s**2 - 31*s + 9) + Pkd2*k2*k3**4*(r*(147*s - 58) + 48*s**2 - 53*s - 3) + k2**2*(-2*Pk2*k3**2*(156*r**2 + 5*r*(96*s - 41) + 258*s**2 - 249*s + 16) + 3*Pkdd2*k3**4*(21*s**2 - 20*s + 5))) + k1**2*k2**4*k3**2*(-2*Pk2*k2**2*(12*cosphi**2*(3*r - 1)*(2*r + 2*s - 1) + 96*r**2 + 159*r*s - 94*r + 42*s**2 - 39*s + 9) + Pk2*k3**2*(2*cosphi**2*(69*r**2 + 72*r*s - 68*r - 24*s + 21) + 198*r**2 - 261*r*s - 89*r + 151*s + 16) + Pkd2*k2*k3**2*(r*(75*s - 34) + 42*s**2 - 39*s + 9))) - 56*k1**2*k2**2*k3**6*(r*(6*s - 3) - 3*s + 1)*(-2*Pk2*b2 + 2*Pk2*g2 + Pkd2*b2*k2 - 2*Pkd2*g2*k2))/(7*d**2*k1**3*k2**3*k3**6) - D1**4*Pk1*f**2*mu*mu2**5*(28*b1**2*k1**2*k3**6*(k1**2*(24*Pk2 + k2*(-9*Pkd2 + Pkdd2*k2))*(3*s**2 - 3*s + 1) + k2**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(6*s**2 - 3*s + 1)) + b1*k2**2*(-84*Pk2*k2**2*k3**4*r**2*(f*k3**2 + 4*k2**2) + 8*k1**4*(96*Pk2*k2**4*(3*r**2 + r*(6*s - 3) + 3*s**2 - 3*s + 1) + 4*Pk2*k3**4*(-42*r*s + 21*r + 15*s**2 - 15*s + 5) - 18*Pkd2*k2**3*k3**2*(r*(6*s - 3) + 6*s**2 - 6*s + 2) + Pkd2*k2*k3**4*(42*r*s - 21*r - 69*s**2 + 69*s - 23) + 2*k2**2*(Pk2*k3**2*(-63*r**2 + 24*r*s - 12*r + 87*s**2 - 87*s + 29) + 3*Pkdd2*k3**4*(3*s**2 - 3*s + 1))) - k1**2*k3**2*(-28*Pk2*f*k3**4*(12*r + 3*s**2 - 4*s - 9) + 112*Pk2*k2**4*(9*r**2 + 6*r*(2*s - 1) + 3*s**2 - 3*s + 1) + 28*Pkd2*f*k2*k3**4*(3*r - 24*s**2 + 17*s - 6) - 56*Pkd2*k2**3*k3**2*(r*(6*s - 3) + 3*s**2 - 3*s + 1) + k2**2*(-16*Pk2*k3**2*(24*r**2 - 18*r*s + 9*r - 21*s**2 + 21*s - 7) + 7*Pkdd2*f*k3**4*(33*s**2 - 24*s + 5)))) + f*k2**2*(14*Pk2*k2**2*k3**4*(f*k3**2*(3*cosphi**2*(4*r**2 - 2*r + 1) + 9*r**2 - 12*r + 5) + k2**2*(-6*r**2 - 8*r + 6)) - 4*k1**4*(48*Pk2*k2**4*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - 2*Pk2*k2**2*k3**2*(21*r**2 + 2*r*(3*s - 8) - 15*s**2 + 27*s - 5) + 28*Pk2*k3**4*s*(1 - 3*s) - 12*Pkd2*k2**3*k3**2*(3*s - 1)*(r + s - 1) + 7*Pkd2*k2*k3**4*s*(3*s - 1)) + k1**2*k3**2*(-84*Pk2*f*k3**4*s**2 + 8*Pk2*k2**4*(75*r**2 + 2*r*(57*s - 41) + 21*s**2 - 45*s + 13) - 4*Pk2*k2**2*k3**2*(63*r**2 + 16*r*(12*s - 7) - 42*s**2 - 50*s + 17) + 21*Pkd2*f*k2*k3**4*s**2 - 4*Pkd2*k2**3*k3**2*(6*r + 7*s*(3*s - 1)))))/(7*d**2*k1**3*k2**3*k3**6) - D1**4*Pk1*f*mu**4*(224*Pk2*b1**3*k2**2*k3**6*r**2 - 2*b1**2*(2*Pk2*k1**2*k3**2*s*(28*k1**4*(r + s) - 16*k1**2*k3**2*s - k3**4*(7*f - 28*r + 8*s + 28)) + 14*Pkd2*f*k1**2*k2*k3**6*s*(-4*r + 2*s + 1) + 28*Pkd2*f*k2**3*k3**6*s*(1 - 2*r) + 14*cosphi**2*f*k3**6*(3*Pk2*k2**2*(2*r**2 + r*(4*s - 2) - 2*s + 1) + k1**2*(Pk2*(12*r*s - 16*s**2 + 3*s - 2) + Pkd2*k2*(8*s**2 - 3*s + 1))) + k2**2*(-96*Pk2*k1**6*(r + s)**2 + 56*Pk2*k1**4*k3**2*s*(r + s) + 56*Pk2*k1**2*k3**4*r*s + k3**6*(4*Pk2*(7*f*(34*r**2 - 4*r*s - 34*r + s + 12) + (4 - 4*r)*(10*r - 7*s - 10)) + 7*Pkdd2*f*k1**2*s**2))) + b1*(112*Pk2*k3**6*(2*b2*k2**2*(r - 1)**2 + g2*(k1**2*s**2 - 4*k2**2*(r - 1)**2)) + 7*f**2*k3**6*(-12*Pk2*k2**2*r**2 - 4*cosphi**2*k1**2*(Pk2*(18*s**2 - s*(15*r + 3) + 2) + Pkd2*k2*(-9*s**2 + 4*s - 1)) + k1**2*(-2*Pk2*s*(5*r + 2) + 2*Pkd2*k2*s*(2 - 5*r) + Pkdd2*k2**2*(3*s**2 - 2*s + 1))) - 2*f*(6*Pk2*k1**6*(4*k2**2*(18*r**2 + 18*r*(2*s - 1) + 18*s**2 - 18*s + 5) - 21*k3**2*s*(2*r + 2*s - 1)) + 14*Pk2*k2**2*k3**4*r*(cosphi**2*k3**2*(2*s - 1) + k2**2*(cosphi**2*(6*r + 2*s - 3) - 8*r + 4)) + k1**4*(48*Pk2*k2**4*(4*r**2 + 2*r*(5*s - 1) + s*(5*s - 3)) + Pk2*k3**4*(2*cosphi**2*(2*s - 1)*(7*r - 12*s + 12) + s*(-98*r + 144*s + 49)) - 36*Pkd2*k2**3*k3**2*s*(2*r + 2*s - 1) + Pkd2*k2*k3**4*(12*cosphi**2*(2*s**2 - 3*s + 1) + s*(14*r + 52*s - 7)) + 2*k2**2*k3**2*(-2*Pk2*(6*cosphi**2*(2*s - 1)*(r + s - 1) - 34*r**2 + 92*r*s + 41*r + 116*s**2 - 26*s - 21) + 3*Pkdd2*k3**2*s**2)) + k1**2*k3**2*(2*Pk2*cosphi**2*k3**4*(2*s - 1)*(7*r - 20*s + 20) - 2*Pk2*k2**4*(r**2*(72*cosphi**2 - 20) + 2*r*(6*cosphi**2*(8*s - 3) + 11*s + 5) + s*(12*cosphi**2*(2*s - 3) + 28*s + 17)) + Pk2*k2**2*k3**2*(4*cosphi**2*(39*r**2 + r*(86*s - 32) - 36*s + 9) + 136*r**2 - 2*r*(177*s + 82) + 56*s**2 + 185*s + 84) + 20*Pkd2*cosphi**2*k2*k3**4*(2*s**2 - 3*s + 1) + Pkd2*k2**3*k3**2*s*(-34*r + s*(24*cosphi**2 + 28) + 17)))) - 2*f*k1**2*(-14*cosphi**2*k3**6*(2*Pk2 - Pkd2*k2)*(b2 - 2*g2)*(2*s**2 - 3*s + 1) + f*k1**2*(-24*Pk2*k2**4*(r + s - 1)**2 + Pk2*k3**4*(-2*cosphi**2*(3*s - 1)*(7*r - 12*s + 12) + 7*r*(s - 1)) + 12*Pkd2*k2**3*k3**2*(s - 1)*(r + s - 1) - Pkd2*k2*k3**4*(s - 1)*(12*cosphi**2*(3*s - 1) + 7*r) + k2**2*k3**2*(2*Pk2*(r + s - 1)*(12*cosphi**2*(3*s - 1) + 10*r + 3*s - 3) - 3*Pkdd2*k3**2*(s - 1)**2)) + f*k2**2*k3**2*r*(14*Pk2*k2**2*(r + s - 1) + Pk2*k3**2*(cosphi**2*(14 - 42*s) - 2*r - 7*s + 7) - 7*Pkd2*k2*k3**2*(s - 1))))/(7*d**2*k1**2*k2**2*k3**6) + D1**4*Pk1*f*mu**2*mu2**2*(28*b1**3*k2*k3**6*s*(Pkd2*k1**2*s + 4*Pkd2*k2**2*r - Pkdd2*k1**2*k2*s) + b1**2*(-8*k1**4*(144*Pk2*k2**4*(r + s)**2 - 14*Pk2*k3**4*s*(r + 2*s) - 36*Pkd2*k2**3*k3**2*s*(r + s) + Pkd2*k2*k3**4*s*(7*r + 11*s) + 3*k2**2*k3**2*(-14*Pk2*(r + s)**2 + Pkdd2*k3**2*s**2)) - k1**2*k3**2*(-336*Pk2*k2**4*(r + s)**2 + 8*k2**2*k3**2*(8*Pk2*(r**2 + 4*r*s + s**2) + 7*Pkd2*k2*s*(r + 2*s)) + k3**4*(14*Pk2*f*(24*cosphi**2*(1 - 2*s)**2 - 24*s**2 + s*(12 - 24*r) - 5) + 16*Pk2*(2*s**2 + s*(3 - 7*r) + 2) - 7*f*k2*(2*Pkd2*(6*cosphi**2*(1 - 2*s)**2 - 32*s**2 + 10*s - 5) + Pkdd2*k2*(40*s**2 - 14*s + 5)) + 8*k2*s*(Pkd2*(7*r - 5*s - 7) + 5*Pkdd2*k2*s))) + 2*k2**2*k3**4*(56*Pk2*k2**2*r*(2*r + s) + k3**2*(Pk2*(7*f*(cosphi**2*(8*r**2 + 2*r*(12*s - 5) + 1) + 64*r**2 + 4*r*(6*s - 5) - 12*s + 10) - 16*r**2 - 8*r*(3 - 7*s) - 16) - 28*Pkd2*k2*(f*r*(9*s - 2) - 2*f*s + s*(r - 1))))) + b1*(7*f**2*k3**6*(3*k1**2*(2*Pk2*(24*cosphi**2*(6*s**2 - 5*s + 1) + r*(6*s + 4) - 12*s**2 + 18*s - 7) - k2*(2*Pkd2*(6*cosphi**2*(6*s**2 - 5*s + 1) + 2*r - (2 - 3*s)**2) + Pkdd2*k2*(6*s**2 - 6*s + 1))) + 2*k2**2*(-3*Pk2*(2*cosphi**2*(9*r**2 + 6*r*(3*s - 2) - 6*s + 5) + 12*r**2 - 6*r*(s + 3) - 4*s + 7) + Pkd2*k2*(9*r*(2*s - 1) - 12*s + 4))) + 2*f*(2*Pk2*k1**6*(12*k2**2*(10*r**2 + r*(20*s - 6) + 10*s**2 - 6*s + 1) - 7*k3**2*(r*(10*s - 3) + 10*s**2 - 6*s + 1)) + k1**4*(48*Pk2*k2**4*(33*r**2 + r*(68*s - 42) + 34*s**2 - 42*s + 13) + Pk2*k3**4*(r*(77 - 70*s) - 220*s**2 + 98*s - 32) - 12*Pkd2*k2**3*k3**2*(r*(34*s - 15) + 34*s**2 - 36*s + 9) + Pkd2*k2*k3**4*(7*r*(10*s - 7) + 120*s**2 - 38*s - 2) + k2**2*(-2*Pk2*k3**2*(296*r**2 + 606*r*s - 270*r + 290*s**2 - 267*s + 36) + 3*Pkdd2*k3**4*(10*s**2 - 14*s + 5))) + k1**2*(48*Pk2*k2**6*(4*r**2 + 2*r*(5*s - 1) + s*(5*s - 3)) + Pk2*k3**6*(-7*r*(30*s - 17) + 100*s**2 - 7*s + 40) - 12*Pkd2*k2**5*k3**2*s*(10*r + 10*s - 3) + Pkd2*k2**3*k3**4*(36*cosphi**2*(1 - 2*s)**2 + 7*r*(20*s - 7) + 240*s**2 - 119*s + 28) + Pkd2*k2*k3**6*(7*r*(10*s - 7) - 80*s**2 + 79*s - 36) + 2*k2**4*k3**2*(-Pk2*(12*cosphi**2*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) + 232*r**2 + 678*r*s - 175*r + 340*s**2 - 294*s - 22) + 15*Pkdd2*k3**2*s**2) + k2**2*k3**4*(Pk2*(12*cosphi**2*(8*r**2 + r*(26*s - 15) - 6*(1 - 2*s)**2) + 64*r**2 + 532*r*s - 47*r + 80*s**2 - 219*s - 70) + 5*Pkdd2*k3**2*(10*s**2 - 14*s + 5))) + k2**2*k3**2*(-14*Pk2*k2**4*(8*r**2 + 2*r*(5*s - 2) - 3*s) + Pk2*k2**2*k3**2*(6*cosphi**2*(16*r**2 + 4*r*(7*s - 4) + 1) - 176*r**2 + r*(72 - 70*s) + 91*s - 52) + Pk2*k3**4*(10*cosphi**2*(2*r**2 - 2*r + 1) + 192*r**2 - 3*r*(70*s + 51) + 133*s + 86) + 7*Pkd2*k2**3*k3**2*s*(10*r - 3) + 7*Pkd2*k2*k3**4*(r*(10*s - 7) - 3*s + 2))) - 28*k3**6*(4*Pk2*g2*k2**2*(r - 1)**2 + b2*k1**2*k2*s**2*(-Pkd2 + Pkdd2*k2) + 2*g2*k1**2*(2*Pk2*(s - 1)**2 + k2*s**2*(Pkd2 - Pkdd2*k2)))) + f*(-6*f*(2*Pk2*k1**6*(4*k2**2*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1) - 7*k3**2*s*(2*r + 2*s - 1)) + k1**4*(16*Pk2*k2**4*(3*r + 3*s - 2)**2 + 2*Pk2*k2**2*k3**2*(-27*r**2 + r*(20 - 68*s) - 41*s**2 + 27*s + 3) + Pk2*k3**4*s*(14*r - 38*s + 7) - 4*Pkd2*k2**3*k3**2*(3*s - 2)*(3*r + 3*s - 2) + Pkd2*k2*k3**4*s*(27*s - 14)) + k1**2*k2**2*(8*Pk2*k2**4*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1) + Pk2*k3**4*(2*cosphi**2*(81*r**2 + 150*r*s - 119*r - 72*s**2 + 24*s + 18) - 16*r*s - 7*r - 7*s) - 4*Pkd2*k2**3*k3**2*(r*(6*s - 3) + 6*s**2 - 6*s + 1) + Pkd2*k2*k3**4*(12*cosphi**2*(6*s**2 - 5*s + 1) + 14*r*s + 5*r + 21*s**2 - 14*s - 4) + k2**2*(-2*Pk2*k3**2*(12*cosphi**2*(9*r**2 + 15*r*s - 11*r + 6*s**2 - 8*s + 3) + 41*r**2 + 68*r*s - 27*r + 27*s**2 - 20*s - 3) + Pkdd2*k3**4*(6*s**2 - 6*s + 1))) + k2**4*k3**2*r*(-14*Pk2*k2**2*(2*r + 2*s - 1) + Pk2*k3**2*(14*cosphi**2*(9*r + 6*s - 5) - 38*r + 14*s + 7) + 7*Pkd2*k2*k3**2*(2*s - 1))) + 7*k3**6*(2*Pk2*b2*k2**2*(cosphi**2*(2*r**2 - 2*r + 1) + 16*r**2 - 20*r + 10) - 4*Pk2*g2*k2**2*(cosphi**2*(2*r**2 - 2*r + 1) + 8*r**2 - 16*r + 10) + b2*k1**2*(2*Pk2*(6*s**2 - 6*s + 5) + k2*(-2*Pkd2*(8*s**2 - 10*s + 5) + Pkdd2*k2*(10*s**2 - 14*s + 5))) - 2*g2*k1**2*(-8*Pk2*(s**2 - 1) + k2*(-2*Pkd2*(8*s**2 - 10*s + 5) + Pkdd2*k2*(10*s**2 - 14*s + 5))))))/(7*d**2*k1**2*k2**2*k3**6) + D1**4*Pk1*f*mu**2*(-7*b1**3*k3**6*(4*Pk2*cosphi**2*k1**2*s*(-r + 2*s) - Pkd2*k1**2*k2*s**2*(4*cosphi**2 + 2) + 4*Pkd2*k2**3*r*s - k2**2*(2*Pk2*r*(r*(cosphi**2 + 10) + s*(4*cosphi**2 - 4)) + Pkdd2*k1**2*s**2)) + b1**2*(2*Pk2*k1**2*k3**2*s*(-70*k1**4*(r + s) + 5*k1**2*k3**2*(7*r + 8*s) + k3**4*(r*(42*f - 35) + 20*s + 35)) + 4*Pk2*k2**4*(12*k1**4*(4*r**2 + 10*r*s + 5*s**2) - 7*k1**2*k3**2*(2*r**2 + 5*r*s + 2*s**2) - 14*k3**4*r**2) + 2*Pkd2*k1**2*k2*k3**4*s*(k1**2*(7*r + 20*s) + k3**2*(-21*f*s + 7*r + 10*s - 7)) + 2*Pkd2*k2**3*k3**2*s*(-36*k1**4*(r + s) + 7*k1**2*k3**2*(r + 2*s) + 7*k3**4*(f*(3*r - 2) + r - 1)) - 4*cosphi**2*(-Pk2*k2**2*k3**4*(7*k2**2*r*(r + s) + k3**2*(-21*f*(2*r**2 + 4*r*s - 2*r - 2*s + 1) + 5*r**2 + 7*r*s - 17*r + 5)) + k1**2*k3**2*(12*Pk2*k2**4*(r + s)**2 - k2**2*k3**2*(Pk2*r*(10*r + 31*s) + 6*Pkd2*k2*s**2) + k3**4*(7*Pk2*f*(-16*s**2 + s*(12*r + 3) - 2) - Pk2*(s - 1)*(7*r - 20*s + 20) + 7*Pkd2*f*k2*(8*s**2 - 3*s + 1) - 10*Pkd2*k2*(s - 1)**2))) + k2**2*(240*Pk2*k1**6*(r + s)**2 - 8*Pk2*k1**4*k3**2*(22*r**2 + 68*r*s + 41*s**2) + 2*k1**2*k3**4*s*(11*Pk2*r + 28*Pk2*s + 3*Pkdd2*k1**2*s) + k3**6*(2*Pk2*(-7*f*(14*r**2 - 9*r*(s + 2) + 2*s + 7) + (r - 1)*(100*r - 91*s - 100)) + Pkdd2*k1**2*(-7*f*(4*s**2 - 2*s + 1) + 10*s**2)))) - 2*b1*f*(6*Pk2*k1**6*(4*k2**2*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1) - 7*k3**2*s*(2*r + 2*s - 1)) + k1**4*(24*Pk2*k2**4*(7*r**2 + 2*r*(7*s - 3) + 7*s**2 - 6*s + 1) + Pk2*k3**4*(2*cosphi**2*(2*s - 1)*(7*r - 12*s + 12) + 7*r*(5*s + 1) + 3*s*(16*s - 7)) - 12*Pkd2*k2**3*k3**2*(r*(4*s - 1) + (1 - 2*s)**2) + Pkd2*k2*k3**4*(12*cosphi**2*(2*s**2 - 3*s + 1) + 7*r*(s - 1) + 39*s**2) + k2**2*k3**2*(-2*Pk2*(12*cosphi**2*(2*s - 1)*(r + s - 1) + 49*r**2 + 169*r*s - 45*r + 120*s**2 - 57*s - 6) + 3*Pkdd2*k3**2*(s - 1)**2)) + k1**2*(24*Pk2*k2**6*(r + s)**2 - 7*Pk2*k3**6*r*(s - 1) - 12*Pkd2*k2**5*k3**2*s*(r + s) + Pkd2*k2**3*k3**4*(7*r*(2*s - 1) + 33*s**2) + 7*Pkd2*k2*k3**6*r*(s - 1) - 2*cosphi**2*(12*Pk2*k2**4*k3**2*(6*r**2 + r*(8*s - 3) + s*(2*s - 3)) - 2*Pk2*k2**2*k3**4*(39*r**2 + r*(86*s - 32) - 36*s + 9) - Pk2*k3**6*(2*s - 1)*(7*r - 20*s + 20) - 12*Pkd2*k2**3*k3**4*s**2 - 10*Pkd2*k2*k3**6*(2*s**2 - 3*s + 1)) + k2**4*k3**2*(-2*Pk2*(38*r**2 + 74*r*s - 33*r + 36*s**2) + 3*Pkdd2*k3**2*s**2) + k2**2*k3**4*(Pk2*(8*r**2 - r*(16*s + 21) + 3*s*(16*s + 7)) + 5*Pkdd2*k3**2*(s - 1)**2)) + k2**2*k3**2*r*(-14*Pk2*k2**4*(r + s) + Pk2*k2**2*k3**2*(14*cosphi**2*(6*r + 2*s - 3) - 40*r + 21*s + 14) + Pk2*k3**4*(14*cosphi**2*(2*s - 1) - 6*r + 7*s - 7) + 7*Pkd2*k2**3*k3**2*s + 7*Pkd2*k2*k3**4*(s - 1))) + 7*b1*k3**6*(b2*(2*cosphi**2*(Pk2*k2**2*(r - 1)**2 - 2*k1**2*(2*Pk2 - Pkd2*k2)*(s - 1)**2) + k2*(2*Pkd2*k1**2*s**2 + k2*(20*Pk2*(r - 1)**2 + Pkdd2*k1**2*s**2))) - 2*g2*(-10*Pk2*k1**2*s**2 + 2*Pkd2*k1**2*k2*s**2 + cosphi**2*(2*Pk2*k2**2*(r - 1)**2 - 4*k1**2*(2*Pk2 - Pkd2*k2)*(s - 1)**2) + k2**2*(20*Pk2*(r - 1)**2 + Pkdd2*k1**2*s**2))) - 7*f*k3**6*(-4*b2*cosphi**2*k1**2*(2*Pk2 - Pkd2*k2)*(2*s**2 - 3*s + 1) + b2*k2**2*(-2*Pk2*r**2 + Pkdd2*k1**2*(s - 1)**2) + 8*cosphi**2*g2*k1**2*(2*Pk2 - Pkd2*k2)*(2*s**2 - 3*s + 1) - 2*g2*k2**2*(-4*Pk2*r**2 + Pkdd2*k1**2*(s - 1)**2)))/(7*d**2*k1**2*k2**2*k3**6) - D1**4*Pk1*f*mu2**4*(28*b1**3*k1**2*k3**6*s**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + b1**2*(k1**2*(192*Pk2*k2**6*(r + s)**2 - 16*k2**4*k3**2*(r + s)*(7*Pk2*r + 6*Pkd2*k2*s) + 8*k2**2*k3**4*s*(-14*Pk2*r + k2*(7*Pkd2*r - 3*Pkd2*s + 3*Pkdd2*k2*s)) + k3**6*(4*Pk2*(7*f*(8*r*s - 2*r - 18*s**2 + 18*s - 11) + (s - 1)*(-56*r + 80*s - 80)) + k2*(14*Pkd2*f*(-4*r*s + r + 36*s**2 - 36*s + 13) + 8*Pkd2*(s - 1)*(7*r - 25*s + 25) + Pkdd2*k2*(-7*f*(18*s**2 - 18*s + 5) + 40*(s - 1)**2)))) - 2*k2**2*k3**2*r*(56*Pk2*k2**4*(r + s) - 4*k2**2*k3**2*(8*Pk2*r + 7*Pkd2*k2*s) + k3**4*(2*Pk2*(84*f*s - 35*f - 8*r + 28*s - 28) + 7*Pkd2*k2*(f - 4*s + 4)))) + b1*(7*f**2*k3**6*(2*Pk2*cosphi**2*k2**2*(9*r**2 - 2*r + 1) - 12*Pk2*k1**2*s**2 - 2*Pk2*k2**2*r*(5*s + 2) + 3*Pkd2*k1**2*k2*s**2 + 2*Pkd2*k2**3*r) - 2*f*(2*k1**4*(12*Pk2*k2**4*(10*r**2 + r*(20*s - 6) + 10*s**2 - 6*s + 1) - Pk2*k2**2*k3**2*(28*r**2 + r*(22*s + 17) - 6*s**2 - 4*s + 7) + 28*Pk2*k3**4*s*(1 - 2*s) - 12*Pkd2*k2**3*k3**2*(r + s)*(2*s - 1) + 7*Pkd2*k2*k3**4*s*(2*s - 1)) + k1**2*k2**2*(24*Pk2*k2**4*(16*r**2 + 18*r*(2*s - 1) + 18*s**2 - 18*s + 5) + Pk2*k3**4*(112*r**2 + r*(5 - 42*s) - 148*s**2 + 120*s + 14) - 12*Pkd2*k2**3*k3**2*(9*r*(2*s - 1) + 18*s**2 - 18*s + 5) + Pkd2*k2*k3**4*(174*r*s - 75*r + 28*s**2 - 14*s - 18) + k2**2*(-4*Pk2*k3**2*(130*r**2 + 200*r*s - 86*r + 48*s**2 - 41*s + 2) + 3*Pkdd2*k3**4*(18*s**2 - 18*s + 5))) + k2**4*k3**2*r*(-14*Pk2*k2**2*(16*r + 18*s - 9) + Pk2*k3**2*(184*r + 70*s - 35) + 63*Pkd2*k2*k3**2*(2*s - 1))) + 28*k3**6*(4*Pk2*g2*k2**2*r**2 + b2*k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(s - 1)**2 - 2*g2*k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2))*(s - 1)**2)) + 2*f**2*k2**2*(2*Pk2*k1**4*(12*k2**2*(r + s - 1) - 7*k3**2*s)*(r + s - 1) + Pk2*k2**2*k3**4*(6*cosphi**2*(3*r**2 - 2*r + 1) - s*(7*r - 7)) + k1**2*k3**2*(-2*Pk2*k2**2*(3*r**2 + r*(13*s - 6) + 10*s**2 - 13*s + 3) + Pk2*k3**2*s*(7*r + 2*s - 7) + 3*Pkd2*k2*k3**2*s**2)))/(7*d**2*k1**2*k2**2*k3**6) - D1**4*Pk1*f*mu2**2*(-7*b1**3*k3**6*s*(8*Pk2*k2**2*r + k1**2*(Pk2*(-4*r + 10*s) + k2*(4*Pkd2*r - 10*Pkd2*s + 5*Pkdd2*k2*s))) + b1**2*(-4*k1**4*(60*Pk2*k2**4*(r + s)**2 - 7*Pk2*k2**2*k3**2*(2*r**2 + 5*r*s + 3*s**2) - 14*Pk2*k3**4*s**2 - 12*Pkd2*k2**3*k3**2*s*(r + s) + 7*Pkd2*k2*k3**4*s**2) - k1**2*(48*Pk2*k2**6*(4*r**2 + 10*r*s + 5*s**2) - 8*k2**4*k3**2*(Pk2*(36*r**2 + 80*r*s + 33*s**2) + 15*Pkd2*k2*s*(r + s)) + 2*k2**2*k3**4*(Pk2*(28*r**2 + 73*r*s + 8*s**2) + k2*s*(59*Pkd2*r + 44*Pkd2*s + 15*Pkdd2*k2*s)) + k3**6*(2*Pk2*(7*f*(24*cosphi**2*(1 - 2*s)**2 + 9*r*s - 2*r - 14*s**2 + 18*s - 7) - (s - 1)*(77*r - 54*s + 54)) + k2*(-14*Pkd2*f*(6*cosphi**2*(1 - 2*s)**2 + 3*r*s - r - 10*s**2 + 12*s - 4) + 10*Pkd2*(s - 1)*(7*r - 10*s + 10) - 7*Pkdd2*f*k2*(6*s**2 - 6*s + 1) + 50*Pkdd2*k2*(s - 1)**2))) + 2*k2**2*k3**2*(7*Pk2*cosphi**2*f*k3**4*(8*r**2 + 2*r*(12*s - 5) + 1) - r*(-14*Pk2*k2**4*(4*r + 5*s) + k2**2*k3**2*(32*Pk2*r + 49*Pk2*s + 35*Pkd2*k2*s) + k3**4*(Pk2*(42*f*s + 16*r - 21*s + 21) - 7*Pkd2*k2*(f - 5*s + 5))))) + b1*(2*f*(2*Pk2*k1**6*(r + s)*(12*k2**2*(r + s) - 7*k3**2*s) + k1**4*(24*Pk2*k2**4*(7*r**2 + 2*r*(7*s - 3) + 7*s**2 - 6*s + 1) - 2*Pk2*k2**2*k3**2*(36*r**2 + 74*r*s + s*(38*s - 33)) + Pk2*k3**4*s*(21*r - 40*s + 14) - 12*Pkd2*k2**3*k3**2*(r + s)*(3*s - 2) + 2*Pkd2*k2*k3**4*s*(12*s - 7)) + k1**2*(24*Pk2*k2**6*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1) + Pk2*k2**2*k3**4*(12*cosphi**2*(8*r**2 + r*(26*s - 15) - 6*(1 - 2*s)**2) + 48*r**2 + r*(21 - 16*s) + s*(8*s - 21)) + Pk2*k3**6*s*(7*r - 6*s - 7) - 12*Pkd2*k2**5*k3**2*(r*(6*s - 3) + 6*s**2 - 6*s + 1) + Pkd2*k2**3*k3**4*(36*cosphi**2*(1 - 2*s)**2 + 78*r*s - 33*r + 24*s**2 - 14*s - 12) + 5*Pkd2*k2*k3**6*s**2 + k2**4*k3**2*(-2*Pk2*(12*cosphi**2*(6*r**2 + 2*r*(9*s - 5) + 3*(1 - 2*s)**2) + 120*r**2 + 169*r*s - 57*r + 49*s**2 - 45*s - 6) + 3*Pkdd2*k3**2*(6*s**2 - 6*s + 1))) + k2**2*k3**2*(2*Pk2*cosphi**2*k3**2*(k2**2*(48*r**2 + 84*r*s - 48*r + 3) + 5*k3**2*(2*r**2 - 2*r + 1)) - 42*Pk2*k2**4*r*(2*r + 2*s - 1) + Pk2*k2**2*k3**2*(48*r**2 + 7*r*(5*s - 3) + 7*s) - 7*Pk2*k3**4*s*(r - 1) + 21*Pkd2*k2**3*k3**2*r*(2*s - 1))) - 7*k3**6*(5*b2*k1**2*(2*Pk2 + k2*(-2*Pkd2 + Pkdd2*k2))*(s - 1)**2 - 2*g2*(-8*Pk2*k2**2*r**2 + k1**2*(8*Pk2 + 5*k2*(-2*Pkd2 + Pkdd2*k2))*(s - 1)**2))) + 7*f*k3**6*(2*Pk2*b2*cosphi**2*k2**2*(2*r**2 - 2*r + 1) - 4*Pk2*cosphi**2*g2*k2**2*(2*r**2 - 2*r + 1) + b2*k1**2*s**2*(-2*Pk2 + Pkd2*k2) + 2*g2*k1**2*s**2*(4*Pk2 - Pkd2*k2)))/(7*d**2*k1**2*k2**2*k3**6) + D1**4*Pk1*f*mu**3*mu2*(-112*b1**3*k2**3*k3**6*r*(2*Pk2*k2*r - Pkd2*k1**2*s) - 2*b1**2*(-28*Pk2*k2**4*k3**6*(f*(26*r**2 - 29*r + 11) + 4*(r - 1)**2) + 7*cosphi**2*f*k3**6*(-3*Pk2*k2**4*(2*r**2 - 2*r + 1) + 2*k1**4*(4*Pk2 - Pkd2*k2)*(6*s**2 - 7*s + 2) + k1**2*k2**2*(Pk2*(-12*r**2 - 64*r*s + 22*r + 48*s**2 - 20*s + 5) - 2*Pkd2*k2*(12*s**2 - 7*s + 2))) + 4*k1**6*(96*Pk2*k2**4*(r + s)**2 - 14*Pk2*k2**2*k3**2*(r**2 + 4*r*s + 3*s**2) - 14*Pk2*k3**4*s**2 - 12*Pkd2*k2**3*k3**2*s*(r + s) + 7*Pkd2*k2*k3**4*s**2) - 2*k1**4*k3**2*(28*Pk2*k2**4*(r**2 + 4*r*s + 3*s**2) + Pk2*k3**4*s**2*(42*f + 28) - 14*Pkd2*k2**3*k3**2*s**2 - Pkd2*k2*k3**4*s**2*(42*f + 14) + k2**2*k3**2*s*(-32*Pk2*(r + s) + 21*Pkdd2*f*k3**2*s)) - k1**2*k2**2*k3**4*(56*Pk2*k2**2*r*(r + 2*s) + k3**2*(14*Pk2*f*(24*r**2 - 13*r - 2*s + 6) + 8*Pk2*(r - 1)*(7*r - 4*s - 7) + 4*Pkd2*k2*s*(20*r - 7*s - 20) + 7*f*k2*(Pkd2*r*(8 - 48*s) + 6*Pkd2*s*(s + 2) + 3*Pkdd2*k2*s**2)))) + b1*(7*f**2*k3**6*(24*Pk2*k2**4*r**2 + 2*k1**4*(2*Pk2*(8*cosphi**2*(9*s**2 - 9*s + 2) - 4*s**2 + 12*s - 5) - k2*(Pkd2*(4*cosphi**2*(9*s**2 - 9*s + 2) - 7*s**2 + 16*s - 6) + Pkdd2*k2*(3*s**2 - 4*s + 1))) - k1**2*k2**2*(4*Pk2*cosphi**2*(15*r**2 + r*(72*s - 34) - 36*s**2 - 6*s + 9) + 6*Pk2*(8*r**2 - 8*r*(s + 1) - 4*s + 3) + k2*(2*Pkd2*(2*cosphi**2*(18*s**2 - 9*s + 2) - 24*r*s + 12*r + 12*s - 5) + Pkdd2*k2*(6*s**2 - 4*s + 1)))) + 4*f*(Pk2*k2**4*k3**4*r*(14*cosphi**2 - 28)*(k2**2 + k3**2)*(2*r - 1) + k1**6*(24*Pk2*k2**4*(26*r**2 + r*(52*s - 30) + 26*s**2 - 30*s + 9) - 2*Pk2*k2**2*k3**2*(42*r**2 + 14*r*(13*s - 3) + 140*s**2 - 111*s + 14) - 7*Pk2*k3**4*(12*s**2 - 5*s + 2) - 12*Pkd2*k2**3*k3**2*(3*s - 1)*(2*r + 2*s - 1) + 7*Pkd2*k2*k3**4*(6*s**2 - 3*s + 1)) + k1**4*(48*Pk2*k2**6*(4*r**2 + 2*r*(5*s - 1) + s*(5*s - 3)) + Pk2*k2**2*k3**4*(2*cosphi**2*(14*r**2 + 66*r*s - 45*r - 72*s**2 + 84*s - 24) - 28*r**2 - 2*r*(s - 6) + 112*s**2 + 3*s - 21) - 7*Pk2*k3**6*(4*s**2 - 5*s + 2) - 12*Pkd2*k2**5*k3**2*s*(8*r + 8*s - 3) + Pkd2*k2**3*k3**4*(12*cosphi**2*(6*s**2 - 7*s + 2) + 92*s**2 + s*(42*r - 35) + 7) + 7*Pkd2*k2*k3**6*(2*s**2 - 3*s + 1) + 2*k2**4*k3**2*(-Pk2*(12*cosphi**2*(2*r**2 + 8*r*s - 5*r + 6*s**2 - 7*s + 2) - 12*r**2 + 264*r*s + 39*r + 232*s**2 - 113*s - 40) + 9*Pkdd2*k3**2*s**2)) + k1**2*k2**2*k3**2*(-2*Pk2*k2**4*(r**2*(24*cosphi**2 + 18) + r*(12*cosphi**2*(2*s - 1) + 46*s - 9) - s*(12*cosphi**2 - 14*s + 2)) + Pk2*k2**2*k3**2*(2*cosphi**2*(46*r**2 + 90*r*s - 46*r - 24*s + 9) + 36*r**2 - 226*r*s - 74*r + 28*s**2 + 138*s + 37) + Pk2*k3**4*(2*cosphi**2*(2*r - 1)*(7*r + 20*s - 20) - 28*r**2 + 16*r*s + 6*r - 27*s) + 2*Pkd2*k2**3*k3**2*s*(9*r + 7*s - 1) - Pkd2*k2*k3**4*(s - 1)*(40*r - 14*s - 13))) + 112*k1**2*k2**2*k3**6*s*(r - 1)*(Pkd2*b2*k2 - 2*g2*(Pk2 + Pkd2*k2))) + 4*f*k1**2*(f*(-2*k1**4*(24*Pk2*k2**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + Pk2*k2**2*k3**2*(-14*r**2 + r*(7 - 28*s) + s*(20 - 14*s)) + 7*Pk2*k3**4*s*(1 - 2*s) - 6*Pkd2*k2**3*k3**2*(s - 1)*(2*r + 2*s - 1) + 7*Pkd2*k2*k3**4*s*(s - 1)) + k1**2*k2**2*(-24*Pk2*k2**4*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + Pk2*k3**4*(-84*cosphi**2*r**2 + r*(cosphi**2*(214 - 270*s) + 13*s - 7) + 2*s*(12*cosphi**2*(9*s - 7) + 7)) + 12*Pkd2*k2**3*k3**2*(r*(3*s - 2) + 3*s**2 - 4*s + 1) + Pkd2*k2*k3**4*(-12*cosphi**2*(9*s**2 - 9*s + 2) - 21*r*s + 2*r - 14*s**2 + 14*s + 6) + k2**2*(2*Pk2*k3**2*(12*cosphi**2*(6*r**2 + 15*r*s - 11*r + 9*s**2 - 11*s + 4) + 44*r**2 + 67*r*s - 27*r + 23*s**2 - 26*s - 3) - 3*Pkdd2*k3**4*(3*s**2 - 4*s + 1))) + k2**4*k3**2*r*(14*Pk2*k2**2*(3*r + 3*s - 2) + Pk2*k3**2*(-14*cosphi**2*(6*r + 9*s - 5) + 22*r - 21*s + 7) - 7*Pkd2*k2*k3**2*(3*s - 2))) - 14*k2**2*k3**6*(b2*(-2*Pk2*cosphi**2*(2*r - 1)*(s - 1) + Pk2*s + Pkd2*k2*(2*r - 1)*(s - 1)) + 2*g2*(2*Pk2*cosphi**2*(2*r - 1)*(s - 1) + Pk2*(-2*r*s + r - s) + Pkd2*k2*(-2*r*s + 2*r + s - 1)))))/(7*d**2*k1**3*k2**3*k3**6) + D1**4*Pk1*f*mu*mu2**3*(-28*b1**3*k1**2*k3**6*s**2*(k1**2*(8*Pk2 + k2*(-5*Pkd2 + Pkdd2*k2)) + k2**3*(-Pkd2 + Pkdd2*k2)) + b1**2*(112*Pk2*k2**4*k3**4*r**2*(k2**2 + k3**2*(2*f + 1)) + k1**4*(-768*Pk2*k2**6*(r + s)**2 + 16*k2**4*k3**2*(r + s)*(7*Pk2*(3*r + s) + 18*Pkd2*k2*s) - 8*k2**2*k3**4*s*(-14*Pk2*(2*r + s) + k2*(Pkd2*(14*r + s) + 6*Pkdd2*k2*s)) + 7*k3**6*(4*Pk2*(f*(26*s**2 - 28*s + 13) + 8*(s - 1)**2) + k2*(-4*Pkd2*(f*(17*s**2 - 19*s + 7) + 2*(s - 1)**2) + Pkdd2*f*k2*(14*s**2 - 16*s + 5)))) + k1**2*k2**2*k3**2*(112*Pk2*k2**4*(3*r**2 + 4*r*s + s**2) - 8*k2**2*k3**2*(16*Pk2*r*(r + s) + 7*Pkd2*k2*s*(2*r + s)) + k3**4*(2*Pk2*(7*f*(64*r*s - 20*r - 4*s**2 - 4*s + 3) + (s - 1)*(-32*r + 56*s - 56)) + 7*k2*(4*Pkd2*f*(r - 6*s**2 + 3*s - 2) - 8*Pkd2*(s - 1)**2 + Pkdd2*f*k2*(28*s**2 - 16*s + 5))))) - b1*(224*Pk2*g2*k1**2*k2**2*k3**6*r*(s - 1) + 7*f**2*k3**6*(4*Pk2*k2**4*(cosphi**2*(9*r**2 - 6*r + 3) + 4*r**2 - 12*r + 5) + 6*k1**4*s**2*(-4*Pk2 + Pkd2*k2) + k1**2*k2**2*(2*Pk2*cosphi**2*(18*r**2 - 6*r - 240*s**2 + 176*s - 29) + 6*Pk2*(-4*r*(2*s + 1) + 8*s**2 - 8*s + 3) + 2*Pkd2*k2*(cosphi**2*(60*s**2 - 44*s + 8) + 6*r - 17*s**2 + 16*s - 5) + Pkdd2*k2**2*(10*s**2 - 8*s + 1))) - 4*f*(-7*Pk2*k2**4*k3**4*(k2**2*(10*r**2 - 5*r + 3) + k3**2*(2*r**2 - 5*r + 3)) + k1**6*(24*Pk2*k2**4*(10*r**2 + r*(20*s - 6) + 10*s**2 - 6*s + 1) - 2*Pk2*k2**2*k3**2*(14*r**2 + r*(46*s - 2) + 32*s**2 - 23*s + 7) + 28*Pk2*k3**4*s*(1 - 2*s) - 12*Pkd2*k2**3*k3**2*(r + s)*(2*s - 1) + 7*Pkd2*k2*k3**4*s*(2*s - 1)) + k1**4*(24*Pk2*k2**6*(24*r**2 + r*(52*s - 30) + 26*s**2 - 30*s + 9) + Pk2*k2**2*k3**4*(42*r**2 + r*(48 - 94*s) - 76*s**2 + 62*s + 5) + 28*Pk2*k3**6*s*(1 - 2*s) - 24*Pkd2*k2**5*k3**2*(2*s - 1)*(5*r + 5*s - 3) + Pkd2*k2**3*k3**4*(2*r*(61*s - 31) + 20*s**2 + s - 17) + 7*Pkd2*k2*k3**6*s*(2*s - 1) + k2**4*(-2*Pk2*k3**2*(224*r**2 + 360*r*s - 173*r + 104*s**2 - 89*s + 6) + 3*Pkdd2*k3**4*(14*s**2 - 16*s + 5))) + k1**2*k2**2*k3**2*(-2*Pk2*k2**4*(138*r**2 + r*(206*s - 111) + 42*s**2 - 54*s + 8) + Pk2*k2**2*k3**2*(124*r**2 + 178*r*s - 39*r - 64*s - 14) + Pk2*k3**4*(14*r**2 + r*(96*s - 107) - 28*s**2 - 34*s + 33) + 7*Pkd2*k2**3*k3**2*(2*r*(7*s - 4) + 6*s**2 - 4*s + 1) + Pkd2*k2*k3**4*(10*r + 7*s*(2*s - 1))))) + 4*f*k2**2*(f*(-2*Pk2*k1**6*(12*k2**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 7*k3**2*s*(3*r + 3*s - 2)) - 14*Pk2*k2**4*k3**4*r*(cosphi**2*(6*r - 2) - 2*r + 1) + k1**4*(-48*Pk2*k2**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 2*Pk2*k2**2*k3**2*(23*r**2 + r*(67*s - 26) + 44*s**2 - 27*s - 3) + Pk2*k3**4*s*(-21*r + 22*s + 7) + 12*Pkd2*k2**3*k3**2*(2*s - 1)*(r + s - 1) + Pkd2*k2*k3**4*s*(7 - 23*s)) + k1**2*k2**2*k3**2*(2*Pk2*cosphi**2*(12*k2**2*(3*r - 1)*(2*r + 2*s - 1) + k3**2*(-69*r**2 - 72*r*s + 68*r + 24*s - 21)) + 2*Pk2*k2**2*(14*r**2 + 4*r*(7*s - 5) + 7*s*(2*s - 1)) + Pk2*k3**2*(r*(13*s + 14) - 7*s) + Pkd2*k2*k3**2*(-6*r + s*(7 - 14*s)))) + 7*k1**2*k3**6*(2*Pk2*b2*(r*(4*s - 5) - 2*s + 2) - 4*Pk2*g2*(r*(2*s - 5) - s + 2) + Pkd2*b2*k2*r - 2*Pkd2*g2*k2*r)))/(7*d**2*k1**3*k2**3*k3**6) - D1**4*Pk1*f*mu*mu2*(-7*b1**3*k3**6*(10*Pk2*k1**4*s**2 - 8*Pkd2*k1**4*k2*s**2 + 4*Pkd2*k1**2*k2**3*s**2 + 3*Pkdd2*k1**4*k2**2*s**2 + 3*k2**4*(4*Pk2*r**2 + Pkdd2*k1**2*s**2)) + b1**2*(14*Pk2*k2**4*k3**4*(4*k2**2*r**2 + k3**2*(f*(cosphi**2*(6*r**2 - 6*r + 3) + 3*r**2 - 12*r + 5) + 10*r**2 - 12*r + 6)) + 4*k1**6*(-120*Pk2*k2**4*(r + s)**2 + 14*Pk2*k2**2*k3**2*(r**2 + 5*r*s + 4*s**2) + 14*Pk2*k3**4*s**2 + 12*Pkd2*k2**3*k3**2*s*(r + s) - 7*Pkd2*k2*k3**4*s**2) - k1**4*(96*Pk2*k2**6*(4*r**2 + 10*r*s + 5*s**2) - 32*k2**4*k3**2*(Pk2*(13*r**2 + 34*r*s + 17*s**2) + 6*Pkd2*k2*s*(r + s)) + 4*k2**2*k3**4*(Pk2*(7*r**2 + 23*r*s + 24*s**2) + k2*s*(33*Pkd2*r + 26*Pkd2*s + 9*Pkdd2*k2*s)) + 7*k3**6*(2*Pk2*(f*(8*cosphi**2*(6*s**2 - 7*s + 2) - 3*s**2 + 12*s - 5) - 8*s**2 + 8*s - 4) + k2*(Pkd2*(f*(-4*cosphi**2*(6*s**2 - 7*s + 2) + 6*s**2 - 16*s + 6) + 8*s**2 - 8*s + 4) + Pkdd2*f*k2*(-3*s**2 + 4*s - 1)))) + k1**2*k2**2*k3**2*(56*Pk2*k2**4*(3*r**2 + 5*r*s + s**2) - 4*k2**2*k3**2*(Pk2*(9*r**2 + 23*r*s + 14*s**2) + 7*Pkd2*k2*s*(3*r + s)) + k3**4*(2*Pk2*(7*cosphi**2*f*(12*r**2 + r*(64*s - 22) - 48*s**2 + 20*s - 5) + 14*r**2 - 4*r*(28*f*s + 8*s + 3) + 16*s + 14) + 7*k2*(Pkd2*(f*(4*cosphi**2*(12*s**2 - 7*s + 2) + 4*r + 3*s**2 - 2) - 8*s**2 + 8*s - 4) + Pkdd2*f*k2*(6*s**2 - 4*s + 1))))) + 4*b1*(28*Pk2*g2*k1**2*k2**2*k3**6*(-2*r*s + r + s) + f*(Pk2*k2**4*k3**4*r*(14*cosphi**2 - 7)*(k2**2 + k3**2)*(2*r - 1) + k1**6*(24*Pk2*k2**4*(5*r**2 + 2*r*(5*s - 3) + 5*s**2 - 6*s + 1) - 2*Pk2*k2**2*k3**2*(7*r**2 + 35*r*s + s*(28*s - 27)) + 7*Pk2*k3**4*s*(1 - 2*s) - 12*Pkd2*k2**3*k3**2*(r + s)*(s - 1) + 7*Pkd2*k2*k3**4*s*(s - 1)) + k1**4*(24*Pk2*k2**6*(5*r**2 + 2*r*(5*s - 3) + 5*s**2 - 6*s + 1) + Pk2*k2**2*k3**4*(2*cosphi**2*(14*r**2 + 66*r*s - 45*r - 72*s**2 + 84*s - 24) + 14*r**2 + 2*r*(2*s + 7) + 3*s*(8*s - 7)) + 7*Pk2*k3**6*s*(1 - 2*s) - 12*Pkd2*k2**5*k3**2*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + Pkd2*k2**3*k3**4*(12*cosphi**2*(6*s**2 - 7*s + 2) + r*(33*s - 20) + 23*s**2 - 7*s - 6) + 7*Pkd2*k2*k3**6*s*(s - 1) + k2**4*k3**2*(-2*Pk2*(12*cosphi**2*(2*r**2 + 8*r*s - 5*r + 6*s**2 - 7*s + 2) + 65*r**2 + 130*r*s - 51*r + 65*s**2 - 51*s - 6) + 3*Pkdd2*k3**2*(3*s**2 - 4*s + 1))) + k1**2*k2**2*k3**2*(2*Pk2*cosphi**2*(-12*k2**4*(r + s)*(2*r - 1) + k2**2*k3**2*(46*r**2 + 90*r*s - 46*r - 24*s + 9) + k3**4*(2*r - 1)*(7*r + 20*s - 20)) - 2*Pk2*k2**4*(28*r**2 + r*(35*s - 27) + 7*s**2) + Pk2*k2**2*k3**2*(24*r**2 + r*(4*s - 21) + 14*s*(s + 1)) - Pk2*k3**4*(r*(12*s + 7) + 7*s) + 7*Pkd2*k2**3*k3**2*(r*(3*s - 2) + s**2) + Pkd2*k2*k3**4*(10*r + s*(7*s - 7))))) + 28*f*k1**2*k2**2*k3**6*(4*Pk2*b2*cosphi**2*(2*r - 1)*(s - 1) - 8*Pk2*cosphi**2*g2*(2*r - 1)*(s - 1) + b2*r*(-2*Pk2*s + Pkd2*k2) - 2*g2*r*(-4*Pk2*s + Pkd2*k2)))/(7*d**2*k1**3*k2**3*k3**6) + 32*D1**4*Pk2*Pkd1*b1*ct**2*f**2*k1*mu**6*(2*k1**2*(6*r**2 + 6*r*(s - 1) - 3*s + 2) + 9*k3**2*(3*r**2 - 3*r + 1))/(7*d**2*k3**4) + 2*D1**4*Pk2*Pkd1*b1*ct*f**2*mu**6*(-63*f*k3**4*r*(3*r - 1) + 28*k1**4*(6*r**2 + 6*r*(s - 1) - 3*s + 2) + 2*k1**2*(14*k2**2*(6*r**2 + 6*r*(s - 1) - 3*s + 2) + k3**2*(105*r**2 - 3*r*(32*s + 35) + 48*s + 35)) - 63*k2**2*k3**2*(-6*r**2 + 6*r - 2))/(7*d**2*k2*k3**4) + 36*D1**4*Pk2*Pkd1*b1*f**3*mu**7*mu2*(6*r**2 - 4*r + 1)/(d**2*k2) + 8*D1**4*Pk2*Pkd1*ct**4*f**3*k1*mu**4*r*(4*k1**2*(r + s - 1) + 9*k3**2*r)/(7*d**2*k3**4) - 32*D1**4*Pk2*Pkd1*ct**3*f**3*k1*mu**5*mu2*(2*k1**2*(6*r**2 + 6*r*(s - 1) - s + 1) + 9*k3**2*r*(3*r - 1))/(7*d**2*k3**4) + 32*D1**4*Pk2*Pkd1*ct**2*f**3*k1*mu**6*mu2**2*(k1**2*(24*r**2 + 24*r*(s - 1) - 8*s + 6) + 9*k3**2*(6*r**2 - 4*r + 1))/(7*d**2*k3**4) + 2*D1**4*Pk2*Pkd1*ct*f**3*mu**6*mu2**2*(-189*f*k3**4*r*(4*r - 1) + 28*k1**4*(12*r**2 + 12*r*(s - 1) - 4*s + 3) + 2*k1**2*(14*k2**2*(12*r**2 + 12*r*(s - 1) - 4*s + 3) + k3**2*(210*r**2 - 4*r*(48*s + 19) + 64*s + 19)) + 126*k2**2*k3**2*(6*r**2 - 4*r + 1))/(7*d**2*k2*k3**4) + 36*D1**4*Pk2*Pkd1*f**4*mu**7*mu2**3*(10*r**2 - 5*r + 1)/(d**2*k2) - D1**4*Pk2*Pkdd1*b1**2*ct**3*f*r**2*(k1**2*(23*k2**2 + 7*k3**2) + 7*k2**2*(k2**2 + k3**2))/(7*d**2*k1*k2*k3**2) - D1**4*Pk2*Pkdd1*b1**2*ct*f*(7*k1**4*r**2 + k1**2*(19*k2**2*r**2 + 7*k3**2*(r**2*(b1 + 1) - 2*r + 1)) + 7*k2**2*k3**2*(r**2*(b1 + 1) - 2*r + 1))/(7*d**2*k1*k2*k3**2) - 48*D1**4*Pk2*Pkdd1*b1*ct**4*f**2*k1*k2*mu*mu2*r**2/(7*d**2*k3**2) - 48*D1**4*Pk2*Pkdd1*b1*ct**4*f**2*k2**2*mu2**2*r**2/(7*d**2*k3**2) - 2*D1**4*Pk2*Pkdd1*b1*ct**4*f*r**2*(2*b1*(2*k2**2 + k3**2) + 7*g2*k3**2)/(7*d**2*k3**2) - 6*D1**4*Pk2*Pkdd1*b1*ct**3*f**2*mu2**2*r**2*(15*k1**2*k2 + 7*k2**3)/(7*d**2*k1*k3**2) - D1**4*Pk2*Pkdd1*b1*ct**3*f*mu**2*r*(-32*b1*k1**2*k2**2*r + f*(7*k1**4*r + k1**2*(k2**2*(62*r - 32) + 7*k3**2*r) + 7*k2**2*r*(k2**2 + k3**2)))/(7*d**2*k1*k2*k3**2) - 32*D1**4*Pk2*Pkdd1*b1*ct**2*f**2*k1**2*mu**6*(3*r**2 - 3*r + 1)/(7*d**2*k3**2) - D1**4*Pk2*Pkdd1*b1*ct**2*f*(7*b1**2*k3**2*r**2 + 2*b1*(k3**2*(7*r**2 - 4*r + 2) + r**2*(11*k1**2 + 10*k2**2)) + 7*k3**2*(b2*r**2 + g2*(2 - 4*r)))/(7*d**2*k3**2) - D1**4*Pk2*Pkdd1*b1*ct**2*f*mu*mu2*(-4*b1*r**2*(k1**2*(19*k2**2 + 7*k3**2) + 7*k2**2*(k2**2 + k3**2)) + f*(28*k1**4*r**2 + k1**2*(4*k2**2*(35*r**2 - 23*r + 4) + 7*k3**2*r*(3*b1*r + 4*r - 4)) + 14*k2**2*r*(2*k2**2*(r - 1) + k3**2*(3*b1*r + 2*r - 2))))/(7*d**2*k1*k2*k3**2) - 2*D1**4*Pk2*Pkdd1*b1*ct*f**2*k1*mu**6*(f*k3**2*r*(1 - 3*r) + k1**2*(6*r**2 - 6*r + 2) + k2**2*(6*r**2 - 6*r + 2))/(d**2*k2*k3**2) + D1**4*Pk2*Pkdd1*b1*ct*f*mu**4*(-28*b1*(k1**2 + k2**2)*(k1**2*r**2 + k3**2*(r - 1)**2) - 7*f**2*k1**2*k3**2*r*(5*r - 2) + f*(14*b1*k2**2*k3**2*r*(2*r - 1) + 7*k1**4*(18*r**2 - 18*r + 5) + k1**2*(14*b1*k3**2*r*(4*r - 1) + k2**2*(174*r**2 - 150*r + 35))))/(7*d**2*k1*k2*k3**2) + D1**4*Pk2*Pkdd1*b1*ct*f*mu**2*(b1*(35*k1**4*r**2 + k1**2*(59*k2**2*r**2 + 7*k3**2*(r**2*(2*b1 + 5) - 10*r + 5)) + 7*k2**2*k3**2*(r**2*(2*b1 + 5) - 10*r + 5)) - f*(7*b1*k2**2*k3**2*r*(3*r - 2) + 7*k1**4*(6*r**2 - 6*r + 1) + k1**2*(14*b1*k3**2*r*(3*r - 1) + k2**2*(78*r**2 - 66*r + 7))))/(7*d**2*k1*k2*k3**2) - D1**4*Pk2*Pkdd1*b1*ct*f*mu2**2*(-7*b1*r**2*(k1**2 + k2**2)*(k2**2 + k3**2) + f*(7*k1**4*r**2 + k1**2*(k2**2*(50*r**2 - 14*r + 7) + 7*k3**2*(3*b1*r**2 + r**2 - 2*r + 1)) + 7*k2**2*(k2**2*(r - 1)**2 + k3**2*(6*b1*r**2 + r**2 - 2*r + 1))))/(7*d**2*k1*k2*k3**2) - 4*D1**4*Pk2*Pkdd1*b1*f**3*k1*mu**7*mu2*(6*r**2 - 4*r + 1)/(d**2*k2) - 4*D1**4*Pk2*Pkdd1*b1*f**2*mu**6*(7*b1*k3**2 + 6*k1**2)*(3*r**2 - 3*r + 1)/(7*d**2*k3**2) - D1**4*Pk2*Pkdd1*b1*f**2*mu**5*mu2*(28*b1*k2**2*k3**2*(3*r**2 - 3*r + 1) + k1**2*(48*k2**2*(3*r**2 - 3*r + 1) + 7*k3**2*(4*b1*(6*r**2 - 3*r + 1) + f*(-33*r**2 + 24*r - 5))))/(7*d**2*k1*k2*k3**2) - D1**4*Pk2*Pkdd1*b1*f*mu**4*(28*b1**2*k3**2*r**2 + 8*b1*(3*k1**2*r**2 + 5*k3**2*(r - 1)**2) - f*(7*b1*k3**2 + 6*k1**2)*(18*r**2 - 18*r + 5) + k3**2*(28*b2 - 56*g2)*(r - 1)**2)/(7*d**2*k3**2) + D1**4*Pk2*Pkdd1*b1*f*mu**2*(35*b1**2*k3**2*r**2 + 10*b1*(3*k1**2*r**2 + 5*k3**2*(r - 1)**2) - f*(7*b1*k3**2 + 6*k1**2)*(6*r**2 - 6*r + 1) + 5*k3**2*(7*b2 - 14*g2)*(r - 1)**2)/(7*d**2*k3**2) - D1**4*Pk2*Pkdd1*b1*f*(7*b1**2*k3**2*r**2 + 2*b1*(3*k1**2*r**2 + 5*k3**2*(r - 1)**2) + k3**2*(7*b2 - 14*g2)*(r - 1)**2)/(7*d**2*k3**2) - D1**4*Pk2*Pkdd1*b1*f*mu**3*mu2*(4*b1*r**2*(7*b1*k2**2*k3**2 + k1**2*(7*b1*k3**2 + 12*k2**2)) + 7*f**2*k1**2*k3**2*(10*r**2 - 8*r + 1) - f*(7*b1*k2**2*k3**2*(14*r**2 - 16*r + 5) + k1**2*(7*b1*k3**2*(28*r**2 - 16*r + 5) + 12*k2**2*(14*r**2 - 16*r + 5))))/(7*d**2*k1*k2*k3**2) + D1**4*Pk2*Pkdd1*b1*f*mu*mu2*(3*b1*r**2*(7*b1*k2**2*k3**2 + k1**2*(7*b1*k3**2 + 12*k2**2)) - f*(7*b1*k2**2*k3**2*(3*r**2 - 4*r + 1) + k1**2*(7*b1*k3**2*(6*r**2 - 4*r + 1) + 12*k2**2*(3*r**2 - 4*r + 1))))/(7*d**2*k1*k2*k3**2) - 8*D1**4*Pk2*Pkdd1*ct**4*f**3*k1**2*mu**4*r**2/(7*d**2*k3**2) - 48*D1**4*Pk2*Pkdd1*ct**4*f**3*k1*k2*mu**3*mu2*r**2/(7*d**2*k3**2) - 48*D1**4*Pk2*Pkdd1*ct**4*f**3*k2**2*mu**2*mu2**2*r**2/(7*d**2*k3**2) - 2*D1**4*Pk2*Pkdd1*ct**4*f**2*mu**2*r**2*(2*b1*(2*k1**2 + 2*k2**2 + k3**2) + 7*g2*k3**2)/(7*d**2*k3**2) + 32*D1**4*Pk2*Pkdd1*ct**3*f**3*k1**2*mu**5*mu2*r*(3*r - 1)/(7*d**2*k3**2) + 96*D1**4*Pk2*Pkdd1*ct**3*f**3*k1*k2*mu**4*mu2**2*r*(3*r - 1)/(7*d**2*k3**2) + 64*D1**4*Pk2*Pkdd1*ct**3*f**3*k2**2*mu**3*mu2**3*r*(3*r - 1)/(7*d**2*k3**2) - D1**4*Pk2*Pkdd1*ct**3*f**2*k1*mu**4*r*(32*b1*k2**2*(1 - 2*r) + 7*f*r*(k1**2 + k2**2))/(7*d**2*k2*k3**2) - 64*D1**4*Pk2*Pkdd1*ct**3*f**2*k2**2*mu*mu2**3*r*(-2*b1*r + f*(r - 1))/(7*d**2*k3**2) + 2*D1**4*Pk2*Pkdd1*ct**3*f**2*mu**3*mu2*r*(4*b1*(8*k1**2*r + k2**2*(8*r - 4) + k3**2*(4*r - 2)) + f*k1**2*(16 - 53*r) - 21*f*k2**2*r + 28*g2*k3**2*(2*r - 1))/(7*d**2*k3**2) - 6*D1**4*Pk2*Pkdd1*ct**3*f**2*k2*mu**2*mu2**2*r*(-32*b1*k1**2*r + f*k1**2*(31*r - 16) + 7*f*k2**2*r)/(7*d**2*k1*k3**2) + 2*D1**4*Pk2*Pkdd1*ct**3*f*mu*mu2*r*(8*b1**2*r*(2*k2**2 + k3**2) + b1*f*(-37*k1**2*r + k2**2*(16 - 37*r) - 8*k3**2*(r - 1)) + 28*b1*g2*k3**2*r - 28*f*g2*k3**2*(r - 1))/(7*d**2*k3**2) - 32*D1**4*Pk2*Pkdd1*ct**2*f**3*k1**2*mu**6*mu2**2*(6*r**2 - 4*r + 1)/(7*d**2*k3**2) - 64*D1**4*Pk2*Pkdd1*ct**2*f**3*k1*k2*mu**5*mu2**3*(6*r**2 - 4*r + 1)/(7*d**2*k3**2) - 32*D1**4*Pk2*Pkdd1*ct**2*f**3*k2**2*mu**4*mu2**4*(6*r**2 - 4*r + 1)/(7*d**2*k3**2) - D1**4*Pk2*Pkdd1*ct**2*f**2*k1*mu**5*mu2*(64*b1*k2**2*(3*r**2 - 3*r + 1) + 7*f*r*(3*f*k3**2*r + k1**2*(4 - 12*r) + k2**2*(4 - 12*r)))/(7*d**2*k2*k3**2) + 8*D1**4*Pk2*Pkdd1*ct**2*f**2*k2**2*mu**2*mu2**4*(-12*b1*r**2 + f*(15*r**2 - 18*r + 5))/(7*d**2*k3**2) - 8*D1**4*Pk2*Pkdd1*ct**2*f**2*k2**2*mu2**4*(-2*b1*r**2 + f*(r - 1)**2)/(7*d**2*k3**2) - 4*D1**4*Pk2*Pkdd1*ct**2*f**2*mu**4*mu2**2*(4*b1*(6*k1**2*r**2 + k2**2*(6*r**2 - 6*r + 2) + k3**2*(3*r**2 - 3*r + 1)) + 21*f**2*k3**2*r**2 + f*(k1**2*(-117*r**2 + 65*r - 10) + 21*k2**2*r*(1 - 3*r)) + 14*g2*k3**2*(3*r**2 - 3*r + 1))/(7*d**2*k3**2) - 2*D1**4*Pk2*Pkdd1*ct**2*f**2*k2*mu**3*mu2**3*(96*b1*k1**2*r**2 + 35*f**2*k3**2*r**2 - 4*f*(k1**2*(63*r**2 - 47*r + 10) + 7*k2**2*r*(3*r - 1)))/(7*d**2*k1*k3**2) - 2*D1**4*Pk2*Pkdd1*ct**2*f**2*k2*mu*mu2**3*(-8*b1*r**2*(13*k1**2 + 7*k2**2) + f*k1**2*(52*r**2 - 60*r + 8) + 7*f*r*(5*b1*k3**2*r + 4*k2**2*(r - 1)))/(7*d**2*k1*k3**2) - D1**4*Pk2*Pkdd1*ct**2*f*mu**4*(16*b1**2*(2*k1**2*r**2 + k3**2*(r - 1)**2) + b1*(21*f**2*k3**2*r**2 - 4*f*(k1**2*(50*r**2 - 43*r + 10) + 7*k2**2*r*(2*r - 1)) + 56*g2*k3**2*(r - 1)**2) + 6*f**2*k1**2*r**2)/(7*d**2*k3**2) - 2*D1**4*Pk2*Pkdd1*ct**2*f*mu**2*mu2**2*(4*b1*r**2*(2*b1*(2*k2**2 + k3**2) + 7*g2*k3**2) + f**2*(k1**2*(87*r**2 - 66*r + 4) + 3*r*(21*b1*k3**2*r + k2**2*(27*r - 14))) - f*(2*b1*(62*k1**2*r**2 + 2*k2**2*(31*r**2 - 14*r + 5) + k3**2*(10*r**2 - 14*r + 5)) + 7*g2*k3**2*(10*r**2 - 14*r + 5)))/(7*d**2*k3**2) - D1**4*Pk2*Pkdd1*ct**2*f*mu**2*(4*b1**2*(k3**2*(r**2*(7*f - 5) + 10*r - 5) - r**2*(17*k1**2 + 7*k2**2)) + 2*b1*(f*k1**2*(48*r**2 - 38*r + 4) + f*r*(2*k2**2*(12*r - 7) + 5*k3**2*r) - 35*g2*k3**2*(r - 1)**2) + 7*f*k3**2*r**2*(b2 - 2*g2))/(7*d**2*k3**2) - 2*D1**4*Pk2*Pkdd1*ct**2*f*mu2**2*(b1**2*r**2*(-4*k2**2 + k3**2*(21*f - 2)) + b1*(f*(25*k1**2*r**2 + k2**2*(43*r**2 - 8*r + 4) + 2*k3**2*(r - 1)**2) - 7*g2*k3**2*r**2) + 7*f*g2*k3**2*(r - 1)**2)/(7*d**2*k3**2) - 2*D1**4*Pk2*Pkdd1*ct**2*f*mu**3*mu2*(32*b1**2*k1**2*k2**2*r**2 + b1*f*(-28*k1**4*r**2 + k1**2*(-2*k2**2*(84*r**2 - 71*r + 20) + 7*k3**2*r*(3*f*r - 4*r + 2)) + 7*k2**2*r*(k2**2*(2 - 4*r) + k3**2*(3*f*r - 4*r + 2))) + 2*f**2*k1**2*r*(7*k1**2*(2*r - 1) + k2**2*(23*r - 7)))/(7*d**2*k1*k2*k3**2) - 2*D1**4*Pk2*Pkdd1*ct*f**3*k1*mu**6*mu2**2*(3*f*k3**2*r*(1 - 4*r) + 2*k1**2*(6*r**2 - 4*r + 1) + 2*k2**2*(6*r**2 - 4*r + 1))/(d**2*k2*k3**2) + 8*D1**4*Pk2*Pkdd1*ct*f**3*mu**5*mu2**3*(2*f*k3**2*r*(4*r - 1) + k1**2*(-6*r**2 + 4*r - 1) + k2**2*(-6*r**2 + 4*r - 1))/(d**2*k3**2) - 2*D1**4*Pk2*Pkdd1*ct*f**3*k2*mu**4*mu2**4*(5*f*k3**2*r*(1 - 4*r) + 2*k1**2*(6*r**2 - 4*r + 1) + 2*k2**2*(6*r**2 - 4*r + 1))/(d**2*k1*k3**2) + 4*D1**4*Pk2*Pkdd1*ct*f**2*mu**5*mu2*(-7*b1*(3*f*k3**2*r*(1 - 3*r) + k1**2*(6*r**2 - 6*r + 2) + k2**2*(6*r**2 - 6*r + 2)) + 6*f*k1**2*r*(3*r - 1))/(7*d**2*k3**2) - 2*D1**4*Pk2*Pkdd1*ct*f**2*mu**3*mu2**3*(84*b1*r**2*(k1**2 + k2**2) + 56*f**2*k3**2*r*(2*r - 1) - f*(28*b1*k3**2*r*(9*r - 1) + 7*k1**2*(21*r**2 - 20*r + 5) + k2**2*(219*r**2 - 164*r + 35)))/(7*d**2*k3**2) - 2*D1**4*Pk2*Pkdd1*ct*f**2*mu*mu2**3*(-2*b1*r**2*(28*b1*k3**2 + 21*k1**2 + 45*k2**2) + f*(28*b1*k3**2*r*(3*r - 1) + 7*k1**2*(3*r**2 - 4*r + 1) + k2**2*(45*r**2 - 52*r + 7)))/(7*d**2*k3**2) + D1**4*Pk2*Pkdd1*ct*f**2*k2*mu**2*mu2**4*(-12*b1*r**2*(k1**2 + k2**2) - 5*f**2*k3**2*r*(3*r - 2) + f*(30*b1*k3**2*r**2 + k1**2*(15*r**2 - 18*r + 5) + k2**2*(15*r**2 - 18*r + 5)))/(d**2*k1*k3**2) - D1**4*Pk2*Pkdd1*ct*f**2*k2*mu2**4*(-2*b1*r**2*(k1**2 + k2**2) + f*(5*b1*k3**2*r**2 + k1**2*(r - 1)**2 + k2**2*(r - 1)**2))/(d**2*k1*k3**2) - D1**4*Pk2*Pkdd1*ct*f**2*mu**4*mu2**2*(28*b1*(k1**2 + k2**2)*(3*k1**2*r**2 + k2**2*(3*r**2 - 3*r + 1) + k3**2*(3*r**2 - 3*r + 1)) + 21*f**2*k1**2*k3**2*r*(5*r - 2) - f*(84*b1*k2**2*k3**2*r*(3*r - 1) + 7*k1**4*(27*r**2 - 22*r + 5) + k1**2*(42*b1*k3**2*r*(6*r - 1) + k2**2*(405*r**2 - 226*r + 35))))/(7*d**2*k1*k2*k3**2) + 2*D1**4*Pk2*Pkdd1*ct*f*mu**3*mu2*(14*b1**2*r*(f*k3**2*(8*r - 1) + r*(-2*k1**2 - 2*k2**2)) + b1*f*(k1**2*(122*r**2 - 112*r + 35) + k2**2*(122*r**2 - 124*r + 35) + k3**2*r*(20 - 42*f)*(2*r - 1)) - 2*f*r*(2*r - 1)*(6*f*k1**2 - k3**2*(7*b2 - 14*g2)))/(7*d**2*k3**2) + 2*D1**4*Pk2*Pkdd1*ct*f*mu*mu2*(14*b1**3*k3**2*r**2 + b1**2*r*(14*f*k3**2*(1 - 4*r) + r*(21*k1**2 + 33*k2**2 + 20*k3**2)) - b1*(f*k1**2*(33*r**2 - 28*r + 7) + f*(r - 1)*(k2**2*(33*r - 7) + 20*k3**2*r) + k3**2*r**2*(-14*b2 + 28*g2)) - 14*f*k3**2*r*(b2 - 2*g2)*(r - 1))/(7*d**2*k3**2) - D1**4*Pk2*Pkdd1*ct*f*mu**2*mu2**2*(28*b1**2*r**2*(k1**2 + k2**2)*(k2**2 + k3**2) - b1*f*(70*k1**4*r**2 + k1**2*(k2**2*(284*r**2 - 98*r + 35) + 7*k3**2*(r**2*(12*b1 + 10) - 14*r + 5)) + 7*k2**2*(k2**2*(10*r**2 - 14*r + 5) + k3**2*(r**2*(24*b1 + 10) - 14*r + 5))) + f**2*(42*b1*k2**2*k3**2*r*(3*r - 2) + 7*k1**4*(6*r**2 - 6*r + 1) + k1**2*(42*b1*k3**2*r*(3*r - 1) + k2**2*(150*r**2 - 114*r + 7))))/(7*d**2*k1*k2*k3**2) - 4*D1**4*Pk2*Pkdd1*f**4*k1*mu**7*mu2**3*(10*r**2 - 5*r + 1)/(d**2*k2) - 8*D1**4*Pk2*Pkdd1*f**4*mu**6*mu2**4*(10*r**2 - 5*r + 1)/d**2 - 4*D1**4*Pk2*Pkdd1*f**4*k2*mu**5*mu2**5*(10*r**2 - 5*r + 1)/(d**2*k1) - 12*D1**4*Pk2*Pkdd1*f**3*mu**6*mu2**2*(7*b1*k3**2 + 2*k1**2)*(6*r**2 - 4*r + 1)/(7*d**2*k3**2) + 2*D1**4*Pk2*Pkdd1*f**3*mu**4*mu2**4*(-12*k2**2*(6*r**2 - 4*r + 1) - 7*k3**2*(b1*(36*r**2 - 8*r + 2) + f*(-36*r**2 + 26*r - 5)))/(7*d**2*k3**2) + D1**4*Pk2*Pkdd1*f**3*k2*mu**3*mu2**5*(-24*b1*r**2 + f*(28*r**2 - 24*r + 5))/(d**2*k1) - D1**4*Pk2*Pkdd1*f**3*k2*mu*mu2**5*(-9*b1*r**2 + 3*f*r**2 - 4*f*r + f)/(d**2*k1) + D1**4*Pk2*Pkdd1*f**3*mu**5*mu2**3*(-56*b1*k2**2*k3**2*(6*r**2 - 4*r + 1) + k1**2*(-48*k2**2*(6*r**2 - 4*r + 1) - 7*k3**2*(4*b1*(12*r**2 - 4*r + 1) + f*(-44*r**2 + 28*r - 5))))/(7*d**2*k1*k2*k3**2) + D1**4*Pk2*Pkdd1*f**2*mu**4*mu2**2*(-28*b1**2*k3**2*(12*r**2 - 3*r + 1) - 8*b1*(9*k1**2*r**2 + k2**2*(9*r**2 - 9*r + 3) + 5*k3**2*(3*r**2 - 3*r + 1)) + 3*f*(7*b1*k3**2 + 2*k1**2)*(27*r**2 - 22*r + 5) - 4*k3**2*(7*b2 - 14*g2)*(3*r**2 - 3*r + 1))/(7*d**2*k3**2) - D1**4*Pk2*Pkdd1*f**2*mu**2*mu2**4*(-7*b1*f*k3**2*(45*r**2 - 18*r + 5) + 12*b1*r**2*(7*b1*k3**2 + 6*k2**2) + 14*f**2*k3**2*(6*r**2 - 6*r + 1) - 6*f*k2**2*(15*r**2 - 18*r + 5))/(7*d**2*k3**2) - D1**4*Pk2*Pkdd1*f**2*mu2**4*(7*b1*f*k3**2*(3*r**2 - 2*r + 1) - 2*b1*r**2*(7*b1*k3**2 + 6*k2**2) + 6*f*k2**2*(r - 1)**2)/(7*d**2*k3**2) + D1**4*Pk2*Pkdd1*f**2*mu**3*mu2**3*(-12*b1*r**2*(14*b1*k2**2*k3**2 + k1**2*(7*b1*k3**2 + 12*k2**2)) - 7*f**2*k1**2*k3**2*(10*r**2 - 8*r + 1) + f*(14*b1*k2**2*k3**2*(21*r**2 - 20*r + 5) + k1**2*(7*b1*k3**2*(42*r**2 - 20*r + 5) + 12*k2**2*(21*r**2 - 20*r + 5))))/(7*d**2*k1*k2*k3**2) - D1**4*Pk2*Pkdd1*f**2*mu*mu2**3*(-6*b1*r**2*(14*b1*k2**2*k3**2 + k1**2*(7*b1*k3**2 + 12*k2**2)) + f*(14*b1*k2**2*k3**2*(3*r**2 - 4*r + 1) + k1**2*(7*b1*k3**2*(6*r**2 - 4*r + 1) + 12*k2**2*(3*r**2 - 4*r + 1))))/(7*d**2*k1*k2*k3**2) - D1**4*Pk2*Pkdd1*f*mu**2*mu2**2*(4*b1*r**2*(7*b1**2*k3**2 + 2*b1*(3*k2**2 + 5*k3**2) + k3**2*(7*b2 - 14*g2)) + 3*f**2*(7*b1*k3**2 + 2*k1**2)*(6*r**2 - 6*r + 1) - f*(7*b1**2*k3**2*(40*r**2 - 14*r + 5) + 2*b1*(30*k1**2*r**2 + 3*k2**2*(10*r**2 - 14*r + 5) + 5*k3**2*(10*r**2 - 14*r + 5)) + k3**2*(7*b2 - 14*g2)*(10*r**2 - 14*r + 5)))/(7*d**2*k3**2) + D1**4*Pk2*Pkdd1*f*mu2**2*(7*b1**3*k3**2*r**2 + b1**2*(-7*f*k3**2*(4*r**2 - 2*r + 1) + r**2*(6*k2**2 + 10*k3**2)) - 2*b1*f*(3*k1**2*r**2 + 3*k2**2*(r - 1)**2 + 5*k3**2*(r - 1)**2) + 7*b1*k3**2*r**2*(b2 - 2*g2) - 7*f*k3**2*(b2 - 2*g2)*(r - 1)**2)/(7*d**2*k3**2) + 48*D1**4*Pkd1*b1*ct**4*f**2*mu2**2*r*(5*Pk2*k2**2*k3**2*r + k1**2*(2*Pk2*k2**2*(3*r + 3*s - 1) + 4*Pk2*k3**2*s - Pkd2*k2*k3**2*s))/(7*d**2*k1*k3**4) + 2*D1**4*Pkd1*b1*ct**4*f*r*(10*Pk2*b1*k3**2*r*(2*k2**2 + k3**2) + 35*Pk2*g2*k3**4*r + 8*b1*k1**2*(4*Pk2*k2**2*(r + s) + 2*Pk2*k3**2*s - Pkd2*k2*k3**2*s))/(7*d**2*k1*k3**4) + D1**4*Pkd1*b1*ct**3*f*(b1*(35*Pk2*k2**2*k3**2*r**2*(k2**2 + k3**2) + 2*k1**4*r*(76*Pk2*k2**2*(r + s) + 30*Pk2*k3**2*s - 15*Pkd2*k2*k3**2*s) + k1**2*(88*Pk2*k2**4*r*(r + s) + Pk2*k2**2*k3**2*r*(7*r - 32*s) + Pk2*k3**4*(7*r**2 + 16*r*s - 16*s) - 30*Pkd2*k2**3*k3**2*r*s + 8*Pkd2*k2*k3**4*(-2*r*s + r + s))) + 28*g2*k1**2*k3**4*(2*Pk2*s*(r - 1) + Pkd2*k2*(-2*r*s + r + s)))/(7*d**2*k1**2*k2*k3**4) + D1**4*Pkd1*b1*ct**2*f*mu2**2*(f*(2*k1**4*r*(2*Pk2*k2**2*(57*r + 57*s - 14) + 28*Pk2*k3**2*s - 7*Pkd2*k2*k3**2*s) + k1**2*(4*Pk2*k2**4*(184*r**2 + 184*r*s - 99*r - 15*s + 15) - 2*Pk2*k2**2*k3**2*(79*r**2 - 58*r*s + 21*r + 14*s) + 28*Pk2*k3**4*s*(3*b1*r + 2*r - 2) + 2*Pkd2*k2**3*k3**2*(-98*r*s + 37*r + 7*s) - 7*Pkd2*k2*k3**4*s*(3*b1*r + 2*r - 2)) + 2*k2**2*(14*Pk2*k2**4*(7*r**2 + r*(7*s - 5) - s + 1) - 3*Pk2*k2**2*k3**2*r*(27*r + 14*s - 7) + 7*Pk2*k3**4*(3*b1*r*(r + 2*s) + s*(2*r - 2)) + 7*Pkd2*k2**3*k3**2*(r*(3 - 7*s) + s) - 7*Pkd2*k2*k3**4*s*(3*b1*r + r - 1))) - 2*r*(-63*Pk2*g2*k2**2*k3**4*r + b1*(42*Pk2*k2**6*(r + s) + k1**2*(90*Pk2*k2**4*(r + s) - 37*k2**2*k3**2*s*(-2*Pk2 + Pkd2*k2) + 21*k3**4*(4*Pk2 - Pkd2*k2)*(s - 1)) - 3*k2**4*k3**2*(12*Pk2*r + 7*Pkd2*k2*s) + 3*k2**2*k3**4*(-2*Pk2*(3*r - 7*s + 7) - 7*Pkd2*k2*(s - 1)))))/(7*d**2*k1*k2**2*k3**4) + D1**4*Pkd1*b1*ct**2*f*(Pk2*k2**2*k3**4*r**2*(7*b2 - 84*g2) + 7*b1**2*k3**4*r*(2*Pk2*k1**2*s + Pk2*k2**2*r - Pkd2*k1**2*k2*s - Pkd2*k2**3*s) + 2*b1*(14*Pk2*k2**6*r*(r + s) + k1**4*r*(58*Pk2*k2**2*(r + s) + 14*Pk2*k3**2*s - 7*Pkd2*k2*k3**2*s) + k1**2*(96*Pk2*k2**4*r*(r + s) - k2**2*k3**2*r*(37*Pk2*r + 39*Pk2*s + 28*Pkd2*k2*s) + 7*k3**4*(Pk2*r*(3*s - 1) - 2*Pk2*s + Pkd2*k2*(-2*r*s + r + s))) - k2**4*k3**2*r*(10*Pk2*r + 21*Pk2*s + 7*Pkd2*k2*s) + k2**2*k3**4*(Pk2*r*(-5*r - 7*s + 7) + 7*Pkd2*k2*(-2*r*s + r + s))))/(7*d**2*k1*k2**2*k3**4) - D1**4*Pkd1*b1*ct*f*(14*b1**2*k3**4*r*(-Pk2*k2**2*r + k1**2*(Pk2*r + 2*Pkd2*k2*s)) + b1*(-28*Pk2*k1**6*r*(r + s) + 7*Pk2*k2**2*k3**2*(3*k2**2*r**2 + k3**2*(r**2 + 4*r - 2)) + 2*k1**4*r*(-64*Pk2*k2**2*(r + s) + 3*Pk2*k3**2*(7*r + 10*s) + 13*Pkd2*k2*k3**2*s) + k1**2*(-52*Pk2*k2**4*r*(r + s) + k2**2*k3**2*r*(91*Pk2*r + 80*Pk2*s + 26*Pkd2*k2*s) + k3**4*(Pk2*(35*r**2 + 4*r*(4*s - 7) - 16*s + 14) + 20*Pkd2*k2*(r*(2*s - 1) - s)))) + 14*k1**2*k3**4*(Pkd2*b2*k2*(r*(2*s - 1) - s) + 2*g2*(2*Pk2*s*(r - 1) + Pkd2*k2*(-2*r*s + r + s))))/(7*d**2*k1**2*k2*k3**4) - 2*D1**4*Pkd1*b1*f**3*mu2**6*r*(4*Pk2 - Pkd2*k2)*(3*s - 1)/(d**2*k1) + 2*D1**4*Pkd1*b1*f**2*mu**6*(126*Pk2*b1*k2**2*k3**4*(3*r**2 - 3*r + 1) + 6*Pk2*k1**4*(4*k2**2*(6*r**2 + 6*r*(s - 1) - 3*s + 2) + 7*k3**2*s*(1 - 2*r)) + k1**2*(7*Pk2*f*k3**4*s + 6*Pk2*k2**2*k3**2*(30*r**2 - 2*r*(7*s + 15) + 7*s + 10) + 7*Pkd2*f*k2*k3**4*s*(3*r - 1)))/(7*d**2*k1*k2**2*k3**4) + D1**4*Pkd1*b1*f*mu2**2*(f*(2*Pk2*k1**4*r*(12*k2**2*(r + s) - 7*k3**2*s) + k1**2*(24*Pk2*k2**4*(4*r**2 + 4*r*(s - 1) - s + 1) - 2*Pk2*k2**2*k3**2*(33*r**2 + 14*r*s - 7*s) + 14*Pk2*k3**4*(b1*r*(3*s - 2) - r*s + s) - 7*Pkd2*b1*k2*k3**4*r*(3*s - 2) + 12*Pkd2*k2**3*k3**2*r*(2 - 3*s)) - 2*k2**2*k3**2*(Pk2*(k2**2*(39*r**2 + 7*r*s - 7*s) + 7*k3**2*s*(r - 1)) + 7*b1*k3**2*r*(3*Pk2*r + Pkd2*k2*(3*s - 1)))) + r*(Pk2*k2**2*k3**4*r*(7*b2 - 14*g2) + 7*b1**2*k3**4*(-4*Pk2*k1**2*s + Pk2*k2**2*r + 2*Pkd2*k1**2*k2*s + 2*Pkd2*k2**3*s) + 2*b1*(Pk2*k2**2*k3**2*(k2**2*(17*r + 7*s) + k3**2*(5*r + 7*s - 7)) + k1**2*(-36*Pk2*k2**4*(r + s) + 7*Pk2*k3**4*(s - 1) + k2**2*k3**2*(7*Pk2*(2*r + s) + 12*Pkd2*k2*s)))))/(7*d**2*k1*k2**2*k3**4) - D1**4*Pkd1*b1*f*(Pk2*k2**2*k3**4*r**2*(7*b2 - 14*g2) + 7*b1**2*k2*k3**4*r*(Pk2*k2*(r + 2*s) + Pkd2*k1**2*s + Pkd2*k2**2*s) - 2*b1*(Pk2*k1**4*r*(12*k2**2*(r + s) - 7*k3**2*s) - Pk2*k2**2*k3**2*(10*k2**2*r**2 + k3**2*(5*r**2 + 7*r*s - 7*s)) + k1**2*(12*Pk2*k2**4*r*(r + s) - 19*Pk2*k2**2*k3**2*r*(r + s) - 7*Pk2*k3**4*s*(r - 1) - 6*Pkd2*k2**3*k3**2*r*s)))/(7*d**2*k1*k2**2*k3**4) + 64*D1**4*Pkd1*ct**4*f**3*k2*mu*mu2**3*r*(2*Pk2*k2**2*(r + s - 1) + 4*Pk2*k3**2*s - Pkd2*k2*k3**2*s)/(7*d**2*k3**4) + 16*D1**4*Pkd1*ct**4*f**3*mu**3*mu2*r*(27*Pk2*k2**2*k3**2*r + 4*k1**2*(Pk2*k2**2*(5*r + 5*s - 3) + 4*Pk2*k3**2*s - Pkd2*k2*k3**2*s))/(7*d**2*k2*k3**4) + 48*D1**4*Pkd1*ct**4*f**3*mu**2*mu2**2*r*(9*Pk2*k2**2*k3**2*r + k1**2*(2*Pk2*k2**2*(5*r + 5*s - 3) + 12*Pk2*k3**2*s - 3*Pkd2*k2*k3**2*s))/(7*d**2*k1*k3**4) + 8*D1**4*Pkd1*ct**4*f**2*mu*mu2*r*(2*b1*(4*Pk2*k2**4*(r + s - 1) + Pk2*k2**2*k3**2*(15*r + 4*s) + 4*Pk2*k3**4*s - 2*Pkd2*k2**3*k3**2*s - Pkd2*k2*k3**4*s + 2*k1**2*(4*Pk2*k2**2*(2*r + 2*s - 1) + 4*Pk2*k3**2*s - Pkd2*k2*k3**2*s)) + 7*g2*k3**4*s*(4*Pk2 - Pkd2*k2))/(7*d**2*k2*k3**4) + 2*D1**4*Pkd1*ct**4*f**2*mu**2*r*(63*Pk2*g2*k3**4*r + 2*b1*(8*Pk2*k1**4*(r + s - 1) + 9*Pk2*k3**2*r*(2*k2**2 + k3**2) + 2*k1**2*(8*Pk2*k2**2*(2*r + 2*s - 1) + Pk2*k3**2*(5*r + 12*s) - 6*Pkd2*k2*k3**2*s)))/(7*d**2*k1*k3**4) - 16*D1**4*Pkd1*ct**3*f**3*k2*mu**2*mu2**4*(2*Pk2*k2**2*(21*r**2 + r*(21*s - 19) - 3*s + 3) + 4*Pk2*k3**2*(r*(21*s - 5) - 3*s) + Pkd2*k2*k3**2*(r*(5 - 21*s) + 3*s))/(7*d**2*k3**4) - 16*D1**4*Pkd1*ct**3*f**3*mu**4*mu2**2*(54*Pk2*k2**2*k3**2*r*(3*r - 1) + k1**2*(2*Pk2*k2**2*(57*r**2 + 57*r*s - 47*r - 11*s + 7) + 4*Pk2*k3**2*(21*r*s - 3*r - 5*s) + Pkd2*k2*k3**2*(-21*r*s + 3*r + 5*s)))/(7*d**2*k2*k3**4) - 32*D1**4*Pkd1*ct**3*f**3*mu**3*mu2**3*(18*Pk2*k2**2*k3**2*r*(3*r - 1) + k1**2*(2*Pk2*k2**2*(33*r**2 + 33*r*s - 27*r - 6*s + 4) + 4*Pk2*k3**2*(21*r*s - 4*r - 4*s) + Pkd2*k2*k3**2*(-21*r*s + 4*r + 4*s)))/(7*d**2*k1*k3**4) + 16*D1**4*Pkd1*ct**3*f**2*k2*mu2**4*(-5*b1*r*(2*Pk2*k2**2*(2*r + 2*s - 1) + 4*Pk2*k3**2*(2*s - 1) + Pkd2*k2*k3**2*(1 - 2*s)) + f*(r - 1)*(2*Pk2*k2**2*(r + s - 1) + 4*Pk2*k3**2*s - Pkd2*k2*k3**2*s))/(7*d**2*k3**4) + D1**4*Pkd1*ct**3*f**2*mu**4*(-16*b1*(18*Pk2*k2**2*k3**2*r*(2*r - 1) + k1**2*(2*Pk2*k2**2*(18*r**2 + 2*r*(9*s - 7) - 7*s + 3) + 10*Pk2*k3**2*s*(2*r - 1) + 5*Pkd2*k2*k3**2*s*(1 - 2*r))) + f*r*(28*Pk2*k1**4*(r + s - 1) + 63*Pk2*k2**2*k3**2*r + k1**2*(60*Pk2*k2**2*(r + s - 1) + 35*Pk2*k3**2*r - 16*Pkd2*k2*k3**2*(s - 1))))/(7*d**2*k2*k3**4) + 8*D1**4*Pkd1*ct**3*f**2*mu*mu2**3*(-8*b1*r*(10*Pk2*k2**2*k3**2*r + k1**2*(2*Pk2*k2**2*(9*r + 9*s - 4) + 4*Pk2*k3**2*(5*s - 2) + Pkd2*k2*k3**2*(2 - 5*s))) + f*(k1**2*(2*Pk2*k2**2*(35*r**2 + 35*r*s - 43*r - 16*s + 8) + 4*Pk2*k3**2*s*(19*r - 8) + Pkd2*k2*k3**2*s*(8 - 19*r)) + k2**2*r*(14*Pk2*k2**2*(r + s - 1) + 2*Pk2*k3**2*(16*r + 7*s - 12) - 7*Pkd2*k2*k3**2*s)))/(7*d**2*k1*k3**4) + 2*D1**4*Pkd1*ct**3*f**2*mu**3*mu2*(f*(189*Pk2*k2**4*k3**2*r**2 + 4*k1**4*(Pk2*k2**2*(67*r**2 + 67*r*s - 53*r - 8*s + 8) + 28*Pk2*k3**2*r*s - 7*Pkd2*k2*k3**2*r*s) + k1**2*k2**2*r*(4*Pk2*k2**2*(59*r + 59*s - 37) + Pk2*k3**2*(233*r + 56*s - 48) + 4*Pkd2*k2*k3**2*(8 - 19*s))) - 4*k2**2*(63*Pk2*g2*k3**4*r*(2*r - 1) + 2*b1*(4*Pk2*k1**4*r*(4*r + 4*s - 3) + 9*Pk2*k3**2*r*(2*k2**2 + k3**2)*(2*r - 1) + 4*k1**2*(Pk2*k2**2*(14*r**2 + 2*r*(7*s - 6) - 5*s + 3) + Pk2*k3**2*(5*r**2 + 10*r*s - 4*s) + Pkd2*k2*k3**2*s*(2 - 5*r)))))/(7*d**2*k1*k2**2*k3**4) + 2*D1**4*Pkd1*ct**3*f**2*mu**2*mu2**2*(f*(189*Pk2*k2**4*k3**2*r**2 + k1**4*(2*Pk2*k2**2*(297*r**2 + 3*r*(99*s - 85) - 72*s + 40) + 12*Pk2*k3**2*s*(37*r - 8) - 3*Pkd2*k2*k3**2*s*(37*r - 8)) + 3*k1**2*k2**2*r*(2*Pk2*k2**2*(51*r + 51*s - 29) + Pk2*k3**2*(131*r + 42*s - 48) + Pkd2*k2*k3**2*(8 - 37*s))) - 2*k1**2*(2*b1*(4*Pk2*k2**4*(10*r**2 + 10*r*(s - 1) - 3*s + 3) + 4*Pk2*k2**2*(17*k1**2*r*(2*r + 2*s - 1) + k3**2*(30*r**2 + 10*r*s - 3*s)) + 4*Pk2*k3**2*(2*k1**2*r*(10*s - 3) + k3**2*(10*r*s - 3*r - 3*s)) + 2*Pkd2*k2**3*k3**2*s*(3 - 10*r) + Pkd2*k2*k3**2*(k1**2*r*(6 - 20*s) + k3**2*(r*(3 - 10*s) + 3*s))) + 7*g2*k3**4*(4*Pk2 - Pkd2*k2)*(r*(10*s - 3) - 3*s)))/(7*d**2*k1**2*k2*k3**4) - 2*D1**4*Pkd1*ct**3*f*mu*mu2*(140*Pk2*b1*g2*k2**2*k3**4*r**2 + 28*Pk2*f*g2*k2**2*k3**4*r*(3 - 4*r) + 8*b1**2*k2**2*r*(5*Pk2*k3**2*r*(2*k2**2 + k3**2) + 2*k1**2*(10*Pk2*k2**2*(r + s) + 6*Pk2*k3**2*s - 3*Pkd2*k2*k3**2*s)) - b1*f*(2*k1**4*r*(44*Pk2*k2**2*(2*r + 2*s - 1) + 28*Pk2*k3**2*s - 7*Pkd2*k2*k3**2*s) + k1**2*(4*Pk2*k2**4*(99*r**2 + 99*r*s - 85*r - 24*s + 8) + Pk2*k2**2*k3**2*(21*r**2 + 152*r*s - 64*s) + 56*Pk2*k3**4*r*s - 4*Pkd2*k2**3*k3**2*(31*r*s - 8*r - 8*s) - 14*Pkd2*k2*k3**4*r*s) + k2**2*r*(28*Pk2*k2**4*(r + s - 1) + Pk2*k2**2*k3**2*(169*r - 48) + 4*Pk2*k3**4*(8*r + 7*s - 6) - 14*Pkd2*k2**3*k3**2*s - 14*Pkd2*k2*k3**4*s)))/(7*d**2*k1*k2**2*k3**4) + D1**4*Pkd1*ct**3*f*mu**2*(-28*Pkd2*f*g2*k1**2*k2*k3**4*r*(s - 1) - 8*b1**2*k1**2*(20*Pk2*k2**2*k3**2*r**2 + 6*Pk2*k3**4*s*(r - 1) - 3*Pkd2*k2*k3**4*s*(r - 1) + 2*k1**2*r*(14*Pk2*k2**2*(r + s) + 6*Pk2*k3**2*s - 3*Pkd2*k2*k3**2*s)) + b1*(f*(28*Pk2*k1**6*r*(r + s - 1) + 63*Pk2*k2**2*k3**2*r**2*(k2**2 + k3**2) + k1**4*(4*Pk2*k2**2*(139*r**2 + 139*r*s - 109*r - 40*s + 8) + Pk2*k3**2*(7*r**2 + 276*r*s - 96*s) + 2*Pkd2*k2*k3**2*(-77*r*s + 8*r + 24*s)) + k1**2*r*(8*Pk2*k2**4*(18*r + 18*s - 7) + 2*Pk2*k2**2*k3**2*(131*r - 16*s - 48) + 35*Pk2*k3**4*r - 58*Pkd2*k2**3*k3**2*s - 8*Pkd2*k2*k3**4*(s - 1))) - 84*g2*k1**2*k3**4*s*(2*Pk2 - Pkd2*k2)*(r - 1)))/(7*d**2*k1**2*k2*k3**4) + 2*D1**4*Pkd1*ct**3*f*mu2**2*(-12*b1**2*k1**2*r*(4*Pk2*k2**4*(r + s) - 2*k2**2*k3**2*s*(-2*Pk2 + Pkd2*k2) + k3**4*(4*Pk2 - Pkd2*k2)*(s - 1)) + b1*(f*(105*Pk2*k2**4*k3**2*r**2 + k1**4*r*(2*Pk2*k2**2*(119*r + 119*s - 37) + 116*Pk2*k3**2*s - 29*Pkd2*k2*k3**2*s) + k1**2*(2*Pk2*k2**4*(119*r**2 + 119*r*s - 61*r - 8*s + 8) + Pk2*k2**2*k3**2*(21*r**2 + 58*r*s - 16*s) + 16*Pk2*k3**4*s*(r - 1) + Pkd2*k2**3*k3**2*(-77*r*s + 24*r + 8*s) - 4*Pkd2*k2*k3**4*s*(r - 1))) - 42*g2*k1**2*k3**4*r*(4*Pk2 - Pkd2*k2)*(s - 1)) + 14*f*g2*k1**2*k3**4*s*(4*Pk2 - Pkd2*k2)*(r - 1))/(7*d**2*k1**2*k2*k3**4) + 32*D1**4*Pkd1*ct**2*f**3*k2*mu**3*mu2**5*(2*Pk2*k2**2*(12*r**2 + 12*r*(s - 1) - 4*s + 3) + 4*Pk2*k3**2*(4*r*(3*s - 1) - 4*s + 1) + Pkd2*k2*k3**2*(r*(4 - 12*s) + 4*s - 1))/(7*d**2*k3**4) + 32*D1**4*Pkd1*ct**2*f**3*mu**5*mu2**3*(18*Pk2*k2**2*k3**2*(6*r**2 - 4*r + 1) + k1**2*(6*Pk2*k2**2*(12*r**2 + 12*r*(s - 1) - 4*s + 3) + 4*Pk2*k3**2*(4*r*(3*s - 1) - 4*s + 1) + Pkd2*k2*k3**2*(r*(4 - 12*s) + 4*s - 1)))/(7*d**2*k2*k3**4) + 32*D1**4*Pkd1*ct**2*f**3*mu**4*mu2**4*(9*Pk2*k2**2*k3**2*(6*r**2 - 4*r + 1) + 2*k1**2*(3*Pk2*k2**2*(12*r**2 + 12*r*(s - 1) - 4*s + 3) + 4*Pk2*k3**2*(4*r*(3*s - 1) - 4*s + 1) + Pkd2*k2*k3**2*(r*(4 - 12*s) + 4*s - 1)))/(7*d**2*k1*k3**4) + 32*D1**4*Pkd1*ct**2*f**2*k2*mu*mu2**5*(3*b1*r*(2*Pk2*k2**2*(2*r + 2*s - 1) + 4*Pk2*k3**2*(2*s - 1) + Pkd2*k2*k3**2*(1 - 2*s)) - f*(r - 1)*(2*Pk2*k2**2*(3*r + 3*s - 2) + 4*Pk2*k3**2*(3*s - 1) + Pkd2*k2*k3**2*(1 - 3*s)))/(7*d**2*k3**4) + D1**4*Pkd1*ct**2*f**2*mu**5*mu2*(189*Pk2*f**2*k3**4*r**2 + 96*b1*(6*Pk2*k2**2*k3**2*(3*r**2 - 3*r + 1) + k1**2*(2*Pk2*k2**2*(6*r**2 + 6*r*(s - 1) - 3*s + 2) + 2*Pk2*k3**2*s*(2*r - 1) + Pkd2*k2*k3**2*s*(1 - 2*r))) - 4*f*(14*Pk2*k1**4*(6*r**2 + 6*r*(s - 1) - s + 1) + 63*Pk2*k2**2*k3**2*r*(3*r - 1) + k1**2*(2*Pk2*k2**2*(66*r**2 + 66*r*s - 74*r - 15*s + 15) + Pk2*k3**2*(105*r**2 - 48*r*s - 19*r - 8*s) - 8*Pkd2*k2*k3**2*(3*r - 1)*(s - 1))))/(7*d**2*k2*k3**4) - D1**4*Pkd1*ct**2*f**2*mu**2*mu2**4*(-96*b1*r*(5*Pk2*k2**2*k3**2*r + 2*k1**2*(3*Pk2*k2**2*(2*r + 2*s - 1) + 4*Pk2*k3**2*(2*s - 1) + Pkd2*k2*k3**2*(1 - 2*s))) - 105*f**2*k3**4*r*s*(4*Pk2 - Pkd2*k2) + 2*f*(k1**2*(2*Pk2*k2**2*(411*r**2 + 411*r*s - 493*r - 189*s + 141) + 4*Pk2*k3**2*(291*r*s - 83*r - 117*s + 32) + Pkd2*k2*k3**2*(-291*r*s + 83*r + 117*s - 32)) + k2**2*(14*Pk2*k2**2*(21*r**2 + 21*r*s - 19*r - 3*s + 3) + 2*Pk2*k3**2*(18*r**2 + 147*r*s - 143*r - 21*s + 46) - 7*Pkd2*k2*k3**2*(21*r*s - 5*r - 3*s))))/(7*d**2*k1*k3**4) + D1**4*Pkd1*ct**2*f**2*mu2**4*(-2*b1*r*(k1**2*(118*Pk2*k2**2*(2*r + 2*s - 1) + 204*Pk2*k3**2*(2*s - 1) - 51*Pkd2*k2*k3**2*(2*s - 1)) + k2**2*(70*Pk2*k2**2*(2*r + 2*s - 1) - 2*Pk2*k3**2*(76*r - 70*s + 35) + 35*Pkd2*k2*k3**2*(1 - 2*s))) + f*(140*Pk2*b1*k3**4*r*s + 28*Pk2*k2**4*(r - 1)*(r + s - 1) + 28*Pk2*k2**2*k3**2*s*(r - 1) - 35*Pkd2*b1*k2*k3**4*r*s - 14*Pkd2*k2**3*k3**2*s*(r - 1) + 2*k1**2*(r - 1)*(30*Pk2*k2**2*(r + s - 1) + 28*Pk2*k3**2*s - 7*Pkd2*k2*k3**2*s)))/(7*d**2*k1*k3**4) - D1**4*Pkd1*ct**2*f**2*mu**4*mu2**2*(-21*f**2*k3**4*r*(20*Pk2*k1**2*s + 36*Pk2*k2**2*r - 5*Pkd2*k1**2*k2*s) + 2*f*(378*Pk2*k2**4*k3**2*r*(3*r - 1) + k1**4*(10*Pk2*k2**2*(123*r**2 + 123*r*s - 109*r - 33*s + 21) + 28*Pk2*k3**2*(21*r*s - 3*r - 5*s) - 7*Pkd2*k2*k3**2*(21*r*s - 3*r - 5*s)) + k1**2*k2**2*(2*Pk2*k2**2*(543*r**2 + 543*r*s - 473*r - 125*s + 81) + 2*Pk2*k3**2*(501*r**2 + 3*r*s - 250*r - 59*s + 54) + Pkd2*k2*k3**2*(-291*r*s + 117*r + 83*s - 32))) - 24*k2**2*(8*Pk2*b1*k1**4*r*(2*r + 2*s - 1) + 6*Pk2*b1*k3**2*(2*k2**2 + k3**2)*(3*r**2 - 3*r + 1) + 21*Pk2*g2*k3**4*(3*r**2 - 3*r + 1) + 4*b1*k1**2*(2*Pk2*k2**2*(6*r**2 + 6*r*(s - 1) - 3*s + 2) + Pk2*k3**2*(5*r**2 + 8*r*s - 4*s) + 2*Pkd2*k2*k3**2*s*(1 - 2*r))))/(7*d**2*k1*k2**2*k3**4) - 2*D1**4*Pkd1*ct**2*f**2*mu**3*mu2**3*(-7*f**2*k3**4*r*(64*Pk2*k1**2*s + 45*Pk2*k2**2*r - 16*Pkd2*k1**2*k2*s) + 2*f*(126*Pk2*k2**4*k3**2*r*(3*r - 1) + k1**4*(2*Pk2*k2**2*(447*r**2 + 447*r*s - 437*r - 146*s + 100) + 4*Pk2*k3**2*(195*r*s - 44*r - 52*s + 8) + Pkd2*k2*k3**2*(-195*r*s + 44*r + 52*s - 8)) + k1**2*k2**2*(2*Pk2*k2**2*(279*r**2 + 279*r*s - 229*r - 58*s + 36) + 2*Pk2*k3**2*(207*r**2 + 99*r*s - 187*r - 36*s + 50) + Pkd2*k2*k3**2*(-195*r*s + 52*r + 44*s - 8))) - 4*k1**2*(2*b1*(4*Pk2*k2**4*(6*r**2 + 6*r*(s - 1) - 3*s + 2) + 12*Pk2*k2**2*(3*k1**2*r*(2*r + 2*s - 1) + k3**2*(5*r**2 + 2*r*s - s)) + 4*Pk2*k3**2*(6*k1**2*r*(2*s - 1) + k3**2*(6*r*s - 3*r - 3*s + 1)) + 6*Pkd2*k2**3*k3**2*s*(1 - 2*r) - Pkd2*k2*k3**2*(6*k1**2*r*(2*s - 1) + k3**2*(6*r*s - 3*r - 3*s + 1))) + 7*g2*k3**4*(4*Pk2 - Pkd2*k2)*(r*(6*s - 3) - 3*s + 1)))/(7*d**2*k1**2*k2*k3**4) + D1**4*Pkd1*ct**2*f*mu**4*(16*Pk2*b1**2*k2**2*(8*k1**4*r*(r + s) + 10*k1**2*k3**2*r**2 + 9*k3**4*(r - 1)**2) + b1*(504*Pk2*g2*k2**2*k3**4*(r - 1)**2 + 7*f**2*k3**4*r*(10*Pk2*k1**2*s + 27*Pk2*k2**2*r - 5*Pkd2*k1**2*k2*s) - 2*f*(126*Pk2*k2**4*k3**2*r*(2*r - 1) + k1**4*(2*Pk2*k2**2*(270*r**2 + 270*r*s - 242*r - 121*s + 61) + 70*Pk2*k3**2*s*(2*r - 1) + 35*Pkd2*k2*k3**2*s*(1 - 2*r)) + k1**2*k2**2*(2*Pk2*k2**2*(158*r**2 + 2*r*(79*s - 57) - 65*s + 21) + 2*Pk2*k3**2*(234*r**2 - r*(64*s + 199) + 8*s + 54) - 51*Pkd2*k2*k3**2*s*(2*r - 1)))) + 2*f**2*k1**2*r*(k1**2*(26*Pk2*k2**2*(r + s - 1) + 7*Pk2*k3**2*(s - 1) - 7*Pkd2*k2*k3**2*(s - 1)) + k2**2*(14*Pk2*k2**2*(r + s - 1) + Pk2*k3**2*(-5*r - 7*s + 7) - 7*Pkd2*k2*k3**2*(s - 1))))/(7*d**2*k1*k2**2*k3**4) + 2*D1**4*Pkd1*ct**2*f*mu**2*mu2**2*(4*b1*k2**2*r*(35*Pk2*g2*k3**4*r + 2*b1*(5*Pk2*k3**2*r*(2*k2**2 + k3**2) + 8*k1**2*(3*Pk2*k2**2*(r + s) + 2*Pk2*k3**2*s - Pkd2*k2*k3**2*s))) + f**2*(k1**4*(2*Pk2*k2**2*(216*r**2 + 216*r*(s - 1) - 87*s + 43) + 84*Pk2*k3**2*s*(2*r - 1) + 21*Pkd2*k2*k3**2*s*(1 - 2*r)) + k1**2*(252*Pk2*b1*k3**4*r*s + 2*Pk2*k2**4*(372*r**2 + 372*r*s - 339*r - 111*s + 67) + Pk2*k2**2*k3**2*(63*r**2 + 90*r*s - 21*r - 90*s + 16) - 63*Pkd2*b1*k2*k3**4*r*s + Pkd2*k2**3*k3**2*(-210*r*s + 69*r + 69*s - 32)) + 3*k2**2*r*(21*Pk2*b1*k3**4*(5*r + 2*s) + 14*Pk2*k2**4*(2*r + 2*s - 1) + Pk2*k2**2*k3**2*(95*r - 14*s - 49) - 21*Pkd2*b1*k2*k3**4*s + 7*Pkd2*k2**3*k3**2*(1 - 2*s))) - f*(7*Pk2*g2*k2**2*k3**4*(26*r**2 - 50*r + 23) + b1*(k1**4*r*(2*Pk2*k2**2*(318*r + 318*s - 143) + 28*Pk2*k3**2*(10*s - 3) + 7*Pkd2*k2*k3**2*(3 - 10*s)) + k1**2*(2*Pk2*k2**4*(580*r**2 + 580*r*s - 477*r - 141*s + 93) + 2*Pk2*k2**2*k3**2*(14*r**2 + 140*r*s + 27*r - 85*s) + 28*Pk2*k3**4*(10*r*s - 3*r - 3*s) + Pkd2*k2**3*k3**2*(-332*r*s + 85*r + 85*s) + 7*Pkd2*k2*k3**4*(-10*r*s + 3*r + 3*s)) + k2**2*(14*Pk2*k2**4*(10*r**2 + 10*r*(s - 1) - 3*s + 3) + 4*Pk2*k2**2*k3**2*(131*r**2 - 50*r + 23) + 2*Pk2*k3**4*(26*r**2 + r*(70*s - 71) - 21*s + 23) + 7*Pkd2*k2**3*k3**2*s*(3 - 10*r) + 7*Pkd2*k2*k3**4*(r*(3 - 10*s) + 3*s)))))/(7*d**2*k1*k2**2*k3**4) - D1**4*Pkd1*ct**2*f*mu**2*(322*Pk2*b1*g2*k2**2*k3**4*(r - 1)**2 - 35*Pk2*f*k2**2*k3**4*r**2*(b2 - 4*g2) + b1**2*(84*Pk2*k1**2*k3**2*s*(k1**2*r + k3**2*(-f*r + r - 1)) + 20*Pk2*k2**4*r*(13*k1**2*(r + s) + 7*k3**2*r) - 4*Pk2*k2**2*(-89*k1**4*r*(r + s) + k1**2*k3**2*r*(-13*r + 32*s) + k3**4*(r**2*(35*f - 23) + 46*r - 23)) - 42*Pkd2*k1**2*k2*k3**2*s*(k1**2*r + k3**2*(-f*r + r - 1)) + Pkd2*k2**3*k3**2*s*(-74*k1**2*r + 21*k3**2*(r*(f - 2) + 2))) - 2*b1*f*(k1**4*(2*Pk2*k2**2*(145*r**2 + 145*r*s - 131*r - 59*s + 15) + 7*Pk2*k3**2*(13*r*s - r - 6*s) + 7*Pkd2*k2*k3**2*(-7*r*s + r + 3*s)) + k1**2*(2*Pk2*k2**4*(146*r**2 + 146*r*s - 105*r - 51*s + 7) + Pk2*k2**2*k3**2*(4*r**2 - 110*r*s + 7*r + 16*s + 16) + 7*Pk2*k3**4*r*(s - 1) + Pkd2*k2**3*k3**2*(-98*r*s + 7*r + 37*s) - 7*Pkd2*k2*k3**4*r*(s - 1)) + k2**2*r*(14*Pk2*k2**4*(r + s) + Pk2*k2**2*k3**2*(100*r - 21*s - 56) + Pk2*k3**4*(15*r - 7*s + 7) - 7*Pkd2*k2**3*k3**2*s - 7*Pkd2*k2*k3**4*(s - 1))))/(7*d**2*k1*k2**2*k3**4) + 2*D1**4*Pkd1*ct**2*f*mu**3*mu2*(-2*b1*f*(14*Pk2*k1**6*r*(4*r + 4*s - 3) + 63*Pk2*k2**2*k3**2*r*(k2**2 + k3**2)*(2*r - 1) + 2*k1**4*(Pk2*k2**2*(286*r**2 + 286*r*s - 281*r - 115*s + 69) + Pk2*k3**2*(7*r**2 + 86*r*s + 8*r - 44*s) + Pkd2*k2*k3**2*(-59*r*s + 8*r + 22*s)) + k1**2*(2*Pk2*k2**4*(114*r**2 + 114*r*s - 92*r - 43*s + 21) + Pk2*k2**2*k3**2*(356*r**2 - 64*r*s - 299*r + 8*s + 100) + Pk2*k3**4*(70*r**2 - 16*r*s - 27*r - 4*s) + 2*Pkd2*k2**3*k3**2*s*(18 - 43*r) + 4*Pkd2*k2*k3**4*(-2*r*s + 2*r + s - 1))) + 8*b1*k1**2*(2*b1*(10*Pk2*k2**2*k3**2*r**2 + 2*Pk2*k3**4*s*(r - 1) - Pkd2*k2*k3**4*s*(r - 1) + 2*k1**2*r*(6*Pk2*k2**2*(r + s) + 2*Pk2*k3**2*s - Pkd2*k2*k3**2*s)) + 7*g2*k3**4*s*(2*Pk2 - Pkd2*k2)*(r - 1)) + f**2*(189*Pk2*b1*k2**2*k3**4*r**2 + 28*Pk2*k1**6*(4*r**2 + 4*r*(s - 1) - s + 1) + 2*k1**4*(2*Pk2*k2**2*(95*r**2 + 95*r*s - 84*r - 15*s + 15) + Pk2*k3**2*(14*r**2 + 13*r*s - 14*r - 8*s) + Pkd2*k2*k3**2*(-49*r*s + 30*r + 8*s - 8)) + k1**2*r*(21*Pk2*b1*k3**4*(5*r + 8*s) + 28*Pk2*k2**4*(3*r + 3*s - 2) + 2*Pk2*k2**2*k3**2*(55*r - 21*s - 14) - 84*Pkd2*b1*k2*k3**4*s + 14*Pkd2*k2**3*k3**2*(2 - 3*s))) + 28*f*g2*k1**2*k3**4*(Pk2*(r*(4*s - 2) + s) + Pkd2*k2*(2*r - 1)*(s - 1)))/(7*d**2*k1**2*k2*k3**4) + 2*D1**4*Pkd1*ct**2*f*mu*mu2**3*(8*b1*k1**2*r*(2*b1*(4*Pk2*k2**4*(r + s) - 2*k2**2*k3**2*s*(-2*Pk2 + Pkd2*k2) + k3**4*(4*Pk2 - Pkd2*k2)*(s - 1)) + 7*g2*k3**4*(4*Pk2 - Pkd2*k2)*(s - 1)) + f**2*(7*Pk2*k2**2*k3**2*r*(25*b1*k3**2*r + 4*k2**2*(5*r - 4)) + 2*k1**4*(2*Pk2*k2**2*(73*r**2 + 73*r*s - 95*r - 44*s + 22) + 28*Pk2*k3**2*s*(3*r - 2) - 7*Pkd2*k2*k3**2*s*(3*r - 2)) + 2*k1**2*(168*Pk2*b1*k3**4*r*s + 22*Pk2*k2**4*(7*r**2 + 7*r*s - 9*r - 4*s + 2) + 2*Pk2*k2**2*k3**2*(7*r**2 + 17*r*s - 22*s + 4) - 42*Pkd2*b1*k2*k3**4*r*s + Pkd2*k2**3*k3**2*(-49*r*s + 8*r + 30*s - 8))) - 4*f*(b1*(70*Pk2*k2**4*k3**2*r**2 + k1**4*r*(10*Pk2*k2**2*(19*r + 19*s - 8) + 4*Pk2*k3**2*(43*s - 18) + Pkd2*k2*k3**2*(18 - 43*s)) + k1**2*(2*Pk2*k2**4*(87*r**2 + 87*r*s - 48*r - 8*s + 4) - 2*Pk2*k2**2*k3**2*(19*r**2 - 27*r*s + 6*r + 8*s) + 8*Pk2*k3**4*(r - 1)*(2*s - 1) + Pkd2*k2**3*k3**2*(-59*r*s + 22*r + 8*s) + 2*Pkd2*k2*k3**4*(-2*r*s + r + 2*s - 1))) + 7*g2*k1**2*k3**4*(4*Pk2 - Pkd2*k2)*(r - 1)*(2*s - 1)))/(7*d**2*k1**2*k2*k3**4) + D1**4*Pkd1*ct**2*f*mu*mu2*(-b1**2*(70*Pk2*k2**2*k3**2*r**2*(2*k2**2 + k3**2*(2 - 3*f)) + 4*k1**4*r*(134*Pk2*k2**2*(r + s) + 58*Pk2*k3**2*s - 29*Pkd2*k2*k3**2*s) + k1**2*(344*Pk2*k2**4*r*(r + s) - 4*k2**2*k3**2*r*(5*Pk2*r + 32*Pk2*s + 29*Pkd2*k2*s) + k3**4*(Pk2*(r**2*(28 - 21*f) - 32*r*(7*f*s - 1) - 32*s) + 16*Pkd2*k2*(r*s*(7*f - 2) + r + s)))) + 4*b1*(f*(14*Pk2*k1**6*r*(2*r + 2*s - 1) + 7*Pk2*k2**2*k3**2*r*(k2**2 + k3**2)*(5*r - 4) + k1**4*(2*Pk2*k2**2*(126*r**2 + 126*r*s - 115*r - 37*s + 15) - Pk2*k3**2*(21*r**2 - 59*r*s + 14*r + 28*s) + 2*Pkd2*k2*k3**2*(-28*r*s + 11*r + 7*s)) + k1**2*(2*Pk2*k2**4*(70*r**2 + 70*r*(s - 1) - 29*s + 7) + Pk2*k2**2*k3**2*(-37*r**2 - 53*r*s + 14*r + 8*s + 8) + Pk2*k3**4*(7*r**2 + 12*r*s - 4*s) + 2*Pkd2*k2**3*k3**2*(r*(7 - 28*s) + 11*s) + 2*Pkd2*k2*k3**4*(-7*r*s + 2*r + 2*s - 2))) - 14*g2*k1**2*k3**4*(2*Pk2*(r - s) + Pkd2*k2*(-2*r*s + r + s))) - 28*f*k1**2*k3**4*(2*Pk2*g2*s*(4*r + 1) - 2*Pkd2*g2*k2*(r + s - 1) + b2*r*s*(-2*Pk2 + Pkd2*k2)))/(7*d**2*k1**2*k2*k3**4) + 4*D1**4*Pkd1*ct*f**3*mu**3*mu2**5*(28*Pk2*f*k3**4*(r*(3 - 18*s) + 2*s) + 14*Pk2*k2**4*(12*r**2 + 12*r*(s - 1) - 4*s + 3) - 2*Pk2*k2**2*k3**2*(96*r**2 - 12*r*(7*s + 3) + 28*s + 9) + 7*Pkd2*f*k2*k3**4*(3*r*(6*s - 1) - 2*s) - 7*Pkd2*k2**3*k3**2*(4*r*(3*s - 1) - 4*s + 1) + 7*k1**2*(2*Pk2*k2**2*(12*r**2 + 12*r*(s - 1) - 4*s + 3) + 4*Pk2*k3**2*(4*r*(3*s - 1) - 4*s + 1) + Pkd2*k2*k3**2*(r*(4 - 12*s) + 4*s - 1)))/(7*d**2*k1*k3**4) + 4*D1**4*Pkd1*ct*f**3*mu**5*mu2**3*(126*Pk2*k2**2*k3**2*(2*f*k3**2*r*(1 - 4*r) + k2**2*(6*r**2 - 4*r + 1)) + 7*k1**4*(6*Pk2*k2**2*(12*r**2 + 12*r*(s - 1) - 4*s + 3) + 4*Pk2*k3**2*(4*r*(3*s - 1) - 4*s + 1) + Pkd2*k2*k3**2*(r*(4 - 12*s) + 4*s - 1)) + k1**2*(28*Pk2*f*k3**4*(r*(2 - 18*s) + 3*s) + 42*Pk2*k2**4*(12*r**2 + 12*r*(s - 1) - 4*s + 3) + 4*Pk2*k2**2*k3**2*(57*r**2 - 2*r*(27*s + 10) + 18*s + 5) + 7*Pkd2*f*k2*k3**4*(2*r*(9*s - 1) - 3*s) - 7*Pkd2*k2**3*k3**2*(4*r*(3*s - 1) - 4*s + 1)))/(7*d**2*k1*k2**2*k3**4) + 2*D1**4*Pkd1*ct*f**3*mu**4*mu2**4*(-63*Pk2*k2**2*k3**2*(5*f*k3**2*r*(4*r - 1) - 2*k2**2*(6*r**2 - 4*r + 1)) + 28*k1**4*(3*Pk2*k2**2*(12*r**2 + 12*r*(s - 1) - 4*s + 3) + 4*Pk2*k3**2*(4*r*(3*s - 1) - 4*s + 1) + Pkd2*k2*k3**2*(r*(4 - 12*s) + 4*s - 1)) + 2*k1**2*(-28*Pk2*f*k3**4*(r*(36*s - 5) - 5*s) + 42*Pk2*k2**4*(12*r**2 + 12*r*(s - 1) - 4*s + 3) + Pk2*k2**2*k3**2*(-174*r**2 + 4*r*(36*s + 17) - 48*s - 17) + 7*Pkd2*f*k2*k3**4*(r*(36*s - 5) - 5*s) - 14*Pkd2*k2**3*k3**2*(4*r*(3*s - 1) - 4*s + 1)))/(7*d**2*k1**2*k2*k3**4) + 2*D1**4*Pkd1*ct*f**2*mu*mu2**5*(6*b1*r*(7*k1**2*(2*Pk2*k2**2*(2*r + 2*s - 1) + 4*Pk2*k3**2*(2*s - 1) + Pkd2*k2*k3**2*(1 - 2*s)) + k2**2*(14*Pk2*k2**2*(2*r + 2*s - 1) - 2*Pk2*k3**2*(16*r - 14*s + 7) + 7*Pkd2*k2*k3**2*(1 - 2*s))) + 7*f**2*k3**4*s*(4*Pk2 - Pkd2*k2)*(3*r - 2) + f*(84*Pk2*b1*k3**4*r*(2 - 7*s) - 28*Pk2*k2**4*(r - 1)*(3*r + 3*s - 2) + 4*Pk2*k2**2*k3**2*(r - 1)*(24*r - 21*s - 1) + 21*Pkd2*b1*k2*k3**4*r*(7*s - 2) + 14*Pkd2*k2**3*k3**2*(r - 1)*(3*s - 1) - 14*k1**2*(r - 1)*(2*Pk2*k2**2*(3*r + 3*s - 2) + 4*Pk2*k3**2*(3*s - 1) + Pkd2*k2*k3**2*(1 - 3*s))))/(7*d**2*k1*k3**4) + 2*D1**4*Pkd1*ct*f**2*mu**5*mu2*(126*Pk2*b1*k2**2*k3**2*(3*f*k3**2*r*(1 - 3*r) + k2**2*(6*r**2 - 6*r + 2)) + 42*b1*k1**4*(2*Pk2*k2**2*(6*r**2 + 6*r*(s - 1) - 3*s + 2) + 2*Pk2*k3**2*s*(2*r - 1) + Pkd2*k2*k3**2*s*(1 - 2*r)) + b1*k1**2*(42*Pk2*f*k3**4*s*(2 - 7*r) + 84*Pk2*k2**4*(6*r**2 + 6*r*(s - 1) - 3*s + 2) + 4*Pk2*k2**2*k3**2*(57*r**2 - 3*r*(32*s + 19) + 48*s + 19) + 21*Pkd2*f*k2*k3**4*s*(7*r - 2) + 42*Pkd2*k2**3*k3**2*s*(1 - 2*r)) - 2*f*k1**4*(2*Pk2*k2**2*(57*r**2 + 57*r*s - 64*r - 13*s + 13) - 7*Pk2*k3**2*(2*r + 2*s - 1) - 7*Pkd2*k2*k3**2*(3*r - 1)*(s - 1)) - 7*f*k1**2*(2*Pk2*f*k3**4*r*(2 - 3*s) + 4*Pk2*k2**4*(3*r - 1)*(r + s - 1) + 2*Pk2*k2**2*k3**2*(6*r**2 + r*(2 - 6*s) - 1) + Pkd2*f*k2*k3**4*r*(3*s - 2) + 2*Pkd2*k2**3*k3**2*(-3*r*(s - 1) + s - 1)))/(7*d**2*k1*k2**2*k3**4) - 2*D1**4*Pkd1*ct*f**2*mu**3*mu2**3*(112*Pk2*g2*k2**2*k3**4*(3*r**2 - 3*r + 1) - 2*b1*(21*k1**4*r*(6*Pk2*k2**2*(2*r + 2*s - 1) + 4*Pk2*k3**2*(2*s - 1) + Pkd2*k2*k3**2*(1 - 2*s)) + k1**2*(14*Pk2*k2**4*(24*r**2 + 3*r*(8*s - 5) - 3*s + 2) - 6*Pk2*k2**2*k3**2*(9*r**2 + r*(4*s - 9) + 7*s) + 28*Pk2*k3**4*(r*(6*s - 3) - 3*s + 1) + 21*Pkd2*k2**3*k3**2*(-4*r*s + r + s) - 7*Pkd2*k2*k3**4*(r*(6*s - 3) - 3*s + 1)) + k2**2*(14*Pk2*k2**4*(6*r**2 + 6*r*(s - 1) - 3*s + 2) + 2*Pk2*k2**2*k3**2*(57*r**2 + 48*r - 16) - 2*Pk2*k3**4*(24*r**2 - 3*r*(14*s + 1) + 21*s + 1) + 21*Pkd2*k2**3*k3**2*s*(1 - 2*r) - 7*Pkd2*k2*k3**4*(r*(6*s - 3) - 3*s + 1))) + 14*f**2*k3**4*(4*Pk2*k1**2*s*(2 - 5*r) - 2*Pk2*k2**2*r*(24*r + 5*s - 12) + Pkd2*k1**2*k2*s*(5*r - 2) + Pkd2*k2**3*r*(5*s - 2)) + f*(14*k1**4*(2*Pk2*k2**2*(27*r**2 + r*(27*s - 31) - 13*s + 9) + 4*Pk2*k3**2*(2*r - 1)*(3*s - 1) + Pkd2*k2*k3**2*(r*(2 - 6*s) + 3*s - 1)) + k1**2*(56*Pk2*b1*k3**4*(r*(21*s - 4) - 2*s) + 4*Pk2*k2**4*(429*r**2 + r*(429*s - 414) - 141*s + 94) + Pk2*k2**2*k3**2*(-129*r**2 - 4*r + 84*s + 23) + 14*Pkd2*b1*k2*k3**4*(r*(4 - 21*s) + 2*s) - 2*Pkd2*k2**3*k3**2*(r*(210*s - 59) - 59*s + 14)) + 7*k2**2*(4*Pk2*b1*k3**4*(45*r**2 + 7*r*(3*s - 1) - 4*s) + 4*Pk2*k2**4*(3*r - 1)*(2*r + 2*s - 1) + Pk2*k2**2*k3**2*(117*r**2 - 24*r*(s + 4) + 29) + 2*Pkd2*b1*k2*k3**4*(r*(2 - 21*s) + 4*s) - 2*Pkd2*k2**3*k3**2*(3*r - 1)*(2*s - 1))))/(7*d**2*k1*k2**2*k3**4) + D1**4*Pkd1*ct*f**2*mu**4*mu2**2*(-112*Pk2*g2*k1**2*k3**4*(r*(6*s - 3) - 3*s + 1) + 4*b1*(42*Pk2*k1**6*r*(2*r + 2*s - 1) + 63*Pk2*k2**2*k3**2*(k2**2 + k3**2)*(3*r**2 - 3*r + 1) + 3*k1**4*(14*Pk2*k2**2*(8*r**2 + r*(8*s - 7) - 3*s + 2) + Pk2*k3**2*(7*r**2 + 8*r*(3*s + 2) - 28*s) + 14*Pkd2*k2*k3**2*s*(1 - 2*r)) + k1**2*(42*Pk2*k2**4*(6*r**2 + 6*r*(s - 1) - 3*s + 2) + Pk2*k2**2*k3**2*(18*r**2 + r*(87 - 96*s) + 48*s - 29) + 3*Pk2*k3**4*(35*r**2 - r*(16*s + 27) + 8*s + 9) + 42*Pkd2*k2**3*k3**2*s*(1 - 2*r))) + 42*f**2*k1**2*k3**4*r*(Pk2*(15*r + 8*s - 9) + 2*Pkd2*k2*(1 - 2*s)) - f*(756*Pk2*b1*k2**2*k3**4*r*(3*r - 1) + 28*Pk2*k1**6*(27*r**2 + 27*r*(s - 1) - 11*s + 7) + k1**4*(4*Pk2*k2**2*(657*r**2 + r*(657*s - 597) - 185*s + 119) + Pk2*k3**2*(189*r**2 - 2*r*(180*s + 89) + 64*s + 83) - 4*Pkd2*k2*k3**2*(3*r*(42*s - 17) - 36*s + 14)) + 7*k1**2*(6*Pk2*b1*k3**4*(30*r**2 + 7*r*(6*s - 1) - 10*s) + 8*Pk2*k2**4*(3*r - 1)*(3*r + 3*s - 2) + Pk2*k2**2*k3**2*(207*r**2 - 6*r*(12*s + 17) + 25) + 6*Pkd2*b1*k2*k3**4*(-21*r*s + r + 5*s) - 4*Pkd2*k2**3*k3**2*(3*r - 1)*(3*s - 2))))/(7*d**2*k1**2*k2*k3**4) - D1**4*Pkd1*ct*f**2*mu**2*mu2**4*(-12*b1*r*(35*Pk2*k2**4*k3**2*r + 14*k1**4*(3*Pk2*k2**2*(2*r + 2*s - 1) + 4*Pk2*k3**2*(2*s - 1) + Pkd2*k2*k3**2*(1 - 2*s)) + k1**2*k2**2*(42*Pk2*k2**2*(2*r + 2*s - 1) - 3*Pk2*k3**2*(19*r - 8*s + 4) + 14*Pkd2*k2*k3**2*(1 - 2*s))) - 14*f**2*k3**4*(24*Pk2*k1**2*s*(2*r - 1) + 5*Pk2*k2**2*r*(9*r - 5) + 6*Pkd2*k1**2*k2*s*(1 - 2*r)) + f*(7*Pk2*k2**2*k3**2*(150*b1*k3**2*r**2 + k2**2*(51*r**2 - 82*r + 29)) + 28*k1**4*(3*Pk2*k2**2*(11*r**2 + 11*r*s - 15*r - 7*s + 5) + 4*Pk2*k3**2*(3*r - 2)*(3*s - 1) + Pkd2*k2*k3**2*(-9*r*s + 3*r + 6*s - 2)) + k1**2*(168*Pk2*b1*k3**4*(r*(21*s - 5) - s) + 12*Pk2*k2**4*(119*r**2 + r*(119*s - 143) - 55*s + 41) + Pk2*k2**2*k3**2*(-639*r**2 + r*(528*s + 314) - 120*s - 17) - 42*Pkd2*b1*k2*k3**4*(r*(21*s - 5) - s) - 4*Pkd2*k2**3*k3**2*(18*r*(7*s - 2) - 51*s + 14))))/(7*d**2*k1**2*k2*k3**4) + 2*D1**4*Pkd1*ct*f**2*mu2**4*(b1*r*(63*Pk2*k2**4*k3**2*r - 14*k1**4*(3*Pk2*k2**2*(2*r + 2*s - 1) + 4*Pk2*k3**2*(2*s - 1) + Pkd2*k2*k3**2*(1 - 2*s)) + k1**2*(140*Pk2*b1*k3**4*(1 - 2*s) - 102*Pk2*k2**4*(2*r + 2*s - 1) + Pk2*k2**2*k3**2*(155*r - 144*s + 72) + 35*Pkd2*b1*k2*k3**4*(2*s - 1) + 44*Pkd2*k2**3*k3**2*(2*s - 1))) + f*(14*Pk2*k1**4*k2**2*(r - 1)*(r + s - 1) + 7*Pk2*k2**2*k3**2*(5*b1*k3**2*r**2 + k2**2*(r - 1)**2) + k1**2*(28*Pk2*b1*k3**4*s*(3*r - 1) + 26*Pk2*k2**4*(r - 1)*(r + s - 1) - Pk2*k2**2*k3**2*(r - 1)*(7*r + 4*s - 7) + 7*Pkd2*b1*k2*k3**4*s*(1 - 3*r) - 6*Pkd2*k2**3*k3**2*s*(r - 1))))/(7*d**2*k1**2*k2*k3**4) - 2*D1**4*Pkd1*ct*f*mu**3*mu2*(-2*b1**2*(28*Pk2*k1**2*k3**2*s*(k1**2*r + k3**2*(-5*f*r + f + r - 1)) + 14*Pk2*k2**4*r*(6*k1**2*(r + s) + 5*k3**2*r) + Pk2*k2**2*(84*k1**4*r*(r + s) - 2*k1**2*k3**2*r*(9*r + 32*s) + k3**4*(-r**2*(280*f + 16) + r*(35*f + 32) - 16)) - 14*Pkd2*k1**2*k2*k3**2*s*(k1**2*r + k3**2*(-5*f*r + f + r - 1)) + 7*Pkd2*k2**3*k3**2*s*(-2*k1**2*r + k3**2*(5*f*r - 2*f - 2*r + 2))) + b1*(112*Pk2*g2*k2**2*k3**4*(r - 1)**2 - 14*f**2*k3**4*(2*k1**2*(2*Pk2 - Pkd2*k2)*(r*(4*s - 1) - s) + k2**2*r*(3*Pk2*(12*r - 5) + Pkd2*k2*(1 - 3*s))) + f*(2*k1**4*(4*Pk2*k2**2*(82*r**2 + r*(82*s - 86) - 35*s + 21) + 7*Pk2*k3**2*(r*(8*s - 1) - 4*s) + 14*Pkd2*k2*k3**2*(-3*r*s + r + s)) + k1**2*(4*Pk2*k2**4*(238*r**2 + r*(238*s - 233) - 107*s + 60) + Pk2*k2**2*k3**2*(-42*r**2 + r*(16 - 560*s) + 256*s + 45) - 14*Pk2*k3**4*(r + 2*s - 1) + 2*Pkd2*k2**3*k3**2*(-2*r*(58*s - 7) + 45*s) - 14*Pkd2*k2*k3**4*(2*r - 1)*(s - 1)) + 7*k2**2*(4*Pk2*k2**4*(r + s)*(2*r - 1) + Pk2*k2**2*k3**2*(82*r**2 - 2*r*(8*s + 45) + 4*s + 31) + 2*Pk2*k3**4*(12*r**2 - r*(4*s + 3) - 1) + 2*Pkd2*k2**3*k3**2*s*(1 - 2*r) + 2*Pkd2*k2*k3**4*(-2*r*(s - 1) + s - 1)))) + f*(Pk2*k2**2*k3**4*r*(70*b2 - 196*g2)*(2*r - 1) + f*(63*Pk2*k2**4*k3**2*r**2 - 2*k1**4*(2*Pk2*k2**2*(38*r**2 + 38*r*s - 45*r - 13*s + 13) - 7*Pk2*k3**2*(2*r + 2*s - 1) - 7*Pkd2*k2*k3**2*(2*r - 1)*(s - 1)) + k1**2*k2**2*(-4*Pk2*k2**2*(32*r**2 + r*(32*s - 33) - 7*s + 7) + Pk2*k3**2*(79*r**2 + 8*r*(7*s - 6) + 14) + 2*Pkd2*k2*k3**2*(r*(32*s - 26) - 7*s + 7)))))/(7*d**2*k1*k2**2*k3**4) + 4*D1**4*Pkd1*ct*f*mu*mu2**3*(2*b1*r*(-28*Pk2*g2*k2**2*k3**4*r + b1*(14*Pk2*k2**6*(r + s) + 7*k1**2*(2*Pk2*k2**4*(r + s) + k2**2*k3**2*s*(2*Pk2 - Pkd2*k2) + k3**4*(4*Pk2 - Pkd2*k2)*(s - 1)) - k2**4*k3**2*(16*Pk2*r + 7*Pkd2*k2*s) + k2**2*k3**4*(-2*Pk2*(4*r - 7*s + 7) - 7*Pkd2*k2*(s - 1)))) + f**2*(14*Pk2*k1**4*k2**2*(3*r**2 + r*(3*s - 4) - 2*s + 1) + k1**2*(28*Pk2*b1*k3**4*s*(3*r - 1) + 2*Pk2*k2**4*(77*r**2 + 77*r*s - 103*r - 52*s + 26) + Pk2*k2**2*k3**2*(-21*r**2 - 12*r*s + 21*r - 20*s + 7) + 7*Pkd2*b1*k2*k3**4*s*(1 - 3*r) + Pkd2*k2**3*k3**2*(-32*r*s + 7*r + 26*s - 7)) + k2**2*(14*Pk2*b1*k3**4*(6*r**2 + 8*r*s - 3*r - 2*s) + 14*Pk2*k2**4*(r - 1)*(2*r + 2*s - 1) + Pk2*k2**2*k3**2*(13*r**2 - 28*r*s - r + 7) + 14*Pkd2*b1*k2*k3**4*(-4*r*s + r + s) - 7*Pkd2*k2**3*k3**2*(r - 1)*(2*s - 1))) + f*(28*Pk2*g2*k2**2*k3**4*(2*r**2 - 3*r + 1) - 7*b1**2*k3**4*r*(k1**2*(4*Pk2 - Pkd2*k2)*(5*s - 2) + 2*k2**2*(2*Pk2*(r + 5*s - 1) + Pkd2*k2*(1 - 5*s))) - b1*(7*k1**4*r*(2*Pk2*k2**2*(8*r + 8*s - 3) + 4*Pk2*k3**2*(2*s - 1) + Pkd2*k2*k3**2*(1 - 2*s)) + k1**2*(2*Pk2*k2**4*(206*r**2 + 2*r*(103*s - 52) - 14*s + 7) - Pk2*k2**2*k3**2*(137*r**2 + r*(30 - 80*s) + 28*s) + 28*Pk2*k3**4*(r - 1)*(2*s - 1) + Pkd2*k2**3*k3**2*(r*(45 - 116*s) + 14*s) - 7*Pkd2*k2*k3**4*(r - 1)*(2*s - 1)) + k2**2*(14*Pk2*k2**4*(3*r - 1)*(2*r + 2*s - 1) - Pk2*k2**2*k3**2*(93*r**2 + r*(56*s - 76) + 16) - 2*Pk2*k3**4*(r - 1)*(8*r - 14*s + 3) + 14*Pkd2*k2**3*k3**2*(-3*r*s + r + s) - 7*Pkd2*k2*k3**4*(r - 1)*(2*s - 1)))))/(7*d**2*k1*k2**2*k3**4) - 2*D1**4*Pkd1*ct*f*mu*mu2*(14*Pk2*f*k2**2*k3**4*r*(-2*b2*r + b2 + 8*g2*r - 6*g2) + 7*b1**3*k3**4*r*(6*Pk2*k1**2*s + 2*Pk2*k2**2*r - 3*Pkd2*k1**2*k2*s - 3*Pkd2*k2**3*s) + b1**2*(14*Pk2*k1**2*k3**2*(f*k3**2*(r*(2 - 9*s) + 2*s) + s*(2*k1**2*r + 2*k3**2*(r - 1))) + 28*Pk2*k2**6*r*(r + s) + Pk2*k2**4*r*(260*k1**2*(r + s) + k3**2*(r - 56*s)) - Pk2*k2**2*(-112*k1**4*r*(r + s) + k1**2*k3**2*r*(95*r + 124*s) + 2*k3**4*(r**2*(56*f + 6) + r*(-7*f + 14*s - 30) + 8)) - 7*Pkd2*k1**2*k2*k3**2*(2*k1**2*r*s + k3**2*(r*(-9*f*s + 2*f + 4*s - 2) + s*(2*f - 2))) - 14*Pkd2*k2**5*k3**2*r*s + Pkd2*k2**3*k3**2*(-64*k1**2*r*s + 7*k3**2*(r*(9*f*s - 2*f - 4*s + 2) + s*(2 - 2*f)))) + b1*(14*Pk2*k2**2*k3**4*(b2*r**2 - 2*g2*(5*r**2 - 4*r + 2)) + f*(-2*k1**4*(2*Pk2*k2**2*(40*r**2 + 40*r*s - 41*r - 14*s + 7) - 7*Pk2*k3**2*r - 7*Pkd2*k2*k3**2*r*(s - 1)) + k1**2*(-4*Pk2*k2**4*(83*r**2 + 83*r*s - 90*r - 39*s + 13) + Pk2*k2**2*k3**2*(161*r**2 + 152*r*s - 70*r - 64*s) + 14*Pk2*k3**4*(r + 2*s - 1) + 2*Pkd2*k2**3*k3**2*(50*r*s - 19*r - 19*s) + 14*Pkd2*k2*k3**4*(r - 1)*(s - 1)) + k2**2*(-28*Pk2*k2**4*(r - 1)*(r + s) + Pk2*k2**2*k3**2*(29*r**2 + 4*r*(14*s + 9) - 28*s - 28) + 2*Pk2*k3**4*(-12*r**2 + r*(14*s - 5) + 7) + 14*Pkd2*k2**3*k3**2*s*(r - 1) + 14*Pkd2*k2*k3**4*(r - 1)*(s - 1)))))/(7*d**2*k1*k2**2*k3**4) + D1**4*Pkd1*ct*f*mu**4*(2*b1**2*(56*Pk2*k1**6*r*(r + s) + 2*Pk2*k1**4*r*(28*k2**2*(r + s) + k3**2*(7*r - 32*s)) - 63*Pk2*k2**2*k3**4*(r**2*(2*f - 2) - r*(f - 4) - 2) + k1**2*(70*Pk2*k2**2*k3**2*r**2 + k3**4*(Pk2*(35*f*r - r**2*(140*f - 70) - 4*r*(8*s + 35) + 32*s + 70) + 35*Pkd2*f*k2*s*(2*r - 1)))) - b1*k1**2*(224*Pk2*g2*k3**4*s*(r - 1) - 14*f**2*k3**4*r*(5*Pk2*(3*r - 1) + Pkd2*k2*(1 - 3*s)) + f*(28*Pk2*k1**4*(18*r**2 + 18*r*(s - 1) - 9*s + 5) + k1**2*(4*Pk2*k2**2*(262*r**2 + 262*r*s - 224*r - 119*s + 53) + Pk2*k3**2*(210*r**2 - 688*r*s - 210*r + 288*s + 91) - 88*Pkd2*k2*k3**2*s*(2*r - 1)) + 7*k2**2*(8*Pk2*k2**2*(r + s)*(2*r - 1) + k3**2*(Pk2*(118*r**2 - 2*r*(16*s + 55) + 8*s + 33) + 4*Pkd2*k2*s*(1 - 2*r))))) + 3*f**2*k1**2*r*(-7*Pk2*k2**2*k3**2*r + k1**2*(8*Pk2*k2**2*(r + s - 1) - 7*Pk2*k3**2*r - 4*Pkd2*k2*k3**2*(s - 1))))/(7*d**2*k1**2*k2*k3**4) + D1**4*Pkd1*ct*f*mu**2*mu2**2*(4*b1*r*(-56*Pk2*g2*k1**2*k3**4*(s - 1) + b1*(35*Pk2*k2**2*k3**2*r*(k2**2 + k3**2) + 28*k1**4*(3*Pk2*k2**2*(r + s) + 2*Pk2*k3**2*s - Pkd2*k2*k3**2*s) + k1**2*(84*Pk2*k2**4*(r + s) + Pk2*k3**4*(7*r - 16*s + 16) - k2**2*k3**2*(57*Pk2*r + 32*Pk2*s + 28*Pkd2*k2*s)))) + 2*f**2*(14*Pk2*k1**6*(6*r**2 + 6*r*(s - 1) - 3*s + 1) - 21*Pk2*k2**2*k3**2*r*(-2*b1*k3**2*(9*r - 5) + 3*k2**2*r) + k1**4*(2*Pk2*k2**2*(249*r**2 + 3*r*(83*s - 90) - 117*s + 65) - Pk2*k3**2*(42*r**2 + 24*r*s + 72*s - 35) + Pkd2*k2*k3**2*(r*(42 - 99*s) + 60*s - 28)) + k1**2*(21*Pk2*b1*k3**4*(6*r**2 + 24*r*s - 7*r - 6*s) + 2*Pk2*k2**4*(99*r**2 + 99*r*s - 102*r - 42*s + 28) - Pk2*k2**2*k3**2*(57*r**2 + 126*r*s - 60*r + 7) - 63*Pkd2*b1*k2*k3**4*(4*r*s - r - s) + Pkd2*k2**3*k3**2*(-99*r*s + 60*r + 42*s - 28))) + f*(-14*b1**2*k3**4*(60*Pk2*k2**2*r**2 + k1**2*(Pk2*(6*r**2 + 80*r*s - 6*r - 6*s) + Pkd2*k2*(-40*r*s + 3*r + 3*s))) - b1*(28*Pk2*k1**6*r*(10*r + 10*s - 3) + 7*Pk2*k2**2*k3**2*(k2**2 + k3**2)*(46*r**2 - 70*r + 29) + 2*k1**4*(2*Pk2*k2**2*(512*r**2 + 512*r*s - 375*r - 105*s + 63) - Pk2*k3**2*(119*r**2 - 128*r*s + 2*r + 112*s) + 2*Pkd2*k2*k3**2*(-114*r*s + 37*r + 28*s)) + k1**2*(4*Pk2*k2**4*(298*r**2 + 298*r*s - 312*r - 123*s + 81) + Pk2*k2**2*k3**2*(-540*r**2 - 656*r*s + 546*r + 224*s - 65) + Pk2*k3**4*(42*r**2 + 240*r*s - 170*r - 8*s + 31) + 4*Pkd2*k2**3*k3**2*(-114*r*s + 28*r + 37*s) + 20*Pkd2*k2*k3**4*(-10*r*s + 3*r + 3*s))) + 14*k1**2*k3**4*(-b2*(2*Pk2 - Pkd2*k2)*(r*(10*s - 3) - 3*s) + g2*(8*Pk2*(10*r*s - 3*r - 5*s + 1) + 2*Pkd2*k2*(-10*r*s + 3*r + 3*s)))))/(7*d**2*k1**2*k2*k3**4) - D1**4*Pkd1*ct*f*mu**2*(14*Pkd2*f*k1**2*k2*k3**4*r*(b2 - 2*g2)*(s - 1) + 14*b1**3*k3**4*r*(5*Pk2*k2**2*r + k1**2*(Pk2*r - 3*Pkd2*k2*s)) + b1**2*(140*Pk2*k1**6*r*(r + s) + 7*Pk2*k2**2*k3**4*(r**2*(29 - 18*f) + r*(10*f - 58) + 29) + k1**4*r*(364*Pk2*k2**2*(r + s) - Pk2*k3**2*(77*r + 216*s) - 64*Pkd2*k2*k3**2*s) + k1**2*(56*Pk2*k2**4*r*(r + s) + k2**2*k3**2*r*(23*Pk2*r - 112*Pk2*s - 28*Pkd2*k2*s) + k3**4*(Pk2*(r**2*(63 - 84*f) + 2*r*(7*f - 40*s - 63) + 80*s + 63) + 2*Pkd2*k2*(7*f*(10*r*s - r - 3*s) + s*(30 - 30*r))))) - b1*(f*(28*Pk2*k1**6*(6*r**2 + 6*r*(s - 1) - 3*s + 1) - 21*Pk2*k2**2*k3**2*r**2*(k2**2 + k3**2) + k1**4*(4*Pk2*k2**2*(141*r**2 + 141*r*s - 122*r - 65*s + 13) + Pk2*k3**2*(-105*r**2 - 276*r*s + 84*r + 96*s + 14) + 2*Pkd2*k2*k3**2*(-63*r*s + 6*r + 32*s)) + k1**2*(4*Pk2*k2**4*(r + s)*(27*r - 14) + 2*Pk2*k2**2*k3**2*(9*r**2 - 96*r*s - 22*r + 28*s + 21) - 21*Pk2*k3**4*r**2 + 2*Pkd2*k2**3*k3**2*s*(14 - 27*r) - 20*Pkd2*k2*k3**4*r*(s - 1))) + 14*k1**2*k3**4*s*(r - 1)*(20*Pk2*g2 + 3*Pkd2*b2*k2 - 6*Pkd2*g2*k2)))/(7*d**2*k1**2*k2*k3**4) + D1**4*Pkd1*ct*f*mu2**2*(42*b1**3*k1**2*k3**4*r*s*(-2*Pk2 + Pkd2*k2) + b1**2*(21*Pk2*k2**2*k3**2*r**2*(k2**2 + k3**2*(4*f + 1)) - 28*k1**4*r*(3*Pk2*k2**2*(r + s) + 2*Pk2*k3**2*s - Pkd2*k2*k3**2*s) + k1**2*(-156*Pk2*k2**4*r*(r + s) + k2**2*k3**2*r*(113*Pk2*r + 32*Pk2*s + 64*Pkd2*k2*s) + k3**4*(Pk2*(-28*f*s + r**2*(49 - 42*f) + 4*r*(70*f*s - 21*f - 26*s + 26)) + 2*Pkd2*k2*(f*r*(21 - 70*s) + 7*f*s + 30*r*(s - 1))))) + 2*b1*(f*(14*Pk2*k1**6*r*(r + s) + 7*Pk2*k2**2*k3**2*(k2**2*(-8*r**2 - 2*r + 1) + k3**2*(r - 1)**2) + k1**4*(2*Pk2*k2**2*(77*r**2 + 77*r*s - 40*r - 7*s + 7) - Pk2*k3**2*r*(21*r + 4*s + 14) + Pkd2*k2*k3**2*r*(14 - 27*s)) + k1**2*(2*Pk2*k2**4*(70*r**2 + 70*r*s - 58*r - 13*s + 13) + Pk2*k2**2*k3**2*(-161*r**2 - 58*r*s + 28*r + 16*s - 7) - Pk2*k3**4*(r - 1)*(7*r - 12*s - 7) + Pkd2*k2**3*k3**2*(-63*r*s + 32*r + 6*s) - 10*Pkd2*k2*k3**4*s*(r - 1))) - 7*k1**2*k3**4*r*(s - 1)*(6*Pk2*b2 - 16*Pk2*g2 - 3*Pkd2*b2*k2 + 6*Pkd2*g2*k2)) + 14*f*k1**2*k3**4*s*(r - 1)*(2*Pk2*b2 - 8*Pk2*g2 - Pkd2*b2*k2 + 2*Pkd2*g2*k2))/(7*d**2*k1**2*k2*k3**4) + 4*D1**4*Pkd1*f**4*mu**4*mu2**6*(4*Pk2 - Pkd2*k2)*(5*r*(4*s - 1) - 5*s + 1)/(d**2*k1) + 4*D1**4*Pkd1*f**4*mu**6*mu2**4*(18*Pk2*k2**2*(10*r**2 - 5*r + 1) + k1**2*(4*Pk2 - Pkd2*k2)*(5*r*(4*s - 1) - 5*s + 1))/(d**2*k1*k2**2) + 4*D1**4*Pkd1*f**4*mu**5*mu2**5*(9*Pk2*k2**2*(10*r**2 - 5*r + 1) + 2*k1**2*(4*Pk2 - Pkd2*k2)*(5*r*(4*s - 1) - 5*s + 1))/(d**2*k1**2*k2) - 2*D1**4*Pkd1*f**3*mu**2*mu2**6*(4*Pk2 - Pkd2*k2)*(8*b1*r*(1 - 3*s) + f*(3*r - 2)*(4*s - 1))/(d**2*k1) + 2*D1**4*Pkd1*f**3*mu**6*mu2**2*(378*Pk2*b1*k2**2*k3**4*(6*r**2 - 4*r + 1) + 2*Pk2*k1**4*(12*k2**2*(12*r**2 + 12*r*(s - 1) - 4*s + 3) - 7*k3**2*(4*r*(3*s - 1) - 4*s + 1)) + k1**2*(2*Pk2*k2**2*k3**2*(180*r**2 - 4*r*(21*s + 23) + 28*s + 23) + 7*Pk2*k3**4*(16*b1*s*(3*r - 1) + f*(-24*r*s + 16*r + 9*s - 4)) + 7*Pkd2*k2*k3**4*(8*b1*s*(1 - 3*r) + f*(4*r - 1)*(3*s - 2))))/(7*d**2*k1*k2**2*k3**4) + 2*D1**4*Pkd1*f**3*mu**4*mu2**4*(k1**2*(72*Pk2*k2**4*(12*r**2 + 12*r*(s - 1) - 4*s + 3) - 2*Pk2*k2**2*k3**2*(168*r**2 - 4*r*(51*s + 11) + 68*s + 11) + 28*Pk2*k3**4*(2*b1*(24*r*s - 8*r - 4*s + 1) - f*(5*r - 2)*(4*s - 1)) - 24*Pkd2*k2**3*k3**2*(4*r*(3*s - 1) - 4*s + 1) - 7*Pkd2*k2*k3**4*(2*b1*(24*r*s - 8*r - 4*s + 1) - f*(5*r - 2)*(4*s - 1))) + k2**2*k3**2*(2*Pk2*k2**2*(12*r**2 + r*(20 - 84*s) + 28*s - 5) + 7*Pk2*k3**2*(2*b1*(90*r**2 + 48*r*s - 28*r - 16*s + 7) + f*(-228*r**2 - 40*r*s + 178*r + 15*s - 43)) - 7*Pkd2*k2*k3**2*(2*b1*(24*r*s - 4*r - 8*s + 1) - f*(4*r - 1)*(5*s - 2))))/(7*d**2*k1*k2**2*k3**4) + D1**4*Pkd1*f**3*mu**5*mu2**3*(504*Pk2*b1*k2**2*k3**4*(6*r**2 - 4*r + 1) + 8*k1**4*(18*Pk2*k2**2*(12*r**2 + 12*r*(s - 1) - 4*s + 3) - 2*Pk2*k3**2*(21*r**2 + 2*r*(3*s - 8) - 2*s + 4) - 3*Pkd2*k2*k3**2*(4*r*(3*s - 1) - 4*s + 1)) + k1**2*(16*Pk2*k2**2*k3**2*(69*r**2 - 2*r*(21*s + 16) + 14*s + 8) + 7*Pk2*k3**4*(4*b1*(60*r**2 + 72*r*s - 28*r - 24*s + 7) + f*(-284*r**2 - 128*r*s + 242*r + 48*s - 57)) - 28*Pkd2*k2*k3**4*(b1*(36*r*s - 4*r - 12*s + 1) + 2*f*(-8*r*s + 4*r + 2*s - 1))))/(7*d**2*k1**2*k2*k3**4) + D1**4*Pkd1*f**3*mu**3*mu2**5*(7*Pk2*k2**2*k3**2*(-8*k2**2*(6*r**2 - 4*r + 1) + k3**2*(120*b1*r**2 + f*(-172*r**2 + 146*r - 37))) + 4*k1**2*(12*Pk2*k2**4*(12*r**2 + 12*r*(s - 1) - 4*s + 3) - 2*Pk2*k2**2*k3**2*(42*r**2 - 4*r*(18*s + 1) + 24*s + 1) + 28*Pk2*k3**4*(b1*(36*r*s - 12*r - 4*s + 1) + 2*f*(-8*r*s + 2*r + 4*s - 1)) - 6*Pkd2*k2**3*k3**2*(4*r*(3*s - 1) - 4*s + 1) - 7*Pkd2*k2*k3**4*(b1*(36*r*s - 12*r - 4*s + 1) + 2*f*(-8*r*s + 2*r + 4*s - 1))))/(7*d**2*k1**2*k2*k3**4) - D1**4*Pkd1*f**2*mu**4*mu2**2*(4*Pk2*k2**2*k3**4*(-35*b2 + 70*g2)*(3*r**2 - 3*r + 1) + 28*b1**2*k3**4*(6*Pk2*k1**2*s*(1 - 4*r) - 5*Pk2*k2**2*(12*r**2 - 3*r + 1) + 3*Pkd2*k1**2*k2*s*(4*r - 1) + 3*Pkd2*k2**3*s*(2*r - 1)) - 4*b1*(3*Pk2*k1**4*r*(12*k2**2*(2*r + 2*s - 1) + 7*k3**2*(1 - 2*s)) + Pk2*k2**2*k3**2*(k2**2*(6*r**2 - 6*r*(7*s + 1) + 21*s + 2) + k3**2*(150*r**2 - 3*r*(14*s + 43) + 21*s + 43)) + k1**2*(36*Pk2*k2**4*(6*r**2 + 6*r*(s - 1) - 3*s + 2) + Pk2*k2**2*k3**2*(-66*r**2 - 84*r*s + 105*r + 21*s - 28) - 7*Pk2*k3**4*(r*(6*s - 3) - 3*s + 1) + 36*Pkd2*k2**3*k3**2*s*(1 - 2*r))) - 7*f**2*k3**4*(-12*Pk2*k2**2*r**2 + k1**2*(2*Pk2*(5*r*(3*s - 2) - 9*s + 4) - Pkd2*k2*(5*r - 2)*(3*s - 2))) + f*(2*Pk2*k1**4*(12*k2**2*(27*r**2 + 27*r*(s - 1) - 11*s + 7) + 7*k3**2*(r*(5 - 27*s) + 11*s - 2)) + 2*k1**2*(7*Pk2*b1*k3**4*(6*r*(11*s - 4) - 21*s + 4) + 24*Pk2*k2**4*(3*r - 1)*(3*r + 3*s - 2) + Pk2*k2**2*k3**2*(81*r**2 - r*(189*s + 85) + 41*s + 43) - 7*Pkd2*b1*k2*k3**4*(3*r*(11*s - 4) - 9*s + 2) - 12*Pkd2*k2**3*k3**2*(3*r - 1)*(3*s - 2)) - 7*k2**2*k3**2*(12*Pk2*k2**2*r*(3*r - 1) + b1*k3**2*(-3*Pk2*(177*r**2 - 142*r - 4*s + 39) + 4*Pkd2*k2*(3*r - 1)*(3*s - 1)))))/(7*d**2*k1*k2**2*k3**4) - D1**4*Pkd1*f**2*mu**2*mu2**4*(12*b1*r*(k1**2*(28*Pk2*b1*k3**4*(1 - 2*s) - 36*Pk2*k2**4*(2*r + 2*s - 1) + Pk2*k2**2*k3**2*(28*r - 34*s + 17) + 7*Pkd2*b1*k2*k3**4*(2*s - 1) + 12*Pkd2*k2**3*k3**2*(2*s - 1)) + k2**2*k3**2*(-7*Pk2*b1*k3**2*(r + 8*s - 2) + Pk2*k2**2*(22*r + 14*s - 7) + 7*Pkd2*b1*k2*k3**2*(4*s - 1))) + 7*f**2*k2**2*k3**4*(-6*Pk2*(8*r**2 + 5*r*(s - 2) - 5*s + 4) + Pkd2*k2*(3*r - 2)*(5*s - 2)) + f*(2*k1**2*(56*Pk2*b1*k3**4*(3*r - 1)*(3*s - 1) + 36*Pk2*k2**4*(11*r**2 + r*(11*s - 15) - 7*s + 5) + 3*Pk2*k2**2*k3**2*(-42*r**2 + r*(37*s + 25) - 27*s + 2) - 14*Pkd2*b1*k2*k3**4*(3*r - 1)*(3*s - 1) - 12*Pkd2*k2**3*k3**2*(3*r - 2)*(3*s - 1)) + k2**2*k3**2*(7*Pk2*b1*k3**2*(99*r**2 + 2*r*(66*s - 37) - 48*s + 23) - 6*Pk2*k2**2*(9*r**2 + r*(35*s - 11) - 21*s - 1) - 14*Pkd2*b1*k2*k3**2*(r*(33*s - 9) - 12*s + 2))))/(7*d**2*k1*k2**2*k3**4) + D1**4*Pkd1*f**2*mu2**4*(2*b1*r*(k1**2*(28*Pk2*b1*k3**4*(1 - 2*s) - 36*Pk2*k2**4*(2*r + 2*s - 1) + Pk2*k2**2*k3**2*(28*r - 34*s + 17) + 7*Pkd2*b1*k2*k3**4*(2*s - 1) + 12*Pkd2*k2**3*k3**2*(2*s - 1)) + k2**2*k3**2*(7*Pk2*b1*k3**2*(3*r - 8*s + 2) + Pk2*k2**2*(46*r + 14*s - 7) + 7*Pkd2*b1*k2*k3**2*(4*s - 1))) + f*k2**2*(2*Pk2*k1**2*(r - 1)*(12*k2**2*(r + s - 1) - 7*k3**2*s) + 7*k3**2*(-2*Pk2*k2**2*s*(r - 1) + b1*k3**2*r*(2*Pk2 - Pkd2*k2)*(5*s - 2))))/(7*d**2*k1*k2**2*k3**4) + D1**4*Pkd1*f**2*mu**5*mu2*(28*b1**2*k3**4*(9*Pk2*k2**2*(3*r**2 - 3*r + 1) + k1**2*(5*Pk2*(6*r**2 - 3*r + 1) + 3*Pkd2*k2*s*(1 - 2*r))) + b1*k1**2*(7*Pk2*f*k3**4*(-219*r**2 + 158*r + 12*s - 41) + 8*Pk2*k2**2*k3**2*(69*r**2 - 42*r*s - 69*r + 21*s + 23) + 28*Pkd2*f*k2*k3**4*(3*r - 1)*(3*s - 1) + 8*k1**2*(18*Pk2*k2**2*(6*r**2 + 6*r*(s - 1) - 3*s + 2) - 7*Pk2*k3**2*(3*r**2 + r*(6*s - 3) - 3*s + 1) + 9*Pkd2*k2*k3**2*s*(1 - 2*r))) + f*k1**2*(-7*Pk2*k3**2*r*(3*f*k3**2*r + k2**2*(4 - 12*r)) - 4*k1**2*(12*Pk2*k2**2*(3*r - 1)*(r + s - 1) + Pk2*k3**2*(-21*r**2 + 7*r - 6*s) - 6*Pkd2*k2*k3**2*(3*r - 1)*(s - 1))))/(7*d**2*k1**2*k2*k3**4) - D1**4*Pkd1*f**2*mu**3*mu2**3*(-84*b1**2*k3**4*(10*Pk2*k2**2*r**2 + k1**2*(Pk2*(r**2 + 16*r*s - 2*r - 2*s) + Pkd2*k2*(-8*r*s + r + s))) - 8*b1*(-7*Pk2*k2**2*k3**2*(k2**2 + k3**2)*(3*r**2 - 3*r + 1) + 3*k1**4*r*(18*Pk2*k2**2*(2*r + 2*s - 1) + Pk2*k3**2*(-7*r - 2*s + 1) + 3*Pkd2*k2*k3**2*(1 - 2*s)) + k1**2*(6*Pk2*k2**4*(6*r**2 + 6*r*(s - 1) - 3*s + 2) - Pk2*k2**2*k3**2*(24*r**2 + 42*r*(s - 1) + 7) - 3*Pk2*k3**4*(7*r**2 + r*(3 - 20*s) + 10*s - 1) + 9*Pkd2*k2**3*k3**2*s*(1 - 2*r) - 5*Pkd2*k2*k3**4*(r*(6*s - 3) - 3*s + 1))) - 14*f**2*k3**4*(-5*Pk2*k2**2*r**2 + k1**2*(Pk2*(20*r**2 + 32*r*(s - 1) - 24*s + 13) + 4*Pkd2*k2*(r*(2 - 4*s) + 2*s - 1))) + f*(14*Pk2*k2**2*k3**2*(b1*k3**2*(135*r**2 - 126*r + 37) + 4*k2**2*r*(1 - 3*r)) + 4*k1**4*(12*Pk2*k2**2*(27*r**2 + r*(27*s - 31) - 13*s + 9) + Pk2*k3**2*(-42*r**2 + r*(39 - 75*s) + 34*s - 9) - 6*Pkd2*k2*k3**2*(2*r - 1)*(3*s - 1)) + k1**2*(7*Pk2*b1*k3**4*(102*r**2 + 2*r*(144*s - 67) - 96*s + 33) + 48*Pk2*k2**4*(3*r - 1)*(2*r + 2*s - 1) + 4*Pk2*k2**2*k3**2*(69*r**2 - r*(147*s + 61) + 58*s + 30) - 28*Pkd2*b1*k2*k3**4*(r*(36*s - 11) - 11*s + 2) - 24*Pkd2*k2**3*k3**2*(3*r - 1)*(2*s - 1))) + k1**2*k3**4*(2*Pk2 - Pkd2*k2)*(-28*b2 + 56*g2)*(r*(6*s - 3) - 3*s + 1))/(7*d**2*k1**2*k2*k3**4) + D1**4*Pkd1*f**2*mu*mu2**5*(14*Pk2*f**2*k2**2*k3**4*(6*r**2 - 8*r + 3) - 12*b1*r*(14*Pk2*k2**4*k3**2*r + k1**2*(28*Pk2*b1*k3**4*(1 - 2*s) - 12*Pk2*k2**4*(2*r + 2*s - 1) + 2*Pk2*k2**2*k3**2*(7*r - 12*s + 6) + 7*Pkd2*b1*k2*k3**4*(2*s - 1) + 6*Pkd2*k2**3*k3**2*(2*s - 1))) - f*(7*Pk2*k2**2*k3**2*(15*b1*k3**2*r**2 - 4*k2**2*(3*r**2 - 4*r + 1)) + 4*k1**2*(28*Pk2*b1*k3**4*(3*r - 1)*(3*s - 1) + 12*Pk2*k2**4*(r - 1)*(3*r + 3*s - 2) - Pk2*k2**2*k3**2*(r - 1)*(21*r - 36*s + 5) - 7*Pkd2*b1*k2*k3**4*(3*r - 1)*(3*s - 1) - 6*Pkd2*k2**3*k3**2*(r - 1)*(3*s - 1))))/(7*d**2*k1**2*k2*k3**4) - D1**4*Pkd1*f*mu**4*(-140*Pk2*b1**3*k2**2*k3**4*r**2 + 6*Pk2*f**2*k1**2*k2**2*k3**2*r**2 - b1**2*(14*Pk2*k1**2*k3**2*s*(-4*k1**2*r + k3**2*(f - 4*r + 4)) + Pk2*k2**2*(96*k1**4*r*(r + s) + 8*k1**2*k3**2*r*(3*r - 7*s) + k3**4*(-7*f*(122*r**2 - 2*r*(4*s + 61) + 2*s + 39) + (8*r - 8)*(25*r - 7*s - 25))) + 14*Pkd2*f*k1**2*k2*k3**4*s*(4*r - 1) + 14*Pkd2*f*k2**3*k3**4*s*(2*r - 1)) + b1*(Pk2*k2**2*k3**4*(-140*b2 + 280*g2)*(r - 1)**2 + 7*f**2*k3**4*(2*Pk2*k1**2*s + 3*Pk2*k2**2*r**2 + Pkd2*k1**2*k2*s*(5*r - 2)) + 2*f*(3*Pk2*k1**4*(4*k2**2*(18*r**2 + 18*r*(s - 1) - 9*s + 5) + 21*k3**2*s*(1 - 2*r)) + 14*Pk2*k2**4*k3**2*r*(1 - 2*r) + k1**2*k2**2*(24*Pk2*k2**2*(r + s)*(2*r - 1) + k3**2*(Pk2*(122*r**2 - 2*r*(87*s + 68) + 75*s + 57) + 12*Pkd2*k2*s*(1 - 2*r))))))/(7*d**2*k1*k2**2*k3**4) + D1**4*Pkd1*f*mu**2*mu2**2*(-4*b1*r*(Pk2*k2**2*k3**4*r*(-7*b2 + 14*g2) + 7*b1**2*k3**4*(-4*Pk2*k1**2*s - Pk2*k2**2*r + 2*Pkd2*k1**2*k2*s + 2*Pkd2*k2**3*s) + 2*b1*(Pk2*k2**2*k3**2*(k2**2*(11*r + 7*s) + k3**2*(-5*r + 7*s - 7)) + k1**2*(-36*Pk2*k2**4*(r + s) + 7*Pk2*k3**4*(s - 1) + k2**2*k3**2*(7*Pk2*(2*r + s) + 12*Pkd2*k2*s)))) + 2*f**2*(3*Pk2*k1**4*(4*k2**2*(6*r**2 + 6*r*(s - 1) - 3*s + 1) + 7*k3**2*s*(1 - 2*r)) + 3*Pk2*k2**4*k3**2*r*(14 - 27*r) + 7*b1*k2**2*k3**4*(3*Pk2*(9*r**2 - 12*r - 2*s + 4) + Pkd2*k2*(r*(3 - 9*s) + 6*s - 2)) + k1**2*(7*Pk2*b1*k3**4*(6*r*(3*s - 2) - 9*s + 4) + 12*Pk2*k2**4*(3*r - 2)*(3*r + 3*s - 2) - 3*Pk2*k2**2*k3**2*(21*r**2 + 14*r*(s - 1) + 5*s - 4) - 7*Pkd2*b1*k2*k3**4*(3*r - 1)*(3*s - 2) - 6*Pkd2*k2**3*k3**2*(3*r - 2)*(3*s - 2))) + f*(Pk2*k2**2*k3**4*(-7*b2 + 14*g2)*(26*r**2 - 34*r + 15) + 7*b1**2*k3**4*(8*Pk2*k1**2*(r*(2 - 9*s) + 2*s) + Pk2*k2**2*(-104*r**2 + 34*r - 15) + 4*Pkd2*k1**2*k2*(r*(9*s - 2) - 2*s) + 4*Pkd2*k2**3*(r*(9*s - 2) - 2*s)) - 2*b1*(Pk2*k1**4*r*(12*k2**2*(10*r + 10*s - 3) + 7*k3**2*(3 - 10*s)) + Pk2*k2**2*k3**2*(k2**2*(-90*r**2 - 70*r*s - 4*r + 49*s + 17) + k3**2*(130*r**2 - 70*r*s - 149*r + 49*s + 61)) + k1**2*(12*Pk2*k2**4*(34*r**2 + 34*r*s - 36*r - 15*s + 9) - 7*Pk2*k2**2*k3**2*(30*r**2 + 20*r*s - 17*r - 7*s + 4) + 7*Pk2*k3**4*(-10*r*s + 3*r + 7*s - 2) - 48*Pkd2*k2**3*k3**2*(3*r*s - r - s)))))/(7*d**2*k1*k2**2*k3**4) + D1**4*Pkd1*f*mu**2*(-7*Pk2*f*k2**2*k3**4*r**2*(b2 - 2*g2) + 7*b1**3*k2*k3**4*r*(Pk2*k2*(-15*r + 4*s) + 2*Pkd2*k1**2*s + 2*Pkd2*k2**2*s) + b1**2*(-14*Pk2*k1**2*k3**2*s*(-5*k1**2*r + k3**2*(f - 5*r + 5)) - 4*Pk2*k2**4*r*(12*k1**2*(r + s) - 7*k3**2*r) + 2*Pk2*k2**2*(-60*k1**4*r*(r + s) + k1**2*k3**2*r*(29*r + 59*s) + k3**4*(7*f*(10*r**2 - 3*r*(s + 4) + s + 4) + (5 - 5*r)*(15*r - 7*s - 15))) + 14*Pkd2*f*k1**2*k2*k3**4*s*(1 - 3*r) + Pkd2*k2**3*k3**2*s*(-7*f*k3**2*(3*r - 2) + 24*k1**2*r)) + b1*(Pk2*k2**2*k3**4*(-105*b2 + 210*g2)*(r - 1)**2 + 2*f*(3*Pk2*k1**4*(4*k2**2*(6*r**2 + 6*r*(s - 1) - 3*s + 1) + 7*k3**2*s*(1 - 2*r)) + Pk2*k2**2*k3**2*r*(k2**2*(14 - 24*r) - 5*k3**2*r) + k1**2*(12*Pk2*k2**4*(r + s)*(3*r - 2) + k2**2*k3**2*(Pk2*(-24*r**2 - 78*r*s + 14*r + 33*s + 12) + 6*Pkd2*k2*s*(2 - 3*r))))))/(7*d**2*k1*k2**2*k3**4) - D1**4*Pkd1*f*mu**3*mu2*(-28*b1**3*k3**4*r*(5*Pk2*k2**2*r + k1**2*(Pk2*r - 2*Pkd2*k2*s)) + b1**2*(7*Pk2*k2**2*k3**4*(f*(94*r**2 - 106*r + 37) + 8*(r - 1)**2) - 8*k1**4*r*(36*Pk2*k2**2*(r + s) - 7*Pk2*k3**2*(r + 2*s) - 6*Pkd2*k2*k3**2*s) + k1**2*k3**2*(8*Pk2*k2**2*r*(r + 14*s) + k3**2*(7*Pk2*(f*(76*r**2 - 42*r - 4*s + 17) + 8*(r - 1)**2) + 4*Pkd2*k2*(f*r*(14 - 84*s) + 21*f*s + s*(20*r - 20))))) + 2*b1*(Pkd2*k1**2*k2*k3**4*s*(28*b2 - 56*g2)*(r - 1) - 7*f**2*k3**4*(-3*Pk2*k2**2*r**2 + k1**2*(Pk2*(17*r**2 - 16*r - 6*s + 5) + 2*Pkd2*k2*(-6*r*s + 2*r + 3*s - 1))) + 2*f*(-7*Pk2*k2**2*k3**2*r*(k2**2 + k3**2)*(2*r - 1) + k1**4*(24*Pk2*k2**2*(2*r - 1)*(5*r + 5*s - 3) - 7*Pk2*k3**2*(6*r**2 + 2*r*(7*s - 2) - 8*s + 1) + 12*Pkd2*k2*k3**2*(-3*r*s + r + s)) + k1**2*(12*Pk2*k2**4*(r + s)*(2*r - 1) + Pk2*k2**2*k3**2*(58*r**2 - r*(122*s + 91) + 62*s + 44) + Pk2*k3**4*(-14*r**2 + 7*r - 10*s) + 6*Pkd2*k2**3*k3**2*s*(1 - 2*r) - 10*Pkd2*k2*k3**4*(2*r - 1)*(s - 1)))) - 4*f*k1**2*(f*(Pk2*k2**2*k3**2*r*(7 - 23*r) + k1**2*(12*Pk2*k2**2*(2*r - 1)*(r + s - 1) + Pk2*k3**2*(-14*r**2 + 7*r - 6*s) - 6*Pkd2*k2*k3**2*(2*r - 1)*(s - 1))) + k3**4*(7*b2 - 14*g2)*(Pk2*s + Pkd2*k2*(2*r - 1)*(s - 1))))/(7*d**2*k1**2*k2*k3**4) + 2*D1**4*Pkd1*f*mu*mu2**3*(-4*b1*r*(7*Pk2*b1*k2**2*k3**2*r*(k2**2 + k3**2) + 7*b1**2*k1**2*k3**4*s*(-2*Pk2 + Pkd2*k2) + b1*k1**2*(-12*Pk2*k2**4*(r + s) + k2**2*k3**2*(7*Pk2*r + 6*Pkd2*k2*s) + k3**4*(Pk2*(7*r - 20*s + 20) + 10*Pkd2*k2*(s - 1))) - k1**2*k3**4*(2*Pk2 - Pkd2*k2)*(7*b2 - 14*g2)*(s - 1)) + f**2*(2*Pk2*k1**4*(12*k2**2*(3*r**2 + r*(3*s - 4) - 2*s + 1) + 7*k3**2*s*(2 - 3*r)) + 7*Pk2*k2**2*k3**2*(b1*k3**2*(7*r**2 - 16*r + 6) - 4*k2**2*r*(r - 1)) + k1**2*(7*Pk2*b1*k3**4*(12*r*(2*s - 1) - 12*s + 5) + 24*Pk2*k2**4*(r - 1)*(2*r + 2*s - 1) + 2*Pk2*k2**2*k3**2*(-14*r**2 - 21*r*s + 14*r + 2*s + 6) - 14*Pkd2*b1*k2*k3**4*(3*r - 1)*(2*s - 1) - 12*Pkd2*k2**3*k3**2*(r - 1)*(2*s - 1))) + f*(7*b1**2*k3**4*(-14*Pk2*k2**2*r**2 + k1**2*(5*Pk2*r**2 + Pk2*r*(12 - 48*s) + 8*Pk2*s + 6*Pkd2*k2*r*(4*s - 1) - 4*Pkd2*k2*s)) - 2*b1*(-7*Pk2*k2**2*k3**2*(k2**2*(6*r**2 - 3*r + 1) + k3**2*(2*r**2 - 3*r + 1)) + 2*k1**4*r*(6*Pk2*k2**2*(8*r + 8*s - 3) + Pk2*k3**2*(-7*r - 9*s + 1) + 3*Pkd2*k2*k3**2*(1 - 2*s)) + k1**2*(12*Pk2*k2**4*(3*r - 1)*(2*r + 2*s - 1) - Pk2*k2**2*k3**2*(86*r**2 + 7*r*(6*s - 5) + 7) - Pk2*k3**4*(r - 1)*(14*r - 40*s + 13) + 12*Pkd2*k2**3*k3**2*(-3*r*s + r + s) - 10*Pkd2*k2*k3**4*(r - 1)*(2*s - 1))) + k1**2*k3**4*(2*Pk2 - Pkd2*k2)*(-14*b2 + 28*g2)*(r - 1)*(2*s - 1)))/(7*d**2*k1**2*k2*k3**4) + D1**4*Pkd1*f*mu*mu2*(7*b1**3*k3**4*r*(-9*Pk2*k2**2*r + k1**2*(3*Pk2*r + 8*Pkd2*k2*s)) + b1**2*(14*Pk2*k2**2*k3**2*(2*k2**2*r**2 + k3**2*(f*(3*r**2 - 8*r + 3) + 4*r**2 - 4*r + 2)) - 4*k1**4*r*(48*Pk2*k2**2*(r + s) - 7*Pk2*k3**2*(r + 3*s) - 6*Pkd2*k2*k3**2*s) + k1**2*(-48*Pk2*k2**4*r*(r + s) + 4*k2**2*k3**2*r*(23*Pk2*r + 33*Pk2*s + 6*Pkd2*k2*s) + k3**4*(-7*Pk2*(f*(3*r**2 + 4*s - 2) - 8*r**2 + 8*r - 4) + 4*Pkd2*k2*(r*(-28*f*s + 7*f + 20*s - 10) + s*(7*f - 10))))) + 4*b1*(Pkd2*k1**2*k2*k3**4*(7*b2 - 14*g2)*(r*(2*s - 1) - s) + f*(-7*Pk2*k2**2*k3**2*r*(k2**2 + k3**2)*(r - 1) + k1**4*(12*Pk2*k2**2*(4*r**2 + r*(4*s - 5) - 2*s + 1) - 7*Pk2*k3**2*(r**2 + 3*r*s - 2*s) - 6*Pkd2*k2*k3**2*r*(s - 1)) + k1**2*(12*Pk2*k2**4*(r - 1)*(r + s) + Pk2*k2**2*k3**2*(-23*r**2 + r*(7 - 33*s) + 20*s + 6) + Pk2*k3**4*(-7*r**2 + 7*r - 10*s) - 6*Pkd2*k2**3*k3**2*s*(r - 1) - 10*Pkd2*k2*k3**4*(r - 1)*(s - 1)))) - 28*f*k1**2*k3**4*(b2 - 2*g2)*(Pk2*s + Pkd2*k2*(r - 1)*(s - 1)))/(7*d**2*k1**2*k2*k3**4)
    perm13 = 1
    perm23 = 1
    print("unfinished!!!""")
    return perm12+perm13+perm23